Torque 3D - Script Manual: Introduction

Introduction

Welcome to the Torque 3D Reference Manual. This document contains information on learning and using Torque 3D's proprietary scripting language, as well as provides in depth reference to all the classes, functions, methods, callbacks, and variables exposed. This manual is divided in the following sections:

  • Introduction
    • What is TorqueScript
    • Basic Usage
    • Scripting vs Engine Programming
    • Script Editors
    • Recent Changes

  • Syntax Guide
    • The Basics
    • Variables
    • Data Types
    • Operations
    • Control Statements
    • Loops
    • Functions
    • Game Objects

  • Quick Reference
    • Lexical Structure
    • TorqueScript Operators
    • Statements
    • Expressions

  • Module Reference
    • Core
      • Strings
      • File I/O
      • Console
      • Math
        • Vectors
        • Matrix Math
    • Engine
      • Game
      • GUI
      • GFX
      • Sound
      • Input Management

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: What is TorqueScript

What is TorqueScript

TorqueScript (TS) is a proprietary scripting language developed specifically for Torque technology. The language itself is derived from the scripting used for Tribes 2, which was the base tech Torque evolved from. Scripts are written and stored in .cs files, which are compiled and executed by a binary compiled via the C++ engine (.exe for Windows or .app OS X).

The CS extension stands for "C Script," meaning the language is resembles C programming. Though there is a connection, TorqueScript is a much higher level language which is easier to learn than standard C or C++.


Torque 3D - Script Manual: Basic Usage

Basic Usage

Like most other scripting languages, such as Python or Java Script, TorqueScript is a high-level programming language interpreted by Torque 3D at run time. Unlike C++, you can write your code in script and run it without recompiling your game.

All of your interfaces can be built using the GUI Editor, which saves the data out to TorqueScript. The same goes for data saved by the World Editor or Material Editor. Most of the editors themselves are C++ components exposed and constructed via TorqueScript.

More importantly, nearly all of your game play programming will be written in TorqueScript: inventory systems, win/lose scenarios, AI, weapon functionality, collision response, game flow. All of these can be written in TorqueScript. The language will allow you to rapidly prototype your game without having to be programming expert or perform lengthy engine recompilin.


Torque 3D - Script Manual: Scripting vs Engine Programming

Scripting vs Engine Programming

As mentioned above, TorqueScript comprised of the core C++ objects needed to make your game. For example, you will use the PlayerData structure to create player objects for your game. This structure was written in C++:

C++ PlayerData Code

struct PlayerData: public ShapeBaseData {
   typedef ShapeBaseData Parent;

   bool renderFirstPerson; // Render the player shape in first person

   mass = 9.0f;         // from ShapeBase
   drag = 0.3f;         // from ShapeBase
   density = 1.1f;      // from ShapeBase

Instead of having to go into C++ and create new PlayerData objects or edit certain fields (such as mass), PlayerData was exposed to TorqueScript:

Example TorqueScript PlayerData Code

datablock PlayerData(DefaultPlayerData)
{
   renderFirstPerson = true;
   className = Armor;
   shapeFile = "art/shapes/actors/gideon/base.dts";
   mass = 100;
   drag = 1.3;
   maxdrag = 0.4;

   // Allowable Inventory Items
   maxInv[Pistol] = 1;
   maxInv[PistolAmmo] = 50;
};

If you want to change the name of the object, the mass, the inventory, or anything else, just open the script, make the change, and save the file. When you run your game, the changes will immediately take affect. Of course, for this example you could have used the Datablock Editor, but you should get the point. TorqueScript is the first place you should go to write your game play code.


Torque 3D - Script Manual: Script Editors

Script Editors

TorqueScript files are essentially text files. This means you have several editors to choose from. Some users prefer to use the stock OS text editors: Notepad on Windows or Text Edit on OS X. Others will use their programming IDEs (Interactive Development Environments), such as Visual Studio for Windows or Xcode on OS X. Third party applications are the most popular choice:

On Windows

Recommended:

  • Torsion - Torsion is undeniably the best TorqueScript IDE was developed by Torque veterans Sickhead Games. If you are developing on Windows, this is the first thing you should purchase after Torque 3D. No other editor offers this level of quality and functionality:
    • Integrated "One Click" script debugging.
    • Full control over script execution via step and break commands.
    • Advanced editor features like code folding, line wrapping, auto-indent, column marker, automatic bracket matching, and visible display of tabs and spaces.
    • Goto line and text searching.
    • ScriptSense updated dynamically as you type.
    • Customizable syntax highlighting for TorqueScript.
    • Unlimited undo/redo buffer.
    • Code browser window for exploring both engine exports and script symbols in your project.

Alternatives:

  • Notepad++ - This is a free (as in "free speech" and also as in "free beer") source code editor and Notepad replacement that supports several languages.
  • UltraEdit - UltraEdit is a powerful disk-based text editor, programmer's editor, and hex editor that is used to edit TorqueScript, HTML, PHP, javascript, Perl, C/C++, and a multitude of other coding/programming languages.

On OS X

Recommended:

  • Xcode - Xcode is Apple's premiere development environment for Mac OS X. If you plan on modifying Torque 3D's source code, you will need this anyway. Most developers at GarageGames use Xcode to modify their scripts on a Mac.
  • Text Edit - This is the OS X default text editor. With no bells or whistles, this is not the best editor you can use on OS X, but it is free and ships with the OS.

Alternatives:

  • TIDE - Torque Integrated Development Environment (TIDE) is a free, cross-platform IDE for Torque Game Engine scripting by Paul Dana and Stefan Moises. It is implemented in Java as a "plugin suite" for the jEdit text editor and contains plugins for syntax highlighting, function browsing, script debugging, etc.
  • Smultron - Smultron is a text editor written in Cocoa for Mac OS X Leopard 10.5 which is designed to be both easy to use and powerful.


Torque 3D - Script Manual: Recent Changes

Recent Changes

Foreach Statements

Two new statements simplify the iteration over sets of objects and string vectors.

To loop over each object in a SimSet, use the foreach statement:

foreach( %obj in %set )
   /* do something with %obj */;

To loop over each element in a string vector, use the foreach$ statement:

foreach$( %str in "a b c" )
   /* do something with %str */;

foreach Statement foreach$ Statement

Redefinition Behavior

Singletons

Lookup Operator

Floating-Point Notation

Datablock Syntax Extensions

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: Syntax Guide

Syntax Guide

  • Syntax Guide
    • The Basics
    • Variables
    • Data Types
    • Operations
    • Control Statements
    • Loops
    • Functions
    • Game Objects
    • Packages


Torque 3D - Script Manual: The Basics

The Basics

Rules

Like other languages, TorqueScript has certain syntactical rules you need to follow. The language is typeless, very forgiving, easy to debug, and is not as strict as a low level language like C++. Observe the following line in a script:

// Create test variable with a temporary variable
%testVariable = 3;

The three most simple rules obeyed in the above code are:

  • 1. Ending a line with a semi-colon (;)
  • 2. Proper use of white space.
  • 3. Commenting

    The engine will parse code line by line, stopping whenever it reaches a semi-colon. This is referred to as a statement termination, common to other programming languages such as C++, Javascript, etc. The following code will produce an error that may cause your entire script to fail:

    To the human eye, you are able to discern two separate lines of code with different actions. Here is how the script compiler will read it:
%testVariable = 3%anotherVariable = 4;

This is obviously not what the original code was meant to do. There are exemptions to this rule, but they come into play when multiple lines of code are supposed to work together for a single action:

if(%testVariable == 4)
  echo("Variable equals 4");

We have not covered conditional operators or echo commands yet, but you should notice that the first line does not have a semi-colon. The easiest explanation is that the code is telling the compiler: "Read the first line, do the second line if we meet the requirements." In other words, perform operations between semi-colons. Complex operations require multiple lines of code working together.

The second rule, proper use of whitespace, is just as easy to remember. Whitespace refers to how your script code is separated between operations. Let's look at the first example again:

%testVariable = 3;

The code is storing a value (3) in a local variable (testVariable). It is doing so by using a common mathematical operator, the equal sign. TorqueScript recognizes the equal sign and performs the action just as expected. It does not care if there are spaces in the operation:

%testVariable=3;

The above code works just as well, even without the spaces between the variable, the equal sign, and the 3. The whitespace rule makes a lot more sense when combined with the semi-colon rule and multiple lines of code working together. The following will compile and run without error:

if(%testVariable == 4) echo("Variable equals 4");

Comments

The last rule is optional, but should be used as often as possible if you want to create clean code. Whenever you write code, you should try to use comments. Comments are a way for you to leave notes in code which are not compiled into the game. The compiler will essentially skip over these lines.

There are two different comment syntax styles. The first one uses the two slashes, //. This is used for single line comments:

Example:

// This comment line will be ignored
// This second line will also be ignored
%testVariable = 3;
// This third line will also be ignored

In the last example, the only line of code that will be executed has to do with testVariable. If you need to comment large chunks of code, or leave a very detailed message, you can use the / * comment * / syntax (without spaces between asterix and slash). The / * starts the commenting, the * / ends the commenting, and anything in between will be considered a comment.

Example:

/*
While attending school, an instructor taught a mantra I still use:

"Read. Read Code. Code."

Applying this to Torque 3D development is easy:

READ the documentation first.

READ CODE written by other Torque developers.

CODE your own prototypes based on what you have learned.
*/

As you can see, the comment makes full use of whitespace and multiple lines. While it is important to comment what the code does, you can also use this to temporarily remove unwanted code until a better solution is found:

Example:

// Why are you using multiple if statements. Why not use a switch$?
/*
if(%testVariable == "Mich")
  echo("User name: ", %testVariable);

if(%testVariable == "Heather")
  echo("User Name: ", %testVariable);

if(%testVariable == "Nikki")
  echo("User Name: ", %testVariable);
*/


Torque 3D - Script Manual: Variables

Variables

Now that you know the two most basic rules of writing code in TorqueScript, this is the best time to learn about variables. A variable is a letter, word, or phrase linked to a value stored in your game's memory and used during operations. Creating a variable is a one line process. The following code creates a variable by naming it and assigning a value:

 %localVariable = 3;

You can assign any type value to the variable you want. This is referred to as a language being type-insensitive. TorqueScript does not care (insensitive) what you put in a variable, even after you have created it. The following code is completely valid:

%localVariable = 27;
%localVariable = "Heather";
%localVariable = "7 7 7";

The main purpose of the code is to show that TorqueScript treats all data types the same way. It will interpret and convert the values internally, so you do not have to worry about typecasting. That may seem a little confusing. After all, when would you want a variable that can store a number, a string, or a vector?

You will rarely need to, which is why you want to start practicing good programming habits. An important practice is proper variable naming. The following code will make a lot more sense, considering how the variables are named:

%userName = "Heather";
%userAge = 27;
%userScores = "7 7 7";

Earlier, I mentioned that TorqueScript is more forgiving than low level programming languages. While it expects you to obey the basic syntax rules, it will allow you to get away with small mistakes or inconsistency. The best example is variable case sensitivity. At some point in school you learned the difference between upper case and lower case letters.

With variables, TorqueScript is not case sensitive. You can create a variable and refer to it during operations without adhering to case rules:

%userName = "Heather";
echo(%Username);

In the above code, userName and Username are the same variable, even though they are using different capitalization. You should still try to remain consistent in your variable naming and usage, but you will not be punished if you slip up occasionally.

Types

There are two types of variables you can declare and use in TorqueScript: local and global. Both are created and referenced similarly:

%localVariable = 1;
$globalVariable = 2;

As you can see, local variable names are preceded by the percent sign (%). Global variables are preceded by the dollar sign ($). Both types can be used in the same manner: operations, functions, equations, etc. The main difference has to do with how they are scoped.

In programming, scoping refers to where in memory a variable exists and its life. A local variable is meant to only exist in specific blocks of code, and its value is discarded when you leave that block. Global variables are meant to exist and hold their value during your entire programs execution. Look at the following code to see an example of a local variable:

 function test()
{
   %userName = "Heather";
   echo(%userName);
}

We will cover functions a little later, but you should know that functions are blocks of code that only execute when you call them by name. This means the variable, userName, does not exist until the test() function is called. When the function has finished all of its logic, the userName variable will no longer exist. If you were to try to access the userName variable outside of the function, you will get nothing.

Most variables you will work with are local, but you will eventually want a variables that last for your entire game. These are extremely important values used throughout the project. This is when global variables become useful. For the most part, you can declare global variables whenever you want:

$PlayerName = "Heather";

function printPlayerName()
{
   echo($PlayerName);
}

function setPlayerName()
{
   $PlayerName = "Nikki";
}

The above code makes full use of a global variable that holds a player's name. The first declaration of the variable happens outside of the functions, written anywhere in your script. Because it is global, you can reference it in other locations, including separate script files. Once declared, your game will hold on to the variable until shutdown.


Torque 3D - Script Manual: Data Types

Data Types

As I mentioned above, TorqueScript comprised of the core C++ objects needed to make your game. For example, you will use the PlayerData structure to create player objects for your game. This structure was written in C++:

TorqueScript implicitly supports several variable data-types: numbers, strings, booleans, and arrays and vectors. If you wish to test the various data types, you can use the echo(...) command. For example:

%meaningOfLife = 42;
echo(%meaningOfLife);

$name = "Heather";
echo($name);

The echo will post the results in the console, which can be accessed by pressing the tilde key (~) while in game.

Numbers

TorqueScript handles standard numeric types

123     (Integer)
1.234   (floating point)
1234e-3 (scientific notation)
0xc001  (hexadecimal)

Example:

%myInteger = 3;
%myFloat = 2.5;
%mySciNot = 314e-1;
%myHexa = 0xc001;

Strings

Text, such as names or phrases, are supported as strings. Numbers can also be stored in string format. Standard strings are stored in double-quotes.

 "abcd"    (string)

Example:

 $UserName = "Heather";

Tagged Strings

Strings with single quotes are called "tagged strings".

 'abcd'  (tagged string)

Tagged strings are special in that they contain string data, but also have a special numeric tag associated with them. Tagged strings are used for sending string data across a network. The value of a tagged string is only sent once, regardless of how many times you actually do the sending.

On subsequent sends, only the tag value is sent. Tagged values must be de-tagged before printing. You will not need to use a tagged string often unless you are in need of sending strings across a network often, like a chat system.

Example:

$a = 'This is a tagged string';
echo("  Tagged string: ", $a);
echo("Detagged string: ", detag('$a'));

The output will be similar to this:

 24
___

The second echo will be blank unless the string has been passed to you over a network.

Booleans

Like most programming languages, TorqueScript also supports Booleans. Boolean numbers have only two values- true or false.

true    (1)
false   (0)

Again, as in many programming languages the constant "true" evaluates to the number 1 in TorqueScript, and the constant "false" evaluates to the number 0. However, non-zero values are also considered true. Think of booleans as "on/off" switches, often used in conditional statements.

Example:

$lightsOn = true;

if($lightsOn)
  echo("Lights are turned on");

Arrays

Arrays are data structures used to store consecutive values of the same data type.

$TestArray[n]   (Single-dimension)
$TestArray[m,n] (Multidimensional)
$TestArray[m_n] (Multidimensional)

If you have a list of similar variables you wish to store together, try using an array to save time and create cleaner code. The syntax displayed above uses the letters 'n' and 'm' to represent where you will input the number of elements in an array. The following example shows code that could benefit from an array:

Example:

$firstUser = "Heather";
$secondUser = "Nikki";
$thirdUser = "Mich";

echo($firstUser);
echo($secondUser);
echo($thirdUser);

Instead of using a global variable for each user name, we can put those values into a single array:

Example:

$userNames[0] = "Heather";
$userNames[1] = "Nikki";
$userNames[2] = "Mich";

echo($userNames[0]);
echo($userNames[1]);
echo($userNames[2]);

Now, let's break the code down. Like any other variable declaration, you can create an array by giving it a name and value:

 $userNames[0] = "Heather";

What separates an array declaration from a standard variable is the use of brackets []. The number you put between the brackets is called the index. The index will access a specific element in an array, allowing you to view or manipulate the data. All the array values are stored in consecutive order.

If you were able to see an array on paper, it would look something like this:

 [0] [1] [2]

In our example, the data looks like this:

 ["Heather"] ["Nikki"] ["Mich"]

Like other programming languages, the index is always a numerical value and the starting index is always 0. Just remember, index 0 is always the first element in an array. As you can see in the above example, we create the array by assigning the first index (0) a string value ("Heather").

The next two lines continue filling out the array, progressing through the index consecutively.

$userNames[1] = "Nikki";
$userNames[2] = "Mich";

The second array element (index 1) is assigned a different string value ("Nikki"), as is the third (index 2). At this point, we still have a single array structure, but it is holding three separate values we can access. Excellent for organization.

The last section of code shows how you can access the data that has been stored in the array. Again, you use a numerical index to point to an element in the array. If you want to access the first element, use 0:

 echo($userNames[0]);

In a later section, you will learn about looping structures that make using arrays a lot simpler. Before moving on, you should know that an array does not have to be a single, ordered list. TorqueScript also support multidimensional arrays.

An single-dimensional array contains a single row of values. A multidimensional array is essentially an array of arrays, which introduces columns as well. The following is a visual of what a multidimensional looks like with three rows and three columns:

[x] [x] [x]
[x] [x] [x]
[x] [x] [x]

Defining this kind of array in TorqueScript is simple. The following creates an array with 3 rows and 3 columns.

Example:

$testArray[0,0] = "a";
$testArray[0,1] = "b";
$testArray[0,2] = "c";

$testArray[1,0] = "d";
$testArray[1,1] = "e";
$testArray[1,2] = "f";

$testArray[2,0] = "g";
$testArray[2,1] = "h";
$testArray[2,2] = "i";

Notice that we are are now using two indices, both starting at 0 and stopping at 2. We can use these as coordinates to determine which array element we are accessing:

[0,0] [0,1] [0,2]
[1,0] [1,1] [1,2]
[2,0] [2,1] [2,2]

In our example, which progresses through the alphabet, you can visualize the data in the same way:

[a] [b] [c]
[d] [e] [f]
[g] [h] [i]

The first element [0,0] points to the letter 'a'. The last element [2,2] points to the letter 'i'.

Vectors

"Vectors" are a helpful data-type which are used throughout Torque 3D. For example, many fields in the World Editor take numeric values in sets of 3 or 4. These are stored as strings and interpreted as "vectors".

"1.0 1.0 1.0"   (3 element vector)

The most common example of a vector would be a world position. Like most 3D coordinate systems, an object's position is stored as (X Y Z). You can use a three element vector to hold this data:

Example:

%position = "25.0 32 42.5";

You can separate the values using spaces or tabs (bot are acceptable whitespace). Another example is storing color data in a four element vector. The values that make up a color are "Red Blue Green Alpha," which are all numbers. You can create a vector for color using hard numbers, or variables:

Example:

%firstColor = "100 100 100 1.0";
echo(%firstColor);

%red = 128;
%blue = 255;
%green = 64;
%alpha = 1.0;

%secondColor = %red SPC %blue SPC %green SPC %alpha;
echo(%secondColor);


Torque 3D - Script Manual: Operations

Operations

Operators in TorqueScript behave very similarly to operators in real world math and other programming languages. You should recognize quite a few of these from math classes you took in school, but with small syntactical changes. The rest of this section will explain the syntax and show a brief example, but we will cover these in depth in later guides.

Arithmetic Operations

Basic math operations are supported using a syntax clear to everyone. TorqueScript supports multiplication, division, modulo, addition, and subtraction. Additionally, standard auto-increment and auto-decrement operations are available:

Example:

// Multiplication
%product = 3*4; // results in 12

// Division
%quotient = 4/2; // results in 2

// Modulo
%mod = 5%2; // results in 1

// Addition
%sum = 3+4; // results in 7

// Subtraction
%difference = 4-3; // results in 1

// Auto-increment
%value = 3;
%incr = %value++; // results in 4;

//Auto-decrement
%value = 3;
%decre = %value--; // results in 2;

See also:
Full Reference

Relational Operations

Relational operators are used for comparing values and variables against each other. Again, the syntax for these operatations closely resemble real world math. The value returned from a comparison will always be true(1) or false(0).

Example:

// Greater than
if(4 > 3)
   echo("True. 3 is not greater than 4");

// Greater than or equal to
if(3 >= 3)
   echo("True. 3 is equal to or greater than 3");

// Equal to
if(6 == 6);
   echo("True. 6 is exactly equal to 6");

// Not equal to
if(3 != 5)
   echo("True. 3 is not equal to 5");

See also:
Full Reference

Bitwise Operations

Bitwise operations are used for comparing and shifting the bits of a value.

Examples:

// Bitwise NOT/complement. Unary operation that flips bits.
%value = 101;
%bitValue = ~%value; // results in 101 becoming 010

// Bitwise AND. When applied to two binary values, resulting bits are 1 if original pairs were 1
%valueOne = 0101;
%valueTwo = 0011;
%bitValue = %valueOne&%valueTwo; // Results in 0001

See also:
Full Reference

Assignment Operations

Assignment operators are used for setting the value of a variable. You should recognize it as the "equals" sign.

Example:

%val = 3; // Assigns the value of 3 to the %val variable

%val = 3+4; // Assigns the value of 3+4 to the %val variable

%val += 3; // Assigns the %val variable the value of 3 plus itself

See also:
Full Reference

String Operations

There are special values you can use to concatenate strings and variables. Concatenation refers to the joining of multiple values into a single variable. The following is the basic syntax:

 "string 1" operation "string 2"

You can use string operators similarly to how you use mathematical operators (=, +, -, *). You have four operators at your disposal: @ NL TAB SPC. For example, the @ symbol will concatenate two strings together exactly how you specify, without adding any additional whitespace.

Example:

%newString = "Hello" @ "World";
echo(%newString);

// OUPUT: HelloWorld

See also:
Full Reference


Torque 3D - Script Manual: Control Statements

Control Statements

Control Statements

TorqueScript provides basic branching structures that will be familiar to programmers that have used other languages. If you are completely new to programming, you use branching structures to control your game's flow and logic. This section builds on everything you have learned about TorqueScript so far.

if, then, else

This type of structure is used to test a condition, then perform certain actions if the condition passes or fails. You do not always have to use the full structure, but the following syntax shows the extent of the conditional:

 if(<boolean expression>)
{
   pass logic
}
else
{
   alternative logic
}

Remember how boolean values work? Essentially, a bool can either be true (1) or false (0). The condition (boolean) is always typed into the parenthesis after the "if" syntax. Your logic will be typed within the brackets {}. The following example uses specific variable names and conditions to show how this can be used:

Example:

// Global variable that controls lighting
$lightsShouldBeOn = true;

// Check to see if lights should be on or off
if($lightsShouldBeOn)
{
   // True. Call turn on lights function
   turnOnLights();

   echo("Lights have been turned on");
}
else
{
   // False. Turn off the lights
   turnOffLights();

   echo("Lights have been turned off");
}

Brackets for single line statements are optional. If you are thinking about adding additional logic to the code, then you should use the brackets anyway. If you know you will only use one logic statement, you can use the following syntax:

Example:

// Global variable that controls lighting
$lightsShouldBeOn = true;

// Check to see if lights should be on or off
if($lightsShouldBeOn)
  turnOnLights();   // True. Call turn on lights function
else
  turnOffLights(); // False. Turn off the lights

switch and switch$

If your code is using several cascading if-then-else statements based on a single value, you might want to use a switch statement instead. Switch statements are easier to manage and read. There are two types of switch statements, based on data type: numeric (switch) and string (switch$).

Switch Syntax:

switch(<numeric expression>)
{
   case value0:
       statements;
   case value1:
       statements;
   case value3:
       statements;
   default:
       statements;
}

As the above code demonstrates, start by declaring the switch statement by passing in a value to the switch(...) line. Inside of the brackets {}, you will list out all the possible cases that will execute based on what value being tested. It is wise to always use the default case, anticipating rogue values being passed in.

Example:

switch($ammoCount)
{
   case 0:
      echo("Out of ammo, time to reload");
      reloadWeapon();
   case 1:
      echo("Almost out of ammo, warn user");
      lowAmmoWarning();
   case 100:
      echo("Full ammo count");
      playFullAmmoSound();
   default:
      doNothing();
}

switch only properly evaluates numerical values. If you need a switch statement to handle a string value, you will want to use switch$. The switch$ syntax is similar to what you just learned:

Switch$ Syntax:

switch$ (<string expression>)
{
   case "string value 0":
                statements;
   case "string value 1":
                statements;
...
   case "string value N":
                statements;
   default:
                statements;
}

Appending the $ sign to switch will immediately cause the parameter passed in to be parsed as a string. The following code applies this logic:

Example:

// Print out specialties
switch($userName)
{
   case "Heather":
      echo("Sniper");
   case "Nikki":
      echo("Demolition");
   case Mich:
      echo("Meat shield");
   default:
      echo("Unknown user");
}


Torque 3D - Script Manual: Loops

Loops

As the name implies, this structure type is used to repeat logic in a loop based on an expression. The expression is usually a set of variables that increase by count, or a constant variable changed once a loop has hit a specific point. For Loop

For Loop

for Loop Syntax:

for(expression0; expression1; expression2)
{
    statement(s);
}

One way to label the expressions in this syntax are (startExpression; testExpression; countExpression). Each expression is separated by a semi-colon.

Example:

for(%count = 0; %count < 3; %count++)
{
    echo(%count);
}

// OUTPUT:
// 0
// 1
// 2

The first expression creates the local variable count and initializing it to 0. In the second expression determines when to stop looping, which is when the count is no longer less than 3. Finally, the third expression increases the count the loop relies on.

While Loop

A while loop is a much simpler looping structure compared to a for loop.

while Loop Syntax:

while(expression)
{
    statements;
}

As soon as the expression is met, the while loop will terminate:

Example:

%countLimit = 0;

while(%countLimit <= 5)
{
   echo("Still in loop");
   %countLimit++;
}
echo("Loop was terminated");

// OUPUT:
// Still in loop
// Still in loop
// Still in loop
// Still in loop
// Still in loop
// Still in loop
// Loop was terminated


Torque 3D - Script Manual: Functions

Functions

Much of your TorqueScript experience will come down to calling existing functions and writing your own. Functions are a blocks of code that only execute when you call them by name. Basic functions in TorqueScript are defined as follows:

// function - Is a keyword telling TorqueScript we are defining a new function.
// function_name - Is the name of the function we are creating.
// ... - Is any number of additional arguments.
// statements - Your custom logic executed when function is called
// return val - The value the function will give back after it has completed. Optional.

function function_name([arg0],...,[argn])
{
    statements;
    [return val;]
}

The function keyword, like other TorqueScript keywords, is case sensitive. You must type it exactly as shown above. The following is an example of a custom function that takes in two parameters, then executes code based on those arguments.

TorqueScript can take any number of arguments, as long as they are comma separated. If you call a function and pass fewer parameters than the function's definition specifies, the un-passed parameters will be given an empty string as their default value.

Example:

function echoRepeat (%echoString, %repeatCount)
{
   for (%count = 0; %count < %repeatCount; %count++)
   {
      echo(%echoString);
   }
}

You can cause this function to execute by calling it in the console, or in another function:

echoRepeat("hello!", 5);

// OUTPUT:
// "hello!"
// "hello!"
// "hello!"
// "hello!"
// "hello!"

If you define a function and give it the same name as a previously defined function, TorqueScript will completely override the old function. This still applies even if you change the number of parameters used; the older function will still be overridden.


Torque 3D - Script Manual: Game Objects

Game Objects

The most complex aspect of TorqueScript involves dealing with game objects. Much of your object creation will be performed in the World Editor, but you should still know how to manipulate objects at a script level. One thing to remember is that everything in TorqueScript is an object: players, vehicles, items, etc.

Every object added in the level is saved to a mission file, which is written entirely in TorqueScript. This also means every game object is accessible from script. First, we will study the syntax of object creation.

Syntax

Even though objects are originally created in C++, they are exposed to script in a way that allows them to be declared using the following syntax:

Object Definition:

 // In TorqueScript
%objectID = new ObjectType(Name : CopySource, arg0, ..., argn)
{
   <datablock = DatablockIdentifier;>

   [existing_field0 = InitialValue0;]
   ...
   [existing_fieldN = InitialValueN;]

   [dynamic_field0 = InitialValue0;]
   ...
   [dynamic_fieldN = InitialValueN;]
};

Syntax Breakdown:

  • objectID : Is the variable where the object's handle will be stored.
  • new : Is a key word telling the engine to create an instance of the following ObjectType.
  • ObjectType : Is any class declared in the engine or in script that has been derived from SimObject or a subclass of SimObject. SimObject-derived objects are what we were calling "game world objects" above.
  • Name (optional) : Is any expression evaluating to a string, which will be used as the object's name.
  • CopySource (optional) : The name of an object which is previously defined somewhere in script. Existing field values will be copied from CopySource to the new object being created. Any dynamic fields defined in CopySource will also be defined in the new object, and their values will be copied. Note: If CopySource is of a different ObjectType than the object being created, only CopySource's dynamic fields will be copied.
  • arg0, ..., argn (optional) : Is a comma separated list of arguments to the class constructor (if it takes any).
  • datablock : Many objects (those derived from GameBase, or children of GameBase) require datablocks to initialize specific attributes of the new object. Datablocks are discussed below.
  • existing_fieldN : In addition to initializing values with a datablock, you may also initialize existing class members (fields) here. Note: In order to modify a member of a C++-defined class, the member must be exposed to the Console. This concept is discussed in detail later.
  • dynamic_fieldN : Lastly, you may create new fields (which will exist only in Script) for your new object. These will show up as dynamic fields in the World Editor Inspector.

The main object variants you can create are SimObjects without a datablock, and game objects which require a datablock. The most basic SimObject can be created in a single line of code:

Example:

// Create a SimObject without any name, argument, or fields.
$exampleSimObject = new SimObject();

The $exampleSimObject variable now has access to all the properties and functions of a basic SimOBject. Usually, when you are creating a SimObject you will want custom fields to define features

Example:

// Create a SimObject with a custom field
$exampleSimObject = new SimObject()
{
   catchPhrase = "Hello world!";
};

As with the previous example, the above code creates a SimObject without a name which can be referenced by the global variable $exampleSimObject. This time, we have added a user defined field called "catchPhrase." There is not a single stock Torque 3D object that has a field called "catchPhrase." However, by adding this field to the SimObject it is now stored as long as that object exists.

The other game object variant mentioned previously involves the usage of datablocks. Datablocks contain static information used by a game object with a similar purpose. Datablocks are transmitted from a server to client, which means they cannot be modified while the game is running.

We will cover datablocks in more detail later, but the following syntax shows how to create a game object using a datablock.

Example:

// create a StaticShape using a datablock
datablock StaticShapeData(ceiling_fan)
{
   category = "Misc";
   shapeFile = "art/shapes/undercity/cfan.dts";
   isInvincible = true;
};

new StaticShape(CistFan)
{
   dataBlock = "ceiling_fan";
   position = "12.5693 35.5857 59.5747";
   rotation = "1 0 0 0";
   scale = "1 1 1";
};

Once you have learned about datablocks, the process is quite simple:

  1. Create a datablock in script, or using the datablock editor
  2. Add a shape to the scene from script or using the World Editor
  3. Assign the new object a datablock

Handles vs Names

Every game object added to a level can be accessed by two parameters:

  • Handle - A unique numeric ID generated when the object is created
  • Name - This is an optional parameter given to an object when it is created. You can assign a name to an object from the World Editor, or do so in TorqueScript using the following syntax:

Example:

// In this example, CistFan is the name of the object
new StaticShape(CistFan)
{
   dataBlock = "ceiling_fan";
   position = "12.5693 35.5857 59.5747";
   rotation = "1 0 0 0";
   scale = "1 1 1";
};

While in the World Editor, you will not be allowed to assign the same name to multiple, separate objects. The editor will ignore the attempt. If you manually name two objects the same thing in script, the game will only load the first object and ignore the second.

Singletons

If you need a global script object with only a single instance, you can use the singleton keyword. Singletons, in TorqueScript, are mostly used for unique shaders, materials, and other client-side only objects.

For example, SSAO (screen space ambient occlusion) is a post-processing effect. The game will only ever need a single instance of the shader, but it needs to be globally accessible on the client. The declaration of the SSAO shader in TorqueScript can be shown below:

singleton ShaderData( SSAOShader )
{
   DXVertexShaderFile   = "shaders/common/postFx/postFxV.hlsl";
   DXPixelShaderFile    = "shaders/common/postFx/ssao/SSAO_P.hlsl";
   pixVersion = 3.0;
};

Methods

In addition to the creation of stand-alone functions, TorqueScript allows you to create and call methods attached to objects. Some of the more important ConsoleMethods are already written in C++, then exposed to script. You can call these methods by using the dot (.) notation.

Syntax:

objHandle.function_name();

objName.function_name();

Example:

new StaticShape(CistFan)
{
   dataBlock = "ceiling_fan";
   position = "12.5693 35.5857 59.5747";
   rotation = "1 0 0 0";
   scale = "1 1 1";
};

// Write all the objects methods to the console log
CistFan.dump();

// Get the ID of an object, using the object's name
$objID = CistFan.getID();

// Print the ID to the console
echo("Object ID: ", $objID);

// Get the object's position, using the object's handle
%position = $objID.getPosition();

// Print the position to the console
echo("Object Position: ", %position);

The above example shows how you can call an object's method by using its name or a variable containing its handle (unique ID number). Additionally, TorqueScript supports the creation of methods that have no associated C++ counterpart.

Syntax:

// function - Is a keyword telling TorqueScript we are defining a new function.
// ClassName::- Is the class type this function is supposed to work with.
// function_name - Is the name of the function we are creating.
// ... - Is any number of additional arguments.
// statements - Your custom logic executed when function is called
// %this- Is a variable that will contain the handle of the 'calling object'.
// return val - The value the function will give back after it has completed. Optional.

function Classname::func_name(%this, [arg0],...,[argn])
{
   statements;
   [return val;]
}

At a minimum, object methods require that you pass them an object handle. You will often see the first argument named this. People use this as a hint, but you can name it anything you want. As with Console functions any number of additional arguments can be specified separated by commas.

As a simple example, let's say there is an object called Samurai, derived from the Player class. It is likely that a specific appearance and play style will be given to the samurai, so custom ConsoleMethods can be written. Here is a sample:

Example:

function Samurai::sheatheSword(%this)
{
    echo("Katana sheathed");
}

When you add a Samurai object to your level via the World Editor, it will be given an ID. Let's pretend the handle (ID number) is 1042. We can call its ConsoleMethod once it is defined, using the period syntax:

Example:

1042.sheatheSword();

// OUTPUT: "Katana sheathed"

Notice that no parameters were passed into the function. The this parameter is inherent, and the original function did not require any other parameters.


Torque 3D - Script Manual: Packages

Packages

The package keyword tells the console that the subsequent block of code is to be declared but not loaded. Packages provide dynamic function-polymorphism in TorqueScript. In short, a function defined in a package will over-ride the prior definition of a same named function when the is activated. When the package is subsequently de-activated, the previous definition of any overridden functions will be re-asserted.

A package has the following syntax:

package package_name
{
   function function_definition0()
   {
      // code
   }

   function function_definitionN()
   {
      // code
   }
};

Some things to know:

  • The same function can be defined in multiple packages.
  • Only functions can be packaged.
  • Datablocks cannot be packaged.
  • Packages 'stack' meaning that deactivating packages activated prior to the currently active (s) will deactivate all packages activated prior to the being deactivated (see example below).
  • Functions in a may activate and deactivate packages.

In order to use the functions in a package, the package must be activated:

activatePackage(package_name);

Subsequently a package can be deactivated:

deactivatePackage(package_name);

Usage

First, define a function and two packages, each of which provides an alternative definition by the same name.

function testFunction()
{
   echo( "testFunction() - unpackaged." );
}

package MyPackage0
{
  function testFunction()
  {
      echo( "testFunction() - MyPackage0." );
  }
};

package MyPackage1
{
  function testFunction()
  {
      echo( "testFunction() - MyPackage1." );
  }
};

Now invoke the testFunction() function from the console under three different conditions:

==> testFunction();
testFunction() - unpackaged.

==> activatePackage( MyPackage0 );

==> testFunction();
testFunction() - MyPackage0.

==> activatePackage( MyPackage1 );

==> testFunction();
testFunction() - MyPackage1.

==> deactivatePackage( MyPackage0 );  // MyPackage1 is automatically deactivated.

==> testFunction();
testFunction() - unpackaged.
See also:
Packages

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: Quick Reference

Quick Reference

  • TorqueScript Quick Reference
    • Lexical Structure
    • Types
    • Statements
    • Expressions
    • TorqueScript Operators


Torque 3D - Script Manual: Lexical Structure

Lexical Structure

Comments

Single-line comments start with two forward slashes next to each other.

 // Comment up to next newline.

Multi-line comments start with / * and end with * / (without the spaces between the symbols).

 /* Multi-line
 comment */

Literals

Text

Keywords

The following identifiers are reserved in TorqueScript and cannot be used as names.

 assert
 break
 case
 continue
 datablock
 default
 do
 else
 false
 for
 foreach
 foreach$
 function
 if
 in
 namespace
 new
 NL
 or
 package
 return
 singleton
 SPC
 switch
 switch$
 TAB
 true
 while


Torque 3D - Script Manual: Types

Types

TorqueScript has four different kinds of types:

  • Atomics
  • Compounds
  • Enumerations
  • Bitfields
  • Objects

Atomic Types

Atomic types are the building block types of TorqueScript. All literals have atomic types.

The following atomic types are defined:

bool
A boolean value. true or false.
int
A signed integer value between -2147483648 and 2147483647.
float
A single-precision floating-point value.
string
A string of UTF-8 encoded Unicode characters.

Compound Types

A compound type is a type with structured values that are composed of individual values of atomic types.

The following compound types are defined:

ColorI
A RGBA color value in 8bit precision integer values. Each color component ranges from 0-255.
ColorF
A RGBA color value in single-precision floating-point values. Each color component ranges from 0-1.
Point3F/VectorF
MatrixF

Enumeration Types

Bitfield Types

Object Types

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: Statements

Statements

   statement
      : iteration_statement
      | branching_statement
      | block_statement
      | expression_statement
      | empty_statement

Iteration Statements

   iteration_statement
      : for_statement
      | while_statement
      | do_statement
      | foreach_statement
      | foreachstr_statement

for Statement

while Statement

do Statement

foreach Statement

   foreach_statement
      : 'foreach' '(' variable 'in' expression ')' statement

The foreach statement iterates over all objects contained in a SimSet.

Example:
   foreach( %obj in RootGroup )
      echo( %obj.getName() );

foreach$ Statement

   foreachstr_statement
      : 'foreach$' '(' variable 'in' expression ')' statement

The foreach$ statement iterates over all words in a string. Words are separated by newlines, spaces, and/or tabs.

Example:
   foreach$( %str in "a b c d" )
      echo( %str );

Field Manipulators

Branching Statements

if Statement

   if_statement
      : 'if' '(' expression ')' statement
      | 'if' '(' expression ')' statement 'else' statement

switch Statement

switch Statement

return Statement

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: Expressions

Expressions

Unary Expressions

Negation (prefix) | -
Increment (postfix) | ++
Decrement (postfix) | --

Binary Expressions

Numeric Inequality | !=
Numeric Equality | ==
String Equality | $=
String Inequality | !$=

Lookup Expressions

Member Expression

Call Expression

Object Creation Expressions

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: TorqueScript Operators

TorqueScript Operators

Operators in TorqueScript behave very similarly to operators in real world math and other programming languages. You should recognize quite a few of these from math classes you took in school, but with small syntactical changes. The rest of this section will explain the syntax and show a brief example, but we will cover these in depth in later guides.

Arithmetic Operators

Arithmetic Operators
Operator | Name | Example | Explanation
 | multiplication | $a * $b | Multiply $a and $b.
/ | division | $a / $b | Divide $a by $b.
% | modulo | $a % $b | Remainder of $a divided by $b.
+ | addition | $a + $b | Add $a and $b.
- | subtraction | $a - $b | Subtract $b from $a.
++ | auto-increment (post-fix only) | $a++ | Increment $a. Note: ++$a is illegal. Note: the value of $a++ is that of the incremented variable: auto-increment is post-fix in syntax, but pre-increment in sematics (the variable is incremented, before the return value is calculated). This behavior is unlike that of C and C++.
- - | auto-decrement (post-fix only) | $b-- | Decrement $b. Note: --$b is illegal. Note: the value of $a-- is that of the decremented variable: auto-decrement is post-fix in syntax, but pre-decrement in sematics (the variable is decremented, before the return value is calculated). This behavior is unlike that of C and C++.

Relational Operators

Relations (Arithmetic, Logical, and String)
Operator | Name | Example | Explanation
< | Less than | $a < $b | 1 if $a is less than % b (0 otherwise.)
> | More than | $a > $b | 1 if $a is greater than % b (0 otherwise.)
<= | Less than or Equal to | $a <= $b | 1 if $a is less than or equal to % b (0 otherwise.)
>= | More than or Equal to | $a >= $b | 1 if $a is greater than or equal to % b (0 otherwise.)
== | Equal to | $a == $b | 1 if $a is equal to % b (0 otherwise.)
!= | Not equal to | $a != $b | 1 if $a is not equal to % b (0 otherwise.)
! | Logical NOT | !$a | 1 if $a is 0 (0 otherwise.)
&& | Logical AND | $a && $b | 1 if $a and $b are both non-zero (0 otherwise.)
|| | Logical OR | $a || $b | 1 if either $a or $b is non-zero (0 otherwise.)
$= | String equal to | $c $= $d | 1 if $c equal to $d .
!$= | String not equal to | $c !$= $d | 1 if $c not equal to $d.

Bitwise Operators

Bitwise Operators
Operator | Name | Example | Explanation
~ | Bitwise complement | ~$a | flip bits 1 to 0 and 0 to 1. (i.e. ~10b == 01b)
& | Bitwise AND | $a & $b | composite of elements where bits in same position are 1. (i.e. 1b & 1b == 1b)
| | Bitwise OR | $a | $b | composite of elements where bits 1 in either of the two elements. (i.e. 100b & 001b == 101b)
^ | Bitwise XOR | $a ^ $b | composite of elements where bits in same position are opposite. (i.e. 100b & 101b == 001b)
<< | Left Shift | $a << 3 | element shifted left by 3 and padded with zeros. (i.e. 11b << 3d == 11000b)
>> | Right Shift | $a >> 3 | element shifted right by 3 and padded with zeros. (i.e. 11010b >> 3d == 00011b)

Assignment Operators

Assignment and Assignment Operators
Operator | Name | Example | Explanation
= | Assignment | $a = $b; | Assign value of $b to $a. Note: the value of an assignment is the value being assigned, so $a = $b = $c is legal.
op= | Assignment Operators | $a op= $b; | Equivalent to $a = $a op $b, where op can be any of: / % + - & | ^ << >>

String Operators

String Operators
Operator | Name | Example | Explanation
@ | String concatenation | $c @ $d | Concatenates strings $c and $d into a single string. Numeric literals/variables convert to strings.
NL | New Line | $c NL $d | Concatenates strings $c and $d into a single string separated by new-line. Note: such a string can be decomposed with getRecord()
TAB | Tab | $c TAB $d | Concatenates strings $c and $d into a single string separated by tab. Note: such a string can be decomposed with getField()
SPC | Space | $c SPC $d | Concatenates strings $c and $d into a single string separated by space. Note: such a string can be decomposed with getWord()


Torque 3D - Script Manual: Module Index

Modules

Here is a list of all modules:
  • Camera System
    • Base Camera
    • Path Camera
  • Core
    • Console
      • Debugging
      • Logging
      • Messaging
      • Packages
      • Scripting
    • File I/O
      • File Searching
    • Math
      • Matrix Math
      • Random Numbers
      • Vector Math
    • Strings
      • Field Manipulators
    • Utilities
  • Environment Objects
    • Atmosphere
    • Foliage
    • Forest
    • Miscellaneous
    • Terrain
    • Water
  • GUI
    • 3D Controls
    • Button Controls
    • Container Controls
    • Core Controls
    • Game Controls
    • General Controls
    • Image and Video Controls
    • Utility Controls
    • Value Controls
  • Game
    • AI
    • Game Objects
    • Miscellaneous
    • Physics
    • Special Effects
    • Vehicles
  • Input Management
    • Input Event Listing
  • Networking
  • Platform
    • Localization
    • Mac
    • Windows
  • Rendering
    • Font
    • GFX
      • Materials
      • Shaders
    • Lighting
      • Advanced Lighting
      • Basic Lighting
    • Render Binning
  • Sound
    • FMOD


Torque 3D - Script Manual: Camera System

Camera System

This section is dedicated to the various camera objects in Torque 3D. More...

Modules

Base Camera

The base camera object that is typically manipulated by a GameConnection's input.

Path Camera

A camera that moves along a path.

Functions

void | setDefaultFov (float defaultFOV)
Set the default FOV for a camera.
void | setFov (float FOV)
Set the FOV of the camera.
void | setZoomSpeed (int speed)
Set the zoom speed of the camera. This affects how quickly the camera changes from one field of view to another.

Detailed Description

This section is dedicated to the various camera objects in Torque 3D.

Function Documentation

void setDefaultFov ( float defaultFOV )

Set the default FOV for a camera.

Parameters:
defaultFOV The default field of view in degrees
void setFov ( float FOV )

Set the FOV of the camera.

Parameters:
FOV The camera's new FOV in degrees
void setZoomSpeed ( int speed )

Set the zoom speed of the camera. This affects how quickly the camera changes from one field of view to another.

Parameters:
speed The camera's zoom speed in ms per 90deg FOV change


Torque 3D - Script Manual: Base Camera

Base Camera
[Camera System]

The base camera object that is typically manipulated by a GameConnection's input. More...

Classes

class | Camera
Represents a position, direction and field of view to render a scene from. More...
class | CameraData
A datablock that describes a camera. More...

Enumerations

enum CameraMotionMode {
Stationary,
FreeRotate,
Fly,
OrbitObject,
OrbitPoint,
TrackObject,
Overhead,
EditOrbit
}

Movement behavior type for Camera.

More...

Variables

static float | Camera::movementSpeed
Global camera movement speed in units/s (typically m/s), with a base value of 40.

Detailed Description

The base camera object that is typically manipulated by a GameConnection's input.

Enumeration Type Documentation

enum CameraMotionMode

Movement behavior type for Camera.

Enumerator:
Stationary

Camera does not rotate or move.

FreeRotate

Camera may rotate but does not move.

Fly

Camera may rotate and move freely.

OrbitObject

Camera orbits about a given object. Damage flash and white out is determined by the object being orbited. See Camera::setOrbitMode() to set the orbit object and other parameters.

OrbitPoint

Camera orbits about a given point. See Camera::setOrbitMode() to set the orbit point and other parameters.

TrackObject

Camera always faces a given object. See Camera::setTrackObject() to set the object to track and a distance to remain from the object.

Overhead

Camera moves in the XY plane.

EditOrbit

Used by the World Editor to orbit about a point. When first activated, the camera is rotated to face the orbit point rather than move to it.

Variable Documentation

float Camera::movementSpeed [static, inherited]

Global camera movement speed in units/s (typically m/s), with a base value of 40.

Used in the following camera modes:

  • Edit Orbit Mode
  • Fly Mode
  • Overhead Mode


Torque 3D - Script Manual: Path Camera

Path Camera
[Camera System]

A camera that moves along a path. More...

Classes

class | PathCamera
A camera that moves along a path. The camera can then be made to travel along this path forwards or backwards. More...
class | PathCameraData
General interface to control a PathCamera object from the script level. More...

Detailed Description

A camera that moves along a path.


Torque 3D - Script Manual: Core

Core

Basic engine and language functionality for TorqueScript. More...

Modules

Utilities

Miscellaneous utility functions.

Console

The basis of the TorqueScript system and command execution.

File I/O

Functions allowing you to search for files, read them, write them, and access their properties.

Strings

Functions for dealing with string values.

Math

Functions for dealing with vectors and matrices etc.

Detailed Description

Basic engine and language functionality for TorqueScript.


Torque 3D - Script Manual: Console

Console
[Core]

The basis of the TorqueScript system and command execution. More...

Classes

class | ScriptGroup
Essentially a SimGroup, but with onAdd and onRemove script callbacks. More...
class | ScriptObject
A script-level OOP object which allows binding of a class, superClass and arguments along with declaration of methods. More...
class | SimDataBlock
Root DataBlock class. More...
class | SimGroup
A collection of SimObjects that are owned by the group. More...
class | SimObject
Base class for almost all objects involved in the simulation. More...
class | SimSet
A collection of SimObjects. More...

Modules

Logging

Functions for logging messages, warnings, and errors to the console.

Debugging

Functionality to help spot program errors.

Scripting

Functions for working with script code.

Packages

Functions relating to the control of packages.

Messaging

Script classes and functions used for passing messages and events between classes.

Functions

void | cls ()
Clears the console output.
void | debugEnumInstances (string className, string functionName)
Call the given function for each instance of the given class.
void | deleteDataBlocks ()
Delete all the datablocks we've downloaded.
bool | dumpEngineDocs (string outputFile)
Dumps the engine scripting documentation to the specified file overwriting any existing content.
SimXMLDocument exportEngineAPIToXML ()
Create a XML document containing a dump of the entire exported engine API.
string | getCategoryOfClass (string className)
Returns the category of the given class.
string | getDescriptionOfClass (string className)
Returns the description string for the named class.
bool | isClass (string identifier)
Returns true if the passed identifier is the name of a declared class.
bool | isMemberOfClass (string className, string superClassName)
Returns true if the class is derived from the super class.
bool | isValidObjectName (string name)
Return true if the given name makes for a valid object name.
SimObject | loadObject (string filename)
Loads a serialized object from a file.
void | preloadClientDataBlocks ()
Preload all datablocks in client mode.
bool | saveObject (SimObject object, string filename)
Serialize the object to a file.
void | unitTest_runTests ([searchString[, bool skipInteractive]])
Run unit tests, or just the tests that prefix match against the searchString.

Variables

string | $instantGroup
The group that objects will be added to when they are created.
bool | $Con::alwaysUseDebugOutput
Determines whether to send output to the platform's "debug" system.
bool | $Con::logBufferEnabled
If true, the log buffer will be enabled.
int | $Con::printLevel
This is deprecated.
bool | $Con::useTimestamp
If true a timestamp is prepended to every console message.
bool | $Con::warnUndefinedVariables
If true, a warning will be displayed in the console whenever a undefined variable is used in script.

Detailed Description

The basis of the TorqueScript system and command execution.

Function Documentation

void cls ( )

Clears the console output.

void debugEnumInstances | ( | string | className,
 |  | string | functionName
 | ) |  |

Call the given function for each instance of the given class.

Parameters:
className | Name of the class for which to enumerate instances.
functionName | Name of function to call and pass each instance of the given class.
Note:
This function is only available in debug builds and primarily meant as an aid in debugging.
void deleteDataBlocks ( )

Delete all the datablocks we've downloaded.

This is usually done in preparation of downloading a new set of datablocks, such as occurs on a mission change, but it's also good post-mission cleanup.

bool dumpEngineDocs ( string outputFile )

Dumps the engine scripting documentation to the specified file overwriting any existing content.

Parameters:
outputFile The relative or absolute output file path and name.
Returns:
Returns true if successful.
SimXMLDocument exportEngineAPIToXML ( )

Create a XML document containing a dump of the entire exported engine API.

Returns:
A SimXMLDocument containing a dump of the engine's export information or NULL if the operation failed.
string getCategoryOfClass ( string className )

Returns the category of the given class.

Parameters:
className The name of the class.
string getDescriptionOfClass ( string className )

Returns the description string for the named class.

Parameters:
className The name of the class.
Returns:
The class description in string format.
bool isClass ( string identifier )

Returns true if the passed identifier is the name of a declared class.

bool isMemberOfClass | ( | string | className,
 |  | string | superClassName
 | ) |  |

Returns true if the class is derived from the super class.

If either class doesn't exist this returns false.

Parameters:
className | The class name.
superClassName | The super class to look for.
bool isValidObjectName ( string name )

Return true if the given name makes for a valid object name.

Parameters:
name Name of object
Returns:
True if name is allowed, false if denied (usually because it starts with a number, _, or invalid character
SimObject loadObject ( string filename )

Loads a serialized object from a file.

Parameters:
Name and path to text file containing the object
void preloadClientDataBlocks ( )

Preload all datablocks in client mode.

(Server parameter is set to false). This will take some time to complete.

bool saveObject | ( | SimObject | object,
 |  | string | filename
 | ) |  |

Serialize the object to a file.

Parameters:
object | The object to serialize.
filename | The file name and path.
void unitTest_runTests ( [searchString[, bool skipInteractive] ] )

Run unit tests, or just the tests that prefix match against the searchString.

Variable Documentation

string $instantGroup

The group that objects will be added to when they are created.

bool $Con::alwaysUseDebugOutput

Determines whether to send output to the platform's "debug" system.

Note:
This is disabled in shipping builds.
bool $Con::logBufferEnabled

If true, the log buffer will be enabled.

int $Con::printLevel

This is deprecated.

It is no longer in use and does nothing.

bool $Con::useTimestamp

If true a timestamp is prepended to every console message.

bool $Con::warnUndefinedVariables

If true, a warning will be displayed in the console whenever a undefined variable is used in script.


Torque 3D - Script Manual: Debugging

Debugging
[Console]

Functionality to help spot program errors. More...

Functions

void | backtrace ()
Prints the scripting call stack to the console log.
void | debug ()
Drops the engine into the native C++ debugger.
void | debugDumpAllObjects ()
Dumps all current EngineObject instances to the console.
void | debugv (string variableName)
Logs the value of the given variable to the console.
void | dumpAlloc (int allocNum)
Dumps information about the given allocated memory block.
void | dumpMemSnapshot (string fileName)
Dumps a snapshot of current memory to a file.
void | dumpUnflaggedAllocs (string fileName="")
Dumps all unflagged memory allocations.
void | flagCurrentAllocs ()
Flags all current memory allocations.
void | freeMemoryDump ()
Dumps some useful statistics regarding free memory.
void | profilerDump ()
Dumps current profiling stats to the console window.
void | profilerDumpToFile (string fileName)
Dumps current profiling stats to a file.
void | profilerEnable (bool enable)
Enables or disables the profiler.
void | profilerMarkerEnable (string markerName, bool enable=true)
Enable or disable a specific profile.
void | profilerReset ()
Resets the profiler, clearing it of all its data.
int | sizeof (string objectOrClass)
Determines the memory consumption of a class or object.
void | telnetSetParameters (int port, string consolePass, string listenPass, bool remoteEcho=false)
Initializes and open the telnet console.
void | trace (bool enable=true)
Enable or disable tracing in the script code VM.
void | validateMemory ()
Used to validate memory space for the game.

Variables

string | getBuildString
Get the type of build, "Debug" or "Release".
string | getCompileTimeString
Get the time of compilation.
string | getEngineName
Get the name of the engine product that this is running from, as a string.
int | getVersionNumber
Get the version of the build, as a string.
string | getVersionString
Get the version of the build, as a string.

Detailed Description

Functionality to help spot program errors.

Also provides profiler functions, helpful in determining performance bottlenecks.

Function Documentation

void backtrace ( )

Prints the scripting call stack to the console log.

Used to trace functions called from within functions. Can help discover what functions were called (and not yet exited) before the current point in scripts.

void debug ( )

Drops the engine into the native C++ debugger.

This function triggers a debug break and drops the process into the IDE's debugger. If the process is not running with a debugger attached it will generate a runtime error on most platforms.

Note:
This function is not available in shipping builds.
void debugDumpAllObjects ( )

Dumps all current EngineObject instances to the console.

Note:
This function is only available in debug builds.
void debugv ( string variableName )

Logs the value of the given variable to the console.

Prints a string of the form "<variableName> = <variable value>" to the console.

Parameters:
variableName Name of the local or global variable to print.
Example:
%var = 1;
debugv( "%var" ); // Prints "%var = 1"
void dumpAlloc ( int allocNum )

Dumps information about the given allocated memory block.

Parameters:
allocNum Memory block to dump information about.
Note:
Available in debug builds only. In torqueConfig.h, TORQUE_DISABLE_MEMORY_MANAGER must be undefined to use this function.
void dumpMemSnapshot ( string fileName )

Dumps a snapshot of current memory to a file.

The total memory used will also be output to the console. This function will attempt to create the file if it does not already exist.

Parameters:
fileName Name and path of file to save profiling stats to. Must use forward slashes (/)
Example:
dumpMemSnapshot( "C:/Torque/ProfilerLogs/profilerlog1.txt" );
Note:
Available in debug builds only. In torqueConfig.h, TORQUE_DISABLE_MEMORY_MANAGER must be undefined to use this function.
void dumpUnflaggedAllocs ( string fileName = "" )

Dumps all unflagged memory allocations.

Dumps all memory allocations that were made after a call to flagCurrentAllocs(). Helpful when used with flagCurrentAllocs() for detecting memory leaks and analyzing general memory usage.

Parameters:
fileName Optional file path and location to dump all memory allocations not flagged by flagCurrentAllocs(). If left blank, data will be dumped to the console.
Example:
dumpMemSnapshot(); // dumps info to console
dumpMemSnapshot( "C:/Torque/profilerlog1.txt" ); // dumps info to file
Note:
Available in debug builds only. In torqueConfig.h, TORQUE_DISABLE_MEMORY_MANAGER must be undefined to use this function.
void flagCurrentAllocs ( )

Flags all current memory allocations.

Flags all current memory allocations for exclusion in subsequent calls to dumpUnflaggedAllocs(). Helpful in detecting memory leaks and analyzing memory usage.

void freeMemoryDump ( )

Dumps some useful statistics regarding free memory.

Dumps an analysis of 'free chunks' of memory. Does not print how much memory is free.

void profilerDump ( )

Dumps current profiling stats to the console window.

Note:
Markers disabled with profilerMarkerEnable() will be skipped over. If the profiler is currently running, it will be disabled.
void profilerDumpToFile ( string fileName )

Dumps current profiling stats to a file.

Note:
If the profiler is currently running, it will be disabled.
Parameters:
fileName Name and path of file to save profiling stats to. Must use forward slashes (/). Will attempt to create the file if it does not already exist.
Example:
profilerDumpToFile( "C:/Torque/log1.txt" );
void profilerEnable ( bool enable )

Enables or disables the profiler.

Data is only gathered while the profiler is enabled.

Note:
Profiler is not available in shipping builds. T3D has predefined profiling areas surrounded by markers, but you may need to define additional markers (in C++) around areas you wish to profile, by using the PROFILE_START( markerName ); and PROFILE_END(); macros.
void profilerMarkerEnable | ( | string | markerName,
 |  | bool | enable = true
 | ) |  |

Enable or disable a specific profile.

Parameters:
enable | Optional paramater to enable or disable the profile.
markerName | Name of a specific marker to enable or disable.
Note:
Calling this function will first call profilerReset(), clearing all data from profiler. All profile markers are enabled by default.
void profilerReset ( )

Resets the profiler, clearing it of all its data.

If the profiler is currently running, it will first be disabled. All markers will retain their current enabled/disabled status.

int sizeof ( string objectOrClass )

Determines the memory consumption of a class or object.

Parameters:
objectOrClass The object or class being measured.
Returns:
Returns the total size of an object in bytes.
void telnetSetParameters | ( | int | port,
 |  | string | consolePass,
 |  | string | listenPass,
 |  | bool | remoteEcho = false
 | ) |  |

Initializes and open the telnet console.

Parameters:
port | Port to listen on for console connections (0 will shut down listening).
consolePass | Password for read/write access to console.
listenPass | Password for read access to console.
remoteEcho | [optional] Enable echoing back to the client, off by default.
void trace ( bool enable = true )

Enable or disable tracing in the script code VM.

When enabled, the script code runtime will trace the invocation and returns from all functions that are called and log them to the console. This is helpful in observing the flow of the script program.

Parameters:
enable New setting for script trace execution, on by default.
void validateMemory ( )

Used to validate memory space for the game.

Variable Documentation

string getBuildString

Get the type of build, "Debug" or "Release".

string getCompileTimeString

Get the time of compilation.

string getEngineName

Get the name of the engine product that this is running from, as a string.

int getVersionNumber

Get the version of the build, as a string.

string getVersionString

Get the version of the build, as a string.


Torque 3D - Script Manual: Logging

Logging
[Console]

Functions for logging messages, warnings, and errors to the console. More...

Classes

class | ConsoleLogger

Enumerations

enum LogLevel {
normal,
warning,
error
}

Priority levels for logging entries.

More...

Functions

void | dumpConsoleClasses (bool dumpScript=true, bool dumpEngine=true)
Dumps all declared console classes to the console.
void | dumpConsoleFunctions (bool dumpScript=true, bool dumpEngine=true)
Dumps all declared console functions to the console.
void | echo (string message...)
Logs a message to the console.
void | error (string message...)
Logs an error message to the console.
void | log (string message)
Logs a message to the console.
void | logError (string message)
Logs an error message to the console.
void | logWarning (string message)
Logs a warning message to the console.
void | setLogMode (int mode)
Determines how log files are written.
void | warn (string message...)
Logs a warning message to the console.

Detailed Description

Functions for logging messages, warnings, and errors to the console.

Enumeration Type Documentation

enum LogLevel

Priority levels for logging entries.

Enumerator:
normal

Lowest priority level, no highlighting.

warning

Mid level priority, tags and highlights possible issues in blue.

error

Highest priority level, extreme emphasis on this entry. Highlighted in red.

Function Documentation

void dumpConsoleClasses | ( | bool | dumpScript = true,
 |  | bool | dumpEngine = true
 | ) |  |

Dumps all declared console classes to the console.

Parameters:
dumpScript | Optional parameter specifying whether or not classes defined in script should be dumped.
dumpEngine | Optional parameter specifying whether or not classes defined in the engine should be dumped.
void dumpConsoleFunctions | ( | bool | dumpScript = true,
 |  | bool | dumpEngine = true
 | ) |  |

Dumps all declared console functions to the console.

Parameters:
dumpScript | Optional parameter specifying whether or not functions defined in script should be dumped.
dumpEngine | Optional parameter specitying whether or not functions defined in the engine should be dumped.
void echo ( string message... )

Logs a message to the console.

Concatenates all given arguments to a single string and prints the string to the console. A newline is added automatically after the text.

Parameters:
message Any number of string arguments.
void error ( string message... )

Logs an error message to the console.

Concatenates all given arguments to a single string and prints the string to the console as an error message (in the in-game console, these will show up using a red font by default). A newline is added automatically after the text.

Parameters:
message Any number of string arguments.
void log ( string message )

Logs a message to the console.

Parameters:
message The message text.
Note:
By default, messages will appear white in the console.
void logError ( string message )

Logs an error message to the console.

Parameters:
message The message text.
Note:
By default, errors will appear red in the console.
void logWarning ( string message )

Logs a warning message to the console.

Parameters:
message The message text.
Note:
By default, warnings will appear turquoise in the console.
void setLogMode ( int mode )

Determines how log files are written.

Sets the operational mode of the console logging system.

Parameters:
mode Parameter specifying the logging mode. This can be:

  • 1: Open and close the console log file for each seperate string of output. This will ensure that all parts get written out to disk and that no parts remain in intermediate buffers even if the process crashes.
  • 2: Keep the log file open and write to it continuously. This will make the system operate faster but if the process crashes, parts of the output may not have been written to disk yet and will be missing from the log.

Additionally, when changing the log mode and thus opening a new log file, either of the two mode values may be combined by binary OR with 0x4 to cause the logging system to flush all console log messages that had already been issued to the console system into the newly created log file.

Note:
Xbox 360 does not support logging to a file. Use Platform::OutputDebugStr in C++ instead.
void warn ( string message... )

Logs a warning message to the console.

Concatenates all given arguments to a single string and prints the string to the console as a warning message (in the in-game console, these will show up using a turquoise font by default). A newline is added automatically after the text.

Parameters:
message Any number of string arguments.


Torque 3D - Script Manual: Messaging

Messaging
[Console]

Script classes and functions used for passing messages and events between classes. More...

Classes

class | EventManager
The EventManager class is a wrapper for the standard messaging system. More...
class | Message
Base class for messages. More...
class | MessageForwarder
Forward messages from one queue to another. More...
class | ScriptMsgListener
Script accessible version of Dispatcher::IMessageListener. Often used in conjunction with EventManager. More...

Functions

bool | dispatchMessage (string queueName, string message, string data)
Dispatch a message to a queue.
bool | dispatchMessageObject (string queueName, string message)
Dispatch a message object to a queue.
bool | isQueueRegistered (string queueName)
Determines if a dispatcher queue exists.
bool | registerMessageListener (string queueName, string listener)
Registers an event message.
void | registerMessageQueue (string queueName)
Registeres a dispatcher queue.
void | unregisterMessageListener (string queueName, string listener)
Unregisters an event message.
void | unregisterMessageQueue (string queueName)
Unregisters a dispatcher queue.

Detailed Description

Script classes and functions used for passing messages and events between classes.

Function Documentation

bool dispatchMessage | ( | string | queueName,
 |  | string | message,
 |  | string | data
 | ) |  |

Dispatch a message to a queue.

Parameters:
queueName | Queue to dispatch the message to
message | Message to dispatch
data | Data for message
Returns:
True for success, false for failure
See also:
dispatchMessageObject
bool dispatchMessageObject | ( | string | queueName,
 |  | string | message
 | ) |  |

Dispatch a message object to a queue.

Parameters:
queueName | Queue to dispatch the message to
message | Message to dispatch
Returns:
true for success, false for failure
See also:
dispatchMessage
bool isQueueRegistered ( string queueName )

Determines if a dispatcher queue exists.

Parameters:
queueName String containing the name of queue
bool registerMessageListener | ( | string | queueName,
 |  | string | listener
 | ) |  |

Registers an event message.

Parameters:
queueName | String containing the name of queue to attach listener to
listener | Name of event messenger
void registerMessageQueue ( string queueName )

Registeres a dispatcher queue.

Parameters:
queueName String containing the name of queue
void unregisterMessageListener | ( | string | queueName,
 |  | string | listener
 | ) |  |

Unregisters an event message.

Parameters:
queueName | String containing the name of queue
listener | Name of event messenger
void unregisterMessageQueue ( string queueName )

Unregisters a dispatcher queue.

Parameters:
queueName String containing the name of queue


Torque 3D - Script Manual: Packages

Packages
[Console]

Functions relating to the control of packages. More...

Functions

void | activatePackage (String packageName)
Activates an existing package.
void | deactivatePackage (String packageName)
Deactivates a previously activated package.
string | getFunctionPackage (string funcName)
Provides the name of the package the function belongs to.
string | getMethodPackage (string namespace, string method)
Provides the name of the package the method belongs to.
string | getPackageList ()
Returns a space delimited list of the active packages in stack order.
bool | isPackage (String identifier)
Returns true if the identifier is the name of a declared package.

Detailed Description

Functions relating to the control of packages.

See also:
Packages

Function Documentation

void activatePackage ( String packageName )

Activates an existing package.

The activation occurs by updating the namespace linkage of existing functions and methods. If the package is already activated the function does nothing.

void deactivatePackage ( String packageName )

Deactivates a previously activated package.

The package is deactivated by removing its namespace linkages to any function or method. If there are any packages above this one in the stack they are deactivated as well. If the package is not on the stack this function does nothing.

string getFunctionPackage ( string funcName )

Provides the name of the package the function belongs to.

Parameters:
funcName String containing name of the function
Returns:
The name of the function's package
string getMethodPackage | ( | string | namespace,
 |  | string | method
 | ) |  |

Provides the name of the package the method belongs to.

Parameters:
namespace | Class or namespace, such as Player
method | Name of the funciton to search for
Returns:
The name of the method's package
string getPackageList ( )

Returns a space delimited list of the active packages in stack order.

bool isPackage ( String identifier )

Returns true if the identifier is the name of a declared package.


Torque 3D - Script Manual: Scripting

Scripting
[Console]

Functions for working with script code. More...

Classes

class | ArrayObject
Data structure for storing indexed sequences of key/value pairs. More...
class | ScriptGroup
Essentially a SimGroup, but with onAdd and onRemove script callbacks. More...
class | ScriptObject
A script-level OOP object which allows binding of a class, superClass and arguments along with declaration of methods. More...
class | SimGroup
A collection of SimObjects that are owned by the group. More...
class | SimSet
A collection of SimObjects. More...

Functions

string | call (string functionName, string args...)
Apply the given arguments to the specified global function and return the result of the call.
bool | compile (string fileName, bool overrideNoDSO=false)
Compile a file to bytecode.
void | deleteVariables (string pattern)
Undefine all global variables matching the given name pattern.
bool | exec (string fileName, bool noCalls=false, bool journalScript=false)
Execute the given script file.
bool | execPrefs (string relativeFileName, bool noCalls=false, bool journalScript=false)
Manually execute a special script file that contains game or editor preferences.
void | export (string pattern, string filename="", bool append=false)
Write out the definitions of all global variables matching the given name pattern.
string | getDSOPath (string scriptFileName)
Get the absolute path to the file in which the compiled code for the given script file will be stored.
string | getVariable (string varName)
Returns the value of the named variable or an empty string if not found.
bool | isDefined (string varName)
Determines if a variable exists and contains a value.
bool | isFunction (string funcName)
Determines if a function exists or not.
bool | isMethod (string namespace, string method)
Determines if a class/namespace method exists.
void | setVariable (string varName, string value)
Sets the value of the named variable.

Detailed Description

Functions for working with script code.

Function Documentation

string call | ( | string | functionName,
 |  | string | args...
 | ) |  |

Apply the given arguments to the specified global function and return the result of the call.

Parameters:
functionName The name of the function to call. This function must be in the global namespace, i.e. you cannot call a function in a namespace through call. Use eval() for that.
Returns:
The result of the function call.
Example:
function myFunction( %arg )
{
  return ( %arg SPC "World!" );
}

echo( call( "myFunction", "Hello" ) ); // Prints "Hello World!" to the console.

bool compile | ( | string | fileName,
 |  | bool | overrideNoDSO = false
 | ) |  |

Compile a file to bytecode.

This function will read the TorqueScript code in the specified file, compile it to internal bytecode, and, if DSO generation is enabled or overrideNoDDSO is true, will store the compiled code in a .dso file in the current DSO path mirrorring the path of fileName.

Parameters:
fileName | Path to the file to compile to bytecode.
overrideNoDSO | If true, force generation of DSOs even if the engine is compiled to not generate write compiled code to DSO files.
Returns:
True if the file was successfully compiled, false if not.
Note:
The definitions contained in the given file will not be made available and no code will actually be executed. Use exec() for that.
See also:
getDSOPath
exec
void deleteVariables ( string pattern )

Undefine all global variables matching the given name pattern.

Parameters:
pattern A global variable name pattern. Must begin with '$'.
Example:
// Define a global variable in the "My" namespace.
$My::Variable = "value";

// Undefine all variable in the "My" namespace.
deleteVariables( "$My::*" );
See also:
strIsMatchExpr
bool exec | ( | string | fileName,
 |  | bool | noCalls = false,
 |  | bool | journalScript = false
 | ) |  |

Execute the given script file.

Parameters:
fileName | Path to the file to execute
noCalls | Deprecated
journalScript | Deprecated
Returns:
True if the script was successfully executed, false if not.
Example:
// Execute the init.cs script file found in the same directory as the current script file.
exec( "./init.cs" );
See also:
compile
eval
bool execPrefs | ( | string | relativeFileName,
 |  | bool | noCalls = false,
 |  | bool | journalScript = false
 | ) |  |

Manually execute a special script file that contains game or editor preferences.

Parameters:
relativeFileName | Name and path to file from project folder
noCalls | Deprecated
journalScript | Deprecated
Returns:
True if script was successfully executed
Note:
Appears to be useless in Torque 3D, should be deprecated
void export | ( | string | pattern,
 |  | string | filename = "",
 |  | bool | append = false
 | ) |  |

Write out the definitions of all global variables matching the given name pattern.

If fileName is not "", the variable definitions are written to the specified file. Otherwise the definitions will be printed to the console.

The output are valid TorqueScript statements that can be executed to restore the global variable values.

Parameters:
pattern | A global variable name pattern. Must begin with '$'.
filename | Path of the file to which to write the definitions or "" to write the definitions to the console.
append | If true and fileName is not "", then the definitions are appended to the specified file. Otherwise existing contents of the file (if any) will be overwritten.
Example:
// Write out all preference variables to a prefs.cs file.
export( "$prefs::*", "prefs.cs" );
string getDSOPath ( string scriptFileName )

Get the absolute path to the file in which the compiled code for the given script file will be stored.

Parameters:
scriptFileName Path to the .cs script file.
Returns:
The absolute path to the .dso file for the given script file.
Note:
The compiler will store newly compiled DSOs in the prefs path but pre-existing DSOs will be loaded from the current paths.
See also:
compile
getPrefsPath
string getVariable ( string varName )

Returns the value of the named variable or an empty string if not found.

Name of the variable to search for

Returns:
Value contained by varName, "" if the variable does not exist
bool isDefined ( string varName )

Determines if a variable exists and contains a value.

Parameters:
varName Name of the variable to search for
Returns:
True if the variable was defined in script, false if not
Example:
isDefined( "$myVar" );
bool isFunction ( string funcName )

Determines if a function exists or not.

Parameters:
funcName String containing name of the function
Returns:
True if the function exists, false if not
bool isMethod | ( | string | namespace,
 |  | string | method
 | ) |  |

Determines if a class/namespace method exists.

Parameters:
namespace | Class or namespace, such as Player
method | Name of the function to search for
Returns:
True if the method exists, false if not
void setVariable | ( | string | varName,
 |  | string | value
 | ) |  |

Sets the value of the named variable.

Parameters:
varName | Name of the variable to locate
value | New value of the variable
Returns:
True if variable was successfully found and set


Torque 3D - Script Manual: File I/O

File I/O
[Core]

Functions allowing you to search for files, read them, write them, and access their properties. More...

Classes

class | FileDialog
Base class responsible for displaying an OS file browser. More...
class | FileObject
This class is responsible opening, reading, creating, and saving file contents. More...
class | FileStreamObject
A wrapper around StreamObject for parsing text and data from files. More...
class | OpenFileDialog
Derived from FileDialog, this class is responsible for opening a file browser with the intention of opening a file. More...
class | OpenFolderDialog
OS level dialog used for browsing folder structures. More...
class | SaveFileDialog
Derived from FileDialog, this class is responsible for opening a file browser with the intention of saving a file. More...
class | SimXMLDocument
File I/O object used for creating, reading, and writing XML documents. More...
class | StreamObject
Base class for working with streams. More...
class | ZipObject
Provides access to a zip file. More...

Modules

File Searching

Functions for searching files by name patterns.

Functions

bool | createPath (string path)
Create the given directory or the path leading to the given filename.
string | expandFilename (string filename)
Grabs the full path of a specified file.
string | expandOldFilename (string filename)
Retrofits a filepath that uses old Torque style.
String | fileBase (string fileName)
Get the base of a file name (removes extension).
String | fileCreatedTime (string fileName)
Returns a platform specific formatted string with the creation time for the file.
bool | fileDelete (string path)
Delete a file from the hard drive.
String | fileExt (string fileName)
Get the extension of a file.
String | fileModifiedTime (string fileName)
Returns a platform specific formatted string with the last modified time for the file.
String | fileName (string fileName)
Get the file name of a file (removes extension and path).
String | filePath (string fileName)
Get the path of a file (removes name and extension).
int | fileSize (string fileName)
Determines the size of a file on disk.
String | getCurrentDirectory ()
Return the current working directory.
String | getDirectoryList (string path, int depth=0)
Gathers a list of directories starting at the given path.
String | getExecutableName ()
Gets the name of the game's executable.
int | getFileCRC (string fileName)
Provides the CRC checksum of the given file.
String | getMainDotCsDir ()
Get the absolute path to the directory that contains the main.cs script from which the engine was started.
String | getWorkingDirectory ()
Reports the current directory.
bool | IsDirectory (string directory)
Determines if a specified directory exists or not.
bool | isFile (string fileName)
Determines if the specified file exists or not.
bool | isWriteableFileName (string fileName)
Determines if a file name can be written to using File I/O.
String | makeFullPath (string path, string cwd="")
Converts a relative file path to a full path.
String | makeRelativePath (string path, string to="")
Turns a full or local path to a relative one.
void | openFile (string file)
Open the given file through the system. This will usually open the file in its associated application.
void | openFolder (string path)
Open the given folder in the system's file manager.
String | pathConcat (string path, string file)
Combines two separate strings containing a file path and file name together into a single string.
bool | pathCopy (string fromFile, string toFile, bool noOverwrite=true)
Copy a file to a new location.
bool | setCurrentDirectory (string path)
Set the current working directory.
void | startFileChangeNotifications ()
Start watching resources for file changes.
void | stopFileChangeNotifications ()
Stop watching resources for file changes.

Variables

string | $Con::File
The currently executing script file.
string | $Con::Root
The mod folder for the currently executing script file.

Detailed Description

Functions allowing you to search for files, read them, write them, and access their properties.

Function Documentation

bool createPath ( string path )

Create the given directory or the path leading to the given filename.

If path ends in a trailing slash, then all components in the given path will be created as directories (if not already in place). If path, does not end in a trailing slash, then the last component of the path is taken to be a file name and only the directory components of the path will be created.

Parameters:
path The path to create.
Note:
Only present in a Tools build of Torque.
string expandFilename ( string filename )

Grabs the full path of a specified file.

Parameters:
filename Name of the local file to locate
Returns:
String containing the full filepath on disk
string expandOldFilename ( string filename )

Retrofits a filepath that uses old Torque style.

Returns:
String containing filepath with new formatting
String fileBase ( string fileName )

Get the base of a file name (removes extension).

Parameters:
fileName Name and path of file to check
Returns:
String containing the file name, minus extension
String fileCreatedTime ( string fileName )

Returns a platform specific formatted string with the creation time for the file.

Parameters:
fileName Name and path of file to check
Returns:
Formatted string (OS specific) containing created time, "9/3/2010 12:33:47 PM" for example
bool fileDelete ( string path )

Delete a file from the hard drive.

Parameters:
path Name and path of the file to delete
Note:
THERE IS NO RECOVERY FROM THIS. Deleted file is gone for good.
Returns:
True if file was successfully deleted
String fileExt ( string fileName )

Get the extension of a file.

Parameters:
fileName Name and path of file
Returns:
String containing the extension, such as ".exe" or ".cs"
String fileModifiedTime ( string fileName )

Returns a platform specific formatted string with the last modified time for the file.

Parameters:
fileName Name and path of file to check
Returns:
Formatted string (OS specific) containing modified time, "9/3/2010 12:33:47 PM" for example
String fileName ( string fileName )

Get the file name of a file (removes extension and path).

Parameters:
fileName Name and path of file to check
Returns:
String containing the file name, minus extension and path
String filePath ( string fileName )

Get the path of a file (removes name and extension).

Parameters:
fileName Name and path of file to check
Returns:
String containing the path, minus name and extension
int fileSize ( string fileName )

Determines the size of a file on disk.

Parameters:
fileName Name and path of the file to check
Returns:
Returns filesize in KB, or -1 if no file
String getCurrentDirectory ( )

Return the current working directory.

Returns:
The absolute path of the current working directory.
Note:
Only present in a Tools build of Torque.
See also:
getWorkingDirectory()
String getDirectoryList | ( | string | path,
 |  | int | depth = 0
 | ) |  |

Gathers a list of directories starting at the given path.

Parameters:
path | String containing the path of the directory
depth | Depth of search, as in how many subdirectories to parse through
Returns:
Tab delimited string containing list of directories found during search, "" if no files were found
String getExecutableName ( )

Gets the name of the game's executable.

Returns:
String containing this game's executable name
int getFileCRC ( string fileName )

Provides the CRC checksum of the given file.

Parameters:
fileName The path to the file.
Returns:
The calculated CRC checksum of the file, or -1 if the file could not be found.
String getMainDotCsDir ( )

Get the absolute path to the directory that contains the main.cs script from which the engine was started.

This directory will usually contain all the game assets and, in a user-side game installation, will usually be read-only.

Returns:
The path to the main game assets.
String getWorkingDirectory ( )

Reports the current directory.

Returns:
String containing full file path of working directory
bool IsDirectory ( string directory )

Determines if a specified directory exists or not.

Parameters:
directory String containing path in the form of "foo/bar"
Returns:
Returns true if the directory was found.
Note:
Do not include a trailing slash '/'.
bool isFile ( string fileName )

Determines if the specified file exists or not.

Parameters:
fileName The path to the file.
Returns:
Returns true if the file was found.
bool isWriteableFileName ( string fileName )

Determines if a file name can be written to using File I/O.

Parameters:
fileName Name and path of file to check
Returns:
Returns true if the file can be written to.
String makeFullPath | ( | string | path,
 |  | string | cwd = ""
 | ) |  |

Converts a relative file path to a full path.

For example, "./console.log" becomes "C:/Torque/t3d/examples/FPS Example/game/console.log"

Parameters:
path | Name of file or path to check
cwd | Optional current working directory from which to build the full path.
Returns:
String containing non-relative directory of path
String makeRelativePath | ( | string | path,
 |  | string | to = ""
 | ) |  |

Turns a full or local path to a relative one.

For example, "./game/art" becomes "game/art"

Parameters:
path | Full path (may include a file) to convert
to | Optional base path used for the conversion. If not supplied the current working directory is used.
Returns:
String containing relative path
void openFile ( string file )

Open the given file through the system. This will usually open the file in its associated application.

Parameters:
file Path of the file to open.
Note:
Only present in a Tools build of Torque.
void openFolder ( string path )

Open the given folder in the system's file manager.

Parameters:
path full path to a directory.
Note:
Only present in a Tools build of Torque.
String pathConcat | ( | string | path,
 |  | string | file
 | ) |  |

Combines two separate strings containing a file path and file name together into a single string.

Parameters:
path | String containing file path
file | String containing file name
Returns:
String containing concatenated file name and path
bool pathCopy | ( | string | fromFile,
 |  | string | toFile,
 |  | bool | noOverwrite = true
 | ) |  |

Copy a file to a new location.

Parameters:
fromFile | Path of the file to copy.
toFile | Path where to copy fromFile to.
noOverwrite | If true, then fromFile will not overwrite a file that may already exist at toFile.
Returns:
True if the file was successfully copied, false otherwise.
Note:
Only present in a Tools build of Torque.
bool setCurrentDirectory ( string path )

Set the current working directory.

Parameters:
path The absolute or relative (to the current working directory) path of the directory which should be made the new working directory.
Returns:
True if the working directory was successfully changed to path, false otherwise.
Note:
Only present in a Tools build of Torque.
void startFileChangeNotifications ( )

Start watching resources for file changes.

Typically this is called during initializeCore().

See also:
stopFileChangeNotifications()
void stopFileChangeNotifications ( )

Stop watching resources for file changes.

Typically this is called during shutdownCore().

See also:
startFileChangeNotifications()

Variable Documentation

string $Con::File

The currently executing script file.

string $Con::Root

The mod folder for the currently executing script file.


Torque 3D - Script Manual: File Searching

File Searching
[File I/O]

Functions for searching files by name patterns. More...

Functions

String | findFirstFile (string pattern, bool recurse=true)
Returns the first file in the directory system matching the given pattern.
String | findFirstFileMultiExpr (string pattern, bool recurse=true)
Returns the first file in the directory system matching the given patterns.
String | findNextFile (string pattern="")
Returns the next file matching a search begun in findFirstFile().
String | findNextFileMultiExpr (string pattern="")
Returns the next file matching a search begun in findFirstFileMultiExpr().
int | getFileCount (string pattern, bool recurse=true)
Returns the number of files in the directory tree that match the given patterns.
int | getFileCountMultiExpr (string pattern, bool recurse=true)
Returns the number of files in the directory tree that match the given patterns.

Detailed Description

Functions for searching files by name patterns.

Function Documentation

String findFirstFile | ( | string | pattern,
 |  | bool | recurse = true
 | ) |  |

Returns the first file in the directory system matching the given pattern.

Use the corresponding findNextFile() to step through the results. If you're only interested in the number of files returned by the pattern match, use getFileCount().

This function differs from findFirstFileMultiExpr() in that it supports a single search pattern being passed in.

Note:
You cannot run multiple simultaneous file system searches with these functions. Each call to findFirstFile() and findFirstFileMultiExpr() initiates a new search and renders a previous search invalid.
Parameters:
pattern | The path and file name pattern to match against.
recurse | If true, the search will exhaustively recurse into subdirectories of the given path and match the given filename pattern.
Returns:
The path of the first file matched by the search or an empty string if no matching file could be found.
Example:
// Execute all .cs files in a subdirectory and its subdirectories.
for( %file = findFirstFile( "subdirectory/*.cs" ); %file !$= ""; %file = findNextFile() )
   exec( %file );
See also:
findNextFile()
getFileCount()
findFirstFileMultiExpr()
String findFirstFileMultiExpr | ( | string | pattern,
 |  | bool | recurse = true
 | ) |  |

Returns the first file in the directory system matching the given patterns.

Use the corresponding findNextFileMultiExpr() to step through the results. If you're only interested in the number of files returned by the pattern match, use getFileCountMultiExpr().

This function differs from findFirstFile() in that it supports multiple search patterns to be passed in.

Note:
You cannot run multiple simultaneous file system searches with these functions. Each call to findFirstFile() and findFirstFileMultiExpr() initiates a new search and renders a previous search invalid.
Parameters:
pattern | The path and file name pattern to match against, such as *.cs. Separate multiple patterns with TABs. For example: "*.cs" TAB "*.dso"
recurse | If true, the search will exhaustively recurse into subdirectories of the given path and match the given filename patterns.
Returns:
String of the first matching file path, or an empty string if no matching files were found.
Example:
// Find all DTS or Collada models
%filePatterns = "*.dts" TAB "*.dae";
%fullPath = findFirstFileMultiExpr( %filePatterns );
while ( %fullPath !$= "" )
{
   echo( %fullPath );
   %fullPath = findNextFileMultiExpr( %filePatterns );
}
See also:
findNextFileMultiExpr()
getFileCountMultiExpr()
findFirstFile()
String findNextFile ( string pattern = "" )

Returns the next file matching a search begun in findFirstFile().

Parameters:
pattern The path and file name pattern to match against. This is optional and may be left out as it is not used by the code. It is here for legacy reasons.
Returns:
The path of the next filename matched by the search or an empty string if no more files match.
Example:
// Execute all .cs files in a subdirectory and its subdirectories.
for( %file = findFirstFile( "subdirectory/*.cs" ); %file !$= ""; %file = findNextFile() )
   exec( %file );
See also:
findFirstFile()
String findNextFileMultiExpr ( string pattern = "" )

Returns the next file matching a search begun in findFirstFileMultiExpr().

Parameters:
pattern The path and file name pattern to match against. This is optional and may be left out as it is not used by the code. It is here for legacy reasons.
Returns:
String of the next matching file path, or an empty string if no matching files were found.
Example:
// Find all DTS or Collada models
%filePatterns = "*.dts" TAB "*.dae";
%fullPath = findFirstFileMultiExpr( %filePatterns );
while ( %fullPath !$= "" )
{
   echo( %fullPath );
   %fullPath = findNextFileMultiExpr( %filePatterns );
}
See also:
findFirstFileMultiExpr()
int getFileCount | ( | string | pattern,
 |  | bool | recurse = true
 | ) |  |

Returns the number of files in the directory tree that match the given patterns.

This function differs from getFileCountMultiExpr() in that it supports a single search pattern being passed in.

If you're interested in a list of files that match the given pattern and not just the number of files, use findFirstFile() and findNextFile().

Parameters:
pattern | The path and file name pattern to match against.
recurse | If true, the search will exhaustively recurse into subdirectories of the given path and match the given filename pattern counting files in subdirectories.
Returns:
Number of files located using the pattern
Example:
// Count the number of .cs files in a subdirectory and its subdirectories.
getFileCount( "subdirectory/*.cs" );
See also:
findFirstFile()
findNextFile()
getFileCountMultiExpr()
int getFileCountMultiExpr | ( | string | pattern,
 |  | bool | recurse = true
 | ) |  |

Returns the number of files in the directory tree that match the given patterns.

If you're interested in a list of files that match the given patterns and not just the number of files, use findFirstFileMultiExpr() and findNextFileMultiExpr().

Parameters:
pattern | The path and file name pattern to match against, such as *.cs. Separate multiple patterns with TABs. For example: "*.cs" TAB "*.dso"
recurse | If true, the search will exhaustively recurse into subdirectories of the given path and match the given filename pattern.
Returns:
Number of files located using the patterns
Example:
// Count all DTS or Collada models
%filePatterns = "*.dts" TAB "*.dae";
echo( "Nunmer of shape files:" SPC getFileCountMultiExpr( %filePatterns ) );
See also:
findFirstFileMultiExpr()
findNextFileMultiExpr()


Torque 3D - Script Manual: Math

Math
[Core]

Functions for dealing with vectors and matrices etc. More...

Modules

Vector Math

Functions for working with three-dimensional vectors (VectorF/Point3F).

Matrix Math

Functions for working with matrices (MatrixF, AngAxisF, MatrixRotation, MatrixPosition).

Random Numbers

Functions for generating random numbers.

Functions

Point3F | getBoxCenter (Box3F box)
Get the center point of an axis-aligned box.
float | getMax (float v1, float v2)
Calculate the greater of two specified numbers.
float | getMin (float v1, float v2)
Calculate the lesser of two specified numbers.
float | m2Pi ()
Return the value of 2*PI (full-circle in radians).
float | mAbs (float v)
Calculate absolute value of specified value.
float | mAcos (float v)
Calculate the arc-cosine of v.
float | mAsin (float v)
Calculate the arc-sine of v.
float | mAtan (float rise, float run)
Calculate the arc-tangent (slope) of a line defined by rise and run.
void | mathInit (...)
Install the math library with specified extensions.
int | mCeil (float v)
Round v up to the nearest integer.
float | mClamp (float v, float min, float max)
Clamp the specified value between two bounds.
float | mCos (float v)
Calculate the cosine of v.
float | mDegToRad (float degrees)
Convert specified degrees into radians.
string | mFloatLength (float v, int precision)
Formats the specified number to the given number of decimal places.
int | mFloor (float v)
Round v down to the nearest integer.
float | mFMod (float v, float d)
Calculate the remainder of v/d.
bool | mIsPow2 (int v)
Returns whether the value is an exact power of two.
float | mLerp (float v1, float v2, float time)
Calculate linearly interpolated value between two specified numbers using specified normalized time.
float | mLog (float v)
Calculate the natural logarithm of v.
float | mPi ()
Return the value of PI (half-circle in radians).
float | mPow (float v, float p)
Calculate b raised to the p-th power.
float | mRadToDeg (float radians)
Convert specified radians into degrees.
int | mRound (float v)
Round v to the nearest integer.
float | mSaturate (float v)
Clamp the specified value between 0 and 1 (inclusive).
float | mSin (float v)
Calculate the sine of v.
string | mSolveCubic (float a, float b, float c, float d)
Solve a cubic equation (3rd degree polynomial) of form a*x^3 + b*x^2 + c*x + d = 0.
string | mSolveQuadratic (float a, float b, float c)
Solve a quadratic equation (2nd degree polynomial) of form a*x^2 + b*x + c = 0.
string | mSolveQuartic (float a, float b, float c, float d, float e)
Solve a quartic equation (4th degree polynomial) of form a*x^4 + b*x^3 + c*x^2 + d*x + e = 0.
float | mSqrt (float v)
Calculate the square-root of v.
float | mTan (float v)
Calculate the tangent of v.

Detailed Description

Functions for dealing with vectors and matrices etc.

Function Documentation

Point3F getBoxCenter ( Box3F box )

Get the center point of an axis-aligned box.

Parameters:
b A Box3F, in string format using "minExtentX minExtentY minExtentZ maxExtentX maxExtentY maxExtentZ"
Returns:
Center of the box.
float getMax | ( | float | v1,
 |  | float | v2
 | ) |  |

Calculate the greater of two specified numbers.

Parameters:
v1 | Input value.
v2 | Input value.
Returns:
The greater value of the two specified values.
float getMin | ( | float | v1,
 |  | float | v2
 | ) |  |

Calculate the lesser of two specified numbers.

Parameters:
v1 | Input value.
v2 | Input value.
Returns:
The lesser value of the two specified values.
float m2Pi ( )

Return the value of 2*PI (full-circle in radians).

Returns:
The value of 2*PI.
float mAbs ( float v )

Calculate absolute value of specified value.

Parameters:
v Input Value.
Returns:
Absolute value of specified value.
float mAcos ( float v )

Calculate the arc-cosine of v.

Parameters:
v Input Value (in radians).
Returns:
The arc-cosine of the input value.
float mAsin ( float v )

Calculate the arc-sine of v.

Parameters:
v Input Value (in radians).
Returns:
The arc-sine of the input value.
float mAtan | ( | float | rise,
 |  | float | run
 | ) |  |

Calculate the arc-tangent (slope) of a line defined by rise and run.

Parameters:
rise | of line.
run | of line.
Returns:
The arc-tangent (slope) of a line defined by rise and run.
void mathInit ( ... )

Install the math library with specified extensions.

Possible parameters are:

  • 'DETECT' Autodetect math lib settings.
  • 'C' Enable the C math routines. C routines are always enabled.
  • 'FPU' Enable floating point unit routines.
  • 'MMX' Enable MMX math routines.
  • '3DNOW' Enable 3dNow! math routines.
  • 'SSE' Enable SSE math routines.
int mCeil ( float v )

Round v up to the nearest integer.

Parameters:
v Number to convert to integer.
Returns:
Number converted to integer.
float mClamp | ( | float | v,
 |  | float | min,
 |  | float | max
 | ) |  |

Clamp the specified value between two bounds.

Parameters:
v | Input value.
min | Minimum Bound.
max | Maximum Bound.
Returns:
The specified value clamped to the specified bounds.
float mCos ( float v )

Calculate the cosine of v.

Parameters:
v Input Value (in radians).
Returns:
The cosine of the input value.
float mDegToRad ( float degrees )

Convert specified degrees into radians.

Parameters:
degrees Input Value (in degrees).
Returns:
The specified degrees value converted to radians.
string mFloatLength | ( | float | v,
 |  | int | precision
 | ) |  |

Formats the specified number to the given number of decimal places.

Parameters:
v | Number to format.
precision | Number of decimal places to format to (1-9).
Returns:
Number formatted to the specified number of decimal places.
int mFloor ( float v )

Round v down to the nearest integer.

Parameters:
v Number to convert to integer.
Returns:
Number converted to integer.
float mFMod | ( | float | v,
 |  | float | d
 | ) |  |

Calculate the remainder of v/d.

Parameters:
v | Input Value.
d | Divisor Value.
Returns:
The remainder of v/d.
bool mIsPow2 ( int v )

Returns whether the value is an exact power of two.

Parameters:
v Input value.
Returns:
Whether the specified value is an exact power of two.
float mLerp | ( | float | v1,
 |  | float | v2,
 |  | float | time
 | ) |  |

Calculate linearly interpolated value between two specified numbers using specified normalized time.

Parameters:
v1 | Interpolate From Input value.
v2 | Interpolate To Input value.
time | Normalized time used to interpolate values (0-1).
Returns:
The interpolated value between the two specified values at normalized time t.
float mLog ( float v )

Calculate the natural logarithm of v.

Parameters:
v Input Value.
Returns:
The natural logarithm of the input value.
float mPi ( )

Return the value of PI (half-circle in radians).

Returns:
The value of PI.
float mPow | ( | float | v,
 |  | float | p
 | ) |  |

Calculate b raised to the p-th power.

Parameters:
v | Input Value.
p | Power to raise value by.
Returns:
v raised to the p-th power.
float mRadToDeg ( float radians )

Convert specified radians into degrees.

Parameters:
radians Input Value (in radians).
Returns:
The specified radians value converted to degrees.
int mRound ( float v )

Round v to the nearest integer.

Parameters:
v Number to convert to integer.
Returns:
Number converted to integer.
float mSaturate ( float v )

Clamp the specified value between 0 and 1 (inclusive).

Parameters:
v Input value.
Returns:
The specified value clamped between 0 and 1 (inclusive).
float mSin ( float v )

Calculate the sine of v.

Parameters:
v Input Value (in radians).
Returns:
The sine of the input value.
string mSolveCubic | ( | float | a,
 |  | float | b,
 |  | float | c,
 |  | float | d
 | ) |  |

Solve a cubic equation (3rd degree polynomial) of form a*x^3 + b*x^2 + c*x + d = 0.

Parameters:
a | First Coefficient.
b | Second Coefficient.
c | Third Coefficient.
d | Fourth Coefficient.
Returns:
A 4-tuple, containing: (sol x0 x1 x2). (sol) is the number of solutions(being 0, 1, 2 or 3), and (x0), (x1) and (x2) are the solutions, if any.
string mSolveQuadratic | ( | float | a,
 |  | float | b,
 |  | float | c
 | ) |  |

Solve a quadratic equation (2nd degree polynomial) of form a*x^2 + b*x + c = 0.

Parameters:
a | First Coefficient.
b | Second Coefficient.
c | Third Coefficient.
Returns:
A triple, containing: (sol x0 x1). (sol) is the number of solutions(being 0, 1, or 2), and (x0) and (x1) are the solutions, if any.
string mSolveQuartic | ( | float | a,
 |  | float | b,
 |  | float | c,
 |  | float | d,
 |  | float | e
 | ) |  |

Solve a quartic equation (4th degree polynomial) of form a*x^4 + b*x^3 + c*x^2 + d*x + e = 0.

Parameters:
a | First Coefficient.
b | Second Coefficient.
c | Third Coefficient.
d | Fourth Coefficient.
e | Fifth Coefficient.
Returns:
A 5-tuple, containing: (sol x0 x1 x2 c3). (sol) is the number of solutions(being 0, 1, 2, 3 or 4), and (x0), (x1), (x2) and (x3) are the solutions, if any.
float mSqrt ( float v )

Calculate the square-root of v.

Parameters:
v Input Value.
Returns:
The square-root of the input value.
float mTan ( float v )

Calculate the tangent of v.

Parameters:
v Input Value (in radians).
Returns:
The tangent of the input value.


Torque 3D - Script Manual: Matrix Math

Matrix Math
[Math]

Functions for working with matrices (MatrixF, AngAxisF, MatrixRotation, MatrixPosition). More...

Functions

TransformF | MatrixCreate (VectorF position, AngAxisF orientation)
Create a transform from the given translation and orientation.
TransformF | MatrixCreateFromEuler (Point3F angles)
a matrix from the given rotations.
Point3F | MatrixMulPoint (TransformF transform, Point3F point)
Multiply the given point by the given transform assuming that w=1.
TransformF | MatrixMultiply (TransformF left, TransformF right)
Multiply the two matrices.
VectorF | MatrixMulVector (TransformF transform, VectorF vector)
Multiply the vector by the transform assuming that w=0.

Detailed Description

Functions for working with matrices (MatrixF, AngAxisF, MatrixRotation, MatrixPosition).

Function Documentation

TransformF MatrixCreate | ( | VectorF | position,
 |  | AngAxisF | orientation
 | ) |  |

Create a transform from the given translation and orientation.

Parameters:
position | The translation vector for the transform.
orientation | The axis and rotation that orients the transform.
Returns:
A transform based on the given position and orientation.
TransformF MatrixCreateFromEuler ( Point3F angles )

a matrix from the given rotations.

Parameters:
Vector3F X, Y, and Z rotation in *radians*.
Returns:
A transform based on the given orientation.
Point3F MatrixMulPoint | ( | TransformF | transform,
 |  | Point3F | point
 | ) |  |

Multiply the given point by the given transform assuming that w=1.

This function will multiply the given vector such that translation with take effect.

Parameters:
transform | A transform.
point | A vector.
Returns:
The transformed vector.
TransformF MatrixMultiply | ( | TransformF | left,
 |  | TransformF | right
 | ) |  |

Multiply the two matrices.

Parameters:
left | First transform.
right | Right transform.
Returns:
Concatenation of the two transforms.
VectorF MatrixMulVector | ( | TransformF | transform,
 |  | VectorF | vector
 | ) |  |

Multiply the vector by the transform assuming that w=0.

This function will multiply the given vector by the given transform such that translation will not affect the vector.

Parameters:
transform | A transform.
vector | A vector.
Returns:
The transformed vector.


Torque 3D - Script Manual: Random Numbers

Random Numbers
[Math]

Functions for generating random numbers. More...

Functions

float | getRandom (int a=1, int b=0)
Get a random number between a and b.
int | getRandomSeed ()
Get the current seed used by the random number generator.
void | setRandomSeed (int seed=-1)
Set the current seed for the random number generator.

Detailed Description

Functions for generating random numbers.

Based on a seed, the random number generator produces a sequence of numbers. As a given seed will always produce the same sequence of numbers this can be used to generate re-producible sequences of apparently random numbers.

To set the seed, call setRandomSeed().

Function Documentation

float getRandom | ( | int | a = 1,
 |  | int | b = 0
 | ) |  |

Get a random number between a and b.

Parameters:
a | Lower bound on the random number. The random number will be >= a.
b | Upper bound on the random number. The random number will be <= b.
Returns:
A pseudo-random number between a and b.
See also:
setRandomSeed
int getRandomSeed ( )

Get the current seed used by the random number generator.

Returns:
The current random number generator seed value.
void setRandomSeed ( int seed = -1 )

Set the current seed for the random number generator.

Based on this seed, a repeatable sequence of numbers will be produced by getRandom().

Parameters:
seed The seed with which to initialize the randon number generator with. The same seed will always leed tothe same sequence of pseudo-random numbers. If -1, the current timestamp will be used as the seed which is a good basis for randomization.


Torque 3D - Script Manual: Vector Math

Vector Math
[Math]

Functions for working with three-dimensional vectors (VectorF/Point3F). More...

Functions

VectorF | VectorAdd (VectorF a, VectorF b)
Add two vectors.
VectorF | VectorCross (VectorF a, VectorF b)
Calculcate the cross product of two vectors.
float | VectorDist (VectorF a, VectorF b)
Compute the distance between two vectors.
float | VectorDot (VectorF a, VectorF b)
Compute the dot product of two vectors.
float | VectorLen (VectorF v)
Calculate the magnitude of the given vector.
VectorF | VectorLerp (VectorF a, VectorF b, float t)
Linearly interpolate between two vectors by t.
VectorF | VectorNormalize (VectorF v)
Brings a vector into its unit form, i.e. such that it has the magnitute 1.
MatrixF | VectorOrthoBasis (AngAxisF aa)
Create an orthogonal basis from the given vector.
VectorF | VectorScale (VectorF a, float scalar)
Scales a vector by a scalar.
VectorF | VectorSub (VectorF a, VectorF b)
Subtract two vectors.

Detailed Description

Functions for working with three-dimensional vectors (VectorF/Point3F).

Function Documentation

VectorF VectorAdd | ( | VectorF | a,
 |  | VectorF | b
 | ) |  |

Add two vectors.

Parameters:
a | The first vector.
b | The second vector.
Returns:
The vector a + b.
Example:
//-----------------------------------------------------------------------------
//
// VectorAdd( %a, %b );
//
// The sum of vector a, (ax, ay, az), and vector b, (bx, by, bz) is:
//
//     a + b = ( ax + bx, ay + by, az + bz )
//
//-----------------------------------------------------------------------------
%a = "1 0 0";
%b = "0 1 0";

// %r = "( 1 + 0, 0 + 1, 0 + 0 )";
// %r = "1 1 0";
%r = VectorAdd( %a, %b );

VectorF VectorCross | ( | VectorF | a,
 |  | VectorF | b
 | ) |  |

Calculcate the cross product of two vectors.

Parameters:
a | The first vector.
b | The second vector.
Returns:
The cross product x b.
Example:
//-----------------------------------------------------------------------------
//
// VectorCross( %a, %b );
//
// The cross product of vector a, (ax, ay, az), and vector b, (bx, by, bz), is
//
//     a x b = ( ( ay * bz ) - ( az * by ), ( az * bx ) - ( ax * bz ), ( ax * by ) - ( ay * bx ) )
//
//-----------------------------------------------------------------------------

%a = "1 1 0";
%b = "2 0 1";

// %r = "( ( 1 * 1 ) - ( 0 * 0 ), ( 0 * 2 ) - ( 1 * 1 ), ( 1 * 0 ) - ( 1 * 2 ) )";
// %r = "1 -1 -2";
%r = VectorCross( %a, %b );

float VectorDist | ( | VectorF | a,
 |  | VectorF | b
 | ) |  |

Compute the distance between two vectors.

Parameters:
a | The first vector.
b | The second vector.
Returns:
The length( b - a ).
Example:
//-----------------------------------------------------------------------------
//
// VectorDist( %a, %b );
//
// The distance between vector a, (ax, ay, az), and vector b, (bx, by, bz), is
//
//     a -> b = ||( b - a )||
//            = ||( bx - ax, by - ay, bz - az )||
//            = mSqrt( ( bx - ax ) * ( bx - ax ) + ( by - ay ) * ( by - ay ) + ( bz - az ) * ( bz - az ) )
//
//-----------------------------------------------------------------------------

%a = "1 1 0";
%b = "2 0 1";

// %r = mSqrt( ( 2 - 1 ) * ( 2 - 1) + ( 0 - 1 ) * ( 0 - 1 ) + ( 1 - 0 ) * ( 1 - 0 ) );
// %r = mSqrt( 3 );
%r = VectorDist( %a, %b );

float VectorDot | ( | VectorF | a,
 |  | VectorF | b
 | ) |  |

Compute the dot product of two vectors.

Parameters:
a | The first vector.
b | The second vector.
Returns:
The dot product a * b.
Example:
//-----------------------------------------------------------------------------
//
// VectorDot( %a, %b );
//
// The dot product between vector a, (ax, ay, az), and vector b, (bx, by, bz), is:
//
//     a . b = ( ax * bx + ay * by + az * bz )
//
//-----------------------------------------------------------------------------

%a = "1 1 0";
%b = "2 0 1";

// %r = "( 1 * 2 + 1 * 0 + 0 * 1 )";
// %r = 2;
%r = VectorDot( %a, %b );
float VectorLen ( VectorF v )

Calculate the magnitude of the given vector.

Parameters:
v A vector.
Returns:
The length of vector v.
Example:
//-----------------------------------------------------------------------------
//
// VectorLen( %a );
//
// The length or magnitude of  vector a, (ax, ay, az), is:
//
//     ||a|| = Sqrt( ax * ax + ay * ay + az * az )
//
//-----------------------------------------------------------------------------

%a = "1 1 0";

// %r = mSqrt( 1 * 1 + 1 * 1 + 0 * 0 );
// %r = mSqrt( 2 );
// %r = 1.414;
%r = VectorLen( %a );

VectorF VectorLerp | ( | VectorF | a,
 |  | VectorF | b,
 |  | float | t
 | ) |  |

Linearly interpolate between two vectors by t.

Parameters:
a | Vector to start interpolation from.
b | Vector to interpolate to.
t | Interpolation factor (0-1). At zero, a is returned and at one, b is returned. In between, an interpolated vector between a and b is returned.
Returns:
An interpolated vector between a and b.
Example:
//-----------------------------------------------------------------------------
//
// VectorLerp( %a, %b );
//
// The point between vector a, (ax, ay, az), and vector b, (bx, by, bz), which is
// weighted by the interpolation factor, t, is
//
//     r = a + t * ( b - a )
//       = ( ax + t * ( bx - ax ), ay + t * ( by - ay ), az + t * ( bz - az ) )
//
//-----------------------------------------------------------------------------

%a = "1 1 0";
%b = "2 0 1";
%v = "0.25";

// %r = "( 1 + 0.25 * ( 2 - 1 ), 1 + 0.25 * ( 0 - 1 ), 0 + 0.25 * ( 1 - 0 ) )";
// %r = "1.25 0.75 0.25";
%r = VectorLerp( %a, %b );
VectorF VectorNormalize ( VectorF v )

Brings a vector into its unit form, i.e. such that it has the magnitute 1.

Parameters:
v The vector to normalize.
Returns:
The vector v scaled to length 1.
Example:
//-----------------------------------------------------------------------------
//
// VectorNormalize( %a );
//
// The normalized vector a, (ax, ay, az), is:
//
//     a^ = a / ||a||
//        = ( ax / ||a||, ay / ||a||, az / ||a|| )
//
//-----------------------------------------------------------------------------

%a = "1 1 0";
%l = 1.414;

// %r = "( 1 / 1.141, 1 / 1.141, 0 / 1.141 )";
// %r = "0.707 0.707 0";
%r = VectorNormalize( %a );
MatrixF VectorOrthoBasis ( AngAxisF aa )

Create an orthogonal basis from the given vector.

Parameters:
aaf The vector to create the orthogonal basis from.
Returns:
A matrix representing the orthogonal basis.
VectorF VectorScale | ( | VectorF | a,
 |  | float | scalar
 | ) |  |

Scales a vector by a scalar.

Parameters:
a | The vector to scale.
scalar | The scale factor.
Returns:
The vector a * scalar.
Example:
//-----------------------------------------------------------------------------
//
// VectorScale( %a, %v );
//
// Scaling vector a, (ax, ay, az), but the scalar, v, is:
//
//     a * v = ( ax * v, ay * v, az * v )
//
//-----------------------------------------------------------------------------

%a = "1 1 0";
%v = "2";

// %r = "( 1 * 2, 1 * 2, 0 * 2 )";
// %r = "2 2 0";
%r = VectorScale( %a, %v );

VectorF VectorSub | ( | VectorF | a,
 |  | VectorF | b
 | ) |  |

Subtract two vectors.

Parameters:
a | The first vector.
b | The second vector.
Returns:
The vector a - b.
Example:
//-----------------------------------------------------------------------------
//
// VectorSub( %a, %b );
//
// The difference of vector a, (ax, ay, az), and vector b, (bx, by, bz) is:
//
//     a - b = ( ax - bx, ay - by, az - bz )
//
//-----------------------------------------------------------------------------

%a = "1 0 0";
%b = "0 1 0";

// %r = "( 1 - 0, 0 - 1, 0 - 0 )";
// %r = "1 -1 0";
%r = VectorSub( %a, %b );


Torque 3D - Script Manual: Strings

Strings
[Core]

Functions for dealing with string values. More...

Modules

Field Manipulators

Functions to deal with whitespace-separated lists of values in strings.

Functions

string | collapseEscape (string text)
Replace all escape sequences in text with their respective character codes.
void | dumpStringMemStats ()
Dumps information about String memory usage.
bool | endsWith (string str, string suffix, bool caseSensitive=false)
Test whether the given string ends with the given suffix.
string | expandEscape (string text)
Replace all characters in text that need to be escaped for the string to be a valid string literal with their respective escape sequences.
string | getSubStr (string str, int start, int numChars=-1)
Return a substring of str starting at start and continuing either through to the end of str (if numChars is -1) or for numChars characters (except if this would exceed the actual source string length).
int | getTrailingNumber (string str)
Get the numeric suffix of the given input string.
bool | isalnum (string str, int index)
Test whether the character at the given position is an alpha-numeric character.
bool | isspace (string str, int index)
Test whether the character at the given position is a whitespace character.
string | ltrim (string str)
Remove leading whitespace from the string.
string | nextToken (string str, string token, string delimiters)
Tokenize a string using a set of delimiting characters.
string | rtrim (string str)
Remove trailing whitespace from the string.
bool | startsWith (string str, string prefix, bool caseSensitive=false)
Test whether the given string begins with the given prefix.
int | strasc (string chr)
Return the integer character code value corresponding to the first character in the given string.
string | strchr (string str, string chr)
Find the first occurrence of the given character in str.
int | strchrpos (string str, string chr, int start=0)
Find the first occurrence of the given character in the given string.
int | strcmp (string str1, string str2)
Compares two strings using case-sensitive comparison.
string | strformat (string format, string value)
Format the given value as a string using printf-style formatting.
int | stricmp (string str1, string str2)
Compares two strings using case-insensitive comparison.
int | strinatcmp (string str1, string str2)
Compares two strings using "natural order" case-insensitive comparison.
string | stripChars (string str, string chars)
Remove all occurrences of characters contained in chars from str.
String | stripTrailingNumber (string str)
Strip a numeric suffix from the given string.
bool | strIsMatchExpr (string pattern, string str, bool caseSensitive=false)
Match a pattern against a string.
bool | strIsMatchMultipleExpr (string patterns, string str, bool caseSensitive=false)
Match a multiple patterns against a single string.
int | strlen (string str)
Get the length of the given string in bytes.
string | strlwr (string str)
Return an all lower-case version of the given string.
int | strnatcmp (string str1, string str2)
Compares two strings using "natural order" case-sensitive comparison.
int | strpos (string haystack, string needle, int offset=0)
Find the start of needle in haystack searching from left to right beginning at the given offset.
string | strrchr (string str, string chr)
Find the last occurrence of the given character in str.
int | strrchrpos (string str, string chr, int start=0)
Find the last occurrence of the given character in the given string.
string | strrepeat (string str, int numTimes, string delimiter="")
Return a string that repeats str numTimes number of times delimiting each occurrence with delimiter.
string | strreplace (string source, string from, string to)
Replace all occurrences of from in source with to.
int | strstr (string string, string substring)
Find the start of substring in the given string searching from left to right.
string | strupr (string str)
Return an all upper-case version of the given string.
string | trim (string str)
Remove leading and trailing whitespace from the string.

Detailed Description

Functions for dealing with string values.

Since in TorqueScript any value is implicitly also a string, these functions can be used with all values.

Function Documentation

string collapseEscape ( string text )

Replace all escape sequences in text with their respective character codes.

This function replaces all escape sequences (\n, \t, etc) in the given string with the respective characters they represent.

The primary use of this function is for converting strings from their literal form into their compiled/translated form, as is normally done by the TorqueScript compiler.

Parameters:
text A string.
Returns:
A duplicate of text with all escape sequences replaced by their respective character codes.
Example:
// Print:
//
//    str
//    ing
//
// to the console.  Note how the backslash in the string must be escaped here
// in order to prevent the TorqueScript compiler from collapsing the escape
// sequence in the resulting string.
echo( collapseEscape( "str\ning" ) );
See also:
expandEscape
void dumpStringMemStats ( )

Dumps information about String memory usage.

bool endsWith | ( | string | str,
 |  | string | suffix,
 |  | bool | caseSensitive = false
 | ) |  |

Test whether the given string ends with the given suffix.

Parameters:
str | The string to test.
suffix | The potential suffix of str.
caseSensitive | If true, the comparison will be case-sensitive; if false, differences in casing will not be taken into account.
Returns:
True if the last characters in str match the complete contents of suffix; false otherwise.
Example:
startsWith( "TEST123", "123" ) // Returns true.
See also:
startsWith
string expandEscape ( string text )

Replace all characters in text that need to be escaped for the string to be a valid string literal with their respective escape sequences.

All characters in text that cannot appear in a string literal will be replaced by an escape sequence (\n, \t, etc).

The primary use of this function is for converting strings suitable for being passed as string literals to the TorqueScript compiler.

Parameters:
text A string
Returns:
A duplicate of the text parameter with all unescaped characters that cannot appear in string literals replaced by their respective escape sequences.

expandEscape( "str" NL "ing" ) // Returns "str\ning".

See also:
collapseEscape
string getSubStr | ( | string | str,
 |  | int | start,
 |  | int | numChars = -1
 | ) |  |

Return a substring of str starting at start and continuing either through to the end of str (if numChars is -1) or for numChars characters (except if this would exceed the actual source string length).

Parameters:
str | The string from which to extract a substring.
start | The offset at which to start copying out characters.
numChars | Optional argument to specify the number of characters to copy. If this is -1, all characters up the end of the input string are copied.
Returns:
A string that contains the given portion of the input string.
Example:
getSubStr( "foobar", 1, 2 ) // Returns "oo".
int getTrailingNumber ( string str )

Get the numeric suffix of the given input string.

Parameters:
str The string from which to read out the numeric suffix.
Returns:
The numeric value of the number suffix of str or -1 if str has no such suffix.
Example:
getTrailingNumber( "test123" ) // Returns '123'.
See also:
stripTrailingNumber
bool isalnum | ( | string | str,
 |  | int | index
 | ) |  |

Test whether the character at the given position is an alpha-numeric character.

Alpha-numeric characters are characters that are either alphabetic (a-z, A-Z) or numbers (0-9).

Parameters:
str | The string to test.
index | The index of a character in str.
Returns:
True if the character at the given index in str is an alpha-numeric character; false otherwise.
See also:
isspace
bool isspace | ( | string | str,
 |  | int | index
 | ) |  |

Test whether the character at the given position is a whitespace character.

Characters such as tab, space, or newline are considered whitespace.

Parameters:
str | The string to test.
index | The index of a character in str.
Returns:
True if the character at the given index in str is a whitespace character; false otherwise.
See also:
isalnum
string ltrim ( string str )

Remove leading whitespace from the string.

Parameters:
str A string.
Returns:
A string that is the same as str but with any leading (i.e. leftmost) whitespace removed.
Example:
ltrim( "   string  " ); // Returns "string  ".
See also:
rtrim
trim
string nextToken | ( | string | str,
 |  | string | token,
 |  | string | delimiters
 | ) |  |

Tokenize a string using a set of delimiting characters.

This function first skips all leading charaters in str that are contained in delimiters. From that position, it then scans for the next character in str that is contained in delimiters and stores all characters from the starting position up to the first delimiter in a variable in the current scope called token. Finally, it skips all characters in delimiters after the token and then returns the remaining string contents in str.

To scan out all tokens in a string, call this function repeatedly by passing the result it returns each time as the new str until the function returns "".

Parameters:
str | A string.
token | The name of the variable in which to store the current token. This variable is set in the scope in which nextToken is called.
delimiters | A string of characters. Each character is considered a delimiter.
Returns:
The remainder of str after the token has been parsed out or "" if no more tokens were found in str.
Example:
// Prints:
// a
// b
// c
%str = "a   b c";
while ( %str !$= "" )
{
   // First time, stores "a" in the variable %token and sets %str to "b c".
   %str = nextToken( %str, "token", " " );
   echo( %token );
}
string rtrim ( string str )

Remove trailing whitespace from the string.

Parameters:
str A string.
Returns:
A string that is the same as str but with any trailing (i.e. rightmost) whitespace removed.
Example:
rtrim( "   string  " ); // Returns "   string".
See also:
ltrim
trim
bool startsWith | ( | string | str,
 |  | string | prefix,
 |  | bool | caseSensitive = false
 | ) |  |

Test whether the given string begins with the given prefix.

Parameters:
str | The string to test.
prefix | The potential prefix of str.
caseSensitive | If true, the comparison will be case-sensitive; if false, differences in casing will not be taken into account.
Returns:
True if the first characters in str match the complete contents of prefix; false otherwise.
Example:
startsWith( "TEST123", "test" ) // Returns true.
See also:
endsWith
int strasc ( string chr )

Return the integer character code value corresponding to the first character in the given string.

Parameters:
chr a (one-character) string.
Returns:
the UTF32 code value for the first character in the given string.
string strchr | ( | string | str,
 |  | string | chr
 | ) |  |

Find the first occurrence of the given character in str.

Parameters:
str | The string to search.
chr | The character to search for. Only the first character from the string is taken.
Returns:
The remainder of the input string starting with the given character or the empty string if the character could not be found.
See also:
strrchr
int strchrpos | ( | string | str,
 |  | string | chr,
 |  | int | start = 0
 | ) |  |

Find the first occurrence of the given character in the given string.

Parameters:
str | The string to search.
chr | The character to look for. Only the first character of this string will be searched for.
start | The index into str at which to start searching for the given character.
Returns:
The index of the first occurrence of chr in str or -1 if str does not contain the given character.
Example:
strchrpos( "test", "s" ) // Returns 2.

int strcmp | ( | string | str1,
 |  | string | str2
 | ) |  |

Compares two strings using case-sensitive comparison.

Parameters:
str1 | The first string.
str2 | The second string.
Returns:
0 if both strings are equal, a value <0 if the first character different in str1 has a smaller character code value than the character at the same position in str2, and a value >1 otherwise.
Example:
if( strcmp( %var, "foobar" ) == 0 )
   echo( "%var is equal to 'foobar'" );
See also:
stricmp
strnatcmp
string strformat | ( | string | format,
 |  | string | value
 | ) |  |

Format the given value as a string using printf-style formatting.

Parameters:
format | A printf-style format string.
value | The value argument matching the given format string.
Example:
// Convert the given integer value to a string in a hex notation.
%hex = strformat( "%x", %value );
See also:
http://en.wikipedia.org/wiki/Printf
int stricmp | ( | string | str1,
 |  | string | str2
 | ) |  |

Compares two strings using case-insensitive comparison.

Parameters:
str1 | The first string.
str2 | The second string.
Returns:
0 if both strings are equal, a value <0 if the first character different in str1 has a smaller character code value than the character at the same position in str2, and a value >0 otherwise.
Example:
if( stricmp( "FOObar", "foobar" ) == 0 )
   echo( "this is always true" );
See also:
strcmp
strinatcmp
int strinatcmp | ( | string | str1,
 |  | string | str2
 | ) |  |

Compares two strings using "natural order" case-insensitive comparison.

Natural order means that rather than solely comparing single character code values, strings are ordered in a natural way. For example, the string "hello10" is considered greater than the string "hello2" even though the first numeric character in "hello10" actually has a smaller character value than the corresponding character in "hello2". However, since 10 is greater than 2, strnatcmp will put "hello10" after "hello2".

Parameters:
str1 | The first string.
str2 | The second string.
Returns:
0 if the strings are equal, a value >0 if str1 comes after str2 in a natural order, and a value <0 if str1 comes before str2 in a natural order.
Example:
// Bubble sort 10 elements of %array using natural order
do
{
   %swapped = false;
   for( %i = 0; %i < 10 - 1; %i ++ )
      if( strnatcmp( %array[ %i ], %array[ %i + 1 ] ) > 0 )
      {
         %temp = %array[ %i ];
         %array[ %i ] = %array[ %i + 1 ];
         %array[ %i + 1 ] = %temp;
         %swapped = true;
      }
}
while( %swapped );
See also:
stricmp
strnatcmp
string stripChars | ( | string | str,
 |  | string | chars
 | ) |  |

Remove all occurrences of characters contained in chars from str.

Parameters:
str | The string to filter characters out from.
chars | A string of characters to filter out from str.
Returns:
A version of str with all occurrences of characters contained in chars filtered out.
Example:
stripChars( "teststring", "se" ); // Returns "tttring".
String stripTrailingNumber ( string str )

Strip a numeric suffix from the given string.

Parameters:
str The string from which to strip its numeric suffix.
Returns:
The string str without its number suffix or the original string str if it has no such suffix.
Example:
stripTrailingNumber( "test123" ) // Returns "test".
See also:
getTrailingNumber
bool strIsMatchExpr | ( | string | pattern,
 |  | string | str,
 |  | bool | caseSensitive = false
 | ) |  |

Match a pattern against a string.

Parameters:
pattern | The wildcard pattern to match against. The pattern can include characters, '*' to match any number of characters and '?' to match a single character.
str | The string which should be matched against pattern.
caseSensitive | If true, characters in the pattern are matched in case-sensitive fashion against this string. If false, differences in casing are ignored.
Returns:
True if str matches the given pattern.
Example:
strIsMatchExpr( "f?o*R", "foobar" ) // Returns true.
See also:
strIsMatchMultipleExpr
bool strIsMatchMultipleExpr | ( | string | patterns,
 |  | string | str,
 |  | bool | caseSensitive = false
 | ) |  |

Match a multiple patterns against a single string.

Parameters:
patterns | A tab-separated list of patterns. Each pattern can include charaters, '*' to match any number of characters and '?' to match a single character. Each of the patterns is tried in turn.
str | The string which should be matched against patterns.
caseSensitive | If true, characters in the pattern are matched in case-sensitive fashion against this string. If false, differences in casing are ignored.
Returns:
True if str matches any of the given patterns.
Example:
strIsMatchMultipleExpr( "*.cs *.gui *.mis", "mymission.mis" ) // Returns true.
See also:
strIsMatchExpr
int strlen ( string str )

Get the length of the given string in bytes.

Note:
This does not return a true character count for strings with multi-byte characters!
Parameters:
str A string.
Returns:
The length of the given string in bytes.
string strlwr ( string str )

Return an all lower-case version of the given string.

Parameters:
str A string.
Returns:
A version of str with all characters converted to lower-case.
Example:
strlwr( "TesT1" ) // Returns "test1"
See also:
strupr
int strnatcmp | ( | string | str1,
 |  | string | str2
 | ) |  |

Compares two strings using "natural order" case-sensitive comparison.

Natural order means that rather than solely comparing single character code values, strings are ordered in a natural way. For example, the string "hello10" is considered greater than the string "hello2" even though the first numeric character in "hello10" actually has a smaller character value than the corresponding character in "hello2". However, since 10 is greater than 2, strnatcmp will put "hello10" after "hello2".

Parameters:
str1 | The first string.
str2 | The second string.
Returns:
0 if the strings are equal, a value >0 if str1 comes after str2 in a natural order, and a value <0 if str1 comes before str2 in a natural order.
Example:
// Bubble sort 10 elements of %array using natural order
do
{
   %swapped = false;
   for( %i = 0; %i < 10 - 1; %i ++ )
      if( strnatcmp( %array[ %i ], %array[ %i + 1 ] ) > 0 )
      {
         %temp = %array[ %i ];
         %array[ %i ] = %array[ %i + 1 ];
         %array[ %i + 1 ] = %temp;
         %swapped = true;
      }
}
while( %swapped );
See also:
strcmp
strinatcmp
int strpos | ( | string | haystack,
 |  | string | needle,
 |  | int | offset = 0
 | ) |  |

Find the start of needle in haystack searching from left to right beginning at the given offset.

Parameters:
haystack | The string to search.
needle | The string to search for.
Returns:
The index at which the first occurrence of needle was found in haystack or -1 if no match was found.
Example:
strpos( "b ab", "b", 1 ) // Returns 3.

string strrchr | ( | string | str,
 |  | string | chr
 | ) |  |

Find the last occurrence of the given character in str.

Parameters:
str | The string to search.
chr | The character to search for. Only the first character from the string is taken.
Returns:
The remainder of the input string starting with the given character or the empty string if the character could not be found.
See also:
strchr
int strrchrpos | ( | string | str,
 |  | string | chr,
 |  | int | start = 0
 | ) |  |

Find the last occurrence of the given character in the given string.

Parameters:
str | The string to search.
chr | The character to look for. Only the first character of this string will be searched for.
start | The index into str at which to start searching for the given character.
Returns:
The index of the last occurrence of chr in str or -1 if str does not contain the given character.
Example:
strrchrpos( "test", "t" ) // Returns 3.

string strrepeat | ( | string | str,
 |  | int | numTimes,
 |  | string | delimiter = ""
 | ) |  |

Return a string that repeats str numTimes number of times delimiting each occurrence with delimiter.

Parameters:
str | The string to repeat multiple times.
numTimes | The number of times to repeat str in the result string.
delimiter | The string to put between each repetition of str.
Returns:
A string containing str repeated numTimes times.
Example:
strrepeat( "a", 5, "b" ) // Returns "ababababa".

string strreplace | ( | string | source,
 |  | string | from,
 |  | string | to
 | ) |  |

Replace all occurrences of from in source with to.

Parameters:
source | The string in which to replace the occurrences of from.
from | The string to replace in source.
to | The string with which to replace occurrences of .
Returns:
A string with all occurrences of from in source replaced by to.
Example:
strreplace( "aabbccbb", "bb", "ee" ) // Returns "aaeeccee".

int strstr | ( | string | string,
 |  | string | substring
 | ) |  |

Find the start of substring in the given string searching from left to right.

Parameters:
string | The string to search.
substring | The string to search for.
Returns:
The index into string at which the first occurrence of substring was found or -1 if substring could not be found.
Example:
strstr( "abcd", "c" ) // Returns 2.
string strupr ( string str )

Return an all upper-case version of the given string.

Parameters:
str A string.
Returns:
A version of str with all characters converted to upper-case.
Example:
strupr( "TesT1" ) // Returns "TEST1"
See also:
strlwr
string trim ( string str )

Remove leading and trailing whitespace from the string.

Parameters:
str A string.
Returns:
A string that is the same as str but with any leading (i.e. leftmost) and trailing (i.e. rightmost) whitespace removed.
Example:
trim( "   string  " ); // Returns "string".


Torque 3D - Script Manual: Field Manipulators

Field Manipulators
[Strings]

Functions to deal with whitespace-separated lists of values in strings. More...

Functions

string | firstWord (string text)
Return the first word in text.
string | getField (string text, int index)
Extract the field at the given index in the newline and/or tab separated list in text.
int | getFieldCount (string text)
Return the number of newline and/or tab separated fields in text.
string | getFields (string text, int startIndex, int endIndex=-1)
Extract a range of fields from the given startIndex onwards thru endIndex.
string | getRecord (string text, int index)
Extract the record at the given index in the newline-separated list in text.
int | getRecordCount (string text)
Return the number of newline-separated records in text.
string | getRecords (string text, int startIndex, int endIndex=-1)
Extract a range of records from the given startIndex onwards thru endIndex.
string | getWord (string text, int index)
Extract the word at the given index in the whitespace-separated list in text.
int | getWordCount (string text)
Return the number of whitespace-separated words in text.
string | getWords (string text, int startIndex, int endIndex=-1)
Extract a range of words from the given startIndex onwards thru endIndex.
string | removeField (string text, int index)
Remove the field in text at the given index.
string | removeRecord (string text, int index)
Remove the record in text at the given index.
string | removeWord (string text, int index)
Remove the word in text at the given index.
string | restWords (string text)
Return all but the first word in text.
string | setField (string text, int index, string replacement)
Replace the field in text at the given index with replacement.
string | setRecord (string text, int index, string replacement)
Replace the record in text at the given index with replacement.
string | setWord (string text, int index, string replacement)
Replace the word in text at the given index with replacement.

Detailed Description

Functions to deal with whitespace-separated lists of values in strings.

TorqueScript extensively uses strings to represent lists of values. The functions in this group simplify working with these lists and allow to easily extract individual values from their strings.

The list strings are segregated into three groups according to the delimiters used to separate invididual values in the strings:

  • Strings of words: Elements are separated by newlines (\n), spaces, or tabs (\t).
  • Strings of fields: Elements are sepaerated by newlines (\n) or tabs (\t).
  • Strings of records: Elements are separated by newlines (\n).

Aside from the functions here, another useful means to work with strings of words is TorqueScript's foreach$ statement.

foreach$ Statement

Function Documentation

string firstWord ( string text )

Return the first word in text.

Parameters:
text A list of words separated by newlines, spaces, and/or tabs.
Returns:
The word at index 0 in text or "" if text is empty.
Note:
This is equal to
getWord( text, 0 )
See also:
getWord
string getField | ( | string | text,
 |  | int | index
 | ) |  |

Extract the field at the given index in the newline and/or tab separated list in text.

Fields in text must be separated by newlines and/or tabs.

Parameters:
text | A list of fields separated by newlines and/or tabs.
index | The zero-based index of the field to extract.
Returns:
The field at the given index or "" if the index is out of range.
Example:
getField( "a b" TAB "c d" TAB "e f", 1 ) // Returns "c d"
See also:
getFields
getFieldCount
getWord
getRecord
int getFieldCount ( string text )

Return the number of newline and/or tab separated fields in text.

Parameters:
text A list of fields separated by newlines and/or tabs.
Returns:
The number of newline and/or tab sepearated elements in text.
Example:
getFieldCount( "a b" TAB "c d" TAB "e f" ) // Returns 3
See also:
getWordCount
getRecordCount
string getFields | ( | string | text,
 |  | int | startIndex,
 |  | int | endIndex = -1
 | ) |  |

Extract a range of fields from the given startIndex onwards thru endIndex.

Fields in text must be separated by newlines and/or tabs.

Parameters:
text | A list of fields separated by newlines and/or tabs.
startIndex | The zero-based index of the first field to extract from text.
endIndex | The zero-based index of the last field to extract from text. If this is -1, all fields beginning with startIndex are extracted from text.
Returns:
A string containing the specified range of fields from text or "" if startIndex is out of range or greater than endIndex.
Example:
getFields( "a b" TAB "c d" TAB "e f", 1 ) // Returns "c d" TAB "e f"
See also:
getField
getFieldCount
getWords
getRecords
string getRecord | ( | string | text,
 |  | int | index
 | ) |  |

Extract the record at the given index in the newline-separated list in text.

Records in text must be separated by newlines.

Parameters:
text | A list of records separated by newlines.
index | The zero-based index of the record to extract.
Returns:
The record at the given index or "" if index is out of range.
Example:
getRecord( "a b" NL "c d" NL "e f", 1 ) // Returns "c d"
See also:
getRecords
getRecordCount
getWord
getField
int getRecordCount ( string text )

Return the number of newline-separated records in text.

Parameters:
text A list of records separated by newlines.
Returns:
The number of newline-sepearated elements in text.
Example:
getRecordCount( "a b" NL "c d" NL "e f" ) // Returns 3
See also:
getWordCount
getFieldCount
string getRecords | ( | string | text,
 |  | int | startIndex,
 |  | int | endIndex = -1
 | ) |  |

Extract a range of records from the given startIndex onwards thru endIndex.

Records in text must be separated by newlines.

Parameters:
text | A list of records separated by newlines.
startIndex | The zero-based index of the first record to extract from text.
endIndex | The zero-based index of the last record to extract from text. If this is -1, all records beginning with startIndex are extracted from text.
Returns:
A string containing the specified range of records from text or "" if startIndex is out of range or greater than endIndex.
Example:
getRecords( "a b" NL "c d" NL "e f", 1 ) // Returns "c d" NL "e f"
See also:
getRecord
getRecordCount
getWords
getFields
string getWord | ( | string | text,
 |  | int | index
 | ) |  |

Extract the word at the given index in the whitespace-separated list in text.

Words in text must be separated by newlines, spaces, and/or tabs.

Parameters:
text | A whitespace-separated list of words.
index | The zero-based index of the word to extract.
Returns:
The word at the given index or "" if the index is out of range.
Example:
getWord( "a b c", 1 ) // Returns "b"
See also:
getWords
getWordCount
getField
getRecord
int getWordCount ( string text )

Return the number of whitespace-separated words in text.

Words in text must be separated by newlines, spaces, and/or tabs.

Parameters:
text A whitespace-separated list of words.
Returns:
The number of whitespace-separated words in text.
Example:
getWordCount( "a b c d e" ) // Returns 5
See also:
getFieldCount
getRecordCount
string getWords | ( | string | text,
 |  | int | startIndex,
 |  | int | endIndex = -1
 | ) |  |

Extract a range of words from the given startIndex onwards thru endIndex.

Words in text must be separated by newlines, spaces, and/or tabs.

Parameters:
text | A whitespace-separated list of words.
startIndex | The zero-based index of the first word to extract from text.
endIndex | The zero-based index of the last word to extract from text. If this is -1, all words beginning with startIndex are extracted from text.
Returns:
A string containing the specified range of words from text or "" if startIndex is out of range or greater than endIndex.
Example:
getWords( "a b c d", 1, 2, ) // Returns "b c"
See also:
getWord
getWordCount
getFields
getRecords
string removeField | ( | string | text,
 |  | int | index
 | ) |  |

Remove the field in text at the given index.

Fields in text must be separated by newlines and/or tabs.

Parameters:
text | A list of fields separated by newlines and/or tabs.
index | The zero-based index of the field in text.
Returns:
A new string with the field at the given index removed or the original string if index is out of range.
Example:
removeField( "a b" TAB "c d" TAB "e f", 1 ) // Returns "a b" TAB "e f"
See also:
removeWord
removeRecord
string removeRecord | ( | string | text,
 |  | int | index
 | ) |  |

Remove the record in text at the given index.

Records in text must be separated by newlines.

Parameters:
text | A list of records separated by newlines.
index | The zero-based index of the record in text.
Returns:
A new string with the record at the given index removed or the original string if index is out of range.
Example:
removeRecord( "a b" NL "c d" NL "e f", 1 ) // Returns "a b" NL "e f"
See also:
removeWord
removeField
string removeWord | ( | string | text,
 |  | int | index
 | ) |  |

Remove the word in text at the given index.

Words in text must be separated by newlines, spaces, and/or tabs.

Parameters:
text | A whitespace-separated list of words.
index | The zero-based index of the word in text.
Returns:
A new string with the word at the given index removed or the original string if index is out of range.
Example:
removeWord( "a b c d", 2 ) // Returns "a b d"
See also:
removeField
removeRecord
string restWords ( string text )

Return all but the first word in text.

Parameters:
text A list of words separated by newlines, spaces, and/or tabs.
Returns:
text with the first word removed.
Note:
This is equal to
getWords( text, 1 )
See also:
getWords
string setField | ( | string | text,
 |  | int | index,
 |  | string | replacement
 | ) |  |

Replace the field in text at the given index with replacement.

Fields in text must be separated by newlines and/or tabs.

Parameters:
text | A list of fields separated by newlines and/or tabs.
index | The zero-based index of the field to replace.
replacement | The string with which to replace the field.
Returns:
A new string with the field at the given index replaced by replacement or the original string if index is out of range.
Example:
setField( "a b" TAB "c d" TAB "e f", 1, "g h" ) // Returns "a b" TAB "g h" TAB "e f"
See also:
getField
setWord
setRecord
string setRecord | ( | string | text,
 |  | int | index,
 |  | string | replacement
 | ) |  |

Replace the record in text at the given index with replacement.

Records in text must be separated by newlines.

Parameters:
text | A list of records separated by newlines.
index | The zero-based index of the record to replace.
replacement | The string with which to replace the record.
Returns:
A new string with the record at the given index replaced by replacement or the original string if index is out of range.
Example:
setRecord( "a b" NL "c d" NL "e f", 1, "g h" ) // Returns "a b" NL "g h" NL "e f"
See also:
getRecord
setWord
setField
string setWord | ( | string | text,
 |  | int | index,
 |  | string | replacement
 | ) |  |

Replace the word in text at the given index with replacement.

Words in text must be separated by newlines, spaces, and/or tabs.

Parameters:
text | A whitespace-separated list of words.
index | The zero-based index of the word to replace.
replacement | The string with which to replace the word.
Returns:
A new string with the word at the given index replaced by replacement or the original string if index is out of range.
Example:
setWord( "a b c d", 2, "f" ) // Returns "a b f d"
See also:
getWord
setField
setRecord


Torque 3D - Script Manual: Utilities

Utilities
[Core]

Miscellaneous utility functions. More...

Functions

int | countBits (int v)
Count the number of bits that are set in the given 32 bit integer.
Torque::UUID | generateUUID ()
Generate a new universally unique identifier (UUID).

Detailed Description

Miscellaneous utility functions.

Function Documentation

int countBits ( int v )

Count the number of bits that are set in the given 32 bit integer.

Parameters:
v An integer value.
Returns:
The number of bits that are set in v.
Torque::UUID generateUUID ( )

Generate a new universally unique identifier (UUID).

Returns:
A newly generated UUID.


Torque 3D - Script Manual: Environment Objects

Environment Objects

Objects that represent environmental features, such as, terrain, water, atmosphere, plants and trees. More...

Modules

Water

Objects that represent water features, from puddles to rivers and oceans.

Atmosphere

Objects that represent the atmosphere and weather, such as the sky, sun, clouds, and precipitation.

Terrain

Objects that specialize in representing terrain and other collidable/walkable surfaces.

Forest

Objects for efficiently placing and rendering trees, rocks, foliage, or any such feature needed in large number.

Foliage

Objects used for mass replication of foliage, such as grass, rocks, and bushes.

Miscellaneous

Miscellaneous environmental and level objects.

Detailed Description

Objects that represent environmental features, such as, terrain, water, atmosphere, plants and trees.


Torque 3D - Script Manual: Atmosphere

Atmosphere
[Environment Objects]

Objects that represent the atmosphere and weather, such as the sky, sun, clouds, and precipitation. More...

Classes

class | BasicClouds
Renders up to three layers of scrolling cloud-cover textures overhead. More...
class | CloudLayer
A layer of clouds which change shape over time and are affected by scene lighting. More...
class | Lightning
An individual lightning bolt, created from a LightningData object. More...
class | LightningData
An emitter for Lightning objects. More...
class | LightningStrikeEvent
A lightning bolt strike, called from strikeRandomPoint or strikeObject method on Lightning. More...
class | Precipitation
Defines a precipitation based storm (IE: rain, snow, etc.). More...
class | PrecipitationData
Defines the droplets used in a storm (IE: raindrops, snowflakes, etc.). More...
class | ScatterSky
Represents both the sun and sky for scenes with a dynamic time of day. More...
class | SkyBox
Represents the sky with an artist-created cubemap. More...
class | Sun
A global light affecting your entire scene and optionally renders a corona effect. More...

Detailed Description

Objects that represent the atmosphere and weather, such as the sky, sun, clouds, and precipitation.


Torque 3D - Script Manual: Foliage

Foliage
[Environment Objects]

Objects used for mass replication of foliage, such as grass, rocks, and bushes. More...

Classes

class | fxFoliageReplicator
An emitter to replicate fxFoliageItem objects across an area. More...
class | fxShapeReplicatedStatic
The object definition for shapes that will be replicated across an area using an fxShapeReplicator. More...
class | fxShapeReplicator
An emitter for objects to replicate across an area. More...
class | GroundCover
Covers the ground in a field of objects (IE: Grass, Flowers, etc). More...

Functions

void | StartClientReplication ()
Activates the shape replicator.
void | StartFoliageReplication ()
Activates the foliage replicator.

Variables

float | $pref::GroundCover::densityScale
A global LOD scalar which can reduce the overall density of placed GroundCover.
static int | GroundCover::renderedBatches
Stat for number of rendered billboard batches.
static int | GroundCover::renderedBillboards
Stat for number of rendered billboards.
static int | GroundCover::renderedCells
Stat for number of rendered cells.
static int | GroundCover::renderedShapes
Stat for number of rendered shapes.

Detailed Description

Objects used for mass replication of foliage, such as grass, rocks, and bushes.

Function Documentation

void StartClientReplication ( )

Activates the shape replicator.

Example:
// Call the function
StartClientReplication()
void StartFoliageReplication ( )

Activates the foliage replicator.

Example:
// Call the function
StartFoliageReplication();

Variable Documentation

float $pref::GroundCover::densityScale

A global LOD scalar which can reduce the overall density of placed GroundCover.

int GroundCover::renderedBatches [static, inherited]

Stat for number of rendered billboard batches.

int GroundCover::renderedBillboards [static, inherited]

Stat for number of rendered billboards.

int GroundCover::renderedCells [static, inherited]

Stat for number of rendered cells.

int GroundCover::renderedShapes [static, inherited]

Stat for number of rendered shapes.


Torque 3D - Script Manual: Forest

Forest
[Environment Objects]

Objects for efficiently placing and rendering trees, rocks, foliage, or any such feature needed in large number. More...

Classes

class | Forest
Forest is a global-bounds scene object provides collision and rendering for a (.forest) data file. More...
class | ForestBrushElement
Represents a type of ForestItem and parameters for how it is placed when painting with a ForestBrush that contains it. More...
class | ForestItemData
Base class for defining a type of ForestItem. It does not implement loading or rendering of the shapeFile. More...
class | ForestWindEmitter
Object responsible for simulating wind in a level. More...
class | TSForestItemData
Concrete implementation of ForestItemData which loads and renders dts format shapeFiles. More...

Variables

static bool | Forest::disableImposters
A debugging aid which will disable rendering of all imposters in the forest.
static bool | Forest::drawBounds
A debugging aid which renders the forest bounds.
static bool | Forest::drawCells
A debugging aid which renders the forest cell bounds.
static bool | Forest::forceImposters
A debugging aid which will force all forest items to be rendered as imposters.

Detailed Description

Objects for efficiently placing and rendering trees, rocks, foliage, or any such feature needed in large number.

Variable Documentation

bool Forest::disableImposters [static, inherited]

A debugging aid which will disable rendering of all imposters in the forest.

bool Forest::drawBounds [static, inherited]

A debugging aid which renders the forest bounds.

bool Forest::drawCells [static, inherited]

A debugging aid which renders the forest cell bounds.

bool Forest::forceImposters [static, inherited]

A debugging aid which will force all forest items to be rendered as imposters.


Torque 3D - Script Manual: Miscellaneous

Miscellaneous
[Environment Objects]

Miscellaneous environmental and level objects. More...

Classes

class | ConvexShape
A renderable, collidable convex shape defined by a collection of surface planes. More...
class | LevelInfo
Stores and controls the rendering and status information for a game level. More...
class | Marker
A single joint, or knot, along a path. Should be stored inside a Path container object. A path markers can be one of three primary movement types: "normal", "Position Only", or "Kink". More...
class | MissionArea
Level object which defines the boundaries of the level. More...
class | MissionMarker
This is a base class for all "marker" related objets. It is a 3D representation of a point in the level. More...
class | MissionMarkerData
A very basic class containing information used by MissionMarker objects for rendering. More...
class | Path
A spline along which various objects can move along. The spline object acts like a container for Marker objects, which make up the joints, or knots, along the path. Paths can be assigned a speed, can be looping or non-looping. Each of a path's markers can be one of three primary movement types: "normal", "Position Only", or "Kink". More...
class | PhysicalZone
Physical Zones are areas that modify the player's gravity and/or velocity and/or applied force. More...
class | Portal
An object that provides a "window" into a zone, allowing a viewer to see what's rendered in the zone. More...
class | Prefab
A collection of arbitrary objects which can be allocated and manipulated as a group. More...
class | ReflectorDesc
A datablock which defines performance and quality properties for dynamic reflections. More...
class | SpawnSphere
This class is used for creating any type of game object, assigning it a class, datablock, and even a function when it is spawned. More...
class | TerrainMaterial
The TerrainMaterial class orginizes the material settings for a single terrain material layer. More...
class | TimeOfDay
Environmental object that triggers a day/night cycle in level. More...
class | WayPoint
Special type of marker, distinguished by a name and team ID number. More...
class | Zone
An object that culls the rendering of everything contained within it. More...

Enumerations

enum MarkerKnotType {
Normal,
Only,
Kink
}

The type of knot that this marker will be.

More...
enum MarkerSmoothingType {
Spline,
Linear
}

The type of smoothing this marker will have for pathed objects.

More...

Functions

MissionArea getMissionAreaServerObject ()
Get the MissionArea object, if any.

Detailed Description

Miscellaneous environmental and level objects.

Enumeration Type Documentation

enum MarkerKnotType

The type of knot that this marker will be.

Enumerator:
Normal

Knot will have a smooth camera translation/rotation effect.

Only

Will do the same for translations, leaving rotation un-touched.

Kink

The rotation will take effect immediately for an abrupt rotation change.

enum MarkerSmoothingType

The type of smoothing this marker will have for pathed objects.

Enumerator:
Spline

Marker will cause the movements of the pathed object to be smooth.

Linear

Marker will have no smoothing effect.

Function Documentation

MissionArea getMissionAreaServerObject ( )

Get the MissionArea object, if any.


Torque 3D - Script Manual: Terrain

Terrain
[Environment Objects]

Objects that specialize in representing terrain and other collidable/walkable surfaces. More...

Classes

class | DecalRoad
A strip shaped decal defined by spine nodes which clips against Terrain objects. More...
class | GroundPlane
An infinite plane extending in all direction. More...
class | MeshRoad
A strip of rectangular mesh segments defined by a 3D spline for prototyping road-shaped objects in your scene. More...
class | TerrainBlock
Represent a terrain object in a Torque 3D level. More...

Functions

bool | getTerrainHeight (Point2I position)
Gets the terrain height at the specified position.
bool | getTerrainHeight (F32 x, F32 y)
Gets the terrain height at the specified position.
bool | getTerrainHeightBelowPosition (Point2I position)
Takes a world point and find the "highest" terrain underneath it.
bool | getTerrainHeightBelowPosition (F32 x, F32 y)
Takes a world point and find the "highest" terrain underneath it.
bool | getTerrainUnderWorldPoint (Point3F position)
Gets the terrain block that is located under the given world point.
bool | getTerrainUnderWorldPoint (F32 x, F32 y, F32 z)
Takes a world point and find the "highest" terrain underneath it.

Variables

static bool | TerrainBlock::debugRender
Triggers debug rendering of terrain cells.
float | $pref::Terrain::detailScale
A global detail scale used to tweak the material detail distances.
float | $pref::Terrain::lodScale
A global LOD scale used to tweak the default terrain screen error value.

Detailed Description

Objects that specialize in representing terrain and other collidable/walkable surfaces.

Function Documentation

bool getTerrainHeight ( Point2I position )

Gets the terrain height at the specified position.

Parameters:
position The world space point, minus the z (height) value. Formatted as ("x y")
Returns:
Returns the terrain height at the given point as an F32 value.
bool getTerrainHeight | ( | F32 | x,
 |  | F32 | y
 | ) |  |

Gets the terrain height at the specified position.

Parameters:
x | The X coordinate in world space
y | The Y coordinate in world space
Returns:
Returns the terrain height at the given point as an F32 value.
bool getTerrainHeightBelowPosition ( Point2I position )

Takes a world point and find the "highest" terrain underneath it.

Parameters:
position The world space point, minus the z (height) value. Formatted as ("x y")
Returns:
Returns the closest terrain height below the given point as an F32 value.
bool getTerrainHeightBelowPosition | ( | F32 | x,
 |  | F32 | y
 | ) |  |

Takes a world point and find the "highest" terrain underneath it.

Parameters:
x | The X coordinate in world space
y | The Y coordinate in world space
Returns:
Returns the closest terrain height below the given point as an F32 value.
bool getTerrainUnderWorldPoint ( Point3F position )

Gets the terrain block that is located under the given world point.

Parameters:
position The world space coordinate you wish to query at. Formatted as ("x y z")
Returns:
Returns the ID of the requested terrain block (0 if not found).
bool getTerrainUnderWorldPoint | ( | F32 | x,
 |  | F32 | y,
 |  | F32 | z
 | ) |  |

Takes a world point and find the "highest" terrain underneath it.

Parameters:
x | The X coordinate in world space
y | The Y coordinate in world space
z | The Z coordinate in world space
Returns:
Returns the ID of the requested terrain block (0 if not found).

Variable Documentation

bool TerrainBlock::debugRender [static, inherited]

Triggers debug rendering of terrain cells.

float $pref::Terrain::detailScale

A global detail scale used to tweak the material detail distances.

float $pref::Terrain::lodScale

A global LOD scale used to tweak the default terrain screen error value.


Torque 3D - Script Manual: Water

Water
[Environment Objects]

Objects that represent water features, from puddles to rivers and oceans. More...

Classes

class | River
A water volume defined by a 3D spline. More...
class | WaterBlock
A block shaped water volume defined by a 3D scale and orientation. More...
class | WaterObject
Abstract base class for representing a body of water. More...
class | WaterPlane
Represents a large body of water stretching to the horizon in all directions. More...

Variables

bool | $pref::Water::disableTrueReflections
Force all water objects to use static cubemap reflections.
static bool | WaterObject::wireframe
If true, will render the wireframe of the WaterObject.

Detailed Description

Objects that represent water features, from puddles to rivers and oceans.

Variable Documentation

bool $pref::Water::disableTrueReflections

Force all water objects to use static cubemap reflections.

bool WaterObject::wireframe [static, inherited]

If true, will render the wireframe of the WaterObject.


Torque 3D - Script Manual: GUI

GUI

Subsystem to display user interface elements and handle high-level rendering control flow. More...

Modules

3D Controls

Controls to render 3D elements.

Core Controls

Core parts of the Gui System.

Button Controls

A collection of various buttons (push buttons, radio buttons, check boxes, etc).

General Controls

A collection of general controls (bitmap, text, popup, etc).

Container Controls

A collection of various containers (container, window, scroll, etc).

Image and Video Controls

Controls that display images or videos.

Value Controls

Controls that display values and optionally allow to edit them.

Utility Controls

A collection of utility classes that support other GUI controls.

Game Controls

GUI controls dedicated to game play systems, such as heads up displays.

Detailed Description

Subsystem to display user interface elements and handle high-level rendering control flow.

Internationalization

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: 3D Controls

3D Controls
[GUI]

Controls to render 3D elements. More...

Classes

class | GameTSCtrl
The main 3D viewport for a Torque 3D game. More...
class | GuiObjectView
GUI control which displays a 3D model. More...
class | GuiTSCtrl
Abstract base class for controls that render 3D scenes. More...

Detailed Description

Controls to render 3D elements.


Torque 3D - Script Manual: Button Controls

Button Controls
[GUI]

A collection of various buttons (push buttons, radio buttons, check boxes, etc). More...

Classes

class | GuiBitmapButtonCtrl
A button that renders its various states (mouse over, pushed, etc.) from separate bitmaps. More...
class | GuiBitmapButtonTextCtrl
An extension of GuiBitmapButtonCtrl that additionally renders a text label on the bitmapped button. More...
class | GuiBorderButtonCtrl
A push button that renders only a border. More...
class | GuiButtonBaseCtrl
The base class for the various button controls. More...
class | GuiButtonCtrl
The most widely used button class. More...
class | GuiCheckBoxCtrl
A named checkbox that can be toggled on and off. More...
class | GuiRadioCtrl
A button based around the radio concept. More...
class | GuiSwatchButtonCtrl
A button that is used to represent color; often used in correlation with a color picker. More...
class | GuiToggleButtonCtrl
Deprecated gui control. More...

Enumerations

enum GuiButtonType {
PushButton,
ToggleButton,
RadioButton
}

Type of button control.

More...

Detailed Description

A collection of various buttons (push buttons, radio buttons, check boxes, etc).

Enumeration Type Documentation

enum GuiButtonType

Type of button control.

Enumerator:
PushButton

A button that triggers an action when clicked.

ToggleButton

A button that is toggled between on and off state.

RadioButton

A button placed in groups for presenting choices.


Torque 3D - Script Manual: Container Controls

Container Controls
[GUI]

A collection of various containers (container, window, scroll, etc). More...

Classes

class | GuiAutoScrollCtrl
A container that scrolls its child control up over time. More...
class | GuiContainer
Brief Desc. More...
class | GuiControlArrayControl
Brief Desc. More...
class | GuiDynamicCtrlArrayControl
A container that arranges children into a grid. More...
class | GuiFrameSetCtrl
A gui control allowing a window to be subdivided into panes, each of which displays a gui control child of the GuiFrameSetCtrl. More...
class | GuiPaneControl
A collapsable pane control. More...
class | GuiPanel
The GuiPanel panel is a container that when opaque will draw a left to right gradient using its profile fill and fill highlight colors. More...
class | GuiRolloutCtrl
A container that shows a single child with an optional header bar that can be used to collapse and expand the rollout. More...
class | GuiScrollCtrl
A container that allows to view one or more possibly larger controls inside its area by providing horizontal and/or vertical scroll bars. More...
class | GuiSpeedometerHud
Displays the speed of the current Vehicle based control object. More...
class | GuiSplitContainer
A container that splits its area between two child controls. More...
class | GuiStackControl
A container that stacks its children horizontally or vertically. More...
class | GuiTabBookCtrl
A container. More...
class | GuiTabPageCtrl
A single page in a GuiTabBookCtrl. More...
class | GuiTreeViewCtrl
Hierarchical list of text items with optional icons. More...
class | GuiWindowCtrl
A window with a title bar and an optional set of buttons. More...

Enumerations

enum GuiAutoScrollDirection {
Up,
Down,
Left,
Right
}

Direction in which to scroll the child control.

More...
enum GuiDockingType {
None,
Client,
Top,
Bottom,
Left,
Right
}
enum GuiFrameState {
alwaysOn,
alwaysOff,
dynamic
}
enum GuiHorizontalStackingType {
Right,
Left
}

Determines how child controls are stacked horizontally.

More...
enum GuiScrollBarBehavior {
alwaysOn,
alwaysOff,
dynamic
}

Display behavior of a scroll bar. Determines when a scrollbar will be visible.

More...
enum GuiSplitFixedPanel {
None,
FirstPanel,
SecondPanel
}

Which side of the splitter to keep at a fixed size (if any).

More...
enum GuiSplitOrientation {
Vertical,
Horizontal
}

Axis along which to divide the container's space.

More...
enum GuiStackingType {
Vertical,
Horizontal,
Dynamic
}

Stacking method used to position child controls.

More...
enum GuiTabPosition {
Top,
Bottom
}

Where the control should put the tab headers for selecting individual pages.

More...
enum GuiVerticalStackingType {
Bottom,
Top
}

Determines how child controls are stacked vertically.

More...

Detailed Description

A collection of various containers (container, window, scroll, etc).

Enumeration Type Documentation

enum GuiAutoScrollDirection

Direction in which to scroll the child control.

Enumerator:
Up

Scroll from bottom towards top.

Down

Scroll from top towards bottom.

Left

Scroll from right towards left.

Right

Scroll from left towards right.

enum GuiDockingType
Enumerator:
None
Client
Top
Bottom
Left
Right
enum GuiFrameState
Enumerator:
alwaysOn
alwaysOff
dynamic
enum GuiHorizontalStackingType

Determines how child controls are stacked horizontally.

Enumerator:
Right

Child controls are positioned in order from left to right (left-most control is first).

Left

Child controls are positioned in order from right to left (right-most control is first).

enum GuiScrollBarBehavior

Display behavior of a scroll bar. Determines when a scrollbar will be visible.

Enumerator:
alwaysOn

Always visible.

alwaysOff

Never visible.

dynamic

Only visible when actually needed, i.e. when the child control(s) exceed the visible space on the given axis.

enum GuiSplitFixedPanel

Which side of the splitter to keep at a fixed size (if any).

Enumerator:
None

Allow both childs to resize (default).

FirstPanel

Keep.

SecondPanel
enum GuiSplitOrientation

Axis along which to divide the container's space.

Enumerator:
Vertical

Divide vertically placing one child left and one child right.

Horizontal

Divide horizontally placing one child on top and one child below.

enum GuiStackingType

Stacking method used to position child controls.

Enumerator:
Vertical

Stack children vertically by setting their Y position.

Horizontal

Stack children horizontall by setting their X position.

Dynamic

Automatically switch between Vertical and Horizontal stacking. Vertical stacking is chosen when the stack control is taller than it is wide, horizontal stacking is chosen when the stack control is wider than it is tall.

enum GuiTabPosition

Where the control should put the tab headers for selecting individual pages.

Enumerator:
Top

Tab headers on top edge.

Bottom

Tab headers on bottom edge.

enum GuiVerticalStackingType

Determines how child controls are stacked vertically.

Enumerator:
Bottom

Child controls are positioned in order from top to bottom (top-most control is first).

Top

Child controls are positioned in order from bottom to top (bottom-most control is first).


Torque 3D - Script Manual: Core Controls

Core Controls
[GUI]

Core parts of the Gui System. More...

Classes

class | GuiCanvas
A canvas on which rendering occurs. More...
class | GuiConsole
The on-screen, in-game console. Calls getLog() to get the on-screen console entries, then renders them as needed. More...
class | GuiConsoleEditCtrl
Text entry element of a GuiConsole. More...
class | GuiControl
Base class for all Gui control objects. More...
class | GuiControlProfile
A collection of properties that determine control behavior and rendering. More...
class | GuiCursor
Acts as a skin for the cursor, where each GuiCursor object can have its own look and click-zone. More...
class | GuiFadeinBitmapCtrl
A GUI control which renders a black square over a bitmap image. The black square will fade out, then fade back in after a determined time. This control is especially useful for transitions and splash screens. More...
class | GuiIconButtonCtrl
Draws the bitmap within a special button control. Only a single bitmap is used and the button will be drawn in a highlighted mode when the mouse hovers over it or when it has been clicked. More...
class | GuiListBoxCtrl
A list of text items. More...
class | GuiMenuBar
GUI Control which displays a horizontal bar with individual drop-down menu items. Each menu item may also have submenu items. More...
class | GuiMLTextCtrl
A text control that uses the Gui Markup Language ('ML') tags to dynamically change the text. More...
class | GuiMouseEventCtrl
Used to overlaps a 'hot region' where you want to catch inputs with and have specific events occur based on individual callbacks. More...
class | GuiTextCtrl
GUI control object this displays a single line of text, without TorqueML. More...
class | GuiTextEditSliderBitmapCtrl
GUI Control which displays a numerical value which can be increased or decreased using a pair of bitmap up/down buttons. More...
class | GuiTextEditSliderCtrl
GUI Control which displays a numerical value which can be increased or decreased using a pair of arrows. More...

Enumerations

enum GuiAlignmentType {
Left,
Center,
Right,
Top,
Bottom
}
enum GuiFontCharset {
ANSI,
SYMBOL,
SHIFTJIS,
HANGEUL,
HANGUL,
GB2312,
CHINESEBIG5,
OEM,
JOHAB,
HEBREW,
ARABIC,
GREEK,
TURKISH,
VIETNAMESE,
THAI,
EASTEUROPE,
RUSSIAN,
MAC,
BALTIC
}
enum GuiHorizontalSizing {
right,
width,
left,
center,
relative,
windowRelative
}

Horizontal sizing behavior of a GuiControl.

More...
enum GuiVerticalSizing {
bottom,
height,
top,
center,
relative,
windowRelative
}

Vertical sizing behavior of a GuiControl.

More...

Functions

bool | excludeOtherInstance (string appIdentifer)
Used to exclude/prevent all other instances using the same identifier specified.
string | StripMLControlChars (string inString)
Strip TorqueML control characters from the specified string, returning a 'clean' version.

Variables

GuiControl $ThisControl
The control for which a command is currently being evaluated. Only set during 'command' and altCommand callbacks to the control for which the command or altCommand is invoked.

Detailed Description

Core parts of the Gui System.

Enumeration Type Documentation

enum GuiAlignmentType
Enumerator:
Left
Center
Right
Top
Bottom
enum GuiFontCharset
Enumerator:
ANSI
SYMBOL
SHIFTJIS
HANGEUL
HANGUL
GB2312
CHINESEBIG5
OEM
JOHAB
HEBREW
ARABIC
GREEK
TURKISH
VIETNAMESE
THAI
EASTEUROPE
RUSSIAN
MAC
BALTIC
enum GuiHorizontalSizing

Horizontal sizing behavior of a GuiControl.

Enumerator:
right
width
left
center
relative
windowRelative
enum GuiVerticalSizing

Vertical sizing behavior of a GuiControl.

Enumerator:
bottom
height
top
center
relative
windowRelative

Function Documentation

bool excludeOtherInstance ( string appIdentifer )

Used to exclude/prevent all other instances using the same identifier specified.

Note:
Not used on OSX, Xbox, or in Win debug builds
Parameters:
appIdentifier Name of the app set up for exclusive use.
Returns:
False if another app is running that specified the same appIdentifier
string StripMLControlChars ( string inString )

Strip TorqueML control characters from the specified string, returning a 'clean' version.

Parameters:
inString String to strip TorqueML control characters from.
Example:
// Define the string to strip TorqueML control characters from
%string = "<font:Arial:24>How Now <color:c43c12>Brown <color:000000>Cow";

// Request the stripped version of the string
%strippedString = StripMLControlChars(%string);
Returns:
Version of the inputted string with all TorqueML characters removed.
See also:
References

Variable Documentation

GuiControl $ThisControl

The control for which a command is currently being evaluated. Only set during 'command' and altCommand callbacks to the control for which the command or altCommand is invoked.


Torque 3D - Script Manual: Game Controls

Game Controls
[GUI]

GUI controls dedicated to game play systems, such as heads up displays. More...

Classes

class | GuiClockHud
Basic HUD clock. Displays the current simulation time offset from some base. More...
class | GuiCrossHairHud
Basic cross hair hud. Reacts to state of control object. Also displays health bar for named objects under the cross hair. More...
class | GuiGameListMenuCtrl
A base class for cross platform menu controls that are gamepad friendly. More...
class | GuiGameListMenuProfile
A GuiControlProfile with additional fields specific to GuiGameListMenuCtrl. More...
class | GuiGameListOptionsCtrl
A control for showing pages of options that are gamepad friendly. More...
class | GuiGameListOptionsProfile
A GuiControlProfile with additional fields specific to GuiGameListOptionsCtrl. More...
class | GuiHealthBarHud
A basic health bar. Shows the damage value of the current PlayerObjectType control object. More...
class | GuiShapeNameHud
Displays name and damage of ShapeBase objects in its bounds. Must be a child of a GuiTSCtrl and a server connection must be present. More...

Functions

void | snapToggle ()
Prevents mouse movement from being processed.

Detailed Description

GUI controls dedicated to game play systems, such as heads up displays.

Function Documentation

void snapToggle ( )

Prevents mouse movement from being processed.

In the source, whenever a mouse move event occurs GameTSCtrl::onMouseMove() is called. Whenever snapToggle() is called, it will flag a variable that can prevent this from happening: gSnapLine. This variable is not exposed to script, so you need to call this function to trigger it.

Example:
// Snapping is off by default, so we will toggle
// it on first:
PlayGui.snapToggle();

// Mouse movement should be disabled
// Let's turn it back on
PlayGui.snapToggle();


Torque 3D - Script Manual: General Controls

General Controls
[GUI]

A collection of general controls (bitmap, text, popup, etc). More...

Classes

class | GuiBitmapCtrl
A gui control that is used to display an image. More...
class | GuiBubbleTextCtrl
A single-line text control that displays its text in a multi-line popup when clicked. More...
class | GuiDirectoryFileListCtrl
A control that displays a list of files from within a single directory in the game file system. More...
class | GuiMLTextEditCtrl
A text entry control that accepts the Gui Markup Language ('ML') tags and multiple lines. More...
class | GuiPopUpMenuCtrl
A control that allows to select a value from a drop-down list. More...
class | GuiPopUpMenuCtrlEx
A control that allows to select a value from a drop-down list. More...
class | GuiSeparatorCtrl
A control that renders a horizontal or vertical separator with an optional text label (horizontal only). More...
class | GuiTextEditCtrl
A component that places a text entry box on the screen. More...
class | GuiTextListCtrl
GUI control that displays a list of text. Text items in the list can be individually selected. More...

Enumerations

enum GuiSeparatorType {
Vertical,
Horizontal
}

GuiSeparatorCtrl orientations.

More...

Detailed Description

A collection of general controls (bitmap, text, popup, etc).

Enumeration Type Documentation

enum GuiSeparatorType

GuiSeparatorCtrl orientations.

Enumerator:
Vertical
Horizontal


Torque 3D - Script Manual: Image and Video Controls

Image and Video Controls
[GUI]

Controls that display images or videos. More...

Classes

class | GuiBitmapBorderCtrl
A control that renders a skinned border specified in its profile. More...
class | GuiChunkedBitmapCtrl
This is a control that will render a specified bitmap or a bitmap specified in a referenced variable. More...
class | GuiTheoraCtrl
A control to playing Theora videos. More...

Enumerations

enum GuiBitmapMode {
Stretched,
Centered
}

Rendering behavior when placing bitmaps in controls.

More...
enum GuiIconButtonIconLocation {
None,
Left,
Right,
Center
}
enum GuiIconButtonTextLocation {
None,
Bottom,
Right,
Top,
Left,
Center
}
enum GuiTheoraTranscoder {
Auto,
Generic,
SSE2420RGBA
}

Routine to use for converting Theora's Y'CbCr pixel format to RGB color space.

More...

Detailed Description

Controls that display images or videos.

Enumeration Type Documentation

enum GuiBitmapMode

Rendering behavior when placing bitmaps in controls.

Enumerator:
Stretched

Stretch bitmap to fit control extents.

Centered

Center bitmap in control.

enum GuiIconButtonIconLocation
Enumerator:
None
Left
Right
Center
enum GuiIconButtonTextLocation
Enumerator:
None
Bottom
Right
Top
Left
Center
enum GuiTheoraTranscoder

Routine to use for converting Theora's Y'CbCr pixel format to RGB color space.

Enumerator:
Auto

Automatically detect most appropriate setting.

Generic

Slower but beneric transcoder that can convert all Y'CbCr input formats to RGB or RGBA output.

SSE2420RGBA

Fast SSE2-based transcoder with fixed conversion from 4:2:0 Y'CbCr to RGBA.


Torque 3D - Script Manual: Utility Controls

Utility Controls
[GUI]

A collection of utility classes that support other GUI controls. More...

Classes

class | GuiDragAndDropControl
A container control that can be used to implement drag&drop behavior. More...
class | GuiInputCtrl
A control that locks the mouse and reports all keyboard input events to script. More...
class | GuiMessageVectorCtrl
A chat HUD control that displays messages from a MessageVector. More...
class | GuiScriptNotifyCtrl
A control which adds several reactions to other GUIs via callbacks. More...
class | GuiTickCtrl
Brief Description. More...
class | MessageVector
Store a list of chat messages. More...

Detailed Description

A collection of utility classes that support other GUI controls.


Torque 3D - Script Manual: Value Controls

Value Controls
[GUI]

Controls that display values and optionally allow to edit them. More...

Classes

class | GuiGraphCtrl
A control that plots one or more curves in a chart. More...
class | GuiProgressBitmapCtrl
A horizontal progress bar rendered from a repeating image. More...
class | GuiProgressCtrl
GUI Control which displays a horizontal bar which increases as the progress value of 0.0 - 1.0 increases. More...
class | GuiSliderCtrl
A control that displays a value between its minimal and maximal bounds using a slider placed on a vertical or horizontal axis. More...

Enumerations

enum GuiGraphType {
Bar,
Filled,
Point,
PolyLine
}

The charting style of a single plotting curve in a GuiGraphCtrl.

More...

Detailed Description

Controls that display values and optionally allow to edit them.

Enumeration Type Documentation

enum GuiGraphType

The charting style of a single plotting curve in a GuiGraphCtrl.

Enumerator:
Bar

Plot the curve as a bar chart.

Filled

Plot a filled poly graph that connects the data points on the curve.

Point

Plot each data point on the curve as a single dot.

PolyLine

Plot straight lines through the data points of the curve.


Torque 3D - Script Manual: Game

Game

This section includes all objects, functions, and variables related to game play elements exposed by Torque 3D. More...

Classes

class | SimObject
Base class for almost all objects involved in the simulation. More...

Modules

Game Objects

Objects which can be controlled or directly interact with a user, such as Player, Projectile, Item, etc.

Special Effects

Classes responsible for special effect objects, such as Explosion, Debris, Particles, etc.

AI

Classes and functions related to artificial intelligence for Torque 3D.

Miscellaneous

Miscellaneous/uncategorized game related objects.

Physics

Objects and functions related to Torque 3D's physics layer.

Vehicles

This section is dedicated to vehicle game objects, such as the base Vehicle class, WheeledVehicle, FlyingVehicle, and so on.

Functions

bool | addBadWord (string badWord)
Add a string to the bad word filter.
bool | containerBoxEmpty (int mask, Point3F center, float xRadius, float yRadius=-1, float zRadius=-1, bool useClientContainer=false)
See if any objects of the given types are present in box of given extent.
string | containerFindFirst (int mask, Point3F point, float x, float y, float z)
Find objects matching the bitmask type within a box centered at point, with extents x, y, z.
string | containerFindNext ()
Get more results from a previous call to containerFindFirst().
string | containerRayCast (Point3F start, Point3F end, int mask, SceneObject pExempt=NULL, bool useClientContainer=false)
Cast a ray from start to end, checking for collision against items matching mask.
float | containerSearchCurrDist (bool useClientContainer=false)
Get distance of the center of the current item from the center of the current initContainerRadiusSearch.
float | containerSearchCurrRadiusDist (bool useClientContainer=false)
Get the distance of the closest point of the current item from the center of the current initContainerRadiusSearch.
SceneObject | containerSearchNext (bool useClientContainer=false)
Get next item from a search started with initContainerRadiusSearch() or initContainerTypeSearch().
bool | containsBadWords (string text)
Checks to see if text is a bad word.
string | filterString (string baseString=NULL, string replacementChars=NULL)
Replaces the characters in a string with designated text.
void | initContainerRadiusSearch (Point3F pos, float radius, int mask, bool useClientContainer=false)
Start a search for items at the given position and within the given radius, filtering by mask.
void | initContainerTypeSearch (int mask, bool useClientContainer=false)
Start a search for all items of the types specified by the bitset mask.
bool | isPointInside (Point3F position)
Check to see if a point in world space is inside of an interior.
bool | isPointInside (F32 x, F32 y, F32 z)
void | pathOnMissionLoadDone ()
Load all path information from interiors.
void | resetFPSTracker ()
Reset FPS stats (fps::).
void | sceneDumpZoneStates (bool updateFirst=true)
Dump the current zoning states of all zone spaces in the scene to the console.
SceneObject | sceneGetZoneOwner (int zoneId=true)
Return the SceneObject that contains the given zone.
void | setInteriorRenderMode (int mode)
Globally changes how InteriorInstances are rendered. Useful for debugging geometry and rendering artifacts.
bool | spawnObject (class[, dataBlock, name, properties, script])
Global function used for spawning any type of object.

Variables

float | $cameraFov
The camera's Field of View.
float | $mvBackwardAction
Backwards movement speed for the active player.
bool | $mvDeviceIsKeyboardMouse
Boolean state for it the system is using a keyboard and mouse or not.
float | $mvDownAction
Downwards movement speed for the active player.
float | $mvForwardAction
Forwards movement speed for the active player.
bool | $mvFreeLook
Boolean state for if freelook is active or not.
float | $mvLeftAction
Left movement speed for the active player.
float | $mvPitch
Current pitch value, typically applied through input devices, such as a mouse.
float | $mvPitchDownSpeed
Downwards pitch speed.
float | $mvPitchUpSpeed
Upwards pitch speed.
float | $mvRightAction
Right movement speed for the active player.
float | $mvRoll
Current roll value, typically applied through input devices, such as a mouse.
float | $mvRollLeftSpeed
Left roll speed.
float | $mvRollRightSpeed
Right roll speed.
int | $mvTriggerCount0
Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.
int | $mvTriggerCount1
Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.
int | $mvTriggerCount2
Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.
int | $mvTriggerCount3
Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.
int | $mvTriggerCount4
Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.
int | $mvTriggerCount5
Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.
float | $mvUpAction
Upwards movement speed for the active player.
float | $mvXAxis_L
Left thumbstick X axis position on a dual-analog gamepad.
float | $mvXAxis_R
Right thumbstick X axis position on a dual-analog gamepad.
float | $mvYaw
Current yaw value, typically applied through input devices, such as a mouse.
float | $mvYawLeftSpeed
Left Yaw speed.
float | $mvYawRightSpeed
Right Yaw speed.
float | $mvYAxis_L
Left thumbstick Y axis position on a dual-analog gamepad.
float | $mvYAxis_R
Right thumbstick Y axis position on a dual-analog gamepad.
int | $Ease::Back
Backwards ease for curve movement.
int | $Ease::Bounce
Bounce ease for curve movement.
int | $Ease::Circular
Circular ease for curve movement.
int | $Ease::Cubic
Cubic ease for curve movement.
float | $pref::Camera::distanceScale
A scale to apply to the normal visible distance, typically used for tuning performance.
int | $Ease::Elastic
Elastic ease for curve movement.
bool | $pref::enableBadWordFilter
If true, the bad word filter will be enabled.
bool | $pref::enablePostEffects
If true, post effects will be eanbled.
int | $Ease::Exponential
Exponential ease for curve movement.
int | $Ease::In
In ease for curve movement.
int | $Ease::InOut
InOut ease for curve movement.
bool | $pref::Input::JoystickEnabled
If true, the joystick is currently enabled.
int | $Ease::Linear
Linear ease for curve movement.
int | $Ease::Out
Out ease for curve movement.
int | $Ease::Quadratic
Quadratic ease for curve movement.
int | $Ease::Quartic
Quartic ease for curve movement.
int | $Ease::Quintic
Quintic ease for curve movement.
int | $Ease::Sinusoidal
Sinusoidal ease for curve movement.

Detailed Description

This section includes all objects, functions, and variables related to game play elements exposed by Torque 3D.

Function Documentation

bool addBadWord ( string badWord )

Add a string to the bad word filter.

The bad word filter is a table containing words which will not be displayed in chat windows. Instead, a designated replacement string will be displayed. There are already a number of bad words automatically defined.

Parameters:
badWord Exact text of the word to restrict.
Returns:
True if word was successfully added, false if the word or a subset of it already exists in the table
See also:
filterString()
Example:
// In this game, "Foobar" is banned
%badWord = "Foobar";

// Returns true, word was successfully added
addBadWord(%badWord);

// Returns false, word has already been added
addBadWord("Foobar");

bool containerBoxEmpty | ( | int | mask,
 |  | Point3F | center,
 |  | float | xRadius,
 |  | float | yRadius = -1,
 |  | float | zRadius = -1,
 |  | bool | useClientContainer = false
 | ) |  |

See if any objects of the given types are present in box of given extent.

Note:
Extent parameter is last since only one radius is often needed. If one radius is provided, the yRadius and zRadius are assumed to be the same. Unfortunately, if you need to use the client container, you'll need to set all of the radius parameters. Fortunately, this function is mostly used on the server.
Parameters:
mask | Indicates the type of objects we are checking against.
center | Center of box.
xRadius | Search radius in the x-axis. See note above.
yRadius | Search radius in the y-axis. See note above.
zRadius | Search radius in the z-axis. See note above.
useClientContainer | Optionally indicates the search should be within the client container.
Returns:
true if the box is empty, false if any object is found.
string containerFindFirst | ( | int | mask,
 |  | Point3F | point,
 |  | float | x,
 |  | float | y,
 |  | float | z
 | ) |  |

Find objects matching the bitmask type within a box centered at point, with extents x, y, z.

Returns:
The first object found, or an empty string if nothing was found. Thereafter, you can get more results using containerFindNext().
See also:
containerFindNext
string containerFindNext ( )

Get more results from a previous call to containerFindFirst().

Note:
You must call containerFindFirst() to begin the search.
Returns:
The next object found, or an empty string if nothing else was found.
See also:
containerFindFirst()
string containerRayCast | ( | Point3F | start,
 |  | Point3F | end,
 |  | int | mask,
 |  | SceneObject | pExempt = NULL,
 |  | bool | useClientContainer = false
 | ) |  |

Cast a ray from start to end, checking for collision against items matching mask.

If pExempt is specified, then it is temporarily excluded from collision checks (For instance, you might want to exclude the player if said player was firing a weapon.)

Parameters:
start | An XYZ vector containing the tail position of the ray.
end | An XYZ vector containing the head position of the ray
mask | A bitmask corresponding to the type of objects to check for
pExempt | An optional ID for a single object that ignored for this raycast
useClientContainer | Optionally indicates the search should be within the client container.
Returns:
A string containing either null, if nothing was struck, or these fields:
  • The ID of the object that was struck.
  • The x, y, z position that it was struck.
  • The x, y, z of the normal of the face that was struck.
float containerSearchCurrDist ( bool useClientContainer = false )

Get distance of the center of the current item from the center of the current initContainerRadiusSearch.

Parameters:
useClientContainer Optionally indicates the search should be within the client container.
Returns:
distance from the center of the current object to the center of the search
See also:
containerSearchNext
float containerSearchCurrRadiusDist ( bool useClientContainer = false )

Get the distance of the closest point of the current item from the center of the current initContainerRadiusSearch.

Parameters:
useClientContainer Optionally indicates the search should be within the client container.
Returns:
distance from the closest point of the current object to the center of the search
See also:
containerSearchNext
SceneObject containerSearchNext ( bool useClientContainer = false )

Get next item from a search started with initContainerRadiusSearch() or initContainerTypeSearch().

Parameters:
useClientContainer Optionally indicates the search should be within the client container.
Returns:
the next object found in the search, or null if no more
Example:
// print the names of all nearby ShapeBase derived objects
%position = %obj.getPosition;
%radius = 20;
%mask = $TypeMasks::ShapeBaseObjectType;
initContainerRadiusSearch( %position, %radius, %mask );
while ( (%targetObject = containerSearchNext()) != 0 )
{
   echo( "Found: " @ %targetObject.getName() );
}
See also:
initContainerRadiusSearch()
initContainerTypeSearch()
bool containsBadWords ( string text )

Checks to see if text is a bad word.

The text is considered to be a bad word if it has been added to the bad word filter.

Parameters:
text Text to scan for bad words
Returns:
True if the text has bad word(s), false if it is clean
See also:
addBadWord()
filterString()
Example:
// In this game, "Foobar" is banned
%badWord = "Foobar";

// Add a banned word to the bad word filter
addBadWord(%badWord);

// Create the base string, can come from anywhere like user chat
%userText = "Foobar";

// Create a string of random letters
%replacementChars = "knqwrtlzs";

// If the text contains a bad word, filter it before printing
// Otherwise print the original text
if(containsBadWords(%userText))
{
   // Filter the string
   %filteredText = filterString(%userText, %replacementChars);

   // Print filtered text
   echo(%filteredText);
}
else
   echo(%userText);

string filterString | ( | string | baseString = NULL,
 |  | string | replacementChars = NULL
 | ) |  |

Replaces the characters in a string with designated text.

Uses the bad word filter to determine which characters within the string will be replaced.

Parameters:
baseString | The original string to filter.
replacementChars | A string containing letters you wish to swap in the baseString.
Returns:
The new scrambled string
See also:
addBadWord()
containsBadWords()
Example:
// Create the base string, can come from anywhere
%baseString = "Foobar";

// Create a string of random letters
%replacementChars = "knqwrtlzs";

// Filter the string
%newString = filterString(%baseString, %replacementChars);

// Print the new string to console
echo(%newString);

void initContainerRadiusSearch | ( | Point3F | pos,
 |  | float | radius,
 |  | int | mask,
 |  | bool | useClientContainer = false
 | ) |  |

Start a search for items at the given position and within the given radius, filtering by mask.

Parameters:
pos | Center position for the search
radius | Search radius
mask | Bitmask of object types to include in the search
useClientContainer | Optionally indicates the search should be within the client container.
See also:
containerSearchNext
void initContainerTypeSearch | ( | int | mask,
 |  | bool | useClientContainer = false
 | ) |  |

Start a search for all items of the types specified by the bitset mask.

Parameters:
mask | Bitmask of object types to include in the search
useClientContainer | Optionally indicates the search should be within the client container.
See also:
containerSearchNext
bool isPointInside ( Point3F position )

Check to see if a point in world space is inside of an interior.

Parameters:
position The position to check in world space.
Example:
// Check to see if a point is inside any interior
%point = "100 100 100";
%isInside = isPointInside(%point);

bool isPointInside | ( | F32 | x,
 |  | F32 | y,
 |  | F32 | z
 | ) |  |

Check to see if a set of coordinates in world space are inside of an interior.

Parameters:
x | X-coordinate for position in world space.
y | Y-coordinate for position in world space.
z | Z-coordinate for position in world space.
Example:
// Check to see if a point is inside any interior
%isInside = isPointInside(100, 100, 100);
void pathOnMissionLoadDone ( )

Load all path information from interiors.

This function is usually called from the loadMissionStage2() server-side function after the mission file has loaded.

Example:
// Inform the engine to load all path information from interiors.
pathOnMissionLoadDone();
void resetFPSTracker ( )

Reset FPS stats (fps::).

void sceneDumpZoneStates ( bool updateFirst = true )

Dump the current zoning states of all zone spaces in the scene to the console.

Parameters:
updateFirst If true, zoning states are brought up to date first; if false, the zoning states are dumped as is.
Note:
Only valid on the client.
SceneObject sceneGetZoneOwner ( int zoneId = true )

Return the SceneObject that contains the given zone.

Parameters:
zoneId ID of zone.
Returns:
A SceneObject or NULL if the given zoneId is invalid.
Note:
Only valid on the client.
void setInteriorRenderMode ( int mode )

Globally changes how InteriorInstances are rendered. Useful for debugging geometry and rendering artifacts.

Note:
This does not work in shipping mode
Parameters:
mode The render mode can be one of the following numbers:

NormalRender = 0,

NormalRenderLines = 1,

ShowDetail = 2,

ShowAmbiguous = 3,

ShowOrphan = 4,

ShowLightmaps = 5,

ShowTexturesOnly = 6,

ShowPortalZones = 7,

ShowOutsideVisible = 8,

ShowCollisionFans = 9,

ShowStrips = 10,

ShowNullSurfaces = 11,

ShowLargeTextures = 12,

ShowHullSurfaces = 13,

ShowVehicleHullSurfaces = 14,

ShowVertexColors = 15,

ShowDetailLevel = 16

bool spawnObject ( class [, dataBlock, name, properties, script] )

Global function used for spawning any type of object.

Note: This is separate from SpawnSphere::spawnObject(). This function is not called off any other class and uses different parameters than the SpawnSphere's function. In the source, SpawnSphere::spawnObject() actually calls this function and passes its properties (spawnClass, spawnDatablock, etc).

Parameters:
class | Mandatory field specifying the object class, such as Player or TSStatic.
datablock | Field specifying the object's datablock, optional for objects such as TSStatic, mandatory for game objects like Player.
name | Optional field specifying a name for this instance of the object.
properties | Optional set of parameters applied to the spawn object during creation.
script | Optional command(s) to execute when spawning an object.
Example:
// Set the parameters for the spawn function
%objectClass = "Player";
%objectDatablock = "DefaultPlayerData";
%objectName = "PlayerName";
%additionalProperties = "health = \"0\";"; // Note the escape sequence \ in front of quotes
%spawnScript = "echo(\"Player Spawned\");" // Note the escape sequence \ in front of quotes
// Spawn with the engine's Sim::spawnObject() function
%player = spawnObject(%objectClass, %objectDatablock, %objectName, %additionalProperties, %spawnScript);

Variable Documentation

float $cameraFov

The camera's Field of View.

float $mvBackwardAction

Backwards movement speed for the active player.

bool $mvDeviceIsKeyboardMouse

Boolean state for it the system is using a keyboard and mouse or not.

float $mvDownAction

Downwards movement speed for the active player.

float $mvForwardAction

Forwards movement speed for the active player.

bool $mvFreeLook

Boolean state for if freelook is active or not.

float $mvLeftAction

Left movement speed for the active player.

float $mvPitch

Current pitch value, typically applied through input devices, such as a mouse.

float $mvPitchDownSpeed

Downwards pitch speed.

float $mvPitchUpSpeed

Upwards pitch speed.

float $mvRightAction

Right movement speed for the active player.

float $mvRoll

Current roll value, typically applied through input devices, such as a mouse.

float $mvRollLeftSpeed

Left roll speed.

float $mvRollRightSpeed

Right roll speed.

int $mvTriggerCount0

Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.

int $mvTriggerCount1

Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.

int $mvTriggerCount2

Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.

int $mvTriggerCount3

Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.

int $mvTriggerCount4

Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.

int $mvTriggerCount5

Used to determine the trigger counts of buttons. Namely used for input actions such as jumping and weapons firing.

float $mvUpAction

Upwards movement speed for the active player.

float $mvXAxis_L

Left thumbstick X axis position on a dual-analog gamepad.

float $mvXAxis_R

Right thumbstick X axis position on a dual-analog gamepad.

float $mvYaw

Current yaw value, typically applied through input devices, such as a mouse.

float $mvYawLeftSpeed

Left Yaw speed.

float $mvYawRightSpeed

Right Yaw speed.

float $mvYAxis_L

Left thumbstick Y axis position on a dual-analog gamepad.

float $mvYAxis_R

Right thumbstick Y axis position on a dual-analog gamepad.

int $Ease::Back

Backwards ease for curve movement.

int $Ease::Bounce

Bounce ease for curve movement.

int $Ease::Circular

Circular ease for curve movement.

int $Ease::Cubic

Cubic ease for curve movement.

float $pref::Camera::distanceScale

A scale to apply to the normal visible distance, typically used for tuning performance.

int $Ease::Elastic

Elastic ease for curve movement.

bool $pref::enableBadWordFilter

If true, the bad word filter will be enabled.

bool $pref::enablePostEffects

If true, post effects will be eanbled.

int $Ease::Exponential

Exponential ease for curve movement.

int $Ease::In

In ease for curve movement.

int $Ease::InOut

InOut ease for curve movement.

bool $pref::Input::JoystickEnabled

If true, the joystick is currently enabled.

int $Ease::Linear

Linear ease for curve movement.

int $Ease::Out

Out ease for curve movement.

int $Ease::Quadratic

Quadratic ease for curve movement.

int $Ease::Quartic

Quartic ease for curve movement.

int $Ease::Quintic

Quintic ease for curve movement.

int $Ease::Sinusoidal

Sinusoidal ease for curve movement.


Torque 3D - Script Manual: AI

AI
[Game]

Classes and functions related to artificial intelligence for Torque 3D. More...

Classes

class | AIClient
Simulated client driven by AI commands. More...
class | AIConnection
Special client connection driven by an AI, rather than a human. More...
class | AIPlayer
A Player object not controlled by conventional input, but by an AI engine. More...

Functions

int | aiConnect (...)
Creates a new AIConnection, and passes arguments to its onConnect script callback.

Detailed Description

Classes and functions related to artificial intelligence for Torque 3D.

Function Documentation

int aiConnect ( ... )

Creates a new AIConnection, and passes arguments to its onConnect script callback.

Returns:
The newly created AIConnection
See also:
GameConnection for parameter information


Torque 3D - Script Manual: Game Objects

Game Objects
[Game]

Objects which can be controlled or directly interact with a user, such as Player, Projectile, Item, etc. More...

Classes

class | AIPlayer
A Player object not controlled by conventional input, but by an AI engine. More...
class | GameBase
Base class for game objects which use datablocks, networking, are editable, and need to process ticks. More...
class | GameBaseData
Scriptable, demo-able datablock. Used by GameBase objects. More...
class | InteriorInstance
Object used to represent buildings and other architectural structures (legacy). More...
class | Item
Base Item class. Uses the ItemData datablock for common properties. More...
class | ItemData
Stores properties for an individual Item type. More...
class | Player
A client-controlled player character. More...
class | PlayerData
Defines properties for a Player object. More...
class | Projectile
Base projectile class. Uses the ProjectileData class for properties of individual projectiles. More...
class | ProjectileData
Stores properties for an individual projectile type. More...
class | SceneObject
A networkable object that exists in the 3D world. More...
class | ShapeBase
A scriptable, renderable shape. More...
class | ShapeBaseData
Defines properties for a ShapeBase object. More...
class | ShapeBaseImageData
Represents geometry to be mounted to a ShapeBase object. More...
class | SpawnSphere
This class is used for creating any type of game object, assigning it a class, datablock, and even a function when it is spawned. More...
class | StaticShape
The most basic 3D shape with a datablock available in Torque 3D. More...
class | StaticShapeData
The most basic ShapeBaseData derrived shape datablock available in Torque 3D. More...
class | Trigger
A Trigger is a volume of space that initiates script callbacks when objects pass through the Trigger. More...
class | TriggerData
Defines shared properties for Trigger objects. More...
class | TSShapeConstructor
An object used to modify a DTS or COLLADA shape model after it has been loaded by Torque. More...
class | TSStatic
A static object derived from a 3D model file and placed within the game world. More...

Enumerations

enum ItemLightType {
NoLight,
ConstantLight,
PulsingLight
}

The type of light the Item has.

More...
enum ShapeBaseImageLightType {
NoLight,
ConstantLight,
SpotLight,
PulsingLight,
WeaponFireLight
}

The type of light to attach to this ShapeBaseImage.

More...
enum ShapeBaseImageLoadedState {
Ignore,
Loaded,
Empty
}

The loaded state of this ShapeBaseImage.

More...
enum ShapeBaseImageRecoilState {
NoRecoil,
LightRecoil,
MediumRecoil,
HeavyRecoil
}

What kind of recoil this ShapeBaseImage should emit when fired.

More...
enum ShapeBaseImageSpinState {
Ignore,
Stop,
SpinUp,
SpinDown,
FullSpeed
}

How the spin animation should be played.

More...
enum TSMeshType {
None,
Bounds,
Mesh,
Mesh
}

Type of mesh data available in a shape.

More...

Variables

float | $SB::DFDec
Speed to reduce the damage flash effect per tick.
static bool | Trigger::renderTriggers
Forces all Trigger's to render.
float | $SB::WODec
Speed to reduce the whiteout effect per tick.

Detailed Description

Objects which can be controlled or directly interact with a user, such as Player, Projectile, Item, etc.

Does not include vehicles as they have their own section.

Enumeration Type Documentation

enum ItemLightType

The type of light the Item has.

Enumerator:
NoLight

The item has no light attached.

ConstantLight

The item has a constantly emitting light attached.

PulsingLight

The item has a pulsing light attached.

enum ShapeBaseImageLightType

The type of light to attach to this ShapeBaseImage.

Enumerator:
NoLight

No light is attached.

ConstantLight

A constant emitting light is attached.

SpotLight

A spotlight is attached.

PulsingLight

A pusling light is attached.

WeaponFireLight

Light emits when the weapon is fired, then dissipates.

enum ShapeBaseImageLoadedState

The loaded state of this ShapeBaseImage.

Enumerator:
Ignore

Ignore the loaded state.

Loaded

ShapeBaseImage is loaded.

Empty

ShapeBaseImage is not loaded.

enum ShapeBaseImageRecoilState

What kind of recoil this ShapeBaseImage should emit when fired.

Enumerator:
NoRecoil

No recoil occurs.

LightRecoil

A light recoil occurs.

MediumRecoil

A medium recoil occurs.

HeavyRecoil

A heavy recoil occurs.

enum ShapeBaseImageSpinState

How the spin animation should be played.

Enumerator:
Ignore

No changes to the spin sequence.

Stop

Stops the spin sequence at its current position.

SpinUp

Increase spin sequence timeScale from 0 (on state entry) to 1 (after stateTimeoutValue seconds).

SpinDown

Decrease spin sequence timeScale from 1 (on state entry) to 0 (after stateTimeoutValue seconds).

FullSpeed

Resume the spin sequence playback at its current position with timeScale = 1.

enum TSMeshType

Type of mesh data available in a shape.

Enumerator:
None

No mesh data.

Bounds

Bounding box of the shape.

Mesh

Specifically desingated "collision" meshes.

Mesh

Rendered mesh polygons.

Variable Documentation

float $SB::DFDec

Speed to reduce the damage flash effect per tick.

See also:
ShapeBase::setDamageFlash()
ShapeBase::getDamageFlash()
Note:
Relies on the flash postFx.
bool Trigger::renderTriggers [static, inherited]

Forces all Trigger's to render.

Used by the Tools and debug render modes.

float $SB::WODec

Speed to reduce the whiteout effect per tick.

See also:
ShapeBase::setWhiteOut()
ShapeBase::getWhiteOut
Note:
Relies on the flash postFx.


Torque 3D - Script Manual: Miscellaneous

Miscellaneous
[Game]

Miscellaneous/uncategorized game related objects. More...

Miscellaneous/uncategorized game related objects.


Torque 3D - Script Manual: Physics

Physics
[Game]

Objects and functions related to Torque 3D's physics layer. More...

Classes

class | PhysicsDebris
Represents one or more rigid bodies defined in a single mesh file with a limited lifetime. More...
class | PhysicsDebrisData
Defines the properties of a type of PhysicsDebrisData. More...
class | PhysicsForce
Helper object for gameplay physical forces. WIP. More...
class | PhysicsShape
Represents a destructible physical object simulated through the plugin system. More...
class | PhysicsShapeData
Defines the properties of a type of PhysicsShape. More...
class | PxCloth
Rectangular patch of cloth simulated by PhysX. More...
class | PxMaterial
Defines a PhysX material assignable to PxMultiActorData. More...
class | PxMultiActor
Represents a destructible physical object simulated using PhysX. More...
class | PxMultiActorData
Defines the properties of a type of PxMultiActor. More...
class | RadialImpulseEvent
Creates a physics based impulse effect from a defined central point and magnitude. More...

Enumerations

enum PhysicsSimType {
ClientOnly,
ServerOnly,
ClientServer
}

How to handle the physics simulation with the client's and server.

More...

Functions

void | PhysicsForce::attach (Point3F start, Point3F direction, float maxDist)
Performs a physics ray cast and attracts the hit dynamic physics body to the force position.
void | PhysicsForce::detach (Point3F force=Point3F::Zero)
Releases the attached physics body with an optional push force.
bool | PhysicsForce::isAttached ()
Returns true if there is a physics body attached.

Variables

bool | $Physics::isSinglePlayer
Used to inform the physics simulation that there is only one player.
float | $pref::PhysicsDebris::lifetimeScale
Used to scale the lifetime of physics debris. Set it to 0 to disable physics debris completely.
static bool | PhysicsShape::noCorrections
If set true, client-side shapes will recieve no corrections from the server and will instead by allowed to diverge.
static bool | PhysicsShape::noSmoothing
If set true, client-side shapes will render immediately at the position they are corrected to when a correction is recieved from the server.
bool | physicsPluginPresent
physicsPluginPresent()
int | $pref::Physics::threadCount
Number of threads to use in a single pass of the physics engine.

Detailed Description

Objects and functions related to Torque 3D's physics layer.

Enumeration Type Documentation

enum PhysicsSimType

How to handle the physics simulation with the client's and server.

Enumerator:
ClientOnly

Only handle physics on the client.

ServerOnly

Only handle physics on the server.

ClientServer

Handle physics on both the client and server.

Function Documentation

void PhysicsForce::attach | ( | Point3F | start,
 |  | Point3F | direction,
 |  | float | maxDist |
 | ) |  |  | [inherited]

Performs a physics ray cast and attracts the hit dynamic physics body to the force position.

void PhysicsForce::detach ( Point3F force = Point3F::Zero ) [inherited]

Releases the attached physics body with an optional push force.

bool PhysicsForce::isAttached ( ) [inherited]

Returns true if there is a physics body attached.

Variable Documentation

bool $Physics::isSinglePlayer

Used to inform the physics simulation that there is only one player.

float $pref::PhysicsDebris::lifetimeScale

Used to scale the lifetime of physics debris. Set it to 0 to disable physics debris completely.

bool PhysicsShape::noCorrections [static, inherited]

If set true, client-side shapes will recieve no corrections from the server and will instead by allowed to diverge.

bool PhysicsShape::noSmoothing [static, inherited]

If set true, client-side shapes will render immediately at the position they are corrected to when a correction is recieved from the server.

bool physicsPluginPresent

physicsPluginPresent()

Returns true if a physics plugin exists and is initialized.

int $pref::Physics::threadCount

Number of threads to use in a single pass of the physics engine.


Torque 3D - Script Manual: Special Effects

Special Effects
[Game]

Classes responsible for special effect objects, such as Explosion, Debris, Particles, etc. More...

Classes

class | Debris
Base debris class. Uses the DebrisData datablock for properties of individual debris objects. More...
class | DebrisData
Stores properties for an individual debris type. More...
class | DecalData
A datablock describing an individual decal. More...
class | DecalManager
All decals are managed by the decal manager. Provides a few global variables for managing the number of decals that are visible at any one time and the lifetime of the decal. More...
class | Explosion
The emitter for an explosion, whose properties are defined in an ExplosionData object. More...
class | ExplosionData
The data on what an explosion should look like. Definesa particle data, debris data, affects the lighting conditions in the region of the explosion, and shakes the camera. More...
class | ForestWindEmitter
Object responsible for simulating wind in a level. More...
class | LightAnimData
A datablock which defines and performs light animation, such as rotation, brightness fade, and colorization. More...
class | Lightning
An individual lightning bolt, created from a LightningData object. More...
class | LightningData
An emitter for Lightning objects. More...
class | LightningStrikeEvent
A lightning bolt strike, called from strikeRandomPoint or strikeObject method on Lightning. More...
class | ParticleData
Contains information for how specific particles should look and react including particle colors, particle imagemap, acceleration value for individual particles and spin information. More...
class | ParticleEmitter
This object is responsible for all particle emissions. More...
class | ParticleEmitterData
Acts as the physical point in space in white Particles are created from. Also manages how to fire particles, including velocity, offset and length of firing (or 'ejection'). More...
class | ParticleEmitterNode
Manages timing update information for the assigned particleEmitter. Particles can be assigned to this emitter through the method setEmitterDataBlock(particleEmitterDatablock). More...
class | ParticleEmitterNodeData
Contains the timeMuliplier information to be assigned to a ParticleEmitterNode. The time multiplayer value for the ParticleEmitterNodeData can be set with nodeData.timeMultiple = value;. More...
class | Precipitation
Defines a precipitation based storm (IE: rain, snow, etc.). More...
class | PrecipitationData
Defines the droplets used in a storm (IE: raindrops, snowflakes, etc.). More...
class | Splash
Manages the ring used for a Splash effect. More...
class | SplashData
Acts as the physical point in space in white a Splash is created from. More...

Enumerations

enum ParticleBlendStyle {
NORMAL,
ADDITIVE,
SUBTRACTIVE,
PREMULTALPHA
}

The type of visual blending style to apply to the particles.

More...

Functions

float | calcExplosionCoverage (Point3F pos=Point3F(0.0f, 0.0f, 0.0f), int id=NULL, int covMask=NULL)
Calculates how much an explosion effects a specific object. Use this to determine.
int | decalManagerAddDecal (Point3F position, Point3F normal, float rot, float scale, DecalData decalData, bool isImmortal=false)
Adds a new decal to the decal manager.
void | decalManagerClear ()
Removes all decals currently loaded in the decalManager.
bool | decalManagerDirty ()
Returns if the decal manager has unsaved modifications.
bool | decalManagerLoad (string fileName)
Loads the decals from the entered filename.
bool | decalManagerRemoveDecal (int decalID)
Remove specified decal from the scene.
void | decalManagerSave (String decalSaveFile="")
Saves the decals for the active mission in the entered filename.

Variables

bool | $Decals::debugRender
If true, the decal spheres will be visualized when in the editor.
bool | $pref::Decals::enabled
Whether decals are currently enabled or not.
float | $pref::Decals::lifeTimeScale
Lifetime that decals will last after being created in the world.
bool | $Decals::poolBuffers
If true, will merge all PrimitiveBuffers and VertexBuffers into a pair of pools before clearing them at the end of a frame.
float | $Decals::sphereDistanceTolerance
The distance at which the decal system will start breaking up decal spheres when adding new decals.
float | $Decals::sphereRadiusTolerance
The radius beyond which the decal system will start breaking up decal spheres when adding new decals.

Detailed Description

Classes responsible for special effect objects, such as Explosion, Debris, Particles, etc.

Enumeration Type Documentation

enum ParticleBlendStyle

The type of visual blending style to apply to the particles.

Enumerator:
NORMAL

No blending style.

ADDITIVE

Adds the color of the pixel to the frame buffer with full alpha for each pixel.

SUBTRACTIVE

Subtractive Blending. Reverses the color model, causing dark colors to have a stronger visual effect.

PREMULTALPHA

Color blends with the colors of the imagemap rather than the alpha.

Function Documentation

float calcExplosionCoverage | ( | Point3F | pos = Point3F(0.0f, 0.0f, 0.0f),
 |  | int | id = NULL,
 |  | int | covMask = NULL
 | ) |  |

Calculates how much an explosion effects a specific object. Use this to determine.

damage values to objects based on their distance from the explosion's center point.

Example:
// Get the position of an explosion.
%position = ExplosionData.getPosition();

// Set a list of TypeMasks (defined in gameFunctioncs.cpp), seperated by the | character.
%TypeMasks = $TypeMasks::StaticObjectType | $TypeMasks::ItemObjectType

// Call the function, and acquire the value of effect, from 0.0f - 1.0f.
%effectValue = calcExplosionCoverage(%position , %sceneObjectToEffect , %TypeMasks);

int decalManagerAddDecal | ( | Point3F | position,
 |  | Point3F | normal,
 |  | float | rot,
 |  | float | scale,
 |  | DecalData | decalData,
 |  | bool | isImmortal = false
 | ) |  |

Adds a new decal to the decal manager.

Parameters:
position | Position for new decal to be placed.
normal | Up vector for the decal. Like the axel for this decal.
rot | Distance for this decal to be rotated around the normal, like a tire on an axel.
scale | Physical scale of new decal.
decalData | DecalData Datablock to use for the new decal.
isImmortal | Whether or not this decal is immortal. If immortal, it does not age and must be removed explicitly.
Returns:
Returns the ID of the new decal object or -1 on failure.
Example:
// Specify the decal position
%position = "1.0 1.0 1.0";

// Specify the up vector
%normal = "0.0 0.0 1.0";

// Specify the rotation for the decal
%rotation = "0.5";

// Specify the scale for the decal
%scale = "0.35";

// Specify the decalData datablock to use for this new decal
%decalData = "decalDatablockName";

// Specify if this decal is immortal. Immortal decals don't age and must be removed explicitly.
%immortal = "false";

// Tell the decal manager to remove all existing decals.
decalManagerAddDecal( %position, %normal, %rotation, %scale, %decalData, %immortal);
void decalManagerClear ( )

Removes all decals currently loaded in the decalManager.

Example:
// Tell the decal manager to remove all existing decals.
decalManagerClear();
bool decalManagerDirty ( )

Returns if the decal manager has unsaved modifications.

Returns:
True if the decal manager has unsaved modifications, false if everything has been saved.
Example:
// Ask the decal manager if it has unsaved modifications.
%hasUnsavedModifications = decalManagerDirty();
bool decalManagerLoad ( string fileName )

Loads the decals from the entered filename.

Parameters:
fileName Filename to load the decals from.
Returns:
True if the decal manager was able to load the requested file, false if it could not.
Example:
// Set the filename to load the decals from.
%fileName = "./missionDecals.mis.decals";
// Inform the decal manager to load the decals from the entered filename.
decalManagerLoad(%fileName);
bool decalManagerRemoveDecal ( int decalID )

Remove specified decal from the scene.

Returns:
Returns true if successful, false if decal not found.
Parameters:
decalID Entry ID of the decal to remove.
Example:
// Specify a decal ID to be removed
%decalID = 1;

// Tell the decal manager to remove the specified decal ID.
decalManagerRemoveDecal( %decalId )
void decalManagerSave ( String decalSaveFile = "" )

Saves the decals for the active mission in the entered filename.

Parameters:
decalSaveFile Filename to save the decals at.
Example:
// Set the filename to save the decals in. If no filename is set, then the decals will
   default to <activeMissionName>.mis.decals
%fileName = "./missionDecals.mis.decals";
// Inform the decal manager to save the decals for the active mission.
decalManagerSave(%fileName);

Variable Documentation

bool $Decals::debugRender

If true, the decal spheres will be visualized when in the editor.

bool $pref::Decals::enabled

Whether decals are currently enabled or not.

float $pref::Decals::lifeTimeScale

Lifetime that decals will last after being created in the world.

bool $Decals::poolBuffers

If true, will merge all PrimitiveBuffers and VertexBuffers into a pair of pools before clearing them at the end of a frame.

If false, will just clear them at the end of a frame.

float $Decals::sphereDistanceTolerance

The distance at which the decal system will start breaking up decal spheres when adding new decals.

float $Decals::sphereRadiusTolerance

The radius beyond which the decal system will start breaking up decal spheres when adding new decals.


Torque 3D - Script Manual: Vehicles

Vehicles
[Game]

This section is dedicated to vehicle game objects, such as the base Vehicle class, WheeledVehicle, FlyingVehicle, and so on. More...

Classes

class | FlyingVehicle
A flying vehicle. More...
class | FlyingVehicleData
Defines the properties of a FlyingVehicle. More...
class | HoverVehicle
A hovering vehicle. More...
class | HoverVehicleData
Defines the properties of a HoverVehicle. More...
class | Vehicle
Base functionality shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle. More...
class | VehicleData
Base properties shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle. More...
class | WheeledVehicle
A wheeled vehicle. More...
class | WheeledVehicleData
Defines the properties of a WheeledVehicle. More...
class | WheeledVehicleSpring
Defines the properties of a WheeledVehicle spring. More...
class | WheeledVehicleTire
Defines the properties of a WheeledVehicle tire. More...

Detailed Description

This section is dedicated to vehicle game objects, such as the base Vehicle class, WheeledVehicle, FlyingVehicle, and so on.


Torque 3D - Script Manual: Input Management

Input Management

Functions and classes relating to to user input. More...

Classes

class | ActionMap
ActionMaps assign platform input events to console commands. More...

Modules

Input Event Listing

List of all possible input events that can be mapped.

Functions

void | activateDirectInput ()
Activates DirectInput.
void | deactivateDirectInput ()
Disables DirectInput.
void | disableJoystick ()
Disables use of the joystick.
void | disableXInput ()
Disables XInput for Xbox 360 controllers.
void | echoInputState ()
Prints information to the console stating if DirectInput and a Joystick are enabled and active.
bool | enableJoystick ()
Enables use of the joystick.
bool | enableXInput ()
Enables XInput for Xbox 360 controllers.
ActionMap getCurrentActionMap ()
Returns the current ActionMap.
int | getXInputState (int controllerID, string property, bool current)
Queries the current state of a connected Xbox 360 controller.
bool | isJoystickEnabled ()
Queries input manager to see if a joystick is enabled.
bool | isXInputConnected (int controllerID)
Checks to see if an Xbox 360 controller is connected.
void | lockMouse (bool isLocked)
Lock or unlock the mouse to the window.
void | resetXInput ()
Rebuilds the XInput section of the InputManager.
void | rumble (string device, float xRumble, float yRumble)
Activates the vibration motors in the specified controller.

Detailed Description

Functions and classes relating to to user input.

Input events come from the OS, are translated in the platform layer and then posted to the game. By default the game then checks the input event against a global ActionMap (which supercedes all other action handlers). If there is no action specified for the event, it is passed on to the GUI system. If the GUI does not handle the input event it is passed to the currently active (non-global) ActionMap stack.

Example: the user presses the ~ (tilde) key, which is bound in the global ActionMap to toggleConsole.

This causes the console function associated with the bind to be executed, which in this case is toggleConsole, resulting in the console output window being shown. If the key had not been bound in the global map, it would have passed to the first gui that could have handled it, and if none did, it would pass to any game actions that were bound to that key.

See also:
ActionMap

Function Documentation

void activateDirectInput ( )

Activates DirectInput.

Also activates any connected joysticks.

void deactivateDirectInput ( )

Disables DirectInput.

Also deactivates any connected joysticks.

void disableJoystick ( )

Disables use of the joystick.

Note:
DirectInput must be enabled and active to use this function.
void disableXInput ( )

Disables XInput for Xbox 360 controllers.

void echoInputState ( )

Prints information to the console stating if DirectInput and a Joystick are enabled and active.

bool enableJoystick ( )

Enables use of the joystick.

Note:
DirectInput must be enabled and active to use this function.
bool enableXInput ( )

Enables XInput for Xbox 360 controllers.

Note:
XInput is enabled by default. Disable to use an Xbox 360 Controller as a joystick device.
ActionMap getCurrentActionMap ( )

Returns the current ActionMap.

See also:
ActionMap
int getXInputState | ( | int | controllerID,
 |  | string | property,
 |  | bool | current
 | ) |  |

Queries the current state of a connected Xbox 360 controller.

XInput Properties:

  • XI_THUMBLX, XI_THUMBLY - X and Y axes of the left thumbstick.
  • XI_THUMBRX, XI_THUMBRY - X and Y axes of the right thumbstick.
  • XI_LEFT_TRIGGER, XI_RIGHT_TRIGGER - Left and Right triggers.
  • SI_UPOV, SI_DPOV, SI_LPOV, SI_RPOV - Up, Down, Left, and Right on the directional pad.
  • XI_START, XI_BACK - The Start and Back buttons.
  • XI_LEFT_THUMB, XI_RIGHT_THUMB - Clicking in the left and right thumbstick.
  • XI_LEFT_SHOULDER, XI_RIGHT_SHOULDER - Left and Right bumpers.
  • XI_A, XI_B , XI_X, XI_Y - The A, B, X, and Y buttons.
Parameters:
controllerID | Zero-based index of the controller to return information about.
property | Name of input action being queried, such as "XI_THUMBLX".
current | True checks current device in action.
Returns:
Button queried - 1 if the button is pressed, 0 if it's not.
Thumbstick queried - Int representing displacement from rest position.
Trigger queried - Int from 0 to 255 representing how far the trigger is displaced.
bool isJoystickEnabled ( )

Queries input manager to see if a joystick is enabled.

Returns:
1 if a joystick exists and is enabled, 0 if it's not.
bool isXInputConnected ( int controllerID )

Checks to see if an Xbox 360 controller is connected.

Parameters:
controllerID Zero-based index of the controller to check.
Returns:
1 if the controller is connected, 0 if it isn't, and 205 if XInput hasn't been initialized.
void lockMouse ( bool isLocked )

Lock or unlock the mouse to the window.

When true, prevents the mouse from leaving the bounds of the game window.

void resetXInput ( )

Rebuilds the XInput section of the InputManager.

Requests a full refresh of events for all controllers. Useful when called at the beginning of game code after actionMaps are set up to hook up all appropriate events.

void rumble | ( | string | device,
 |  | float | xRumble,
 |  | float | yRumble
 | ) |  |

Activates the vibration motors in the specified controller.

The controller will constantly at it's xRumble and yRumble intensities until changed or told to stop.Valid inputs for xRumble/yRumble are [0 - 1].

Parameters:
device | Name of the device to rumble.
xRumble | Intensity to apply to the left motor.
yRumble | Intensity to apply to the right motor.
Note:
in an Xbox 360 controller, the left motor is low-frequency, while the right motor is high-frequency.


Torque 3D - Script Manual: Input Event Listing

Input Event Listing
[Input Management]

List of all possible input events that can be mapped. More...

List of all possible input events that can be mapped.

The following table represents all keyboard, mouse, and joystick input events available to stock Torque 3D. It should be noted that letter and number keys directly correlate to their mapping. For example "a" is literally the letter a. The button0, button1, and button2 are the most commonly used input mappings for left mouse button, right mouse button, and middle mouse button (respectively).

Keyboard General Events
Event Name | Event Name | Event Name | Event Name
Note: All general keys can be bound by simply using the key... ex. "u" will trigger the u key response.
backspace | end | win_apps | tilde
tab | home | cmd | minus
return | left | opt | equals
enter | up | lopt | lbracket
shift | right | ropt | rbracket
ctrl | down | numlock | backslash
alt | print | scrolllock | semicolon
pause | insert | rshift | apostrophe
capslock | delete | lcontrol | comma
escape | help | rcontrol | period
space | win_lwindow | lalt | slash
pagedown | win_rwindow | ralt | lessthan
pageup |  |  |
Keyboard Numpad Events
Event Name | Event Name | Event Name | Event Name
numpad0 | numpad5 | numpad9 | numpadminus
numpad1 | numpad6 | numpadadmult | numpaddecimal
numpad2 | numpad7 | numpadadd | numpaddivide
numpad3 | numpad8 | numpadsep | numpadenter
numpad4 |  |  |
Keyboard Function Key Events
Event Name | Event Name | Event Name | Event Name
f1 | f7 | f13 | f19
f2 | f8 | f14 | f20
f3 | f9 | f15 | f21
f4 | f10 | f16 | f22
f5 | f11 | f17 | f23
f6 | f12 | f18 | f24
Joystick/Mouse Events
Event Name | Event Name | Event Name | Event Name
button0 | button8 | button16 | button24
button1 | button9 | button17 | button25
button2 | button10 | button18 | button26
button3 | button11 | button19 | button27
button4 | button12 | button20 | button28
button5 | button13 | button21 | button29
button6 | button14 | button22 | button30
button7 | button15 | button23 | button31
Joystick/Mouse Axes
Event Name | Event Name | Event Name | Event Name
xaxis | zaxis | ryaxis | slider
yaxis | rxaxis | rzaxis |
Joystick POV
Event Name | Event Name | Event Name | Event Name
xpov | dpov | xpov2 | dpov2
ypov | lpov | ypov2 | lpov2
upov | rpov | upov2 | rpov2
Miscellaneous Events
Event Name | Event Name |  |
anykey | nomatch |  |
See also:
ActionMap


Torque 3D - Script Manual: Networking

Networking

Classes and functions related Torque 3D networking. More...

Classes

class | AIClient
Simulated client driven by AI commands. More...
class | AIConnection
Special client connection driven by an AI, rather than a human. More...
class | GameConnection
The game-specific subclass of NetConnection. More...
class | NetConnection
Provides the basis for implementing a multiplayer game protocol. More...
class | NetObject
Superclass for all ghostable networked objects. More...
class | SimpleMessageEvent
A very simple example of a network event used by SimpleNetObject. More...
class | SimpleNetObject
A very simple example of a class derived from NetObject. More...

Functions

string | addTaggedString (string str)
Use the addTaggedString function to tag a new string and add it to the NetStringTable.
string | buildTaggedString (string format,...)
Build a tagged string using the specified format.
void | closeNetPort ()
Closes the current network port.
void | commandToClient (NetConnection client, string func,...)
Send a command from the server to the client.
void | commandToServer (string func,...)
Send a command to the server.
string | detag (string str)
Returns the string from a tag string.
void | DNetSetLogging (bool enabled)
Enables logging of the connection protocols.
void | dumpNetStats ()
Dumps network statistics for each class to the console.
void | dumpNetStringTable ()
Dump the current contents of the networked string table to the console.
string | getTag (string textTagString)
Extracts the tag from a tagged string.
string | getTaggedString (int tag)
Use the getTaggedString function to convert a tag to a string.
void | removeTaggedString (int tag)
Remove a tagged string from the Net String Table.
bool | setNetPort (int port, bool bind=true)
Set the network port for the game to use. If bind is true, bind()will be called on the port.

Variables

int | $pref::Net::LagThreshold
How long between received packets before the client is considered as lagging.
int | $Stats::netBitsReceived
The number of bytes received during the last packet process operation.
int | $Stats::netBitsSent
The number of bytes sent during the last packet send operation.
int | $Stats::netGhostUpdates
The total number of ghosts added, removed, and/or updated on the client during the last packet process operation.
int | $pref::Net::PacketRateToClient
Sets how often packets are sent from the server to a client.
int | $pref::Net::PacketRateToServer
Sets how often packets are sent from the client to the server.
int | $pref::Net::PacketSize
Sets the maximum size in bytes an individual network packet may be.

Callbacks

void | onDataBlockObjectReceived (int index, int total)
Called on the client each time a datablock has been received.
void | onLightManagerActivate (string name)
A callback called by the engine when a light manager is activated.
void | onLightManagerDeactivate (string name)
A callback called by the engine when a light manager is deactivated.

Detailed Description

Classes and functions related Torque 3D networking.

Overview

Torque was designed from the foundation up to offer robust client/server networked simulations.

Performance over the internet drove the design for the networking model. Torque attempts to deal with three fundamental problems of network simulation programming: limited bandwidth, packet loss and latency.

An instance of Torque can be set up as a dedicated server, a client, or both a client and a server. If the game is a client and a server, it still behaves as a client connected to a server - instead of using the network, however, the NetConnection object has a short-circuit link to another NetConnection object in the same application instance. This is known as a local connection.

Bandwidth is a problem because in the large, open environments that Torque allows, and with the large number of clients that the engine supports (depending on amount of data sent per client, game world complexity, and available bandwidth), potentially many different objects can be moving and updating at once. Torque uses three main strategies to maximize available bandwidth. First, it prioritizes data, sending updates to what is most "important" to a client at a greater frequency than it updates data that is less important. Second, it sends only data that is necessary. Using the BitStream class, only the absolute minimum number of bits needed for a given piece of data will be sent. Also, when object state changes, Torque only sends the part of the object state that changed. Last, Torque caches common strings (NetStringTable) and data (SimDataBlock) so that they only need to be transmitted once.

Packet loss is a problem because the information in lost data packets must somehow be retransmitted, yet in many cases the data in the dropped packet, if resent directly, will be stale by the time it gets to the client. For example, suppose that packet 1 contains a position update for a player and packet 2 contains a more recent position update for that same player. If packet 1 is dropped but packet 2 makes it across to the client, the engine shouldn't resend the data that was in packet 1. It is older than the version that was received by the client. In order to minimize data that gets resent unnecessarily, the engine classifies data into four groups:

  • Unguaranteed Data (NetEvent) - if this data is lost, don't re-transmit it. An example of this type of data could be real-time voice traffic. By the time it is resent subsequent voice segments will already have played.
  • Guaranteed Data (NetEvent) - if this data is lost, resend it. Chat messages, messages for players joining and leaving the game and mission end messages are all examples of guaranteed data.
  • Most-Recent State Data (NetObject) - Only the most current version of the data is important. If an update is lost, send the current state, unless it has been sent already.
  • Guaranteed Quickest Data (Move) - critical data that must get through as soon as possible.

Latency is a problem in the simulation because the network delay in information transfer (which, for modems, can be up to a quarter of a second or more) makes the client's view of the world perpetually out-of-sync with the server. Twitch FPS games, for which Torque was initially designed, require instant control response in order to feel anything but sluggish. Also, fast moving objects can be difficult for highly latent players to hit. In order to solve these problems Torque employs several strategies:

  • Interpolation is used to smoothly move an object from where the client thinks it is to where the server says it is.
  • Extrapolation is used to guess where the object is going based on its state and rules of movement.
  • Prediction is used to form an educated guess about where an object is going based on rules of movement and client input.

The network architecture is layered: at the bottom is the platform layer, above that the notify protocol layer, followed by the NetConnection object and event management layer.

On Ghosting and Scoping

Ghosting is the most complex, and most powerful, part of Torque's networking capabilities.

It allows the information sent to clients to be very precisely matched to what they need, so that no excess bandwidth is wasted. The control object's onCameraScopeQuery() is called, to determine scoping information for the client; then objects which are in scope are then transmitted to the client, prioritized by the results of their getPriority() method.

There is a cap on the maximum number of ghosts; ghost IDs are currently sent via a 12-bit field, ergo, there is a cap of 4096 objects ghosted per client. This can be easily raised; see the GhostConstants enum.

Each object ghosted is assigned a ghost ID; the client is only aware of the ghost ID. This acts to enhance game security, as it becomes difficult to map objects from one connection to another, or to reliably identify objects from ID alone. IDs are also reassigned based on need, making it hard to track objects that have fallen out of scope (as any object which the player shouldn't see would).

resolveGhostID() is used on the client side, and resolveObjectFromGhostIndex() on the server side, to turn ghost IDs into object references. getGhostID() is used in the other direction to determine an object's ghost ID based on its SimObject ID.

The NetConnection is a SimGroup. On the client side, it contains all the objects which have been ghosted to that client. On the server side, it is empty; it can be used (typically in script) to hold objects related to the connection. For instance, you might place an observation camera in the NetConnnection. In both cases, when the connection is destroyed, so are the contained objects.

See also:
NetConnection, the basis for implementing a multiplayer game protocol. Also see NetObject, which is the superclass for ghostable objects, and ShapeBase, which is the base for player and vehicle classes.

Local Connections

It is possible to run both the server and client within the same process.

This is typically done while developing your game, and is often required when using Torque's built-in world creation tools. This is known as a local connection.

Any time a player launches the game and chooses to host a mission, they are also making use of a local connection (all other players joining the game use a regular, networked connection). A local connection is also used when building a single player game.

Internally, a local connection short-circuits the networking layer and allows for data to pass immediately between the internal server and client. However, it should be noted that there is still the additional overhead of having seperate server and client branches within the code, even when creating a single player game. When developing your single player game, you need to be mindful that a client and server still exist within the engine.

See also:
NetConnection, the basis for implementing a multiplayer game protocol.

Function Documentation

string addTaggedString ( string str )

Use the addTaggedString function to tag a new string and add it to the NetStringTable.

Parameters:
str The string to tagged and placed in the NetStringTable. Tagging ignores case, so tagging the same string (excluding case differences) will be ignored as a duplicated tag.
Returns:
Returns a string( containing a numeric value) equivalent to the string ID for the newly tagged string
See also:
Data Types
string buildTaggedString | ( | string | format,
 |  |  | ...
 | ) |  |

Build a tagged string using the specified format.

See also:
Data Types
void closeNetPort ( )

Closes the current network port.

void commandToClient | ( | NetConnection | client,
 |  | string | func,
 |  |  | ...
 | ) |  |

Send a command from the server to the client.

Parameters:
client | The numeric ID of a client gameConnection
func | Name of the client function being called
... Various parameters being passed to client command
Example:
// Set up the client command
// Update the Ammo Counter with current ammo, if not any then hide the counter.
function clientCmdSetAmmoAmountHud(%amount)
{
   if (!%amount)
     AmmoAmount.setVisible(false);
   else
   {
     AmmoAmount.setVisible(true);
     AmmoAmount.setText("Ammo: "@%amount);
   }
}
// Call it from a server function
function GameConnection::setAmmoAmountHud(%client, %amount)
{
   commandToClient(%client, 'SetAmmoAmountHud', %amount);
}

void commandToServer | ( | string | func,
 |  |  | ...
 | ) |  |

Send a command to the server.

Parameters:
func Name of the server command being called
... Various parameters being passed to server command
Example:
// Create a standard function
function toggleCamera(%val)
{
   // If key was down, call a server command named 'ToggleCamera'
   if (%val)
      commandToServer('ToggleCamera');
}

// Server command being called from above
function serverCmdToggleCamera(%client)
{
   if (%client.getControlObject() == %client.player)
   {
     %client.camera.setVelocity("0 0 0");
     %control = %client.camera;
   }
   else
   {
     %client.player.setVelocity("0 0 0");
     %control = %client.player;
  }
   %client.setControlObject(%control);
   clientCmdSyncEditorGui();
}
string detag ( string str )

Returns the string from a tag string.

See also:
Data Types
void DNetSetLogging ( bool enabled )

Enables logging of the connection protocols.

Parameters:
enabled True to enable, false to disable
void dumpNetStats ( )

Dumps network statistics for each class to the console.

Note:
This method only works when TORQUE_NET_STATS is defined in torqueConfig.h.
void dumpNetStringTable ( )

Dump the current contents of the networked string table to the console.

Note:
This function is available only in debug builds.
string getTag ( string textTagString )

Extracts the tag from a tagged string.

See also:
Data Types
string getTaggedString ( int tag )

Use the getTaggedString function to convert a tag to a string.

This is not the same as detag() which can only be used within the context of a function that receives a tag. This function can be used any time and anywhere to convert a tag to a string.

Parameters:
tag A numeric tag ID.
See also:
Data Types
void onDataBlockObjectReceived | ( | int | index,
 |  | int | total
 | ) |  |

Called on the client each time a datablock has been received.

This callback is typically used to notify the player of how far along in the datablock download process they are.

Parameters:
index | The index of the datablock just received.
total | The total number of datablocks to be received.
See also:
GameConnection, GameConnection::transmitDataBlocks(), GameConnection::onDataBlocksDone()
void onLightManagerActivate ( string name )

A callback called by the engine when a light manager is activated.

Parameters:
name The name of the light manager being activated.
void onLightManagerDeactivate ( string name )

A callback called by the engine when a light manager is deactivated.

Parameters:
name The name of the light manager being deactivated.
void removeTaggedString ( int tag )

Remove a tagged string from the Net String Table.

Parameters:
tag The tag associated with the string
See also:
Data Types
bool setNetPort | ( | int | port,
 |  | bool | bind = true
 | ) |  |

Set the network port for the game to use. If bind is true, bind()will be called on the port.

This will trigger a windows firewall prompt. If you don't have firewall tunneling tech you can set this to false to avoid the prompt.

Variable Documentation

int $pref::Net::LagThreshold

How long between received packets before the client is considered as lagging.

This is used by GameConnection to determine if the client is lagging. Its value is in ms. If the client is indeed lagging, setLagIcon() is called to inform the user in some way. i.e. display an icon on screen.

See also:
GameConnection, GameConnection::setLagIcon()
int $Stats::netBitsReceived

The number of bytes received during the last packet process operation.

int $Stats::netBitsSent

The number of bytes sent during the last packet send operation.

int $Stats::netGhostUpdates

The total number of ghosts added, removed, and/or updated on the client during the last packet process operation.

int $pref::Net::PacketRateToClient

Sets how often packets are sent from the server to a client.

It is possible to control how often packets may be sent to the clients. This may be used to throttle the amount of bandwidth being used, but should be adjusted with caution.

The actual formula used to calculate the delay between sending packets to a client is:

Packet Update Delay To Client = 1024 / $pref::Net::PacketRateToClient

with the result in ms. A minimum rate of 1 is enforced in the source code. The default value is 10.

Note:
When using a local connection (Local Connections) be aware that this variable is always forced to 128.
int $pref::Net::PacketRateToServer

Sets how often packets are sent from the client to the server.

It is possible to control how often packets may be sent to the server. This may be used to throttle the amount of bandwidth being used, but should be adjusted with caution.

The actual formula used to calculate the delay between sending packets to the server is:

Packet Update Delay To Server = 1024 / $pref::Net::PacketRateToServer

with the result in ms. A minimum rate of 8 is enforced in the source code. The default value is 32.

Note:
When using a local connection (Local Connections) be aware that this variable is always forced to 128.
int $pref::Net::PacketSize

Sets the maximum size in bytes an individual network packet may be.

It is possible to control how large each individual network packet may be. Increasing its size from the default allows for more data to be sent on each network send. However, this value should be changed with caution as too large a value will cause packets to be split up by the networking platform or hardware, which is something Torque cannot handle.

A minimum packet size of 100 bytes is enforced in the source code. There is no enforced maximum. The default value is 200 bytes.

Note:
When using a local connection (Local Connections) be aware that this variable is always forced to 1024 bytes.


Torque 3D - Script Manual: Platform

Platform

Classes

class | HTTPObject
Allows communications between the game and a server using HTTP protocols. More...
class | RigidShape
The RigidShape class implements rigid-body physics for DTS objects in the world. More...
class | RigidShapeData
Defines the physics properties for an individual RigidShapeData physics object. More...
class | TCPObject
Allows communications between the game and a server using TCP/IP protocols. More...

Modules

Localization

Classes and functions related Torque 3D networking.

Mac

Functionality exclusive to Torque on OSX.

Windows

Functionality exclusive to Torque on Windows.

Enumerations

enum MBButtons {
Ok,
OkCancel,
RetryCancel,
SaveDontSave,
SaveDontSaveCancel
}

Which buttons to display on a message box.

More...
enum MBIcons {
Information,
Warning,
Stop,
Question
}

What icon to show on a message box.

More...
enum MBReturnVal {
OK,
Cancelled,
Retry,
DontSave
}

Return value for messageBox() indicating which button was pressed by the user.

More...

Functions

void | TCPObject::connect (string address)
Connect to the given address.
void | TCPObject::disconnect ()
Disconnect from whatever this TCPObject is currently connected to, if anything.
bool | displaySplashWindow ()
Display a startup splash window suitable for showing while the engine still starts up.
int | getRealTime ()
Return the current real time in milliseconds.
int | getSimTime ()
Sim time is time since the game started.
bool | getWebDeployment ()
Test whether Torque is running in web-deployment mode.
void | gotoWebPage (string address)
Open the given URL or file in the user's web browser.
bool | isDebugBuild ()
Test whether the engine has been compiled with TORQUE_DEBUG, i.e. if it includes debugging functionality.
bool | isShippingBuild ()
Test whether the engine has been compiled with TORQUE_SHIPPING, i.e. in a form meant for final release.
bool | isToolBuild ()
Test whether the engine has been compiled with TORQUE_TOOLS, i.e. if it includes tool-related functionality.
void | TCPObject::listen (int port)
Start listening on the specified port for connections.
int | messageBox (string title, string message, MBButtons buttons=MBOkCancel, MBIcons icons=MIInformation)
Display a modal message box using the platform's native message box implementation.
void | playJournal (string filename)
Begin playback of a journal from a specified field.
void | quit ()
Shut down the engine and exit its process.
void | quitWithErrorMessage (string message)
Display an error message box showing the given message and then shut down the engine and exit its process.
void | saveJournal (string filename)
Save the journal to the specified file.
void | TCPObject::send (string data)
Transmits the data string to the server.
bool | shellExecute (string executable, string args, string directory)
Launches an outside executable or batch file.

Variables

const int | $MRCancel
Determines the cancel button press state in a message box.
const int | $MRDontSave
Determines the don't save button press state in a message box.
const int | $MROk
Determines the ok button press state in a message box.
const int | $MRRetry
Determines the retry button press state in a message box.
int | $platform::backgroundSleepTime
Controls processor time usage when the game window is out of focus.
int | $platform::timeManagerProcessInterval
Controls processor time usage when the game window is in focus.

Detailed Description

Enumeration Type Documentation

enum MBButtons

Which buttons to display on a message box.

Enumerator:
Ok
OkCancel
RetryCancel
SaveDontSave
SaveDontSaveCancel
enum MBIcons

What icon to show on a message box.

Enumerator:
Information
Warning
Stop
Question
enum MBReturnVal

Return value for messageBox() indicating which button was pressed by the user.

Enumerator:
OK
Cancelled
Retry
DontSave

Function Documentation

void TCPObject::connect ( string address ) [inherited]

Connect to the given address.

Parameters:
address Server address to connect to.
Example:
// Set the address.
%address = "www.garagegames.com";

// Inform this TCPObject to connect to the specified address.
%thisTCPObj.connect(%address);
void TCPObject::disconnect ( ) [inherited]

Disconnect from whatever this TCPObject is currently connected to, if anything.

Example:
// Inform this TCPObject to disconnect from anything it is currently connected to.
%thisTCPObj.disconnect();
bool displaySplashWindow ( )

Display a startup splash window suitable for showing while the engine still starts up.

Note:
This is currently only implemented on Windows.
Returns:
True if the splash window could be successfully initialized.
int getRealTime ( )

Return the current real time in milliseconds.

Real time is platform defined; typically time since the computer booted.

int getSimTime ( )

Sim time is time since the game started.

Return the current sim time in milliseconds.

bool getWebDeployment ( )

Test whether Torque is running in web-deployment mode.

In this mode, Torque will usually run within a browser and certain restrictions apply (e.g. Torque will not be able to enter fullscreen exclusive mode).

Returns:
True if Torque is running in web-deployment mode.
void gotoWebPage ( string address )

Open the given URL or file in the user's web browser.

Parameters:
address The address to open. If this is not prefixed by a protocol specifier ("...://"), then the function checks whether the address refers to a file or directory and if so, prepends "file://" to adress; if the file check fails, "http://" is prepended to address.
Example:
gotoWebPage( "http://www.garagegames.com" );
bool isDebugBuild ( )

Test whether the engine has been compiled with TORQUE_DEBUG, i.e. if it includes debugging functionality.

Returns:
True if this is a debug build; false otherwise.
bool isShippingBuild ( )

Test whether the engine has been compiled with TORQUE_SHIPPING, i.e. in a form meant for final release.

Returns:
True if this is a shipping build; false otherwise.
bool isToolBuild ( )

Test whether the engine has been compiled with TORQUE_TOOLS, i.e. if it includes tool-related functionality.

Returns:
True if this is a tool build; false otherwise.
void TCPObject::listen ( int port ) [inherited]

Start listening on the specified port for connections.

Parameters:
port Port for this TCPObject to start listening for connections on.
Example:
// Set the port number list
%portNumber = 80;

// Inform this TCPObject to start listening at the specified port.
%thisTCPObj.send(%portNumber);

int messageBox | ( | string | title,
 |  | string | message,
 |  | MBButtons | buttons = MBOkCancel,
 |  | MBIcons | icons = MIInformation
 | ) |  |

Display a modal message box using the platform's native message box implementation.

Parameters:
title | The title to display on the message box window.
message | The text message to display in the box.
buttons | Which buttons to put on the message box.
icons | Which icon to show next to the message.
Returns:
One of $MROK, $MRCancel, $MRRetry, and $MRDontSave identifying the button that the user pressed.
Example:
messageBox( "Error", "" );
void playJournal ( string filename )

Begin playback of a journal from a specified field.

Parameters:
filename Name and path of file journal file
void quit ( )

Shut down the engine and exit its process.

This function cleanly uninitializes the engine and then exits back to the system with a process exit status indicating a clean exit.

See also:
quitWithErrorMessage
void quitWithErrorMessage ( string message )

Display an error message box showing the given message and then shut down the engine and exit its process.

This function cleanly uninitialized the engine and then exits back to the system with a process exit status indicating an error.

Parameters:
message The message to log to the console and show in an error message box.
See also:
quit
void saveJournal ( string filename )

Save the journal to the specified file.

void TCPObject::send ( string data ) [inherited]

Transmits the data string to the server.

Parameters:
data The data string to send back to the server.
Example:
// Set the command data
%data = ""GET " @ $RSSFeed::serverURL @ " HTTP/1.0
Host: " @ $RSSFeed::serverName @ "\nUser-Agent: " @ $RSSFeed::userAgent @ "\n\r\n\r\n""

// Send the command back to the active server.
%thisTCPObj.send(%data);

bool shellExecute | ( | string | executable,
 |  | string | args,
 |  | string | directory
 | ) |  |

Launches an outside executable or batch file.

Parameters:
executable | Name of the executable or batch file
args | Optional list of arguments, in string format, to pass to the executable
directory | Optional string containing path to output or shell

Variable Documentation

int $MRCancel

Determines the cancel button press state in a message box.

int $MRDontSave

Determines the don't save button press state in a message box.

int $MROk

Determines the ok button press state in a message box.

int $MRRetry

Determines the retry button press state in a message box.

int $platform::backgroundSleepTime

Controls processor time usage when the game window is out of focus.

int $platform::timeManagerProcessInterval

Controls processor time usage when the game window is in focus.


Torque 3D - Script Manual: Localization

Localization
[Platform]

Classes and functions related Torque 3D networking. More...

Classes

class | LangTable
Provides the code necessary to handle the low level management of the string tables for localization. More...

Functions

int | getCoreLangTable ()
Gets the primary LangTable used by the game.
void | setCoreLangTable (string LangTable)
Sets the primary LangTable used by the game.

Detailed Description

Classes and functions related Torque 3D networking.

Overview

Introduction

Localizing large applications can be an extremely time consuming and aggravating process. This manual is intended to guide you through the changes made to Torque to support localization and help you reduce the ongoing headaches in day-to-day development in a localized codebase.

This manual assumes you are at least familiar with Torque Script. C++ and localization experience is not necessary.

Languages and String Tables

Lets say you want to print some text to the console. From script, you’d usually just write something like:

echo("Hello, World!");

This is all well and good, if all you care about is English. What do you do if the user wants your game to talk French? You could do something like the following:

switch($Pref::Language)
{
   case $ENGLISH:
      echo("Hello, World!");
   case $FRENCH:
      echo("Salut, Monde!");
... other languages here ...
}

Sure, this works. It's also a complete pain in the backside to keep up to date, let alone that you'd have to repeat the switch for every string you use. In the C++ code alone there is upwards of 4000 strings that are candidates for localization, so this method is clearly not even close to an option.

String tables are the answer to this problem. A string table is an array of strings that you can reference based on an ID instead of specifying the string directly in the source code. Changing which language the string is displayed in is simply a matter of using a string table that contains the strings in the language you wish to display. The above example can be reduced down to the following:

echo(L($STR_HELLO_WORLD));

The code is not much different to how you wrote it before, but the string will now be displayed in the correct language based on the user's selection. This does come with a price, however. You now have to create and maintain string tables for all the languages you support, which can be a big headache. Torque tries to make this as simple as possible, and some tips for creating and maintaining these string tables are given later.

Script Interface

Torque contains a lot of strings, not just in the C++ code but in the script code too. For example, all your GUIs are created in script and must also be localized. To further complicate matters the scripts are contained in mod directories, each of which is a separate entity.

Strings in Script

It would be cumbersome and difficult to maintain one string table for all the strings, so Torque doesn't try. Each mod has it's own string table, as well as the core C++ code. You would be forgiven for thinking that this leads to having to write code as follows:

echo(L($StarterFPSTable, $STR_HELLO_WORLD));

I don't know about you, but I'm a lazy programmer and that's just too much typing for me to put up with every time I want to display a string. Instead, you just use:

echo(L($STR_HELLO_WORLD));

Torque takes care of the rest: the correct table will be used based on which mod the code is executed from.

Loading strings and specifying languages

The new LangTable class, accessible in script as well as in C++, provides the code necessary to handle the low level management of the string tables and obtaining the correct strings from them. One LangTable is created for each mod, as well as one for the C++ code.

An important portion of the localization system is implemented in script. This support code is responsible for managing the language tables and provides you with a simpler API than would be the case using LangTable directly. To provide this API, a new mod called "lang" has been added. The lang mod works a little like the common mod in that it just provides code needed by all mods. As the localization code is needed very early in the initialisation code, adding it to the common mod was not possible.

To ease loading of language tables, language maps are provided. These map the displayed name of the language to a string table on disk and are used to provide automatic loading across all mods. You specify the language map in the lang/languages.cs script, for example:

addLanguageMap("English", "english.lso");
addLanguageMap("Pony", "pony.lso");

The first argument to addLanguageMap() is the name of the language as it will be displayed to the user, and the second is the filename of the language. The filename will be concatenated onto the mod path to find the actual filename name of the table to load.

To load the language tables for the current mod, in the onStart() function for the mod, before any other code, use the following:

table = loadModLangTables("starter.fps/lang/tables");
setModLangTable(table);

loadModLangTables() loads the tables from the specified directory based on the information in the language map. setModLangTable() tells the C++ code to use the specified table for the current mod. This is usually done in the mod's onStart() function. After loading the tables, the current language will be set to English.

 // setup localization:
   $I18N::starter.fps = new LangTable();
   exec("starter.fps/lang/tables/German.cs");
   exec("starter.fps/lang/tables/English.cs");
   $I18N::starter.fps.addLanguage("starter.fps/lang/tables/German.lso", "German");
   $I18N::starter.fps.addLanguage("starter.fps/lang/tables/English.lso", "English");
   $I18N::starter.fps.setDefaultLanguage(0); // German is default here
   $I18N::starter.fps.setCurrentLanguage(0); // German is current
$I18N::starter.fps.setCurrentLanguage(1); // this would set the current language to english

Handling user language preferences

In the Torque demo, the user is provided two ways to change their language settings. If they have not already chosen a language, for example the first time they run the game, a dialog will pop up after the splash screens asking them to choose a language. The language can also be changed at any time from the options dialog. Note that some strings will not be in the new language until the game is restarted. There will be further discussion on this topic in later chapters.

When the language is changed, the onChangeLanguage() function is called. This should be overriden for each mod in the same way as onStart(). The following code can be used for all mods:

function onChangeLanguage()
{
   setCurrentLanguage(getModLangTable(), $pref::I18N::language);
   Parent::onChangeLanguage();
}

To change the language for all mods, you can simply use the setLanguage() function. setLanguage() takes one argument, the display name of the language to switch to.

Localizing the GUI

The GUI provides some interesting challenges for localization. Since GUI files are just script files that create the objects for the GUI, text is specified as a member field of the object. For example:

new GuiButtonCtrl() {
      text = "Quit!";
... other fields ...
};

As this is just a script, you can localize it easily by using the L() function in the same way you would with other scripts, for example:

new GuiButtonCtrl() {
      text = L($STR_QUIT);
... other fields ...
};

Unfortunately, this is not a viable solution. If you save that GUI from the GUI editor, the call to L() will be replaced with the text it returned when creating the GUI, reverting it to the first example. The only way around that is to edit all your GUIs by hand, which is not a particularly pleasant option when you have an editor to do it for you.

In order to sensibly support editing of GUIs, most of the GUI controls that support the text field now also support a textID field. This is the name of the ID variable for the string, for example:

new GuiButtonCtrl() {
      textID = "STR_QUIT";
... other fields ...
};

In addition, a setTextID() method was added to all controls that expose a setText() method to allow you to set the text at run time. It functions the same as the setText() method, except it works with IDs.

obj.setTextID("STR_ABOUT");

The only caveat is you must specify the name of the variable as a string, and not the variable itself. If you used the variable, for example obj.setText($STR_ABOUT), then the textID field would get set to the numeric ID, and the GUI control would be looking for a variable called, for example, 45.

If you don't specify an ID, or the ID you do specify is invalid for whatever reason, then the control will simply use the text field as before.

Specifying the language table

Unfortunately, there is not enough context available in the GUI system to determine which mod the control was defined in, so the tricks used to make the L() function work cannot be used in the GUI.

To work around the problem, a field was added to GuiControl to specify the table to use, called langTableMod, which is simply the name of the mod to get the language table from. Usually, this will be the same as the mod that the .gui file resides in.

To avoid having to specify the table for every control that needs it, a crude form of inheritance was implemented. If langTableMod is not specified for a control, the control's parent will be checked. This means you only have to specify the table in the root control for the GUI. However, you could also specify a different table on a per-control basis if needed, for example if you wanted to use a string from the language table for common. The following example GUI illustrates this better:

   // The value that you set langTableMod to is the same as name after "$I18N::". If you use "$I18N::bob" then langTableMod = "bob".
   new GuiChunkedBitmapCtrl(MainMenuGui) {
   profile = "GuiContentProfile";
   horizSizing = "width";
   vertSizing = "height";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 8";
   visible = "1";
   langTableMod = "starter.fps";
   bitmap = "./background";
   useVariable = "0";
   tile = "0";
      helpTag = "0";
   new GuiButtonCtrl() {
      profile = "GuiButtonProfile";
      horizSizing = "right";
      vertSizing = "top";
      position = "36 413";
      extent = "110 20";
      minExtent = "8 8";
      visible = "1";
      command = "quit();";
      textID = "STR_QUIT";
      groupNum = "-1";
      buttonType = "PushButton";
         helpTag = "0";
   };
};

Refreshing the GUI

When the user has chosen a new language, it would be nice to be able to get the GUI to refresh without forcing them to restart the game. One nice side effect of the updates to the GUI system is that we can do that.

The way the textID field was implemented is it checks for a valid ID, then if it has one it passes the string directly to setText(). The initial update of the text field is done on onWake(), so to get the control to update you only have to cause it to get an onWake() event.

It turns out that you can trick Torque into resending onWake() events quite simply, without having to write a ton of code. For the main canvas, you can simply do:

if(isObject(Canvas))
Canvas.setContent(Canvas.getContent());

When implementing the options dialog, I found that this wont refresh the dialogs. To work around that, when you click apply the script will pop the dialog then re-push it, as follows:

Canvas.popDialog(optionsDlg);
Canvas.pushDialog(optionsDlg);

Of course, some things will not be possible to update when you change the language. It may be worth considering requiring users to restart the game for language changes to take effect for the sake of consistency.

C++ Interface

The C++ interface is largely in flux at the moment pending fixing the string extractor to cope with multi-line strings. In terms of how you reference strings, it will be largely the same as the script interface.

Caveats

This will have caveats for the localization thingy.

The Localization Tools

The current toolset consists of the command line language compiler, called langc, which is used to compile a language file into the various formats needed by the engine.

Language Files

Language files are simple text files containing the identifiers and strings. An example follows:

TEST_STR_1=This is a test
TEST_STR_2=and so is this!

The string definitions are similar to variable definitions in C++ and Torque Script, except you do not need quotes or a semicolon. The "variable" becomes the ID as it will be referred to in the game code.

If you need the string to span multiple lines, you can use the usual
as you would in C++. Note that currently you can't use a trailing \ on the line to continue to the next line. (Note: this should be fixed)

You can use any amount of white space on either side of the equals sign. Two options control how the compiler handles whitespace. By default, any whitespace after the equals (leading spaces) will be stripped and any space on the end of the string (trailing spaces) will be left alone. Two options control this behaviour:

-S

Strip leading space. When this option is specified, any space after the = sign will become part of the string.

-T

Strip trailing space. When specified, space on the end of the string will be stripped. </tbody>

Comments may be inserted in the language file at the beginning of a line only. You can use #, ; or // to delimit comments. For example:

# This is a comment
; So is this
And this

Compiling Language Files

Before a language file can be used in the engine, it has to be compiled into a .lso file. As the process is slightly different depending on whether you are compiling the default english language file or a translation, it is not possible to do this automatically, as is done with scripts.

The default language is usually English. There is no hard and fast restriction on which language is the default, but for the purposes of documentation it will be assumed that English is your default language. It is worth pointing out that because strings that are missing from a particular language will use the default language, and some strings (particularly in the C++ code) are not localized, not using English for the default language may cause inconsistencies.

Language files are compiled with the langc tool, found in the tools directory. Like other Torque tools, langc must be compiled before you can use it.

langc can also produce some other related files, for example header files for the IDs and templates for translations.

In its simplest usage, langc requires the name of the language file to compile and an output basename, for example:

> langc english.lang english

The first argument is the name of the language file and the second is the basename for output files. langc can create a number of different files, so rather then force you to specify the filename of each one explicitly, you only have to specify the first part of the filename. The relevant extension will be added automatically.

If you were to run the above example, english.lang would be compiled, but no output files will be generated. This can be useful for checking if there are any errors in the file, but most of the time you'll want to produce some output files.

To compile the language to an lso, you use the -l option, as follows:

> langc -l english.lang english

This will compile english.lang and, assuming there were no errors, will produce english.lso, ready to load into the engine.

Identifiers

Earlier in this manual, global variables were used as identifiers for the strings, but there was no mention of where they came from. Because these are a pain in the backside to maintain, langc does the job for you. When you compile the english language file, you can also generate a script file containing global variables for each string ID in the language file.

To generate the script, simply use the -s option. For example:

> langc -s english.lang english

This will generate a file called english.cs. Using the earlier example .lang file, the generated script would look something like this:

// Automatically generated. DO NOT EDIT
This is a test
$TEST_STR_1 = 0;
and so is this!
$TEST_STR_2 = 1;

If you'd like to save some time, you can specify multiple options at once, as in the following example:

> langc -ls english.lang english

This will create both english.lso and english.cs.

Compiling Translations

Although translations compile to the same lso files as the default language, the process is slightly more involved. This is because the identifiers must come from the default english file to ensure they are correct.

You can create a template for a new translation, based on the english file, as follows:

> langc -r english.lang french

This will generate a file called french.tran, the format of which is identical to the .lang files described earlier.

# Automatically generated.
# [TEST_STR_1:0] This is a test
TEST_STR_1=
# [TEST_STR_2:1] and so is this!
TEST_STR_2=

The comments preceding each string definition are intended to tell the translator what the original english string was. The actual string definitions are left blank so that langc will issue a warning for empty, and thus untranslated, strings.

Compiling a translation requires a few more options then compiling the english file.

> langc -tl -e english.lang french.tran french

Here, -t tells langc you want to compile a translation, -e english.lang specifies the filename of the english translation and, as before, -l causes the .lso file to be compiled.

When the translation is loaded into the engine, any strings that are left empty will automatically fall back to the english version of them. By default, langc will issue a warning when compiling the file if a string is empty. This is useful while compiling translations to determine which strings have not been translated. However, it's less useful when compiling the english file, so these warnings may be turned off with the -W option. It is not recommended to use -W when compiling translations.

Other langc options

Aside from the above, langc provides a few additional options that you may find useful. These were purposefully not mentioned before as they are not particularly useful at this time.

A complete list of current langc options may be obtained by running langc with no arguments, as follows:

> langc
Usage: langc [options] <filename> <outbasename>
Where options is one or more of:
 -l    Write Language File              -h    Write C++ Header
 -s    Write Script                     -d    Write C++ Defaults
 -t    Compile a translation            -r    Write translation file
 -e <filename>   Specify english file when compiling translations
 -S    Don't strip leading spaces       -T    Strip trailing spaces
 -I    Don't warn for invalid chars     -W    Don't warn for empty identifiers
 -q    Quiet mode, no warnings at all

Of particular note are the options -h and -d, used when building files for the C++ localization. The -h option generates a C++ header file in the same way as the -s option does for scripts. The -d option writes a C++ source file that provides a big array of default strings. This is intended to be used as an extra fallback when a string can't be found in the language table (or when there is no language table), which allows the same executable to be used whether localization is active or not.

Identifiers must be valid variable names, as they are used directly both as script variables and C++ defines. By default, langc will warn you if an invalid character is used in an identifier. The -I option prevents this.

The -q option is simply a shortcut to disable all warnings at once. If any errors occur, they will still be displayed.

Function Documentation

          int getCoreLangTable
          (

           )

Gets the primary LangTable used by the game.

Returns:
ID of the core LangTable

          void setCoreLangTable
          (
          string
           LangTable
           )

Sets the primary LangTable used by the game.

Parameters:

 LangTable  ID of the core LangTable


Torque 3D - Script Manual: Mac

Mac
[Platform]

Functionality exclusive to Torque on OSX. More...

Functionality exclusive to Torque on OSX.


Torque 3D - Script Manual: Windows

Windows
[Platform]

Functionality exclusive to Torque on Windows. More...

Functionality exclusive to Torque on Windows.


Torque 3D - Script Manual: Rendering

Rendering

All rendering related functionality. More...

Classes

class | PostEffect
A fullscreen shader effect. More...
class | RenderMeshExample
An example scene object which renders a mesh. More...
class | RenderObjectExample
An example scene object which renders using a callback. More...
class | RenderShapeExample
An example scene object which renders a DTS. More...

Modules

Font

Various helpers for working with fonts from script.

GFX

The low level graphics interface to the engine.

Lighting

The script functionality related to the lighting systems and lights.

Render Binning

The render sorting and batching system.

Enumerations

enum PFXRenderTime {
PFXBeforeBin,
PFXAfterBin,
PFXAfterDiffuse,
PFXEndOfFrame,
PFXTexGenOnDemand
}

When to process this effect during the frame.

More...
enum PFXTargetClear {
PFXTargetClear_None,
PFXTargetClear_OnCreate,
PFXTargetClear_OnDraw
}

Describes when the target texture should be cleared.

More...

Functions

void | addGlobalShaderMacro (string name, string value=NULL)
Adds a global shader macro which will be merged with the script defined macros on every shader. The macro will replace the value of an existing macro of the same name. For the new macro to take effect all the shaders in the system need to be reloaded.
void | beginSampling (location,[backend])
Takes a string informing the backend where to store sample data and optionally a name of the specific logging backend to use. The default is the CSV backend. In most cases, the logging store will be a file name.
void | enableSamples (pattern,[state])
Enable sampling for all keys that match the given name pattern. Slashes are treated as separators.
int | getActiveDDSFiles ()
Returns the count of active DDSs files in memory.
String | getBitmapInfo (string filename)
Returns image info in the following format: width TAB height TAB bytesPerPixel. It will return an empty string if the file is not found.
void | initDisplayDeviceInfo ()
Initializes variables that track device and vendor information/IDs.
void | playJournalToVideo (string journalFile, string videoFile=NULL, string encoder="THEORA", float framerate=30.0f, Point2I resolution=Point2I(0, 0))
Load a journal file and capture it video.
void | removeGlobalShaderMacro (string name)
Removes an existing global macro by name.
void | startVideoCapture (GuiCanvas canvas, string filename, string encoder="THEORA", float framerate=30.0f, Point2I resolution=Point2I(0, 0))
Begins a video capture session.
void | stopSampling ()
Stops the rendering sampler.
void | stopVideoCapture ()
Stops the video capture session.

Variables

bool | $pref::imposter::canShadow
User preference which toggles shadows from imposters. Defaults to true.
float | $pref::TS::detailAdjust
User perference for scaling the TSShape level of detail. The smaller the value the closer the camera must get to see the highest LOD. This setting can have a huge impact on performance in mesh heavy scenes. The default value is 1.
bool | $Scene::disableTerrainOcclusion
Used to disable the somewhat expensive terrain occlusion testing.
bool | $Scene::disableZoneCulling
If true, zone culling will be disabled and the scene contents will only be culled against the root frustum.
int | $TSControl::frameCount
The number of frames that have been rendered since this control was created.
int | $pref::Reflect::frameLimitMS
ReflectionManager tries not to spend more than this amount of time updating reflections per frame.
int | $Sampler::frequency
Samples taken every nth frame.
bool | $Scene::lockCull
Debug tool which locks the frustum culling to the current camera location.
int | $pref::TS::maxInstancingVerts
Enables mesh instancing on non-skin meshes that have less that this count of verts. The default value is 200. Higher values can degrade performance.
int | $Scene::maxOccludersPerZone
Maximum number of occluders that will be concurrently allowed into the scene culling state of any given zone.
float | $Scene::occluderMinHeightPercentage
TODO.
float | $Scene::occluderMinWidthPercentage
TODO.
float | $pref::Reflect::refractTexScale
RefractTex has dimensions equal to the active render target scaled in both x and y by this float.
bool | $Scene::renderBoundingBoxes
If true, the bounding boxes of objects will be displayed.
int | $pref::TS::skipLoadDLs
User perference which causes TSShapes to skip loading higher lods. This potentialy reduces the GPU resources and materials generated as well as limits the LODs rendered. The default value is 0.
int | $pref::TS::skipRenderDLs
User perference which causes TSShapes to skip rendering higher lods. This will reduce the number of draw calls and triangles rendered and improve rendering performance when proper LODs have been created for your models. The default value is 0.
float | $pref::TS::smallestVisiblePixelSize
User perference which sets the smallest pixel size at which TSShapes will skip rendering. This will force all shapes to stop rendering when they get smaller than this size. The default value is -1 which disables it.
float | $pref::windEffectRadius
Radius to affect the wind.

Detailed Description

All rendering related functionality.

Enumeration Type Documentation

enum PFXRenderTime

When to process this effect during the frame.

Enumerator:
PFXBeforeBin

Before a RenderInstManager bin.

PFXAfterBin

After a RenderInstManager bin.

PFXAfterDiffuse

After the diffuse rendering pass.

PFXEndOfFrame

When the end of the frame is reached.

PFXTexGenOnDemand

This PostEffect is not processed by the manager. It will generate its texture when it is requested.

enum PFXTargetClear

Describes when the target texture should be cleared.

Enumerator:
PFXTargetClear_None

Never clear the PostEffect target.

PFXTargetClear_OnCreate

Clear once on create.

PFXTargetClear_OnDraw

Clear before every draw.

Function Documentation

void addGlobalShaderMacro | ( | string | name,
 |  | string | value = NULL
 | ) |  |

Adds a global shader macro which will be merged with the script defined macros on every shader. The macro will replace the value of an existing macro of the same name. For the new macro to take effect all the shaders in the system need to be reloaded.

See also:
resetLightManager, removeGlobalShaderMacro
void beginSampling ( location )

Takes a string informing the backend where to store sample data and optionally a name of the specific logging backend to use. The default is the CSV backend. In most cases, the logging store will be a file name.

Example:
beginSampling( "mysamples.csv" );
void enableSamples ( pattern )

Enable sampling for all keys that match the given name pattern. Slashes are treated as separators.

int getActiveDDSFiles ( )

Returns the count of active DDSs files in memory.

String getBitmapInfo ( string filename )

Returns image info in the following format: width TAB height TAB bytesPerPixel. It will return an empty string if the file is not found.

void initDisplayDeviceInfo ( )

Initializes variables that track device and vendor information/IDs.

void playJournalToVideo | ( | string | journalFile,
 |  | string | videoFile = NULL,
 |  | string | encoder = "THEORA",
 |  | float | framerate = 30.0f,
 |  | Point2I | resolution = Point2I(0, 0)
 | ) |  |

Load a journal file and capture it video.

void removeGlobalShaderMacro ( string name )

Removes an existing global macro by name.

See also:
addGlobalShaderMacro
void startVideoCapture | ( | GuiCanvas | canvas,
 |  | string | filename,
 |  | string | encoder = "THEORA",
 |  | float | framerate = 30.0f,
 |  | Point2I | resolution = Point2I(0, 0)
 | ) |  |

Begins a video capture session.

See also:
stopVideoCapture
void stopSampling ( )

Stops the rendering sampler.

void stopVideoCapture ( )

Stops the video capture session.

See also:
startVideoCapture

Variable Documentation

bool $pref::imposter::canShadow

User preference which toggles shadows from imposters. Defaults to true.

float $pref::TS::detailAdjust

User perference for scaling the TSShape level of detail. The smaller the value the closer the camera must get to see the highest LOD. This setting can have a huge impact on performance in mesh heavy scenes. The default value is 1.

bool $Scene::disableTerrainOcclusion

Used to disable the somewhat expensive terrain occlusion testing.

bool $Scene::disableZoneCulling

If true, zone culling will be disabled and the scene contents will only be culled against the root frustum.

int $TSControl::frameCount

The number of frames that have been rendered since this control was created.

int $pref::Reflect::frameLimitMS

ReflectionManager tries not to spend more than this amount of time updating reflections per frame.

int $Sampler::frequency

Samples taken every nth frame.

bool $Scene::lockCull

Debug tool which locks the frustum culling to the current camera location.

int $pref::TS::maxInstancingVerts

Enables mesh instancing on non-skin meshes that have less that this count of verts. The default value is 200. Higher values can degrade performance.

int $Scene::maxOccludersPerZone

Maximum number of occluders that will be concurrently allowed into the scene culling state of any given zone.

float $Scene::occluderMinHeightPercentage

TODO.

float $Scene::occluderMinWidthPercentage

TODO.

float $pref::Reflect::refractTexScale

RefractTex has dimensions equal to the active render target scaled in both x and y by this float.

bool $Scene::renderBoundingBoxes

If true, the bounding boxes of objects will be displayed.

int $pref::TS::skipLoadDLs

User perference which causes TSShapes to skip loading higher lods. This potentialy reduces the GPU resources and materials generated as well as limits the LODs rendered. The default value is 0.

See also:
$pref::TS::skipRenderDLs
int $pref::TS::skipRenderDLs

User perference which causes TSShapes to skip rendering higher lods. This will reduce the number of draw calls and triangles rendered and improve rendering performance when proper LODs have been created for your models. The default value is 0.

See also:
$pref::TS::skipLoadDLs
float $pref::TS::smallestVisiblePixelSize

User perference which sets the smallest pixel size at which TSShapes will skip rendering. This will force all shapes to stop rendering when they get smaller than this size. The default value is -1 which disables it.

float $pref::windEffectRadius

Radius to affect the wind.


Torque 3D - Script Manual: Font

Font
[Rendering]

Various helpers for working with fonts from script. More...

Functions

void | dumpFontCacheStatus ()
Dumps to the console a full description of all cached fonts, along with info on the codepoints each contains.
void | duplicateCachedFont (string oldFontName, int oldFontSize, string newFontName)
Copy the specified old font to a new name. The new copy will not have a platform font backing it, and so will never have characters added to it. But this is useful for making copies of fonts to add postprocessing effects to via exportCachedFont.
void | exportCachedFont (string faceName, int fontSize, string fileName, int padding, int kerning)
Export specified font to the specified filename as a PNG. The image can then be processed in Photoshop or another tool and reimported using importCachedFont. Characters in the font are exported as one long strip.
void | importCachedFont (string faceName, int fontSize, string fileName, int padding, int kerning)
Import an image strip from exportCachedFont. Call with the same parameters you called exportCachedFont.
void | populateAllFontCacheRange (int rangeStart, int rangeEnd)
Populate the font cache for all fonts with Unicode code points in the specified range.
void | populateAllFontCacheString (string string)
Populate the font cache for all fonts with characters from the specified string.
void | populateFontCacheRange (string faceName, int fontSize, int rangeStart, int rangeEnd)
Populate the font cache for the specified font with Unicode code points in the specified range.
void | populateFontCacheString (string faceName, int fontSize, string string)
Populate the font cache for the specified font with characters from the specified string.
void | writeFontCache ()
Force all cached fonts to serialize themselves to the cache.

Detailed Description

Various helpers for working with fonts from script.

Function Documentation

void dumpFontCacheStatus ( )

Dumps to the console a full description of all cached fonts, along with info on the codepoints each contains.

void duplicateCachedFont | ( | string | oldFontName,
 |  | int | oldFontSize,
 |  | string | newFontName
 | ) |  |

Copy the specified old font to a new name. The new copy will not have a platform font backing it, and so will never have characters added to it. But this is useful for making copies of fonts to add postprocessing effects to via exportCachedFont.

Parameters:
oldFontName | The name of the font face to copy.
oldFontSize | The size of the font to copy.
newFontName | The name of the new font face.
void exportCachedFont | ( | string | faceName,
 |  | int | fontSize,
 |  | string | fileName,
 |  | int | padding,
 |  | int | kerning
 | ) |  |

Export specified font to the specified filename as a PNG. The image can then be processed in Photoshop or another tool and reimported using importCachedFont. Characters in the font are exported as one long strip.

Parameters:
faceName | The name of the font face.
fontSize | The size of the font in pixels.
fileName | The file name and path for the output PNG.
padding | The padding between characters.
kerning | The kerning between characters.
void importCachedFont | ( | string | faceName,
 |  | int | fontSize,
 |  | string | fileName,
 |  | int | padding,
 |  | int | kerning
 | ) |  |

Import an image strip from exportCachedFont. Call with the same parameters you called exportCachedFont.

Parameters:
faceName | The name of the font face.
fontSize | The size of the font in pixels.
fileName | The file name and path for the input PNG.
padding | The padding between characters.
kerning | The kerning between characters.
void populateAllFontCacheRange | ( | int | rangeStart,
 |  | int | rangeEnd
 | ) |  |

Populate the font cache for all fonts with Unicode code points in the specified range.

Parameters:
rangeStart | The start Unicode point.
rangeEnd | The end Unicode point.
Note:
We only support BMP-0, so code points range from 0 to 65535.
void populateAllFontCacheString ( string string )

Populate the font cache for all fonts with characters from the specified string.

void populateFontCacheRange | ( | string | faceName,
 |  | int | fontSize,
 |  | int | rangeStart,
 |  | int | rangeEnd
 | ) |  |

Populate the font cache for the specified font with Unicode code points in the specified range.

Parameters:
faceName | The name of the font face.
fontSize | The size of the font in pixels.
rangeStart | The start Unicode point.
rangeEnd | The end Unicode point.
Note:
We only support BMP-0, so code points range from 0 to 65535.
void populateFontCacheString | ( | string | faceName,
 |  | int | fontSize,
 |  | string | string
 | ) |  |

Populate the font cache for the specified font with characters from the specified string.

Parameters:
faceName | The name of the font face.
fontSize | The size of the font in pixels.
string | The string to populate.
void writeFontCache ( )

Force all cached fonts to serialize themselves to the cache.


Torque 3D - Script Manual: GFX

GFX
[Rendering]

The low level graphics interface to the engine. More...

Classes

class | CubemapData
Used to create static or dynamic cubemaps. More...
class | DebugDrawer
A debug helper for rendering debug primitives to the scene. More...
class | GFXCardProfiler
Provides a device independent wrapper around both the capabilities reported by the card/drivers and the exceptions recorded in various scripts. More...
class | GFXCardProfilerAPI
This class is the interface between TorqueScript and GFXCardProfiler. More...
class | GFXInit
Functions for tracking GFX adapters and initializing them into devices. More...
class | GFXSamplerStateData
A sampler state used by GFXStateBlockData. More...
class | GFXStateBlockData
A state block description for rendering. More...
class | Material
A material in Torque 3D is a data structure that describes a surface. More...
class | PfxVis
Singleton class that exposes ConsoleStaticFunctions for debug visualizing PostEffects. More...
class | RenderFormatToken
Used to change the render target format when rendering in AL. More...

Modules

Materials

Classes, structures, functions, and variables related to Torque 3D's material system.

Shaders

Classes, structures, functions, and variables related to Torque 3D's shader system.

Enumerations

enum GFXAdapterType {
OpenGL,
D3D8,
D3D9,
NullDevice,
Xenon
}

Back-end graphics API used by the GFX subsystem.

More...
enum GFXBlend {
GFXBlendZero,
GFXBlendOne,
GFXBlendSrcColor,
GFXBlendInvSrcColor,
GFXBlendSrcAlpha,
GFXBlendInvSrcAlpha,
GFXBlendDestAlpha,
GFXBlendInvDestAlpha,
GFXBlendDestColor,
GFXBlendInvDestColor,
GFXBlendSrcAlphaSat
}

The supported blend modes.

More...
enum GFXBlendOp {
GFXBlendOpAdd,
GFXBlendOpSubtract,
GFXBlendOpRevSubtract,
GFXBlendOpMin,
GFXBlendOpMax
}

The blend operators.

More...
enum GFXCmpFunc {
GFXCmpNever,
GFXCmpLess,
GFXCmpEqual,
GFXCmpLessEqual,
GFXCmpGreater,
GFXCmpNotEqual,
GFXCmpGreaterEqual,
GFXCmpAlways
}

The supported comparison functions.

More...
enum GFXCullMode {
GFXCullNone,
GFXCullCW,
GFXCullCCW
}

The render cull modes.

More...
enum GFXFormat {
GFXFormatR8G8B8,
GFXFormatR8G8B8A8,
GFXFormatR8G8B8X8,
GFXFormatR32F,
GFXFormatR5G6B5,
GFXFormatR5G5B5A1,
GFXFormatR5G5B5X1,
GFXFormatA4L4,
GFXFormatA8L8,
GFXFormatA8,
GFXFormatL8,
GFXFormatDXT1,
GFXFormatDXT2,
GFXFormatDXT3,
GFXFormatDXT4,
GFXFormatDXT5,
GFXFormatD32,
GFXFormatD24X8,
GFXFormatD24S8,
GFXFormatD24FS8,
GFXFormatD16,
GFXFormatR32G32B32A32F,
GFXFormatR16G16B16A16F,
GFXFormatL16,
GFXFormatR16G16B16A16,
GFXFormatR16G16,
GFXFormatR16F,
GFXFormatR16G16F,
GFXFormatR10G10B10A2
}

The texture formats.

More...
enum GFXStencilOp {
GFXStencilOpKeep,
GFXStencilOpZero,
GFXStencilOpReplace,
GFXStencilOpIncrSat,
GFXStencilOpDecrSat,
GFXStencilOpInvert,
GFXStencilOpIncr,
GFXStencilOpDecr
}

The stencil operators.

More...
enum GFXTextureAddressMode {
GFXAddressWrap,
GFXAddressMirror,
GFXAddressClamp,
GFXAddressBorder,
GFXAddressMirrorOnce
}

The texture address modes.

More...
enum GFXTextureArgument {
GFXTADiffuse,
GFXTACurrent,
GFXTATexture,
GFXTATFactor,
GFXTASpecular,
GFXTATemp,
GFXTAConstant,
OneMinus,
AlphaReplicate
}

The texture arguments.

More...
enum GFXTextureFilterType {
GFXTextureFilterNone,
GFXTextureFilterPoint,
GFXTextureFilterLinear,
GFXTextureFilterAnisotropic,
GFXTextureFilterPyramidalQuad,
GFXTextureFilterGaussianQuad
}

The texture filter types.

More...
enum GFXTextureOp {
GFXTOPDisable,
GFXTOPSelectARG1,
GFXTOPSelectARG2,
GFXTOPModulate,
GFXTOPModulate2X,
GFXTOPModulate4X,
GFXTOPAdd,
GFXTOPAddSigned,
GFXTOPAddSigned2X,
GFXTOPSubtract,
GFXTOPAddSmooth,
GFXTOPBlendDiffuseAlpha,
GFXTOPBlendTextureAlpha,
GFXTOPBlendFactorAlpha,
GFXTOPBlendTextureAlphaPM,
GFXTOPBlendCURRENTALPHA,
GFXTOPPreModulate,
GFXTOPModulateAlphaAddColor,
GFXTOPModulateColorAddAlpha,
GFXTOPModulateInvAlphaAddColor,
GFXTOPModulateInvColorAddAlpha,
GFXTOPBumpEnvMap,
GFXTOPBumpEnvMapLuminance,
GFXTOPDotProduct3,
GFXTOPLERP
}

The texture operators.

More...
enum GFXTextureTransformFlags {
GFXTTFDisable,
GFXTTFFCoord1D,
GFXTTFFCoord2D,
GFXTTFFCoord3D,
GFXTTFFCoord4D,
GFXTTFProjected
}

The texture transform state flags.

More...
enum MaterialAnimType {
Scroll,
Rotate,
Wave,
Scale,
Sequence
}

The type of animation effect to apply to this material.

More...
enum MaterialBlendOp {
None,
Mul,
Add,
AddAlpha,
Sub,
LerpAlpha
}

The type of graphical blending operation to apply to this material.

More...
enum MaterialWaveType {
Sin,
Triangle,
Square
}

When using the Wave material animation, one of these Wave Types will be used to determine the type of wave to display.

More...

Functions

void | cleanupTexturePool ()
Release the unused pooled textures in texture manager freeing up video memory.
void | clearGFXResourceFlags ()
Clears the flagged state on all allocated GFX resources. See flagCurrentGFXResources for usage details.
void | describeGFXResources (string resourceTypes, string filePath, bool unflaggedOnly=false)
Dumps a description of GFX resources to a file or the console.
void | describeGFXStateBlocks (string filePath)
Dumps a description of all state blocks.
void | dumpRandomNormalMap ()
Creates a 64x64 normal map texture filled with noise. The texture is saved to randNormTex.png in the location of the game executable.
void | dumpTextureObjects ()
Dumps a list of all active texture objects to the console.
void | flagCurrentGFXResources ()
Flags all currently allocated GFX resources. Used for resource allocation and leak tracking by flagging current resources then dumping a list of unflagged resources at some later point in execution.
void | flushTextureCache ()
Releases all textures and resurrects the texture manager.
static int | GFXInit::getAdapterCount ()
Return the number of graphics adapters available.
GFXFormat getBestHDRFormat ()
Returns the best texture format for storage of HDR data for the active device.
Point3F | getDesktopResolution ()
Returns the width, height, and bitdepth of the screen/desktop.
string | getDisplayDeviceInformation ()
Get the string describing the active GFX device.
String | getDisplayDeviceList ()
Returns a tab-seperated string of the detected devices across all adapters.
float | getPixelShaderVersion ()
Returns the pixel shader version for the active device.
String | getTextureProfileStats ()
Returns a list of texture profiles in the format: ProfileName TextureCount TextureMB.
void | listGFXResources (bool unflaggedOnly=false)
Returns a list of the unflagged GFX resources. See flagCurrentGFXResources for usage details.
void | reloadTextures ()
Reload all the textures from disk.
void | screenShot (string file, string format, int tileCount=1, float tileOverlap=0)
Takes a screenshot with optional tiling to produce huge screenshots.
void | setPixelShaderVersion (float version)
Sets the pixel shader version for the active device. This can be used to force a lower pixel shader version than is supported by the device for testing or performance optimization.
void | setReflectFormat (GFXFormat format)
Set the reflection texture format.

Variables

bool | $gfx::disableOcclusionQuery
Debug helper that disables all hardware occlusion queries causing them to return only the visibile state.
bool | $pref::Video::disableVerticalSync
Disables vertical sync on the active device.
bool | $gfx::disassembleAllShaders
On supported devices this will dump shader disassembly to the procedural shader folder.
float | $pref::Video::forcedPixVersion
Will force the shader model if the value is positive and less than the shader model supported by the active device. Use 0 for fixed function.
int | $pref::Video::textureReductionLevel
The number of mipmap levels to drop on loaded textures to reduce video memory usage. It will skip any textures that have been defined as not allowing down scaling.
bool | $gfx::wireframe
Used to toggle wireframe rendering at runtime.

Detailed Description

The low level graphics interface to the engine.

In Torque the GFX layer provides access to abstracted low level graphics concepts. From script you have limited access to graphics rendering as it is usually too slow to do individual draw calls thru the scripting interface. For drawing its usually better to use the higher level gameplay objects.

Note:
Detailed technical descriptions of when to use specific GFXStateBlockData fields, how GFXBlendOp works, or other interfaces of that nature are outside the scope of this manual. Since Torque is based on DirectX and OpenGL any reference documents for those APIs will provide the background needed to learn about rendering.

Enumeration Type Documentation

enum GFXAdapterType

Back-end graphics API used by the GFX subsystem.

Enumerator:
OpenGL

OpenGL.

D3D8

Direct3D 8.

D3D9

Direct3D 9.

NullDevice

Null device for dedicated servers.

Xenon

Direct3D 9 on Xbox 360.

enum GFXBlend

The supported blend modes.

Enumerator:
GFXBlendZero

(0, 0, 0, 0)

GFXBlendOne

(1, 1, 1, 1)

GFXBlendSrcColor

(Rs, Gs, Bs, As)

GFXBlendInvSrcColor

(1 - Rs, 1 - Gs, 1 - Bs, 1 - As)

GFXBlendSrcAlpha

(As, As, As, As)

GFXBlendInvSrcAlpha

( 1 - As, 1 - As, 1 - As, 1 - As)

GFXBlendDestAlpha

(Ad Ad Ad Ad)

GFXBlendInvDestAlpha

(1 - Ad 1 - Ad 1 - Ad 1 - Ad)

GFXBlendDestColor

(Rd, Gd, Bd, Ad)

GFXBlendInvDestColor

(1 - Rd, 1 - Gd, 1 - Bd, 1 - Ad)

GFXBlendSrcAlphaSat

(f, f, f, 1) where f = min(As, 1 - Ad)

enum GFXBlendOp

The blend operators.

Enumerator:
GFXBlendOpAdd
GFXBlendOpSubtract
GFXBlendOpRevSubtract
GFXBlendOpMin
GFXBlendOpMax
enum GFXCmpFunc

The supported comparison functions.

Enumerator:
GFXCmpNever
GFXCmpLess
GFXCmpEqual
GFXCmpLessEqual
GFXCmpGreater
GFXCmpNotEqual
GFXCmpGreaterEqual
GFXCmpAlways
enum GFXCullMode

The render cull modes.

Enumerator:
GFXCullNone
GFXCullCW
GFXCullCCW
enum GFXFormat

The texture formats.

Note:
Not all formats are supported on all platforms.
Enumerator:
GFXFormatR8G8B8
GFXFormatR8G8B8A8
GFXFormatR8G8B8X8
GFXFormatR32F
GFXFormatR5G6B5
GFXFormatR5G5B5A1
GFXFormatR5G5B5X1
GFXFormatA4L4
GFXFormatA8L8
GFXFormatA8
GFXFormatL8
GFXFormatDXT1
GFXFormatDXT2
GFXFormatDXT3
GFXFormatDXT4
GFXFormatDXT5
GFXFormatD32
GFXFormatD24X8
GFXFormatD24S8
GFXFormatD24FS8
GFXFormatD16
GFXFormatR32G32B32A32F
GFXFormatR16G16B16A16F
GFXFormatL16
GFXFormatR16G16B16A16
GFXFormatR16G16
GFXFormatR16F
GFXFormatR16G16F
GFXFormatR10G10B10A2
enum GFXStencilOp

The stencil operators.

Enumerator:
GFXStencilOpKeep
GFXStencilOpZero
GFXStencilOpReplace
GFXStencilOpIncrSat
GFXStencilOpDecrSat
GFXStencilOpInvert
GFXStencilOpIncr
GFXStencilOpDecr
enum GFXTextureAddressMode

The texture address modes.

Enumerator:
GFXAddressWrap
GFXAddressMirror
GFXAddressClamp
GFXAddressBorder
GFXAddressMirrorOnce
enum GFXTextureArgument

The texture arguments.

Enumerator:
GFXTADiffuse
GFXTACurrent
GFXTATexture
GFXTATFactor
GFXTASpecular
GFXTATemp
GFXTAConstant
OneMinus
AlphaReplicate
enum GFXTextureFilterType

The texture filter types.

Enumerator:
GFXTextureFilterNone
GFXTextureFilterPoint
GFXTextureFilterLinear
GFXTextureFilterAnisotropic
GFXTextureFilterPyramidalQuad
GFXTextureFilterGaussianQuad
enum GFXTextureOp

The texture operators.

Enumerator:
GFXTOPDisable
GFXTOPSelectARG1
GFXTOPSelectARG2
GFXTOPModulate
GFXTOPModulate2X
GFXTOPModulate4X
GFXTOPAdd
GFXTOPAddSigned
GFXTOPAddSigned2X
GFXTOPSubtract
GFXTOPAddSmooth
GFXTOPBlendDiffuseAlpha
GFXTOPBlendTextureAlpha
GFXTOPBlendFactorAlpha
GFXTOPBlendTextureAlphaPM
GFXTOPBlendCURRENTALPHA
GFXTOPPreModulate
GFXTOPModulateAlphaAddColor
GFXTOPModulateColorAddAlpha
GFXTOPModulateInvAlphaAddColor
GFXTOPModulateInvColorAddAlpha
GFXTOPBumpEnvMap
GFXTOPBumpEnvMapLuminance
GFXTOPDotProduct3
GFXTOPLERP
enum GFXTextureTransformFlags

The texture transform state flags.

Enumerator:
GFXTTFDisable
GFXTTFFCoord1D
GFXTTFFCoord2D
GFXTTFFCoord3D
GFXTTFFCoord4D
GFXTTFProjected
enum MaterialAnimType

The type of animation effect to apply to this material.

Enumerator:
Scroll

Scroll the material along the X/Y axis.

Rotate

Rotate the material around a point.

Wave

Warps the material with an animation using Sin, Triangle or Square mathematics.

Scale

Scales the material larger and smaller with a pulsing effect.

Sequence

Enables the material to have multiple frames of animation in its imagemap.

enum MaterialBlendOp

The type of graphical blending operation to apply to this material.

Enumerator:
None

Disable blending for this material.

Mul

Multiplicative blending.

Add

Adds the color of the material to the frame buffer with full alpha for each pixel.

AddAlpha

The color is modulated by the alpha channel before being added to the frame buffer.

Sub

Subtractive Blending. Reverses the color model, causing dark colors to have a stronger visual effect.

LerpAlpha

Linearly interpolates between Material color and frame buffer color based on alpha.

enum MaterialWaveType

When using the Wave material animation, one of these Wave Types will be used to determine the type of wave to display.

Enumerator:
Sin

Warps the material along a curved Sin Wave.

Triangle

Warps the material along a sharp Triangle Wave.

Square

Warps the material along a wave which transitions between two oppposite states. As a Square Wave, the transition is quick and sudden.

Function Documentation

void cleanupTexturePool ( )

Release the unused pooled textures in texture manager freeing up video memory.

void clearGFXResourceFlags ( )

Clears the flagged state on all allocated GFX resources. See flagCurrentGFXResources for usage details.

See also:
flagCurrentGFXResources, listGFXResources, describeGFXResources
void describeGFXResources | ( | string | resourceTypes,
 |  | string | filePath,
 |  | bool | unflaggedOnly = false
 | ) |  |

Dumps a description of GFX resources to a file or the console.

Parameters:
resourceTypes | A space seperated list of resource types or an empty string for all resources.
filePath | A file to dump the list to or an empty string to write to the console.
unflaggedOnly | If true only unflagged resources are dumped. See flagCurrentGFXResources.
Note:
The resource types can be one or more of the following:
  • texture
  • texture target
  • window target
  • vertex buffers
  • primitive buffers
  • fences
  • cubemaps
  • shaders
  • stateblocks
void describeGFXStateBlocks ( string filePath )

Dumps a description of all state blocks.

Parameters:
filePath A file to dump the state blocks to or an empty string to write to the console.
void dumpRandomNormalMap ( )

Creates a 64x64 normal map texture filled with noise. The texture is saved to randNormTex.png in the location of the game executable.

void dumpTextureObjects ( )

Dumps a list of all active texture objects to the console.

Note:
This function is only available in debug builds.
void flagCurrentGFXResources ( )

Flags all currently allocated GFX resources. Used for resource allocation and leak tracking by flagging current resources then dumping a list of unflagged resources at some later point in execution.

See also:
listGFXResources, clearGFXResourceFlags, describeGFXResources
void flushTextureCache ( )

Releases all textures and resurrects the texture manager.

static int GFXInit::getAdapterCount ( ) [static, inherited]

Return the number of graphics adapters available.

GFXFormat getBestHDRFormat ( )

Returns the best texture format for storage of HDR data for the active device.

Point3F getDesktopResolution ( )

Returns the width, height, and bitdepth of the screen/desktop.

string getDisplayDeviceInformation ( )

Get the string describing the active GFX device.

String getDisplayDeviceList ( )

Returns a tab-seperated string of the detected devices across all adapters.

float getPixelShaderVersion ( )

Returns the pixel shader version for the active device.

String getTextureProfileStats ( )

Returns a list of texture profiles in the format: ProfileName TextureCount TextureMB.

void listGFXResources ( bool unflaggedOnly = false )

Returns a list of the unflagged GFX resources. See flagCurrentGFXResources for usage details.

See also:
flagCurrentGFXResources, clearGFXResourceFlags, describeGFXResources
void reloadTextures ( )

Reload all the textures from disk.

void screenShot | ( | string | file,
 |  | string | format,
 |  | int | tileCount = 1,
 |  | float | tileOverlap = 0
 | ) |  |

Takes a screenshot with optional tiling to produce huge screenshots.

Parameters:
file | The output image file path.
format | Either JPEG or PNG.
tileCount | If greater than 1 will tile the current screen size to take a large format screenshot.
tileOverlap | The amount of horizontal and vertical overlap between the tiles used to remove tile edge artifacts from post effects.
void setPixelShaderVersion ( float version )

Sets the pixel shader version for the active device. This can be used to force a lower pixel shader version than is supported by the device for testing or performance optimization.

Parameters:
version The floating point shader version number.
Note:
This will only affect shaders/materials created after the call and should be used before the game begins.
See also:
$pref::Video::forcedPixVersion
void setReflectFormat ( GFXFormat format )

Set the reflection texture format.

Variable Documentation

bool $gfx::disableOcclusionQuery

Debug helper that disables all hardware occlusion queries causing them to return only the visibile state.

bool $pref::Video::disableVerticalSync

Disables vertical sync on the active device.

Note:
The video mode must be reset for the change to take affect.
bool $gfx::disassembleAllShaders

On supported devices this will dump shader disassembly to the procedural shader folder.

float $pref::Video::forcedPixVersion

Will force the shader model if the value is positive and less than the shader model supported by the active device. Use 0 for fixed function.

Note:
The graphics device must be reset for the change to take affect.
int $pref::Video::textureReductionLevel

The number of mipmap levels to drop on loaded textures to reduce video memory usage. It will skip any textures that have been defined as not allowing down scaling.

bool $gfx::wireframe

Used to toggle wireframe rendering at runtime.


Torque 3D - Script Manual: Materials

Materials
[GFX]

Classes, structures, functions, and variables related to Torque 3D's material system. More...

Classes

class | CustomMaterial
Material object which provides more control over surface properties. More...

Functions

void | addMaterialMapping (string texName, string matName)
Set up a material to texture mapping.
string | getMaterialMapping (string texName)
Gets the name of the material mapped to this texture.

Variables

int | $pref::Video::defaultAnisotropy
Default anisotropy value.
void | dumpMaterialInstances
Dumps a formatted list of currently allocated material instances to the console.
string | getMapEntry
Returns the material name via the materialList mapTo entry.
void | reInitMaterials
Flushes all the procedural shaders and re-initializes all the active materials instances.

Detailed Description

Classes, structures, functions, and variables related to Torque 3D's material system.

Function Documentation

void addMaterialMapping | ( | string | texName,
 |  | string | matName
 | ) |  |

Set up a material to texture mapping.

string getMaterialMapping ( string texName )

Gets the name of the material mapped to this texture.

param texName Name of the texture

Variable Documentation

int $pref::Video::defaultAnisotropy

Default anisotropy value.

void dumpMaterialInstances

Dumps a formatted list of currently allocated material instances to the console.

string getMapEntry

Returns the material name via the materialList mapTo entry.

Returns:
String containing the material name
void reInitMaterials

Flushes all the procedural shaders and re-initializes all the active materials instances.


Torque 3D - Script Manual: Shaders

Shaders
[GFX]

Classes, structures, functions, and variables related to Torque 3D's shader system. More...

Classes

class ShaderData
Special type of data block that stores information about a handwritten shader. More...

Detailed Description

Classes, structures, functions, and variables related to Torque 3D's shader system.


Torque 3D - Script Manual: Lighting

Lighting
[Rendering]

The script functionality related to the lighting systems and lights. More...

Classes

class | AdvancedLightBinManager
Rendering Manager responsible for lighting, shadows, and global variables affecing both. More...
class | LightAnimData
A datablock which defines and performs light animation, such as rotation, brightness fade, and colorization. More...
class | LightBase
This is the base class for light objects. More...
class | LightDescription
A helper datablock used by classes (such as shapebase) that submit lights to the scene but do not use actual "LightBase" objects. More...
class | LightFlareData
Defines a light flare effect usable by scene lights. More...
class | PointLight
Lighting object that radiates light in all directions. More...
class | SpotLight
Lighting object which emits conical light in a direction. More...

Modules

Advanced Lighting

The script functionality related to the Advanced Lghting system.

Basic Lighting

The script functionality related to the Basic Lghting system.

Functions

string | getActiveLightManager ()
Returns the active light manager name.
String | getLightManagerNames ()
Returns a tab seperated list of light manager names.
bool | lightScene (string completeCallbackFn=NULL, string mode=NULL)
Will generate static lighting for the scene if supported by the active light manager.
void | resetLightManager ()
Deactivates and then activates the currently active light manager.This causes most shaders to be regenerated and is often used when global rendering changes have occured.
bool | setLightManager (string name)
Finds and activates the named light manager.

Variables

bool | $Light::renderLightFrustums
Toggles rendering of light frustums when the light is selected in the editor.
bool | $Light::renderViz
Toggles visualization of light object's radius or cone.

Callbacks

void | onLightManagerActivate (string name)
A callback called by the engine when a light manager is activated.
void | onLightManagerDeactivate (string name)
A callback called by the engine when a light manager is deactivated.

Detailed Description

The script functionality related to the lighting systems and lights.

Function Documentation

string getActiveLightManager ( )

Returns the active light manager name.

String getLightManagerNames ( )

Returns a tab seperated list of light manager names.

bool lightScene | ( | string | completeCallbackFn = NULL,
 |  | string | mode = NULL
 | ) |  |

Will generate static lighting for the scene if supported by the active light manager.

If mode is "forceAlways", the lightmaps will be regenerated regardless of whether lighting cache files can be written to. If mode is "forceWritable", then the lightmaps will be regenerated only if the lighting cache files can be written.

Parameters:
completeCallbackFn | The name of the function to execute when the lighting is complete.
mode | One of "forceAlways", "forceWritable" or "loadOnly".
Returns:
Returns true if the scene lighting process was started.
void onLightManagerActivate ( string name )

A callback called by the engine when a light manager is activated.

Parameters:
name The name of the light manager being activated.
void onLightManagerDeactivate ( string name )

A callback called by the engine when a light manager is deactivated.

Parameters:
name The name of the light manager being deactivated.
void resetLightManager ( )

Deactivates and then activates the currently active light manager.This causes most shaders to be regenerated and is often used when global rendering changes have occured.

bool setLightManager ( string name )

Finds and activates the named light manager.

Returns:
Returns true if the light manager is found and activated.

Variable Documentation

bool $Light::renderLightFrustums

Toggles rendering of light frustums when the light is selected in the editor.

Note:
Only works for shadow mapped lights.
bool $Light::renderViz

Toggles visualization of light object's radius or cone.


Torque 3D - Script Manual: Advanced Lighting

Advanced Lighting
[Lighting]

The script functionality related to the Advanced Lghting system. More...

Enumerations

enum ShadowFilterMode {
None,
SoftShadow,
SoftShadowHighQuality
}

The shadow filtering modes for Advanced Lighting shadows.

More...
enum ShadowType {
Spot,
PSSM,
Paraboloid,
DualParaboloidSinglePass,
DualParaboloid,
CubeMap
}

Variables

float | $pref::PSSM::detailAdjustScale
Scales the model LOD when rendering into the PSSM shadow. Use this to reduce the draw calls when rendering the shadow by having meshes LOD out nearer to the camera than normal.
bool | $Shadows::disable
Used by the editor to disable all shadow rendering.
bool | $pref::Shadows::disable
Used to disable all shadow rendering.
ShadowFilterMode $pref::shadows::filterMode
The filter mode to use for shadows.
bool | $AL::PSSMDebugRender
Enables debug rendering of the PSSM shadows.
float | $pref::PSSM::smallestVisiblePixelSize
The smallest pixel size an object can be and still be rendered into the PSSM shadow. Use this to force culling of small objects which contribute little to the final shadow.
float | $pref::Shadows::textureScalar
Used to scale the shadow texture sizes. This can reduce the shadow quality and texture memory overhead or increase them.
bool | $AL::UseSSAOMask
Used by the SSAO PostEffect to toggle the sampling of ssaomask texture by the light shaders.

Detailed Description

The script functionality related to the Advanced Lghting system.

Enumeration Type Documentation

enum ShadowFilterMode

The shadow filtering modes for Advanced Lighting shadows.

Enumerator:
None

Simple point sampled filtering. This is the fastest and lowest quality mode.

SoftShadow

A variable tap rotated poisson disk soft shadow filter. It performs 4 taps to classify the point as in shadow, out of shadow, or along a shadow edge. Samples on the edge get an additional 8 taps to soften them.

SoftShadowHighQuality

A 12 tap rotated poisson disk soft shadow filter. It performs all the taps for every point without any early rejection.

enum ShadowType
Enumerator:
Spot
PSSM
Paraboloid
DualParaboloidSinglePass
DualParaboloid
CubeMap

Variable Documentation

float $pref::PSSM::detailAdjustScale

Scales the model LOD when rendering into the PSSM shadow. Use this to reduce the draw calls when rendering the shadow by having meshes LOD out nearer to the camera than normal.

See also:
$pref::TS::detailAdjust
bool $Shadows::disable

Used by the editor to disable all shadow rendering.

bool $pref::Shadows::disable

Used to disable all shadow rendering.

ShadowFilterMode $pref::shadows::filterMode

The filter mode to use for shadows.

bool $AL::PSSMDebugRender

Enables debug rendering of the PSSM shadows.

float $pref::PSSM::smallestVisiblePixelSize

The smallest pixel size an object can be and still be rendered into the PSSM shadow. Use this to force culling of small objects which contribute little to the final shadow.

See also:
$pref::TS::smallestVisiblePixelSize
float $pref::Shadows::textureScalar

Used to scale the shadow texture sizes. This can reduce the shadow quality and texture memory overhead or increase them.

bool $AL::UseSSAOMask

Used by the SSAO PostEffect to toggle the sampling of ssaomask texture by the light shaders.


Torque 3D - Script Manual: Basic Lighting

Basic Lighting
[Lighting]

The script functionality related to the Basic Lghting system. More...

Variables

int | $BasicLightManagerStats::activePlugins
The number of active Basic Lighting SceneObjectLightingPlugin objects this frame.
int | $BasicLightManagerStats::elapsedUpdateMs
The number of milliseconds spent this frame updating Basic Lighting shadows.
float | $pref::ProjectedShadow::fadeEndPixelSize
A size in pixels at which BL shadows are fully faded out. This should be a smaller value than fadeStartPixelSize.
float | $pref::ProjectedShadow::fadeStartPixelSize
A size in pixels at which BL shadows begin to fade out. This should be a larger value than fadeEndPixelSize.
float | $BasicLightManager::shadowFilterDistance
The maximum distance in meters that projected shadows will get soft filtering.
int | $BasicLightManagerStats::shadowsUpdated
The number of Basic Lighting shadows updated this frame.

Detailed Description

The script functionality related to the Basic Lghting system.

Variable Documentation

int $BasicLightManagerStats::activePlugins

The number of active Basic Lighting SceneObjectLightingPlugin objects this frame.

int $BasicLightManagerStats::elapsedUpdateMs

The number of milliseconds spent this frame updating Basic Lighting shadows.

float $pref::ProjectedShadow::fadeEndPixelSize

A size in pixels at which BL shadows are fully faded out. This should be a smaller value than fadeStartPixelSize.

See also:
DecalData
float $pref::ProjectedShadow::fadeStartPixelSize

A size in pixels at which BL shadows begin to fade out. This should be a larger value than fadeEndPixelSize.

See also:
DecalData
float $BasicLightManager::shadowFilterDistance

The maximum distance in meters that projected shadows will get soft filtering.

int $BasicLightManagerStats::shadowsUpdated

The number of Basic Lighting shadows updated this frame.


Torque 3D - Script Manual: Render Binning

Render Binning
[Rendering]

The render sorting and batching system. More...

Classes

class | RenderBinManager
The abstract base for all render bins. More...
class | RenderGlowMgr
A render bin for the glow pass. More...
class | RenderImposterMgr
A render bin for batch rendering imposters. More...
class | RenderMeshMgr
A render bin for mesh rendering. More...
class | RenderObjectMgr
A render bin which uses object callbacks for rendering. More...
class | RenderOcclusionMgr
A render bin which renders occlusion query requests. More...
class | RenderParticleMgr
A render bin which renders particle geometry. More...
class | RenderPassManager
A grouping of render bin managers which forms a render pass. More...
class | RenderPassStateBin
A non-rendering render bin used to enable/disable a RenderPassStateToken. More...
class | RenderPassStateToken
Abstract base class for RenderFormatToken, used to manipulate what goes on in the render manager. More...
class | RenderPrePassMgr
The render bin which performs a z+normals prepass used in Advanced Lighting. More...
class | RenderTerrainMgr
A render bin for terrain mesh rendering. More...
class | RenderTexTargetBinManager
An abstract base class for render bin managers that render to a named textue target. More...
class | RenderTranslucentMgr
A render bin for rendering translucent meshes. More...

Enumerations

enum RenderTexTargetSize {
windowsize,
windowsizescaled,
fixedsize
}

What size to render the target texture. Sizes are based on the Window the render is occuring in.

More...

Variables

static bool | RenderOcclusionMgr::debugRender
A debugging feature which renders the occlusion volumes to the scene.
static bool | RenderTerrainMgr::renderWireframe
Used to enable wireframe rendering on terrain for debugging.

Detailed Description

The render sorting and batching system.

In Torque we use a binning system to do the initial ordering and batching of rendering operations.

When rendering a pass is made thru all the game objects visible in the scene. The game objects will each submit one or more RenderInst to the RenderPassManager. The pass manager maintains an ordered list of RenderBinManagers each which get a chance to consume the RenderInst.

After all the game objects have been processed the RenderPassManager lets each bin sort then render the RenderInsts they contain.

Currently from script you can only define and change the order of the bins in the RenderPassManager. To create new types of bins or add new rendering methods you will need C++ source access.

See core\scripts\client\renderManager.cs.

Enumeration Type Documentation

enum RenderTexTargetSize

What size to render the target texture. Sizes are based on the Window the render is occuring in.

Enumerator:
windowsize

Render to the size of the window.

windowsizescaled

Render to the size of the window, scaled to the render target's size.

fixedsize

Don't scale the target texture, and render to its default size.

Variable Documentation

bool RenderOcclusionMgr::debugRender [static, inherited]

A debugging feature which renders the occlusion volumes to the scene.

See also:
RenderOcclusionMgr
bool RenderTerrainMgr::renderWireframe [static, inherited]

Used to enable wireframe rendering on terrain for debugging.


Torque 3D - Script Manual: Sound

Sound

A broad range of functionality for creating rich game audio. More...

Classes

class | SFXAmbience
A datablock that describes an ambient sound space. More...
class | SFXController
A sound source that drives multi-source playback. More...
class | SFXDescription
A description for how a sound should be played. More...
class | SFXEmitter
An invisible 3D object that emits sound. More...
class | SFXEnvironment
Description of a reverb environment. More...
class | SFXParameter
A sound channel value that can be bound to multiple sound sources. More...
class | SFXPlayList
A datablock describing a playback pattern of sounds. More...
class | SFXProfile
Encapsulates a single sound file for playback by the sound system. More...
class | SFXSound
A sound controller that directly plays a single sound file. More...
class | SFXSource
Playback controller for a sound source. More...
class | SFXSpace
A volume in space that defines an ambient sound zone. More...
class | SFXState
A boolean switch used to modify playlist behavior. More...
class | SFXTrack
Abstract base class for sound data that can be played back by the sound system. More...

Modules

FMOD

Functionality specific to the FMOD SFX implementation.

Enumerations

enum SFXChannel {
Volume,
Pitch,
Priority,
PositionX,
PositionY,
PositionZ,
RotationX,
RotationY,
RotationZ,
VelocityX,
VelocityY,
VelocityZ,
ReferenceDistance,
MaxDistance,
ConeInsideAngle,
ConeOutsideAngle,
ConeOutsideVolume,
Cursor,
Status,
User0,
User1,
User2,
User3
}

Channels are individual properties of sound sources that may be animated over time.

More...
enum SFXDistanceModel {
Linear,
Logarithmic
}

Type of volume distance attenuation curve.

More...
enum SFXPlayListLoopMode {
All,
Single
}

Playlist behavior when description is set to loop.

More...
enum SFXPlayListRandomMode {
NotRandom,
StrictRandom,
OrderedRandom
}

Randomization pattern to apply to playlist slot playback order.

More...
enum SFXPlayListReplayMode {
IgnorePlaying,
RestartPlaying,
KeepPlaying,
StartNew,
SkipIfPlaying
}

Behavior when hitting the play stage of a slot that is still playing from a previous cycle.

More...
enum SFXPlayListStateMode {
StopWhenDeactivated,
PauseWhenDeactivated,
IgnoreWhenDeactivated
}

Reaction behavior when a state is changed incompatibly on a slot that has already started playing.

More...
enum SFXPlayListTransitionMode {
None,
Wait,
WaitAll,
Stop,
StopAll
}

Playlist behavior when transitioning in and out of invididual slots.

More...
enum SFXStatus {
Playing,
Stopped,
Paused
}

Playback status of sound source.

More...

Functions

bool | sfxCreateDevice (string provider, string device, bool useHardware, int maxBuffers)
Try to create a new sound device using the given properties.
SFXSource | sfxCreateSource (SFXTrack track)
Create a new source that plays the given track.
SFXSource | sfxCreateSource (SFXTrack track, float x, float y, float z)
Create a new source that plays the given track and position its 3D sounds source at the given coordinates (if it is a 3D sound).
SFXSound | sfxCreateSource (SFXDescription description, string filename)
Create a temporary SFXProfile from the given description and filename and then create and return a new source that plays the profile.
SFXSound | sfxCreateSource (SFXDescription description, string filename, float x, float y, float z)
Create a temporary SFXProfile from the given description and filename and then create and return a new source that plays the profile. Position the sound source at the given coordinates (if it is a 3D sound).
void | sfxDeleteDevice ()
Delete the currently active sound device and release all its resources.
void | sfxDeleteWhenStopped (SFXSource source)
Mark the given source for deletion as soon as it moves into stopped state.
void | sfxDumpSources (bool includeGroups=false)
Dump information about all current SFXSource instances to the console.
string | sfxDumpSourcesToString (bool includeGroups=false)
Dump information about all current SFXSource instances to a string.
string | sfxGetActiveStates ()
Return a newline-separated list of all active states.
string | sfxGetAvailableDevices ()
Get a list of all available sound devices.
string | sfxGetDeviceInfo ()
Return information about the currently active sound device.
SFXDistanceModel sfxGetDistanceModel ()
Get the falloff curve type currently being applied to 3D sounds.
float | sfxGetDopplerFactor ()
Get the current global doppler effect setting.
float | sfxGetRolloffFactor ()
Get the current global scale factor applied to volume attenuation of 3D sounds in the logarithmic model.
SFXSource | sfxPlay (SFXSource source)
Start playback of the given source.
void | sfxPlay (SFXTrack track)
Create a new play-once source for the given track and start playback of the source.
void | sfxPlay (SFXTrack track, float x, float y, float z)
Create a new play-once source for the given track, position its 3D sound at the given coordinates (if the track's description is set up for 3D sound) and start playback of the source.
SFXSource | sfxPlayOnce (SFXTrack track)
Create a play-once source for the given track.
SFXSource | sfxPlayOnce (SFXTrack track, float x, float y, float z, float fadeInTime=-1)
Create a play-once source for the given given track and position the source's 3D sound at the given coordinates only if the track's description is set up for 3D sound).
SFXSource | sfxPlayOnce (SFXDescription description, string filename)
Create a new temporary SFXProfile from the given description and filename, then create a play-once source for it and start playback.
SFXSource | sfxPlayOnce (SFXDescription description, string filename, float x, float y, float z, float fadeInTime=-1)
Create a new temporary SFXProfile from the given description and filename, then create a play-once source for it and start playback. Position the source's 3D sound at the given coordinates (only if the description is set up for 3D sound).
void | sfxSetDistanceModel (SFXDistanceModel model)
Set the falloff curve type to use for distance-based volume attenuation of 3D sounds.
void | sfxSetDopplerFactor (float value)
Set the global doppler effect scale factor.
void | sfxSetRolloffFactor (float value)
Set the global scale factor to apply to volume attenuation of 3D sounds in the logarithmic model.
void | sfxStop (SFXSource source)
Stop playback of the given source.
void | sfxStopAndDelete (SFXSource source)
Stop playback of the given source (if it is not already stopped) and delete the source.

Variables

int | $SFX::ambientUpdateTime
Milliseconds spent on the last ambient audio update.
const int | $SFX::DEVICE_CAPS_DSPEFFECTS
Sound device capability flag indicating that the sound device supports adding DSP effect chains to sounds.
const int | $SFX::DEVICE_CAPS_FMODDESIGNER
Sound device capability flag indicating that the sound device supports FMOD Designer audio projects.
const int | $SFX::DEVICE_CAPS_MULTILISTENER
Sound device capability flag indicating that the sound device supports multiple concurrent listeners.
const int | $SFX::DEVICE_CAPS_OCCLUSION
Sound device capability flag indicating that the sound device implements sound occlusion.
const int | $SFX::DEVICE_CAPS_REVERB
Sound device capability flag indicating that the sound device supports reverb.
const int | $SFX::DEVICE_CAPS_VOICEMANAGEMENT
Sound device capability flag indicating that the sound device implements its own voice virtualization.
const int | $SFX::DEVICE_INFO_CAPS
Index of device capability flags in device info string.
const int | $SFX::DEVICE_INFO_MAXBUFFERS
Index of buffer limit number in device info string.
const int | $SFX::DEVICE_INFO_NAME
Index of device name field in device info string.
const int | $SFX::DEVICE_INFO_PROVIDER
Index of sound provider field in device info string.
const int | $SFX::DEVICE_INFO_USEHARDWARE
Index of use hardware flag in device info string.
int | $SFX::numCulled
Number of SFXSounds that are currently in virtualized playback mode.
int | $SFX::numPlaying
Number of SFXSources that are currently in playing state.
int | $SFX::numSounds
Number of SFXSound type objects (i.e. actual single-file sounds) that are currently instantiated.
int | $SFX::numSources
Number of SFXSource type objects that are currently instantiated.
int | $SFX::numVoices
Number of voices that are currently allocated on the sound device.
int | $SFX::parameterUpdateTime
Milliseconds spent on the last SFXParameter update loop.
static ColorI | SFXEmitter::renderColorInnerCone
The color with which to render dots in the inner sound cone (Editor only).
static ColorI | SFXEmitter::renderColorOuterCone
The color with which to render dots in the outer sound cone (Editor only).
static ColorI | SFXEmitter::renderColorOutsideVolume
The color with which to render dots outside of the outer sound cone (Editor only).
static ColorI | SFXEmitter::renderColorPlayingInRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is playing and in range of the listener.
static ColorI | SFXEmitter::renderColorPlayingOutOfRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is playing but out of the range of the listener.
static ColorI | SFXEmitter::renderColorRangeSphere
The color of the range sphere with which to render sound emitters in the editor.
static ColorI | SFXEmitter::renderColorStoppedInRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is not playing but the emitter is in range of the listener.
static ColorI | SFXEmitter::renderColorStoppedOutOfRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is not playing and the emitter is out of range of the listener.
static bool | SFXEmitter::renderEmitters
Whether to render enhanced range feedback in the editor on all emitters regardless of selection state.
static float | SFXEmitter::renderPointDistance
The distance between individual points in the sound emitter rendering in the editor as the points move from the emitter's center away to maxDistance.
static float | SFXEmitter::renderRadialIncrements
The stepping (in degrees) for the radial sweep along the axis of the XY plane sweep for sound emitter rendering in the editor.
static float | SFXEmitter::renderSweepIncrements
The stepping (in degrees) for the radial sweep on the XY plane for sound emitter rendering in the editor.
int | $SFX::sourceUpdateTime
Milliseconds spent on the last SFXSource update loop.

Detailed Description

A broad range of functionality for creating rich game audio.

3D Audio

Streaming vs. Buffered Audio

See also:
SFXDescription::isStreaming

Interactive Audio

See also:
SFXPlayList
SFXState

Ambient Audio

See also:
SFXAmbience

Audio Reverb

Please consult the EAX documentation for more information

Note:
Reverb currently only works with FMOD.
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
http://connect.creativelabs.com/developer/Gaming/Forms/AllItems.aspx
SFXEnvironment
SFXDescription::useCustomReverb

Supported Sound File Formats

Note:
When using FMOD, the sound system supports all formats implemented by FMOD. Before applying file lookup patterns to a sound file path, the file name is first passed unaltered to FMOD. This allows to, for example, use URLs for internet radio playback.

Providers and Devices

  • FMOD
  • OpenAL
  • XAudio2
  • DirectSound
  • Null
See also:
sfxGetAvailableDevices
sfxGetDeviceInfo
sfxCreateDevice
sfxDeleteDevice

Sound System Updates

Live Asset Updates of Sound Files

Enumeration Type Documentation

enum SFXChannel

Channels are individual properties of sound sources that may be animated over time.

See also:
SFXParameter

Interactive Audio

Enumerator:
Volume

Channel controls volume level of attached sound sources.

See also:
SFXDescription::volume
Pitch

Channel controls pitch of attached sound sources.

See also:
SFXDescription::pitch
Priority

Channel controls virtualizaton priority level of attached sound sources.

See also:
SFXDescription::priority
PositionX

Channel controls X coordinate of 3D sound position of attached sources.

PositionY

Channel controls Y coordinate of 3D sound position of attached sources.

PositionZ

Channel controls Z coordinate of 3D sound position of attached sources.

RotationX

Channel controls X rotation (in degrees) of 3D sound orientation of attached sources.

RotationY

Channel controls Y rotation (in degrees) of 3D sound orientation of attached sources.

RotationZ

Channel controls Z rotation (in degrees) of 3D sound orientation of attached sources.

VelocityX

Channel controls X coordinate of 3D sound velocity vector of attached sources.

VelocityY

Channel controls Y coordinate of 3D sound velocity vector of attached sources.

VelocityZ

Channel controls Z coordinate of 3D sound velocity vector of attached sources.

ReferenceDistance

Channel controls reference distance of 3D sound of attached sources.

See also:
SFXDescription::referenceDistance
MaxDistance

Channel controls max volume attenuation distance of 3D sound of attached sources.

See also:
SFXDescription::maxDistance
ConeInsideAngle

Channel controls angle (in degrees) of 3D sound inner volume cone of attached sources.

See also:
SFXDescription::coneInsideAngle
ConeOutsideAngle

Channel controls angle (in degrees) of 3D sound outer volume cone of attached sources.

See also:
SFXDescription::coneOutsideAngle
ConeOutsideVolume

Channel controls volume outside of 3D sound outer cone of attached sources.

See also:
SFXDescription::coneOutsideVolume
Cursor

Channel controls playback cursor of attached sound sources.

Note:
Be aware that different types of sound sources interpret play cursor positions differently or do not actually have play cursors (these sources will ignore the channel).
Status

Channel controls playback status of attached sound sources.

The channel's value is rounded down to the nearest integer and interpreted in the following way:

  • 1: Play
  • 2: Stop
  • 3: Pause
User0

Channel available for custom use. By default ignored by sources.

Note:
For FMOD Designer event sources (SFXFMODEventSource), this channel is used for event parameters defined in FMOD Designer and should not be used otherwise.
See also:
SFXSource::onParameterValueChange
User1

Channel available for custom use. By default ignored by sources.

See also:
SFXSource::onParameterValueChange
User2

Channel available for custom use. By default ignored by sources.

See also:
SFXSource::onParameterValueChange
User3

Channel available for custom use. By default ignored by sources.

See also:
SFXSource::onParameterValueChange
enum SFXDistanceModel

Type of volume distance attenuation curve.

The distance model determines the falloff curve applied to the volume of 3D sounds over distance.

Volume Attenuation

3D Audio

Enumerator:
Linear

Volume attenuates linearly from the references distance onwards to max distance where it reaches zero.

Logarithmic

Volume attenuates logarithmically starting from the reference distance and halving every reference distance step from there on. Attenuation stops at max distance but volume won't reach zero.

enum SFXPlayListLoopMode

Playlist behavior when description is set to loop.

See also:
SFXDescription::isLooping
SFXPlayList::loopMode
Enumerator:
All

Loop over all slots, i.e. jump from last to first slot after all slots have played.

Single

Loop infinitely over the current slot. Only useful in combination with either states or manual playlist control.

enum SFXPlayListRandomMode

Randomization pattern to apply to playlist slot playback order.

See also:
SFXPlayList::random
Enumerator:
NotRandom

Play slots in sequential order. No randomization.

StrictRandom

Play a strictly random selection of slots.

In this mode, a set of numSlotsToPlay random numbers between 0 and numSlotsToPlay-1 (inclusive), i.e. in the range of valid slot indices, is generated and playlist slots are played back in the order of this list. This allows the same slot to occur multiple times in a list and, consequentially, allows for other slots to not appear at all in a given slot ordering.

OrderedRandom

Play all slots in the list in a random order.

In this mode, the numSlotsToPlay slots from the list with valid tracks assigned are put into a random order and played. This guarantees that each slots is played exactly once albeit at a random position in the total ordering.

enum SFXPlayListReplayMode

Behavior when hitting the play stage of a slot that is still playing from a previous cycle.

See also:
SFXPlayList::replay
Enumerator:
IgnorePlaying

Ignore any sources that may already be playing on the slot and just create a new source.

RestartPlaying

Restart all sources that was last created for the slot.

KeepPlaying

Keep playing the current source(s) as if the source started last on the slot was created in this cycle. For this, the sources associated with the slot are brought to the top of the play stack.

StartNew

Stop all sources currently playing on the slot and then create a new source.

SkipIfPlaying

If there are sources already playing on the slot, skip the play stage.

enum SFXPlayListStateMode

Reaction behavior when a state is changed incompatibly on a slot that has already started playing.

See also:
SFXPlayList::stateMode
Enumerator:
StopWhenDeactivated

Stop the sources playing on the slot when a state changes to a setting that is incompatible with the slot's state setting.

PauseWhenDeactivated

Pause all sources playing on the slot when a state changes to a setting that is incompatible with the slot's state setting.

When the slot's state is reactivated again, the sources will resume playback.

IgnoreWhenDeactivated

Ignore when a state changes to a setting incompatible with the slot's state setting and just keep playing sources attached to the slot.

enum SFXPlayListTransitionMode

Playlist behavior when transitioning in and out of invididual slots.

Transition behaviors apply when the playback controller starts processing a playlist slot and when it ends processing a slot. Using transition behaviors, playback can be synchronized.

See also:
SFXPlayList::transitionIn
SFXPlayList::transitionOut
Enumerator:
None

No transition. Immediately move on to processing the slot or immediately move on to the next slot.

Wait

Wait for the sound source spawned last by this playlist to finish playing. Then proceed.

WaitAll

Wait for all sound sources currently spawned by the playlist to finish playing. Then proceed.

Stop

Stop the sound source spawned last by this playlist. Then proceed.

StopAll

Stop all sound sources spawned by the playlist. Then proceed.

enum SFXStatus

Playback status of sound source.

Enumerator:
Playing

The source is currently playing.

Stopped

Playback of the source is stopped. When transitioning to Playing state, playback will start at the beginning of the source.

Paused

Playback of the source is paused. Resuming playback will play from the current playback position.

Function Documentation

bool sfxCreateDevice | ( | string | provider,
 |  | string | device,
 |  | bool | useHardware,
 |  | int | maxBuffers
 | ) |  |

Try to create a new sound device using the given properties.

If a sound device is currently initialized, it will be uninitialized first. However, be aware that in this case, if this function fails, it will not restore the previously active device but rather leave the sound system in an uninitialized state.

Sounds that are already playing while the new device is created will be temporarily transitioned to virtualized playback and then resume normal playback once the device has been created.

In the core scripts, sound is automatically set up during startup in the sfxStartup() function.

Parameters:
provider | The name of the device provider as returned by sfxGetAvailableDevices().
device | The name of the device as returned by sfxGetAvailableDevices().
useHardware | Whether to enabled hardware mixing on the device or not. Only relevant if supported by the given device.
maxBuffers | The maximum number of concurrent voices for this device to use or -1 for the device to pick its own reasonable default.
Returns:
True if the initialization was successful, false if not.
Note:
This function must be called before any of the sound playback functions can be used.
See also:
sfxGetAvailableDevices
sfxGetDeviceInfo
sfxDeleteDevice

Providers and Devices

SFXSource sfxCreateSource ( SFXTrack track )

Create a new source that plays the given track.

The source will be returned in stopped state. Call SFXSource::play() to start playback.

In contrast to play-once sources, the source object will not be automatically deleted once playback stops. Call delete() to release the source object.

This function will automatically create the right SFXSource type for the given SFXTrack.

Parameters:
track The track the source should play.
Returns:
A new SFXSource for playback of the given track or 0 if no source could be created from the given track.
Note:
Trying to create a source for a device-specific track type will fail if the currently selected device does not support the type. Example: trying to create a source for an FMOD Designer event when not running FMOD.
Example:
// Create and play a source from a pre-existing profile:
%source = sfxCreateSource( SoundFileProfile );
%source.play();

SFXSource sfxCreateSource | ( | SFXTrack | track,
 |  | float | x,
 |  | float | y,
 |  | float | z
 | ) |  |

Create a new source that plays the given track and position its 3D sounds source at the given coordinates (if it is a 3D sound).

The source will be returned in stopped state. Call SFXSource::play() to start playback.

In contrast to play-once sources, the source object will not be automatically deleted once playback stops. Call delete() to release the source object.

This function will automatically create the right SFXSource type for the given SFXTrack.

Parameters:
track | The track the source should play.
x | The X coordinate of the 3D sound position.
y | The Y coordinate of the 3D sound position.
z | The Z coordinate of the 3D sound position.
Returns:
A new SFXSource for playback of the given track or 0 if no source could be created from the given track.
Note:
Trying to create a source for a device-specific track type will fail if the currently selected device does not support the type. Example: trying to create a source for an FMOD Designer event when not running FMOD.
Example:
// Create and play a source from a pre-existing profile and position it at (100, 200, 300):
%source = sfxCreateSource( SoundFileProfile, 100, 200, 300 );
%source.play();

SFXSound sfxCreateSource | ( | SFXDescription | description,
 |  | string | filename
 | ) |  |

Create a temporary SFXProfile from the given description and filename and then create and return a new source that plays the profile.

The source will be returned in stopped state. Call SFXSource::play() to start playback.

In contrast to play-once sources, the source object will not be automatically deleted once playback stops. Call delete() to release the source object.

Parameters:
description | The description to use for setting up the temporary SFXProfile.
filename | Path to the sound file to play.
Returns:
A new SFXSource for playback of the given track or 0 if no source or no temporary profile could be created.
Example:
// Create a source for a music track:
%source = sfxCreateSource( AudioMusicLoop2D, "art/sound/backgroundMusic" );
%source.play();
See also:
SFXProfile
SFXSound sfxCreateSource | ( | SFXDescription | description,
 |  | string | filename,
 |  | float | x,
 |  | float | y,
 |  | float | z
 | ) |  |

Create a temporary SFXProfile from the given description and filename and then create and return a new source that plays the profile. Position the sound source at the given coordinates (if it is a 3D sound).

The source will be returned in stopped state. Call SFXSource::play() to start playback.

In contrast to play-once sources, the source object will not be automatically deleted once playback stops. Call delete() to release the source object.

Parameters:
description | The description to use for setting up the temporary SFXProfile.
filename | Path to the sound file to play.
x | The X coordinate of the 3D sound position.
y | The Y coordinate of the 3D sound position.
z | The Z coordinate of the 3D sound position.
Returns:
A new SFXSource for playback of the given track or 0 if no source or no temporary profile could be created.
Example:
// Create a source for a music track and position it at (100, 200, 300):
%source = sfxCreateSource( AudioMusicLoop3D, "art/sound/backgroundMusic", 100, 200, 300 );
%source.play();
See also:
SFXProfile
void sfxDeleteDevice ( )

Delete the currently active sound device and release all its resources.

SFXSources that are still playing will be transitioned to virtualized playback mode. When creating a new device, they will automatically transition back to normal playback.

In the core scripts, this is done automatically for you during shutdown in the sfxShutdown() function.

See also:
sfxCreateDevice

Providers and Devices

void sfxDeleteWhenStopped ( SFXSource source )

Mark the given source for deletion as soon as it moves into stopped state.

This function will retroactively turn the given source into a play-once source (see Play-Once Sources).

Parameters:
source A sound source.
void sfxDumpSources ( bool includeGroups = false )

Dump information about all current SFXSource instances to the console.

The dump includes information about the playback status for each source, volume levels, virtualization, etc.

Parameters:
includeGroups If true, direct instances of SFXSources (which represent logical sound groups) will be included. Otherwise only instances of subclasses of SFXSources are included in the dump.
See also:
SFXSource
sfxDumpSourcesToString
string sfxDumpSourcesToString ( bool includeGroups = false )

Dump information about all current SFXSource instances to a string.

The dump includes information about the playback status for each source, volume levels, virtualization, etc.

Parameters:
includeGroups If true, direct instances of SFXSources (which represent logical sound groups) will be included. Otherwise only instances of subclasses of SFXSources are included in the dump.
Returns:
A string containing a dump of information about all currently instantiated SFXSources.
See also:
SFXSource
sfxDumpSources
string sfxGetActiveStates ( )

Return a newline-separated list of all active states.

Returns:
A list of the form
stateName1 NL stateName2 NL stateName3 ...
where each element is the name of an active state object.
Example:
// Disable all active states.
foreach$( %state in sfxGetActiveStates() )
   %state.disable();
string sfxGetAvailableDevices ( )

Get a list of all available sound devices.

The return value will be a newline-separated list of entries where each line describes one available sound device. Each such line will have the following format:

provider TAB device TAB hasHardware TAB numMaxBuffers
  • provider: The name of the device provider (e.g. "FMOD").
  • device: The name of the device as returned by the device layer.
  • hasHardware: Whether the device supports hardware mixing or not.
  • numMaxBuffers: The maximum number of concurrent voices supported by the device's mixer. If this limit limit is exceeded, i.e. if there are more active sounds playing at any one time, then voice virtualization will start culling voices and put them into virtualized playback mode. Voice virtualization may or may not be provided by the device itself; if not provided by the device, it will be provided by Torque's sound system.
Returns:
A newline-separated list of information about all available sound devices.
See also:
sfxCreateDevice
sfxGetDeviceInfo
$SFX::DEVICE_INFO_PROVIDER
$SFX::DEVICE_INFO_NAME
$SFX::DEVICE_INFO_USEHARDWARE
$SFX::DEVICE_INFO_MAXBUFFERS

Providers and Devices

string sfxGetDeviceInfo ( )

Return information about the currently active sound device.

The return value is a tab-delimited string of the following format:

provider TAB device TAB hasHardware TAB numMaxBuffers TAB caps
  • provider: The name of the device provider (e.g. "FMOD").
  • device: The name of the device as returned by the device layer.
  • hasHardware: Whether the device supports hardware mixing or not.
  • numMaxBuffers: The maximum number of concurrent voices supported by the device's mixer. If this limit limit is exceeded, i.e. if there are more active sounds playing at any one time, then voice virtualization will start culling voices and put them into virtualized playback mode. Voice virtualization may or may not be provided by the device itself; if not provided by the device, it will be provided by Torque's sound system.
  • caps: A bitfield of capability flags.
Returns:
A tab-separated list of properties of the currently active sound device or the empty string if no sound device has been initialized.
See also:
sfxCreateDevice
sfxGetAvailableDevices
$SFX::DEVICE_INFO_PROVIDER
$SFX::DEVICE_INFO_NAME
$SFX::DEVICE_INFO_USEHARDWARE
$SFX::DEVICE_INFO_MAXBUFFERS
$SFX::DEVICE_INFO_CAPS
$SFX::DEVICE_CAPS_REVERB
$SFX::DEVICE_CAPS_VOICEMANAGEMENT
$SFX::DEVICE_CAPS_OCCLUSION
$SFX::DEVICE_CAPS_DSPEFFECTS
$SFX::DEVICE_CAPS_MULTILISTENER
$SFX::DEVICE_CAPS_FMODDESIGNER

Providers and Devices

SFXDistanceModel sfxGetDistanceModel ( )

Get the falloff curve type currently being applied to 3D sounds.

Returns:
The current distance model type.

Volume Attenuation

3D Audio

float sfxGetDopplerFactor ( )

Get the current global doppler effect setting.

Returns:
The current global doppler effect scale factor (>=0).
See also:
sfxSetDopplerFactor

Doppler Effect

float sfxGetRolloffFactor ( )

Get the current global scale factor applied to volume attenuation of 3D sounds in the logarithmic model.

Returns:
The current scale factor for logarithmic 3D sound falloff curves.
See also:
sfxGetDistanceModel
SFXDistanceModel

Volume Attenuation 3D Audio

SFXSource sfxPlay ( SFXSource source )

Start playback of the given source.

This is the same as calling SFXSource::play() directly.

Parameters:
source The source to start playing.
Returns:
source.
Example:
// Create and play a source from a pre-existing profile:
%source = sfxCreateSource( SoundFileProfile );
%source.play();
void sfxPlay ( SFXTrack track )

Create a new play-once source for the given track and start playback of the source.

This is equivalent to calling sfxCreateSource() on and SFXSource::play() on the resulting source.

Parameters:
track The sound datablock to play.
Returns:
The newly created play-once source or 0 if the creation failed.

Play-Once Sources

void sfxPlay | ( | SFXTrack | track,
 |  | float | x,
 |  | float | y,
 |  | float | z
 | ) |  |

Create a new play-once source for the given track, position its 3D sound at the given coordinates (if the track's description is set up for 3D sound) and start playback of the source.

This is equivalent to calling sfxCreateSource() on and SFXSource::play() on the resulting source.

Parameters:
track | The sound datablock to play.
x | The X coordinate of the 3D sound position.
y | The Y coordinate of the 3D sound position.
z | The Z coordinate of the 3D sound position.
Returns:
The newly created play-once source or 0 if the creation failed.

Play-Once Sources

SFXSource sfxPlayOnce ( SFXTrack track )

Create a play-once source for the given track.

Once playback has finished, the source will be automatically deleted in the next sound system update.

Parameters:
track The sound datablock.
Returns:
A newly created temporary source in "Playing" state or 0 if the operation failed.

Play-Once Sources

SFXSource sfxPlayOnce | ( | SFXTrack | track,
 |  | float | x,
 |  | float | y,
 |  | float | z,
 |  | float | fadeInTime = -1
 | ) |  |

Create a play-once source for the given given track and position the source's 3D sound at the given coordinates only if the track's description is set up for 3D sound).

Once playback has finished, the source will be automatically deleted in the next sound system update.

Parameters:
track | The sound datablock.
x | The X coordinate of the 3D sound position.
y | The Y coordinate of the 3D sound position.
z | The Z coordinate of the 3D sound position.
fadeInTime | If >=0, this overrides the SFXDescription::fadeInTime value on the track's description.
Returns:
A newly created temporary source in "Playing" state or 0 if the operation failed.
Example:
// Immediately start playing the given track.  Fade it in to full volume over 5 seconds.
sfxPlayOnce( MusicTrack, 0, 0, 0, 5.f );

Play-Once Sources

SFXSource sfxPlayOnce | ( | SFXDescription | description,
 |  | string | filename
 | ) |  |

Create a new temporary SFXProfile from the given description and filename, then create a play-once source for it and start playback.

Once playback has finished, the source will be automatically deleted in the next sound system update. If not referenced otherwise by then, the temporary SFXProfile will also be deleted.

Parameters:
description | The description to use for playback.
filename | Path to the sound file to play.
Returns:
A newly created temporary source in "Playing" state or 0 if the operation failed.
Example:
// Play a sound effect file once.
sfxPlayOnce( AudioEffects, "art/sound/weapons/Weapon_pickup" );

Play-Once Sources

SFXSource sfxPlayOnce | ( | SFXDescription | description,
 |  | string | filename,
 |  | float | x,
 |  | float | y,
 |  | float | z,
 |  | float | fadeInTime = -1
 | ) |  |

Create a new temporary SFXProfile from the given description and filename, then create a play-once source for it and start playback. Position the source's 3D sound at the given coordinates (only if the description is set up for 3D sound).

Once playback has finished, the source will be automatically deleted in the next sound system update. If not referenced otherwise by then, the temporary SFXProfile will also be deleted.

Parameters:
description | The description to use for playback.
filename | Path to the sound file to play.
x | The X coordinate of the 3D sound position.
y | The Y coordinate of the 3D sound position.
z | The Z coordinate of the 3D sound position.
fadeInTime | If >=0, this overrides the SFXDescription::fadeInTime value on the track's description.
Returns:
A newly created temporary source in "Playing" state or 0 if the operation failed.
Example:
// Play a sound effect file once using a 3D sound with a default falloff placed at the origin.
sfxPlayOnce( AudioDefault3D, "art/sound/weapons/Weapon_pickup", 0, 0, 0 );

Play-Once Sources

void sfxSetDistanceModel ( SFXDistanceModel model )

Set the falloff curve type to use for distance-based volume attenuation of 3D sounds.

Parameters:
model The distance model to use for 3D sound.
Note:
This setting takes effect globally and is applied to all 3D sounds.
void sfxSetDopplerFactor ( float value )

Set the global doppler effect scale factor.

Parameters:
value The new doppler shift scale factor.
Precondition:
value must be >= 0.
See also:
sfxGetDopplerFactor

Doppler Effect

void sfxSetRolloffFactor ( float value )

Set the global scale factor to apply to volume attenuation of 3D sounds in the logarithmic model.

Parameters:
value The new scale factor for logarithmic 3D sound falloff curves.
Precondition:
value must be > 0.
Note:
This function has no effect if the currently distance model is set to SFXDistanceModel::Linear.
See also:
sfxGetDistanceModel
SFXDistanceModel

Volume Attenuation 3D Audio

void sfxStop ( SFXSource source )

Stop playback of the given source.

This is equivalent to calling SFXSource::stop().

Parameters:
source The source to put into stopped state.
void sfxStopAndDelete ( SFXSource source )

Stop playback of the given source (if it is not already stopped) and delete the source.

The advantage of this function over directly calling delete() is that it will correctly handle volume fades that may be configured on the source. Whereas calling delete() would immediately stop playback and delete the source, this functionality will wait for the fade-out to play and only then stop the source and delete it.

Parameters:
source A sound source.

Volume Fades

Variable Documentation

int $SFX::ambientUpdateTime

Milliseconds spent on the last ambient audio update.

Sound System Updates

Ambient Audio

int $SFX::DEVICE_CAPS_DSPEFFECTS

Sound device capability flag indicating that the sound device supports adding DSP effect chains to sounds.

See also:
sfxGetDeviceInfo
Note:
This is not yet used by the sound system.
See also:
sfxGetDeviceInfo
int $SFX::DEVICE_CAPS_FMODDESIGNER

Sound device capability flag indicating that the sound device supports FMOD Designer audio projects.

Note:
This is exclusive to FMOD. If the FMOD Event DLLs are in place and could be successfully loaded, this flag will be set after initializating an FMOD audio device.
See also:
sfxGetDeviceInfo

FMOD Designer Audio

int $SFX::DEVICE_CAPS_MULTILISTENER

Sound device capability flag indicating that the sound device supports multiple concurrent listeners.

Note:
Currently only FMOD implements this.
See also:
sfxGetDeviceInfo
int $SFX::DEVICE_CAPS_OCCLUSION

Sound device capability flag indicating that the sound device implements sound occlusion.

Note:
This is not yet used by the sound system.
See also:
sfxGetDeviceInfo
int $SFX::DEVICE_CAPS_REVERB

Sound device capability flag indicating that the sound device supports reverb.

Note:
Currently only FMOD implements this.
See also:
sfxGetDeviceInfo

Audio Reverb

int $SFX::DEVICE_CAPS_VOICEMANAGEMENT

Sound device capability flag indicating that the sound device implements its own voice virtualization.

For these devices, the sound system will deactivate its own voice management and leave voice virtualization entirely to the device.

Note:
Currently only FMOD implements this.
See also:
sfxGetDeviceInfo

Sounds and Voices

int $SFX::DEVICE_INFO_CAPS

Index of device capability flags in device info string.

See also:
sfxGetDeviceInfo
sfxGetAvailableDevices
int $SFX::DEVICE_INFO_MAXBUFFERS

Index of buffer limit number in device info string.

See also:
sfxGetDeviceInfo
sfxGetAvailableDevices
int $SFX::DEVICE_INFO_NAME

Index of device name field in device info string.

See also:
sfxGetDeviceInfo
sfxGetAvailableDevices
int $SFX::DEVICE_INFO_PROVIDER

Index of sound provider field in device info string.

See also:
sfxGetDeviceInfo
sfxGetAvailableDevices
int $SFX::DEVICE_INFO_USEHARDWARE

Index of use hardware flag in device info string.

See also:
sfxGetDeviceInfo
sfxGetAvailableDevices
int $SFX::numCulled

Number of SFXSounds that are currently in virtualized playback mode.

Sounds and Voices

int $SFX::numPlaying

Number of SFXSources that are currently in playing state.

int $SFX::numSounds

Number of SFXSound type objects (i.e. actual single-file sounds) that are currently instantiated.

int $SFX::numSources

Number of SFXSource type objects that are currently instantiated.

int $SFX::numVoices

Number of voices that are currently allocated on the sound device.

int $SFX::parameterUpdateTime

Milliseconds spent on the last SFXParameter update loop.

Sound System Updates

Interactive Audio

ColorI SFXEmitter::renderColorInnerCone [static, inherited]

The color with which to render dots in the inner sound cone (Editor only).

ColorI SFXEmitter::renderColorOuterCone [static, inherited]

The color with which to render dots in the outer sound cone (Editor only).

ColorI SFXEmitter::renderColorOutsideVolume [static, inherited]

The color with which to render dots outside of the outer sound cone (Editor only).

ColorI SFXEmitter::renderColorPlayingInRange [static, inherited]

The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is playing and in range of the listener.

ColorI SFXEmitter::renderColorPlayingOutOfRange [static, inherited]

The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is playing but out of the range of the listener.

ColorI SFXEmitter::renderColorRangeSphere [static, inherited]

The color of the range sphere with which to render sound emitters in the editor.

ColorI SFXEmitter::renderColorStoppedInRange [static, inherited]

The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is not playing but the emitter is in range of the listener.

ColorI SFXEmitter::renderColorStoppedOutOfRange [static, inherited]

The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is not playing and the emitter is out of range of the listener.

bool SFXEmitter::renderEmitters [static, inherited]

Whether to render enhanced range feedback in the editor on all emitters regardless of selection state.

float SFXEmitter::renderPointDistance [static, inherited]

The distance between individual points in the sound emitter rendering in the editor as the points move from the emitter's center away to maxDistance.

float SFXEmitter::renderRadialIncrements [static, inherited]

The stepping (in degrees) for the radial sweep along the axis of the XY plane sweep for sound emitter rendering in the editor.

float SFXEmitter::renderSweepIncrements [static, inherited]

The stepping (in degrees) for the radial sweep on the XY plane for sound emitter rendering in the editor.

int $SFX::sourceUpdateTime

Milliseconds spent on the last SFXSource update loop.

Sound System Updates

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: FMOD

FMOD
[Sound]

Functionality specific to the FMOD SFX implementation. More...

Classes

class | SFXFMODEvent
A playable sound event in an FMOD Designer audio project. More...
class | SFXFMODEventGroup
A group of events in an imported FMOD Designer project. More...
class | SFXFMODEventSource
A sound source controller playing an FMOD Designer event (SFXFMODEvent). More...
class | SFXFMODProject
An FMOD Designer project loaded into Torque. More...

Functions

void | fmodDumpDSPInfo ()
Dump information about the standard DSP effects.
void | fmodDumpMemoryStats ()

Variables

bool | $pref::SFX::FMOD::disableSoftware
Whether to disable the FMOD software mixer to conserve memory.
string | $pref::SFX::FMOD::DSoundHRTF
The type of HRTF to use for hardware-mixed 3D sounds when FMOD is using DirectSound for sound output and hardware-acceleration is not available.
bool | $pref::SFX::FMOD::enableProfile
Whether to enable support for FMOD's profiler.
int | $SFX::Device::fmodCoreMem
Current number of bytes allocated by the core FMOD sound system.
int | $SFX::Device::fmodEventMem
Current number of bytes allocated by the FMOD Designer event system.
int | $SFX::Device::fmodNumEventSources
The current number of SFXFMODEventSource instances in the system.
string | $pref::SFX::FMOD::pluginPath
Path to additional FMOD plugins.
bool | $pref::SFX::FMOD::useSoftwareHRTF
Whether to enable HRTF in FMOD's software mixer.
bool | $pref::SFX::FMOD::useSoftwareReverbLowmem
If true, FMOD's SFX reverb is run using 22/24kHz delay buffers, halving the memory required.

Detailed Description

Functionality specific to the FMOD SFX implementation.

When using FMOD for audio output in combination with Torque's sound system, an extended set of features is available to the user. This includes:

  • Reverb support
  • Enhanced voice virtualization
  • Support for multiple listeners
  • Enhanced sound format support
    • .aiff
    • .asf
    • .asx
    • .dls
    • .flac
    • .fsb
    • .it
    • .m3u
    • .mid
    • .mod
    • .mp2
    • .mp3
    • .ogg
    • .pls
    • .s3m
    • .vag
    • .wav
    • .wax
    • .wma
    • .xm
    • .xma (on Xbox only)
  • FMOD Designer enhanced audio design support
See also:
http://www.fmod.org

FMOD Designer Audio

Using the FMOD Profiler with Torque

FMOD's profiler tool allows to inspect the operation of the FMOD sound system at runtime. To use the tool with Torque, set $pref::SFX::FMOD::enableProfile to true and either restart Torque or reinitialize the FMOD device (e.g. by switching back and forth to the device). After that, you can connect to the running Torque instance from within the FMOD profiler tool.

Function Documentation

void fmodDumpDSPInfo ( )

Dump information about the standard DSP effects.

void fmodDumpMemoryStats ( )
Returns:
Prints the current memory consumption of the FMOD module

Variable Documentation

bool $pref::SFX::FMOD::disableSoftware

Whether to disable the FMOD software mixer to conserve memory.

All sounds not created with SFXDescription::useHardware or using DSP effects will fail to load.

Note:
Only applies when using an FMOD sound device.
string $pref::SFX::FMOD::DSoundHRTF

The type of HRTF to use for hardware-mixed 3D sounds when FMOD is using DirectSound for sound output and hardware-acceleration is not available.

Options are

  • "none": simple stereo panning/doppler/attenuation
  • "light": slightly higher quality than "none"
  • "full": full quality 3D playback
Note:
Only applies when using an FMOD sound device.
bool $pref::SFX::FMOD::enableProfile

Whether to enable support for FMOD's profiler.

Note:
Only applies when using an FMOD sound device.

Using the FMOD Profiler with Torque

int $SFX::Device::fmodCoreMem

Current number of bytes allocated by the core FMOD sound system.

Note:
Only relevant if an FMOD sound device is used.
int $SFX::Device::fmodEventMem

Current number of bytes allocated by the FMOD Designer event system.

Note:
Only relevant if an FMOD sound device is used and the FMOD event DLL is loaded.
int $SFX::Device::fmodNumEventSources

The current number of SFXFMODEventSource instances in the system.

This tells the number of sounds in the system that are currently playing FMOD Designer events.

Note:
Only relevant if an FMOD sound device is used.
string $pref::SFX::FMOD::pluginPath

Path to additional FMOD plugins.

Note:
Only applies when using an FMOD sound device.
bool $pref::SFX::FMOD::useSoftwareHRTF

Whether to enable HRTF in FMOD's software mixer.

This will add a lowpass filter effect to the DSP effect chain of all sounds mixed in software.

Note:
Only applies when using an FMOD sound device.
bool $pref::SFX::FMOD::useSoftwareReverbLowmem

If true, FMOD's SFX reverb is run using 22/24kHz delay buffers, halving the memory required.

Note:
Only applies when using an FMOD sound device.


Torque 3D - Script Manual: Class List

Class List

Here are the classes, structs, unions and interfaces with brief descriptions:
ActionMap | ActionMaps assign platform input events to console commands
AdvancedLightBinManager | Rendering Manager responsible for lighting, shadows, and global variables affecing both
AIClient | Simulated client driven by AI commands
AIConnection | Special client connection driven by an AI, rather than a human
AIPlayer | A Player object not controlled by conventional input, but by an AI engine
ArrayObject | Data structure for storing indexed sequences of key/value pairs
BanList | Used for kicking and banning players from a server. There is only a single instance of BanList. It is very important to note that you do not ever create this object in script like you would other game play objects. You simply reference it via namespace
BasicClouds | Renders up to three layers of scrolling cloud-cover textures overhead
Camera | Represents a position, direction and field of view to render a scene from
CameraData | A datablock that describes a camera
CloudLayer | A layer of clouds which change shape over time and are affected by scene lighting
ConsoleLogger |
ConvexShape | A renderable, collidable convex shape defined by a collection of surface planes
CubemapData | Used to create static or dynamic cubemaps
CustomMaterial | Material object which provides more control over surface properties
Debris | Base debris class. Uses the DebrisData datablock for properties of individual debris objects
DebrisData | Stores properties for an individual debris type
DebugDrawer | A debug helper for rendering debug primitives to the scene
DecalData | A datablock describing an individual decal
DecalManager | All decals are managed by the decal manager. Provides a few global variables for managing the number of decals that are visible at any one time and the lifetime of the decal
DecalRoad | A strip shaped decal defined by spine nodes which clips against Terrain objects
EditorIconRegistry | This class is used to find the correct icon file path for different SimObject class types
EventManager | Wrapper for the standard messaging system
Explosion | The emitter for an explosion, whose properties are defined in an ExplosionData object
ExplosionData | The data on what an explosion should look like. Definesa particle data, debris data, affects the lighting conditions in the region of the explosion, and shakes the camera
FileDialog | Base class responsible for displaying an OS file browser
FileObject | This class is responsible opening, reading, creating, and saving file contents
FileStreamObject | A wrapper around StreamObject for parsing text and data from files
FlyingVehicle | A flying vehicle
FlyingVehicleData | Defines the properties of a FlyingVehicle
Forest | Forest is a global-bounds scene object provides collision and rendering for a (.forest) data file
ForestBrushElement | Represents a type of ForestItem and parameters for how it is placed when painting with a ForestBrush that contains it
ForestItemData | Base class for defining a type of ForestItem. It does not implement loading or rendering of the shapeFile
ForestWindEmitter | Object responsible for simulating wind in a level
fxFoliageReplicator | An emitter to replicate fxFoliageItem objects across an area
fxShapeReplicatedStatic | The object definition for shapes that will be replicated across an area using an fxShapeReplicator
fxShapeReplicator | An emitter for objects to replicate across an area
GameBase | Base class for game objects which use datablocks, networking, are editable, and need to process ticks
GameBaseData | Scriptable, demo-able datablock. Used by GameBase objects
GameConnection | The game-specific subclass of NetConnection
GameTSCtrl | The main 3D viewport for a Torque 3D game
GFXCardProfiler | Provides a device independent wrapper around both the capabilities reported by the card/drivers and the exceptions recorded in various scripts
GFXCardProfilerAPI | This class is the interface between TorqueScript and GFXCardProfiler
GFXInit | Functions for tracking GFX adapters and initializing them into devices
GFXSamplerStateData | A sampler state used by GFXStateBlockData
GFXStateBlockData | A state block description for rendering
GroundCover | Covers the ground in a field of objects (IE: Grass, Flowers, etc)
GroundPlane | An infinite plane extending in all direction
GuiArrayCtrl |
GuiAutoScrollCtrl | A container that scrolls its child control up over time
GuiBitmapBorderCtrl | A control that renders a skinned border specified in its profile
GuiBitmapButtonCtrl | A button that renders its various states (mouse over, pushed, etc.) from separate bitmaps
GuiBitmapButtonTextCtrl | An extension of GuiBitmapButtonCtrl that additionally renders a text label on the bitmapped button
GuiBitmapCtrl | A gui control that is used to display an image
GuiBorderButtonCtrl | A push button that renders only a border
GuiBubbleTextCtrl | A single-line text control that displays its text in a multi-line popup when clicked
GuiButtonBaseCtrl | The base class for the various button controls
GuiButtonCtrl | The most widely used button class
GuiCanvas | A canvas on which rendering occurs
GuiCheckBoxCtrl | A named checkbox that can be toggled on and off
GuiChunkedBitmapCtrl | This is a control that will render a specified bitmap or a bitmap specified in a referenced variable
GuiClockHud | Basic HUD clock. Displays the current simulation time offset from some base
GuiConsole | The on-screen, in-game console. Calls getLog() to get the on-screen console entries, then renders them as needed
GuiConsoleEditCtrl | Text entry element of a GuiConsole
GuiContainer | Brief Desc
GuiControl | Base class for all Gui control objects
GuiControlArrayControl | Brief Desc
GuiControlProfile | A collection of properties that determine control behavior and rendering
GuiCrossHairHud | Basic cross hair hud. Reacts to state of control object. Also displays health bar for named objects under the cross hair
GuiCursor | Acts as a skin for the cursor, where each GuiCursor object can have its own look and click-zone
GuiDirectoryFileListCtrl | A control that displays a list of files from within a single directory in the game file system
GuiDragAndDropControl | A container control that can be used to implement drag&drop behavior
GuiDynamicCtrlArrayControl | A container that arranges children into a grid
GuiFadeinBitmapCtrl | A GUI control which renders a black square over a bitmap image. The black square will fade out, then fade back in after a determined time. This control is especially useful for transitions and splash screens
GuiFrameSetCtrl | A gui control allowing a window to be subdivided into panes, each of which displays a gui control child of the GuiFrameSetCtrl
GuiGameListMenuCtrl | A base class for cross platform menu controls that are gamepad friendly
GuiGameListMenuProfile | A GuiControlProfile with additional fields specific to GuiGameListMenuCtrl
GuiGameListOptionsCtrl | A control for showing pages of options that are gamepad friendly
GuiGameListOptionsProfile | A GuiControlProfile with additional fields specific to GuiGameListOptionsCtrl
GuiGraphCtrl | A control that plots one or more curves in a chart
GuiHealthBarHud | A basic health bar. Shows the damage value of the current PlayerObjectType control object
GuiIconButtonCtrl | Draws the bitmap within a special button control. Only a single bitmap is used and the button will be drawn in a highlighted mode when the mouse hovers over it or when it has been clicked
GuiInputCtrl | A control that locks the mouse and reports all keyboard input events to script
GuiListBoxCtrl | A list of text items
GuiMenuBar | GUI Control which displays a horizontal bar with individual drop-down menu items. Each menu item may also have submenu items
GuiMessageVectorCtrl | A chat HUD control that displays messages from a MessageVector
GuiMLTextCtrl | A text control that uses the Gui Markup Language ('ML') tags to dynamically change the text
GuiMLTextEditCtrl | A text entry control that accepts the Gui Markup Language ('ML') tags and multiple lines
GuiMouseEventCtrl | Used to overlaps a 'hot region' where you want to catch inputs with and have specific events occur based on individual callbacks
GuiObjectView | GUI control which displays a 3D model
GuiPaneControl | A collapsable pane control
GuiPanel | The GuiPanel panel is a container that when opaque will draw a left to right gradient using its profile fill and fill highlight colors
GuiPopUpMenuCtrl | A control that allows to select a value from a drop-down list
GuiPopUpMenuCtrlEx | A control that allows to select a value from a drop-down list
GuiProgressBitmapCtrl | A horizontal progress bar rendered from a repeating image
GuiProgressCtrl | GUI Control which displays a horizontal bar which increases as the progress value of 0.0 - 1.0 increases
GuiRadioCtrl | A button based around the radio concept
GuiRolloutCtrl | A container that shows a single child with an optional header bar that can be used to collapse and expand the rollout
GuiScriptNotifyCtrl | A control which adds several reactions to other GUIs via callbacks
GuiScrollCtrl | A container that allows to view one or more possibly larger controls inside its area by providing horizontal and/or vertical scroll bars
GuiSeparatorCtrl | A control that renders a horizontal or vertical separator with an optional text label (horizontal only)
GuiShapeNameHud | Displays name and damage of ShapeBase objects in its bounds. Must be a child of a GuiTSCtrl and a server connection must be present
GuiSliderCtrl | A control that displays a value between its minimal and maximal bounds using a slider placed on a vertical or horizontal axis
GuiSpeedometerHud | Displays the speed of the current Vehicle based control object
GuiSplitContainer | A container that splits its area between two child controls
GuiStackControl | A container that stacks its children horizontally or vertically
GuiSwatchButtonCtrl | A button that is used to represent color; often used in correlation with a color picker
GuiTabBookCtrl | A container
GuiTabPageCtrl | A single page in a GuiTabBookCtrl
GuiTextCtrl | GUI control object this displays a single line of text, without TorqueML
GuiTextEditCtrl | A component that places a text entry box on the screen
GuiTextEditSliderBitmapCtrl | GUI Control which displays a numerical value which can be increased or decreased using a pair of bitmap up/down buttons
GuiTextEditSliderCtrl | GUI Control which displays a numerical value which can be increased or decreased using a pair of arrows
GuiTextListCtrl | GUI control that displays a list of text. Text items in the list can be individually selected
GuiTheoraCtrl | A control to playing Theora videos
GuiTickCtrl | Brief Description
GuiToggleButtonCtrl | Deprecated gui control
GuiTreeViewCtrl | Hierarchical list of text items with optional icons
GuiTSCtrl | Abstract base class for controls that render 3D scenes
GuiWindowCtrl | A window with a title bar and an optional set of buttons
HoverVehicle | A hovering vehicle
HoverVehicleData | Defines the properties of a HoverVehicle
HTTPObject | Allows communications between the game and a server using HTTP protocols
InteriorInstance | Object used to represent buildings and other architectural structures (legacy)
Item | Base Item class. Uses the ItemData datablock for common properties
ItemData | Stores properties for an individual Item type
LangTable | Provides the code necessary to handle the low level management of the string tables for localization
LevelInfo | Stores and controls the rendering and status information for a game level
LightAnimData | A datablock which defines and performs light animation, such as rotation, brightness fade, and colorization
LightBase | This is the base class for light objects
LightDescription | A helper datablock used by classes (such as shapebase) that submit lights to the scene but do not use actual "LightBase" objects
LightFlareData | Defines a light flare effect usable by scene lights
Lightning | An individual lightning bolt, created from a LightningData object
LightningData | An emitter for Lightning objects
LightningStrikeEvent | A lightning bolt strike, called from strikeRandomPoint or strikeObject method on Lightning
Marker | A single joint, or knot, along a path. Should be stored inside a Path container object. A path markers can be one of three primary movement types: "normal", "Position Only", or "Kink"
Material | A material in Torque 3D is a data structure that describes a surface
MeshRoad | A strip of rectangular mesh segments defined by a 3D spline for prototyping road-shaped objects in your scene
Message | Base class for messages
MessageForwarder | Forward messages from one queue to another
MessageVector | Store a list of chat messages
MissionArea | Level object which defines the boundaries of the level
MissionMarker | This is a base class for all "marker" related objets. It is a 3D representation of a point in the level
MissionMarkerData | A very basic class containing information used by MissionMarker objects for rendering
NetConnection | Provides the basis for implementing a multiplayer game protocol
NetObject | Superclass for all ghostable networked objects
OcclusionVolume |
OpenFileDialog | Derived from FileDialog, this class is responsible for opening a file browser with the intention of opening a file
OpenFolderDialog | OS level dialog used for browsing folder structures
ParticleData | Contains information for how specific particles should look and react including particle colors, particle imagemap, acceleration value for individual particles and spin information
ParticleEmitter | This object is responsible for all particle emissions
ParticleEmitterData | Acts as the physical point in space in white Particles are created from. Also manages how to fire particles, including velocity, offset and length of firing (or 'ejection')
ParticleEmitterNode | Manages timing update information for the assigned particleEmitter. Particles can be assigned to this emitter through the method setEmitterDataBlock(particleEmitterDatablock)
ParticleEmitterNodeData | Contains the timeMuliplier information to be assigned to a ParticleEmitterNode. The time multiplayer value for the ParticleEmitterNodeData can be set with nodeData.timeMultiple = value;
Path | A spline along which various objects can move along. The spline object acts like a container for Marker objects, which make up the joints, or knots, along the path. Paths can be assigned a speed, can be looping or non-looping. Each of a path's markers can be one of three primary movement types: "normal", "Position Only", or "Kink"
PathCamera | A camera that moves along a path. The camera can then be made to travel along this path forwards or backwards
PathCameraData | General interface to control a PathCamera object from the script level
PfxVis | Singleton class that exposes ConsoleStaticFunctions for debug visualizing PostEffects
PhysicalZone | Physical Zones are areas that modify the player's gravity and/or velocity and/or applied force
PhysicsDebris | Represents one or more rigid bodies defined in a single mesh file with a limited lifetime
PhysicsDebrisData | Defines the properties of a type of PhysicsDebrisData
PhysicsForce | Helper object for gameplay physical forces. WIP
PhysicsShape | Represents a destructible physical object simulated through the plugin system
PhysicsShapeData | Defines the properties of a type of PhysicsShape
Player | A client-controlled player character
PlayerData | Defines properties for a Player object
PointLight | Lighting object that radiates light in all directions
Portal | An object that provides a "window" into a zone, allowing a viewer to see what's rendered in the zone
PostEffect | A fullscreen shader effect
Precipitation | Defines a precipitation based storm (IE: rain, snow, etc.)
PrecipitationData | Defines the droplets used in a storm (IE: raindrops, snowflakes, etc.)
Prefab | A collection of arbitrary objects which can be allocated and manipulated as a group
Projectile | Base projectile class. Uses the ProjectileData class for properties of individual projectiles
ProjectileData | Stores properties for an individual projectile type
PxCloth | Rectangular patch of cloth simulated by PhysX
PxMaterial | Defines a PhysX material assignable to PxMultiActorData
PxMultiActor | Represents a destructible physical object simulated using PhysX
PxMultiActorData | Defines the properties of a type of PxMultiActor
RadialImpulseEvent | Creates a physics based impulse effect from a defined central point and magnitude
ReflectorDesc | A datablock which defines performance and quality properties for dynamic reflections
RenderBinManager | The abstract base for all render bins
RenderFormatToken | Used to change the render target format when rendering in AL
RenderGlowMgr | A render bin for the glow pass
RenderImposterMgr | A render bin for batch rendering imposters
RenderMeshExample | An example scene object which renders a mesh
RenderMeshMgr | A render bin for mesh rendering
RenderObjectExample | An example scene object which renders using a callback
RenderObjectMgr | A render bin which uses object callbacks for rendering
RenderOcclusionMgr | A render bin which renders occlusion query requests
RenderParticleMgr | A render bin which renders particle geometry
RenderPassManager | A grouping of render bin managers which forms a render pass
RenderPassStateBin | A non-rendering render bin used to enable/disable a RenderPassStateToken
RenderPassStateToken | Abstract base class for RenderFormatToken, used to manipulate what goes on in the render manager
RenderPrePassMgr | The render bin which performs a z+normals prepass used in Advanced Lighting
RenderShapeExample | An example scene object which renders a DTS
RenderTerrainMgr | A render bin for terrain mesh rendering
RenderTexTargetBinManager | An abstract base class for render bin managers that render to a named textue target
RenderTranslucentMgr | A render bin for rendering translucent meshes
RigidShape | Implements rigid-body physics for DTS objects in the world
RigidShapeData | Defines the physics properties for an individual RigidShapeData physics object
River | A water volume defined by a 3D spline
SaveFileDialog | Derived from FileDialog, this class is responsible for opening a file browser with the intention of saving a file
ScatterSky | Represents both the sun and sky for scenes with a dynamic time of day
SceneObject | A networkable object that exists in the 3D world
ScriptGroup | Essentially a SimGroup, but with onAdd and onRemove script callbacks
ScriptMsgListener | Script accessible version of Dispatcher::IMessageListener. Often used in conjunction with EventManager
ScriptObject | A script-level OOP object which allows binding of a class, superClass and arguments along with declaration of methods
SFXAmbience | A datablock that describes an ambient sound space
SFXController | A sound source that drives multi-source playback
SFXDescription | A description for how a sound should be played
SFXEmitter | An invisible 3D object that emits sound
SFXEnvironment | Description of a reverb environment
SFXFMODEvent | A playable sound event in an FMOD Designer audio project
SFXFMODEventGroup | A group of events in an imported FMOD Designer project
SFXFMODEventSource | A sound source controller playing an FMOD Designer event (SFXFMODEvent)
SFXFMODProject | An FMOD Designer project loaded into Torque
SFXParameter | A sound channel value that can be bound to multiple sound sources
SFXPlayList | A datablock describing a playback pattern of sounds
SFXProfile | Encapsulates a single sound file for playback by the sound system
SFXSound | A sound controller that directly plays a single sound file
SFXSource | Playback controller for a sound source
SFXSpace | A volume in space that defines an ambient sound zone
SFXState | A boolean switch used to modify playlist behavior
SFXTrack | Abstract base class for sound data that can be played back by the sound system
ShaderData | Special type of data block that stores information about a handwritten shader
ShapeBase | A scriptable, renderable shape
ShapeBaseData | Defines properties for a ShapeBase object
ShapeBaseImageData | Represents geometry to be mounted to a ShapeBase object
SimDataBlock | Root DataBlock class
SimGroup | A collection of SimObjects that are owned by the group
SimObject | Base class for almost all objects involved in the simulation
SimpleMessageEvent | A very simple example of a network event used by SimpleNetObject
SimpleNetObject | A very simple example of a class derived from NetObject
SimSet | A collection of SimObjects
SimXMLDocument | File I/O object used for creating, reading, and writing XML documents
SkyBox | Represents the sky with an artist-created cubemap
SpawnSphere | This class is used for creating any type of game object, assigning it a class, datablock, and even a function when it is spawned
Splash | Manages the ring used for a Splash effect
SplashData | Acts as the physical point in space in white a Splash is created from
SpotLight | Lighting object which emits conical light in a direction
StaticShape | The most basic 3D shape with a datablock available in Torque 3D
StaticShapeData | The most basic ShapeBaseData derrived shape datablock available in Torque 3D
StreamObject | Base class for working with streams
Sun | A global light affecting your entire scene and optionally renders a corona effect
TCPObject | Allows communications between the game and a server using TCP/IP protocols
TerrainBlock | Represent a terrain object in a Torque 3D level
TerrainMaterial | Orginizes the material settings for a single terrain material layer
TimeOfDay | Environmental object that triggers a day/night cycle in level
Trigger | A Trigger is a volume of space that initiates script callbacks when objects pass through the Trigger
TriggerData | Defines shared properties for Trigger objects
TSForestItemData | Concrete implementation of ForestItemData which loads and renders dts format shapeFiles
TSShapeConstructor | An object used to modify a DTS or COLLADA shape model after it has been loaded by Torque
TSStatic | A static object derived from a 3D model file and placed within the game world
Vehicle | Base functionality shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle
VehicleData | Base properties shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle
WaterBlock | A block shaped water volume defined by a 3D scale and orientation
WaterObject | Abstract base class for representing a body of water
WaterPlane | Represents a large body of water stretching to the horizon in all directions
WayPoint | Special type of marker, distinguished by a name and team ID number
WheeledVehicle | A wheeled vehicle
WheeledVehicleData | Defines the properties of a WheeledVehicle
WheeledVehicleSpring | Defines the properties of a WheeledVehicle spring
WheeledVehicleTire | Defines the properties of a WheeledVehicle tire
ZipObject | Provides access to a zip file
Zone | An object that culls the rendering of everything contained within it


Torque 3D - Script Manual: ActionMap Class Reference

ActionMap Class Reference
[Input Management]

ActionMaps assign platform input events to console commands. More...

Inheritance diagram for ActionMap:
[legend]

List of all members.

Public Member Functions

bool | bind (string device, string action, string command)
Associates a function to an input event.
bool | bind (string device, string action, string flag, string deadZone, string scale, string command)
Associates a function and input parameters to an input event.
bool | bindCmd (string device, string action, string makeCmd, string breakCmd="")
Associates a make command and optional break command to a specified input device action.
bool | bindObj (string device, string action, string command, SimObjectID object)
Associates a function to an input event for a specified class or object.
bool | bindObj (string device, string action, string flag, string deadZone, string scale, string command, SimObjectID object)
Associates a function to an input event for a specified class or object.
string | getBinding (string command)
Gets the ActionMap binding for the specified command.
string | getCommand (string device, string action)
Gets ActionMap command for the device and action.
string | getDeadZone (string device, string action)
Gets the Dead zone for the specified device and action.
float | getScale (string device, string action)
Get any scaling on the specified device and action.
bool | isInverted (string device, string action)
Determines if the specified device and action is inverted.
void | pop ()
Pop the ActionMap off the ActionMap stack.
void | push ()
Push the ActionMap onto the ActionMap stack.
void | save (string fileName=NULL, bool append=false)
Saves the ActionMap to a file or dumps it to the console.
bool | unbind (string device, string action)
Removes the binding on an input device and action.
bool | unbindObj (string device, string action, string obj)
Remove any object-binding on an input device and action.

Detailed Description

ActionMaps assign platform input events to console commands.

Any platform input event can be bound in a single, generic way. In theory, the game doesn't need to know if the event came from the keyboard, mouse, joystick or some other input device. This allows users of the game to map keys and actions according to their own preferences. Game action maps are arranged in a stack for processing so individual parts of the game can define specific actions. For example, when the player jumps into a vehicle it could push a vehicle action map and pop the default player action map.

Creating an ActionMap

The input system allows for the creation of multiple ActionMaps, so long as they have unique names and do not already exist. It's a simple three step process.

1. Check to see if the ActionMap exists 2. Delete it if it exists 3. Instantiate the ActionMap

The following is an example of how to create a new ActionMap:

Example:
if ( isObject( moveMap ) )
   moveMap.delete();
new ActionMap(moveMap);

Binding Functions

Once you have created an ActionMap, you can start binding functionality to events. Currently, Torque 3D supports the following devices out of the box

Mouse

Keyboard

Joystick/Gamepad

Xbox 360 Controller

The two most commonly used binding methods are bind() and bindCmd(). Both are similar in that they will bind functionality to a device and event, but different in how the event is interpreted. With bind(), you specify a device, action to bind, then a function to be called when the event happens.

Example:
// Simple function that prints to console
// %val - Sent by the device letting the user know
// if an input was pressed (true) or released (false)
function testInput(%val)
{
   if(%val)
     echo("Key is down");
   else
     echo("Key was released");
}

// Bind the 'K' key to the testInput function
moveMap.bind(keyboard, "k", testInput);

bindCmd is an alternative method for binding commands. This function is similar to bind(), except two functions are set to be called when the event is processed.

One will be called when the event is activated (input down), while the other is activated when the event is broken (input release). When using bindCmd(), pass the functions as strings rather than the function names.

Example:
// Print to the console when the spacebar is pressed
function onSpaceDown()
{
   echo("Space bar down!");
}

// Print to the console when the spacebar is released
function onSpaceUp()
{
   echo("Space bar up!");
}

// Bind the commands onSpaceDown and onSpaceUp to spacebar events
moveMap.bindCmd(keyboard, "space", "onSpaceDown();", "onSpaceUp();");

Switching ActionMaps

Let's say you want to have different ActionMaps activated based on game play situations. A classic example would be first person shooter controls and racing controls in the same game. On foot, spacebar may cause your player to jump. In a vehicle, it may cause some kind of "turbo charge". You simply need to push/pop the ActionMaps appropriately:

First, create two separate ActionMaps:

Example:
// Create the two ActionMaps
if ( isObject( moveMap ) )
   moveMap.delete();
new ActionMap(moveMap);

if ( isObject( carMap ) )
   carMap.delete();
new ActionMap(carMap);

Next, create the two separate functions. Both will be bound to spacebar, but not the same ActionMap:

Example:
// Print to the console the player is jumping
function playerJump(%val)
{
   if(%val)
     echo("Player jumping!");
}

// Print to the console the vehicle is charging
function turboCharge()
{
   if(%val)
     echo("Vehicle turbo charging!");
}

You are now ready to bind functions to your ActionMaps' devices:

Example:
// Bind the spacebar to the playerJump function
// when moveMap is the active ActionMap
moveMap.bind(keyboard, "space", playerJump);

// Bind the spacebar to the turboCharge function
// when carMap is the active ActionMap
carMap.bind(keyboard, "space", turboCharge);

Finally, you can use the push() and pop() commands on each ActionMap to toggle activation. To activate an ActionMap, use push():

Example:
// Make moveMap the active action map
// You should now be able to activate playerJump with spacebar
moveMap.push();

To switch ActionMaps, first pop() the old one. Then you can push() the new one:

Example:
// Deactivate moveMap
moveMap.pop();

// Activate carMap
carMap.push();

Member Function Documentation

bool ActionMap::bind | ( | string | device,
 |  | string | action,
 |  | string | command
 | ) |  |

Associates a function to an input event.

When the input event is raised, the specified function will be called.

Parameters:
device | The input device, such as mouse or keyboard.
action | The input event, such as space, button0, etc.
command | The function to bind to the action. Function must have a single boolean argument.
Returns:
True if the binding was successful, false if the device was unknown or description failed.
Example:
// Simple function that prints to console
// %val - Sent by the device letting the user know
// if an input was pressed (true) or released (false)
function testInput(%val)
{
   if(%val)
     echo("Key is down");
   else
     echo("Key was released");
}

// Bind the 'K' key to the testInput function
moveMap.bind(keyboard, k, testInput);

bool ActionMap::bind | ( | string | device,
 |  | string | action,
 |  | string | flag,
 |  | string | deadZone,
 |  | string | scale,
 |  | string | command
 | ) |  |

Associates a function and input parameters to an input event.

When the input event is raised, the specified function will be called. Modifier flags may be specified to process dead zones, input inversion, and more.

Valid modifier flags:

  • R - Input is Ranged.
  • S - Input is Scaled.
  • I - Input is inverted.
  • D - Dead zone is present.
  • N - Input should be re-fit to a non-linear scale.
Parameters:
device | The input device, such as mouse or keyboard.
action | The input event, such as space, button0, etc.
flag | Modifier flag assigned during binding, letting event know there are additional parameters to consider.
deadZone | Restricted region in which device motion will not be acknowledged.
scale | Modifies the deadZone region.
command | The function bound to the action. Must take in a single argument.
Returns:
True if the binding was successful, false if the device was unknown or description failed.
Example:
// Simple function that adjusts the pitch of the camera based on the mouse's movement along the X axis.
function testPitch(%val)
{
   %pitchAdj = getMouseAdjustAmount(%val);
    $mvPitch += %pitchAdj;
}

// Bind the mouse's X axis to the testPitch function
// DI is flagged, meaning input is inverted and has a deadzone
%this.bind( mouse, "xaxis", "DI", "-0.23 0.23", testPitch );

bool ActionMap::bindCmd | ( | string | device,
 |  | string | action,
 |  | string | makeCmd,
 |  | string | breakCmd = ""
 | ) |  |

Associates a make command and optional break command to a specified input device action.

Must include parenthesis and semicolon in the make and break command strings.

Parameters:
device | The device to bind to. Can be a keyboard, mouse, joystick or gamepad.
action | The device action to bind to. The action is dependant upon the device. Specify a key for keyboards.
makeCmd | The command to execute when the device/action is made.
breakCmd | [optional] The command to execute when the device or action is unmade.
Returns:
True the bind was successful, false if the device was unknown or description failed.
Example:
// Print to the console when the spacebar is pressed
function onSpaceDown()
{
   echo("Space bar down!");
}

// Print to the console when the spacebar is released
function onSpaceUp()
{
   echo("Space bar up!");
}

// Bind the commands onSpaceDown() and onSpaceUp() to spacebar events

moveMap.bindCmd(keyboard, "space", "onSpaceDown();", "onSpaceUp();");

bool ActionMap::bindObj | ( | string | device,
 |  | string | action,
 |  | string | command,
 |  | SimObjectID | object
 | ) |  |

Associates a function to an input event for a specified class or object.

You must specify a device, the action to bind, a function, and an object to be called when the event happens. The function specified must be set to receive a single boolean value passed.

Parameters:
device | The input device, such as mouse or keyboard.
action | The input event, such as space, button0, etc.
command | The function bound to the action.
object | The object or class bound to the action.
Returns:
True if the binding was successful, false if the device was unknown or description failed.
Example:
moveMap.bindObj(keyboard, "numpad1", "rangeChange", %player);

bool ActionMap::bindObj | ( | string | device,
 |  | string | action,
 |  | string | flag,
 |  | string | deadZone,
 |  | string | scale,
 |  | string | command,
 |  | SimObjectID | object
 | ) |  |

Associates a function to an input event for a specified class or object.

You must specify a device, the action to bind, a function, and an object to be called when the event happens. The function specified must be set to receive a single boolean value passed. Modifier flags may be specified to process dead zones, input inversion, and more.

Valid modifier flags:

  • R - Input is Ranged.
  • S - Input is Scaled.
  • I - Input is inverted.
  • D - Dead zone is present.
  • N - Input should be re-fit to a non-linear scale.
Parameters:
device | The input device, such as mouse or keyboard.
action | The input event, such as space, button0, etc.
flag | Modifier flag assigned during binding, letting event know there are additional parameters to consider.
deadZone | [Required only when flag is set] Restricted region in which device motion will not be acknowledged.
scale | [Required only when flag is set] Modifies the deadZone region.
command | The function bound to the action.
object | The object or class bound to the action.
Returns:
True if the binding was successful, false if the device was unknown or description failed.
Example:
// Bind the mouse's movement along the x-axis to the testInput function of the Player class
// DSI is flagged, meaning input is inverted, has scale and has a deadzone
%this.bindObj( mouse, "xaxis", "DSI", %deadZone, %scale, "testInput", %player );
string ActionMap::getBinding ( string command )

Gets the ActionMap binding for the specified command.

Use getField() on the return value to get the device and action of the binding.

Parameters:
command The function to search bindings for.
Returns:
The binding against the specified command. Returns an empty string("") if a binding wasn't found.
Example:
// Find what the function "jump()" is bound to in moveMap
%bind = moveMap.getBinding( "jump" );

if ( %bind !$= "" )
{
// Find out what device is used in the binding
   %device = getField( %bind, 0 );

// Find out what action (such as a key) is used in the binding
   %action = getField( %bind, 1 );
}
See also:
getField
string ActionMap::getCommand | ( | string | device,
 |  | string | action
 | ) |  |

Gets ActionMap command for the device and action.

Parameters:
device | The device that was bound. Can be a keyboard, mouse, joystick or a gamepad.
action | The device action that was bound. The action is dependant upon the device. Specify a key for keyboards.
Returns:
The command against the specified device and action.
Example:
// Find what function is bound to a device's action
// In this example, "jump()" was assigned to the space key in another script
%command = moveMap.getCommand("keyboard", "space");

// Should print "jump" in the console
echo(%command)

string ActionMap::getDeadZone | ( | string | device,
 |  | string | action
 | ) |  |

Gets the Dead zone for the specified device and action.

Parameters:
device | The device that was bound. Can be a keyboard, mouse, joystick or a gamepad.
action | The device action that was bound. The action is dependant upon the device. Specify a key for keyboards.
Returns:
The dead zone for the specified device and action. Returns "0 0" if there is no dead zone or an empty string("") if the mapping was not found.
Example:
%deadZone = moveMap.getDeadZone( "gamepad", "thumbrx");

float ActionMap::getScale | ( | string | device,
 |  | string | action
 | ) |  |

Get any scaling on the specified device and action.

Parameters:
device | The device that was bound. Can be keyboard, mouse, joystick or gamepad.
action | The device action that was bound. The action is dependant upon the device. Specify a key for keyboards.
Returns:
Any scaling applied to the specified device and action.
Example:
%scale = %moveMap.getScale( "gamepad", "thumbrx");

bool ActionMap::isInverted | ( | string | device,
 |  | string | action
 | ) |  |

Determines if the specified device and action is inverted.

Should only be used for scrolling devices or gamepad/joystick axes.

Parameters:
device | The device that was bound. Can be a keyboard, mouse, joystick or a gamepad.
action | The device action that was bound. The action is dependant upon the device. Specify a key for keyboards.
Returns:
True if the specified device and action is inverted.
Example:
%if ( moveMap.isInverted( "mouse", "xaxis"))
   echo("Mouse's xAxis is inverted");
void ActionMap::pop ( )

Pop the ActionMap off the ActionMap stack.

Deactivates an ActionMap and removes it from the stack.

Example:
// Deactivate moveMap
moveMap.pop();
See also:
ActionMap
void ActionMap::push ( )

Push the ActionMap onto the ActionMap stack.

Activates an ActionMap and placees it at the top of the ActionMap stack.

Example:
// Make moveMap the active action map
moveMap.push();
See also:
ActionMap
void ActionMap::save | ( | string | fileName = NULL,
 |  | bool | append = false
 | ) |  |

Saves the ActionMap to a file or dumps it to the console.

Parameters:
fileName | The file path to save the ActionMap to. If a filename is not specified the ActionMap will be dumped to the console.
append | Whether to write the ActionMap at the end of the file or overwrite it.
Example:
// Write out the actionmap into the config.cs file
moveMap.save( "scripts/client/config.cs" );

bool ActionMap::unbind | ( | string | device,
 |  | string | action
 | ) |  |

Removes the binding on an input device and action.

Parameters:
device | The device to unbind from. Can be a keyboard, mouse, joystick or a gamepad.
action | The device action to unbind from. The action is dependant upon the device. Specify a key for keyboards.
Returns:
True if the unbind was successful, false if the device was unknown or description failed.
Example:
moveMap.unbind("keyboard", "space");

bool ActionMap::unbindObj | ( | string | device,
 |  | string | action,
 |  | string | obj
 | ) |  |

Remove any object-binding on an input device and action.

Parameters:
device | The device to bind to. Can be keyboard, mouse, joystick or gamepad.
action | The device action to unbind from. The action is dependant upon the device. Specify a key for keyboards.
obj | The object to perform unbind against.
Returns:
True if the unbind was successful, false if the device was unknown or description failed.
Example:
moveMap.unbindObj("keyboard", "numpad1", "rangeChange", %player);


Torque 3D - Script Manual: AdvancedLightBinManager Class Reference

AdvancedLightBinManager Class Reference
[Lighting]

Rendering Manager responsible for lighting, shadows, and global variables affecing both. More...

Inheritance diagram for AdvancedLightBinManager:
[legend]

List of all members.

Detailed Description

Rendering Manager responsible for lighting, shadows, and global variables affecing both.

Should not be exposed to TorqueScript as a game object, meant for internal use only


Torque 3D - Script Manual: AIClient Class Reference

AIClient Class Reference
[AI, Networking]

Simulated client driven by AI commands. More...

Inheritance diagram for AIClient:
[legend]

List of all members.

Public Attributes

string | getAimLocation
ai.getAimLocation();
string | getLocation
ai.getLocation();
string | getMoveDestination
ai.getMoveDestination();
int | getTargetObject
ai.getTargetObject();
void | missionCycleCleanup
ai.missionCycleCleanup();
void | move
ai.move();
void | moveForward
ai.moveForward();
void | setAimLocation
ai.setAimLocation( x y z );
void | setMoveDestination
ai.setMoveDestination( x y z );
void | setMoveSpeed
ai.setMoveSpeed( float );
void | setTargetObject
ai.setTargetObject( obj );
void | stop
ai.stop();

Detailed Description

Simulated client driven by AI commands.

This object is derived from the AIConnection class. It introduces its own Player object to solidify the purpose of this class: Simulated client connecting as a player

To get more specific, if you want a strong alternative to AIPlayer (and wish to make use of the AIConnection structure), consider AIClient. AIClient inherits from AIConnection, contains quite a bit of functionality you will find in AIPlayer, and has its own Player object.

Note:
This is a legacy class, which you are discouraged from using as it will most likely be deprecated in a future version. For now it has been left in for backwards compatibility with TGE and the old RTS Kit. Use AIPlayer instead.
See also:
AIPlayer, AIConnection

Member Data Documentation

string AIClient::getAimLocation

ai.getAimLocation();

string AIClient::getLocation

ai.getLocation();

string AIClient::getMoveDestination

ai.getMoveDestination();

int AIClient::getTargetObject

ai.getTargetObject();

void AIClient::missionCycleCleanup

ai.missionCycleCleanup();

void AIClient::move

ai.move();

void AIClient::moveForward

ai.moveForward();

void AIClient::setAimLocation

ai.setAimLocation( x y z );

void AIClient::setMoveDestination

ai.setMoveDestination( x y z );

void AIClient::setMoveSpeed

ai.setMoveSpeed( float );

void AIClient::setTargetObject

ai.setTargetObject( obj );

void AIClient::stop

ai.stop();


Torque 3D - Script Manual: AIConnection Class Reference

AIConnection Class Reference
[AI, Networking]

Special client connection driven by an AI, rather than a human. More...

Inheritance diagram for AIConnection:
[legend]

List of all members.

Public Member Functions

float | getMove (string field)
Get the given field of a move.
bool | getTrigger (int trigger)
Is the given trigger set?
void | setFreeLook (bool isFreeLook)
Enable/disable freelook on the current move.
void | setMove (string field, float value)
Set a field on the current move.
void | setTrigger (int trigger, bool set)
Set a trigger.

Public Attributes

string | getAddress
bool | getFreeLook
getFreeLook()Is freelook on for the current move?

Detailed Description

Special client connection driven by an AI, rather than a human.

Unlike other net connections, AIConnection is intended to run unmanned. Rather than gathering input from a human using a device, move events, triggers, and look events are driven through functions like AIConnection::setMove.

In addition to having its own set of functions for managing client move events, a member variable inherited by GameConnection is toggle: mAIControlled. This is useful for a server to determine if a connection is AI driven via the function GameConnection::isAIControlled

AIConnection is an alternative to manually creating an AI driven game object. When you want the server to manage AI, you will create a specific one from script using a class like AIPlayer. If you do not want the server managing the AI and wish to simulate a complete client connection, you will use AIConnection

.To get more specific, if you want a strong alternative to AIPlayer (and wish to make use of the AIConnection structure), consider AIClient. AIClient inherits from AIConnection, contains quite a bit of functionality you will find in AIPlayer, and has its own Player object.

Example:
// Create a new AI client connection
%botConnection = aiConnect("MasterBlaster" @ %i, -1, 0.5, false, "SDF", 1.0);

// In another area of the code, you can locate this and any other AIConnections
// using the isAIControlled function
for(%i = 0; %i < ClientGroup.getCount(); %i++)
{
   %client = ClientGroup.getObject(%i);
   if(%client.isAIControlled())
   {
      // React to this AI controlled client
   }
}
Note:
This is a legacy class, which you are discouraged from using as it will most likely be deprecated in a future version. For now it has been left in for backwards compatibility with TGE and the old RTS Kit. Use GameConnection and AIPlayer instead.
See also:
GameConnection, NetConnection, AIClient

Member Function Documentation

float AIConnection::getMove ( string field )

Get the given field of a move.

Parameters:
field One of {'x','y','z','yaw','pitch','roll'}
Returns:
The requested field on the current move.
bool AIConnection::getTrigger ( int trigger )

Is the given trigger set?

void AIConnection::setFreeLook ( bool isFreeLook )

Enable/disable freelook on the current move.

void AIConnection::setMove | ( | string | field,
 |  | float | value
 | ) |  |

Set a field on the current move.

Parameters:
field | One of {'x','y','z','yaw','pitch','roll'}
value | Value to set field to.
void AIConnection::setTrigger | ( | int | trigger,
 |  | bool | set
 | ) |  |

Set a trigger.

Member Data Documentation

string AIConnection::getAddress
bool AIConnection::getFreeLook

getFreeLook()Is freelook on for the current move?


Torque 3D - Script Manual: AIPlayer Class Reference

AIPlayer Class Reference
[AI, Game Objects]

A Player object not controlled by conventional input, but by an AI engine. More...

Inheritance diagram for AIPlayer:
[legend]

List of all members.

Public Member Functions

void | clearAim ()
Use this to stop aiming at an object or a point.
Point3F | getAimLocation ()
Returns the point the AIPlayer is aiming at.
int | getAimObject ()
Gets the object the AIPlayer is targeting.
Point3F | getMoveDestination ()
Get the AIPlayer's current destination.
void | setAimLocation (Point3F target)
Tells the AIPlayer to aim at the location provided.
void | setAimObject (GameBase targetObject, Point3F offset)
Sets the AIPlayer's target object. May optionally set an offset from target location.
void | setMoveDestination (Point3F goal, bool slowDown=true)
Tells the AI to move to the location provided.
void | setMoveSpeed (float speed)
Sets the move speed for an AI object.
void | stop ()
Tells the AIPlayer to stop moving.

Public Attributes

AI

float | mMoveTolerance
Distance from destination before stopping.
int | moveStuckTestDelay
The number of ticks to wait before testing if the AIPlayer is stuck.
float | moveStuckTolerance
Distance tolerance on stuck check.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A Player object not controlled by conventional input, but by an AI engine.

The AIPlayer provides a Player object that may be controlled from script. You control where the player moves and how fast. You may also set where the AIPlayer is aiming at -- either a location or another game object.

The AIPlayer class does not have a datablock of its own. It makes use of the PlayerData datablock to define how it looks, etc. As the AIPlayer is an extension of the Player class it can mount objects and fire weapons, or mount vehicles and drive them.

While the PlayerData datablock is used, there are a number of additional callbacks that are implemented by AIPlayer on the datablock. These are listed here:

void onReachDestination(AIPlayer obj) Called when the player has reached its set destination using the setMoveDestination() method. The actual point at which this callback is called is when the AIPlayer is within the mMoveTolerance of the defined destination.

void onMoveStuck(AIPlayer obj) While in motion, if an AIPlayer has moved less than moveStuckTolerance within a single tick, this callback is called. From here you could choose an alternate destination to get the AIPlayer moving again.

void onTargetEnterLOS(AIPlayer obj) When an object is being aimed at (following a call to setAimObject()) and the targeted object enters the AIPlayer's line of sight, this callback is called. The LOS test is a ray from the AIPlayer's eye position to the center of the target's bounding box. The LOS ray test only checks against interiors, statis shapes, and terrain.

void onTargetExitLOS(AIPlayer obj) When an object is being aimed at (following a call to setAimObject()) and the targeted object leaves the AIPlayer's line of sight, this callback is called. The LOS test is a ray from the AIPlayer's eye position to the center of the target's bounding box. The LOS ray test only checks against interiors, statis shapes, and terrain.

Example:
// Create the demo player object
%player = new AiPlayer()
{
   dataBlock = DemoPlayer;
   path = "";
};
See also:
Player for a list of all inherited functions, variables, and base description

Member Function Documentation

void AIPlayer::clearAim ( )

Use this to stop aiming at an object or a point.

See also:
setAimLocation()
setAimObject()
Point3F AIPlayer::getAimLocation ( )

Returns the point the AIPlayer is aiming at.

This will reflect the position set by setAimLocation(), or the position of the object that the bot is now aiming at. If the bot is not aiming at anything, this value will change to whatever point the bot's current line-of-sight intercepts.

Returns:
World space coordinates of the object AI is aiming at. Formatted as "X Y Z".
See also:
setAimLocation()
setAimObject()
int AIPlayer::getAimObject ( )

Gets the object the AIPlayer is targeting.

Returns:
Returns -1 if no object is being aimed at, or the SimObjectID of the object the AIPlayer is aiming at.
See also:
setAimObject()
Point3F AIPlayer::getMoveDestination ( )

Get the AIPlayer's current destination.

Returns:
Returns a point containing the "x y z" position of the AIPlayer's current move destination. If no move destination has yet been set, this returns "0 0 0".
See also:
setMoveDestination()
void AIPlayer::setAimLocation ( Point3F target )

Tells the AIPlayer to aim at the location provided.

Parameters:
target An "x y z" position in the game world to target.
See also:
getAimLocation()
void AIPlayer::setAimObject | ( | GameBase | targetObject,
 |  | Point3F | offset
 | ) |  |

Sets the AIPlayer's target object. May optionally set an offset from target location.

Parameters:
targetObject | The object to target
offset | Optional three-element offset vector which will be added to the position of the aim object.
Example:
// Without an offset
%ai.setAimObject(%target);

// With an offset
// Cause our AI object to aim at the target
// offset (0, 0, 1) so you don't aim at the target's feet
%ai.setAimObject(%target, "0 0 1");
See also:
getAimLocation()
getAimObject()
clearAim()
void AIPlayer::setMoveDestination | ( | Point3F | goal,
 |  | bool | slowDown = true
 | ) |  |

Tells the AI to move to the location provided.

Parameters:
goal | Coordinates in world space representing location to move to.
slowDown | A boolean value. If set to true, the bot will slow down when it gets within 5-meters of its move destination. If false, the bot will stop abruptly when it reaches the move destination. By default, this is true.
Note:
Upon reaching a move destination, the bot will clear its move destination and calls to getMoveDestination will return "0 0 0".
See also:
getMoveDestination()
void AIPlayer::setMoveSpeed ( float speed )

Sets the move speed for an AI object.

Parameters:
speed A speed multiplier between 0.0 and 1.0. This is multiplied by the AIPlayer's base movement rates (as defined in its PlayerData datablock)
See also:
getMoveDestination()
void AIPlayer::stop ( )

Tells the AIPlayer to stop moving.

Member Data Documentation

bool AIPlayer::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from Player.

bool AIPlayer::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from Player.

float AIPlayer::mMoveTolerance

Distance from destination before stopping.

When the AIPlayer is moving to a given destination it will move to within this distance of the destination and then stop. By providing this tolerance it helps the AIPlayer from never reaching its destination due to minor obstacles, rounding errors on its position calculation, etc. By default it is set to 0.25.

int AIPlayer::moveStuckTestDelay

The number of ticks to wait before testing if the AIPlayer is stuck.

When the AIPlayer is asked to move, this property is the number of ticks to wait before the AIPlayer starts to check if it is stuck. This delay allows the AIPlayer to accelerate to full speed without its initial slow start being considered as stuck.

Note:
Set to zero to have the stuck test start immediately.
float AIPlayer::moveStuckTolerance

Distance tolerance on stuck check.

When the AIPlayer is moving to a given destination, if it ever moves less than this tolerance during a single tick, the AIPlayer is considered stuck. At this point the onMoveStuck() callback is called on the datablock.


Torque 3D - Script Manual: ArrayObject Class Reference

ArrayObject Class Reference
[Scripting]

Data structure for storing indexed sequences of key/value pairs. More...

Inheritance diagram for ArrayObject:
[legend]

List of all members.

Public Member Functions

void | add (string key, string value="")
Adds a new element to the end of an array (same as push_back()).
bool | append (ArrayObject target)
Appends the target array to the array object.
int | count ()
Get the number of elements in the array.
int | countKey (string key)
Get the number of times a particular key is found in the array.
int | countValue (string value)
Get the number of times a particular value is found in the array.
bool | crop (ArrayObject target)
Removes elements with matching keys from array.
bool | duplicate (ArrayObject target)
Alters array into an exact duplicate of the target array.
void | echo ()
Echos the array contents to the console.
void | empty ()
Emptys all elements from an array.
void | erase (int index)
Removes an element at a specific position from the array.
int | getCurrent ()
Gets the current pointer index.
int | getIndexFromKey (string key)
Search the array from the current position for the key.
int | getIndexFromValue (string value)
Search the array from the current position for the element.
string | getKey (int index)
Get the key of the array element at the submitted index.
string | getValue (int index)
Get the value of the array element at the submitted index.
void | insert (string key, string value, int index)
Adds a new element to a specified position in the array.
int | moveFirst ()
Moves array pointer to start of array.
int | moveLast ()
Moves array pointer to end of array.
int | moveNext ()
Moves array pointer to next position.
int | movePrev ()
Moves array pointer to prev position.
void | pop_back ()
Removes the last element from the array.
void | pop_front ()
Removes the first element from the array.
void | push_back (string key, string value="")
Adds a new element to the end of an array.
void | push_front (string key, string value="")
Adds a new element to the front of an array.
void | setCurrent (int index)
Sets the current pointer index.
void | setKey (string key, int index)
Set the key at the given index.
void | setValue (string value, int index)
Set the value at the given index.
void | sort (bool descending=false)
Alpha sorts the array by value.
void | sorta ()
Alpha sorts the array by value in ascending order.
void | sortd ()
Alpha sorts the array by value in descending order.
void | sortf (string functionName)
Sorts the array by value in ascending order using the given callback function.
void | sortfd (string functionName)
Sorts the array by value in descending order using the given callback function.
void | sortfk (string functionName)
Sorts the array by key in ascending order using the given callback function.
void | sortfkd (string functionName)
Sorts the array by key in descending order using the given callback function.
void | sortk (bool descending=false)
Alpha sorts the array by key.
void | sortka ()
Alpha sorts the array by key in ascending order.
void | sortkd ()
Alpha sorts the array by key in descending order.
void | sortn (bool descending=false)
Numerically sorts the array by value.
void | sortna ()
Numerically sorts the array by value in ascending order.
void | sortnd ()
Numerically sorts the array by value in descending order.
void | sortnk (bool descending=false)
Numerically sorts the array by key.
void | sortnka ()
Numerical sorts the array by key in ascending order.
void | sortnkd ()
Numerical sorts the array by key in descending order.
void | uniqueKey ()
Removes any elements that have duplicated keys (leaving the first instance).
void | uniqueValue ()
Removes any elements that have duplicated values (leaving the first instance).

Public Attributes

bool | caseSensitive
Makes the keys and values case-sensitive.
caseString | key
Helper field which allows you to add new key['keyname'] = value pairs.

Detailed Description

Data structure for storing indexed sequences of key/value pairs.

This is a powerful array class providing PHP style arrays in TorqueScript.

The following features are supported:

  • array pointers: this allows you to move forwards or backwards through the array as if it was a list, including jumping to the start or end.
  • sorting: the array can be sorted in either alphabetic or numeric mode, on the key or the value, and in ascending or descending order
  • add/remove elements: elements can be pushed/popped from the start or end of the array, or can be inserted/erased from anywhere in the middle
  • removal of duplicates: remove duplicate keys or duplicate values
  • searching: search the array and return the index of a particular key or value
  • counting: count the number of instaces of a particular value or key in the array, as well as the total number of elements
  • advanced features: array append, array crop and array duplicate

Array element keys and values can be strings or numbers

Member Function Documentation

void ArrayObject::add | ( | string | key,
 |  | string | value = ""
 | ) |  |

Adds a new element to the end of an array (same as push_back()).

Parameters:
key | Key for the new element
value | Value for the new element
bool ArrayObject::append ( ArrayObject target )

Appends the target array to the array object.

Parameters:
target ArrayObject to append to the end of this array
int ArrayObject::count ( )

Get the number of elements in the array.

int ArrayObject::countKey ( string key )

Get the number of times a particular key is found in the array.

Parameters:
key Key value to count
int ArrayObject::countValue ( string value )

Get the number of times a particular value is found in the array.

Parameters:
value Array element value to count
bool ArrayObject::crop ( ArrayObject target )

Removes elements with matching keys from array.

Parameters:
target ArrayObject containing keys to remove from this array
bool ArrayObject::duplicate ( ArrayObject target )

Alters array into an exact duplicate of the target array.

Parameters:
target ArrayObject to duplicate
void ArrayObject::echo ( )

Echos the array contents to the console.

void ArrayObject::empty ( )

Emptys all elements from an array.

void ArrayObject::erase ( int index )

Removes an element at a specific position from the array.

Parameters:
index 0-based index of the element to remove
int ArrayObject::getCurrent ( )

Gets the current pointer index.

int ArrayObject::getIndexFromKey ( string key )

Search the array from the current position for the key.

Parameters:
value Array key to search for
Returns:
Index of the first element found, or -1 if none
int ArrayObject::getIndexFromValue ( string value )

Search the array from the current position for the element.

Parameters:
value Array value to search for
Returns:
Index of the first element found, or -1 if none
string ArrayObject::getKey ( int index )

Get the key of the array element at the submitted index.

Parameters:
index 0-based index of the array element to get
Returns:
The key associated with the array element at the specified index, or "" if the index is out of range
string ArrayObject::getValue ( int index )

Get the value of the array element at the submitted index.

Parameters:
index 0-based index of the array element to get
Returns:
The value of the array element at the specified index, or "" if the index is out of range
void ArrayObject::insert | ( | string | key,
 |  | string | value,
 |  | int | index
 | ) |  |

Adds a new element to a specified position in the array.

  • index = 0 will insert an element at the start of the array (same as push_front())
  • index = array.count() will insert an element at the end of the array (same as push_back())
Parameters:
key | Key for the new element
value | Value for the new element
index | 0-based index at which to insert the new element
int ArrayObject::moveFirst ( )

Moves array pointer to start of array.

Returns:
Returns the new array pointer
int ArrayObject::moveLast ( )

Moves array pointer to end of array.

Returns:
Returns the new array pointer
int ArrayObject::moveNext ( )

Moves array pointer to next position.

Returns:
Returns the new array pointer, or -1 if already at the end
int ArrayObject::movePrev ( )

Moves array pointer to prev position.

Returns:
Returns the new array pointer, or -1 if already at the start
void ArrayObject::pop_back ( )

Removes the last element from the array.

void ArrayObject::pop_front ( )

Removes the first element from the array.

void ArrayObject::push_back | ( | string | key,
 |  | string | value = ""
 | ) |  |

Adds a new element to the end of an array.

Parameters:
key | Key for the new element
value | Value for the new element
void ArrayObject::push_front | ( | string | key,
 |  | string | value = ""
 | ) |  |

Adds a new element to the front of an array.

void ArrayObject::setCurrent ( int index )

Sets the current pointer index.

Parameters:
index New 0-based pointer index
void ArrayObject::setKey | ( | string | key,
 |  | int | index
 | ) |  |

Set the key at the given index.

Parameters:
key | New key value
index | 0-based index of the array element to update
void ArrayObject::setValue | ( | string | value,
 |  | int | index
 | ) |  |

Set the value at the given index.

Parameters:
value | New array element value
index | 0-based index of the array element to update
void ArrayObject::sort ( bool descending = false )

Alpha sorts the array by value.

Parameters:
descending [optional] True for descending sort, false for ascending sort
void ArrayObject::sorta ( )

Alpha sorts the array by value in ascending order.

void ArrayObject::sortd ( )

Alpha sorts the array by value in descending order.

void ArrayObject::sortf ( string functionName )

Sorts the array by value in ascending order using the given callback function.

Parameters:
functionName Name of a function that takes two arguments A and B and returns -1 if A is less, 1 if B is less, and 0 if both are equal.
Example:
function mySortCallback(%a, %b)
{
   return strcmp( %a.name, %b.name );
}

%array.sortf( "mySortCallback" );
void ArrayObject::sortfd ( string functionName )

Sorts the array by value in descending order using the given callback function.

Parameters:
functionName Name of a function that takes two arguments A and B and returns -1 if A is less, 1 if B is less, and 0 if both are equal.
See also:
sortf
void ArrayObject::sortfk ( string functionName )

Sorts the array by key in ascending order using the given callback function.

Parameters:
functionName Name of a function that takes two arguments A and B and returns -1 if A is less, 1 if B is less, and 0 if both are equal.
See also:
sortf
void ArrayObject::sortfkd ( string functionName )

Sorts the array by key in descending order using the given callback function.

Parameters:
functionName Name of a function that takes two arguments A and B and returns -1 if A is less, 1 if B is less, and 0 if both are equal.
See also:
sortf
void ArrayObject::sortk ( bool descending = false )

Alpha sorts the array by key.

Parameters:
descending [optional] True for descending sort, false for ascending sort
void ArrayObject::sortka ( )

Alpha sorts the array by key in ascending order.

void ArrayObject::sortkd ( )

Alpha sorts the array by key in descending order.

void ArrayObject::sortn ( bool descending = false )

Numerically sorts the array by value.

Parameters:
descending [optional] True for descending sort, false for ascending sort
void ArrayObject::sortna ( )

Numerically sorts the array by value in ascending order.

void ArrayObject::sortnd ( )

Numerically sorts the array by value in descending order.

void ArrayObject::sortnk ( bool descending = false )

Numerically sorts the array by key.

Parameters:
descending [optional] True for descending sort, false for ascending sort
void ArrayObject::sortnka ( )

Numerical sorts the array by key in ascending order.

void ArrayObject::sortnkd ( )

Numerical sorts the array by key in descending order.

void ArrayObject::uniqueKey ( )

Removes any elements that have duplicated keys (leaving the first instance).

void ArrayObject::uniqueValue ( )

Removes any elements that have duplicated values (leaving the first instance).

Member Data Documentation

bool ArrayObject::caseSensitive

Makes the keys and values case-sensitive.

By default, comparison of key and value strings will be case-insensitive.

caseString ArrayObject::key

Helper field which allows you to add new key['keyname'] = value pairs.


Torque 3D - Script Manual: BanList Class Reference

BanList Class Reference

Used for kicking and banning players from a server. There is only a single instance of BanList. It is very important to note that you do not ever create this object in script like you would other game play objects. You simply reference it via namespace. More...

List of all members.

Static Public Member Functions

static void | add (int uniqueId, string transportAddress, int banLength)
Ban a user for banLength seconds.
static void | addAbsolute (int uniqueId, string transportAddress, int banTime)
Ban a user until a given time.
static void | export (string filename)
Dump the banlist to a file.
static bool | isBanned (int uniqueId, string transportAddress)
Is someone banned?
static void | removeBan (int uniqueId, string transportAddress)
Unban someone.

Detailed Description

Used for kicking and banning players from a server. There is only a single instance of BanList. It is very important to note that you do not ever create this object in script like you would other game play objects. You simply reference it via namespace.

For this to be used effectively, make sure you are hooking up other functions to BanList. For example, functions like GameConnection::onConnectRequestRejected( this, msg ) and function GameConnection::onConnectRequest are excellent places to make use of the BanList. Other systems can be used in conjunction for strict control over a server

See also:
addBadWord
containsBadWords

Member Function Documentation

static void BanList::add | ( | int | uniqueId,
 |  | string | transportAddress,
 |  | int | banLength |
 | ) |  |  | [static]

Ban a user for banLength seconds.

Parameters:
uniqueId | Unique ID of the player.
transportAddress | Address from which the player connected.
banLength | Time period over which to ban the player.
Example:
// Kick someone off the server
// %client - This is the connection to the person we are kicking
function kick(%client)
{
      // Let the server know what happened
      messageAll( 'MsgAdminForce', '\c2The Admin has kicked %1.', %client.playerName);

      // If it is not an AI Player, execute the ban.
      if (!%client.isAIControlled())
         BanList::add(%client.guid, %client.getAddress(), $pref::Server::KickBanTime);

      // Let the player know they messed up
      %client.delete("You have been kicked from this server");
}

static void BanList::addAbsolute | ( | int | uniqueId,
 |  | string | transportAddress,
 |  | int | banTime |
 | ) |  |  | [static]

Ban a user until a given time.

Parameters:
uniqueId | Unique ID of the player.
transportAddress | Address from which the player connected.
banTime | Time at which they will be allowed back in.
Example:
// Kick someone off the server
// %client - This is the connection to the person we are kicking
function kick(%client)
{
      // Let the server know what happened
      messageAll( 'MsgAdminForce', '\c2The Admin has kicked %1.', %client.playerName);

      // If it is not an AI Player, execute the ban.
      if (!%client.isAIControlled())
         BanList::addAbsolute(%client.guid, %client.getAddress(), $pref::Server::KickBanTime);

      // Let the player know they messed up
      %client.delete("You have been kicked from this server");
}
static void BanList::export ( string filename ) [static]

Dump the banlist to a file.

Parameters:
filename Path of the file to write the list to.
Example:
BanList::Export("./server/banlist.cs");

static bool BanList::isBanned | ( | int | uniqueId,
 |  | string | transportAddress |
 | ) |  |  | [static]

Is someone banned?

Parameters:
uniqueId | Unique ID of the player.
transportAddress | Address from which the player connected.
Example:
//-----------------------------------------------------------------------------
// This script function is called before a client connection
// is accepted.  Returning  will accept the connection,
// anything else will be sent back as an error to the client.
// All the connect args are passed also to onConnectRequest
function GameConnection::onConnectRequest( %client, %netAddress, %name )
{
     // Find out who is trying to connect
     echo("Connect request from: " @ %netAddress);

     // Are they allowed in?
     if(BanList::isBanned(%client.guid, %netAddress))
        return "CR_YOUAREBANNED";

     // Is there room for an unbanned player?
     if($Server::PlayerCount >= $pref::Server::MaxPlayers)
        return "CR_SERVERFULL";
     return ;
}

static void BanList::removeBan | ( | int | uniqueId,
 |  | string | transportAddress |
 | ) |  |  | [static]

Unban someone.

Parameters:
uniqueId | Unique ID of the player.
transportAddress | Address from which the player connected.
Example:
BanList::removeBan(%userID, %ipAddress);


Torque 3D - Script Manual: BasicClouds Class Reference

BasicClouds Class Reference
[Atmosphere]

Renders up to three layers of scrolling cloud-cover textures overhead. More...

Inheritance diagram for BasicClouds:
[legend]

List of all members.

Public Attributes

BasicClouds

float | height [3]
Abstract number which controls the curvature and height of the dome mesh.
bool | layerEnabled [3]
Enable or disable rendering of this layer.
Point2F | texDirection [3]
Texture scroll direction for this layer, relative to the world axis.
Point2F | texOffset [3]
UV offset for this layer.
float | texScale [3]
Texture repeat for this layer.
float | texSpeed [3]
Texture scroll speed for this layer.
filename | texture [3]
Texture for this layer.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Renders up to three layers of scrolling cloud-cover textures overhead.

BasicClouds always renders overhead, following the camera. It is intended as part of the background of your level, rendering in front of Sky/Sun type objects and behind everything else.

The parameters controlling the rendering of each texture are refered to and grouped as 'layers'. They are rendered in sequential order, so, layer 1 obscures layer 0, and so on.

BasicClouds is not affected by scene lighting and is therefore not appropriate for scenes in which lighting radically changes, such as day/night.

Member Data Documentation

float BasicClouds::height[3]

Abstract number which controls the curvature and height of the dome mesh.

bool BasicClouds::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool BasicClouds::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool BasicClouds::layerEnabled[3]

Enable or disable rendering of this layer.

Point2F BasicClouds::texDirection[3]

Texture scroll direction for this layer, relative to the world axis.

Point2F BasicClouds::texOffset[3]

UV offset for this layer.

float BasicClouds::texScale[3]

Texture repeat for this layer.

float BasicClouds::texSpeed[3]

Texture scroll speed for this layer.

filename BasicClouds::texture[3]

Texture for this layer.


Torque 3D - Script Manual: Camera Class Reference

Camera Class Reference
[Base Camera]

Represents a position, direction and field of view to render a scene from. More...

Inheritance diagram for Camera:
[legend]

List of all members.

Public Member Functions

void | autoFitRadius (float radius)
Move the camera to fully view the given radius.
VectorF | getAngularVelocity ()
Get the angular velocity for a Newton mode camera.
Camera::CameraMotionMode getMode ()
Returns the current camera control mode.
Point3F | getOffset ()
Get the camera's offset from its orbit or tracking point.
Point3F | getPosition ()
Get the camera's position in the world.
Point3F | getRotation ()
Get the camera's Euler rotation in radians.
VectorF | getVelocity ()
Get the velocity for the camera.
bool | isEditOrbitMode ()
Is the camera in edit orbit mode?
bool | isRotationDamped ()
Is this a Newton Fly mode camera with damped rotation?
void | lookAt (Point3F point)
Point the camera at the specified position. Does not work in Orbit or Track modes.
void | setAngularDrag (float drag)
Set the angular drag for a Newton mode camera.
void | setAngularForce (float force)
Set the angular force for a Newton mode camera.
void | setAngularVelocity (VectorF velocity)
Set the angular velocity for a Newton mode camera.
void | setBrakeMultiplier (float multiplier)
Set the Newton mode camera brake multiplier when trigger[1] is active.
void | setDrag (float drag)
Set the drag for a Newton mode camera.
void | setEditOrbitMode ()
Set the editor camera to orbit around a point set with Camera::setEditOrbitPoint().
void | setEditOrbitPoint (Point3F point)
Set the editor camera's orbit point.
void | setFlyForce (float force)
Set the force applied to a Newton mode camera while moving.
void | setFlyMode ()
Set the camera to fly freely.
void | setMass (float mass)
Set the mass for a Newton mode camera.
void | setNewtonFlyMode ()
Set the camera to fly freely, but with ease-in and ease-out.
void | setOffset (Point3F offset)
Set the camera's offset.
void | setOrbitMode (GameBase orbitObject, TransformF orbitPoint, float minDistance, float maxDistance, float initDistance, bool ownClientObj=false, Point3F offset=Point3F(0.0f, 0.0f, 0.0f), bool locked=false)
Set the camera to orbit around the given object, or if none is given, around the given point.
bool | setOrbitObject (GameBase orbitObject, VectorF rotation, float minDistance, float maxDistance, float initDistance, bool ownClientObject=false, Point3F offset=Point3F(0.0f, 0.0f, 0.0f), bool locked=false)
Set the camera to orbit around a given object.
void | setOrbitPoint (TransformF orbitPoint, float minDistance, float maxDistance, float initDistance, Point3F offset=Point3F(0.0f, 0.0f, 0.0f), bool locked=false)
Set the camera to orbit around a given point.
void | setRotation (Point3F rot)
Set the camera's Euler rotation in radians.
void | setSpeedMultiplier (float multiplier)
Set the Newton mode camera speed multiplier when trigger[0] is active.
bool | setTrackObject (GameBase trackObject, Point3F offset=Point3F(0.0f, 0.0f, 0.0f))
Set the camera to track a given object.
void | setValidEditOrbitPoint (bool validPoint)
Set if there is a valid editor camera orbit point.
void | setVelocity (VectorF velocity)
Set the velocity for the camera.

Public Attributes

Camera: Newton Mode

float | angularDrag
Drag on camera when rotating (Newton mode only). Default value is 2.
float | angularForce
Force applied on camera when asked to rotate (Newton mode only). Default value is 100.
float | brakeMultiplier
Speed multiplier when triggering the brake (Newton mode only). Default value is 2.
float | drag
Drag on camera when moving (Newton mode only). Default value is 2.
float | force
Force applied on camera when asked to move (Newton mode only). Default value is 500.
float | mass
The camera's mass (Newton mode only). Default value is 10.
bool | newtonMode
Apply smoothing (acceleration and damping) to camera movements.
bool | newtonRotation
Apply smoothing (acceleration and damping) to camera rotations.
float | speedMultiplier
Speed multiplier when triggering the accelerator (Newton mode only). Default value is 2.
Camera

CameraMotionMode controlMode
The current camera control mode.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static float | movementSpeed
Global camera movement speed in units/s (typically m/s), with a base value of 40.

Detailed Description

Represents a position, direction and field of view to render a scene from.

A camera is typically manipulated by a GameConnection. When set as the connection's control object, the camera handles all movement actions ($mvForwardAction, $mvPitch, etc.) just like a Player.

Example:
// Set an already created camera as the GameConnection's control object
%connection.setControlObject(%camera);

Methods of Operation

The camera has two general methods of operation. The first is the standard mode where the camera starts and stops its motion and rotation instantly. This is the default operation of the camera and is used by most games. It may be specifically set with Camera::setFlyMode() for 6 DoF motion. It is also typically the method used with Camera::setOrbitMode() or one of its helper methods to orbit about a specific object (such as the Player's dead body) or a specific point.

The second method goes under the name of Newton as it follows Newton's 2nd law of motion: F=ma. This provides the camera with an ease-in and ease-out feel for both movement and rotation. To activate this method for movement, either use Camera::setNewtonFlyMode() or set the Camera::newtonMode field to true. To activate this method for rotation, set the Camera::newtonRotation to true. This method of operation is not typically used in games, and was developed to allow for a smooth fly through of a game level while recording a demo video. But with the right force and drag settings, it may give a more organic feel to the camera to games that use an overhead view, such as a RTS.

There is a third, minor method of operation but it is not generally used for games. This is when the camera is used with Torque's World Editor in Edit Orbit Mode. When set, this allows the camera to rotate about a specific point in the world, and move towards and away from this point. See Camera::setEditOrbitMode() and Camera::setEditOrbitPoint(). While in this mode, Camera::autoFitRadius() may also be used.

Example:
// Create a camera in the level and set its position to a given spawn point.
// Note: The camera starts in the standard fly mode.
%cam = new Camera() {
   datablock = "Observer";
};
MissionCleanup.add( %cam );
%cam.setTransform( %spawnPoint.getTransform() );
Example:
// Create a camera at the given spawn point for the specified
// GameConnection i.e. the client.  Uses the standard
// Sim::spawnObject() function to create the camera using the
// defined default settings.
// Note: The camera starts in the standard fly mode.
function GameConnection::spawnCamera(%this, %spawnPoint)
{
   // Set the control object to the default camera
   if (!isObject(%this.camera))
   {
      if (isDefined("$Game::DefaultCameraClass"))
         %this.camera = spawnObject($Game::DefaultCameraClass, $Game::DefaultCameraDataBlock);
   }

   // If we have a camera then set up some properties
   if (isObject(%this.camera))
   {
      // Make sure we're cleaned up when the mission ends
      MissionCleanup.add( %this.camera );

      // Make sure the camera is always in scope for the connection
      %this.camera.scopeToClient(%this);

      // Send all user input from the connection to the camera
      %this.setControlObject(%this.camera);

      if (isDefined("%spawnPoint"))
      {
         // Attempt to treat %spawnPoint as an object, such as a
         // SpawnSphere class.
         if (getWordCount(%spawnPoint) == 1 && isObject(%spawnPoint))
         {
            %this.camera.setTransform(%spawnPoint.getTransform());
         }
         else
         {
            // Treat %spawnPoint as an AngleAxis transform
            %this.camera.setTransform(%spawnPoint);
         }
      }
   }
}

Motion Modes

Beyond the different operation methods, the Camera may be set to one of a number of motion modes. These motion modes determine how the camera will respond to input and may be used to constrain how the Camera moves. The CameraMotionMode enumeration defines the possible set of modes and the Camera's current may be obtained by using getMode().

Some of the motion modes may be set using specific script methods. These often provide additional parameters to set up the mode in one go. Otherwise, it is always possible to set a Camera's motion mode using the controlMode property. Just pass in the name of the mode enum. The following table lists the motion modes, how to set them up, and what they offer:

Mode | Set From Script | Input Move | Input Rotate | Can Use Newton Mode?
Stationary | controlMode property | No | No | No
FreeRotate | controlMode property | No | Yes | Rotate Only
Fly | setFlyMode() | Yes | Yes | Yes
OrbitObject | setOrbitMode() | Orbits object | Points to object | Move only
OrbitPoint | setOrbitPoint() | Orbits point | Points to location | Move only
TrackObject | setTrackObject() | No | Points to object | Yes
Overhead | controlMode property | Yes | No | Yes
EditOrbit (object selected) | setEditOrbitMode() | Orbits object | Points to object | Move only
EditOrbit (no object) | setEditOrbitMode() | Yes | Yes | Yes

Trigger Input

Passing a move trigger ($mvTriggerCount0, $mvTriggerCount1, etc.) on to a Camera performs different actions depending on which mode the camera is in. While in Fly, Overhead or EditOrbit mode, either trigger0 or trigger1 will cause a camera to move twice its normal movement speed. You can see this in action within the World Editor, where holding down the left mouse button while in mouse look mode (right mouse button is also down) causes the Camera to move faster.

Passing along trigger2 will put the camera into strafe mode. While in this mode a Fly, FreeRotate or Overhead Camera will not rotate from the move input. Instead the yaw motion will be applied to the Camera's x motion, and the pitch motion will be applied to the Camera's z motion. You can see this in action within the World Editor where holding down the middle mouse button allows the user to move the camera up, down and side-to-side.

While the camera is operating in Newton Mode, trigger0 and trigger1 behave slightly differently. Here trigger0 activates a multiplier to the applied acceleration force as defined by speedMultiplier. This has the affect of making the camera move up to speed faster. trigger1 has the opposite affect by acting as a brake. When trigger1 is active a multiplier is added to the Camera's drag as defined by brakeMultiplier.

See also:
CameraData
CameraMotionMode
Camera::movementSpeed

Member Function Documentation

void Camera::autoFitRadius ( float radius )

Move the camera to fully view the given radius.

Note:
For this operation to take affect a valid edit orbit point must first be specified. See Camera::setEditOrbitPoint().
Parameters:
radius The radius to view.
VectorF Camera::getAngularVelocity ( )

Get the angular velocity for a Newton mode camera.

Returns:
The angular velocity in the form of "x y z".
Note:
Only returns useful results when Camera::newtonRotation is set to true.
Camera::CameraMotionMode Camera::getMode ( )

Returns the current camera control mode.

See also:
CameraMotionMode
Point3F Camera::getOffset ( )

Get the camera's offset from its orbit or tracking point.

The offset is added to the camera's position when set to CameraMode::OrbitObject.

Returns:
The offset in the form of "x y z".
Point3F Camera::getPosition ( )

Get the camera's position in the world.

Returns:
The position in the form of "x y z".

Reimplemented from SceneObject.

Point3F Camera::getRotation ( )

Get the camera's Euler rotation in radians.

Returns:
The rotation in radians in the form of "x y z".
VectorF Camera::getVelocity ( )

Get the velocity for the camera.

Returns:
The camera's velocity in the form of "x y z".
Note:
Only useful when the Camera is in Newton mode.

Reimplemented from ShapeBase.

bool Camera::isEditOrbitMode ( )

Is the camera in edit orbit mode?

Returns:
true if the camera is in edit orbit mode.
bool Camera::isRotationDamped ( )

Is this a Newton Fly mode camera with damped rotation?

Returns:
true if the camera uses a damped rotation. i.e. Camera::newtonRotation is set to true.
void Camera::lookAt ( Point3F point )

Point the camera at the specified position. Does not work in Orbit or Track modes.

Parameters:
point The position to point the camera at.
void Camera::setAngularDrag ( float drag )

Set the angular drag for a Newton mode camera.

Parameters:
drag The angular drag applied while the camera is rotating.
Note:
Only takes affect when Camera::newtonRotation is set to true.
void Camera::setAngularForce ( float force )

Set the angular force for a Newton mode camera.

Parameters:
force The angular force applied when attempting to rotate the camera.
Note:
Only takes affect when Camera::newtonRotation is set to true.
void Camera::setAngularVelocity ( VectorF velocity )

Set the angular velocity for a Newton mode camera.

Parameters:
velocity The angular velocity infor form of "x y z".
Note:
Only takes affect when Camera::newtonRotation is set to true.
void Camera::setBrakeMultiplier ( float multiplier )

Set the Newton mode camera brake multiplier when trigger[1] is active.

Parameters:
multiplier The brake multiplier to apply.
Note:
Only used when Camera is in Newton mode.
void Camera::setDrag ( float drag )

Set the drag for a Newton mode camera.

Parameters:
drag The drag applied to the camera while moving.
Note:
Only used when Camera is in Newton mode.
void Camera::setEditOrbitMode ( )

Set the editor camera to orbit around a point set with Camera::setEditOrbitPoint().

Note:
This method is generally used only within the World Editor and other tools. To orbit about an object or point within a game, see Camera::setOrbitMode() and its helper methods.
void Camera::setEditOrbitPoint ( Point3F point )

Set the editor camera's orbit point.

Parameters:
point The point the camera will orbit in the form of "x y z".
void Camera::setFlyForce ( float force )

Set the force applied to a Newton mode camera while moving.

Parameters:
force The force applied to the camera while attempting to move.
Note:
Only used when Camera is in Newton mode.
void Camera::setFlyMode ( )

Set the camera to fly freely.

Allows the camera to have 6 degrees of freedom. Provides for instantaneous motion and rotation unless one of the Newton fields has been set to true. See Camera::newtonMode and Camera::newtonRotation.

void Camera::setMass ( float mass )

Set the mass for a Newton mode camera.

Parameters:
mass The mass used during ease-in and ease-out calculations.
Note:
Only used when Camera is in Newton mode.
void Camera::setNewtonFlyMode ( )

Set the camera to fly freely, but with ease-in and ease-out.

This method allows for the same 6 degrees of freedom as Camera::setFlyMode() but activates the ease-in and ease-out on the camera's movement. To also activate Newton mode for the camera's rotation, set Camera::newtonRotation to true.

void Camera::setOffset ( Point3F offset )

Set the camera's offset.

The offset is added to the camera's position when set to CameraMode::OrbitObject.

Parameters:
offset The distance to offset the camera by in the form of "x y z".
void Camera::setOrbitMode | ( | GameBase | orbitObject,
 |  | TransformF | orbitPoint,
 |  | float | minDistance,
 |  | float | maxDistance,
 |  | float | initDistance,
 |  | bool | ownClientObj = false,
 |  | Point3F | offset = Point3F(0.0f, 0.0f, 0.0f),
 |  | bool | locked = false
 | ) |  |

Set the camera to orbit around the given object, or if none is given, around the given point.

Parameters:
orbitObject | The object to orbit around. If no object is given (0 or blank string is passed in) use the orbitPoint instead
orbitPoint | The point to orbit around when no object is given. In the form of "x y z ax ay az aa" such as returned by SceneObject::getTransform().
minDistance | The minimum distance allowed to the orbit object or point.
maxDistance | The maximum distance allowed from the orbit object or point.
initDistance | The initial distance from the orbit object or point.
ownClientObj | [optional] Are we orbiting an object that is owned by us? Default is false.
offset | [optional] An offset added to the camera's position. Default is no offset.
locked | [optional] Indicates the camera does not receive input from the player. Default is false.
See also:
Camera::setOrbitObject()
Camera::setOrbitPoint()
bool Camera::setOrbitObject | ( | GameBase | orbitObject,
 |  | VectorF | rotation,
 |  | float | minDistance,
 |  | float | maxDistance,
 |  | float | initDistance,
 |  | bool | ownClientObject = false,
 |  | Point3F | offset = Point3F(0.0f, 0.0f, 0.0f),
 |  | bool | locked = false
 | ) |  |

Set the camera to orbit around a given object.

Parameters:
orbitObject | The object to orbit around.
rotation | The initial camera rotation about the object in radians in the form of "x y z".
minDistance | The minimum distance allowed to the orbit object or point.
maxDistance | The maximum distance allowed from the orbit object or point.
initDistance | The initial distance from the orbit object or point.
ownClientObject | [optional] Are we orbiting an object that is owned by us? Default is false.
offset | [optional] An offset added to the camera's position. Default is no offset.
locked | [optional] Indicates the camera does not receive input from the player. Default is false.
Returns:
false if the given object could not be found.
See also:
Camera::setOrbitMode()
void Camera::setOrbitPoint | ( | TransformF | orbitPoint,
 |  | float | minDistance,
 |  | float | maxDistance,
 |  | float | initDistance,
 |  | Point3F | offset = Point3F(0.0f, 0.0f, 0.0f),
 |  | bool | locked = false
 | ) |  |

Set the camera to orbit around a given point.

Parameters:
orbitPoint | The point to orbit around. In the form of "x y z ax ay az aa" such as returned by SceneObject::getTransform().
minDistance | The minimum distance allowed to the orbit object or point.
maxDistance | The maximum distance allowed from the orbit object or point.
initDistance | The initial distance from the orbit object or point.
offset | [optional] An offset added to the camera's position. Default is no offset.
locked | [optional] Indicates the camera does not receive input from the player. Default is false.
See also:
Camera::setOrbitMode()
void Camera::setRotation ( Point3F rot )

Set the camera's Euler rotation in radians.

Parameters:
rot The rotation in radians in the form of "x y z".
Note:
Rotation around the Y axis is ignored
void Camera::setSpeedMultiplier ( float multiplier )

Set the Newton mode camera speed multiplier when trigger[0] is active.

Parameters:
multiplier The speed multiplier to apply.
Note:
Only used when Camera is in Newton mode.
bool Camera::setTrackObject | ( | GameBase | trackObject,
 |  | Point3F | offset = Point3F(0.0f, 0.0f, 0.0f)
 | ) |  |

Set the camera to track a given object.

Parameters:
trackObject | The object to track.
offset | [optional] An offset added to the camera's position. Default is no offset.
Returns:
false if the given object could not be found.
void Camera::setValidEditOrbitPoint ( bool validPoint )

Set if there is a valid editor camera orbit point.

When validPoint is set to false the Camera operates as if it is in Fly mode rather than an Orbit mode.

Parameters:
validPoint Indicates the validity of the orbit point.
Note:
Only used when Camera is in Edit Orbit Mode.
void Camera::setVelocity ( VectorF velocity )

Set the velocity for the camera.

Parameters:
velocity The camera's velocity in the form of "x y z".
Note:
Only affects the Camera when in Newton mode.

Member Data Documentation

float Camera::angularDrag

Drag on camera when rotating (Newton mode only). Default value is 2.

float Camera::angularForce

Force applied on camera when asked to rotate (Newton mode only). Default value is 100.

float Camera::brakeMultiplier

Speed multiplier when triggering the brake (Newton mode only). Default value is 2.

CameraMotionMode Camera::controlMode

The current camera control mode.

float Camera::drag

Drag on camera when moving (Newton mode only). Default value is 2.

float Camera::force

Force applied on camera when asked to move (Newton mode only). Default value is 500.

bool Camera::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

bool Camera::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.

float Camera::mass

The camera's mass (Newton mode only). Default value is 10.

bool Camera::newtonMode

Apply smoothing (acceleration and damping) to camera movements.

bool Camera::newtonRotation

Apply smoothing (acceleration and damping) to camera rotations.

float Camera::speedMultiplier

Speed multiplier when triggering the accelerator (Newton mode only). Default value is 2.


Torque 3D - Script Manual: CameraData Class Reference

CameraData Class Reference
[Base Camera]

A datablock that describes a camera. More...

Inheritance diagram for CameraData:
[legend]

List of all members.

Detailed Description

A datablock that describes a camera.

Example:
datablock CameraData(Observer)
{
   mode = "Observer";
};
See also:
Camera

Datablock_Networking


Torque 3D - Script Manual: CloudLayer Class Reference

CloudLayer Class Reference
[Atmosphere]

A layer of clouds which change shape over time and are affected by scene lighting. More...

Inheritance diagram for CloudLayer:
[legend]

List of all members.

Public Attributes

CloudLayer

ColorF | baseColor
Base cloud color before lighting.
float | coverage
Fraction of sky covered by clouds 0-1.
float | exposure
Brightness scale so CloudLayer can be overblown if desired.
float | height
Abstract number which controls the curvature and height of the dome mesh.
Point2F | texDirection [3]
Controls the direction this slot scrolls.
float | texScale [3]
Controls the texture repeat of this slot.
float | texSpeed [3]
Controls the speed this slot scrolls.
filename | texture
An RGBA texture which should contain normals and opacity (density).
float | windSpeed
Overall scalar to texture scroll speed.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A layer of clouds which change shape over time and are affected by scene lighting.

CloudLayer always renders overhead, following the camera. It is intended as part of the background of your level, rendering in front of Sky/Sun type objects and behind everything else.

The illusion of clouds forming and changing over time is controlled by the normal/opacity texture and the three sets of texture animation parameters. The texture is sampled three times. The first sample defines overall cloud density, where clouds are likely to form and their general size and shape. The second two samples control how it changes over time; they are combined and used as modifiers to the first sample.

CloudLayer is affected by scene lighting and is designed to be used in scenes with dynamic lighting or time of day changes.

Member Data Documentation

ColorF CloudLayer::baseColor

Base cloud color before lighting.

float CloudLayer::coverage

Fraction of sky covered by clouds 0-1.

float CloudLayer::exposure

Brightness scale so CloudLayer can be overblown if desired.

float CloudLayer::height

Abstract number which controls the curvature and height of the dome mesh.

bool CloudLayer::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool CloudLayer::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

Point2F CloudLayer::texDirection[3]

Controls the direction this slot scrolls.

float CloudLayer::texScale[3]

Controls the texture repeat of this slot.

float CloudLayer::texSpeed[3]

Controls the speed this slot scrolls.

filename CloudLayer::texture

An RGBA texture which should contain normals and opacity (density).

float CloudLayer::windSpeed

Overall scalar to texture scroll speed.


Torque 3D - Script Manual: ConsoleLogger Class Reference

ConsoleLogger Class Reference
[Logging]

Inheritance diagram for ConsoleLogger:
[legend]

List of all members.

Public Member Functions

bool | attach ()
Attaches the logger to the console and begins writing to file.
bool | detach ()
Detaches the logger from the console and stops writing to file.

Public Attributes

Logging

LogLevel level
Determines the priority level and attention the logged entry gets when recorded.

Detailed Description

A class designed to be used as a console consumer and log the data it receives to a file.

See also:
dumpConsoleFunctions
dumpConsoleClasses

Member Function Documentation

bool ConsoleLogger::attach ( )

Attaches the logger to the console and begins writing to file.

Example:
// Create the logger
// Will automatically start writing to testLogging.txt with normal priority
new ConsoleLogger(logger, "testLogging.txt", false);

// Send something to the console, with the logger consumes and writes to file
echo("This is logged to the file");

// Stop logging, but do not delete the logger
logger.detach();

echo("This is not logged to the file");

// Attach the logger to the console again
logger.attach();

// Logging has resumed
echo("Logging has resumed");
bool ConsoleLogger::detach ( )

Detaches the logger from the console and stops writing to file.

Example:
// Create the logger
// Will automatically start writing to testLogging.txt with normal priority
new ConsoleLogger(logger, "testLogging.txt", false);

// Send something to the console, with the logger consumes and writes to file
echo("This is logged to the file");

// Stop logging, but do not delete the logger
logger.detach();

echo("This is not logged to the file");

// Attach the logger to the console again
logger.attach();

// Logging has resumed
echo("Logging has resumed");

Member Data Documentation

LogLevel ConsoleLogger::level

Determines the priority level and attention the logged entry gets when recorded.


Torque 3D - Script Manual: ConvexShape Class Reference

ConvexShape Class Reference
[Miscellaneous]

A renderable, collidable convex shape defined by a collection of surface planes. More...

Inheritance diagram for ConvexShape:
[legend]

List of all members.

Public Attributes

Rendering

string | Material
Material used to render the ConvexShape surface.
Internal

string | surface
Do not modify, for internal use.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A renderable, collidable convex shape defined by a collection of surface planes.

ConvexShape is intended to be used as a temporary asset for quickly blocking out a scene or filling in approximate shapes to be later replaced with final assets. This is most easily done by using the WorldEditor's Sketch Tool.

Member Data Documentation

bool ConvexShape::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool ConvexShape::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string ConvexShape::Material

Material used to render the ConvexShape surface.

string ConvexShape::surface

Do not modify, for internal use.


Torque 3D - Script Manual: CubemapData Class Reference

CubemapData Class Reference
[GFX]

Used to create static or dynamic cubemaps. More...

Inheritance diagram for CubemapData:
[legend]

List of all members.

Public Member Functions

string | getFilename ()
Returns the script filename of where the CubemapData object was defined. This is used by the material editor.
void | updateFaces ()
Update the assigned cubemaps faces.

Public Attributes

filename | cubeFace [6]
The 6 cubemap face textures for a static cubemap.
bool | dynamic
Set to true if this is a dynamic cubemap. The default is false.
float | dynamicFarDist
The far clip distance used when rendering to the dynamic cubemap.
float | dynamicNearDist
The near clip distance used when rendering to the dynamic cubemap.
int | dynamicObjectTypeMask
The typemask used to filter the objects rendered to the dynamic cubemap.
int | dynamicSize
The size of each dynamic cubemap face in pixels.

Detailed Description

Used to create static or dynamic cubemaps.

This object is used with Material, WaterObject, and other objects for cubemap reflections.

A simple declaration of a static cubemap:

Example:
singleton CubemapData( SkyboxCubemap )
{
   cubeFace[0] = "./skybox_1";
   cubeFace[1] = "./skybox_2";
   cubeFace[2] = "./skybox_3";
   cubeFace[3] = "./skybox_4";
   cubeFace[4] = "./skybox_5";
   cubeFace[5] = "./skybox_6";
};
Note:
The dynamic cubemap functionality in CubemapData has been depreciated in favor of ReflectorDesc.
See also:
ReflectorDesc

Member Function Documentation

string CubemapData::getFilename ( )

Returns the script filename of where the CubemapData object was defined. This is used by the material editor.

Reimplemented from SimObject.

void CubemapData::updateFaces ( )

Update the assigned cubemaps faces.

Member Data Documentation

filename CubemapData::cubeFace[6]

The 6 cubemap face textures for a static cubemap.

They are in the following order:

  • cubeFace[0] is -X
  • cubeFace[1] is +X
  • cubeFace[2] is -Z
  • cubeFace[3] is +Z
  • cubeFace[4] is -Y
  • cubeFace[5] is +Y
bool CubemapData::dynamic

Set to true if this is a dynamic cubemap. The default is false.

float CubemapData::dynamicFarDist

The far clip distance used when rendering to the dynamic cubemap.

float CubemapData::dynamicNearDist

The near clip distance used when rendering to the dynamic cubemap.

int CubemapData::dynamicObjectTypeMask

The typemask used to filter the objects rendered to the dynamic cubemap.

int CubemapData::dynamicSize

The size of each dynamic cubemap face in pixels.


Torque 3D - Script Manual: CustomMaterial Class Reference

CustomMaterial Class Reference
[Materials]

Material object which provides more control over surface properties. More...

Inheritance diagram for CustomMaterial:
[legend]

List of all members.

Public Attributes

Material fallback
Alternate material for targeting lower end hardware.
bool | forwardLit
Flags this material as needing lights for forward rendering.
string | shader
Name of a GFXShaderData for this effect.
GFXStateBlockData stateBlock
Name of a GFXStateBlockData for this effect.
string | target
String identifier of this material's target texture.
float | version
Specifies pixel shader version for hardware, such as 2.0, 3.0, etc.

Detailed Description

Material object which provides more control over surface properties.

CustomMaterials allow the user to specify their own shaders via the ShaderData datablock CustomMaterials are derived from Materials, so they can hold a lot of the same properties, but it is up to the user to code how these properties are used.

Example:
singleton CustomMaterial( WaterBasic )
{
   sampler["reflectMap"] = "$reflectbuff";
   sampler["refractBuff"] = "$backbuff";

   cubemap = NewLevelSkyCubemap;
   shader = WaterBasicShader;
   stateBlock = WaterBasicStateBlock;
   version = 2.0;
};
See also:
Material, GFXStateBlock, GFXShaderData

Member Data Documentation

Material CustomMaterial::fallback

Alternate material for targeting lower end hardware.

bool CustomMaterial::forwardLit

Flags this material as needing lights for forward rendering.

string CustomMaterial::shader

Name of a GFXShaderData for this effect.

GFXStateBlockData CustomMaterial::stateBlock

Name of a GFXStateBlockData for this effect.

string CustomMaterial::target

String identifier of this material's target texture.

float CustomMaterial::version

Specifies pixel shader version for hardware, such as 2.0, 3.0, etc.


Torque 3D - Script Manual: Debris Class Reference

Debris Class Reference
[Special Effects]

Base debris class. Uses the DebrisData datablock for properties of individual debris objects. More...

Inheritance diagram for Debris:
[legend]

List of all members.

Public Member Functions

bool | init (string inputPosition="1.0 1.0 1.0", string inputVelocity="1.0 0.0 0.0")
Manually set this piece of debris at the given position with the given velocity.

Public Attributes

Debris

float | lifetime
Length of time for this debris object to exist. When expired, the object will be deleted.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Base debris class. Uses the DebrisData datablock for properties of individual debris objects.

Debris is typically made up of a shape and up to two particle emitters. In most cases Debris objects are not created directly. They are usually produced automatically by other means, such as through the Explosion class. When an explosion goes off, its ExplosionData datablock determines what Debris to emit.

Example:
datablock ExplosionData(GrenadeLauncherExplosion)
{
   // Assiging debris data
   debris = GrenadeDebris;

   // Adjust how debris is ejected
   debrisThetaMin = 10;
   debrisThetaMax = 60;
   debrisNum = 4;
   debrisNumVariance = 2;
   debrisVelocity = 25;
   debrisVelocityVariance = 5;

   // Note: other ExplosionData properties are not listed for this example
};
Note:
Debris are client side only objects.
See also:
DebrisData
ExplosionData
Explosion

Member Function Documentation

bool Debris::init | ( | string | inputPosition = "1.0 1.0 1.0",
 |  | string | inputVelocity = "1.0 0.0 0.0"
 | ) |  |

Manually set this piece of debris at the given position with the given velocity.

Usually you do not manually create Debris objects as they are generated through other means, such as an Explosion. This method exists when you do manually create a Debris object and want to have it start moving.

Parameters:
inputPosition | Position to place the debris.
inputVelocity | Velocity to move the debris after it has been placed.
Returns:
Always returns true.
Example:
// Define the position
%position = "1.0 1.0 1.0";

// Define the velocity
%velocity = "1.0 0.0 0.0";

// Inform the debris object of its new position and velocity
%debris.init(%position,%velocity);

Member Data Documentation

bool Debris::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool Debris::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

float Debris::lifetime

Length of time for this debris object to exist. When expired, the object will be deleted.

The initial lifetime value comes from the DebrisData datablock.

See also:
DebrisData::lifetime
DebrisData::lifetimeVariance


Torque 3D - Script Manual: DebrisData Class Reference

DebrisData Class Reference
[Special Effects]

Stores properties for an individual debris type. More...

Inheritance diagram for DebrisData:
[legend]

List of all members.

Public Attributes

Physical Properties

float | baseRadius
Radius at which the standard elasticity and friction apply.
int | bounceVariance
Allowed variance in the value of numBounces.
float | elasticity
A floating-point value specifying how 'bouncy' this object is.
float | friction
A floating-point value specifying how much velocity is lost to impact and sliding friction.
float | gravModifier
How much gravity affects debris.
float | lifetime
Amount of time until this debris object is destroyed.
float | lifetimeVariance
Allowed variance in the value of lifetime.
float | maxSpinSpeed
Maximum speed that this debris object will rotate.
float | minSpinSpeed
Minimum speed that this debris object will rotate.
int | numBounces
How many times to allow this debris object to bounce until it either explodes, becomes static or snaps (defined in explodeOnMaxBounce, staticOnMaxBounce, snapOnMaxBounce).
float | terminalVelocity
Max velocity magnitude.
bool | useRadiusMass
Use mass calculations based on radius.
float | velocity
Speed at which this debris object will move.
float | velocityVariance
Allowed variance in the value of velocity.
Datablocks

ParticleEmitterData | emitters [2]
List of particle emitters to spawn along with this debris object.
ExplosionData Explosion
ExplosionData to spawn along with this debris object.
Behavior

bool | explodeOnMaxBounce
If true, this debris object will explode after it has bounced max times.
bool | fade
If true, this debris object will fade out when destroyed.
bool | ignoreWater
If true, this debris object will not collide with water, acting as if the water is not there.
bool | snapOnMaxBounce
If true, this debris object will snap into a resting position on the last bounce.
bool | staticOnMaxBounce
If true, this debris object becomes static after it has bounced max times.
Display

filename | shapeFile
Object model to use for this debris object.
string | texture
Texture imagemap to use for this debris object.

Detailed Description

Stores properties for an individual debris type.

DebrisData defines the base properties for a Debris object. Typically you'll want a Debris object to consist of a shape and possibly up to two particle emitters. The DebrisData datablock provides the definition for these items, along with physical properties and how a Debris object will react to other game objects, such as water and terrain.

Example:
datablock DebrisData(GrenadeDebris)
{
   shapeFile = "art/shapes/weapons/ramrifle/debris.dts";
   emitters[0] = GrenadeDebrisFireEmitter;
   elasticity = 0.4;
   friction = 0.25;
   numBounces = 3;
   bounceVariance = 1;
   explodeOnMaxBounce = false;
   staticOnMaxBounce = false;
   snapOnMaxBounce = false;
   minSpinSpeed = 200;
   maxSpinSpeed = 600;
   lifetime = 4;
   lifetimeVariance = 1.5;
   velocity = 15;
   velocityVariance = 5;
   fade = true;
   useRadiusMass = true;
   baseRadius = 0.3;
   gravModifier = 1.0;
   terminalVelocity = 20;
   ignoreWater = false;
};
See also:
Debris

Member Data Documentation

float DebrisData::baseRadius

Radius at which the standard elasticity and friction apply.

Only used when useRaduisMass is true.

See also:
useRadiusMass.
int DebrisData::bounceVariance

Allowed variance in the value of numBounces.

Must be less than numBounces.

See also:
numBounces
float DebrisData::elasticity

A floating-point value specifying how 'bouncy' this object is.

Must be in the range of -10 to 10.

ParticleEmitterData DebrisData::emitters[2]

List of particle emitters to spawn along with this debris object.

These are optional. You could have Debris made up of only a shape.

bool DebrisData::explodeOnMaxBounce

If true, this debris object will explode after it has bounced max times.

Be sure to provide an ExplosionData datablock for this to take effect.

See also:
explosion
ExplosionData DebrisData::Explosion

ExplosionData to spawn along with this debris object.

This is optional as not all Debris explode.

bool DebrisData::fade

If true, this debris object will fade out when destroyed.

This fade occurs over the last second of the Debris' lifetime.

float DebrisData::friction

A floating-point value specifying how much velocity is lost to impact and sliding friction.

Must be in the range of -10 to 10.

float DebrisData::gravModifier

How much gravity affects debris.

bool DebrisData::ignoreWater

If true, this debris object will not collide with water, acting as if the water is not there.

float DebrisData::lifetime

Amount of time until this debris object is destroyed.

Must be in the range of 0 to 1000.

See also:
lifetimeVariance
float DebrisData::lifetimeVariance

Allowed variance in the value of lifetime.

Must be less than lifetime.

See also:
lifetime
float DebrisData::maxSpinSpeed

Maximum speed that this debris object will rotate.

Must be in the range of -10000 to 10000.

See also:
minSpinSpeed
float DebrisData::minSpinSpeed

Minimum speed that this debris object will rotate.

Must be in the range of -10000 to 1000, and must be less than maxSpinSpeed.

See also:
maxSpinSpeed
int DebrisData::numBounces

How many times to allow this debris object to bounce until it either explodes, becomes static or snaps (defined in explodeOnMaxBounce, staticOnMaxBounce, snapOnMaxBounce).

Must be within the range of 0 to 10000.

See also:
bounceVariance
filename DebrisData::shapeFile

Object model to use for this debris object.

This shape is optional. You could have Debris made up of only particles.

bool DebrisData::snapOnMaxBounce

If true, this debris object will snap into a resting position on the last bounce.

bool DebrisData::staticOnMaxBounce

If true, this debris object becomes static after it has bounced max times.

float DebrisData::terminalVelocity

Max velocity magnitude.

string DebrisData::texture

Texture imagemap to use for this debris object.

Not used any more.

bool DebrisData::useRadiusMass

Use mass calculations based on radius.

Allows for the adjustment of elasticity and friction based on the Debris size.

See also:
baseRadius
float DebrisData::velocity

Speed at which this debris object will move.

See also:
velocityVariance
float DebrisData::velocityVariance

Allowed variance in the value of velocity.

Must be less than velocity.

See also:
velocity


Torque 3D - Script Manual: DebugDrawer Class Reference

DebugDrawer Class Reference
[GFX]

A debug helper for rendering debug primitives to the scene. More...

Inheritance diagram for DebugDrawer:
[legend]

List of all members.

Public Member Functions

void | drawBox (Point3F a, Point3F b, ColorF color=ColorF::WHITE)
Draws an axis aligned box primitive within the two 3d points.
void | drawLine (Point3F a, Point3F b, ColorF color=ColorF::WHITE)
Draws a line primitive between two 3d points.
void | setLastTTL (int ms)
Sets the "time to live" (TTL) for the last rendered primitive.
void | setLastZTest (bool enabled)
Sets the z buffer reading state for the last rendered primitive.
void | toggleDrawing ()
Toggles the rendering of DebugDrawer primitives.
void | toggleFreeze ()
Toggles freeze mode which keeps the currently rendered primitives from expiring.

Detailed Description

A debug helper for rendering debug primitives to the scene.

The DebugDrawer is used to render debug primitives to the scene for testing. It is often useful when debugging collision code or complex 3d algorithms to have them draw debug information, like culling hulls or bounding volumes, normals, simple lines, and so forth.

A key feature of the DebugDrawer is that each primitive gets a "time to live" (TTL) which allows them to continue to render to the scene for a fixed period of time. You can freeze or resume the system at any time to allow you to examine the output.

Example:
DebugDraw.drawLine( %player.getMuzzlePoint( 0 ), %hitPoint );
DebugDraw.setLastTTL( 5000 ); // 5 seconds.

The DebugDrawer renders solely in world space and all primitives are rendered with the cull mode disabled.

Note:
This feature can easily be used to cheat in online games, so you should be sure it is disabled in your shipping game. By default the DebugDrawer is disabled in all TORQUE_SHIPPING builds.

Member Function Documentation

void DebugDrawer::drawBox | ( | Point3F | a,
 |  | Point3F | b,
 |  | ColorF | color = ColorF::WHITE
 | ) |  |

Draws an axis aligned box primitive within the two 3d points.

void DebugDrawer::drawLine | ( | Point3F | a,
 |  | Point3F | b,
 |  | ColorF | color = ColorF::WHITE
 | ) |  |

Draws a line primitive between two 3d points.

void DebugDrawer::setLastTTL ( int ms )

Sets the "time to live" (TTL) for the last rendered primitive.

void DebugDrawer::setLastZTest ( bool enabled )

Sets the z buffer reading state for the last rendered primitive.

void DebugDrawer::toggleDrawing ( )

Toggles the rendering of DebugDrawer primitives.

void DebugDrawer::toggleFreeze ( )

Toggles freeze mode which keeps the currently rendered primitives from expiring.


Torque 3D - Script Manual: DecalData Class Reference

DecalData Class Reference
[Special Effects]

A datablock describing an individual decal. More...

Inheritance diagram for DecalData:
[legend]

List of all members.

Public Member Functions

void | postApply ()
Reloads imagemap textures for this DecalData.

Public Attributes

Rendering

float | clippingAngle
The angle in degrees used to clip geometry that faces away from the decal projection direction.
float | fadeEndPixelSize
LOD value - size in pixels at which decals of this type are fully faded out. This should be a smaller value than fadeStartPixelSize.
float | fadeStartPixelSize
LOD value - size in pixels at which decals of this type begin to fade out. This should be a larger value than fadeEndPixelSize. However, you may also set this to a negative value to disable lod-based fading.
char | renderPriority
Default renderPriority for decals of this type.
Decal

int | fadeTime
Milliseconds of sim time for decal to fade after expiration.
int | lifeSpan
Milliseconds of sim time for decal to expire.
string | Material
Material for this decal type.
float | size
Width/height in meters before scale is applied.
Texturing

int | frame
Index of texture rectangle to use for this decal.
bool | randomize
If true, a random texture rectangle is picked for each instance of this decal.
int | texCols
Number of columns on the supplied imagemap.
int | texRows
Number of rows on the supplied imagemap.
int | textureCoordCount
Number of individual frames in this imagemap.
RectF | textureCoords [16]
A RectF in uv space - eg ( topleft.x topleft.y extent.x extent.y ).

Detailed Description

A datablock describing an individual decal.

Example:
datablock DecalData(ScorchRXDecal)
{
   Material = "DECAL_RocketEXP";
   size = "5.0";
   lifeSpan = "50000";
   randomize = "1";
   texRows = "2";
   texCols = "2";
   clippingAngle = "60";
};

Member Function Documentation

void DecalData::postApply ( )

Reloads imagemap textures for this DecalData.

Example:
// Inform the decal object to reload its imagemap and frame data.
%decalData.postApply();

Member Data Documentation

float DecalData::clippingAngle

The angle in degrees used to clip geometry that faces away from the decal projection direction.

float DecalData::fadeEndPixelSize

LOD value - size in pixels at which decals of this type are fully faded out. This should be a smaller value than fadeStartPixelSize.

float DecalData::fadeStartPixelSize

LOD value - size in pixels at which decals of this type begin to fade out. This should be a larger value than fadeEndPixelSize. However, you may also set this to a negative value to disable lod-based fading.

int DecalData::fadeTime

Milliseconds of sim time for decal to fade after expiration.

int DecalData::frame

Index of texture rectangle to use for this decal.

int DecalData::lifeSpan

Milliseconds of sim time for decal to expire.

string DecalData::Material

Material for this decal type.

bool DecalData::randomize

If true, a random texture rectangle is picked for each instance of this decal.

char DecalData::renderPriority

Default renderPriority for decals of this type.

float DecalData::size

Width/height in meters before scale is applied.

int DecalData::texCols

Number of columns on the supplied imagemap.

int DecalData::texRows

Number of rows on the supplied imagemap.

int DecalData::textureCoordCount

Number of individual frames in this imagemap.

RectF DecalData::textureCoords[16]

A RectF in uv space - eg ( topleft.x topleft.y extent.x extent.y ).


Torque 3D - Script Manual: DecalManager Class Reference

DecalManager Class Reference
[Special Effects]

All decals are managed by the decal manager. Provides a few global variables for managing the number of decals that are visible at any one time and the lifetime of the decal. More...

Inheritance diagram for DecalManager:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

All decals are managed by the decal manager. Provides a few global variables for managing the number of decals that are visible at any one time and the lifetime of the decal.

See also:
$pref::Decals::enabled
$pref::Decals::lifeTimeScale
$Decals::poolBuffers
decalManagerSave
decalLoadFile
decalManagerDirty
decalManagerClear
decalManagerAddDecal
decalManagerRemoveDecal

Member Data Documentation

bool DecalManager::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool DecalManager::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.


Torque 3D - Script Manual: DecalRoad Class Reference

DecalRoad Class Reference
[Terrain]

A strip shaped decal defined by spine nodes which clips against Terrain objects. More...

Inheritance diagram for DecalRoad:
[legend]

List of all members.

Public Member Functions

void | postApply ()
Intended as a helper to developers and editor scripts.
void | regenerate ()
Intended as a helper to developers and editor scripts.

Public Attributes

DecalRoad

float | breakAngle
Angle in degrees - DecalRoad will subdivided the spline if its curve is greater than this threshold.
string | Material
Material used for rendering.
int | renderPriority
DecalRoad(s) are rendered in descending renderPriority order.
float | textureLength
The length in meters of textures mapped to the DecalRoad.
Internal

string | Node
Do not modify, for internal use.

Static Public Attributes

static bool | discardAll
For use by the Decal Editor.
static bool | EditorOpen
For use by the Decal Editor.
static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static bool | showBatches
For use by the Decal Editor.
static bool | showRoad
For use by the Decal Editor.
static bool | showSpline
For use by the Decal Editor.
static int | updateDelay
For use by the Decal Editor.
static bool | wireframe
For use by the Decal Editor.

Detailed Description

A strip shaped decal defined by spine nodes which clips against Terrain objects.

DecalRoad is for representing a road or path ( or other inventive things ) across a TerrainBlock. It renders as a decal and is therefore only for features that do not need geometric depth.

The Material assigned to DecalRoad should tile vertically.

Member Function Documentation

void DecalRoad::postApply ( )

Intended as a helper to developers and editor scripts.

Force trigger an inspectPostApply. This will transmit the material and other fields ( not including nodes ) to client objects.

void DecalRoad::regenerate ( )

Intended as a helper to developers and editor scripts.

Force DecalRoad to update it's spline and reclip geometry.

Member Data Documentation

float DecalRoad::breakAngle

Angle in degrees - DecalRoad will subdivided the spline if its curve is greater than this threshold.

bool DecalRoad::discardAll [static]

For use by the Decal Editor.

bool DecalRoad::EditorOpen [static]

For use by the Decal Editor.

bool DecalRoad::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool DecalRoad::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string DecalRoad::Material

Material used for rendering.

string DecalRoad::Node

Do not modify, for internal use.

int DecalRoad::renderPriority

DecalRoad(s) are rendered in descending renderPriority order.

bool DecalRoad::showBatches [static]

For use by the Decal Editor.

bool DecalRoad::showRoad [static]

For use by the Decal Editor.

bool DecalRoad::showSpline [static]

For use by the Decal Editor.

float DecalRoad::textureLength

The length in meters of textures mapped to the DecalRoad.

int DecalRoad::updateDelay [static]

For use by the Decal Editor.

bool DecalRoad::wireframe [static]

For use by the Decal Editor.


Torque 3D - Script Manual: EditorIconRegistry Class Reference

EditorIconRegistry Class Reference

This class is used to find the correct icon file path for different SimObject class types. More...

Detailed Description

This class is used to find the correct icon file path for different SimObject class types.

It is typically used by the editors, not intended for actual game development


Torque 3D - Script Manual: EventManager Class Reference

EventManager Class Reference
[Messaging]

The EventManager class is a wrapper for the standard messaging system. More...

Inheritance diagram for EventManager:
[legend]

List of all members.

Public Member Functions

void | dumpEvents ()
Print all registered events to the console.
void | dumpSubscribers (String event)
Print all subscribers to an event to the console.
bool | isRegisteredEvent (String event)
Check if an event is registered or not.
bool | postEvent (String event, String data)
~Trigger an event.
bool | registerEvent (String event)
Register an event with the event manager.
void | remove (SimObject listener, String event)
Remove a listener from an event.
void | removeAll (SimObject listener)
Remove a listener from all events.
bool | subscribe (SimObject listener, String event, String callback)
Subscribe a listener to an event.
void | unregisterEvent (String event)
Remove an event from the EventManager.

Public Attributes

string | queue
List of events currently waiting.

Detailed Description

The EventManager class is a wrapper for the standard messaging system.

It provides functionality for management of event queues, events, and subscriptions. Creating an EventManager is as simple as calling new EventManager and specifying a queue name.

Example:
// Create the EventManager.
$MyEventManager = new EventManager() { queue = "MyEventManager"; };

// Create an event.
$MyEventManager.registerEvent( "SomeCoolEvent" );

// Create a listener and subscribe.
$MyListener = new ScriptMsgListener() { class = MyListener; };
$MyEventManager.subscribe( $MyListener, "SomeCoolEvent" );

function MyListener::onSomeCoolEvent( %this, %data )
{
     echo( "onSomeCoolEvent Triggered" );
}

// Trigger the event.
$MyEventManager.postEvent( "SomeCoolEvent", "Data" );
See also:
ScriptMsgListener

Member Function Documentation

void EventManager::dumpEvents ( )

Print all registered events to the console.

void EventManager::dumpSubscribers ( String event )

Print all subscribers to an event to the console.

Parameters:
event The event whose subscribers are to be printed. If this parameter isn't specified, all events will be dumped.
bool EventManager::isRegisteredEvent ( String event )

Check if an event is registered or not.

Parameters:
event The event to check.
Returns:
Whether or not the event exists.
bool EventManager::postEvent | ( | String | event,
 |  | String | data
 | ) |  |

~Trigger an event.

Parameters:
event | The event to trigger.
data | The data associated with the event.
Returns:
Whether or not the event was dispatched successfully.
bool EventManager::registerEvent ( String event )

Register an event with the event manager.

Parameters:
event The event to register.
Returns:
Whether or not the event was registered successfully.
void EventManager::remove | ( | SimObject | listener,
 |  | String | event
 | ) |  |

Remove a listener from an event.

Parameters:
listener | The listener to remove.
event | The event to be removed from.
void EventManager::removeAll ( SimObject listener )

Remove a listener from all events.

Parameters:
listener The listener to remove.
bool EventManager::subscribe | ( | SimObject | listener,
 |  | String | event,
 |  | String | callback
 | ) |  |

Subscribe a listener to an event.

Parameters:
listener | The listener to subscribe.
event | The event to subscribe to.
callback | Optional method name to receive the event notification. If this is not specified, "on[event]" will be used.
Returns:
Whether or not the subscription was successful.
void EventManager::unregisterEvent ( String event )

Remove an event from the EventManager.

Parameters:
event The event to remove.

Member Data Documentation

string EventManager::queue

List of events currently waiting.


Torque 3D - Script Manual: Explosion Class Reference

Explosion Class Reference
[Special Effects]

The emitter for an explosion, whose properties are defined in an ExplosionData object. More...

Inheritance diagram for Explosion:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

The emitter for an explosion, whose properties are defined in an ExplosionData object.

Member Data Documentation

bool Explosion::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool Explosion::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.


Torque 3D - Script Manual: ExplosionData Class Reference

ExplosionData Class Reference
[Special Effects]

The data on what an explosion should look like. Definesa particle data, debris data, affects the lighting conditions in the region of the explosion, and shakes the camera. More...

Inheritance diagram for ExplosionData:
[legend]

List of all members.

Public Attributes

Point3F | camShakeAmp
Amplitude to shake the camera, defined as the 3 F32 values of X Y Z.
float | camShakeDuration
Duration to shake the camera.
float | camShakeFalloff
Falloff value for the camera shake.
Point3F | camShakeFreq
Frequency to shake the camera, defined as the 3 F32 values of X Y Z.
float | camShakeRadius
Radial distance that a camera's position must be in relation to the center of the explosion to have its camera shaken.
DebrisData Debris
List of DebrisData to spawn with this explosion.
int | debrisNum
Number of debris objects to create.
int | debrisNumVariance
Variance in the number of debris objects to create, from 0 to n.
float | debrisPhiMax
Maximum reference angle, from the vertical plane, to eject debris from.
float | debrisPhiMin
Minimum reference angle, from the vertical plane, to eject debris from.
float | debrisThetaMax
Maximum angle, from the horizontal plane, to eject debris from.
float | debrisThetaMin
Minimum angle, from the horizontal plane, to eject debris from.
float | debrisVelocity
Velocity to toss debris at.
float | debrisVelocityVariance
Variance in the debris velocity, from 0 to n.
int | delayMS
Amount of time, in milliseconds, to delay the explosion from starting from the creation of this ExplosionData object.
int | delayVariance
Variance of the delayMS, in milliseconds, to delay the expolosion from start from the creation of this ExplosionData object.
ParticleEmitterData | emitter [4]
List of ParticleEmitterData objects to spawn with this explosion.
Point3F | explosionScale
Scale size create the explosionShape DTS model at the start of the explosion.
filename | explosionShape
DTS shape to place at the center of the explosion. The 'ambient' animation of this model will automatically be played at the start of the explosion.
bool | faceViewer
Boolean, sets if the visual effects of the explosion should or should not face the player.
int | lifetimeMS
Lifetime, in milliseconds, of this ExplosionData object.
int | lifetimeVariance
Time variance, in milliseconds, for the lifetimeMS of this ExplosionData object.
float | lightEndBrightness
ColorF | lightEndColor
float | lightEndRadius
float | lightNormalOffset
float | lightStartBrightness
ColorF | lightStartColor
float | lightStartRadius
float | offset
Allowed offset for the center position of this ExplosionData to be created from the specified position.
int | particleDensity
Density of the particles used in the explosion.
ParticleEmitterData ParticleEmitter
ParticleEmitterData object to be spawned with this explosion.
float | particleRadius
Radius distance that particles should travel from the explosion.
float | playSpeed
Time scale at which to play the full explosion sequence.
bool | shakeCamera
Boolean, determines if the camera shakes or not during this explosion.
Point3F | sizes [4]
Sizes to set the ExplosionData. Up to 4 allowed. Will transition through sizes based on values set in the times value.
SFXTrack soundProfile
Non-looping sound effect that will be played at the start of the explosion.
ExplosionData | subExplosion [5]
List of additional ExplosionData objects to create alongside this ExplosionData object.
float | times [4]
Times to transition through the explosion effect. Up to 4 allowed. Values are 0.0 - 1.0, and corrispond to the life of the ExplosionData where 0 is the beginning and 1 is end of the lifespace.

Detailed Description

The data on what an explosion should look like. Definesa particle data, debris data, affects the lighting conditions in the region of the explosion, and shakes the camera.

Member Data Documentation

Point3F ExplosionData::camShakeAmp

Amplitude to shake the camera, defined as the 3 F32 values of X Y Z.

float ExplosionData::camShakeDuration

Duration to shake the camera.

float ExplosionData::camShakeFalloff

Falloff value for the camera shake.

Point3F ExplosionData::camShakeFreq

Frequency to shake the camera, defined as the 3 F32 values of X Y Z.

float ExplosionData::camShakeRadius

Radial distance that a camera's position must be in relation to the center of the explosion to have its camera shaken.

DebrisData ExplosionData::Debris

List of DebrisData to spawn with this explosion.

int ExplosionData::debrisNum

Number of debris objects to create.

int ExplosionData::debrisNumVariance

Variance in the number of debris objects to create, from 0 to n.

float ExplosionData::debrisPhiMax

Maximum reference angle, from the vertical plane, to eject debris from.

float ExplosionData::debrisPhiMin

Minimum reference angle, from the vertical plane, to eject debris from.

float ExplosionData::debrisThetaMax

Maximum angle, from the horizontal plane, to eject debris from.

float ExplosionData::debrisThetaMin

Minimum angle, from the horizontal plane, to eject debris from.

float ExplosionData::debrisVelocity

Velocity to toss debris at.

float ExplosionData::debrisVelocityVariance

Variance in the debris velocity, from 0 to n.

int ExplosionData::delayMS

Amount of time, in milliseconds, to delay the explosion from starting from the creation of this ExplosionData object.

int ExplosionData::delayVariance

Variance of the delayMS, in milliseconds, to delay the expolosion from start from the creation of this ExplosionData object.

ParticleEmitterData ExplosionData::emitter[4]

List of ParticleEmitterData objects to spawn with this explosion.

Point3F ExplosionData::explosionScale

Scale size create the explosionShape DTS model at the start of the explosion.

filename ExplosionData::explosionShape

DTS shape to place at the center of the explosion. The 'ambient' animation of this model will automatically be played at the start of the explosion.

bool ExplosionData::faceViewer

Boolean, sets if the visual effects of the explosion should or should not face the player.

int ExplosionData::lifetimeMS

Lifetime, in milliseconds, of this ExplosionData object.

int ExplosionData::lifetimeVariance

Time variance, in milliseconds, for the lifetimeMS of this ExplosionData object.

float ExplosionData::lightEndBrightness
ColorF ExplosionData::lightEndColor
float ExplosionData::lightEndRadius
float ExplosionData::lightNormalOffset
float ExplosionData::lightStartBrightness
ColorF ExplosionData::lightStartColor
float ExplosionData::lightStartRadius
float ExplosionData::offset

Allowed offset for the center position of this ExplosionData to be created from the specified position.

int ExplosionData::particleDensity

Density of the particles used in the explosion.

ParticleEmitterData ExplosionData::ParticleEmitter

ParticleEmitterData object to be spawned with this explosion.

float ExplosionData::particleRadius

Radius distance that particles should travel from the explosion.

float ExplosionData::playSpeed

Time scale at which to play the full explosion sequence.

bool ExplosionData::shakeCamera

Boolean, determines if the camera shakes or not during this explosion.

Point3F ExplosionData::sizes[4]

Sizes to set the ExplosionData. Up to 4 allowed. Will transition through sizes based on values set in the times value.

SFXTrack ExplosionData::soundProfile

Non-looping sound effect that will be played at the start of the explosion.

ExplosionData ExplosionData::subExplosion[5]

List of additional ExplosionData objects to create alongside this ExplosionData object.

float ExplosionData::times[4]

Times to transition through the explosion effect. Up to 4 allowed. Values are 0.0 - 1.0, and corrispond to the life of the ExplosionData where 0 is the beginning and 1 is end of the lifespace.


Torque 3D - Script Manual: FileDialog Class Reference

FileDialog Class Reference
[File I/O]

Base class responsible for displaying an OS file browser. More...

Inheritance diagram for FileDialog:
[legend]

List of all members.

Public Member Functions

bool | Execute ()
Launches the OS file browser.

Public Attributes

bool | changePath
True/False whether to set the working directory to the directory returned by the dialog.
string | defaultFile
The default file path when the dialog is shown.
string | defaultPath
The default directory path when the dialog is shown.
string | fileName
The default file name when the dialog is shown.
string | filters
The filter string for limiting the types of files visible in the dialog. It makes use of the pipe symbol '|' as a delimiter. For example:
string | title
The title for the dialog.

Detailed Description

Base class responsible for displaying an OS file browser.

FileDialog is a platform agnostic dialog interface for querying the user for file locations. It is designed to be used through the exposed scripting interface.

FileDialog is the base class for Native File Dialog controls in Torque. It provides these basic areas of functionality:

  • Inherits from SimObject and is exposed to the scripting interface
  • Provides blocking interface to allow instant return to script execution
  • Simple object configuration makes practical use easy and effective

FileDialog is *NOT* intended to be used directly in script and is only exposed to script to expose generic file dialog attributes.

This base class is usable in TorqueScript, but is does not specify what functionality is intended (open or save?). Its children, OpenFileDialog and SaveFileDialog, do make use of DialogStyle flags and do make use of specific funcationality. These are the preferred classes to use

However, the FileDialog base class does contain the key properties and important method for file browing. The most important function is Execute(). This is used by both SaveFileDialog and OpenFileDialog to initiate the browser.

Example:
// NOTE: This is not he preferred class to use, but this still works

// Create the file dialog
%baseFileDialog = new FileDialog()
{
   // Allow browsing of all file types
   filters = "*.*";

   // No default file
   defaultFile = ;

   // Set default path relative to project
   defaultPath = "./";

   // Set the title
   title = "Durpa";

   // Allow changing of path you are browsing
   changePath = true;
};

 // Launch the file dialog
 %baseFileDialog.Execute();

 // Don't forget to cleanup
 %baseFileDialog.delete();
Note:
FileDialog and its related classes are only availble in a Tools build of Torque.
See also:
OpenFileDialog for a practical example on opening a file
SaveFileDialog for a practical example of saving a file

Member Function Documentation

bool FileDialog::Execute ( )

Launches the OS file browser.

After an Execute() call, the chosen file name and path is available in one of two areas. If only a single file selection is permitted, the results will be stored in the fileName attribute.

If multiple file selection is permitted, the results will be stored in the files array. The total number of files in the array will be stored in the fileCount attribute.

Example:
// NOTE: This is not he preferred class to use, but this still works

// Create the file dialog
%baseFileDialog = new FileDialog()
{
   // Allow browsing of all file types
   filters = "*.*";

   // No default file
   defaultFile = ;

   // Set default path relative to project
   defaultPath = "./";

   // Set the title
   title = "Durpa";

   // Allow changing of path you are browsing
   changePath = true;
};

 // Launch the file dialog
 %baseFileDialog.Execute();

 // Don't forget to cleanup
 %baseFileDialog.delete();

 // A better alternative is to use the
 // derived classes which are specific to file open and save

 // Create a dialog dedicated to opening files
 %openFileDlg = new OpenFileDialog()
 {
    // Look for jpg image files
    // First part is the descriptor|second part is the extension
    Filters = "Jepg Files|*.jpg";
    // Allow browsing through other folders
    ChangePath = true;

    // Only allow opening of one file at a time
    MultipleFiles = false;
 };

 // Launch the open file dialog
 %result = %openFileDlg.Execute();

 // Obtain the chosen file name and path
 if ( %result )
 {
    %seletedFile = %openFileDlg.file;
 }
 else
 {
    %selectedFile = "";
 }
 // Cleanup
 %openFileDlg.delete();

 // Create a dialog dedicated to saving a file
 %saveFileDlg = new SaveFileDialog()
 {
    // Only allow for saving of COLLADA files
    Filters = "COLLADA Files (*.dae)|*.dae|";

    // Default save path to where the WorldEditor last saved
    DefaultPath = $pref::WorldEditor::LastPath;

    // No default file specified
    DefaultFile = "";

    // Do not allow the user to change to a new directory
    ChangePath = false;

    // Prompt the user if they are going to overwrite an existing file
    OverwritePrompt = true;
 };

 // Launch the save file dialog
 %result = %saveFileDlg.Execute();

 // Obtain the file name
 %selectedFile = "";
 if ( %result )
    %selectedFile = %saveFileDlg.file;

 // Cleanup
 %saveFileDlg.delete();
Returns:
True if the file was selected was successfully found (opened) or declared (saved).

Member Data Documentation

bool FileDialog::changePath

True/False whether to set the working directory to the directory returned by the dialog.

string FileDialog::defaultFile

The default file path when the dialog is shown.

string FileDialog::defaultPath

The default directory path when the dialog is shown.

string FileDialog::fileName

The default file name when the dialog is shown.

string FileDialog::filters

The filter string for limiting the types of files visible in the dialog. It makes use of the pipe symbol '|' as a delimiter. For example:

'All Files|*.*'

'Image Files|*.png;*.jpg|Png Files|*.png|Jepg Files|*.jpg'

string FileDialog::title

The title for the dialog.


Torque 3D - Script Manual: FileObject Class Reference

FileObject Class Reference
[File I/O]

This class is responsible opening, reading, creating, and saving file contents. More...

Inheritance diagram for FileObject:
[legend]

List of all members.

Public Member Functions

void | close ()
Close the file.
bool | isEOF ()
Determines if the parser for this FileObject has reached the end of the file.
bool | openForAppend (string filename)
Open a specified file for writing, adding data to the end of the file.
bool | openForRead (string filename)
Open a specified file for reading.
bool | openForWrite (string filename)
Open a specified file for writing.
string | peekLine ()
Read a line from the file without moving the stream position.
string | readLine ()
Read a line from file.
void | writeLine (string text)
Write a line to the file, if it was opened for writing.
void | writeObject (SimObject *object)
Write an object to a text file.
void | writeObject (SimObject *object, string prepend)
Write an object to a text file, with some data added first.

Detailed Description

This class is responsible opening, reading, creating, and saving file contents.

FileObject acts as the interface with OS level files. You create a new FileObject and pass into it a file's path and name. The FileObject class supports three distinct operations for working with files:

Operation | FileObject Method | Description
Read | openForRead() | Open the file for reading
Write | openForWrite() | Open the file for writing to and replace its contents (if any)
Append | openForAppend() | Open the file and start writing at its end

Before you may work with a file you need to use one of the three above methods on the FileObject.

Example:
// Create a file object for writing
%fileWrite = new FileObject();

// Open a file to write to, if it does not exist it will be created
%result = %fileWrite.OpenForWrite("./test.txt");

if ( %result )
{
   // Write a line to the text files
   %fileWrite.writeLine("READ. READ CODE. CODE");
}

// Close the file when finished
%fileWrite.close();

// Cleanup the file object
%fileWrite.delete();

// Create a file object for reading
%fileRead = new FileObject();

// Open a text file, if it exists
%result = %fileRead.OpenForRead("./test.txt");

if ( %result )
{
   // Read in the first line
   %line = %fileRead.readline();

   // Print the line we just read
   echo(%line);
}

// Close the file when finished
%fileRead.close();

// Cleanup the file object
%fileRead.delete();

Member Function Documentation

void FileObject::close ( )

Close the file.

It is EXTREMELY important that you call this function when you are finished reading or writing to a file. Failing to do so is not only a bad programming practice, but could result in bad data or corrupt files. Remember: Open, Read/Write, Close, Delete...in that order!

Example:
// Create a file object for reading
%fileRead = new FileObject();

// Open a text file, if it exists
%fileRead.OpenForRead("./test.txt");

// Peek the first line
%line = %fileRead.peekLine();

// Print the line we just peeked
echo(%line);
// If we peek again...
%line = %fileRead.peekLine();

// We will get the same output as the first time
// since the stream did not move forward
echo(%line);

// Close the file when finished
%fileWrite.close();

// Cleanup the file object
%fileWrite.delete();
bool FileObject::isEOF ( )

Determines if the parser for this FileObject has reached the end of the file.

Example:
// Create a file object for reading
%fileRead = new FileObject();

// Open a text file, if it exists
%fileRead.OpenForRead("./test.txt");

// Keep reading until we reach the end of the file
while( !%fileRead.isEOF() )
{
   %line = %fileRead.readline();
   echo(%line);
}

// Made it to the end
echo("Finished reading file");
Returns:
True if the parser has reached the end of the file, false otherwise
bool FileObject::openForAppend ( string filename )

Open a specified file for writing, adding data to the end of the file.

There is no limit as to what kind of file you can write. Any format and data is allowable, not just text. Unlike openForWrite(), which will erase an existing file if it is opened, openForAppend() preserves data in an existing file and adds to it.

Parameters:
filename Path, name, and extension of file to append to
Example:
// Create a file object for writing
%fileWrite = new FileObject();

// Open a file to write to, if it does not exist it will be created
// If it does exist, whatever we write will be added to the end
%result = %fileWrite.OpenForAppend("./test.txt");
Returns:
True if file was successfully opened, false otherwise
bool FileObject::openForRead ( string filename )

Open a specified file for reading.

There is no limit as to what kind of file you can read. Any format and data contained within is accessible, not just text

Parameters:
filename Path, name, and extension of file to be read
Example:
// Create a file object for reading
%fileRead = new FileObject();

// Open a text file, if it exists
%result = %fileRead.OpenForRead("./test.txt");
Returns:
True if file was successfully opened, false otherwise
bool FileObject::openForWrite ( string filename )

Open a specified file for writing.

There is no limit as to what kind of file you can write. Any format and data is allowable, not just text

Parameters:
filename Path, name, and extension of file to write to
Example:
// Create a file object for writing
%fileWrite = new FileObject();

// Open a file to write to, if it does not exist it will be created
%result = %fileWrite.OpenForWrite("./test.txt");
Returns:
True if file was successfully opened, false otherwise
string FileObject::peekLine ( )

Read a line from the file without moving the stream position.

Emphasis on *line*, as in you cannot parse individual characters or chunks of data. There is no limitation as to what kind of data you can read. Unlike readLine, the parser does not move forward after reading.

Parameters:
filename Path, name, and extension of file to be read
Example:
// Create a file object for reading
%fileRead = new FileObject();

// Open a text file, if it exists
%fileRead.OpenForRead("./test.txt");

// Peek the first line
%line = %fileRead.peekLine();

// Print the line we just peeked
echo(%line);
// If we peek again...
%line = %fileRead.peekLine();

// We will get the same output as the first time
// since the stream did not move forward
echo(%line);
Returns:
String containing the line of data that was just peeked
string FileObject::readLine ( )

Read a line from file.

Emphasis on *line*, as in you cannot parse individual characters or chunks of data. There is no limitation as to what kind of data you can read.

Example:
// Create a file object for reading
%fileRead = new FileObject();

// Open a text file, if it exists
%fileRead.OpenForRead("./test.txt");

// Read in the first line
%line = %fileRead.readline();

// Print the line we just read
echo(%line);
Returns:
String containing the line of data that was just read
void FileObject::writeLine ( string text )

Write a line to the file, if it was opened for writing.

There is no limit as to what kind of text you can write. Any format and data is allowable, not just text. Be careful of what you write, as whitespace, current values, and literals will be preserved.

Parameters:
text The data we are writing out to file.
Example:
// Create a file object for writing
%fileWrite = new FileObject();

// Open a file to write to, if it does not exist it will be created
%fileWrite.OpenForWrite("./test.txt");

// Write a line to the text files
%fileWrite.writeLine("READ. READ CODE. CODE");
Returns:
True if file was successfully opened, false otherwise
void FileObject::writeObject ( SimObject * object )

Write an object to a text file.

Unlike a simple writeLine using specified strings, this function writes an entire object to file, preserving its type, name, and properties. This is similar to the save() functionality of the SimObject class, but with a bit more control.

Parameters:
object The SimObject being written to file, properties, name, and all.
Example:
// Let's assume this SpawnSphere was created and currently
// exists in the running level
new SpawnSphere(TestSphere)
{
   spawnClass = "Player";
   spawnDatablock = "DefaultPlayerData";
   autoSpawn = "1";
   radius = "5";
   sphereWeight = "1";
   indoorWeight = "1";
   outdoorWeight = "1";
   dataBlock = "SpawnSphereMarker";
   position = "-42.222 1.4845 4.80334";
   rotation = "0 0 -1 108";
   scale = "1 1 1";
   canSaveDynamicFields = "1";
};

// Create a file object for writing
%fileWrite = new FileObject();

// Open a file to write to, if it does not exist it will be created
%fileWrite.OpenForWrite("./spawnSphers.txt");

// Write out the TestSphere
%fileWrite.writeObject(TestSphere);

// Close the text file
%fileWrite.close();

// Cleanup
%fileWrite.delete();

void FileObject::writeObject | ( | SimObject * | object,
 |  | string | prepend
 | ) |  |

Write an object to a text file, with some data added first.

Unlike a simple writeLine using specified strings, this function writes an entire object to file, preserving its type, name, and properties. This is similar to the save() functionality of the SimObject class, but with a bit more control.

Parameters:
object | The SimObject being written to file, properties, name, and all.
prepend | Data or text that is written out before the SimObject.
Example:
// Let's assume this SpawnSphere was created and currently
// exists in the running level
new SpawnSphere(TestSphere)
{
   spawnClass = "Player";
   spawnDatablock = "DefaultPlayerData";
   autoSpawn = "1";
   radius = "5";
   sphereWeight = "1";
   indoorWeight = "1";
   outdoorWeight = "1";
   dataBlock = "SpawnSphereMarker";
   position = "-42.222 1.4845 4.80334";
   rotation = "0 0 -1 108";
   scale = "1 1 1";
   canSaveDynamicFields = "1";
};

// Create a file object for writing
%fileWrite = new FileObject();

// Open a file to write to, if it does not exist it will be created
%fileWrite.OpenForWrite("./spawnSphers.txt");

// Write out the TestSphere, with a prefix
%fileWrite.writeObject(TestSphere, "$mySphere = ");

// Close the text file
%fileWrite.close();

// Cleanup
%fileWrite.delete();


Torque 3D - Script Manual: FileStreamObject Class Reference

FileStreamObject Class Reference
[File I/O]

A wrapper around StreamObject for parsing text and data from files. More...

Inheritance diagram for FileStreamObject:
[legend]

List of all members.

Public Member Functions

void | close ()
Close the file. You can no longer read or write to it unless you open it again.
bool | open (string filename, string openMode)
Open a file for reading, writing, reading and writing, or appending.

Detailed Description

A wrapper around StreamObject for parsing text and data from files.

FileStreamObject inherits from StreamObject and provides some unique methods for working with strings. If you're looking for general file handling, you may want to use FileObject.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
%fsObject.open("./test.txt", "read");

// Get the status and print it
%status = %fsObject.getStatus();
echo(%status);

// Always remember to close a file stream when finished
%fsObject.close();
See also:
StreamObject for the list of inherited functions variables
FileObject for general file handling.

Member Function Documentation

void FileStreamObject::close ( )

Close the file. You can no longer read or write to it unless you open it again.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
%fsObject.open("./test.txt", "read");

// Always remember to close a file stream when finished
%fsObject.close();
See also:
open()
bool FileStreamObject::open | ( | string | filename,
 |  | string | openMode
 | ) |  |

Open a file for reading, writing, reading and writing, or appending.

Using "Read" for the open mode allows you to parse the contents of file, but not making modifications. "Write" will create a new file if it does not exist, or erase the contents of an existing file when opened. Write also allows you to modify the contents of the file.

"ReadWrite" will provide the ability to parse data (read it in) and manipulate data (write it out) interchangeably. Keep in mind the stream can move during each operation. Finally, "WriteAppend" will open a file if it exists, but will not clear the contents. You can write new data starting at the end of the files existing contents.

Parameters:
filename | Name of file to open
openMode | One of "Read", "Write", "ReadWrite" or "WriteAppend"
Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
%fsObject.open("./test.txt", "read");

// Get the status and print it
%status = %fsObject.getStatus();
echo(%status);

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
True if the file was successfully opened, false if something went wrong
See also:
close()


Torque 3D - Script Manual: FlyingVehicle Class Reference

FlyingVehicle Class Reference
[Vehicles]

A flying vehicle. More...

Inheritance diagram for FlyingVehicle:
[legend]

List of all members.

Public Member Functions

void | useCreateHeight (bool enabled)
Set whether the vehicle should temporarily use the createHoverHeight specified in the datablock.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A flying vehicle.

The model used for the FlyingVehicle has the following requirements:

Collision mesh
A convex collision mesh at detail size -1.
JetNozzle0-1 nodes
Particle emitter nodes used when thrusting forward.
JetNozzle2-3 nodes
Particle emitter nodes used when thrusting downward.
JetNozzleX, JetNozzleY nodes
Particle emitter nodes used when thrusting backward.
contrail0-3 nodes
Particle emitter nodes used when generating contrails.
activateBack animation
Non-cyclic animation sequence played when the vehicle begins thrusting forwards.
maintainBack animation
Cyclic animation sequence played after activateBack when the vehicle continues thrusting forwards.
activateBot animation
Non-cyclic animation sequence played when the vehicle begins thrusting upwards.
maintainBot animation
Cyclic animation sequence played after activateBot when the vehicle continues thrusting upwards.

Member Function Documentation

void FlyingVehicle::useCreateHeight ( bool enabled )

Set whether the vehicle should temporarily use the createHoverHeight specified in the datablock.

This can help avoid problems with spawning.

Parameters:
enabled true to use the datablock createHoverHeight, false otherwise

Member Data Documentation

bool FlyingVehicle::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from Vehicle.

bool FlyingVehicle::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from Vehicle.


Torque 3D - Script Manual: FlyingVehicleData Class Reference

FlyingVehicleData Class Reference
[Vehicles]

Defines the properties of a FlyingVehicle. More...

Inheritance diagram for FlyingVehicleData:
[legend]

List of all members.

Public Attributes

float | autoAngularForce
Corrective torque applied to level out the vehicle when moving at less than maxAutoSpeed.
float | autoInputDamping
Scale factor applied to steering input if speed is less than maxAutoSpeed.
float | autoLinearForce
Corrective force applied to slow the vehicle when moving at less than maxAutoSpeed.
ParticleEmitterData backwardJetEmitter
Emitter to generate particles for backward jet thrust.
float | createHoverHeight
The vehicle's height off the ground when useCreateHeight is active.
ParticleEmitterData downJetEmitter
Emitter to generate particles for downward jet thrust.
SFXProfile engineSound
Looping engine sound.
ParticleEmitterData forwardJetEmitter
Emitter to generate particles for forward jet thrust.
float | horizontalSurfaceForce
Damping force in the opposite direction to sideways velocity.
float | hoverHeight
The vehicle's height off the ground when at rest.
SFXProfile jetSound
Looping sound to play while the vehicle is jetting.
float | maneuveringForce
Maximum X and Y (horizontal plane) maneuvering force.
float | maxAutoSpeed
Maximum speed for automatic vehicle control assistance.
float | minTrailSpeed
Minimum speed to start generating contrail particles.
float | rollForce
Damping torque against rolling maneuvers (rotation about the y-axis).
float | rotationalDrag
Rotational drag factor.
float | steeringForce
Maximum X and Z (sideways and vertical) steering force.
float | steeringRollForce
Roll force induced by sideways steering input value.
ParticleEmitterData trailEmitter
Emitter to generate contrail particles from model nodes contrail0 - contrail3.
float | verticalSurfaceForce
Damping force in the opposite direction to vertical velocity.
float | vertThrustMultiple
Multiplier applied to the jetForce (defined in VehicleData) when thrusting vertically.

Detailed Description

Defines the properties of a FlyingVehicle.

Member Data Documentation

float FlyingVehicleData::autoAngularForce

Corrective torque applied to level out the vehicle when moving at less than maxAutoSpeed.

The force is inversely proportional to vehicle speed.

float FlyingVehicleData::autoInputDamping

Scale factor applied to steering input if speed is less than maxAutoSpeed.

Smaller values make steering less sensitive.

float FlyingVehicleData::autoLinearForce

Corrective force applied to slow the vehicle when moving at less than maxAutoSpeed.

The force is inversely proportional to vehicle speed.

ParticleEmitterData FlyingVehicleData::backwardJetEmitter

Emitter to generate particles for backward jet thrust.

Backward jet thrust particles are emitted from model nodes JetNozzleX and JetNozzleY.

float FlyingVehicleData::createHoverHeight

The vehicle's height off the ground when useCreateHeight is active.

This can help avoid problems with spawning the vehicle.

ParticleEmitterData FlyingVehicleData::downJetEmitter

Emitter to generate particles for downward jet thrust.

Downward jet thrust particles are emitted from model nodes JetNozzle2 and JetNozzle3.

SFXProfile FlyingVehicleData::engineSound

Looping engine sound.

ParticleEmitterData FlyingVehicleData::forwardJetEmitter

Emitter to generate particles for forward jet thrust.

Forward jet thrust particles are emitted from model nodes JetNozzle0 and JetNozzle1.

float FlyingVehicleData::horizontalSurfaceForce

Damping force in the opposite direction to sideways velocity.

float FlyingVehicleData::hoverHeight

The vehicle's height off the ground when at rest.

SFXProfile FlyingVehicleData::jetSound

Looping sound to play while the vehicle is jetting.

float FlyingVehicleData::maneuveringForce

Maximum X and Y (horizontal plane) maneuvering force.

The actual force applied depends on the current thrust.

float FlyingVehicleData::maxAutoSpeed

Maximum speed for automatic vehicle control assistance.

Vehicles travelling at speeds above this value do not get control assitance.

float FlyingVehicleData::minTrailSpeed

Minimum speed to start generating contrail particles.

float FlyingVehicleData::rollForce

Damping torque against rolling maneuvers (rotation about the y-axis).

Acts to adjust roll to a stable position over time.

float FlyingVehicleData::rotationalDrag

Rotational drag factor.

Slows vehicle rotation.

float FlyingVehicleData::steeringForce

Maximum X and Z (sideways and vertical) steering force.

The actual force applied depends on the current steering input.

float FlyingVehicleData::steeringRollForce

Roll force induced by sideways steering input value.

ParticleEmitterData FlyingVehicleData::trailEmitter

Emitter to generate contrail particles from model nodes contrail0 - contrail3.

float FlyingVehicleData::verticalSurfaceForce

Damping force in the opposite direction to vertical velocity.

float FlyingVehicleData::vertThrustMultiple

Multiplier applied to the jetForce (defined in VehicleData) when thrusting vertically.


Torque 3D - Script Manual: Forest Class Reference

Forest Class Reference
[Forest]

Forest is a global-bounds scene object provides collision and rendering for a (.forest) data file. More...

Inheritance diagram for Forest:
[legend]

List of all members.

Public Member Functions

void | clear ()
bool | isDirty ()
void | regenCells ()

Public Attributes

filename | dataFile
The source forest data file.
bool | saveDataFile
saveDataFile( [path] )
Lod

float | lodReflectScalar
Scalar applied to the farclip distance when Forest renders into a reflection.

Static Public Attributes

static bool | disableImposters
A debugging aid which will disable rendering of all imposters in the forest.
static bool | drawBounds
A debugging aid which renders the forest bounds.
static bool | drawCells
A debugging aid which renders the forest cell bounds.
static bool | forceImposters
A debugging aid which will force all forest items to be rendered as imposters.
static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Forest is a global-bounds scene object provides collision and rendering for a (.forest) data file.

Forest is designed to efficiently render a large number of static meshes: trees, rocks plants, etc. These cannot be moved at game-time or play animations but do support wind effects using vertex shader transformations guided by vertex color in the asset and user placed wind emitters ( or weapon explosions ).

Script level manipulation of forest data is not possible through Forest, it is only the rendering/collision. All editing is done through the world editor.

See also:
TSForestItemData Defines a tree type.
GuiForestEditorCtrl Used by the world editor to provide manipulation of forest data.

Member Function Documentation

void Forest::clear ( )
bool Forest::isDirty ( )
void Forest::regenCells ( )

Member Data Documentation

filename Forest::dataFile

The source forest data file.

bool Forest::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool Forest::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

float Forest::lodReflectScalar

Scalar applied to the farclip distance when Forest renders into a reflection.

bool Forest::saveDataFile

saveDataFile( [path] )


Torque 3D - Script Manual: ForestBrushElement Class Reference

ForestBrushElement Class Reference
[Forest]

Represents a type of ForestItem and parameters for how it is placed when painting with a ForestBrush that contains it. More...

Inheritance diagram for ForestBrushElement:
[legend]

List of all members.

Public Attributes

ForestBrushElement

float | elevationMax
The max world space elevation this item will be placed.
float | elevationMin
The min world space elevation this item will be placed.
ForestItemData ForestItemData
The type of ForestItem this element holds placement parameters for.
float | probability
The probability that this element will be created during an editor brush stroke is the sum of all element probabilities in the brush divided by the probability of this element.
float | rotationRange
The max rotation in degrees that items will be placed.
float | scaleExponent
An exponent used to bias between the minimum and maximum random sizes.
float | scaleMax
The maximum random size of each item.
float | scaleMin
The minimum random size for each item.
float | sinkMax
Max variation in the sink radius.
float | sinkMin
Min variation in the sink radius.
float | sinkRadius
This is the radius used to calculate how much to sink the trunk at its base and is used to sink the tree into the ground when its on a slope.
float | slopeMax
The max surface slope in degrees this item will be placed on.
float | slopeMin
The min surface slope in degrees this item will be placed on.

Detailed Description

Represents a type of ForestItem and parameters for how it is placed when painting with a ForestBrush that contains it.

Member Data Documentation

float ForestBrushElement::elevationMax

The max world space elevation this item will be placed.

float ForestBrushElement::elevationMin

The min world space elevation this item will be placed.

ForestItemData ForestBrushElement::ForestItemData

The type of ForestItem this element holds placement parameters for.

float ForestBrushElement::probability

The probability that this element will be created during an editor brush stroke is the sum of all element probabilities in the brush divided by the probability of this element.

float ForestBrushElement::rotationRange

The max rotation in degrees that items will be placed.

float ForestBrushElement::scaleExponent

An exponent used to bias between the minimum and maximum random sizes.

float ForestBrushElement::scaleMax

The maximum random size of each item.

float ForestBrushElement::scaleMin

The minimum random size for each item.

float ForestBrushElement::sinkMax

Max variation in the sink radius.

float ForestBrushElement::sinkMin

Min variation in the sink radius.

float ForestBrushElement::sinkRadius

This is the radius used to calculate how much to sink the trunk at its base and is used to sink the tree into the ground when its on a slope.

float ForestBrushElement::slopeMax

The max surface slope in degrees this item will be placed on.

float ForestBrushElement::slopeMin

The min surface slope in degrees this item will be placed on.


Torque 3D - Script Manual: ForestItemData Class Reference

ForestItemData Class Reference
[Forest]

Base class for defining a type of ForestItem. It does not implement loading or rendering of the shapeFile. More...

Inheritance diagram for ForestItemData:
[legend]

List of all members.

Public Attributes

Wind

float | branchAmp
Amplitude of the effect on larger branches.
float | dampingCoefficient
Coefficient used in calculating spring forces on the trunk. Causes oscillation and forces to decay faster over time.
float | detailAmp
Amplitude of the winds effect on leafs/fronds.
float | detailFreq
Frequency (speed) of the effect on leafs/fronds.
float | mass
Mass used in calculating spring forces on the trunk. Generally how springy a plant is.
float | rigidity
Rigidity used in calculating spring forces on the trunk. How much the plant resists the wind force.
float | tightnessCoefficient
Coefficient used in calculating spring forces on the trunk. How much the plant resists bending.
float | trunkBendScale
Overall bend amount of the tree trunk by wind and impacts.
float | windScale
Overall scale to the effect of wind.
Media

bool | collidable
Can other objects or spacial queries hit items of this type.
float | radius
Radius used during placement to ensure items are not crowded.
filename | shapeFile
Shape file for this item type.

Detailed Description

Base class for defining a type of ForestItem. It does not implement loading or rendering of the shapeFile.

Member Data Documentation

float ForestItemData::branchAmp

Amplitude of the effect on larger branches.

bool ForestItemData::collidable

Can other objects or spacial queries hit items of this type.

float ForestItemData::dampingCoefficient

Coefficient used in calculating spring forces on the trunk. Causes oscillation and forces to decay faster over time.

float ForestItemData::detailAmp

Amplitude of the winds effect on leafs/fronds.

float ForestItemData::detailFreq

Frequency (speed) of the effect on leafs/fronds.

float ForestItemData::mass

Mass used in calculating spring forces on the trunk. Generally how springy a plant is.

float ForestItemData::radius

Radius used during placement to ensure items are not crowded.

float ForestItemData::rigidity

Rigidity used in calculating spring forces on the trunk. How much the plant resists the wind force.

filename ForestItemData::shapeFile

Shape file for this item type.

float ForestItemData::tightnessCoefficient

Coefficient used in calculating spring forces on the trunk. How much the plant resists bending.

float ForestItemData::trunkBendScale

Overall bend amount of the tree trunk by wind and impacts.

float ForestItemData::windScale

Overall scale to the effect of wind.


Torque 3D - Script Manual: ForestWindEmitter Class Reference

ForestWindEmitter Class Reference
[Special Effects, Forest]

Object responsible for simulating wind in a level. More...

Inheritance diagram for ForestWindEmitter:
[legend]

List of all members.

Public Member Functions

void | attachToObject (int objectID)
Mounts the wind emitter to another scene object.

Public Attributes

ForestWind

float | gustFrequency
The frequency of gusting in seconds.
float | gustStrength
The maximum strength of a gust.
float | gustWobbleStrength
The amount of random wobble added to gust and turbulence vectors.
float | gustYawAngle
The amount of degrees the wind direction can drift (both positive and negative).
float | gustYawFrequency
The frequency of wind yaw drift, in seconds.
bool | hasMount
Determines if the emitter is mounted to another object.
bool | radialEmitter
Determines if the emitter is a global direction or local radial emitter.
float | radius
The radius of the emitter for local radial emitters.
float | strength
The strength of the wind force.
float | turbulenceFrequency
The frequency of gust turbulence, in seconds.
float | turbulenceStrength
The strength of gust turbulence.
bool | windEnabled
Determines if the emitter will be counted in wind calculations.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Object responsible for simulating wind in a level.

When placed in the level, a ForestWindEmitter will cause tree branches to bend and sway, leaves to flutter, and create vertical bending on the tree's trunk.

Example:
// The following is a full declaration of a wind emitter
new ForestWindEmitter()
{
   position = "497.739 765.821 102.395";
   windEnabled = "1";
   radialEmitter = "1";
   strength = "1";
   radius = "3";
   gustStrength = "0.5";
   gustFrequency = "1";
   gustYawAngle = "10";
   gustYawFrequency = "4";
   gustWobbleStrength = "2";
   turbulenceStrength = "1";
   turbulenceFrequency = "2";
   hasMount = "0";
   scale = "3 3 3";
   canSave = "1";
   canSaveDynamicFields = "1";
   rotation = "1 0 0 0";
};

Member Function Documentation

void ForestWindEmitter::attachToObject ( int objectID )

Mounts the wind emitter to another scene object.

Parameters:
objectID Unique ID of the object wind emitter should attach to
Example:
// Wind emitter previously created and named %windEmitter
// Going to attach it to the player, making him a walking wind storm
%windEmitter.attachToObject(%player);

Member Data Documentation

float ForestWindEmitter::gustFrequency

The frequency of gusting in seconds.

float ForestWindEmitter::gustStrength

The maximum strength of a gust.

float ForestWindEmitter::gustWobbleStrength

The amount of random wobble added to gust and turbulence vectors.

float ForestWindEmitter::gustYawAngle

The amount of degrees the wind direction can drift (both positive and negative).

float ForestWindEmitter::gustYawFrequency

The frequency of wind yaw drift, in seconds.

bool ForestWindEmitter::hasMount

Determines if the emitter is mounted to another object.

bool ForestWindEmitter::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool ForestWindEmitter::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool ForestWindEmitter::radialEmitter

Determines if the emitter is a global direction or local radial emitter.

float ForestWindEmitter::radius

The radius of the emitter for local radial emitters.

float ForestWindEmitter::strength

The strength of the wind force.

float ForestWindEmitter::turbulenceFrequency

The frequency of gust turbulence, in seconds.

float ForestWindEmitter::turbulenceStrength

The strength of gust turbulence.

bool ForestWindEmitter::windEnabled

Determines if the emitter will be counted in wind calculations.


Torque 3D - Script Manual: fxFoliageReplicator Class Reference

fxFoliageReplicator Class Reference
[Foliage]

An emitter to replicate fxFoliageItem objects across an area. More...

Inheritance diagram for fxFoliageReplicator:
[legend]

List of all members.

Public Attributes

Restrictions

int | AllowedTerrainSlope
Maximum surface angle allowed for foliage instances.
bool | AllowOnInteriors
Foliage will be placed on InteriorInstances when set.
bool | AllowOnStatics
Foliage will be placed on Static shapes when set.
bool | AllowOnTerrain
Foliage will be placed on terrain when set.
bool | AllowOnWater
Foliage will be placed on/under water when set.
bool | AllowWaterSurface
Foliage will be placed on water when set. Requires AllowOnWater.
Culling

float | AlphaCutoff
Minimum alpha value allowed on foliage instances.
int | CullResolution
Minimum size of culling bins. Must be >= 8 and <= OuterRadius.
float | FadeInRegion
Region beyond ViewDistance where foliage fades in/out.
float | FadeOutRegion
Region before ViewClosest where foliage fades in/out.
float | GroundAlpha
Alpha of the foliage at ground level. 0 = transparent, 1 = opaque.
bool | UseCulling
Use culling bins when enabled.
float | ViewClosest
Minimum distance from camera where foliage appears.
float | ViewDistance
Maximum distance from camera where foliage appears.
Debugging

float | DebugBoxHeight
Height multiplier for drawn culling bins.
bool | HideFoliage
Foliage is hidden when set to true.
int | PlacementAreaHeight
Height of the placement ring in world units.
ColorF | PlacementColour
Color of the placement ring.
bool | ShowPlacementArea
Draw placement rings when set to true.
bool | UseDebugInfo
Culling bins are drawn when set to true.
Dimensions

bool | FixAspectRatio
Maintain aspect ratio of image if true. This option ignores MaxWidth.
bool | FixSizeToMax
Use only MaxWidth and MaxHeight for billboard size. Ignores MinWidth and MinHeight.
float | MaxHeight
Maximum height of foliage billboards.
float | MaxWidth
Maximum width of foliage billboards.
float | MinHeight
Minimum height of foliage billboards.
float | MinWidth
Minimum width of foliage billboards.
float | OffsetZ
Offset billboards by this amount vertically.
bool | RandomFlip
Randomly flip billboards left-to-right.
bool | useTrueBillboards
Use camera facing billboards ( including the z axis ).
Media

int | FoliageCount
Maximum foliage instance count.
filename | FoliageFile
Image file for the foliage texture.
int | FoliageRetries
Number of times to try placing a foliage instance before giving up.
int | seed
Random seed for foliage placement.
Area

int | InnerRadiusX
Placement area inner radius on the X axis.
int | InnerRadiusY
Placement area inner radius on the Y axis.
int | OuterRadiusX
Placement area outer radius on the X axis.
int | OuterRadiusY
Placement area outer radius on the Y axis.
Lighting

bool | LightOn
Foliage should be illuminated with changing lights when true.
bool | LightSync
Foliage instances have the same lighting when set and LightOn is set.
float | LightTime
Time before foliage illumination cycle repeats.
float | MaxLuminance
Maximum luminance for foliage instances.
float | MinLuminance
Minimum luminance for foliage instances.
Animation

float | MaxSwayTime
Maximum sway cycle time in seconds.
float | MinSwayTime
Minumum sway cycle time in seconds.
float | SwayMagFront
Front-to-back sway magnitude.
float | SwayMagSide
Left-to-right sway magnitude.
bool | SwayOn
Foliage should sway randomly when true.
bool | SwaySync
Foliage instances should sway together when true and SwayOn is enabled.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An emitter to replicate fxFoliageItem objects across an area.

Member Data Documentation

int fxFoliageReplicator::AllowedTerrainSlope

Maximum surface angle allowed for foliage instances.

bool fxFoliageReplicator::AllowOnInteriors

Foliage will be placed on InteriorInstances when set.

bool fxFoliageReplicator::AllowOnStatics

Foliage will be placed on Static shapes when set.

bool fxFoliageReplicator::AllowOnTerrain

Foliage will be placed on terrain when set.

bool fxFoliageReplicator::AllowOnWater

Foliage will be placed on/under water when set.

bool fxFoliageReplicator::AllowWaterSurface

Foliage will be placed on water when set. Requires AllowOnWater.

float fxFoliageReplicator::AlphaCutoff

Minimum alpha value allowed on foliage instances.

int fxFoliageReplicator::CullResolution

Minimum size of culling bins. Must be >= 8 and <= OuterRadius.

float fxFoliageReplicator::DebugBoxHeight

Height multiplier for drawn culling bins.

float fxFoliageReplicator::FadeInRegion

Region beyond ViewDistance where foliage fades in/out.

float fxFoliageReplicator::FadeOutRegion

Region before ViewClosest where foliage fades in/out.

bool fxFoliageReplicator::FixAspectRatio

Maintain aspect ratio of image if true. This option ignores MaxWidth.

bool fxFoliageReplicator::FixSizeToMax

Use only MaxWidth and MaxHeight for billboard size. Ignores MinWidth and MinHeight.

int fxFoliageReplicator::FoliageCount

Maximum foliage instance count.

filename fxFoliageReplicator::FoliageFile

Image file for the foliage texture.

int fxFoliageReplicator::FoliageRetries

Number of times to try placing a foliage instance before giving up.

float fxFoliageReplicator::GroundAlpha

Alpha of the foliage at ground level. 0 = transparent, 1 = opaque.

bool fxFoliageReplicator::HideFoliage

Foliage is hidden when set to true.

int fxFoliageReplicator::InnerRadiusX

Placement area inner radius on the X axis.

int fxFoliageReplicator::InnerRadiusY

Placement area inner radius on the Y axis.

bool fxFoliageReplicator::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool fxFoliageReplicator::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool fxFoliageReplicator::LightOn

Foliage should be illuminated with changing lights when true.

bool fxFoliageReplicator::LightSync

Foliage instances have the same lighting when set and LightOn is set.

float fxFoliageReplicator::LightTime

Time before foliage illumination cycle repeats.

float fxFoliageReplicator::MaxHeight

Maximum height of foliage billboards.

float fxFoliageReplicator::MaxLuminance

Maximum luminance for foliage instances.

float fxFoliageReplicator::MaxSwayTime

Maximum sway cycle time in seconds.

float fxFoliageReplicator::MaxWidth

Maximum width of foliage billboards.

float fxFoliageReplicator::MinHeight

Minimum height of foliage billboards.

float fxFoliageReplicator::MinLuminance

Minimum luminance for foliage instances.

float fxFoliageReplicator::MinSwayTime

Minumum sway cycle time in seconds.

float fxFoliageReplicator::MinWidth

Minimum width of foliage billboards.

float fxFoliageReplicator::OffsetZ

Offset billboards by this amount vertically.

int fxFoliageReplicator::OuterRadiusX

Placement area outer radius on the X axis.

int fxFoliageReplicator::OuterRadiusY

Placement area outer radius on the Y axis.

int fxFoliageReplicator::PlacementAreaHeight

Height of the placement ring in world units.

ColorF fxFoliageReplicator::PlacementColour

Color of the placement ring.

bool fxFoliageReplicator::RandomFlip

Randomly flip billboards left-to-right.

int fxFoliageReplicator::seed

Random seed for foliage placement.

bool fxFoliageReplicator::ShowPlacementArea

Draw placement rings when set to true.

float fxFoliageReplicator::SwayMagFront

Front-to-back sway magnitude.

float fxFoliageReplicator::SwayMagSide

Left-to-right sway magnitude.

bool fxFoliageReplicator::SwayOn

Foliage should sway randomly when true.

bool fxFoliageReplicator::SwaySync

Foliage instances should sway together when true and SwayOn is enabled.

bool fxFoliageReplicator::UseCulling

Use culling bins when enabled.

bool fxFoliageReplicator::UseDebugInfo

Culling bins are drawn when set to true.

bool fxFoliageReplicator::useTrueBillboards

Use camera facing billboards ( including the z axis ).

float fxFoliageReplicator::ViewClosest

Minimum distance from camera where foliage appears.

float fxFoliageReplicator::ViewDistance

Maximum distance from camera where foliage appears.


Torque 3D - Script Manual: fxShapeReplicatedStatic Class Reference

fxShapeReplicatedStatic Class Reference
[Foliage]

The object definition for shapes that will be replicated across an area using an fxShapeReplicator. More...

Inheritance diagram for fxShapeReplicatedStatic:
[legend]

List of all members.

Public Attributes

Collision

bool | allowPlayerStep
Allow a Player to walk up sloping polygons in the TSStatic (based on the collisionType).
TSMeshType collisionType
The type of mesh data to use for collision queries.
TSMeshType decalType
The type of mesh data used to clip decal polygons against.
Debug

int | forceDetail
Forces rendering to a particular detail level.
float | renderNormals
Debug rendering mode shows the normals for each point in the TSStatic's mesh.
Rendering

bool | meshCulling
Enables detailed culling of meshes within the TSStatic. Should only be used with large complex shapes like buildings which contain many submeshes.
bool | originSort
Enables translucent sorting of the TSStatic by its origin instead of the bounds.
bool | playAmbient
Enables automatic playing of the animation sequence named "ambient" (if it exists) when the TSStatic is loaded.
Media

filename | shapeName
Path and filename of the model file (.DTS, .DAE) to use for this TSStatic.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

The object definition for shapes that will be replicated across an area using an fxShapeReplicator.

Member Data Documentation

bool fxShapeReplicatedStatic::allowPlayerStep

Allow a Player to walk up sloping polygons in the TSStatic (based on the collisionType).

When set to false, the slightest bump will stop the player from walking on top of the object.

TSMeshType fxShapeReplicatedStatic::collisionType

The type of mesh data to use for collision queries.

TSMeshType fxShapeReplicatedStatic::decalType

The type of mesh data used to clip decal polygons against.

int fxShapeReplicatedStatic::forceDetail

Forces rendering to a particular detail level.

bool fxShapeReplicatedStatic::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool fxShapeReplicatedStatic::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool fxShapeReplicatedStatic::meshCulling

Enables detailed culling of meshes within the TSStatic. Should only be used with large complex shapes like buildings which contain many submeshes.

bool fxShapeReplicatedStatic::originSort

Enables translucent sorting of the TSStatic by its origin instead of the bounds.

bool fxShapeReplicatedStatic::playAmbient

Enables automatic playing of the animation sequence named "ambient" (if it exists) when the TSStatic is loaded.

float fxShapeReplicatedStatic::renderNormals

Debug rendering mode shows the normals for each point in the TSStatic's mesh.

filename fxShapeReplicatedStatic::shapeName

Path and filename of the model file (.DTS, .DAE) to use for this TSStatic.


Torque 3D - Script Manual: fxShapeReplicator Class Reference

fxShapeReplicator Class Reference
[Foliage]

An emitter for objects to replicate across an area. More...

Inheritance diagram for fxShapeReplicator:
[legend]

List of all members.

Public Attributes

Restraints

bool | AlignToTerrain
Align shapes to surface normal when set.
int | AllowedTerrainSlope
Maximum surface angle allowed for shape instances.
bool | AllowOnInteriors
Shapes will be placed on InteriorInstances when set.
bool | AllowOnStatics
Shapes will be placed on Static shapes when set.
bool | AllowOnTerrain
Shapes will be placed on terrain when set.
bool | AllowOnWater
Shapes will be placed on/under water when set.
bool | AllowWaterSurface
Shapes will be placed on water when set. Requires AllowOnWater.
bool | Interactions
Allow physics interactions with shapes.
Point3F | TerrainAlignment
Surface normals will be multiplied by these values when AlignToTerrain is enabled.
Debugging

bool | HideReplications
Replicated shapes are hidden when set to true.
int | PlacementAreaHeight
Height of the placement ring in world units.
ColorF | PlacementColour
Color of the placement ring.
bool | ShowPlacementArea
Draw placement rings when set to true.
Placement Radius

int | InnerRadiusX
Placement area inner radius on the X axis.
int | InnerRadiusY
Placement area inner radius on the Y axis.
int | OuterRadiusX
Placement area outer radius on the X axis.
int | OuterRadiusY
Placement area outer radius on the Y axis.
Object Transforms

int | OffsetZ
Offset shapes by this amount vertically.
Point3F | ShapeRotateMax
Maximum shape rotation angles.
Point3F | ShapeRotateMin
Minimum shape rotation angles.
Point3F | ShapeScaleMax
Maximum shape scale.
Point3F | ShapeScaleMin
Minimum shape scale.
Replications

int | seed
Random seed for shape placement.
int | ShapeCount
Maximum shape instance count.
int | ShapeRetries
Number of times to try placing a shape instance before giving up.
Media

filename | shapeFile
Filename of shape to replicate.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An emitter for objects to replicate across an area.

Member Data Documentation

bool fxShapeReplicator::AlignToTerrain

Align shapes to surface normal when set.

int fxShapeReplicator::AllowedTerrainSlope

Maximum surface angle allowed for shape instances.

bool fxShapeReplicator::AllowOnInteriors

Shapes will be placed on InteriorInstances when set.

bool fxShapeReplicator::AllowOnStatics

Shapes will be placed on Static shapes when set.

bool fxShapeReplicator::AllowOnTerrain

Shapes will be placed on terrain when set.

bool fxShapeReplicator::AllowOnWater

Shapes will be placed on/under water when set.

bool fxShapeReplicator::AllowWaterSurface

Shapes will be placed on water when set. Requires AllowOnWater.

bool fxShapeReplicator::HideReplications

Replicated shapes are hidden when set to true.

int fxShapeReplicator::InnerRadiusX

Placement area inner radius on the X axis.

int fxShapeReplicator::InnerRadiusY

Placement area inner radius on the Y axis.

bool fxShapeReplicator::Interactions

Allow physics interactions with shapes.

bool fxShapeReplicator::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool fxShapeReplicator::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

int fxShapeReplicator::OffsetZ

Offset shapes by this amount vertically.

int fxShapeReplicator::OuterRadiusX

Placement area outer radius on the X axis.

int fxShapeReplicator::OuterRadiusY

Placement area outer radius on the Y axis.

int fxShapeReplicator::PlacementAreaHeight

Height of the placement ring in world units.

ColorF fxShapeReplicator::PlacementColour

Color of the placement ring.

int fxShapeReplicator::seed

Random seed for shape placement.

int fxShapeReplicator::ShapeCount

Maximum shape instance count.

filename fxShapeReplicator::shapeFile

Filename of shape to replicate.

int fxShapeReplicator::ShapeRetries

Number of times to try placing a shape instance before giving up.

Point3F fxShapeReplicator::ShapeRotateMax

Maximum shape rotation angles.

Point3F fxShapeReplicator::ShapeRotateMin

Minimum shape rotation angles.

Point3F fxShapeReplicator::ShapeScaleMax

Maximum shape scale.

Point3F fxShapeReplicator::ShapeScaleMin

Minimum shape scale.

bool fxShapeReplicator::ShowPlacementArea

Draw placement rings when set to true.

Point3F fxShapeReplicator::TerrainAlignment

Surface normals will be multiplied by these values when AlignToTerrain is enabled.


Torque 3D - Script Manual: GameBase Class Reference

GameBase Class Reference
[Game Objects]

Base class for game objects which use datablocks, networking, are editable, and need to process ticks. More...

Inheritance diagram for GameBase:
[legend]

List of all members.

Public Member Functions

bool | applyImpulse (Point3F pos, VectorF vel)
Apply an impulse to this object as defined by a world position and velocity vector.
void | applyRadialImpulse (Point3F origin, float radius, float magnitude)
Applies a radial impulse to the object using the given origin and force.
int | getDataBlock ()
Get the datablock used by this object.
bool | setDataBlock (GameBaseData data)
Assign this GameBase to use the specified datablock.
Callbacks

void | setControl (bool controlled)
Called when the client controlling the object changes.

Public Attributes

Game

GameBaseData dataBlock
Script datablock used for game objects.

Static Public Attributes

static bool | boundingBox
Toggles on the rendering of the bounding boxes for certain types of objects in scene.
static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Base class for game objects which use datablocks, networking, are editable, and need to process ticks.

Member Function Documentation

bool GameBase::applyImpulse | ( | Point3F | pos,
 |  | VectorF | vel
 | ) |  |

Apply an impulse to this object as defined by a world position and velocity vector.

Parameters:
pos | impulse world position
vel | impulse velocity (impulse force F = m * v)
Returns:
Always true
Note:
Not all objects that derrive from GameBase have this defined.
void GameBase::applyRadialImpulse | ( | Point3F | origin,
 |  | float | radius,
 |  | float | magnitude
 | ) |  |

Applies a radial impulse to the object using the given origin and force.

Parameters:
origin | World point of origin of the radial impulse.
radius | The radius of the impulse area.
magnitude | The strength of the impulse.
Note:
Not all objects that derrive from GameBase have this defined.
int GameBase::getDataBlock ( )

Get the datablock used by this object.

Returns:
the datablock this GameBase is using.
See also:
setDataBlock()
void GameBase::setControl ( bool controlled )

Called when the client controlling the object changes.

Parameters:
controlled true if a client now controls this object, false if no client controls this object.
bool GameBase::setDataBlock ( GameBaseData data )

Assign this GameBase to use the specified datablock.

Parameters:
data new datablock to use
Returns:
true if successful, false if failed.
See also:
getDataBlock()

Member Data Documentation

bool GameBase::boundingBox [static]

Toggles on the rendering of the bounding boxes for certain types of objects in scene.

GameBaseData GameBase::dataBlock

Script datablock used for game objects.

bool GameBase::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in ShapeBase, MissionMarker, WayPoint, StaticShape, Explosion, ParticleEmitter, Splash, PhysicsDebris, PxCloth, Vehicle, HoverVehicle, Player, AIPlayer, Camera, Debris, Item, SpawnSphere, PathCamera, Projectile, RigidShape, Trigger, Lightning, ParticleEmitterNode, Precipitation, PhysicsShape, PxMultiActor, FlyingVehicle, and WheeledVehicle.

bool GameBase::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in ShapeBase, MissionMarker, WayPoint, StaticShape, Explosion, ParticleEmitter, Splash, PhysicsDebris, PxCloth, Vehicle, HoverVehicle, Player, AIPlayer, Camera, Debris, Item, SpawnSphere, PathCamera, Projectile, RigidShape, Trigger, Lightning, ParticleEmitterNode, Precipitation, PhysicsShape, PxMultiActor, FlyingVehicle, and WheeledVehicle.


Torque 3D - Script Manual: GameBaseData Class Reference

GameBaseData Class Reference
[Game Objects]

Scriptable, demo-able datablock. Used by GameBase objects. More...

Inheritance diagram for GameBaseData:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onAdd (GameBase obj)
Called when the object is added to the scene.
void | onMount (GameBase obj, SceneObject mountObj, int node)
Called when the object is mounted to another object in the scene.
void | onNewDataBlock (GameBase obj)
Called when the object has a new datablock assigned.
void | onRemove (GameBase obj)
Called when the object is removed from the scene.
void | onUnmount (GameBase obj, SceneObject mountObj, int node)
Called when the object is unmounted from another object in the scene.

Public Attributes

Scripting

caseString | category
The group that this datablock will show up in under the "Scripted" tab in the World Editor Library.

Detailed Description

Scriptable, demo-able datablock. Used by GameBase objects.

See also:
GameBase

Member Function Documentation

void GameBaseData::onAdd ( GameBase obj )

Called when the object is added to the scene.

Parameters:
obj the GameBase object
Example:
datablock GameBaseData(MyObjectData)
{
   category = "Misc";
};

function MyObjectData::onAdd( %this, %obj )
{
   echo( "Added " @ %obj.getName() @ " to the scene." );
}

function MyObjectData::onNewDataBlock( %this, %obj )
{
   echo( "Assign " @ %this.getName() @ " datablock to " %obj.getName() );
}

function MyObjectData::onRemove( %this, %obj )
{
   echo( "Removed " @ %obj.getName() @ " to the scene." );
}

function MyObjectData::onMount( %this, %obj, %mountObj, %node )
{
   echo( %obj.getName() @ " mounted to " @ %mountObj.getName() );
}

function MyObjectData::onUnmount( %this, %obj, %mountObj, %node )
{
   echo( %obj.getName() @ " unmounted from " @ %mountObj.getName() );
}

void GameBaseData::onMount | ( | GameBase | obj,
 |  | SceneObject | mountObj,
 |  | int | node
 | ) |  |

Called when the object is mounted to another object in the scene.

Parameters:
obj | the GameBase object being mounted
mountObj | the object we are mounted to
node | the mountObj node we are mounted to
See also:
onAdd for an example
void GameBaseData::onNewDataBlock ( GameBase obj )

Called when the object has a new datablock assigned.

Parameters:
obj the GameBase object
See also:
onAdd for an example
void GameBaseData::onRemove ( GameBase obj )

Called when the object is removed from the scene.

Parameters:
obj the GameBase object
See also:
onAdd for an example
void GameBaseData::onUnmount | ( | GameBase | obj,
 |  | SceneObject | mountObj,
 |  | int | node
 | ) |  |

Called when the object is unmounted from another object in the scene.

Parameters:
obj | the GameBase object being unmounted
mountObj | the object we are unmounted from
node | the mountObj node we are unmounted from
See also:
onAdd for an example

Member Data Documentation

caseString GameBaseData::category

The group that this datablock will show up in under the "Scripted" tab in the World Editor Library.


Torque 3D - Script Manual: GameConnection Class Reference

GameConnection Class Reference
[Networking]

The game-specific subclass of NetConnection. More...

Inheritance diagram for GameConnection:
[legend]

List of all members.

Public Member Functions

void | activateGhosting ()
Called by the server during phase 2 of the mission download to start sending ghosts to the client.
bool | chaseCam (int size)
Sets the size of the chase camera's matrix queue.
void | clearCameraObject ()
Clear the connection's camera object reference.
void | delete (string reason="")
On the server, disconnect a client and pass along an optional reason why.
SimObject getCameraObject ()
Returns the connection's camera object used when not viewing through the control object.
float | getControlCameraDefaultFov ()
Returns the default field of view as used by the control object's camera.
float | getControlCameraFov ()
Returns the field of view as used by the control object's camera.
GameBase getControlObject ()
On the server, returns the object that the client is controlling.By default the control object is an instance of the Player class, but can also be an instance of Camera (when editing the mission, for example), or any other ShapeBase derived class as appropriate for the game.
float | getDamageFlash ()
On the client, get the control object's damage flash level.
float | getWhiteOut ()
On the client, get the control object's white-out level.
bool | isAIControlled ()
Returns true if this connection is AI controlled.
bool | isControlObjectRotDampedCamera ()
Returns true if the object being controlled by the client is making use of a rotation damped camera.
bool | isDemoPlaying ()
Returns true if a previously recorded demo file is now playing.
bool | isDemoRecording ()
Returns true if a demo file is now being recorded.
bool | isFirstPerson ()
Returns true if this connection is in first person mode.
void | listClassIDs ()
List all of the classes that this connection knows about, and what their IDs are. Useful for debugging network problems.
bool | play2D (SFXProfile profile)
Used on the server to play a 2D sound that is not attached to any object.
bool | play3D (SFXProfile profile, TransformF location)
Used on the server to play a 3D sound that is not attached to any object.
bool | playDemo (string demoFileName)
On the client, play back a previously recorded game session.
void | resetGhosting ()
On the server, resets the connection to indicate that ghosting has been disabled.
void | setBlackOut (bool doFade, int timeMS)
On the server, sets the client's 3D display to fade to black.
bool | setCameraObject (GameBase camera)
On the server, set the connection's camera object used when not viewing through the control object.
void | setConnectArgs (const char *args)
On the client, pass along a variable set of parameters to the server.
void | setControlCameraFov (float newFOV)
On the server, sets the control object's camera's field of view.
bool | setControlObject (GameBase ctrlObj)
On the server, sets the object that the client will control.
void | setFirstPerson (bool firstPerson)
On the server, sets this connection into or out of first person mode.
void | setJoinPassword (string password)
On the client, set the password that will be passed to the server.
void | setMissionCRC (int CRC)
On the server, transmits the mission file's CRC value to the client.
void | startRecording (string fileName)
On the client, starts recording the network connection's traffic to a demo file.
void | stopRecording ()
On the client, stops the recording of a connection's network traffic to a file.
void | transmitDataBlocks (int sequence)
Sent by the server during phase 1 of the mission download to send the datablocks to the client.
Callbacks

void | initialControlSet ()
Called on the client when the first control object has been set by the server and we are now ready to go.
void | onConnectionAccepted ()
Called on the client when the connection to the server has been established.
void | onConnectionDropped (string reason)
Called on the client when the connection to the server has been dropped.
void | onConnectionError (string errorString)
Called on the client when there is an error with the connection to the server.
void | onConnectionTimedOut ()
Called on the client when the connection to the server times out.
void | onConnectRequestRejected (string reason)
Called on the client when the connection to the server has been rejected.
void | onConnectRequestTimedOut ()
Called when connection attempts have timed out.
void | onDataBlocksDone (int sequence)
Called on the server when all datablocks has been sent to the client.
void | onDrop (string disconnectReason)
Called on the server when the client's connection has been dropped.
void | onFlash (bool state)
Called on the client when the damage flash or white out states change.
void | setLagIcon (bool state)
Called on the client to display the lag icon.

Static Public Member Functions

static int | getServerConnection ()
On the client, this static mehtod will return the connection to the server, if any.

Detailed Description

The game-specific subclass of NetConnection.

The GameConnection introduces the concept of the control object. The control object is simply the object that the client is associated with that network connection controls. By default the control object is an instance of the Player class, but can also be an instance of Camera (when editing the mission, for example), or any other ShapeBase derived class as appropriate for the game.

Torque uses a model in which the server is the authoritative master of the simulation. To prevent clients from cheating, the server simulates all player moves and then tells the client where his player is in the world. This model, while secure, can have problems. If the network latency is high, this round-trip time can give the player a very noticeable sense of movement lag. To correct this problem, the game uses a form of prediction - it simulates the movement of the control object on the client and on the server both. This way the client doesn't need to wait for round-trip verification of his moves. Only in the case of a force acting on the control object on the server that doesn't exist on the client does the client's position need to be forcefully changed.

To support this, all control objects (derivative of ShapeBase) must supply a writePacketData() and readPacketData() function that send enough data to accurately simulate the object on the client. These functions are only called for the current control object, and only when the server can determine that the client's simulation is somehow out of sync with the server. This occurs usually if the client is affected by a force not present on the server (like an interpolating object) or if the server object is affected by a server only force (such as the impulse from an explosion).

The Move structure is a 32 millisecond snapshot of player input, containing x, y, and z positional and rotational changes as well as trigger state changes. When time passes in the simulation moves are collected (depending on how much time passes), and applied to the current control object on the client. The same moves are then packed over to the server in GameConnection::writePacket(), for processing on the server's version of the control object.

See also:
Networking, NetConnection, ShapeBase

Member Function Documentation

void GameConnection::activateGhosting ( )

Called by the server during phase 2 of the mission download to start sending ghosts to the client.

Ghosts represent objects on the server that are in scope for the client. These need to be synchronized with the client in order for the client to see and interact with them. This is typically done during the standard mission start phase 2 when following Torque's example mission startup sequence.

Example:
function serverCmdMissionStartPhase2Ack(%client, %seq, %playerDB)
{
   // Make sure to ignore calls from a previous mission load
   if (%seq != $missionSequence || !$MissionRunning)
      return;
   if (%client.currentPhase != 1.5)
      return;
   %client.currentPhase = 2;

   // Set the player datablock choice
   %client.playerDB = %playerDB;

   // Update mod paths, this needs to get there before the objects.
   %client.transmitPaths();

   // Start ghosting objects to the client
   %client.activateGhosting();
}
See also:
On Ghosting and Scoping for a description of the ghosting system.
bool GameConnection::chaseCam ( int size )

Sets the size of the chase camera's matrix queue.

Note:
This sets the queue size across all GameConnections.
This is not currently hooked up.
void GameConnection::clearCameraObject ( )

Clear the connection's camera object reference.

See also:
GameConnection::setCameraObject() and GameConnection::getCameraObject()
void GameConnection::delete ( string reason = "" )

On the server, disconnect a client and pass along an optional reason why.

This method performs two operations: it disconnects a client connection from the server, and it deletes the connection object. The optional reason is sent in the disconnect packet and is often displayed to the user so they know why they've been disconnected.

Parameters:
reason [optional] The reason why the user has been disconnected from the server.
Example:
function kick(%client)
{
   messageAll( 'MsgAdminForce', '\c2The Admin has kicked %1.', %client.playerName);

   if (!%client.isAIControlled())
      BanList::add(%client.guid, %client.getAddress(), $Pref::Server::KickBanTime);
   %client.delete("You have been kicked from this server");
}
SimObject GameConnection::getCameraObject ( )

Returns the connection's camera object used when not viewing through the control object.

See also:
GameConnection::setCameraObject() and GameConnection::clearCameraObject()
float GameConnection::getControlCameraDefaultFov ( )

Returns the default field of view as used by the control object's camera.

float GameConnection::getControlCameraFov ( )

Returns the field of view as used by the control object's camera.

GameBase GameConnection::getControlObject ( )

On the server, returns the object that the client is controlling.By default the control object is an instance of the Player class, but can also be an instance of Camera (when editing the mission, for example), or any other ShapeBase derived class as appropriate for the game.

See also:
GameConnection::setControlObject()
float GameConnection::getDamageFlash ( )

On the client, get the control object's damage flash level.

Returns:
flash level
static int GameConnection::getServerConnection ( ) [static]

On the client, this static mehtod will return the connection to the server, if any.

Returns:
The SimObject ID of the server connection, or -1 if none is found.
float GameConnection::getWhiteOut ( )

On the client, get the control object's white-out level.

Returns:
white-out level
void GameConnection::initialControlSet ( )

Called on the client when the first control object has been set by the server and we are now ready to go.

A common action to perform when this callback is called is to switch the GUI canvas from the loading screen and over to the 3D game GUI.

bool GameConnection::isAIControlled ( )

Returns true if this connection is AI controlled.

See also:
AIConnection
bool GameConnection::isControlObjectRotDampedCamera ( )

Returns true if the object being controlled by the client is making use of a rotation damped camera.

See also:
Camera
bool GameConnection::isDemoPlaying ( )

Returns true if a previously recorded demo file is now playing.

See also:
GameConnection::playDemo()
bool GameConnection::isDemoRecording ( )

Returns true if a demo file is now being recorded.

See also:
GameConnection::startRecording(), GameConnection::stopRecording()
bool GameConnection::isFirstPerson ( )

Returns true if this connection is in first person mode.

Note:
Transition to first person occurs over time via mCameraPos, so this won't immediately return true after a set.
void GameConnection::listClassIDs ( )

List all of the classes that this connection knows about, and what their IDs are. Useful for debugging network problems.

Note:
The list is sent to the console.
void GameConnection::onConnectionAccepted ( )

Called on the client when the connection to the server has been established.

void GameConnection::onConnectionDropped ( string reason )

Called on the client when the connection to the server has been dropped.

Parameters:
reason The reason why the connection was dropped.
void GameConnection::onConnectionError ( string errorString )

Called on the client when there is an error with the connection to the server.

Parameters:
errorString The connection error text.
void GameConnection::onConnectionTimedOut ( )

Called on the client when the connection to the server times out.

void GameConnection::onConnectRequestRejected ( string reason )

Called on the client when the connection to the server has been rejected.

Parameters:
reason The reason why the connection request was rejected.
void GameConnection::onConnectRequestTimedOut ( )

Called when connection attempts have timed out.

void GameConnection::onDataBlocksDone ( int sequence )

Called on the server when all datablocks has been sent to the client.

During phase 1 of the mission download, all datablocks are sent from the server to the client. Once all datablocks have been sent, this callback is called and the mission download procedure may move on to the next phase.

Parameters:
sequence The sequence is common between the server and client and ensures that the client is acting on the most recent mission start process. If an errant network packet (one that was lost but has now been found) is received by the client with an incorrect sequence, it is just ignored. This sequence number is updated on the server every time a mission is loaded.
See also:
GameConnection::transmitDataBlocks()
void GameConnection::onDrop ( string disconnectReason )

Called on the server when the client's connection has been dropped.

Parameters:
disconnectReason The reason why the connection was dropped.
void GameConnection::onFlash ( bool state )

Called on the client when the damage flash or white out states change.

When the server changes the damage flash or white out values, this callback is called either is on or both are off. Typically this is used to enable the flash postFx.

Parameters:
state Set to true if either the damage flash or white out conditions are active.
bool GameConnection::play2D ( SFXProfile profile )

Used on the server to play a 2D sound that is not attached to any object.

Parameters:
profile The SFXProfile that defines the sound to play.
Example:
function ServerPlay2D(%profile)
{
   // Play the given sound profile on every client.
   // The sounds will be transmitted as an event, not attached to any object.
   for(%idx = 0; %idx < ClientGroup.getCount(); %idx++)
      ClientGroup.getObject(%idx).play2D(%profile);
}

bool GameConnection::play3D | ( | SFXProfile | profile,
 |  | TransformF | location
 | ) |  |

Used on the server to play a 3D sound that is not attached to any object.

Parameters:
profile | The SFXProfile that defines the sound to play.
location | The position and orientation of the 3D sound given in the form of "x y z ax ay az aa".
Example:
function ServerPlay3D(%profile,%transform)
{
   // Play the given sound profile at the given position on every client
   // The sound will be transmitted as an event, not attached to any object.
   for(%idx = 0; %idx < ClientGroup.getCount(); %idx++)
      ClientGroup.getObject(%idx).play3D(%profile,%transform);
}
bool GameConnection::playDemo ( string demoFileName )

On the client, play back a previously recorded game session.

It is often useful to play back a game session. This could be for producing a demo of the game that will be shown at a later time, or for debugging a game. By recording the entire network stream it is possible to later play game the game exactly as it unfolded during the actual play session. This is because all user control and server results pass through the connection.

Returns:
True if the playback was successful. False if there was an issue, such as not being able to open the demo file for playback.
See also:
GameConnection::startRecording(), GameConnection::stopRecording()
void GameConnection::resetGhosting ( )

On the server, resets the connection to indicate that ghosting has been disabled.

Typically when a mission has ended on the server, all connected clients are informed of this change and their connections are reset back to a starting state. This method resets a connection on the server to indicate that ghosts are no longer being transmitted. On the client end, all ghost information will be deleted.

Example:
   // Inform the clients
   for (%clientIndex = 0; %clientIndex < ClientGroup.getCount(); %clientIndex++)
   {
      // clear ghosts and paths from all clients
      %cl = ClientGroup.getObject(%clientIndex);
      %cl.endMission();
      %cl.resetGhosting();
      %cl.clearPaths();
   }
See also:
On Ghosting and Scoping for a description of the ghosting system.
void GameConnection::setBlackOut | ( | bool | doFade,
 |  | int | timeMS
 | ) |  |

On the server, sets the client's 3D display to fade to black.

Parameters:
doFade | Set to true to fade to black, and false to fade from black.
timeMS | Time it takes to perform the fade as measured in ms.
Note:
Not currently hooked up, and is not synchronized over the network.
bool GameConnection::setCameraObject ( GameBase camera )

On the server, set the connection's camera object used when not viewing through the control object.

See also:
GameConnection::getCameraObject() and GameConnection::clearCameraObject()
void GameConnection::setConnectArgs ( const char * args )

On the client, pass along a variable set of parameters to the server.

Once the connection is established with the server, the server calls its onConnect() method with the client's passed in parameters as aruments.

See also:
GameConnection::onConnect()
void GameConnection::setControlCameraFov ( float newFOV )

On the server, sets the control object's camera's field of view.

Parameters:
newFOV New field of view (in degrees) to force the control object's camera to use. This value is clamped to be within the range of 1 to 179 degrees.
Note:
When transmitted over the network to the client, the resolution is limited to one degree. Any fraction is dropped.
bool GameConnection::setControlObject ( GameBase ctrlObj )

On the server, sets the object that the client will control.

By default the control object is an instance of the Player class, but can also be an instance of Camera (when editing the mission, for example), or any other ShapeBase derived class as appropriate for the game.

Parameters:
ctrlObj The GameBase object on the server to control.
void GameConnection::setFirstPerson ( bool firstPerson )

On the server, sets this connection into or out of first person mode.

Parameters:
firstPerson Set to true to put the connection into first person mode.
void GameConnection::setJoinPassword ( string password )

On the client, set the password that will be passed to the server.

On the server, this password is compared with what is stored in

pref
:Server::Password. If

pref::Server::Password is empty then the client's sent password is ignored. Otherwise, if the passed in client password and the server password do not match, the CHR_PASSWORD error string is sent back to the client and the connection is immediately terminated.

This password checking is performed quite early on in the connection request process so as to minimize the impact of multiple failed attempts -- also known as hacking.

void GameConnection::setLagIcon ( bool state )

Called on the client to display the lag icon.

When the connection with the server is lagging, this callback is called to allow the game GUI to display some indicator to the player.

Parameters:
state Set to true if the lag icon should be displayed.
void GameConnection::setMissionCRC ( int CRC )

On the server, transmits the mission file's CRC value to the client.

Typically, during the standard mission start phase 1, the mission file's CRC value on the server is send to the client. This allows the client to determine if the mission has changed since the last time it downloaded this mission and act appropriately, such as rebuilt cached lightmaps.

Parameters:
CRC The mission file's CRC value on the server.
Example:
function serverCmdMissionStartPhase1Ack(%client, %seq)
{
   // Make sure to ignore calls from a previous mission load
   if (%seq != $missionSequence || !$MissionRunning)
      return;
   if (%client.currentPhase != 0)
      return;
   %client.currentPhase = 1;

   // Start with the CRC
   %client.setMissionCRC( $missionCRC );

   // Send over the datablocks...
   // OnDataBlocksDone will get called when have confirmation
   // that they've all been received.
   %client.transmitDataBlocks($missionSequence);
}
void GameConnection::startRecording ( string fileName )

On the client, starts recording the network connection's traffic to a demo file.

It is often useful to play back a game session. This could be for producing a demo of the game that will be shown at a later time, or for debugging a game. By recording the entire network stream it is possible to later play game the game exactly as it unfolded during the actual play session. This is because all user control and server results pass through the connection.

Parameters:
fileName The file name to use for the demo recording.
See also:
GameConnection::stopRecording(), GameConnection::playDemo()
void GameConnection::stopRecording ( )

On the client, stops the recording of a connection's network traffic to a file.

See also:
GameConnection::startRecording(), GameConnection::playDemo()
void GameConnection::transmitDataBlocks ( int sequence )

Sent by the server during phase 1 of the mission download to send the datablocks to the client.

SimDataBlocks, also known as just datablocks, need to be transmitted to the client prior to the client entering the game world. These represent the static data that most objects in the world reference. This is typically done during the standard mission start phase 1 when following Torque's example mission startup sequence.

When the datablocks have all been transmitted, onDataBlocksDone() is called to move the mission start process to the next phase.

Parameters:
sequence The sequence is common between the server and client and ensures that the client is acting on the most recent mission start process. If an errant network packet (one that was lost but has now been found) is received by the client with an incorrect sequence, it is just ignored. This sequence number is updated on the server every time a mission is loaded.
Example:
function serverCmdMissionStartPhase1Ack(%client, %seq)
{
   // Make sure to ignore calls from a previous mission load
   if (%seq != $missionSequence || !$MissionRunning)
      return;
   if (%client.currentPhase != 0)
      return;
   %client.currentPhase = 1;

   // Start with the CRC
   %client.setMissionCRC( $missionCRC );

   // Send over the datablocks...
   // OnDataBlocksDone will get called when have confirmation
   // that they've all been received.
   %client.transmitDataBlocks($missionSequence);
}
See also:
GameConnection::onDataBlocksDone()


Torque 3D - Script Manual: GameTSCtrl Class Reference

GameTSCtrl Class Reference
[3D Controls]

The main 3D viewport for a Torque 3D game. More...

Inheritance diagram for GameTSCtrl:
[legend]

List of all members.

Detailed Description

The main 3D viewport for a Torque 3D game.

With the exception of a few very niche genres, the bulk of your 3D game viewing will occur in a GameTSCtrl. You typically only need a single GameTSCtrl, unless you are implementing a very complex interface system. In the demos, you can find our example named "PlayGui".

It is recommended that any game GUIs that are not pushed and popped constantly, be contained within your GameTSCtrl. Examples include targeting reticle, standard healthbar, ammo count, etc. This is mostly a design decision, but the way Torque 3D's GUI system works somewhat encourages you to group the controls in this manner.

    // Example of a GameTSCtrl
    // PlayGui is the main TSControl through which the game is viewed
    // Also contains a Guis for:
    // - A lag icon
    // - Showing other shape names
    // - Crossahir
    %guiContent = new GameTSCtrl(PlayGui)
    {
      cameraZRot = "0";
      forceFOV = "0";
      reflectPriority = "1";
      Profile = "GuiContentProfile";
      HorizSizing = "right";
      VertSizing = "bottom";
      position = "0 0";
      Extent = "1024 768";

      new GuiBitmapCtrl(LagIcon)
      {
         bitmap = "art/gui/lagIcon.png";
         // Note: Rest of fields hidden for this example
      };

      new GuiShapeNameHud()
      {
         fillColor = "0 0 0 0.25";
         frameColor = "0 1 0 1";
         textColor = "0 1 0 1";
         showFill = "0";
         showFrame = "0";

         // Note: Rest of fields hidden for this example
      };

      new GuiCrossHairHud(Reticle)
      {
         damageFillColor = "0 1 0 1";
         damageFrameColor = "1 0.6 0 1";
         damageRect = "50 4";
         damageOffset = "0 10";
         bitmap = "art/gui/weaponHud/blank.png";
         // Note: Rest of fields hidden for this example
      };
    };
See also:
GuiTSCtrl
GuiObjectView


Torque 3D - Script Manual: GFXCardProfiler Class Reference

GFXCardProfiler Class Reference
[GFX]

Provides a device independent wrapper around both the capabilities reported by the card/drivers and the exceptions recorded in various scripts. More...

Detailed Description

Provides a device independent wrapper around both the capabilities reported by the card/drivers and the exceptions recorded in various scripts.

The GFXCardProfiler provides a device independent wrapper around both the capabilities reported by the card/drivers and the exceptions recorded in various scripts.

The materials system keeps track of most caps-related rendering optimizations and/or workarounds, but it is occasionally necessary to expose capability information to higher level code (for instance, if some feature depends on a specific subset of render functionality) or to keep track of exceptions.

The proper way to fix this is to get the IHV to release fixed drivers and/or move to a single consistent rendering path that works. Of course, when you're releasing a game, especially on a timeline (or with a less than infinite budget) this isn't always a valid solution.

It's also often convenient to be able to tweak performance/detail settings based on the identified card type.

GFXCardProfiler addresses both these needs by providing two data retrieval methods and a generic interface for querying capability strings.

Note:
The GFXCardProfiler is at heart a system for implementing WORKAROUNDS. It is not guaranteed to work in all cases. The capability strings it responds to are specific to each implementation. You should be EXTREMELY careful when working with this functionality. When used in moderation it can be a project-saver, but if used to excess or without forethought it can lead to complex, hard-to-maintain code.

The first data retrieval method that the GFXCardProfiler supports is a card-specific capability query. This is implemented by each subclass. In the case of DirectX, this means using the built-in capability query. For OpenGL or other APIs, more exotic methods may be necessary. The goal of this method is to retrieve some reasonable defaults that can be overridden later if necessary.

The second data retrieval method is script based. In ./profile a collection of script files are stored. They are named in one of the forms:

    Renderer.cs
    Renderer.VendorString.CardString.cs
    Renderer.VendorString.CardString.cs
    Renderer.VendorString.CardString.VersionString.cs

These files are found and executed from most general to most specific. For instance, say we're working in the D3D renderer with an nVidia GeForce FX 5950, running driver version 53.36. The following files would be found and executed:

    D3D.cs
    D3D.nVidia.cs
    D3D.nVidia.GeForceFX5950.cs
    D3D.nVidia.GeForceFX5950.5336.cs

The general rule for turning strings into filename parts is to strip all spaces and punctuation. If a file is not found, no error is reported; it is assumed that the absence of a file means all is well.

Several functions are made available to allow simple logic in the script functions (for instance, to enable a workaround for a given range of driver versions). They are:

  • GFXCardProfiler::getRenderer()
  • GFXCardProfiler::getVendor()
  • GFXCardProfiler::getCard()
  • GFXCardProfiler::getVersion()

In addition, specific subclasses may expose other values (for instance, chipset IDs). These are made available as static members of the specific subclass. For instance, a D3D-specific chipset query may be made available as GFXD3DCardProfiler::getChipset().

Finally, once a script file has reached a determination they may indicate their settings to the GFXCardProfiler by calling GFXCardProfiler::setCapability(). For instance,

    // Indicate we can show the color red.
    GFXCardProfiler::setCapability("supportsRed", true);

GFXCardProfiler may be queried from script by calling GFXCardProfiler::queryProfile() - for instance:

    GFXCardProfiler::queryProfile("supportsRed", false); // Query with default.


Torque 3D - Script Manual: GFXCardProfilerAPI Class Reference

GFXCardProfilerAPI Class Reference
[GFX]

This class is the interface between TorqueScript and GFXCardProfiler. More...

List of all members.

Static Public Member Functions

static String | getCard ()
Returns the card name.
static String | getRenderer ()
Returns the renderer name. For example D3D9 or OpenGL.
static String | getVendor ()
Returns the card vendor name.
static String | getVersion ()
Returns the driver version string.
static int | getVideoMemoryMB ()
Returns the amount of video memory in megabytes.
static int | queryProfile (string name, int defaultValue)
Used to query the value of a specific card capability.
static void | setCapability (string name, int value)
Used to set the value for a specific card capability.

Detailed Description

This class is the interface between TorqueScript and GFXCardProfiler.

You will not actually declare GFXCardProfilerAPI in TorqueScript. It exists solely to give access to the GFXCardProfiler's querying functions, such as GFXCardProfiler::getRenderer.

Example:
// Example of accessing GFXCardProfiler function from script
// Notice you are not using the API version
%videoMem = GFXCardProfiler::getVideoMemoryMB();
See also:
GFXCardProfiler for more information

Member Function Documentation

static String GFXCardProfilerAPI::getCard ( ) [static]

Returns the card name.

static String GFXCardProfilerAPI::getRenderer ( ) [static]

Returns the renderer name. For example D3D9 or OpenGL.

static String GFXCardProfilerAPI::getVendor ( ) [static]

Returns the card vendor name.

static String GFXCardProfilerAPI::getVersion ( ) [static]

Returns the driver version string.

static int GFXCardProfilerAPI::getVideoMemoryMB ( ) [static]

Returns the amount of video memory in megabytes.

static int GFXCardProfilerAPI::queryProfile | ( | string | name,
 |  | int | defaultValue |
 | ) |  |  | [static]

Used to query the value of a specific card capability.

Parameters:
name | The name of the capability being queried.
defaultValue | The value to return if the capability is not defined.
static void GFXCardProfilerAPI::setCapability | ( | string | name,
 |  | int | value |
 | ) |  |  | [static]

Used to set the value for a specific card capability.

Parameters:
name | The name of the capability being set.
value | The value to set for that capability.


Torque 3D - Script Manual: GFXInit Class Reference

GFXInit Class Reference
[GFX]

Functions for tracking GFX adapters and initializing them into devices. More...

List of all members.

Static Public Member Functions

static void | createNullDevice ()
Create the NULL graphics device used for testing or headless operation.
static int | getAdapterCount ()
Return the number of graphics adapters available.
static String | getAdapterMode (int index, int modeIndex)
Gets the details of the specified adapter mode.
static int | getAdapterModeCount (int index)
Gets the number of modes available on the specified adapter.
static String | getAdapterName (int index)
Returns the name of the graphics adapter.
static float | getAdapterShaderModel (int index)
Returns the supported shader model of the graphics adapter or -1 if the index is bad.
static GFXAdapterType | getAdapterType (int index)
Returns the type (D3D9, D3D8, GL, Null) of a graphics adapter.
static int | getDefaultAdapterIndex ()
Returns the index of the default graphics adapter. This is the graphics device which will be used to initialize the engine.

Detailed Description

Functions for tracking GFX adapters and initializing them into devices.

Member Function Documentation

static void GFXInit::createNullDevice ( ) [static]

Create the NULL graphics device used for testing or headless operation.

static String GFXInit::getAdapterMode | ( | int | index,
 |  | int | modeIndex |
 | ) |  |  | [static]

Gets the details of the specified adapter mode.

Parameters:
index | Index of the adapter to query.
modeIndex | Index of the mode to get data from.
Returns:
A video mode string in the format 'width height fullscreen bitDepth refreshRate aaLevel'.
See also:
GuiCanvas::getVideoMode()
static int GFXInit::getAdapterModeCount ( int index ) [static]

Gets the number of modes available on the specified adapter.

Parameters:
index Index of the adapter to get modes from.
Returns:
The number of video modes supported by the adapter or -1 if the given adapter was not found.
static String GFXInit::getAdapterName ( int index ) [static]

Returns the name of the graphics adapter.

Parameters:
index The index of the adapter.
static float GFXInit::getAdapterShaderModel ( int index ) [static]

Returns the supported shader model of the graphics adapter or -1 if the index is bad.

Parameters:
index The index of the adapter.
static GFXAdapterType GFXInit::getAdapterType ( int index ) [static]

Returns the type (D3D9, D3D8, GL, Null) of a graphics adapter.

Parameters:
index The index of the adapter.
static int GFXInit::getDefaultAdapterIndex ( ) [static]

Returns the index of the default graphics adapter. This is the graphics device which will be used to initialize the engine.


Torque 3D - Script Manual: GFXSamplerStateData Class Reference

GFXSamplerStateData Class Reference
[GFX]

A sampler state used by GFXStateBlockData. More...

Inheritance diagram for GFXSamplerStateData:
[legend]

List of all members.

Public Attributes

GFXTextureArgument resultArg
The selection of the destination register for the result of this stage. The default is GFXTACurrent.
GFXTextureTransformFlags textureTransform
Sets the texture transform state. The default is GFXTTFFDisable.
Address Mode

GFXTextureAddressMode addressModeU
The texture address mode for the u coordinate. The default is GFXAddressWrap.
GFXTextureAddressMode addressModeV
The texture address mode for the v coordinate. The default is GFXAddressWrap.
GFXTextureAddressMode addressModeW
The texture address mode for the w coordinate. The default is GFXAddressWrap.
Alpha Op

GFXTextureArgument alphaArg1
The first alpha argument for the texture stage. The default value is GFXTATexture.
GFXTextureArgument alphaArg2
The second alpha argument for the texture stage. The default value is GFXTADiffuse.
GFXTextureArgument alphaArg3
The third alpha channel selector operand for triadic operations (multiply, add, and linearly interpolate). The default value is GFXTACurrent.
GFXTextureOp alphaOp
The texture alpha blending operation. The default value is GFXTOPModulate.
Color Op

GFXTextureArgument colorArg1
The first color argument for the texture stage. The default value is GFXTACurrent.
GFXTextureArgument colorArg2
The second color argument for the texture stage. The default value is GFXTATexture.
GFXTextureArgument colorArg3
The third color argument for triadic operations (multiply, add, and linearly interpolate). The default value is GFXTACurrent.
GFXTextureOp textureColorOp
The texture color blending operation. The default value is GFXTOPDisable which disables the sampler.
Filter State

GFXTextureFilterType magFilter
The texture magnification filter. The default is GFXTextureFilterLinear.
int | maxAnisotropy
The maximum texture anisotropy. The default value is 1.
GFXTextureFilterType minFilter
The texture minification filter. The default is GFXTextureFilterLinear.
GFXTextureFilterType mipFilter
The texture mipmap filter used during minification. The default is GFXTextureFilterLinear.
float | mipLODBias
The mipmap level of detail bias. The default value is zero.

Detailed Description

A sampler state used by GFXStateBlockData.

The samplers define how a texture will be sampled when used from the shader or fixed function device

Example:
singleton GFXSamplerStateData(SamplerClampLinear)
{
   textureColorOp = GFXTOPModulate;
   addressModeU = GFXAddressClamp;
   addressModeV = GFXAddressClamp;
   addressModeW = GFXAddressClamp;
   magFilter = GFXTextureFilterLinear;
   minFilter = GFXTextureFilterLinear;
   mipFilter = GFXTextureFilterLinear;
};

There are a few predefined samplers in the core scripts which you can use with GFXStateBlockData for the most common rendering cases:

  • SamplerClampLinear
  • SamplerClampPoint
  • SamplerWrapLinear
  • SamplerWrapPoint
See also:
GFXStateBlockData

Member Data Documentation

GFXTextureAddressMode GFXSamplerStateData::addressModeU

The texture address mode for the u coordinate. The default is GFXAddressWrap.

GFXTextureAddressMode GFXSamplerStateData::addressModeV

The texture address mode for the v coordinate. The default is GFXAddressWrap.

GFXTextureAddressMode GFXSamplerStateData::addressModeW

The texture address mode for the w coordinate. The default is GFXAddressWrap.

GFXTextureArgument GFXSamplerStateData::alphaArg1

The first alpha argument for the texture stage. The default value is GFXTATexture.

GFXTextureArgument GFXSamplerStateData::alphaArg2

The second alpha argument for the texture stage. The default value is GFXTADiffuse.

GFXTextureArgument GFXSamplerStateData::alphaArg3

The third alpha channel selector operand for triadic operations (multiply, add, and linearly interpolate). The default value is GFXTACurrent.

GFXTextureOp GFXSamplerStateData::alphaOp

The texture alpha blending operation. The default value is GFXTOPModulate.

GFXTextureArgument GFXSamplerStateData::colorArg1

The first color argument for the texture stage. The default value is GFXTACurrent.

GFXTextureArgument GFXSamplerStateData::colorArg2

The second color argument for the texture stage. The default value is GFXTATexture.

GFXTextureArgument GFXSamplerStateData::colorArg3

The third color argument for triadic operations (multiply, add, and linearly interpolate). The default value is GFXTACurrent.

GFXTextureFilterType GFXSamplerStateData::magFilter

The texture magnification filter. The default is GFXTextureFilterLinear.

int GFXSamplerStateData::maxAnisotropy

The maximum texture anisotropy. The default value is 1.

GFXTextureFilterType GFXSamplerStateData::minFilter

The texture minification filter. The default is GFXTextureFilterLinear.

GFXTextureFilterType GFXSamplerStateData::mipFilter

The texture mipmap filter used during minification. The default is GFXTextureFilterLinear.

float GFXSamplerStateData::mipLODBias

The mipmap level of detail bias. The default value is zero.

GFXTextureArgument GFXSamplerStateData::resultArg

The selection of the destination register for the result of this stage. The default is GFXTACurrent.

GFXTextureOp GFXSamplerStateData::textureColorOp

The texture color blending operation. The default value is GFXTOPDisable which disables the sampler.

GFXTextureTransformFlags GFXSamplerStateData::textureTransform

Sets the texture transform state. The default is GFXTTFFDisable.


Torque 3D - Script Manual: GFXStateBlockData Class Reference

GFXStateBlockData Class Reference
[GFX]

A state block description for rendering. More...

Inheritance diagram for GFXStateBlockData:
[legend]

List of all members.

Public Attributes

Alpha Test

bool | alphaDefined
Set to true if the alpha test state is not all defaults.
bool | alphaTestEnable
Enables per-pixel alpha testing. The default is false.
GFXCmpFunc alphaTestFunc
The test function used to accept or reject a pixel based on its alpha value. The default is GFXCmpGreaterEqual.
int | alphaTestRef
The reference alpha value against which pixels are tested. The default is zero.
Alpha Blending

bool | blendDefined
Set to true if the alpha blend state is not all defaults.
GFXBlend blendDest
The destination blend state. The default is GFXBlendZero.
bool | blendEnable
Enables alpha blending. The default is false.
GFXBlendOp blendOp
The arithmetic operation applied to alpha blending. The default is GFXBlendOpAdd.
GFXBlend blendSrc
The source blend state. The default is GFXBlendOne.
Color Write

bool | colorWriteAlpha
Enables alpha channel writes. The default is true.
bool | colorWriteBlue
Enables blue channel writes. The default is true.
bool | colorWriteDefined
Set to true if the color write state is not all defaults.
bool | colorWriteGreen
Enables green channel writes. The default is true.
bool | colorWriteRed
Enables red channel writes. The default is true.
Culling

bool | cullDefined
Set to true if the culling state is not all defaults.
GFXCullMode cullMode
Defines how back facing triangles are culled if at all. The default is GFXCullCCW.
Fixed Function

bool | ffLighting
Enables fixed function lighting when rendering without a shader on geometry with vertex normals. The default is false.
bool | vertexColorEnable
Enables fixed function vertex coloring when rendering without a shader. The default is false.
Sampler States

bool | samplersDefined
Set to true if the sampler states are not all defaults.
GFXSamplerStateData | samplerStates [16]
The array of texture sampler states.
ColorI | textureFactor
The color used for multiple-texture blending with the GFXTATFactor texture-blending argument or the GFXTOPBlendFactorAlpha texture-blending operation. The default is opaque white (255, 255, 255, 255).
Separate Alpha Blending

bool | separateAlphaBlendDefined
Set to true if the seperate alpha blend state is not all defaults.
GFXBlend separateAlphaBlendDest
The destination blend state. The default is GFXBlendZero.
bool | separateAlphaBlendEnable
Enables the separate blend mode for the alpha channel. The default is false.
GFXBlendOp separateAlphaBlendOp
The arithmetic operation applied to separate alpha blending. The default is GFXBlendOpAdd.
GFXBlend separateAlphaBlendSrc
The source blend state. The default is GFXBlendOne.
Stencil

bool | stencilDefined
Set to true if the stencil state is not all defaults.
bool | stencilEnable
Enables stenciling. The default is false.
GFXStencilOp stencilFailOp
The stencil operation to perform if the stencil test fails. The default is GFXStencilOpKeep.
GFXCmpFunc stencilFunc
The comparison function to test the reference value to a stencil buffer entry. The default is GFXCmpNever.
int | stencilMask
The mask applied to the reference value and each stencil buffer entry to determine the significant bits for the stencil test. The default is 0xFFFFFFFF.
GFXStencilOp stencilPassOp
The stencil operation to perform if both the stencil and the depth tests pass. The default is GFXStencilOpKeep.
int | stencilRef
The reference value for the stencil test. The default is zero.
int | stencilWriteMask
The write mask applied to values written into the stencil buffer. The default is 0xFFFFFFFF.
GFXStencilOp stencilZFailOp
The stencil operation to perform if the stencil test passes and the depth test fails. The default is GFXStencilOpKeep.
Depth

float | zBias
A floating-point bias used when comparing depth values. The default is zero.
bool | zDefined
Set to true if the depth state is not all defaults.
bool | zEnable
Enables z-buffer reads. The default is true.
GFXCmpFunc zFunc
The depth comparision function which a pixel must pass to be written to the z-buffer. The default is GFXCmpLessEqual.
float | zSlopeBias
An additional floating-point bias based on the maximum depth slop of the triangle being rendered. The default is zero.
bool | zWriteEnable
Enables z-buffer writes. The default is true.

Detailed Description

A state block description for rendering.

This object is used with ShaderData in CustomMaterial and PostEffect to define the render state.

Example:
singleton GFXStateBlockData( PFX_DOFDownSampleStateBlock )
{
   zDefined = true;
   zEnable = false;
   zWriteEnable = false;

   samplersDefined = true;
   samplerStates[0] = SamplerClampLinear;
   samplerStates[1] = SamplerClampPoint;

   // Copy the clamped linear sampler, but change
   // the u coord to wrap for this special case.
   samplerStates[2] = new GFXSamplerStateData( : SamplerClampLinear )
   {
      addressModeU = GFXAddressWrap;
   };
};
Note:
The 'xxxxDefined' fields are used to know what groups of fields are modified when combining multiple state blocks in material processing. You should take care to enable the right ones when setting values.

Member Data Documentation

bool GFXStateBlockData::alphaDefined

Set to true if the alpha test state is not all defaults.

bool GFXStateBlockData::alphaTestEnable

Enables per-pixel alpha testing. The default is false.

GFXCmpFunc GFXStateBlockData::alphaTestFunc

The test function used to accept or reject a pixel based on its alpha value. The default is GFXCmpGreaterEqual.

int GFXStateBlockData::alphaTestRef

The reference alpha value against which pixels are tested. The default is zero.

bool GFXStateBlockData::blendDefined

Set to true if the alpha blend state is not all defaults.

GFXBlend GFXStateBlockData::blendDest

The destination blend state. The default is GFXBlendZero.

bool GFXStateBlockData::blendEnable

Enables alpha blending. The default is false.

GFXBlendOp GFXStateBlockData::blendOp

The arithmetic operation applied to alpha blending. The default is GFXBlendOpAdd.

GFXBlend GFXStateBlockData::blendSrc

The source blend state. The default is GFXBlendOne.

bool GFXStateBlockData::colorWriteAlpha

Enables alpha channel writes. The default is true.

bool GFXStateBlockData::colorWriteBlue

Enables blue channel writes. The default is true.

bool GFXStateBlockData::colorWriteDefined

Set to true if the color write state is not all defaults.

bool GFXStateBlockData::colorWriteGreen

Enables green channel writes. The default is true.

bool GFXStateBlockData::colorWriteRed

Enables red channel writes. The default is true.

bool GFXStateBlockData::cullDefined

Set to true if the culling state is not all defaults.

GFXCullMode GFXStateBlockData::cullMode

Defines how back facing triangles are culled if at all. The default is GFXCullCCW.

bool GFXStateBlockData::ffLighting

Enables fixed function lighting when rendering without a shader on geometry with vertex normals. The default is false.

bool GFXStateBlockData::samplersDefined

Set to true if the sampler states are not all defaults.

GFXSamplerStateData GFXStateBlockData::samplerStates[16]

The array of texture sampler states.

Note:
Not all graphics devices support 16 samplers. In general all systems support 4 samplers with most modern cards doing 8.
bool GFXStateBlockData::separateAlphaBlendDefined

Set to true if the seperate alpha blend state is not all defaults.

GFXBlend GFXStateBlockData::separateAlphaBlendDest

The destination blend state. The default is GFXBlendZero.

bool GFXStateBlockData::separateAlphaBlendEnable

Enables the separate blend mode for the alpha channel. The default is false.

GFXBlendOp GFXStateBlockData::separateAlphaBlendOp

The arithmetic operation applied to separate alpha blending. The default is GFXBlendOpAdd.

GFXBlend GFXStateBlockData::separateAlphaBlendSrc

The source blend state. The default is GFXBlendOne.

bool GFXStateBlockData::stencilDefined

Set to true if the stencil state is not all defaults.

bool GFXStateBlockData::stencilEnable

Enables stenciling. The default is false.

GFXStencilOp GFXStateBlockData::stencilFailOp

The stencil operation to perform if the stencil test fails. The default is GFXStencilOpKeep.

GFXCmpFunc GFXStateBlockData::stencilFunc

The comparison function to test the reference value to a stencil buffer entry. The default is GFXCmpNever.

int GFXStateBlockData::stencilMask

The mask applied to the reference value and each stencil buffer entry to determine the significant bits for the stencil test. The default is 0xFFFFFFFF.

GFXStencilOp GFXStateBlockData::stencilPassOp

The stencil operation to perform if both the stencil and the depth tests pass. The default is GFXStencilOpKeep.

int GFXStateBlockData::stencilRef

The reference value for the stencil test. The default is zero.

int GFXStateBlockData::stencilWriteMask

The write mask applied to values written into the stencil buffer. The default is 0xFFFFFFFF.

GFXStencilOp GFXStateBlockData::stencilZFailOp

The stencil operation to perform if the stencil test passes and the depth test fails. The default is GFXStencilOpKeep.

ColorI GFXStateBlockData::textureFactor

The color used for multiple-texture blending with the GFXTATFactor texture-blending argument or the GFXTOPBlendFactorAlpha texture-blending operation. The default is opaque white (255, 255, 255, 255).

bool GFXStateBlockData::vertexColorEnable

Enables fixed function vertex coloring when rendering without a shader. The default is false.

float GFXStateBlockData::zBias

A floating-point bias used when comparing depth values. The default is zero.

bool GFXStateBlockData::zDefined

Set to true if the depth state is not all defaults.

bool GFXStateBlockData::zEnable

Enables z-buffer reads. The default is true.

GFXCmpFunc GFXStateBlockData::zFunc

The depth comparision function which a pixel must pass to be written to the z-buffer. The default is GFXCmpLessEqual.

float GFXStateBlockData::zSlopeBias

An additional floating-point bias based on the maximum depth slop of the triangle being rendered. The default is zero.

bool GFXStateBlockData::zWriteEnable

Enables z-buffer writes. The default is true.


Torque 3D - Script Manual: GroundCover Class Reference

GroundCover Class Reference
[Foliage]

Covers the ground in a field of objects (IE: Grass, Flowers, etc). More...

Inheritance diagram for GroundCover:
[legend]

List of all members.

Public Attributes

GroundCover General

RectF | billboardUVs [8]
Subset material UV coordinates for this cover billboard.
float | clumpExponent [8]
An exponent used to bias between the minimum and maximum clump counts for a particular clump.
float | clumpRadius [8]
The maximum clump radius.
float | dissolveRadius
This is less than or equal to radius and defines when fading of cover elements begins.
int | gridSize
The number of cells per axis in the grid.
bool | invertLayer [8]
Indicates that the terrain material index given in 'layer' is an exclusion mask.
string | layer [8]
Terrain material name to limit coverage to, or blank to not limit.
string | Material
Material used by all GroundCover segments.
float | maxBillboardTiltAngle
The maximum amout of degrees the billboard will tilt down to match the camera.
int | maxClumpCount [8]
The maximum amount of elements in a clump.
int | maxElements
The maximum amount of cover elements to include in the grid at any one time.
float | maxElevation [8]
The maximum world space elevation for placement.
float | maxSlope [8]
The maximum slope angle in degrees for placement.
int | minClumpCount [8]
The minimum amount of elements in a clump.
float | minElevation [8]
The minimum world space elevation for placement.
float | probability [8]
The probability of one cover type verses another (relative to all cover types).
float | radius
Outer generation radius from the current camera position.
float | reflectScale
Scales the various culling radii when rendering a reflection. Typically for water.
int | seed
This RNG seed is saved and sent to clients for generating the same cover.
float | shapeCullRadius
This is the distance at which DTS elements are completely culled out.
filename | shapeFilename [8]
The cover shape filename. [Optional].
bool | shapesCastShadows
Whether DTS elements should cast shadows or not.
float | sizeExponent [8]
An exponent used to bias between the minimum and maximum random sizes.
float | sizeMax [8]
The maximum random size of this cover type.
float | sizeMin [8]
The minimum random size for each cover type.
float | windScale [8]
The wind effect scale.
float | zOffset
Offset along the Z axis to render the ground cover.
GroundCover Debug

bool | lockFrustum
Debug parameter for locking the culling frustum which will freeze the cover generation.
bool | noBillboards
Debug parameter for turning off billboard rendering.
bool | noShapes
Debug parameter for turning off shape rendering.
bool | renderCells
Debug parameter for displaying the grid cells.
GroundCover Wind

Point2F | windDirection
The direction of the wind.
float | windGustFrequency
Controls how often the wind gust peaks per second.
float | windGustLength
The length in meters between peaks in the wind gust.
float | windGustStrength
The maximum distance in meters that the peak wind gust will displace an element.
float | windTurbulenceFrequency
Controls the overall rapidity of the wind turbulence.
float | windTurbulenceStrength
The maximum distance in meters that the turbulence can displace a ground cover element.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static int | renderedBatches
Stat for number of rendered billboard batches.
static int | renderedBillboards
Stat for number of rendered billboards.
static int | renderedCells
Stat for number of rendered cells.
static int | renderedShapes
Stat for number of rendered shapes.

Detailed Description

Covers the ground in a field of objects (IE: Grass, Flowers, etc).

Member Data Documentation

RectF GroundCover::billboardUVs[8]

Subset material UV coordinates for this cover billboard.

float GroundCover::clumpExponent[8]

An exponent used to bias between the minimum and maximum clump counts for a particular clump.

float GroundCover::clumpRadius[8]

The maximum clump radius.

float GroundCover::dissolveRadius

This is less than or equal to radius and defines when fading of cover elements begins.

int GroundCover::gridSize

The number of cells per axis in the grid.

bool GroundCover::invertLayer[8]

Indicates that the terrain material index given in 'layer' is an exclusion mask.

bool GroundCover::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool GroundCover::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string GroundCover::layer[8]

Terrain material name to limit coverage to, or blank to not limit.

bool GroundCover::lockFrustum

Debug parameter for locking the culling frustum which will freeze the cover generation.

string GroundCover::Material

Material used by all GroundCover segments.

float GroundCover::maxBillboardTiltAngle

The maximum amout of degrees the billboard will tilt down to match the camera.

int GroundCover::maxClumpCount[8]

The maximum amount of elements in a clump.

int GroundCover::maxElements

The maximum amount of cover elements to include in the grid at any one time.

float GroundCover::maxElevation[8]

The maximum world space elevation for placement.

float GroundCover::maxSlope[8]

The maximum slope angle in degrees for placement.

int GroundCover::minClumpCount[8]

The minimum amount of elements in a clump.

float GroundCover::minElevation[8]

The minimum world space elevation for placement.

bool GroundCover::noBillboards

Debug parameter for turning off billboard rendering.

bool GroundCover::noShapes

Debug parameter for turning off shape rendering.

float GroundCover::probability[8]

The probability of one cover type verses another (relative to all cover types).

float GroundCover::radius

Outer generation radius from the current camera position.

float GroundCover::reflectScale

Scales the various culling radii when rendering a reflection. Typically for water.

bool GroundCover::renderCells

Debug parameter for displaying the grid cells.

int GroundCover::seed

This RNG seed is saved and sent to clients for generating the same cover.

float GroundCover::shapeCullRadius

This is the distance at which DTS elements are completely culled out.

filename GroundCover::shapeFilename[8]

The cover shape filename. [Optional].

bool GroundCover::shapesCastShadows

Whether DTS elements should cast shadows or not.

float GroundCover::sizeExponent[8]

An exponent used to bias between the minimum and maximum random sizes.

float GroundCover::sizeMax[8]

The maximum random size of this cover type.

float GroundCover::sizeMin[8]

The minimum random size for each cover type.

Point2F GroundCover::windDirection

The direction of the wind.

float GroundCover::windGustFrequency

Controls how often the wind gust peaks per second.

float GroundCover::windGustLength

The length in meters between peaks in the wind gust.

float GroundCover::windGustStrength

The maximum distance in meters that the peak wind gust will displace an element.

float GroundCover::windScale[8]

The wind effect scale.

float GroundCover::windTurbulenceFrequency

Controls the overall rapidity of the wind turbulence.

float GroundCover::windTurbulenceStrength

The maximum distance in meters that the turbulence can displace a ground cover element.

float GroundCover::zOffset

Offset along the Z axis to render the ground cover.


Torque 3D - Script Manual: GroundPlane Class Reference

GroundPlane Class Reference
[Terrain]

An infinite plane extending in all direction. More...

Inheritance diagram for GroundPlane:
[legend]

List of all members.

Public Member Functions

void | postApply ()
Intended as a helper to developers and editor scripts.

Public Attributes

Plane

string | Material
Name of Material used to render GroundPlane's surface.
float | scaleU
Scale of texture repeat in the U direction.
float | scaleV
Scale of texture repeat in the V direction.
float | squareSize
Square size in meters to which GroundPlane subdivides its geometry.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An infinite plane extending in all direction.

GroundPlane is useful for setting up simple testing scenes, or it can be placed under an existing scene to keep objects from falling into 'nothing'.

GroundPlane may not be moved or rotated, it is always at the world origin.

Member Function Documentation

void GroundPlane::postApply ( )

Intended as a helper to developers and editor scripts.

Force trigger an inspectPostApply. This will transmit material and other fields to client objects.

Member Data Documentation

bool GroundPlane::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool GroundPlane::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string GroundPlane::Material

Name of Material used to render GroundPlane's surface.

float GroundPlane::scaleU

Scale of texture repeat in the U direction.

float GroundPlane::scaleV

Scale of texture repeat in the V direction.

float GroundPlane::squareSize

Square size in meters to which GroundPlane subdivides its geometry.


Torque 3D - Script Manual: GuiArrayCtrl Class Reference

GuiArrayCtrl Class Reference

Inheritance diagram for GuiArrayCtrl:
[legend]


Torque 3D - Script Manual: GuiAutoScrollCtrl Class Reference

GuiAutoScrollCtrl Class Reference
[Container Controls]

A container that scrolls its child control up over time. More...

Inheritance diagram for GuiAutoScrollCtrl:
[legend]

List of all members.

Public Member Functions

void | reset ()
Reset scrolling.
Callbacks

void | onComplete ()
Called when the child control has been scrolled in entirety.
void | onReset ()
Called when the child control is reset to its initial position and the cycle starts again.
void | onStart ()
Called when the control starts to scroll.
void | onTick ()
Called every 32ms on the control.

Public Attributes

Scrolling

int | childBorder
Padding to put around child control (in pixels).
bool | isLooping
If true, the scrolling will reset to the beginning once completing a cycle.
float | resetDelay
Seconds to wait after scrolling completes before resetting and starting over.
GuiAutoScrollDirection scrollDirection
Direction in which the child control is moved.
bool | scrollOutOfSight
If true, the child control will be completely scrolled out of sight; otherwise it will only scroll until the other end becomes visible.
float | scrollSpeed
Scrolling speed in pixels per second.
float | startDelay
Seconds to wait before starting to scroll.

Detailed Description

A container that scrolls its child control up over time.

This container can be used to scroll a single child control in either of the four directions.

Example:
// Create a GuiAutoScrollCtrl that scrolls a long text of credits.
new GuiAutoScrollCtrl( CreditsScroller )
{
   position = "0 0";
   extent = Canvas.extent.x SPC Canvas.extent.y;

   scrollDirection = "Up"; // Scroll upwards.
   startDelay = 4; // Wait 4 seconds before starting to scroll.
   isLooping = false; // Don't loop the credits.
   scrollOutOfSight = true; // Scroll up fully.

   new GuiMLTextCtrl()
   {
      text = $CREDITS;
   };
};

function CreditsScroller::onComplete( %this )
{
   // Switch back to main menu after credits have rolled.
   Canvas.setContent( MainMenu );
}

// Start rolling credits.
Canvas.setContent( CreditsScroller );
Note:
Only the first child will be scrolled.

Member Function Documentation

void GuiAutoScrollCtrl::onComplete ( )

Called when the child control has been scrolled in entirety.

void GuiAutoScrollCtrl::onReset ( )

Called when the child control is reset to its initial position and the cycle starts again.

void GuiAutoScrollCtrl::onStart ( )

Called when the control starts to scroll.

void GuiAutoScrollCtrl::onTick ( )

Called every 32ms on the control.

void GuiAutoScrollCtrl::reset ( )

Reset scrolling.

Member Data Documentation

int GuiAutoScrollCtrl::childBorder

Padding to put around child control (in pixels).

bool GuiAutoScrollCtrl::isLooping

If true, the scrolling will reset to the beginning once completing a cycle.

float GuiAutoScrollCtrl::resetDelay

Seconds to wait after scrolling completes before resetting and starting over.

Note:
Only takes effect if isLooping is true.
GuiAutoScrollDirection GuiAutoScrollCtrl::scrollDirection

Direction in which the child control is moved.

bool GuiAutoScrollCtrl::scrollOutOfSight

If true, the child control will be completely scrolled out of sight; otherwise it will only scroll until the other end becomes visible.

float GuiAutoScrollCtrl::scrollSpeed

Scrolling speed in pixels per second.

float GuiAutoScrollCtrl::startDelay

Seconds to wait before starting to scroll.


Torque 3D - Script Manual: GuiBitmapBorderCtrl Class Reference

GuiBitmapBorderCtrl Class Reference
[Image and Video Controls]

A control that renders a skinned border specified in its profile. More...

Inheritance diagram for GuiBitmapBorderCtrl:
[legend]

List of all members.

Detailed Description

A control that renders a skinned border specified in its profile.

This control uses the bitmap specified in it's profile (GuiControlProfile::bitmapName). It takes this image and breaks up aspects of it to skin the border of this control with. It is also important to set GuiControlProfile::hasBitmapArray to true on the profile as well.

The bitmap referenced should be broken up into a 3 x 3 grid (using the top left color pixel as a border color between each of the images) in which it will map to the following places: 1 = Top Left Corner 2 = Top Right Corner 3 = Top Center 4 = Left Center 5 = Right Center 6 = Bottom Left Corner 7 = Bottom Center 8 = Bottom Right Corner 0 = Nothing

1 2 3 4 5 0 6 7 8

Example:
singleton GuiControlProfile (BorderGUIProfile)
{
   bitmap = "core/art/gui/images/borderArray";
   hasBitmapArray = true;
   opaque = false;
};

new GuiBitmapBorderCtrl(BitmapBorderGUI)
{
   profile = "BorderGUIProfile";
   position = "0 0";
   extent = "400 40";
   visible = "1";
};
See also:
GuiControlProfile::bitmapName
GuiControlProfile::hasBitmapArray


Torque 3D - Script Manual: GuiBitmapButtonCtrl Class Reference

GuiBitmapButtonCtrl Class Reference
[Button Controls]

A button that renders its various states (mouse over, pushed, etc.) from separate bitmaps. More...

Inheritance diagram for GuiBitmapButtonCtrl:
[legend]

List of all members.

Public Member Functions

void | setBitmap (string path)
Set the bitmap to show on the button.
Callbacks

void | onAltClick ()
Called when per-modifier functionality is enabled and the user clicks on the button with the ALT key pressed.
void | onCtrlClick ()
Called when per-modifier functionality is enabled and the user clicks on the button with the CTRL key pressed.
void | onDefaultClick ()
Called when per-modifier functionality is enabled and the user clicks on the button without any modifier pressed.
void | onShiftClick ()
Called when per-modifier functionality is enabled and the user clicks on the button with the SHIFT key pressed.

Public Attributes

Bitmap

bool | autoFitExtents
If true, the control's extents will be set to match the bitmap's extents when setting the bitmap.
filename | bitmap
Texture file to display on this button.
GuiBitmapMode bitmapMode
Behavior for fitting the bitmap to the control extents.
bool | useModifiers
If true, per-modifier button functionality is enabled.
bool | useStates
If true, per-mouse state button functionality is enabled.

Detailed Description

A button that renders its various states (mouse over, pushed, etc.) from separate bitmaps.

A bitmapped button is a push button that uses one or more texture images for rendering its individual states.

To find the individual textures associated with the button, a naming scheme is used. For each state a suffix is appended to the texture file name given in the GuiBitmapButtonCtrl::bitmap field:

  • "_n": Normal state. This one will be active when no other state applies.
  • "_h": Highlighted state. This applies when the mouse is hovering over the button.
  • "_d": Depressed state. This applies when the left mouse button has been clicked on the button but not yet released.
  • "_i": Inactive state. This applies when the button control has been deactivated (GuiControl::setActive())

If a bitmap for a particular state cannot be found, the default bitmap will be used. To disable all state-based bitmap functionality, set useStates to false which will make the control solely render from the bitmap specified in the bitmap field.

Per-Modifier Button Actions

If GuiBitmapButtonCtrl::useModifiers is set to true, per-modifier button actions and textures are enabled. This functionality allows to associate different images and different actions with a button depending on which modifiers are pressed on the keyboard by the user.

When enabled, this functionality alters the texture lookup above by prepending the following strings to the suffixes listed above:

  • "": Default. No modifier is pressed.
  • "_ctrl": Image to use when CTRL/CMD is down.
  • "_alt": Image to use when ALT is down.
  • "_shift": Image to use when SHIFT is down

When this functionality is enabled, a new set of callbacks is used:

  • onDefaultClick: Button was clicked without a modifier being presssed.
  • onCtrlClick: Button was clicked with the CTRL/CMD key down.
  • onAltClick: Button was clicked with the ALT key down.
  • onShiftClick: Button was clicked with the SHIFT key down.

GuiControl::command or GuiControl::onAction() still work as before when per-modifier functionality is enabled.

Note that modifiers cannot be mixed. If two or more modifiers are pressed, a single one will take precedence over the remaining modifiers. The order of precedence corresponds to the order listed above.

Example:
// Create an OK button that will trigger an onOk() call on its parent when clicked:
%okButton = new GuiBitmapButtonCtrl()
{
   bitmap = "art/gui/okButton";
   autoFitExtents = true;
   command = "$ThisControl.getParent().onOk();";
};

Member Function Documentation

void GuiBitmapButtonCtrl::onAltClick ( )

Called when per-modifier functionality is enabled and the user clicks on the button with the ALT key pressed.

Per-Modifier Button Actions

void GuiBitmapButtonCtrl::onCtrlClick ( )

Called when per-modifier functionality is enabled and the user clicks on the button with the CTRL key pressed.

Per-Modifier Button Actions

void GuiBitmapButtonCtrl::onDefaultClick ( )

Called when per-modifier functionality is enabled and the user clicks on the button without any modifier pressed.

Per-Modifier Button Actions

void GuiBitmapButtonCtrl::onShiftClick ( )

Called when per-modifier functionality is enabled and the user clicks on the button with the SHIFT key pressed.

Per-Modifier Button Actions

void GuiBitmapButtonCtrl::setBitmap ( string path )

Set the bitmap to show on the button.

Parameters:
path Path to the texture file in any of the supported formats.

Member Data Documentation

bool GuiBitmapButtonCtrl::autoFitExtents

If true, the control's extents will be set to match the bitmap's extents when setting the bitmap.

The bitmap extents will always be taken from the default/normal bitmap (in case the extents of the various bitmaps do not match up.)

filename GuiBitmapButtonCtrl::bitmap

Texture file to display on this button.

If useStates is false, this will be the file that renders on the control. Otherwise, this will specify the default texture name to which the various state and modifier suffixes are appended to find the per-state and per-modifier (if enabled) textures.

GuiBitmapMode GuiBitmapButtonCtrl::bitmapMode

Behavior for fitting the bitmap to the control extents.

If set to 'Stretched', the bitmap will be stretched both verticall and horizontally to fit inside the control's extents.

If set to 'Centered', the bitmap will stay at its original resolution centered in the control's rectangle (getting clipped if the control is smaller than the texture).

bool GuiBitmapButtonCtrl::useModifiers

If true, per-modifier button functionality is enabled.

Per-Modifier Button Actions

bool GuiBitmapButtonCtrl::useStates

If true, per-mouse state button functionality is enabled.

Defaults to true.

If you do not use per-state images on this button set this to false to speed up the loading process by inhibiting searches for the individual images.


Torque 3D - Script Manual: GuiBitmapButtonTextCtrl Class Reference

GuiBitmapButtonTextCtrl Class Reference
[Button Controls]

An extension of GuiBitmapButtonCtrl that additionally renders a text label on the bitmapped button. More...

Inheritance diagram for GuiBitmapButtonTextCtrl:
[legend]

List of all members.

Detailed Description

An extension of GuiBitmapButtonCtrl that additionally renders a text label on the bitmapped button.

The text for the label is taken from the GuiButtonBaseCtrl::text property.

For rendering, the label is placed, relative to the control's upper left corner, at the text offset specified in the control's profile (GuiControlProfile::textOffset) and justified according to the profile's setting (GuiControlProfile::justify).

See also:
GuiControlProfile::textOffset
GuiControlProfile::justify


Torque 3D - Script Manual: GuiBitmapCtrl Class Reference

GuiBitmapCtrl Class Reference
[General Controls]

A gui control that is used to display an image. More...

Inheritance diagram for GuiBitmapCtrl:
[legend]

List of all members.

Public Member Functions

void | setBitmap (String filename, bool resize)
Assign an image to the control.
void | setBitmap (String filename)
Assign an image to the control.
void | setValue (int x, int y)
Set the offset of the bitmap within the control.

Public Attributes

Bitmap

filename | bitmap
The bitmap file to display in the control.
bool | wrap
If true, the bitmap is tiled inside the control rather than stretched to fit.

Detailed Description

A gui control that is used to display an image.

The image is stretched to the constraints of the control by default. However, the control can also tile the image as well.

The image itself is stored inside the GuiBitmapCtrl::bitmap field. The boolean value that decides whether the image is stretched or tiled is stored inside the GuiBitmapCtrl::wrap field.

Example:
// Create a tiling GuiBitmapCtrl that displays "myImage.png"
%bitmapCtrl = new GuiBitmapCtrl()
{
   bitmap = "myImage.png";
   wrap = "true";
};

Member Function Documentation

void GuiBitmapCtrl::setBitmap | ( | String | filename,
 |  | bool | resize
 | ) |  |

Assign an image to the control.

Child controls with resize according to their layout settings.

Parameters:
filename | The filename of the image.
resize | Optional parameter. If true, the GUI will resize to fit the image.
void GuiBitmapCtrl::setBitmap ( String filename )

Assign an image to the control.

Child controls will resize according to their layout settings.

Parameters:
filename | The filename of the image.
resize | A boolean value that decides whether the ctrl refreshes or not.
void GuiBitmapCtrl::setValue | ( | int | x,
 |  | int | y
 | ) |  |

Set the offset of the bitmap within the control.

Parameters:
x | The x-axis offset of the image.
y | The y-axis offset of the image.

Member Data Documentation

filename GuiBitmapCtrl::bitmap

The bitmap file to display in the control.

bool GuiBitmapCtrl::wrap

If true, the bitmap is tiled inside the control rather than stretched to fit.


Torque 3D - Script Manual: GuiBorderButtonCtrl Class Reference

GuiBorderButtonCtrl Class Reference
[Button Controls]

A push button that renders only a border. More...

Inheritance diagram for GuiBorderButtonCtrl:
[legend]

List of all members.

Detailed Description

A push button that renders only a border.

A border button consists of a border rendered along its extents according to the border thickness defined in its profile (GuiControlProfile::border). For the border color, a color is selected from the profile according to current button state:

  • Default state: GuiControlProfile::borderColor
  • Highlighted (mouse is over the button): GuiControlProfile::fontColorHL
  • Depressed (mouse button down but not yet released): GuiControlProfile::fontColorSEL


Torque 3D - Script Manual: GuiBubbleTextCtrl Class Reference

GuiBubbleTextCtrl Class Reference
[General Controls]

A single-line text control that displays its text in a multi-line popup when clicked. More...

Inheritance diagram for GuiBubbleTextCtrl:
[legend]

List of all members.

Detailed Description

A single-line text control that displays its text in a multi-line popup when clicked.

This control acts like a GuiTextCtrl (and inherits from it), when clicked it creates a GuiMLTextCtrl roughly where you clicked with the same text in it. This allows you to have a single line text control which upon clicking will display the entire text contained in a multi-line format.

Example:
new GuiBubbleTextCtrl(BubbleTextGUI)
{
   text = "This is the first sentence.  This second sentence can be sized outside of the default single line view, upon clicking this will be displayed in a multi-line format.";
};
See also:
GuiTextCtrl
GuiMLTextCtrl


Torque 3D - Script Manual: GuiButtonBaseCtrl Class Reference

GuiButtonBaseCtrl Class Reference
[Button Controls]

The base class for the various button controls. More...

Inheritance diagram for GuiButtonBaseCtrl:
[legend]

List of all members.

Public Member Functions

string | getText ()
Get the text display on the button's label (if any).
void | performClick ()
Simulate a click on the button.
void | resetState ()
Reset the mousing state of the button.
void | setStateOn (bool isOn=true)
For toggle or radio buttons, set whether the button is currently activated or not. For radio buttons, toggling a button on will toggle all other radio buttons in its group to off.
void | setText (string text)
Set the text displayed on the button's label.
void | setTextID (string id)
Set the text displayed on the button's label using a string from the string table assigned to the control.
Callbacks

void | onClick ()
Called when the primary action of the button is triggered (e.g. by a left mouse click).
void | onDoubleClick ()
Called when the left mouse button is double-clicked on the button.
void | onMouseDown ()
If useMouseEvents is true, this is called when the left mouse button is pressed on an (active) button.
void | onMouseDragged ()
If useMouseEvents is true, this is called when a left mouse button drag is detected, i.e. when the user pressed the left mouse button on the control and then moves the mouse over a certain distance threshold with the mouse button still pressed.
void | onMouseEnter ()
If useMouseEvents is true, this is called when the mouse cursor moves over the button (only if the button is the front-most visible control, though).
void | onMouseLeave ()
If useMouseEvents is true, this is called when the mouse cursor moves off the button (only if the button had previously received an onMouseEvent() event).
void | onMouseUp ()
If useMouseEvents is true, this is called when the left mouse button is release over an (active) button.
void | onRightClick ()
Called when the right mouse button is clicked on the button.

Public Attributes

Button

GuiButtonType buttonType
Button behavior type.
int | groupNum
Radio button toggle group number. All radio buttons that are assigned the same groupNum and that are parented to the same control will synchronize their toggle state, i.e. if one radio button is toggled on all other radio buttons in its group will be toggled off.
caseString | text
Text label to display on button (if button class supports text labels).
string | textID
ID of string in string table to use for text label on button.
bool | useMouseEvents
If true, mouse events will be passed on to script. Default is false.

Detailed Description

The base class for the various button controls.

This is the base class for the various types of button controls. If no more specific functionality is required than offered by this class, then it can be instantiated and used directly. Otherwise, its subclasses should be used:

  • GuiRadioCtrl (radio buttons)
  • GuiCheckBoxCtrl (checkboxes)
  • GuiButtonCtrl (push buttons with text labels)
  • GuiBitmapButtonCtrl (bitmapped buttons)
  • GuiBitmapButtonTextCtrl (bitmapped buttons with a text label)
  • GuiToggleButtonCtrl (toggle buttons, i.e. push buttons with "sticky" behavior)
  • GuiSwatchButtonCtrl (color swatch buttons)
  • GuiBorderButtonCtrl (push buttons for surrounding child controls)

Member Function Documentation

string GuiButtonBaseCtrl::getText ( )

Get the text display on the button's label (if any).

Returns:
The button's label.
void GuiButtonBaseCtrl::onClick ( )

Called when the primary action of the button is triggered (e.g. by a left mouse click).

void GuiButtonBaseCtrl::onDoubleClick ( )

Called when the left mouse button is double-clicked on the button.

void GuiButtonBaseCtrl::onMouseDown ( )

If useMouseEvents is true, this is called when the left mouse button is pressed on an (active) button.

void GuiButtonBaseCtrl::onMouseDragged ( )

If useMouseEvents is true, this is called when a left mouse button drag is detected, i.e. when the user pressed the left mouse button on the control and then moves the mouse over a certain distance threshold with the mouse button still pressed.

void GuiButtonBaseCtrl::onMouseEnter ( )

If useMouseEvents is true, this is called when the mouse cursor moves over the button (only if the button is the front-most visible control, though).

void GuiButtonBaseCtrl::onMouseLeave ( )

If useMouseEvents is true, this is called when the mouse cursor moves off the button (only if the button had previously received an onMouseEvent() event).

void GuiButtonBaseCtrl::onMouseUp ( )

If useMouseEvents is true, this is called when the left mouse button is release over an (active) button.

Note:
To trigger actions, better use onClick() since onMouseUp() will also be called when the mouse was not originally pressed on the button.
void GuiButtonBaseCtrl::onRightClick ( )

Called when the right mouse button is clicked on the button.

void GuiButtonBaseCtrl::performClick ( )

Simulate a click on the button.

This method will trigger the button's action just as if the button had been pressed by the user.

void GuiButtonBaseCtrl::resetState ( )

Reset the mousing state of the button.

This method should not generally be called.

void GuiButtonBaseCtrl::setStateOn ( bool isOn = true )

For toggle or radio buttons, set whether the button is currently activated or not. For radio buttons, toggling a button on will toggle all other radio buttons in its group to off.

Parameters:
isOn If true, the button will be toggled on (if not already); if false, it will be toggled off.
Note:
Toggling the state of a button with this method will not not trigger the action associated with the button. To do that, use performClick().

Reimplemented in GuiCheckBoxCtrl.

void GuiButtonBaseCtrl::setText ( string text )

Set the text displayed on the button's label.

Parameters:
text The text to display as the button's text label.
Note:
Not all buttons render text labels.
See also:
getText
setTextID
void GuiButtonBaseCtrl::setTextID ( string id )

Set the text displayed on the button's label using a string from the string table assigned to the control.

Parameters:
id Name of the variable that contains the integer string ID. Used to look up string in table.
Note:
Not all buttons render text labels.
See also:
setText
getText
GuiControl::langTableMod
LangTable

Internationalization

Member Data Documentation

GuiButtonType GuiButtonBaseCtrl::buttonType

Button behavior type.

int GuiButtonBaseCtrl::groupNum

Radio button toggle group number. All radio buttons that are assigned the same groupNum and that are parented to the same control will synchronize their toggle state, i.e. if one radio button is toggled on all other radio buttons in its group will be toggled off.

The default group is -1.

caseString GuiButtonBaseCtrl::text

Text label to display on button (if button class supports text labels).

string GuiButtonBaseCtrl::textID

ID of string in string table to use for text label on button.

See also:
setTextID
GuiControl::langTableMod
LangTable
bool GuiButtonBaseCtrl::useMouseEvents

If true, mouse events will be passed on to script. Default is false.


Torque 3D - Script Manual: GuiButtonCtrl Class Reference

GuiButtonCtrl Class Reference
[Button Controls]

The most widely used button class. More...

Inheritance diagram for GuiButtonCtrl:
[legend]

List of all members.

Detailed Description

The most widely used button class.

GuiButtonCtrl renders seperately of, but utilizes all of the functionality of GuiBaseButtonCtrl. This grants GuiButtonCtrl the versatility to be either of the 3 button types.

Example:
// Create a PushButton GuiButtonCtrl that calls randomFunction when clicked
%button = new GuiButtonCtrl()
{
   profile    = "GuiButtonProfile";
   buttonType = "PushButton";
   command    = "randomFunction();";
};


Torque 3D - Script Manual: GuiCanvas Class Reference

GuiCanvas Class Reference
[Core Controls]

A canvas on which rendering occurs. More...

Inheritance diagram for GuiCanvas:
[legend]

List of all members.

Public Member Functions

Point2I | clientToScreen (Point2I coordinate)
Translate a coordinate from canvas window-space to screen-space.
void | cursorOff ()
Turns on the mouse off.
void | cursorOn ()
Turns on the mouse cursor.
int | getContent ()
Get the GuiControl which is being used as the content.
Point2I | getCursorPos ()
Get the current position of the cursor.
Point2I | getExtent ()
Returns the dimensions of the canvas.
string | getMode (int modeId)
Gets information on the specified mode of this device.
int | getModeCount ()
Gets the number of modes available on this device.
int | getMouseControl ()
Gets the gui control under the mouse.
string | getVideoMode ()
Gets the current screen mode as a string.
Point2I | getWindowPosition ()
Get the current position of the platform window associated with the canvas.
void | hideCursor ()
Disable rendering of the cursor.
bool | isCursorOn ()
Determines if mouse cursor is enabled.
bool | isCursorShown ()
Determines if mouse cursor is rendering.
bool | isFullscreen ()
Is this canvas currently fullscreen?
bool | isMaximized ()
bool | isMinimized ()
void | maximizeWindow ()
maximize this canvas' window.
void | minimizeWindow ()
minimize this canvas' window.
void | popDialog (GuiControl ctrl)
Removes a specific dialog control.
void | popDialog ()
Removes a dialog at the front most layer.
void | popLayer ()
Removes the top most layer of dialogs.
void | popLayer (S32 layer)
Removes a specified layer of dialogs.
void | pushDialog (GuiControl ctrl, int layer=0, bool center=false)
Adds a dialog control onto the stack of dialogs.
void | renderFront (bool enable)
This turns on/off front-buffer rendering.
void | repaint (int elapsedMS=0)
Force canvas to redraw. If the elapsed time is greater than the time since the last paint then the repaint will be skipped.
void | reset ()
Reset the update regions for the canvas.
void | restoreWindow ()
restore this canvas' window.
Point2I | screenToClient (Point2I coordinate)
Translate a coordinate from screen-space to canvas window-space.
void | setContent (GuiControl ctrl)
Set the content of the canvas to a specified control.
void | setCursor (GuiCursor cursor)
Sets the cursor for the canvas.
bool | setCursorPos (Point2I pos)
Sets the position of the cursor.
bool | setCursorPos (F32 posX, F32 posY)
Sets the position of the cursor.
void | setFocus ()
Claim OS input focus for this canvas' window.
void | setVideoMode (int width, int height, bool fullscreen,[int bitDepth],[int refreshRate],[int antialiasLevel])
Change the video mode of this canvas. This method has the side effect of setting the $pref::Video::mode to the new values.
void | setWindowPosition (Point2I position)
Set the position of the platform window associated with the canvas.
void | setWindowTitle (string newTitle)
Change the title of the OS window.
void | showCursor ()
Enable rendering of the cursor.
void | toggleFullscreen ()
toggle canvas from fullscreen to windowed mode or back.

Public Attributes

Mouse Handling

bool | alwaysHandleMouseButtons
Deal with mouse buttons, even if the cursor is hidden.
Canvas Rendering

int | numFences
The number of GFX fences to use.

Detailed Description

A canvas on which rendering occurs.

What a GUICanvas Can Contain...

Content Control

A content control is the top level GuiControl for a screen. This GuiControl will be the parent control for all other GuiControls on that particular screen.

Dialogs

A dialog is essentially another screen, only it gets overlaid on top of the current content control, and all input goes to the dialog. This is most akin to the "Open File" dialog box found in most operating systems. When you choose to open a file, and the "Open File" dialog pops up, you can no longer send input to the application, and must complete or cancel the open file request. Torque keeps track of layers of dialogs. The dialog with the highest layer is on top and will get all the input, unless the dialog is modeless, which is a profile option.

See also:
GuiControlProfile

Dirty Rectangles

The GuiCanvas is based on dirty regions. Every frame the canvas paints only the areas of the canvas that are 'dirty' or need updating. In most cases, this only is the area under the mouse cursor. This is why if you look in guiCanvas.cc the call to glClear is commented out. What you will see is a black screen, except in the dirty regions, where the screen will be painted normally. If you are making an animated GuiControl you need to add your control to the dirty areas of the canvas.

See also:
GuiControl

Member Function Documentation

Point2I GuiCanvas::clientToScreen ( Point2I coordinate )

Translate a coordinate from canvas window-space to screen-space.

Parameters:
coordinate The coordinate in window-space.
Returns:
The given coordinate translated to screen-space.
void GuiCanvas::cursorOff ( )

Turns on the mouse off.

Example:
Canvas.cursorOff();
void GuiCanvas::cursorOn ( )

Turns on the mouse cursor.

Example:
Canvas.cursorOn();
int GuiCanvas::getContent ( )

Get the GuiControl which is being used as the content.

Example:
Canvas.getContent();
Returns:
ID of current content control
Point2I GuiCanvas::getCursorPos ( )

Get the current position of the cursor.

Parameters:
param Description
Example:
%cursorPos = Canvas.getCursorPos();
Returns:
Screen coordinates of mouse cursor, in format "X Y"
Point2I GuiCanvas::getExtent ( )

Returns the dimensions of the canvas.

Example:
%extent = Canvas.getExtent();
Returns:
Width and height of canvas. Formatted as numerical values in a single string "# #"

Reimplemented from GuiControl.

string GuiCanvas::getMode ( int modeId )

Gets information on the specified mode of this device.

Parameters:
modeId Index of the mode to get data from.
Returns:
A video mode string given an adapter and mode index.
See also:
GuiCanvas::getVideoMode()
int GuiCanvas::getModeCount ( )

Gets the number of modes available on this device.

Parameters:
param Description
Example:
%modeCount = Canvas.getModeCount()
Returns:
The number of video modes supported by the device
int GuiCanvas::getMouseControl ( )

Gets the gui control under the mouse.

Example:
%underMouse = Canvas.getMouseControl();
Returns:
ID of the gui control, if one was found. NULL otherwise
string GuiCanvas::getVideoMode ( )

Gets the current screen mode as a string.

The return string will contain 5 values (width, height, fullscreen, bitdepth, refreshRate). You will need to parse out each one for individual use.

Example:
%screenWidth = getWord(Canvas.getVideoMode(), 0);
%screenHeight = getWord(Canvas.getVideoMode(), 1);
%isFullscreen = getWord(Canvas.getVideoMode(), 2);
%bitdepth = getWord(Canvas.getVideoMode(), 3);
%refreshRate = getWord(Canvas.getVideoMode(), 4);
Returns:
String formatted with screen width, screen height, screen mode, bit depth, and refresh rate.
Point2I GuiCanvas::getWindowPosition ( )

Get the current position of the platform window associated with the canvas.

Returns:
The window position of the canvas in screen-space.
void GuiCanvas::hideCursor ( )

Disable rendering of the cursor.

Example:
Canvas.hideCursor();
bool GuiCanvas::isCursorOn ( )

Determines if mouse cursor is enabled.

Example:
// Is cursor on?
if(Canvas.isCursorOn())
   echo("Canvas cursor is on");
Returns:
Returns true if the cursor is on.
bool GuiCanvas::isCursorShown ( )

Determines if mouse cursor is rendering.

Example:
// Is cursor rendering?
if(Canvas.isCursorShown())
   echo("Canvas cursor is rendering");
Returns:
Returns true if the cursor is rendering.
bool GuiCanvas::isFullscreen ( )

Is this canvas currently fullscreen?

bool GuiCanvas::isMaximized ( )
bool GuiCanvas::isMinimized ( )
void GuiCanvas::maximizeWindow ( )

maximize this canvas' window.

void GuiCanvas::minimizeWindow ( )

minimize this canvas' window.

void GuiCanvas::popDialog ( GuiControl ctrl )

Removes a specific dialog control.

Parameters:
ctrl Dialog to pop
Example:
Canvas.popDialog(RecordingsDlg);
void GuiCanvas::popDialog ( )

Removes a dialog at the front most layer.

Example:
// Pops whatever is on layer 0
Canvas.popDialog();
void GuiCanvas::popLayer ( )

Removes the top most layer of dialogs.

Example:
Canvas.popLayer();
void GuiCanvas::popLayer ( S32 layer )

Removes a specified layer of dialogs.

Parameters:
layer Number of the layer to pop
Example:
Canvas.popLayer(1);

void GuiCanvas::pushDialog | ( | GuiControl | ctrl,
 |  | int | layer = 0,
 |  | bool | center = false
 | ) |  |

Adds a dialog control onto the stack of dialogs.

Parameters:
ctrl | Dialog to add
layer | Layer to put dialog on (optional)
center | True to center dialog on canvas (optional)
Example:
Canvas.pushDialog(RecordingsDlg);
void GuiCanvas::renderFront ( bool enable )

This turns on/off front-buffer rendering.

Parameters:
enable True if all rendering should be done to the front buffer
Example:
Canvas.renderFront(false);
void GuiCanvas::repaint ( int elapsedMS = 0 )

Force canvas to redraw. If the elapsed time is greater than the time since the last paint then the repaint will be skipped.

Parameters:
elapsedMS The optional elapsed time in milliseconds.
Example:
Canvas.repaint();
void GuiCanvas::reset ( )

Reset the update regions for the canvas.

Example:
Canvas.reset();
void GuiCanvas::restoreWindow ( )

restore this canvas' window.

Point2I GuiCanvas::screenToClient ( Point2I coordinate )

Translate a coordinate from screen-space to canvas window-space.

Parameters:
coordinate The coordinate in screen-space.
Returns:
The given coordinate translated to window-space.
void GuiCanvas::setContent ( GuiControl ctrl )

Set the content of the canvas to a specified control.

Parameters:
ctrl ID or name of GuiControl to set content to
Example:
Canvas.setContent(PlayGui);
void GuiCanvas::setCursor ( GuiCursor cursor )

Sets the cursor for the canvas.

Parameters:
cursor Name of the GuiCursor to use
Example:
Canvas.setCursor("DefaultCursor");
bool GuiCanvas::setCursorPos ( Point2I pos )

Sets the position of the cursor.

Parameters:
pos Point, in screenspace for the cursor. Formatted as ("x y")
Example:
Canvas.setCursorPos("0 0");

bool GuiCanvas::setCursorPos | ( | F32 | posX,
 |  | F32 | posY
 | ) |  |

Sets the position of the cursor.

Parameters:
posX | X-coordinate, in screenspace for the cursor.
posY | Y-coordinate, in screenspace for the cursor.
Example:
Canvas.setCursorPos(0,0);
void GuiCanvas::setFocus ( )

Claim OS input focus for this canvas' window.

void GuiCanvas::setVideoMode | ( | int | width,
 |  | int | height,
 |  | bool | fullscreen
 | ) |  |

Change the video mode of this canvas. This method has the side effect of setting the $pref::Video::mode to the new values.

Parameters:
width | The screen width to set.
height | The screen height to set.
fullscreen | Specify true to run fullscreen or false to run in a window
bitDepth | [optional] The desired bit-depth. Defaults to the current setting. This parameter is ignored if you are running in a window.
refreshRate | [optional] The desired refresh rate. Defaults to the current setting. This parameter is ignored if you are running in a window
antialiasLevel | [optional] The level of anti-aliasing to apply 0 = none
void GuiCanvas::setWindowPosition ( Point2I position )

Set the position of the platform window associated with the canvas.

Parameters:
position The new position of the window in screen-space.
void GuiCanvas::setWindowTitle ( string newTitle )

Change the title of the OS window.

Parameters:
newTitle String containing the new name
Example:
Canvas.setWindowTitle("Documentation Rocks!");
void GuiCanvas::showCursor ( )

Enable rendering of the cursor.

Example:
Canvas.showCursor();
void GuiCanvas::toggleFullscreen ( )

toggle canvas from fullscreen to windowed mode or back.

Example:
// If we are in windowed mode, the following will put is in fullscreen
Canvas.toggleFullscreen();

Member Data Documentation

bool GuiCanvas::alwaysHandleMouseButtons

Deal with mouse buttons, even if the cursor is hidden.

int GuiCanvas::numFences

The number of GFX fences to use.


Torque 3D - Script Manual: GuiCheckBoxCtrl Class Reference

GuiCheckBoxCtrl Class Reference
[Button Controls]

A named checkbox that can be toggled on and off. More...

Inheritance diagram for GuiCheckBoxCtrl:
[legend]

List of all members.

Public Member Functions

bool | isStateOn ()
Test whether the checkbox is currently checked.
void | setStateOn (bool newState)
Set whether the checkbox is ticked or not.

Detailed Description

A named checkbox that can be toggled on and off.

A GuiCheckBoxCtrl displays a text label next to a checkbox that can be toggled on and off by the user. Checkboxes are usually used to present boolean choices like, for example, a switch to toggle fullscreen video on and off.

Example:
// Create a checkbox that allows to toggle fullscreen on and off.
new GuiCheckBoxCtrl( FullscreenToggle )
{
   text = "Fullscreen";
};

// Set the initial state to match the current fullscreen setting.
FullscreenToggle.setStateOn( Canvas.isFullscreen() );

// Define function to be called when checkbox state is toggled.
function FullscreenToggle::onClick( %this )
{
   Canvas.toggleFullscreen();
}

Member Function Documentation

bool GuiCheckBoxCtrl::isStateOn ( )

Test whether the checkbox is currently checked.

Returns:
True if the checkbox is currently ticked, false otherwise.
void GuiCheckBoxCtrl::setStateOn ( bool newState )

Set whether the checkbox is ticked or not.

Parameters:
newState If true the box will be checked, if false, it will be unchecked.
Note:
This method will not trigger the command associated with the control. To toggle the checkbox state as if the user had clicked the control, use performClick().

Reimplemented from GuiButtonBaseCtrl.


Torque 3D - Script Manual: GuiChunkedBitmapCtrl Class Reference

GuiChunkedBitmapCtrl Class Reference
[Image and Video Controls]

This is a control that will render a specified bitmap or a bitmap specified in a referenced variable. More...

Inheritance diagram for GuiChunkedBitmapCtrl:
[legend]

List of all members.

Public Member Functions

void | setBitmap (string filename)
Set the image rendered in this control.

Public Attributes

GuiChunkedBitmapCtrl

filename | bitmap
This is the bitmap to render to the control.
bool | tile
This is no longer in use.
bool | useVariable
This decides whether to use the "bitmap" file or a bitmap stored in "variable".

Detailed Description

This is a control that will render a specified bitmap or a bitmap specified in a referenced variable.

This control allows you to either set a bitmap with the "bitmap" field or with the setBitmap method. You can also choose to reference a variable in the "variable" field such as "$image" and then set "useVariable" to true. This will cause it to synchronize the variable with the bitmap displayed (if the variable holds a valid image). You can then change the variable and effectively changed the displayed image.

Example:
$image = "anotherbackground.png";
new GuiChunkedBitmapCtrl(ChunkedBitmap)
{
   bitmap = "background.png";
   variable = "$image";
   useVariable = false;
}

// This will result in the control rendering "background.png"
// If we now set the useVariable to true it will now render "anotherbackground.png"
ChunkedBitmap.useVariable = true;
See also:
GuiControl::variable

Member Function Documentation

void GuiChunkedBitmapCtrl::setBitmap ( string filename )

Set the image rendered in this control.

Parameters:
filename The image name you want to set
Example:
ChunkedBitmap.setBitmap("images/background.png");

Member Data Documentation

filename GuiChunkedBitmapCtrl::bitmap

This is the bitmap to render to the control.

bool GuiChunkedBitmapCtrl::tile

This is no longer in use.

bool GuiChunkedBitmapCtrl::useVariable

This decides whether to use the "bitmap" file or a bitmap stored in "variable".


Torque 3D - Script Manual: GuiClockHud Class Reference

GuiClockHud Class Reference
[Game Controls]

Basic HUD clock. Displays the current simulation time offset from some base. More...

Inheritance diagram for GuiClockHud:
[legend]

List of all members.

Public Member Functions

float | getTime ()
Returns the current time, in seconds.
void | setTime (float timeInSeconds=60)
Sets the current base time for the clock.

Public Attributes

Misc

ColorF | fillColor
Standard color for the background of the control.
ColorF | frameColor
Color for the control's frame.
bool | showFill
If true, draws a background color behind the control.
bool | showFrame
If true, draws a frame around the control.
ColorF | textColor
Color for the text on this control.

Detailed Description

Basic HUD clock. Displays the current simulation time offset from some base.

Example:
 new GuiClockHud(){
   fillColor = "0.0 1.0 0.0 1.0"; // Fills with a solid green color
   frameColor = "1.0 1.0 1.0 1.0"; // Solid white frame color
   textColor = "1.0 1.0 1.0 1.0"; // Solid white text Color
   showFill = "true";
   showFrame = "true";
};

Member Function Documentation

float GuiClockHud::getTime ( )

Returns the current time, in seconds.

Returns:
timeInseconds Current time, in seconds
Example:
// Get the current time from the GuiClockHud control
%timeInSeconds = %guiClockHud.getTime();
void GuiClockHud::setTime ( float timeInSeconds = 60 )

Sets the current base time for the clock.

Parameters:
timeInSeconds Time to set the clock, in seconds (IE: 00:02 would be 120)
Example:
// Define the time, in seconds
%timeInSeconds = 120;

// Change the time on the GuiClockHud control
%guiClockHud.setTime(%timeInSeconds);

Member Data Documentation

ColorF GuiClockHud::fillColor

Standard color for the background of the control.

ColorF GuiClockHud::frameColor

Color for the control's frame.

bool GuiClockHud::showFill

If true, draws a background color behind the control.

bool GuiClockHud::showFrame

If true, draws a frame around the control.

ColorF GuiClockHud::textColor

Color for the text on this control.


Torque 3D - Script Manual: GuiConsole Class Reference

GuiConsole Class Reference
[Core Controls]

The on-screen, in-game console. Calls getLog() to get the on-screen console entries, then renders them as needed. More...

Inheritance diagram for GuiConsole:
[legend]

List of all members.

Public Member Functions

Callbacks

void onMessageSelected (ConsoleLogEntry::Level level, string message)
Called when a message in the log is clicked.

Detailed Description

The on-screen, in-game console. Calls getLog() to get the on-screen console entries, then renders them as needed.

Example:
   new GuiConsole()
      {
         //Properties not specific to this control have been omitted from this example.
      };
See also:
GuiControl

Member Function Documentation

void GuiConsole::onMessageSelected | ( | ConsoleLogEntry::Level | level,
 |  | string | message
 | ) |  |

Called when a message in the log is clicked.

Parameters:
level | Diagnostic level of the message.
message | Message text.


Torque 3D - Script Manual: GuiConsoleEditCtrl Class Reference

GuiConsoleEditCtrl Class Reference
[Core Controls]

Text entry element of a GuiConsole. More...

Inheritance diagram for GuiConsoleEditCtrl:
[legend]

List of all members.

Public Attributes

GuiConsoleEditCtrl

bool useSiblingScroller

Detailed Description

Text entry element of a GuiConsole.

Example:
new GuiConsoleEditCtrl(ConsoleEntry)
{
   profile = "ConsoleTextEditProfile";
   horizSizing = "width";
   vertSizing = "top";
   position = "0 462";
   extent = "640 18";
   minExtent = "8 8";
   visible = "1";
   altCommand = "ConsoleEntry::eval();";
   helpTag = "0";
   maxLength = "255";
   historySize = "40";
   password = "0";
   tabComplete = "0";
   sinkAllKeyEvents = "1";
   useSiblingScroller = "1";
};

Member Data Documentation

bool GuiConsoleEditCtrl::useSiblingScroller


Torque 3D - Script Manual: GuiContainer Class Reference

GuiContainer Class Reference
[Container Controls]

Brief Desc. More...

Inheritance diagram for GuiContainer:
[legend]

List of all members.

Public Attributes

Layout

bool | anchorBottom
bool | anchorLeft
bool | anchorRight
bool | anchorTop
GuiDockingType docking
RectSpacingI | margin
RectSpacingI | padding

Detailed Description

Brief Desc.

Example:
// Comment:
%okButton = new ClassObject()
instantiation

Member Data Documentation

bool GuiContainer::anchorBottom
bool GuiContainer::anchorLeft
bool GuiContainer::anchorRight
bool GuiContainer::anchorTop
GuiDockingType GuiContainer::docking
RectSpacingI GuiContainer::margin
RectSpacingI GuiContainer::padding


Torque 3D - Script Manual: GuiControl Class Reference

GuiControl Class Reference
[Core Controls]

Base class for all Gui control objects. More...

Inheritance diagram for GuiControl:
[legend]

List of all members.

Public Member Functions

void | addGuiControl (GuiControl control)
Add the given control as a child to this control.
void | clearFirstResponder (bool ignored=false)
Clear this control from being the first responder in its hierarchy chain.
bool | controlIsChild (GuiControl control)
Test whether the given control is a direct or indirect child to this control.
GuiControl | findHitControl (int x, int y)
Find the topmost child control located at the given coordinates.
string | findHitControls (int x, int y, int width, int height)
Find all visible child controls that intersect with the given rectangle.
float | getAspect ()
Get the aspect ratio of the control's extents.
Point2I | getCenter ()
Get the coordinate of the control's center point relative to its parent.
Point2I | getExtent ()
Get the width and height of the control.
GuiControl getFirstResponder ()
Get the first responder set on this GuiControl tree.
Point2I | getGlobalCenter ()
Get the coordinate of the control's center point in coordinates relative to the root control in its control hierarchy.
Point2I | getGlobalPosition ()
Get the position of the control relative to the root of the GuiControl hierarchy it is contained in.
Point2I | getMinExtent ()
Get the minimum allowed size of the control.
GuiControl getParent ()
Get the immediate parent control of the control.
Point2I | getPosition ()
Get the control's current position relative to its parent.
GuiCanvas getRoot ()
Get the canvas on which the control is placed.
bool | isAwake ()
Test whether the control is currently awake.
bool | isFirstResponder ()
Test whether the control is the current first responder.
bool | isMouseLocked ()
Indicates if the mouse is locked in this control.
bool | isVisible ()
Test whether the control is currently set to be visible.
void | makeFirstResponder (bool isFirst)
bool | pointInControl (int x, int y)
Test whether the given point lies within the rectangle of the control.
void | resize (int x, int y, int width, int height)
Resize and reposition the control using the give coordinates and dimensions. Child controls will resize according to their layout behaviors.
void | setActive (bool state=true)
void | setCenter (int x, int y)
Set the control's position by its center point.
void | setExtent (S32 width, S32 height)
Resize the control to the given dimensions.
void | setExtent (Point2I p)
Resize the control to the given dimensions.
void | setFirstResponder ()
Make this control the current first responder.
void | setPosition (int x, int y)
Position the control in the local space of the parent control.
void | setPositionGlobal (int x, int y)
Set position of the control relative to the root of the GuiControl hierarchy it is contained in.
void | setProfile (GuiControlProfile profile)
Set the control profile for the control to use.
void | setValue (string value)
Set the value associated with the control.
void | setVisible (bool state=true)
Set whether the control is visible or not.
Callbacks

void | onAction ()
Called when the control's associated action is triggered and no 'command' is defined for the control.
void | onActive (bool state)
Called when the control changes its activeness state, i.e. when going from active to inactive or vice versa.
void | onAdd ()
Called when the control object is registered with the system after the control has been created.
void | onControlDragEnter (GuiControl control, Point2I dropPoint)
Called when a drag&drop operation through GuiDragAndDropControl has entered the control. This is only called for topmost visible controls as the GuiDragAndDropControl moves over them.
void | onControlDragExit (GuiControl control, Point2I dropPoint)
Called when a drag&drop operation through GuiDragAndDropControl has exited the control and moved over a different control. This is only called for topmost visible controls as the GuiDragAndDropControl moves off of them.
void | onControlDragged (GuiControl control, Point2I dropPoint)
Called when a drag&drop operation through GuiDragAndDropControl is moving across the control after it has entered it. This is only called for topmost visible controls as the GuiDragAndDropControl moves across them.
void | onControlDropped (GuiControl control, Point2I dropPoint)
Called when a drag&drop operation through GuiDragAndDropControl has completed and is dropping its payload onto the control. This is only called for topmost visible controls as the GuiDragAndDropControl drops its payload on them.
void | onDialogPop ()
Called when the control is removed as a dialog from the canvas.
void | onDialogPush ()
Called when the control is pushed as a dialog onto the canvas.
void | onGainFirstResponder ()
Called when the control gains first responder status on the GuiCanvas.
void | onLoseFirstResponder ()
Called when the control loses first responder status on the GuiCanvas.
void | onRemove ()
Called when the control object is removed from the system before it is deleted.
void | onSleep ()
Called when the control is put to sleep.
void | onVisible (bool state)
Called when the control changes its visibility state, i.e. when going from visible to invisible or vice versa.
void | onWake ()
Called when the control is woken up.

Public Attributes

string | getValue
bool | isActive
Control

string | accelerator
Key combination that triggers the control's primary action when the control is on the canvas.
bool | active
Whether the control is enabled for user interaction.
string | altCommand
Command to execute on the secondary action of the control.
string | command
Command to execute on the primary action of the control.
deprecated | modal
GuiControlProfile profile
The control profile that determines fill styles, font settings, etc.
deprecated | setFirstResponder
string | variable
Name of the variable to which the value of this control will be synchronized.
bool | visible
Whether the control is visible or hidden.
Layout

Point2I | extent
The width and height of the control.
GuiHorizontalSizing horizSizing
The horizontal resizing behavior.
Point2I | minExtent
The minimum width and height of the control. The control will not be resized smaller than this.
Point2I | position
The position relative to the parent control.
GuiVerticalSizing vertSizing
The vertical resizing behavior.
ToolTip

int | hovertime
Time for mouse to hover over control until tooltip is shown (in milliseconds).
string | tooltip
String to show in tooltip for this control.
GuiControlProfile tooltipProfile
Control profile to use when rendering tooltips for this control.
Editing

bool | isContainer
If true, the control may contain child controls.
Localization

string | langTableMod
Name of string table to use for lookup of internationalized text.

Detailed Description

Base class for all Gui control objects.

GuiControl is the basis for the Gui system. It represents an individual control that can be placed on the canvas and with which the mouse and keyboard can potentially interact with.

Control Hierarchies

GuiControls are arranged in a hierarchy. All children of a control are placed in their parent's coordinate space, i.e. their coordinates are relative to the upper left corner of their immediate parent. When a control is moved, all its child controls are moved along with it.

Since GuiControl's are SimGroups, hierarchy also implies ownership. This means that if a control is destroyed, all its children are destroyed along with it. It also means that a given control can only be part of a single GuiControl hierarchy. When adding a control to another control, it will automatically be reparented from another control it may have previously been parented to.

Layout System

GuiControls have a two-dimensional position and are rectangular in shape.

Event System

Control Profiles

Common data accessed by GuiControls is stored in so-called "Control Profiles." This includes font, color, and texture information. By pooling this data in shared objects, the appearance of any number of controls can be changed quickly and easily by modifying only the shared profile object.

If not explicitly assigned a profile, a control will by default look for a profile object that matches its class name. This means that the class GuiMyCtrl, for example, will look for a profile called 'GuiMyProfile'. If this profile cannot be found, the control will fall back to GuiDefaultProfile which must be defined in any case for the Gui system to work.

In addition to its primary profile, a control may be assigned a second profile called 'tooltipProfile' that will be used to render tooltip popups for the control.

Triggered Actions

First Responders

At any time, a single control can be what is called the "first responder" on the GuiCanvas is is placed on. This control will be the first control to receive keyboard events not bound in the global ActionMap. If the first responder choses to handle a particular keyboard event,

Waking and Sleeping

Visibility and Activeness

By default, a GuiControl is active which means that it

See also:
GuiCanvas
GuiControlProfile

Member Function Documentation

void GuiControl::addGuiControl ( GuiControl control )

Add the given control as a child to this control.

This is synonymous to calling SimGroup::addObject.

Parameters:
control The control to add as a child.
Note:
The control will retain its current position and size.
See also:
SimGroup::addObject Control Hierarchies
void GuiControl::clearFirstResponder ( bool ignored = false )

Clear this control from being the first responder in its hierarchy chain.

Parameters:
ignored Ignored. Supported for backwards-compatibility.
bool GuiControl::controlIsChild ( GuiControl control )

Test whether the given control is a direct or indirect child to this control.

Parameters:
control The potential child control.
Returns:
True if the given control is a direct or indirect child to this control.
GuiControl GuiControl::findHitControl | ( | int | x,
 |  | int | y
 | ) |  |

Find the topmost child control located at the given coordinates.

Note:
Only children that are both visible and have the 'modal' flag set in their profile will be considered in the search.
Parameters:
x | The X coordinate in the control's own coordinate space.
y | The Y coordinate in the control's own coordinate space.
Returns:
The topmost child control at the given coordintes or the control on which the method was called if no matching child could be found.
See also:
GuiControlProfile::modal
findHitControls
string GuiControl::findHitControls | ( | int | x,
 |  | int | y,
 |  | int | width,
 |  | int | height
 | ) |  |

Find all visible child controls that intersect with the given rectangle.

Note:
Invisible child controls will not be included in the search.
Parameters:
x | The X coordinate of the rectangle's upper left corner in the control's own coordinate space.
y | The Y coordinate of the rectangle's upper left corner in the control's own coordinate space.
width | The width of the search rectangle in pixels.
height | The height of the search rectangle in pixels.
Returns:
A space-separated list of the IDs of all visible control objects intersecting the given rectangle.
Example:
// Lock all controls in the rectangle at x=10 and y=10 and the extent width=100 and height=100.
foreach$( %ctrl in %this.findHitControls( 10, 10, 100, 100 ) )
   %ctrl.setLocked( true );
See also:
findHitControl
float GuiControl::getAspect ( )

Get the aspect ratio of the control's extents.

Returns:
The width of the control divided by its height.
See also:
getExtent
Point2I GuiControl::getCenter ( )

Get the coordinate of the control's center point relative to its parent.

Returns:
The coordinate of the control's center point in parent-relative coordinates.
Point2I GuiControl::getExtent ( )

Get the width and height of the control.

Returns:
A point structure containing the width of the control in x and the height in y.

Reimplemented in GuiCanvas.

GuiControl GuiControl::getFirstResponder ( )

Get the first responder set on this GuiControl tree.

Returns:
The first responder set on the control's subtree.
See also:
isFirstResponder
makeFirstResponder
setFirstResponder First Responders
Point2I GuiControl::getGlobalCenter ( )

Get the coordinate of the control's center point in coordinates relative to the root control in its control hierarchy.

the center coordinate of the control in root-relative coordinates.

Point2I GuiControl::getGlobalPosition ( )

Get the position of the control relative to the root of the GuiControl hierarchy it is contained in.

Returns:
The control's current position in root-relative coordinates.
Point2I GuiControl::getMinExtent ( )

Get the minimum allowed size of the control.

Returns:
The minimum size to which the control can be shrunk.
See also:
minExtent
GuiControl GuiControl::getParent ( )

Get the immediate parent control of the control.

Returns:
The immediate parent GuiControl or 0 if the control is not parented to a GuiControl.
Point2I GuiControl::getPosition ( )

Get the control's current position relative to its parent.

Returns:
The coordinate of the control in its parent's coordinate space.
GuiCanvas GuiControl::getRoot ( )

Get the canvas on which the control is placed.

Returns:
The canvas on which the control's hierarchy is currently placed or 0 if the control is not currently placed on a GuiCanvas.
See also:
GuiControl_Hierarchy
bool GuiControl::isAwake ( )

Test whether the control is currently awake.

If a control is awake it means that it is part of the GuiControl hierarchy of a GuiCanvas.

Returns:
True if the control is awake.Waking and Sleeping
bool GuiControl::isFirstResponder ( )

Test whether the control is the current first responder.

Returns:
True if the control is the current first responder.
See also:
makeFirstResponder
setFirstResponder First Responders
bool GuiControl::isMouseLocked ( )

Indicates if the mouse is locked in this control.

Returns:
True if the mouse is currently locked.
bool GuiControl::isVisible ( )

Test whether the control is currently set to be visible.

Returns:
True if the control is currently set to be visible.
Note:
This method does not tell anything about whether the control is actually visible to the user at the moment.

Visibility and Activeness

void GuiControl::makeFirstResponder ( bool isFirst )
void GuiControl::onAction ( )

Called when the control's associated action is triggered and no 'command' is defined for the control.

Triggered Actions

void GuiControl::onActive ( bool state )

Called when the control changes its activeness state, i.e. when going from active to inactive or vice versa.

Parameters:
stat The new activeness state.
See also:
isActive
setActive Visibility and Activeness
void GuiControl::onAdd ( )

Called when the control object is registered with the system after the control has been created.

void GuiControl::onControlDragEnter | ( | GuiControl | control,
 |  | Point2I | dropPoint
 | ) |  |

Called when a drag&drop operation through GuiDragAndDropControl has entered the control. This is only called for topmost visible controls as the GuiDragAndDropControl moves over them.

Parameters:
control | The payload of the drag operation.
dropPoint | The point at which the payload would be dropped if it were released now. Relative to the canvas.
void GuiControl::onControlDragExit | ( | GuiControl | control,
 |  | Point2I | dropPoint
 | ) |  |

Called when a drag&drop operation through GuiDragAndDropControl has exited the control and moved over a different control. This is only called for topmost visible controls as the GuiDragAndDropControl moves off of them.

Parameters:
control | The payload of the drag operation.
dropPoint | The point at which the payload would be dropped if it were released now. Relative to the canvas.
void GuiControl::onControlDragged | ( | GuiControl | control,
 |  | Point2I | dropPoint
 | ) |  |

Called when a drag&drop operation through GuiDragAndDropControl is moving across the control after it has entered it. This is only called for topmost visible controls as the GuiDragAndDropControl moves across them.

Parameters:
control | The payload of the drag operation.
dropPoint | The point at which the payload would be dropped if it were released now. Relative to the canvas.
void GuiControl::onControlDropped | ( | GuiControl | control,
 |  | Point2I | dropPoint
 | ) |  |

Called when a drag&drop operation through GuiDragAndDropControl has completed and is dropping its payload onto the control. This is only called for topmost visible controls as the GuiDragAndDropControl drops its payload on them.

Parameters:
control | The control that is being dropped onto this control.
dropPoint | The point at which the control is being dropped. Relative to the canvas.
void GuiControl::onDialogPop ( )

Called when the control is removed as a dialog from the canvas.

See also:
GuiCanvas::popDialog
void GuiControl::onDialogPush ( )

Called when the control is pushed as a dialog onto the canvas.

See also:
GuiCanvas::pushDialog
void GuiControl::onGainFirstResponder ( )

Called when the control gains first responder status on the GuiCanvas.

See also:
setFirstResponder
makeFirstResponder
isFirstResponder First Responders
void GuiControl::onLoseFirstResponder ( )

Called when the control loses first responder status on the GuiCanvas.

See also:
setFirstResponder
makeFirstResponder
isFirstResponder First Responders
void GuiControl::onRemove ( )

Called when the control object is removed from the system before it is deleted.

void GuiControl::onSleep ( )

Called when the control is put to sleep.

Waking and Sleeping

void GuiControl::onVisible ( bool state )

Called when the control changes its visibility state, i.e. when going from visible to invisible or vice versa.

Parameters:
state The new visibility state.
See also:
isVisible
setVisible Visibility and Activeness
void GuiControl::onWake ( )

Called when the control is woken up.

Waking and Sleeping

bool GuiControl::pointInControl | ( | int | x,
 |  | int | y
 | ) |  |

Test whether the given point lies within the rectangle of the control.

Parameters:
x | X coordinate of the point in parent-relative coordinates.
y | Y coordinate of the point in parent-relative coordinates.
Returns:
True if the point is within the control, false if not.
See also:
getExtent
getPosition
void GuiControl::resize | ( | int | x,
 |  | int | y,
 |  | int | width,
 |  | int | height
 | ) |  |

Resize and reposition the control using the give coordinates and dimensions. Child controls will resize according to their layout behaviors.

Parameters:
x | The new X coordinate of the control in its parent's coordinate space.
y | The new Y coordinate of the control in its parent's coordinate space.
width | The new width to which the control should be resized.
height | The new height to which the control should be resized.
void GuiControl::setActive ( bool state = true )
void GuiControl::setCenter | ( | int | x,
 |  | int | y
 | ) |  |

Set the control's position by its center point.

Parameters:
x | The X coordinate of the new center point of the control relative to the control's parent.
y | The Y coordinate of the new center point of the control relative to the control's parent.
void GuiControl::setExtent | ( | S32 | width,
 |  | S32 | height
 | ) |  |

Resize the control to the given dimensions.

Child controls will resize according to their layout settings.

Parameters:
width | The new width of the control in pixels.
height | The new height of the control in pixels.
void GuiControl::setExtent ( Point2I p )

Resize the control to the given dimensions.

Child controls with resize according to their layout settings.

Parameters:
p The new ( width, height ) extents of the control.
void GuiControl::setFirstResponder ( )

Make this control the current first responder.

Note:
Only controls with a profile that has canKeyFocus enabled are able to become first responders.
See also:
GuiControlProfile::canKeyFocus
isFirstResponder First Responders
void GuiControl::setPosition | ( | int | x,
 |  | int | y
 | ) |  |

Position the control in the local space of the parent control.

Parameters:
x | The new X coordinate of the control relative to its parent's upper left corner.
y | The new Y coordinate of the control relative to its parent's upper left corner.
void GuiControl::setPositionGlobal | ( | int | x,
 |  | int | y
 | ) |  |

Set position of the control relative to the root of the GuiControl hierarchy it is contained in.

Parameters:
x | The new X coordinate of the control relative to the root's upper left corner.
y | The new Y coordinate of the control relative to the root's upper left corner.
void GuiControl::setProfile ( GuiControlProfile profile )

Set the control profile for the control to use.

The profile used by a control determines a great part of its behavior and appearance.

Parameters:
profile The new profile the control should use. Control Profiles
void GuiControl::setValue ( string value )

Set the value associated with the control.

Parameters:
value The new value for the control.
void GuiControl::setVisible ( bool state = true )

Set whether the control is visible or not.

Parameters:
state The new visiblity flag state for the control. Visibility and Activeness

Member Data Documentation

string GuiControl::accelerator

Key combination that triggers the control's primary action when the control is on the canvas.

bool GuiControl::active

Whether the control is enabled for user interaction.

string GuiControl::altCommand

Command to execute on the secondary action of the control.

Note:
Within this script snippet, the control on which the altCommand is being executed is bound to the global variable $ThisControl.
string GuiControl::command

Command to execute on the primary action of the control.

Note:
Within this script snippet, the control on which the command is being executed is bound to the global variable $ThisControl.
Point2I GuiControl::extent

The width and height of the control.

string GuiControl::getValue
GuiHorizontalSizing GuiControl::horizSizing

The horizontal resizing behavior.

int GuiControl::hovertime

Time for mouse to hover over control until tooltip is shown (in milliseconds).

bool GuiControl::isActive
bool GuiControl::isContainer

If true, the control may contain child controls.

string GuiControl::langTableMod

Name of string table to use for lookup of internationalized text.

Point2I GuiControl::minExtent

The minimum width and height of the control. The control will not be resized smaller than this.

deprecated GuiControl::modal
Point2I GuiControl::position

The position relative to the parent control.

GuiControlProfile GuiControl::profile

The control profile that determines fill styles, font settings, etc.

deprecated GuiControl::setFirstResponder
string GuiControl::tooltip

String to show in tooltip for this control.

GuiControlProfile GuiControl::tooltipProfile

Control profile to use when rendering tooltips for this control.

string GuiControl::variable

Name of the variable to which the value of this control will be synchronized.

GuiVerticalSizing GuiControl::vertSizing

The vertical resizing behavior.

bool GuiControl::visible

Whether the control is visible or hidden.


Torque 3D - Script Manual: GuiControlArrayControl Class Reference

GuiControlArrayControl Class Reference
[Container Controls]

Brief Desc. More...

Inheritance diagram for GuiControlArrayControl:
[legend]

List of all members.

Public Attributes

Array

int | colCount
Number of colums in the array.
intList | colSizes
Size of each individual column.
int | colSpacing
Padding to put between columns.
int | rowSize
Heigth of a row in the array.
int | rowSpacing
Padding to put between rows.

Detailed Description

Brief Desc.

Example:
// Comment:
%okButton = new ClassObject()
instantiation

Member Data Documentation

int GuiControlArrayControl::colCount

Number of colums in the array.

intList GuiControlArrayControl::colSizes

Size of each individual column.

int GuiControlArrayControl::colSpacing

Padding to put between columns.

int GuiControlArrayControl::rowSize

Heigth of a row in the array.

int GuiControlArrayControl::rowSpacing

Padding to put between rows.


Torque 3D - Script Manual: GuiControlProfile Class Reference

GuiControlProfile Class Reference
[Core Controls]

A collection of properties that determine control behavior and rendering. More...

Inheritance diagram for GuiControlProfile:
[legend]

List of all members.

Public Member Functions

int | getStringWidth (pString)

Public Attributes

string | category
Category under which the profile will appear in the editor.
Text

bool | autoSizeHeight
Automatically adjust height of control to fit contents.
bool | autoSizeWidth
Automatically adjust width of control to fit contents.
ColorI | cursorColor
Color to use for the text cursor.
GuiFontCharset fontCharset
Font character set.
ColorI | fontColor
Font color for normal text (same as fontColors[0]).
ColorI | fontColorHL
Font color for highlighted text (same as fontColors[1]).
ColorI | fontColorLink
Font color for links in text (same as fontColors[4]).
ColorI | fontColorLinkHL
Font color for highlighted links in text (same as fontColors[5]).
ColorI | fontColorNA
Font color when control is not active/disabled (same as fontColors[2]).
ColorI | fontColors [10]
Font colors to use for different text types/states.
ColorI | fontColorSEL
Font color for selected text (same as fontColors[3]).
int | fontSize
Font size in points.
string | fontType
Name of font family and typeface (e.g. "Arial Bold").
GuiAlignmentType justify
Horizontal alignment for text.
bool | numbersOnly
Whether control should only accept numerical data (GuiTextEditCtrl).
bool | returnTab
Whether to add automatic tab event when return is pressed so focus moves on to next control (GuiTextEditCtrl).
Point2I | textOffset
Text offset for the control.
Appearance

ColorI | bevelColorHL
Used for the high-light part of the bevel.
ColorI | bevelColorLL
Used for the low-light part of the bevel.
int | border
For most controls, if border is > 0 a border will be drawn. Some controls use this to draw different types of borders however.
ColorI | borderColor
Color to draw border with.
ColorI | borderColorHL
Used instead of borderColor when the object is highlighted.
ColorI | borderColorNA
Used instead of borderColor when the object is not active or disabled.
int | borderThickness
Thickness of border in pixels.
ColorI | fillColor
This is used to fill the bounds of the control with a TypeColorI if it is opaque.
ColorI | fillColorHL
This is used instead of fillColor if the object is highlighted.
ColorI | fillColorNA
This is used instead of fillColor if the object is not active or disabled.
ColorI | fillColorSEL
This is used instead of fillColor if the object is selected.
bool | opaque
True if this object is not translucent, and should draw a fill.
Misc

filename | bitmap
Texture to use for rendering control.
bool | hasBitmapArray
If true, 'bitmap' is an array of images.
string | profileForChildren
The name of the profile to use for the children controls.
SFXTrack soundButtonDown
Sound to play when mouse has been pressed on control.
SFXTrack soundButtonOver
Sound to play when mouse is hovering over control.
Behavior

bool | canKeyFocus
Whether the control can have the keyboard focus.
bool | modal
True if this is a Modeless dialog meaning it will pass input through instead of taking it all.
bool | mouseOverSelected
True if this object should be "selected" while the mouse is over it.
bool | tab
True if this object is accessable from using the tab key.

Detailed Description

A collection of properties that determine control behavior and rendering.

Member Function Documentation

int GuiControlProfile::getStringWidth ( pString )

Member Data Documentation

bool GuiControlProfile::autoSizeHeight

Automatically adjust height of control to fit contents.

bool GuiControlProfile::autoSizeWidth

Automatically adjust width of control to fit contents.

ColorI GuiControlProfile::bevelColorHL

Used for the high-light part of the bevel.

ColorI GuiControlProfile::bevelColorLL

Used for the low-light part of the bevel.

filename GuiControlProfile::bitmap

Texture to use for rendering control.

int GuiControlProfile::border

For most controls, if border is > 0 a border will be drawn. Some controls use this to draw different types of borders however.

ColorI GuiControlProfile::borderColor

Color to draw border with.

ColorI GuiControlProfile::borderColorHL

Used instead of borderColor when the object is highlighted.

ColorI GuiControlProfile::borderColorNA

Used instead of borderColor when the object is not active or disabled.

int GuiControlProfile::borderThickness

Thickness of border in pixels.

bool GuiControlProfile::canKeyFocus

Whether the control can have the keyboard focus.

string GuiControlProfile::category

Category under which the profile will appear in the editor.

ColorI GuiControlProfile::cursorColor

Color to use for the text cursor.

ColorI GuiControlProfile::fillColor

This is used to fill the bounds of the control with a TypeColorI if it is opaque.

ColorI GuiControlProfile::fillColorHL

This is used instead of fillColor if the object is highlighted.

ColorI GuiControlProfile::fillColorNA

This is used instead of fillColor if the object is not active or disabled.

ColorI GuiControlProfile::fillColorSEL

This is used instead of fillColor if the object is selected.

GuiFontCharset GuiControlProfile::fontCharset

Font character set.

ColorI GuiControlProfile::fontColor

Font color for normal text (same as fontColors[0]).

ColorI GuiControlProfile::fontColorHL

Font color for highlighted text (same as fontColors[1]).

ColorI GuiControlProfile::fontColorLink

Font color for links in text (same as fontColors[4]).

ColorI GuiControlProfile::fontColorLinkHL

Font color for highlighted links in text (same as fontColors[5]).

ColorI GuiControlProfile::fontColorNA

Font color when control is not active/disabled (same as fontColors[2]).

ColorI GuiControlProfile::fontColors[10]

Font colors to use for different text types/states.

ColorI GuiControlProfile::fontColorSEL

Font color for selected text (same as fontColors[3]).

int GuiControlProfile::fontSize

Font size in points.

string GuiControlProfile::fontType

Name of font family and typeface (e.g. "Arial Bold").

bool GuiControlProfile::hasBitmapArray

If true, 'bitmap' is an array of images.

GuiAlignmentType GuiControlProfile::justify

Horizontal alignment for text.

bool GuiControlProfile::modal

True if this is a Modeless dialog meaning it will pass input through instead of taking it all.

bool GuiControlProfile::mouseOverSelected

True if this object should be "selected" while the mouse is over it.

bool GuiControlProfile::numbersOnly

Whether control should only accept numerical data (GuiTextEditCtrl).

bool GuiControlProfile::opaque

True if this object is not translucent, and should draw a fill.

string GuiControlProfile::profileForChildren

The name of the profile to use for the children controls.

bool GuiControlProfile::returnTab

Whether to add automatic tab event when return is pressed so focus moves on to next control (GuiTextEditCtrl).

SFXTrack GuiControlProfile::soundButtonDown

Sound to play when mouse has been pressed on control.

SFXTrack GuiControlProfile::soundButtonOver

Sound to play when mouse is hovering over control.

bool GuiControlProfile::tab

True if this object is accessable from using the tab key.

Point2I GuiControlProfile::textOffset

Text offset for the control.


Torque 3D - Script Manual: GuiCrossHairHud Class Reference

GuiCrossHairHud Class Reference
[Game Controls]

Basic cross hair hud. Reacts to state of control object. Also displays health bar for named objects under the cross hair. More...

Inheritance diagram for GuiCrossHairHud:
[legend]

List of all members.

Public Attributes

Damage

ColorF | damageFillColor
As the health bar depletes, this color will represent the health loss amount.
ColorF | damageFrameColor
Color for the health bar's frame.
Point2I | damageOffset
Offset for drawing the damage portion of the health control.
Point2I | damageRect
Size for the health bar portion of the control.

Detailed Description

Basic cross hair hud. Reacts to state of control object. Also displays health bar for named objects under the cross hair.

Uses the base bitmap control to render a bitmap, and decides whether to draw or not depending on the current control object and it's state. If there is ShapeBase object under the cross hair and it's named, then a small health bar is displayed.

Example:
 new GuiCrossHairHud(){
   damageFillColor = "1.0 0.0 0.0 1.0"; // Fills with a solid red color
   damageFrameColor = "1.0 1.0 1.0 1.0"; // Solid white frame color
   damageRect = "15 5";
   damageOffset = "0 -10";
};

Member Data Documentation

ColorF GuiCrossHairHud::damageFillColor

As the health bar depletes, this color will represent the health loss amount.

ColorF GuiCrossHairHud::damageFrameColor

Color for the health bar's frame.

Point2I GuiCrossHairHud::damageOffset

Offset for drawing the damage portion of the health control.

Point2I GuiCrossHairHud::damageRect

Size for the health bar portion of the control.


Torque 3D - Script Manual: GuiCursor Class Reference

GuiCursor Class Reference
[Core Controls]

Acts as a skin for the cursor, where each GuiCursor object can have its own look and click-zone. More...

Inheritance diagram for GuiCursor:
[legend]

List of all members.

Public Attributes

filename | bitmapName
File name of the bitmap for the cursor.
Point2I | hotSpot
The location of the cursor's hot spot (which pixel carries the click).
Point2F | renderOffset
Offset of the bitmap, where 0 signifies left edge of the bitmap, 1, the right. Similarly for the Y-component.

Detailed Description

Acts as a skin for the cursor, where each GuiCursor object can have its own look and click-zone.

GuiCursors act as skins for the cursor in the game, where each individual GuiCursor can have its own defined imagemap, click zone and render offset. This allows a game to easily support a wide range of cursors. The active cursor can de changed for each Canvas using canvasObj.setCursor(GuiCursor);.

Example:
new GuiCursor(DefaultCursor)
{
   hotSpot = "1 1";
   renderOffset = "0 0";
   bitmapName = "~/art/gui/images/defaultCursor";
};
See also:
GuiCanvas

Member Data Documentation

filename GuiCursor::bitmapName

File name of the bitmap for the cursor.

Point2I GuiCursor::hotSpot

The location of the cursor's hot spot (which pixel carries the click).

Point2F GuiCursor::renderOffset

Offset of the bitmap, where 0 signifies left edge of the bitmap, 1, the right. Similarly for the Y-component.


Torque 3D - Script Manual: GuiDirectoryFileListCtrl Class Reference

GuiDirectoryFileListCtrl Class Reference
[General Controls]

A control that displays a list of files from within a single directory in the game file system. More...

Inheritance diagram for GuiDirectoryFileListCtrl:
[legend]

List of all members.

Public Member Functions

string | getSelectedFile ()
Get the currently selected filename.
string | getSelectedFiles ()
Get the list of selected files.
void | reload ()
Update the file list.
void | setFilter (string filter)
Set the file filter.
bool | setPath (string path, string filter)
Set the search path and file filter.

Public Attributes

string | fileFilter
Tab-delimited list of file name patterns. Only matched files will be displayed.
string | filePath
Path in game directory from which to list files.

Detailed Description

A control that displays a list of files from within a single directory in the game file system.

Example:
new GuiDirectoryFileListCtrl()
{
   filePath = "art/shapes";
   fileFilter = "*.dts" TAB "*.dae";
   //Properties not specific to this control have been omitted from this example.
};

Member Function Documentation

string GuiDirectoryFileListCtrl::getSelectedFile ( )

Get the currently selected filename.

Returns:
The filename of the currently selected file
string GuiDirectoryFileListCtrl::getSelectedFiles ( )

Get the list of selected files.

Returns:
A space separated list of selected files
void GuiDirectoryFileListCtrl::reload ( )

Update the file list.

void GuiDirectoryFileListCtrl::setFilter ( string filter )

Set the file filter.

Parameters:
filter Tab-delimited list of file name patterns. Only matched files will be displayed.
bool GuiDirectoryFileListCtrl::setPath | ( | string | path,
 |  | string | filter
 | ) |  |

Set the search path and file filter.

Parameters:
path | Path in game directory from which to list files.
filter | Tab-delimited list of file name patterns. Only matched files will be displayed.

Member Data Documentation

string GuiDirectoryFileListCtrl::fileFilter

Tab-delimited list of file name patterns. Only matched files will be displayed.

string GuiDirectoryFileListCtrl::filePath

Path in game directory from which to list files.


Torque 3D - Script Manual: GuiDragAndDropControl Class Reference

GuiDragAndDropControl Class Reference
[Utility Controls]

A container control that can be used to implement drag&drop behavior. More...

Inheritance diagram for GuiDragAndDropControl:
[legend]

List of all members.

Public Member Functions

void | startDragging (int x=0, int y=0)
Start the drag operation.

Public Attributes

bool | deleteOnMouseUp
If true, the control deletes itself when the left mouse button is released.

Detailed Description

A container control that can be used to implement drag&drop behavior.

GuiDragAndDropControl is a special control that can be used to allow drag&drop behavior to be implemented where GuiControls may be dragged across the canvas and the dropped on other GuiControls.

To start a drag operation, construct a GuiDragAndDropControl and add the control that should be drag&dropped as a child to it. Note that this must be a single child control. To drag multiple controls, wrap them in a new GuiControl object as a temporary container.

Then, to initiate the drag, add the GuiDragAndDropControl to the canvas and call startDragging(). You can optionally supply an offset to better position the GuiDragAndDropControl on the mouse cursor.

As the GuiDragAndDropControl is then moved across the canvas, it will call the onControlDragEnter(), onControlDragExit(), onControlDragged(), and finally onControlDropped() callbacks on the visible topmost controls that it moves across. onControlDropped() is called when the mouse button is released and the drag operation thus finished.

Example:
// The following example implements drag&drop behavior for GuiSwatchButtonCtrl so that
// one color swatch may be dragged over the other to quickly copy its color.
//
// This code is taken from the stock scripts.

//---------------------------------------------------------------------------------------------

// With this method, we start the operation when the mouse is click-dragged away from a color swatch.
function GuiSwatchButtonCtrl::onMouseDragged( %this )
{
   // First we construct a new temporary swatch button that becomes the payload for our
   // drag operation and give it the properties of the swatch button we want to copy.

   %payload = new GuiSwatchButtonCtrl();
   %payload.assignFieldsFrom( %this );
   %payload.position = "0 0";
   %payload.dragSourceControl = %this; // Remember where the drag originated from so that we don't copy a color swatch onto itself.

   // Calculate the offset of the GuiDragAndDropControl from the mouse cursor.  Here we center
   // it on the cursor.

   %xOffset = getWord( %payload.extent, 0 ) / 2;
   %yOffset = getWord( %payload.extent, 1 ) / 2;

   // Compute the initial position of the GuiDragAndDrop control on the cavas based on the current
   // mouse cursor position.

   %cursorpos = Canvas.getCursorPos();
   %xPos = getWord( %cursorpos, 0 ) - %xOffset;
   %yPos = getWord( %cursorpos, 1 ) - %yOffset;

   // Create the drag control.

   %ctrl = new GuiDragAndDropControl()
   {
      canSaveDynamicFields    = "0";
      Profile                 = "GuiSolidDefaultProfile";
      HorizSizing             = "right";
      VertSizing              = "bottom";
      Position                = %xPos SPC %yPos;
      extent                  = %payload.extent;
      MinExtent               = "4 4";
      canSave                 = "1";
      Visible                 = "1";
      hovertime               = "1000";

      // Let the GuiDragAndDropControl delete itself on mouse-up.  When the drag is aborted,
      // this not only deletes the drag control but also our payload.
      deleteOnMouseUp         = true;

      // To differentiate drags, use the namespace hierarchy to classify them.
      // This will allow a color swatch drag to tell itself apart from a file drag, for example.
      class                   = "GuiDragAndDropControlType_ColorSwatch";
   };

   // Add the temporary color swatch to the drag control as the payload.
   %ctrl.add( %payload );

   // Start drag by adding the drag control to the canvas and then calling startDragging().

   Canvas.getContent().add( %ctrl );
   %ctrl.startDragging( %xOffset, %yOffset );
}

//---------------------------------------------------------------------------------------------

// This method receives the drop when the mouse button is released over a color swatch control
// during a drag operation.
function GuiSwatchButtonCtrl::onControlDropped( %this, %payload, %position )
{
   // Make sure this is a color swatch drag operation.
   if( !%payload.parentGroup.isInNamespaceHierarchy( "GuiDragAndDropControlType_ColorSwatch" ) )
      return;

   // If dropped on same button whence we came from,
   // do nothing.

   if( %payload.dragSourceControl == %this )
      return;

   // If a swatch button control is dropped onto this control,
   // copy it's color.

   if( %payload.isMemberOfClass( "GuiSwatchButtonCtrl" ) )
   {
      // If the swatch button is part of a color-type inspector field,
      // remember the inspector field so we can later set the color
      // through it.

      if( %this.parentGroup.isMemberOfClass( "GuiInspectorTypeColorI" ) )
         %this.parentGroup.apply( ColorFloatToInt( %payload.color ) );
      else if( %this.parentGroup.isMemberOfClass( "GuiInspectorTypeColorF" ) )
         %this.parentGroup.apply( %payload.color );
      else
         %this.setColor( %payload.color );
   }
}
See also:
GuiControl::onControlDragEnter
GuiControl::onControlDragExit
GuiControl::onControlDragged
GuiControl::onControlDropped

Member Function Documentation

void GuiDragAndDropControl::startDragging | ( | int | x = 0,
 |  | int | y = 0
 | ) |  |

Start the drag operation.

Parameters:
x | X coordinate for the mouse pointer offset which the drag control should position itself.
y | Y coordinate for the mouse pointer offset which the drag control should position itself.

Member Data Documentation

bool GuiDragAndDropControl::deleteOnMouseUp

If true, the control deletes itself when the left mouse button is released.

If at this point, the drag&drop control still contains its payload, it will be deleted along with the control.


Torque 3D - Script Manual: GuiDynamicCtrlArrayControl Class Reference

GuiDynamicCtrlArrayControl Class Reference
[Container Controls]

A container that arranges children into a grid. More...

Inheritance diagram for GuiDynamicCtrlArrayControl:
[legend]

List of all members.

Public Member Functions

void | refresh ()
Recalculates the position and size of this control and all its children.

Public Attributes

bool | autoCellSize
When true, the cell size is set to the widest/tallest child control.
int | colCount
Number of columns the child controls have been arranged into. This value is calculated automatically when children are added, removed or resized; writing it directly has no effect.
int | colSize
Width of each column. If autoCellSize is set, this will be calculated automatically from the widest child control.
int | colSpacing
Spacing between columns.
bool | dynamicSize
If true, the width or height of this control will be automatically calculated based on the number of child controls (width if fillRowFirst is false, height if fillRowFirst is true).
bool | fillRowFirst
Controls whether rows or columns are filled first.
bool | frozen
When true, the array will not update when new children are added or in response to child resize events. This is useful to prevent unnecessary resizing when adding, removing or resizing a number of child controls.
RectSpacingI | padding
Padding around the top, bottom, left, and right of this control. This reduces the area available for child controls.
int | rowCount
Number of rows the child controls have been arranged into. This value is calculated automatically when children are added, removed or resized; writing it directly has no effect.
int | rowSize
Height of each row. If autoCellSize is set, this will be calculated automatically from the tallest child control.
int | rowSpacing
Spacing between rows.

Detailed Description

A container that arranges children into a grid.

This container maintains a 2D grid of GUI controls. If one is added, deleted, or resized, then the grid is updated. The insertion order into the grid is determined by the internal order of the children (ie. the order of addition).
Children are added to the grid by row or column until they fill the assocated GuiDynamicCtrlArrayControl extent (width or height). For example, a GuiDynamicCtrlArrayControl with 15 children, and fillRowFirst set to true may be arranged as follows:

1  2  3  4  5  6
7  8  9  10 11 12
13 14 15

If dynamicSize were set to true in this case, the GuiDynamicCtrlArrayControl height would be calculated to fit the 3 rows of child controls.

Example:
new GuiDynamicCtrlArrayControl()
{
   colSize = "128";
   rowSize = "18";
   colSpacing = "2";
   rowSpacing = "2";
   frozen = "0";
   autoCellSize = "1";
   fillRowFirst = "1";
   dynamicSize = "1";
   padding = "0 0 0 0";
   //Properties not specific to this control have been omitted from this example.
};

Member Function Documentation

void GuiDynamicCtrlArrayControl::refresh ( )

Recalculates the position and size of this control and all its children.

Member Data Documentation

bool GuiDynamicCtrlArrayControl::autoCellSize

When true, the cell size is set to the widest/tallest child control.

int GuiDynamicCtrlArrayControl::colCount

Number of columns the child controls have been arranged into. This value is calculated automatically when children are added, removed or resized; writing it directly has no effect.

int GuiDynamicCtrlArrayControl::colSize

Width of each column. If autoCellSize is set, this will be calculated automatically from the widest child control.

int GuiDynamicCtrlArrayControl::colSpacing

Spacing between columns.

bool GuiDynamicCtrlArrayControl::dynamicSize

If true, the width or height of this control will be automatically calculated based on the number of child controls (width if fillRowFirst is false, height if fillRowFirst is true).

bool GuiDynamicCtrlArrayControl::fillRowFirst

Controls whether rows or columns are filled first.

If true, controls are added to the grid left-to-right (to fill a row); then rows are added top-to-bottom as shown below:

1 2 3 4
5 6 7 8

If false, controls are added to the grid top-to-bottom (to fill a column); then columns are added left-to-right as shown below:

1 3 5 7
2 4 6 8
bool GuiDynamicCtrlArrayControl::frozen

When true, the array will not update when new children are added or in response to child resize events. This is useful to prevent unnecessary resizing when adding, removing or resizing a number of child controls.

RectSpacingI GuiDynamicCtrlArrayControl::padding

Padding around the top, bottom, left, and right of this control. This reduces the area available for child controls.

int GuiDynamicCtrlArrayControl::rowCount

Number of rows the child controls have been arranged into. This value is calculated automatically when children are added, removed or resized; writing it directly has no effect.

int GuiDynamicCtrlArrayControl::rowSize

Height of each row. If autoCellSize is set, this will be calculated automatically from the tallest child control.

int GuiDynamicCtrlArrayControl::rowSpacing

Spacing between rows.


Torque 3D - Script Manual: GuiFadeinBitmapCtrl Class Reference

GuiFadeinBitmapCtrl Class Reference
[Core Controls]

A GUI control which renders a black square over a bitmap image. The black square will fade out, then fade back in after a determined time. This control is especially useful for transitions and splash screens. More...

Inheritance diagram for GuiFadeinBitmapCtrl:
[legend]

List of all members.

Public Member Functions

Callbacks

void | click ()
Informs the script level that this object received a Click event from the cursor or keyboard.
void | onDone ()
Informs the script level that this object has completed is fade cycle.

Public Attributes

Fading

bool | done
Whether the fade cycle has finished running.
ColorF | fadeColor
Color to fade in from and fade out to.
EaseF | fadeInEase
Easing curve for fade-in.
int | fadeInTime
Milliseconds for the bitmap to fade in.
EaseF | fadeOutEase
Easing curve for fade-out.
int | fadeOutTime
Milliseconds for the bitmap to fade out.
int | waitTime
Milliseconds to wait after fading in before fading out the bitmap.

Detailed Description

A GUI control which renders a black square over a bitmap image. The black square will fade out, then fade back in after a determined time. This control is especially useful for transitions and splash screens.

Example:
new GuiFadeinBitmapCtrl()
   {
      fadeinTime = "1000";
      waitTime = "2000";
      fadeoutTime = "1000";
      done = "1";
      // Additional GUI properties that are not specific to GuiFadeinBitmapCtrl have been omitted from this example.
   };
See also:
GuiBitmapCtrl

Member Function Documentation

void GuiFadeinBitmapCtrl::click ( )

Informs the script level that this object received a Click event from the cursor or keyboard.

Example:
GuiFadeInBitmapCtrl::click(%this)
   {
      // Code to run when click occurs
   }
See also:
Core Controls
void GuiFadeinBitmapCtrl::onDone ( )

Informs the script level that this object has completed is fade cycle.

Example:
GuiFadeInBitmapCtrl::onDone(%this)
   {
      // Code to run when the fade cycle completes
   }
See also:
Core Controls

Member Data Documentation

bool GuiFadeinBitmapCtrl::done

Whether the fade cycle has finished running.

ColorF GuiFadeinBitmapCtrl::fadeColor

Color to fade in from and fade out to.

EaseF GuiFadeinBitmapCtrl::fadeInEase

Easing curve for fade-in.

int GuiFadeinBitmapCtrl::fadeInTime

Milliseconds for the bitmap to fade in.

EaseF GuiFadeinBitmapCtrl::fadeOutEase

Easing curve for fade-out.

int GuiFadeinBitmapCtrl::fadeOutTime

Milliseconds for the bitmap to fade out.

int GuiFadeinBitmapCtrl::waitTime

Milliseconds to wait after fading in before fading out the bitmap.


Torque 3D - Script Manual: GuiFrameSetCtrl Class Reference

GuiFrameSetCtrl Class Reference
[Container Controls]

A gui control allowing a window to be subdivided into panes, each of which displays a gui control child of the GuiFrameSetCtrl. More...

Inheritance diagram for GuiFrameSetCtrl:
[legend]

List of all members.

Public Member Functions

void | addColumn ()
Add a new column.
void | addRow ()
Add a new row.
void | frameBorder (int index, string state="dynamic")
Override the borderEnable setting for this frame.
void | frameMinExtent (int index, int width, int height)
Set the minimum width and height for the frame. It will not be possible for the user to resize the frame smaller than this.
void | frameMovable (int index, string state="dynamic")
Override the borderMovable setting for this frame.
void | framePadding (int index, RectSpacingI padding)
Set the padding for this frame. Padding introduces blank space on the inside edge of the frame.
int | getColumnCount ()
Get the number of columns.
int | getColumnOffset (int index)
Get the horizontal offset of a column.
RectSpacingI | getFramePadding (int index)
Get the padding for this frame.
int | getRowCount ()
Get the number of rows.
int | getRowOffset (int index)
Get the vertical offset of a row.
void | removeColumn ()
Remove the last (rightmost) column.
void | removeRow ()
Remove the last (bottom) row.
void | setColumnOffset (int index, int offset)
Set the horizontal offset of a column.
void | setRowOffset (int index, int offset)
Set the vertical offset of a row.
void | updateSizes ()
Recalculates child control sizes.

Public Attributes

bool | autoBalance
If true, row and column offsets are automatically scaled to match the new extents when the control is resized.
ColorI | borderColor
Color of interior borders between cells.
GuiFrameState borderEnable
Controls whether frame borders are enabled.
GuiFrameState borderMovable
Controls whether borders can be dynamically repositioned with the mouse by the user.
int | borderWidth
Width of interior borders between cells in pixels.
intList | columns
A vector of column offsets (determines the width of each column).
int | fudgeFactor
Offset for row and column dividers in pixels.
intList | rows
A vector of row offsets (determines the height of each row).

Detailed Description

A gui control allowing a window to be subdivided into panes, each of which displays a gui control child of the GuiFrameSetCtrl.

Each gui control child will have an associated FrameDetail through which frame-specific details can be assigned. Frame-specific values override the values specified for the entire frameset.

Note that it is possible to have more children than frames, or more frames than children. In the former case, the extra children will not be visible (they are moved beyond the visible extent of the frameset). In the latter case, frames will be empty. For example, if a frameset had two columns and two rows but only three gui control children they would be assigned to frames as follows:

                 1 | 2
                 -----
                 3 |

The last frame would be blank.

Example:
new GuiFrameSetCtrl()
{
   columns = "3";
   rows = "2";
   borderWidth = "1";
   borderColor = "128 128 128";
   borderEnable = "dynamic";
   borderMovable = "dynamic";
   autoBalance = "1";
   fudgeFactor = "0";
   //Properties not specific to this control have been omitted from this example.
};

Member Function Documentation

void GuiFrameSetCtrl::addColumn ( )

Add a new column.

void GuiFrameSetCtrl::addRow ( )

Add a new row.

void GuiFrameSetCtrl::frameBorder | ( | int | index,
 |  | string | state = "dynamic"
 | ) |  |

Override the borderEnable setting for this frame.

Parameters:
index | Index of the frame to modify
state | New borderEnable state: "on", "off" or "dynamic"
void GuiFrameSetCtrl::frameMinExtent | ( | int | index,
 |  | int | width,
 |  | int | height
 | ) |  |

Set the minimum width and height for the frame. It will not be possible for the user to resize the frame smaller than this.

Parameters:
index | Index of the frame to modify
width | Minimum width in pixels
height | Minimum height in pixels
void GuiFrameSetCtrl::frameMovable | ( | int | index,
 |  | string | state = "dynamic"
 | ) |  |

Override the borderMovable setting for this frame.

Parameters:
index | Index of the frame to modify
state | New borderEnable state: "on", "off" or "dynamic"
void GuiFrameSetCtrl::framePadding | ( | int | index,
 |  | RectSpacingI | padding
 | ) |  |

Set the padding for this frame. Padding introduces blank space on the inside edge of the frame.

Parameters:
index | Index of the frame to modify
padding | Frame top, bottom, left, and right padding
int GuiFrameSetCtrl::getColumnCount ( )

Get the number of columns.

Returns:
The number of columns
int GuiFrameSetCtrl::getColumnOffset ( int index )

Get the horizontal offset of a column.

Parameters:
index Index of the column to query
Returns:
Column offset in pixels
RectSpacingI GuiFrameSetCtrl::getFramePadding ( int index )

Get the padding for this frame.

Parameters:
index Index of the frame to query
int GuiFrameSetCtrl::getRowCount ( )

Get the number of rows.

Returns:
The number of rows
int GuiFrameSetCtrl::getRowOffset ( int index )

Get the vertical offset of a row.

Parameters:
index Index of the row to query
Returns:
Row offset in pixels
void GuiFrameSetCtrl::removeColumn ( )

Remove the last (rightmost) column.

void GuiFrameSetCtrl::removeRow ( )

Remove the last (bottom) row.

void GuiFrameSetCtrl::setColumnOffset | ( | int | index,
 |  | int | offset
 | ) |  |

Set the horizontal offset of a column.

Note that column offsets must always be in increasing order, and therefore this offset must be between the offsets of the colunns either side.

Parameters:
index | Index of the column to modify
offset | New column offset
void GuiFrameSetCtrl::setRowOffset | ( | int | index,
 |  | int | offset
 | ) |  |

Set the vertical offset of a row.

Note that row offsets must always be in increasing order, and therefore this offset must be between the offsets of the rows either side.

Parameters:
index | Index of the row to modify
offset | New row offset
void GuiFrameSetCtrl::updateSizes ( )

Recalculates child control sizes.

Member Data Documentation

bool GuiFrameSetCtrl::autoBalance

If true, row and column offsets are automatically scaled to match the new extents when the control is resized.

ColorI GuiFrameSetCtrl::borderColor

Color of interior borders between cells.

GuiFrameState GuiFrameSetCtrl::borderEnable

Controls whether frame borders are enabled.

Frames use this value unless overridden for that frame using ctrl.frameBorder(index)

GuiFrameState GuiFrameSetCtrl::borderMovable

Controls whether borders can be dynamically repositioned with the mouse by the user.

Frames use this value unless overridden for that frame using ctrl.frameMovable(index)

int GuiFrameSetCtrl::borderWidth

Width of interior borders between cells in pixels.

intList GuiFrameSetCtrl::columns

A vector of column offsets (determines the width of each column).

int GuiFrameSetCtrl::fudgeFactor

Offset for row and column dividers in pixels.

intList GuiFrameSetCtrl::rows

A vector of row offsets (determines the height of each row).


Torque 3D - Script Manual: GuiGameListMenuCtrl Class Reference

GuiGameListMenuCtrl Class Reference
[Game Controls]

A base class for cross platform menu controls that are gamepad friendly. More...

Inheritance diagram for GuiGameListMenuCtrl:
[legend]

List of all members.

Public Member Functions

void | activateRow ()
Activates the current row. The script callback of the current row will be called (if it has one).
void | addRow (string label, string callback, int icon=-1, int yPad=0, bool useHighlightIcon=true, bool enabled=true)
Add a row to the list control.
int | getRowCount ()
Gets the number of rows on the control.
string | getRowLabel (int row)
Gets the label displayed on the specified row.
int | getSelectedRow ()
Gets the index of the currently selected row.
bool | isRowEnabled (int row)
Determines if the specified row is enabled or disabled.
void | setRowEnabled (int row, bool enabled)
Sets a row's enabled status according to the given parameters.
void | setRowLabel (int row, string label)
Sets the label on the given row.
void | setSelected (int row)
Sets the selected row. Only rows that are enabled can be selected.
Callbacks

void | onChange ()
Called when the selected row changes.

Public Attributes

string | callbackOnA
Script callback when the 'A' button is pressed. 'A' inputs are Keyboard: A, Return, Space; Gamepad: A, Start.
string | callbackOnB
Script callback when the 'B' button is pressed. 'B' inputs are Keyboard: B, Esc, Backspace, Delete; Gamepad: B, Back.
string | callbackOnX
Script callback when the 'X' button is pressed. 'X' inputs are Keyboard: X; Gamepad: X.
string | callbackOnY
Script callback when the 'Y' button is pressed. 'Y' inputs are Keyboard: Y; Gamepad: Y.
bool | debugRender
Enable debug rendering.

Detailed Description

A base class for cross platform menu controls that are gamepad friendly.

This class is used to build row-based menu GUIs that can be easily navigated using the keyboard, mouse or gamepad. The desired row can be selected using the mouse, or by navigating using the Up and Down buttons.

Example:
new GuiGameListMenuCtrl()
{
   debugRender = "0";
   callbackOnA = "applyOptions();";
   callbackOnB = "Canvas.setContent(MainMenuGui);";
   callbackOnX = "";
   callbackOnY = "revertOptions();";
   //Properties not specific to this control have been omitted from this example.
};
See also:
GuiGameListMenuProfile

Member Function Documentation

void GuiGameListMenuCtrl::activateRow ( )

Activates the current row. The script callback of the current row will be called (if it has one).

void GuiGameListMenuCtrl::addRow | ( | string | label,
 |  | string | callback,
 |  | int | icon = -1,
 |  | int | yPad = 0,
 |  | bool | useHighlightIcon = true,
 |  | bool | enabled = true
 | ) |  |

Add a row to the list control.

Parameters:
label | The text to display on the row as a label.
callback | Name of a script function to use as a callback when this row is activated.
icon | [optional] Index of the icon to use as a marker.
yPad | [optional] An extra amount of height padding before the row. Does nothing on the first row.
useHighlightIcon | [optional] Does this row use the highlight icon?.
enabled | [optional] If this row is initially enabled.
int GuiGameListMenuCtrl::getRowCount ( )

Gets the number of rows on the control.

Returns:
(int) The number of rows on the control.
string GuiGameListMenuCtrl::getRowLabel ( int row )

Gets the label displayed on the specified row.

Parameters:
row Index of the row to get the label of.
Returns:
The label for the row.
int GuiGameListMenuCtrl::getSelectedRow ( )

Gets the index of the currently selected row.

Returns:
Index of the selected row.
bool GuiGameListMenuCtrl::isRowEnabled ( int row )

Determines if the specified row is enabled or disabled.

Parameters:
row The row to set the enabled status of.
Returns:
True if the specified row is enabled. False if the row is not enabled or the given index was not valid.
void GuiGameListMenuCtrl::onChange ( )

Called when the selected row changes.

void GuiGameListMenuCtrl::setRowEnabled | ( | int | row,
 |  | bool | enabled
 | ) |  |

Sets a row's enabled status according to the given parameters.

Parameters:
row | The index to check for validity.
enabled | Indicate true to enable the row or false to disable it.
void GuiGameListMenuCtrl::setRowLabel | ( | int | row,
 |  | string | label
 | ) |  |

Sets the label on the given row.

Parameters:
row | Index of the row to set the label on.
label | Text to set as the label of the row.
void GuiGameListMenuCtrl::setSelected ( int row )

Sets the selected row. Only rows that are enabled can be selected.

Parameters:
row Index of the row to set as selected.

Member Data Documentation

string GuiGameListMenuCtrl::callbackOnA

Script callback when the 'A' button is pressed. 'A' inputs are Keyboard: A, Return, Space; Gamepad: A, Start.

string GuiGameListMenuCtrl::callbackOnB

Script callback when the 'B' button is pressed. 'B' inputs are Keyboard: B, Esc, Backspace, Delete; Gamepad: B, Back.

string GuiGameListMenuCtrl::callbackOnX

Script callback when the 'X' button is pressed. 'X' inputs are Keyboard: X; Gamepad: X.

string GuiGameListMenuCtrl::callbackOnY

Script callback when the 'Y' button is pressed. 'Y' inputs are Keyboard: Y; Gamepad: Y.

bool GuiGameListMenuCtrl::debugRender

Enable debug rendering.


Torque 3D - Script Manual: GuiGameListMenuProfile Class Reference

GuiGameListMenuProfile Class Reference
[Game Controls]

A GuiControlProfile with additional fields specific to GuiGameListMenuCtrl. More...

Inheritance diagram for GuiGameListMenuProfile:
[legend]

List of all members.

Public Attributes

Point2I | hitAreaLowerRight
Position of the lower right corner of the row hit area (relative to row's top left corner).
Point2I | hitAreaUpperLeft
Position of the upper left corner of the row hit area (relative to row's top left corner).
Point2I | iconOffset
Offset from the row's top left corner at which to render the row icon.
Point2I | rowSize
The base size ("width height") of a row.

Detailed Description

A GuiControlProfile with additional fields specific to GuiGameListMenuCtrl.

Example:
new GuiGameListMenuProfile()
{
   hitAreaUpperLeft = "10 2";
   hitAreaLowerRight = "190 18";
   iconOffset = "10 2";
   rowSize = "200 20";
   //Properties not specific to this control have been omitted from this example.
};

Member Data Documentation

Point2I GuiGameListMenuProfile::hitAreaLowerRight

Position of the lower right corner of the row hit area (relative to row's top left corner).

Point2I GuiGameListMenuProfile::hitAreaUpperLeft

Position of the upper left corner of the row hit area (relative to row's top left corner).

Point2I GuiGameListMenuProfile::iconOffset

Offset from the row's top left corner at which to render the row icon.

Point2I GuiGameListMenuProfile::rowSize

The base size ("width height") of a row.


Torque 3D - Script Manual: GuiGameListOptionsCtrl Class Reference

GuiGameListOptionsCtrl Class Reference
[Game Controls]

A control for showing pages of options that are gamepad friendly. More...

Inheritance diagram for GuiGameListOptionsCtrl:
[legend]

List of all members.

Public Member Functions

void | addRow (string label, string options, bool wrapOptions, string callback, int icon=-1, int yPad=0, bool enabled=true)
Add a row to the list control.
string | getCurrentOption (int row)
Gets the text for the currently selected option of the given row.
bool | selectOption (int row, string option)
Set the row's current option to the one specified.
void | setOptions (int row, string optionsList)
Sets the list of options on the given row.

Detailed Description

A control for showing pages of options that are gamepad friendly.

Each row in this control allows the selection of one value from a set of options using the keyboard, gamepad or mouse. The row is rendered as 2 columns: the first column contains the row label, the second column contains left and right arrows (for mouse picking) and the currently selected value.

See also:
GuiGameListOptionsProfile

Member Function Documentation

void GuiGameListOptionsCtrl::addRow | ( | string | label,
 |  | string | options,
 |  | bool | wrapOptions,
 |  | string | callback,
 |  | int | icon = -1,
 |  | int | yPad = 0,
 |  | bool | enabled = true
 | ) |  |

Add a row to the list control.

Parameters:
label | The text to display on the row as a label.
options | A tab separated list of options.
wrapOptions | Specify true to allow options to wrap at each end or false to prevent wrapping.
callback | Name of a script function to use as a callback when this row is activated.
icon | [optional] Index of the icon to use as a marker.
yPad | [optional] An extra amount of height padding before the row. Does nothing on the first row.
enabled | [optional] If this row is initially enabled.
string GuiGameListOptionsCtrl::getCurrentOption ( int row )

Gets the text for the currently selected option of the given row.

Parameters:
row Index of the row to get the option from.
Returns:
A string representing the text currently displayed as the selected option on the given row. If there is no such displayed text then the empty string is returned.
bool GuiGameListOptionsCtrl::selectOption | ( | int | row,
 |  | string | option
 | ) |  |

Set the row's current option to the one specified.

Parameters:
row | Index of the row to set an option on.
option | The option to be made active.
Returns:
True if the row contained the option and was set, false otherwise.
void GuiGameListOptionsCtrl::setOptions | ( | int | row,
 |  | string | optionsList
 | ) |  |

Sets the list of options on the given row.

Parameters:
row | Index of the row to set options on.
optionsList | A tab separated list of options for the control.


Torque 3D - Script Manual: GuiGameListOptionsProfile Class Reference

GuiGameListOptionsProfile Class Reference
[Game Controls]

A GuiControlProfile with additional fields specific to GuiGameListOptionsCtrl. More...

Inheritance diagram for GuiGameListOptionsProfile:
[legend]

List of all members.

Public Attributes

int | columnSplit
Padding between the leftmost edge of the control, and the row's left arrow.
int | rightPad
Padding between the rightmost edge of the control and the row's right arrow.

Detailed Description

A GuiControlProfile with additional fields specific to GuiGameListOptionsCtrl.

Example:
new GuiGameListOptionsProfile()
{
   columnSplit = "100";
   rightPad = "4";
   //Properties not specific to this control have been omitted from this example.
};

Member Data Documentation

int GuiGameListOptionsProfile::columnSplit

Padding between the leftmost edge of the control, and the row's left arrow.

int GuiGameListOptionsProfile::rightPad

Padding between the rightmost edge of the control and the row's right arrow.


Torque 3D - Script Manual: GuiGraphCtrl Class Reference

GuiGraphCtrl Class Reference
[Value Controls]

A control that plots one or more curves in a chart. More...

Inheritance diagram for GuiGraphCtrl:
[legend]

List of all members.

Public Member Functions

void | addAutoPlot (int plotId, string variable, int updateFrequency)
Sets up the given plotting curve to automatically plot the value of the variable with a frequency of updateFrequency.
void | addDatum (int plotId, float value)
Add a data point to the plot's curve.
float | getDatum (int plotId, int index)
Get a data point on the given plotting curve.
void | matchScale (int plotID1, int plotID2,...)
Set the scale of all specified plots to the maximum scale among them.
void | removeAutoPlot (int plotId)
Stop automatic variable plotting for the given curve.
void | setGraphType (int plotId, GuiGraphType graphType)
Change the charting type of the given plotting curve.

Public Attributes

Graph

float | centerY
Ratio of where to place the center coordinate of the graph on the Y axis. 0.5=middle height of control.
ColorF | plotColor [6]
Color to use for the plotting curves in the graph.
int | plotInterval [6]
Interval between auto-plots of plotVariable for the respective curve (in milliseconds).
GuiGraphType | plotType [6]
Charting type of the plotting curves.
string | plotVariable [6]
Name of the variable to automatically plot on the curves. If empty, auto-plotting is disabled for the respective curve.

Detailed Description

A control that plots one or more curves in a chart.

Up to 6 individual curves can be plotted in the graph. Each plotted curve can have its own display style including its own charting style (plotType) and color (plotColor).

The data points on each curve can be added in one of two ways:

  • Manually by calling addDatum(). This causes new data points to be added to the left end of the plotting curve.
  • Automatically by letting the graph plot the values of a variable over time. This is achieved by calling addAutoPlot and specifying the variable and update frequency.
Example:
// Create a graph that plots a red polyline graph of the FPS counter in a 1 second (1000 milliseconds) interval.
new GuiGraphCtrl( FPSGraph )
{
   plotType[ 0 ] = "PolyLine";
   plotColor[ 0 ] = "1 0 0";
   plotVariable[ 0 ] = "fps::real";
   plotInterval[ 0 ] = 1000;
};
Note:
Each curve has a maximum number of 200 data points it can have at any one time. Adding more data points to a curve will cause older data points to be removed.

Member Function Documentation

void GuiGraphCtrl::addAutoPlot | ( | int | plotId,
 |  | string | variable,
 |  | int | updateFrequency
 | ) |  |

Sets up the given plotting curve to automatically plot the value of the variable with a frequency of updateFrequency.

Parameters:
plotId | Index of the plotting curve. Must be 0<=plotId<6.
variable | Name of the global variable.
updateFrequency | Frequency with which to add new data points to the plotting curve (in milliseconds).
Example:
// Plot FPS counter at 1 second intervals.
%graph.addAutoPlot( 0, "fps::real", 1000 );

void GuiGraphCtrl::addDatum | ( | int | plotId,
 |  | float | value
 | ) |  |

Add a data point to the plot's curve.

Parameters:
plotId | Index of the plotting curve to which to add the data point. Must be 0<=plotId<6.
value | Value of the data point to add to the curve.
Note:
Data values are added to the left end of the plotting curve.
A maximum number of 200 data points can be added to any single plotting curve at any one time. If this limit is exceeded, data points on the right end of the curve are culled.
float GuiGraphCtrl::getDatum | ( | int | plotId,
 |  | int | index
 | ) |  |

Get a data point on the given plotting curve.

Parameters:
plotId | Index of the plotting curve from which to fetch the data point. Must be 0<=plotId<6.
index | Index of the data point on the curve.
Returns:
The value of the data point or -1 if plotId or index are out of range.
void GuiGraphCtrl::matchScale | ( | int | plotID1,
 |  | int | plotID2,
 |  |  | ...
 | ) |  |

Set the scale of all specified plots to the maximum scale among them.

Parameters:
plotID1 | Index of plotting curve.
plotID2 | Index of plotting curve.
void GuiGraphCtrl::removeAutoPlot ( int plotId )

Stop automatic variable plotting for the given curve.

Parameters:
plotId Index of the plotting curve. Must be 0<=plotId<6.
void GuiGraphCtrl::setGraphType | ( | int | plotId,
 |  | GuiGraphType | graphType
 | ) |  |

Change the charting type of the given plotting curve.

Parameters:
plotId | Index of the plotting curve. Must be 0<=plotId<6.
graphType | Charting type to use for the curve.
Note:
Instead of calling this method, you can directly assign to plotType.

Member Data Documentation

float GuiGraphCtrl::centerY

Ratio of where to place the center coordinate of the graph on the Y axis. 0.5=middle height of control.

This allows to account for graphs that have only positive or only negative data points, for example.

ColorF GuiGraphCtrl::plotColor[6]

Color to use for the plotting curves in the graph.

int GuiGraphCtrl::plotInterval[6]

Interval between auto-plots of plotVariable for the respective curve (in milliseconds).

GuiGraphType GuiGraphCtrl::plotType[6]

Charting type of the plotting curves.

string GuiGraphCtrl::plotVariable[6]

Name of the variable to automatically plot on the curves. If empty, auto-plotting is disabled for the respective curve.


Torque 3D - Script Manual: GuiHealthBarHud Class Reference

GuiHealthBarHud Class Reference
[Game Controls]

A basic health bar. Shows the damage value of the current PlayerObjectType control object. More...

Inheritance diagram for GuiHealthBarHud:
[legend]

List of all members.

Public Attributes

Colors

ColorF | damageFillColor
As the health bar depletes, this color will represent the health loss amount.
ColorF | fillColor
Standard color for the background of the control.
ColorF | frameColor
Color for the control's frame.
Misc

bool | displayEnergy
If true, display the energy value rather than the damage value.
bool | showFill
If true, we draw the background color of the control.
bool | showFrame
If true, we draw the frame of the control.
Pulse

int | pulseRate
Speed at which the control will pulse.
float | pulseThreshold
Health level the control must be under before the control will pulse.

Detailed Description

A basic health bar. Shows the damage value of the current PlayerObjectType control object.

This gui displays the damage value of the current PlayerObjectType control object. The gui can be set to pulse if the health value drops below a set value. This control only works if a server connection exists and it's control object is a PlayerObjectType. If either of these requirements is false, the control is not rendered.

Example:
 new GuiHealthBarHud(){
   fillColor = "0.0 1.0 0.0 1.0"; // Fills with a solid green color
   frameColor = "1.0 1.0 1.0 1.0"; // Solid white frame color
   damageFillColor = "1.0 0.0 0.0 1.0"; // Fills with a solid red color
   pulseRate = "500";
   pulseThreshold = "0.25";
   showFill = "true";
   showFrame = "true";
   displayEnergy = "false";
};

Member Data Documentation

ColorF GuiHealthBarHud::damageFillColor

As the health bar depletes, this color will represent the health loss amount.

bool GuiHealthBarHud::displayEnergy

If true, display the energy value rather than the damage value.

ColorF GuiHealthBarHud::fillColor

Standard color for the background of the control.

ColorF GuiHealthBarHud::frameColor

Color for the control's frame.

int GuiHealthBarHud::pulseRate

Speed at which the control will pulse.

float GuiHealthBarHud::pulseThreshold

Health level the control must be under before the control will pulse.

bool GuiHealthBarHud::showFill

If true, we draw the background color of the control.

bool GuiHealthBarHud::showFrame

If true, we draw the frame of the control.


Torque 3D - Script Manual: GuiIconButtonCtrl Class Reference

GuiIconButtonCtrl Class Reference
[Core Controls]

Draws the bitmap within a special button control. Only a single bitmap is used and the button will be drawn in a highlighted mode when the mouse hovers over it or when it has been clicked. More...

Inheritance diagram for GuiIconButtonCtrl:
[legend]

List of all members.

Public Member Functions

void | setBitmap (string buttonFilename)
Set the bitmap to use for the button portion of this control.

Public Attributes

bool | autoSize
If true, the text and icon will be automatically sized to the size of the control.
Point2I | buttonMargin
Margin area around the button.
filename | iconBitmap
Bitmap file for the icon to display on the button.
GuiIconButtonIconLocation iconLocation
Where to place the icon on the control. Options are 0 (None), 1 (Left), 2 (Right), 3 (Center).
bool | makeIconSquare
If true, will make sure the icon is square.
bool | sizeIconToButton
If true, the icon will be scaled to be the same size as the button.
GuiIconButtonTextLocation textLocation
Where to place the text on the control.
int | textMargin
Margin between the icon and the text.

Detailed Description

Draws the bitmap within a special button control. Only a single bitmap is used and the button will be drawn in a highlighted mode when the mouse hovers over it or when it has been clicked.

Example:
new GuiIconButtonCtrl(TestIconButton)
{
   buttonMargin = "4 4";
   iconBitmap = "art/gui/lagIcon.png";
   iconLocation = "Center";
   sizeIconToButton = "0";
   makeIconSquare = "1";
   textLocation = "Bottom";
   textMargin = "-2";
   autoSize = "0";
   text = "Lag Icon";
   textID = ""STR_LAG"";
   buttonType = "PushButton";
   profile = "GuiIconButtonProfile";
};
See also:
GuiControl
GuiButtonCtrl

Member Function Documentation

void GuiIconButtonCtrl::setBitmap ( string buttonFilename )

Set the bitmap to use for the button portion of this control.

Parameters:
buttonFilename Filename for the image
Example:
// Define the button filename
%buttonFilename = "pearlButton";

// Inform the GuiIconButtonCtrl control to update its main button graphic to the defined bitmap
%thisGuiIconButtonCtrl.setBitmap(%buttonFilename);
See also:
GuiControl
GuiButtonCtrl

Member Data Documentation

bool GuiIconButtonCtrl::autoSize

If true, the text and icon will be automatically sized to the size of the control.

Point2I GuiIconButtonCtrl::buttonMargin

Margin area around the button.

filename GuiIconButtonCtrl::iconBitmap

Bitmap file for the icon to display on the button.

GuiIconButtonIconLocation GuiIconButtonCtrl::iconLocation

Where to place the icon on the control. Options are 0 (None), 1 (Left), 2 (Right), 3 (Center).

bool GuiIconButtonCtrl::makeIconSquare

If true, will make sure the icon is square.

bool GuiIconButtonCtrl::sizeIconToButton

If true, the icon will be scaled to be the same size as the button.

GuiIconButtonTextLocation GuiIconButtonCtrl::textLocation

Where to place the text on the control.

Options are 0 (None), 1 (Bottom), 2 (Right), 3 (Top), 4 (Left), 5 (Center).

int GuiIconButtonCtrl::textMargin

Margin between the icon and the text.


Torque 3D - Script Manual: GuiInputCtrl Class Reference

GuiInputCtrl Class Reference
[Utility Controls]

A control that locks the mouse and reports all keyboard input events to script. More...

Inheritance diagram for GuiInputCtrl:
[legend]

List of all members.

Public Member Functions

Callbacks

void onInputEvent (string device, string action, bool state)
Callback that occurs when an input is triggered on this control.

Detailed Description

A control that locks the mouse and reports all keyboard input events to script.

This is useful for implementing custom keyboard handling code, and most commonly used in Torque for a menu that allows a user to remap their in-game controls

Example:
new GuiInputCtrl(OptRemapInputCtrl)
{
   lockMouse = "0";
   position = "0 0";
   extent = "64 64";
   minExtent = "8 8";
   horizSizing = "center";
   vertSizing = "bottom";
   profile = "GuiInputCtrlProfile";
   visible = "1";
   active = "1";
   tooltipProfile = "GuiToolTipProfile";
   hovertime = "1000";
   isContainer = "0";
   canSave = "1";
   canSaveDynamicFields = "0";
};
See also:
GuiMouseEventCtrl

Member Function Documentation

void GuiInputCtrl::onInputEvent | ( | string | device,
 |  | string | action,
 |  | bool | state
 | ) |  |

Callback that occurs when an input is triggered on this control.

Parameters:
device | The device type triggering the input, such as keyboard, mouse, etc
action | The actual event occuring, such as a key or button
state | True if the action is being pressed, false if it is being release


Torque 3D - Script Manual: GuiListBoxCtrl Class Reference

GuiListBoxCtrl Class Reference
[Core Controls]

A list of text items. More...

Inheritance diagram for GuiListBoxCtrl:
[legend]

List of all members.

Public Member Functions

void | addFilteredItem (string newItem)
Checks if there is an item with the exact text of what is passed in, and if so the item is removed from the list and adds that item's data to the filtered list.
void | clearItemColor (int index)
Removes any custom coloring from an item at the defined index id in the list.
void | clearItems ()
Clears all the items in the listbox.
void | clearSelection ()
Sets all currently selected items to unselected.
void | deleteItem (int itemIndex)
Removes the list entry at the requested index id from the control and clears the memory associated with it.
void | doMirror ()
Informs the GuiListBoxCtrl object to mirror the contents of the GuiListBoxCtrl stored in the mirrorSet field.
int | findItemText (string findText, bool bCaseSensitive=false)
Returns index of item with matching text or -1 if none found.
int | getItemCount ()
Returns the number of items in the list.
string | getItemObject (int index)
Returns the object associated with an item. This only makes sense if you are mirroring a simset.
string | getItemText (int index)
Returns the text of the item at the specified index.
int | getLastClickItem ()
Request the item index for the item that was last clicked.
int | getSelCount ()
Returns the number of items currently selected.
int | getSelectedItem ()
Returns the selected items index or -1 if none selected. If multiple selections exist it returns the first selected item.
string | getSelectedItems ()
Returns a space delimited list of the selected items indexes in the list.
void | insertItem (string text, int index)
Inserts an item into the list at the specified index and returns the index assigned or -1 on error.
void | removeFilteredItem (string itemName)
Removes an item of the entered name from the filtered items list.
void | setCurSel (int indexId)
Sets the currently selected item at the specified index.
void | setCurSelRange (int indexStart, int indexStop=999999)
Sets the current selection range from index start to stop. If no stop is specified it sets from start index to the end of the list.
void | setItemColor (int index, ColorF color)
Sets the color of a single list entry at the specified index id.
void | setItemText (int index, string newtext)
Sets the items text at the specified index.
void | setItemTooltip (int index, string text)
Set the tooltip text to display for the given list item.
void | setMultipleSelection (bool allowMultSelections)
Enable or disable multiple selections for this GuiListBoxCtrl object.
void | setSelected (int index, bool setSelected=true)
Sets the item at the index specified to selected or not.
Callbacks

bool | isObjectMirrored (string indexIdString)
Checks if a list item at a defined index id is mirrored, and returns the result.
void | onClearSelection ()
Called whenever a selected item in the list is cleared.
void | onDeleteKey ()
Called whenever the Delete key on the keyboard has been pressed while in this control.
void | onDoubleClick ()
Called whenever an item in the list has been double clicked.
void | onMouseDragged ()
Called whenever the mouse is dragged across the control.
void | onMouseUp (string itemHit, string mouseClickCount)
Called whenever the mouse has previously been clicked down (onMouseDown) and has now been raised on the control. If an item in the list was hit during the click cycle, then the index id of the clicked object along with how many clicks occured are passed into the callback.
void | onSelect (string index, string itemText)
Called whenever an item in the list is selected.
void | onUnselect (string index, string itemText)
Called whenever a selected item in the list has been unselected.

Public Attributes

bool | allowMultipleSelections
If true, will allow the selection of multiple items in the listbox.
bool | colorBullet
If true, colored items will render a colored rectangular bullet next to the item text.
bool | fitParentWidth
If true, the width of the listbox will match the width of its parent control.
string | makeNameCallback
A script snippet to control what is displayed in the list for a SimObject. Within this snippet, $ThisControl is bound to the guiListBoxCtrl and $ThisObject to the contained object in question.
string | mirrorSet
If populated with the name of another GuiListBoxCtrl, then this list box will mirror the contents of the mirrorSet listbox.

Detailed Description

A list of text items.

A list of text items where each individual entry can have its own text value, text color and associated SimObject.

Example:
new GuiListBoxCtrl(GuiMusicPlayerMusicList)
{
   allowMultipleSelections = "true";
   fitParentWidth = "true";
   mirrorSet = "AnotherGuiListBoxCtrl";
   makeNameCallback = "";
   colorBullet = "1";
   //Properties not specific to this control have been omitted from this example.
};
See also:
GuiControl

Member Function Documentation

void GuiListBoxCtrl::addFilteredItem ( string newItem )

Checks if there is an item with the exact text of what is passed in, and if so the item is removed from the list and adds that item's data to the filtered list.

Parameters:
itemName Name of the item that we wish to add to the filtered item list of the GuiListBoxCtrl.
Example:
// Define the itemName that we wish to add to the filtered item list.
%itemName = "This Item Name";

// Add the item name to the filtered item list.
%thisGuiListBoxCtrl.addFilteredItem(%filteredItemName);
See also:
GuiControl
void GuiListBoxCtrl::clearItemColor ( int index )

Removes any custom coloring from an item at the defined index id in the list.

Parameters:
index Index id for the item to clear any custom color from.
Example:
// Define the index id
%index = "4";

// Request the GuiListBoxCtrl object to remove any custom coloring from the defined index entry
%thisGuiListBoxCtrl.clearItemColor(%index);
See also:
GuiControl
void GuiListBoxCtrl::clearItems ( )

Clears all the items in the listbox.

Example:
// Inform the GuiListBoxCtrl object to clear all items from its list.
%thisGuiListBoxCtrl.clearItems();
See also:
GuiControl
void GuiListBoxCtrl::clearSelection ( )

Sets all currently selected items to unselected.

Detailed description

Example:
// Inform the GuiListBoxCtrl object to set all of its items to unselected./n%thisGuiListBoxCtrl.clearSelection();
See also:
GuiControl
void GuiListBoxCtrl::deleteItem ( int itemIndex )

Removes the list entry at the requested index id from the control and clears the memory associated with it.

Parameters:
itemIndex Index id location to remove the item from.
Example:
// Define the index id we want to remove from the list
%itemIndex = "8";

// Inform the GuiListBoxCtrl object to remove the item at the defined index id.
%thisGuiListBoxCtrl.deleteItem(%itemIndex);
See also:
References
void GuiListBoxCtrl::doMirror ( )

Informs the GuiListBoxCtrl object to mirror the contents of the GuiListBoxCtrl stored in the mirrorSet field.

Example:
\ Inform the object to mirror the object located at %thisGuiListBox.mirrorSet
%thisGuiListBox.doMirror();
See also:
Core Controls
int GuiListBoxCtrl::findItemText | ( | string | findText,
 |  | bool | bCaseSensitive = false
 | ) |  |

Returns index of item with matching text or -1 if none found.

Parameters:
findText | Text in the list to find.
isCaseSensitive | If true, the search will be case sensitive.
Example:
// Define the text we wish to find in the list.
%findText = "Hickory Smoked Gideon"/n/n// Define if this is a case sensitive search or not.
%isCaseSensitive = "false";

// Ask the GuiListBoxCtrl object what item id in the list matches the requested text.
%matchingId = %thisGuiListBoxCtrl.findItemText(%findText,%isCaseSensitive);
Returns:
Index id of item with matching text or -1 if none found.
See also:
GuiControl
int GuiListBoxCtrl::getItemCount ( )

Returns the number of items in the list.

Example:
// Request the number of items in the list of the GuiListBoxCtrl object.
%listItemCount = %thisGuiListBoxCtrl.getItemCount();
Returns:
The number of items in the list.
See also:
GuiControl
string GuiListBoxCtrl::getItemObject ( int index )

Returns the object associated with an item. This only makes sense if you are mirroring a simset.

Parameters:
index Index id to request the associated item from.
Example:
// Define the index id
%index = "12";

// Request the item from the GuiListBoxCtrl object
%object = %thisGuiListBoxCtrl.getItemObject(%index);
Returns:
The object associated with the item in the list.
See also:
References
string GuiListBoxCtrl::getItemText ( int index )

Returns the text of the item at the specified index.

Parameters:
index Index id to return the item text from.
Example:
// Define the index id entry to request the text from
%index = "12";

// Request the item id text from the GuiListBoxCtrl object.
%text = %thisGuiListBoxCtrl.getItemText(%index);
Returns:
The text of the requested index id.
See also:
GuiControl
int GuiListBoxCtrl::getLastClickItem ( )

Request the item index for the item that was last clicked.

Example:
// Request the item index for the last clicked item in the list
%lastClickedIndex = %thisGuiListBoxCtrl.getLastClickItem();
Returns:
Index id for the last clicked item in the list.
See also:
GuiControl
int GuiListBoxCtrl::getSelCount ( )

Returns the number of items currently selected.

Example:
// Request the number of currently selected items
%selectedItemCount = %thisGuiListBoxCtrl.getSelCount();
Returns:
Number of currently selected items.
See also:
GuiControl
int GuiListBoxCtrl::getSelectedItem ( )

Returns the selected items index or -1 if none selected. If multiple selections exist it returns the first selected item.

Example:
// Request the index id of the currently selected item
%selectedItemId = %thisGuiListBoxCtrl.getSelectedItem();
Returns:
The selected items index or -1 if none selected.
See also:
GuiControl
string GuiListBoxCtrl::getSelectedItems ( )

Returns a space delimited list of the selected items indexes in the list.

Example:
// Request a space delimited list of the items in the GuiListBoxCtrl object.
%selectionList = %thisGuiListBoxCtrl.getSelectedItems();
Returns:
Space delimited list of the selected items indexes in the list
See also:
GuiControl
void GuiListBoxCtrl::insertItem | ( | string | text,
 |  | int | index
 | ) |  |

Inserts an item into the list at the specified index and returns the index assigned or -1 on error.

Parameters:
text | Text item to add.
index | Index id to insert the list item text at.
Example:
// Define the text to insert
%text = "Secret Agent Gideon";

// Define the index entry to insert the text at
%index = "14";

// In form the GuiListBoxCtrl object to insert the text at the defined index.
%assignedId = %thisGuiListBoxCtrl.insertItem(%text,%index);
Returns:
If successful will return the index id assigned. If unsuccessful, will return -1.
See also:
GuiControl
bool GuiListBoxCtrl::isObjectMirrored ( string indexIdString )

Checks if a list item at a defined index id is mirrored, and returns the result.

Parameters:
indexIdString Index id of the list to check.
Example:
// Engine has requested of the script level to determine if a list entry is mirrored or not.
GuiListBoxCtrl::isObjectMirrored(%this, %indexIdString)
   {
      // Perform code required to check and see if the list item at the index id is mirrored or not.
      return %isMirrored;
   }
Returns:
A boolean value on if the list item is mirrored or not.
See also:
GuiControl
void GuiListBoxCtrl::onClearSelection ( )

Called whenever a selected item in the list is cleared.

Example:
// A selected item is cleared, causing the callback to occur.
GuiListBoxCtrl::onClearSelection(%this)
   {
      // Code to run whenever a selected item is cleared
   }
See also:
GuiControl
void GuiListBoxCtrl::onDeleteKey ( )

Called whenever the Delete key on the keyboard has been pressed while in this control.

Example:
// The delete key on the keyboard has been pressed while this control is in focus, causing the callback to occur.
GuiListBoxCtrl::onDeleteKey(%this)
   {
      // Code to call whenever the delete key is pressed
   }
See also:
GuiControl
void GuiListBoxCtrl::onDoubleClick ( )

Called whenever an item in the list has been double clicked.

Example:
// An item in the list is double clicked, causing the callback to occur.
GuiListBoxCtrl::onDoubleClick(%this)
   {
      // Code to run whenever an item in the control has been double clicked
   }
See also:
GuiControl
void GuiListBoxCtrl::onMouseDragged ( )

Called whenever the mouse is dragged across the control.

Example:
// Mouse is dragged across the control, causing the callback to occur.
GuiListBoxCtrl::onMouseDragged(%this)
   {
      // Code to run whenever the mouse is dragged across the control
   }
See also:
GuiControl
void GuiListBoxCtrl::onMouseUp | ( | string | itemHit,
 |  | string | mouseClickCount
 | ) |  |

Called whenever the mouse has previously been clicked down (onMouseDown) and has now been raised on the control. If an item in the list was hit during the click cycle, then the index id of the clicked object along with how many clicks occured are passed into the callback.

Detailed description

Parameters:
itemHit | Index id for the list item that was hit
mouseClickCount | How many mouse clicks occured on this list item
Example:
// Mouse was previously clicked down, and now has been released, causing the callback to occur.
GuiListBoxCtrl::onMouseUp(%this, %itemHit, %mouseClickCount)
   {
      // Code to call whenever the mouse has been clicked and released on the control
   }
See also:
GuiControl
void GuiListBoxCtrl::onSelect | ( | string | index,
 |  | string | itemText
 | ) |  |

Called whenever an item in the list is selected.

Parameters:
index | Index id for the item in the list that was selected.
itemText | Text for the list item at the index that was selected.
Example:
// An item in the list is selected, causing the callback to occur
GuiListBoxCtrl::onSelect(%this, %index, %itemText)
   {
      // Code to run whenever an item in the list is selected
   }
See also:
GuiControl
void GuiListBoxCtrl::onUnselect | ( | string | index,
 |  | string | itemText
 | ) |  |

Called whenever a selected item in the list has been unselected.

Parameters:
index | Index id of the item that was unselected
itemText | Text for the list entry at the index id that was unselected
Example:
// A selected item is unselected, causing the callback to occur
GuiListBoxCtrl::onUnSelect(%this, %indexId, %itemText)
   {
      // Code to run whenever a selected list item is unselected
   }
See also:
GuiControl
void GuiListBoxCtrl::removeFilteredItem ( string itemName )

Removes an item of the entered name from the filtered items list.

Parameters:
itemName Name of the item to remove from the filtered list.
Example:
// Define the itemName that you wish to remove.
%itemName = "This Item Name";

// Remove the itemName from the GuiListBoxCtrl
%thisGuiListBoxCtrl.removeFilteredItem(%itemName);
See also:
GuiControl
void GuiListBoxCtrl::setCurSel ( int indexId )

Sets the currently selected item at the specified index.

Parameters:
indexId Index Id to set selected.
Example:
// Define the index id that we wish to select.
%selectId = "4";

// Inform the GuiListBoxCtrl object to set the requested index as selected.
%thisGuiListBoxCtrl.setCurSel(%selectId);
See also:
GuiControl
void GuiListBoxCtrl::setCurSelRange | ( | int | indexStart,
 |  | int | indexStop = 999999
 | ) |  |

Sets the current selection range from index start to stop. If no stop is specified it sets from start index to the end of the list.

Parameters:
indexStart | Index Id to start selection.
indexStop | Index Id to end selection.
Example:
// Set start id
%indexStart = "3";

// Set end id
%indexEnd = "6";

// Request the GuiListBoxCtrl object to select the defined range.
%thisGuiListBoxCtrl.setCurSelRange(%indexStart,%indexEnd);
See also:
GuiControl
void GuiListBoxCtrl::setItemColor | ( | int | index,
 |  | ColorF | color
 | ) |  |

Sets the color of a single list entry at the specified index id.

Parameters:
index | Index id to modify the color of in the list.
color | Color value to set the list entry to.
Example:
// Define the index id value
%index = "5";

// Define the color value
%color = "1.0 0.0 0.0";

// Inform the GuiListBoxCtrl object to change the color of the requested index
%thisGuiListBoxCtrl.setItemColor(%index,%color);
See also:
GuiControl
void GuiListBoxCtrl::setItemText | ( | int | index,
 |  | string | newtext
 | ) |  |

Sets the items text at the specified index.

Parameters:
index | Index id to set the item text at.
newtext | Text to change the list item at index id to.
Example:
// Define the index id/n%index = "12";

// Define the text to set the list item to
%newtext = "Gideon's Fancy Goggles";

// Inform the GuiListBoxCtrl object to change the text at the requested index
%thisGuiListBoxCtrl.setItemText(%index,%newText);
See also:
GuiControl
void GuiListBoxCtrl::setItemTooltip | ( | int | index,
 |  | string | text
 | ) |  |

Set the tooltip text to display for the given list item.

Parameters:
index | Index id to change the tooltip text
text | Text for the tooltip.
Example:
// Define the index id
%index = "12";

// Define the tooltip text
%tooltip = "Gideon's goggles can see through space and time."

// Inform the GuiListBoxCtrl object to set the tooltop for the item at the defined index id
%thisGuiListBoxCtrl.setItemToolTip(%index,%tooltip);
See also:
GuiControl
void GuiListBoxCtrl::setMultipleSelection ( bool allowMultSelections )

Enable or disable multiple selections for this GuiListBoxCtrl object.

Parameters:
allowMultSelections Boolean variable to set the use of multiple selections or not.
Example:
// Define the multiple selection use state.
%allowMultSelections = "true";

// Set the allow  multiple selection state on the GuiListBoxCtrl object.
%thisGuiListBoxCtrl.setMultipleSelection(%allowMultSelections);
See also:
GuiControl
void GuiListBoxCtrl::setSelected | ( | int | index,
 |  | bool | setSelected = true
 | ) |  |

Sets the item at the index specified to selected or not.

Detailed description

Parameters:
index | Item index to set selected or unselected.
setSelected | Boolean selection state to set the requested item index.
Example:
// Define the index
%index = "5";

// Define the selection state
%selected = "true"

// Inform the GuiListBoxCtrl object of the new selection state for the requested index entry.
%thisGuiListBoxCtrl.setSelected(%index,%selected);
See also:
GuiControl

Member Data Documentation

bool GuiListBoxCtrl::allowMultipleSelections

If true, will allow the selection of multiple items in the listbox.

bool GuiListBoxCtrl::colorBullet

If true, colored items will render a colored rectangular bullet next to the item text.

bool GuiListBoxCtrl::fitParentWidth

If true, the width of the listbox will match the width of its parent control.

string GuiListBoxCtrl::makeNameCallback

A script snippet to control what is displayed in the list for a SimObject. Within this snippet, $ThisControl is bound to the guiListBoxCtrl and $ThisObject to the contained object in question.

string GuiListBoxCtrl::mirrorSet

If populated with the name of another GuiListBoxCtrl, then this list box will mirror the contents of the mirrorSet listbox.


Torque 3D - Script Manual: GuiMenuBar Class Reference

GuiMenuBar Class Reference
[Core Controls]

GUI Control which displays a horizontal bar with individual drop-down menu items. Each menu item may also have submenu items. More...

Inheritance diagram for GuiMenuBar:
[legend]

List of all members.

Public Member Functions

void | addMenu (string menuText, int menuId)
Adds a new menu to the menu bar.
void | addMenuItem (string targetMenu="", string menuItemText="", int menuItemId=0, string accelerator=NULL, int checkGroup=-1)
Adds a menu item to the specified menu. The menu argument can be either the text of a menu or its id.
void | addSubmenuItem (string menuTarget, string menuItem, string submenuItemText, int submenuItemId, string accelerator, int checkGroup)
Adds a menu item to the specified menu. The menu argument can be either the text of a menu or its id.
void | clearMenuItems (string menuTarget)
Removes all the menu items from the specified menu.
void | clearMenus (int param1, int param2)
Clears all the menus from the menu bar.
void | clearSubmenuItems (string menuTarget, string menuItem)
Removes all the menu items from the specified submenu.
void | removeMenu (string menuTarget)
Removes the specified menu from the menu bar.
void | removeMenuItem (string menuTarget, string menuItemTarget)
Removes the specified menu item from the menu.
void | setCheckmarkBitmapIndex (int bitmapindex)
Sets the menu bitmap index for the check mark image.
void | setMenuBitmapIndex (string menuTarget, int bitmapindex, bool bitmaponly, bool drawborder)
Sets the bitmap index for the menu and toggles rendering only the bitmap.
void | setMenuItemBitmap (string menuTarget, string menuItemTarget, int bitmapIndex)
Sets the specified menu item bitmap index in the bitmap array. Setting the item's index to -1 will remove any bitmap.
void | setMenuItemChecked (string menuTarget, string menuItemTarget, bool checked)
Sets the menu item bitmap to a check mark, which by default is the first element in the bitmap array (although this may be changed with setCheckmarkBitmapIndex()). Any other menu items in the menu with the same check group become unchecked if they are checked.
void | setMenuItemEnable (string menuTarget, string menuItemTarget, bool enabled)
sets the menu item to enabled or disabled based on the enable parameter. The specified menu and menu item can either be text or ids.
void | setMenuItemSubmenuState (string menuTarget, string menuItem, bool isSubmenu)
Sets the given menu item to be a submenu.
void | setMenuItemText (string menuTarget, string menuItemTarget, string newMenuItemText)
Sets the text of the specified menu item to the new string.
void | setMenuItemVisible (string menuTarget, string menuItemTarget, bool isVisible)
Brief Description.
void | setMenuMargins (int horizontalMargin, int verticalMargin, int bitmapToTextSpacing)
Sets the menu rendering margins: horizontal, vertical, bitmap spacing.
void | setMenuText (string menuTarget, string newMenuText)
Sets the text of the specified menu to the new string.
void | setMenuVisible (string menuTarget, bool visible)
Sets the whether or not to display the specified menu.
void | setSubmenuItemChecked (string menuTarget, string menuItemTarget, string submenuItemText, bool checked)
Sets the menu item bitmap to a check mark, which by default is the first element in the bitmap array (although this may be changed with setCheckmarkBitmapIndex()). Any other menu items in the menu with the same check group become unchecked if they are checked.
Callbacks

void | onMenuItemSelect (string menuId, string menuText, string menuItemId, string menuItemText)
Called whenever an item in a menu is selected.
void | onMenuSelect (string menuId, string menuText)
Called whenever a menu is selected.
void | onMouseInMenu (bool isInMenu)
Called whenever the mouse enters, or persists is in the menu.
void | onSubmenuSelect (string submenuId, string submenuText)
Called whenever a submenu is selected.

Public Attributes

int | padding
Extra padding to add to the bounds of the control.

Detailed Description

GUI Control which displays a horizontal bar with individual drop-down menu items. Each menu item may also have submenu items.

Example:
new GuiMenuBar(newMenuBar)
{
   Padding = "0";
   //Properties not specific to this control have been omitted from this example.
};

// Add a menu to the menu bar
newMenuBar.addMenu(0,"New Menu");

// Add a menu item to the New Menu
newMenuBar.addMenuItem(0,"New Menu Item",0,"n",-1);

// Add a submenu item to the New Menu Item
newMenuBar.addSubmenuItem(0,1,"New Submenu Item",0,"s",-1);
See also:
GuiTickCtrl

Member Function Documentation

void GuiMenuBar::addMenu | ( | string | menuText,
 |  | int | menuId
 | ) |  |

Adds a new menu to the menu bar.

Parameters:
menuText | Text to display for the new menu item.
menuId | ID for the new menu item.
Example:
// Define the menu text
%menuText = "New Menu";

// Define the menu ID.
%menuId = "2";

// Inform the GuiMenuBar control to add the new menu
%thisGuiMenuBar.addMenu(%menuText,%menuId);
See also:
GuiTickCtrl
void GuiMenuBar::addMenuItem | ( | string | targetMenu = "",
 |  | string | menuItemText = "",
 |  | int | menuItemId = 0,
 |  | string | accelerator = NULL,
 |  | int | checkGroup = -1
 | ) |  |

Adds a menu item to the specified menu. The menu argument can be either the text of a menu or its id.

Parameters:
menu | Menu name or menu Id to add the new item to.
menuItemText | Text for the new menu item.
menuItemId | Id for the new menu item.
accelerator | Accelerator key for the new menu item.
checkGroup | Check group to include this menu item in.
Example:
// Define the menu we wish to add the item to
%targetMenu = "New Menu";  or  %menu = "4";

// Define the text for the new menu item
%menuItemText = "Menu Item";

// Define the id for the new menu item
%menuItemId = "3";

// Set the accelerator key to toggle this menu item with
%accelerator = "n";

// Define the Check Group that this menu item will be in, if we want it to be in a check group. -1 sets it in no check group.
%checkGroup = "4";

// Inform the GuiMenuBar control to add the new menu item with the defined fields
%thisGuiMenuBar.addMenuItem(%menu,%menuItemText,%menuItemId,%accelerator,%checkGroup);
See also:
GuiTickCtrl
void GuiMenuBar::addSubmenuItem | ( | string | menuTarget,
 |  | string | menuItem,
 |  | string | submenuItemText,
 |  | int | submenuItemId,
 |  | string | accelerator,
 |  | int | checkGroup
 | ) |  |

Adds a menu item to the specified menu. The menu argument can be either the text of a menu or its id.

Parameters:
menuTarget | Menu to affect a submenu in
menuItem | Menu item to affect
submenuItemText | Text to show for the new submenu
submenuItemId | Id for the new submenu
accelerator | Accelerator key for the new submenu
checkGroup | Which check group the new submenu should be in, or -1 for none.
Example:
// Define the menuTarget
%menuTarget = "New Menu";  or  %menuTarget = "3";

// Define the menuItem
%menuItem = "New Menu Item";  or  %menuItem = "5";

// Define the text for the new submenu
%submenuItemText = "New Submenu Item";

// Define the id for the new submenu
%submenuItemId = "4";

// Define the accelerator key for the new submenu
%accelerator = "n";

// Define the checkgroup for the new submenu
%checkgroup = "7";

// Request the GuiMenuBar control to add the new submenu with the defined information
%thisGuiMenuBar.addSubmenuItem(%menuTarget,%menuItem,%submenuItemText,%submenuItemId,%accelerator,%checkgroup);
See also:
GuiTickCtrl
void GuiMenuBar::clearMenuItems ( string menuTarget )

Removes all the menu items from the specified menu.

Parameters:
menuTarget Menu to remove all items from
Example:
// Define the menuTarget
%menuTarget = "New Menu";  or %menuTarget = "3";

// Inform the GuiMenuBar control to clear all menu items from the defined menu
%thisGuiMenuBar.clearMenuItems(%menuTarget);
See also:
GuiTickCtrl
void GuiMenuBar::clearMenus | ( | int | param1,
 |  | int | param2
 | ) |  |

Clears all the menus from the menu bar.

Example:
// Inform the GuiMenuBar control to clear all menus from itself.
%thisGuiMenuBar.clearMenus();
See also:
GuiTickCtrl
void GuiMenuBar::clearSubmenuItems | ( | string | menuTarget,
 |  | string | menuItem
 | ) |  |

Removes all the menu items from the specified submenu.

Parameters:
menuTarget | Menu to affect a submenu in
menuItem | Menu item to affect
Example:
// Define the menuTarget
%menuTarget = "New Menu";  or %menuTarget = "3";

// Define the menuItem
%menuItem = "New Menu Item";  or  %menuItem = "5";

// Inform the GuiMenuBar to remove all submenu items from the defined menu item
%thisGuiMenuBar.clearSubmenuItems(%menuTarget,%menuItem);
See also:
GuiControl
void GuiMenuBar::onMenuItemSelect | ( | string | menuId,
 |  | string | menuText,
 |  | string | menuItemId,
 |  | string | menuItemText
 | ) |  |

Called whenever an item in a menu is selected.

Parameters:
menuId | Index id of the menu which contains the selected menu item
menuText | Text of the menu which contains the selected menu item
menuItemId | Index id of the selected menu item
menuItemText | Text of the selected menu item
Example:
// A menu item has been selected, causing the callback to occur.
GuiMenuBar::onMenuItemSelect(%this,%menuId,%menuText,%menuItemId,%menuItemText)
{
   // Code to run when the callback occurs
}
See also:
GuiTickCtrl
void GuiMenuBar::onMenuSelect | ( | string | menuId,
 |  | string | menuText
 | ) |  |

Called whenever a menu is selected.

Parameters:
menuId | Index id of the clicked menu
menuText | Text of the clicked menu
Example:
// A menu has been selected, causing the callback to occur.
GuiMenuBar::onMenuSelect(%this,%menuId,%menuText)
{
   // Code to run when the callback occurs
}
See also:
GuiTickCtrl
void GuiMenuBar::onMouseInMenu ( bool isInMenu )

Called whenever the mouse enters, or persists is in the menu.

Parameters:
isInMenu True if the mouse has entered the menu, otherwise is false.
Note:
To receive this callback, call setProcessTicks(true) on the menu bar.
Example:
// Mouse enters or persists within the menu, causing the callback to occur.
GuiMenuBar::onMouseInMenu(%this,%hasLeftMenu)
{
   // Code to run when the callback occurs
}
See also:
GuiTickCtrl
void GuiMenuBar::onSubmenuSelect | ( | string | submenuId,
 |  | string | submenuText
 | ) |  |

Called whenever a submenu is selected.

Parameters:
submenuId | Id of the selected submenu
submenuText | Text of the selected submenu
Example:
GuiMenuBar::onSubmenuSelect(%this,%submenuId,%submenuText)
{
   // Code to run when the callback occurs
}
See also:
GuiTickCtrl
void GuiMenuBar::removeMenu ( string menuTarget )

Removes the specified menu from the menu bar.

Parameters:
menuTarget Menu to remove from the menu bar
Example:
// Define the menuTarget
%menuTarget = "New Menu";  or %menuTarget = "3";

// Inform the GuiMenuBar to remove the defined menu from the menu bar
%thisGuiMenuBar.removeMenu(%menuTarget);
See also:
GuiTickCtrl
void GuiMenuBar::removeMenuItem | ( | string | menuTarget,
 |  | string | menuItemTarget
 | ) |  |

Removes the specified menu item from the menu.

Parameters:
menuTarget | Menu to affect the menu item in
menuItem | Menu item to affect
Example:
// Define the menuTarget
%menuTarget = "New Menu";  or %menuTarget = "3";

// Define the menuItem
%menuItem = "New Menu Item";  or  %menuItem = "5";

// Request the GuiMenuBar control to remove the define menu item
%thisGuiMenuBar.removeMenuItem(%menuTarget,%menuItem);
See also:
GuiTickCtrl
void GuiMenuBar::setCheckmarkBitmapIndex ( int bitmapindex )

Sets the menu bitmap index for the check mark image.

Parameters:
bitmapIndex Bitmap index for the check mark image.
Example:
// Define the bitmap index
%bitmapIndex = "2";

// Inform the GuiMenuBar control of the proper bitmap index for the check mark image
%thisGuiMenuBar.setCheckmarkBitmapIndex(%bitmapIndex);
See also:
GuiTickCtrl
void GuiMenuBar::setMenuBitmapIndex | ( | string | menuTarget,
 |  | int | bitmapindex,
 |  | bool | bitmaponly,
 |  | bool | drawborder
 | ) |  |

Sets the bitmap index for the menu and toggles rendering only the bitmap.

Parameters:
menuTarget | Menu to affect
bitmapindex | Bitmap index to set for the menu
bitmaponly | If true, only the bitmap will be rendered
drawborder | If true, a border will be drawn around the menu.
Example:
// Define the menuTarget to affect
%menuTarget = "New Menu";  or %menuTarget = "3";

// Set the bitmap index
%bitmapIndex = "5";

// Set if we are only to render the bitmap or not
%bitmaponly = "true";

// Set if we are rendering a border or not
%drawborder = "true";

// Inform the GuiMenuBar of the bitmap and rendering changes
%thisGuiMenuBar.setMenuBitmapIndex(%menuTarget,%bitmapIndex,%bitmapOnly,%drawBorder);
See also:
GuiTickCtrl
void GuiMenuBar::setMenuItemBitmap | ( | string | menuTarget,
 |  | string | menuItemTarget,
 |  | int | bitmapIndex
 | ) |  |

Sets the specified menu item bitmap index in the bitmap array. Setting the item's index to -1 will remove any bitmap.

Parameters:
menuTarget | Menu to affect the menuItem in
menuItem | Menu item to affect
bitmapIndex | Bitmap index to set the menu item to
Example:
// Define the menuTarget
%menuTarget = "New Menu";  or  %menuTarget = "3";

// Define the menuItem"
%menuItem = "New Menu Item";  or %menuItem = "2";

// Define the bitmapIndex
%bitmapIndex = "6";

// Inform the GuiMenuBar control to set the menu item to the defined bitmap
%thisGuiMenuBar.setMenuItemBitmap(%menuTarget,%menuItem,%bitmapIndex);
See also:
GuiTickCtrl
void GuiMenuBar::setMenuItemChecked | ( | string | menuTarget,
 |  | string | menuItemTarget,
 |  | bool | checked
 | ) |  |

Sets the menu item bitmap to a check mark, which by default is the first element in the bitmap array (although this may be changed with setCheckmarkBitmapIndex()). Any other menu items in the menu with the same check group become unchecked if they are checked.

Parameters:
menuTarget | Menu to work in
menuItem | Menu item to affect
checked | Whether we are setting it to checked or not
Example:

Returns:
If not void, return value and description

See also:
References

void GuiMenuBar::setMenuItemEnable | ( | string | menuTarget,
 |  | string | menuItemTarget,
 |  | bool | enabled
 | ) |  |

sets the menu item to enabled or disabled based on the enable parameter. The specified menu and menu item can either be text or ids.

Detailed description

Parameters:

 menuTarget   | Menu to work in

 menuItemTarget   | The menu item inside of the menu to enable or disable

 enabled   | Boolean enable / disable value.

Example:
// Define the menu
%menu = "New Menu";  or  %menu = "4";

// Define the menu item
%menuItem = "New Menu Item";  or %menuItem = "2";

// Define the enabled state
%enabled = "true";

// Inform the GuiMenuBar control to set the enabled state of the requested menu item
%thisGuiMenuBar.setMenuItemEnable(%menu,%menuItme,%enabled);

See also:
GuiTickCtrl

void GuiMenuBar::setMenuItemSubmenuState | ( | string | menuTarget,
 |  | string | menuItem,
 |  | bool | isSubmenu
 | ) |  |

Sets the given menu item to be a submenu.

Parameters:

 menuTarget   | Menu to affect a submenu in

 menuItem   | Menu item to affect

 isSubmenu   | Whether or not the menuItem will become a subMenu or not

Example:
// Define the menuTarget
%menuTarget = "New Menu";  or %menuTarget = "3";

// Define the menuItem
%menuItem = "New Menu Item";  or  %menuItem = "5";

// Define whether or not the Menu Item is a sub menu or not
%isSubmenu = "true";

// Inform the GuiMenuBar control to set the defined menu item to be a submenu or not.
%thisGuiMenuBar.setMenuItemSubmenuState(%menuTarget,%menuItem,%isSubmenu);

See also:
GuiTickCtrl

void GuiMenuBar::setMenuItemText | ( | string | menuTarget,
 |  | string | menuItemTarget,
 |  | string | newMenuItemText
 | ) |  |

Sets the text of the specified menu item to the new string.

Parameters:

 menuTarget   | Menu to affect

 menuItem   | Menu item in the menu to change the text at

 newMenuItemText   | New menu text

Example:
// Define the menuTarget
%menuTarget = "New Menu";  or  %menuTarget = "4";

// Define the menuItem
%menuItem = "New Menu Item";  or  %menuItem = "2";

// Define the new text for the menu item
%newMenuItemText = "Very New Menu Item";

// Inform the GuiMenuBar control to change the defined menu item with the new text
%thisGuiMenuBar.setMenuItemText(%menuTarget,%menuItem,%newMenuItemText);

See also:
GuiTickCtrl

void GuiMenuBar::setMenuItemVisible | ( | string | menuTarget,
 |  | string | menuItemTarget,
 |  | bool | isVisible
 | ) |  |

Brief Description.

Detailed description

Parameters:

 menuTarget   | Menu to affect the menu item in

 menuItem   | Menu item to affect

 isVisible   | Visible state to set the menu item to.

Example:
// Define the menuTarget
%menuTarget = "New Menu";  or  %menuTarget = "3";

// Define the menuItem
%menuItem = "New Menu Item";  or  %menuItem = "2";

// Define the visibility state
%isVisible = "true";

// Inform the GuiMenuBarControl of the visibility state of the defined menu item
%thisGuiMenuBar.setMenuItemVisible(%menuTarget,%menuItem,%isVisible);

See also:
GuiTickCtrl

void GuiMenuBar::setMenuMargins | ( | int | horizontalMargin,
 |  | int | verticalMargin,
 |  | int | bitmapToTextSpacing
 | ) |  |

Sets the menu rendering margins: horizontal, vertical, bitmap spacing.

Detailed description

Parameters:

 horizontalMargin   | Number of pixels on the left and right side of a menu's text.

 verticalMargin   | Number of pixels on the top and bottom of a menu's text.

 bitmapToTextSpacing   | Number of pixels between a menu's bitmap and text.

Example:
// Define the horizontalMargin
%horizontalMargin = "5";

// Define the verticalMargin
%verticalMargin = "5";

// Define the bitmapToTextSpacing
%bitmapToTextSpacing = "12";

// Inform the GuiMenuBar control to set its margins based on the defined values.
%thisGuiMenuBar.setMenuMargins(%horizontalMargin,%verticalMargin,%bitmapToTextSpacing);

See also:
GuiTickCtrl

void GuiMenuBar::setMenuText | ( | string | menuTarget,
 |  | string | newMenuText
 | ) |  |

Sets the text of the specified menu to the new string.

Parameters:

 menuTarget   | Menu to affect

 newMenuText   | New menu text

Example:
// Define the menu to affect%menu = "New Menu";  or %menu = "3";

// Define the text to change the menu to
%newMenuText = "Still a New Menu";

// Inform the GuiMenuBar control to change the defined menu to the defined text
%thisGuiMenuBar.setMenuText(%menu,%newMenuText);

See also:
GuiTickCtrl

void GuiMenuBar::setMenuVisible | ( | string | menuTarget,
 |  | bool | visible
 | ) |  |

Sets the whether or not to display the specified menu.

Parameters:

 menuTarget   | Menu item to affect

 visible   | Whether the menu item will be visible or not

Example:
// Define the menu to work with
%menuTarget = "New Menu";  or  %menuTarget = "4";

// Define if the menu should be visible or not
%visible = "true";

// Inform the GuiMenuBar control of the new visibility state for the defined menu
%thisGuiMenuBar.setMenuVisible(%menuTarget,%visible);

See also:
GuiTickCtrl

void GuiMenuBar::setSubmenuItemChecked | ( | string | menuTarget,
 |  | string | menuItemTarget,
 |  | string | submenuItemText,
 |  | bool | checked
 | ) |  |

Sets the menu item bitmap to a check mark, which by default is the first element in the bitmap array (although this may be changed with setCheckmarkBitmapIndex()). Any other menu items in the menu with the same check group become unchecked if they are checked.

Parameters:

 menuTarget   | Menu to affect a submenu in

 menuItem   | Menu item to affect

 submenuItemText   | Text to show for submenu

 checked   | Whether or not this submenu item will be checked.

Example:
// Define the menuTarget
%menuTarget = "New Menu";  or %menuTarget = "3";

// Define the menuItem
%menuItem = "New Menu Item";  or  %menuItem = "5";

// Define the text for the new submenu
%submenuItemText = "Submenu Item";

// Define if this submenu item should be checked or not
%checked = "true";

// Inform the GuiMenuBar control to set the checked state of the defined submenu item
%thisGuiMenuBar.setSubmenuItemChecked(%menuTarget,%menuItem,%submenuItemText,%checked);

Returns:
If not void, return value and description

See also:
References

Member Data Documentation

          int GuiMenuBar::padding

Extra padding to add to the bounds of the control.


Torque 3D - Script Manual: GuiMessageVectorCtrl Class Reference

GuiMessageVectorCtrl Class Reference
[Utility Controls]

A chat HUD control that displays messages from a MessageVector. More...

Inheritance diagram for GuiMessageVectorCtrl:
[legend]

List of all members.

Public Member Functions

bool | attach (MessageVector item)
Push a line onto the back of the list.
void | detach ()
Stop listing messages from the MessageVector previously attached to, if any.

Public Attributes

string | allowedMatches [16]
int | lineContinuedIndex
int | lineSpacing
ColorI | matchColor
int | maxColorIndex

Detailed Description

A chat HUD control that displays messages from a MessageVector.

This renders messages from a MessageVector; the important thing here is that the MessageVector holds all the messages we care about, while we can destroy and create these GUI controls as needed.

Example:
// Declare ChatHud, which is what will display the actual chat from a MessageVector
new GuiMessageVectorCtrl(ChatHud) {
   profile = "ChatHudMessageProfile";
   horizSizing = "width";
   vertSizing = "height";
   position = "1 1";
   extent = "252 16";
   minExtent = "8 8";
   visible = "1";
   helpTag = "0";
   lineSpacing = "0";
   lineContinuedIndex = "10";
   matchColor = "0 0 255 255";
   maxColorIndex = "5";
};

// All messages are stored in this HudMessageVector, the actual
// MainChatHud only displays the contents of this vector.
new MessageVector(HudMessageVector);

// Attach the MessageVector to the chat control
chatHud.attach(HudMessageVector);
See also:
MessageVector for more details on how this is used

Member Function Documentation

bool GuiMessageVectorCtrl::attach ( MessageVector item )

Push a line onto the back of the list.

Parameters:
item The GUI element being pushed into the control
Example:
// All messages are stored in this HudMessageVector, the actual
// MainChatHud only displays the contents of this vector.
new MessageVector(HudMessageVector);

// Attach the MessageVector to the chat control
chatHud.attach(HudMessageVector);
Returns:
Value
void GuiMessageVectorCtrl::detach ( )

Stop listing messages from the MessageVector previously attached to, if any.

Detailed description

Parameters:
param Description
Example:
// Deatch the MessageVector from HudMessageVector
// HudMessageVector will no longer render the text
chatHud.detach();

Member Data Documentation

string GuiMessageVectorCtrl::allowedMatches[16]
int GuiMessageVectorCtrl::lineContinuedIndex
int GuiMessageVectorCtrl::lineSpacing
ColorI GuiMessageVectorCtrl::matchColor
int GuiMessageVectorCtrl::maxColorIndex


Torque 3D - Script Manual: GuiMLTextCtrl Class Reference

GuiMLTextCtrl Class Reference
[Core Controls]

A text control that uses the Gui Markup Language ('ML') tags to dynamically change the text. More...

Inheritance diagram for GuiMLTextCtrl:
[legend]

List of all members.

Public Member Functions

void | addText (string text, bool reformat)
Appends the text in the control with additional text. Also .
void | forceReflow ()
Forces the text control to reflow the text after new text is added, possibly resizing the control.
string | getText ()
Returns the text from the control, including TorqueML characters.
void | scrollToBottom ()
Scroll to the bottom of the text.
void | scrollToTag (int tagID)
Scroll down to a specified tag.
void | scrollToTop (int param1, int param2)
Scroll to the top of the text.
void | setAlpha (float alphaVal)
Sets the alpha value of the control.
bool | setCursorPosition (int newPos)
Change the text cursor's position to a new defined offset within the text in the control.
void | setText (string text)
Set the text contained in the control.
Callbacks

void | onResize (string width, string maxY)
Called whenever the control size changes.
void | onURL (string url)
Called whenever a URL was clicked on within the control.

Public Attributes

Text

bool | allowColorChars
If true, the control will allow characters to have unique colors.
SFXTrack deniedSound
If the text will not fit in the control, the deniedSound is played.
int | lineSpacing
The number of blank pixels to place between each line.
int | maxChars
Maximum number of characters that the control will display.
caseString | text
Text to display in this control.
bool | useURLMouseCursor
If true, the mouse cursor will turn into a hand cursor while over a link in the text.

Detailed Description

A text control that uses the Gui Markup Language ('ML') tags to dynamically change the text.

Example of dynamic changes include colors, styles, and/or hyperlinks. These changes can occur without having to use separate text controls with separate text profiles.

Example:
new GuiMLTextCtrl(CenterPrintText)
{
    lineSpacing = "2";
    allowColorChars = "0";
    maxChars = "-1";
    deniedSound = "DeniedSoundProfile";
    text = "The Text for This Control.";
    useURLMouseCursor = "true";
    //Properties not specific to this control have been omitted from this example.
};
See also:
GuiControl

Member Function Documentation

void GuiMLTextCtrl::addText | ( | string | text,
 |  | bool | reformat
 | ) |  |

Appends the text in the control with additional text. Also .

Parameters:
text | New text to append to the existing text.
reformat | If true, the control will also be visually reset.
Example:
// Define new text to add
%text = "New Text to Add";

// Set reformat boolean
%reformat = "true";

// Inform the control to add the new text
%thisGuiMLTextCtrl.addText(%text,%reformat);
See also:
GuiControl
void GuiMLTextCtrl::forceReflow ( )

Forces the text control to reflow the text after new text is added, possibly resizing the control.

Example:
// Define new text to add
%newText = "BACON!";

// Add the new text to the control
%thisGuiMLTextCtrl.addText(%newText);

// Inform the GuiMLTextCtrl object to force a reflow to ensure the added text fits properly.
%thisGuiMLTextCtrl.forceReflow();
See also:
GuiControl
string GuiMLTextCtrl::getText ( )

Returns the text from the control, including TorqueML characters.

Example:
// Get the text displayed in the control
%controlText = %thisGuiMLTextCtrl.getText();
Returns:
Text string displayed in the control, including any TorqueML characters.
See also:
GuiControl
void GuiMLTextCtrl::onResize | ( | string | width,
 |  | string | maxY
 | ) |  |

Called whenever the control size changes.

Parameters:
width | The new width value for the control
maxY | The current maximum allowed Y value for the control
Example:
// Control size changed, causing the callback to occur.
GuiMLTextCtrl::onResize(%this,%width,%maxY)
   {
      // Code to call when the control size changes
   }
See also:
GuiControl
void GuiMLTextCtrl::onURL ( string url )

Called whenever a URL was clicked on within the control.

Parameters:
url The URL address that was clicked on.
Example:
// A URL address was clicked on in the control, causing the callback to occur.
GuiMLTextCtrl::onUrl(%this,%url)
   {
      // Code to run whenever a URL was clicked on
   }
See also:
GuiControl
void GuiMLTextCtrl::scrollToBottom ( )

Scroll to the bottom of the text.

Example:
// Inform GuiMLTextCtrl object to scroll to its bottom
%thisGuiMLTextCtrl.scrollToBottom();
See also:
GuiControl
void GuiMLTextCtrl::scrollToTag ( int tagID )

Scroll down to a specified tag.

Detailed description

Parameters:
tagID TagID to scroll the control to
Example:
// Define the TagID we want to scroll the control to
%tagId = "4";

// Inform the GuiMLTextCtrl to scroll to the defined TagID
%thisGuiMLTextCtrl.scrollToTag(%tagId);
See also:
GuiControl
void GuiMLTextCtrl::scrollToTop | ( | int | param1,
 |  | int | param2
 | ) |  |

Scroll to the top of the text.

Example:
// Inform GuiMLTextCtrl object to scroll to its top
%thisGuiMLTextCtrl.scrollToTop();
See also:
GuiControl
void GuiMLTextCtrl::setAlpha ( float alphaVal )

Sets the alpha value of the control.

Parameters:
alphaVal n - 1.0 floating value for the alpha
Example:
// Define the alphe value
%alphaVal = "0.5";

// Inform the control to update its alpha value.
%thisGuiMLTextCtrl.setAlpha(%alphaVal);
See also:
GuiControl
bool GuiMLTextCtrl::setCursorPosition ( int newPos )

Change the text cursor's position to a new defined offset within the text in the control.

Parameters:
newPos Offset to place cursor.
Example:
// Define cursor offset position
%position = "23";

// Inform the GuiMLTextCtrl object to move the cursor to the new position.
%thisGuiMLTextCtrl.setCursorPosition(%position);
Returns:
Returns true if the cursor position moved, or false if the position was not changed.
See also:
GuiControl
void GuiMLTextCtrl::setText ( string text )

Set the text contained in the control.

Parameters:
text The text to display in the control.
Example:
// Define the text to display
%text = "Nifty Control Text";

// Set the text displayed within the control
%thisGuiMLTextCtrl.setText(%text);
See also:
GuiControl

Member Data Documentation

bool GuiMLTextCtrl::allowColorChars

If true, the control will allow characters to have unique colors.

SFXTrack GuiMLTextCtrl::deniedSound

If the text will not fit in the control, the deniedSound is played.

int GuiMLTextCtrl::lineSpacing

The number of blank pixels to place between each line.

int GuiMLTextCtrl::maxChars

Maximum number of characters that the control will display.

caseString GuiMLTextCtrl::text

Text to display in this control.

bool GuiMLTextCtrl::useURLMouseCursor

If true, the mouse cursor will turn into a hand cursor while over a link in the text.

This is dependant on the markup language used by the GuiMLTextCtrl


Torque 3D - Script Manual: GuiMLTextEditCtrl Class Reference

GuiMLTextEditCtrl Class Reference
[General Controls]

A text entry control that accepts the Gui Markup Language ('ML') tags and multiple lines. More...

Inheritance diagram for GuiMLTextEditCtrl:
[legend]

List of all members.

Public Attributes

string escapeCommand
Script function to run whenever the 'escape' key is pressed when this control is in focus.

Detailed Description

A text entry control that accepts the Gui Markup Language ('ML') tags and multiple lines.

Example:
new GuiMLTextEditCtrl()
   {
      lineSpacing = "2";
      allowColorChars = "0";
      maxChars = "-1";
      deniedSound = "DeniedSoundProfile";
      text = "";
      escapeCommand = "onEscapeScriptFunction();";
     //Properties not specific to this control have been omitted from this example.
   };
See also:
GuiMLTextCtrl
GuiControl

Member Data Documentation

string GuiMLTextEditCtrl::escapeCommand

Script function to run whenever the 'escape' key is pressed when this control is in focus.


Torque 3D - Script Manual: GuiMouseEventCtrl Class Reference

GuiMouseEventCtrl Class Reference
[Core Controls]

Used to overlaps a 'hot region' where you want to catch inputs with and have specific events occur based on individual callbacks. More...

Inheritance diagram for GuiMouseEventCtrl:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onMouseDown (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the mouse is pressed down while in this control.
void | onMouseDragged (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the mouse is dragged while in this control.
void | onMouseEnter (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the mouse enters this control.
void | onMouseLeave (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the mouse leaves this control.
void | onMouseMove (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the mouse is moved (without dragging) while in this control.
void | onMouseUp (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the mouse is released while in this control.
void | onRightMouseDown (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the right mouse button is pressed while in this control.
void | onRightMouseDragged (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the mouse is dragged in this control while the right mouse button is pressed.
void | onRightMouseUp (U8 modifier, Point2I mousePoint, U8 mouseClickCount)
Callback that occurs whenever the right mouse button is released while in this control.

Public Attributes

Input

bool | lockMouse
Whether the control should lock the mouse between up and down button events.

Detailed Description

Used to overlaps a 'hot region' where you want to catch inputs with and have specific events occur based on individual callbacks.

Mouse event callbacks supported by this control are: onMouseUp, onMouseDown, onMouseMove, onMouseDragged, onMouseEnter, onMouseLeave, onRightMouseDown, onRightMouseUp and onRightMouseDragged.

Example:
new GuiMouseEventCtrl()
{
   lockMouse = "0";
   //Properties not specific to this control have been omitted from this example.
};
See also:
GuiControl

Member Function Documentation

void GuiMouseEventCtrl::onMouseDown | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the mouse is pressed down while in this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Mouse was pressed down in this control, causing the callback
GuiMouseEventCtrl::onMouseDown(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onMouseDragged | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the mouse is dragged while in this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Mouse was dragged in this control, causing the callback
GuiMouseEventCtrl::onMouseDragged(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onMouseEnter | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the mouse enters this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Mouse entered this control, causing the callback
GuiMouseEventCtrl::onMouseEnter(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onMouseLeave | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the mouse leaves this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Mouse left this control, causing the callback
GuiMouseEventCtrl::onMouseLeave(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onMouseMove | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the mouse is moved (without dragging) while in this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Mouse was moved in this control, causing the callback
GuiMouseEventCtrl::onMouseMove(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onMouseUp | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the mouse is released while in this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Mouse was released in this control, causing the callback
GuiMouseEventCtrl::onMouseUp(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onRightMouseDown | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the right mouse button is pressed while in this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Right mouse button was pressed in this control, causing the callback
GuiMouseEventCtrl::onRightMouseDown(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onRightMouseDragged | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the mouse is dragged in this control while the right mouse button is pressed.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Right mouse button was dragged in this control, causing the callback
GuiMouseEventCtrl::onRightMouseDragged(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl
void GuiMouseEventCtrl::onRightMouseUp | ( | U8 | modifier,
 |  | Point2I | mousePoint,
 |  | U8 | mouseClickCount
 | ) |  |

Callback that occurs whenever the right mouse button is released while in this control.

Parameters:
modifier Key that was pressed during this callback. Values are:

$EventModifier::RSHIFT

$EventModifier::SHIFT

$EventModifier::LCTRL

$EventModifier::RCTRL

$EventModifier::CTRL

$EventModifier::CTRL

$EventModifier::RALT

$EventModifier::ALT

Parameters:
mousePoint | X/Y location of the mouse point
mouseClickCount | How many mouse clicks have occured for this event
Example:
// Right mouse button was released in this control, causing the callback
GuiMouseEventCtrl::onRightMouseUp(%this,%modifier,%mousePoint,%mouseClickCount)
{
   // Code to call when a mouse event occurs.
}
See also:
GuiControl

Member Data Documentation

bool GuiMouseEventCtrl::lockMouse

Whether the control should lock the mouse between up and down button events.


Torque 3D - Script Manual: GuiObjectView Class Reference

GuiObjectView Class Reference
[3D Controls]

GUI control which displays a 3D model. More...

Inheritance diagram for GuiObjectView:
[legend]

List of all members.

Public Member Functions

float | getCameraSpeed ()
Return the current multiplier for camera zooming and rotation.
string | getModel ()
Return the model displayed in this view.
string | getMountedModel ()
Return the name of the mounted model.
string | getMountSkin (int param1, int param2)
Return the name of skin used on the mounted model.
float | getOrbitDistance ()
Return the current distance at which the camera orbits the object.
string | getSkin ()
Return the name of skin used on the primary model.
void | setCameraSpeed (float factor)
Sets the multiplier for the camera rotation and zoom speed.
void | setLightAmbient (ColorF color)
Set the light ambient color on the sun object used to render the model.
void | setLightColor (ColorF color)
Set the light color on the sun object used to render the model.
void | setLightDirection (Point3F direction)
Set the light direction from which to light the model.
void | setModel (string shapeName)
Sets the model to be displayed in this control.
void | setMount (string shapeName, string mountNodeIndexOrName)
Mounts the given model to the specified mount point of the primary model displayed in this control.
void | setMountedModel (string shapeName)
Sets the model to be mounted on the primary model.
void | setMountSkin (string skinName)
Sets the skin to use on the mounted model.
void | setOrbitDistance (float distance)
Sets the distance at which the camera orbits the object. Clamped to the acceptable range defined in the class by min and max orbit distances.
void | setSeq (string indexOrName)
Sets the animation to play for the viewed object.
void | setSkin (string skinName)
Sets the skin to use on the model being displayed.
Callbacks

void | onMouseEnter ()
Called whenever the mouse enters the control.
void | onMouseLeave ()
Called whenever the mouse leaves the control.

Public Attributes

Animation

string | animSequence
The animation sequence to play on the model.
Camera

float | cameraSpeed
Multiplier for mouse camera operations.
float | maxOrbitDiststance
Minimum distance below which the camera will not zoom in further.
float | minOrbitDiststance
Maxiumum distance to which the camera can be zoomed out.
float | orbitDiststance
Distance from which to render the model.
Lighting

ColorF | lightAmbient
Ambient color of the sunlight used to render the model.
ColorF | lightColor
Diffuse color of the sunlight used to render the model.
Point3F | lightDirection
Direction from which the model is illuminated.
Mounting

string | mountedNode
Name of node on primary model to which to mount the secondary shape.
filename | mountedShapeFile
Optional shape file to mount on the primary model (e.g. weapon).
string | mountedSkin
Skin name used on mounted shape file.
Model

filename | shapeFile
The object model shape file to show in the view.
string | skin
The skin to use on the object model.

Detailed Description

GUI control which displays a 3D model.

Model displayed in the control can have other objects mounted onto it, and the light settings can be adjusted.

Example:
   new GuiObjectView(ObjectPreview)
   {
      shapeFile = "art/shapes/items/kit/healthkit.dts";
      mountedNode = "mount0";
      lightColor = "1 1 1 1";
      lightAmbient = "0.5 0.5 0.5 1";
      lightDirection = "0 0.707 -0.707";
      orbitDiststance = "2";
      minOrbitDiststance = "0.917688";
      maxOrbitDiststance = "5";
      cameraSpeed = "0.01";
      cameraZRot = "0";
      forceFOV = "0";
      reflectPriority = "0";
   };
See also:
GuiControl

Member Function Documentation

float GuiObjectView::getCameraSpeed ( )

Return the current multiplier for camera zooming and rotation.

Example:
// Request the current camera zooming and rotation multiplier value
%multiplier = %thisGuiObjectView.getCameraSpeed();
Returns:
Camera zooming / rotation multiplier value.
See also:
GuiControl
string GuiObjectView::getModel ( )

Return the model displayed in this view.

Example:
// Request the displayed model name from the GuiObjectView object.
%modelName = %thisGuiObjectView.getModel();
Returns:
Name of the displayed model.
See also:
GuiControl
string GuiObjectView::getMountedModel ( )

Return the name of the mounted model.

Example:
// Request the name of the mounted model from the GuiObjectView object
%mountedModelName = %thisGuiObjectView.getMountedModel();
Returns:
Name of the mounted model.
See also:
GuiControl
string GuiObjectView::getMountSkin | ( | int | param1,
 |  | int | param2
 | ) |  |

Return the name of skin used on the mounted model.

Example:
// Request the skin name from the model mounted on to the main model in the control
%mountModelSkin = %thisGuiObjectView.getMountSkin();
Returns:
Name of the skin used on the mounted model.
See also:
GuiControl
float GuiObjectView::getOrbitDistance ( )

Return the current distance at which the camera orbits the object.

Example:
// Request the current orbit distance
%orbitDistance = %thisGuiObjectView.getOrbitDistance();
Returns:
The distance at which the camera orbits the object.
See also:
GuiControl
string GuiObjectView::getSkin ( )

Return the name of skin used on the primary model.

Example:
// Request the name of the skin used on the primary model in the control
%skinName = %thisGuiObjectView.getSkin();
Returns:
Name of the skin used on the primary model.
See also:
GuiControl
void GuiObjectView::onMouseEnter ( )

Called whenever the mouse enters the control.

Example:
// The mouse has entered the control, causing the callback to occur
GuiObjectView::onMouseEnter(%this)
   {
      // Code to run when the mouse enters this control
   }
See also:
GuiControl
void GuiObjectView::onMouseLeave ( )

Called whenever the mouse leaves the control.

Example:
// The mouse has left the control, causing the callback to occur
GuiObjectView::onMouseLeave(%this)
   {
      // Code to run when the mouse leaves this control
   }
See also:
GuiControl
void GuiObjectView::setCameraSpeed ( float factor )

Sets the multiplier for the camera rotation and zoom speed.

Parameters:
factor Multiplier for camera rotation and zoom speed.
Example:
// Set the factor value
%factor = "0.75";

// Inform the GuiObjectView object to set the camera speed.
%thisGuiObjectView.setCameraSpeed(%factor);
See also:
GuiControl
void GuiObjectView::setLightAmbient ( ColorF color )

Set the light ambient color on the sun object used to render the model.

Parameters:
color Ambient color of sunlight.
Example:
// Define the sun ambient color value
%color = "1.0 0.4 0.6";

// Inform the GuiObjectView object to set the sun ambient color to the requested value
%thisGuiObjectView.setLightAmbient(%color);
See also:
GuiControl
void GuiObjectView::setLightColor ( ColorF color )

Set the light color on the sun object used to render the model.

Parameters:
color Color of sunlight.
Example:
// Set the color value for the sun
%color = "1.0 0.4 0.5";

// Inform the GuiObjectView object to change the sun color to the defined value
%thisGuiObjectView.setLightColor(%color);
See also:
GuiControl
void GuiObjectView::setLightDirection ( Point3F direction )

Set the light direction from which to light the model.

Parameters:
direction XYZ direction from which the light will shine on the model
Example:
// Set the light direction
%direction = "1.0 0.2 0.4"

// Inform the GuiObjectView object to change the light direction to the defined value
%thisGuiObjectView.setLightDirection(%direction);
See also:
GuiControl
void GuiObjectView::setModel ( string shapeName )

Sets the model to be displayed in this control.

Parameters:
shapeName Name of the model to display.
Example:
// Define the model we want to display
%shapeName = "gideon.dts";

// Tell the GuiObjectView object to display the defined model
%thisGuiObjectView.setModel(%shapeName);
See also:
GuiControl
void GuiObjectView::setMount | ( | string | shapeName,
 |  | string | mountNodeIndexOrName
 | ) |  |

Mounts the given model to the specified mount point of the primary model displayed in this control.

Detailed description

Parameters:
shapeName | Name of the model to mount.
mountNodeIndexOrName | Index or name of the mount point to be mounted to. If index, corresponds to "mountN" in your shape where N is the number passed here.
Example:
// Set the shapeName to mount
%shapeName = "GideonGlasses.dts"

// Set the mount node of the primary model in the control to mount the new shape at
%mountNodeIndexOrName = "3";
//OR:
%mountNodeIndexOrName = "Face";

// Inform the GuiObjectView object to mount the shape at the specified node.
%thisGuiObjectView.setMount(%shapeName,%mountNodeIndexOrName);
See also:
GuiControl
void GuiObjectView::setMountedModel ( string shapeName )

Sets the model to be mounted on the primary model.

Parameters:
shapeName Name of the model to mount.
Example:
// Define the model name to mount
%modelToMount = "GideonGlasses.dts";

// Inform the GuiObjectView object to mount the defined model to the existing model in the control
%thisGuiObjectView.setMountedModel(%modelToMount);
See also:
GuiControl
void GuiObjectView::setMountSkin ( string skinName )

Sets the skin to use on the mounted model.

Parameters:
skinName Name of the skin to set on the model mounted to the main model in the control
Example:
// Define the name of the skin
%skinName = "BronzeGlasses";

// Inform the GuiObjectView Control of the skin to use on the mounted model
%thisGuiObjectViewCtrl.setMountSkin(%skinName);
See also:
GuiControl
void GuiObjectView::setOrbitDistance ( float distance )

Sets the distance at which the camera orbits the object. Clamped to the acceptable range defined in the class by min and max orbit distances.

Detailed description

Parameters:
distance The distance to set the orbit to (will be clamped).
Example:
// Define the orbit distance value
%orbitDistance = "1.5";

// Inform the GuiObjectView object to set the orbit distance to the defined value
%thisGuiObjectView.setOrbitDistance(%orbitDistance);
See also:
GuiControl
void GuiObjectView::setSeq ( string indexOrName )

Sets the animation to play for the viewed object.

Parameters:
indexOrName The index or name of the animation to play.
Example:
// Set the animation index value, or animation sequence name.
%indexVal = "3";
//OR:
%indexVal = "idle";

// Inform the GuiObjectView object to set the animation sequence of the object in the control.
%thisGuiObjectVew.setSeq(%indexVal);
See also:
GuiControl
void GuiObjectView::setSkin ( string skinName )

Sets the skin to use on the model being displayed.

Parameters:
skinName Name of the skin to use.
Example:
// Define the skin we want to apply to the main model in the control
%skinName = "disco_gideon";

// Inform the GuiObjectView control to update the skin the to defined skin
%thisGuiObjectView.setSkin(%skinName);
See also:
GuiControl

Member Data Documentation

string GuiObjectView::animSequence

The animation sequence to play on the model.

float GuiObjectView::cameraSpeed

Multiplier for mouse camera operations.

ColorF GuiObjectView::lightAmbient

Ambient color of the sunlight used to render the model.

ColorF GuiObjectView::lightColor

Diffuse color of the sunlight used to render the model.

Point3F GuiObjectView::lightDirection

Direction from which the model is illuminated.

float GuiObjectView::maxOrbitDiststance

Minimum distance below which the camera will not zoom in further.

float GuiObjectView::minOrbitDiststance

Maxiumum distance to which the camera can be zoomed out.

string GuiObjectView::mountedNode

Name of node on primary model to which to mount the secondary shape.

filename GuiObjectView::mountedShapeFile

Optional shape file to mount on the primary model (e.g. weapon).

string GuiObjectView::mountedSkin

Skin name used on mounted shape file.

float GuiObjectView::orbitDiststance

Distance from which to render the model.

filename GuiObjectView::shapeFile

The object model shape file to show in the view.

string GuiObjectView::skin

The skin to use on the object model.


Torque 3D - Script Manual: GuiPaneControl Class Reference

GuiPaneControl Class Reference
[Container Controls]

A collapsable pane control. More...

Inheritance diagram for GuiPaneControl:
[legend]

List of all members.

Public Member Functions

void | setCollapsed (bool collapse)
Collapse or un-collapse the control.

Public Attributes

Pane

bool | barBehindText
Whether to draw the bitmapped pane bar behind the header text, too.
string | caption
Text label to display as the pane header.
string | captionID
String table text ID to use as caption string (overrides 'caption').
bool | collapsable
Whether the pane can be collapsed by clicking its header.

Detailed Description

A collapsable pane control.

This class wraps a single child control and displays a header with caption above it. If you click the header it will collapse or expand (if collapsable is enabled). The control resizes itself based on its collapsed/expanded size.
In the GUI editor, if you just want the header you can make collapsable false. The caption field lets you set the caption; it expects a bitmap (from the GuiControlProfile) that contains two images - the first is displayed when the control is expanded and the second is displayed when it is collapsed. The header is sized based on the first image.

Example:
new GuiPaneControl()
{
   caption = "Example Pane";
   collapsable = "1";
   barBehindText = "1";
   //Properties not specific to this control have been omitted from this example.
};

Member Function Documentation

void GuiPaneControl::setCollapsed ( bool collapse )

Collapse or un-collapse the control.

Parameters:
collapse True to collapse the control, false to un-collapse it

Member Data Documentation

bool GuiPaneControl::barBehindText

Whether to draw the bitmapped pane bar behind the header text, too.

string GuiPaneControl::caption

Text label to display as the pane header.

string GuiPaneControl::captionID

String table text ID to use as caption string (overrides 'caption').

bool GuiPaneControl::collapsable

Whether the pane can be collapsed by clicking its header.


Torque 3D - Script Manual: GuiPanel Class Reference

GuiPanel Class Reference
[Container Controls]

The GuiPanel panel is a container that when opaque will draw a left to right gradient using its profile fill and fill highlight colors. More...

Inheritance diagram for GuiPanel:
[legend]

List of all members.

Detailed Description

The GuiPanel panel is a container that when opaque will draw a left to right gradient using its profile fill and fill highlight colors.

Example:
// Mandatory GuiDefaultProfile
// Contains the fill color information required by a GuiPanel
// Some values left out for sake of this example
new GuiControlProfile (GuiDefaultProfile)
{
   // fill color
   opaque = false;
   fillColor = "242 241 240";
   fillColorHL ="228 228 235";
   fillColorSEL = "98 100 137";
   fillColorNA = "255 255 255 ";
};

new GuiPanel(TestPanel)
{
   position = "45 33";
   extent = "342 379";
   minExtent = "16 16";
   horizSizing = "right";
   vertSizing = "bottom";
   profile = "GuiDefaultProfile"; // Color fill info is in this profile
   isContainer = "1";
};
See also:
GuiControlProfile


Torque 3D - Script Manual: GuiPopUpMenuCtrl Class Reference

GuiPopUpMenuCtrl Class Reference
[General Controls]

A control that allows to select a value from a drop-down list. More...

Inheritance diagram for GuiPopUpMenuCtrl:
[legend]

List of all members.

Public Member Functions

void | add (string name, int idNum, int scheme=0)
void | addScheme (int id, ColorI fontColor, ColorI fontColorHL, ColorI fontColorSEL)
void | changeTextById (int id, string text)
void | clearEntry (S32 entry)
int | findText (string text)
Returns the position of the first entry containing the specified text.
string | getTextById (int id)
void | replaceText (bool doReplaceText)
void | setEnumContent (string class, string enum)
This fills the popup with a classrep's field enumeration type info.
void | setFirstSelected ([scriptCallback=true])
void | setSelected (int id,[scriptCallback=true])

Public Attributes

filename | bitmap
Point2I | bitmapBounds
void | clear
Clear the popup list.
void | forceClose
void | forceOnAction
int | getSelected
string | getText
int | maxPopupHeight
bool | reverseTextList
bool | sbUsesNAColor
void | setNoneSelected
int | size
Get the size of the menu - the number of entries in it.
void | sort
Sort the list alphabetically.
void | sortID
Sort the list by ID.

Detailed Description

A control that allows to select a value from a drop-down list.

For a nearly identical GUI with additional features, use GuiPopUpMenuCtrlEx.

Example:
new GuiPopUpMenuCtrl()
{
   maxPopupHeight = "200";
   sbUsesNAColor = "0";
   reverseTextList = "0";
   bitmapBounds = "16 16";
   maxLength = "1024";
   position = "56 31";
   extent = "64 64";
   minExtent = "8 2";
   profile = "GuiPopUpMenuProfile";
   tooltipProfile = "GuiToolTipProfile";
};
Note:
This is definitely going to be deprecated soon.
See also:
GuiPopUpMenuCtrlEx for more features and better explanations.

Member Function Documentation

void GuiPopUpMenuCtrl::add | ( | string | name,
 |  | int | idNum,
 |  | int | scheme = 0
 | ) |  |
void GuiPopUpMenuCtrl::addScheme | ( | int | id,
 |  | ColorI | fontColor,
 |  | ColorI | fontColorHL,
 |  | ColorI | fontColorSEL
 | ) |  |
void GuiPopUpMenuCtrl::changeTextById | ( | int | id,
 |  | string | text
 | ) |  |
void GuiPopUpMenuCtrl::clearEntry ( S32 entry )
int GuiPopUpMenuCtrl::findText ( string text )

Returns the position of the first entry containing the specified text.

string GuiPopUpMenuCtrl::getTextById ( int id )
void GuiPopUpMenuCtrl::replaceText ( bool doReplaceText )
void GuiPopUpMenuCtrl::setEnumContent | ( | string | class,
 |  | string | enum
 | ) |  |

This fills the popup with a classrep's field enumeration type info.

More of a helper function than anything. If console access to the field list is added, at least for the enumerated types, then this should go away..

void GuiPopUpMenuCtrl::setFirstSelected ( )
void GuiPopUpMenuCtrl::setSelected ( int id )

Member Data Documentation

filename GuiPopUpMenuCtrl::bitmap
Point2I GuiPopUpMenuCtrl::bitmapBounds
void GuiPopUpMenuCtrl::clear

Clear the popup list.

void GuiPopUpMenuCtrl::forceClose
void GuiPopUpMenuCtrl::forceOnAction
int GuiPopUpMenuCtrl::getSelected
string GuiPopUpMenuCtrl::getText
int GuiPopUpMenuCtrl::maxPopupHeight
bool GuiPopUpMenuCtrl::reverseTextList
bool GuiPopUpMenuCtrl::sbUsesNAColor
void GuiPopUpMenuCtrl::setNoneSelected
int GuiPopUpMenuCtrl::size

Get the size of the menu - the number of entries in it.

void GuiPopUpMenuCtrl::sort

Sort the list alphabetically.

void GuiPopUpMenuCtrl::sortID

Sort the list by ID.


Torque 3D - Script Manual: GuiPopUpMenuCtrlEx Class Reference

GuiPopUpMenuCtrlEx Class Reference
[General Controls]

A control that allows to select a value from a drop-down list. More...

Inheritance diagram for GuiPopUpMenuCtrlEx:
[legend]

List of all members.

Public Member Functions

void | add (string name, int idNum, int scheme=0)
void | add (string name, S32 idNum, S32 scheme=0)
Adds an entry to the list.
void | addCategory (string text)
Add a category to the list.
void | addScheme (int id, ColorI fontColor, ColorI fontColorHL, ColorI fontColorSEL)
Create a new scheme and add it to the list of choices for when a new text entry is added.
void | clear ()
Clear the popup list.
void | clearEntry (S32 entry)
int | findText (string text)
Returns the id of the first entry containing the specified text or -1 if not found.
void | forceClose ()
Manually force this control to collapse and close.
void | forceOnAction ()
Manually for the onAction function, which updates everything in this control.
int | getSelected ()
Get the current selection of the menu.
string | getText ()
Get the.
string | getTextById (int id)
Get the text of an entry based on an ID.
void | setNoneSelected (int param)
Clears selection in the menu.
setSelected (int id, bool scriptCallback=true)
setSelected (bool scriptCallback=true)
void | setText (string text)
Set the current text to a specified value.
void | sort ()
Sort the list alphabetically.
void | sortID ()
Sort the list by ID.

Public Attributes

filename | bitmap
File name of bitmap to use.
Point2I | bitmapBounds
Boundaries of bitmap displayed.
string | getColorById
Get color of an entry's box.
bool | hotTrackCallback
Whether to provide a 'onHotTrackItem' callback when a list item is hovered over.
int | maxPopupHeight
Length of menu when it extends.
void | replaceText
Flag that causes each new text addition to replace the current entry.
bool | reverseTextList
Reverses text list if popup extends up, instead of down.
bool | sbUsesNAColor
Deprecated.
void | setEnumContent
This fills the popup with a classrep's field enumeration type info.
int | size
Get the size of the menu.

Detailed Description

A control that allows to select a value from a drop-down list.

This is essentially a GuiPopUpMenuCtrl, but with quite a few more features.

Example:
new GuiPopUpMenuCtrlEx()
{
   maxPopupHeight = "200";
   sbUsesNAColor = "0";
   reverseTextList = "0";
   bitmapBounds = "16 16";
   hotTrackCallback = "0";
   extent = "64 64";
   profile = "GuiDefaultProfile";
   tooltipProfile = "GuiToolTipProfile";
};
See also:
GuiPopUpMenuCtrl

Member Function Documentation

void GuiPopUpMenuCtrlEx::add | ( | string | name,
 |  | int | idNum,
 |  | int | scheme = 0
 | ) |  |
void GuiPopUpMenuCtrlEx::add | ( | string | name,
 |  | S32 | idNum,
 |  | S32 | scheme = 0
 | ) |  |

Adds an entry to the list.

Parameters:
name | String containing the name of the entry
idNum | Numerical value assigned to the name
scheme | Optional ID associated with a scheme for font coloring, highlight coloring, and selection coloring
void GuiPopUpMenuCtrlEx::addCategory ( string text )

Add a category to the list.

Acts as a separator between entries, allowing for sub-lists

Parameters:
text Name of the new category
void GuiPopUpMenuCtrlEx::addScheme | ( | int | id,
 |  | ColorI | fontColor,
 |  | ColorI | fontColorHL,
 |  | ColorI | fontColorSEL
 | ) |  |

Create a new scheme and add it to the list of choices for when a new text entry is added.

Parameters:
id | Numerical id associated with this scheme
fontColor | The base text font color. Formatted as "Red Green Blue", each a numerical between 0 and 255.
fontColorHL | Color of text when being highlighted. Formatted as "Red Green Blue", each a numerical between 0 and 255.
fontColorSel | Color of text when being selected. Formatted as "Red Green Blue", each a numerical between 0 and 255.
void GuiPopUpMenuCtrlEx::clear ( )

Clear the popup list.

Reimplemented from SimSet.

void GuiPopUpMenuCtrlEx::clearEntry ( S32 entry )
int GuiPopUpMenuCtrlEx::findText ( string text )

Returns the id of the first entry containing the specified text or -1 if not found.

Parameters:
text String value used for the query
Returns:
Numerical ID of entry containing the text.
void GuiPopUpMenuCtrlEx::forceClose ( )

Manually force this control to collapse and close.

void GuiPopUpMenuCtrlEx::forceOnAction ( )

Manually for the onAction function, which updates everything in this control.

int GuiPopUpMenuCtrlEx::getSelected ( )

Get the current selection of the menu.

Returns:
Returns the ID of the currently selected entry
string GuiPopUpMenuCtrlEx::getText ( )

Get the.

Detailed description

Parameters:
param Description
Example:
// Comment
code();
Returns:
Returns current text in string format
string GuiPopUpMenuCtrlEx::getTextById ( int id )

Get the text of an entry based on an ID.

Parameters:
id The ID assigned to the entry being queried
Returns:
String contained by the specified entry, NULL if empty or bad ID
void GuiPopUpMenuCtrlEx::setNoneSelected ( int param )

Clears selection in the menu.

GuiPopUpMenuCtrlEx::setSelected | ( | int | id,
 |  | bool | scriptCallback = true
 | ) |  |

brief Manually set an entry as selected int his control

Parameters:
id | The ID of the entry to select
scripCallback | Optional boolean that forces the script callback if true
GuiPopUpMenuCtrlEx::setSelected ( bool scriptCallback = true )

brief Manually set the selection to the first entry

Parameters:
scripCallback Optional boolean that forces the script callback if true
void GuiPopUpMenuCtrlEx::setText ( string text )

Set the current text to a specified value.

Parameters:
text String containing new text to set

Reimplemented from GuiTextCtrl.

void GuiPopUpMenuCtrlEx::sort ( )

Sort the list alphabetically.

void GuiPopUpMenuCtrlEx::sortID ( )

Sort the list by ID.

Member Data Documentation

filename GuiPopUpMenuCtrlEx::bitmap

File name of bitmap to use.

Point2I GuiPopUpMenuCtrlEx::bitmapBounds

Boundaries of bitmap displayed.

string GuiPopUpMenuCtrlEx::getColorById

Get color of an entry's box.

Parameters:
id ID number of entry to query
Returns:
ColorI in the format of "Red Green Blue Alpha", each of with is a value between 0 - 255
bool GuiPopUpMenuCtrlEx::hotTrackCallback

Whether to provide a 'onHotTrackItem' callback when a list item is hovered over.

int GuiPopUpMenuCtrlEx::maxPopupHeight

Length of menu when it extends.

void GuiPopUpMenuCtrlEx::replaceText

Flag that causes each new text addition to replace the current entry.

Parameters:
True to turn on replacing, false to disable it
bool GuiPopUpMenuCtrlEx::reverseTextList

Reverses text list if popup extends up, instead of down.

bool GuiPopUpMenuCtrlEx::sbUsesNAColor

Deprecated.

void GuiPopUpMenuCtrlEx::setEnumContent

This fills the popup with a classrep's field enumeration type info.

More of a helper function than anything. If console access to the field list is added, at least for the enumerated types, then this should go away.

Parameters:
class | Name of the class containing the enum
enum | Name of the enum value to acces
int GuiPopUpMenuCtrlEx::size

Get the size of the menu.

Returns:
Number of entries in the menu


Torque 3D - Script Manual: GuiProgressBitmapCtrl Class Reference

GuiProgressBitmapCtrl Class Reference
[Value Controls]

A horizontal progress bar rendered from a repeating image. More...

Inheritance diagram for GuiProgressBitmapCtrl:
[legend]

List of all members.

Public Member Functions

void | setBitmap (string filename)
Set the bitmap to use for rendering the progress bar.

Public Attributes

filename | bitmap
~Path to the bitmap file to use for rendering the progress bar.

Detailed Description

A horizontal progress bar rendered from a repeating image.

This class is used give progress feedback to the user. Unlike GuiProgressCtrl which simply renders a filled rectangle, GuiProgressBitmapCtrl renders the bar using a bitmap.

This bitmap can either be simple, plain image which is then stretched into the current extents of the bar as it fills up or it can be a bitmap array with three entries. In the case of a bitmap array, the first entry in the array is used to render the left cap of the bar and the third entry in the array is used to render the right cap of the bar. The second entry is streched in-between the two caps.

Example:
// This example shows one way to break down a long-running computation into phases
// and incrementally update a progress bar between the phases.

new GuiProgressBitmapCtrl( Progress )
{
   bitmap = "core/art/gui/images/loading";
   extent = "300 50";
   position = "100 100";
};

// Put the control on the canvas.
%wrapper = new GuiControl();
%wrapper.addObject( Progress );
Canvas.pushDialog( %wrapper );

// Start the computation.
schedule( 1, 0, "phase1" );

function phase1()
{
   Progress.setValue( 0 );

   // Perform some computation.
   //...

   // Update progress.
   Progress.setValue( 0.25 );

   // Schedule next phase.  Don't call directly so engine gets a change to run refresh.
   schedule( 1, 0, "phase2" );
}

function phase2()
{
   // Perform some computation.
   //...

   // Update progress.
   Progress.setValue( 0.7 );

   // Schedule next phase.  Don't call directly so engine gets a change to run refresh.
   schedule( 1, 0, "phase3" );
}

function phase3()
{
   // Perform some computation.
   //...

   // Update progress.
   Progress.setValue( 0.9 );

   // Schedule next phase.  Don't call directly so engine gets a change to run refresh.
   schedule( 1, 0, "phase4" );
}

function phase4()
{
   // Perform some computation.
   //...

   // Final update of progress.
   Progress.setValue( 1.0 );
}
See also:
GuiProgressCtrl

Member Function Documentation

void GuiProgressBitmapCtrl::setBitmap ( string filename )

Set the bitmap to use for rendering the progress bar.

Parameters:
filename ~Path to the bitmap file.
Note:
Directly assign to bitmap rather than using this method.
See also:
GuiProgressBitmapCtrl::setBitmap

Member Data Documentation

filename GuiProgressBitmapCtrl::bitmap

~Path to the bitmap file to use for rendering the progress bar.

If the profile assigned to the control already has a bitmap assigned, this property need not be set in which case the bitmap from the profile is used.


Torque 3D - Script Manual: GuiProgressCtrl Class Reference

GuiProgressCtrl Class Reference
[Value Controls]

GUI Control which displays a horizontal bar which increases as the progress value of 0.0 - 1.0 increases. More...

Inheritance diagram for GuiProgressCtrl:
[legend]

List of all members.

Detailed Description

GUI Control which displays a horizontal bar which increases as the progress value of 0.0 - 1.0 increases.

Example:
     new GuiProgressCtrl(JS_statusBar)
    {
          //Properties not specific to this control have been omitted from this example.
     };

// Define the value to set the progress bar%value = "0.5f"

// Set the value of the progress bar, from 0.0 - 1.0
%thisGuiProgressCtrl.setValue(%value);
// Get the value of the progress bar.
%progress = %thisGuiProgressCtrl.getValue();
See also:
GuiTextCtrl
GuiControl


Torque 3D - Script Manual: GuiRadioCtrl Class Reference

GuiRadioCtrl Class Reference
[Button Controls]

A button based around the radio concept. More...

Inheritance diagram for GuiRadioCtrl:
[legend]

List of all members.

Detailed Description

A button based around the radio concept.

GuiRadioCtrl's functionality is based around GuiButtonBaseCtrl's ButtonTypeRadio type.

A button control with a radio box and a text label. This control is used in groups where multiple radio buttons present a range of options out of which one can be chosen. A radio button automatically signals its siblings when it is toggled on.

Example:
// Create a GuiCheckBoxCtrl that calls randomFunction with its current value when clicked.
%radio = new GuiRadioCtrl()
{
   profile = "GuiRadioProfile";
};


Torque 3D - Script Manual: GuiRolloutCtrl Class Reference

GuiRolloutCtrl Class Reference
[Container Controls]

A container that shows a single child with an optional header bar that can be used to collapse and expand the rollout. More...

Inheritance diagram for GuiRolloutCtrl:
[legend]

List of all members.

Public Member Functions

void | collapse ()
Collapse the rollout if it is currently expanded. This will make the rollout's child control invisible.
void | expand ()
Expand the rollout if it is currently collapsed. This will make the rollout's child control visible.
void | instantCollapse ()
Instantly collapse the rollout without animation. To smoothly slide the rollout to collapsed state, use collapse().
void | instantExpand ()
Instantly expand the rollout without animation. To smoothly slide the rollout to expanded state, use expand().
bool | isExpanded ()
Determine whether the rollout is currently expanded, i.e. whether the child control is visible.
void | sizeToContents ()
Resize the rollout to exactly fit around its child control. This can be used to manually trigger a recomputation of the rollout size.
void | toggleCollapse ()
Toggle the current collapse state of the rollout. If it is currently expanded, then collapse it. If it is currently collapsed, then expand it.
void | toggleExpanded (bool instantly=false)
Toggle the current expansion state of the rollout If it is currently expanded, then collapse it. If it is currently collapsed, then expand it.
Callbacks

void | onCollapsed ()
Called when the rollout is collapsed.
void | onExpanded ()
Called when the rollout is expanded.
void | onHeaderRightClick ()
Called when the user right-clicks on the rollout's header. This is useful for implementing context menus for rollouts.

Public Attributes

Rollout

bool | autoCollapseSiblings
Whether to automatically collapse sibling rollouts.
string | caption
Text label to display on the rollout header.
bool | clickCollapse
Whether the rollout can be collapsed by clicking its header.
int | defaultHeight
Default height of the client area. This is used when no child control has been added to the rollout.
bool | expanded
The current rollout expansion state.
bool | hideHeader
Whether to render the rollout header.
RectI | margin
Margin to put around child control.

Detailed Description

A container that shows a single child with an optional header bar that can be used to collapse and expand the rollout.

A rollout is a container that can be collapsed and expanded using smooth animation. By default, rollouts will display a header with a caption along the top edge of the control which can be clicked by the user to toggle the collapse state of the rollout.

Rollouts will automatically size themselves to exactly fit around their child control. They will also automatically position their child control in their upper left corner below the header (if present).

Note:
GuiRolloutCtrls will only work correctly with a single child control. To put multiple controls in a rollout, put them in their own group using a new GuiControl which then can be put inside the rollout.

Member Function Documentation

void GuiRolloutCtrl::collapse ( )

Collapse the rollout if it is currently expanded. This will make the rollout's child control invisible.

Note:
The rollout will animate to collapsed state. To instantly collapse without animation, use instantCollapse().
void GuiRolloutCtrl::expand ( )

Expand the rollout if it is currently collapsed. This will make the rollout's child control visible.

Note:
The rollout will animate to expanded state. To instantly expand without animation, use instantExpand().
void GuiRolloutCtrl::instantCollapse ( )

Instantly collapse the rollout without animation. To smoothly slide the rollout to collapsed state, use collapse().

void GuiRolloutCtrl::instantExpand ( )

Instantly expand the rollout without animation. To smoothly slide the rollout to expanded state, use expand().

bool GuiRolloutCtrl::isExpanded ( )

Determine whether the rollout is currently expanded, i.e. whether the child control is visible.

Returns:
True if the rollout is expanded, false if not.

Reimplemented from SimObject.

void GuiRolloutCtrl::onCollapsed ( )

Called when the rollout is collapsed.

void GuiRolloutCtrl::onExpanded ( )

Called when the rollout is expanded.

void GuiRolloutCtrl::onHeaderRightClick ( )

Called when the user right-clicks on the rollout's header. This is useful for implementing context menus for rollouts.

void GuiRolloutCtrl::sizeToContents ( )

Resize the rollout to exactly fit around its child control. This can be used to manually trigger a recomputation of the rollout size.

void GuiRolloutCtrl::toggleCollapse ( )

Toggle the current collapse state of the rollout. If it is currently expanded, then collapse it. If it is currently collapsed, then expand it.

void GuiRolloutCtrl::toggleExpanded ( bool instantly = false )

Toggle the current expansion state of the rollout If it is currently expanded, then collapse it. If it is currently collapsed, then expand it.

Parameters:
instant If true, the rollout will toggle its state without animation. Otherwise, the rollout will smoothly slide into the opposite state.

Member Data Documentation

bool GuiRolloutCtrl::autoCollapseSiblings

Whether to automatically collapse sibling rollouts.

If this is true, the rollout will automatically collapse all sibling rollout controls when it is expanded. If this is false, the auto-collapse behavior can be triggered by CTRL (CMD on MAC) clicking the rollout header. CTRL/CMD clicking also works if this is false, in which case the auto-collapsing of sibling controls will be temporarily deactivated.

string GuiRolloutCtrl::caption

Text label to display on the rollout header.

bool GuiRolloutCtrl::clickCollapse

Whether the rollout can be collapsed by clicking its header.

int GuiRolloutCtrl::defaultHeight

Default height of the client area. This is used when no child control has been added to the rollout.

bool GuiRolloutCtrl::expanded

The current rollout expansion state.

bool GuiRolloutCtrl::hideHeader

Whether to render the rollout header.

Note:
If this is false, the user cannot toggle the rollout state with the mouse.
RectI GuiRolloutCtrl::margin

Margin to put around child control.


Torque 3D - Script Manual: GuiScriptNotifyCtrl Class Reference

GuiScriptNotifyCtrl Class Reference
[Utility Controls]

A control which adds several reactions to other GUIs via callbacks. More...

Inheritance diagram for GuiScriptNotifyCtrl:
[legend]

List of all members.

Callbacks

bool | onChildAdded
Enables/disables onChildAdded callback.
bool | onChildRemoved
Enables/disables onChildRemoved callback.
bool | onChildResized
Enables/disables onChildResized callback.
bool | onGainFirstResponder
Enables/disables onGainFirstResponder callback.
bool | onLoseFirstResponder
Enables/disables onLoseFirstResponder callback.
bool | onParentResized
Enables/disables onParentResized callback.
bool | onResize
Enables/disables onResize callback.
void | onChildAdded (SimObjectId ID, SimObjectId childID)
Called when a child is added to this GUI.
void | onChildRemoved (SimObjectId ID, SimObjectId childID)
Called when a child is removed from this GUI.
void | onChildResized (SimObjectId ID, SimObjectId childID)
Called when a child is of this GUI is being resized.
void | onGainFirstResponder (SimObjectId ID)
Called when this GUI gains focus.
void | onLoseFirstResponder (SimObjectId ID)
Called when this GUI loses focus.
void | onParentResized (SimObjectId ID)
Called when this GUI's parent is resized.
void | onResize (SimObjectId ID)
Called when this GUI is resized.

Detailed Description

A control which adds several reactions to other GUIs via callbacks.

GuiScriptNotifyCtrl does not exist to render anything. When parented or made a child of other controls, you can toggle flags on or off to make use of its specialized callbacks. Normally these callbacks are used as utility functions by the GUI Editor, or other container classes. However, for very fancy GUI work where controls interact with each other constantly, this is a handy utility to make use of.

Example:
// Common member fields left out for sake of example
new GuiScriptNotifyCtrl()
{
   onChildAdded = "0";
   onChildRemoved = "0";
   onChildResized = "0";
   onParentResized = "0";
};

Member Function Documentation

void GuiScriptNotifyCtrl::onChildAdded | ( | SimObjectId | ID,
 |  | SimObjectId | childID
 | ) |  |

Called when a child is added to this GUI.

Parameters:
ID | Unique object ID assigned when created (this in script).
childID | Unique object ID of child being added.
void GuiScriptNotifyCtrl::onChildRemoved | ( | SimObjectId | ID,
 |  | SimObjectId | childID
 | ) |  |

Called when a child is removed from this GUI.

Parameters:
ID | Unique object ID assigned when created (this in script).
childID | Unique object ID of child being removed.
void GuiScriptNotifyCtrl::onChildResized | ( | SimObjectId | ID,
 |  | SimObjectId | childID
 | ) |  |

Called when a child is of this GUI is being resized.

Parameters:
ID | Unique object ID assigned when created (this in script).
childID | Unique object ID of child being resized.
void GuiScriptNotifyCtrl::onGainFirstResponder ( SimObjectId ID )

Called when this GUI gains focus.

Parameters:
ID Unique object ID assigned when created (this in script).
void GuiScriptNotifyCtrl::onLoseFirstResponder ( SimObjectId ID )

Called when this GUI loses focus.

Parameters:
ID Unique object ID assigned when created (this in script).
void GuiScriptNotifyCtrl::onParentResized ( SimObjectId ID )

Called when this GUI's parent is resized.

Parameters:
ID Unique object ID assigned when created (this in script).
void GuiScriptNotifyCtrl::onResize ( SimObjectId ID )

Called when this GUI is resized.

Parameters:
ID Unique object ID assigned when created (this in script).

Member Data Documentation

bool GuiScriptNotifyCtrl::onChildAdded

Enables/disables onChildAdded callback.

bool GuiScriptNotifyCtrl::onChildRemoved

Enables/disables onChildRemoved callback.

bool GuiScriptNotifyCtrl::onChildResized

Enables/disables onChildResized callback.

bool GuiScriptNotifyCtrl::onGainFirstResponder

Enables/disables onGainFirstResponder callback.

bool GuiScriptNotifyCtrl::onLoseFirstResponder

Enables/disables onLoseFirstResponder callback.

bool GuiScriptNotifyCtrl::onParentResized

Enables/disables onParentResized callback.

bool GuiScriptNotifyCtrl::onResize

Enables/disables onResize callback.


Torque 3D - Script Manual: GuiScrollCtrl Class Reference

GuiScrollCtrl Class Reference
[Container Controls]

A container that allows to view one or more possibly larger controls inside its area by providing horizontal and/or vertical scroll bars. More...

Inheritance diagram for GuiScrollCtrl:
[legend]

List of all members.

Public Member Functions

void | computeSizes ()
Refresh sizing and positioning of child controls.
Point2I | getScrollPosition ()
Get the current coordinates of the scrolled content.
int | getScrollPositionX ()
Get the current X coordinate of the scrolled content.
int | getScrollPositionY ()
Get the current Y coordinate of the scrolled content.
void | scrollToBottom ()
Scroll all the way to the bottom of the vertical scrollbar and the left of the horizontal bar.
void | scrollToObject (GuiControl control)
Scroll the control so that the given child control is visible.
void | scrollToTop ()
Scroll all the way to the top of the vertical and left of the horizontal scrollbar.
void | setScrollPosition (int x, int y)
Set the position of the scrolled content.
Callbacks

void | onScroll ()
Called each time the child controls are scrolled by some amount.

Public Attributes

Scolling

Point2I | childMargin
Padding region to put around child contents.
bool | constantThumbHeight
GuiScrollBarBehavior hScrollBar
When to display the horizontal scrollbar.
bool | lockHorizScroll
Horizontal scrolling not allowed if set.
bool | lockVertScroll
Vertical scrolling not allowed if set.
int | mouseWheelScrollSpeed
Pixels/Tick - if not positive then mousewheel scrolling occurs instantly (like other scrolling).
GuiScrollBarBehavior vScrollBar
When to display the vertical scrollbar.
bool | willFirstRespond

Detailed Description

A container that allows to view one or more possibly larger controls inside its area by providing horizontal and/or vertical scroll bars.

Member Function Documentation

void GuiScrollCtrl::computeSizes ( )

Refresh sizing and positioning of child controls.

Point2I GuiScrollCtrl::getScrollPosition ( )

Get the current coordinates of the scrolled content.

Returns:
The current position of the scrolled content.
int GuiScrollCtrl::getScrollPositionX ( )

Get the current X coordinate of the scrolled content.

Returns:
The current X coordinate of the scrolled content.
int GuiScrollCtrl::getScrollPositionY ( )

Get the current Y coordinate of the scrolled content.

Returns:
The current Y coordinate of the scrolled content.
void GuiScrollCtrl::onScroll ( )

Called each time the child controls are scrolled by some amount.

void GuiScrollCtrl::scrollToBottom ( )

Scroll all the way to the bottom of the vertical scrollbar and the left of the horizontal bar.

void GuiScrollCtrl::scrollToObject ( GuiControl control )

Scroll the control so that the given child control is visible.

Parameters:
control A child control.
void GuiScrollCtrl::scrollToTop ( )

Scroll all the way to the top of the vertical and left of the horizontal scrollbar.

void GuiScrollCtrl::setScrollPosition | ( | int | x,
 |  | int | y
 | ) |  |

Set the position of the scrolled content.

Parameters:
x | Position on X axis.
y | Position on y axis.

Member Data Documentation

Point2I GuiScrollCtrl::childMargin

Padding region to put around child contents.

bool GuiScrollCtrl::constantThumbHeight
GuiScrollBarBehavior GuiScrollCtrl::hScrollBar

When to display the horizontal scrollbar.

bool GuiScrollCtrl::lockHorizScroll

Horizontal scrolling not allowed if set.

bool GuiScrollCtrl::lockVertScroll

Vertical scrolling not allowed if set.

int GuiScrollCtrl::mouseWheelScrollSpeed

Pixels/Tick - if not positive then mousewheel scrolling occurs instantly (like other scrolling).

GuiScrollBarBehavior GuiScrollCtrl::vScrollBar

When to display the vertical scrollbar.

bool GuiScrollCtrl::willFirstRespond


Torque 3D - Script Manual: GuiSeparatorCtrl Class Reference

GuiSeparatorCtrl Class Reference
[General Controls]

A control that renders a horizontal or vertical separator with an optional text label (horizontal only). More...

Inheritance diagram for GuiSeparatorCtrl:
[legend]

List of all members.

Public Attributes

int | borderMargin
string | caption
Optional text label to display.
bool | invisible
int | leftMargin
Left margin of text label.
GuiSeparatorType type
Orientation of separator.

Detailed Description

A control that renders a horizontal or vertical separator with an optional text label (horizontal only).

Example:
new GuiSeparatorCtrl()
{
   profile = "GuiDefaultProfile";
   position = "505 0";
   extent = "10 17";
   minExtent = "10 17";
   canSave = "1";
   visible = "1";
   horizSizing = "left";
};

Member Data Documentation

int GuiSeparatorCtrl::borderMargin
string GuiSeparatorCtrl::caption

Optional text label to display.

bool GuiSeparatorCtrl::invisible
int GuiSeparatorCtrl::leftMargin

Left margin of text label.

GuiSeparatorType GuiSeparatorCtrl::type

Orientation of separator.


Torque 3D - Script Manual: GuiShapeNameHud Class Reference

GuiShapeNameHud Class Reference
[Game Controls]

Displays name and damage of ShapeBase objects in its bounds. Must be a child of a GuiTSCtrl and a server connection must be present. More...

Inheritance diagram for GuiShapeNameHud:
[legend]

List of all members.

Public Attributes

Misc

float | distanceFade
Visibility distance (how far the player must be from the ShapeBase object in focus) for this control to render.
bool | showFill
If true, we draw the background color of the control.
bool | showFrame
If true, we draw the frame of the control.
float | verticalOffset
Amount to vertically offset the control in relation to the ShapeBase object in focus.
Colors

ColorF | fillColor
Standard color for the background of the control.
ColorF | frameColor
Color for the control's frame.
ColorF | textColor
Color for the text on this control.

Detailed Description

Displays name and damage of ShapeBase objects in its bounds. Must be a child of a GuiTSCtrl and a server connection must be present.

This control displays the name and damage value of all named ShapeBase objects on the client. The name and damage of objects within the control's display area are overlayed above the object.

This GUI control must be a child of a TSControl, and a server connection and control object must be present. This is a stand-alone control and relies only on the standard base GuiControl.

Example:
 new GuiShapeNameHud(){
   fillColor = "0.0 1.0 0.0 1.0"; // Fills with a solid green color
   frameColor = "1.0 1.0 1.0 1.0"; // Solid white frame color
   textColor = "1.0 1.0 1.0 1.0"; // Solid white text Color
   showFill = "true";
   showFrame = "true";
   verticalOffset = "0.15";
   distanceFade = "15.0";
};

Member Data Documentation

float GuiShapeNameHud::distanceFade

Visibility distance (how far the player must be from the ShapeBase object in focus) for this control to render.

ColorF GuiShapeNameHud::fillColor

Standard color for the background of the control.

ColorF GuiShapeNameHud::frameColor

Color for the control's frame.

bool GuiShapeNameHud::showFill

If true, we draw the background color of the control.

bool GuiShapeNameHud::showFrame

If true, we draw the frame of the control.

ColorF GuiShapeNameHud::textColor

Color for the text on this control.

float GuiShapeNameHud::verticalOffset

Amount to vertically offset the control in relation to the ShapeBase object in focus.


Torque 3D - Script Manual: GuiSliderCtrl Class Reference

GuiSliderCtrl Class Reference
[Value Controls]

A control that displays a value between its minimal and maximal bounds using a slider placed on a vertical or horizontal axis. More...

Inheritance diagram for GuiSliderCtrl:
[legend]

List of all members.

Public Member Functions

float | getValue ()
Get the current value of the slider based on the position of the thumb.
bool | isThumbBeingDragged ()
Returns true if the thumb is currently being dragged by the user. This method is mainly useful for scrubbing type sliders where the slider position is sync'd to a changing value. When the user is dragging the thumb, however, the sync'ing should pause and not get in the way of the user.
void | setValue (float pos, bool doCallback=false)
Set position of the thumb on the slider.
Callbacks

void | onMouseDragged ()
Called when the left mouse button is dragged across the slider.

Public Attributes

Slider

Point2F | range
Min and max values corresponding to left and right slider position.
bool | snap
Whether to snap the slider to tick marks.
int | ticks
Spacing between tick marks in pixels. 0=off.
float | value
The value corresponding to the current slider position.

Detailed Description

A control that displays a value between its minimal and maximal bounds using a slider placed on a vertical or horizontal axis.

A slider displays a value and allows that value to be changed by dragging a thumb control along the axis of the slider. In this way, the value is changed between its allowed minimum and maximum.

To hook up script code to the value changes of a slider, use the command and altCommand properties. command is executed once the thumb is released by the user whereas altCommand is called any time the slider value changes. When changing the slider value from script, however, trigger of altCommand is suppressed by default.

The orientation of a slider is automatically determined from the ratio of its width to its height. If a slider is taller than it is wide, it will be rendered with a vertical orientation. If it is wider than it is tall, it will be rendered with a horizontal orientation.

The rendering of a slider depends on the bitmap in the slider's profile. This bitmap must be a bitmap array comprised of at least five bitmap rectangles. The rectangles are used such that:

  • Rectangle #1: Left edge of slider
  • Rectangle #2: Center piece of slider; this is stretched between the left and right edge
  • Rectangle #3: Right edge of slider
  • Rectangle #4: Thumb button in normal state
  • Rectangle #5: Thumb button in highlighted (mouse-over) state
Example:
// Create a sound source and a slider that changes the volume of the source.

%source = sfxPlayOnce( "art/sound/testing", AudioLoop2D );

new GuiSlider()
{
   // Update the sound source volume when the slider is being dragged and released.
   command = %source @ ".setVolume( $ThisControl.value );";

   // Limit the range to 0..1 since that is the allowable range for sound volumes.
   range = "0 1";
};
See also:
GuiTextEditSliderCtrl
GuiTextEditSliderBitmapCtrl

Member Function Documentation

float GuiSliderCtrl::getValue ( )

Get the current value of the slider based on the position of the thumb.

Returns:
Slider position (from range.x to range.y).
bool GuiSliderCtrl::isThumbBeingDragged ( )

Returns true if the thumb is currently being dragged by the user. This method is mainly useful for scrubbing type sliders where the slider position is sync'd to a changing value. When the user is dragging the thumb, however, the sync'ing should pause and not get in the way of the user.

void GuiSliderCtrl::onMouseDragged ( )

Called when the left mouse button is dragged across the slider.

void GuiSliderCtrl::setValue | ( | float | pos,
 |  | bool | doCallback = false
 | ) |  |

Set position of the thumb on the slider.

Parameters:
pos | New slider position (from range.x to range.y)
doCallback | If true, the altCommand callback will be invoked

Member Data Documentation

Point2F GuiSliderCtrl::range

Min and max values corresponding to left and right slider position.

bool GuiSliderCtrl::snap

Whether to snap the slider to tick marks.

int GuiSliderCtrl::ticks

Spacing between tick marks in pixels. 0=off.

float GuiSliderCtrl::value

The value corresponding to the current slider position.


Torque 3D - Script Manual: GuiSpeedometerHud Class Reference

GuiSpeedometerHud Class Reference
[Container Controls]

Displays the speed of the current Vehicle based control object. More...

Inheritance diagram for GuiSpeedometerHud:
[legend]

List of all members.

Public Attributes

Needle

Point2F | center
Center of the needle, offset from the GuiSpeedometerHud control top left corner.
ColorF | color
Color of the needle.
float | length
Length of the needle from center to end.
float | maxAngle
Angle (in radians) of the needle when the Vehicle speed is >= maxSpeed. An angle of 0 points right, 90 points up etc).
float | maxSpeed
Maximum Vehicle speed (in Torque units per second) to represent on the speedo (Vehicle speeds greater than this are clamped to maxSpeed).
float | minAngle
Angle (in radians) of the needle when the Vehicle speed is 0. An angle of 0 points right, 90 points up etc).
float | tail
Length of the needle from center to tail.
float | width
Width of the needle.

Detailed Description

Displays the speed of the current Vehicle based control object.

This control only works if a server connection exists, and its control object is a Vehicle derived class. If either of these requirements is false, the control is not rendered.
The control renders the speedometer needle as a colored quad, rotated to indicate the Vehicle speed as determined by the minAngle, maxAngle, and maxSpeed properties. This control is normally placed on top of a GuiBitmapCtrl representing the speedometer dial.

Example:
new GuiSpeedometerHud()
{
   maxSpeed = "100";
   minAngle = "215";
   maxAngle = "0";
   color = "1 0.3 0.3 1";
   center = "130 123";
   length = "100";
   width = "2";
   tail = "0";
   //Properties not specific to this control have been omitted from this example.
};

Member Data Documentation

Point2F GuiSpeedometerHud::center

Center of the needle, offset from the GuiSpeedometerHud control top left corner.

ColorF GuiSpeedometerHud::color

Color of the needle.

float GuiSpeedometerHud::length

Length of the needle from center to end.

float GuiSpeedometerHud::maxAngle

Angle (in radians) of the needle when the Vehicle speed is >= maxSpeed. An angle of 0 points right, 90 points up etc).

float GuiSpeedometerHud::maxSpeed

Maximum Vehicle speed (in Torque units per second) to represent on the speedo (Vehicle speeds greater than this are clamped to maxSpeed).

float GuiSpeedometerHud::minAngle

Angle (in radians) of the needle when the Vehicle speed is 0. An angle of 0 points right, 90 points up etc).

float GuiSpeedometerHud::tail

Length of the needle from center to tail.

float GuiSpeedometerHud::width

Width of the needle.


Torque 3D - Script Manual: GuiSplitContainer Class Reference

GuiSplitContainer Class Reference
[Container Controls]

A container that splits its area between two child controls. More...

Inheritance diagram for GuiSplitContainer:
[legend]

List of all members.

Public Attributes

Splitter

Options to configure split panels contained by this control

GuiSplitFixedPanel fixedPanel
Which (if any) side of the splitter to keep at a fixed size.
int | fixedSize
Width of the fixed panel specified by fixedPanel (if any).
GuiSplitOrientation orientation
Whether to split between top and bottom (horizontal) or between left and right (vertical).
Point2I | splitPoint
Point on control through which the splitter goes.
int | splitterSize
Width of the splitter bar between the two sides. Default is 2.

Detailed Description

A container that splits its area between two child controls.

A GuiSplitContainer can be used to dynamically subdivide an area between two child controls. A splitter bar is placed between the two controls and allows to dynamically adjust the sizing ratio between the two sides. Splitting can be either horizontal (subdividing top and bottom) or vertical (subdividing left and right) depending on orientation.

By using fixedPanel, one of the panels can be chosen to remain at a fixed size (fixedSize).

Example:
// Create a vertical splitter with a fixed-size left panel.
%splitter = new GuiSplitContainer()
{
   orientation = "Vertical";
   fixedPanel = "FirstPanel";
   fixedSize = 100;

   new GuiScrollCtrl()
   {
      new GuiMLTextCtrl()
      {
         text = %longText;
      };
   };

   new GuiScrollCtrl()
   {
      new GuiMLTextCtrl()
      {
         text = %moreLongText;
      };
   };
};
Note:
The children placed inside GuiSplitContainers must be GuiContainers.

Member Data Documentation

GuiSplitFixedPanel GuiSplitContainer::fixedPanel

Which (if any) side of the splitter to keep at a fixed size.

int GuiSplitContainer::fixedSize

Width of the fixed panel specified by fixedPanel (if any).

GuiSplitOrientation GuiSplitContainer::orientation

Whether to split between top and bottom (horizontal) or between left and right (vertical).

Point2I GuiSplitContainer::splitPoint

Point on control through which the splitter goes.

Changed relatively if size of control changes.

int GuiSplitContainer::splitterSize

Width of the splitter bar between the two sides. Default is 2.


Torque 3D - Script Manual: GuiStackControl Class Reference

GuiStackControl Class Reference
[Container Controls]

A container that stacks its children horizontally or vertically. More...

Inheritance diagram for GuiStackControl:
[legend]

List of all members.

Public Member Functions

void | freeze (bool freeze)
Prevents control from restacking - useful when adding or removing child controls.
bool | isFrozen ()
Return whether or not this control is frozen.
void | updateStack ()
Restack the child controls.

Public Attributes

Stacking

bool | changeChildPosition
Determines whether to reposition child controls.
bool | changeChildSizeToFit
Determines whether to resize child controls.
bool | dynamicNonStackExtent
Determines whether to resize the stack control along the non-stack axis (change height for horizontal stacking, change width for vertical stacking). No effect if dynamicSize is false.
bool | dynamicPos
Determines whether to reposition the stack along the stack axis when it is auto-resized. No effect if dynamicSize is false.
bool | dynamicSize
Determines whether to resize the stack control along the stack axis (change width for horizontal stacking, change height for vertical stacking).
GuiHorizontalStackingType horizStacking
Controls the type of horizontal stacking to use (Left to Right or Right to Left).
int | padding
Distance (in pixels) between stacked child controls.
GuiStackingType stackingType
Determines the method used to position the child controls.
GuiVerticalStackingType vertStacking
Controls the type of vertical stacking to use (Top to Bottom or Bottom to Top).

Detailed Description

A container that stacks its children horizontally or vertically.

This container maintains a horizontal or vertical stack of GUI controls. If one is added, deleted, or resized, then the stack is resized to fit. The order of the stack is determined by the internal order of the children (ie. the order of addition).

Example:
new GuiStackControl()
{
   stackingType = "Dynamic";
   horizStacking = "Left to Right";
   vertStacking = "Top to Bottom";
   padding = "4";
   dynamicSize = "1";
   dynamicNonStackExtent = "0";
   dynamicPos = "0";
   changeChildSizeToFit = "1";
   changeChildPosition = "1";
   //Properties not specific to this control have been omitted from this example.
};

Member Function Documentation

void GuiStackControl::freeze ( bool freeze )

Prevents control from restacking - useful when adding or removing child controls.

Parameters:
freeze True to freeze the control, false to unfreeze it
Example:
%stackCtrl.freeze(true);
// add controls to stack
%stackCtrl.freeze(false);
bool GuiStackControl::isFrozen ( )

Return whether or not this control is frozen.

void GuiStackControl::updateStack ( )

Restack the child controls.

Member Data Documentation

bool GuiStackControl::changeChildPosition

Determines whether to reposition child controls.

If true, horizontally stacked children are aligned along the top edge of the stack control. Vertically stacked children are aligned along the left edge of the stack control. If false, horizontally stacked children retain their Y position, and vertically stacked children retain their X position.

bool GuiStackControl::changeChildSizeToFit

Determines whether to resize child controls.

If true, horizontally stacked children keep their width, but have their height set to the stack control height. Vertically stacked children keep their height, but have their width set to the stack control width. If false, child controls are not resized.

bool GuiStackControl::dynamicNonStackExtent

Determines whether to resize the stack control along the non-stack axis (change height for horizontal stacking, change width for vertical stacking). No effect if dynamicSize is false.

If true, the stack will be resized to the maximum of the child control widths/heights. If false, the stack will not be resized.

bool GuiStackControl::dynamicPos

Determines whether to reposition the stack along the stack axis when it is auto-resized. No effect if dynamicSize is false.

If true, the stack will grow left for horizontal stacking, and grow up for vertical stacking. If false, the stack will grow right for horizontal stacking, and grow down for vertical stacking.

bool GuiStackControl::dynamicSize

Determines whether to resize the stack control along the stack axis (change width for horizontal stacking, change height for vertical stacking).

If true, the stack width/height will be resized to the sum of the child control widths/heights. If false, the stack will not be resized.

GuiHorizontalStackingType GuiStackControl::horizStacking

Controls the type of horizontal stacking to use (Left to Right or Right to Left).

int GuiStackControl::padding

Distance (in pixels) between stacked child controls.

GuiStackingType GuiStackControl::stackingType

Determines the method used to position the child controls.

GuiVerticalStackingType GuiStackControl::vertStacking

Controls the type of vertical stacking to use (Top to Bottom or Bottom to Top).


Torque 3D - Script Manual: GuiSwatchButtonCtrl Class Reference

GuiSwatchButtonCtrl Class Reference
[Button Controls]

A button that is used to represent color; often used in correlation with a color picker. More...

Inheritance diagram for GuiSwatchButtonCtrl:
[legend]

List of all members.

Public Member Functions

void | setColor (string newColor)
Set the color of the swatch control.

Public Attributes

ColorF | color
The foreground color of GuiSwatchButtonCtrl.

Detailed Description

A button that is used to represent color; often used in correlation with a color picker.

A swatch button is a push button that uses its color field to designate the color drawn over an image, on top of a button.

The color itself is a float value stored inside the GuiSwatchButtonCtrl::color field. The texture path that represents the image underlying the color is stored inside the GuiSwatchButtonCtrl::bitmap field. The default value assigned toGuiSwatchButtonCtrl::color is "1 1 1 1"( White ). The default/fallback image assigned to GuiSwatchButtonCtrl::bitmap is "core/art/gui/images/transp_grid".

Example:
// Create a GuiSwatchButtonCtrl that calls randomFunction with its current color when clicked
%swatchButton = new GuiSwatchButtonCtrl()
{
   profile = "GuiInspectorSwatchButtonProfile";
   command = "randomFunction( $ThisControl.color );";
};

Member Function Documentation

void GuiSwatchButtonCtrl::setColor ( string newColor )

Set the color of the swatch control.

Parameters:
newColor The new color string given to the swatch control in float format "r g b a".
Note:
It's also important to note that when setColor is called causes the control's altCommand field to be executed.

Member Data Documentation

ColorF GuiSwatchButtonCtrl::color

The foreground color of GuiSwatchButtonCtrl.


Torque 3D - Script Manual: GuiTabBookCtrl Class Reference

GuiTabBookCtrl Class Reference
[Container Controls]

A container. More...

Inheritance diagram for GuiTabBookCtrl:
[legend]

List of all members.

Public Member Functions

void | addPage (string title="")
Add a new tab page to the control.
int | getSelectedPage ()
Get the index of the currently selected tab page.
void | selectPage (int index)
Set the selected tab page.
Callbacks

void | onTabRightClick (String text, int index)
Called when the user right-clicks on a tab page header.
void | onTabSelected (String text, int index)
Called when a new tab page is selected.

Public Attributes

TabBook

bool | allowReorder
Whether reordering tabs with the mouse is allowed.
int | defaultPage
Index of page to select on first onWake() call (-1 to disable).
int | frontTabPadding
X offset of first tab page header.
int | minTabWidth
Minimum width allocated to a tab page header.
int | selectedPage
Index of currently selected page.
int | tabHeight
Height of tab page headers.
int | tabMargin
Spacing to put between individual tab page headers.
GuiTabPosition tabPosition
Where to place the tab page headers.

Detailed Description

A container.

Example:
// Create
Note:
Only GuiTabPageCtrls must be added to GuiTabBookCtrls. If an object of a different class is added to the control, it will be reassigned to either the active page or the tab book's parent.
See also:
GuiTabPageCtrl

Member Function Documentation

void GuiTabBookCtrl::addPage ( string title = "" )

Add a new tab page to the control.

Parameters:
title Title text for the tab page header.
int GuiTabBookCtrl::getSelectedPage ( )

Get the index of the currently selected tab page.

Returns:
Index of the selected tab page or -1 if no tab page is selected.
void GuiTabBookCtrl::onTabRightClick | ( | String | text,
 |  | int | index
 | ) |  |

Called when the user right-clicks on a tab page header.

Parameters:
text | Text of the page header for the tab that is being selected.
index | Index of the tab page being selected.
void GuiTabBookCtrl::onTabSelected | ( | String | text,
 |  | int | index
 | ) |  |

Called when a new tab page is selected.

Parameters:
text | Text of the page header for the tab that is being selected.
index | Index of the tab page being selected.
void GuiTabBookCtrl::selectPage ( int index )

Set the selected tab page.

Parameters:
index Index of the tab page.

Member Data Documentation

bool GuiTabBookCtrl::allowReorder

Whether reordering tabs with the mouse is allowed.

int GuiTabBookCtrl::defaultPage

Index of page to select on first onWake() call (-1 to disable).

int GuiTabBookCtrl::frontTabPadding

X offset of first tab page header.

int GuiTabBookCtrl::minTabWidth

Minimum width allocated to a tab page header.

int GuiTabBookCtrl::selectedPage

Index of currently selected page.

int GuiTabBookCtrl::tabHeight

Height of tab page headers.

int GuiTabBookCtrl::tabMargin

Spacing to put between individual tab page headers.

GuiTabPosition GuiTabBookCtrl::tabPosition

Where to place the tab page headers.


Torque 3D - Script Manual: GuiTabPageCtrl Class Reference

GuiTabPageCtrl Class Reference
[Container Controls]

A single page in a GuiTabBookCtrl. More...

Inheritance diagram for GuiTabPageCtrl:
[legend]

List of all members.

Public Member Functions

void | select ()
Select this page in its tab book.

Public Attributes

bool | fitBook
Determines whether to resize this page when it is added to the tab book. If true, the page will be resized according to the tab book extents and tabPosition property.

Detailed Description

A single page in a GuiTabBookCtrl.

Example:
new GuiTabPageCtrl()
{
   fitBook = "1";
   //Properties not specific to this control have been omitted from this example.
};

Member Function Documentation

void GuiTabPageCtrl::select ( )

Select this page in its tab book.

Member Data Documentation

bool GuiTabPageCtrl::fitBook

Determines whether to resize this page when it is added to the tab book. If true, the page will be resized according to the tab book extents and tabPosition property.


Torque 3D - Script Manual: GuiTextCtrl Class Reference

GuiTextCtrl Class Reference
[Core Controls]

GUI control object this displays a single line of text, without TorqueML. More...

Inheritance diagram for GuiTextCtrl:
[legend]

List of all members.

Public Member Functions

void | setText (string text)
Sets the text in the control.
void | setTextID (string textID)
Maps the text ctrl to a variable used in localization, rather than raw text.

Public Attributes

int | maxLength
Defines the maximum length of the text. The default is 1024.
caseString | text
The text to show on the control.
string | textID
Maps the text of this control to a variable used in localization, rather than raw text.

Detailed Description

GUI control object this displays a single line of text, without TorqueML.

Example:
   new GuiTextCtrl()
   {
      text = "Hello World";
      textID = ""STR_HELLO"";
      maxlength = "1024";
       //Properties not specific to this control have been omitted from this example.
   };
See also:
GuiControl
Localization

Member Function Documentation

void GuiTextCtrl::setText ( string text )

Sets the text in the control.

Parameters:
text Text to display in the control.
Example:
// Set the text to show in the control
%text = "Gideon - Destroyer of World";

// Inform the GuiTextCtrl control to change its text to the defined value
%thisGuiTextCtrl.setText(%text);
See also:
GuiControl

Reimplemented in GuiTextEditCtrl, and GuiPopUpMenuCtrlEx.

void GuiTextCtrl::setTextID ( string textID )

Maps the text ctrl to a variable used in localization, rather than raw text.

Parameters:
textID Name of variable text should be mapped to
Example:
// Inform the GuiTextCtrl control of the textID to use
%thisGuiTextCtrl.setTextID("STR_QUIT");
See also:
GuiControl
Localization

Member Data Documentation

int GuiTextCtrl::maxLength

Defines the maximum length of the text. The default is 1024.

caseString GuiTextCtrl::text

The text to show on the control.

string GuiTextCtrl::textID

Maps the text of this control to a variable used in localization, rather than raw text.


Torque 3D - Script Manual: GuiTextEditCtrl Class Reference

GuiTextEditCtrl Class Reference
[General Controls]

A component that places a text entry box on the screen. More...

Inheritance diagram for GuiTextEditCtrl:
[legend]

List of all members.

Public Member Functions

void | clearSelectedText ()
Unselects all selected text in the control.
void | forceValidateText ()
Force a validation to occur.
int | getCursorPos ()
Returns the current position of the text cursor in the control.
string | getText ()
Acquires the current text displayed in this control.
bool | isAllTextSelected ()
Checks to see if all text in the control has been selected.
void | selectAllText ()
Selects all text within the control.
void | setCursorPos (int position)
Sets the text cursor at the defined position within the control.
void | setText (string text)
Sets the text in the control.
Callbacks

void | onReturn ()
Called when the 'Return' or 'Enter' key is pressed.
void | onTabComplete (string val)
Called if tabComplete is true, and the 'tab' key is pressed.
void | onValidate ()
Called whenever the control is validated.

Public Attributes

Text Input

SFXTrack deniedSound
If the attempted text cannot be entered, this sound effect will be played.
string | escapeCommand
Script command to be called when the Escape key is pressed.
int | historySize
How large of a history buffer to maintain.
bool | password
If true, all characters entered will be stored in the control, however will display as the character stored in passwordMask.
string | passwordMask
If 'password' is true, this is the character that will be used to mask the characters in the control.
bool | sinkAllKeyEvents
If true, every key event will act as if the Enter key was pressed.
bool | tabComplete
If true, when the 'tab' key is pressed, it will act as if the Enter key was pressed on the control.
string | validate
Script command to be called when the first validater is lost.

Detailed Description

A component that places a text entry box on the screen.

Fonts and sizes are changed using profiles. The text value can be set or entered by a user.

Example:
   new GuiTextEditCtrl(MessageHud_Edit)
   {
       text = "Hello World";
       validate = "validateCommand();"
       escapeCommand = "escapeCommand();";
       historySize = "5";
       tabComplete = "true";
       deniedSound = "DeniedSoundProfile";
       sinkAllKeyEvents = "true";
       password = "true";
       passwordMask = "*";
        //Properties not specific to this control have been omitted from this example.
   };
See also:
GuiTextCtrl
GuiControl

Member Function Documentation

void GuiTextEditCtrl::clearSelectedText ( )

Unselects all selected text in the control.

Example:
// Inform the control to unselect all of its selected text
%thisGuiTextEditCtrl.clearSelectedText();
See also:
GuiControl
void GuiTextEditCtrl::forceValidateText ( )

Force a validation to occur.

Example:
// Inform the control to force a validation of its text.
%thisGuiTextEditCtrl.forceValidateText();
See also:
GuiControl
int GuiTextEditCtrl::getCursorPos ( )

Returns the current position of the text cursor in the control.

Example:
// Acquire the cursor position in the control
%position = %thisGuiTextEditCtrl.getCursorPost();
Returns:
Text cursor position within the control.
See also:
GuiControl
string GuiTextEditCtrl::getText ( )

Acquires the current text displayed in this control.

Example:
// Acquire the value of the text control.
%text = %thisGuiTextEditCtrl.getText();
Returns:
The current text within the control.
See also:
GuiControl
bool GuiTextEditCtrl::isAllTextSelected ( )

Checks to see if all text in the control has been selected.

Example:
// Check to see if all text has been selected or not.
%allSelected = %thisGuiTextEditCtrl.isAllTextSelected();
Returns:
True if all text in the control is selected, otherwise false.
See also:
GuiControl
void GuiTextEditCtrl::onReturn ( )

Called when the 'Return' or 'Enter' key is pressed.

Example:
// Return or Enter key was pressed, causing the callback to occur.
GuiTextEditCtrl::onReturn(%this)
   {
      // Code to run when the onReturn callback occurs
   }
See also:
GuiTextCtrl
GuiControl
void GuiTextEditCtrl::onTabComplete ( string val )

Called if tabComplete is true, and the 'tab' key is pressed.

Parameters:
val Input to mimick the '1' sent by the actual tab key button press.
Example:
// Tab key has been pressed, causing the callback to occur.
GuiTextEditCtrl::onTabComplete(%this,%val)
   {
      //Code to run when the onTabComplete callback occurs
   }
See also:
GuiTextCtrl
GuiControl
void GuiTextEditCtrl::onValidate ( )

Called whenever the control is validated.

Example:
// The control gets validated, causing the callback to occur
GuiTextEditCtrl::onValidated(%this)
   {
      // Code to run when the control is validated
   }
See also:
GuiTextCtrl
GuiControl
void GuiTextEditCtrl::selectAllText ( )

Selects all text within the control.

Example:
// Inform the control to select all of its text.
%thisGuiTextEditCtrl.selectAllText();
See also:
GuiControl
void GuiTextEditCtrl::setCursorPos ( int position )

Sets the text cursor at the defined position within the control.

Parameters:
position Text position to set the text cursor.
Example:
// Define the cursor position
%position = "12";

// Inform the GuiTextEditCtrl control to place the text cursor at the defined position
%thisGuiTextEditCtrl.setCursorPos(%position);
See also:
GuiControl
void GuiTextEditCtrl::setText ( string text )

Sets the text in the control.

Parameters:
text Text to place in the control.
Example:
// Define the text to display
%text = "Text!"

// Inform the GuiTextEditCtrl to display the defined text
%thisGuiTextEditCtrl.setText(%text);
See also:
GuiControl

Reimplemented from GuiTextCtrl.

Member Data Documentation

SFXTrack GuiTextEditCtrl::deniedSound

If the attempted text cannot be entered, this sound effect will be played.

string GuiTextEditCtrl::escapeCommand

Script command to be called when the Escape key is pressed.

int GuiTextEditCtrl::historySize

How large of a history buffer to maintain.

bool GuiTextEditCtrl::password

If true, all characters entered will be stored in the control, however will display as the character stored in passwordMask.

string GuiTextEditCtrl::passwordMask

If 'password' is true, this is the character that will be used to mask the characters in the control.

bool GuiTextEditCtrl::sinkAllKeyEvents

If true, every key event will act as if the Enter key was pressed.

bool GuiTextEditCtrl::tabComplete

If true, when the 'tab' key is pressed, it will act as if the Enter key was pressed on the control.

string GuiTextEditCtrl::validate

Script command to be called when the first validater is lost.


Torque 3D - Script Manual: GuiTextEditSliderBitmapCtrl Class Reference

GuiTextEditSliderBitmapCtrl Class Reference
[Core Controls]

GUI Control which displays a numerical value which can be increased or decreased using a pair of bitmap up/down buttons. More...

Inheritance diagram for GuiTextEditSliderBitmapCtrl:
[legend]

List of all members.

Public Attributes

filename | bitmap
Unused.
bool | focusOnMouseWheel
If true, the control will accept giving focus to the user when the mouse wheel is used.
string | format
Character format type to place in the control.
float | increment
How far to increment the slider on each step.
Point2F | range
Maximum vertical and horizontal range to allow in the control.

Detailed Description

GUI Control which displays a numerical value which can be increased or decreased using a pair of bitmap up/down buttons.

This control uses the bitmap specified in it's profile (GuiControlProfile::bitmapName). It takes this image and breaks up aspects of it to render the up and down arrows. It is also important to set GuiControlProfile::hasBitmapArray to true on the profile as well.

The bitmap referenced should be broken up into a 1 x 4 grid (using the top left color pixel as a border color between each of the images) in which it will map to the following places:

  1. Up arrow active
  2. Up arrow inactive
  3. Down arrow active
  4. Down arrow inactive
1
2
3
4
Example:
singleton GuiControlProfile (SliderBitmapGUIProfile)
{
   bitmap = "core/art/gui/images/sliderArray";
   hasBitmapArray = true;
   opaque = false;
};

new GuiTextEditSliderBitmapCtrl()
{
   profile = "SliderBitmapGUIProfile";
   format = "%3.2f";
   range = "-1e+03 1e+03";
   increment = "0.1";
   focusOnMouseWheel = "0";
   bitmap = "";
   //Properties not specific to this control have been omitted from this example.
};
See also:
GuiTextEditSliderCtrl
GuiTextEditCtrl

Member Data Documentation

filename GuiTextEditSliderBitmapCtrl::bitmap

Unused.

bool GuiTextEditSliderBitmapCtrl::focusOnMouseWheel

If true, the control will accept giving focus to the user when the mouse wheel is used.

string GuiTextEditSliderBitmapCtrl::format

Character format type to place in the control.

float GuiTextEditSliderBitmapCtrl::increment

How far to increment the slider on each step.

Point2F GuiTextEditSliderBitmapCtrl::range

Maximum vertical and horizontal range to allow in the control.


Torque 3D - Script Manual: GuiTextEditSliderCtrl Class Reference

GuiTextEditSliderCtrl Class Reference
[Core Controls]

GUI Control which displays a numerical value which can be increased or decreased using a pair of arrows. More...

Inheritance diagram for GuiTextEditSliderCtrl:
[legend]

List of all members.

Public Attributes

bool | focusOnMouseWheel
If true, the control will accept giving focus to the user when the mouse wheel is used.
string | format
Character format type to place in the control.
float | increment
How far to increment the slider on each step.
Point2F | range
Maximum vertical and horizontal range to allow in the control.

Detailed Description

GUI Control which displays a numerical value which can be increased or decreased using a pair of arrows.

Example:
new GuiTextEditSliderCtrl()
{
   format = "%3.2f";
   range = "-1e+03 1e+03";
   increment = "0.1";
   focusOnMouseWheel = "0";
   //Properties not specific to this control have been omitted from this example.
};
See also:
GuiTextEditCtrl

Member Data Documentation

bool GuiTextEditSliderCtrl::focusOnMouseWheel

If true, the control will accept giving focus to the user when the mouse wheel is used.

string GuiTextEditSliderCtrl::format

Character format type to place in the control.

float GuiTextEditSliderCtrl::increment

How far to increment the slider on each step.

Point2F GuiTextEditSliderCtrl::range

Maximum vertical and horizontal range to allow in the control.


Torque 3D - Script Manual: GuiTextListCtrl Class Reference

GuiTextListCtrl Class Reference
[General Controls]

GUI control that displays a list of text. Text items in the list can be individually selected. More...

Inheritance diagram for GuiTextListCtrl:
[legend]

List of all members.

Public Member Functions

int | addRow (int id=0, string text="", int index=-1)
Adds a new row at end of the list with the defined id and text. If index is used, then the new row is inserted at the row location of 'index'.
void | clear ()
Clear the list.
void | clearSelection ()
Set the selection to nothing.
int | findTextIndex (string needle)
Find needle in the list, and return the row number it was found in.
int | getRowId (int index)
Get the row ID for an index.
int | getRowNumById (int id)
Get the row number for a specified id.
string | getRowText (int index)
Get the text of the row with the specified index.
string | getRowTextById (int id)
Get the text of a row with the specified id.
int | getSelectedId ()
Get the ID of the currently selected item.
int | getSelectedRow ()
Returns the selected row index (not the row ID).
bool | isRowActive (int rowNum)
Check if the specified row is currently active or not.
void | removeRow (int index)
Remove a row from the table, based on its index.
void | removeRowById (int id)
Remove row with the specified id.
int | rowCount ()
Get the number of rows.
void | scrollVisible (int rowNum)
Scroll so the specified row is visible.
void | setRowActive (int rowNum, bool active)
Mark a specified row as active/not.
void | setRowById (int id, string text)
Sets the text at the defined id.
void | setSelectedById (int id)
Finds the specified entry by id, then marks its row as selected.
void | setSelectedRow (int rowNum)
void | sort (int columnId, bool increasing=true)
Performs a standard (alphabetical) sort on the values in the specified column.
void | sortNumerical (int columnID, bool increasing=true)
Perform a numerical sort on the values in the specified column.
Callbacks

void | onDeleteKey (string id)
Called when the delete key has been pressed.
void | onSelect (string cellid, string text)
Called whenever an item in the list is selected.

Public Attributes

bool | clipColumnText
If true, text exceeding a column's given width will get clipped.
intList | columns
A vector of column offsets. The number of values determines the number of columns in the table.
bool | fitParentWidth
If true, the width of this control will match the width of its parent.

Detailed Description

GUI control that displays a list of text. Text items in the list can be individually selected.

Example:
      new GuiTextListCtrl(EndGameGuiList)
      {
         columns = "0 256";
           fitParentWidth = "1";
         clipColumnText = "0";
          //Properties not specific to this control have been omitted from this example.
      };
See also:
Reference

Member Function Documentation

int GuiTextListCtrl::addRow | ( | int | id = 0,
 |  | string | text = "",
 |  | int | index = -1
 | ) |  |

Adds a new row at end of the list with the defined id and text. If index is used, then the new row is inserted at the row location of 'index'.

Parameters:
id | Id of the new row.
text | Text to display at the new row.
index | Index to insert the new row at. If not used, new row will be placed at the end of the list.
Example:
// Define the id
%id = "4";

// Define the text to display
%text = "Display Text"

// Define the index (optional)
%index = "2"

// Inform the GuiTextListCtrl control to add the new row with the defined information.
%rowIndex = %thisGuiTextListCtrl.addRow(%id,%text,%index);
Returns:
Returns the row index of the new row. If 'index' was defined, then this just returns the number of rows in the list.
See also:
References
void GuiTextListCtrl::clear ( )

Clear the list.

Example:
// Inform the GuiTextListCtrl control to clear its contents
%thisGuiTextListCtrl.clear();
See also:
GuiControl
void GuiTextListCtrl::clearSelection ( )

Set the selection to nothing.

Example:
// Deselect anything that is currently selected
%thisGuiTextListCtrl.clearSelection();
See also:
GuiControl
int GuiTextListCtrl::findTextIndex ( string needle )

Find needle in the list, and return the row number it was found in.

Parameters:
needle Text to find in the list.
Example:
// Define the text to find in the list
%needle = "Text To Find";

// Request the row number that contains the defined text to find

%rowNumber = %thisGuiTextListCtrl.findTextIndex(%needle);
Returns:
Row number that the defined text was found in,
See also:
GuiControl
int GuiTextListCtrl::getRowId ( int index )

Get the row ID for an index.

Parameters:
index Index to get the RowID at
Example:
// Define the index
%index = "3";

// Request the row ID at the defined index
%rowId = %thisGuiTextListCtrl.getRowId(%index);
Returns:
RowId at the defined index.
See also:
GuiControl
int GuiTextListCtrl::getRowNumById ( int id )

Get the row number for a specified id.

Parameters:
id Id to get the row number at
Example:
// Define the id
%id = "4";

// Request the row number from the GuiTextListCtrl control at the defined id.
%rowNumber = %thisGuiTextListCtrl.getRowNumById(%id);
See also:
GuiControl
string GuiTextListCtrl::getRowText ( int index )

Get the text of the row with the specified index.

Parameters:
index Row index to acquire the text at.
Example:
// Define the row index
%index = "5";

// Request the text from the row at the defined index
%rowText = %thisGuiTextListCtrl.getRowText(%index);
Returns:
Text at the defined row index.
See also:
GuiControl
string GuiTextListCtrl::getRowTextById ( int id )

Get the text of a row with the specified id.

Example:
// Define the id
%id = "4";

// Inform the GuiTextListCtrl control to return the text at the defined row id
%rowText = %thisGuiTextListCtrl.getRowTextById(%id);
Returns:
Row text at the requested row id.
See also:
GuiControl
int GuiTextListCtrl::getSelectedId ( )

Get the ID of the currently selected item.

Example:
// Acquire the ID of the selected item in the list.
%id = %thisGuiTextListCtrl.getSelectedId();
Returns:
The id of the selected item in the list.
See also:
GuiControl
int GuiTextListCtrl::getSelectedRow ( )

Returns the selected row index (not the row ID).

Example:
// Acquire the selected row index
%rowIndex = %thisGuiTextListCtrl.getSelectedRow();
Returns:
Index of the selected row
See also:
GuiControl
bool GuiTextListCtrl::isRowActive ( int rowNum )

Check if the specified row is currently active or not.

Parameters:
rowNum Row number to check the active state.
Example:
// Define the row number
%rowNum = "5";

// Request the active state of the defined row number from the GuiTextListCtrl control.
%rowActiveState = %thisGuiTextListCtrl.isRowActive(%rowNum);
Returns:
Active state of the defined row number.
See also:
GuiControl
void GuiTextListCtrl::onDeleteKey ( string id )

Called when the delete key has been pressed.

Parameters:
id Id of the selected item in the list
Example:
// The delete key was pressed while the GuiTextListCtrl was in focus, causing the callback to occur.
GuiTextListCtrl::onDeleteKey(%this,%id)
   {
      // Code to run when the delete key is pressed
   }
See also:
GuiControl
void GuiTextListCtrl::onSelect | ( | string | cellid,
 |  | string | text
 | ) |  |

Called whenever an item in the list is selected.

Parameters:
cellid | The ID of the cell that was selected
text | The text in the selected cel
Example:
// A cel in the control was selected, causing the callback to occur
GuiTextListCtrl::onSelect(%this,%callid,%text)
   {
      // Code to run when a cel item is selected
   }
See also:
GuiControl
void GuiTextListCtrl::removeRow ( int index )

Remove a row from the table, based on its index.

Parameters:
index Row index to remove from the list.
Example:
// Define the row index
%index = "4";

// Inform the GuiTextListCtrl control to remove the row at the defined row index
%thisGuiTextListCtrl.removeRow(%index);
See also:
GuiControl
void GuiTextListCtrl::removeRowById ( int id )

Remove row with the specified id.

Parameters:
id Id to remove the row entry at
Example:
// Define the id
%id = "4";

// Inform the GuiTextListCtrl control to remove the row at the defined id
%thisGuiTextListCtrl.removeRowById(%id);
See also:
GuiControl
int GuiTextListCtrl::rowCount ( )

Get the number of rows.

Example:
// Get the number of rows in the list
%rowCount = %thisGuiTextListCtrl.rowCount();
Returns:
Number of rows in the list.
See also:
GuiControl
void GuiTextListCtrl::scrollVisible ( int rowNum )

Scroll so the specified row is visible.

Parameters:
rowNum Row number to make visible
Example:
// Define the row number to make visible
%rowNum = "4";

// Inform the GuiTextListCtrl control to scroll the list so the defined rowNum is visible.
%thisGuiTextListCtrl.scrollVisible(%rowNum);
See also:
GuiControl
void GuiTextListCtrl::setRowActive | ( | int | rowNum,
 |  | bool | active
 | ) |  |

Mark a specified row as active/not.

Parameters:
rowNum | Row number to change the active state.
active | Boolean active state to set the row number.
Example:
// Define the row number
%rowNum = "4";

// Define the boolean active state
%active = "true";

// Informthe GuiTextListCtrl control to set the defined active state at the defined row number.
%thisGuiTextListCtrl.setRowActive(%rowNum,%active);
See also:
GuiControl
void GuiTextListCtrl::setRowById | ( | int | id,
 |  | string | text
 | ) |  |

Sets the text at the defined id.

Parameters:
id | Id to change.
text | Text to use at the Id.
Example:
// Define the id
%id = "4";

// Define the text
%text = "Text To Display";

// Inform the GuiTextListCtrl control to display the defined text at the defined id
%thisGuiTextListCtrl.setRowById(%id,%text);
See also:
GuiControl
void GuiTextListCtrl::setSelectedById ( int id )

Finds the specified entry by id, then marks its row as selected.

Parameters:
id Entry within the text list to make selected.
Example:
// Define the id
%id = "5";

// Inform the GuiTextListCtrl control to set the defined id entry as selected
%thisGuiTextListCtrl.setSelectedById(%id);
See also:
GuiControl
void GuiTextListCtrl::setSelectedRow ( int rowNum )

the specified row.

Parameters:
rowNum Row number to set selected.
Example:
// Define the row number to set selected
%rowNum = "4";

%guiTextListCtrl.setSelectedRow(%rowNum);
See also:
GuiControl
void GuiTextListCtrl::sort | ( | int | columnId,
 |  | bool | increasing = true
 | ) |  |

Performs a standard (alphabetical) sort on the values in the specified column.

Parameters:
columnId | Column ID to perform the sort on.
increasing | If false, sort will be performed in reverse.
Example:
// Define the columnId
%id = "1";

// Define if we are increasing or not
%increasing = "false";

// Inform the GuiTextListCtrl to perform the sort operation
%thisGuiTextListCtrl.sort(%id,%increasing);
See also:
GuiControl
void GuiTextListCtrl::sortNumerical | ( | int | columnID,
 |  | bool | increasing = true
 | ) |  |

Perform a numerical sort on the values in the specified column.

Detailed description

Parameters:
columnId | Column ID to perform the sort on.
increasing | If false, sort will be performed in reverse.
Example:
// Define the columnId
%id = "1";

// Define if we are increasing or not
%increasing = "false";

// Inform the GuiTextListCtrl to perform the sort operation
%thisGuiTextListCtrl.sortNumerical(%id,%increasing);
See also:
GuiControl

Member Data Documentation

bool GuiTextListCtrl::clipColumnText

If true, text exceeding a column's given width will get clipped.

intList GuiTextListCtrl::columns

A vector of column offsets. The number of values determines the number of columns in the table.

bool GuiTextListCtrl::fitParentWidth

If true, the width of this control will match the width of its parent.


Torque 3D - Script Manual: GuiTheoraCtrl Class Reference

GuiTheoraCtrl Class Reference
[Image and Video Controls]

A control to playing Theora videos. More...

Inheritance diagram for GuiTheoraCtrl:
[legend]

List of all members.

Public Member Functions

float | getCurrentTime ()
Get the current playback time.
bool | isPlaybackDone ()
Test whether the video has finished playing.
void | pause ()
Pause playback of the video. If the video is not currently playing, the call is ignored.
void | play ()
Start playing the video. If the video is already playing, the call is ignored.
void | setFile (string filename)
Set the video file to play. If a video is already playing, playback is stopped and the new video file is loaded.
void | stop ()
Stop playback of the video. The next call to play() will then start playback from the beginning of the video.

Public Attributes

Playback

ColorI | backgroundColor
Fill color when video is not playing.
bool | matchVideoSize
Whether to automatically match control extents to the video size.
bool | playOnWake
Whether to start playing video when control is woken up.
bool | renderDebugInfo
If true, displays an overlay on top of the video with useful debugging information.
bool | stopOnSleep
Whether to stop video when control is set to sleep.
filename | theoraFile
Theora video file to play.
GuiTheoraTranscoder transcoder
The routine to use for Y'CbCr to RGB conversion.

Detailed Description

A control to playing Theora videos.

This control can be used to play videos in the Theora video format. The videos may include audio in Vorbis format. The codecs for both formats are integrated with the engine and no codecs must be present on the user's machine.

Example:
%video = new GuiTheoraCtrl()
{
   theoraFile = "videos/intro.ogv";
   playOnWake = false;
   stopOnSleep = true;
}

Canvas.setContent( %video );
%video.play();
See also:
http://www.theora.org

Member Function Documentation

float GuiTheoraCtrl::getCurrentTime ( )

Get the current playback time.

Returns:
The elapsed playback time in seconds.
bool GuiTheoraCtrl::isPlaybackDone ( )

Test whether the video has finished playing.

Returns:
True if the video has finished playing, false otherwise.
void GuiTheoraCtrl::pause ( )

Pause playback of the video. If the video is not currently playing, the call is ignored.

While stopped, the control displays the last frame.

void GuiTheoraCtrl::play ( )

Start playing the video. If the video is already playing, the call is ignored.

void GuiTheoraCtrl::setFile ( string filename )

Set the video file to play. If a video is already playing, playback is stopped and the new video file is loaded.

Parameters:
filename The video file to load.
void GuiTheoraCtrl::stop ( )

Stop playback of the video. The next call to play() will then start playback from the beginning of the video.

While stopped, the control renders empty with just the background color.

Member Data Documentation

ColorI GuiTheoraCtrl::backgroundColor

Fill color when video is not playing.

bool GuiTheoraCtrl::matchVideoSize

Whether to automatically match control extents to the video size.

bool GuiTheoraCtrl::playOnWake

Whether to start playing video when control is woken up.

bool GuiTheoraCtrl::renderDebugInfo

If true, displays an overlay on top of the video with useful debugging information.

bool GuiTheoraCtrl::stopOnSleep

Whether to stop video when control is set to sleep.

If this is not set to true, the video will be paused when the control is put to sleep. This is because there is no support for seeking in the video stream in the player backend and letting the time source used to synchronize video (either audio or a raw timer) get far ahead of frame decoding will cause possibly very long delays when the control is woken up again.

filename GuiTheoraCtrl::theoraFile

Theora video file to play.

GuiTheoraTranscoder GuiTheoraCtrl::transcoder

The routine to use for Y'CbCr to RGB conversion.


Torque 3D - Script Manual: GuiTickCtrl Class Reference

GuiTickCtrl Class Reference
[Utility Controls]

Brief Description. More...

Inheritance diagram for GuiTickCtrl:
[legend]

List of all members.

Public Member Functions

void setProcessTicks (bool tick) void setProcessTicks([tick
This will set this object to either be processing ticks or not.

Detailed Description

Brief Description.

This Gui Control is designed to be subclassed to let people create controls which want to receive update ticks at a constant interval. This class was created to be the Parent class of a control which used a DynamicTexture along with a VectorField to create warping effects much like the ones found in visualization displays for iTunes or Winamp. Those displays are updated at the framerate frequency. This works fine for those effects, however for an application of the same type of effects for things like Gui transitions the framerate-driven update frequency is not desirable because it does not allow the developer to be able to have any idea of a consistent user-experience.

Enter the ITickable interface. This lets the Gui control, in this case, update the dynamic texture at a constant rate of once per tick, even though it gets rendered every frame, thus creating a framerate-independent update frequency so that the effects are at a consistent speed regardless of the specifics of the system the user is on. This means that the screen-transitions will occur in the same time on a machine getting 300fps in the Gui shell as a machine which gets 150fps in the Gui shell.

Member Function Documentation

void GuiTickCtrl::setProcessTicks ( bool tick )

This will set this object to either be processing ticks or not.

This will set this object to either be processing ticks or not.

Parameters:
tick (optional) True or nothing to enable ticking, false otherwise.
Example:
// Turn off ticking for a control, like a MenuBar (declared previously)
%sampleMenuBar.setProcessTicks(false);


Torque 3D - Script Manual: GuiToggleButtonCtrl Class Reference

GuiToggleButtonCtrl Class Reference
[Button Controls]

Deprecated gui control. More...

Inheritance diagram for GuiToggleButtonCtrl:
[legend]

List of all members.

Detailed Description

Deprecated gui control.

See also:
GuiButtonCtrl
GuiCheckBoxCtrl


Torque 3D - Script Manual: GuiTreeViewCtrl Class Reference

GuiTreeViewCtrl Class Reference
[Container Controls]

Hierarchical list of text items with optional icons. More...

Inheritance diagram for GuiTreeViewCtrl:
[legend]

List of all members.

Public Member Functions

void | addSelection (int id, bool isLastSelection=true)
Add an item/object to the current selection.
bool | buildIconTable (builds an icon table)
void | clear ()
empty tree
void | clearFilterText ()
Clear the current item filtering pattern.
void | clearSelection ()
Unselect all currently selected items.
void | deleteSelection ()
Delete all items/objects in the current selection.
bool | editItem (TreeItemId item, string newText, string newValue)
bool | expandItem (TreeItemId item, bool expand=true)
int | findChildItemByName (int parentId, string childName)
Get the child item of the given parent item whose text matches childName.
int | findItemByName (string text)
Get the ID of the item whose text matches the given text.
int | findItemByObjectId (find item by object id and returns the mId)
int | findItemByValue (string value)
Get the ID of the item whose value matches value.
int | getChild (TreeItemId item)
string | getFilterText ()
Get the current filter expression. Only tree items whose text matches this expression are displayed. By default, the expression is empty and all items are shown.
string | getItemText (TreeItemId item)
string | getItemValue (TreeItemId item)
int | getNextSibling (TreeItemId item)
int | getParent (TreeItemId item)
int | getPrevSibling (TreeItemId item)
int | getSelectedItem (int index=0)
Return the selected item at the given index.
int | getSelectedObject (int index=0)
Return the currently selected SimObject at the given index in inspector mode or -1.
string | getTextToRoot (TreeItemId item, Delimiter=none)
gets the text from the current node to the root, concatenating at each branch upward, with a specified delimiter optionally
void | hideSelection (bool state=true)
Call SimObject::setHidden( state ) on all objects in the current selection.
int | insertItem (int parentId, string text, string value="", string icon="", int normalImage=0, int expandedImage=0)
Add a new item to the tree.
bool | isItemSelected (int id)
Check whether the given item is currently selected in the tree.
bool | isParentItem (int id)
Returns true if the given item contains child items.
void | lockSelection (bool lock=true)
Set whether the current selection can be changed by the user or not.
bool | markItem (TreeItemId item, bool mark=true)
void | moveItemDown (TreeItemId item)
void | moveItemUp (TreeItemId item)
void | open (SimSet obj, bool okToEdit=true)
Set the root of the tree view to the specified object, or to the root set.
bool | removeItem (TreeItemId item)
void | removeSelection (deselects an item)
void | scrollVisible (TreeItemId item)
int | scrollVisibleByObjectId (show item by object id.returns true if sucessful.)
bool | selectItem (TreeItemId item, bool select=true)
void | setDebug (bool value=true)
Enable/disable debug output.
void | setFilterText (string pattern)
Set the pattern by which to filter items in the tree. Only items in the tree whose text matches this pattern are displayed.
void | setItemImages (int id, int normalImage, int expandedImage)
Sets the normal and expanded images to show for the given item.
void | setItemTooltip (int id, string text)
Set the tooltip to show for the given item.
void | showItemRenameCtrl (TreeItemId id)
Show the rename text field for the given item (only one at a time).
void | sort (int parent, bool traverseHierarchy=false, bool parentsFirst=false, bool caseSensitive=true)
Sorts all items of the given parent (or root). With 'hierarchy', traverses hierarchy.
void | toggleHideSelection ()
Toggle the hidden state of all objects in the current selection.
void | toggleLockSelection ()
Toggle the locked state of all objects in the current selection.
Callbacks

bool | canRenameObject (SimObject object)
bool | handleRenameObject (string newName, SimObject object)
bool | isValidDragTarget (int id, string value)
void | onAddGroupSelected (SimGroup group)
void | onAddMultipleSelectionBegin ()
void | onAddMultipleSelectionEnd ()
void | onAddSelection (int itemOrObjectId, bool isLastSelection)
void | onBeginReparenting ()
void | onClearSelection ()
void | onDefineIcons ()
bool | onDeleteObject (SimObject object)
void | onDeleteSelection ()
void | onDragDropped ()
void | onEndReparenting ()
void | onInspect (int itemOrObjectId)
void | onKeyDown (int modifier, int keyCode)
void | onMouseDragged ()
void | onMouseUp (int hitItemId, int mouseClickCount)
void | onObjectDeleteCompleted ()
void | onRemoveSelection (int itemOrObjectId)
void | onReparent (int itemOrObjectId, int oldParentItemOrObjectId, int newParentItemOrObjectId)
void | onRightMouseDown (int itemId, Point2I mousePos, SimObject object)
void | onRightMouseUp (int itemId, Point2I mousePos, SimObject object)
void | onSelect (int itemOrObjectId)
void | onUnselect (int itemOrObjectId)

Public Attributes

void | addChildSelectionByValue
addChildSelectionByValue(TreeItemId parent, value)
void | buildVisibleTree
Build the visible tree.
void | cancelRename
For internal use.
int | getFirstRootItem
Get id for root item.
int | getItemCount
string | getSelectedItemList
returns a space seperated list of mulitple item ids
int | getSelectedItemsCount
string | getSelectedObjectList
Returns a space sperated list of all selected object ids.
void | onRenameValidate
For internal use.
void | removeAllChildren
removeAllChildren(TreeItemId parent)
void | removeChildSelectionByValue
removeChildSelectionByValue(TreeItemId parent, value)
Inspector Trees

bool | canRenameObjects
If true clicking on a selected item ( that is an object and not the root ) will allow you to rename it.
bool | compareToObjectID
bool | renameInternal
If true then object renaming operates on the internalName rather than the object name.
bool | showClassNameForUnnamedObjects
If true, class names will be used as object names for unnamed objects.
bool | showClassNames
If true, item text labels for objects will include class names.
bool | showInternalNames
If true, item text labels for obje ts will include internal names.
bool | showObjectIds
If true, item text labels for objects will include object IDs.
bool | showObjectNames
If true, item text labels for objects will include object names.
TreeView

bool | clearAllOnSingleSelection
bool | deleteObjectAllowed
bool | destroyTreeOnSleep
If true, the entire tree item hierarchy is deleted when the control goes to sleep.
bool | dragToItemAllowed
bool | fullRowSelect
int | itemHeight
bool | mouseDragging
bool | multipleSelections
If true, multiple items can be selected concurrently.
bool | showRoot
If true, the root item is shown in the tree.
int | tabSize
int | textOffset
bool | tooltipOnWidthOnly
bool | useInspectorTooltips

Detailed Description

Hierarchical list of text items with optional icons.

Can also be used to inspect SimObject hierarchies, primarily within editors.

GuiTreeViewCtrls can either display arbitrary user-defined trees or can be used to display SimObject hierarchies where each parent node in the tree is a SimSet or SimGroup and each leaf node is a SimObject.

Each item in the tree has a text and a value. For trees that display SimObject hierarchies, the text for each item is automatically derived from objects while the value for each item is the ID of the respective SimObject. For trees that are not tied to SimObjects, both text and value of each item are set by the user.

Additionally, items in the tree can have icons.

Each item in the tree has a distinct numeric ID that is unique within its tree. The ID of the root item, which is always present on a tree, is 0.

Example:
new GuiTreeViewCtrl(DatablockEditorTree)
{
   tabSize = "16";
   textOffset = "2";
   fullRowSelect = "0";
   itemHeight = "21";
   destroyTreeOnSleep = "0";
   MouseDragging = "0";
   MultipleSelections = "1";
   DeleteObjectAllowed = "1";
   DragToItemAllowed = "0";
   ClearAllOnSingleSelection = "1";
   showRoot = "1";
   internalNamesOnly = "0";
   objectNamesOnly = "0";
   compareToObjectID = "0";
   Profile = "GuiTreeViewProfile";
   tooltipprofile = "GuiToolTipProfile";
   hovertime = "1000";
};

Member Function Documentation

void GuiTreeViewCtrl::addSelection | ( | int | id,
 |  | bool | isLastSelection = true
 | ) |  |

Add an item/object to the current selection.

Parameters:
id | ID of item/object to add to the selection.
isLastSelection | Whether there are more pending items/objects to be added to the selection. If false, the control will defer refreshing the tree and wait until addSelection() is called with this parameter set to true.
bool GuiTreeViewCtrl::buildIconTable ( builds an icon table )
bool GuiTreeViewCtrl::canRenameObject ( SimObject object )
void GuiTreeViewCtrl::clear ( )

empty tree

void GuiTreeViewCtrl::clearFilterText ( )

Clear the current item filtering pattern.

See also:
setFilterText
getFilterText
void GuiTreeViewCtrl::clearSelection ( )

Unselect all currently selected items.

void GuiTreeViewCtrl::deleteSelection ( )

Delete all items/objects in the current selection.

bool GuiTreeViewCtrl::editItem | ( | TreeItemId | item,
 |  | string | newText,
 |  | string | newValue
 | ) |  |
bool GuiTreeViewCtrl::expandItem | ( | TreeItemId | item,
 |  | bool | expand = true
 | ) |  |
int GuiTreeViewCtrl::findChildItemByName | ( | int | parentId,
 |  | string | childName
 | ) |  |

Get the child item of the given parent item whose text matches childName.

Parameters:
parentId | Item ID of the parent in which to look for the child.
childName | Text of the child item to find.
Returns:
ID of the child item or -1 if no child in parentId has the given text childName.
Note:
This method does not recurse, i.e. it only looks for direct children.
int GuiTreeViewCtrl::findItemByName ( string text )

Get the ID of the item whose text matches the given text.

Parameters:
text Item text to match.
Returns:
ID of the item or -1 if no item matches the given text.
int GuiTreeViewCtrl::findItemByObjectId ( find item by object id and returns the mId )
int GuiTreeViewCtrl::findItemByValue ( string value )

Get the ID of the item whose value matches value.

Parameters:
value Value text to match.
Returns:
ID of the item or -1 if no item has the given value.
int GuiTreeViewCtrl::getChild ( TreeItemId item )
string GuiTreeViewCtrl::getFilterText ( )

Get the current filter expression. Only tree items whose text matches this expression are displayed. By default, the expression is empty and all items are shown.

Returns:
The current filter pattern or an empty string if no filter pattern is currently active.
See also:
setFilterText
clearFilterText
string GuiTreeViewCtrl::getItemText ( TreeItemId item )
string GuiTreeViewCtrl::getItemValue ( TreeItemId item )
int GuiTreeViewCtrl::getNextSibling ( TreeItemId item )
int GuiTreeViewCtrl::getParent ( TreeItemId item )
int GuiTreeViewCtrl::getPrevSibling ( TreeItemId item )
int GuiTreeViewCtrl::getSelectedItem ( int index = 0 )

Return the selected item at the given index.

int GuiTreeViewCtrl::getSelectedObject ( int index = 0 )

Return the currently selected SimObject at the given index in inspector mode or -1.

string GuiTreeViewCtrl::getTextToRoot | ( | TreeItemId | item,
 |  | Delimiter | = none
 | ) |  |

gets the text from the current node to the root, concatenating at each branch upward, with a specified delimiter optionally

bool GuiTreeViewCtrl::handleRenameObject | ( | string | newName,
 |  | SimObject | object
 | ) |  |
void GuiTreeViewCtrl::hideSelection ( bool state = true )

Call SimObject::setHidden( state ) on all objects in the current selection.

Parameters:
state Visibility state to set objects in selection to.
int GuiTreeViewCtrl::insertItem | ( | int | parentId,
 |  | string | text,
 |  | string | value = "",
 |  | string | icon = "",
 |  | int | normalImage = 0,
 |  | int | expandedImage = 0
 | ) |  |

Add a new item to the tree.

Parameters:
parentId | Item ID of parent to which to add the item as a child. 0 is root item.
text | Text to display on the item in the tree.
value | Behind-the-scenes value of the item.
icon
normalImage
expandedImage
Returns:
The ID of the newly added item.
bool GuiTreeViewCtrl::isItemSelected ( int id )

Check whether the given item is currently selected in the tree.

Parameters:
id Item/object ID.
Returns:
True if the given item/object is currently selected in the tree.
bool GuiTreeViewCtrl::isParentItem ( int id )

Returns true if the given item contains child items.

bool GuiTreeViewCtrl::isValidDragTarget | ( | int | id,
 |  | string | value
 | ) |  |
void GuiTreeViewCtrl::lockSelection ( bool lock = true )

Set whether the current selection can be changed by the user or not.

Parameters:
lock If true, the current selection is frozen and cannot be changed. If false, the selection may be modified.
bool GuiTreeViewCtrl::markItem | ( | TreeItemId | item,
 |  | bool | mark = true
 | ) |  |
void GuiTreeViewCtrl::moveItemDown ( TreeItemId item )
void GuiTreeViewCtrl::moveItemUp ( TreeItemId item )
void GuiTreeViewCtrl::onAddGroupSelected ( SimGroup group )
void GuiTreeViewCtrl::onAddMultipleSelectionBegin ( )
void GuiTreeViewCtrl::onAddMultipleSelectionEnd ( )
void GuiTreeViewCtrl::onAddSelection | ( | int | itemOrObjectId,
 |  | bool | isLastSelection
 | ) |  |
void GuiTreeViewCtrl::onBeginReparenting ( )
void GuiTreeViewCtrl::onClearSelection ( )
void GuiTreeViewCtrl::onDefineIcons ( )
bool GuiTreeViewCtrl::onDeleteObject ( SimObject object )
void GuiTreeViewCtrl::onDeleteSelection ( )
void GuiTreeViewCtrl::onDragDropped ( )
void GuiTreeViewCtrl::onEndReparenting ( )
void GuiTreeViewCtrl::onInspect ( int itemOrObjectId )
void GuiTreeViewCtrl::onKeyDown | ( | int | modifier,
 |  | int | keyCode
 | ) |  |
void GuiTreeViewCtrl::onMouseDragged ( )
void GuiTreeViewCtrl::onMouseUp | ( | int | hitItemId,
 |  | int | mouseClickCount
 | ) |  |
void GuiTreeViewCtrl::onObjectDeleteCompleted ( )
void GuiTreeViewCtrl::onRemoveSelection ( int itemOrObjectId )
void GuiTreeViewCtrl::onReparent | ( | int | itemOrObjectId,
 |  | int | oldParentItemOrObjectId,
 |  | int | newParentItemOrObjectId
 | ) |  |
void GuiTreeViewCtrl::onRightMouseDown | ( | int | itemId,
 |  | Point2I | mousePos,
 |  | SimObject | object
 | ) |  |
void GuiTreeViewCtrl::onRightMouseUp | ( | int | itemId,
 |  | Point2I | mousePos,
 |  | SimObject | object
 | ) |  |
void GuiTreeViewCtrl::onSelect ( int itemOrObjectId )
void GuiTreeViewCtrl::onUnselect ( int itemOrObjectId )
void GuiTreeViewCtrl::open | ( | SimSet | obj,
 |  | bool | okToEdit = true
 | ) |  |

Set the root of the tree view to the specified object, or to the root set.

bool GuiTreeViewCtrl::removeItem ( TreeItemId item )
void GuiTreeViewCtrl::removeSelection ( deselects an item )
void GuiTreeViewCtrl::scrollVisible ( TreeItemId item )
int GuiTreeViewCtrl::scrollVisibleByObjectId ( show item by object id.returns true if sucessful. )
bool GuiTreeViewCtrl::selectItem | ( | TreeItemId | item,
 |  | bool | select = true
 | ) |  |
void GuiTreeViewCtrl::setDebug ( bool value = true )

Enable/disable debug output.

void GuiTreeViewCtrl::setFilterText ( string pattern )

Set the pattern by which to filter items in the tree. Only items in the tree whose text matches this pattern are displayed.

Parameters:
pattern New pattern based on which visible items in the tree should be filtered. If empty, all items become visible.
See also:
getFilterText
clearFilterText
void GuiTreeViewCtrl::setItemImages | ( | int | id,
 |  | int | normalImage,
 |  | int | expandedImage
 | ) |  |

Sets the normal and expanded images to show for the given item.

void GuiTreeViewCtrl::setItemTooltip | ( | int | id,
 |  | string | text
 | ) |  |

Set the tooltip to show for the given item.

void GuiTreeViewCtrl::showItemRenameCtrl ( TreeItemId id )

Show the rename text field for the given item (only one at a time).

void GuiTreeViewCtrl::sort | ( | int | parent,
 |  | bool | traverseHierarchy = false,
 |  | bool | parentsFirst = false,
 |  | bool | caseSensitive = true
 | ) |  |

Sorts all items of the given parent (or root). With 'hierarchy', traverses hierarchy.

void GuiTreeViewCtrl::toggleHideSelection ( )

Toggle the hidden state of all objects in the current selection.

void GuiTreeViewCtrl::toggleLockSelection ( )

Toggle the locked state of all objects in the current selection.

Member Data Documentation

void GuiTreeViewCtrl::addChildSelectionByValue

addChildSelectionByValue(TreeItemId parent, value)

void GuiTreeViewCtrl::buildVisibleTree

Build the visible tree.

void GuiTreeViewCtrl::cancelRename

For internal use.

bool GuiTreeViewCtrl::canRenameObjects

If true clicking on a selected item ( that is an object and not the root ) will allow you to rename it.

bool GuiTreeViewCtrl::clearAllOnSingleSelection
bool GuiTreeViewCtrl::compareToObjectID
bool GuiTreeViewCtrl::deleteObjectAllowed
bool GuiTreeViewCtrl::destroyTreeOnSleep

If true, the entire tree item hierarchy is deleted when the control goes to sleep.

bool GuiTreeViewCtrl::dragToItemAllowed
bool GuiTreeViewCtrl::fullRowSelect
int GuiTreeViewCtrl::getFirstRootItem

Get id for root item.

int GuiTreeViewCtrl::getItemCount
string GuiTreeViewCtrl::getSelectedItemList

returns a space seperated list of mulitple item ids

int GuiTreeViewCtrl::getSelectedItemsCount
string GuiTreeViewCtrl::getSelectedObjectList

Returns a space sperated list of all selected object ids.

int GuiTreeViewCtrl::itemHeight
bool GuiTreeViewCtrl::mouseDragging
bool GuiTreeViewCtrl::multipleSelections

If true, multiple items can be selected concurrently.

void GuiTreeViewCtrl::onRenameValidate

For internal use.

void GuiTreeViewCtrl::removeAllChildren

removeAllChildren(TreeItemId parent)

void GuiTreeViewCtrl::removeChildSelectionByValue

removeChildSelectionByValue(TreeItemId parent, value)

bool GuiTreeViewCtrl::renameInternal

If true then object renaming operates on the internalName rather than the object name.

bool GuiTreeViewCtrl::showClassNameForUnnamedObjects

If true, class names will be used as object names for unnamed objects.

bool GuiTreeViewCtrl::showClassNames

If true, item text labels for objects will include class names.

bool GuiTreeViewCtrl::showInternalNames

If true, item text labels for obje ts will include internal names.

bool GuiTreeViewCtrl::showObjectIds

If true, item text labels for objects will include object IDs.

bool GuiTreeViewCtrl::showObjectNames

If true, item text labels for objects will include object names.

bool GuiTreeViewCtrl::showRoot

If true, the root item is shown in the tree.

int GuiTreeViewCtrl::tabSize
int GuiTreeViewCtrl::textOffset
bool GuiTreeViewCtrl::tooltipOnWidthOnly
bool GuiTreeViewCtrl::useInspectorTooltips


Torque 3D - Script Manual: GuiTSCtrl Class Reference

GuiTSCtrl Class Reference
[3D Controls]

Abstract base class for controls that render 3D scenes. More...

Inheritance diagram for GuiTSCtrl:
[legend]

List of all members.

Public Member Functions

float | calculateViewDistance (float radius)
Given the camera's current FOV, get the distance from the camera's viewpoint at which the given radius will fit in the render area.
Point2F | getWorldToScreenScale ()
Get the ratio between world-space units and pixels.
Point3F | project (Point3F worldPosition)
Transform world-space coordinates to screen-space (x, y, depth) coordinates.
Point3F | unproject (Point3F screenPosition)
Transform 3D screen-space coordinates (x, y, depth) to world space.

Public Attributes

Camera

float | cameraZRot
Z rotation angle of camera.
float | forceFOV
The vertical field of view in degrees or zero to use the normal camera FOV.
Rendering

float | reflectPriority
The share of the per-frame reflection update work this control's rendering should run.

Detailed Description

Abstract base class for controls that render 3D scenes.

GuiTSCtrl is the base class for controls that render 3D camera views in Torque. The class itself does not implement a concrete scene rendering. Use GuiObjectView to display invidiual shapes in the Gui and GameTSCtrl to render full scenes.

See also:
GameTSCtrl
GuiObjectView

Member Function Documentation

float GuiTSCtrl::calculateViewDistance ( float radius )

Given the camera's current FOV, get the distance from the camera's viewpoint at which the given radius will fit in the render area.

Parameters:
radius Radius in world-space units which should fit in the view.
Returns:
The distance from the viewpoint at which the given radius would be fully visible.
Point2F GuiTSCtrl::getWorldToScreenScale ( )

Get the ratio between world-space units and pixels.

Returns:
The amount of world-space units covered by the extent of a single pixel.
Point3F GuiTSCtrl::project ( Point3F worldPosition )

Transform world-space coordinates to screen-space (x, y, depth) coordinates.

Parameters:
worldPosition The world-space position to transform to screen-space.
Returns:
The
Point3F GuiTSCtrl::unproject ( Point3F screenPosition )

Transform 3D screen-space coordinates (x, y, depth) to world space.

This method can be, for example, used to find the world-space position relating to the current mouse cursor position.

Parameters:
screenPosition The x/y position on the screen plus the depth from the screen-plane outwards.
Returns:
The world-space position corresponding to the given screen-space coordinates.

Member Data Documentation

float GuiTSCtrl::cameraZRot

Z rotation angle of camera.

float GuiTSCtrl::forceFOV

The vertical field of view in degrees or zero to use the normal camera FOV.

float GuiTSCtrl::reflectPriority

The share of the per-frame reflection update work this control's rendering should run.

The reflect update priorities of all visible GuiTSCtrls are added together and each control is assigned a share of the per-frame reflection update time according to its percentage of the total priority value.


Torque 3D - Script Manual: GuiWindowCtrl Class Reference

GuiWindowCtrl Class Reference
[Container Controls]

A window with a title bar and an optional set of buttons. More...

Inheritance diagram for GuiWindowCtrl:
[legend]

List of all members.

Public Member Functions

void | attachTo (GuiWindowCtrl window)
void | selectWindow ()
Bring the window to the front.
void | setCollapseGroup (bool state)
Set the window's collapsing state.
void | toggleCollapseGroup ()
Toggle the window collapsing.
Callbacks

void | onClose ()
Called when the close button has been pressed.
void | onCollapse ()
Called when the window is collapsed by clicking its title bar.
void | onMaximize ()
Called when the window has been maximized.
void | onMinimize ()
Called when the window has been minimized.
void | onRestore ()
Called when the window is restored from minimized, maximized, or collapsed state.

Static Public Member Functions

static void | attach (GuiWindowCtrl bottomWindow, GuiWindowCtrl topWindow)
Attach bottomWindow to so that bottomWindow moves along with topWindow when it is dragged.

Public Attributes

Window

bool | canClose
Whether the window has a close button.
bool | canCollapse
Whether the window can be collapsed by clicking its title bar.
bool | canMaximize
Whether the window has a maximize button.
bool | canMinimize
Whether the window has a minimize button.
bool | canMove
Whether the window can be moved by dragging its titlebar.
string | closeCommand
Script code to execute when the window is closed.
bool | edgeSnap
If true, the window will snap to the edges of other windows when moved close to them.
bool | resizeHeight
Whether the window can be resized vertically.
bool | resizeWidth
Whether the window can be resized horizontally.
string | text
Text label to display in titlebar.

Detailed Description

A window with a title bar and an optional set of buttons.

The GuiWindowCtrl class implements windows that can be freely placed within the render window. Additionally, the windows can be resized and maximized/minimized.

Example:
new GuiWindowCtrl( MyWindow )
{
   text = "My Window"; // The text that is displayed on the title bar.
   resizeWidth = true; // Allow horizontal resizing by user via mouse.
   resizeHeight = true; // Allow vertical resizing by user via mouse.
   canClose = true; // Display a close button in the title bar.
   canMinimize = true; // Display a minimize button in the title bar.
   canMaximize = true; // Display a maximize button in the title bar.
};

Member Function Documentation

static void GuiWindowCtrl::attach | ( | GuiWindowCtrl | bottomWindow,
 |  | GuiWindowCtrl | topWindow |
 | ) |  |  | [static]

Attach bottomWindow to so that bottomWindow moves along with topWindow when it is dragged.

Parameters:
bottomWindow
topWindow
void GuiWindowCtrl::attachTo ( GuiWindowCtrl window )
void GuiWindowCtrl::onClose ( )

Called when the close button has been pressed.

void GuiWindowCtrl::onCollapse ( )

Called when the window is collapsed by clicking its title bar.

void GuiWindowCtrl::onMaximize ( )

Called when the window has been maximized.

void GuiWindowCtrl::onMinimize ( )

Called when the window has been minimized.

void GuiWindowCtrl::onRestore ( )

Called when the window is restored from minimized, maximized, or collapsed state.

void GuiWindowCtrl::selectWindow ( )

Bring the window to the front.

void GuiWindowCtrl::setCollapseGroup ( bool state )

Set the window's collapsing state.

void GuiWindowCtrl::toggleCollapseGroup ( )

Toggle the window collapsing.

Member Data Documentation

bool GuiWindowCtrl::canClose

Whether the window has a close button.

bool GuiWindowCtrl::canCollapse

Whether the window can be collapsed by clicking its title bar.

bool GuiWindowCtrl::canMaximize

Whether the window has a maximize button.

bool GuiWindowCtrl::canMinimize

Whether the window has a minimize button.

bool GuiWindowCtrl::canMove

Whether the window can be moved by dragging its titlebar.

string GuiWindowCtrl::closeCommand

Script code to execute when the window is closed.

bool GuiWindowCtrl::edgeSnap

If true, the window will snap to the edges of other windows when moved close to them.

bool GuiWindowCtrl::resizeHeight

Whether the window can be resized vertically.

bool GuiWindowCtrl::resizeWidth

Whether the window can be resized horizontally.

string GuiWindowCtrl::text

Text label to display in titlebar.


Torque 3D - Script Manual: HoverVehicle Class Reference

HoverVehicle Class Reference
[Vehicles]

A hovering vehicle. More...

Inheritance diagram for HoverVehicle:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A hovering vehicle.

A hover vehicle is a vehicle that maintains a specific distance between the vehicle and the ground at all times; unlike a flying vehicle which is free to ascend and descend at will.The model used for the HoverVehicle has the following requirements:

Collision mesh
A convex collision mesh at detail size -1.
JetNozzle0-1 nodes
Particle emitter nodes used when thrusting forward.
JetNozzle2-3 nodes
Particle emitter nodes used when thrusting downward.
JetNozzleX node
Particle emitter node used when thrusting backward.
activateBack animation
Non-cyclic animation sequence played when the vehicle begins thrusting forwards.
maintainBack animation
Cyclic animation sequence played after activateBack when the vehicle continues thrusting forwards.

Member Data Documentation

bool HoverVehicle::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from Vehicle.

bool HoverVehicle::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from Vehicle.


Torque 3D - Script Manual: HoverVehicleData Class Reference

HoverVehicleData Class Reference
[Vehicles]

Defines the properties of a HoverVehicle. More...

Inheritance diagram for HoverVehicleData:
[legend]

List of all members.

Public Attributes

float | brakingActivationSpeed
Maximum speed below which a braking force is applied.
float | brakingForce
Force generated by braking.
float | dragForce
Drag force factor that acts opposite to the vehicle velocity.
ParticleEmitterData dustTrailEmitter
Emitter to generate particles for the vehicle's dust trail.
float | dustTrailFreqMod
Number of dust trail particles to generate based on vehicle speed.
Point3F | dustTrailOffset
"X Y Z" offset from the vehicle's origin from which to generate dust trail particles.
SFXProfile engineSound
Looping engine sound.
float | floatingGravMag
Scale factor applied to the vehicle gravitational force when the vehicle is floating.
float | floatingThrustFactor
Scalar applied to the vehicle's thrust force when the vehicle is floating.
SFXProfile floatSound
Looping sound played while the vehicle is floating.
ParticleEmitterData forwardJetEmitter
Emitter to generate particles for forward jet thrust.
float | gyroDrag
Damping torque that acts against the vehicle's current angular momentum.
SFXProfile jetSound
Looping sound played when the vehicle is jetting.
float | mainThrustForce
Force generated by thrusting the vehicle forward.
float | normalForce
Force generated in the ground normal direction when the vehicle is not floating (within stabalizer length from the ground).
float | pitchForce
Pitch (rotation about the X-axis) force applied when steering in the y-axis direction.
float | restorativeForce
Force generated to stabalize the vehicle (return it to neutral pitch/roll) when the vehicle is floating (more than stabalizer length from the ground.
float | reverseThrustForce
Force generated by thrusting the vehicle backward.
float | rollForce
Roll (rotation about the Y-axis) force applied when steering in the x-axis direction.
float | stabDampingConstant
Damping spring force acting against changes in the stabalizer length.
float | stabLenMax
Length of the base stabalizer when travelling at maximum speed (maxThrustSpeed).
float | stabLenMin
Length of the base stabalizer when travelling at minimum speed (0).
float | stabSpringConstant
Value used to generate stabalizer spring force. The force generated depends on stabilizer compression, that is how close the vehicle is to the ground proportional to current stabalizer length.
float | steeringForce
Yaw (rotation about the Z-axis) force applied when steering in the x-axis direction.about the vehicle's Z-axis).
float | strafeThrustForce
Force generated by thrusting the vehicle to one side.
float | triggerTrailHeight
Maximum height above surface to emit dust trail particles.
float | turboFactor
Scale factor applied to the vehicle's thrust force when jetting.
float | vertFactor
Scalar applied to the vertical portion of the velocity drag acting on the vehicle.

Detailed Description

Defines the properties of a HoverVehicle.

Member Data Documentation

float HoverVehicleData::brakingActivationSpeed

Maximum speed below which a braking force is applied.

See also:
brakingForce
float HoverVehicleData::brakingForce

Force generated by braking.

The vehicle is considered to be braking if it is moving, but the throttle is off, and no left or right thrust is being applied. This force is only applied when the vehicle's velocity is less than brakingActivationSpeed.

float HoverVehicleData::dragForce

Drag force factor that acts opposite to the vehicle velocity.

Also used to determnine the vehicle's maxThrustSpeed.

See also:
mainThrustForce
ParticleEmitterData HoverVehicleData::dustTrailEmitter

Emitter to generate particles for the vehicle's dust trail.

The trail of dust particles is generated only while the vehicle is moving.

float HoverVehicleData::dustTrailFreqMod

Number of dust trail particles to generate based on vehicle speed.

The vehicle's speed is divided by this value to determine how many particles to generate each frame. Lower values give a more dense trail, higher values a more sparse trail.

Point3F HoverVehicleData::dustTrailOffset

"X Y Z" offset from the vehicle's origin from which to generate dust trail particles.

By default particles are emitted directly beneath the origin of the vehicle model.

SFXProfile HoverVehicleData::engineSound

Looping engine sound.

The volume is dynamically adjusted based on the current thrust level.

float HoverVehicleData::floatingGravMag

Scale factor applied to the vehicle gravitational force when the vehicle is floating.

See also:
stabLenMin
float HoverVehicleData::floatingThrustFactor

Scalar applied to the vehicle's thrust force when the vehicle is floating.

Note:
The floatingThrustFactor must be between 0.0 and 1.0 (inclusive).
SFXProfile HoverVehicleData::floatSound

Looping sound played while the vehicle is floating.

See also:
stabMinLen
ParticleEmitterData HoverVehicleData::forwardJetEmitter

Emitter to generate particles for forward jet thrust.

Forward jet thrust particles are emitted from model nodes JetNozzle0 and JetNozzle1.

float HoverVehicleData::gyroDrag

Damping torque that acts against the vehicle's current angular momentum.

SFXProfile HoverVehicleData::jetSound

Looping sound played when the vehicle is jetting.

float HoverVehicleData::mainThrustForce

Force generated by thrusting the vehicle forward.

Also used to determine the maxThrustSpeed:

Example:
maxThrustSpeed = (mainThrustForce + strafeThrustForce) / dragForce;
float HoverVehicleData::normalForce

Force generated in the ground normal direction when the vehicle is not floating (within stabalizer length from the ground).

See also:
stabLenMin
float HoverVehicleData::pitchForce

Pitch (rotation about the X-axis) force applied when steering in the y-axis direction.

float HoverVehicleData::restorativeForce

Force generated to stabalize the vehicle (return it to neutral pitch/roll) when the vehicle is floating (more than stabalizer length from the ground.

See also:
stabLenMin
float HoverVehicleData::reverseThrustForce

Force generated by thrusting the vehicle backward.

float HoverVehicleData::rollForce

Roll (rotation about the Y-axis) force applied when steering in the x-axis direction.

float HoverVehicleData::stabDampingConstant

Damping spring force acting against changes in the stabalizer length.

See also:
stabLenMin
float HoverVehicleData::stabLenMax

Length of the base stabalizer when travelling at maximum speed (maxThrustSpeed).

See also:
stabLenMin
mainThrustForce
float HoverVehicleData::stabLenMin

Length of the base stabalizer when travelling at minimum speed (0).

Each tick, the vehicle performs 2 raycasts (from the center back and center front of the vehicle) to check for contact with the ground. The base stabalizer length determines the length of that raycast; if neither raycast hit the ground, the vehicle is floating, stabalizer spring and ground normal forces are not applied.

See also:
stabSpringConstant
float HoverVehicleData::stabSpringConstant

Value used to generate stabalizer spring force. The force generated depends on stabilizer compression, that is how close the vehicle is to the ground proportional to current stabalizer length.

See also:
stabLenMin
float HoverVehicleData::steeringForce

Yaw (rotation about the Z-axis) force applied when steering in the x-axis direction.about the vehicle's Z-axis).

float HoverVehicleData::strafeThrustForce

Force generated by thrusting the vehicle to one side.

Also used to determine the vehicle's maxThrustSpeed.

See also:
mainThrustForce
float HoverVehicleData::triggerTrailHeight

Maximum height above surface to emit dust trail particles.

If the vehicle is less than triggerTrailHeight above a static surface with a material that has 'showDust' set to true, the vehicle will emit particles from the dustTrailEmitter.

float HoverVehicleData::turboFactor

Scale factor applied to the vehicle's thrust force when jetting.

float HoverVehicleData::vertFactor

Scalar applied to the vertical portion of the velocity drag acting on the vehicle.

For the horizontal (X and Y) components of velocity drag, a factor of 0.25 is applied when the vehicle is floating, and a factor of 1.0 is applied when the vehicle is not floating. This velocity drag is multiplied by the vehicle's dragForce, as defined above, and the result is subtracted from it's movement force.

Note:
The vertFactor must be between 0.0 and 1.0 (inclusive).


Torque 3D - Script Manual: HTTPObject Class Reference

HTTPObject Class Reference
[Platform]

Allows communications between the game and a server using HTTP protocols. More...

Inheritance diagram for HTTPObject:
[legend]

List of all members.

Public Member Functions

void | get (string Address, string requirstURI, string query="")
Send a GET command to a server to send or retrieve data.
void | post (string Address, string requirstURI, string query, string post)
Send POST command to a server to send or retrieve data.

Detailed Description

Allows communications between the game and a server using HTTP protocols.

Example:
// Create an HTTP object for communications
%newHTTPObj = new HTTPObject();

//  Transmit a get command with a specific server. Be sure to always include the port or the transfer will not work.
%newHTTPObj.get("www.garagegames.com:80","index.php");

// Callback from the engine. Called when the HTTPObject receives a response from the server, along with return data.
function HTTPObject.onLine(%this,%returnLine);
{
   echo("Data returned from the server = " @ %returnLine );
};

// DNS Resolved Response
HTTPObject::onDNSResolved(%this)
{
   // Do Code When DNS Resolved
}

// DNS Failed Resonse
HTTPObject::onDNSFailed(%this)
{
   // Do Code When DNS Failed
}

// Connected to Server Response
HTTPObject::onConnected(%this)
{
   // Do Code When Connected
}

// Connection to Server Failed
HTTPObject::onConnectFailed(%this)
{
   // Do Code When Connection Failed
}

// Disconnected from Server
HTTPObject::onDisconnected(%this)
{
   // Do Code When Disconnected
}

Member Function Documentation

void HTTPObject::get | ( | string | Address,
 |  | string | requirstURI,
 |  | string | query = ""
 | ) |  |

Send a GET command to a server to send or retrieve data.

Parameters:
Address | HTTP web address to send this get call to. Be sure to include the port at the end (IE: "www.garagegames.com:80").
requirstURI | Specific location on the server to access (IE: "index.php".)
query | Optional. Actual data to transmit to the server. Can be anything required providing it sticks with limitations of the HTTP protocol.
Example:
// Create an HTTP object for communications
%httpObj = new HTTPObject();

// Specify a URL to transmit to
%url = "www.garagegames.com";

// Specify a URI to communicate with
%URI = "/index.php";

// Specify a query to send.
%query = "";

// Send the GET command to the server
%httpObj.get(%url,%URI,%query);

void HTTPObject::post | ( | string | Address,
 |  | string | requirstURI,
 |  | string | query,
 |  | string | post
 | ) |  |

Send POST command to a server to send or retrieve data.

Parameters:
Address | HTTP web address to send this get call to. Be sure to include the port at the end (IE: "www.garagegames.com:80").
requirstURI | Specific location on the server to access (IE: "index.php".)
query | Actual data to transmit to the server. Can be anything required providing it sticks with limitations of the HTTP protocol.
post | Submission data to be processed.
Example:
// Create an HTTP object for communications
%httpObj = new HTTPObject();

// Specify a URL to transmit to
%url = "www.garagegames.com";

// Specify a URI to communicate with
%URI = "/index.php";

// Specify a query to send.
%query = "";

// Specify the submission data.
%post = "";

// Send the POST command to the server
%httpObj.POST(%url,%URI,%query,%post);


Torque 3D - Script Manual: InteriorInstance Class Reference

InteriorInstance Class Reference
[Game Objects]

Object used to represent buildings and other architectural structures (legacy). More...

Inheritance diagram for InteriorInstance:
[legend]

List of all members.

Public Member Functions

void | changeMaterial (string mapTo, Material oldMat, Material newMat)
Change one of the materials on the shape.
void | exportToCollada (bool bakeTransform)
Exports the Interior to a Collada file.
string | getModelFile ()
Get the interior file name.
int | getNumDetailLevels ()
Get the number of detail levels interior was created with.
int | getTargetCount (int detailLevel)
Get the number of materials used by interior.
string | getTargetName (int detailLevel, int targetNum)
Get the name of the indexed shape material.
void | setAlarmMode (string alarmMode)
This sets the alarm mode of the interior.
void | setDetailLevel (int level)
Manually changes the current detail level, rather than automatically via view distance.

Public Attributes

Media

filename | interiorFile
Path and filename of the Interior file (.DIF) to load for this InteriorInstance.
Zoning

int | zoneGroup
ID of group the zone is part of.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Object used to represent buildings and other architectural structures (legacy).

Interiors are made up entirely from convex hulls or, as they are more commonly known as by game artists, brushes. So what you see is what you collide against. There is no difference between the visible meshes and the collision meshes.

Unlike a DTS or COLLADA mesh, interiors do not support any animation. They also do not support transparent textures. If you need animation or transparency then you are forced to use other model objects.

It is important to note that interiors are no longer the preferred format for large structures. It is an old format, which does not have much to offer above DTS or COLLADA. They are still included in Torque 3D for the sake of backwards compatibility for developers porting older TGE or TGEA projects. It will be deprecated soon.

Member Function Documentation

void InteriorInstance::changeMaterial | ( | string | mapTo,
 |  | Material | oldMat,
 |  | Material | newMat
 | ) |  |

Change one of the materials on the shape.

This method changes materials per mapTo with others. The material that is being replaced is mapped to unmapped_mat as a part of this transition.

Note:
Warning, right now this only sort of works. It doesn't do a live update like it should. 
Parameters:
mapTo | The name of the material target to remap (from getTargetName)
oldMat | The old Material that was mapped
newMat | The new Material to map
Example:
// remap the first material in the shape
%mapTo = %interiorObject.getTargetName( 0 );
%interiorObject.changeMaterial( %mapTo, 0, MyMaterial );
void InteriorInstance::exportToCollada ( bool bakeTransform )

Exports the Interior to a Collada file.

Parameters:
bakeTransform Bakes the InteriorInstance's transform into the vertex positions
Example:
// Export to COLLADA, do not bakeTransform
%interiorObject.exportToCollada(0);
string InteriorInstance::getModelFile ( )

Get the interior file name.

Returns:
The name of the interior's model file in .DIF.
Example:
%interiorObject.getModelFile();
int InteriorInstance::getNumDetailLevels ( )

Get the number of detail levels interior was created with.

Example:
%numLODs = %interiorObject.getNumDetailLevels();
echo(%numLODs);
int InteriorInstance::getTargetCount ( int detailLevel )

Get the number of materials used by interior.

Parameters:
detailLevel Interior level of detail to scan
Returns:
The number of materials used by the interior at a specified detail level
Example:
// Find materials used at first level of detail
%targetCount = %interiorObject.getTargetCount(1);
echo(%targetCount);

string InteriorInstance::getTargetName | ( | int | detailLevel,
 |  | int | targetNum
 | ) |  |

Get the name of the indexed shape material.

Parameters:
detailLevel | Target LOD
targetNum | Index mapped to the target
Returns:
The name of the target (material) at the specified detail level and index
Example:
// First level of detail, top of the index map
%targetName = %interiorObject.getTargetName(1, 0);
echo(%targetName);
void InteriorInstance::setAlarmMode ( string alarmMode )

This sets the alarm mode of the interior.

The alarm mode is used when debugging bad geometry for an interior. When on, the the bad verties will be rendered a different color.

Parameters:
alarmMode If true the interior will be in an alarm state next frame. Options are 'On' or 'Off'.
Example:
// Turn on alarm mode debugging for interior
%interiorObject.setAlarmMode("On");
void InteriorInstance::setDetailLevel ( int level )

Manually changes the current detail level, rather than automatically via view distance.

Parameters:
level Detail level to force.
Example:
%interiorObject.setDetailLevel(2);

Member Data Documentation

filename InteriorInstance::interiorFile

Path and filename of the Interior file (.DIF) to load for this InteriorInstance.

bool InteriorInstance::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool InteriorInstance::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

int InteriorInstance::zoneGroup

ID of group the zone is part of.


Torque 3D - Script Manual: Item Class Reference

Item Class Reference
[Game Objects]

Base Item class. Uses the ItemData datablock for common properties. More...

Inheritance diagram for Item:
[legend]

List of all members.

Public Member Functions

string | getLastStickyNormal ()
Get the normal of the surface on which the object is stuck.
string | getLastStickyPos ()
Get the position on the surface on which this Item is stuck.
bool | isRotating ()
Is the object still rotating?
bool | isStatic ()
Is the object static (ie, non-movable)?
bool | setCollisionTimeout (int ignoreColObj=NULL)
Temporarily disable collisions against a specific ShapeBase object.
Callbacks

void | onEnterLiquid (string objID, string waterCoverage, string liquidType)
Informs an Item object that it has entered liquid, along with information about the liquid type.
void | onLeaveLiquid (string objID, string liquidType)
Informs an Item object that it has left a liquid, along with information about the liquid type.
void | onStickyCollision (string objID)
Informs the Item object that it is now sticking to another object.

Public Attributes

Misc

bool | rotate
If true, the object will automatically rotate around its Z axis.
bool | static
If true, the object is not moving in the world (and will not be updated through the network).

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static int | maxWarpTicks
When a warp needs to occur due to the client being too far off from the server, this is the maximum number of ticks we'll allow the client to warp to catch up.
static float | minWarpTicks
Fraction of tick at which instant warp occures on the client.

Detailed Description

Base Item class. Uses the ItemData datablock for common properties.

Items represent an object in the world, usually one that the player will interact with. One example is a health kit on the group that is automatically picked up when the player comes into contact with it.

Example:
// This is the "health patch" dropped by a dying player.
datablock ItemData(HealthKitPatch)
{
   // Mission editor category, this datablock will show up in the
   // specified category under the "shapes" root category.
   category = "Health";

   className = "HealthPatch";

   // Basic Item properties
   shapeFile = "art/shapes/items/patch/healthpatch.dts";
   mass = 2;
   friction = 1;
   elasticity = 0.3;
   emap = true;

   // Dynamic properties used by the scripts
   pickupName = "a health patch";
   repairAmount = 50;
};

%obj = new Item()
{
   dataBlock = HealthKitSmall;
   parentGroup = EWCreatorWindow.objectGroup;
   static = true;
   rotate = true;
};
See also:
ItemData

Member Function Documentation

string Item::getLastStickyNormal ( )

Get the normal of the surface on which the object is stuck.

Returns:
Returns The XYZ normal from where this Item is stuck.
Example:
// Acquire the position where this Item is currently stuck
%stuckPosition = %item.getLastStickPos();
Note:
Server side only.
string Item::getLastStickyPos ( )

Get the position on the surface on which this Item is stuck.

Returns:
Returns The XYZ position of where this Item is stuck.
Example:
// Acquire the position where this Item is currently stuck
%stuckPosition = %item.getLastStickPos();
Note:
Server side only.
bool Item::isRotating ( )

Is the object still rotating?

Returns:
True if the object is still rotating, false if it is not.
Example:
// Query the item on if it is or is not rotating.
%isRotating = %itemData.isRotating();
See also:
rotate
bool Item::isStatic ( )

Is the object static (ie, non-movable)?

Returns:
True if the object is static, false if it is not.
Example:
// Query the item on if it is or is not static.
%isStatic = %itemData.isStatic();
See also:
static
void Item::onEnterLiquid | ( | string | objID,
 |  | string | waterCoverage,
 |  | string | liquidType
 | ) |  |

Informs an Item object that it has entered liquid, along with information about the liquid type.

Parameters:
objID | Object ID for this Item object.
waterCoverage | How much coverage of water this Item object has.
liquidType | The type of liquid that this Item object has entered.
Note:
Server side only.
See also:
Item, ItemData, WaterObject
void Item::onLeaveLiquid | ( | string | objID,
 |  | string | liquidType
 | ) |  |

Informs an Item object that it has left a liquid, along with information about the liquid type.

Parameters:
objID | Object ID for this Item object.
liquidType | The type of liquid that this Item object has left.
Note:
Server side only.
See also:
Item, ItemData, WaterObject
void Item::onStickyCollision ( string objID )

Informs the Item object that it is now sticking to another object.

This callback is only called if the ItemData::sticky property for this Item is true.

Parameters:
objID Object ID this Item object.
Note:
Server side only.
See also:
Item, ItemData
bool Item::setCollisionTimeout ( int ignoreColObj = NULL )

Temporarily disable collisions against a specific ShapeBase object.

This is useful to prevent a player from immediately picking up an Item they have just thrown. Only one object may be on the timeout list at a time. The timeout is defined as 15 ticks.

Parameters:
objectID ShapeBase object ID to disable collisions against.
Returns:
Returns true if the ShapeBase object requested could be found, false if it could not.
Example:
// Set the ShapeBase Object ID to disable collisions against
%ignoreColObj = %player.getID();

// Inform this Item object to ignore collisions temproarily against the %ignoreColObj.
%item.setCollisionTimeout(%ignoreColObj);

Member Data Documentation

bool Item::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

bool Item::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.

int Item::maxWarpTicks [static]

When a warp needs to occur due to the client being too far off from the server, this is the maximum number of ticks we'll allow the client to warp to catch up.

float Item::minWarpTicks [static]

Fraction of tick at which instant warp occures on the client.

bool Item::rotate

If true, the object will automatically rotate around its Z axis.

bool Item::static

If true, the object is not moving in the world (and will not be updated through the network).


Torque 3D - Script Manual: ItemData Class Reference

ItemData Class Reference
[Game Objects]

Stores properties for an individual Item type. More...

Inheritance diagram for ItemData:
[legend]

List of all members.

Public Attributes

float | elasticity
A floating-point value specifying how 'bouncy' this ItemData is.
float | friction
A floating-point value specifying how much velocity is lost to impact and sliding friction.
float | gravityMod
Floating point value to multiply the existing gravity with, just for this ItemData.
ColorF | lightColor
Color value to make this light. Example: "1.0,1.0,1.0".
bool | lightOnlyStatic
If true, this ItemData will only cast a light if the Item for this ItemData has a static value of true.
float | lightRadius
Distance from the center point of this ItemData for the light to affect.
int | LightTime
Time value for the light of this ItemData, used to control the pulse speed of the PulsingLight LightType.
ItemLightType lightType
Type of light to apply to this ItemData. Options are NoLight, ConstantLight, PulsingLight. Default is NoLight.
float | maxVelocity
Maximum velocity that this ItemData is able to move.
bool | sticky
If true, ItemData will 'stick' to any surface it collides with.

Detailed Description

Stores properties for an individual Item type.

Items represent an object in the world, usually one that the player will interact with. One example is a health kit on the group that is automatically picked up when the player comes into contact with it.

ItemData provides the common properties for a set of Items. These properties include a DTS or DAE model used to render the Item in the world, its physical properties for when the Item interacts with the world (such as being tossed by the player), and any lights that emit from the Item.

Example:
datablock ItemData(HealthKitSmall)
{
   category ="Health";
   className = "HealthPatch";
   shapeFile = "art/shapes/items/kit/healthkit.dts";
   gravityMod = "1.0";
   mass = 2;
   friction = 1;
   elasticity = 0.3;
   density = 2;
   drag = 0.5;
   maxVelocity = "10.0";
   emap = true;
   sticky = false;
   dynamicType = "0"
;   lightOnlyStatic = false;
   lightType = "NoLight";
   lightColor = "1.0 1.0 1.0 1.0";
   lightTime = 1000;
   lightRadius = 10.0;
   // Dynamic properties used by the scripts

   pickupName = "a small health kit";
   repairAmount = 50;
};

Member Data Documentation

float ItemData::elasticity

A floating-point value specifying how 'bouncy' this ItemData is.

float ItemData::friction

A floating-point value specifying how much velocity is lost to impact and sliding friction.

float ItemData::gravityMod

Floating point value to multiply the existing gravity with, just for this ItemData.

ColorF ItemData::lightColor

Color value to make this light. Example: "1.0,1.0,1.0".

See also:
lightType
bool ItemData::lightOnlyStatic

If true, this ItemData will only cast a light if the Item for this ItemData has a static value of true.

See also:
lightType
float ItemData::lightRadius

Distance from the center point of this ItemData for the light to affect.

See also:
lightType
int ItemData::LightTime

Time value for the light of this ItemData, used to control the pulse speed of the PulsingLight LightType.

See also:
lightType
ItemLightType ItemData::lightType

Type of light to apply to this ItemData. Options are NoLight, ConstantLight, PulsingLight. Default is NoLight.

float ItemData::maxVelocity

Maximum velocity that this ItemData is able to move.

bool ItemData::sticky

If true, ItemData will 'stick' to any surface it collides with.

When an item does stick to a surface, the Item::onStickyCollision() callback is called. The Item has methods to retrieve the world position and normal the Item is stuck to.

Note:
Valid objects to stick to must be of StaticShapeObjectType.


Torque 3D - Script Manual: LangTable Class Reference

LangTable Class Reference
[Localization]

Provides the code necessary to handle the low level management of the string tables for localization. More...

Inheritance diagram for LangTable:
[legend]

List of all members.

Public Member Functions

int | addLanguage (string filename,[string languageName])
Adds a language to the table.
int | getCurrentLanguage ()
Get the ID of the current language table.
string | getLangName (int language)
Return the readable name of the language table.
int | getNumLang ()
Used to find out how many languages are in the table.
string | getString (string filename)
Grabs a string from the specified table.
void | setCurrentLanguage (int language)
Sets the current language table for grabbing text.
void | setDefaultLanguage (int language)
Sets the default language table.

Detailed Description

Provides the code necessary to handle the low level management of the string tables for localization.

One LangTable is created for each mod, as well as one for the C++ code. LangTable is responsible for obtaining the correct strings from each and relaying it to the appropriate controls.

See also:
Localization for a full description

Member Function Documentation

int LangTable::addLanguage ( string filename )

Adds a language to the table.

Parameters:
filename | Name and path to the language file
languageName | Optional name to assign to the new language entry
Returns:
True If file was successfully found and language created
int LangTable::getCurrentLanguage ( )

Get the ID of the current language table.

Returns:
Numerical ID of the current language table
string LangTable::getLangName ( int language )

Return the readable name of the language table.

Parameters:
language Numerical ID of the language table to access
Returns:
String containing the name of the table, NULL if ID was invalid or name was never specified
int LangTable::getNumLang ( )

Used to find out how many languages are in the table.

Returns:
Size of the vector containing the languages, numerical
string LangTable::getString ( string filename )

Grabs a string from the specified table.

If an invalid is passed, the function will attempt to to grab from the default table

Parameters:
filename Name of the language table to access
Returns:
Text from the specified language table, "" if ID was invalid and default table is not set
void LangTable::setCurrentLanguage ( int language )

Sets the current language table for grabbing text.

Parameters:
language ID of the table
void LangTable::setDefaultLanguage ( int language )

Sets the default language table.

Parameters:
language ID of the table


Torque 3D - Script Manual: LevelInfo Class Reference

LevelInfo Class Reference
[Miscellaneous]

Stores and controls the rendering and status information for a game level. More...

Inheritance diagram for LevelInfo:
[legend]

List of all members.

Public Attributes

Lighting

bool | advancedLightmapSupport
Enable expanded support for mixing static and dynamic lighting (more costly).
EaseF | ambientLightBlendCurve
Interpolation curve to use for blending from one ambient light color to a different one.
float | ambientLightBlendPhase
Number of seconds it takes to blend from one ambient light color to a different one.
LevelInfo

ColorI | canvasClearColor
The color used to clear the background before the scene or any GUIs are rendered.
Visibility

float | decalBias
NearPlane bias used when rendering Decal and DecalRoad. This should be tuned to the visibleDistance in your level.
float | nearClip
Closest distance from the camera's position to render the world.
float | visibleDistance
Furthest distance fromt he camera's position to render the world.
Fog

float | fogAtmosphereHeight
A height in meters for altitude fog falloff.
ColorF | fogColor
The default color for the scene fog.
float | fogDensity
The 0 to 1 density value for the exponential fog falloff.
float | fogDensityOffset
An offset from the camera in meters for moving the start of the fog effect.
Sound

SFXAmbience soundAmbience
The global ambient sound environment.
SFXDistanceModel soundDistanceModel
The distance attenuation model to use.

Detailed Description

Stores and controls the rendering and status information for a game level.

Example:
new LevelInfo(theLevelInfo)
{
  visibleDistance = "1000";
  fogColor = "0.6 0.6 0.7 1";
  fogDensity = "0";
  fogDensityOffset = "700";
  fogAtmosphereHeight = "0";
  canvasClearColor = "0 0 0 255";
  canSaveDynamicFields = "1";
  levelName = "Blank Room";
  desc0 = "A blank room ready to be populated with Torque objects.";
  Enabled = "1";
};

Member Data Documentation

bool LevelInfo::advancedLightmapSupport

Enable expanded support for mixing static and dynamic lighting (more costly).

EaseF LevelInfo::ambientLightBlendCurve

Interpolation curve to use for blending from one ambient light color to a different one.

float LevelInfo::ambientLightBlendPhase

Number of seconds it takes to blend from one ambient light color to a different one.

ColorI LevelInfo::canvasClearColor

The color used to clear the background before the scene or any GUIs are rendered.

float LevelInfo::decalBias

NearPlane bias used when rendering Decal and DecalRoad. This should be tuned to the visibleDistance in your level.

float LevelInfo::fogAtmosphereHeight

A height in meters for altitude fog falloff.

ColorF LevelInfo::fogColor

The default color for the scene fog.

float LevelInfo::fogDensity

The 0 to 1 density value for the exponential fog falloff.

float LevelInfo::fogDensityOffset

An offset from the camera in meters for moving the start of the fog effect.

float LevelInfo::nearClip

Closest distance from the camera's position to render the world.

SFXAmbience LevelInfo::soundAmbience

The global ambient sound environment.

SFXDistanceModel LevelInfo::soundDistanceModel

The distance attenuation model to use.

float LevelInfo::visibleDistance

Furthest distance fromt he camera's position to render the world.


Torque 3D - Script Manual: LightAnimData Class Reference

LightAnimData Class Reference
[Special Effects, Lighting]

A datablock which defines and performs light animation, such as rotation, brightness fade, and colorization. More...

Inheritance diagram for LightAnimData:
[legend]

List of all members.

Public Attributes

Brightness

The brightness animation state.

float | brightnessA
The value of the A key in the keyframe sequence.
string | brightnessKeys
The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.
float | brightnessPeriod
The animation time for keyframe sequence.
bool | brightnessSmooth
If true the transition between keyframes will be smooth.
float | brightnessZ
The value of the Z key in the keyframe sequence.
Color

The RGB color animation state.

float | colorA [3]
The value of the A key in the keyframe sequence.
string | colorKeys [3]
The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.
float | colorPeriod [3]
The animation time for keyframe sequence.
bool | colorSmooth [3]
If true the transition between keyframes will be smooth.
float | colorZ [3]
The value of the Z key in the keyframe sequence.
Offset

The XYZ translation animation state relative to the light position.

float | offsetA [3]
The value of the A key in the keyframe sequence.
string | offsetKeys [3]
The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.
float | offsetPeriod [3]
The animation time for keyframe sequence.
bool | offsetSmooth [3]
If true the transition between keyframes will be smooth.
float | OffsetZ [3]
The value of the Z key in the keyframe sequence.
Rotation

The XYZ rotation animation state relative to the light orientation.

float | rotA [3]
The value of the A key in the keyframe sequence.
string | rotKeys [3]
The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.
float | rotPeriod [3]
The animation time for keyframe sequence.
bool | rotSmooth [3]
If true the transition between keyframes will be smooth.
float | rotZ [3]
The value of the Z key in the keyframe sequence.

Detailed Description

A datablock which defines and performs light animation, such as rotation, brightness fade, and colorization.

Example:
datablock LightAnimData( SubtlePulseLightAnim )
{
   brightnessA = 0.5;
   brightnessZ = 1;
   brightnessPeriod = 1;
   brightnessKeys = "aza";
   brightnessSmooth = true;
};
See also:
LightBase
LightDescription

Member Data Documentation

float LightAnimData::brightnessA

The value of the A key in the keyframe sequence.

string LightAnimData::brightnessKeys

The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.

float LightAnimData::brightnessPeriod

The animation time for keyframe sequence.

bool LightAnimData::brightnessSmooth

If true the transition between keyframes will be smooth.

float LightAnimData::brightnessZ

The value of the Z key in the keyframe sequence.

float LightAnimData::colorA[3]

The value of the A key in the keyframe sequence.

string LightAnimData::colorKeys[3]

The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.

float LightAnimData::colorPeriod[3]

The animation time for keyframe sequence.

bool LightAnimData::colorSmooth[3]

If true the transition between keyframes will be smooth.

float LightAnimData::colorZ[3]

The value of the Z key in the keyframe sequence.

float LightAnimData::offsetA[3]

The value of the A key in the keyframe sequence.

string LightAnimData::offsetKeys[3]

The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.

float LightAnimData::offsetPeriod[3]

The animation time for keyframe sequence.

bool LightAnimData::offsetSmooth[3]

If true the transition between keyframes will be smooth.

float LightAnimData::OffsetZ[3]

The value of the Z key in the keyframe sequence.

float LightAnimData::rotA[3]

The value of the A key in the keyframe sequence.

string LightAnimData::rotKeys[3]

The keyframe sequence encoded into a string where characters from A to Z define a position between the two animation values.

float LightAnimData::rotPeriod[3]

The animation time for keyframe sequence.

bool LightAnimData::rotSmooth[3]

If true the transition between keyframes will be smooth.

float LightAnimData::rotZ[3]

The value of the Z key in the keyframe sequence.


Torque 3D - Script Manual: LightBase Class Reference

LightBase Class Reference
[Lighting]

This is the base class for light objects. More...

Inheritance diagram for LightBase:
[legend]

List of all members.

Public Member Functions

void | playAnimation ()
Plays the light animation assigned to this light with the existing LightAnimData datablock.
void | playAnimation (LightAnimData anim)
Plays the light animation on this light using a new LightAnimData. If no LightAnimData is passed the existing one is played.
void | setLightEnabled (bool state)
Toggles the light on and off.

Public Attributes

void | pauseAnimation
Stops the light animation.
Light Animation

bool | animate
Toggles animation for the light on and off.
float | animationPeriod
The length of time in seconds for a single playback of the light animation (must be > 0).
float | animationPhase
The phase used to offset the animation start time to vary the animation of nearby lights.
LightAnimData animationType
Datablock containing light animation information (LightAnimData).
Advanced Lighting

Point3F | attenuationRatio
The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.
filename | cookie
A custom pattern texture which is projected from the light.
float | fadeStartDistance
Start fading shadows out at this distance. 0 = auto calculate this distance.
bool | lastSplitTerrainOnly
This toggles only terrain being rendered to the last split of a PSSM shadow map.
float | logWeight
The logrithmic PSSM split distance factor.
int | numSplits
The logrithmic PSSM split distance factor.
Point4F | overDarkFactor
The ESM shadow darkening factor.
float | shadowDistance
The distance from the camera to extend the PSSM shadow.
float | shadowSoftness
ShadowType shadowType
The type of shadow to use on this light.
int | texSize
The texture size of the shadow map.
Light

float | brightness
Adjusts the lights power, 0 being off completely.
bool | castShadows
Enables/disabled shadow casts by this light.
ColorF | color
Changes the base color hue of the light.
bool | isEnabled
Enables/Disables the object rendering and functionality in the scene.
float | priority
Used for sorting of lights by the light manager. Priority determines if a light has a stronger effect than, those with a lower value.
Misc

float | flareScale
Globally scales all features of the light flare.
LightFlareData flareType
Datablock containing light flare information (LightFlareData).
Advanced Lighting Lightmap

bool | includeLightmappedGeometryInShadow
This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).
bool | representedInLightmap
This light is represented in lightmaps (static light, default: false).
ColorF | shadowDarkenColor
The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

This is the base class for light objects.

It is *NOT* intended to be used directly in script, but exists to provide the base member variables and generic functionality. You should be using the derived classes PointLight and SpotLight, which can be declared in TorqueScript or added from the World Editor.

For this class, we only add basic lighting options that all lighting systems would use. The specific lighting system options are injected at runtime by the lighting system itself.

See also:
PointLight
SpotLight

Member Function Documentation

void LightBase::playAnimation ( )

Plays the light animation assigned to this light with the existing LightAnimData datablock.

Example:
// Play the animation assigned to this light
CrystalLight.playAnimation();
void LightBase::playAnimation ( LightAnimData anim )

Plays the light animation on this light using a new LightAnimData. If no LightAnimData is passed the existing one is played.

Parameters:
anim Name of the LightAnimData datablock to be played
Example:
// Play the animation using a new LightAnimData datablock
CrystalLight.playAnimation(SubtlePulseLightAnim);
void LightBase::setLightEnabled ( bool state )

Toggles the light on and off.

Parameters:
state Turns the light on (true) or off (false)
Example:
// Disable the light
CrystalLight.setLightEnabled(false);

// Renable the light
CrystalLight.setLightEnabled(true);

Member Data Documentation

bool LightBase::animate

Toggles animation for the light on and off.

float LightBase::animationPeriod

The length of time in seconds for a single playback of the light animation (must be > 0).

float LightBase::animationPhase

The phase used to offset the animation start time to vary the animation of nearby lights.

LightAnimData LightBase::animationType

Datablock containing light animation information (LightAnimData).

Point3F LightBase::attenuationRatio

The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.

float LightBase::brightness

Adjusts the lights power, 0 being off completely.

bool LightBase::castShadows

Enables/disabled shadow casts by this light.

ColorF LightBase::color

Changes the base color hue of the light.

filename LightBase::cookie

A custom pattern texture which is projected from the light.

float LightBase::fadeStartDistance

Start fading shadows out at this distance. 0 = auto calculate this distance.

float LightBase::flareScale

Globally scales all features of the light flare.

LightFlareData LightBase::flareType

Datablock containing light flare information (LightFlareData).

bool LightBase::includeLightmappedGeometryInShadow

This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).

bool LightBase::isEnabled

Enables/Disables the object rendering and functionality in the scene.

bool LightBase::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in PointLight, and SpotLight.

bool LightBase::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in PointLight, and SpotLight.

bool LightBase::lastSplitTerrainOnly

This toggles only terrain being rendered to the last split of a PSSM shadow map.

float LightBase::logWeight

The logrithmic PSSM split distance factor.

int LightBase::numSplits

The logrithmic PSSM split distance factor.

Point4F LightBase::overDarkFactor

The ESM shadow darkening factor.

void LightBase::pauseAnimation

Stops the light animation.

float LightBase::priority

Used for sorting of lights by the light manager. Priority determines if a light has a stronger effect than, those with a lower value.

bool LightBase::representedInLightmap

This light is represented in lightmaps (static light, default: false).

ColorF LightBase::shadowDarkenColor

The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).

float LightBase::shadowDistance

The distance from the camera to extend the PSSM shadow.

float LightBase::shadowSoftness
ShadowType LightBase::shadowType

The type of shadow to use on this light.

int LightBase::texSize

The texture size of the shadow map.


Torque 3D - Script Manual: LightDescription Class Reference

LightDescription Class Reference
[Lighting]

A helper datablock used by classes (such as shapebase) that submit lights to the scene but do not use actual "LightBase" objects. More...

Inheritance diagram for LightDescription:
[legend]

List of all members.

Public Member Functions

void | apply ()
Force an inspectPostApply call for the benefit of tweaking via the console.

Public Attributes

Light Animation

float | animationPeriod
The length of time in seconds for a single playback of the light animation.
float | animationPhase
The phase used to offset the animation start time to vary the animation of nearby lights.
LightAnimData animationType
Datablock containing light animation information (LightAnimData).
Advanced Lighting

Point3F | attenuationRatio
The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.
filename | cookie
A custom pattern texture which is projected from the light.
float | fadeStartDistance
Start fading shadows out at this distance. 0 = auto calculate this distance.
bool | lastSplitTerrainOnly
This toggles only terrain being rendered to the last split of a PSSM shadow map.
float | logWeight
The logrithmic PSSM split distance factor.
int | numSplits
The logrithmic PSSM split distance factor.
Point4F | overDarkFactor
The ESM shadow darkening factor.
float | shadowDistance
The distance from the camera to extend the PSSM shadow.
float | shadowSoftness
ShadowType shadowType
The type of shadow to use on this light.
int | texSize
The texture size of the shadow map.
Light

float | brightness
Adjusts the lights power, 0 being off completely.
bool | castShadows
Enables/disabled shadow casts by this light.
ColorF | color
Changes the base color hue of the light.
float | range
Controls the size (radius) of the light.
Misc

float | flareScale
Globally scales all features of the light flare.
LightFlareData flareType
Datablock containing light flare information (LightFlareData).
Advanced Lighting Lightmap

bool | includeLightmappedGeometryInShadow
This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).
bool | representedInLightmap
This light is represented in lightmaps (static light, default: false).
ColorF | shadowDarkenColor
The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).

Detailed Description

A helper datablock used by classes (such as shapebase) that submit lights to the scene but do not use actual "LightBase" objects.

This datablock stores the properties of that light as fields that can be initialized from script.

Example:
// Declare a light description to be used on a rocket launcher projectile
datablock LightDescription(RocketLauncherLightDesc)
{
   range = 4.0;
   color = "1 1 0";
   brightness = 5.0;
   animationType = PulseLightAnim;
   animationPeriod = 0.25;
};

// Declare a ProjectileDatablock which uses the light description
datablock ProjectileData(RocketLauncherProjectile)
{
   lightDesc = RocketLauncherLightDesc;

   projectileShapeName = "art/shapes/weapons/SwarmGun/rocket.dts";

   directDamage = 30;
   radiusDamage = 30;
   damageRadius = 5;
   areaImpulse = 2500;

   // ... remaining ProjectileData fields not listed for this example
};
See also:
LightBase

Member Function Documentation

void LightDescription::apply ( )

Force an inspectPostApply call for the benefit of tweaking via the console.

Normally this functionality is only exposed to objects via the World Editor, once changes have been made. Exposing apply to script allows you to make changes to it on the fly without the World Editor.

Note:
This is intended for debugging and tweaking, not for game play
Example:
// Change a property of the light description
RocketLauncherLightDesc.brightness = 10;

// Make it so
RocketLauncherLightDesc.apply();

Member Data Documentation

float LightDescription::animationPeriod

The length of time in seconds for a single playback of the light animation.

float LightDescription::animationPhase

The phase used to offset the animation start time to vary the animation of nearby lights.

LightAnimData LightDescription::animationType

Datablock containing light animation information (LightAnimData).

Point3F LightDescription::attenuationRatio

The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.

float LightDescription::brightness

Adjusts the lights power, 0 being off completely.

bool LightDescription::castShadows

Enables/disabled shadow casts by this light.

ColorF LightDescription::color

Changes the base color hue of the light.

filename LightDescription::cookie

A custom pattern texture which is projected from the light.

float LightDescription::fadeStartDistance

Start fading shadows out at this distance. 0 = auto calculate this distance.

float LightDescription::flareScale

Globally scales all features of the light flare.

LightFlareData LightDescription::flareType

Datablock containing light flare information (LightFlareData).

bool LightDescription::includeLightmappedGeometryInShadow

This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).

bool LightDescription::lastSplitTerrainOnly

This toggles only terrain being rendered to the last split of a PSSM shadow map.

float LightDescription::logWeight

The logrithmic PSSM split distance factor.

int LightDescription::numSplits

The logrithmic PSSM split distance factor.

Point4F LightDescription::overDarkFactor

The ESM shadow darkening factor.

float LightDescription::range

Controls the size (radius) of the light.

bool LightDescription::representedInLightmap

This light is represented in lightmaps (static light, default: false).

ColorF LightDescription::shadowDarkenColor

The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).

float LightDescription::shadowDistance

The distance from the camera to extend the PSSM shadow.

float LightDescription::shadowSoftness
ShadowType LightDescription::shadowType

The type of shadow to use on this light.

int LightDescription::texSize

The texture size of the shadow map.


Torque 3D - Script Manual: LightFlareData Class Reference

LightFlareData Class Reference
[Lighting]

Defines a light flare effect usable by scene lights. More...

Inheritance diagram for LightFlareData:
[legend]

List of all members.

Public Member Functions

void | apply ()
Intended as a helper to developers and editor scripts.

Public Attributes

FlareElements

float | elementDist [20]
Where this element appears along the flare beam.
RectF | elementRect [20]
A rectangle specified in pixels of the flareTexture image.
bool | elementRotate [20]
Defines if this element orients to point along the flare beam or if it is always upright.
float | elementScale [20]
Size scale applied to this element.
ColorF | elementTint [20]
Used to modulate this element's color if elementUseLightColor is false.
bool | elementUseLightColor [20]
If true this element's color is modulated by the light color. If false, elementTint will be used.
bool | flareEnabled
Allows the user to disable this flare globally for any lights referencing it.
filename | flareTexture
The texture / sprite sheet for this flare.
LightFlareData

float | occlusionRadius
If positive an occlusion query is used to test flare visibility, else it uses simple raycasts.
float | overallScale
Size scale applied to all elements of the flare.
bool | renderReflectPass
If false the flare does not render in reflections, else only non-zero distance elements are rendered.

Detailed Description

Defines a light flare effect usable by scene lights.

LightFlareData is a datablock which defines a type of flare effect. This may then be referenced by other classes which support the rendering of a flare: Sun, ScatterSky, LightBase.

A flare contains one or more elements defined in the element* named fields of LightFlareData, with a maximum of ten elements. Each element is rendered as a 2D sprite in screenspace.

Example:
// example from Full Template, core/art/datablocks/lights.cs
datablock LightFlareData( LightFlareExample0 )
{
   overallScale = 2.0;
   flareEnabled = true;
   renderReflectPass = true;
   flareTexture = "./../special/lensFlareSheet1";
   occlusionRadius = 0.25;

   elementRect[0] = "0 512 512 512";
   elementDist[0] = 0.0;
   elementScale[0] = 0.5;
   elementTint[0] = "1.0 1.0 1.0";
   elementRotate[0] = false;
   elementUseLightColor[0] = false;

   elementRect[1] = "512 0 512 512";
   elementDist[1] = 0.0;
   elementScale[1] = 2.0;
   elementTint[1] = "0.5 0.5 0.5";
   elementRotate[1] = false;
   elementUseLightColor[1] = false;
};

The elementDist field defines where along the flare's beam the element appears. A distance of 0.0 is directly over the light source, a distance of 1.0 is at the screen center, and a distance of 2.0 is at the position of the light source mirrored across the screen center.

Member Function Documentation

void LightFlareData::apply ( )

Intended as a helper to developers and editor scripts.

Force trigger an inspectPostApply

Member Data Documentation

float LightFlareData::elementDist[20]

Where this element appears along the flare beam.

RectF LightFlareData::elementRect[20]

A rectangle specified in pixels of the flareTexture image.

bool LightFlareData::elementRotate[20]

Defines if this element orients to point along the flare beam or if it is always upright.

float LightFlareData::elementScale[20]

Size scale applied to this element.

ColorF LightFlareData::elementTint[20]

Used to modulate this element's color if elementUseLightColor is false.

See also:
elementUseLightColor
bool LightFlareData::elementUseLightColor[20]

If true this element's color is modulated by the light color. If false, elementTint will be used.

See also:
elementTint
bool LightFlareData::flareEnabled

Allows the user to disable this flare globally for any lights referencing it.

filename LightFlareData::flareTexture

The texture / sprite sheet for this flare.

float LightFlareData::occlusionRadius

If positive an occlusion query is used to test flare visibility, else it uses simple raycasts.

float LightFlareData::overallScale

Size scale applied to all elements of the flare.

bool LightFlareData::renderReflectPass

If false the flare does not render in reflections, else only non-zero distance elements are rendered.


Torque 3D - Script Manual: Lightning Class Reference

Lightning Class Reference
[Special Effects, Atmosphere]

An individual lightning bolt, created from a LightningData object. More...

Inheritance diagram for Lightning:
[legend]

List of all members.

Public Member Functions

void | strikeObject (int id=NULL)
Creates a LightningStrikeEvent which strikes a specific object.
void | strikeRandomPoint ()
Creates a LightningStrikeEvent which attempts to strike a random target in range of the Lightning object.
void | warningFlashes ()
Adds a new LightningStrikeEvent to all clients.
Callbacks

void | applyDamage (Point3F hitPosition, Point3F hitNormal, SceneObject hitObject)
Informs an object that it was hit by lightning and needs to take damage.

Public Attributes

Bolts

float | boltStartRadius
The radius in which a lightning bolt can occur from the center of the LightningData object.
float | chanceToHitTarget
Percentage change between 0.0f and 1.0f that the lightning bolt will hit something.
bool | useFog
Boolean, determines the useage of fog on the lightning bolts.
Colors

ColorF | color
Color to blend the StrikeTextures in LightningData with.
ColorF | fadeColor
Color to blend the StrikeTextures in LightningData with when the bolt is fading away.
Strikes

float | strikeRadius
Radius in which a lightning bolt may occur from the center of the Lightning object.
int | strikesPerMinute
Number of lightning strikes to perform per minute.
float | strikeWidth
Width of a lightning bolt.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An individual lightning bolt, created from a LightningData object.

See also:
LightningData

Member Function Documentation

void Lightning::applyDamage | ( | Point3F | hitPosition,
 |  | Point3F | hitNormal,
 |  | SceneObject | hitObject
 | ) |  |

Informs an object that it was hit by lightning and needs to take damage.

Parameters:
Lightning | object.
Object | that was hit.
Position | the lightning bolt hit in the world.
Range | that the lightning bolt struck.
See also:
Lightning, LightningData
void Lightning::strikeObject ( int id = NULL )

Creates a LightningStrikeEvent which strikes a specific object.

Example:
// Define a ShapeBase ID
  %shapeBaseID = 4566;

// Tell the lightning object to create a LightningStrikeEvent which hits a specific target.
%lightning.strikeObject(%shapeBaseID);
void Lightning::strikeRandomPoint ( )

Creates a LightningStrikeEvent which attempts to strike a random target in range of the Lightning object.

Example:
// Tell the lightning object to create a LightningStrikeEvent which will hit a target if one is available.
%lightning.strikeRandomPoint();
void Lightning::warningFlashes ( )

Adds a new LightningStrikeEvent to all clients.

Example:
// Tell the lightning object to create a LightningStrikeEvent on all connected clients.
%lightning.warningFlashes();

Member Data Documentation

float Lightning::boltStartRadius

The radius in which a lightning bolt can occur from the center of the LightningData object.

float Lightning::chanceToHitTarget

Percentage change between 0.0f and 1.0f that the lightning bolt will hit something.

ColorF Lightning::color

Color to blend the StrikeTextures in LightningData with.

ColorF Lightning::fadeColor

Color to blend the StrikeTextures in LightningData with when the bolt is fading away.

bool Lightning::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool Lightning::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

float Lightning::strikeRadius

Radius in which a lightning bolt may occur from the center of the Lightning object.

int Lightning::strikesPerMinute

Number of lightning strikes to perform per minute.

float Lightning::strikeWidth

Width of a lightning bolt.

bool Lightning::useFog

Boolean, determines the useage of fog on the lightning bolts.


Torque 3D - Script Manual: LightningData Class Reference

LightningData Class Reference
[Special Effects, Atmosphere]

An emitter for Lightning objects. More...

Inheritance diagram for LightningData:
[legend]

List of all members.

Public Attributes

SFXTrack strikeSound
Sound profile to play on a lightning strike.
string | strikeTextures [8]
List of textures to use during a lightning strike.
SFXTrack | thunderSounds [8]
List of thunder sound effects to play.

Detailed Description

An emitter for Lightning objects.

See also:
Lightning

Member Data Documentation

SFXTrack LightningData::strikeSound

Sound profile to play on a lightning strike.

string LightningData::strikeTextures[8]

List of textures to use during a lightning strike.

SFXTrack LightningData::thunderSounds[8]

List of thunder sound effects to play.


Torque 3D - Script Manual: LightningStrikeEvent Class Reference

LightningStrikeEvent Class Reference
[Special Effects, Atmosphere]

A lightning bolt strike, called from strikeRandomPoint or strikeObject method on Lightning. More...

Detailed Description

A lightning bolt strike, called from strikeRandomPoint or strikeObject method on Lightning.

See also:
Lightning, LightningData


Torque 3D - Script Manual: Marker Class Reference

Marker Class Reference
[Miscellaneous]

A single joint, or knot, along a path. Should be stored inside a Path container object. A path markers can be one of three primary movement types: "normal", "Position Only", or "Kink". More...

Inheritance diagram for Marker:
[legend]

List of all members.

Public Attributes

Misc

int | msToNext
Milliseconds to next marker in sequence.
int | seqNum
Marker position in sequence of markers on this path.
MarkerSmoothingType smoothingType
Path smoothing at this marker/knot. "Linear"means no smoothing, while "Spline" means to smooth.
MarkerKnotType type
Type of this marker/knot. A "normal" knot will have a smooth camera translation/rotation effect.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A single joint, or knot, along a path. Should be stored inside a Path container object. A path markers can be one of three primary movement types: "normal", "Position Only", or "Kink".

Example:
new path()
   {
     isLooping = "1";

     new Marker()
      {
         seqNum = "0";
         type = "Normal";
         msToNext = "1000";
         smoothingType = "Spline";
         position = "-0.054708 -35.0612 234.802";
         rotation = "1 0 0 0";
      };

   };
See also:
Path

Member Data Documentation

bool Marker::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool Marker::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

int Marker::msToNext

Milliseconds to next marker in sequence.

int Marker::seqNum

Marker position in sequence of markers on this path.

MarkerSmoothingType Marker::smoothingType

Path smoothing at this marker/knot. "Linear"means no smoothing, while "Spline" means to smooth.

MarkerKnotType Marker::type

Type of this marker/knot. A "normal" knot will have a smooth camera translation/rotation effect.

"Position Only"will do the same for translations, leaving rotation un-touched. Lastly, a "Kink" means the rotation will take effect immediately for an abrupt rotation change.


Torque 3D - Script Manual: Material Class Reference

Material Class Reference
[GFX]

A material in Torque 3D is a data structure that describes a surface. More...

Inheritance diagram for Material:
[legend]

List of all members.

Public Attributes

int | alphaRef
The alpha reference value for alpha testing. Must be between 0 to 255.
bool | alphaTest
Enables alpha test when rendering the material.
MaterialAnimType | animFlags [4]
The types of animation to play on this material.
filename | baseTex [4]
For backwards compatibility.
bool | bumpAtlas [4]
filename | bumpTex [4]
For backwards compatibility.
bool | castShadows
If set to false the lighting system will not cast shadows from this material.
Point2I | cellIndex [4]
Point2I | cellLayout [4]
int | cellSize [4]
ColorF | colorMultiply [4]
For backwards compatibility.
string | cubemap
The name of a CubemapData for environment mapping.
filename | detailMap [4]
A typically greyscale detail texture additively blended into the material.
filename | detailNormalMap [4]
A second normal map texture applied at the detail scale. You can use the DXTnm format only when per-pixel specular highlights are disabled.
float | detailNormalMapStrength [4]
Used to scale the strength of the detail normal map when blended with the base normal map.
Point2F | detailScale [4]
The scale factor for the detail map.
filename | detailTex [4]
For backwards compatibility.
ColorF | diffuseColor [4]
This color is multiplied against the diffuse texture color. If no diffuse texture is present this is the material color.
filename | diffuseMap [4]
The diffuse color texture map.
bool | doubleSided
Disables backface culling casing surfaces to be double sided. Note that the lighting on the backside will be a mirror of the front side of the surface.
void | dumpInstances
Dumps a formatted list of the currently allocated material instances for this material to the console.
bool | dynamicCubemap
Enables the material to use the dynamic cubemap from the ShapeBase object its applied to.
bool | emissive [4]
Enables emissive lighting for the material.
filename | envMap [4]
The name of an environment map cube map to apply to this material.
filename | envTex [4]
For backwards compatibility.
void | flush
Flushes all material instances that use this material.
string | getAnimFlags
string | getFilename
Get filename of material.
bool | glow [4]
Enables rendering this material to the glow buffer.
bool | isAutoGenerated
Returns true if this Material was automatically generated by MaterialList::mapMaterials().
filename | lightMap [4]
The lightmap texture used with pureLight.
string | mapTo
Used to map this material to the material name used by TSShape.
float | minnaertConstant [4]
The Minnaert shading constant value. Must be greater than 0 to enable the effect.
filename | normalMap [4]
The normal map texture. You can use the DXTnm format only when per-pixel specular highlights are disabled, or a specular map is in use.
filename | overlayMap [4]
A secondary diffuse color texture map which will use the second texcoord of a mesh.
filename | overlayTex [4]
For backwards compatibility.
float | parallaxScale [4]
Enables parallax mapping and defines the scale factor for the parallax effect. Typically this value is less than 0.4 else the effect breaks down.
bool | pixelSpecular [4]
This enables per-pixel specular highlights controlled by the alpha channel of the normal map texture. Note that if pixel specular is enabled the DXTnm format will not work with your normal map, unless you are also using a specular map.
bool | planarReflection
void | reload
Reloads all material instances that use this material.
Point2F | rotPivotOffset [4]
The piviot position in UV coordinates to center the rotation animation.
float | rotSpeed [4]
The speed to rotate the texture in degrees per second when rotation animation is enabled.
Point2F | scrollDir [4]
The scroll direction in UV space when scroll animation is enabled.
float | scrollSpeed [4]
The speed to scroll the texture in UVs per second when scroll animation is enabled.
float | sequenceFramePerSec [4]
The number of frames per second for frame based sequence animations if greater than zero.
float | sequenceSegmentSize [4]
The size of each frame in UV units for sequence animations.
void | setAutoGenerated
setAutoGenerated(bool isAutoGenerated): Set whether or not the Material is autogenerated.
ColorF | specular [4]
The color of the specular highlight when not using a specularMap.
filename | specularMap [4]
The specular map texture. The RGB channels of this texture provide a per-pixel replacement for the 'specular' parameter on the material. If this texture contains alpha information, the alpha channel of the texture will be used as the gloss map. This provides a per-pixel replacement for the 'specularPower' on the material.
float | specularPower [4]
The intensity of the specular highlight when not using a specularMap.
bool | subSurface [4]
Enables the subsurface scattering approximation.
ColorF | subSurfaceColor [4]
The color used for the subsurface scattering approximation.
float | subSurfaceRolloff [4]
The 0 to 1 rolloff factor used in the subsurface scattering approximation.
filename | toneMap [4]
The tonemap texture used with pureLight.
bool | translucent
If true this material is translucent blended.
MaterialBlendOp translucentBlendOp
The type of blend operation to use when the material is translucent.
bool | translucentZWrite
If enabled and the material is translucent it will write into the depth buffer.
bool | useAnisotropic [4]
Use anisotropic filtering for the textures of this stage.
bool | vertColor [4]
If enabled, vertex colors are premultiplied with diffuse colors.
bool | vertLit [4]
If true the vertex color is used for lighting.
float | waveAmp [4]
The wave amplitude when wave animation is enabled.
float | waveFreq [4]
The wave frequency when wave animation is enabled.
MaterialWaveType | waveType [4]
The type of wave animation to perform when wave animation is enabled.
Behavioral

SFXTrack customFootstepSound
The sound to play when the player walks over the material. If this is set, it overrides footstepSoundId. This field is useful for directly assigning custom footstep sounds to materials without having to rely on the PlayerData sound assignment.
SFXTrack customImpactSound
The sound to play when the player impacts on the surface with a velocity equal or greater than PlayerData::groundImpactMinSpeed. If this is set, it overrides impactSoundId. This field is useful for directly assigning custom impact sounds to materials without having to rely on the PlayerData sound assignment.
ColorF | effectColor [2]
If showDust is true, this is the set of colors to use for the ParticleData of the dust emitter.
int | footstepSoundId
What sound to play from the PlayerData sound list when the player walks over the material. -1 (default) to not play any sound.
int | impactSoundId
What sound to play from the PlayerData sound list when the player impacts on the surface with a velocity equal or greater than PlayerData::groundImpactMinSpeed.
bool | showDust
Whether to emit dust particles from a shape moving over the material. This is, for example, used by vehicles or players to decide whether to show dust trails.
bool | showFootprints
Whether to show player footprint decals on this material.

Detailed Description

A material in Torque 3D is a data structure that describes a surface.

It contains many different types of information for rendering properties. Torque 3D generates shaders from Material definitions. The shaders are compiled at runtime and output into the example/shaders directory. Any errors or warnings generated from compiling the procedurally generated shaders are output to the console as well as the output window in the Visual C IDE.

Example:
singleton Material(DECAL_scorch)
{
   baseTex[0] = "./scorch_decal.png";
   vertColor[ 0 ] = true;

   translucent = true;
   translucentBlendOp = None;
   translucentZWrite = true;
   alphaTest = true;
   alphaRef = 84;
};
See also:
Rendering
ShaderData

Member Data Documentation

int Material::alphaRef

The alpha reference value for alpha testing. Must be between 0 to 255.

See also:
alphaTest
bool Material::alphaTest

Enables alpha test when rendering the material.

See also:
alphaRef
MaterialAnimType Material::animFlags[4]

The types of animation to play on this material.

filename Material::baseTex[4]

For backwards compatibility.

See also:
diffuseMap
bool Material::bumpAtlas[4]
filename Material::bumpTex[4]

For backwards compatibility.

See also:
normalMap
bool Material::castShadows

If set to false the lighting system will not cast shadows from this material.

Point2I Material::cellIndex[4]
Point2I Material::cellLayout[4]
int Material::cellSize[4]
ColorF Material::colorMultiply[4]

For backwards compatibility.

See also:
diffuseColor
string Material::cubemap

The name of a CubemapData for environment mapping.

SFXTrack Material::customFootstepSound

The sound to play when the player walks over the material. If this is set, it overrides footstepSoundId. This field is useful for directly assigning custom footstep sounds to materials without having to rely on the PlayerData sound assignment.

Be aware that materials are client-side objects. This means that the SFXTracks assigned to materials must be client-side, too.

SFXTrack Material::customImpactSound

The sound to play when the player impacts on the surface with a velocity equal or greater than PlayerData::groundImpactMinSpeed. If this is set, it overrides impactSoundId. This field is useful for directly assigning custom impact sounds to materials without having to rely on the PlayerData sound assignment.

Be aware that materials are client-side objects. This means that the SFXTracks assigned to materials must be client-side, too.

filename Material::detailMap[4]

A typically greyscale detail texture additively blended into the material.

filename Material::detailNormalMap[4]

A second normal map texture applied at the detail scale. You can use the DXTnm format only when per-pixel specular highlights are disabled.

float Material::detailNormalMapStrength[4]

Used to scale the strength of the detail normal map when blended with the base normal map.

Point2F Material::detailScale[4]

The scale factor for the detail map.

filename Material::detailTex[4]

For backwards compatibility.

See also:
detailMap
ColorF Material::diffuseColor[4]

This color is multiplied against the diffuse texture color. If no diffuse texture is present this is the material color.

filename Material::diffuseMap[4]

The diffuse color texture map.

bool Material::doubleSided

Disables backface culling casing surfaces to be double sided. Note that the lighting on the backside will be a mirror of the front side of the surface.

void Material::dumpInstances

Dumps a formatted list of the currently allocated material instances for this material to the console.

bool Material::dynamicCubemap

Enables the material to use the dynamic cubemap from the ShapeBase object its applied to.

ColorF Material::effectColor[2]

If showDust is true, this is the set of colors to use for the ParticleData of the dust emitter.

See also:
ParticleData::colors
bool Material::emissive[4]

Enables emissive lighting for the material.

filename Material::envMap[4]

The name of an environment map cube map to apply to this material.

filename Material::envTex[4]

For backwards compatibility.

See also:
envMap
void Material::flush

Flushes all material instances that use this material.

int Material::footstepSoundId

What sound to play from the PlayerData sound list when the player walks over the material. -1 (default) to not play any sound.

The IDs are:

  • 0: PlayerData::FootSoftSound
  • 1: PlayerData::FootHardSound
  • 2: PlayerData::FootMetalSound
  • 3: PlayerData::FootSnowSound
  • 4: PlayerData::FootShallowSound
  • 5: PlayerData::FootWadingSound
  • 6: PlayerData::FootUnderwaterSound
  • 7: PlayerData::FootBubblesSound
  • 8: PlayerData::movingBubblesSound
  • 9: PlayerData::waterBreathSound
  • 10: PlayerData::impactSoftSound
  • 11: PlayerData::impactHardSound
  • 12: PlayerData::impactMetalSound
  • 13: PlayerData::impactSnowSound
  • 14: PlayerData::impactWaterEasy
  • 15: PlayerData::impactWaterMedium
  • 16: PlayerData::impactWaterHard
  • 17: PlayerData::exitingWater
string Material::getAnimFlags
string Material::getFilename

Get filename of material.

bool Material::glow[4]

Enables rendering this material to the glow buffer.

int Material::impactSoundId

What sound to play from the PlayerData sound list when the player impacts on the surface with a velocity equal or greater than PlayerData::groundImpactMinSpeed.

For a list of IDs, see footstepSoundId

bool Material::isAutoGenerated

Returns true if this Material was automatically generated by MaterialList::mapMaterials().

filename Material::lightMap[4]

The lightmap texture used with pureLight.

string Material::mapTo

Used to map this material to the material name used by TSShape.

float Material::minnaertConstant[4]

The Minnaert shading constant value. Must be greater than 0 to enable the effect.

filename Material::normalMap[4]

The normal map texture. You can use the DXTnm format only when per-pixel specular highlights are disabled, or a specular map is in use.

filename Material::overlayMap[4]

A secondary diffuse color texture map which will use the second texcoord of a mesh.

filename Material::overlayTex[4]

For backwards compatibility.

See also:
overlayMap
float Material::parallaxScale[4]

Enables parallax mapping and defines the scale factor for the parallax effect. Typically this value is less than 0.4 else the effect breaks down.

bool Material::pixelSpecular[4]

This enables per-pixel specular highlights controlled by the alpha channel of the normal map texture. Note that if pixel specular is enabled the DXTnm format will not work with your normal map, unless you are also using a specular map.

bool Material::planarReflection
void Material::reload

Reloads all material instances that use this material.

Point2F Material::rotPivotOffset[4]

The piviot position in UV coordinates to center the rotation animation.

float Material::rotSpeed[4]

The speed to rotate the texture in degrees per second when rotation animation is enabled.

Point2F Material::scrollDir[4]

The scroll direction in UV space when scroll animation is enabled.

float Material::scrollSpeed[4]

The speed to scroll the texture in UVs per second when scroll animation is enabled.

float Material::sequenceFramePerSec[4]

The number of frames per second for frame based sequence animations if greater than zero.

float Material::sequenceSegmentSize[4]

The size of each frame in UV units for sequence animations.

void Material::setAutoGenerated

setAutoGenerated(bool isAutoGenerated): Set whether or not the Material is autogenerated.

bool Material::showDust

Whether to emit dust particles from a shape moving over the material. This is, for example, used by vehicles or players to decide whether to show dust trails.

bool Material::showFootprints

Whether to show player footprint decals on this material.

See also:
PlayerData::decalData
ColorF Material::specular[4]

The color of the specular highlight when not using a specularMap.

filename Material::specularMap[4]

The specular map texture. The RGB channels of this texture provide a per-pixel replacement for the 'specular' parameter on the material. If this texture contains alpha information, the alpha channel of the texture will be used as the gloss map. This provides a per-pixel replacement for the 'specularPower' on the material.

float Material::specularPower[4]

The intensity of the specular highlight when not using a specularMap.

bool Material::subSurface[4]

Enables the subsurface scattering approximation.

ColorF Material::subSurfaceColor[4]

The color used for the subsurface scattering approximation.

float Material::subSurfaceRolloff[4]

The 0 to 1 rolloff factor used in the subsurface scattering approximation.

filename Material::toneMap[4]

The tonemap texture used with pureLight.

bool Material::translucent

If true this material is translucent blended.

MaterialBlendOp Material::translucentBlendOp

The type of blend operation to use when the material is translucent.

bool Material::translucentZWrite

If enabled and the material is translucent it will write into the depth buffer.

bool Material::useAnisotropic[4]

Use anisotropic filtering for the textures of this stage.

bool Material::vertColor[4]

If enabled, vertex colors are premultiplied with diffuse colors.

bool Material::vertLit[4]

If true the vertex color is used for lighting.

float Material::waveAmp[4]

The wave amplitude when wave animation is enabled.

float Material::waveFreq[4]

The wave frequency when wave animation is enabled.

MaterialWaveType Material::waveType[4]

The type of wave animation to perform when wave animation is enabled.


Torque 3D - Script Manual: MeshRoad Class Reference

MeshRoad Class Reference
[Terrain]

A strip of rectangular mesh segments defined by a 3D spline for prototyping road-shaped objects in your scene. More...

Inheritance diagram for MeshRoad:
[legend]

List of all members.

Public Member Functions

void | postApply ()
Intended as a helper to developers and editor scripts.
void | regenerate ()
Intended as a helper to developers and editor scripts.
void | setNodeDepth (int idx, float meters)
Intended as a helper to developers and editor scripts.

Public Attributes

MeshRoad

string | bottomMaterial
Material for the bottom surface of the road.
float | breakAngle
Angle in degrees - MeshRoad will subdivide the spline if its curve is greater than this threshold.
string | sideMaterial
Material for the left, right, front, and back surfaces of the road.
float | textureLength
The length in meters of textures mapped to the MeshRoad.
string | topMaterial
Material for the upper surface of the road.
int | widthSubdivisions
Subdivide segments widthwise this many times when generating vertices.
Internal

string | Node
Do not modify, for internal use.

Static Public Attributes

static bool | EditorOpen
True if the MeshRoad editor is open, otherwise false.
static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static bool | showBatches
Determines if the debug rendering of the batches cubes is displayed or not.
static bool | showRoad
If true, the road will be rendered. When in the editor, roads are always rendered regardless of this flag.
static bool | showSpline
If true, the spline on which the curvature of this road is based will be rendered.
static bool | wireframe
If true, will render the wireframe of the road.

Detailed Description

A strip of rectangular mesh segments defined by a 3D spline for prototyping road-shaped objects in your scene.

User may control width and depth per node, overall spline shape in three dimensions, and seperate Materials for rendering the top, bottom, and side surfaces.

MeshRoad is not capable of handling intersections, branches, curbs, or other desirable features in a final 'road' asset and is therefore intended for prototyping and experimentation.

Materials assigned to MeshRoad should tile vertically.

Member Function Documentation

void MeshRoad::postApply ( )

Intended as a helper to developers and editor scripts.

Force trigger an inspectPostApply. This will transmit material and other fields ( not including nodes ) to client objects.

void MeshRoad::regenerate ( )

Intended as a helper to developers and editor scripts.

Force MeshRoad to recreate its geometry.

void MeshRoad::setNodeDepth | ( | int | idx,
 |  | float | meters
 | ) |  |

Intended as a helper to developers and editor scripts.

Sets the depth in meters of a particular node.

Member Data Documentation

string MeshRoad::bottomMaterial

Material for the bottom surface of the road.

float MeshRoad::breakAngle

Angle in degrees - MeshRoad will subdivide the spline if its curve is greater than this threshold.

bool MeshRoad::EditorOpen [static]

True if the MeshRoad editor is open, otherwise false.

bool MeshRoad::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool MeshRoad::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string MeshRoad::Node

Do not modify, for internal use.

bool MeshRoad::showBatches [static]

Determines if the debug rendering of the batches cubes is displayed or not.

bool MeshRoad::showRoad [static]

If true, the road will be rendered. When in the editor, roads are always rendered regardless of this flag.

bool MeshRoad::showSpline [static]

If true, the spline on which the curvature of this road is based will be rendered.

string MeshRoad::sideMaterial

Material for the left, right, front, and back surfaces of the road.

float MeshRoad::textureLength

The length in meters of textures mapped to the MeshRoad.

string MeshRoad::topMaterial

Material for the upper surface of the road.

int MeshRoad::widthSubdivisions

Subdivide segments widthwise this many times when generating vertices.

bool MeshRoad::wireframe [static]

If true, will render the wireframe of the road.


Torque 3D - Script Manual: Message Class Reference

Message Class Reference
[Messaging]

Base class for messages. More...

Inheritance diagram for Message:
[legend]

List of all members.

Public Member Functions

void | addReference ()
Increment the reference count for this message.
void | freeReference ()
Decrement the reference count for this message.
string | getType ()
Get message type (script class name or C++ class name if no script defined class).
Callbacks

void | onAdd ()
Script callback when a message is first created and registered.
void | onRemove ()
Script callback when a message is deleted.

Detailed Description

Base class for messages.

Message is the base class for C++ defined messages, and may also be used in script for script defined messages if no C++ subclass is appropriate.

Messages are reference counted and will be automatically deleted when their reference count reaches zero. When you dispatch a message, a reference will be added before the dispatch and freed after the dispatch. This allows for temporary messages with no additional code. If you want to keep the message around, for example to dispatch it to multiple queues, call addReference() before dispatching it and freeReference() when you are done with it. Never delete a Message object directly unless addReference() has not been called or the message has not been dispatched.

Message IDs are pooled similarly to datablocks, with the exception that IDs are reused. If you keep a message for longer than a single dispatch, then you should ensure that you clear any script variables that refer to it after the last freeReference(). If you don't, then it is probable that the object ID will become valid again in the future and could cause hard to track down bugs.

Messages have a unique type to simplify message handling code. For object messages, the type is defined as either the script defined class name or the C++ class name if no script class was defined. The message type may be obtained through the getType() method.

By convention, any data for the message is held in script accessible fields. Messages that need to be handled in C++ as well as script provide the relevant data through persistent fields in a subclass of Message to provide best performance on the C++ side. Script defined messages usually their through dynamic fields, and may be accessed in C++ using the SimObject::getDataField() method.

Member Function Documentation

void Message::addReference ( )

Increment the reference count for this message.

void Message::freeReference ( )

Decrement the reference count for this message.

string Message::getType ( )

Get message type (script class name or C++ class name if no script defined class).

void Message::onAdd ( )

Script callback when a message is first created and registered.

Example:
function Message::onAdd(%this)
{
   // Perform on add code here
}
void Message::onRemove ( )

Script callback when a message is deleted.

Example:
function Message::onRemove(%this)
{
   // Perform on remove code here
}


Torque 3D - Script Manual: MessageForwarder Class Reference

MessageForwarder Class Reference
[Messaging]

Forward messages from one queue to another. More...

Inheritance diagram for MessageForwarder:
[legend]

List of all members.

Public Attributes

caseString toQueue
Name of queue to forward to.

Detailed Description

Forward messages from one queue to another.

MessageForwarder is a script class that can be used to forward messages from one queue to another.

Example:
%fwd = new MessageForwarder()
{
   toQueue = "QueueToSendTo";
};

registerMessageListener("FromQueue", %fwd);

Where "QueueToSendTo" is the queue you want to forward to, and "FromQueue" is the queue you want to forward from.

Member Data Documentation

caseString MessageForwarder::toQueue

Name of queue to forward to.


Torque 3D - Script Manual: MessageVector Class Reference

MessageVector Class Reference
[Utility Controls]

Store a list of chat messages. More...

Inheritance diagram for MessageVector:
[legend]

List of all members.

Public Member Functions

void | clear ()
Clear all messages in the vector.
bool | deleteLine (int deletePos)
Delete the line at the specified position.
void | dump (string filename)
Dump the message vector to a file without a header.
void | dump (string filename, string header)
Dump the message vector to a file with a header.
int | getLineIndexByTag (int tag)
Scan through the vector, returning the line number of the first line that matches the specified tag; else returns -1 if no match was found.
int | getLineTag (int pos)
Get the tag of a specified line.
string | getLineText (int pos)
Get the text at a specified line.
string | getLineTextByTag (int tag)
Scan through the lines in the vector, returning the first line that has a matching tag.
int | getNumLines ()
Get the number of lines in the vector.
bool | insertLine (int insertPos, string msg, int tag)
Push a line onto the back of the list.
bool | popBackLine ()
Pop a line from the back of the list; destroys the line.
bool | popFrontLine ()
Pop a line from the front of the vector, destroying the line.
void | pushBackLine (string msg, int tag)
Push a line onto the back of the list.
void | pushFrontLine (string msg, int tag)
Push a line onto the front of the vector.

Detailed Description

Store a list of chat messages.

This is responsible for managing messages which appear in the chat HUD, not the actual control rendered to the screen

Example:
// Declare ChatHud, which is what will display the actual chat from a MessageVector
new GuiMessageVectorCtrl(ChatHud) {
   profile = "ChatHudMessageProfile";
   horizSizing = "width";
   vertSizing = "height";
   position = "1 1";
   extent = "252 16";
   minExtent = "8 8";
   visible = "1";
   helpTag = "0";
   lineSpacing = "0";
   lineContinuedIndex = "10";
   matchColor = "0 0 255 255";
   maxColorIndex = "5";
};

// All messages are stored in this HudMessageVector, the actual
// MainChatHud only displays the contents of this vector.
new MessageVector(HudMessageVector);

// Attach the MessageVector to the chat control
chatHud.attach(HudMessageVector);
See also:
GuiMessageVectorCtrl for more details on how this is used.

Member Function Documentation

void MessageVector::clear ( )

Clear all messages in the vector.

Example:
HudMessageVector.clear();
bool MessageVector::deleteLine ( int deletePos )

Delete the line at the specified position.

Parameters:
deletePos Position in the vector containing the line to be deleted
Example:
// Delete the first line (index 0) in the vector...
HudMessageVector.deleteLine(0);
Returns:
False if deletePos is greater than the number of lines in the current vector
void MessageVector::dump ( string filename )

Dump the message vector to a file without a header.

Parameters:
filename Name and path of file to dump text to.
Example:
// Dump the entire chat log to a text file
HudMessageVector.dump("./chatLog.txt");

void MessageVector::dump | ( | string | filename,
 |  | string | header
 | ) |  |

Dump the message vector to a file with a header.

Parameters:
filename | Name and path of file to dump text to.
header | Prefix information for write out
Example:
// Arbitrary header data
%headerInfo = "Ars Moriendi Chat Log";

// Dump the entire chat log to a text file
HudMessageVector.dump("./chatLog.txt", %headerInfo);
int MessageVector::getLineIndexByTag ( int tag )

Scan through the vector, returning the line number of the first line that matches the specified tag; else returns -1 if no match was found.

Parameters:
tag Numerical value assigned to a message when it was added or inserted
Example:
// Locate a line of text tagged with the value "1", then delete it.
%taggedLine = HudMessageVector.getLineIndexByTag(1);
HudMessageVector.deleteLine(%taggedLine);
Returns:
Line with matching tag, other wise -1
int MessageVector::getLineTag ( int pos )

Get the tag of a specified line.

Parameters:
pos Position in vector to grab tag from
Example:
// Remove all lines that do not have a tag value of 1.
while( HudMessageVector.getNumLines())
{
   %tag = HudMessageVector.getLineTag(1);
   if(%tag != 1)
      %tag.delete();
   HudMessageVector.popFrontLine();
}
Returns:
Tag value of a given line, if the position is greater than the number of lines return 0
string MessageVector::getLineText ( int pos )

Get the text at a specified line.

Parameters:
pos Position in vector to grab text from
Example:
// Print a line of text at position 1.
%text = HudMessageVector.getLineText(1);
echo(%text);
Returns:
Text at specified line, if the position is greater than the number of lines return ""
string MessageVector::getLineTextByTag ( int tag )

Scan through the lines in the vector, returning the first line that has a matching tag.

Parameters:
tag Numerical value assigned to a message when it was added or inserted
Example:
// Locate text in the vector tagged with the value "1", then print it
%taggedText = HudMessageVector.getLineTextByTag(1);
echo(%taggedText);
Returns:
Text from a line with matching tag, other wise ""
int MessageVector::getNumLines ( )

Get the number of lines in the vector.

Example:
// Find out how many lines have been stored in HudMessageVector
%chatLines = HudMessageVector.getNumLines();
echo(%chatLines);

bool MessageVector::insertLine | ( | int | insertPos,
 |  | string | msg,
 |  | int | tag
 | ) |  |

Push a line onto the back of the list.

Parameters:
msg | Text that makes up the message
tag | Numerical value associated with this message, useful for searching.
Example:
// Add the message...
HudMessageVector.insertLine(1, "Hello World", 0);
Returns:
False if insertPos is greater than the number of lines in the current vector
bool MessageVector::popBackLine ( )

Pop a line from the back of the list; destroys the line.

Example:
HudMessageVector.popBackLine();
Returns:
False if there are no lines to pop (underflow), true otherwise
bool MessageVector::popFrontLine ( )

Pop a line from the front of the vector, destroying the line.

Example:
HudMessageVector.popFrontLine();
Returns:
False if there are no lines to pop (underflow), true otherwise
void MessageVector::pushBackLine | ( | string | msg,
 |  | int | tag
 | ) |  |

Push a line onto the back of the list.

Parameters:
msg | Text that makes up the message
tag | Numerical value associated with this message, useful for searching.
Example:
// Add the message...
HudMessageVector.pushBackLine("Hello World", 0);

void MessageVector::pushFrontLine | ( | string | msg,
 |  | int | tag
 | ) |  |

Push a line onto the front of the vector.

Parameters:
msg | Text that makes up the message
tag | Numerical value associated with this message, useful for searching.
Example:
// Add the message...
HudMessageVector.pushFrontLine("Hello World", 0);


Torque 3D - Script Manual: MissionArea Class Reference

MissionArea Class Reference
[Miscellaneous]

Level object which defines the boundaries of the level. More...

Inheritance diagram for MissionArea:
[legend]

List of all members.

Public Member Functions

string | getArea ()
Returns 4 fields: starting x, starting y, extents x, extents y.
void | postApply ()
Intended as a helper to developers and editor scripts.
void | setArea (int x, int y, int width, int height)
  • Defines the size of the MissionArea

Public Attributes

Dimensions

RectI | area
Four corners (X1, X2, Y1, Y2) that makes up the level's boundaries.
float | flightCeiling
Represents the top of the mission area, used by FlyingVehicle.
float | flightCeilingRange
Distance from ceiling before FlyingVehicle thrust is cut off.

Detailed Description

Level object which defines the boundaries of the level.

This is a simple box with starting points, width, depth, and height. It does not have any default functionality. Instead, when objects hit the boundaries certain script callbacks will be made allowing you to control the reaction.

Example:
new MissionArea(GlobalMissionArea)
{
     Area = "-152 -352 1008 864";
     flightCeiling = "300";
     flightCeilingRange = "20";
     canSaveDynamicFields = "1";
       enabled = "1";
       TypeBool locked = "false";
};

Member Function Documentation

string MissionArea::getArea ( )

Returns 4 fields: starting x, starting y, extents x, extents y.

void MissionArea::postApply ( )

Intended as a helper to developers and editor scripts.

Force trigger an inspectPostApply. This will transmit material and other fields ( not including nodes ) to client objects.

void MissionArea::setArea | ( | int | x,
 |  | int | y,
 |  | int | width,
 |  | int | height
 | ) |  |

  • Defines the size of the MissionArea

param x Starting X coordinate position for MissionArea param y Starting Y coordinate position for MissionArea param width New width of the MissionArea param height New height of the MissionArea

Note:
Only the server object may be set.

Member Data Documentation

RectI MissionArea::area

Four corners (X1, X2, Y1, Y2) that makes up the level's boundaries.

float MissionArea::flightCeiling

Represents the top of the mission area, used by FlyingVehicle.

float MissionArea::flightCeilingRange

Distance from ceiling before FlyingVehicle thrust is cut off.


Torque 3D - Script Manual: MissionMarker Class Reference

MissionMarker Class Reference
[Miscellaneous]

This is a base class for all "marker" related objets. It is a 3D representation of a point in the level. More...

Inheritance diagram for MissionMarker:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

This is a base class for all "marker" related objets. It is a 3D representation of a point in the level.

The main use of a MissionMarker is to represent a point in 3D space with a mesh and basic ShapeBase information. If you simply need to mark a spot in your level, with no overhead from additional fields, this is a useful object.

Example:
new MissionMarker()
{
   dataBlock = "WayPointMarker";
   position = "295.699 -171.817 280.124";
   rotation = "0 0 -1 13.8204";
   scale = "1 1 1";
   isRenderEnabled = "true";
   canSaveDynamicFields = "1";
   enabled = "1";
};
Note:
MissionMarkers will not add themselves to the scene except when in the editor.
See also:
MissionMarkerData
SpawnSphere
WayPoint

Member Data Documentation

bool MissionMarker::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

Reimplemented in WayPoint, and SpawnSphere.

bool MissionMarker::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.

Reimplemented in WayPoint, and SpawnSphere.


Torque 3D - Script Manual: MissionMarkerData Class Reference

MissionMarkerData Class Reference
[Miscellaneous]

A very basic class containing information used by MissionMarker objects for rendering. More...

Inheritance diagram for MissionMarkerData:
[legend]

List of all members.

Detailed Description

A very basic class containing information used by MissionMarker objects for rendering.

MissionMarkerData, is an extremely barebones class derived from ShapeBaseData. It is solely used by MissionMarker classes (such as SpawnSphere), so that you can see the object while editing a level.

Example:
datablock MissionMarkerData(SpawnSphereMarker)
{
   category = "Misc";
   shapeFile = "core/art/shapes/octahedron.dts";
};
See also:
MissionMarker
SpawnSphere
WayPoint


Torque 3D - Script Manual: NetConnection Class Reference

NetConnection Class Reference
[Networking]

Provides the basis for implementing a multiplayer game protocol. More...

Inheritance diagram for NetConnection:
[legend]

List of all members.

Public Member Functions

void | checkMaxRate ()
Ensures that all configured packet rates and sizes meet minimum requirements.
void | clearPaths ()
On the server, resets the connection to indicate that mod paths have not been transmitted.
void | connect (string remoteAddress)
Connects to the remote address.
string | connectLocal ()
Connects with the server that is running within the same process as the client.
string | getAddress ()
Returns the far end network address for the connection.
int | getGhostID (int realID)
On server or client, convert a real id to the ghost id for this connection.
int | getGhostsActive ()
Returns the number of active ghosts on the connection.
int | getPacketLoss ()
Returns the percentage of packets lost per tick.
int | getPing ()
Returns the average round trip time (in ms) for the connection.
int | resolveGhostID (int ghostID)
On the client, convert a ghost ID from this connection to a real SimObject ID.
int | resolveObjectFromGhostIndex (int ghostID)
On the server, convert a ghost ID from this connection to a real SimObject ID.
void | setSimulatedNetParams (float packetLoss, int delay)
Simulate network issues on the connection for testing.
void | transmitPaths ()
Sent by the server during phase 2 of the mission download to update mod paths.

Detailed Description

Provides the basis for implementing a multiplayer game protocol.

NetConnection combines a low-level notify protocol implemented in ConnectionProtocol with a SimGroup, and implements several distinct subsystems:

  • Event Manager This is responsible for transmitting NetEvents over the wire. It deals with ensuring that the various types of NetEvents are delivered appropriately, and with notifying the event of its delivery status.
  • Move Manager This is responsible for transferring a Move to the server 32 times a second (on the client) and applying it to the control object (on the server).
  • Ghost Manager This is responsible for doing scoping calculations (on the server side) and transmitting most-recent ghost information to the client.
  • File Transfer It is often the case that clients will lack important files when connecting to a server which is running a mod or new map. This subsystem allows the server to transfer such files to the client.
  • Networked String Table String data can easily soak up network bandwidth, so for efficiency, we implement a networked string table. We can then notify the connection of strings we will reference often, such as player names, and transmit only a tag, instead of the whole string.
  • Demo Recording A demo in Torque is a log of the network traffic between client and server; when a NetConnection records a demo, it simply logs this data to a file. When it plays a demo back, it replays the logged data.
  • Connection Database This is used to keep track of all the NetConnections; it can be iterated over (for instance, to send an event to all active connections), or queried by address.

The NetConnection is a SimGroup. On the client side, it contains all the objects which have been ghosted to that client. On the server side, it is empty; it can be used (typically in script) to hold objects related to the connection. For instance, you might place an observation camera in the NetConnnection. In both cases, when the connection is destroyed, so are the contained objects.

The NetConnection also has the concept of local connections. These are used when the client and server reside in the same process. A local connection is typically required to use the standard Torque world building tools. A local connection is also required when building a single player game.

See also:
Networking, On Ghosting and Scoping, Local Connections, GameConnection, AIConnection, and AIClient.

Member Function Documentation

void NetConnection::checkMaxRate ( )

Ensures that all configured packet rates and sizes meet minimum requirements.

This method is normally only called when a NetConnection class is first constructed. It need only be manually called if the global variables that set the packet rate or size have changed.

Note:
If
pref
:Net::PacketRateToServer,

pref::Net::PacketRateToClient or $pref::Net::PacketSize have been changed since a NetConnection has been created, this method must be called on all connections for them to follow the new rates or size.

void NetConnection::clearPaths ( )

On the server, resets the connection to indicate that mod paths have not been transmitted.

Typically when a mission has ended on the server, all connected clients are informed of this change and their connections are reset back to a starting state. This method resets a connection on the server to indicate that mod paths have not been transmitted.

Example:
   // Inform the clients
   for (%clientIndex = 0; %clientIndex < ClientGroup.getCount(); %clientIndex++)
   {
      // clear ghosts and paths from all clients
      %cl = ClientGroup.getObject(%clientIndex);
      %cl.endMission();
      %cl.resetGhosting();
      %cl.clearPaths();
   }
void NetConnection::connect ( string remoteAddress )

Connects to the remote address.

Attempts to connect with another NetConnection on the given address. Typically once connected, a game's information is passed along from the server to the client, followed by the player entering the game world. The actual procedure is dependent on the NetConnection subclass that is used. i.e. GameConnection.

Parameters:
remoteAddress The address to connect to in the form of IP:<address>:<port although the IP: portion is optional. The address portion may be in the form of w.x.y.z or as a host name, in which case a DNS lookup will be performed. You may also substitue the word broadcast for the address to broadcast the connect request over the local subnet.
See also:
NetConnection::connectLocal() to connect to a server running within the same process as the client.
string NetConnection::connectLocal ( )

Connects with the server that is running within the same process as the client.

Returns:
An error text message upon failure, or an empty string when successful.
See also:
See Local Connections for a description of local connections and their use. See NetConnection::connect() to connect to a server running in another process (on the same machine or not).
string NetConnection::getAddress ( )

Returns the far end network address for the connection.

The address will be in one of the following forms:

  • IP:Broadcast:<port> for broadcast type addresses
  • IP:<address>:<port> for IP addresses
  • local when connected locally (server and client running in same process
int NetConnection::getGhostID ( int realID )

On server or client, convert a real id to the ghost id for this connection.

Torque's network ghosting system only exchanges ghost ID's between the server and client. Use this method on the server or client to discover an object's ghost ID based on its real SimObject ID.

Parameters:
realID The real SimObject ID of the object.
Returns:
The ghost ID of the object for this connection, or -1 if it could not be resolved.
See also:
On Ghosting and Scoping for a description of the ghosting system.
int NetConnection::getGhostsActive ( )

Returns the number of active ghosts on the connection.

int NetConnection::getPacketLoss ( )

Returns the percentage of packets lost per tick.

Note:
This method is not yet hooked up.
int NetConnection::getPing ( )

Returns the average round trip time (in ms) for the connection.

The round trip time is recalculated every time a notify packet is received. Notify packets are used to information the connection that the far end successfully received the sent packet.

int NetConnection::resolveGhostID ( int ghostID )

On the client, convert a ghost ID from this connection to a real SimObject ID.

Torque's network ghosting system only exchanges ghost ID's between the server and client. Use this method on the client to discover an object's local SimObject ID when you only have a ghost ID.

Parameters:
ghostID The ghost ID of the object as sent by the server.
Returns:
The SimObject ID of the object, or 0 if it could not be resolved.
Example:
%object = ServerConnection.resolveGhostID( %ghostId );
See also:
On Ghosting and Scoping for a description of the ghosting system.
int NetConnection::resolveObjectFromGhostIndex ( int ghostID )

On the server, convert a ghost ID from this connection to a real SimObject ID.

Torque's network ghosting system only exchanges ghost ID's between the server and client. Use this method on the server to discover an object's local SimObject ID when you only have a ghost ID.

Parameters:
ghostID The ghost ID of the object as sent by the server.
Returns:
The SimObject ID of the object, or 0 if it could not be resolved.
Example:
%object = %client.resolveObjectFromGhostIndex( %ghostId );
See also:
On Ghosting and Scoping for a description of the ghosting system.
void NetConnection::setSimulatedNetParams | ( | float | packetLoss,
 |  | int | delay
 | ) |  |

Simulate network issues on the connection for testing.

Parameters:
packetLoss | The fraction of packets that will be lost. Ranges from 0.0 (no loss) to 1.0 (complete loss)
delay | Delays packets being transmitted by simulating a particular ping. This is an absolute integer, measured in ms.
void NetConnection::transmitPaths ( )

Sent by the server during phase 2 of the mission download to update mod paths.

Mod paths on the client need to be in sync with the server prior to objects being ghosted. This is typically done during the standard mission start phase 2 when following Torque's example mission startup sequence.

Example:
function serverCmdMissionStartPhase2Ack(%client, %seq, %playerDB)
{
   // Make sure to ignore calls from a previous mission load
   if (%seq != $missionSequence || !$MissionRunning)
      return;
   if (%client.currentPhase != 1.5)
      return;
   %client.currentPhase = 2;

   // Set the player datablock choice
   %client.playerDB = %playerDB;

   // Update mod paths, this needs to get there before the objects.
   %client.transmitPaths();

   // Start ghosting objects to the client
   %client.activateGhosting();
}


Torque 3D - Script Manual: NetObject Class Reference

NetObject Class Reference
[Networking]

Superclass for all ghostable networked objects. More...

Inheritance diagram for NetObject:
[legend]

List of all members.

Public Member Functions

void | clearScopeToClient (NetConnection client)
Undo the effects of a scopeToClient() call.
int | getClientObject ()
Returns a pointer to the client object when on a local connection.
int | getGhostID ()
Get the ghost index of this object from the server.
int | getServerObject ()
Returns a pointer to the client object when on a local connection.
bool | isClientObject ()
Called to check if an object resides on the clientside.
bool | isServerObject ()
Checks if an object resides on the server.
void | scopeToClient (NetConnection client)
Cause the NetObject to be forced as scoped on the specified NetConnection.
void | setScopeAlways ()
Always scope this object on all connections.

Detailed Description

Superclass for all ghostable networked objects.

Introduction To NetObject And Ghosting

This class is the basis of the ghost implementation in Torque 3D. Every 3D object is a NetObject. One of the most powerful aspects of Torque's networking code is its support for ghosting and prioritized, most-recent-state network updates. The way this works is a bit complex, but it is immensely efficient. Let's run through the steps that the server goes through for each client in this part of Torque's networking:

  • First, the server determines what objects are in-scope for the client. This is done by calling onCameraScopeQuery() on the object which is considered the "scope" object. This is usually the player object, but it can be something else. (For instance, the current vehicle, or a object we're remote controlling.)
  • Second, it ghosts them to the client; this is implemented in netGhost.cc.
  • Finally, it sends updates as needed, by checking the dirty list and packing updates.

There several significant advantages to using this networking system:

  • Efficient network usage, since we only send data that has changed. In addition, since we only care about most-recent data, if a packet is dropped, we don't waste effort trying to deliver stale data.
  • Cheating protection; since we don't deliver information about game objects which aren't in scope, we dramatically reduce the ability of clients to hack the game and gain a meaningful advantage. (For instance, they can't find out about things behind them, since objects behind them don't fall in scope.) In addition, since ghost IDs are assigned per-client, it's difficult for any sort of co-ordination between cheaters to occur.

NetConnection contains the Ghost Manager implementation, which deals with transferring data to the appropriate clients and keeping state in synch.

An Example Implementation

The basis of the ghost implementation in Torque is NetObject. It tracks the dirty flags for the various states that the object trackers, and does some other book-keeping to allow more efficient operation of the networking layer.

Using a NetObject is very simple; let's go through a simple example implementation:

   class SimpleNetObject : public NetObject
   {
   public:
     typedef NetObject Parent;
     DECLARE_CONOBJECT(SimpleNetObject);

Above is the standard boilerplate code for a Torque class. You can find out more about this in SimObject.

      char message1[256];
      char message2[256];
      enum States {
         Message1Mask = BIT(0),
         Message2Mask = BIT(1),
      };

For our example, we're having two "states" that we keep track of, message1 and message2. In a real object, we might map our states to health and position, or some other set of fields. You have 32 bits to work with, so it's possible to be very specific when defining states. In general, you should try to use as few states as possible (you never know when you'll need to expand your object's functionality!), and in fact, most of your fields will end up changing all at once, so it's not worth it to be too fine-grained. (As an example, position and velocity on Player are controlled by the same bit, as one rarely changes without the other changing, too.)

      SimpleNetObject()
      {
         // in order for an object to be considered by the network system,
         // the Ghostable net flag must be set.
         // the ScopeAlways flag indicates that the object is always scoped
         // on all active connections.
         mNetFlags.set(ScopeAlways | Ghostable);
         dStrcpy(message1, "Hello World 1!");
         dStrcpy(message2, "Hello World 2!");
      }

Here is the constructor. Here, you see that we initialize our net flags to show that we should always be scoped, and that we're to be taken into consideration for ghosting. We also provide some initial values for the message fields.

      U32 packUpdate(NetConnection *, U32 mask, BitStream *stream)
      {
         // check which states need to be updated, and update them
         if(stream->writeFlag(mask & Message1Mask))
            stream->writeString(message1);
         if(stream->writeFlag(mask & Message2Mask))
            stream->writeString(message2);

         // the return value from packUpdate can set which states still
         // need to be updated for this object.
         return 0;
      }

Here's half of the meat of the networking code, the packUpdate() function. (The other half, unpackUpdate(), we'll get to in a second.) The comments in the code pretty much explain everything, however, notice that the code follows a pattern of if(writeFlag(mask & StateMask)) { ... write data ... }. The packUpdate()/unpackUpdate() functions are responsible for reading and writing the dirty bits to the bitstream by themselves.

      void unpackUpdate(NetConnection *, BitStream *stream)
      {
         // the unpackUpdate function must be symmetrical to packUpdate
         if(stream->readFlag())
         {
            stream->readString(message1);
            Con::printf("Got message1: %s", message1);
         }
         if(stream->readFlag())
         {
            stream->readString(message2);
            Con::printf("Got message2: %s", message2);
         }
      }

The other half of the networking code in any NetObject, unpackUpdate(). In our simple example, all that the code does is print the new messages to the console; however, in a more advanced object, you might trigger animations, update complex object properties, or even spawn new objects, based on what packet data you unpack.

      void setMessage1(const char *msg)
      {
         setMaskBits(Message1Mask);
         dStrcpy(message1, msg);
      }
      void setMessage2(const char *msg)
      {
         setMaskBits(Message2Mask);
         dStrcpy(message2, msg);
      }

Here are the accessors for the two properties. It is good to encapsulate your state variables, so that you don't have to remember to make a call to setMaskBits every time you change anything; the accessors can do it for you. In a more complex object, you might need to set multiple mask bits when you change something; this can be done using the | operator, for instance, setMaskBits( Message1Mask | Message2Mask ); if you changed both messages.

   IMPLEMENT_CO_NETOBJECT_V1(SimpleNetObject);

   ConsoleMethod(SimpleNetObject, setMessage1, void, 3, 3, "(string msg) Set message 1.")
   {
      object->setMessage1(argv[2]);
   }

   ConsoleMethod(SimpleNetObject, setMessage2, void, 3, 3, "(string msg) Set message 2.")
   {
      object->setMessage2(argv[2]);
   }

Finally, we use the NetObject implementation macro, IMPLEMENT_CO_NETOBJECT_V1(), to implement our NetObject. It is important that we use this, as it makes Torque perform certain initialization tasks that allow us to send the object over the network. IMPLEMENT_CONOBJECT() doesn't perform these tasks, see the documentation on AbstractClassRep for more details.

See also:
NetConnection
SceneObject

Member Function Documentation

void NetObject::clearScopeToClient ( NetConnection client )

Undo the effects of a scopeToClient() call.

Parameters:
client The connection to remove this object's scoping from
int NetObject::getClientObject ( )

Returns a pointer to the client object when on a local connection.

Short-Circuit-Networking: this is only valid for a local-client / singleplayer situation.

Example:
// Psuedo-code, some values left out for this example
%node = new ParticleEmitterNode(){};
%clientObject = %node.getClientObject();
if(isObject(%clientObject)
   %clientObject.setTransform("0 0 0");
Returns:
The ID of client object
int NetObject::getGhostID ( )

Get the ghost index of this object from the server.

Example:
%ghostID = LocalClientConnection.getGhostId( %serverObject );
Returns:
The index of this ghost in the GhostManager on the server
int NetObject::getServerObject ( )

Returns a pointer to the client object when on a local connection.

Short-Circuit-Netorking: this is only valid for a local-client / singleplayer situation.

Example:
// Psuedo-code, some values left out for this example
%node = new ParticleEmitterNode(){};
%serverObject = %node.getServerObject();
if(isObject(%serverObject)
   %serverObject.setTransform("0 0 0");
Returns:
The ID of server object
bool NetObject::isClientObject ( )

Called to check if an object resides on the clientside.

Returns:
True if the object resides on the client, false otherwise.
bool NetObject::isServerObject ( )

Checks if an object resides on the server.

Returns:
True if the object resides on the server, false otherwise.
void NetObject::scopeToClient ( NetConnection client )

Cause the NetObject to be forced as scoped on the specified NetConnection.

Parameters:
client The connection this object will always be scoped to
Example:
// Called to create new cameras in TorqueScript
// %this - The active GameConnection
// %spawnPoint - The spawn point location where we creat the camera
function GameConnection::spawnCamera(%this, %spawnPoint)
{
   // If this connection's camera exists
   if(isObject(%this.camera))
   {
      // Add it to the mission group to be cleaned up later
      MissionCleanup.add( %this.camera );

      // Force it to scope to the client side
      %this.camera.scopeToClient(%this);
   }
}
void NetObject::setScopeAlways ( )

Always scope this object on all connections.

The object is marked as ScopeAlways and is immediately ghosted to all active connections. This function has no effect if the object is not marked as Ghostable.


Torque 3D - Script Manual: OcclusionVolume Class Reference

OcclusionVolume Class Reference

Inheritance diagram for OcclusionVolume:
[legend]

List of all members.

Public Attributes

Internal

string | edge
For internal use only.
string | plane
For internal use only.
string | point
For internal use only.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Member Data Documentation

string OcclusionVolume::edge

For internal use only.

bool OcclusionVolume::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool OcclusionVolume::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string OcclusionVolume::plane

For internal use only.

string OcclusionVolume::point

For internal use only.


Torque 3D - Script Manual: OpenFileDialog Class Reference

OpenFileDialog Class Reference
[File I/O]

Derived from FileDialog, this class is responsible for opening a file browser with the intention of opening a file. More...

Inheritance diagram for OpenFileDialog:
[legend]

List of all members.

Public Attributes

bool | MultipleFiles
True/False whether multiple files may be selected and returned or not.
bool | MustExist
True/False whether the file returned must exist or not.

Detailed Description

Derived from FileDialog, this class is responsible for opening a file browser with the intention of opening a file.

The core usage of this dialog is to locate a file in the OS and return the path and name. This does not handle the actual file parsing or data manipulation. That functionality is left up to the FileObject class.

Example:
 // Create a dialog dedicated to opening files
 %openFileDlg = new OpenFileDialog()
 {
    // Look for jpg image files
    // First part is the descriptor|second part is the extension
    Filters = "Jepg Files|*.jpg";
    // Allow browsing through other folders
    ChangePath = true;

    // Only allow opening of one file at a time
    MultipleFiles = false;
 };

 // Launch the open file dialog
 %result = %openFileDlg.Execute();

 // Obtain the chosen file name and path
 if ( %result )
 {
    %seletedFile = %openFileDlg.file;
 }
 else
 {
    %selectedFile = "";
 }

 // Cleanup
 %openFileDlg.delete();
Note:
FileDialog and its related classes are only availble in a Tools build of Torque.
See also:
FileDialog
SaveFileDialog
FileObject

Member Data Documentation

bool OpenFileDialog::MultipleFiles

True/False whether multiple files may be selected and returned or not.

bool OpenFileDialog::MustExist

True/False whether the file returned must exist or not.


Torque 3D - Script Manual: OpenFolderDialog Class Reference

OpenFolderDialog Class Reference
[File I/O]

OS level dialog used for browsing folder structures. More...

Inheritance diagram for OpenFolderDialog:
[legend]

List of all members.

Public Attributes

filename fileMustExist
File that must be in selected folder for it to be valid.

Detailed Description

OS level dialog used for browsing folder structures.

This is essentially an OpenFileDialog, but only used for returning directory paths, not files.

Note:
FileDialog and its related classes are only availble in a Tools build of Torque.
See also:
OpenFileDialog for more details on functionality.

Member Data Documentation

filename OpenFolderDialog::fileMustExist

File that must be in selected folder for it to be valid.


Torque 3D - Script Manual: ParticleData Class Reference

ParticleData Class Reference
[Special Effects]

Contains information for how specific particles should look and react including particle colors, particle imagemap, acceleration value for individual particles and spin information. More...

Inheritance diagram for ParticleData:
[legend]

List of all members.

Public Member Functions

void | reload ()
Reloads this particle.

Public Attributes

bool | animateTexture
If true, allow the particle texture to be an animated sprite.
string | animTexFrames
A list of frames and / or frame ranges to use for particle animation if animateTexture is true. Example: "0-16 20 19 18 17 31-21".
string | animTexName
Texture file to use for this particle if animateTexture is true.
Point2I | animTexTiling
The number of frames, in the rows and columns, stored in animTexName. Maximum of 256 frames can be stored in a single animTexName when using animTexTiling. Entered as "Columns / Rows". eg. "4 4".
ColorF | colors [4]
Color values to set the particles, rgba. Up to 4 allowed. Will transition through colors based on values set in the times value. Example: colors[0] = "0.6 1.0 1.0 0.5".
float | constantAcceleration
Amount to continously accelerate this particle by.
float | dragCoefficient
Particle physics drag amount.
int | framesPerSec
If animateTexture is true, this defines the frames per second of the sprite animation.
float | gravityCoefficient
Strength of gravity on the particles.
float | inheritedVelFactor
Amount to allow the velocity inherited from the emitter to effect the velocity of these particles.
int | lifetimeMS
Time in milliseconds before this particle is destroyed.
int | lifetimeVarianceMS
Variance in lifetime of particle between 0 milliseconds and n.
float | sizes [4]
Sizes to set the particles. Up to 4 allowed. Will transition through sizes based on values set in the times value.
float | spinRandomMax
Maximum allowed spin speed of this particle, between spinRandomMin and n.
float | spinRandomMin
Minimum allowed spin speed of this particle, between n and spinRandomMax.
float | spinSpeed
Speed at which to spin the particle.
Point2F | textureCoords [4]
4 dimensional array defining the 4 locational points, in F32 (where 0.0 is top / left and 1.0 is bottom / right) of the textureName to use for this particle.
string | textureName
Texture file to use for this particle.
float | times [4]
Times to transition between colors and sizes. Up to 4 allowed. Values are 0.0 - 1.0, and corrispond to the life of the particle where 0 is first created and 1 is end of lifespace.
bool | useInvAlpha
If true, will invert the colors of this particle.
float | windCoefficient
Strength of wind on the particles.

Detailed Description

Contains information for how specific particles should look and react including particle colors, particle imagemap, acceleration value for individual particles and spin information.

Member Function Documentation

void ParticleData::reload ( )

Reloads this particle.

Example:
// Get the editor's current particle
%particle = PE_ParticleEditor.currParticle

// Change a particle value
%particle.setFieldValue(%propertyField,%value);

// Reload it
%particle.reload();

Member Data Documentation

bool ParticleData::animateTexture

If true, allow the particle texture to be an animated sprite.

string ParticleData::animTexFrames

A list of frames and / or frame ranges to use for particle animation if animateTexture is true. Example: "0-16 20 19 18 17 31-21".

string ParticleData::animTexName

Texture file to use for this particle if animateTexture is true.

Point2I ParticleData::animTexTiling

The number of frames, in the rows and columns, stored in animTexName. Maximum of 256 frames can be stored in a single animTexName when using animTexTiling. Entered as "Columns / Rows". eg. "4 4".

ColorF ParticleData::colors[4]

Color values to set the particles, rgba. Up to 4 allowed. Will transition through colors based on values set in the times value. Example: colors[0] = "0.6 1.0 1.0 0.5".

float ParticleData::constantAcceleration

Amount to continously accelerate this particle by.

float ParticleData::dragCoefficient

Particle physics drag amount.

int ParticleData::framesPerSec

If animateTexture is true, this defines the frames per second of the sprite animation.

float ParticleData::gravityCoefficient

Strength of gravity on the particles.

float ParticleData::inheritedVelFactor

Amount to allow the velocity inherited from the emitter to effect the velocity of these particles.

int ParticleData::lifetimeMS

Time in milliseconds before this particle is destroyed.

int ParticleData::lifetimeVarianceMS

Variance in lifetime of particle between 0 milliseconds and n.

float ParticleData::sizes[4]

Sizes to set the particles. Up to 4 allowed. Will transition through sizes based on values set in the times value.

float ParticleData::spinRandomMax

Maximum allowed spin speed of this particle, between spinRandomMin and n.

float ParticleData::spinRandomMin

Minimum allowed spin speed of this particle, between n and spinRandomMax.

float ParticleData::spinSpeed

Speed at which to spin the particle.

Point2F ParticleData::textureCoords[4]

4 dimensional array defining the 4 locational points, in F32 (where 0.0 is top / left and 1.0 is bottom / right) of the textureName to use for this particle.

string ParticleData::textureName

Texture file to use for this particle.

float ParticleData::times[4]

Times to transition between colors and sizes. Up to 4 allowed. Values are 0.0 - 1.0, and corrispond to the life of the particle where 0 is first created and 1 is end of lifespace.

bool ParticleData::useInvAlpha

If true, will invert the colors of this particle.

float ParticleData::windCoefficient

Strength of wind on the particles.


Torque 3D - Script Manual: ParticleEmitter Class Reference

ParticleEmitter Class Reference
[Special Effects]

This object is responsible for all particle emissions. More...

Inheritance diagram for ParticleEmitter:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

This object is responsible for all particle emissions.

Main interface for creating particles. The emitter does _not_ track changes in axis or velocity over the course of a single update, so this should be called at a fairly fine grain. The emitter will potentially track the last particle to be created into the next call to this function in order to create a uniformly random time distribution of the particles.

If the object to which the emitter is attached is in motion, it should try to ensure that for call (n+1) to this function, start is equal to the end from call (n). This will ensure a uniform spatial distribution.

Member Data Documentation

bool ParticleEmitter::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool ParticleEmitter::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.


Torque 3D - Script Manual: ParticleEmitterData Class Reference

ParticleEmitterData Class Reference
[Special Effects]

Acts as the physical point in space in white Particles are created from. Also manages how to fire particles, including velocity, offset and length of firing (or 'ejection'). More...

Inheritance diagram for ParticleEmitterData:
[legend]

List of all members.

Public Member Functions

void | reload ()
Reloads this emitter.

Public Attributes

ParticleEmitterData

Point3F | alignDirection
The direction aligned particles should face, defined as the 3 F32 values of X Y Z.
bool | alignParticles
If true, particles always face along a particular axis.
float | ambientFactor
Used to generate the final particle color by interpolating between the particle color and the particle color multiplied by the ambient color.
ParticleBlendStyle blendStyle
Pre-defined blend factor setting. Use integer value. BlendNormal = 1, BlendAdditive = 2, BlendSubtractive = 3, BlendPremultAlpha = 4, BlendGreyscale = 5.
float | ejectionOffset
Z offset from emitter point to eject from.
int | ejectionPeriodMS
Time, in Milliseconds, between particle ejection.
float | ejectionVelocity
Ejection velocity.
bool | highResOnly
This particle system should not use the mixed-resolution renderer. If your particle system has large amounts of overdraw, consider disabling this option.
int | lifetimeMS
Lifetime of particles.
int | lifetimeVarianceMS
Variance in lifetime from 0 milliseconds to n.
bool | orientOnVelocity
If true, Particles will face the screen at the start.
bool | orientParticles
If true, Particles will always face the screen.
bool | overrideAdvance
If false, particles emitted in the same frame have their positions adjusted. If true, adjustment is skipped and particles will clump together.
string | particles
Used to load particle data directly from a string.
int | periodVarianceMS
Variance in ejection period between 0 milliseconds and n.
float | phiReferenceVel
Reference angle, from the vertical plane, to eject from.
float | phiVariance
Variance from the reference angle, from 0 to n.
bool | renderReflection
Enables this particle emitter to render into reflective surfaces like water.
bool | reverseOrder
If true, reverses draw order of particles.
float | softnessDistance
For soft particles, the distance (in meters) where particles will be faded based on the difference in depth between the particle and the scene geometry.
bool | sortParticles
If true, particles are sorted back-to-front.
string | textureName
Emitter texture file to override particle textures.
float | thetaMax
Maximum angle, from the horizontal plane, to eject from.
float | thetaMin
Minimum angle, from the horizontal plane, to eject from.
bool | useEmitterColors
If true, will use emitter specified colors instead of datablock colors.
bool | useEmitterSizes
If true, will use emitter specified sizes instead of datablock sizes.
float | velocityVariance
Variance for velocity between 0 and n.

Detailed Description

Acts as the physical point in space in white Particles are created from. Also manages how to fire particles, including velocity, offset and length of firing (or 'ejection').

Example:
datablock ParticleEmitterData(GrenadeExpDustEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 0.0;
   ejectionOffset = 0.0;
   thetaMin = 85;
   thetaMax = 85;
   phiReferenceVel = 0;
   phiVariance = 360;
   overrideAdvances = false;
   lifetimeMS = 200;
   particles = "GrenadeExpDust";
};

Member Function Documentation

void ParticleEmitterData::reload ( )

Reloads this emitter.

Example:
// Get the editor's current particle emitter
%emitter = PE_EmitterEditor.currEmitter

// Change a field value
%emitter.setFieldValue(%propertyField,%value);

// Reload this emitter
%emitter.reload();

Member Data Documentation

Point3F ParticleEmitterData::alignDirection

The direction aligned particles should face, defined as the 3 F32 values of X Y Z.

bool ParticleEmitterData::alignParticles

If true, particles always face along a particular axis.

float ParticleEmitterData::ambientFactor

Used to generate the final particle color by interpolating between the particle color and the particle color multiplied by the ambient color.

ParticleBlendStyle ParticleEmitterData::blendStyle

Pre-defined blend factor setting. Use integer value. BlendNormal = 1, BlendAdditive = 2, BlendSubtractive = 3, BlendPremultAlpha = 4, BlendGreyscale = 5.

float ParticleEmitterData::ejectionOffset

Z offset from emitter point to eject from.

int ParticleEmitterData::ejectionPeriodMS

Time, in Milliseconds, between particle ejection.

float ParticleEmitterData::ejectionVelocity

Ejection velocity.

bool ParticleEmitterData::highResOnly

This particle system should not use the mixed-resolution renderer. If your particle system has large amounts of overdraw, consider disabling this option.

int ParticleEmitterData::lifetimeMS

Lifetime of particles.

int ParticleEmitterData::lifetimeVarianceMS

Variance in lifetime from 0 milliseconds to n.

bool ParticleEmitterData::orientOnVelocity

If true, Particles will face the screen at the start.

bool ParticleEmitterData::orientParticles

If true, Particles will always face the screen.

bool ParticleEmitterData::overrideAdvance

If false, particles emitted in the same frame have their positions adjusted. If true, adjustment is skipped and particles will clump together.

string ParticleEmitterData::particles

Used to load particle data directly from a string.

int ParticleEmitterData::periodVarianceMS

Variance in ejection period between 0 milliseconds and n.

float ParticleEmitterData::phiReferenceVel

Reference angle, from the vertical plane, to eject from.

float ParticleEmitterData::phiVariance

Variance from the reference angle, from 0 to n.

bool ParticleEmitterData::renderReflection

Enables this particle emitter to render into reflective surfaces like water.

bool ParticleEmitterData::reverseOrder

If true, reverses draw order of particles.

float ParticleEmitterData::softnessDistance

For soft particles, the distance (in meters) where particles will be faded based on the difference in depth between the particle and the scene geometry.

bool ParticleEmitterData::sortParticles

If true, particles are sorted back-to-front.

string ParticleEmitterData::textureName

Emitter texture file to override particle textures.

float ParticleEmitterData::thetaMax

Maximum angle, from the horizontal plane, to eject from.

float ParticleEmitterData::thetaMin

Minimum angle, from the horizontal plane, to eject from.

bool ParticleEmitterData::useEmitterColors

If true, will use emitter specified colors instead of datablock colors.

bool ParticleEmitterData::useEmitterSizes

If true, will use emitter specified sizes instead of datablock sizes.

float ParticleEmitterData::velocityVariance

Variance for velocity between 0 and n.


Torque 3D - Script Manual: ParticleEmitterNode Class Reference

ParticleEmitterNode Class Reference
[Special Effects]

Manages timing update information for the assigned particleEmitter. Particles can be assigned to this emitter through the method setEmitterDataBlock(particleEmitterDatablock). More...

Inheritance diagram for ParticleEmitterNode:
[legend]

List of all members.

Public Member Functions

void | setActive (bool active)
Turns the emitter on or off.
void | setEmitterDataBlock (ParticleEmitterData emitterDatablock=0)
Assigns the datablock for this emitter.

Public Attributes

bool | active
Boolean which sets and determines if this EmitterNode is active or not.
ParticleEmitterData emitter
Particle emitter datablock to use.
float | velocity
Velocity to use when spawning the particles.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Manages timing update information for the assigned particleEmitter. Particles can be assigned to this emitter through the method setEmitterDataBlock(particleEmitterDatablock).

Member Function Documentation

void ParticleEmitterNode::setActive ( bool active )

Turns the emitter on or off.

Parameters:
active New emitter state
void ParticleEmitterNode::setEmitterDataBlock ( ParticleEmitterData emitterDatablock = 0 )

Assigns the datablock for this emitter.

Parameters:
datablockID Numerical reference to datablock ID
Example:
// Get the editor's current particle emitter
%emitter = PE_EmitterEditor.currEmitter

// Assign a new datablock value
%emitter.setEmitterDatablock(%emitterDatablock);

Member Data Documentation

bool ParticleEmitterNode::active

Boolean which sets and determines if this EmitterNode is active or not.

ParticleEmitterData ParticleEmitterNode::emitter

Particle emitter datablock to use.

bool ParticleEmitterNode::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool ParticleEmitterNode::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

float ParticleEmitterNode::velocity

Velocity to use when spawning the particles.


Torque 3D - Script Manual: ParticleEmitterNodeData Class Reference

ParticleEmitterNodeData Class Reference
[Special Effects]

Contains the timeMuliplier information to be assigned to a ParticleEmitterNode. The time multiplayer value for the ParticleEmitterNodeData can be set with nodeData.timeMultiple = value;. More...

Inheritance diagram for ParticleEmitterNodeData:
[legend]

List of all members.

Public Attributes

float timeMultiple
Time multiplier for particle emitter nodes.

Detailed Description

Contains the timeMuliplier information to be assigned to a ParticleEmitterNode. The time multiplayer value for the ParticleEmitterNodeData can be set with nodeData.timeMultiple = value;.

Member Data Documentation

float ParticleEmitterNodeData::timeMultiple

Time multiplier for particle emitter nodes.


Torque 3D - Script Manual: Path Class Reference

Path Class Reference
[Miscellaneous]

A spline along which various objects can move along. The spline object acts like a container for Marker objects, which make up the joints, or knots, along the path. Paths can be assigned a speed, can be looping or non-looping. Each of a path's markers can be one of three primary movement types: "normal", "Position Only", or "Kink". More...

Inheritance diagram for Path:
[legend]

List of all members.

Public Member Functions

int | getPathId ()
Returns the PathID (not the object ID) of this path.

Public Attributes

bool | isLooping
If this is true, the loop is closed, otherwise it is open.

Detailed Description

A spline along which various objects can move along. The spline object acts like a container for Marker objects, which make up the joints, or knots, along the path. Paths can be assigned a speed, can be looping or non-looping. Each of a path's markers can be one of three primary movement types: "normal", "Position Only", or "Kink".

Example:
new path()
   {
     isLooping = "1";

     new Marker()
      {
         seqNum = "0";
         type = "Normal";
         msToNext = "1000";
         smoothingType = "Spline";
         position = "-0.054708 -35.0612 234.802";
         rotation = "1 0 0 0";
      };

   };
See also:
Marker

Member Function Documentation

int Path::getPathId ( )

Returns the PathID (not the object ID) of this path.

Returns:
PathID (not the object ID) of this path.
Example:
// Acquire the PathID of this path object.
%pathID = %thisPath.getPathId();

Member Data Documentation

bool Path::isLooping

If this is true, the loop is closed, otherwise it is open.


Torque 3D - Script Manual: PathCamera Class Reference

PathCamera Class Reference
[Path Camera]

A camera that moves along a path. The camera can then be made to travel along this path forwards or backwards. More...

Inheritance diagram for PathCamera:
[legend]

List of all members.

Public Member Functions

void | popFront ()
Removes the knot at the front of the camera's path.
void | pushBack (TransformF transform, float speed=1.0, string type="Normal", string path="Linear")
Adds a new knot to the back of a path camera's path.
void | pushFront (TransformF transform, float speed=1.0, string type="Normal", string path="Linear")
Adds a new knot to the front of a path camera's path.
void | reset (float speed=1.0f)
Clear the camera's path and set the camera's current transform as the start of the new path.
void | setPosition (float position=0.0f)
Set the current position of the camera along the path.
void | setState (string newState="forward")
Set the movement state for this path camera.
void | setTarget (float position=1.0f)
Set the movement target for this camera along its path.
Callbacks

void | onNode (string node)
A script callback that indicates the path camera has arrived at a specific node in its path. Server side only.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A camera that moves along a path. The camera can then be made to travel along this path forwards or backwards.

A camera's path is made up of knots, which define a position, rotation and speed for the camera. Traversal from one knot to another may be either linear or using a Catmull-Rom spline. If the knot is part of a spline, then it may be a normal knot or defined as a kink. Kinked knots are a hard transition on the spline rather than a smooth one. A knot may also be defined as a position only. In this case the knot is treated as a normal knot but is ignored when determining how to smoothly rotate the camera while it is travelling along the path (the algorithm moves on to the next knot in the path for determining rotation).

The datablock field for a PathCamera is a previously created PathCameraData, which acts as the interface between the script and the engine for this PathCamera object.

See also:
PathCameraData
Example:
%newPathCamera = new PathCamera()
{
  dataBlock = LoopingCam;
  position = "0 0 300 1 0 0 0";
};

Member Function Documentation

void PathCamera::onNode ( string node )

A script callback that indicates the path camera has arrived at a specific node in its path. Server side only.

Parameters:
Node Unique ID assigned to this node.
void PathCamera::popFront ( )

Removes the knot at the front of the camera's path.

Example:
// Remove the first knot in the camera's path.
%pathCamera.popFront();

void PathCamera::pushBack | ( | TransformF | transform,
 |  | float | speed = 1.0,
 |  | string | type = "Normal",
 |  | string | path = "Linear"
 | ) |  |

Adds a new knot to the back of a path camera's path.

Parameters:
transform | Transform for the new knot. In the form of "x y z ax ay az aa" such as returned by SceneObject::getTransform()
speed | Speed setting for this knot.
type | Knot type (Normal, Position Only, Kink).
path | Path type (Linear, Spline).
Example:
// Transform vector for new knot. (Pos_X Pos_Y Pos_Z Rot_X Rot_Y Rot_Z Angle)
%transform = "15.0 5.0 5.0 1.4 1.0 0.2 1.0"

// Speed setting for knot.
%speed = "1.0"

// Knot type. (Normal, Position Only, Kink)
%type = "Normal";

// Path Type. (Linear, Spline)
%path = "Linear";

// Inform the path camera to add a new knot to the back of its path
%pathCamera.pushBack(%transform,%speed,%type,%path);

void PathCamera::pushFront | ( | TransformF | transform,
 |  | float | speed = 1.0,
 |  | string | type = "Normal",
 |  | string | path = "Linear"
 | ) |  |

Adds a new knot to the front of a path camera's path.

Parameters:
transform | Transform for the new knot. In the form of "x y z ax ay az aa" such as returned by SceneObject::getTransform()
speed | Speed setting for this knot.
type | Knot type (Normal, Position Only, Kink).
path | Path type (Linear, Spline).
Example:
// Transform vector for new knot. (Pos_X,Pos_Y,Pos_Z,Rot_X,Rot_Y,Rot_Z,Angle)
%transform = "15.0 5.0 5.0 1.4 1.0 0.2 1.0"

// Speed setting for knot.
%speed = "1.0";

// Knot type. (Normal, Position Only, Kink)
%type = "Normal";

// Path Type. (Linear, Spline)
%path = "Linear";

// Inform the path camera to add a new knot to the front of its path
%pathCamera.pushFront(%transform, %speed, %type, %path);
void PathCamera::reset ( float speed = 1.0f )

Clear the camera's path and set the camera's current transform as the start of the new path.

What specifically occurs is a new knot is created from the camera's current transform. Then the current path is cleared and the new knot is pushed onto the path. Any previous target is cleared and the camera's movement state is set to Forward. The camera is now ready for a new path to be defined.

Parameters:
speed Speed for the camera to move along its path after being reset.
Example:
//Determine the new movement speed of this camera. If not set, the speed will default to 1.0.
%speed = "0.50";

// Inform the path camera to start a new path at// the camera's current position, and set the new // path's speed value.
%pathCamera.reset(%speed);
void PathCamera::setPosition ( float position = 0.0f )

Set the current position of the camera along the path.

Parameters:
position Position along the path, from 0.0 (path start) - 1.0 (path end), to place the camera.
Example:
// Set the camera on a position along its path from 0.0 - 1.0.
%position = "0.35";

// Force the pathCamera to its new position along the path.
%pathCamera.setPosition(%position);
void PathCamera::setState ( string newState = "forward" )

Set the movement state for this path camera.

Parameters:
newState New movement state type for this camera. Forward, Backward or Stop.
Example:
// Set the state type (forward, backward, stop).
// In this example, the camera will travel from the first node
// to the last node (or target if given with setTarget())
%state = "forward";

// Inform the pathCamera to change its movement state to the defined value.
%pathCamera.setState(%state);
void PathCamera::setTarget ( float position = 1.0f )

Set the movement target for this camera along its path.

The camera will attempt to move along the path to the given target in the direction provided by setState() (the default is forwards). Once the camera moves past this target it will come to a stop, and the target state will be cleared.

Parameters:
position Target position, between 0.0 (path start) and 1.0 (path end), for the camera to move to along its path.
Example:
// Set the position target, between 0.0 (path start) and 1.0 (path end), for this camera to move to.
%position = "0.50";

// Inform the pathCamera of the new target position it will move to.
%pathCamera.setTarget(%position);

Member Data Documentation

bool PathCamera::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

bool PathCamera::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.


Torque 3D - Script Manual: PathCameraData Class Reference

PathCameraData Class Reference
[Path Camera]

General interface to control a PathCamera object from the script level. More...

Inheritance diagram for PathCameraData:
[legend]

List of all members.

Detailed Description

General interface to control a PathCamera object from the script level.

See also:
PathCamera
Example:
datablock PathCameraData(LoopingCam)
   {
      mode = "";
   };


Torque 3D - Script Manual: PfxVis Class Reference

PfxVis Class Reference
[GFX]

Singleton class that exposes ConsoleStaticFunctions for debug visualizing PostEffects. More...

List of all members.

Public Member Functions

void | clear ()
Close all visualization windows.
void | hide ()
Hide all visualization windows (they are not destroyed).
void | onWindowClosed (GuiWindowCtrl *ctrl)
Callback when a visualization window is closed.
void | open (PostEffect effect, bool clear)
Open visualization windows for all input and target textures.
void | show ()
Show all visualization windows.

Detailed Description

Singleton class that exposes ConsoleStaticFunctions for debug visualizing PostEffects.

Example:
// Script interface...
PfxVis::open( PostEffect ) // Multiple PostEffects can be visualized at the same time
PfxVis::clear()      // Clear all visualizer windows
PfxVis::hide()       // Hide all windows (are not destroyed)
PfxVis::show()

Member Function Documentation

void PfxVis::clear ( )

Close all visualization windows.

Example:
PfxVis::clear();
void PfxVis::hide ( )

Hide all visualization windows (they are not destroyed).

Example:
PfxVis::hide();
void PfxVis::onWindowClosed ( GuiWindowCtrl * ctrl )

Callback when a visualization window is closed.

Parameters:
ctrl Name of the GUI control being closed
Example:
PfxVis::onWindowClosed( VisWindow )

void PfxVis::open | ( | PostEffect | effect,
 |  | bool | clear
 | ) |  |

Open visualization windows for all input and target textures.

Parameters:
effect | Name of the PostEffect to open
clear | True to close all visualization windows before opening the effect
Example:
// Multiple PostEffects can be visualized at the same time
PfxVis::open( PostEffect )
void PfxVis::show ( )

Show all visualization windows.

Example:
PfxVis::show();


Torque 3D - Script Manual: PhysicalZone Class Reference

PhysicalZone Class Reference
[Miscellaneous]

Physical Zones are areas that modify the player's gravity and/or velocity and/or applied force. More...

Inheritance diagram for PhysicalZone:
[legend]

List of all members.

Public Member Functions

void | activate ()
Activate the physical zone's effects.
void | deactivate ()
Deactivate the physical zone's effects.

Public Attributes

Misc

Point3F | appliedForce
Three-element floating point value representing forces in three axes to apply to objects entering PhysicalZone.
float | gravityMod
Gravity in PhysicalZone. Multiplies against standard gravity.
floatList | polyhedron
The polyhedron type is really a quadrilateral and consists of a cornerpoint followed by three vectors representing the edges extending from the corner.
float | velocityMod
Multiply velocity of objects entering zone by this value every tick.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static bool | renderZones
If true, a box will render around the location of all PhysicalZones.

Detailed Description

Physical Zones are areas that modify the player's gravity and/or velocity and/or applied force.

The datablock properties determine how the physics, velocity and applied forces affect a player who enters this zone.

Example:
new PhysicalZone(Team1JumpPad) {
velocityMod = "1";gravityMod = "0";
appliedForce = "0 0 20000";
polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
position = "273.559 -166.371 249.856";
rotation = "0 0 1 13.0216";
scale = "8 4.95 28.31";
isRenderEnabled = "true";
canSaveDynamicFields = "1";
enabled = "1";
};

Member Function Documentation

void PhysicalZone::activate ( )

Activate the physical zone's effects.

Example:
// Activate effects for a specific physical zone.
%thisPhysicalZone.activate();
void PhysicalZone::deactivate ( )

Deactivate the physical zone's effects.

Example:
// Deactivate effects for a specific physical zone.
%thisPhysicalZone.deactivate();

Member Data Documentation

Point3F PhysicalZone::appliedForce

Three-element floating point value representing forces in three axes to apply to objects entering PhysicalZone.

float PhysicalZone::gravityMod

Gravity in PhysicalZone. Multiplies against standard gravity.

bool PhysicalZone::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool PhysicalZone::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

floatList PhysicalZone::polyhedron

The polyhedron type is really a quadrilateral and consists of a cornerpoint followed by three vectors representing the edges extending from the corner.

bool PhysicalZone::renderZones [static]

If true, a box will render around the location of all PhysicalZones.

float PhysicalZone::velocityMod

Multiply velocity of objects entering zone by this value every tick.


Torque 3D - Script Manual: PhysicsDebris Class Reference

PhysicsDebris Class Reference
[Physics]

Represents one or more rigid bodies defined in a single mesh file with a limited lifetime. More...

Inheritance diagram for PhysicsDebris:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Represents one or more rigid bodies defined in a single mesh file with a limited lifetime.

PhysicsDebris loads a standard dts and creates a rigid body for each collision node.

To work correctly the collision nodes must be positioned as PhysicsDebrisexpects.

Two possible cases: 1. Visible mesh nodes are siblings of the collision node under a common parent dummy node 2. Collision node is a child of its visible mesh node

Also colmesh type nodes are NOT supported; physx and most standard rigid body simulations do not support arbitrary triangle meshs for dynamics do to the computational expense. Therefore, collision nodes must be one of the following: Colbox, Colsphere, Colcapsule, or Col (convex).

Member Data Documentation

bool PhysicsDebris::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool PhysicsDebris::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.


Torque 3D - Script Manual: PhysicsDebrisData Class Reference

PhysicsDebrisData Class Reference
[Physics]

Defines the properties of a type of PhysicsDebrisData. More...

Inheritance diagram for PhysicsDebrisData:
[legend]

List of all members.

Public Attributes

void | preload
Physical Properties

float | angularDamping
Larger values cause rotational velocity to decay over time more quickly.
float | angularSleepThreshold
Angular velocity threshold below which the shape may be put to sleep to save simulation time.
float | buoyancyDensity
The density of this shape for purposes of calculating buoyancy forces. The result of a particular value is relative to the density of the WaterObject it is within.
float | friction
Friction of each physical body, slowing motion when in contact with a surface.
float | lifetime
Base time in seconds that debris persists after time of creation.
float | lifetimeVariance
Range of variation randomly applied to lifetime when debris is created.
float | linearDamping
Larger values cause linear velocity to decay over time more quickly.
float | linearSleepThreshold
Linear velocity threshold below which the shape may be put to sleep to save simulation time.
float | mass
Mass of each physical body.
float | restitution
Bounciness of each physical body in response to collisions. Normal range is zero to one.
float | staticFriction
Friction of each physical body, resisting motion when starting at rest.
float | waterDampingScale
While the shape is in water linear and angular dampening will be scaled by this value. It is expected that this value will usually be greater than one.
Display

bool | castShadows
Enable/Disable rendering into shadows.
filename | shapeFile
Path to the shape file.

Detailed Description

Defines the properties of a type of PhysicsDebrisData.

See also:
PhysicsDebris.

Member Data Documentation

float PhysicsDebrisData::angularDamping

Larger values cause rotational velocity to decay over time more quickly.

float PhysicsDebrisData::angularSleepThreshold

Angular velocity threshold below which the shape may be put to sleep to save simulation time.

float PhysicsDebrisData::buoyancyDensity

The density of this shape for purposes of calculating buoyancy forces. The result of a particular value is relative to the density of the WaterObject it is within.

bool PhysicsDebrisData::castShadows

Enable/Disable rendering into shadows.

float PhysicsDebrisData::friction

Friction of each physical body, slowing motion when in contact with a surface.

float PhysicsDebrisData::lifetime

Base time in seconds that debris persists after time of creation.

float PhysicsDebrisData::lifetimeVariance

Range of variation randomly applied to lifetime when debris is created.

float PhysicsDebrisData::linearDamping

Larger values cause linear velocity to decay over time more quickly.

float PhysicsDebrisData::linearSleepThreshold

Linear velocity threshold below which the shape may be put to sleep to save simulation time.

float PhysicsDebrisData::mass

Mass of each physical body.

void PhysicsDebrisData::preload
float PhysicsDebrisData::restitution

Bounciness of each physical body in response to collisions. Normal range is zero to one.

filename PhysicsDebrisData::shapeFile

Path to the shape file.

float PhysicsDebrisData::staticFriction

Friction of each physical body, resisting motion when starting at rest.

float PhysicsDebrisData::waterDampingScale

While the shape is in water linear and angular dampening will be scaled by this value. It is expected that this value will usually be greater than one.


Torque 3D - Script Manual: PhysicsForce Class Reference

PhysicsForce Class Reference
[Physics]

Helper object for gameplay physical forces. WIP. More...

Inheritance diagram for PhysicsForce:
[legend]

List of all members.

Public Member Functions

void | attach (Point3F start, Point3F direction, float maxDist)
Performs a physics ray cast and attracts the hit dynamic physics body to the force position.
void | detach (Point3F force=Point3F::Zero)
Releases the attached physics body with an optional push force.
bool | isAttached ()
Returns true if there is a physics body attached.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Helper object for gameplay physical forces. WIP.

Member Data Documentation

bool PhysicsForce::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool PhysicsForce::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.


Torque 3D - Script Manual: PhysicsShape Class Reference

PhysicsShape Class Reference
[Physics]

Represents a destructible physical object simulated through the plugin system. More...

Inheritance diagram for PhysicsShape:
[legend]

List of all members.

Public Member Functions

void | destroy ()
Disables rendering and physical simulation of the shape and spawns the explosion, debri, and destroyedShape if any are specified. Note that this does not actually delete the PhysicsShape.
bool | isDestroyed ()
Returns true if the shape is currently destroyed.
void | restore ()
Restore to un-destroyed state: enables rendering and physical simulation.

Public Attributes

PhysicsShape

bool | playAmbient
Enables automatic playing of the animation named "ambient" (if it exists) when the PhysicsShape is loaded.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static bool | noCorrections
If set true, client-side shapes will recieve no corrections from the server and will instead by allowed to diverge.
static bool | noSmoothing
If set true, client-side shapes will render immediately at the position they are corrected to when a correction is recieved from the server.

Detailed Description

Represents a destructible physical object simulated through the plugin system.

See also:
PhysicsShapeData.

Member Function Documentation

void PhysicsShape::destroy ( )

Disables rendering and physical simulation of the shape and spawns the explosion, debri, and destroyedShape if any are specified. Note that this does not actually delete the PhysicsShape.

bool PhysicsShape::isDestroyed ( )

Returns true if the shape is currently destroyed.

void PhysicsShape::restore ( )

Restore to un-destroyed state: enables rendering and physical simulation.

Member Data Documentation

bool PhysicsShape::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool PhysicsShape::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

bool PhysicsShape::playAmbient

Enables automatic playing of the animation named "ambient" (if it exists) when the PhysicsShape is loaded.


Torque 3D - Script Manual: PhysicsShapeData Class Reference

PhysicsShapeData Class Reference
[Physics]

Defines the properties of a type of PhysicsShape. More...

Inheritance diagram for PhysicsShapeData:
[legend]

List of all members.

Public Attributes

Physics

float | angularDamping
Larger values cause rotational velocity to decay over time more quickly.
float | angularSleepThreshold
Angular velocity threshold below which the shape may be put to sleep to save simulation time.
float | buoyancyDensity
The density of this shape for purposes of calculating buoyancy forces. The result of a particular value is relative to the density of the WaterObject it is within.
float | friction
Friction of the shape slowing motion when in contact with a surface.
float | linearDamping
Larger values cause linear velocity to decay over time more quickly.
float | linearSleepThreshold
Linear velocity threshold below which the shape may be put to sleep to save simulation time.
float | mass
Mass of the shape. Set mass to zero to create as a kinematic.
float | restitution
Bounciness of the shape in response to collisions. Normal range is zero to one.
float | staticFriction
Friction of the shape resisting motion when starting at rest.
float | waterDampingScale
While the shape is in water linear and angular dampening will be scaled by this value. It is expected that this value will usually be greater than one.
Media

PhysicsDebrisData Debris
Name of a PhysicsDebrisData to spawn when destroyed (optional).
PhysicsShapeData destroyedShape
Name of a PhysicsShapeData to spawn when destroyed (optional).
ExplosionData Explosion
Name of a ExplosionData to spawn when destroyed (optional).
filename | shapeName
Path to the shape file.
Networking

PhysicsSimType simType
Controls whether this shape is simulated on the server, client, or both physics simulations.

Detailed Description

Defines the properties of a type of PhysicsShape.

See also:
PhysicsShape.

Member Data Documentation

float PhysicsShapeData::angularDamping

Larger values cause rotational velocity to decay over time more quickly.

float PhysicsShapeData::angularSleepThreshold

Angular velocity threshold below which the shape may be put to sleep to save simulation time.

float PhysicsShapeData::buoyancyDensity

The density of this shape for purposes of calculating buoyancy forces. The result of a particular value is relative to the density of the WaterObject it is within.

PhysicsDebrisData PhysicsShapeData::Debris

Name of a PhysicsDebrisData to spawn when destroyed (optional).

PhysicsShapeData PhysicsShapeData::destroyedShape

Name of a PhysicsShapeData to spawn when destroyed (optional).

ExplosionData PhysicsShapeData::Explosion

Name of a ExplosionData to spawn when destroyed (optional).

float PhysicsShapeData::friction

Friction of the shape slowing motion when in contact with a surface.

float PhysicsShapeData::linearDamping

Larger values cause linear velocity to decay over time more quickly.

float PhysicsShapeData::linearSleepThreshold

Linear velocity threshold below which the shape may be put to sleep to save simulation time.

float PhysicsShapeData::mass

Mass of the shape. Set mass to zero to create as a kinematic.

float PhysicsShapeData::restitution

Bounciness of the shape in response to collisions. Normal range is zero to one.

filename PhysicsShapeData::shapeName

Path to the shape file.

PhysicsSimType PhysicsShapeData::simType

Controls whether this shape is simulated on the server, client, or both physics simulations.

float PhysicsShapeData::staticFriction

Friction of the shape resisting motion when starting at rest.

float PhysicsShapeData::waterDampingScale

While the shape is in water linear and angular dampening will be scaled by this value. It is expected that this value will usually be greater than one.


Torque 3D - Script Manual: Player Class Reference

Player Class Reference
[Game Objects]

A client-controlled player character. More...

Inheritance diagram for Player:
[legend]

List of all members.

Public Member Functions

bool | checkDismountPoint (Point3F oldPos, Point3F pos)
Check if it is safe to dismount at this position.
void | clearControlObject ()
Clears the player's current control object.
int | getControlObject ()
Get the current object we are controlling.
string | getDamageLocation (Point3F pos)
Get the named damage location and modifier for a given world position.
string | getState ()
Get the name of the player's current state.
bool | setActionThread (string name, bool hold=false, bool fsp=true)
Set the main action sequence to play for this player.
bool | setArmThread (string name)
Set the sequence that controls the player's arms (dynamically adjusted to match look direction).
bool | setControlObject (ShapeBase obj)
Set the object to be controlled by this player.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static int | maxPredictionTicks
Maximum number of ticks to predict on the client from the last known move obtained from the server.
static int | maxWarpTicks
When a warp needs to occur due to the client being too far off from the server, this is the maximum number of ticks we'll allow the client to warp to catch up.
static float | minWarpTicks
Fraction of tick at which instant warp occures on the client.
static bool | renderCollision
Determines if the player's collision mesh should be rendered.
static bool | renderMyItems
Determines if mounted shapes are rendered or not.
static bool | renderMyPlayer
Determines if the player is rendered or not.

Detailed Description

A client-controlled player character.

The Player object is the main client-controlled object in an FPS, or indeed, any game where the user is in control of a single character. This class (and the associated datablock, PlayerData) allows you to fine-tune the movement, collision detection, animation, and SFX properties of the character. Player derives from ShapeBase, so it is recommended to have a good understanding of that class (and it's parent classes) as well.

See also:
SceneObject
GameBase
ShapeBase
ShapeBaseImageData

Movement

The Player class supports the following modes of movement, known as poses:

  • Stand
  • Crouching
  • Prone
  • Swimming

The acceleration, maximum speed, and bounding box for each mode can be set independently using the PlayerData datablock. The player will automatically switch between swimming and one of the other 3 'dry' modes when entering/exiting the water, but transitions between the non-swimming modes are handled by controller input (such as holding down a key to begin crouching). $mvTriggerCount3 activates crouching, while $mvTriggerCount4 activates being prone.

It is important to set the bounding box correctly for each mode so that collisions with the player remain accurate:

Jumping

The Player class supports jumping. While the player is in contact with a surface (and optionally has enough energy as defined by the PlayerData), $mvTriggerCount2 will cause the player to jump.

Jetting

The Player class includes a simple jetpack behaviour allowing characters to 'jet' upwards while jumping. The jetting behaviour can be linked to the player's energy level using datablock properties as shown below:

Example:
datablock PlayerData( JetPlayer )
{
   ...

   jetJumpForce = 16.0 * 90;
   jetJumpEnergyDrain = 10;
   jetMinJumpEnergy = 25;
   jetMinJumpSpeed = 20;
   jetMaxJumpSpeed = 100;
   jetJumpSurfaceAngle = 78;
}

This player will not be able to jet if he has less than 25 units of energy, and 10 units will be subtracted each tick.

If PlayerData::jetJumpFore is greater than zero then $mvTriggerCount1 will activate jetting.

Air Control

The player may optionally move itself through the air while jumping or falling. This allows the player to adjust their trajectory while in the air, and is known as air control. The PlayerData::airControl property determines what fraction of the player's normal speed they may move while in the air. By default, air control is disabled (set to 0).

Dismounting

It is possible to have the player mount another object, such as a vehicle, just like any other SceneObject. While mounted, $mvTriggerCount2 will cause the player to dismount.

Triggering a Mounted Object

A Player may have other objects mounted to it, with each mounted object assigned to a slot. These Player mounted objects are known as images. See ShapeBase::mountImage(). If there is an image mounted to slot 0, $mvTriggerCount0 will trigger it. If the player dies this trigger is automatically released.

If there is an image mounted to slot 1, $mvTriggerCount1 will trigger it. Otherwise $mvTriggerCount1 will be passed along to the image in slot 0 as an alternate fire state.

Character model

The following sequences are used by the Player object to animate the character. Not all of them are required, but a model should have at least the root, run, back and side animations.

root
Looping sequence played when player is standing but not moving.
run
Looping sequence played when player is running forward.
back
Looping sequence played when player is running backward.
side
Looping sequence played when player is running sideways (strafing). The sequence should depict the player moving left. If side_right is not present, this sequence will be played backwards in its place.
side_right

Looping sequence played when player is running sideways right.

crouch_root
Looping sequence played when player is crouched and not moving.
crouch_forward
Looping sequence played when player is crouched and moving forward.
crouch_backward
Looping sequence played when player is crouched and moving backward.
crouch_side
Looping sequence played when player is crouched and moving sideways. The sequence should depict the player moving left. If crouch_right is not present, this sequence will be played backwards in its place.
crouch_right

Looping sequence played when player is crouched and moving sideways.

prone_root
Looping sequence played when player is prone (lying down) and not moving.
prone_forward
Looping sequence played when player is prone (lying down) and moving forward.
prone_backward

Looping sequence played when player is prone (lying down) and moving backward.

swim_root
Looping sequence played when player is swimming and not moving.
swim_forward
Looping sequence played when player is swimming and moving forward.
swim_backward
Looping sequence played when player is swimming and moving backward.
swim_left
Looping sequence played when player is swimming and moving left. The sequence should depict the player moving left. If swim_right is not present, this sequence will be played backwards in its place.
swim_right

Looping sequence played when player is swimming and moving right.

fall
Sequence played when player is falling.
jump
Sequence played when player has jumped while moving.
standjump
Sequence played when player has jumped from a standing start.
land
Sequence played when player lands after falling.
jet

Looping sequence played when player is jetting.

head
Sequence to control vertical head movement (for looking) (start=full up, end=full down).
headside
Sequence to control horizontal head movement (for looking) (start=full left, end=full right).
look

Sequence to control vertical arm movement (for looking) (start=full up, end=full down).

light_recoil
Sequence played when the player is firing a light weapon. (Based on ShapeBaseImageData)
medium_recoil
Sequence played when player is firing a medium weapon. (Based on ShapeBaseImageData)
heavy_recoil

Sequence played when player is firing a heavy weapon (Based on ShapeBaseImageData).

deathN
Sequence played when player has been killed (a random one of these will play). N is an integer from 1 to 11.

An example of a player datablock appears below:

Example:
datablock PlayerData( BasicPlayerData )
{
   renderFirstPerson = true;

   shapeFile = "art/shapes/actors/gideon/gideon.dts";
   computeCRC = true;

   cameraDefaultFov = 100.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   cameraMaxDist = 3;

   debrisShapeName = "art/shapes/actors/common/debris_player.dts";
   debris = PlayerDebris;

   aiAvoidThis = true;

   minLookAngle = -1.4;
   maxLookAngle = 1.4;
   maxFreelookAngle = 3.0;

   mass = 100;
   drag = 1.3;
   maxdrag = 0.4;
   density = 1.1;
   maxDamage = 100;
   maxEnergy =  60;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;
   rechargeRate = 0.256;

   // Running
   runForce = 48 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 8;
   maxBackwardSpeed = 6;
   maxSideSpeed = 6;
   %boundingBox = "1 1 2";

   // Crouching
   crouchForce = 45.0 * 9.0;
   maxCrouchForwardSpeed = 4.0;
   maxCrouchBackwardSpeed = 2.0;
   maxCrouchSideSpeed = 2.0;
   crouchBoundingBox = "1 1 1.5";

   // Prone
   proneForce = 45.0 * 9.0;
   maxProneForwardSpeed = 4.0;
   maxProneBackwardSpeed = 2.0;
   maxProneSideSpeed = 2.0;
   proneBoundingBox = "1 2 1";

   // Underwater
   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;
   swimBoundingBox = "1 2 2";

   // Jumping
   jumpForce = 8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 15;
   airControl = 0.3;

   recoverDelay = 9;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 45;
   speedDamageScale = 0.4;

   pickupRadius = 0.75;

   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   decalData   = PlayerFootprint;
   decalOffset = 0.25;

   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.4;
   splashEmitter[0] = PlayerWakeEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 5.0;

   // Control slope of runnable/jumpable surfaces
   runSurfaceAngle  = 70;
   jumpSurfaceAngle = 80;
   maxStepHeight = 1.5;  // two meters
   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;

   footstepSplashHeight = 0.35;

   // Footstep Sounds
   FootSoftSound        = FootLightSoftSound;
   FootHardSound        = FootLightHardSound;
   FootMetalSound       = FootLightMetalSound;
   FootSnowSound        = FootLightSnowSound;
   FootShallowSound     = FootLightShallowSplashSound;
   FootWadingSound      = FootLightWadingSound;
   FootUnderwaterSound  = FootLightUnderwaterSound;

   FootBubblesSound     = FootLightBubblesSound;
   movingBubblesSound   = PlayerMoveBubblesSound;
   waterBreathSound     = WaterBreathMaleSound;

   impactSoftSound      = ImpactLightSoftSound;
   impactHardSound      = ImpactLightHardSound;
   impactMetalSound     = ImpactLightMetalSound;
   impactSnowSound      = ImpactLightSnowSound;

   impactWaterEasy      = ImpactLightWaterEasySound;
   impactWaterMedium    = ImpactLightWaterMediumSound;
   impactWaterHard      = ImpactLightWaterHardSound;
   exitingWater         = ExitingWaterLightSound;

   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
};

Member Function Documentation

bool Player::checkDismountPoint | ( | Point3F | oldPos,
 |  | Point3F | pos
 | ) |  |

Check if it is safe to dismount at this position.

Internally this method casts a ray from oldPos to pos to determine if it hits the terrain, an interior object, a water object, another player, a static shape, a vehicle (exluding the one currently mounted), or physical zone. If this ray is in the clear, then the player's bounding box is also checked for a collision at the pos position. If this displaced bounding box is also in the clear, then checkDismountPoint() returns true.

Parameters:
oldPos | The player's current position
pos | The dismount position to check
Returns:
True if the dismount position is clear, false if not
Note:
The player must be already mounted for this method to not assert.
void Player::clearControlObject ( )

Clears the player's current control object.

Returns control to the player. This internally calls Player::setControlObject(0).

Example:
%player.clearControlObject();
echo(%player.getControlObject()); //<-- Returns 0, player assumes control
%player.setControlObject(%vehicle);
echo(%player.getControlObject()); //<-- Returns %vehicle, player controls the vehicle now.
Note:
If the player does not have a control object, the player will receive all moves from its GameConnection. If you're looking to remove control from the player itself (i.e. stop sending moves to the player) use GameConnection::setControlObject() to transfer control to another object, such as a camera.
See also:
setControlObject()
getControlObject()
GameConnection::setControlObject()
int Player::getControlObject ( )

Get the current object we are controlling.

Returns:
ID of the ShapeBase object we control, or 0 if not controlling an object.
See also:
setControlObject()
clearControlObject()
string Player::getDamageLocation ( Point3F pos )

Get the named damage location and modifier for a given world position.

the Player object can simulate different hit locations based on a pre-defined set of PlayerData defined percentages. These hit percentages divide up the Player's bounding box into different regions. The diagram below demonstrates how the various PlayerData properties split up the bounding volume:

While you may pass in any world position and getDamageLocation() will provide a best-fit location, you should be aware that this can produce some interesting results. For example, any position that is above PlayerData::boxHeadPercentage will be considered a 'head' hit, even if the world position is high in the sky. Therefore it may be wise to keep the passed in point to somewhere on the surface of, or within, the Player's bounding volume.

Note:
This method will not return an accurate location when the player is prone or swimming.
Parameters:
pos A world position for which to retrieve a body region on this player.
Returns:
a string containing two words (space separated strings), where the first is a location and the second is a modifier.

Posible locations:

  • head
  • torso
  • legs

Head modifiers:

  • left_back
  • middle_back
  • right_back
  • left_middle
  • middle_middle
  • right_middle
  • left_front
  • middle_front
  • right_front

Legs/Torso modifiers:

  • front_left
  • front_right
  • back_left
  • back_right
See also:
PlayerData::boxHeadPercentage
PlayerData::boxHeadFrontPercentage
PlayerData::boxHeadBackPercentage
PlayerData::boxHeadLeftPercentage
PlayerData::boxHeadRightPercentage
PlayerData::boxTorsoPercentage
string Player::getState ( )

Get the name of the player's current state.

The state is one of the following:

  • Dead - The Player is dead.
  • Mounted - The Player is mounted to an object such as a vehicle.
  • Move - The Player is free to move. The usual state.
  • Recover - The Player is recovering from a fall. See PlayerData::recoverDelay.
Returns:
The current state; one of: "Dead", "Mounted", "Move", "Recover"
bool Player::setActionThread | ( | string | name,
 |  | bool | hold = false,
 |  | bool | fsp = true
 | ) |  |

Set the main action sequence to play for this player.

Parameters:
name | Name of the action sequence to set
hold | Set to false to get a callback on the datablock when the sequence ends (PlayerData::animationDone()). When set to true no callback is made.
fsp | True if first person and none of the spine nodes in the shape should animate. False will allow the shape's spine nodes to animate.
Returns:
True if succesful, false if failed
Note:
The spine nodes for the Player's shape are named as follows:
  • Bip01 Pelvis
  • Bip01 Spine
  • Bip01 Spine1
  • Bip01 Spine2
  • Bip01 Neck
  • Bip01 Head

You cannot use setActionThread() to have the Player play one of the motion determined action animation sequences. These sequences are chosen based on how the Player moves and the Player's current pose. The names of these sequences are:

  • root
  • run
  • side
  • side_right
  • crouch_root
  • crouch_forward
  • crouch_backward
  • crouch_side
  • crouch_right
  • prone_root
  • prone_forward
  • prone_backward
  • swim_root
  • swim_forward
  • swim_backward
  • swim_left
  • swim_right
  • fall
  • jump
  • standjump
  • land
  • jet

If the player moves in any direction then the animation sequence set using this method will be cancelled and the chosen mation-based sequence will take over. This makes great for times when the Player cannot move, such as when mounted, or when it doesn't matter if the action sequence changes, such as waving and saluting.

Example:
// Place the player in a sitting position after being mounted
%player.setActionThread( "sitting", true, true );
bool Player::setArmThread ( string name )

Set the sequence that controls the player's arms (dynamically adjusted to match look direction).

Parameters:
name Name of the sequence to play on the player's arms.
Returns:
true if successful, false if failed.
Note:
By default the 'look' sequence is used, if available.
bool Player::setControlObject ( ShapeBase obj )

Set the object to be controlled by this player.

It is possible to have the moves sent to the Player object from the GameConnection to be passed along to another object. This happens, for example when a player is mounted to a vehicle. The move commands pass through the Player and on to the vehicle (while the player remains stationary within the vehicle). With setControlObject() you can have the Player pass along its moves to any object. One possible use is for a player to move a remote controlled vehicle. In this case the player does not mount the vehicle directly, but still wants to be able to control it.

Parameters:
obj Object to control with this player
Returns:
True if the object is valid, false if not
See also:
getControlObject()
clearControlObject()
GameConnection::setControlObject()

Member Data Documentation

bool Player::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

Reimplemented in AIPlayer.

bool Player::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.

Reimplemented in AIPlayer.

int Player::maxPredictionTicks [static]

Maximum number of ticks to predict on the client from the last known move obtained from the server.

int Player::maxWarpTicks [static]

When a warp needs to occur due to the client being too far off from the server, this is the maximum number of ticks we'll allow the client to warp to catch up.

float Player::minWarpTicks [static]

Fraction of tick at which instant warp occures on the client.

bool Player::renderCollision [static]

Determines if the player's collision mesh should be rendered.

This is mainly used for the tools and debugging.

bool Player::renderMyItems [static]

Determines if mounted shapes are rendered or not.

Used on the client side to disable the rendering of all Player mounted objects. This is mainly used for the tools or debugging.

bool Player::renderMyPlayer [static]

Determines if the player is rendered or not.

Used on the client side to disable the rendering of all Player objects. This is mainly for the tools or debugging.


Torque 3D - Script Manual: PlayerData Class Reference

PlayerData Class Reference
[Game Objects]

Defines properties for a Player object. More...

Inheritance diagram for PlayerData:
[legend]

List of all members.

Public Member Functions

Callbacks

void | animationDone (Player obj)
Called on the server when a scripted animation completes.
void | doDismount (Player obj)
Called when attempting to dismount the player from a vehicle.
void | onEnterLiquid (Player obj, float coverage, string type)
Called when the player enters a liquid.
void | onEnterMissionArea (Player obj)
Called when the player enters the mission area.
void | onLeaveLiquid (Player obj, string type)
Called when the player leaves a liquid.
void | onLeaveMissionArea (Player obj)
Called when the player leaves the mission area.
void | onStartSwim (Player obj)
Called when the player starts swimming.
void | onStopSwim (Player obj)
Called when the player stops swimming.

Public Attributes

float | maxTimeScale
Maximum time scale for action animations.
float | pickupRadius
Radius around the player to collide with Items in the scene (on server).
Movement: Jumping

float | airControl
Amount of movement control the player has when in the air.
int | jumpDelay
Delay time in number of ticks ticks between jumps.
float | jumpEnergyDrain
Energy level drained each time the player jumps.
float | jumpForce
Force used to accelerate the player when a jump is initiated.
float | jumpSurfaceAngle
Angle from vertical (in degrees) where the player can jump.
bool | jumpTowardsNormal
Controls the direction of the jump impulse.
float | maxJumpSpeed
Maximum vertical speed before the player can no longer jump.
float | minJumpEnergy
Minimum energy level required to jump.
float | minJumpSpeed
Minimum speed needed to jump.
Collision

Point3F | boundingBox
Size of the bounding box used by the player for collision.
int | boxHeadBackPercentage
Percentage of the player's bounding box depth that represents the back side of the head.
int | boxHeadFrontPercentage
Percentage of the player's bounding box depth that represents the front side of the head.
int | boxHeadLeftPercentage
Percentage of the player's bounding box width that represents the left side of the head.
float | boxHeadPercentage
Percentage of the player's bounding box height that represents the head.
int | boxHeadRightPercentage
Percentage of the player's bounding box width that represents the right side of the head.
float | boxTorsoPercentage
Percentage of the player's bounding box height that represents the torso.
Point3F | crouchBoundingBox
Collision bounding box used when the player is crouching.
Point3F | proneBoundingBox
Collision bounding box used when the player is prone (laying down).
Point3F | swimBoundingBox
Collision bounding box used when the player is swimming.
Interaction: Splashes

float | bubbleEmitTime
Time in seconds to generate bubble particles after entering the water.
float | exitSplashSoundVelocity
Minimum velocity when leaving the water for the exitingWater sound to play.
float | footstepSplashHeight
Water coverage level to choose between FootShallowSound and FootWadingSound.
float | hardSplashSoundVelocity
Minimum velocity when entering the water for choosing between the impactWaterMedium and impactWaterHard sound to play.
float | mediumSplashSoundVelocity
Minimum velocity when entering the water for choosing between the impactWaterEasy and impactWaterMedium sounds to play.
SplashData Splash
SplashData datablock used to create splashes when the player moves through water.
float | splashAngle
Maximum angle (in degrees) from pure vertical movement in water to generate splashes.
ParticleEmitterData | splashEmitter [3]
Particle emitters used to generate splash particles.
float | splashFreqMod
Multipled by speed to determine the number of splash particles to generate.
float | splashVelEpsilon
Minimum speed to generate splash particles.
float | splashVelocity
Minimum velocity when moving through water to generate splashes.
Movement: Crouching

float | crouchForce
Force used to accelerate the player when crouching.
float | maxCrouchBackwardSpeed
Maximum backward speed when crouching.
float | maxCrouchForwardSpeed
Maximum forward speed when crouching.
float | maxCrouchSideSpeed
Maximum sideways speed when crouching.
Interaction: Footsteps

DecalData DecalData
Decal to place on the ground for player footsteps.
float | decalOffset
Distance from the center of the model to the right foot.
ParticleEmitterData dustEmitter
Emitter used to generate dust particles.
ParticleEmitterData footPuffEmitter
Particle emitter used to generate footpuffs (particles created as the player walks along the ground).
int | footPuffNumParts
Number of footpuff particles to generate each step.
float | footPuffRadius
Particle creation radius for footpuff particles.
Interaction: Sounds

SFXTrack exitingWater
Sound to play when exiting the water with velocity >= exitSplashSoundVelocity.
SFXTrack FootBubblesSound
Sound to play when walking in water and coverage equals 1.0 (fully underwater).
SFXTrack FootHardSound
Sound to play when walking on a surface with Material footstepSoundId 1.
SFXTrack FootMetalSound
Sound to play when walking on a surface with Material footstepSoundId 2.
SFXTrack FootShallowSound
Sound to play when walking in water and coverage is less than footSplashHeight.
SFXTrack FootSnowSound
Sound to play when walking on a surface with Material footstepSoundId 3.
SFXTrack FootSoftSound
Sound to play when walking on a surface with Material footstepSoundId 0.
SFXTrack FootUnderwaterSound
Sound to play when walking in water and coverage equals 1.0 (fully underwater).
SFXTrack FootWadingSound
Sound to play when walking in water and coverage is less than 1, but > footSplashHeight.
SFXTrack impactHardSound
Sound to play after falling on a surface with Material footstepSoundId 1.
SFXTrack impactMetalSound
Sound to play after falling on a surface with Material footstepSoundId 2.
SFXTrack impactSnowSound
Sound to play after falling on a surface with Material footstepSoundId 3.
SFXTrack impactSoftSound
Sound to play after falling on a surface with Material footstepSoundId 0.
SFXTrack impactWaterEasy
Sound to play when entering the water with velocity < mediumSplashSoundVelocity.
SFXTrack impactWaterHard
Sound to play when entering the water with velocity >= hardSplashSoundVelocity.
SFXTrack impactWaterMedium
Sound to play when entering the water with velocity >= mediumSplashSoundVelocity and < hardSplashSoundVelocity.
SFXTrack movingBubblesSound
Sound to play when in water and coverage equals 1.0 (fully underwater).
SFXTrack waterBreathSound
Sound to play when in water and coverage equals 1.0 (fully underwater).
Interaction: Ground Impact

float | groundImpactMinSpeed
Minimum falling impact speed to apply damage and initiate the camera shaking effect.
Point3F | groundImpactShakeAmp
Amplitude of the camera shake effect after falling.
float | groundImpactShakeDuration
Duration (in seconds) of the camera shake effect after falling.
float | groundImpactShakeFalloff
Falloff factor of the camera shake effect after falling.
Point3F | groundImpactShakeFreq
Frequency of the camera shake effect after falling.
Movement

float | horizMaxSpeed
Maximum horizontal speed.
float | horizResistFactor
Factor of resistence once horizResistSpeed has been reached.
float | horizResistSpeed
Horizontal speed at which resistence will take place.
float | maxBackwardSpeed
Maximum backward speed when running.
float | maxForwardSpeed
Maximum forward speed when running.
float | maxSideSpeed
Maximum sideways speed when running.
float | maxStepHeight
Maximum height the player can step up.
float | minImpactSpeed
Minimum impact speed to apply falling damage.
float | minRunEnergy
Minimum energy level required to run or swim.
float | runEnergyDrain
Energy value drained each tick that the player is moving.
float | runForce
Force used to accelerate the player when running.
float | runSurfaceAngle
Maximum angle from vertical (in degrees) the player can run up.
float | upMaxSpeed
Maximum upwards speed.
float | upResistFactor
Factor of resistence once upResistSpeed has been reached.
float | upResistSpeed
Upwards speed at which resistence will take place.
Movement: Jetting

float | jetJumpEnergyDrain
Energy level drained each time the player jet jumps.
float | jetJumpForce
Force used to accelerate the player when a jet jump is initiated.
float | jetJumpSurfaceAngle
Angle from vertical (in degrees) where the player can jet jump.
float | jetMaxJumpSpeed
Maximum vertical speed before the player can no longer jet jump.
float | jetMinJumpEnergy
Minimum energy level required to jet jump.
float | jetMinJumpSpeed
Minimum speed needed to jet jump.
Camera

The settings used by the shape when it is the camera.

float | maxFreelookAngle
Defines the maximum left and right angles (in radians) the player can look in freelook mode.
float | maxLookAngle
Highest angle (in radians) the player can look.
float | minLookAngle
Lowest angle (in radians) the player can look.
bool | renderFirstPerson
Flag controlling whether to render the player shape in first person view.
Movement: Prone

float | maxProneBackwardSpeed
Maximum backward speed when prone (laying down).
float | maxProneForwardSpeed
Maximum forward speed when prone (laying down).
float | maxProneSideSpeed
Maximum sideways speed when prone (laying down).
float | proneForce
Force used to accelerate the player when prone (laying down).
Movement: Swimming

float | maxUnderwaterBackwardSpeed
Maximum backward speed when underwater.
float | maxUnderwaterForwardSpeed
Maximum forward speed when underwater.
float | maxUnderwaterSideSpeed
Maximum sideways speed when underwater.
float | swimForce
Force used to accelerate the player when swimming.
Physics

string | physicsPlayerType
Specifies the type of physics used by the player.
Falling

int | recoverDelay
Number of ticks for the player to recover from falling.
float | recoverRunForceScale
Scale factor applied to runForce while in the recover state.

Detailed Description

Defines properties for a Player object.

See also:
Player

Member Function Documentation

void PlayerData::animationDone ( Player obj )

Called on the server when a scripted animation completes.

Parameters:
obj The Player object
See also:
Player::setActionThread() for setting a scripted animation and its 'hold' parameter to determine if this callback is used.
void PlayerData::doDismount ( Player obj )

Called when attempting to dismount the player from a vehicle.

It is up to the doDismount() method to actually perform the dismount. Often there are some conditions that prevent this, such as the vehicle moving too fast.

Parameters:
obj The Player object
void PlayerData::onEnterLiquid | ( | Player | obj,
 |  | float | coverage,
 |  | string | type
 | ) |  |

Called when the player enters a liquid.

Parameters:
obj | The Player object
coverage | Percentage of the player's bounding box covered by the liquid
type | The type of liquid the player has entered
void PlayerData::onEnterMissionArea ( Player obj )

Called when the player enters the mission area.

Parameters:
obj The Player object
See also:
MissionArea
void PlayerData::onLeaveLiquid | ( | Player | obj,
 |  | string | type
 | ) |  |

Called when the player leaves a liquid.

Parameters:
obj | The Player object
type | The type of liquid the player has left
void PlayerData::onLeaveMissionArea ( Player obj )

Called when the player leaves the mission area.

Parameters:
obj The Player object
See also:
MissionArea
void PlayerData::onStartSwim ( Player obj )

Called when the player starts swimming.

Parameters:
obj The Player object
void PlayerData::onStopSwim ( Player obj )

Called when the player stops swimming.

Parameters:
obj The Player object

Member Data Documentation

float PlayerData::airControl

Amount of movement control the player has when in the air.

This is applied as a multiplier to the player's x and y motion.

Point3F PlayerData::boundingBox

Size of the bounding box used by the player for collision.

Dimensions are given as "width depth height".

int PlayerData::boxHeadBackPercentage

Percentage of the player's bounding box depth that represents the back side of the head.

Used when computing the damage location.

See also:
Player::getDamageLocation
int PlayerData::boxHeadFrontPercentage

Percentage of the player's bounding box depth that represents the front side of the head.

Used when computing the damage location.

See also:
Player::getDamageLocation
int PlayerData::boxHeadLeftPercentage

Percentage of the player's bounding box width that represents the left side of the head.

Used when computing the damage location.

See also:
Player::getDamageLocation
float PlayerData::boxHeadPercentage

Percentage of the player's bounding box height that represents the head.

Used when computing the damage location.

See also:
Player::getDamageLocation
int PlayerData::boxHeadRightPercentage

Percentage of the player's bounding box width that represents the right side of the head.

Used when computing the damage location.

See also:
Player::getDamageLocation
float PlayerData::boxTorsoPercentage

Percentage of the player's bounding box height that represents the torso.

Used when computing the damage location.

See also:
Player::getDamageLocation
float PlayerData::bubbleEmitTime

Time in seconds to generate bubble particles after entering the water.

Point3F PlayerData::crouchBoundingBox

Collision bounding box used when the player is crouching.

See also:
boundingBox
float PlayerData::crouchForce

Force used to accelerate the player when crouching.

DecalData PlayerData::DecalData

Decal to place on the ground for player footsteps.

float PlayerData::decalOffset

Distance from the center of the model to the right foot.

While this defines the distance to the right foot, it is also used to place the left foot decal as well. Just on the opposite side of the player.

ParticleEmitterData PlayerData::dustEmitter

Emitter used to generate dust particles.

Note:
Currently unused.
SFXTrack PlayerData::exitingWater

Sound to play when exiting the water with velocity >= exitSplashSoundVelocity.

See also:
exitSplashSoundVelocity
float PlayerData::exitSplashSoundVelocity

Minimum velocity when leaving the water for the exitingWater sound to play.

See also:
exitingWater
SFXTrack PlayerData::FootBubblesSound

Sound to play when walking in water and coverage equals 1.0 (fully underwater).

SFXTrack PlayerData::FootHardSound

Sound to play when walking on a surface with Material footstepSoundId 1.

SFXTrack PlayerData::FootMetalSound

Sound to play when walking on a surface with Material footstepSoundId 2.

ParticleEmitterData PlayerData::footPuffEmitter

Particle emitter used to generate footpuffs (particles created as the player walks along the ground).

Note:
The generation of foot puffs requires the appropriate triggeres to be defined in the player's animation sequences. Without these, no foot puffs will be generated.
int PlayerData::footPuffNumParts

Number of footpuff particles to generate each step.

Each foot puff is randomly placed within the defined foot puff radius. This includes having footPuffNumParts set to one.

See also:
footPuffRadius
float PlayerData::footPuffRadius

Particle creation radius for footpuff particles.

This is applied to each foot puff particle, even if footPuffNumParts is set to one. So set this value to zero if you want a single foot puff placed at exactly the same location under the player each time.

SFXTrack PlayerData::FootShallowSound

Sound to play when walking in water and coverage is less than footSplashHeight.

See also:
footSplashHeight
SFXTrack PlayerData::FootSnowSound

Sound to play when walking on a surface with Material footstepSoundId 3.

SFXTrack PlayerData::FootSoftSound

Sound to play when walking on a surface with Material footstepSoundId 0.

float PlayerData::footstepSplashHeight

Water coverage level to choose between FootShallowSound and FootWadingSound.

See also:
FootShallowSound
FootWadingSound
SFXTrack PlayerData::FootUnderwaterSound

Sound to play when walking in water and coverage equals 1.0 (fully underwater).

SFXTrack PlayerData::FootWadingSound

Sound to play when walking in water and coverage is less than 1, but > footSplashHeight.

See also:
footSplashHeight
float PlayerData::groundImpactMinSpeed

Minimum falling impact speed to apply damage and initiate the camera shaking effect.

Point3F PlayerData::groundImpactShakeAmp

Amplitude of the camera shake effect after falling.

This is how much to shake the camera.

float PlayerData::groundImpactShakeDuration

Duration (in seconds) of the camera shake effect after falling.

This is how long to shake the camera.

float PlayerData::groundImpactShakeFalloff

Falloff factor of the camera shake effect after falling.

This is how to fade the camera shake over the duration.

Point3F PlayerData::groundImpactShakeFreq

Frequency of the camera shake effect after falling.

This is how fast to shake the camera.

float PlayerData::hardSplashSoundVelocity

Minimum velocity when entering the water for choosing between the impactWaterMedium and impactWaterHard sound to play.

See also:
impactWaterMedium
impactWaterHard
float PlayerData::horizMaxSpeed

Maximum horizontal speed.

Note:
This limit is only enforced if the player's horizontal speed exceeds horizResistSpeed.
See also:
horizResistSpeed
horizResistFactor
float PlayerData::horizResistFactor

Factor of resistence once horizResistSpeed has been reached.

See also:
horizMaxSpeed
horizResistSpeed
float PlayerData::horizResistSpeed

Horizontal speed at which resistence will take place.

See also:
horizMaxSpeed
horizResistFactor
SFXTrack PlayerData::impactHardSound

Sound to play after falling on a surface with Material footstepSoundId 1.

SFXTrack PlayerData::impactMetalSound

Sound to play after falling on a surface with Material footstepSoundId 2.

SFXTrack PlayerData::impactSnowSound

Sound to play after falling on a surface with Material footstepSoundId 3.

SFXTrack PlayerData::impactSoftSound

Sound to play after falling on a surface with Material footstepSoundId 0.

SFXTrack PlayerData::impactWaterEasy

Sound to play when entering the water with velocity < mediumSplashSoundVelocity.

See also:
mediumSplashSoundVelocity
SFXTrack PlayerData::impactWaterHard

Sound to play when entering the water with velocity >= hardSplashSoundVelocity.

See also:
hardSplashSoundVelocity
SFXTrack PlayerData::impactWaterMedium

Sound to play when entering the water with velocity >= mediumSplashSoundVelocity and < hardSplashSoundVelocity.

See also:
mediumSplashSoundVelocity
hardSplashSoundVelocity
float PlayerData::jetJumpEnergyDrain

Energy level drained each time the player jet jumps.

Note:
Setting this to zero will disable any energy drain
See also:
jetMinJumpEnergy
float PlayerData::jetJumpForce

Force used to accelerate the player when a jet jump is initiated.

float PlayerData::jetJumpSurfaceAngle

Angle from vertical (in degrees) where the player can jet jump.

float PlayerData::jetMaxJumpSpeed

Maximum vertical speed before the player can no longer jet jump.

float PlayerData::jetMinJumpEnergy

Minimum energy level required to jet jump.

See also:
jetJumpEnergyDrain
float PlayerData::jetMinJumpSpeed

Minimum speed needed to jet jump.

If the player's own z velocity is greater than this, then it is used to scale the jet jump speed, up to jetMaxJumpSpeed.

See also:
jetMaxJumpSpeed
int PlayerData::jumpDelay

Delay time in number of ticks ticks between jumps.

float PlayerData::jumpEnergyDrain

Energy level drained each time the player jumps.

Note:
Setting this to zero will disable any energy drain
See also:
minJumpEnergy
float PlayerData::jumpForce

Force used to accelerate the player when a jump is initiated.

float PlayerData::jumpSurfaceAngle

Angle from vertical (in degrees) where the player can jump.

bool PlayerData::jumpTowardsNormal

Controls the direction of the jump impulse.

When false, jumps are always in the vertical (+Z) direction. When true jumps are in the direction of the ground normal so long as the player is not directly facing the surface. If the player is directly facing the surface, then they will jump straight up.

float PlayerData::maxBackwardSpeed

Maximum backward speed when running.

float PlayerData::maxCrouchBackwardSpeed

Maximum backward speed when crouching.

float PlayerData::maxCrouchForwardSpeed

Maximum forward speed when crouching.

float PlayerData::maxCrouchSideSpeed

Maximum sideways speed when crouching.

float PlayerData::maxForwardSpeed

Maximum forward speed when running.

float PlayerData::maxFreelookAngle

Defines the maximum left and right angles (in radians) the player can look in freelook mode.

float PlayerData::maxJumpSpeed

Maximum vertical speed before the player can no longer jump.

float PlayerData::maxLookAngle

Highest angle (in radians) the player can look.

Note:
An angle of zero is straight ahead, with positive up and negative down.
float PlayerData::maxProneBackwardSpeed

Maximum backward speed when prone (laying down).

float PlayerData::maxProneForwardSpeed

Maximum forward speed when prone (laying down).

float PlayerData::maxProneSideSpeed

Maximum sideways speed when prone (laying down).

float PlayerData::maxSideSpeed

Maximum sideways speed when running.

float PlayerData::maxStepHeight

Maximum height the player can step up.

The player will automatically step onto changes in ground height less than maxStepHeight. The player will collide with ground height changes greater than this.

float PlayerData::maxTimeScale

Maximum time scale for action animations.

If an action animation has a defined ground frame, it is automatically scaled to match the player's ground velocity. This field limits the maximum time scale used even if the player's velocity exceeds it.

float PlayerData::maxUnderwaterBackwardSpeed

Maximum backward speed when underwater.

float PlayerData::maxUnderwaterForwardSpeed

Maximum forward speed when underwater.

float PlayerData::maxUnderwaterSideSpeed

Maximum sideways speed when underwater.

float PlayerData::mediumSplashSoundVelocity

Minimum velocity when entering the water for choosing between the impactWaterEasy and impactWaterMedium sounds to play.

See also:
impactWaterEasy
impactWaterMedium
float PlayerData::minImpactSpeed

Minimum impact speed to apply falling damage.

This field also sets the minimum speed for the onImpact callback to be invoked.

See also:
ShapeBaseData::onImpact()
float PlayerData::minJumpEnergy

Minimum energy level required to jump.

See also:
jumpEnergyDrain
float PlayerData::minJumpSpeed

Minimum speed needed to jump.

If the player's own z velocity is greater than this, then it is used to scale the jump speed, up to maxJumpSpeed.

See also:
maxJumpSpeed
float PlayerData::minLookAngle

Lowest angle (in radians) the player can look.

Note:
An angle of zero is straight ahead, with positive up and negative down.
float PlayerData::minRunEnergy

Minimum energy level required to run or swim.

See also:
runEnergyDrain
SFXTrack PlayerData::movingBubblesSound

Sound to play when in water and coverage equals 1.0 (fully underwater).

Note that unlike FootUnderwaterSound, this sound plays even if the player is not moving around in the water.

string PlayerData::physicsPlayerType

Specifies the type of physics used by the player.

This depends on the physics module used. An example is 'Capsule'.

Note:
Not current used.
float PlayerData::pickupRadius

Radius around the player to collide with Items in the scene (on server).

Internally the pickupRadius is added to the larger side of the initial bounding box to determine the actual distance, to a maximum of 2 times the bounding box size. The initial bounding box is that used for the root pose, and therefore doesn't take into account the change in pose.

Point3F PlayerData::proneBoundingBox

Collision bounding box used when the player is prone (laying down).

See also:
boundingBox
float PlayerData::proneForce

Force used to accelerate the player when prone (laying down).

int PlayerData::recoverDelay

Number of ticks for the player to recover from falling.

float PlayerData::recoverRunForceScale

Scale factor applied to runForce while in the recover state.

This can be used to temporarily slow the player's movement after a fall, or prevent the player from moving at all if set to zero.

bool PlayerData::renderFirstPerson

Flag controlling whether to render the player shape in first person view.

float PlayerData::runEnergyDrain

Energy value drained each tick that the player is moving.

The player will not be able to move when his energy falls below minRunEnergy.

Note:
Setting this to zero will disable any energy drain.
See also:
minRunEnergy
float PlayerData::runForce

Force used to accelerate the player when running.

float PlayerData::runSurfaceAngle

Maximum angle from vertical (in degrees) the player can run up.

SplashData PlayerData::Splash

SplashData datablock used to create splashes when the player moves through water.

float PlayerData::splashAngle

Maximum angle (in degrees) from pure vertical movement in water to generate splashes.

ParticleEmitterData PlayerData::splashEmitter[3]

Particle emitters used to generate splash particles.

float PlayerData::splashFreqMod

Multipled by speed to determine the number of splash particles to generate.

float PlayerData::splashVelEpsilon

Minimum speed to generate splash particles.

float PlayerData::splashVelocity

Minimum velocity when moving through water to generate splashes.

Point3F PlayerData::swimBoundingBox

Collision bounding box used when the player is swimming.

See also:
boundingBox
float PlayerData::swimForce

Force used to accelerate the player when swimming.

float PlayerData::upMaxSpeed

Maximum upwards speed.

Note:
This limit is only enforced if the player's upward speed exceeds upResistSpeed.
See also:
upResistSpeed
upResistFactor
float PlayerData::upResistFactor

Factor of resistence once upResistSpeed has been reached.

See also:
upMaxSpeed
upResistSpeed
float PlayerData::upResistSpeed

Upwards speed at which resistence will take place.

See also:
upMaxSpeed
upResistFactor
SFXTrack PlayerData::waterBreathSound

Sound to play when in water and coverage equals 1.0 (fully underwater).

Note that unlike FootUnderwaterSound, this sound plays even if the player is not moving around in the water.


Torque 3D - Script Manual: PointLight Class Reference

PointLight Class Reference
[Lighting]

Lighting object that radiates light in all directions. More...

Inheritance diagram for PointLight:
[legend]

List of all members.

Public Attributes

Light

float | radius
Controls the falloff of the light emission.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Lighting object that radiates light in all directions.

PointLight is one of the two types of lighting objects that can be added to a Torque 3D level, the other being SpotLight. Unlike directional or conical light, the PointLight emits lighting in all directions. The attenuation is controlled by a single variable: LightObject::radius.

Example:
// Declaration of a point light in script, or created by World Editor
new PointLight(CrystalLight)
{
   radius = "10";
   isEnabled = "1";
   color = "1 0.905882 0 1";
   brightness = "0.5";
   castShadows = "1";
   priority = "1";
   animate = "1";
   animationType = "SubtlePulseLightAnim";
   animationPeriod = "3";
   animationPhase = "3";
   flareScale = "1";
   attenuationRatio = "0 1 1";
   shadowType = "DualParaboloidSinglePass";
   texSize = "512";
   overDarkFactor = "2000 1000 500 100";
   shadowDistance = "400";
   shadowSoftness = "0.15";
   numSplits = "1";
   logWeight = "0.91";
   fadeStartDistance = "0";
   lastSplitTerrainOnly = "0";
   splitFadeDistances = "10 20 30 40";
   representedInLightmap = "0";
   shadowDarkenColor = "0 0 0 -1";
   includeLightmappedGeometryInShadow = "1";
   position = "-61.3866 1.69186 5.1464";
   rotation = "1 0 0 0";
};
See also:
LightBase
SpotLight

Member Data Documentation

bool PointLight::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from LightBase.

bool PointLight::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from LightBase.

float PointLight::radius

Controls the falloff of the light emission.


Torque 3D - Script Manual: Portal Class Reference

Portal Class Reference
[Miscellaneous]

An object that provides a "window" into a zone, allowing a viewer to see what's rendered in the zone. More...

Inheritance diagram for Portal:
[legend]

List of all members.

Public Member Functions

bool | isExteriorPortal ()
Test whether the portal connects interior zones to the outdoor zone.
bool | isInteriorPortal ()
Test whether the portal connects interior zones only.

Public Attributes

Zoning

bool | backSidePassable
Whether one can view through the back-side of the portal.
bool | frontSidePassable
Whether one can view through the front-side of the portal.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An object that provides a "window" into a zone, allowing a viewer to see what's rendered in the zone.

This is one of two objects used by the manual culling system Torque 3D provides, the other being Zone. When a Zone is placed in a level, all rendering within the zone is hidden from view when the camera is outside it. When inside, all rendering outside the zone is hidden. This is an excellent way to optimize large levels and complex geometry.

You can attach a Portal a zone. This allows you to view what is rendered in the Zone (or what is rendered outside if you are in the zone), like a window. The larger the Portal, the more you can see through a zone.

Example:
// Example declaration of a Portal
new Portal( PortalToTestZone )
{
   position = "12.8467 -4.02246 14.8017";
    rotation = "0 0 -1 97.5085";
    scale = "1 0.25 1";
    canSave = "1";
    canSaveDynamicFields = "1";
};
See also:
Zone

Member Function Documentation

bool Portal::isExteriorPortal ( )

Test whether the portal connects interior zones to the outdoor zone.

Returns:
True if the portal is an exterior portal.
bool Portal::isInteriorPortal ( )

Test whether the portal connects interior zones only.

Returns:
True if the portal is an interior portal.

Member Data Documentation

bool Portal::backSidePassable

Whether one can view through the back-side of the portal.

bool Portal::frontSidePassable

Whether one can view through the front-side of the portal.

bool Portal::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from Zone.

bool Portal::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from Zone.


Torque 3D - Script Manual: PostEffect Class Reference

PostEffect Class Reference
[Rendering]

A fullscreen shader effect. More...

Inheritance diagram for PostEffect:
[legend]

List of all members.

Public Member Functions

void | clearShaderMacros ()
Remove all shader macros.
void | disable ()
Disables the effect.
String | dumpShaderDisassembly ()
Dumps this PostEffect shader's disassembly to a temporary text file.
void | enable ()
Enables the effect.
float | getAspectRatio ()
bool | isEnabled ()
void | reload ()
Reloads the effect shader and textures.
void | removeShaderMacro (string key)
Remove a shader macro. This will usually be called within the preProcess callback.
void | setShaderConst (string name, string value)
Sets the value of a uniform defined in the shader. This will usually be called within the setShaderConsts callback. Array type constants are not supported.
void | setShaderMacro (string key, string value="")
Adds a macro to the effect's shader or sets an existing one's value. This will usually be called within the onAdd or preProcess callback.
bool | toggle ()
Toggles the effect between enabled / disabled.
Callbacks

void | onAdd ()
Called when this object is first created and registered.
void | onDisabled ()
Called when this effect becomes disabled.
bool | onEnabled ()
Called when this effect becomes enabled. If the user returns false from this callback the effect will not be enabled.
void | preProcess ()
Called when an effect is processed but before textures are bound. This allows the user to change texture related paramaters or macros at runtime.
void | setShaderConsts ()
Called immediate before processing this effect. This is the user's chance to set the value of shader uniforms (constants).

Public Attributes

bool | allowReflectPass
Is this effect processed during reflection render passes.
bool | isEnabled
Is the effect on.
bool | oneFrameOnly
Allows you to turn on a PostEffect for only a single frame.
bool | onThisFrame
Allows you to turn on a PostEffect for only a single frame.
string | renderBin
Name of a renderBin, used if renderTime is PFXBeforeBin or PFXAfterBin.
float | renderPriority
PostEffects are processed in DESCENDING order of renderPriority if more than one has the same renderBin/Time.
PFXRenderTime renderTime
When to process this effect during the frame.
string | shader
Name of a GFXShaderData for this effect.
bool | skip
Skip processing of this PostEffect and its children even if its parent is enabled. Parent and sibling PostEffects in the chain are still processed.
GFXStateBlockData stateBlock
Name of a GFXStateBlockData for this effect.
string | target
String identifier of this effect's target texture.
PFXTargetClear targetClear
Describes when the target texture should be cleared.
ColorF | targetClearColor
Color to which the target texture is cleared before rendering.
string | targetDepthStencil
Optional string identifier for this effect's target depth/stencil texture.
GFXFormat targetFormat
Format of the target texture, not applicable if writing to the backbuffer.
Point2F | targetScale
If targetSize is zero this is used to set a relative size from the current target.
Point2I | targetSize
If non-zero this is used as the absolute target size.
filename | texture [4]
Input textures to this effect ( samplers ).

Detailed Description

A fullscreen shader effect.

PFXTextureIdentifiers

Member Function Documentation

void PostEffect::clearShaderMacros ( )

Remove all shader macros.

void PostEffect::disable ( )

Disables the effect.

String PostEffect::dumpShaderDisassembly ( )

Dumps this PostEffect shader's disassembly to a temporary text file.

Returns:
Full path to the dumped file or an empty string if failed.
void PostEffect::enable ( )

Enables the effect.

float PostEffect::getAspectRatio ( )
Returns:
Width over height of the backbuffer.
bool PostEffect::isEnabled ( )
Returns:
True if the effect is enabled.
void PostEffect::onAdd ( )

Called when this object is first created and registered.

void PostEffect::onDisabled ( )

Called when this effect becomes disabled.

bool PostEffect::onEnabled ( )

Called when this effect becomes enabled. If the user returns false from this callback the effect will not be enabled.

Returns:
True to allow this effect to be enabled.
void PostEffect::preProcess ( )

Called when an effect is processed but before textures are bound. This allows the user to change texture related paramaters or macros at runtime.

Example:
function SSAOPostFx::preProcess( %this )
{
   if ( $SSAOPostFx::quality !$= %this.quality )
   {
      %this.quality = mClamp( mRound( $SSAOPostFx::quality ), 0, 2 );

      %this.setShaderMacro( "QUALITY", %this.quality );
   }
   %this.targetScale = $SSAOPostFx::targetScale;
}
See also:
setShaderConst
setShaderMacro
void PostEffect::reload ( )

Reloads the effect shader and textures.

void PostEffect::removeShaderMacro ( string key )

Remove a shader macro. This will usually be called within the preProcess callback.

Parameters:
key Macro to remove.
void PostEffect::setShaderConst | ( | string | name,
 |  | string | value
 | ) |  |

Sets the value of a uniform defined in the shader. This will usually be called within the setShaderConsts callback. Array type constants are not supported.

Parameters:
name | Name of the constanst, prefixed with '$'.
value | Value to set, space seperate values with more than one element.
Example:
function MyPfx::setShaderConsts( %this )
{
   // example float4 uniform
   %this.setShaderConst( "$colorMod", "1.0 0.9 1.0 1.0" );
   // example float1 uniform
   %this.setShaderConst( "$strength", "3.0" );
   // example integer uniform
   %this.setShaderConst( "$loops", "5" );}
void PostEffect::setShaderConsts ( )

Called immediate before processing this effect. This is the user's chance to set the value of shader uniforms (constants).

See also:
setShaderConst
void PostEffect::setShaderMacro | ( | string | key,
 |  | string | value = ""
 | ) |  |

Adds a macro to the effect's shader or sets an existing one's value. This will usually be called within the onAdd or preProcess callback.

Parameters:
key | lval of the macro.
value | rval of the macro, or may be empty.
Example:
function MyPfx::onAdd( %this )
{
   %this.setShaderMacro( "NUM_SAMPLES", "10" );
   %this.setShaderMacro( "HIGH_QUALITY_MODE" );

   // In the shader looks like...
   // #define NUM_SAMPLES 10
   // #define HIGH_QUALITY_MODE
}
bool PostEffect::toggle ( )

Toggles the effect between enabled / disabled.

Returns:
True if effect is enabled.

Member Data Documentation

bool PostEffect::allowReflectPass

Is this effect processed during reflection render passes.

bool PostEffect::isEnabled

Is the effect on.

bool PostEffect::oneFrameOnly

Allows you to turn on a PostEffect for only a single frame.

bool PostEffect::onThisFrame

Allows you to turn on a PostEffect for only a single frame.

string PostEffect::renderBin

Name of a renderBin, used if renderTime is PFXBeforeBin or PFXAfterBin.

float PostEffect::renderPriority

PostEffects are processed in DESCENDING order of renderPriority if more than one has the same renderBin/Time.

PFXRenderTime PostEffect::renderTime

When to process this effect during the frame.

string PostEffect::shader

Name of a GFXShaderData for this effect.

bool PostEffect::skip

Skip processing of this PostEffect and its children even if its parent is enabled. Parent and sibling PostEffects in the chain are still processed.

GFXStateBlockData PostEffect::stateBlock

Name of a GFXStateBlockData for this effect.

string PostEffect::target

String identifier of this effect's target texture.

See also:
PFXTextureIdentifiers
PFXTargetClear PostEffect::targetClear

Describes when the target texture should be cleared.

ColorF PostEffect::targetClearColor

Color to which the target texture is cleared before rendering.

string PostEffect::targetDepthStencil

Optional string identifier for this effect's target depth/stencil texture.

See also:
PFXTextureIdentifiers
GFXFormat PostEffect::targetFormat

Format of the target texture, not applicable if writing to the backbuffer.

Point2F PostEffect::targetScale

If targetSize is zero this is used to set a relative size from the current target.

Point2I PostEffect::targetSize

If non-zero this is used as the absolute target size.

filename PostEffect::texture[4]

Input textures to this effect ( samplers ).

See also:
PFXTextureIdentifiers

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: Precipitation Class Reference

Precipitation Class Reference
[Special Effects, Atmosphere]

Defines a precipitation based storm (IE: rain, snow, etc.). More...

Inheritance diagram for Precipitation:
[legend]

List of all members.

Public Member Functions

void | modifyStorm (float percentage=1.0f, float length=5.0f)
Adjusts the droplet count and overall length of the Precipitation effect.
void | setPercentage (float percentage=1.0f)
Sets how many drops are present at once.
void | setTurbulence (float max=1.0f, float speed=5.0f, float seconds=5.0)
This is used to smoothly change the turbulence.

Public Attributes

Rendering

bool | animateSplashes
Check to enable splash animation on collision.
int | dropAnimateMS
If greater than zero, will animate the drops from the frames in the texture.
float | dropSize
Size of each drop of precipitation. This will scale the texture.
float | fadeDist
The distance at which fading of the drops begins.
float | fadeDistEnd
The distance at which fading of the particles ends.
ColorF | glowIntensity
Set to 0 to disable the glow or or use it to control the intensity of each channel.
bool | reflect
This enables the precipitation to be rendered during reflection passes. This is expensive.
bool | rotateWithCamVel
Enables drops to rotate to face camera.
int | splashMS
Life of splashes in milliseconds.
float | splashSize
Size of each splash animation for when a drop collides.
bool | useLighting
Check to enable shading of the drops and splashes by the sun color.
bool | useTrueBillboards
Check to make drops true (non axis-aligned) billboards.
Precipitation

float | boxHeight
Height of precipitation box.
float | boxWidth
Width of precipitation box.
int | numDrops
Number of drops allowed to exists in the precipitation box at any one time.
Collision

bool | doCollision
Allow collision with world objects.
bool | hitPlayers
Allow collision on player objects.
bool | hitVehicles
Allow collision on vehicles.
Movement

bool | followCam
Enables system to follow the camera or stay where it is placed.
float | maxMass
Maximum mass of a drop.
float | maxSpeed
Maximum speed that a drop will fall.
float | minMass
Minimum mass of a drop.
float | minSpeed
Minimum speed that a drop will fall.
bool | useWind
Check to have the Sky property windSpeed affect precipitation.
Turbulence

float | maxTurbulence
Radius at which precipitation drops spiral when turbulence is enabled.
float | turbulenceSpeed
Speed at which precipitation drops spiral when turbulence is enabled.
bool | useTurbulence
Check to enable turbulence. This causes precipitation drops to spiral while falling.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Defines a precipitation based storm (IE: rain, snow, etc.).

Example:
// The following is added to a level file (.mis) by the World Editor
new Precipitation(TheRain) {
   dropSize = "0.5";
   splashSize = "0.5";
   splashMS = "250";
   animateSplashes = "1";
   dropAnimateMS = "0";
   fadeDist = "0";
   fadeDistEnd = "0";
   useTrueBillboards = "0";
   useLighting = "0";
   glowIntensity = "0 0 0 0";
   reflect = "0";
   rotateWithCamVel = "1";
   doCollision = "1";
   hitPlayers = "0";
   hitVehicles = "0";
   followCam = "1";
   useWind = "0";
   minSpeed = "1.5";
   maxSpeed = "2";
   minMass = "0.75";
   maxMass = "0.85";
   useTurbulence = "0";
   maxTurbulence = "0.1";
   turbulenceSpeed = "0.2";
   numDrops = "1024";
   boxWidth = "200";
   boxHeight = "100";
   dataBlock = "HeavyRain";
};

Member Function Documentation

void Precipitation::modifyStorm | ( | float | percentage = 1.0f,
 |  | float | length = 5.0f
 | ) |  |

Adjusts the droplet count and overall length of the Precipitation effect.

Example:
// The percentage, from 0.0f to 1.0f, of the drops to display at once.
%percentage = 0.5;

// The length of time for the Precipitation effect to last. Will be multiplied by 1000 to get the milliseconds.
%length = 5.0;

// Set the percentage and time by calling the method.
%Precipitation.modifyStorm(%percentage , %length);
void Precipitation::setPercentage ( float percentage = 1.0f )

Sets how many drops are present at once.

Example:
// The percentage, from 0.0f to 1.0f, of the drops to display at once.
%percentage = 0.5f;

// Set the percentage by calling the method.
%Precipitation.setPercentage(%percentage);

void Precipitation::setTurbulence | ( | float | max = 1.0f,
 |  | float | speed = 5.0f,
 |  | float | seconds = 5.0
 | ) |  |

This is used to smoothly change the turbulence.

over a desired time period. Setting ms to zero will cause the change to be instantaneous. Setting max zero will disable turbulence.

Example:
//Set the turbulence value. Set to 0 to disable turbulence.
%turbulence = 0.5;

// The speed of the turbulance effect.
%speed = 5.0;

// The length of time for the turbulence to last. Will be multiplied by 1000 to get the milliseconds.
%seconds = 5.0;

// Set the percentage and time by calling the method.
%Precipitation.setTurbulence(%turbulence , %speed , %seconds);

Member Data Documentation

bool Precipitation::animateSplashes

Check to enable splash animation on collision.

float Precipitation::boxHeight

Height of precipitation box.

float Precipitation::boxWidth

Width of precipitation box.

bool Precipitation::doCollision

Allow collision with world objects.

int Precipitation::dropAnimateMS

If greater than zero, will animate the drops from the frames in the texture.

float Precipitation::dropSize

Size of each drop of precipitation. This will scale the texture.

float Precipitation::fadeDist

The distance at which fading of the drops begins.

float Precipitation::fadeDistEnd

The distance at which fading of the particles ends.

bool Precipitation::followCam

Enables system to follow the camera or stay where it is placed.

ColorF Precipitation::glowIntensity

Set to 0 to disable the glow or or use it to control the intensity of each channel.

bool Precipitation::hitPlayers

Allow collision on player objects.

bool Precipitation::hitVehicles

Allow collision on vehicles.

bool Precipitation::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool Precipitation::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

float Precipitation::maxMass

Maximum mass of a drop.

float Precipitation::maxSpeed

Maximum speed that a drop will fall.

float Precipitation::maxTurbulence

Radius at which precipitation drops spiral when turbulence is enabled.

float Precipitation::minMass

Minimum mass of a drop.

float Precipitation::minSpeed

Minimum speed that a drop will fall.

int Precipitation::numDrops

Number of drops allowed to exists in the precipitation box at any one time.

bool Precipitation::reflect

This enables the precipitation to be rendered during reflection passes. This is expensive.

bool Precipitation::rotateWithCamVel

Enables drops to rotate to face camera.

int Precipitation::splashMS

Life of splashes in milliseconds.

float Precipitation::splashSize

Size of each splash animation for when a drop collides.

float Precipitation::turbulenceSpeed

Speed at which precipitation drops spiral when turbulence is enabled.

bool Precipitation::useLighting

Check to enable shading of the drops and splashes by the sun color.

bool Precipitation::useTrueBillboards

Check to make drops true (non axis-aligned) billboards.

bool Precipitation::useTurbulence

Check to enable turbulence. This causes precipitation drops to spiral while falling.

bool Precipitation::useWind

Check to have the Sky property windSpeed affect precipitation.


Torque 3D - Script Manual: PrecipitationData Class Reference

PrecipitationData Class Reference
[Special Effects, Atmosphere]

Defines the droplets used in a storm (IE: raindrops, snowflakes, etc.). More...

Inheritance diagram for PrecipitationData:
[legend]

List of all members.

Public Attributes

string | dropShader
The name of the shader used for raindrops.
int | dropsPerSide
How many drops are on a side of the raindrop texture.
filename | dropTexture
Texture filename for drop particles.
SFXTrack soundProfile
SFXProfile effect to play.
int | splashesPerSide
How many splash are on a side of the splash texture.
string | splashShader
The name of the shader used for raindrops.
filename | splashTexture
Texture filename for splash particles.

Detailed Description

Defines the droplets used in a storm (IE: raindrops, snowflakes, etc.).

Example:
datablock PrecipitationData(HeavyRain)
{
   soundProfile = "HeavyRainSound";

   dropTexture = "art/environment/precipitation/rain";
   splashTexture = "art/environment/precipitation/water_splash";
   dropSize = 0.35;
   splashSize = 0.1;
   useTrueBillboards = false;
   splashMS = 500;
};

Member Data Documentation

string PrecipitationData::dropShader

The name of the shader used for raindrops.

int PrecipitationData::dropsPerSide

How many drops are on a side of the raindrop texture.

filename PrecipitationData::dropTexture

Texture filename for drop particles.

SFXTrack PrecipitationData::soundProfile

SFXProfile effect to play.

int PrecipitationData::splashesPerSide

How many splash are on a side of the splash texture.

string PrecipitationData::splashShader

The name of the shader used for raindrops.

filename PrecipitationData::splashTexture

Texture filename for splash particles.


Torque 3D - Script Manual: Prefab Class Reference

Prefab Class Reference
[Miscellaneous]

A collection of arbitrary objects which can be allocated and manipulated as a group. More...

Inheritance diagram for Prefab:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onLoad (SimGroup children)
Called when the prefab file is loaded and children objects are created.

Public Attributes

Prefab

filename | fileName
(.prefab) File describing objects within this prefab.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A collection of arbitrary objects which can be allocated and manipulated as a group.

Prefab always points to a (.prefab) file which defines its objects. In fact more than one Prefab can reference this file and both will update if the file is modified.

Prefab is a very simple object and only exists on the server. When it is created it allocates children objects by reading the (.prefab) file like a list of instructions. It then sets their transform relative to the Prefab and Torque networking handles the rest by ghosting the new objects to clients. Prefab itself is not ghosted.

Member Function Documentation

void Prefab::onLoad ( SimGroup children )

Called when the prefab file is loaded and children objects are created.

Parameters:
children SimGroup containing all children objects.

Member Data Documentation

filename Prefab::fileName

(.prefab) File describing objects within this prefab.

bool Prefab::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool Prefab::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.


Torque 3D - Script Manual: Projectile Class Reference

Projectile Class Reference
[Game Objects]

Base projectile class. Uses the ProjectileData class for properties of individual projectiles. More...

Inheritance diagram for Projectile:
[legend]

List of all members.

Public Member Functions

void | presimulate (float seconds=1.0f)
Updates the projectile's positional and collision information.

Public Attributes

Physics

Point3F | initialPosition
Starting position for the projectile.
Point3F | initialVelocity
Starting velocity for the projectile.
Source

int | sourceObject
ID number of the object that fired the projectile.
int | sourceSlot
The sourceObject's weapon slot that the projectile originates from.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Base projectile class. Uses the ProjectileData class for properties of individual projectiles.

Member Function Documentation

void Projectile::presimulate ( float seconds = 1.0f )

Updates the projectile's positional and collision information.

This function will first delete the projectile if it is a server object and is outside it's ProjectileData::lifetime. Also responsible for applying gravity, determining collisions, triggering explosions, emitting trail particles, and calculating bounces if necessary.

Parameters:
seconds Amount of time, in seconds since the simulation's start, to advance.
Example:
// Tell the projectile to process a simulation event, and provide the amount of time
// that has passed since the simulation began.
%seconds = 2.0;
%projectile.presimulate(%seconds);
Note:
This function is not called if the SimObject::hidden is true.

Member Data Documentation

Point3F Projectile::initialPosition

Starting position for the projectile.

Point3F Projectile::initialVelocity

Starting velocity for the projectile.

bool Projectile::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool Projectile::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

int Projectile::sourceObject

ID number of the object that fired the projectile.

Note:
If the projectile was fired by a WeaponImage, sourceObject will be the object that owns the WeaponImage. This is usually the player.
int Projectile::sourceSlot

The sourceObject's weapon slot that the projectile originates from.


Torque 3D - Script Manual: ProjectileData Class Reference

ProjectileData Class Reference
[Game Objects]

Stores properties for an individual projectile type. More...

Inheritance diagram for ProjectileData:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onCollision (Projectile proj, SceneObject col, float fade, Point3F pos, Point3F normal)
Called when a projectile collides with another object.
void | onExplode (Projectile proj, Point3F pos, float fade)
Called when a projectile explodes.

Public Attributes

int | armingDelay
Amount of time, in milliseconds, before the projectile will cause damage or explode on impact.
float | bounceElasticity
Influences post-bounce velocity of a projectile that does not explode on contact.
float | bounceFriction
Factor to reduce post-bounce velocity of a projectile that does not explode on contact.
DecalData decal
Decal datablock used for decals placed at projectile explosion points.
ExplosionData Explosion
Explosion datablock used when the projectile explodes outside of water.
int | fadeDelay
Amount of time, in milliseconds, before the projectile begins to fade out.
float | gravityMod
Scales the influence of gravity on the projectile.
float | impactForce
bool | isBallistic
Detetmines if the projectile should be affected by gravity and whether or not it bounces before exploding.
int | lifetime
Amount of time, in milliseconds, before the projectile is removed from the simulation.
LightDescription lightDesc
LightDescription datablock used for lights attached to the projectile.
float | muzzleVelocity
Amount of velocity the projectile recieves from the "muzzle" of the gun.
ParticleEmitterData ParticleEmitter
Particle emitter datablock used to generate particles while the projectile is outside of water.
ParticleEmitterData particleWaterEmitter
Particle emitter datablock used to generate particles while the projectile is submerged in water.
filename | projectileShapeName
File path to the model of the projectile.
Point3F | scale
Scale to apply to the projectile's size.
SFXTrack sound
SFXTrack datablock used to play sounds while in flight.
SplashData Splash
Splash datablock used to create splash effects as the projectile enters or leaves water.
float | velInheritFactor
Amount of velocity the projectile recieves from the source that created it.
ExplosionData waterExplosion
Explosion datablock used when the projectile explodes underwater.

Detailed Description

Stores properties for an individual projectile type.

Example:
datablock ProjectileData(GrenadeLauncherProjectile)
{
 projectileShapeName = "art/shapes/weapons/SwarmGun/rocket.dts";
directDamage = 30;
radiusDamage = 30;
damageRadius = 5;
areaImpulse = 2000;
explosion = GrenadeLauncherExplosion;
waterExplosion = GrenadeLauncherWaterExplosion;
decal = ScorchRXDecal;
splash = GrenadeSplash;
particleEmitter = GrenadeProjSmokeTrailEmitter;
particleWaterEmitter = GrenadeTrailWaterEmitter;
muzzleVelocity = 30;
velInheritFactor = 0.3;
armingDelay = 2000;
lifetime = 10000;
fadeDelay = 4500;
bounceElasticity = 0.4;
bounceFriction = 0.3;
isBallistic = true;
gravityMod = 0.9;
lightDesc = GrenadeLauncherLightDesc;
damageType = "GrenadeDamage";
};

Member Function Documentation

void ProjectileData::onCollision | ( | Projectile | proj,
 |  | SceneObject | col,
 |  | float | fade,
 |  | Point3F | pos,
 |  | Point3F | normal
 | ) |  |

Called when a projectile collides with another object.

This function is only called on server objects.

Parameters:
proj | The projectile colliding with SceneObject col.
col | The SceneObject hit by the projectile.
fade | The current fadeValue of the projectile, affects its visibility.
pos | The position of the collision.
normal | The normal of the collision.
See also:
Projectile
void ProjectileData::onExplode | ( | Projectile | proj,
 |  | Point3F | pos,
 |  | float | fade
 | ) |  |

Called when a projectile explodes.

This function is only called on server objects.

Parameters:
proj | The exploding projectile.
pos | The position of the explosion.
fade | The current fadeValue of the projectile, affects its visibility.
See also:
Projectile

Member Data Documentation

int ProjectileData::armingDelay

Amount of time, in milliseconds, before the projectile will cause damage or explode on impact.

This value must be equal to or less than the projectile's lifetime.

See also:
lifetime
float ProjectileData::bounceElasticity

Influences post-bounce velocity of a projectile that does not explode on contact.

Scales the velocity from a bounce after friction is taken into account. A value of 1.0 will leave it's velocity unchanged while values greater than 1.0 will increase it.

float ProjectileData::bounceFriction

Factor to reduce post-bounce velocity of a projectile that does not explode on contact.

Reduces bounce velocity by this factor and a multiple of the tangent to impact. Used to simulate surface friction.

DecalData ProjectileData::decal

Decal datablock used for decals placed at projectile explosion points.

ExplosionData ProjectileData::Explosion

Explosion datablock used when the projectile explodes outside of water.

int ProjectileData::fadeDelay

Amount of time, in milliseconds, before the projectile begins to fade out.

This value must be smaller than the projectile's lifetime to have an affect.

float ProjectileData::gravityMod

Scales the influence of gravity on the projectile.

The larger this value is, the more that gravity will affect the projectile. A value of 1.0 will assume "normal" influence upon it. The magnitude of gravity is assumed to be 9.81 m/s/s

Note:
ProjectileData::isBallistic must be true for this to have any affect.
float ProjectileData::impactForce
bool ProjectileData::isBallistic

Detetmines if the projectile should be affected by gravity and whether or not it bounces before exploding.

int ProjectileData::lifetime

Amount of time, in milliseconds, before the projectile is removed from the simulation.

Used with fadeDelay to determine the transparency of the projectile at a given time. A projectile may exist up to a maximum of 131040ms (or 4095 ticks) as defined by Projectile::MaxLivingTicks in the source code.

See also:
fadeDelay
LightDescription ProjectileData::lightDesc

LightDescription datablock used for lights attached to the projectile.

float ProjectileData::muzzleVelocity

Amount of velocity the projectile recieves from the "muzzle" of the gun.

Used with velInheritFactor to determine the initial velocity of the projectile. This value is never modified by the engine.

Note:
This value by default is not transmitted between the server and the client.
See also:
velInheritFactor
ParticleEmitterData ProjectileData::ParticleEmitter

Particle emitter datablock used to generate particles while the projectile is outside of water.

Note:
If datablocks are defined for both particleEmitter and particleWaterEmitter, both effects will play as the projectile enters or leaves water.
See also:
particleWaterEmitter
ParticleEmitterData ProjectileData::particleWaterEmitter

Particle emitter datablock used to generate particles while the projectile is submerged in water.

Note:
If datablocks are defined for both particleWaterEmitter and particleEmitter , both effects will play as the projectile enters or leaves water.
See also:
particleEmitter
filename ProjectileData::projectileShapeName

File path to the model of the projectile.

Point3F ProjectileData::scale

Scale to apply to the projectile's size.

Note:
This is applied after SceneObject::scale
SFXTrack ProjectileData::sound

SFXTrack datablock used to play sounds while in flight.

SplashData ProjectileData::Splash

Splash datablock used to create splash effects as the projectile enters or leaves water.

float ProjectileData::velInheritFactor

Amount of velocity the projectile recieves from the source that created it.

Use an amount between 0 and 1 for the best effect. This value is never modified by the engine.

Note:
This value by default is not transmitted between the server and the client.
ExplosionData ProjectileData::waterExplosion

Explosion datablock used when the projectile explodes underwater.


Torque 3D - Script Manual: PxCloth Class Reference

PxCloth Class Reference
[Physics]

Rectangular patch of cloth simulated by PhysX. More...

Inheritance diagram for PxCloth:
[legend]

List of all members.

Public Attributes

PxClothAttachment | attachments
Optional way to specify cloth verts that will be attached to the world position it is created at.
bool | bending
Enable/disable bending resistance. Select the bending resistance through bendingStiffness.
float | bendingStiffness
Bending stiffness of the cloth in the range 0 to 1.
bool | damping
Enable/disable damping of internal velocities.
float | dampingCoefficient
Spring damping of the cloth in the range 0 to 1.
float | density
Density of the cloth (Mass per Area).
float | friction
Friction coefficient in the range 0 to 1.
string | Material
Material name for rendering.
Point2I | samples
The number of cloth vertices in width and length.
bool | selfCollision
Enable/disable self-collision handling within a single piece of cloth.
Point2F | size
The dimensions of the cloth in width and height.
float | thickness
The thickness is usually a fraction of the overall extent of the cloth and should not be set to a value greater than that. A good value is the maximal distance between two adjacent cloth particles in their rest pose. Visual artifacts or collision problems may appear if the thickness is too small.
bool | triangleCollision
Not supported in current release (according to PhysX docs).Enable/disable collision detection of cloth triangles against the scene. If not set, only collisions of cloth particles are detected. If set, collisions of cloth triangles are detected as well.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Rectangular patch of cloth simulated by PhysX.

PxCloth is affected by other objects in the simulation but does not itself affect others, it is essentially a visual effect. Eg, shooting at cloth will disturb it but will not explode the projectile.

Be careful with the cloth size and resolution because it can easily become performance intensive to simulate. A single piece of cloth that is very large or high resolution is also much more expensive than multiple pieces that add up to the same number of verts.

Note that most field docs have been copied from their PhysX counterpart.

Member Data Documentation

PxClothAttachment PxCloth::attachments

Optional way to specify cloth verts that will be attached to the world position it is created at.

bool PxCloth::bending

Enable/disable bending resistance. Select the bending resistance through bendingStiffness.

float PxCloth::bendingStiffness

Bending stiffness of the cloth in the range 0 to 1.

bool PxCloth::damping

Enable/disable damping of internal velocities.

float PxCloth::dampingCoefficient

Spring damping of the cloth in the range 0 to 1.

float PxCloth::density

Density of the cloth (Mass per Area).

float PxCloth::friction

Friction coefficient in the range 0 to 1.

Defines the damping of the velocities of cloth particles that are in contact.

bool PxCloth::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool PxCloth::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

string PxCloth::Material

Material name for rendering.

Point2I PxCloth::samples

The number of cloth vertices in width and length.

bool PxCloth::selfCollision

Enable/disable self-collision handling within a single piece of cloth.

Point2F PxCloth::size

The dimensions of the cloth in width and height.

float PxCloth::thickness

The thickness is usually a fraction of the overall extent of the cloth and should not be set to a value greater than that. A good value is the maximal distance between two adjacent cloth particles in their rest pose. Visual artifacts or collision problems may appear if the thickness is too small.

bool PxCloth::triangleCollision

Not supported in current release (according to PhysX docs).Enable/disable collision detection of cloth triangles against the scene. If not set, only collisions of cloth particles are detected. If set, collisions of cloth triangles are detected as well.


Torque 3D - Script Manual: PxMaterial Class Reference

PxMaterial Class Reference
[Physics]

Defines a PhysX material assignable to PxMultiActorData. More...

Inheritance diagram for PxMaterial:
[legend]

List of all members.

Public Attributes

PxMaterial

float | dynamicFriction
float | restitution
float | staticFriction

Detailed Description

Defines a PhysX material assignable to PxMultiActorData.

Usually it is prefered to use PhysicsShape and not PxMultiActor because it is not PhysX specific and much easier to setup.

Member Data Documentation

float PxMaterial::dynamicFriction
float PxMaterial::restitution
float PxMaterial::staticFriction


Torque 3D - Script Manual: PxMultiActor Class Reference

PxMultiActor Class Reference
[Physics]

Represents a destructible physical object simulated using PhysX. More...

Inheritance diagram for PxMultiActor:
[legend]

List of all members.

Public Member Functions

void | listMeshes (enum Hidden/Shown/All)
void | setAllHidden (bool)
void | setBroken (bool)
void | setMeshHidden (string meshName, bool isHidden)

Public Attributes

Debug

bool | broken
bool | debugRender

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Represents a destructible physical object simulated using PhysX.

Usually it is prefered to use PhysicsShape and not PxMultiActor because it is not PhysX specific and much easier to setup.

See also:
PxMultiActorData.

Member Function Documentation

void PxMultiActor::listMeshes ( enum Hidden/Shown/ All )
void PxMultiActor::setAllHidden ( bool )
void PxMultiActor::setBroken ( bool )
void PxMultiActor::setMeshHidden | ( | string | meshName,
 |  | bool | isHidden
 | ) |  |

Member Data Documentation

bool PxMultiActor::broken
bool PxMultiActor::debugRender
bool PxMultiActor::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool PxMultiActor::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.


Torque 3D - Script Manual: PxMultiActorData Class Reference

PxMultiActorData Class Reference
[Physics]

Defines the properties of a type of PxMultiActor. More...

Inheritance diagram for PxMultiActorData:
[legend]

List of all members.

Public Attributes

float | breakForce
bool | clientOnly
void | dumpModel
void | reload
bool | singlePlayerOnly
Physics

float | angularDrag
float | buoyancyDensity
string | correctionNode0
string | correctionNode1
float | linearDrag
PxMaterial Material
string | mountNode0
string | mountNode1
string | mountNode10
string | mountNode11
string | mountNode12
string | mountNode13
string | mountNode14
string | mountNode15
string | mountNode16
string | mountNode17
string | mountNode18
string | mountNode19
string | mountNode2
string | mountNode20
string | mountNode21
string | mountNode22
string | mountNode23
string | mountNode24
string | mountNode25
string | mountNode26
string | mountNode27
string | mountNode28
string | mountNode29
string | mountNode3
string | mountNode30
string | mountNode31
string | mountNode4
string | mountNode5
string | mountNode6
string | mountNode7
string | mountNode8
string | mountNode9
bool | noCorrection
filename | physXStream
float | waterDragScale
Media

filename | shapeName

Detailed Description

Defines the properties of a type of PxMultiActor.

Usually it is prefered to use PhysicsShape and not PxMultiActor because it is not PhysX specific and much easier to setup.

Member Data Documentation

float PxMultiActorData::angularDrag
float PxMultiActorData::breakForce
float PxMultiActorData::buoyancyDensity
bool PxMultiActorData::clientOnly
string PxMultiActorData::correctionNode0
string PxMultiActorData::correctionNode1
void PxMultiActorData::dumpModel
float PxMultiActorData::linearDrag
PxMaterial PxMultiActorData::Material
string PxMultiActorData::mountNode0
string PxMultiActorData::mountNode1
string PxMultiActorData::mountNode10
string PxMultiActorData::mountNode11
string PxMultiActorData::mountNode12
string PxMultiActorData::mountNode13
string PxMultiActorData::mountNode14
string PxMultiActorData::mountNode15
string PxMultiActorData::mountNode16
string PxMultiActorData::mountNode17
string PxMultiActorData::mountNode18
string PxMultiActorData::mountNode19
string PxMultiActorData::mountNode2
string PxMultiActorData::mountNode20
string PxMultiActorData::mountNode21
string PxMultiActorData::mountNode22
string PxMultiActorData::mountNode23
string PxMultiActorData::mountNode24
string PxMultiActorData::mountNode25
string PxMultiActorData::mountNode26
string PxMultiActorData::mountNode27
string PxMultiActorData::mountNode28
string PxMultiActorData::mountNode29
string PxMultiActorData::mountNode3
string PxMultiActorData::mountNode30
string PxMultiActorData::mountNode31
string PxMultiActorData::mountNode4
string PxMultiActorData::mountNode5
string PxMultiActorData::mountNode6
string PxMultiActorData::mountNode7
string PxMultiActorData::mountNode8
string PxMultiActorData::mountNode9
bool PxMultiActorData::noCorrection
filename PxMultiActorData::physXStream
void PxMultiActorData::reload
filename PxMultiActorData::shapeName
bool PxMultiActorData::singlePlayerOnly
float PxMultiActorData::waterDragScale


Torque 3D - Script Manual: RadialImpulseEvent Class Reference

RadialImpulseEvent Class Reference
[Physics]

Creates a physics based impulse effect from a defined central point and magnitude. More...

List of all members.

Static Public Member Functions

static void send (string inPosition="1.0 1.0 1.0", float radius=10.0f, float magnitude=20.0f)
Apply a radial impulse to any SceneObjects in the area of effect.

Detailed Description

Creates a physics based impulse effect from a defined central point and magnitude.

See also:
RadialImpulseEvent::send

Member Function Documentation

static void RadialImpulseEvent::send | ( | string | inPosition = "1.0 1.0 1.0",
 |  | float | radius = 10.0f,
 |  | float | magnitude = 20.0f |
 | ) |  |  | [static]

Apply a radial impulse to any SceneObjects in the area of effect.

This event is performed server-side AND client-side.

Parameters:
position | Center point for this radial impulse.
radius | Distance from the position for this radial impulse to affect.
magnitude | The force applied to objects within the radius from the position of this radial impulse effect.
Example:
// Define the Position
%position = "10.0 15.0 10.0";

// Define the Radius
%radius = "25.0";

// Define the Magnitude
%magnitude = "30.0"

// Create a globalRadialImpulse physics effect.
RadialImpulseEvent::send(%position,%radius,%magnitude);


Torque 3D - Script Manual: ReflectorDesc Class Reference

ReflectorDesc Class Reference
[Miscellaneous]

A datablock which defines performance and quality properties for dynamic reflections. More...

Inheritance diagram for ReflectorDesc:
[legend]

List of all members.

Public Attributes

ReflectorDesc

float | detailAdjust
Scale applied to lod calculation of objects rendering into this reflection ( modulates $pref::TS::detailAdjust ).
float | farDist
Far plane distance to use when rendering reflections.
int | maxRateMs
If less than maxRateMs has elapsed since this relfection was last updated, then do not update it again. This 'skip' can be disabled by setting maxRateMs to zero.
float | nearDist
Near plane distance to use when rendering this reflection. Adjust this to limit self-occlusion artifacts.
int | objectTypeMask
Object types which render into this reflection.
float | priority
Priority for updating this reflection, relative to others.
int | texSize
Size in pixels of the (square) reflection texture. For a cubemap this value is interpreted as size of each face.
bool | useOcclusionQuery
If available on the device use HOQs to determine if the reflective object is visible before updating its reflection.

Detailed Description

A datablock which defines performance and quality properties for dynamic reflections.

ReflectorDesc is not itself a reflection and does not render reflections. It is a dummy class for holding and exposing to the user a set of reflection related properties. Objects which support dynamic reflections may then reference a ReflectorDesc.

Example:
datablock ReflectorDesc( ExampleReflectorDesc )
{
   texSize = 256;
   nearDist = 0.1;
   farDist = 500;
   objectTypeMask = 0xFFFFFFFF;
   detailAdjust = 1.0;
   priority = 1.0;
   maxRateMs = 0;
   useOcclusionQuery = true;
};
See also:
ShapeBaseData::cubeReflectorDesc

Member Data Documentation

float ReflectorDesc::detailAdjust

Scale applied to lod calculation of objects rendering into this reflection ( modulates $pref::TS::detailAdjust ).

float ReflectorDesc::farDist

Far plane distance to use when rendering reflections.

int ReflectorDesc::maxRateMs

If less than maxRateMs has elapsed since this relfection was last updated, then do not update it again. This 'skip' can be disabled by setting maxRateMs to zero.

float ReflectorDesc::nearDist

Near plane distance to use when rendering this reflection. Adjust this to limit self-occlusion artifacts.

int ReflectorDesc::objectTypeMask

Object types which render into this reflection.

float ReflectorDesc::priority

Priority for updating this reflection, relative to others.

int ReflectorDesc::texSize

Size in pixels of the (square) reflection texture. For a cubemap this value is interpreted as size of each face.

bool ReflectorDesc::useOcclusionQuery

If available on the device use HOQs to determine if the reflective object is visible before updating its reflection.


Torque 3D - Script Manual: RenderBinManager Class Reference

RenderBinManager Class Reference
[Render Binning]

The abstract base for all render bins. More...

Inheritance diagram for RenderBinManager:
[legend]

List of all members.

Public Member Functions

string | getBinType ()
Returns the bin type string.

Public Attributes

string | binType
Sets the render bin type which limits what render instances are added to this bin.
float | processAddOrder
Defines the order for adding instances in relation to other bins.
float | renderOrder
Defines the order for rendering in relation to other bins.

Detailed Description

The abstract base for all render bins.

The render bins are used by the engine as a high level method to order and batch rendering operations.

Member Function Documentation

string RenderBinManager::getBinType ( )

Returns the bin type string.

Member Data Documentation

string RenderBinManager::binType

Sets the render bin type which limits what render instances are added to this bin.

float RenderBinManager::processAddOrder

Defines the order for adding instances in relation to other bins.

float RenderBinManager::renderOrder

Defines the order for rendering in relation to other bins.


Torque 3D - Script Manual: RenderFormatToken Class Reference

RenderFormatToken Class Reference
[GFX]

Used to change the render target format when rendering in AL. More...

Inheritance diagram for RenderFormatToken:
[legend]

List of all members.

Public Attributes

int aaLevel
Anti-ailiasing level for the this token. 0 disables, -1 uses adapter default.
PostEffect copyEffect
This PostEffect will be run when the render target is changed to the format specified by this token. It is used to copy/format data into the token rendertarget.
GFXFormat depthFormat
Sets the depth/stencil buffer format for this token.
GFXFormat format
Sets the color buffer format for this token.
PostEffect resolveEffect
This PostEffect will be run when the render target is changed back to the format active prior to this token. It is used to copy/format data from the token rendertarget to the backbuffer.

Detailed Description

Used to change the render target format when rendering in AL.

RenderFormatToken is an implementation which changes the format of the back buffer and/or the depth buffer.

The RenderPassStateBin manager changes the rendering state associated with this token. In stock Torque 3D, a single example exists in the way of AL_FormatToken (found in renderManager.cs). In that script file, all the render managers are intialized, and a single RenderFormatToken is used. This implementation basically exists to ensure Advanced Lighting works with MSAA.

The actions for this token toggle the format of the back/depth buffers and it lets you specify a custom shader to "copy" the data so it can be reformatted or altered. This is done through the variables copyEffect and resolveEffect (which are post processes just like fog or glow)

Example:
// This token, and the associated render managers, ensure that driver MSAA does not get used for Advanced Lighting renders.
// The 'AL_FormatResolve' PostEffect copies the result to the backbuffer.
new RenderFormatToken(AL_FormatToken)
{
   enabled = "false";

   format = "GFXFormatR8G8B8A8";
   depthFormat = "GFXFormatD24S8";
   aaLevel = 0; // -1 = match backbuffer

   // The contents of the back buffer before this format token is executed
   // is provided in $inTex
   copyEffect = "AL_FormatCopy";

   // The contents of the render target created by this format token is
   // provided in $inTex
   resolveEffect = "AL_FormatCopy";
};
See also:
RenderPassToken
RenderPassStateBin
game/core/scripts/client/renderManager.cs

Member Data Documentation

int RenderFormatToken::aaLevel

Anti-ailiasing level for the this token. 0 disables, -1 uses adapter default.

PostEffect RenderFormatToken::copyEffect

This PostEffect will be run when the render target is changed to the format specified by this token. It is used to copy/format data into the token rendertarget.

GFXFormat RenderFormatToken::depthFormat

Sets the depth/stencil buffer format for this token.

GFXFormat RenderFormatToken::format

Sets the color buffer format for this token.

PostEffect RenderFormatToken::resolveEffect

This PostEffect will be run when the render target is changed back to the format active prior to this token. It is used to copy/format data from the token rendertarget to the backbuffer.


Torque 3D - Script Manual: RenderGlowMgr Class Reference

RenderGlowMgr Class Reference
[Render Binning]

A render bin for the glow pass. More...

Inheritance diagram for RenderGlowMgr:
[legend]

List of all members.

Detailed Description

A render bin for the glow pass.

When the glow buffer PostEffect is enabled this bin gathers mesh render instances with glow materials and renders them to the glowbuffer offscreen render target.

This render target is then used by the 'GlowPostFx' PostEffect to blur and render the glowing portions of the screen.


Torque 3D - Script Manual: RenderImposterMgr Class Reference

RenderImposterMgr Class Reference
[Render Binning]

A render bin for batch rendering imposters. More...

Inheritance diagram for RenderImposterMgr:
[legend]

List of all members.

Detailed Description

A render bin for batch rendering imposters.

This render bin gathers imposter render instances and renders them in large batches.

You can type 'metrics( imposter )' in the console to see rendering statistics.


Torque 3D - Script Manual: RenderMeshExample Class Reference

RenderMeshExample Class Reference
[Rendering]

An example scene object which renders a mesh. More...

Inheritance diagram for RenderMeshExample:
[legend]

List of all members.

Public Member Functions

void | postApply ()
A utility method for forcing a network update.

Public Attributes

Rendering

string | Material
The name of the material used to render the mesh.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An example scene object which renders a mesh.

This class implements a basic SceneObject that can exist in the world at a 3D position and render itself. There are several valid ways to render an object in Torque. This class implements the preferred rendering method which is to submit a MeshRenderInst along with a Material, vertex buffer, primitive buffer, and transform and allow the RenderMeshMgr handle the actual setup and rendering for you.

See the C++ code for implementation details.

Member Function Documentation

void RenderMeshExample::postApply ( )

A utility method for forcing a network update.

Member Data Documentation

bool RenderMeshExample::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool RenderMeshExample::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string RenderMeshExample::Material

The name of the material used to render the mesh.


Torque 3D - Script Manual: RenderMeshMgr Class Reference

RenderMeshMgr Class Reference
[Render Binning]

A render bin for mesh rendering. More...

Inheritance diagram for RenderMeshMgr:
[legend]

List of all members.

Detailed Description

A render bin for mesh rendering.

This is the primary render bin in Torque which does most of the work of rendering DTS shapes and arbitrary mesh geometry. It knows how to render mesh instances using materials and supports hardware mesh instancing.


Torque 3D - Script Manual: RenderObjectExample Class Reference

RenderObjectExample Class Reference
[Rendering]

An example scene object which renders using a callback. More...

Inheritance diagram for RenderObjectExample:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An example scene object which renders using a callback.

This class implements a basic SceneObject that can exist in the world at a 3D position and render itself. Note that RenderObjectExample handles its own rendering by submitting itself as an ObjectRenderInst (see renderInstance enderPassmanager.h) along with a delegate for its render() function. However, the preffered rendering method in the engine is to submit a MeshRenderInst along with a Material, vertex buffer, primitive buffer, and transform and allow the RenderMeshMgr handle the actual rendering. You can see this implemented in RenderMeshExample.

See the C++ code for implementation details.

Member Data Documentation

bool RenderObjectExample::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool RenderObjectExample::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.


Torque 3D - Script Manual: RenderObjectMgr Class Reference

RenderObjectMgr Class Reference
[Render Binning]

A render bin which uses object callbacks for rendering. More...

Inheritance diagram for RenderObjectMgr:
[legend]

List of all members.

Detailed Description

A render bin which uses object callbacks for rendering.

This render bin gathers object render instances and calls its delegate method to perform rendering. It is used infrequently for specialized scene objects which perform custom rendering.


Torque 3D - Script Manual: RenderOcclusionMgr Class Reference

RenderOcclusionMgr Class Reference
[Render Binning]

A render bin which renders occlusion query requests. More...

Inheritance diagram for RenderOcclusionMgr:
[legend]

List of all members.

Static Public Attributes

static bool debugRender
A debugging feature which renders the occlusion volumes to the scene.

Detailed Description

A render bin which renders occlusion query requests.

This render bin gathers occlusion query render instances and renders them. It is currently used by light flares and ShapeBase reflection cubemaps.

You can type '$RenderOcclusionMgr::debugRender = true' in the console to see debug rendering of the occlusion geometry.


Torque 3D - Script Manual: RenderParticleMgr Class Reference

RenderParticleMgr Class Reference
[Render Binning]

A render bin which renders particle geometry. More...

Inheritance diagram for RenderParticleMgr:
[legend]

List of all members.

Detailed Description

A render bin which renders particle geometry.

This render bin gathers particle render instances, sorts, and renders them. It is currently used by ParticleEmitter and LightFlareData.


Torque 3D - Script Manual: RenderPassManager Class Reference

RenderPassManager Class Reference
[Render Binning]

A grouping of render bin managers which forms a render pass. More...

Inheritance diagram for RenderPassManager:
[legend]

List of all members.

Public Member Functions

void | addManager (RenderBinManager renderBin)
Add as a render bin manager to the pass.
RenderBinManager | getManager (int index)
Returns the render bin manager at the index or null if the index is out of range.
int | getManagerCount ()
Returns the total number of bin managers.
void | removeManager (RenderBinManager renderBin)
Removes a render bin manager.

Detailed Description

A grouping of render bin managers which forms a render pass.

The render pass is used to order a set of RenderBinManager objects which are used when rendering a scene. This class does little work itself other than managing its list of render bins.

In 'core/scripts/client/renderManager.cs' you will find the DiffuseRenderPassManager which is used by the C++ engine to render the scene.

See also:
RenderBinManager

Member Function Documentation

void RenderPassManager::addManager ( RenderBinManager renderBin )

Add as a render bin manager to the pass.

RenderBinManager RenderPassManager::getManager ( int index )

Returns the render bin manager at the index or null if the index is out of range.

int RenderPassManager::getManagerCount ( )

Returns the total number of bin managers.

void RenderPassManager::removeManager ( RenderBinManager renderBin )

Removes a render bin manager.


Torque 3D - Script Manual: RenderPassStateBin Class Reference

RenderPassStateBin Class Reference
[Render Binning]

A non-rendering render bin used to enable/disable a RenderPassStateToken. More...

Inheritance diagram for RenderPassStateBin:
[legend]

List of all members.

Public Attributes

RenderPassStateToken stateToken

Detailed Description

A non-rendering render bin used to enable/disable a RenderPassStateToken.

This is a utility RenderBinManager which does not render any render instances. Its only used to define a point in the render bin order at which a RenderPassStateToken is triggered.

See also:
RenderPassStateToken

Member Data Documentation

RenderPassStateToken RenderPassStateBin::stateToken


Torque 3D - Script Manual: RenderPassStateToken Class Reference

RenderPassStateToken Class Reference
[Render Binning]

Abstract base class for RenderFormatToken, used to manipulate what goes on in the render manager. More...

Inheritance diagram for RenderPassStateToken:
[legend]

List of all members.

Public Member Functions

void | disable ()
Disables the token.
void | enable ()
Enables the token.
void | toggle ()
Toggles the token from enabled to disabled or vice versa.

Public Attributes

bool | enabled
Enables or disables this token.

Detailed Description

Abstract base class for RenderFormatToken, used to manipulate what goes on in the render manager.

You cannot actually instantiate RenderPassToken, only its child: RenderFormatToken. RenderFormatToken is an implementation which changes the format of the back buffer and/or the depth buffer.

The RenderPassStateBin manager changes the rendering state associated with a token it is declared with. In stock Torque 3D, a single example exists in the way of AL_FormatToken (found in renderManager.cs). In that script file, all the render managers are intialized, and a single RenderFormatToken is used. This implementation basically exists to ensure Advanced Lighting works with MSAA.

See also:
RenderFormatToken
RenderPassStateBin
game/core/scripts/client/renderManager.cs

Member Function Documentation

void RenderPassStateToken::disable ( )

Disables the token.

void RenderPassStateToken::enable ( )

Enables the token.

void RenderPassStateToken::toggle ( )

Toggles the token from enabled to disabled or vice versa.

Member Data Documentation

bool RenderPassStateToken::enabled

Enables or disables this token.


Torque 3D - Script Manual: RenderPrePassMgr Class Reference

RenderPrePassMgr Class Reference
[Render Binning]

The render bin which performs a z+normals prepass used in Advanced Lighting. More...

Inheritance diagram for RenderPrePassMgr:
[legend]

List of all members.

Detailed Description

The render bin which performs a z+normals prepass used in Advanced Lighting.

This render bin is used in Advanced Lighting to gather all opaque mesh render instances and render them to the g-buffer for use in lighting the scene and doing effects.

PostEffect and other shaders can access the output of this bin by using the prepass texture target name. See the edge anti-aliasing post effect for an example.

See also:
game/core/scripts/client/postFx/edgeAA.cs


Torque 3D - Script Manual: RenderShapeExample Class Reference

RenderShapeExample Class Reference
[Rendering]

An example scene object which renders a DTS. More...

Inheritance diagram for RenderShapeExample:
[legend]

List of all members.

Public Attributes

Rendering

filename | shapeFile
The path to the DTS shape file.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An example scene object which renders a DTS.

This class implements a basic SceneObject that can exist in the world at a 3D position and render itself. There are several valid ways to render an object in Torque. This class makes use of the 'TS' (three space) shape system. TS manages loading the various mesh formats supported by Torque as well was rendering those meshes (including LOD and animation...though this example doesn't include any animation over time).

See the C++ code for implementation details.

Member Data Documentation

bool RenderShapeExample::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool RenderShapeExample::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

filename RenderShapeExample::shapeFile

The path to the DTS shape file.


Torque 3D - Script Manual: RenderTerrainMgr Class Reference

RenderTerrainMgr Class Reference
[Render Binning]

A render bin for terrain mesh rendering. More...

Inheritance diagram for RenderTerrainMgr:
[legend]

List of all members.

Static Public Attributes

static bool renderWireframe
Used to enable wireframe rendering on terrain for debugging.

Detailed Description

A render bin for terrain mesh rendering.

This bin renders terrain render instances from a TerrainBlock. Normally a mesh would render via the RenderMeshMgr, but terrain uses a TerrainMaterial designed for multi-layered surfaces which this bin can processs.


Torque 3D - Script Manual: RenderTexTargetBinManager Class Reference

RenderTexTargetBinManager Class Reference
[Render Binning]

An abstract base class for render bin managers that render to a named textue target. More...

Inheritance diagram for RenderTexTargetBinManager:
[legend]

List of all members.

Detailed Description

An abstract base class for render bin managers that render to a named textue target.

This bin itself doesn't do any rendering work. It offers functionality to manage a texture render target which derived render bin classes can render into.

See also:
RenderPrePassMgr


Torque 3D - Script Manual: RenderTranslucentMgr Class Reference

RenderTranslucentMgr Class Reference
[Render Binning]

A render bin for rendering translucent meshes. More...

Inheritance diagram for RenderTranslucentMgr:
[legend]

List of all members.

Detailed Description

A render bin for rendering translucent meshes.

This bin is used to render translucent render mesh instances and render object instances. It is generally ordered late in the RenderPassManager after all opaque geometry bins.


Torque 3D - Script Manual: RigidShape Class Reference

RigidShape Class Reference
[Platform]

The RigidShape class implements rigid-body physics for DTS objects in the world. More...

Inheritance diagram for RigidShape:
[legend]

List of all members.

Public Member Functions

void | freezeSim (bool isFrozen)
Enables or disables the physics simulation on the RigidShape object.
void | reset ()
Clears physic forces from the shape and sets it at rest.
Callbacks

void | onEnterLiquid (string objId, string waterCoverage, string liquidType)
Called whenever this RigidShape object enters liquid.
void | onLeaveLiquid (string objId, string liquidType)
Called whenever the RigidShape object exits liquid.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

The RigidShape class implements rigid-body physics for DTS objects in the world.

"Rigid body physics" refers to a system whereby objects are assumed to have a finite size, equally distributed masses, and where deformations of the objects themselves are not accounted for. Uses the RigidShape class to control its physics.

Example:
   datablock RigidShapeData( BouncingBoulder )
   {
      category = "RigidShape";

      shapeFile = "~/data/shapes/boulder/boulder.dts";
      emap = true;

      // Rigid Body
      mass = 500;
      massCenter = "0 0 0";    // Center of mass for rigid body
      massBox = "0 0 0";         // Size of box used for moment of inertia,
                          // if zero it defaults to object bounding box
      drag = 0.2;                // Drag coefficient
      bodyFriction = 0.2;
      bodyRestitution = 0.1;
      minImpactSpeed = 5;        // Impacts over this invoke the script callback
      softImpactSpeed = 5;       // Play SoftImpact Sound
      hardImpactSpeed = 15;      // Play HardImpact Sound
      integration = 4;           // Physics integration: TickSec/Rate
      collisionTol = 0.1;        // Collision distance tolerance
      contactTol = 0.1;          // Contact velocity tolerance

      minRollSpeed = 10;

      maxDrag = 0.5;
      minDrag = 0.01;

      dustHeight = 10;

      dragForce = 0.05;
      vertFactor = 0.05;
   };

 new RigidShape()
   {
      dataBlock = "BouncingBoulder";
      parentGroup = EWCreatorWindow.objectGroup;
   };
See also:
RigidShapeData
ShapeBase

Member Function Documentation

void RigidShape::freezeSim ( bool isFrozen )

Enables or disables the physics simulation on the RigidShape object.

Parameters:
isFrozen Boolean frozen state to set the object.
Example:
// Define the frozen state.
%isFrozen = "true";

// Inform the object of the defined frozen state
%thisRigidShape.freezeSim(%isFrozen);
See also:
ShapeBaseData
void RigidShape::onEnterLiquid | ( | string | objId,
 |  | string | waterCoverage,
 |  | string | liquidType
 | ) |  |

Called whenever this RigidShape object enters liquid.

Parameters:
objId | The ID of the rigidShape object.
waterCoverage | Amount of water coverage the RigidShape has.
liquidType | Type of liquid that was entered.
Example:
// The RigidShape object falls in a body of liquid, causing the callback to occur.
RigidShape::onEnterLiquid(%this,%objId,%waterCoverage,%liquidType)
   {
      // Code to run whenever this callback occurs.
   }
See also:
ShapeBase
void RigidShape::onLeaveLiquid | ( | string | objId,
 |  | string | liquidType
 | ) |  |

Called whenever the RigidShape object exits liquid.

Parameters:
objId | The ID of the RigidShape object.
liquidType | Type if liquid that was exited.
Example:
// The RigidShape object exits in a body of liquid, causing the callback to occur.
RigidShape::onLeaveLiquid(%this,%objId,%liquidType)
   {
      // Code to run whenever this callback occurs.
   }
See also:
ShapeBase
void RigidShape::reset ( )

Clears physic forces from the shape and sets it at rest.

Example:
// Inform the RigidShape object to reset.
%thisRigidShape.reset();
See also:
ShapeBaseData

Member Data Documentation

bool RigidShape::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

bool RigidShape::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.


Torque 3D - Script Manual: RigidShapeData Class Reference

RigidShapeData Class Reference
[Platform]

Defines the physics properties for an individual RigidShapeData physics object. More...

Inheritance diagram for RigidShapeData:
[legend]

List of all members.

Public Attributes

float | bodyFriction
How much friction this object has. Lower values will cause the object to appear to be more slippery.
float | bodyRestitution
The percentage of kinetic energy kept by this object in a collision.
float | collisionTol
Collision distance tolerance.
float | contactTol
Contact velocity tolerance.
float | hardImpactSpeed
Minimum speed at which the object must be travelling for the hard impact sound to be played.
int | integration
Number of physics steps to process per tick.
Point3F | massBox
Size of inertial box.
Point3F | massCenter
Center of mass for rigid body.
float | maxDrag
Maximum drag available to this object.
float | minDrag
Minimum drag available to this object.
float | minImpactSpeed
Minimum collision speed to classify collision as impact (triggers onImpact on server object).
float | minRollSpeed
float | softImpactSpeed
Minimum speed at which this object must be travelling for the soft impact sound to be played.
Camera

The settings used by the shape when it is the camera.

float | cameraDecay
Scalar rate at which the third person camera offset decays, per tick.
float | cameraLag
Scalar amount by which the third person camera lags the object, relative to the object's linear velocity.
float | cameraOffset
The vertical offset of the object's camera.
bool | cameraRoll
Specifies whether the camera's rotation matrix, and the render eye transform are multiplied during camera updates.
Forces

float | dragForce
Used to simulate the constant drag acting on the object.
float | vertFactor
The scalar applied to the vertical portion of the velocity drag acting on a object.
Particle Effects

ParticleEmitterData dustEmitter
Array of pointers to ParticleEmitterData datablocks which will be used to emit particles at object/terrain contact point.
float | dustHeight
Height of dust effects.
ParticleEmitterData dustTrailEmitter
Particle emitter used to create a dust trail for the moving object.
ParticleEmitterData | splashEmitter [2]
Array of pointers to ParticleEmitterData datablocks which will generate splash effects.
float | splashFreqMod
The simulated frequency modulation of a splash generated by this object. Multiplied along with speed and time elapsed when determining splash emition rate.
float | splashVelEpsilon
The threshold speed at which we consider the object's movement to have stopped when updating splash effects.
float | triggerDustHeight
Maximum height from the ground at which the object will generate dust.
Sounds

SFXTrack exitingWater
The AudioProfile will be used to produce sounds when emerging from water.
float | exitSplashSoundVelocity
The minimum velocity at which the exit splash sound will be played when emerging from water.
SFXTrack hardImpactSound
Sound to play when body impacts with at least hardImpactSpeed.
float | hardSplashSoundVelocity
The minimum velocity at which the hard splash sound will be played when impacting water.
SFXTrack impactWaterEasy
The AudioProfile will be used to produce sounds when a soft impact with water occurs.
SFXTrack impactWaterHard
The AudioProfile will be used to produce sounds when a hard impact with water occurs.
SFXTrack impactWaterMedium
The AudioProfile will be used to produce sounds when a medium impact with water occurs.
float | mediumSplashSoundVelocity
The minimum velocity at which the medium splash sound will be played when impacting water.
SFXTrack softImpactSound
Sound to play when body impacts with at least softImageSpeed but less than hardImpactSpeed.
float | softSplashSoundVelocity
The minimum velocity at which the soft splash sound will be played when impacting water.
SFXTrack waterWakeSound
The AudioProfile will be used to produce sounds when a water wake is displayed.

Detailed Description

Defines the physics properties for an individual RigidShapeData physics object.

Example:
   datablock RigidShapeData( BouncingBoulder )
   {
      category = "RigidShape";

      shapeFile = "~/data/shapes/boulder/boulder.dts";
      emap = true;

      // Rigid Body
      mass = 500;
      massCenter = "0 0 0";    // Center of mass for rigid body
      massBox = "0 0 0";         // Size of box used for moment of inertia,
                          // if zero it defaults to object bounding box
      drag = 0.2;                // Drag coefficient
      bodyFriction = 0.2;
      bodyRestitution = 0.1;
      minImpactSpeed = 5;        // Impacts over this invoke the script callback
      softImpactSpeed = 5;       // Play SoftImpact Sound
      hardImpactSpeed = 15;      // Play HardImpact Sound
      integration = 4;           // Physics integration: TickSec/Rate
      collisionTol = 0.1;        // Collision distance tolerance
      contactTol = 0.1;          // Contact velocity tolerance

      minRollSpeed = 10;

      maxDrag = 0.5;
      minDrag = 0.01;

      dustHeight = 10;

      dragForce = 0.05;
      vertFactor = 0.05;
   };
See also:
RigidShape
ShapeBase

Member Data Documentation

float RigidShapeData::bodyFriction

How much friction this object has. Lower values will cause the object to appear to be more slippery.

float RigidShapeData::bodyRestitution

The percentage of kinetic energy kept by this object in a collision.

float RigidShapeData::cameraDecay

Scalar rate at which the third person camera offset decays, per tick.

float RigidShapeData::cameraLag

Scalar amount by which the third person camera lags the object, relative to the object's linear velocity.

float RigidShapeData::cameraOffset

The vertical offset of the object's camera.

bool RigidShapeData::cameraRoll

Specifies whether the camera's rotation matrix, and the render eye transform are multiplied during camera updates.

float RigidShapeData::collisionTol

Collision distance tolerance.

float RigidShapeData::contactTol

Contact velocity tolerance.

float RigidShapeData::dragForce

Used to simulate the constant drag acting on the object.

ParticleEmitterData RigidShapeData::dustEmitter

Array of pointers to ParticleEmitterData datablocks which will be used to emit particles at object/terrain contact point.

float RigidShapeData::dustHeight

Height of dust effects.

ParticleEmitterData RigidShapeData::dustTrailEmitter

Particle emitter used to create a dust trail for the moving object.

SFXTrack RigidShapeData::exitingWater

The AudioProfile will be used to produce sounds when emerging from water.

float RigidShapeData::exitSplashSoundVelocity

The minimum velocity at which the exit splash sound will be played when emerging from water.

SFXTrack RigidShapeData::hardImpactSound

Sound to play when body impacts with at least hardImpactSpeed.

float RigidShapeData::hardImpactSpeed

Minimum speed at which the object must be travelling for the hard impact sound to be played.

float RigidShapeData::hardSplashSoundVelocity

The minimum velocity at which the hard splash sound will be played when impacting water.

SFXTrack RigidShapeData::impactWaterEasy

The AudioProfile will be used to produce sounds when a soft impact with water occurs.

SFXTrack RigidShapeData::impactWaterHard

The AudioProfile will be used to produce sounds when a hard impact with water occurs.

SFXTrack RigidShapeData::impactWaterMedium

The AudioProfile will be used to produce sounds when a medium impact with water occurs.

int RigidShapeData::integration

Number of physics steps to process per tick.

Point3F RigidShapeData::massBox

Size of inertial box.

Point3F RigidShapeData::massCenter

Center of mass for rigid body.

float RigidShapeData::maxDrag

Maximum drag available to this object.

float RigidShapeData::mediumSplashSoundVelocity

The minimum velocity at which the medium splash sound will be played when impacting water.

float RigidShapeData::minDrag

Minimum drag available to this object.

float RigidShapeData::minImpactSpeed

Minimum collision speed to classify collision as impact (triggers onImpact on server object).

float RigidShapeData::minRollSpeed
SFXTrack RigidShapeData::softImpactSound

Sound to play when body impacts with at least softImageSpeed but less than hardImpactSpeed.

float RigidShapeData::softImpactSpeed

Minimum speed at which this object must be travelling for the soft impact sound to be played.

float RigidShapeData::softSplashSoundVelocity

The minimum velocity at which the soft splash sound will be played when impacting water.

ParticleEmitterData RigidShapeData::splashEmitter[2]

Array of pointers to ParticleEmitterData datablocks which will generate splash effects.

float RigidShapeData::splashFreqMod

The simulated frequency modulation of a splash generated by this object. Multiplied along with speed and time elapsed when determining splash emition rate.

float RigidShapeData::splashVelEpsilon

The threshold speed at which we consider the object's movement to have stopped when updating splash effects.

float RigidShapeData::triggerDustHeight

Maximum height from the ground at which the object will generate dust.

float RigidShapeData::vertFactor

The scalar applied to the vertical portion of the velocity drag acting on a object.

SFXTrack RigidShapeData::waterWakeSound

The AudioProfile will be used to produce sounds when a water wake is displayed.


Torque 3D - Script Manual: River Class Reference

River Class Reference
[Water]

A water volume defined by a 3D spline. More...

Inheritance diagram for River:
[legend]

List of all members.

Public Member Functions

void | regenerate ()
Intended as a helper to developers and editor scripts.
void | setBatchSize (float meters)
Intended as a helper to developers and editor scripts.
void | setMaxDivisionSize (float meters)
Intended as a helper to developers and editor scripts.
void | setMetersPerSegment (float meters)
Intended as a helper to developers and editor scripts.
void | setNodeDepth (int idx, float meters)
Intended as a helper to developers and editor scripts.

Public Attributes

River

float | FlowMagnitude
Magnitude of the force vector applied to dynamic objects within the River.
float | LowLODDistance
Segments of the river at this distance in meters or greater will render as a single unsubdivided without undulation effects.
float | SegmentLength
Divide the River lengthwise into segments of this length in meters. These geometric volumes are used for spacial queries like determining containment.
float | SubdivideLength
For purposes of generating the renderable geometry River segments are further subdivided such that no quad is of greater width or length than this distance in meters.
Internal

string | Node
For internal use, do not modify.

Static Public Attributes

static bool | EditorOpen
For editor use.
static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static bool | showNodes
For editor use.
static bool | showRiver
For editor use.
static bool | showSpline
For editor use.
static bool | showWalls
For editor use.
static bool | showWireframe
For editor use.

Detailed Description

A water volume defined by a 3D spline.

User may control width and depth per node and overall spline shape in three dimensions.

River supports dynamic planar reflections (fullReflect) like all WaterObject classes, but keep in mind it is not necessarily a planar surface. For best visual quality a River should be less reflective the more it twists and bends. This caution only applies to Rivers with fullReflect on.

See also:
WaterObject for inherited functionality.

Member Function Documentation

void River::regenerate ( )

Intended as a helper to developers and editor scripts.

Force River to recreate its geometry.

void River::setBatchSize ( float meters )

Intended as a helper to developers and editor scripts.

BatchSize is not currently used.

void River::setMaxDivisionSize ( float meters )

Intended as a helper to developers and editor scripts.

See also:
SubdivideLength field.
void River::setMetersPerSegment ( float meters )

Intended as a helper to developers and editor scripts.

See also:
SegmentLength field.
void River::setNodeDepth | ( | int | idx,
 |  | float | meters
 | ) |  |

Intended as a helper to developers and editor scripts.

Sets the depth in meters of a particular node.

Member Data Documentation

bool River::EditorOpen [static]

For editor use.

float River::FlowMagnitude

Magnitude of the force vector applied to dynamic objects within the River.

bool River::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from WaterObject.

bool River::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from WaterObject.

float River::LowLODDistance

Segments of the river at this distance in meters or greater will render as a single unsubdivided without undulation effects.

string River::Node

For internal use, do not modify.

float River::SegmentLength

Divide the River lengthwise into segments of this length in meters. These geometric volumes are used for spacial queries like determining containment.

bool River::showNodes [static]

For editor use.

bool River::showRiver [static]

For editor use.

bool River::showSpline [static]

For editor use.

bool River::showWalls [static]

For editor use.

bool River::showWireframe [static]

For editor use.

float River::SubdivideLength

For purposes of generating the renderable geometry River segments are further subdivided such that no quad is of greater width or length than this distance in meters.


Torque 3D - Script Manual: SaveFileDialog Class Reference

SaveFileDialog Class Reference
[File I/O]

Derived from FileDialog, this class is responsible for opening a file browser with the intention of saving a file. More...

Inheritance diagram for SaveFileDialog:
[legend]

List of all members.

Public Attributes

bool OverwritePrompt
True/False whether the dialog should prompt before accepting an existing file name.

Detailed Description

Derived from FileDialog, this class is responsible for opening a file browser with the intention of saving a file.

The core usage of this dialog is to locate a file in the OS and return the path and name. This does not handle the actual file writing or data manipulation. That functionality is left up to the FileObject class.

Example:
 // Create a dialog dedicated to opening file
 %saveFileDlg = new SaveFileDialog()
 {
    // Only allow for saving of COLLADA files
    Filters        = "COLLADA Files (*.dae)|*.dae|";

    // Default save path to where the WorldEditor last saved
    DefaultPath    = $pref::WorldEditor::LastPath;

    // No default file specified
    DefaultFile    = "";

    // Do not allow the user to change to a new directory
    ChangePath     = false;

    // Prompt the user if they are going to overwrite an existing file
    OverwritePrompt   = true;
 };

 // Launch the save file dialog
 %saveFileDlg.Execute();

 if ( %result )
 {
    %seletedFile = %openFileDlg.file;
 }
 else
 {
    %selectedFile = "";
 }

 // Cleanup
 %saveFileDlg.delete();
Note:
FileDialog and its related classes are only availble in a Tools build of Torque.
See also:
FileDialog
OpenFileDialog
FileObject

Member Data Documentation

bool SaveFileDialog::OverwritePrompt

True/False whether the dialog should prompt before accepting an existing file name.


Torque 3D - Script Manual: ScatterSky Class Reference

ScatterSky Class Reference
[Atmosphere]

Represents both the sun and sky for scenes with a dynamic time of day. More...

Inheritance diagram for ScatterSky:
[legend]

List of all members.

Public Member Functions

void | applyChanges ()
Apply a full network update of all fields to all clients.

Public Attributes

ScatterSky

Only azimuth and elevation are networked fields. To trigger a full update of all other fields use the applyChanges ConsoleMethod.

ColorF | ambientScale
Modulates the ambient color of sunlight.
float | exposure
Controls the contrast of the sky and sun during daytime.
ColorF | fogScale
Modulates the fog color. Note that this overrides the LevelInfo.fogColor property, so you should not use LevelInfo.fogColor if the level contains a ScatterSky object.
float | mieScattering
Affects the size and intensity of light scattering around the sun.
float | rayleighScattering
Controls how blue the atmosphere is during the day.
float | skyBrightness
Global brightness and intensity applied to the sky and objects in the level.
ColorF | sunScale
Modulates the directional color of sunlight.
Advanced Lighting

Point3F | attenuationRatio
The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.
filename | cookie
A custom pattern texture which is projected from the light.
float | fadeStartDistance
Start fading shadows out at this distance. 0 = auto calculate this distance.
bool | lastSplitTerrainOnly
This toggles only terrain being rendered to the last split of a PSSM shadow map.
float | logWeight
The logrithmic PSSM split distance factor.
int | numSplits
The logrithmic PSSM split distance factor.
Point4F | overDarkFactor
The ESM shadow darkening factor.
float | shadowDistance
The distance from the camera to extend the PSSM shadow.
float | shadowSoftness
ShadowType shadowType
The type of shadow to use on this light.
int | texSize
The texture size of the shadow map.
Orbit

float | azimuth
The horizontal angle of the sun measured clockwise from the positive Y world axis. This field is networked.
float | elevation
The elevation angle of the sun above or below the horizon. This field is networked.
float | moonAzimuth
The horizontal angle of the moon measured clockwise from the positive Y world axis. This is not animated by time or networked.
float | moonElevation
The elevation angle of the moon above or below the horizon. This is not animated by time or networked.
Lighting

float | brightness
The brightness of the ScatterSky's light object.
bool | castShadows
Enables/disables shadows cast by objects due to ScatterSky light.
Misc

float | flareScale
Changes the size and intensity of the flare.
LightFlareData flareType
Datablock for the flare produced by the ScatterSky.
Advanced Lighting Lightmap

bool | includeLightmappedGeometryInShadow
This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).
bool | representedInLightmap
This light is represented in lightmaps (static light, default: false).
ColorF | shadowDarkenColor
The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).
Night

bool | moonEnabled
Enable or disable rendering of the moon sprite during night.
ColorF | moonLightColor
Color of light cast by the directional light during night.
string | moonMat
Material for the moon sprite.
float | moonScale
Controls size the moon sprite renders, specified as a fractional amount of the screen height.
ColorF | nightColor
The ambient color during night. Also used for the sky color if useNightCubemap is false.
string | nightCubemap
Cubemap visible during night.
ColorF | nightFogColor
The fog color during night.
bool | useNightCubemap
Transition to the nightCubemap during night. If false we use nightColor.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Represents both the sun and sky for scenes with a dynamic time of day.

ScatterSky renders as a dome shaped mesh which is camera relative and always overhead. It is intended to be part of the background of your scene and renders before all other objects types.

ScatterSky is designed for outdoor scenes which need to transition fluidly between radically different times of day. It will respond to time changes originating from a TimeOfDay object or the elevation field can be directly adjusted.

During day, ScatterSky uses atmosphereic sunlight scattering aproximations to generate a sky gradient and sun corona. It also calculates the fog color, ambient color, and sun color, which are used for scene lighting. This is user controlled by fields within the ScatterSky group.

During night, ScatterSky supports can transition to a night sky cubemap and moon sprite. The user can control this and night time colors used for scene lighting with fields within the Night group.

A scene with a ScatterSky should not have any other sky or sun objects as it already fulfills both roles.

ScatterSky is intended to be used with CloudLayer and TimeOfDay as part of a scene with dynamic lighting. Having a ScatterSky without a changing time of day would unnecessarily give up artistic control compared and fillrate compared to a SkyBox + Sun setup.

Member Function Documentation

void ScatterSky::applyChanges ( )

Apply a full network update of all fields to all clients.

Member Data Documentation

ColorF ScatterSky::ambientScale

Modulates the ambient color of sunlight.

Point3F ScatterSky::attenuationRatio

The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.

float ScatterSky::azimuth

The horizontal angle of the sun measured clockwise from the positive Y world axis. This field is networked.

float ScatterSky::brightness

The brightness of the ScatterSky's light object.

bool ScatterSky::castShadows

Enables/disables shadows cast by objects due to ScatterSky light.

filename ScatterSky::cookie

A custom pattern texture which is projected from the light.

float ScatterSky::elevation

The elevation angle of the sun above or below the horizon. This field is networked.

float ScatterSky::exposure

Controls the contrast of the sky and sun during daytime.

float ScatterSky::fadeStartDistance

Start fading shadows out at this distance. 0 = auto calculate this distance.

float ScatterSky::flareScale

Changes the size and intensity of the flare.

LightFlareData ScatterSky::flareType

Datablock for the flare produced by the ScatterSky.

ColorF ScatterSky::fogScale

Modulates the fog color. Note that this overrides the LevelInfo.fogColor property, so you should not use LevelInfo.fogColor if the level contains a ScatterSky object.

bool ScatterSky::includeLightmappedGeometryInShadow

This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).

bool ScatterSky::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool ScatterSky::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool ScatterSky::lastSplitTerrainOnly

This toggles only terrain being rendered to the last split of a PSSM shadow map.

float ScatterSky::logWeight

The logrithmic PSSM split distance factor.

float ScatterSky::mieScattering

Affects the size and intensity of light scattering around the sun.

float ScatterSky::moonAzimuth

The horizontal angle of the moon measured clockwise from the positive Y world axis. This is not animated by time or networked.

float ScatterSky::moonElevation

The elevation angle of the moon above or below the horizon. This is not animated by time or networked.

bool ScatterSky::moonEnabled

Enable or disable rendering of the moon sprite during night.

ColorF ScatterSky::moonLightColor

Color of light cast by the directional light during night.

string ScatterSky::moonMat

Material for the moon sprite.

float ScatterSky::moonScale

Controls size the moon sprite renders, specified as a fractional amount of the screen height.

ColorF ScatterSky::nightColor

The ambient color during night. Also used for the sky color if useNightCubemap is false.

string ScatterSky::nightCubemap

Cubemap visible during night.

ColorF ScatterSky::nightFogColor

The fog color during night.

int ScatterSky::numSplits

The logrithmic PSSM split distance factor.

Point4F ScatterSky::overDarkFactor

The ESM shadow darkening factor.

float ScatterSky::rayleighScattering

Controls how blue the atmosphere is during the day.

bool ScatterSky::representedInLightmap

This light is represented in lightmaps (static light, default: false).

ColorF ScatterSky::shadowDarkenColor

The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).

float ScatterSky::shadowDistance

The distance from the camera to extend the PSSM shadow.

float ScatterSky::shadowSoftness
ShadowType ScatterSky::shadowType

The type of shadow to use on this light.

float ScatterSky::skyBrightness

Global brightness and intensity applied to the sky and objects in the level.

ColorF ScatterSky::sunScale

Modulates the directional color of sunlight.

int ScatterSky::texSize

The texture size of the shadow map.

bool ScatterSky::useNightCubemap

Transition to the nightCubemap during night. If false we use nightColor.


Torque 3D - Script Manual: SceneObject Class Reference

SceneObject Class Reference
[Game Objects]

A networkable object that exists in the 3D world. More...

Inheritance diagram for SceneObject:
[legend]

List of all members.

Public Member Functions

Point3F | getEulerRotation ()
Get Euler rotation of this object.
VectorF | getForwardVector ()
Get the direction this object is facing.
int | getMountedObject (int slot)
Get the object mounted at a particular slot.
int | getMountedObjectCount ()
Get the number of objects mounted to us.
int | getMountedObjectNode (int slot)
Get the mount node index of the object mounted at our given slot.
int | getMountNodeObject (int node)
Get the object mounted at our given node index.
Box3F | getObjectBox ()
Get the object's bounding box (relative to the object's origin).
int | getObjectMount ()
Get the object we are mounted to.
Point3F | getPosition ()
Get the object's world position.
VectorF | getRightVector ()
Get the right vector of the object.
Point3F | getScale ()
Get the object's scale.
TransformF | getTransform ()
Get the object's transform.
int | getType ()
Return the type mask for this object.
VectorF | getUpVector ()
Get the up vector of the object.
Box3F | getWorldBox ()
Get the object's world bounding box.
Point3F | getWorldBoxCenter ()
Get the center of the object's world bounding box.
bool | isGlobalBounds ()
Check if this object has a global bounds set.
bool | isMounted ()
Check if we are mounted to another object.
bool | mountObject (SceneObject objB, int slot, TransformF txfm=MatrixF::Identity)
Mount objB to this object at the desired slot with optional transform.
void | setScale (Point3F scale)
Set the object's scale.
void | setTransform (TransformF txfm)
Set the object's transform (orientation and position).
void | unmount ()
Unmount us from the currently mounted object if any.
bool | unmountObject (SceneObject target)
Unmount an object from ourselves.

Public Attributes

Editing

bool | isRenderEnabled
Controls client-side rendering of the object.
bool | isSelectionEnabled
Determines if the object may be selected from wihin the Tools.
Mounting

int | mountNode
Node we are mounted to.
pid | mountPID
PersistentID of object we are mounted to.
MatrixPosition | mountPos
Position we are mounted at ( object space of our mount object ).
MatrixRotation | mountRot
Rotation we are mounted at ( object space of our mount object ).
Transform

MatrixPosition | position
Object world position.
MatrixRotation | rotation
Object world orientation.
Point3F | scale
Object world scale.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A networkable object that exists in the 3D world.

The SceneObject class provides the foundation for 3D objects in the Engine. It exposes the functionality for:

  • Position, rotation and scale within the world.
  • Working with a scene graph (in the Zone and Portal sections), allowing efficient and robust rendering of the game scene.
  • Various helper functions, including functions to get bounding information and momentum/velocity.
  • Mounting one SceneObject to another.
  • An interface for collision detection, as well as ray casting.
  • Lighting. SceneObjects can register lights both at lightmap generation time, and dynamic lights at runtime (for special effects, such as from flame or a projectile, or from an explosion).

You do not typically work with SceneObjects themselves. The SceneObject provides a reference within the game world (the scene), but does not render to the client on its own. The same is true of collision detection beyond that of the bounding box. Instead you use one of the many classes that derrive from SceneObject, such as TSStatic.

Difference Between setHidden() and isRenderEnabled

When it comes time to decide if a SceneObject should render or not, there are two methods that can stop the SceneObject from rendering at all. You need to be aware of the differences between these two methods as they impact how the SceneObject is networked from the server to the client.

The first method of manually controlling if a SceneObject is rendered is through its SceneObject::isRenderEnabled property. When set to false the SceneObject is considered invisible but still present within the scene. This means it still takes part in collisions and continues to be networked.

The second method is using the setHidden() method. This will actually remove a SceneObject from the scene and it will no longer be networked from the server to the cleint. Any client-side ghost of the object will be deleted as the server no longer considers the object to be in scope.

Member Function Documentation

Point3F SceneObject::getEulerRotation ( )

Get Euler rotation of this object.

Returns:
the orientation of the object in the form of rotations around the X, Y and Z axes in degrees.
VectorF SceneObject::getForwardVector ( )

Get the direction this object is facing.

Returns:
a vector indicating the direction this object is facing.
Note:
This is the object's y axis.
int SceneObject::getMountedObject ( int slot )

Get the object mounted at a particular slot.

Parameters:
slot mount slot index to query
Returns:
ID of the object mounted in the slot, or 0 if no object.
int SceneObject::getMountedObjectCount ( )

Get the number of objects mounted to us.

Returns:
the number of mounted objects.
int SceneObject::getMountedObjectNode ( int slot )

Get the mount node index of the object mounted at our given slot.

Parameters:
slot mount slot index to query
Returns:
index of the mount node used by the object mounted in this slot.
int SceneObject::getMountNodeObject ( int node )

Get the object mounted at our given node index.

Parameters:
node mount node index to query
Returns:
ID of the first object mounted at the node, or 0 if none found.
Box3F SceneObject::getObjectBox ( )

Get the object's bounding box (relative to the object's origin).

Returns:
six fields, two Point3Fs, containing the min and max points of the objectbox.
int SceneObject::getObjectMount ( )

Get the object we are mounted to.

Returns:
the SimObjectID of the object we're mounted to, or 0 if not mounted.
Point3F SceneObject::getPosition ( )

Get the object's world position.

Returns:
the current world position of the object

Reimplemented in Camera.

VectorF SceneObject::getRightVector ( )

Get the right vector of the object.

Returns:
a vector indicating the right direction of this object.
Note:
This is the object's x axis.
Point3F SceneObject::getScale ( )

Get the object's scale.

Returns:
object scale as a Point3F
TransformF SceneObject::getTransform ( )

Get the object's transform.

Returns:
the current transform of the object
int SceneObject::getType ( )

Return the type mask for this object.

Returns:
The numeric type mask for the object.
VectorF SceneObject::getUpVector ( )

Get the up vector of the object.

Returns:
a vector indicating the up direction of this object.
Note:
This is the object's z axis.
Box3F SceneObject::getWorldBox ( )

Get the object's world bounding box.

Returns:
six fields, two Point3Fs, containing the min and max points of the worldbox.
Point3F SceneObject::getWorldBoxCenter ( )

Get the center of the object's world bounding box.

Returns:
the center of the world bounding box for this object.
bool SceneObject::isGlobalBounds ( )

Check if this object has a global bounds set.

If global bounds are set to be true, then the object is assumed to have an infinitely large bounding box for collision and rendering purposes.

Returns:
true if the object has a global bounds.
bool SceneObject::isMounted ( )

Check if we are mounted to another object.

Returns:
true if mounted to another object, false if not mounted.
bool SceneObject::mountObject | ( | SceneObject | objB,
 |  | int | slot,
 |  | TransformF | txfm = MatrixF::Identity
 | ) |  |

Mount objB to this object at the desired slot with optional transform.

Parameters:
objB | Object to mount onto us
slot | Mount slot ID
txfm | (optional) mount offset transform
Returns:
true if successful, false if failed (objB is not valid)
void SceneObject::setScale ( Point3F scale )

Set the object's scale.

Parameters:
scale object scale to set
void SceneObject::setTransform ( TransformF txfm )

Set the object's transform (orientation and position).

Parameters:
txfm object transform to set
void SceneObject::unmount ( )

Unmount us from the currently mounted object if any.

bool SceneObject::unmountObject ( SceneObject target )

Unmount an object from ourselves.

Parameters:
target object to unmount
Returns:
true if successful, false if failed

Member Data Documentation

bool SceneObject::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented in ConvexShape, GameBase, ShapeBase, MissionMarker, WayPoint, OcclusionVolume, LightBase, PointLight, StaticShape, SpotLight, DecalManager, RenderObjectExample, RenderShapeExample, Explosion, fxFoliageReplicator, fxShapeReplicator, fxShapeReplicatedStatic, GroundCover, ParticleEmitter, Splash, PhysicsDebris, PxCloth, SFXSpace, Vehicle, HoverVehicle, BasicClouds, CloudLayer, WaterObject, WaterBlock, WaterPlane, Marker, Player, AIPlayer, Camera, Debris, GroundPlane, Item, SpawnSphere, PathCamera, PhysicalZone, Zone, Portal, Prefab, Projectile, RigidShape, Trigger, TSStatic, RenderMeshExample, Lightning, ParticleEmitterNode, Precipitation, PhysicsForce, PhysicsShape, PxMultiActor, SFXEmitter, FlyingVehicle, WheeledVehicle, DecalRoad, MeshRoad, River, ScatterSky, SkyBox, Sun, TimeOfDay, Forest, ForestWindEmitter, InteriorInstance, and TerrainBlock.

bool SceneObject::isRenderEnabled

Controls client-side rendering of the object.

See also:
isRenderable()
bool SceneObject::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented in ConvexShape, GameBase, ShapeBase, MissionMarker, WayPoint, OcclusionVolume, LightBase, PointLight, StaticShape, SpotLight, DecalManager, RenderObjectExample, RenderShapeExample, Explosion, fxFoliageReplicator, fxShapeReplicator, fxShapeReplicatedStatic, GroundCover, ParticleEmitter, Splash, PhysicsDebris, PxCloth, SFXSpace, Vehicle, HoverVehicle, BasicClouds, CloudLayer, WaterObject, WaterBlock, WaterPlane, Marker, Player, AIPlayer, Camera, Debris, GroundPlane, Item, SpawnSphere, PathCamera, PhysicalZone, Zone, Portal, Prefab, Projectile, RigidShape, Trigger, TSStatic, RenderMeshExample, Lightning, ParticleEmitterNode, Precipitation, PhysicsForce, PhysicsShape, PxMultiActor, SFXEmitter, FlyingVehicle, WheeledVehicle, DecalRoad, MeshRoad, River, ScatterSky, SkyBox, Sun, TimeOfDay, Forest, ForestWindEmitter, InteriorInstance, and TerrainBlock.

bool SceneObject::isSelectionEnabled

Determines if the object may be selected from wihin the Tools.

See also:
isSelectable()
int SceneObject::mountNode

Node we are mounted to.

pid SceneObject::mountPID

PersistentID of object we are mounted to.

Unlike the SimObjectID that is determined at run time, the PersistentID of an object is saved with the level/mission and may be used to form a link between objects.

MatrixPosition SceneObject::mountPos

Position we are mounted at ( object space of our mount object ).

MatrixRotation SceneObject::mountRot

Rotation we are mounted at ( object space of our mount object ).

MatrixPosition SceneObject::position

Object world position.

MatrixRotation SceneObject::rotation

Object world orientation.

Point3F SceneObject::scale

Object world scale.


Torque 3D - Script Manual: ScriptGroup Class Reference

ScriptGroup Class Reference
[Console, Scripting]

Essentially a SimGroup, but with onAdd and onRemove script callbacks. More...

Inheritance diagram for ScriptGroup:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onAdd (SimObjectId ID)
Called when this ScriptGroup is added to the system.
void | onRemove (SimObjectId ID)
Called when this ScriptObject is removed from the system.

Detailed Description

Essentially a SimGroup, but with onAdd and onRemove script callbacks.

Example:
// First container, SimGroup containing a ScriptGroup
new SimGroup(Scenes)
{
   // Subcontainer, ScriptGroup containing variables
   // related to a cut scene and a starting WayPoint
   new ScriptGroup(WelcomeScene)
   {
      class = "Scene";
      pathName = "Pathx";
      description = "A small orc village set in the Hardesty mountains. This town and its surroundings will be used to illustrate some the Torque Game Engine's features.";
      pathTime = "0";
      title = "Welcome to Orc Town";

      new WayPoint(start)
      {
         position = "163.873 -103.82 208.354";
         rotation = "0.136165 -0.0544916 0.989186 44.0527";
         scale = "1 1 1";
         dataBlock = "WayPointMarker";
         team = "0";
      };
   };
};
See also:
SimGroup

Member Function Documentation

void ScriptGroup::onAdd ( SimObjectId ID )

Called when this ScriptGroup is added to the system.

Parameters:
ID Unique object ID assigned when created (this in script).
void ScriptGroup::onRemove ( SimObjectId ID )

Called when this ScriptObject is removed from the system.

Parameters:
ID Unique object ID assigned when created (this in script).


Torque 3D - Script Manual: ScriptMsgListener Class Reference

ScriptMsgListener Class Reference
[Messaging]

Script accessible version of Dispatcher::IMessageListener. Often used in conjunction with EventManager. More...

Inheritance diagram for ScriptMsgListener:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onAdd ()
Script callback when a listener is first created and registered.
void | onAddToQueue (string queue)
Callback for when the listener is added to a queue.
bool | onMessageObjectReceived (string queue, Message msg)
Called when a message object (not just the message data) is passed to a listener.
bool | onMessageReceived (string queue, string event, string data)
Called when the listener has received a message.
void | onRemove ()
Script callback when a listener is deleted.
void | onRemoveFromQueue (string queue)
Callback for when the listener is removed from a queue.

Detailed Description

Script accessible version of Dispatcher::IMessageListener. Often used in conjunction with EventManager.

The main use of ScriptMsgListener is to allow script to listen formessages. You can subclass ScriptMsgListener in script to receivethe Dispatcher::IMessageListener callbacks.

Alternatively, you can derive from it in C++ instead of SimObject toget an object that implements Dispatcher::IMessageListener with scriptcallbacks. If you need to derive from something other then SimObject,then you will need to implement the Dispatcher::IMessageListenerinterface yourself.

Example:
// Create the EventManager.
$MyEventManager = new EventManager() { queue = "MyEventManager"; };

// Create an event.
$MyEventManager.registerEvent( "SomeCoolEvent" );

// Create a listener and subscribe.
$MyListener = new ScriptMsgListener() { class = MyListener; };
$MyEventManager.subscribe( $MyListener, "SomeCoolEvent" );

function MyListener::onSomeCoolEvent( %this, %data )
{
   echo( "onSomeCoolEvent Triggered" );
}

// Trigger the event.
$MyEventManager.postEvent( "SomeCoolEvent", "Data" );

Member Function Documentation

void ScriptMsgListener::onAdd ( )

Script callback when a listener is first created and registered.

Example:
function ScriptMsgListener::onAdd(%this)
{
   // Perform on add code here
}
void ScriptMsgListener::onAddToQueue ( string queue )

Callback for when the listener is added to a queue.

The default implementation of onAddToQueue() and onRemoveFromQueue() provide tracking of the queues this listener is added to through the mQueues member. Overrides of onAddToQueue() or onRemoveFromQueue() should ensure they call the parent implementation in any overrides.

Parameters:
queue The name of the queue that the listener added to
See also:
onRemoveFromQueue()
bool ScriptMsgListener::onMessageObjectReceived | ( | string | queue,
 |  | Message | msg
 | ) |  |

Called when a message object (not just the message data) is passed to a listener.

Parameters:
queue | The name of the queue the message was dispatched to
msg | The message object
Returns:
false to prevent other listeners receiving this message, true otherwise
See also:
Message
onMessageReceived
bool ScriptMsgListener::onMessageReceived | ( | string | queue,
 |  | string | event,
 |  | string | data
 | ) |  |

Called when the listener has received a message.

Parameters:
queue | The name of the queue the message was dispatched to
event | The name of the event (function) that was triggered
data | The data (parameters) for the message
Returns:
false to prevent other listeners receiving this message, true otherwise
void ScriptMsgListener::onRemove ( )

Script callback when a listener is deleted.

Example:
function ScriptMsgListener::onRemove(%this)
{
   // Perform on remove code here
}
void ScriptMsgListener::onRemoveFromQueue ( string queue )

Callback for when the listener is removed from a queue.

The default implementation of onAddToQueue() and onRemoveFromQueue() provide tracking of the queues this listener is added to through the mQueues member. Overrides of onAddToQueue() or onRemoveFromQueue() should ensure they call the parent implementation in any overrides.

Parameters:
queue The name of the queue that the listener was removed from
See also:
onAddToQueue()


Torque 3D - Script Manual: ScriptObject Class Reference

ScriptObject Class Reference
[Console, Scripting]

A script-level OOP object which allows binding of a class, superClass and arguments along with declaration of methods. More...

Inheritance diagram for ScriptObject:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onAdd (SimObjectId ID)
Called when this ScriptObject is added to the system.
void | onRemove (SimObjectId ID)
Called when this ScriptObject is removed from the system.

Detailed Description

A script-level OOP object which allows binding of a class, superClass and arguments along with declaration of methods.

ScriptObjects are extrodinarily powerful objects that allow defining of any type of data required. They can optionally have a class and a superclass defined for added control of multiple ScriptObjects through a simple class definition.

Example:
new ScriptObject(Game)
{
   class = "DeathMatchGame";
   superClass = GameCore;
   genre = "Action FPS"; // Note the new, non-Torque variable
};
See also:
SimObject

Member Function Documentation

void ScriptObject::onAdd ( SimObjectId ID )

Called when this ScriptObject is added to the system.

Parameters:
ID Unique object ID assigned when created (this in script).
void ScriptObject::onRemove ( SimObjectId ID )

Called when this ScriptObject is removed from the system.

Parameters:
ID Unique object ID assigned when created (this in script).


Torque 3D - Script Manual: SFXAmbience Class Reference

SFXAmbience Class Reference
[Sound]

A datablock that describes an ambient sound space. More...

Inheritance diagram for SFXAmbience:
[legend]

List of all members.

Public Attributes

Sound

float | dopplerFactor
The factor to apply to the doppler affect in this space.
SFXEnvironment environment
Reverb environment active in the ambience zone.
float | rolloffFactor
The rolloff factor to apply to distance-based volume attenuation in this space.
SFXTrack soundTrack
Sound track to play in the ambience zone.
SFXState | states [4]
States to activate when the ambient zone is entered.

Detailed Description

A datablock that describes an ambient sound space.

Each ambience datablock captures the properties of a unique ambient sound space. A sound space is comprised of:

  • an ambient audio track that is played when the listener is inside the space,
  • a reverb environment that is active inside the space, and
  • a number of SFXStates that are activated when entering the space and deactivated when exiting it.

Each of these properties is optional.

An important characteristic of ambient audio spaces is that their unique nature is not determined by their location in space but rather by their SFXAmbience datablock. This means that the same SFXAmbience datablock assigned to multiple locations in a level represents the same unique audio space to the sound system.

This is an important distinction for the ambient sound mixer which will activate a given ambient audio space only once at any one time regardless of how many intersecting audio spaces with the same SFXAmbience datablock assigned the listener may currently be in.

All SFXAmbience instances are automatically added to the global SFXAmbienceSet.

At the moment, transitions between reverb environments are not blended and different reverb environments from multiple active SFXAmbiences will not be blended together. This will be added in a future version.

Example:
singleton SFXAmbience( Underwater )
{
   environment = AudioEnvUnderwater;
   soundTrack = ScubaSoundList;
   states[ 0 ] = AudioLocationUnderwater;
};
See also:
SFXEnvironment
SFXTrack
SFXState
LevelInfo::soundAmbience
Zone::soundAmbience

Datablock_Networking

Member Data Documentation

float SFXAmbience::dopplerFactor

The factor to apply to the doppler affect in this space.

Defaults to 0.5.

Doppler Effect

SFXEnvironment SFXAmbience::environment

Reverb environment active in the ambience zone.

Audio Reverb

float SFXAmbience::rolloffFactor

The rolloff factor to apply to distance-based volume attenuation in this space.

Defaults to 1.0.

Note:
This applies to the logarithmic distance model only.

Volume Attenuation

SFXTrack SFXAmbience::soundTrack

Sound track to play in the ambience zone.

SFXState SFXAmbience::states[4]

States to activate when the ambient zone is entered.

When the ambient sound state is entered, all states associated with the state will be activated (given that they are not disabled) and deactivated when the space is exited again.


Torque 3D - Script Manual: SFXController Class Reference

SFXController Class Reference
[Sound]

A sound source that drives multi-source playback. More...

Inheritance diagram for SFXController:
[legend]

List of all members.

Public Member Functions

int | getCurrentSlot ()
Get the index of the playlist slot currently processed by the controller.
void | setCurrentSlot (int index)
Set the index of the playlist slot to play by the controller. This can be used to seek in the playlist.

Public Attributes

Debug

bool | trace
If true, the controller logs its operation to the console.

Detailed Description

A sound source that drives multi-source playback.

This class acts as an interpreter for SFXPlayLists. It goes through the slots of the playlist it is attached to and performs the actions described by each of the slots in turn. As SFXControllers are created implicitly by the SFX system when instantiating a source for a play list it is in most cases not necessary to directly deal with the class. The following example demonstrates how a controller would commonly be created.

Example:
// Create a play list from two SFXProfiles.
%playList = new SFXPlayList()
{
   // Use a looped description so the list playback will loop.
   description = AudioMusicLoop2D;

   track[ 0 ] = Profile1;
   track[ 1 ] = Profile2;
};

// Play the list.  This will implicitly create a controller.
sfxPlayOnce( %playList );
Note:
Play lists are updated at regular intervals by the sound system. This processing determines the granularity at which playlist action timing takes place.
This class cannot be instantiated directly. Use sfxPlayOnce() or sfxCreateSource() with the playlist you want to play to create an instance of this class.
See also:
SFXPlayList

Member Function Documentation

int SFXController::getCurrentSlot ( )

Get the index of the playlist slot currently processed by the controller.

Returns:
The slot index currently being played.
See also:
SFXPlayList
void SFXController::setCurrentSlot ( int index )

Set the index of the playlist slot to play by the controller. This can be used to seek in the playlist.

Parameters:
index Index of the playlist slot.

Member Data Documentation

bool SFXController::trace

If true, the controller logs its operation to the console.

This is a non-networked field that will work locally only.


Torque 3D - Script Manual: SFXDescription Class Reference

SFXDescription Class Reference
[Sound]

A description for how a sound should be played. More...

Inheritance diagram for SFXDescription:
[legend]

List of all members.

Public Attributes

3D

int | coneInsideAngle
Inner sound cone angle in degrees.
int | coneOutsideAngle
Outer sound cone angle in degrees.
float | coneOutsideVolume
Determines the volume scale factor applied the a source's base volume level outside of the outer cone.
bool | is3D
If true, sounds played with this description will have a position and orientation in space.
float | maxDistance
The distance at which attenuation stops.
float | referenceDistance
Distance at which volume attenuation begins.
float | rolloffFactor
Scale factor to apply to logarithmic distance attenuation curve. If -1, the global rolloff setting is used.
Point3F | scatterDistance
Bounds on random displacement of 3D sound positions.
Fading

EaseF | fadeInEase
Easing curve for fade-in transition.
float | fadeInTime
Number of seconds to gradually fade in volume from zero when playback starts.
bool | fadeLoops
Fade each cycle of a loop in and/or out; otherwise only fade-in first cycle.
EaseF | fadeOutEase
Easing curve for fade-out transition.
float | fadeOutTime
Number of seconds to gradually fade out volume down to zero when playback is stopped or paused.
Playback

bool | isLooping
If true, the sound will be played in an endless loop.
string | parameters [8]
Names of the parameters to which sources using this description will automatically be linked.
float | pitch
Pitch shift to apply to playback.
float | priority
Priority level for virtualization of sounds (1 = base level).
SFXSource sourceGroup
Group that sources playing with this description should be put into.
bool | useHardware
Whether the sound is allowed to be mixed in hardware.
float | volume
Base volume level for the sound.
Streaming

bool | isStreaming
If true, incrementally stream sounds; otherwise sounds are loaded in full.
int | streamPacketSize
Number of seconds of sample data per single streaming packet.
int | streamReadAhead
Number of sample packets to read and buffer in advance.
Reverb

float | reverbAirAbsorptionFactor
Multiplies SFXEnvironment::airAbsorptionHR.
int | reverbDirect
Direct path level (at low and mid frequencies).
int | reverbDirectHF
Relative direct path level at high frequencies.
float | reverbDopplerFactor
Per-source doppler factor.
int | reverbExclusion
Main exclusion control (attenuation at high frequencies).
float | reverbExclusionLFRatio
Exclusion low-frequency level re. main control.
int | reverbFlags
Bitfield combination of per-sound reverb flags.
int | reverbObstruction
Main obstruction control (attenuation at high frequencies).
float | reverbObstructionLFRatio
Obstruction low-frequency level re. main control.
int | reverbOcclusion
Main occlusion control (attenuation at high frequencies).
float | reverbOcclusionDirectRatio
Relative occlusion control for direct path.
float | reverbOcclusionLFRatio
Occlusion low-frequency level re. main control.
float | reverbOcclusionRoomRatio
Relative occlusion control for room effect.
int | reverbOutsideVolumeHF
Outside sound cone level at high frequencies.
float | reverbReverbRolloffFactor
Per-source logarithmic falloff factor.
int | reverbRoom
Room effect level (at low and mid frequencies).
int | reverbRoomHF
Relative room effect level at high frequencies.
float | reverbRoomRolloffFactor
Room effect falloff factor.
bool | useCustomReverb
If true, use the reverb properties defined here on sounds.

Static Public Attributes

static const int | REVERB_DIRECTHFAUTO
Automatic setting of SFXDescription::reverbDirect due to distance to listener.
static const int | REVERB_INSTANCE0
EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 0. Default target.
static const int | REVERB_INSTANCE1
EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 1.
static const int | REVERB_INSTANCE2
EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 2.
static const int | REVERB_INSTANCE3
EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 3.
static const int | REVERB_ROOMAUTO
Automatic setting of SFXDescription::reverbRoom due to distance to listener.
static const int | REVERB_ROOMHFAUTO
Automatic setting of SFXDescription::reverbRoomHF due to distance to listener.

Detailed Description

A description for how a sound should be played.

SFXDescriptions are used by the sound system to collect all parameters needed to set up a given sound for playback. This includes information like its volume level, its pitch shift, etc. as well as more complex information like its fade behavior, 3D properties, and per-sound reverb properties.

Any sound playback will require a valid SFXDescription.

As datablocks, SFXDescriptions can be set up as either networked datablocks or non-networked datablocks, though it generally makes sense to keep all descriptions non-networked since they will be used exclusively by clients.

Example:
// A description for a 3D sound with a reasonable default range setting.
// The description is set up to assign sounds to the AudioChannelEffects source group
// (defined in the core scripts).  An alternative means to achieve this is to use the
// AudioEffects description as a copy source (": AudioEffects").

singleton SFXDescription( Audio3DSound )
{
  sourceGroup       = AudioChannelEffects;
  is3D              = true;
  referenceDistance = 20.0;
  maxDistance       = 100.0;
};

Member Data Documentation

int SFXDescription::coneInsideAngle

Inner sound cone angle in degrees.

This value determines the angle of the inner volume cone that protrudes out in the direction of a sound. Within this cone, the sound source retains full volume that is unaffected by sound cone settings (though still affected by distance attenuation.)

Valid values are from 0 to 360. Must be less than coneOutsideAngle. Default is 360. Only for 3D sounds.

Sound Cones

int SFXDescription::coneOutsideAngle

Outer sound cone angle in degrees.

This value determines the angle of the outer volume cone that protrudes out in the direction of a sound and surrounds the inner volume cone. Within this cone, volume will linearly interpolate from the outer cone hull inwards to the inner coner hull starting with the base volume scaled by coneOutsideVolume and ramping up/down to the full base volume.

Valid values are from 0 to 360. Must be >= coneInsideAngle. Default is 360. Only for 3D sounds.

Sound Cones

float SFXDescription::coneOutsideVolume

Determines the volume scale factor applied the a source's base volume level outside of the outer cone.

In the outer cone, starting from outside the inner cone, the scale factor smoothly interpolates from 1.0 (within the inner cone) to this value. At the moment, the allowed range is 0.0 (silence) to 1.0 (no attenuation) as amplification is only supported on XAudio2 but not on the other devices.

Only for 3D sound.

Sound Cones

EaseF SFXDescription::fadeInEase

Easing curve for fade-in transition.

Volume fade-ins will interpolate volume along this curve.

Volume Fades

float SFXDescription::fadeInTime

Number of seconds to gradually fade in volume from zero when playback starts.

Must be >= 0.

Volume Fades

bool SFXDescription::fadeLoops

Fade each cycle of a loop in and/or out; otherwise only fade-in first cycle.

By default, volume fading is applied to the beginning and end of the playback range, i.e. a fade-in segment is placed at the beginning of the sound and a fade-out segment is paced at the end of a sound. However, when looping playback, this may be undesirable as each iteration of the sound will then have a fade-in and fade-out effect.

To set up looping sounds such that a fade-in is applied only when the sound is first started (or playback resumed) and a fade-out is only applied when the sound is explicitly paused or stopped, set this field to true.

Default is false.

Volume Fades

EaseF SFXDescription::fadeOutEase

Easing curve for fade-out transition.

Volume fade-outs will interpolate volume along this curve.

Volume Fades

float SFXDescription::fadeOutTime

Number of seconds to gradually fade out volume down to zero when playback is stopped or paused.

Must be >=0.

Volume Fades

bool SFXDescription::is3D

If true, sounds played with this description will have a position and orientation in space.

Unlike a non-positional sound, a 3D sound will have its volume attenuated depending on the distance to the listener in space. The farther the sound moves away from the listener, the less audible it will be.

Non-positional sounds, in contrast, will remain at their original volume regardless of where the listener is.

Note:
Whether a sound is positional or non-positional cannot be changed once the sound was created so this field determines up front which is the case for a given sound.

3D Audio Volume Attenuation

bool SFXDescription::isLooping

If true, the sound will be played in an endless loop.

Default is false.

bool SFXDescription::isStreaming

If true, incrementally stream sounds; otherwise sounds are loaded in full.

Streaming vs. Buffered Audio

float SFXDescription::maxDistance

The distance at which attenuation stops.

In the linear distance model, the attenuated volume will be zero at this distance.

In the logarithmic model, attenuation will simply stop at this distance and the sound will keep its attenuated volume from there on out. As such, it primarily functions as a cutoff factor to exponential distance attentuation to limit the number of voices relevant to updates.

Only applies to 3D sounds.

See also:
LevelInfo::soundDistanceModel

3D Audio Volume Attenuation

string SFXDescription::parameters[8]

Names of the parameters to which sources using this description will automatically be linked.

Individual parameters are identified by their internalName.

Interactive Audio

float SFXDescription::pitch

Pitch shift to apply to playback.

The pitch assigned to a sound determines the speed at which it is played back. A pitch shift of 1 plays the sound at its default speed. A greater shift factor speeds up playback and a smaller shift factor slows it down.

Must be >0. Default is 1.

float SFXDescription::priority

Priority level for virtualization of sounds (1 = base level).

When there are more concurrently active sounds than supported by the audio mixer, some of the sounds need to be culled. Which sounds are culled first depends primarily on total audibility of individual sounds. However, the priority of invidual sounds may be decreased or decreased through this field.

Sounds and Voices

float SFXDescription::referenceDistance

Distance at which volume attenuation begins.

Up to this distance, the sound retains its base volume.

In the linear distance model, the volume will linearly from this distance onwards up to maxDistance where it reaches zero.

In the logarithmic distance model, the reference distance determine how fast the sound volume decreases with distance. Each referenceDistance steps (scaled by the rolloff factor), the volume halves.

A rule of thumb is that for sounds that require you to be close to hear them in the real world, set the reference distance to small values whereas for sounds that are widely audible set it to larger values.

Only applies to 3D sounds.

See also:
LevelInfo::soundDistanceModel

3D Audio Volume Attenuation

const int SFXDescription::REVERB_DIRECTHFAUTO [static]

Automatic setting of SFXDescription::reverbDirect due to distance to listener.

See also:
SFXDescription::flags
const int SFXDescription::REVERB_INSTANCE0 [static]

EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 0. Default target.

See also:
SFXDescription::flags
const int SFXDescription::REVERB_INSTANCE1 [static]

EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 1.

See also:
SFXDescription::flags
const int SFXDescription::REVERB_INSTANCE2 [static]

EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 2.

See also:
SFXDescription::flags
const int SFXDescription::REVERB_INSTANCE3 [static]

EAX4/SFX/GameCube/Wii: Specify channel to target reverb instance 3.

See also:
SFXDescription::flags
const int SFXDescription::REVERB_ROOMAUTO [static]

Automatic setting of SFXDescription::reverbRoom due to distance to listener.

See also:
SFXDescription::flags
const int SFXDescription::REVERB_ROOMHFAUTO [static]

Automatic setting of SFXDescription::reverbRoomHF due to distance to listener.

See also:
SFXDescription::flags
float SFXDescription::reverbAirAbsorptionFactor

Multiplies SFXEnvironment::airAbsorptionHR.

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbDirect

Direct path level (at low and mid frequencies).

Note:
SUPPORTED: EAX/I3DL2/FMODSFX
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbDirectHF

Relative direct path level at high frequencies.

Note:
SUPPORTED: EAX/I3DL2
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbDopplerFactor

Per-source doppler factor.

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbExclusion

Main exclusion control (attenuation at high frequencies).

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbExclusionLFRatio

Exclusion low-frequency level re. main control.

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbFlags

Bitfield combination of per-sound reverb flags.

See also:
REVERB_DIRECTHFAUTO
REVERB_ROOMAUTO
REVERB_ROOMHFAUTO
REVERB_INSTANCE0
REVERB_INSTANCE1
REVERB_INSTANCE2
REVERB_INSTANCE3
int SFXDescription::reverbObstruction

Main obstruction control (attenuation at high frequencies).

Note:
SUPPORTED: EAX/I3DL2
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbObstructionLFRatio

Obstruction low-frequency level re. main control.

Note:
SUPPORTED: EAX/I3DL2
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbOcclusion

Main occlusion control (attenuation at high frequencies).

Note:
SUPPORTED: EAX/I3DL2
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbOcclusionDirectRatio

Relative occlusion control for direct path.

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbOcclusionLFRatio

Occlusion low-frequency level re. main control.

Note:
SUPPORTED: EAX/I3DL2
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbOcclusionRoomRatio

Relative occlusion control for room effect.

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbOutsideVolumeHF

Outside sound cone level at high frequencies.

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbReverbRolloffFactor

Per-source logarithmic falloff factor.

Note:
SUPPORTED: EAX Only
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbRoom

Room effect level (at low and mid frequencies).

Note:
SUPPORTED: EAX/I3DL2/FMODSFX
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
int SFXDescription::reverbRoomHF

Relative room effect level at high frequencies.

Note:
SUPPORTED: EAX/I3DL2
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::reverbRoomRolloffFactor

Room effect falloff factor.

Note:
SUPPORTED: EAX/I3DL2
See also:
http://www.atc.creative.com/algorithms/eax20.pdf
float SFXDescription::rolloffFactor

Scale factor to apply to logarithmic distance attenuation curve. If -1, the global rolloff setting is used.

Note:
Per-sound rolloff is only supported on OpenAL and FMOD at the moment. With other divices, the global rolloff setting is used for all sounds.
See also:
LevelInfo::soundDistanceModel
Point3F SFXDescription::scatterDistance

Bounds on random displacement of 3D sound positions.

When a 3D sound is created and given its initial position in space, this field is used to determine the amount of randomization applied to the actual position given to the sound system.

The randomization uses the following scheme:

x += rand( - scatterDistance[ 0 ], scatterDistance[ 0 ] );
y += rand( - scatterDistance[ 1 ], scatterDistance[ 1 ] );
z += rand( - scatterDistance[ 2 ], scatterDistance[ 2 ] );
SFXSource SFXDescription::sourceGroup

Group that sources playing with this description should be put into.

When a sound source is allocated, it will be made a child of the source group that is listed in its description. This group will then modulate several properties of the sound as it is played.

For example, one use of groups is to segregate sounds so that volume levels of different sound groups such as interface audio and game audio can be controlled independently.

Source Hierarchies

int SFXDescription::streamPacketSize

Number of seconds of sample data per single streaming packet.

This field allows to fine-tune streaming for individual sounds. The streaming system processes streamed sounds in batches called packets. Each packet will contain a set amount of sample data determined by this field. The greater its value, the more sample data each packet contains, the more work is done per packet.

Note:
This field only takes effect when Torque's own sound system performs the streaming. When FMOD is used, this field is ignored and streaming is performed by FMOD.

Streaming vs. Buffered Audio

int SFXDescription::streamReadAhead

Number of sample packets to read and buffer in advance.

This field determines the number of packets that the streaming system will try to keep buffered in advance. As such it determines the number of packets that can be consumed by the sound device before the playback queue is running dry. Greater values thus allow for more lag in the streaming pipeline.

Note:
This field only takes effect when Torque's own sound system performs the streaming. When FMOD is used, this field is ignored and streaming is performed by FMOD.

Streaming vs. Buffered Audio

bool SFXDescription::useCustomReverb

If true, use the reverb properties defined here on sounds.

By default, sounds will be assigned a generic reverb profile. By setting this flag to true, a custom reverb setup can be defined using the "Reverb" properties that will then be assigned to sounds playing with the description.

Audio Reverb

bool SFXDescription::useHardware

Whether the sound is allowed to be mixed in hardware.

If true, the sound system will try to allocate the voice for the sound directly on the sound hardware for mixing by the hardware mixer. Be aware that a hardware mixer may not provide all features available to sounds mixed in software.

Note:
This flag currently only takes effect when using FMOD.
Generally, it is preferable to let sounds be mixed in software.
float SFXDescription::volume

Base volume level for the sound.

This will be the starting point for volume attenuation on the sound. The final effective volume of a sound will be dependent on a number of parameters.

Must be between 0 (mute) and 1 (full volume). Default is 1.

Volume Attenuation


Torque 3D - Script Manual: SFXEmitter Class Reference

SFXEmitter Class Reference
[Sound]

An invisible 3D object that emits sound. More...

Inheritance diagram for SFXEmitter:
[legend]

List of all members.

Public Member Functions

SFXSource getSource ()
Get the sound source object from the emitter.
void | play ()
Manually start playback of the emitter's sound.
void | stop ()
Manually stop playback of the emitter's sound.

Public Attributes

3D Sound

int | coneInsideAngle
Angle of inner volume cone of 3D sound in degrees.
int | coneOutsideAngle
Angle of outer volume cone of 3D sound in degrees.
float | coneOutsideVolume
Volume scale factor of outside of outer volume 3D sound cone.
bool | is3D
Whether to play fileName as a positional (3D) sound or not.
float | maxDistance
Distance at which to stop volume attenuation of the 3D sound.
float | referenceDistance
Distance at which to start volume attenuation of the 3D sound.
Point3F | scatterDistance
Bounds on random offset to apply to initial 3D sound position.
Sound

float | fadeInTime
Number of seconds to gradually fade in volume from zero when playback starts.
float | fadeOutTime
Number of seconds to gradually fade out volume down to zero when playback is stopped or paused.
bool | isLooping
Whether to play fileName in an infinite loop.
bool | isStreaming
Whether to use streamed playback for fileName.
float | pitch
Pitch shift to apply to the sound. Default is 1 = play at normal speed.
bool | playOnAdd
Whether playback of the emitter's sound should start as soon as the emitter object is added to the level.
SFXSource sourceGroup
The SFXSource to which to assign the sound of this emitter as a child.
bool | useTrackDescriptionOnly
If this is true, all fields except for playOnAdd and track are ignored on the emitter object.
float | volume
Volume level to apply to the sound.
Media

filename | fileName
The sound file to play.
SFXTrack track
The track which the emitter should play.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static ColorI | renderColorInnerCone
The color with which to render dots in the inner sound cone (Editor only).
static ColorI | renderColorOuterCone
The color with which to render dots in the outer sound cone (Editor only).
static ColorI | renderColorOutsideVolume
The color with which to render dots outside of the outer sound cone (Editor only).
static ColorI | renderColorPlayingInRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is playing and in range of the listener.
static ColorI | renderColorPlayingOutOfRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is playing but out of the range of the listener.
static ColorI | renderColorRangeSphere
The color of the range sphere with which to render sound emitters in the editor.
static ColorI | renderColorStoppedInRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is not playing but the emitter is in range of the listener.
static ColorI | renderColorStoppedOutOfRange
The color with which to render a sound emitter's marker cube in the editor when the emitter's sound is not playing and the emitter is out of range of the listener.
static bool | renderEmitters
Whether to render enhanced range feedback in the editor on all emitters regardless of selection state.
static float | renderPointDistance
The distance between individual points in the sound emitter rendering in the editor as the points move from the emitter's center away to maxDistance.
static float | renderRadialIncrements
The stepping (in degrees) for the radial sweep along the axis of the XY plane sweep for sound emitter rendering in the editor.
static float | renderSweepIncrements
The stepping (in degrees) for the radial sweep on the XY plane for sound emitter rendering in the editor.

Detailed Description

An invisible 3D object that emits sound.

Sound emitters are used to place sounds in the level. They are full 3D objects with their own position and orientation and when assigned 3D sounds, the transform and velocity of the sound emitter object will be applied to the 3D sound.

Sound emitters can be set up of in either of two ways:

  • By assigning an existing SFXTrack to the emitter's track property.

    In this case the general sound setup (3D, streaming, looping, etc.) will be taken from track. However, the emitter's own properties will still override their corresponding properties in the track's SFXDescription.

  • By directly assigning a sound file to the emitter's fileName property.

    In this case, the sound file will be set up for playback according to the properties defined on the emitter.

Using playOnAdd emitters can be configured to start playing immediately when they are added to the system (e.g. when the level objects are loaded from the mission file).

Note:
A sound emitter need not necessarily emit a 3D sound. Instead, sound emitters may also be used to play non-positional sounds. For placing background audio to a level, however, it is usually easier to use LevelInfo::soundAmbience.

Sound Emitters and Networking

It is important to be aware of the fact that sounds will only play client-side whereas SFXEmitter objects are server-side entities. This means that a server-side object has no connection to the actual sound playing on the client. It is thus not possible for the server-object to perform queries about playback status and other source-related properties as these may in fact differ from client to client.

Member Function Documentation

SFXSource SFXEmitter::getSource ( )

Get the sound source object from the emitter.

Returns:
The sound source used by the emitter or null.
Note:
This method will return null when called on the server-side SFXEmitter object. Only client-side ghosts actually hold on to SFXSources.
void SFXEmitter::play ( )

Manually start playback of the emitter's sound.

If this is called on the server-side object, the play command will be related to all client-side ghosts.

void SFXEmitter::stop ( )

Manually stop playback of the emitter's sound.

If this is called on the server-side object, the stop command will be related to all client-side ghosts.

Member Data Documentation

int SFXEmitter::coneInsideAngle

Angle of inner volume cone of 3D sound in degrees.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::coneInsideAngle
int SFXEmitter::coneOutsideAngle

Angle of outer volume cone of 3D sound in degrees.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::coneOutsideAngle
float SFXEmitter::coneOutsideVolume

Volume scale factor of outside of outer volume 3D sound cone.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::coneOutsideVolume
float SFXEmitter::fadeInTime

Number of seconds to gradually fade in volume from zero when playback starts.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::fadeInTime
float SFXEmitter::fadeOutTime

Number of seconds to gradually fade out volume down to zero when playback is stopped or paused.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::fadeOutTime
filename SFXEmitter::fileName

The sound file to play.

Use either this property or track. If both are assigned, track takes precendence. The primary purpose of this field is to avoid the need for the user to define SFXTrack datablocks for all sounds used in a level.

bool SFXEmitter::is3D

Whether to play fileName as a positional (3D) sound or not.

If a track is assigned, the value of this field is ignored.

See also:
SFXDescription::is3D
bool SFXEmitter::isLooping

Whether to play fileName in an infinite loop.

If a track is assigned, the value of this field is ignored.

See also:
SFXDescription::isLooping
bool SFXEmitter::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool SFXEmitter::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool SFXEmitter::isStreaming

Whether to use streamed playback for fileName.

If a track is assigned, the value of this field is ignored.

See also:
SFXDescription::isStreaming

Streaming vs. Buffered Audio

float SFXEmitter::maxDistance

Distance at which to stop volume attenuation of the 3D sound.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::maxDistance
float SFXEmitter::pitch

Pitch shift to apply to the sound. Default is 1 = play at normal speed.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::pitch
bool SFXEmitter::playOnAdd

Whether playback of the emitter's sound should start as soon as the emitter object is added to the level.

If this is true, the emitter will immediately start to play when the level is loaded.

float SFXEmitter::referenceDistance

Distance at which to start volume attenuation of the 3D sound.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::referenceDistance
Point3F SFXEmitter::scatterDistance

Bounds on random offset to apply to initial 3D sound position.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::scatterDistance
SFXSource SFXEmitter::sourceGroup

The SFXSource to which to assign the sound of this emitter as a child.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::sourceGroup
SFXTrack SFXEmitter::track

The track which the emitter should play.

Note:
If assigned, this field will take precedence over a fileName that may also be assigned to the emitter.
bool SFXEmitter::useTrackDescriptionOnly

If this is true, all fields except for playOnAdd and track are ignored on the emitter object.

This is useful to prevent fields in the track's description from being overridden by emitter fields.

float SFXEmitter::volume

Volume level to apply to the sound.

Note:
This field is ignored if useTrackDescriptionOnly is true.
See also:
SFXDescription::volume


Torque 3D - Script Manual: SFXEnvironment Class Reference

SFXEnvironment Class Reference
[Sound]

Description of a reverb environment. More...

Inheritance diagram for SFXEnvironment:
[legend]

List of all members.

Public Attributes

Reverb

float | airAbsorptionHF
Change in level per meter at high frequencies.
float | decayHFRatio
High-frequency to mid-frequency decay time ratio.
float | decayLFRatio
Low-frequency to mid-frequency decay time ratio.
float | decayTime
Reverberation decay time at mid frequencies.
float | density
Value that controls the modal density in the late reverberation decay.
float | diffusion
Value that controls the echo density in the late reverberation decay.
float | echoDepth
Echo depth.
float | echoTime
Echo time.
float | envDiffusion
Environment diffusion.
float | envSize
Environment size in meters.
int | flags
A bitfield of reverb flags.
float | HFReference
Reference high frequency in Hertz.
float | LFReference
Reference low frequency in Hertz.
float | modulationDepth
Modulation depth.
float | modulationTime
Modulation time.
int | reflections
Early reflections level relative to room effect.
float | reflectionsDelay
Initial reflection delay time.
float | reflectionsPan [3]
Early reflections panning vector.
int | reverb
Late reverberation level relative to room effect.
float | reverbDelay
Late reverberation delay time relative to initial reflection.
float | reverbPan [3]
Late reverberation panning vector.
int | room
Room effect level at mid-frequencies.
int | roomHF
Relative room effect level at high frequencies.
int | roomLF
Relative room effect level at low frequencies.
float | roomRolloffFactor
Logarithmic distance attenuation rolloff scale factor for reverb room size effect.

Static Public Attributes

static const int | REVERB_CORE0
PS2 Only - Reverb is applied to CORE0 (hw voices 0-23).
static const int | REVERB_CORE1
PS2 Only - Reverb is applied to CORE1 (hw voices 24-47).
static const int | REVERB_DECAYHFLIMIT
SFXEnvironment::airAbsorptionHF affects SFXEnvironment::decayHFRatio.
static const int | REVERB_DECAYTIMESCALE
SFXEnvironment::envSize affects reverberation decay time.
static const int | REVERB_ECHOTIMESCALE
SFXEnvironment::envSize affects echo time.
static const int | REVERB_HIGHQUALITYDPL2REVERB
GameCube/Wii Only - Use high-quality DPL2 reverb.
static const int | REVERB_HIGHQUALITYREVERB
GameCube/Wii Only - Use high-quality reverb.
static const int | REVERB_MODULATIONTIMESCALE
SFXEnvironment::envSize affects modulation time.
static const int | REVERB_REFLECTIONSDELAYSCALE
SFXEnvironment::envSize affects initial reflection delay time.
static const int | REVERB_REFLECTIONSSCALE
SFXEnvironment::envSize affects reflection level.
static const int | REVERB_REVERBDELAYSCALE
SFXEnvironment::envSize affects late reverberation delay time.
static const int | REVERB_REVERBSCALE
SFXEnvironment::envSize affects reflections level.

Detailed Description

Description of a reverb environment.

A reverb environment specifies how the audio mixer should render advanced environmental audio effects.

To use reverb environments in your level, set up one or more ambient audio spaces, assign reverb environments appropriately, and then attach the SFXAmbiences to your LevelInfo (taking effect globally) or Zone objects (taking effect locally).

To define your own custom reverb environments, it is usually easiest to adapt one of the pre-existing reverb definitions:

singleton SFXEnvironment( AudioEnvCustomUnderwater : AudioEnvUnderwater )
{
   // Override select properties from AudioEnvUnderwater here.
};

In the Datablock Editor, this can be done by selecting an existing environment to copy from when creating the SFXEnvironment datablock.

For a precise description of reverb audio and the properties of this class, please consult the EAX documentation.

All SFXEnvironment instances are automatically added to the global SFXEnvironmentSet.

See also:
http://www.atc.creative.com/algorithms/eax20.pdf
http://connect.creativelabs.com/developer/Gaming/Forms/AllItems.aspx
SFXAmbience::environment

Audio Reverb

Member Data Documentation

float SFXEnvironment::airAbsorptionHF

Change in level per meter at high frequencies.

float SFXEnvironment::decayHFRatio

High-frequency to mid-frequency decay time ratio.

float SFXEnvironment::decayLFRatio

Low-frequency to mid-frequency decay time ratio.

float SFXEnvironment::decayTime

Reverberation decay time at mid frequencies.

float SFXEnvironment::density

Value that controls the modal density in the late reverberation decay.

float SFXEnvironment::diffusion

Value that controls the echo density in the late reverberation decay.

float SFXEnvironment::echoDepth

Echo depth.

float SFXEnvironment::echoTime

Echo time.

float SFXEnvironment::envDiffusion

Environment diffusion.

float SFXEnvironment::envSize

Environment size in meters.

int SFXEnvironment::flags

A bitfield of reverb flags.

See also:
REVERB_DECAYTIMESCALE
REVERB_REFLECTIONSSCALE
REVERB_REFLECTIONSDELAYSCALE
REVERB_REVERBSCALE
REVERB_REVERBDELAYSCALE
REVERB_DECAYHFLIMIT
REVERB_ECHOTIMESCALE
REVERB_MODULATIONTIMESCALE
REVERB_CORE0
REVERB_CORE1
REVERB_HIGHQUALITYREVERB
REVERB_HIGHQUALITYDPL2REVERB
float SFXEnvironment::HFReference

Reference high frequency in Hertz.

float SFXEnvironment::LFReference

Reference low frequency in Hertz.

float SFXEnvironment::modulationDepth

Modulation depth.

float SFXEnvironment::modulationTime

Modulation time.

int SFXEnvironment::reflections

Early reflections level relative to room effect.

float SFXEnvironment::reflectionsDelay

Initial reflection delay time.

float SFXEnvironment::reflectionsPan[3]

Early reflections panning vector.

int SFXEnvironment::reverb

Late reverberation level relative to room effect.

const int SFXEnvironment::REVERB_CORE0 [static]

PS2 Only - Reverb is applied to CORE0 (hw voices 0-23).

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_CORE1 [static]

PS2 Only - Reverb is applied to CORE1 (hw voices 24-47).

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_DECAYHFLIMIT [static]

SFXEnvironment::airAbsorptionHF affects SFXEnvironment::decayHFRatio.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_DECAYTIMESCALE [static]

SFXEnvironment::envSize affects reverberation decay time.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_ECHOTIMESCALE [static]

SFXEnvironment::envSize affects echo time.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_HIGHQUALITYDPL2REVERB [static]

GameCube/Wii Only - Use high-quality DPL2 reverb.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_HIGHQUALITYREVERB [static]

GameCube/Wii Only - Use high-quality reverb.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_MODULATIONTIMESCALE [static]

SFXEnvironment::envSize affects modulation time.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_REFLECTIONSDELAYSCALE [static]

SFXEnvironment::envSize affects initial reflection delay time.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_REFLECTIONSSCALE [static]

SFXEnvironment::envSize affects reflection level.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_REVERBDELAYSCALE [static]

SFXEnvironment::envSize affects late reverberation delay time.

See also:
SFXEnvironment::flags
const int SFXEnvironment::REVERB_REVERBSCALE [static]

SFXEnvironment::envSize affects reflections level.

See also:
SFXEnvironment::flags
float SFXEnvironment::reverbDelay

Late reverberation delay time relative to initial reflection.

float SFXEnvironment::reverbPan[3]

Late reverberation panning vector.

int SFXEnvironment::room

Room effect level at mid-frequencies.

int SFXEnvironment::roomHF

Relative room effect level at high frequencies.

int SFXEnvironment::roomLF

Relative room effect level at low frequencies.

float SFXEnvironment::roomRolloffFactor

Logarithmic distance attenuation rolloff scale factor for reverb room size effect.


Torque 3D - Script Manual: SFXFMODEvent Class Reference

SFXFMODEvent Class Reference
[FMOD]

A playable sound event in an FMOD Designer audio project. More...

Inheritance diagram for SFXFMODEvent:
[legend]

List of all members.

Public Attributes

DO NOT MODIFY!!

SFXFMODEventGroup fmodGroup
DO NOT MODIFY!!
string | fmodName
DO NOT MODIFY!!
Point2F | fmodParameterRanges [8]
DO NOT MODIFY!!
float | fmodParameterValues [8]
DO NOT MODIFY!!

Detailed Description

A playable sound event in an FMOD Designer audio project.

Member Data Documentation

SFXFMODEventGroup SFXFMODEvent::fmodGroup

DO NOT MODIFY!!

string SFXFMODEvent::fmodName

DO NOT MODIFY!!

Point2F SFXFMODEvent::fmodParameterRanges[8]

DO NOT MODIFY!!

float SFXFMODEvent::fmodParameterValues[8]

DO NOT MODIFY!!


Torque 3D - Script Manual: SFXFMODEventGroup Class Reference

SFXFMODEventGroup Class Reference
[FMOD]

A group of events in an imported FMOD Designer project. More...

Inheritance diagram for SFXFMODEventGroup:
[legend]

List of all members.

Public Member Functions

void | freeData ()
Release the resource data for this group and its subgroups.
bool | isDataLoaded ()
Test whether the resource data for this group has been loaded.
bool | loadData (bool loadStreams=true, bool loadSamples=true)
Load the resource data for this group, if it has not already been loaded (either directly or indirectly through a parent group).

Public Attributes

DO NOT MODIFY!!

SFXFMODEventGroup fmodGroup
DO NOT MODIFY!!
string | fmodName
DO NOT MODIFY!!
SFXFMODProject fmodProject
DO NOT MODIFY!!

Detailed Description

A group of events in an imported FMOD Designer project.

Note:
Instances of this class

Member Function Documentation

void SFXFMODEventGroup::freeData ( )

Release the resource data for this group and its subgroups.

See also:
SFXFMODProject_resources
bool SFXFMODEventGroup::isDataLoaded ( )

Test whether the resource data for this group has been loaded.

Returns:
True if the resource data for this group is currently loaded.
bool SFXFMODEventGroup::loadData | ( | bool | loadStreams = true,
 |  | bool | loadSamples = true
 | ) |  |

Load the resource data for this group, if it has not already been loaded (either directly or indirectly through a parent group).

This method works recursively and thus data for direct and indirect child groups to this group will be loaded as well.

Parameters:
loadStreams | Whether to open streams.
loadSamples | Whether to load sample banks.
Returns:
True if the data has been successfully loaded; false otherwise.
See also:
SFXFMODProject_resources

Member Data Documentation

SFXFMODEventGroup SFXFMODEventGroup::fmodGroup

DO NOT MODIFY!!

string SFXFMODEventGroup::fmodName

DO NOT MODIFY!!

SFXFMODProject SFXFMODEventGroup::fmodProject

DO NOT MODIFY!!


Torque 3D - Script Manual: SFXFMODEventSource Class Reference

SFXFMODEventSource Class Reference
[FMOD]

A sound source controller playing an FMOD Designer event (SFXFMODEvent). More...

Inheritance diagram for SFXFMODEventSource:
[legend]

List of all members.

Detailed Description

A sound source controller playing an FMOD Designer event (SFXFMODEvent).

FMOD event sources are internally created by the sound system to play events from imported FMOD Designer projects.

Note:
This class cannot be instantiated directly by the user. Instead, instances of SFXFMODEventSource will be implicitly created by the sound system when playing an SFXFMODEvent.


Torque 3D - Script Manual: SFXFMODProject Class Reference

SFXFMODProject Class Reference
[FMOD]

An FMOD Designer project loaded into Torque. More...

Inheritance diagram for SFXFMODProject:
[legend]

List of all members.

Public Attributes

FMOD

filename | fileName
The compiled .fev file from FMOD Designer.
filename | mediaPath
Path to the media files; if unset, defaults to project directory.

Detailed Description

An FMOD Designer project loaded into Torque.

Resource Loading

Member Data Documentation

filename SFXFMODProject::fileName

The compiled .fev file from FMOD Designer.

filename SFXFMODProject::mediaPath

Path to the media files; if unset, defaults to project directory.


Torque 3D - Script Manual: SFXParameter Class Reference

SFXParameter Class Reference
[Sound]

A sound channel value that can be bound to multiple sound sources. More...

Inheritance diagram for SFXParameter:
[legend]

List of all members.

Public Member Functions

String | getParameterName ()
Get the name of the parameter.
void | reset ()
Reset the parameter's value to its default.
Callbacks

void | onUpdate ()
Called when the sound system triggers an update on the parameter.

Public Attributes

Sound

SFXChannel channel
Channel that the parameter controls.
float | defaultValue
Value to which the parameter is initially set.
string | description
Textual description of the parameter.
Point2F | range
Permitted range for value.
float | value
Current value of the audio parameter.

Detailed Description

A sound channel value that can be bound to multiple sound sources.

Parameters are special objects that isolate a specific property that sound sources can have and allows to bind this isolated instance to multiple sound sources such that when the value of the parameter changes, all sources bound to the parameter will have their respective property changed.

Parameters are identified and referenced by their internalName. This means that the SFXDescription::parameters and SFXTrack::parameters fields should contain the internalNames of the SFXParameter objects which should be attached to the SFXSources when they are created. No two SFXParameters should have the same internalName.

All SFXParameter instances are automatically made children of the SFXParameterGroup.

Note:
To simply control the volume and/or pitch levels of a group of sounds, it is easier and more efficient to use a sound source group rather than SFXParameters (see Source Hierarchies). Simply create a SFXSource object representing the group, assign SFXDescription::sourceGroup of the sounds appropriately, and then set the volume and/or pitch level of the group to modulate the respective properties of all children.

Parameter Updates

Parameters are periodically allowed to update their own values. This makes it possible to attach custom logic to a parameter and have individual parameters synchronize their values autonomously. Use the onUpdate() callback to attach script code to a parameter update.

Example:
new SFXParameter( EngineRPMLevel )
{
   // Set the name by which this parameter is identified.
   internalName = "EngineRPMLevel";

   // Let this parameter control the pitch of attached sources to simulate engine RPM ramping up and down.
   channel = "Pitch";

   // Start out with unmodified pitch.
   defaultValue = 1;

   // Add a texture description of what this parameter does.
   description = "Engine RPM Level";
};

// Create a description that automatically attaches the engine RPM parameter.
singleton SFXDescription( EngineRPMSound : AudioLoop2D )
{
   parameters[ 0 ] = "EngineRPMLevel";
};

// Create sound sources for the engine.
sfxCreateSource( EngineRPMSound, "art/sound/engine/enginePrimary" );
sfxCreateSource( EngineRPMSound, "art/sound/engine/engineSecondary" );

// Setting the parameter value will now affect the pitch level of both sound sources.
EngineRPMLevel.value = 0.5;
EngineRPMLevel.value = 1.5;

Interactive Audio

Member Function Documentation

String SFXParameter::getParameterName ( )

Get the name of the parameter.

Returns:
The paramete name.
void SFXParameter::onUpdate ( )

Called when the sound system triggers an update on the parameter.

This occurs periodically during system operation.

void SFXParameter::reset ( )

Reset the parameter's value to its default.

See also:
SFXParameter::defaultValue

Member Data Documentation

SFXChannel SFXParameter::channel

Channel that the parameter controls.

This controls which property of the sources it is attached to the parameter controls.

float SFXParameter::defaultValue

Value to which the parameter is initially set.

When the parameter is first added to the system, value will be set to defaultValue.

string SFXParameter::description

Textual description of the parameter.

Primarily for use in the Audio Parameters dialog of the editor to allow for easier identification of parameters.

Point2F SFXParameter::range

Permitted range for value.

Minimum and maximum allowed value for the parameter. Both inclusive.

For all but the User0-3 channels, this property is automatically set up by SFXParameter.

float SFXParameter::value

Current value of the audio parameter.

All attached sources are notified when this value changes.


Torque 3D - Script Manual: SFXPlayList Class Reference

SFXPlayList Class Reference
[Sound]

A datablock describing a playback pattern of sounds. More...

Inheritance diagram for SFXPlayList:
[legend]

List of all members.

Public Attributes

Sound

float | delayTimeIn [16]
Seconds to wait after moving into slot before transitionIn.
Point2F | delayTimeInVariance [16]
Bounds on randomization of delayTimeIn.
float | delayTimeOut [16]
Seconds to wait before moving out of slot after transitionOut.
Point2F | delayTimeOutVariance [16]
Bounds on randomization of delayTimeOut.
float | fadeTimeIn [16]
Seconds to fade sound in (-1 to use the track's own fadeInTime.).
Point2F | fadeTimeInVariance [16]
Bounds on randomization of fadeInTime.
float | fadeTimeOut [16]
Seconds to fade sound out (-1 to use the track's own fadeOutTime.).
Point2F | fadeTimeOutVariance [16]
Bounds on randomization of fadeOutTime.
SFXPlayListLoopMode loopMode
Behavior when description has looping enabled.
float | maxDistance [16]
maxDistance to apply to 3D sounds in this slot (<1 to use maxDistance of track's own description).
Point2F | maxDistanceVariance [16]
Bounds on randomization of maxDistance.
int | numSlotsToPlay
Number of slots to play.
float | pitchScale [16]
Scale factor to apply to pitch of sounds played on this list slot.
Point2F | pitchScaleVariance [16]
Bounds on randomization of pitchScale.
SFXPlayListRandomMode random
Slot playback order randomization pattern.
float | referenceDistance [16]
referenceDistance to set for 3D sounds in this slot (<1 to use referenceDistance of track's own description).
Point2F | referenceDistanceVariance [16]
Bounds on randomization of referenceDistance.
int | repeatCount [16]
Number of times to loop this slot.
SFXPlayListReplayMode | replay [16]
Behavior when an already playing sound is encountered on this slot from a previous cycle.
SFXState | state [16]
State that must be active for this slot to play.
SFXPlayListStateMode | stateMode [16]
Behavior when assigned state is deactivated while slot is playing.
SFXTrack | track [16]
Track to play in this slot.
SFXPlayListTransitionMode | transitionIn [16]
Behavior when moving into this slot.
SFXPlayListTransitionMode | transitionOut [16]
Behavior when moving out of this slot.
float | volumeScale [16]
Scale factor to apply to volume of sounds played on this list slot.
Point2F | volumeScaleVariance [16]
Bounds on randomization of volumeScale.
Debug

bool | trace
Enable/disable execution tracing for this playlist (local only).

Detailed Description

A datablock describing a playback pattern of sounds.

Playlists allow to define intricate playback patterns of invidual tracks and thus allow the sound system to be easily used for playing multiple sounds in single operations.

As playlists are SFXTracks, they can thus be used anywhere in the engine where sound data can be assigned.

Each playlist can hold a maximum of 16 tracks. Longer playlists may be constructed by cascading lists, i.e. by creating a playlist that references other playlists.

Processing of a single playlist slot progresses in a fixed set of steps that are invariably iterated through for each slot (except the slot is assigned a state and its state is deactivated; in this case, the controller will exit out of the slot directly):

  1. delayIn:

    Waits a set amount of time before processing the slot. This is 0 by default and is determined by the delayTimeIn (seconds to wait) and delayTimeInVariance (bounds on randomization) properties.

  2. transitionIn:

    Decides what to do before playing the slot. Defaults to None which makes this stage a no-operation. Alternatively, the slot can be configured to wait for playback of other slots to finish (Wait and WaitAll) or to stop playback of other slots (Stop and StopAll). Note that Wait and Stop always refer to the source that was last started by the list.

  3. play:

    Finally, the track attached to the slot is played. However, this will only start playback of the track and then immediately move on to the next stage. It will not wait for the track to finish playing. Note also that depending on the replay setting for the slot, this stage may pick up a source that is already playing on the slot rather than starting a new one.

    Several slot properties (fade times, min/max distance, and volume/pitch scale) are used in this stage.

  4. delayOut:

    Waits a set amount of time before transitioning out of the slot. This works the same as delayIn and is set to 0 by default (i.e. no delay).

  5. transitionOut:

    Decides what to do after playing the slot. This works like transitionIn.

This is a key difference to playlists in normal music players where upon reaching a certain slot, the slot will immediately play and the player then wait for playback to finish before moving on to the next slot.

Note:
Be aware that time limits set on slot delays are soft limits. The sound system updates sound sources in discrete (and equally system update frequency dependent) intervals which thus determines the granularity at which time-outs can be handled.

Value Randomization

For greater variety, many of the values for individual slots may be given a randomization limit that will trigger a dynamic variance of the specified base value.

Any given field xyz that may be randomized has a corresponding field xyzVariance which is a two-dimensional vector. The first number specifies the greatest value that may be subtracted from the given base value (i.e. the xyz field) whereas the second number specifies the greatest value that may be added to the base value. Between these two limits, a random number is generated.

The default variance settings of "0 0" will thus not allow to add or subtract anything from the base value and effectively disable randomization.

Randomization is re-evaluated on each cycle through a list.

Playlists and States

A unique aspect of playlists is that they allow their playback to be tied to the changing set of active sound states. This feature enables playlists to basically connect to an extensible state machine that can be leveraged by the game code to signal a multitude of different gameplay states with the audio system then automatically reacting to state transitions.

Playlists react to states in three ways:

  • Before a controller starts processing a slot it checks whether the slot is assigned a state. If this is the case, the controller checks whether the particular state is active. If it is not, the entire slot is skipped. If it is, the controller goes on to process the slot.
  • If a controller is in one of the delay stages for a slot that has a state assigned and the state is deactivated, the controller will stop the delay and skip any of the remaining processing stages for the slot.
  • Once the play stage has been processed for a slot that has a state assigned, the slot's stateMode will determine what happens with the playing sound source if the slot's state is deactivated while the sound is still playing.

A simple example of how to make use of states in combination with playlists would be to set up a playlist for background music that reacts to the mood of the current gameplay situation. For example, during combat, tenser music could play than during normal exploration. To set this up, different SFXStates would represent different moods in the game and the background music playlist would have one slot set up for each such mood. By making use of volume fades and the PauseWhenDeactivated stateMode, smooth transitions between the various audio tracks can be produced.

Example:
// Create a play list from two SFXProfiles.
%playList = new SFXPlayList()
{
   // Use a looped description so the list playback will loop.
   description = AudioMusicLoop2D;

   track[ 0 ] = Profile1;
   track[ 1 ] = Profile2;
};

// Play the list.
sfxPlayOnce( %playList );

Interactive Audio

Member Data Documentation

float SFXPlayList::delayTimeIn[16]

Seconds to wait after moving into slot before transitionIn.

Point2F SFXPlayList::delayTimeInVariance[16]

Bounds on randomization of delayTimeIn.

Value Randomization

float SFXPlayList::delayTimeOut[16]

Seconds to wait before moving out of slot after transitionOut.

Point2F SFXPlayList::delayTimeOutVariance[16]

Bounds on randomization of delayTimeOut.

Value Randomization

float SFXPlayList::fadeTimeIn[16]

Seconds to fade sound in (-1 to use the track's own fadeInTime.).

See also:
SFXDescription::fadeTimeIn
Point2F SFXPlayList::fadeTimeInVariance[16]

Bounds on randomization of fadeInTime.

Value Randomization

float SFXPlayList::fadeTimeOut[16]

Seconds to fade sound out (-1 to use the track's own fadeOutTime.).

See also:
SFXDescription::fadeTimeOut
Point2F SFXPlayList::fadeTimeOutVariance[16]

Bounds on randomization of fadeOutTime.

Value Randomization

SFXPlayListLoopMode SFXPlayList::loopMode

Behavior when description has looping enabled.

The loop mode determines whether the list will loop over a single slot or loop over all the entire list of slots being played.

See also:
SFXDescription::isLooping
float SFXPlayList::maxDistance[16]

maxDistance to apply to 3D sounds in this slot (<1 to use maxDistance of track's own description).

See also:
SFXDescription::maxDistance
Point2F SFXPlayList::maxDistanceVariance[16]

Bounds on randomization of maxDistance.

Value Randomization

int SFXPlayList::numSlotsToPlay

Number of slots to play.

Up to a maximum of 16, this field determines the number of slots that are taken from the list for playback. Only slots that have a valid track assigned will be considered for this.

float SFXPlayList::pitchScale[16]

Scale factor to apply to pitch of sounds played on this list slot.

This value will scale the actual pitch set on the track assigned to the slot, i.e. a value of 0.5 will cause the track to play at half its assigned speed.

Point2F SFXPlayList::pitchScaleVariance[16]

Bounds on randomization of pitchScale.

Value Randomization

SFXPlayListRandomMode SFXPlayList::random

Slot playback order randomization pattern.

By setting this field to something other than "NotRandom" to order in which slots of the playlist are processed can be changed from sequential to a random pattern. This allows to to create more varied playback patterns. Defaults to "NotRandom".

float SFXPlayList::referenceDistance[16]

referenceDistance to set for 3D sounds in this slot (<1 to use referenceDistance of track's own description).

See also:
SFXDescription::referenceDistance
Point2F SFXPlayList::referenceDistanceVariance[16]

Bounds on randomization of referenceDistance.

Value Randomization

int SFXPlayList::repeatCount[16]

Number of times to loop this slot.

SFXPlayListReplayMode SFXPlayList::replay[16]

Behavior when an already playing sound is encountered on this slot from a previous cycle.

Each slot can have an arbitrary number of sounds playing on it from previous cycles. This field determines how SFXController will handle these sources.

SFXState SFXPlayList::state[16]

State that must be active for this slot to play.

Playlists and States

SFXPlayListStateMode SFXPlayList::stateMode[16]

Behavior when assigned state is deactivated while slot is playing.

Playlists and States

bool SFXPlayList::trace

Enable/disable execution tracing for this playlist (local only).

If this is true, SFXControllers attached to the list will automatically run in trace mode.

SFXTrack SFXPlayList::track[16]

Track to play in this slot.

This must be set for the slot to be considered for playback. Other settings for a slot will not take effect except this field is set.

SFXPlayListTransitionMode SFXPlayList::transitionIn[16]

Behavior when moving into this slot.

After the delayIn time has expired (if any), this slot determines what the controller will do before actually playing the slot.

SFXPlayListTransitionMode SFXPlayList::transitionOut[16]

Behavior when moving out of this slot.

After the detailTimeOut has expired (if any), this slot determines what the controller will do before moving on to the next slot.

float SFXPlayList::volumeScale[16]

Scale factor to apply to volume of sounds played on this list slot.

This value will scale the actual volume level set on the track assigned to the slot, i.e. a value of 0.5 will cause the track to play at half-volume.

Point2F SFXPlayList::volumeScaleVariance[16]

Bounds on randomization of volumeScale.

Value Randomization

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: SFXProfile Class Reference

SFXProfile Class Reference
[Sound]

Encapsulates a single sound file for playback by the sound system. More...

Inheritance diagram for SFXProfile:
[legend]

List of all members.

Public Member Functions

float | getSoundDuration ()
Return the length of the sound data in seconds.

Public Attributes

Sound

filename | fileName
Path to the sound file.
bool | preload
Whether to preload sound data when the profile is added to system.

Detailed Description

Encapsulates a single sound file for playback by the sound system.

SFXProfile combines a sound description (SFXDescription) with a sound file such that it can be played by the sound system. To be able to play a sound file, the sound system will always require a profile for it to be created. However, several of the SFX functions (sfxPlayOnce(), sfxCreateSource()) perform this creation internally for convenience using temporary profile objects.

Sound files can be in either OGG or WAV format. However, extended format support is available when using FMOD. See Supported Sound File Formats.

Profile Loading

By default, the sound data referenced by a profile will be loaded when the profile is first played and the data then kept until either the profile is deleted or until the sound device on which the sound data is held is deleted.

This initial loading my incur a small delay when the sound is first played. To avoid this, a profile may be expicitly set to load its sound data immediately when the profile is added to the system. This is done by setting the preload property to true.

Note:
Sounds using streamed playback (SFXDescription::isStreaming) cannot be preloaded and will thus ignore the preload flag.
Example:
datablock SFXProfile( Shore01Snd )
{
   fileName     = "art/sound/Lakeshore_mono_01";
   description  = Shore01Looping3d;
   preload      = true;
};

Member Function Documentation

float SFXProfile::getSoundDuration ( )

Return the length of the sound data in seconds.

Returns:
The length of the sound data in seconds or 0 if the sound referenced by the profile could not be found.

Member Data Documentation

filename SFXProfile::fileName

Path to the sound file.

If the extension is left out, it will be inferred by the sound system. This allows to easily switch the sound format without having to go through the profiles and change the filenames there, too.

bool SFXProfile::preload

Whether to preload sound data when the profile is added to system.

Note:
This flag is ignored by streamed sounds.

Profile Loading

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: SFXSound Class Reference

SFXSound Class Reference
[Sound]

A sound controller that directly plays a single sound file. More...

Inheritance diagram for SFXSound:
[legend]

List of all members.

Public Member Functions

float | getDuration ()
Get the total play time (in seconds) of the sound data attached to the sound.
float | getPosition ()
Get the current playback position in seconds.
bool | isReady ()
Test whether the sound data associated with the sound has been fully loaded and is ready for playback.
void | setPosition (float position)
Set the current playback position in seconds.

Detailed Description

A sound controller that directly plays a single sound file.

When playing individual audio files, SFXSounds are implicitly created by the sound system.

Each sound source has an associated play cursor that can be queried and explicitly positioned by the user. The cursor is a floating-point value measured in seconds.

For streamed sources, playback may not be continuous in case the streaming queue is interrupted.

Note:
This class cannot be instantiated directly by the user but rather is implicitly created by the sound system when sfxCreateSource() or sfxPlayOnce() is called on a SFXProfile instance.

Sounds and Voices

To actually emit an audible signal, a sound must allocate a resource on the sound device through which the sound data is being played back. This resource is called 'voice'.

As with other types of resources, the availability of these resources may be restricted, i.e. a given sound device will usually only support a fixed number of voices that are playing at the same time. Since, however, there may be arbitrary many SFXSounds instantiated and playing at the same time, this needs to be solved.

See also:
SFXDescription::priority

Member Function Documentation

float SFXSound::getDuration ( )

Get the total play time (in seconds) of the sound data attached to the sound.

Returns:
Note:
Be aware that for looped sounds, this will not return the total playback time of the sound.
float SFXSound::getPosition ( )

Get the current playback position in seconds.

Returns:
The current play cursor offset.
bool SFXSound::isReady ( )

Test whether the sound data associated with the sound has been fully loaded and is ready for playback.

For streamed sounds, this will be false during playback when the stream queue for the sound is starved and waiting for data. For buffered sounds, only an initial loading phase will potentially cause isReady to return false.

Returns:
True if the sound is ready for playback.
void SFXSound::setPosition ( float position )

Set the current playback position in seconds.

If the source is currently playing, playback will jump to the new position. If playback is stopped or paused, playback will resume at the given position when play() is called.

Parameters:
position The new position of the play cursor (in seconds).


Torque 3D - Script Manual: SFXSource Class Reference

SFXSource Class Reference
[Sound]

Playback controller for a sound source. More...

Inheritance diagram for SFXSource:
[legend]

List of all members.

Public Member Functions

void | addMarker (String name, float pos)
Add a notification marker called name at pos seconds of playback.
void | addParameter (SFXParameter parameter)
Attach parameter to the source,.
float | getAttenuatedVolume ()
Get the final effective volume level of the source.
float | getFadeInTime ()
Get the fade-in time set on the source.
float | getFadeOutTime ()
Get the fade-out time set on the source.
SFXParameter | getParameter (int index)
Get the parameter at the given index.
int | getParameterCount ()
Get the number of SFXParameters that are attached to the source.
float | getPitch ()
Get the pitch scale of the source.
SFXStatus getStatus ()
Get the current playback status.
float | getVolume ()
Get the current base volume level of the source.
bool | isPaused ()
Test whether the source is currently paused.
bool | isPlaying ()
Test whether the source is currently playing.
bool | isStopped ()
Test whether the source is currently stopped.
void | pause (float fadeOutTime=-1.f)
Pause playback of the source.
void | removeParameter (SFXParameter parameter)
Detach parameter from the source.
void | setCone (float innerAngle, float outerAngle, float outsideVolume)
Set up the 3D volume cone for the source.
void | setFadeTimes (float fadeInTime, float fadeOutTime)
Set the fade time parameters of the source.
void | setPitch (float pitch)
Set the pitch scale of the source.
void | setTransform (Point3F position, Point3F direction) void setTransform(Point3F position) void play(float fadeInTime
Start playback of the source.
void | setVolume (float volume)
Set the base volume level for the source.
void | stop (float fadeOutTime=-1.f)
Stop playback of the source.
Callbacks

void | onParameterValueChange (SFXParameter parameter)
Called when a parameter attached to the source changes value.
void | onStatusChange (SFXStatus newStatus)
Called when the playback status of the source changes.

Public Attributes

Sound

SFXDescription description
The playback configuration that determines the initial sound properties and setup.
string | statusCallback
Name of function to call when the status of the source changes.

Detailed Description

Playback controller for a sound source.

All sound playback is driven by SFXSources. Each such source represents an independent playback controller that directly or indirectly affects sound output.

While this class itself is instantiable, such an instance will not by itself emit any sound. This is the responsibility of its subclasses. Note, however, that none of these subclasses must be instantiated directly but must instead be instantiated indirectly through the SFX interface.

Play-Once Sources

Often, a sound source need only exist for the duration of the sound it is playing. In this case so-called "play-once" sources simplify the bookkeeping involved by leaving the deletion of sources that have expired their playtime to the sound system.

Play-once sources can be created in either of two ways:

  • sfxPlayOnce(): Directly create a play-once source from a SFXTrack or file.
  • sfxDeleteWhenStopped(): Retroactively turn any source into a play-once source that will automatically be deleted when moving into stopped state.
See also:
sfxPlayOnce
sfxDeleteWhenStopped

Source Hierarchies

Source are arranged into playback hierarchies where a parent source will scale some of the properties of its children and also hand on any play(), pause(), and stop() commands to them. This allows to easily group sounds into logical units that can then be operated on as a whole.

An example of this is the segregation of sounds according to their use in the game. Volume levels of background music, in-game sound effects, and character voices will usually be controlled independently and putting their sounds into different hierarchies allows to achieve that easily.

The source properties that are scaled by parent values are:

  • volume,
  • pitch, and
  • priority

This means that if a parent has a volume of 0.5, the child will play at half the effective volume it would otherwise have.

Additionally, parents affect the playback state of their children:

  • A parent that is in stopped state will force all its direct and indirect children into stopped state.
  • A parent that is in paused state will force all its direct and indirect children that are playing into paused state. However, children that are in stopped state will not be affected.
  • A parent that is in playing state will not affect the playback state of its children.

Each source maintains a state that is wants to be in which may differ from the state that is enforced on it by its parent. If a parent changes its states in a way that allows a child to move into its desired state, the child will do so.

For logically grouping sources, instantiate the SFXSource class directly and make other sources children to it. A source thus instantiated will not effect any real sound output on its own but will influence the sound output of its direct and indirect children.

Note:
Be aware that the property values used to scale child property values are the effective values. For example, the value used to scale the volume of a child is the effective volume of the parent, i.e. the volume after fades, distance attenuation, etc. has been applied.
See also:
SFXDescription::sourceGroup

Volume Attenuation

During its lifetime, the volume of a source will be continually updated. This update process always progresses in a fixed set of steps to compute the final effective volume of the source based on the base volume level that was either assigned from the SFXDescription associated with the source (SFXDescription::volume) or manually set by the user. The process of finding a source's final effective volume is called "volume attenuation". The steps involved in attenuating a source's volume are (in order):

Fading
If the source currently has a fade-effect applied, the volume is interpolated along the currently active fade curve.
Modulation
If the source is part of a hierarchy, it's volume is scaled according to the effective volume of its parent.
Distance Attenuation
If the source is a 3D sound source, then the volume is interpolated according to the distance model in effect and current listener position and orientation (see 3D Audio).
See also:
SFXDescription::volume
SFXDescription::is3d

Volume Fades

To ease-in and ease-out playback of a sound, fade effects may be applied to sources. A fade will either go from zero volume to full effective volume (fade-in) or from full effective volume to zero volume (fade-out).

Fading is coupled to the play(), pause(), and stop() methods as well as to loop iterations when SFXDescription::fadeLoops is true for the source. play() and the start of a loop iteration will trigger a fade-in whereas pause(), stop() and the end of loop iterations will trigger fade-outs.

For looping sources, if SFXDescription::fadeLoops is false, only the initial play() will trigger a fade-in and no further fading will be applied to loop iterations.

By default, the fade durations will be governed by the SFXDescription::fadeInTime and SFXDescription::fadeOutTime properties of the SFXDescription attached to the source. However, these may be overridden on a per-source basis by setting fade times explicitly with setFadeTimes(). Additionally, the set values may be overridden for individual play(), pause(), and stop() calls by supplying appropriate fadeInTime/fadeOutTime parameters.

By default, volume will interpolate linearly during fades. However, custom interpolation curves can be assigned through the SFXDescription::fadeInEase and SFXDescription::fadeOutTime properties.

See also:
SFXDescription::fadeInTime
SFXDescription::fadeOutTime
SFXDescription::fadeInEase
SFXDescription::fadeOutEase
SFXDescription::fadeLoops

Sound Cones

See also:
SFXDescription::coneInsideAngle
SFXDescription::coneOutsideAngle
SFXDescription::coneOutsideVolume

Doppler Effect

See also:
sfxGetDopplerFactor
sfxSetDopplerFactor
SFXAmbience::dopplerFactor

Playback Markers

Playback markers allow to attach notification triggers to specific playback positions. Once the play cursor crosses a position for which a marker is defined, the onMarkerPassed callback will be triggered on the SFXSource thus allowing to couple script logic to .

Be aware that the precision with which marker callbacks are triggered are bound by global source update frequency. Thus there may be a delay between the play cursor actually passing a marker position and the callback being triggered.

Member Function Documentation

void SFXSource::addMarker | ( | String | name,
 |  | float | pos
 | ) |  |

Add a notification marker called name at pos seconds of playback.

Parameters:
name | Symbolic name for the marker that will be passed to the onMarkerPassed() callback.
pos | Playback position in seconds when the notification should trigger. Note that this is a soft limit and there may be a delay between the play cursor actually passing the position and the callback being triggered.
Note:
For looped sounds, the marker will trigger on each iteration.
Example:
// Create a new source.
$source = sfxCreateSource( AudioMusicLoop2D, "art/sound/backgroundMusic" );

// Assign a class to the source.
$source.class = "BackgroundMusic";

// Add a playback marker at one minute into playback.
$source.addMarker( "first", 60 );

// Define the callback function.  This function will be called when the playback position passes the one minute mark.
function BackgroundMusic::onMarkerPassed( %this, %markerName )
{
   if( %markerName $= "first" )
      echo( "Playback has passed the 60 seconds mark." );
}

// Play the sound.
$source.play();
void SFXSource::addParameter ( SFXParameter parameter )

Attach parameter to the source,.

Once attached, the source will react to value changes of the given parameter. Attaching a parameter will also trigger an initial read-out of the parameter's current value.

Parameters:
parameter The parameter to attach to the source.
float SFXSource::getAttenuatedVolume ( )

Get the final effective volume level of the source.

This method returns the volume level as it is after source group volume modulation, fades, and distance-based volume attenuation have been applied to the base volume level.

Returns:
The effective volume of the source.

Volume Attenuation

float SFXSource::getFadeInTime ( )

Get the fade-in time set on the source.

This will initially be SFXDescription::fadeInTime.

Returns:
The fade-in time set on the source in seconds.
See also:
SFXDescription::fadeInTime

Volume Fades

float SFXSource::getFadeOutTime ( )

Get the fade-out time set on the source.

This will initially be SFXDescription::fadeOutTime.

Returns:
The fade-out time set on the source in seconds.
See also:
SFXDescription::fadeOutTime

Volume Fades

SFXParameter SFXSource::getParameter ( int index )

Get the parameter at the given index.

Parameters:
index Index of the parameter to fetch. Must be 0<=index<=getParameterCount().
Returns:
The parameter at the given index or null if index is out of range.
Example:
// Print the name ofo each parameter attached to %source.
%numParams = %source.getParameterCount();
for( %i = 0; %i < %numParams; %i ++ )
   echo( %source.getParameter( %i ).getParameterName() );
See also:
getParameterCount
int SFXSource::getParameterCount ( )

Get the number of SFXParameters that are attached to the source.

Returns:
The number of parameters attached to the source.
Example:
// Print the name ofo each parameter attached to %source.
%numParams = %source.getParameterCount();
for( %i = 0; %i < %numParams; %i ++ )
   echo( %source.getParameter( %i ).getParameterName() );
See also:
getParameter
addParameter
float SFXSource::getPitch ( )

Get the pitch scale of the source.

Pitch determines the playback speed of the source (default: 1).

Returns:
The current pitch scale factor of the source.
See also:
setPitch
SFXDescription::pitch
SFXStatus SFXSource::getStatus ( )

Get the current playback status.

Returns:
Te current playback status
float SFXSource::getVolume ( )

Get the current base volume level of the source.

This is not the final effective volume that the source is playing at but rather the starting volume level before source group modulation, fades, or distance-based volume attenuation are applied.

Returns:
The current base volume level.
See also:
setVolume
SFXDescription::volume

Volume Attenuation

bool SFXSource::isPaused ( )

Test whether the source is currently paused.

Returns:
True if the source is in paused state, false otherwise.
See also:
pause
getStatus
SFXStatus
bool SFXSource::isPlaying ( )

Test whether the source is currently playing.

Returns:
True if the source is in playing state, false otherwise.
See also:
play
getStatus
SFXStatus
bool SFXSource::isStopped ( )

Test whether the source is currently stopped.

Returns:
True if the source is in stopped state, false otherwise.
See also:
stop
getStatus
SFXStatus
void SFXSource::onParameterValueChange ( SFXParameter parameter )

Called when a parameter attached to the source changes value.

This callback will be triggered before the value change has actually been applied to the source.

Parameters:
parameter The parameter that has changed value.
Note:
This is also triggered when the parameter is first attached to the source.
void SFXSource::onStatusChange ( SFXStatus newStatus )

Called when the playback status of the source changes.

Parameters:
newStatus The new playback status.
void SFXSource::pause ( float fadeOutTime = -1.f )

Pause playback of the source.

Parameters:
fadeOutTime Seconds for the sound to fade down to zero volume. If -1, the SFXDescription::fadeOutTime set in the source's associated description is used. Pass 0 to disable a fade-out effect that may be configured on the description. Be aware that if a fade-out effect is used, the source will not immediately to paused state but will rather remain in playing state until the fade-out time has expired..
void SFXSource::removeParameter ( SFXParameter parameter )

Detach parameter from the source.

Once detached, the source will no longer react to value changes of the given parameter.

If the parameter is not attached to the source, the method will do nothing.

Parameters:
parameter The parameter to detach from the source.
void SFXSource::setCone | ( | float | innerAngle,
 |  | float | outerAngle,
 |  | float | outsideVolume
 | ) |  |

Set up the 3D volume cone for the source.

Parameters:
innerAngle | Angle of the inner sound cone in degrees (SFXDescription::coneInsideAngle). Must be 0<=innerAngle<=360.
outerAngle | Angle of the outer sound cone in degrees (SFXDescription::coneOutsideAngle). Must be 0<=outerAngle<=360.
outsideVolume | Volume scale factor outside of outer cone (SFXDescription::coneOutsideVolume). Must be 0<=outsideVolume<=1.
Note:
This method has no effect on the source if the source is not 3D.
void SFXSource::setFadeTimes | ( | float | fadeInTime,
 |  | float | fadeOutTime
 | ) |  |

Set the fade time parameters of the source.

Parameters:
fadeInTime | The new fade-in time in seconds.
fadeOutTime | The new fade-out time in seconds.
See also:
SFXDescription::fadeInTime
SFXDescription::fadeOutTime

Volume Fades

void SFXSource::setPitch ( float pitch )

Set the pitch scale of the source.

Pitch determines the playback speed of the source (default: 1).

Parameters:
pitch The new pitch scale factor.
See also:
getPitch
SFXDescription::pitch
void SFXSource::setTransform | ( | Point3F | position,
 |  | Point3F | direction
 | ) |  |

Start playback of the source.

Set the position and orientation of the source's 3D sound.

Parameters:
position | The new position in world space.
direction | The forward vector.

Set the position of the source's 3D sound.

Parameters:
position The new position in world space.
Note:
This method has no effect if the source is not a 3D source.

If the sound data for the source has not yet been fully loaded, there will be a delay after calling play and playback will start after the data has become available.

Parameters:
fadeInTime Seconds for the sound to reach full volume. If -1, the SFXDescription::fadeInTime set in the source's associated description is used. Pass 0 to disable a fade-in effect that may be configured on the description.
void SFXSource::setVolume ( float volume )

Set the base volume level for the source.

This volume will be the starting point for source group volume modulation, fades, and distance-based volume attenuation.

Parameters:
volume The new base volume level for the source. Must be 0>=volume<=1.
See also:
getVolume

Volume Attenuation

void SFXSource::stop ( float fadeOutTime = -1.f )

Stop playback of the source.

Parameters:
fadeOutTime Seconds for the sound to fade down to zero volume. If -1, the SFXDescription::fadeOutTime set in the source's associated description is used. Pass 0 to disable a fade-out effect that may be configured on the description. Be aware that if a fade-out effect is used, the source will not immediately transtion to stopped state but will rather remain in playing state until the fade-out time has expired.

Member Data Documentation

SFXDescription SFXSource::description

The playback configuration that determines the initial sound properties and setup.

Any SFXSource must have an associated SFXDescription.

string SFXSource::statusCallback

Name of function to call when the status of the source changes.

The source that had its status changed is passed as the first argument to the function and the new status of the source is passed as the second argument.


Torque 3D - Script Manual: SFXSpace Class Reference

SFXSpace Class Reference
[Sound]

A volume in space that defines an ambient sound zone. More...

Inheritance diagram for SFXSpace:
[legend]

List of all members.

Public Attributes

Internal

string | edge
For internal use only.
string | plane
For internal use only.
string | point
For internal use only.
Sound

SFXAmbience soundAmbience
Ambient sound environment for the space.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A volume in space that defines an ambient sound zone.

Member Data Documentation

string SFXSpace::edge

For internal use only.

bool SFXSpace::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool SFXSpace::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string SFXSpace::plane

For internal use only.

string SFXSpace::point

For internal use only.

SFXAmbience SFXSpace::soundAmbience

Ambient sound environment for the space.


Torque 3D - Script Manual: SFXState Class Reference

SFXState Class Reference
[Sound]

A boolean switch used to modify playlist behavior. More...

Inheritance diagram for SFXState:
[legend]

List of all members.

Public Member Functions

void | activate ()
Increase the activation count on the state.
void | deactivate ()
Decrease the activation count on the state.
void | disable ()
Increase the disabling count of the state.
void | enable ()
Decrease the disabling count of the state.
bool | isActive ()
Test whether the state is currently active.
bool | isDisabled ()
Test whether the state is currently disabled.
Callbacks

void | onActivate ()
Called when the state goes from inactive to active.
void | onDeactivate ()
called when the state goes from active to deactive.

Public Attributes

State

SFXState | excludedStates [4]
States that will automatically be disabled when this state is activated.
SFXState | includedStates [4]
States that will automatically be activated when this state is activated.

Detailed Description

A boolean switch used to modify playlist behavior.

Sound system states are used to allow playlist controllers to make decisions based on global state. This is useful, for example, to couple audio playback to gameplay state. Certain states may, for example, represent different locations that the listener can be in, like underwater, in open space, or indoors. Other states could represent moods of the current gameplay situation, like, for example, an aggressive mood during combat.

By activating and deactivating sound states according to gameplay state, a set of concurrently running playlists may react and adapt to changes in the game.

Activation and Deactivation

At any time, a given state can be either active or inactive. Calling activate() on a state increases an internal counter and calling deactivate() decreases the counter. Only when the count reaches zero will the state be deactivated.

In addition to the activation count, states also maintain a disabling count. Calling disable() increases this count and calling enable() decreases it. As long as this count is greater than zero, a given state will not be activated even if its activation count is non-zero. Calling disable() on an active state will not only increase the disabling count but also deactivate the state. Calling enable() on a state with a positive activation count will re-activate the state when the disabling count reaches zero.

State Dependencies

By listing other states in in its includedStates and excludedStates fields, a state may automatically trigger the activation or disabling of other states in the sytem when it is activated. This allows to form dependency chains between individual states.

Example:
// State indicating that the listener is submerged.
singleton SFXState( AudioLocationUnderwater )
{
   parentGroup = AudioLocation;
   // AudioStateExclusive is a class defined in the core scripts that will automatically
   // ensure for a state to deactivate all the sibling SFXStates in its parentGroup when it
   // is activated.
   className = "AudioStateExclusive";
};

// State suitable e.g. for combat.
singleton SFXState( AudioMoodAggressive )
{
   parentGroup = AudioMood;
   className = "AudioStateExclusive";
};
See also:
SFXPlayList
SFXController
SFXPlayList::state
SFXPlayList::stateMode

Interactive Audio

Member Function Documentation

void SFXState::activate ( )

Increase the activation count on the state.

If the state isn't already active and it is not disabled, the state will be activated.

See also:
isActive
deactivate
void SFXState::deactivate ( )

Decrease the activation count on the state.

If the count reaches zero and the state was not disabled, the state will be deactivated.

See also:
isActive
activate
void SFXState::disable ( )

Increase the disabling count of the state.

If the state is currently active, it will be deactivated.

See also:
isDisabled
void SFXState::enable ( )

Decrease the disabling count of the state.

If the disabling count reaches zero while the activation count is still non-zero, the state will be reactivated again.

See also:
isDisabled
bool SFXState::isActive ( )

Test whether the state is currently active.

This is true when the activation count is >0 and the disabling count is =0.

Returns:
True if the state is currently active.
See also:
activate
bool SFXState::isDisabled ( )

Test whether the state is currently disabled.

This is true when the disabling count of the state is non-zero.

Returns:
True if the state is disabled.
See also:
disable
void SFXState::onActivate ( )

Called when the state goes from inactive to active.

void SFXState::onDeactivate ( )

called when the state goes from active to deactive.

Member Data Documentation

SFXState SFXState::excludedStates[4]

States that will automatically be disabled when this state is activated.

Activation and Deactivation

SFXState SFXState::includedStates[4]

States that will automatically be activated when this state is activated.

Activation and Deactivation

Copyright © GarageGames, LLC. All Rights Reserved.


Torque 3D - Script Manual: SFXTrack Class Reference

SFXTrack Class Reference
[Sound]

Abstract base class for sound data that can be played back by the sound system. More...

Inheritance diagram for SFXTrack:
[legend]

List of all members.

Public Attributes

Sound

SFXDescription description
Playback setup description for this track.
string parameters [8]
Parameters to automatically attach to SFXSources created from this track.

Detailed Description

Abstract base class for sound data that can be played back by the sound system.

The term "track" is used in the sound system to refer to any entity that can be played back as a sound source. These can be individual files (SFXProfile), patterns of other tracks (SFXPlayList), or special sound data defined by a device layer (SFXFMODEvent).

Any track must be paired with a SFXDescription that tells the sound system how to set up playback for the track.

All objects that are of type SFXTrack will automatically be added to SFXTrackSet.

Note:
This class cannot be instantiated directly.

Member Data Documentation

SFXDescription SFXTrack::description

Playback setup description for this track.

If unassigned, the description named "AudioEffects" will automatically be assigned to the track. If this description is not defined, track creation will fail.

string SFXTrack::parameters[8]

Parameters to automatically attach to SFXSources created from this track.

Individual parameters are identified by their internalName.


Torque 3D - Script Manual: ShaderData Class Reference

ShaderData Class Reference
[Shaders]

Special type of data block that stores information about a handwritten shader. More...

Inheritance diagram for ShaderData:
[legend]

List of all members.

Public Member Functions

void | reload ()
Rebuilds all the vertex and pixel shaders instances created from this ShaderData.

Public Attributes

string | defines
A semicolon, tab, or newline delimited string of case sensitive defines that are passed to the shader compiler.
filename | DXPixelShaderFile
Indicates a filename that contains a DirectX pixel shader program.
filename | DXVertexShaderFile
Indicates a filename that contains a DirectX vertex shader program.
filename | OGLPixelShaderFile
Indicates a filename that contains a DirectX pixel shader program.
filename | OGLVertexShaderFile
Indicates a filename that contains an OpenGL vertex shader program.
float | pixVersion
This indicates what target level of shader should be compiled.
bool | useDevicePixVersion
True to use the maximum pixel shader version offered by the graphics card, rather than manually specifying the version in script.

Detailed Description

Special type of data block that stores information about a handwritten shader.

To use hand written shaders, a ShaderData datablock must be used. This datablock refers only to the vertex and pixel shader filenames and a hardware target level. Shaders are API specific, so DirectX and OpenGL shaders must be explicitly identified.

Example:
// Used for the procedural clould system
singleton ShaderData( CloudLayerShader )
{
   DXVertexShaderFile   = "shaders/common/cloudLayerV.hlsl";
   DXPixelShaderFile    = "shaders/common/cloudLayerP.hlsl";
   OGLVertexShaderFile = "shaders/common/gl/cloudLayerV.glsl";
   OGLPixelShaderFile = "shaders/common/gl/cloudLayerP.glsl";
   pixVersion = 2.0;
};

Member Function Documentation

void ShaderData::reload ( )

Rebuilds all the vertex and pixel shaders instances created from this ShaderData.

Example:
// Rebuild the shader instances from ShaderData CloudLayerShader
CloudLayerShader.reload();

Member Data Documentation

string ShaderData::defines

A semicolon, tab, or newline delimited string of case sensitive defines that are passed to the shader compiler.

filename ShaderData::DXPixelShaderFile

Indicates a filename that contains a DirectX pixel shader program.

It must contain only one program and no vertex shader, just the pixel shader. It can be either an HLSL or assembly level shader. The former must have a filename extension of .hlsl, otherwise it assumes it is an assembly file.

filename ShaderData::DXVertexShaderFile

Indicates a filename that contains a DirectX vertex shader program.

It must contain only one program and no pixel shader, just the vertex shader.It can be either an HLSL or assembly level shader. The former must have a filename extension of .hlsl, otherwise it assumes it is an assembly file.

filename ShaderData::OGLPixelShaderFile

Indicates a filename that contains a DirectX pixel shader program.

It must contain only one program and no vertex shader, just the pixel shader.

filename ShaderData::OGLVertexShaderFile

Indicates a filename that contains an OpenGL vertex shader program.

It must contain only one program and no pixel shader, just the vertex shader.

float ShaderData::pixVersion

This indicates what target level of shader should be compiled.

Valid numbers at the time of this writing are 1.1, 1.4, 2.0, and 3.0. The shader will not run properly if your hardware does not support the level of shader you have compiled.

bool ShaderData::useDevicePixVersion

True to use the maximum pixel shader version offered by the graphics card, rather than manually specifying the version in script.


Torque 3D - Script Manual: ShapeBase Class Reference

ShapeBase Class Reference
[Game Objects]

A scriptable, renderable shape. More...

Inheritance diagram for ShapeBase:
[legend]

List of all members.

Public Member Functions

void | applyDamage (float amount)
Increment the current damage level by the specified amount.
bool | applyImpulse (Point3F pos, Point3F vec)
Apply an impulse to the object.
void | applyRepair (float amount)
Repair damage by the specified amount.
bool | canCloak ()
Check if this object can cloak.
void | changeMaterial (string mapTo, Material oldMat, Material newMat)
Change one of the materials on the shape.
bool | destroyThread (int slot)
Destroy an animation thread, which prevents it from playing.
void | dumpMeshVisibility ()
Print a list of visible and hidden meshes in the shape to the console for debugging purposes.
Point3F | getAIRepairPoint ()
Get the position at which the AI should stand to repair things.
float | getCameraFov ()
Returns the vertical field of view in degrees for this object if used as a camera.
int | getControllingClient ()
Get the client (if any) that controls this object.
int | getControllingObject ()
Get the object (if any) that controls this object.
float | getDamageFlash ()
Get the damage flash level.
float | getDamageLevel ()
Get the object's current damage level.
float | getDamagePercent ()
Get the object's current damage level as a percentage of maxDamage.
string | getDamageState ()
Get the object's damage state.
float | getDefaultCameraFov ()
Returns the default vertical field of view in degrees for this object if used as a camera.
float | getEnergyLevel ()
Get the object's current energy level.
float | getEnergyPercent ()
Get the object's current energy level as a percentage of maxEnergy.
Point3F | getEyePoint ()
Get the position of the 'eye' for this object.
TransformF | getEyeTransform ()
Get the 'eye' transform for this object.
VectorF | getEyeVector ()
Get the forward direction of the 'eye' for this object.
bool | getImageAltTrigger (int slot)
Get the alt trigger state of the Image mounted in the specified slot.
bool | getImageAmmo (int slot)
Get the ammo state of the Image mounted in the specified slot.
bool | getImageLoaded (int slot)
Get the loaded state of the Image mounted in the specified slot.
int | getImageSkinTag (int slot)
Get the skin tag ID for the Image mounted in the specified slot.
string | getImageState (int slot)
Get the name of the current state of the Image in the specified slot.
bool | getImageTrigger (int slot)
Get the trigger state of the Image mounted in the specified slot.
string | getLookAtPoint (float distance=2000, int typeMask=0xFFFFFFFF)
Get the world position this object is looking at.
string | getModelFile ()
Get the model filename used by this shape.
int | getMountedImage (int slot)
Get the Image mounted in the specified slot.
int | getMountSlot (ShapeBaseImageData image)
Get the first slot the given datablock is mounted to on this object.
Point3F | getMuzzlePoint (int slot)
Get the muzzle position of the Image mounted in the specified slot.
VectorF | getMuzzleVector (int slot)
Get the muzzle vector of the Image mounted in the specified slot.
int | getPendingImage (int slot)
Get the Image that will be mounted next in the specified slot.
float | getRechargeRate ()
Get the current recharge rate.
float | getRepairRate ()
Get the per-tick repair amount.
string | getShapeName ()
Get the name of the shape.
string | getSkinName ()
Get the name of the skin applied to this shape.
TransformF | getSlotTransform (int slot)
Get the world transform of the specified mount slot.
int | getTargetCount ()
Get the number of materials in the shape.
string | getTargetName (int index)
Get the name of the indexed shape material.
VectorF | getVelocity ()
Get the object's current velocity.
float | getWhiteOut ()
Get the white-out level.
bool | isCloaked ()
Check if this object is cloaked.
bool | isDestroyed ()
Check if the object is in the Destroyed damage state.
bool | isDisabled ()
Check if the object is in the Disabled or Destroyed damage state.
bool | isEnabled ()
Check if the object is in the Enabled damage state.
bool | isHidden ()
Check if the object is hidden.
bool | isImageFiring (int slot)
Check if the current Image state is firing.
bool | isImageMounted (ShapeBaseImageData image)
Check if the given datablock is mounted to any slot on this object.
bool | mountImage (ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="")
Mount a new Image.
bool | pauseThread (int slot)
Pause an animation thread.
bool | playAudio (int slot, SFXTrack track)
Attach a sound to this shape and start playing it.
bool | playThread (int slot, string name="")
Start a new animation thread, or restart one that has been paused or stopped.
void | setAllMeshesHidden (bool hide)
Set the hidden state on all the shape meshes.
void | setCameraFov (float fov)
Set the vertical field of view in degrees for this object if used as a camera.
void | setCloaked (bool cloak)
Set the cloaked state of this object.
void | setDamageFlash (float level)
Set the damage flash level.
void | setDamageLevel (float level)
Set the object's current damage level.
bool | setDamageState (string state)
Set the object's damage state.
void | setDamageVector (Point3F vec)
Set the damage direction vector.
void | setEnergyLevel (float level)
Set this object's current energy level.
void | setHidden (bool show)
Add or remove this object from the scene.
bool | setImageAltTrigger (int slot, bool state)
Set the alt trigger state of the Image mounted in the specified slot.
bool | setImageAmmo (int slot, bool state)
Set the ammo state of the Image mounted in the specified slot.
bool | setImageLoaded (int slot, bool state)
Set the loaded state of the Image mounted in the specified slot.
bool | setImageTrigger (int slot, bool state)
Set the trigger state of the Image mounted in the specified slot.
void | setInvincibleMode (float time, float speed)
Setup the invincible effect.
void | setMeshHidden (string name, bool hide)
Set the hidden state on the named shape mesh.
void | setRechargeRate (float rate)
Set the recharge rate.
void | setRepairRate (float rate)
Set amount to repair damage by each tick.
void | setShapeName (string name)
Set the name of this shape.
void | setSkinName (string name)
Apply a new skin to this shape.
bool | setThreadDir (int slot, bool fwd)
Set the playback direction of an animation thread.
bool | setThreadTimeScale (int slot, float scale)
Set the playback time scale of an animation thread.
bool | setVelocity (Point3F vel)
Set the object's velocity.
void | setWhiteOut (float level)
Set the white-out level.
void | startFade (int time, int delay, bool fadeOut)
Fade the object in or out without removing it from the scene.
bool | stopAudio (int slot)
Stop a sound started with playAudio.
bool | stopThread (int slot)
Stop an animation thread.
bool | unmountImage (int slot)
Unmount the mounted Image in the specified slot.
Callbacks

float | validateCameraFov (float fov)
Called on the server when the client has requested a FOV change.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A scriptable, renderable shape.

ShapeBase is the renderable shape from which most of the scriptable, game objects are derived, including the Player, Vehicle and Item classes. ShapeBase provides collision detection, audio channels, and animation as well as damage (and damage states), energy, and the ability to mount Images and objects.

ShapeBase objects are not normally instantiated in the scene; derived classes such as Player, WheeledVehicle, and, StaticShape are used instead. But ShapeBase (and the associated datablock, ShapeBaseData) may be used to provide functionality common to all derived objects.

A ShapeBase object consists of a DTS or DAE shape file. This file has the following requirements:

  • Nodes

    cam
    This node is used as the 3rd person camera position. If this is not found the 'eye' node is used instead.
    eye
    This node is used as the 1st person camera position.
    ear
    This node is where the SFX listener is mounted on. If this is not found the 'eye' node is used instead.
    mountN
    Nodes used for mounting ShapeBaseImages to this object. N is an integer from 0 to 31
    AIRepairNode
    This node is where AI should stand to repair the object. If not found, the object's origin is used.

  • Sequences Indicating Condition

    visibility
    A two frame sequence used to show object damage when the object is destroyed (start=no damage, end=destroyed). This sequence is optional.
    damage
    Sequence used to show object damage, such as a vehicle getting more dents (start=no damage, end=fully damaged). When the pbject is fully destroyed this sequence returns to the start and the visibility sequence kicks in. This sequence is optional.

  • Detail Levels

    collision-N
    Convex geometry used for collision detection. N is a integer from 1 to 8. For classes that support polysoup collision, this geometry need not be convex.
    LOS-N
    Convex geometry used for line-of-sight collision detection. N is an integer from 9 to 16.

Control Object

Generally in a Torque game, each client is in control of a single game object (such as a Player in an FPS game, or a WheeledVehicle in a racing game). In a game where the client has control over multiple objects (such as units in an RTS), the control object may be the Camera that determines the client's view of the world (although in general, the client's camera object does not need to be the same as the control object).

The object controlled by the client is important for several reasons:

  1. The control object receives Moves from the client GameConnection (such as keyboard or gamepad input).
  2. The control object is used to 'scope' the client, that is, to determine what else in the world is significant for the client, and which objects the server should give priority when sending network updates to the client.

Energy/Damage

ShapeBase includes basic enery and damage systems that may be used by derived classes as required. For example, the Player class uses energy to determine whether the character is capabable of running and jumping, which can be used to mimic the character getting tired and having to rest before continuing. The Player class also uses the damage system PlayerData::onDestroyed callback to trigger a death animation. The Vehicle classes use the current damage level to trigger particle emitters, so a vehicle could progressively generate more smoke as it becomes more damaged.

ShapeBase also includes parameters to 'blow up' the object when it is Destroyed (damage level above ShapeBaseData::destroyedLevel). Blowing up an object can generate an explosion and debris, as well as exclude the object from rendering.

Parameters to control the object's energy and damage functionality can be found in the ShapeBaseData datablock.

See also:
ShapeBaseData::maxEnergy
ShapeBaseData::maxDamage

Member Function Documentation

void ShapeBase::applyDamage ( float amount )

Increment the current damage level by the specified amount.

Parameters:
amount value to add to current damage level
bool ShapeBase::applyImpulse | ( | Point3F | pos,
 |  | Point3F | vec
 | ) |  |

Apply an impulse to the object.

Parameters:
pos | world position of the impulse
vec | impulse momentum (velocity * mass)
Returns:
true
void ShapeBase::applyRepair ( float amount )

Repair damage by the specified amount.

Note that the damage level is only reduced by repairRate per tick, so it may take several ticks for the total repair to complete.

Parameters:
amount total repair value (subtracted from damage level over time)
bool ShapeBase::canCloak ( )

Check if this object can cloak.

Returns:
true
Note:
Not implemented as it always returns true.
void ShapeBase::changeMaterial | ( | string | mapTo,
 |  | Material | oldMat,
 |  | Material | newMat
 | ) |  |

Change one of the materials on the shape.

This method changes materials per mapTo with others. The material that is being replaced is mapped to unmapped_mat as a part of this transition.

Note:
Warning, right now this only sort of works. It doesn't do a live update like it should.
Parameters:
mapTo | the name of the material target to remap (from getTargetName)
oldMat | the old Material that was mapped
newMat | the new Material to map
Example:
// remap the first material in the shape
%mapTo = %obj.getTargetName( 0 );
%obj.changeMaterial( %mapTo, 0, MyMaterial );
bool ShapeBase::destroyThread ( int slot )

Destroy an animation thread, which prevents it from playing.

Parameters:
slot thread slot to destroy
Returns:
true if successful, false if failed
See also:
playThread
void ShapeBase::dumpMeshVisibility ( )

Print a list of visible and hidden meshes in the shape to the console for debugging purposes.

Note:
Only in a SHIPPING build.
Point3F ShapeBase::getAIRepairPoint ( )

Get the position at which the AI should stand to repair things.

If the shape defines a node called "AIRepairNode", this method will return the current world position of that node, otherwise "0 0 0".

Returns:
the AI repair position
float ShapeBase::getCameraFov ( )

Returns the vertical field of view in degrees for this object if used as a camera.

Returns:
current FOV as defined in ShapeBaseData::cameraDefaultFov
int ShapeBase::getControllingClient ( )

Get the client (if any) that controls this object.

The controlling client is the one that will send moves to us to act on.

Returns:
the ID of the controlling GameConnection, or 0 if this object is not controlled by any client.
See also:
GameConnection
int ShapeBase::getControllingObject ( )

Get the object (if any) that controls this object.

Returns:
the ID of the controlling ShapeBase object, or 0 if this object is not controlled by another object.
float ShapeBase::getDamageFlash ( )

Get the damage flash level.

Returns:
flash level
See also:
setDamageFlash
float ShapeBase::getDamageLevel ( )

Get the object's current damage level.

Returns:
damage level
See also:
setDamageLevel()
float ShapeBase::getDamagePercent ( )

Get the object's current damage level as a percentage of maxDamage.

Returns:
damageLevel / datablock.maxDamage
See also:
setDamageLevel()
string ShapeBase::getDamageState ( )

Get the object's damage state.

Returns:
the damage state; one of "Enabled", "Disabled", "Destroyed"
See also:
setDamageState()
float ShapeBase::getDefaultCameraFov ( )

Returns the default vertical field of view in degrees for this object if used as a camera.

Returns:
Default FOV
float ShapeBase::getEnergyLevel ( )

Get the object's current energy level.

Returns:
energy level
See also:
setEnergyLevel()
float ShapeBase::getEnergyPercent ( )

Get the object's current energy level as a percentage of maxEnergy.

Returns:
energyLevel / datablock.maxEnergy
See also:
setEnergyLevel()
Point3F ShapeBase::getEyePoint ( )

Get the position of the 'eye' for this object.

If the object model has a node called 'eye', this method will return that node's current world position, otherwise it will return the object's current world position.

Returns:
the eye position for this object
See also:
getEyeVector
getEyeTransform
TransformF ShapeBase::getEyeTransform ( )

Get the 'eye' transform for this object.

If the object model has a node called 'eye', this method will return that node's current transform, otherwise it will return the object's current transform.

Returns:
the eye transform for this object
See also:
getEyeVector
getEyePoint
VectorF ShapeBase::getEyeVector ( )

Get the forward direction of the 'eye' for this object.

If the object model has a node called 'eye', this method will return that node's current forward direction vector, otherwise it will return the object's current forward direction vector.

Returns:
the eye vector for this object
See also:
getEyePoint
getEyeTransform
bool ShapeBase::getImageAltTrigger ( int slot )

Get the alt trigger state of the Image mounted in the specified slot.

Parameters:
slot Image slot to query
Returns:
the Image's current alt trigger state
bool ShapeBase::getImageAmmo ( int slot )

Get the ammo state of the Image mounted in the specified slot.

Parameters:
slot Image slot to query
Returns:
the Image's current ammo state
bool ShapeBase::getImageLoaded ( int slot )

Get the loaded state of the Image mounted in the specified slot.

Parameters:
slot Image slot to query
Returns:
the Image's current loaded state
int ShapeBase::getImageSkinTag ( int slot )

Get the skin tag ID for the Image mounted in the specified slot.

Parameters:
slot Image slot to query
Returns:
the skinTag value passed to mountImage when the image was mounted
string ShapeBase::getImageState ( int slot )

Get the name of the current state of the Image in the specified slot.

Parameters:
slot Image slot to query
Returns:
name of the current Image state, or "Error" if slot is invalid
bool ShapeBase::getImageTrigger ( int slot )

Get the trigger state of the Image mounted in the specified slot.

Parameters:
slot Image slot to query
Returns:
the Image's current trigger state
string ShapeBase::getLookAtPoint | ( | float | distance = 2000,
 |  | int | typeMask = 0xFFFFFFFF
 | ) |  |

Get the world position this object is looking at.

Casts a ray from the eye and returns information about what the ray hits.

Parameters:
distance | maximum distance of the raycast
typeMask | typeMask of objects to include for raycast collision testing
Returns:
look-at information as "Object HitX HitY HitZ [Material]" or empty string for no hit
Example:
%lookat = %obj.getLookAtPoint();
echo( "Looking at: " @ getWords( %lookat, 1, 3 ) );
string ShapeBase::getModelFile ( )

Get the model filename used by this shape.

Returns:
the shape filename
int ShapeBase::getMountedImage ( int slot )

Get the Image mounted in the specified slot.

Parameters:
slot Image slot to query
Returns:
ID of the ShapeBaseImageData datablock mounted in the slot, or 0 if no Image is mounted there.
int ShapeBase::getMountSlot ( ShapeBaseImageData image )

Get the first slot the given datablock is mounted to on this object.

Parameters:
image ShapeBaseImageData datablock to query
Returns:
index of the first slot the Image is mounted in, or -1 if the Image is not mounted in any slot on this object.
Point3F ShapeBase::getMuzzlePoint ( int slot )

Get the muzzle position of the Image mounted in the specified slot.

If the Image shape contains a node called 'muzzlePoint', then the muzzle position is the position of that node in world space. If no such node is specified, the slot's mount node is used instead.

Parameters:
slot Image slot to query
Returns:
the muzzle position, or "0 0 0" if the slot is invalid
VectorF ShapeBase::getMuzzleVector ( int slot )

Get the muzzle vector of the Image mounted in the specified slot.

If the Image shape contains a node called 'muzzlePoint', then the muzzle vector is the forward direction vector of that node's transform in world space. If no such node is specified, the slot's mount node is used instead.

If the correctMuzzleVector and firstPerson flags are set in the Image, the muzzle vector is computed to point at whatever object is right in front of the object's 'eye' node.

Parameters:
slot Image slot to query
Returns:
the muzzle vector, or "0 1 0" if the slot is invalid
int ShapeBase::getPendingImage ( int slot )

Get the Image that will be mounted next in the specified slot.

Calling mountImage when an Image is already mounted does one of two things:

  1. Mount the new Image immediately, the old Image is discarded and whatever state it was in is ignored.
  2. If the current Image state does not allow Image changes, the new Image is marked as pending, and will not be mounted until the current state completes. eg. if the user changes weapons, you may wish to ensure that the current weapon firing state plays to completion first.

This command retrieves the ID of the pending Image (2nd case above).

Parameters:
slot Image slot to query
Returns:
ID of the pending ShapeBaseImageData datablock, or 0 if none.
float ShapeBase::getRechargeRate ( )

Get the current recharge rate.

Returns:
the recharge rate (per tick)
See also:
setRechargeRate()
float ShapeBase::getRepairRate ( )

Get the per-tick repair amount.

Returns:
the current value to be subtracted from damage level each tick
See also:
setRepairRate
string ShapeBase::getShapeName ( )

Get the name of the shape.

Note:
This is the name of the shape object that is sent to the client, not the DTS or DAE model filename.
Returns:
the name of the shape
See also:
setShapeName()
string ShapeBase::getSkinName ( )

Get the name of the skin applied to this shape.

Returns:
the name of the skin
See also:
setSkinName()
TransformF ShapeBase::getSlotTransform ( int slot )

Get the world transform of the specified mount slot.

Parameters:
slot Image slot to query
Returns:
the mount transform
int ShapeBase::getTargetCount ( )

Get the number of materials in the shape.

Returns:
the number of materials in the shape.
See also:
getTargetName()
string ShapeBase::getTargetName ( int index )

Get the name of the indexed shape material.

Parameters:
index index of the material to get (valid range is 0 - getTargetCount()-1).
Returns:
the name of the indexed material.
See also:
getTargetCount()
VectorF ShapeBase::getVelocity ( )

Get the object's current velocity.

Returns:
the current velocity

Reimplemented in Camera.

float ShapeBase::getWhiteOut ( )

Get the white-out level.

Returns:
white-out level
See also:
setWhiteOut
bool ShapeBase::isCloaked ( )

Check if this object is cloaked.

Returns:
true if cloaked, false if not
See also:
setCloaked()
bool ShapeBase::isDestroyed ( )

Check if the object is in the Destroyed damage state.

Returns:
true if damage state is "Destroyed", false if not
See also:
isDisabled()
isEnabled()
bool ShapeBase::isDisabled ( )

Check if the object is in the Disabled or Destroyed damage state.

Returns:
true if damage state is not "Enabled", false if it is
See also:
isDestroyed()
isEnabled()
bool ShapeBase::isEnabled ( )

Check if the object is in the Enabled damage state.

Returns:
true if damage state is "Enabled", false if not
See also:
isDestroyed()
isDisabled()
bool ShapeBase::isHidden ( )

Check if the object is hidden.

Returns:
true if the object is hidden, false if visible.
bool ShapeBase::isImageFiring ( int slot )

Check if the current Image state is firing.

Parameters:
slot Image slot to query
Returns:
true if the current Image state in this slot has the 'stateFire' flag set.
bool ShapeBase::isImageMounted ( ShapeBaseImageData image )

Check if the given datablock is mounted to any slot on this object.

Parameters:
image ShapeBaseImageData datablock to query
Returns:
true if the Image is mounted to any slot, false otherwise.
bool ShapeBase::mountImage | ( | ShapeBaseImageData | image,
 |  | int | slot,
 |  | bool | loaded = true,
 |  | string | skinTag = ""
 | ) |  |

Mount a new Image.

Parameters:
image | the Image to mount
slot | Image slot to mount into (valid range is 0 - 3)
loaded | initial loaded state for the Image
skinTag | tagged string to reskin the mounted Image
Returns:
true if successful, false if failed
Example:
%player.mountImage( PistolImage, 1 );
%player.mountImage( CrossbowImage, 0, false );
%player.mountImage( RocketLauncherImage, 0, true, 'blue' );
See also:
unmountImage()
getMountedImage()
getPendingImage()
isImageMounted()
bool ShapeBase::pauseThread ( int slot )

Pause an animation thread.

If restarted using playThread, the animation will resume from the paused position.

Parameters:
slot thread slot to stop
Returns:
true if successful, false if failed
See also:
playThread
bool ShapeBase::playAudio | ( | int | slot,
 |  | SFXTrack | track
 | ) |  |

Attach a sound to this shape and start playing it.

Parameters:
slot | Audio slot index for the sound (valid range is 0 - 3)
track | SFXTrack to play
Returns:
true if the sound was attached successfully, false if failed
See also:
stopAudio()
bool ShapeBase::playThread | ( | int | slot,
 |  | string | name = ""
 | ) |  |

Start a new animation thread, or restart one that has been paused or stopped.

Parameters:
slot | thread slot to play. Valid range is 0 - 3)
name | name of the animation sequence to play in this slot. If not specified, the paused or stopped thread in this slot will be resumed.
Returns:
true if successful, false if failed
Example:
%obj.playThread( 0, "ambient" );      // Play the ambient sequence in slot 0
%obj.setThreadTimeScale( 0, 0.5 );    // Play at half-speed
%obj.pauseThread( 0 );                // Pause the sequence
%obj.playThread( 0 );                 // Resume playback
%obj.playThread( 0, "spin" );         // Replace the sequence in slot 0
See also:
pauseThread()
stopThread()
setThreadDir()
setThreadTimeScale()
destroyThread()
void ShapeBase::setAllMeshesHidden ( bool hide )

Set the hidden state on all the shape meshes.

This allows you to hide all meshes in the shape, for example, and then only enable a few.

Parameters:
hide new hidden state for all meshes
void ShapeBase::setCameraFov ( float fov )

Set the vertical field of view in degrees for this object if used as a camera.

Parameters:
fov new FOV value
void ShapeBase::setCloaked ( bool cloak )

Set the cloaked state of this object.

When an object is cloaked it is not rendered.

Parameters:
cloak true to cloak the object, false to uncloak
See also:
isCloaked()
void ShapeBase::setDamageFlash ( float level )

Set the damage flash level.

Damage flash may be used as a postfx effect to flash the screen when the client is damaged.

Note:
Relies on the flash postFx.
Parameters:
level flash level (0-1)
See also:
getDamageFlash()
void ShapeBase::setDamageLevel ( float level )

Set the object's current damage level.

Parameters:
level new damage level
See also:
getDamageLevel()
getDamagePercent()
bool ShapeBase::setDamageState ( string state )

Set the object's damage state.

Parameters:
state should be one of "Enabled", "Disabled", "Destroyed"
Returns:
true if successful, false if failed
See also:
getDamageState()
void ShapeBase::setDamageVector ( Point3F vec )

Set the damage direction vector.

Currently this is only used to initialise the explosion if this object is blown up.

Parameters:
vec damage direction vector
Example:
%obj.setDamageVector( "0 0 1" );
void ShapeBase::setEnergyLevel ( float level )

Set this object's current energy level.

Parameters:
level new energy level
See also:
getEnergyLevel()
getEnergyPercent()
void ShapeBase::setHidden ( bool show )

Add or remove this object from the scene.

When removed from the scene, the object will not be processed or rendered.

Parameters:
show False to hide the object, true to re-show it

Reimplemented from SimObject.

bool ShapeBase::setImageAltTrigger | ( | int | slot,
 |  | bool | state
 | ) |  |

Set the alt trigger state of the Image mounted in the specified slot.

Parameters:
slot | Image slot to modify
state | new alt trigger state for the Image
Returns:
the Image's new alt trigger state
bool ShapeBase::setImageAmmo | ( | int | slot,
 |  | bool | state
 | ) |  |

Set the ammo state of the Image mounted in the specified slot.

Parameters:
slot | Image slot to modify
state | new ammo state for the Image
Returns:
the Image's new ammo state
bool ShapeBase::setImageLoaded | ( | int | slot,
 |  | bool | state
 | ) |  |

Set the loaded state of the Image mounted in the specified slot.

Parameters:
slot | Image slot to modify
state | new loaded state for the Image
Returns:
the Image's new loaded state
bool ShapeBase::setImageTrigger | ( | int | slot,
 |  | bool | state
 | ) |  |

Set the trigger state of the Image mounted in the specified slot.

Parameters:
slot | Image slot to modify
state | new trigger state for the Image
Returns:
the Image's new trigger state
void ShapeBase::setInvincibleMode | ( | float | time,
 |  | float | speed
 | ) |  |

Setup the invincible effect.

This effect is used for HUD feedback to the user that they are invincible.

Note:
Currently not implemented
Parameters:
time | duration in seconds for the invincible effect
speed | speed at which the invincible effect progresses
void ShapeBase::setMeshHidden | ( | string | name,
 |  | bool | hide
 | ) |  |

Set the hidden state on the named shape mesh.

Parameters:
name | name of the mesh to hide/show
hide | new hidden state for the mesh
void ShapeBase::setRechargeRate ( float rate )

Set the recharge rate.

The recharge rate is added to the object's current energy level each tick, up to the maxEnergy level set in the ShapeBaseData datablock.

Parameters:
rate the recharge rate (per tick)
See also:
getRechargeRate()
void ShapeBase::setRepairRate ( float rate )

Set amount to repair damage by each tick.

Note that this value is separate to the repairRate field in ShapeBaseData. This value will be subtracted from the damage level each tick, whereas the ShapeBaseData field limits how much of the applyRepair value is subtracted each tick. Both repair types can be active at the same time.

Parameters:
rate value to subtract from damage level each tick (must be > 0)
See also:
getRepairRate()
void ShapeBase::setShapeName ( string name )

Set the name of this shape.

Note:
This is the name of the shape object that is sent to the client, not the DTS or DAE model filename.
Parameters:
name new name for the shape
See also:
getShapeName()
void ShapeBase::setSkinName ( string name )

Apply a new skin to this shape.

Parameters:
name name of the skin to apply
See also:
getSkinName()
bool ShapeBase::setThreadDir | ( | int | slot,
 |  | bool | fwd
 | ) |  |

Set the playback direction of an animation thread.

Parameters:
slot | thread slot to modify
fwd | true to play the animation forwards, false to play backwards
Returns:
true if successful, false if failed
See also:
playThread()
bool ShapeBase::setThreadTimeScale | ( | int | slot,
 |  | float | scale
 | ) |  |

Set the playback time scale of an animation thread.

Parameters:
slot | thread slot to modify
scale | new thread time scale (1=normal speed, 0.5=half speed etc)
Returns:
true if successful, false if failed
See also:
playThread
bool ShapeBase::setVelocity ( Point3F vel )

Set the object's velocity.

Parameters:
vel new velocity for the object
Returns:
true
void ShapeBase::setWhiteOut ( float level )

Set the white-out level.

White-out may be used as a postfx effect to brighten the screen in response to a game event.

Note:
Relies on the flash postFx.
Parameters:
level flash level (0-1)
See also:
getWhiteOut()
void ShapeBase::startFade | ( | int | time,
 |  | int | delay,
 |  | bool | fadeOut
 | ) |  |

Fade the object in or out without removing it from the scene.

A faded out object is still in the scene and can still be collided with, so if you want to disable collisions for this shape after it fades out use setHidden to temporarily remove this shape from the scene.

Note:
Items have the ability to light their surroundings. When an Item with an active light is fading out, the light it emits is correspondingly reduced until it goes out. Likewise, when the item fades in, the light is turned-up till it reaches it's normal brightntess.
Parameters:
time | duration of the fade effect in ms
delay | delay in ms before the fade effect begins
fadeOut | true to fade-out to invisible, false to fade-in to full visibility
bool ShapeBase::stopAudio ( int slot )

Stop a sound started with playAudio.

Parameters:
slot audio slot index (started with playAudio)
Returns:
true if the sound was stopped successfully, false if failed
See also:
playAudio()
bool ShapeBase::stopThread ( int slot )

Stop an animation thread.

If restarted using playThread, the animation will start from the beginning again.

Parameters:
slot thread slot to stop
Returns:
true if successful, false if failed
See also:
playThread
bool ShapeBase::unmountImage ( int slot )

Unmount the mounted Image in the specified slot.

Parameters:
slot Image slot to unmount
Returns:
true if successful, false if failed
See also:
mountImage()
float ShapeBase::validateCameraFov ( float fov )

Called on the server when the client has requested a FOV change.

When the client requests that its field of view should be changed (because they want to use a sniper scope, for example) this new FOV needs to be validated by the server. This method is called if it exists (it is optional) to validate the requested FOV, and modify it if necessary. This could be as simple as checking that the FOV falls within a correct range, to making sure that the FOV matches the capabilities of the current weapon.

Following this method, ShapeBase ensures that the given FOV still falls within the datablock's cameraMinFov and cameraMaxFov. If that is good enough for your purposes, then you do not need to define the validateCameraFov() callback for your ShapeBase.

Parameters:
fov The FOV that has been requested by the client.
Returns:
The FOV as validated by the server.
See also:
ShapeBaseData

Member Data Documentation

bool ShapeBase::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

Reimplemented in MissionMarker, WayPoint, StaticShape, Vehicle, HoverVehicle, Player, AIPlayer, Camera, Item, SpawnSphere, PathCamera, RigidShape, FlyingVehicle, and WheeledVehicle.

bool ShapeBase::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

Reimplemented in MissionMarker, WayPoint, StaticShape, Vehicle, HoverVehicle, Player, AIPlayer, Camera, Item, SpawnSphere, PathCamera, RigidShape, FlyingVehicle, and WheeledVehicle.


Torque 3D - Script Manual: ShapeBaseData Class Reference

ShapeBaseData Class Reference
[Game Objects]

Defines properties for a ShapeBase object. More...

Inheritance diagram for ShapeBaseData:
[legend]

List of all members.

Public Member Functions

bool | checkDeployPos (TransformF txfm)
Check if there is the space at the given transform is free to spawn into.
TransformF | getDeployTransform (Point3F pos, Point3F normal)
Helper method to get a transform from a position and vector (suitable for use with setTransform).
Callbacks

void | onCollision (ShapeBase obj, SceneObject collObj, VectorF vec, float len)
Called when we collide with another object.
void | onDamage (ShapeBase obj, float delta)
Called when the object is damaged.
void | onDestroyed (ShapeBase obj, string lastState)
Called when the object damage state changes to Destroyed.
void | onDisabled (ShapeBase obj, string lastState)
Called when the object damage state changes to Disabled.
void | onEnabled (ShapeBase obj, string lastState)
Called when the object damage state changes to Enabled.
void | onEndSequence (ShapeBase obj, int slot)
Called when a thread playing a non-cyclic sequence reaches the end of the sequence.
void | onForceUncloak (ShapeBase obj, string reason)
Called when the object is forced to uncloak.
void | onImpact (ShapeBase obj, SceneObject collObj, VectorF vec, float len)
Called when we collide with another object beyond some impact speed.
void | onTrigger (ShapeBase obj, int index, bool state)
Called when a move trigger input changes state.

Public Attributes

Camera

The settings used by the shape when it is the camera.

float | cameraDefaultFov
The default camera vertical FOV in degrees.
float | cameraMaxDist
The maximum distance from the camera to the object.
float | cameraMaxFov
The maximum camera vertical FOV allowed in degrees.
float | cameraMinDist
The minimum distance from the camera to the object.
float | cameraMinFov
The minimum camera vertical FOV allowed in degrees.
bool | firstPersonOnly
Flag controlling whether the view from this object is first person only.
bool | observeThroughObject
Observe this object through its camera transform and default fov.
bool | useEyePoint
Flag controlling whether the client uses this object's eye point to view from.
Misc

bool | computeCRC
If true, verify that the CRC of the client's shape model matches the server's CRC for the shape model when loaded by the client.
Reflection

string | cubeReflectorDesc
References a ReflectorDesc datablock that defines performance and quality properties for dynamic reflections.
Destruction

Parameters related to the destruction effects of this object.

DebrisData Debris
Debris to generate when this shape is blown up.
filename | debrisShapeName
The DTS or DAE model to use for auto-generated breakups.
ExplosionData Explosion
Explosion to generate when this shape is blown up.
bool | renderWhenDestroyed
Whether to render the shape when it is in the "Destroyed" damage state.
ExplosionData underwaterExplosion
Explosion to generate when this shape is blown up underwater.
Physics

float | density
Shape density.
float | drag
Drag factor.
float | mass
Shape mass.
Damage/Energy

float | destroyedLevel
Damage level above which the object is destroyed.
float | disabledLevel
Damage level above which the object is disabled.
bool | inheritEnergyFromMount
Flag controlling whether to manage our own energy level, or to use the energy level of the object we are mounted to.
bool | isInvincible
Invincible flag; when invincible, the object cannot be damaged or repaired.
float | maxDamage
Maximum damage level for this object.
float | maxEnergy
Maximum energy level for this object.
float | repairRate
Rate at which damage is repaired in damage units/tick.
Shadows

bool | shadowEnable
Enable shadows for this shape (currently unused, shadows are always enabled).
float | shadowMaxVisibleDistance
Maximum distance at which shadow is visible (currently unused).
float | shadowProjectionDistance
Maximum height above ground to project shadow. If the object is higher than this no shadow will be rendered.
int | shadowSize
Size of the projected shadow texture (must be power of 2).
float | shadowSphereAdjust
Scalar applied to the radius of spot shadows (initial radius is based on the shape bounds but can be adjusted with this field).
Render

filename | shapeFile
The DTS or DAE model to use for this object.

Detailed Description

Defines properties for a ShapeBase object.

See also:
ShapeBase

Member Function Documentation

bool ShapeBaseData::checkDeployPos ( TransformF txfm )

Check if there is the space at the given transform is free to spawn into.

The shape's bounding box volume is used to check for collisions at the given world transform. Only interior and static objects are checked for collision.

Parameters:
txfm Deploy transform to check
Returns:
True if the space is free, false if there is already something in the way.
Note:
This is a server side only check, and is not actually limited to spawning.
TransformF ShapeBaseData::getDeployTransform | ( | Point3F | pos,
 |  | Point3F | normal
 | ) |  |

Helper method to get a transform from a position and vector (suitable for use with setTransform).

Parameters:
pos | Desired transform position
normal | Vector of desired direction
Returns:
The deploy transform
void ShapeBaseData::onCollision | ( | ShapeBase | obj,
 |  | SceneObject | collObj,
 |  | VectorF | vec,
 |  | float | len
 | ) |  |

Called when we collide with another object.

Parameters:
obj | The ShapeBase object
collObj | The object we collided with
vec | Collision impact vector
len | Length of the impact vector
void ShapeBaseData::onDamage | ( | ShapeBase | obj,
 |  | float | delta
 | ) |  |

Called when the object is damaged.

Parameters:
obj | The ShapeBase object
obj | The ShapeBase object
delta | The amount of damage received.
void ShapeBaseData::onDestroyed | ( | ShapeBase | obj,
 |  | string | lastState
 | ) |  |

Called when the object damage state changes to Destroyed.

Parameters:
obj | The ShapeBase object
lastState | The previous damage state
void ShapeBaseData::onDisabled | ( | ShapeBase | obj,
 |  | string | lastState
 | ) |  |

Called when the object damage state changes to Disabled.

Parameters:
obj | The ShapeBase object
lastState | The previous damage state
void ShapeBaseData::onEnabled | ( | ShapeBase | obj,
 |  | string | lastState
 | ) |  |

Called when the object damage state changes to Enabled.

Parameters:
obj | The ShapeBase object
lastState | The previous damage state
void ShapeBaseData::onEndSequence | ( | ShapeBase | obj,
 |  | int | slot
 | ) |  |

Called when a thread playing a non-cyclic sequence reaches the end of the sequence.

Parameters:
obj | The ShapeBase object
slot | Thread slot that finished playing
void ShapeBaseData::onForceUncloak | ( | ShapeBase | obj,
 |  | string | reason
 | ) |  |

Called when the object is forced to uncloak.

Parameters:
obj | The ShapeBase object
reason | String describing why the object was uncloaked
void ShapeBaseData::onImpact | ( | ShapeBase | obj,
 |  | SceneObject | collObj,
 |  | VectorF | vec,
 |  | float | len
 | ) |  |

Called when we collide with another object beyond some impact speed.

The Player class makes use of this callback when a collision speed is more than PlayerData::minImpactSpeed.

Parameters:
obj | The ShapeBase object
collObj | The object we collided with
vec | Collision impact vector
len | Length of the impact vector
void ShapeBaseData::onTrigger | ( | ShapeBase | obj,
 |  | int | index,
 |  | bool | state
 | ) |  |

Called when a move trigger input changes state.

Parameters:
obj | The ShapeBase object
index | Index of the trigger that changed
state | New state of the trigger

Member Data Documentation

float ShapeBaseData::cameraDefaultFov

The default camera vertical FOV in degrees.

float ShapeBaseData::cameraMaxDist

The maximum distance from the camera to the object.

Used when computing a custom camera transform for this object.

See also:
observeThroughObject
float ShapeBaseData::cameraMaxFov

The maximum camera vertical FOV allowed in degrees.

float ShapeBaseData::cameraMinDist

The minimum distance from the camera to the object.

Used when computing a custom camera transform for this object.

See also:
observeThroughObject
float ShapeBaseData::cameraMinFov

The minimum camera vertical FOV allowed in degrees.

bool ShapeBaseData::computeCRC

If true, verify that the CRC of the client's shape model matches the server's CRC for the shape model when loaded by the client.

string ShapeBaseData::cubeReflectorDesc

References a ReflectorDesc datablock that defines performance and quality properties for dynamic reflections.

DebrisData ShapeBaseData::Debris

Debris to generate when this shape is blown up.

filename ShapeBaseData::debrisShapeName

The DTS or DAE model to use for auto-generated breakups.

Note:
may not be functional.
float ShapeBaseData::density

Shape density.

Used when computing buoyancy when in water.

float ShapeBaseData::destroyedLevel

Damage level above which the object is destroyed.

When the damage level increases above this value, the object damage state is set to "Destroyed".

float ShapeBaseData::disabledLevel

Damage level above which the object is disabled.

Currently unused.

float ShapeBaseData::drag

Drag factor.

Reduces velocity of moving objects.

ExplosionData ShapeBaseData::Explosion

Explosion to generate when this shape is blown up.

bool ShapeBaseData::firstPersonOnly

Flag controlling whether the view from this object is first person only.

bool ShapeBaseData::inheritEnergyFromMount

Flag controlling whether to manage our own energy level, or to use the energy level of the object we are mounted to.

bool ShapeBaseData::isInvincible

Invincible flag; when invincible, the object cannot be damaged or repaired.

float ShapeBaseData::mass

Shape mass.

Used in simulation of moving objects.

float ShapeBaseData::maxDamage

Maximum damage level for this object.

float ShapeBaseData::maxEnergy

Maximum energy level for this object.

bool ShapeBaseData::observeThroughObject

Observe this object through its camera transform and default fov.

If true, when this object is the camera it can provide a custom camera transform and FOV (instead of the default eye transform).

bool ShapeBaseData::renderWhenDestroyed

Whether to render the shape when it is in the "Destroyed" damage state.

float ShapeBaseData::repairRate

Rate at which damage is repaired in damage units/tick.

This value is subtracted from the damage level until it reaches 0.

bool ShapeBaseData::shadowEnable

Enable shadows for this shape (currently unused, shadows are always enabled).

float ShapeBaseData::shadowMaxVisibleDistance

Maximum distance at which shadow is visible (currently unused).

float ShapeBaseData::shadowProjectionDistance

Maximum height above ground to project shadow. If the object is higher than this no shadow will be rendered.

int ShapeBaseData::shadowSize

Size of the projected shadow texture (must be power of 2).

float ShapeBaseData::shadowSphereAdjust

Scalar applied to the radius of spot shadows (initial radius is based on the shape bounds but can be adjusted with this field).

filename ShapeBaseData::shapeFile

The DTS or DAE model to use for this object.

ExplosionData ShapeBaseData::underwaterExplosion

Explosion to generate when this shape is blown up underwater.

bool ShapeBaseData::useEyePoint

Flag controlling whether the client uses this object's eye point to view from.


Torque 3D - Script Manual: ShapeBaseImageData Class Reference

ShapeBaseImageData Class Reference
[Game Objects]

Represents geometry to be mounted to a ShapeBase object. More...

Inheritance diagram for ShapeBaseImageData:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onMount (ShapeBase obj, int slot, float dt)
Called when the Image is first mounted to the object.
void | onUnmount (ShapeBase obj, int slot, float dt)
Called when the Image is unmounted from the object.

Public Attributes

bool | accuFire
Flag to control whether the Image's aim is automatically converged with the crosshair.
Point3F | camShakeAmp
Amplitude of the camera shaking effect.
Point3F | camShakeFreq
Frequency of the camera shaking effect.
DebrisData casing
DebrisData datablock to use for ejected casings.
bool | cloakable
Whether this Image can be cloaked.
bool | computeCRC
If true, verify that the CRC of the client's Image matches the server's CRC for the Image when loaded by the client.
bool | correctMuzzleVector
Flag to adjust the aiming vector to the eye's LOS point.
bool | emap
Whether to enable environment mapping on this Image.
MatrixPosition | eyeOffset
"X Y Z" translation offset from the ShapeBase model's eye node.
MatrixRotation | eyeRotation
"X Y Z ANGLE" rotation offset from the ShapeBase model's eye node.
bool | firstPerson
This flag must be set for the adjusted LOS muzzle vector to be computed.
float | lightBrightness
Brightness of the light this Image emits.
ColorF | lightColor
The color of light this Image emits.
int | lightDuration
Duration in SimTime of Pulsing and WeaponFire type lights.
float | lightRadius
Radius of the light this Image emits.
ShapeBaseImageLightType lightType
The type of light this Image emits.
float | mass
Mass of this Image.
int | maxConcurrentSounds
Maximum number of sounds this Image can play at a time.
float | minEnergy
Minimum Image energy for it to be operable.
int | mountPoint
Mount node # to mount this Image to.
MatrixPosition | offset
"X Y Z" translation offset from this Image's mountPoint node to attach to.
ProjectileData Projectile
The projectile fired by this Image.
MatrixRotation | rotation
"X Y Z ANGLE" rotation offset from this Image's mountPoint node to attach to.
bool | shakeCamera
Flag indicating whether the camera should shake when this Image fires.
filename | shapeFile
The DTS or DAE model to use for this Image.
Point3F | shellExitDir
Vector direction to eject shell casings.
float | shellExitVariance
Variance (in degrees) from the shellExitDir vector to eject casings.
float | shellVelocity
Speed at which to eject casings.
bool | stateAllowImageChange [31]
If false, other Images will temporarily be blocked from mounting while the state machine is executing the tasks in this state.
bool | stateDirection [31]
Direction of the animation to play in this state.
bool | stateEjectShell [31]
If true, a shell casing will be ejected in this state.
ParticleEmitterData | stateEmitter [31]
Emitter to generate particles in this state (from muzzle point or specified node).
string | stateEmitterNode [31]
Name of the node to emit particles from.
float | stateEmitterTime [31]
How long (in seconds) to emit particles on entry to this state.
float | stateEnergyDrain [31]
Amount of energy to subtract from the Image in this state.
bool | stateFire [31]
The first state with this set to true is the state entered by the client when it receives the 'fire' event.
bool | stateIgnoreLoadedForReady [31]
If set to true, and both ready and loaded transitions are true, the ready transition will be taken instead of the loaded transition.
ShapeBaseImageLoadedState | stateLoadedFlag [31]
Set the loaded state of the Image.
caseString | stateName [31]
Name of this state.
ShapeBaseImageRecoilState | stateRecoil [31]
Type of recoil sequence to play on the ShapeBase object on entry to this state.
bool | stateScaleAnimation [31]
If true, the timeScale of the stateSequence animation will be adjusted such that the sequence plays for stateTimeoutValue seconds.
caseString | stateScript [31]
Method to execute on entering this state.
string | stateSequence [31]
Name of the sequence to play on entry to this state.
bool | stateSequenceRandomFlash [31]
If true, a random frame from the muzzle flash sequence will be displayed each frame.
SFXTrack | stateSound [31]
Sound to play on entry to this state.
ShapeBaseImageSpinState | stateSpinThread [31]
Controls how fast the 'spin' animation sequence will be played in this state.
float | stateTimeoutValue [31]
Time in seconds to wait before transitioning to stateTransitionOnTimeout.
string | stateTransitionOnAltTriggerDown [31]
Name of the state to transition to when the alt trigger state of the Image changes to false (alt fire button up).
string | stateTransitionOnAltTriggerUp [31]
Name of the state to transition to when the alt trigger state of the Image changes to true (alt fire button down).
string | stateTransitionOnAmmo [31]
Name of the state to transition to when the ammo state of the Image changes to true.
string | stateTransitionOnLoaded [31]
Name of the state to transition to when the loaded state of the Image changes to 'Loaded'.
string | stateTransitionOnNoAmmo [31]
Name of the state to transition to when the ammo state of the Image changes to false.
string | stateTransitionOnNoTarget [31]
Name of the state to transition to when the Image loses a target.
string | stateTransitionOnNotLoaded [31]
Name of the state to transition to when the loaded state of the Image changes to 'Empty'.
string | stateTransitionOnNotWet [31]
Name of the state to transition to when the Image exits the water.
string | stateTransitionOnTarget [31]
Name of the state to transition to when the Image gains a target.
string | stateTransitionOnTimeout [31]
Name of the state to transition to when we have been in this state for stateTimeoutValue seconds.
string | stateTransitionOnTriggerDown [31]
Name of the state to transition to when the trigger state of the Image changes to false (fire button released).
string | stateTransitionOnTriggerUp [31]
Name of the state to transition to when the trigger state of the Image changes to true (fire button down).
string | stateTransitionOnWet [31]
Name of the state to transition to when the Image enters the water.
bool | stateWaitForTimeout [31]
If false, this state ignores stateTimeoutValue and transitions immediately if other transition conditions are met.
bool | useRemainderDT
If true, allow multiple timeout transitions to occur within a single tick (useful if states have a very small timeout).
bool | usesEnergy
Flag indicating whether this Image uses energy instead of ammo. The energy level comes from the ShapeBase object we're mounted to.

Detailed Description

Represents geometry to be mounted to a ShapeBase object.

Unlike other datablocks, ShapeBaseImageData does not have an associated xBase class associated with it.

Instead, this datablock is an abstraction of geometry that can only be mounted to a ShapeBase object and is only used by a ShapBase object.

The most common use for ShapeBaseImageData objects (referred to as Images hereafter) is for weapons carried by a Player or Vehicle object, and much of the functionality provided by the Image is aimed at that use-case. Images include a powerful state machine to control animations, sounds, script callbacks, and state transitions. This state system is downloaded to the client so that clients can predict state changes and animate accordingly.

The following example - a grenade launcher weapon - demonstates the flexibility of the system. The weapon includes states and transitions to handle the normal ready->fire->reload->ready loop as well as noammo->dryfire for firing when the weapon is out of ammo.

Example:
datablock ShapeBaseImageData( GrenadeLauncherImage )
{
   // Initial start up state
   stateName[0] = "Preactivate";
   stateTransitionOnLoaded[0] = "Activate";
   stateTransitionOnNoAmmo[0] = "NoAmmo";

   // Activating the gun.
   // Called when the weapon is first mounted and there is ammo.
   stateName[1] = "Activate";
   stateTransitionOnTimeout[1] = "Ready";
   stateTimeoutValue[1] = 0.6;
   stateSequence[1] = "Activate";

   // Ready to fire, just waiting for the trigger
   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "CheckWet";
   stateSequence[2] = "Ready";

   // Fire the weapon. Calls the fire script which does the actual work.
   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "PostFire";
   stateTimeoutValue[3] = 0.4;
   stateFire[3] = true;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
   stateSound[3] = GrenadeLauncherFireSound;

   // Check ammo
   stateName[4] = "PostFire";
   stateTransitionOnAmmo[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";

   // Play the reload animation, and transition into
   stateName[5] = "Reload";
   stateTransitionOnTimeout[5] = "Ready";
   stateTimeoutValue[5] = 0.2;
   stateAllowImageChange[5] = false;
   stateSequence[5] = "Reload";
   stateEjectShell[5] = false; // set to true to enable shell casing eject
   stateSound[5] = GrenadeLauncherReloadSound;

   // No ammo in the weapon, just idle until something shows up.
   // Play the dry fire sound if the trigger iS pulled.
   stateName[6] = "NoAmmo";
   stateTransitionOnAmmo[6] = "Reload";
   stateSequence[6] = "NoAmmo";
   stateTransitionOnTriggerDown[6] = "DryFire";

   // No ammo dry fire
   stateName[7] = "DryFire";
   stateTimeoutValue[7] = 1.0;
   stateTransitionOnTimeout[7] = "NoAmmo";
   stateSound[7] = GrenadeLauncherFireEmptySound;

   // Check if wet
   stateName[8] = "CheckWet";
   stateTransitionOnWet[8] = "WetFire";
   stateTransitionOnNotWet[8] = "Fire";

   // Wet fire
   stateName[9] = "WetFire";
   stateTransitionOnTimeout[9] = "PostFire";
   stateTimeoutValue[9] = 0.4;
   stateFire[9] = true;
   stateAllowImageChange[9] = false;
   stateSequence[9] = "Fire";
   stateScript[9] = "onWetFire";
   stateSound[9] = GrenadeLauncherFireSound;
};

Images are mounted into a slot on the target ShapeBase derrived object as shown below.

Example:
$WeaponSlot = 0;

...

// Use a weapon by mounting it onto the given ShapeBase derrived object.
// %data is the weapon whose .image member points to its ShapeBaseImageData datablock
// %obj is the object to mount the weapon on
function Weapon::onUse( %data, %obj )
{
   // Default behavior for all weapons is to mount it into the object's weapon
   // slot, as defined by $WeaponSlot here, and is usually slot 0.  We begin by
   // checking if the requested weapon is already mounted.
   if ( %obj.getMountedImage($WeaponSlot) != %data.image.getId() )
   {
      // The requested weapon is not mounted on $WeaponSlot so mount it now.
      %obj.mountImage( %data.image, $WeaponSlot );
   }
}

The DTS or DAE model used for the Image has the following requirements:

ejectPoint node
Node from which shell casings are emitted
muzzlePoint node
Node used to fire projectiles and particles
retractionPoint node
Nearest point to use as muzzle when up against a wall (and muzzle node is inside wall). This node is optional.
mountPoint node
Where to attach to on this object. If not present the origin of the model will be used.
ambient sequence
Cyclic sequence to play while Image is mounted. This sequence is optional.
spin sequence
Cyclic sequence to play while Image is mounted. This sequence is optional. See ShapeBaseImageSpinState.

Member Function Documentation

void ShapeBaseImageData::onMount | ( | ShapeBase | obj,
 |  | int | slot,
 |  | float | dt
 | ) |  |

Called when the Image is first mounted to the object.

Parameters:
obj | object that this Image has been mounted to
slot | Image mount slot on the object
dt | time remaining in this Image update
void ShapeBaseImageData::onUnmount | ( | ShapeBase | obj,
 |  | int | slot,
 |  | float | dt
 | ) |  |

Called when the Image is unmounted from the object.

Parameters:
obj | object that this Image has been unmounted from
slot | Image mount slot on the object
dt | time remaining in this Image update

Member Data Documentation

bool ShapeBaseImageData::accuFire

Flag to control whether the Image's aim is automatically converged with the crosshair.

Currently unused.

Point3F ShapeBaseImageData::camShakeAmp

Amplitude of the camera shaking effect.

See also:
shakeCamera
Point3F ShapeBaseImageData::camShakeFreq

Frequency of the camera shaking effect.

See also:
shakeCamera
DebrisData ShapeBaseImageData::casing

DebrisData datablock to use for ejected casings.

See also:
stateEjectShell
bool ShapeBaseImageData::cloakable

Whether this Image can be cloaked.

Currently unused.

bool ShapeBaseImageData::computeCRC

If true, verify that the CRC of the client's Image matches the server's CRC for the Image when loaded by the client.

bool ShapeBaseImageData::correctMuzzleVector

Flag to adjust the aiming vector to the eye's LOS point.

See also:
ShapeBase::getMuzzleVector()
bool ShapeBaseImageData::emap

Whether to enable environment mapping on this Image.

MatrixPosition ShapeBaseImageData::eyeOffset

"X Y Z" translation offset from the ShapeBase model's eye node.

When in first person view, this is the offset from the eye node to place the gun. This gives the gun a fixed point in space, typical of a lot of FPS games.

See also:
eyeRotation
MatrixRotation ShapeBaseImageData::eyeRotation

"X Y Z ANGLE" rotation offset from the ShapeBase model's eye node.

When in first person view, this is the rotation from the eye node to place the gun.

See also:
eyeOffset
bool ShapeBaseImageData::firstPerson

This flag must be set for the adjusted LOS muzzle vector to be computed.

See also:
ShapeBase::getMuzzleVector()
float ShapeBaseImageData::lightBrightness

Brightness of the light this Image emits.

Only valid for WeaponFireLight.

See also:
lightType
ColorF ShapeBaseImageData::lightColor

The color of light this Image emits.

See also:
lightType
int ShapeBaseImageData::lightDuration

Duration in SimTime of Pulsing and WeaponFire type lights.

See also:
lightType
float ShapeBaseImageData::lightRadius

Radius of the light this Image emits.

See also:
lightType
ShapeBaseImageLightType ShapeBaseImageData::lightType

The type of light this Image emits.

See also:
ShapeBaseImageLightType
float ShapeBaseImageData::mass

Mass of this Image.

This is added to the total mass of the ShapeBase object.

int ShapeBaseImageData::maxConcurrentSounds

Maximum number of sounds this Image can play at a time.

Any value <= 0 indicates that it can play an infinite number of sounds.

float ShapeBaseImageData::minEnergy

Minimum Image energy for it to be operable.

See also:
usesEnergy
int ShapeBaseImageData::mountPoint

Mount node # to mount this Image to.

This should correspond to a mount# node on the ShapeBase derived object we are mounting to.

MatrixPosition ShapeBaseImageData::offset

"X Y Z" translation offset from this Image's mountPoint node to attach to.

Defaults to "0 0 0". ie. attach this Image's mountPoint node to the ShapeBase model's mount# node without any offset.

See also:
rotation
ProjectileData ShapeBaseImageData::Projectile

The projectile fired by this Image.

MatrixRotation ShapeBaseImageData::rotation

"X Y Z ANGLE" rotation offset from this Image's mountPoint node to attach to.

Defaults to "0 0 0". ie. attach this Image's mountPoint node to the ShapeBase model's mount# node without any additional rotation.

See also:
offset
bool ShapeBaseImageData::shakeCamera

Flag indicating whether the camera should shake when this Image fires.

Note:
Camera shake only works properly if the player is in control of the one and only shapeBase object in the scene which fires an Image that uses camera shake.
filename ShapeBaseImageData::shapeFile

The DTS or DAE model to use for this Image.

Point3F ShapeBaseImageData::shellExitDir

Vector direction to eject shell casings.

See also:
casing
float ShapeBaseImageData::shellExitVariance

Variance (in degrees) from the shellExitDir vector to eject casings.

See also:
shellExitDir
float ShapeBaseImageData::shellVelocity

Speed at which to eject casings.

See also:
casing
bool ShapeBaseImageData::stateAllowImageChange[31]

If false, other Images will temporarily be blocked from mounting while the state machine is executing the tasks in this state.

For instance, if we have a rocket launcher, the player shouldn't be able to switch out while firing. So, you'd set stateAllowImageChange to false in firing states, and true the rest of the time.

bool ShapeBaseImageData::stateDirection[31]

Direction of the animation to play in this state.

True is forward, false is backward.

bool ShapeBaseImageData::stateEjectShell[31]

If true, a shell casing will be ejected in this state.

ParticleEmitterData ShapeBaseImageData::stateEmitter[31]

Emitter to generate particles in this state (from muzzle point or specified node).

See also:
stateEmitterNode
string ShapeBaseImageData::stateEmitterNode[31]

Name of the node to emit particles from.

See also:
stateEmitter
float ShapeBaseImageData::stateEmitterTime[31]

How long (in seconds) to emit particles on entry to this state.

float ShapeBaseImageData::stateEnergyDrain[31]

Amount of energy to subtract from the Image in this state.

Energy is drained at stateEnergyDrain units/tick as long as we are in this state.

See also:
usesEnergy
bool ShapeBaseImageData::stateFire[31]

The first state with this set to true is the state entered by the client when it receives the 'fire' event.

bool ShapeBaseImageData::stateIgnoreLoadedForReady[31]

If set to true, and both ready and loaded transitions are true, the ready transition will be taken instead of the loaded transition.

A state is 'ready' if pressing the fire trigger in that state would transition to the fire state.

ShapeBaseImageLoadedState ShapeBaseImageData::stateLoadedFlag[31]

Set the loaded state of the Image.

  • IgnoreLoaded: Don't change Image loaded state.
  • Loaded: Set Image loaded state to true.
  • NotLoaded: Set Image loaded state to false.
See also:
ShapeBaseImageLoadedState
caseString ShapeBaseImageData::stateName[31]

Name of this state.

ShapeBaseImageRecoilState ShapeBaseImageData::stateRecoil[31]

Type of recoil sequence to play on the ShapeBase object on entry to this state.

  • NoRecoil: Do not play a recoil sequence.
  • LightRecoil: Play the light_recoil sequence.
  • MediumRecoil: Play the medium_recoil sequence.
  • HeavyRecoil: Play the heavy_recoil sequence.
See also:
ShapeBaseImageRecoilState
bool ShapeBaseImageData::stateScaleAnimation[31]

If true, the timeScale of the stateSequence animation will be adjusted such that the sequence plays for stateTimeoutValue seconds.

caseString ShapeBaseImageData::stateScript[31]

Method to execute on entering this state.

Scoped to this image class name, then ShapeBaseImageData. The script callback function takes the same arguments as the onMount callback.

See also:
onMount() for the same arguments as this callback.
string ShapeBaseImageData::stateSequence[31]

Name of the sequence to play on entry to this state.

bool ShapeBaseImageData::stateSequenceRandomFlash[31]

If true, a random frame from the muzzle flash sequence will be displayed each frame.

The name of the muzzle flash sequence is the same as stateSequence, with "_vis" at the end.

SFXTrack ShapeBaseImageData::stateSound[31]

Sound to play on entry to this state.

ShapeBaseImageSpinState ShapeBaseImageData::stateSpinThread[31]

Controls how fast the 'spin' animation sequence will be played in this state.

  • Ignore: No change to the spin sequence.
  • Stop: Stops the spin sequence at its current position.
  • SpinUp: Increase spin sequence timeScale from 0 (on state entry) to 1 (after stateTimeoutValue seconds).
  • SpinDown: Decrease spin sequence timeScale from 1 (on state entry) to 0 (after stateTimeoutValue seconds).
  • FullSpeed: Resume the spin sequence playback at its current position with timeScale=1.
See also:
ShapeBaseImageSpinState
float ShapeBaseImageData::stateTimeoutValue[31]

Time in seconds to wait before transitioning to stateTransitionOnTimeout.

string ShapeBaseImageData::stateTransitionOnAltTriggerDown[31]

Name of the state to transition to when the alt trigger state of the Image changes to false (alt fire button up).

string ShapeBaseImageData::stateTransitionOnAltTriggerUp[31]

Name of the state to transition to when the alt trigger state of the Image changes to true (alt fire button down).

string ShapeBaseImageData::stateTransitionOnAmmo[31]

Name of the state to transition to when the ammo state of the Image changes to true.

string ShapeBaseImageData::stateTransitionOnLoaded[31]

Name of the state to transition to when the loaded state of the Image changes to 'Loaded'.

string ShapeBaseImageData::stateTransitionOnNoAmmo[31]

Name of the state to transition to when the ammo state of the Image changes to false.

string ShapeBaseImageData::stateTransitionOnNoTarget[31]

Name of the state to transition to when the Image loses a target.

string ShapeBaseImageData::stateTransitionOnNotLoaded[31]

Name of the state to transition to when the loaded state of the Image changes to 'Empty'.

string ShapeBaseImageData::stateTransitionOnNotWet[31]

Name of the state to transition to when the Image exits the water.

string ShapeBaseImageData::stateTransitionOnTarget[31]

Name of the state to transition to when the Image gains a target.

string ShapeBaseImageData::stateTransitionOnTimeout[31]

Name of the state to transition to when we have been in this state for stateTimeoutValue seconds.

string ShapeBaseImageData::stateTransitionOnTriggerDown[31]

Name of the state to transition to when the trigger state of the Image changes to false (fire button released).

string ShapeBaseImageData::stateTransitionOnTriggerUp[31]

Name of the state to transition to when the trigger state of the Image changes to true (fire button down).

string ShapeBaseImageData::stateTransitionOnWet[31]

Name of the state to transition to when the Image enters the water.

bool ShapeBaseImageData::stateWaitForTimeout[31]

If false, this state ignores stateTimeoutValue and transitions immediately if other transition conditions are met.

bool ShapeBaseImageData::useRemainderDT

If true, allow multiple timeout transitions to occur within a single tick (useful if states have a very small timeout).

bool ShapeBaseImageData::usesEnergy

Flag indicating whether this Image uses energy instead of ammo. The energy level comes from the ShapeBase object we're mounted to.

See also:
ShapeBase::setEnergyLevel()


Torque 3D - Script Manual: SimDataBlock Class Reference

SimDataBlock Class Reference
[Console]

Root DataBlock class. More...

Inheritance diagram for SimDataBlock:
[legend]

List of all members.

Public Member Functions

void reloadOnLocalClient ()
Reload the datablock. This can only be used with a local client configuration.

Detailed Description

Root DataBlock class.

Introduction

Another powerful aspect of Torque's networking is the datablock. Datablocks are used to provide relatively static information about entities; for instance, what model a weapon should use to display itself, or how heavy a player class is.

This gives significant gains in network efficiency, because it means that all the datablocks on a server can be transferred over the network at client connect time, instead of being intertwined with the update code for NetObjects.

This makes the network code much simpler overall, as one-time initialization code is segregated from the standard object update code, as well as providing several powerful features, which we will discuss momentarily.

preload() and File Downloading

Because datablocks are sent over the wire, using SimDataBlockEvent, before gameplay starts in earnest, we gain in several areas. First, we don't have to try to keep up with the game state while working with incomplete information. Second, we can provide the user with a nice loading screen, instead of the more traditional "Connecting..." message. Finally, and most usefully, we can request missing files from the server as we become aware of them, since we are under no obligation to render anything for the user.

The mechanism for this is fairly basic. After a datablock is unpacked, the preload() method is called. If it returns false and sets an error, then the network code checks to see if a file (or files) failed to be located by the ResManager; if so, then it requests those files from the server. If preload returns true, then the datablock is considered loaded. If preload returns false and sets no error, then the connection is aborted.

Once the file(s) is downloaded, the datablock's preload() method is called again. If it fails with the same error, the connection is aborted. If a new error is returned, then the download-retry process is repeated until the preload works.

Guide To Datablock Code

To make a datablock subclass, you need to extend three functions:

  • preload()
  • packData()
  • unpackData()

packData() and unpackData() simply read or write data to a network stream. If you add any fields, you need to add appropriate calls to read or write. Make sure that the order of reads and writes is the same in both functions. Make sure to call the Parent's version of these methods in every subclass.

preload() is a bit more complex; it is responsible for taking the raw data read by unpackData() and processing it into a form useful by the datablock's owning object. For instance, the Player class' datablock, PlayerData, gets handles to commonly used nodes in the player model, as well as resolving handles to textures and other resources. Any code which loads files or performs other actions beyond simply reading the data from the packet, such as validation, must reside in preload().

To write your own preload() methods, see any of the existing methods in the codebase; for instance, PlayerData::preload() is an excellent example of error-reporting, data validation, and so forth.

Note:
A useful trick, which is used in several places in the engine, is that of temporarily storing SimObjectIds in the variable which will eventually hold the "real" handle. ShapeImage uses this trick in several pllaces; so do the vehicle classes. See GameBaseData for more on using this trick.
See also:
GameBaseData for some more information on the datablocks used throughout most of the engine.

Member Function Documentation

void SimDataBlock::reloadOnLocalClient ( )

Reload the datablock. This can only be used with a local client configuration.


Torque 3D - Script Manual: SimGroup Class Reference

SimGroup Class Reference
[Console, Scripting]

A collection of SimObjects that are owned by the group. More...

Inheritance diagram for SimGroup:
[legend]

List of all members.

Detailed Description

A collection of SimObjects that are owned by the group.

A SimGroup is a stricter form of SimSet. SimObjects may only be a member of a single SimGroup at a time. The SimGroup will automatically enforce the single-group-membership rule (ie. adding an object to a SimGroup will cause it to be removed from its current SimGroup, if any).

Deleting a SimGroup will also delete all SimObjects in the SimGroup.

Example:
// Create a SimGroup for particle emitters
new SimGroup(Emitters)
{
   canSaveDynamicFields = "1";

   new ParticleEmitterNode(CrystalEmmiter) {
      active = "1";
      emitter = "dustEmitter";
      velocity = "1";
      dataBlock = "GenericSmokeEmitterNode";
      position = "-61.6276 2.1142 4.45027";
      rotation = "1 0 0 0";
      scale = "1 1 1";
      canSaveDynamicFields = "1";
   };

   new ParticleEmitterNode(Steam1) {
      active = "1";
      emitter = "SlowSteamEmitter";
      velocity = "1";
      dataBlock = "GenericSmokeEmitterNode";
      position = "-25.0458 1.55289 2.51308";
      rotation = "1 0 0 0";
      scale = "1 1 1";
      canSaveDynamicFields = "1";
   };
};


Torque 3D - Script Manual: SimObject Class Reference

SimObject Class Reference
[Console, Game]

Base class for almost all objects involved in the simulation. More...

Inheritance diagram for SimObject:
[legend]

List of all members.

Public Member Functions

void | assignFieldsFrom (SimObject fromObject)
Copy fields from another object onto this one. The objects must be of same type. Everything from the object will overwrite what's in this object; extra fields in this object will remain. This includes dynamic fields.
void | assignPersistentId ()
Assign a persistent ID to the object if it does not already have one.
string | call (string method, string args...)
Dynamically call a method on an object.
SimObject clone ()
Create a copy of this object.
SimObject deepClone ()
Create a copy of this object and all its subobjects.
void | delete ()
Delete and remove the object.
void | dump (bool detailed=false)
Dump a description of all fields and methods defined on this object to the console.
void | dumpClassHierarchy ()
Dump the native C++ class hierarchy of this object's C++ class to the console.
void | dumpGroupHierarchy ()
Dump the hierarchy of this object up to RootGroup to the console.
ArrayObject dumpMethods ()
List the methods defined on this object.
bool | getCanSave ()
Get whether the object will be included in saves.
string | getClassName ()
Get the name of the C++ class which the object is an instance of.
string | getClassNamespace ()
Get the name of the class namespace assigned to this object.
ArrayObject getDebugInfo ()
Return some behind-the-scenes information on the object.
int | getDeclarationLine ()
Get the line number at which the object is defined in its file.
string | getDynamicField (int index)
Get a value of a dynamic field by index.
int | getDynamicFieldCount ()
Get the number of dynamic fields defined on the object.
string | getField (int index)
Retrieve the value of a static field by index.
int | getFieldCount ()
Get the number of static fields on the object.
string | getFieldType (string fieldName)
Get the console type code of the given field.
string | getFieldValue (string fieldName, int index=-1)
Return the value of the given field on this object.
string | getFilename ()
Returns the filename the object is attached to.
SimGroup getGroup ()
Get the group that this object is contained in.
int | getId ()
Get the underlying unique numeric ID of the object.
string | getInternalName ()
Get the internal name of the object.
string | getName ()
Get the global name of the object.
string | getSuperClassNamespace ()
Get the name of the superclass namespace assigned to this object.
bool | isChildOfGroup (SimGroup group)
Test whether the object belongs directly or indirectly to the given group.
bool | isEditorOnly ()
Return true if the object is only used by the editor.
bool | isExpanded ()
Get whether the object has been marked as expanded. (in editor).
bool | isInNamespaceHierarchy (string name)
Test whether the namespace of this object is a direct or indirect child to the given namespace.
bool | isMemberOfClass (string className)
Test whether this object is a member of the specified class.
bool | isMethod (string methodName)
Test whether the given method is defined on this object.
bool | isNameChangeAllowed ()
Get whether this object may be renamed.
bool | isSelected ()
Get whether the object has been marked as selected. (in editor).
bool | save (string fileName, bool selectedOnly=false, string preAppendString="")
Save out the object to the given file.
int | schedule (float time, string method, string args...)
Delay an invocation of a method.
void | setCanSave (bool value=true)
Set whether the object will be included in saves.
void | setClassNamespace (string name)
Assign a class namespace to this object.
void | setEditorOnly (bool value=true)
Set/clear the editor-only flag on this object.
void | setFieldType (string fieldName, string type)
Set the console type code for the given field.
bool | setFieldValue (string fieldName, string value, int index=-1)
Set the value of the given field on this object.
void | setFilename (string fileName)
Sets the object's file name and path.
void | setHidden (bool value=true)
Hide/unhide the object.
void | setInternalName (string newInternalName)
Set the internal name of the object.
void | setIsExpanded (bool state=true)
Set whether the object has been marked as expanded. (in editor).
void | setIsSelected (bool state=true)
Set whether the object has been marked as selected. (in editor).
void | setLocked (bool value=true)
Lock/unlock the object in the editor.
void | setName (string newName)
Set the global name of the object.
void | setNameChangeAllowed (bool value=true)
Set whether this object can be renamed from its first name.
void | setSuperClassNamespace (string name)
Assign a superclass namespace to this object.

Public Attributes

Persistence

bool | canSave
Whether the object can be saved out. If false, the object is purely transient in nature.
bool | canSaveDynamicFields
True if dynamic fields (added at runtime) should be saved. Defaults to true.
pid | persistentId
The universally unique identifier for the object.
Object

string | class
Script class of object.
string | className
Script class of object.
string | internalName
Optional name that may be used to lookup this object within a SimSet.
SimObject parentGroup
Group hierarchy parent of the object.
string | superClass
Script super-class of object.
Editing

bool | hidden
Whether the object is visible.
bool | locked
Whether the object can be edited.
Ungrouped

string | name
Optional global name of this object.

Detailed Description

Base class for almost all objects involved in the simulation.

Introduction

SimObject is a base class for most of the classes you'll encounter working in Torque. It provides fundamental services allowing "smart" object referencing, creation, destruction, organization, and location. Along with SimEvent, it gives you a flexible event-scheduling system, as well as laying the foundation for the in-game editors, GUI system, and other vital subsystems.

Subclassing

You will spend a lot of your time in Torque subclassing, or working with subclasses of, SimObject. SimObject is designed to be easy to subclass.

You should not need to override anything in a subclass except:

  • The constructor/destructor.
  • processArguments()
  • onAdd()/onRemove()
  • onGroupAdd()/onGroupRemove()
  • onNameChange()
  • onStaticModified()
  • onDeleteNotify()
  • onEditorEnable()/onEditorDisable()
  • inspectPreApply()/inspectPostApply()
  • things from ConsoleObject (see ConsoleObject docs for specifics)

Of course, if you know what you're doing, go nuts! But in most cases, you shouldn't need to touch things not on that list.

When you subclass, you should define a typedef in the class, called Parent, that references the class you're inheriting from.

   class mySubClass : public SimObject {
       typedef SimObject Parent;
       ...

Then, when you override a method, put in:

   bool mySubClass::onAdd()
   {
       if(!Parent::onAdd())
           return false;

       // ... do other things ...
   }

Of course, you want to replace onAdd with the appropriate method call.

A SimObject's Life Cycle

SimObjects do not live apart. One of the primary benefits of using a SimObject is that you can uniquely identify it and easily find it (using its ID). Torque does this by keeping a global hierarchy of SimGroups - a tree - containing every registered SimObject. You can then query for a given object using Sim::findObject() (or SimSet::findObject() if you want to search only a specific set).

          // Three examples of registering an object.

          // Method 1:
          AIClient *aiPlayer = new AIClient();
          aiPlayer->registerObject();

          // Method 2:
          ActionMap* globalMap = new ActionMap;
          globalMap->registerObject("GlobalActionMap");

          // Method 3:
          bool reg = mObj->registerObject(id);

Registering a SimObject performs these tasks:

  • Marks the object as not cleared and not removed.
  • Assigns the object a unique SimObjectID if it does not have one already.
  • Adds the object to the global name and ID dictionaries so it can be found again.
  • Calls the object's onAdd() method. Note: SimObject::onAdd() performs some important initialization steps. See here for details" on how to properly subclass SimObject.
  • If onAdd() fails (returns false), it calls unregisterObject().
  • Checks to make sure that the SimObject was properly initialized (and asserts if not).

Calling registerObject() and passing an ID or a name will cause the object to be assigned that name and/or ID before it is registered.

Congratulations, you have now registered your object! What now?

Well, hopefully, the SimObject will have a long, useful life. But eventually, it must die.

There are a two ways a SimObject can die.

  • First, the game can be shut down. This causes the root SimGroup to be unregistered and deleted. When a SimGroup is unregistered, it unregisters all of its member SimObjects; this results in everything that has been registered with Sim being unregistered, as everything registered with Sim is in the root group.
  • Second, you can manually kill it off, either by calling unregisterObject() or by calling deleteObject().

When you unregister a SimObject, the following tasks are performed:

  • The object is flagged as removed.
  • Notifications are cleaned up.
  • If the object is in a group, then it removes itself from the group.
  • Delete notifications are sent out.
  • Finally, the object removes itself from the Sim globals, and tells Sim to get rid of any pending events for it.

If you call deleteObject(), all of the above tasks are performed, in addition to some sanity checking to make sure the object was previously added properly, and isn't in the process of being deleted. After the object is unregistered, it deallocates itself.

Torque Editors

SimObjects are one of the building blocks for the in-game editors. They provide a basic interface for the editor to be able to list the fields of the object, update them safely and reliably, and inform the object things have changed.

This interface is implemented in the following areas:

  • onNameChange() is called when the object is renamed.
  • onStaticModified() is called whenever a static field is modified.
  • inspectPreApply() is called before the object's fields are updated, when changes are being applied.
  • inspectPostApply() is called after the object's fields are updated.
  • onEditorEnable() is called whenever an editor is enabled (for instance, when you hit F11 to bring up the world editor).
  • onEditorDisable() is called whenever the editor is disabled (for instance, when you hit F11 again to close the world editor).

(Note: you can check the variable gEditingMission to see if the mission editor is running; if so, you may want to render special indicators. For instance, the fxFoliageReplicator renders inner and outer radii when the mission editor is runnning.)

The Console

SimObject extends ConsoleObject by allowing you to to set arbitrary dynamic fields on the object, as well as statically defined fields. This is done through two methods, setDataField and getDataField, which deal with the complexities of allowing access to two different types of object fields.

Static fields take priority over dynamic fields. This is to be expected, as the role of dynamic fields is to allow data to be stored in addition to the predefined fields.

The fields in a SimObject are like properties (or fields) in a class.

Some fields may be arrays, which is what the array parameter is for; if it's non-null, then it is parsed with dAtoI and used as an index into the array. If you access something as an array which isn't, then you get an empty string.

You don't need to read any further than this. Right now, set/getDataField are called a total of 6 times through the entire Torque codebase. Therefore, you probably don't need to be familiar with the details of accessing them. You may want to look at Con::setData instead. Most of the time you will probably be accessing fields directly, or using the scripting language, which in either case means you don't need to do anything special.

The functions to get/set these fields are very straightforward:

    setDataField(StringTable->insert("locked", false), NULL, b ? "true" : "false" );
    curObject->setDataField(curField, curFieldArray, STR.getStringValue());
    setDataField(slotName, array, value);

For advanced users: There are two flags which control the behavior of these functions. The first is ModStaticFields, which controls whether or not the DataField functions look through the static fields (defined with addField; see ConsoleObject for details) of the class. The second is ModDynamicFields, which controls dynamically defined fields. They are set automatically by the console constructor code.

See also:
SceneObject

Member Function Documentation

void SimObject::assignFieldsFrom ( SimObject fromObject )

Copy fields from another object onto this one. The objects must be of same type. Everything from the object will overwrite what's in this object; extra fields in this object will remain. This includes dynamic fields.

Parameters:
fromObject The object from which to copy fields.
void SimObject::assignPersistentId ( )

Assign a persistent ID to the object if it does not already have one.

string SimObject::call | ( | string | method,
 |  | string | args...
 | ) |  |

Dynamically call a method on an object.

Parameters:
method | Name of method to call.
args | Zero or more arguments for the method.
Returns:
The result of the method call.
SimObject SimObject::clone ( )

Create a copy of this object.

Returns:
An exact duplicate of this object.
SimObject SimObject::deepClone ( )

Create a copy of this object and all its subobjects.

Returns:
An exact duplicate of this object and all objects it references.
void SimObject::delete ( )

Delete and remove the object.

void SimObject::dump ( bool detailed = false )

Dump a description of all fields and methods defined on this object to the console.

Parameters:
detailed Whether to print detailed information about members.
void SimObject::dumpClassHierarchy ( )

Dump the native C++ class hierarchy of this object's C++ class to the console.

void SimObject::dumpGroupHierarchy ( )

Dump the hierarchy of this object up to RootGroup to the console.

ArrayObject SimObject::dumpMethods ( )

List the methods defined on this object.

Each description is a newline-separated vector with the following elements:

  • Minimum number of arguments.
  • Maximum number of arguments.
  • Prototype string.
  • Full script file path (if script method).
  • Line number of method definition in script (if script method).
  • Documentation string (not including prototype). This takes up the remainder of the vector.
    Returns:
    An ArrayObject populated with (name,description) pairs of all methods defined on the object.
bool SimObject::getCanSave ( )

Get whether the object will be included in saves.

Returns:
True if the object will be saved; false otherwise.
string SimObject::getClassName ( )

Get the name of the C++ class which the object is an instance of.

Returns:
The name of the C++ class of the object.
string SimObject::getClassNamespace ( )

Get the name of the class namespace assigned to this object.

Returns:
The name of the 'class' namespace.
ArrayObject SimObject::getDebugInfo ( )

Return some behind-the-scenes information on the object.

Returns:
An ArrayObject filled with internal information about the object.
int SimObject::getDeclarationLine ( )

Get the line number at which the object is defined in its file.

Returns:
The line number of the object's definition in script.
See also:
getFilename()
string SimObject::getDynamicField ( int index )

Get a value of a dynamic field by index.

Parameters:
index The index of the dynamic field.
Returns:
The value of the dynamic field at the given index or "".
int SimObject::getDynamicFieldCount ( )

Get the number of dynamic fields defined on the object.

Returns:
The number of dynamic fields defined on the object.
string SimObject::getField ( int index )

Retrieve the value of a static field by index.

Parameters:
index The index of the static field.
Returns:
The value of the static field with the given index or "".
int SimObject::getFieldCount ( )

Get the number of static fields on the object.

Returns:
The number of static fields defined on the object.
string SimObject::getFieldType ( string fieldName )

Get the console type code of the given field.

Returns:
The numeric type code for the underlying console type of the given field.
string SimObject::getFieldValue | ( | string | fieldName,
 |  | int | index = -1
 | ) |  |

Return the value of the given field on this object.

Parameters:
fieldName | The name of the field. If it includes a field index, the index is parsed out.
index | Optional parameter to specify the index of an array field separately.
Returns:
The value of the given field or "" if undefined.
string SimObject::getFilename ( )

Returns the filename the object is attached to.

Returns:
The name of the file the object is associated with; usually the file the object was loaded from.

Reimplemented in CubemapData.

SimGroup SimObject::getGroup ( )

Get the group that this object is contained in.

Note:
If not assigned to particular SimGroup, an object belongs to RootGroup.
Returns:
The SimGroup object to which the object belongs.
int SimObject::getId ( )

Get the underlying unique numeric ID of the object.

Note:
Object IDs are unique only during single engine runs.
Returns:
The unique numeric ID of the object.
string SimObject::getInternalName ( )

Get the internal name of the object.

Returns:
The internal name of the object.
string SimObject::getName ( )

Get the global name of the object.

Returns:
The global name assigned to the object.
string SimObject::getSuperClassNamespace ( )

Get the name of the superclass namespace assigned to this object.

Returns:
The name of the 'superClass' namespace.
bool SimObject::isChildOfGroup ( SimGroup group )

Test whether the object belongs directly or indirectly to the given group.

Parameters:
group The SimGroup object.
Returns:
True if the object is a child of the given group or a child of a group that the given group is directly or indirectly a child to.
bool SimObject::isEditorOnly ( )

Return true if the object is only used by the editor.

Returns:
True if this object exists only for the sake of editing.
bool SimObject::isExpanded ( )

Get whether the object has been marked as expanded. (in editor).

Returns:
True if the object is marked expanded.

Reimplemented in GuiRolloutCtrl.

bool SimObject::isInNamespaceHierarchy ( string name )

Test whether the namespace of this object is a direct or indirect child to the given namespace.

Parameters:
name The name of a namespace.
Returns:
True if the given namespace name is within the namespace hierarchy of this object.
bool SimObject::isMemberOfClass ( string className )

Test whether this object is a member of the specified class.

Parameters:
className Name of a native C++ class.
Returns:
True if this object is an instance of the given C++ class or any of its super classes.
bool SimObject::isMethod ( string methodName )

Test whether the given method is defined on this object.

Parameters:
The name of the method.
Returns:
True if the object implements the given method.
bool SimObject::isNameChangeAllowed ( )

Get whether this object may be renamed.

Returns:
True if this object can be renamed; false otherwise.
bool SimObject::isSelected ( )

Get whether the object has been marked as selected. (in editor).

Returns:
True if the object is currently selected.
bool SimObject::save | ( | string | fileName,
 |  | bool | selectedOnly = false,
 |  | string | preAppendString = ""
 | ) |  |

Save out the object to the given file.

Parameters:
fileName | The name of the file to save to.
selectedOnly | If true, only objects marked as selected will be saved out.
preAppendString | Text which will be preprended directly to the object serialization.
True | on success, false on failure.
int SimObject::schedule | ( | float | time,
 |  | string | method,
 |  | string | args...
 | ) |  |

Delay an invocation of a method.

Parameters:
time | The number of milliseconds after which to invoke the method. This is a soft limit.
method | The method to call.
args | The arguments with which to call the method.
Returns:
The numeric ID of the created schedule. Can be used to cancel the call.
void SimObject::setCanSave ( bool value = true )

Set whether the object will be included in saves.

Parameters:
value If true, the object will be included in saves; if false, it will be excluded.
void SimObject::setClassNamespace ( string name )

Assign a class namespace to this object.

Parameters:
name The name of the 'class' namespace for this object.
void SimObject::setEditorOnly ( bool value = true )

Set/clear the editor-only flag on this object.

Parameters:
value If true, the object is marked as existing only for the editor.
void SimObject::setFieldType | ( | string | fieldName,
 |  | string | type
 | ) |  |

Set the console type code for the given field.

Parameters:
fieldName | The name of the dynamic field to change to type for.
type | The name of the console type.
Note:
This only works for dynamic fields. Types of static fields cannot be changed.
bool SimObject::setFieldValue | ( | string | fieldName,
 |  | string | value,
 |  | int | index = -1
 | ) |  |

Set the value of the given field on this object.

Parameters:
fieldName | The name of the field to assign to. If it includes an array index, the index will be parsed out.
value | The new value to assign to the field.
index | Optional argument to specify an index for an array field.
Returns:
True.
void SimObject::setFilename ( string fileName )

Sets the object's file name and path.

Parameters:
fileName The name of the file to associate this object with.
void SimObject::setHidden ( bool value = true )

Hide/unhide the object.

Parameters:
value If true, the object will be hidden; if false, the object will be unhidden.

Reimplemented in ShapeBase.

void SimObject::setInternalName ( string newInternalName )

Set the internal name of the object.

Parameters:
newInternalName The new internal name for the object.
void SimObject::setIsExpanded ( bool state = true )

Set whether the object has been marked as expanded. (in editor).

Parameters:
state True if the object is to be marked expanded; false if not.
void SimObject::setIsSelected ( bool state = true )

Set whether the object has been marked as selected. (in editor).

Parameters:
state True if object is to be marked selected; false if not.
void SimObject::setLocked ( bool value = true )

Lock/unlock the object in the editor.

Parameters:
value If true, the object will be locked; if false, the object will be unlocked.
void SimObject::setName ( string newName )

Set the global name of the object.

Parameters:
newName The new global name to assign to the object.
Note:
If name changing is disallowed on the object, the method will fail with a console error.
void SimObject::setNameChangeAllowed ( bool value = true )

Set whether this object can be renamed from its first name.

Parameters:
value If true, renaming is allowed for this object; if false, trying to change the name of the object will generate a console error.
void SimObject::setSuperClassNamespace ( string name )

Assign a superclass namespace to this object.

Parameters:
name The name of the 'superClass' namespace for this object.

Member Data Documentation

bool SimObject::canSave

Whether the object can be saved out. If false, the object is purely transient in nature.

bool SimObject::canSaveDynamicFields

True if dynamic fields (added at runtime) should be saved. Defaults to true.

string SimObject::class

Script class of object.

string SimObject::className

Script class of object.

bool SimObject::hidden

Whether the object is visible.

string SimObject::internalName

Optional name that may be used to lookup this object within a SimSet.

bool SimObject::locked

Whether the object can be edited.

string SimObject::name

Optional global name of this object.

SimObject SimObject::parentGroup

Group hierarchy parent of the object.

pid SimObject::persistentId

The universally unique identifier for the object.

string SimObject::superClass

Script super-class of object.


Torque 3D - Script Manual: SimpleMessageEvent Class Reference

SimpleMessageEvent Class Reference
[Networking]

A very simple example of a network event used by SimpleNetObject. More...

Detailed Description

A very simple example of a network event used by SimpleNetObject.

This object exists purely for instructional purposes. It is primarily geared toward developers that wish to understand the inner-working of Torque 3D's networking system. This is not intended for actual game development.

See also:
SimpleNetObject
NetObject


Torque 3D - Script Manual: SimpleNetObject Class Reference

SimpleNetObject Class Reference
[Networking]

A very simple example of a class derived from NetObject. More...

Inheritance diagram for SimpleNetObject:
[legend]

List of all members.

Public Member Functions

void | msg (NetConnection con, string message)
Send a SimpleNetObject message to the specified connection.
void | setMessage (string msg)
Sets the internal message variable.

Detailed Description

A very simple example of a class derived from NetObject.

This object exists purely for instructional purposes. It is primarily geared toward developers that wish to understand the inner-working of Torque 3D's networking system. This is not intended for actual game development.

See also:
NetObject for a full breakdown of this example object

Member Function Documentation

void SimpleNetObject::msg | ( | NetConnection | con,
 |  | string | message
 | ) |  |

Send a SimpleNetObject message to the specified connection.

Parameters:
con | The unique ID of the connection to transmit to
message | The string containing the message to transmit
void SimpleNetObject::setMessage ( string msg )

Sets the internal message variable.

Parameters:
msg The new message to send
Returns:
Value


Torque 3D - Script Manual: SimSet Class Reference

SimSet Class Reference
[Console, Scripting]

A collection of SimObjects. More...

Inheritance diagram for SimSet:
[legend]

List of all members.

Public Member Functions

bool | acceptsAsChild (SimObject obj)
Test whether the given object may be added to the set.
void | add (SimObject objects...)
Add the given objects to the set.
void | bringToFront (SimObject obj)
Make the given object the first object in the set.
void | callOnChildren (string method, string args...)
Call a method on all objects contained in the set.
void | callOnChildrenNoRecurse (string method, string args...)
Call a method on all objects contained in the set.
void | clear ()
Remove all objects from the set.
void | deleteAllObjects ()
Delete all objects in the set.
SimObject | findObjectByInternalName (string internalName, bool searchChildren=false)
Find an object in the set by its internal name.
int | getCount ()
Get the number of objects contained in the set.
int | getFullCount ()
Get the number of direct and indirect child objects contained in the set.
SimObject | getObject (int index)
Get the object at the given index.
int | getObjectIndex (SimObject obj)
Return the index of the given object in this set.
SimObject getRandom ()
Return a random object from the set.
bool | isMember (SimObject obj)
Test whether the given object belongs to the set.
void | listObjects ()
Dump a list of all objects contained in the set to the console.
void | pushToBack (SimObject obj)
Make the given object the last object in the set.
void | remove (SimObject objects...)
Remove the given objects from the set.
void | reorderChild (SimObject child1, SimObject child2)
Make sure child1 is ordered right before child2 in the set.
void | sort (string callbackFunction)
Sort the objects in the set using the given comparison function.
Callbacks

void | onObjectAdded (SimObject object)
Called when an object is added to the set.
void | onObjectRemoved (SimObject object)
Called when an object is removed from the set.

Detailed Description

A collection of SimObjects.

It is often necessary to keep track of an arbitrary set of SimObjects. For instance, Torque's networking code needs to not only keep track of the set of objects which need to be ghosted, but also the set of objects which must always be ghosted. It does this by working with two sets. The first of these is the RootGroup (which is actually a SimGroup) and the second is the GhostAlwaysSet, which contains objects which must always be ghosted to the client.

Some general notes on SimSets:

  • Membership is not exclusive. A SimObject may be a member of multiple SimSets.
  • A SimSet does not destroy subobjects when it is destroyed.
  • A SimSet may hold an arbitrary number of objects.

Member Function Documentation

bool SimSet::acceptsAsChild ( SimObject obj )

Test whether the given object may be added to the set.

Parameters:
obj The object to test for potential membership.
Returns:
True if the object may be added to the set, false otherwise.
void SimSet::add ( SimObject objects... )

Add the given objects to the set.

Parameters:
objects The objects to add to the set.
void SimSet::bringToFront ( SimObject obj )

Make the given object the first object in the set.

Parameters:
obj The object to bring to the frontmost position. Must be contained in the set.
void SimSet::callOnChildren | ( | string | method,
 |  | string | args...
 | ) |  |

Call a method on all objects contained in the set.

Parameters:
method | The name of the method to call.
args | The arguments to the method.
Note:
This method recurses into all SimSets that are children to the set.
See also:
callOnChildrenNoRecurse
void SimSet::callOnChildrenNoRecurse | ( | string | method,
 |  | string | args...
 | ) |  |

Call a method on all objects contained in the set.

Parameters:
method | The name of the method to call.
args | The arguments to the method.
Note:
This method does not recurse into child SimSets.
See also:
callOnChildren
void SimSet::clear ( )

Remove all objects from the set.

Reimplemented in GuiPopUpMenuCtrlEx.

void SimSet::deleteAllObjects ( )

Delete all objects in the set.

SimObject SimSet::findObjectByInternalName | ( | string | internalName,
 |  | bool | searchChildren = false
 | ) |  |

Find an object in the set by its internal name.

Parameters:
internalName | The internal name of the object to look for.
searchChildren | If true, SimSets contained in the set will be recursively searched for the object.
Returns:
The object with the given internal name or 0 if no match was found.
int SimSet::getCount ( )

Get the number of objects contained in the set.

Returns:
The number of objects contained in the set.
int SimSet::getFullCount ( )

Get the number of direct and indirect child objects contained in the set.

Returns:
The number of objects contained in the set as well as in other sets contained directly or indirectly in the set.
SimObject SimSet::getObject ( int index )

Get the object at the given index.

Parameters:
index The object index.
Returns:
The object at the given index or -1 if index is out of range.
int SimSet::getObjectIndex ( SimObject obj )

Return the index of the given object in this set.

Parameters:
obj The object for which to return the index. Must be contained in the set.
Returns:
The index of the object or -1 if the object is not contained in the set.
SimObject SimSet::getRandom ( )

Return a random object from the set.

Returns:
A randomly selected object from the set or -1 if the set is empty.
bool SimSet::isMember ( SimObject obj )

Test whether the given object belongs to the set.

Parameters:
obj The object.
Returns:
True if the object is contained in the set; false otherwise.
void SimSet::listObjects ( )

Dump a list of all objects contained in the set to the console.

void SimSet::onObjectAdded ( SimObject object )

Called when an object is added to the set.

Parameters:
object The object that was added.
void SimSet::onObjectRemoved ( SimObject object )

Called when an object is removed from the set.

Parameters:
object The object that was removed.
void SimSet::pushToBack ( SimObject obj )

Make the given object the last object in the set.

Parameters:
obj The object to bring to the last position. Must be contained in the set.
void SimSet::remove ( SimObject objects... )

Remove the given objects from the set.

Parameters:
objects The objects to remove from the set.
void SimSet::reorderChild | ( | SimObject | child1,
 |  | SimObject | child2
 | ) |  |

Make sure child1 is ordered right before child2 in the set.

Parameters:
child1 | The first child. The object must already be contained in the set.
child2 | The second child. The object must already be contained in the set.
void SimSet::sort ( string callbackFunction )

Sort the objects in the set using the given comparison function.

Parameters:
callbackFunction Name of a function that takes two object arguments A and B and returns -1 if A is less, 1 if B is less, and 0 if both are equal.


Torque 3D - Script Manual: SimXMLDocument Class Reference

SimXMLDocument Class Reference
[File I/O]

File I/O object used for creating, reading, and writing XML documents. More...

Inheritance diagram for SimXMLDocument:
[legend]

List of all members.

Public Member Functions

void | addComment (string comment)
Add the given comment as a child of the document.
void | addData (string text)
Add the given text as a child of current Element.
void | addHeader ()
Add a XML header to a document.
void | addNewElement (string name)
Create a new element with the given name as child of current Element's parent and push it onto the Element stack making it the current one.
void | addText (string text)
Add the given text as a child of current Element.
string | attribute (string attributeName)
Get a string attribute from the current Element on the stack.
bool | attributeExists (string attributeName)
Tests if the requested attribute exists.
float | attributeF32 (string attributeName)
Get float attribute from the current Element on the stack.
int | attributeS32 (string attributeName)
Get int attribute from the current Element on the stack.
void | clear ()
Set this document to its default state.
void | clearError ()
Clear the last error description.
string | elementValue ()
Get the Element's value if it exists.
string | firstAttribute ()
Obtain the name of the current Element's first attribute.
string | getData ()
Gets the text from the current Element.
string | getErrorDesc ()
Get last error description.
string | getText ()
Gets the text from the current Element.
string | lastAttribute ()
Obtain the name of the current Element's last attribute.
bool | loadFile (string fileName)
Load in given filename and prepare it for use.
string | nextAttribute ()
Get the name of the next attribute for the current Element after a call to firstAttribute().
bool | nextSiblingElement (string name)
Put the next sibling Element with the given name on the stack, making it the current one.
void | parse (string xmlString)
Create a document from a XML string.
void | popElement ()
Pop the last Element off the stack.
string | prevAttribute ()
Get the name of the previous attribute for the current Element after a call to lastAttribute().
bool | pushChildElement (int index)
Push the child Element at the given index onto the stack, making it the current one.
bool | pushFirstChildElement (string name)
Push the first child Element with the given name onto the stack, making it the current Element.
void | pushNewElement (string name)
Create a new element with the given name as child of current Element and push it onto the Element stack making it the current one.
string | readComment (int index)
Gives the comment at the specified index, if any.
void | removeText ()
Remove any text on the current Element.
void | reset ()
Set this document to its default state.
bool | saveFile (string fileName)
Save document to the given file name.
void | setAttribute (string attributeName, string value)
Set the attribute of the current Element on the stack to the given value.
void | setObjectAttributes (string objectID)
Add the given SimObject's fields as attributes of the current Element on the stack.

Detailed Description

File I/O object used for creating, reading, and writing XML documents.

A SimXMLDocument is a container of various XML nodes. The Document level may contain a header (sometimes called a declaration), comments and child Elements. Elements may contain attributes, data (or text) and child Elements.

You build new Elements using addNewElement(). This makes the new Element the current one you're working with. You then use setAttribute() to add attributes to the Element. You use addData() or addText() to write to the text area of an Element.

Example:
// Thanks to Rex Hiebert for this example
// Given the following XML
<?xml version="1.0" encoding="utf-8" standalone="yes" ?>
<DataTables>
   <table tableName="2DShapes">
      <rec id="1">Triangle</rec>
      <rec id="2">Square</rec>
      <rec id="3">Circle</rec>
   </table>
   <table tableName="3DShapes">
      <rec id="1">Pyramid</rec>
      <rec id="2">Cube</rec>
      <rec id="3">Sphere</rec>
   </table>
</DataTables>

// Using SimXMLDocument by itself
function readXmlExample(%filename)
{
   %xml = new SimXMLDocument() {};
   %xml.loadFile(%filename);

   %xml.pushChildElement("DataTables");
   %xml.pushFirstChildElement("table");
   while(true)
   {
     echo("TABLE:" SPC %xml.attribute("tableName"));
     %xml.pushFirstChildElement("rec");
     while (true)
     {
       %id = %xml.attribute("id");
       %desc = %xml.getData();
       echo("  Shape" SPC %id SPC %desc);
       if (!%xml.nextSiblingElement("rec")) break;
     }
     %xml.popElement();
     if (!%xml.nextSiblingElement("table")) break;
   }
}

// Thanks to Scott Peal for this example
// Using FileObject in conjunction with SimXMLDocument
// This example uses an XML file with a format of:
// <Models>
//    <Model category="" name="" path="" />
// </Models>
function getModelsInCatagory()
{
   %file = "./Catalog.xml";
   %fo = new FileObject();
   %text = "";

   if(%fo.openForRead(%file))
   {
     while(!%fo.isEOF())
     {
       %text = %text @ %fo.readLine();
       if (!%fo.isEOF()) %text = %text @ "\n";
     }
   }
   else
   {
     echo("Unable to locate the file: " @ %file);
   }

   %fo.delete();

   %xml = new SimXMLDocument() {};
   %xml.parse(%text);
   // "Get" inside of the root element, "Models".
   %xml.pushChildElement(0);

   // "Get" into the first child element
   if (%xml.pushFirstChildElement("Model"))
   {
     while (true)
     {
       //
       //  Here, i read the element's attributes.
       //  You might want to save these values in an array or call the %xml.getElementValue()
       //  if you have a different XML structure.

       %catagory = %xml.attribute("catagory");
       %name = %xml.attribute("name");
       %path = %xml.attribute("path");

       // now, read the next "Model"
       if (!%xml.nextSiblingElement("Model")) break;
     }
   }
}
Note:
SimXMLDocument is a wrapper around TinyXml, a standard XML library. If you're familiar with its concepts, you'll find they also apply here.
See also:
FileObject

Member Function Documentation

void SimXMLDocument::addComment ( string comment )

Add the given comment as a child of the document.

Parameters:
comment String containing the comment.
Example:
// Create a new XML document with a header, a comment and single element.
%x = new SimXMLDocument();
%x.addHeader();
%x.addComment("This is a test comment");
%x.addNewElement("NewElement");
%x.saveFile("test.xml");

// Produces the following file:
// <?xml version="1.0" encoding="utf-8" standalone="yes" ?>
// <!--This is a test comment-->
// <NewElement />
See also:
readComment()
void SimXMLDocument::addData ( string text )

Add the given text as a child of current Element.

Use getData() to retrieve any text from the current Element.

addData() and addText() may be used interchangeably. As there is no difference between data and text, you may also use removeText() to clear any data from the current Element.

Parameters:
text String containing the text.
Example:
// Create a new XML document with a header and single element
// with some added data.
%x = new SimXMLDocument();
%x.addHeader();
%x.addNewElement("NewElement");
%x.addData("Some text");
%x.saveFile("test.xml");

// Produces the following file:
// <?xml version="1.0" encoding="utf-8" standalone="yes" ?>
// <NewElement>Some text</NewElement>
See also:
getData()
addText()
getText()
removeText()
void SimXMLDocument::addHeader ( )

Add a XML header to a document.

Sometimes called a declaration, you typically add a standard header to the document before adding any elements. SimXMLDocument always produces the following header:

<?xml version="1.0" encoding="utf-8" standalone="yes" ?>

Example:
// Create a new XML document with just a header and single element.
%x = new SimXMLDocument();
%x.addHeader();
%x.addNewElement("NewElement");
%x.saveFile("test.xml");

// Produces the following file:
// <?xml version="1.0" encoding="utf-8" standalone="yes" ?>
// <NewElement />
void SimXMLDocument::addNewElement ( string name )

Create a new element with the given name as child of current Element's parent and push it onto the Element stack making it the current one.

Note:
This differs from pushNewElement() in that it adds the new Element to the current Element's parent (or document if there is no parent Element). This makes the new Element a sibling of the current one.
Parameters:
name XML tag for the new Element.
See also:
pushNewElement()
void SimXMLDocument::addText ( string text )

Add the given text as a child of current Element.

Use getText() to retrieve any text from the current Element and removeText() to clear any text.

addText() and addData() may be used interchangeably.

Parameters:
text String containing the text.
Example:
// Create a new XML document with a header and single element
// with some added text.
%x = new SimXMLDocument();
%x.addHeader();
%x.addNewElement("NewElement");
%x.addText("Some text");
%x.saveFile("test.xml");

// Produces the following file:
// <?xml version="1.0" encoding="utf-8" standalone="yes" ?>
// <NewElement>Some text</NewElement>
See also:
getText()
removeText()
addData()
getData()
string SimXMLDocument::attribute ( string attributeName )

Get a string attribute from the current Element on the stack.

Parameters:
attributeName Name of attribute to retrieve.
Returns:
The attribute string if found. Otherwise returns an empty string.
bool SimXMLDocument::attributeExists ( string attributeName )

Tests if the requested attribute exists.

Parameters:
attributeName Name of attribute being queried for.
Returns:
True if the attribute exists.
float SimXMLDocument::attributeF32 ( string attributeName )

Get float attribute from the current Element on the stack.

Parameters:
attributeName Name of attribute to retrieve.
Returns:
The value of the given attribute in the form of a float.
int SimXMLDocument::attributeS32 ( string attributeName )

Get int attribute from the current Element on the stack.

Parameters:
attributeName Name of attribute to retrieve.
Returns:
The value of the given attribute in the form of an integer.
void SimXMLDocument::clear ( )

Set this document to its default state.

Clears all Elements from the documents. Equivalent to using reset()

See also:
reset()
void SimXMLDocument::clearError ( )

Clear the last error description.

string SimXMLDocument::elementValue ( )

Get the Element's value if it exists.

Usually returns the text from the Element.

Returns:
The value from the Element, or an empty string if none is found.
string SimXMLDocument::firstAttribute ( )

Obtain the name of the current Element's first attribute.

Returns:
String containing the first attribute's name, or an empty string if none is found.
See also:
nextAttribute()
lastAttribute()
prevAttribute()
string SimXMLDocument::getData ( )

Gets the text from the current Element.

Use addData() to add text to the current Element.

getData() and getText() may be used interchangeably. As there is no difference between data and text, you may also use removeText() to clear any data from the current Element.

Returns:
String containing the text in the current Element.
Example:
// Using the following test.xml file as an example:
// <?xml version="1.0" encoding="utf-8" standalone="yes" ?>
// <NewElement>Some data</NewElement>

// Load in the file
%x = new SimXMLDocument();
%x.loadFile("test.xml");

// Make the first Element the current one
%x.pushFirstChildElement("NewElement");

// Store the current Element's data ('Some data' in this example)
// into 'result'
%result = %x.getData();
echo( %result );
See also:
addData()
addText()
getText()
removeText()
string SimXMLDocument::getErrorDesc ( )

Get last error description.

Returns:
A string of the last error message.
string SimXMLDocument::getText ( )

Gets the text from the current Element.

Use addText() to add text to the current Element and removeText() to clear any text.

getText() and getData() may be used interchangeably.

Returns:
String containing the text in the current Element.
Example:
// Using the following test.xml file as an example:
// <?xml version="1.0" encoding="utf-8" standalone="yes" ?>
// <NewElement>Some text</NewElement>

// Load in the file
%x = new SimXMLDocument();
%x.loadFile("test.xml");

// Make the first Element the current one
%x.pushFirstChildElement("NewElement");

// Store the current Element's text ('Some text' in this example)
// into 'result'
%result = %x.getText();
echo( %result );
See also:
addText()
removeText()
addData()
getData()
string SimXMLDocument::lastAttribute ( )

Obtain the name of the current Element's last attribute.

Returns:
String containing the last attribute's name, or an empty string if none is found.
See also:
prevAttribute()
firstAttribute()
lastAttribute()
bool SimXMLDocument::loadFile ( string fileName )

Load in given filename and prepare it for use.

Note:
Clears the current document's contents.
Parameters:
fileName Name and path of XML document
Returns:
True if the file was loaded successfully.
string SimXMLDocument::nextAttribute ( )

Get the name of the next attribute for the current Element after a call to firstAttribute().

Returns:
String containing the next attribute's name, or an empty string if none is found.
See also:
firstAttribute()
lastAttribute()
prevAttribute()
bool SimXMLDocument::nextSiblingElement ( string name )

Put the next sibling Element with the given name on the stack, making it the current one.

Parameters:
name String containing name of the next sibling.
Returns:
True if the Element was found and made the current one.
void SimXMLDocument::parse ( string xmlString )

Create a document from a XML string.

Note:
Clears the current document's contents.
Parameters:
xmlString Valid XML to parse and store as a document.
void SimXMLDocument::popElement ( )

Pop the last Element off the stack.

string SimXMLDocument::prevAttribute ( )

Get the name of the previous attribute for the current Element after a call to lastAttribute().

Returns:
String containing the previous attribute's name, or an empty string if none is found.
See also:
lastAttribute()
firstAttribute()
nextAttribute()
bool SimXMLDocument::pushChildElement ( int index )

Push the child Element at the given index onto the stack, making it the current one.

Parameters:
index Numerical index of Element being pushed.
Returns:
True if the Element was found and made the current one.
bool SimXMLDocument::pushFirstChildElement ( string name )

Push the first child Element with the given name onto the stack, making it the current Element.

Parameters:
name String containing name of the child Element.
Returns:
True if the Element was found and made the current one.
Example:
// Using the following test.xml file as an example:
// <?xml version="1.0" encoding="utf-8" standalone="yes" ?>
// <NewElement>Some text</NewElement>

// Load in the file
%x = new SimXMLDocument();
%x.loadFile("test.xml");

// Make the first Element the current one
%x.pushFirstChildElement("NewElement");

// Store the current Element's text ('Some text' in this example)
// into 'result'
%result = %x.getText();
echo( %result );
void SimXMLDocument::pushNewElement ( string name )

Create a new element with the given name as child of current Element and push it onto the Element stack making it the current one.

Note:
This differs from addNewElement() in that it adds the new Element as a child of the current Element (or a child of the document if no Element exists).
Parameters:
name XML tag for the new Element.
See also:
addNewElement()
string SimXMLDocument::readComment ( int index )

Gives the comment at the specified index, if any.

Unlike addComment() that only works at the document level, readComment() may read comments from the document or any child Element. The current Element (or document if no Elements have been pushed to the stack) is the parent for any comments, and the provided index is the number of comments in to read back.

Parameters:
index Comment index number to query from the current Element stack
Returns:
String containing the comment, or an empty string if no comment is found.
See also:
addComment()
void SimXMLDocument::removeText ( )

Remove any text on the current Element.

Use getText() to retrieve any text from the current Element and addText() to add text to the current Element. As getData() and addData() are equivalent to getText() and addText(), removeText() will also remove any data from the current Element.

See also:
addText()
getText()
addData()
getData()
void SimXMLDocument::reset ( )

Set this document to its default state.

Clears all Elements from the documents. Equivalent to using clear()

See also:
clear()
bool SimXMLDocument::saveFile ( string fileName )

Save document to the given file name.

Parameters:
fileName Path and name of XML file to save to.
Returns:
True if the file was successfully saved.
void SimXMLDocument::setAttribute | ( | string | attributeName,
 |  | string | value
 | ) |  |

Set the attribute of the current Element on the stack to the given value.

Parameters:
attributeName | Name of attribute being changed
value | New value to assign to the attribute
void SimXMLDocument::setObjectAttributes ( string objectID )

Add the given SimObject's fields as attributes of the current Element on the stack.

Parameters:
objectID ID of SimObject being copied.


Torque 3D - Script Manual: SkyBox Class Reference

SkyBox Class Reference
[Atmosphere]

Represents the sky with an artist-created cubemap. More...

Inheritance diagram for SkyBox:
[legend]

List of all members.

Public Attributes

void | postApply
Sky Box

bool | drawBottom
If false the bottom of the skybox is not rendered.
float | fogBandHeight
The height (0-1) of the fog band from the horizon to the top of the SkyBox.
string | Material
The name of a cubemap material for the sky box.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Represents the sky with an artist-created cubemap.

SkyBox is not a directional light and should be used in conjunction with a Sun object.

Member Data Documentation

bool SkyBox::drawBottom

If false the bottom of the skybox is not rendered.

float SkyBox::fogBandHeight

The height (0-1) of the fog band from the horizon to the top of the SkyBox.

bool SkyBox::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool SkyBox::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

string SkyBox::Material

The name of a cubemap material for the sky box.

void SkyBox::postApply


Torque 3D - Script Manual: SpawnSphere Class Reference

SpawnSphere Class Reference
[Game Objects, Miscellaneous]

This class is used for creating any type of game object, assigning it a class, datablock, and even a function when it is spawned. More...

Inheritance diagram for SpawnSphere:
[legend]

List of all members.

Public Member Functions

bool | spawnObject (string additionalProps)
Dynamically create a new game object with a specified class, datablock, and optional properties.
Callbacks

void | onAdd (int objectId)
Called when the SpawnSphere is being created.

Public Attributes

Spawn

bool | autoSpawn
Flag to spawn object as soon as SpawnSphere is created, true to enable or false to disabled.
string | spawnClass
Class assigned to object when created, such as Player, or AIPlayer.
string | spawnDatablock
Predefined datablock assigned to the object when created.
string | spawnProperties
String containing ; delimited properties that are set at the time of spawning.
string | spawnScript
Command to execute when spawning an object. New object id is stored in $SpawnObject. Max 255 characters.
Weight

float | indoorWeight
Deprecated.
float | outdoorWeight
Deprecated.
float | sphereWeight
Deprecated.
Dimensions

float | radius
Determines the size of the sphere in which the object will spawn.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

This class is used for creating any type of game object, assigning it a class, datablock, and even a function when it is spawned.

Torque 3D uses a simple spawn system, which can be easily modified to spawn any kind of object (of any class). Each new level already contains at least one SpawnSphere, which is represented by a green octahedron in stock Torque 3D. The spawnClass will determine the object type, such as Player, AIPlayer, etc. The spawnDataBlock will provide this specific instance of the creation with a pre-defined datablock. The really powerful feature of this clas is utilize by the spawnScript field. Through this, you can define a simple script (multiple lines) that will be executed once the object has been spawned.

Example:
new SpawnSphere(DefaultSpawnSphere)
{
   spawnClass = "Player";
   spawnDatablock = "DefaultPlayerData";
   spawnScript = "echo(\"Object Spawned\");"; // Note the escape sequence \ in front of quotes
   spawnProperties = "name = \"Bob\";lifeTotal = 3;"; // Note the escape sequence \ in front of quotes
   autoSpawn = "0";
   radius = "1";
   sphereWeight = "1";
   indoorWeight = "100";
   outdoorWeight = "100";
   dataBlock = "SpawnSphereMarker";
   position = "-0.77266 -19.882 17.8153";
   rotation = "1 0 0 0";
   scale = "1 1 1";
   canSave = "1";
   canSaveDynamicFields = "1";
};

// In the above example, the following two lines of code will execute after spawning
echo("Object Spawned");
echo("Hello World");
See also:
MissionMarker
MissionMarkerData

Member Function Documentation

void SpawnSphere::onAdd ( int objectId )

Called when the SpawnSphere is being created.

Parameters:
objectId The unique SimObjectId generated when SpawnSphere is created
bool SpawnSphere::spawnObject ( string additionalProps )

Dynamically create a new game object with a specified class, datablock, and optional properties.

This is called off the actual SpawnSphere, not to be confused with the Sim::spawnObject(...) global function

Parameters:
additionalProps Optional set of parameters applied to the spawn object during creation.
Example:
// Use the SpawnSphere::spawnObject function to create a game object
// No additional properties assigned
%player = DefaultSpawnSphere.spawnObject();

Member Data Documentation

bool SpawnSphere::autoSpawn

Flag to spawn object as soon as SpawnSphere is created, true to enable or false to disabled.

float SpawnSphere::indoorWeight

Deprecated.

bool SpawnSphere::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from MissionMarker.

bool SpawnSphere::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from MissionMarker.

float SpawnSphere::outdoorWeight

Deprecated.

float SpawnSphere::radius

Determines the size of the sphere in which the object will spawn.

string SpawnSphere::spawnClass

Class assigned to object when created, such as Player, or AIPlayer.

string SpawnSphere::spawnDatablock

Predefined datablock assigned to the object when created.

string SpawnSphere::spawnProperties

String containing ; delimited properties that are set at the time of spawning.

string SpawnSphere::spawnScript

Command to execute when spawning an object. New object id is stored in $SpawnObject. Max 255 characters.

float SpawnSphere::sphereWeight

Deprecated.


Torque 3D - Script Manual: Splash Class Reference

Splash Class Reference
[Special Effects]

Manages the ring used for a Splash effect. More...

Inheritance diagram for Splash:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Manages the ring used for a Splash effect.

Member Data Documentation

bool Splash::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool Splash::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.


Torque 3D - Script Manual: SplashData Class Reference

SplashData Class Reference
[Special Effects]

Acts as the physical point in space in white a Splash is created from. More...

Inheritance diagram for SplashData:
[legend]

List of all members.

Public Attributes

float | acceleration
Constant acceleration value to place upon the splash effect.
ColorF | colors [4]
Color values to set the splash effect, rgba. Up to 4 allowed. Will transition through colors based on values set in the times value. Example: colors[0] = "0.6 1.0 1.0 0.5".
int | delayMS
Time to delay, in milliseconds, before actually starting this effect.
int | delayVariance
Time variance for delayMS.
float | ejectionAngle
Rotational angle to create a splash ring.
float | ejectionFreq
Frequency in which to emit splash rings.
ParticleEmitterData | emitter [3]
List of particle emitters to create at the point of this Splash effect.
ExplosionData Explosion
ExplosionData object to create at the creation position of this splash effect.
float | height
Height for the splash to reach.
int | lifetimeMS
Lifetime for this effect, in milliseconds.
int | lifetimeVariance
Time variance for lifetimeMS.
int | numSegments
Number of ejection points in the splash ring.
float | ringLifetime
Lifetime, in milliseconds, for a splash ring.
Point3F | scale
The scale of this splashing effect, defined as the F32 points X, Y, Z.
SFXProfile soundProfile
SFXProfile effect to play.
float | startRadius
Starting radius size of a splash ring.
float | texFactor
Factor in which to apply the texture to the splash ring, 0.0f - 1.0f.
filename | texture [2]
Imagemap file to use as the texture for the splash effect.
float | texWrap
Amount to wrap the texture around the splash ring, 0.0f - 1.0f.
float | times [4]
Times to transition through the splash effect. Up to 4 allowed. Values are 0.0 - 1.0, and corrispond to the life of the particle where 0 is first created and 1 is end of lifespace.
float | velocity
Velocity for the splash effect to travel.
float | width
Width for the X and Y coordinates to create this effect within.

Detailed Description

Acts as the physical point in space in white a Splash is created from.

Member Data Documentation

float SplashData::acceleration

Constant acceleration value to place upon the splash effect.

ColorF SplashData::colors[4]

Color values to set the splash effect, rgba. Up to 4 allowed. Will transition through colors based on values set in the times value. Example: colors[0] = "0.6 1.0 1.0 0.5".

int SplashData::delayMS

Time to delay, in milliseconds, before actually starting this effect.

int SplashData::delayVariance

Time variance for delayMS.

float SplashData::ejectionAngle

Rotational angle to create a splash ring.

float SplashData::ejectionFreq

Frequency in which to emit splash rings.

ParticleEmitterData SplashData::emitter[3]

List of particle emitters to create at the point of this Splash effect.

ExplosionData SplashData::Explosion

ExplosionData object to create at the creation position of this splash effect.

float SplashData::height

Height for the splash to reach.

int SplashData::lifetimeMS

Lifetime for this effect, in milliseconds.

int SplashData::lifetimeVariance

Time variance for lifetimeMS.

int SplashData::numSegments

Number of ejection points in the splash ring.

float SplashData::ringLifetime

Lifetime, in milliseconds, for a splash ring.

Point3F SplashData::scale

The scale of this splashing effect, defined as the F32 points X, Y, Z.

SFXProfile SplashData::soundProfile

SFXProfile effect to play.

float SplashData::startRadius

Starting radius size of a splash ring.

float SplashData::texFactor

Factor in which to apply the texture to the splash ring, 0.0f - 1.0f.

filename SplashData::texture[2]

Imagemap file to use as the texture for the splash effect.

float SplashData::texWrap

Amount to wrap the texture around the splash ring, 0.0f - 1.0f.

float SplashData::times[4]

Times to transition through the splash effect. Up to 4 allowed. Values are 0.0 - 1.0, and corrispond to the life of the particle where 0 is first created and 1 is end of lifespace.

float SplashData::velocity

Velocity for the splash effect to travel.

float SplashData::width

Width for the X and Y coordinates to create this effect within.


Torque 3D - Script Manual: SpotLight Class Reference

SpotLight Class Reference
[Lighting]

Lighting object which emits conical light in a direction. More...

Inheritance diagram for SpotLight:
[legend]

List of all members.

Public Attributes

Light

float | innerAngle
float | outerAngle
float | range

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Lighting object which emits conical light in a direction.

SpotLight is one of the two types of lighting objects that can be added to a Torque 3D level, the other being PointLight. Unlike directional or point lights, the SpotLights emits lighting in a specific direction within a cone. The distance of the cone is controlled by the SpotLight::range variable.

Example:
// Declaration of a point light in script, or created by World Editor
new SpotLight(SampleSpotLight)
{
   range = "10";
   innerAngle = "40";
   outerAngle = "45";
   isEnabled = "1";
   color = "1 1 1 1";
   brightness = "1";
   castShadows = "0";
   priority = "1";
   animate = "1";
   animationPeriod = "1";
   animationPhase = "1";
   flareType = "LightFlareExample0";
   flareScale = "1";
   attenuationRatio = "0 1 1";
   shadowType = "Spot";
   texSize = "512";
   overDarkFactor = "2000 1000 500 100";
   shadowDistance = "400";
   shadowSoftness = "0.15";
   numSplits = "1";
   logWeight = "0.91";
   fadeStartDistance = "0";
   lastSplitTerrainOnly = "0";
   representedInLightmap = "0";
   shadowDarkenColor = "0 0 0 -1";
   includeLightmappedGeometryInShadow = "0";
   position = "-29.4362 -5.86289 5.58602";
   rotation = "1 0 0 0";
};
See also:
LightBase
PointLight

Member Data Documentation

float SpotLight::innerAngle
bool SpotLight::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from LightBase.

bool SpotLight::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from LightBase.

float SpotLight::outerAngle
float SpotLight::range


Torque 3D - Script Manual: StaticShape Class Reference

StaticShape Class Reference
[Game Objects]

The most basic 3D shape with a datablock available in Torque 3D. More...

Inheritance diagram for StaticShape:
[legend]

List of all members.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

The most basic 3D shape with a datablock available in Torque 3D.

When it comes to placing 3D objects in the scene, you technically have two options:

1. TSStatic objects

2. ShapeBase derived objects

Since ShapeBase and ShapeBaseData are not meant to be instantiated in script, you will use one of its child classes instead. Several game related objects are derived from ShapeBase: Player, Vehicle, Item, and so on.

When you need a 3D object with datablock capabilities, you will use an object derived from ShapeBase. When you need an object with extremely low overhead, and with no other purpose than to be a 3D object in the scene, you will use TSStatic.

The most basic child of ShapeBase is StaticShape. It does not introduce any of the additional functionality you see in Player, Item, Vehicle or the other game play heavy classes. At its core, it is comparable to a TSStatic, but with a datbalock. Having a datablock provides a location for common variables as well as having access to various ShapeBaseData, GameBaseData and SimDataBlock callbacks.

Example:
// Create a StaticShape using a datablock
datablock StaticShapeData(BasicShapeData)
{
   shapeFile = "art/shapes/items/kit/healthkit.dts";
   testVar = "Simple string, not a stock variable";
};

new StaticShape()
{
   dataBlock = "BasicShapeData";
   position = "0.0 0.0 0.0";
   rotation = "1 0 0 0";
   scale = "1 1 1";
};
See also:
StaticShapeData
ShapeBase
TSStatic

Member Data Documentation

bool StaticShape::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

bool StaticShape::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.


Torque 3D - Script Manual: StaticShapeData Class Reference

StaticShapeData Class Reference
[Game Objects]

The most basic ShapeBaseData derrived shape datablock available in Torque 3D. More...

Inheritance diagram for StaticShapeData:
[legend]

List of all members.

Public Attributes

int | dynamicType
An integer value which, if speficied, is added to the value retured by getType().
bool | noIndividualDamage
Deprecated.

Detailed Description

The most basic ShapeBaseData derrived shape datablock available in Torque 3D.

When it comes to placing 3D objects in the scene, you effectively have two options:

1. TSStatic objects

2. ShapeBase derived objects

Since ShapeBase and ShapeBaseData are not meant to be instantiated in script, you will use one of its child classes instead. Several game related objects are derived from ShapeBase: Player, Vehicle, Item, and so on.

When you need a 3D object with datablock capabilities, you will use an object derived from ShapeBase. When you need an object with extremely low overhead, and with no other purpose than to be a 3D object in the scene, you will use TSStatic.

The most basic child of ShapeBase is StaticShape. It does not introduce any of the additional functionality you see in Player, Item, Vehicle or the other game play heavy classes. At its core, it is comparable to a TSStatic, but with a datbalock. Having a datablock provides a location for common variables as well as having access to various ShapeBaseData, GameBaseData and SimDataBlock callbacks.

Example:
// Create a StaticShape using a datablock
datablock StaticShapeData(BasicShapeData)
{
   shapeFile = "art/shapes/items/kit/healthkit.dts";
   testVar = "Simple string, not a stock variable";
};

new StaticShape()
{
   dataBlock = "BasicShapeData";
   position = "0.0 0.0 0.0";
   rotation = "1 0 0 0";
   scale = "1 1 1";
};
See also:
StaticShape
ShapeBaseData
TSStatic

Member Data Documentation

int StaticShapeData::dynamicType

An integer value which, if speficied, is added to the value retured by getType().

This allows you to extend the type mask for a StaticShape that uses this datablock. Type masks are used for container queries, etc.

bool StaticShapeData::noIndividualDamage

Deprecated.


Torque 3D - Script Manual: StreamObject Class Reference

StreamObject Class Reference
[File I/O]

Base class for working with streams. More...

Inheritance diagram for StreamObject:
[legend]

List of all members.

Public Member Functions

bool | copyFrom (SimObject other)
Copy from another StreamObject into this StreamObject.
int | getPosition ()
Gets the position in the stream.
string | getStatus ()
Gets a printable string form of the stream's status.
int | getStreamSize ()
Gets the size of the stream.
bool | isEOF ()
Tests if the stream has reached the end of the file.
bool | isEOS ()
Tests if the stream has reached the end of the file.
string | readLine ()
Read a line from the stream.
String | readLongString (int maxLength)
Read in a string up to the given maximum number of characters.
String | readString ()
Read a string up to a maximum of 256 characters.
String | readSTString (bool caseSensitive=false)
Read in a string and place it on the string table.
bool | setPosition (int newPosition)
Gets the position in the stream.
void | writeLine (string line)
Write a line to the stream, if it was opened for writing.
void | writeLongString (int maxLength, string string)
Write out a string up to the maximum number of characters.
void | writeString (string string, int maxLength=256)
Write out a string with a default maximum length of 256 characters.

Detailed Description

Base class for working with streams.

You do not instantiate a StreamObject directly. Instead, it is used as part of a FileStreamObject and ZipObject to support working with uncompressed and compressed files respectively.

Example:
// You cannot actually declare a StreamObject
// Instead, use the derived class "FileStreamObject"
%fsObject = FileStreamObject();
See also:
FileStreamObject for the derived class usable in script.
ZipObject where StreamObject is used to read and write to files within a zip archive.

Member Function Documentation

bool StreamObject::copyFrom ( SimObject other )

Copy from another StreamObject into this StreamObject.

Parameters:
other The StreamObject to copy from.
Returns:
True if the copy was successful.
int StreamObject::getPosition ( )

Gets the position in the stream.

The easiest way to visualize this is to think of a cursor in a text file. If you have moved the cursor by five characters, the current position is 5. If you move ahead 10 more characters, the position is now 15. For StreamObject, when you read in the line the position is increased by the number of characters parsed, the null terminator, and a newline.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
// This file contains two lines of text repeated:
// Hello World
// Hello World
%fsObject.open("./test.txt", "read");

// Read in the first line
%line = %fsObject.readLine();

// Get the position of the stream
%position = %fsObject.getPosition();

// Print the current position
// Should be 13, 10 for the words, 1 for the space, 1 for the null terminator, and 1 for the newline
echo(%position);

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
Number of bytes which stream has parsed so far, null terminators and newlines are included
See also:
setPosition()
string StreamObject::getStatus ( )

Gets a printable string form of the stream's status.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
%fsObject.open("./test.txt", "read");

// Get the status and print it
%status = %fsObject.getStatus();
echo(%status);

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
String containing status constant, one of the following:

OK - Stream is active and no file errors

IOError - Something went wrong during read or writing the stream

EOS - End of Stream reached (mostly for reads)

IllegalCall - An unsupported operation used. Always w/ accompanied by AssertWarn

Closed - Tried to operate on a closed stream (or detached filter)

UnknownError - Catch all for an error of some kind

Invalid - Entire stream is invalid

int StreamObject::getStreamSize ( )

Gets the size of the stream.

The size is dependent on the type of stream being used. If it is a file stream, returned value will be the size of the file. If it is a memory stream, it will be the size of the allocated buffer.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
// This file contains the following two lines:
// HelloWorld
// HelloWorld
%fsObject.open("./test.txt", "read");

// Found out how large the file stream is
// Then print it to the console
// Should be 22
%streamSize = %fsObject.getStreamSize();
echo(%streamSize);

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
Size of stream, in bytes
bool StreamObject::isEOF ( )

Tests if the stream has reached the end of the file.

This is an alternative name for isEOS. Both functions are interchangeable. This simply exists for those familiar with some C++ file I/O standards.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
%fsObject.open("./test.txt", "read");

// Keep reading until we reach the end of the file
while( !%fsObject.isEOF() )
{
   %line = %fsObject.readLine();
   echo(%line);
}
// Made it to the end
echo("Finished reading file");

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
True if the parser has reached the end of the file, false otherwise
See also:
isEOS()
bool StreamObject::isEOS ( )

Tests if the stream has reached the end of the file.

This is an alternative name for isEOF. Both functions are interchangeable. This simply exists for those familiar with some C++ file I/O standards.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
%fsObject.open("./test.txt", "read");

// Keep reading until we reach the end of the file
while( !%fsObject.isEOS() )
{
   %line = %fsObject.readLine();
   echo(%line);
}
// Made it to the end
echo("Finished reading file");

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
True if the parser has reached the end of the file, false otherwise
See also:
isEOF()
string StreamObject::readLine ( )

Read a line from the stream.

Emphasis on *line*, as in you cannot parse individual characters or chunks of data. There is no limitation as to what kind of data you can read.

Example:
// Create a file stream object for reading
// This file contains the following two lines:
// HelloWorld
// HelloWorld
%fsObject = new FileStreamObject();

%fsObject.open("./test.txt", "read");

// Read in the first line
%line = %fsObject.readLine();

// Print the line we just read
echo(%line);

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
String containing the line of data that was just read
See also:
writeLine()
String StreamObject::readLongString ( int maxLength )

Read in a string up to the given maximum number of characters.

Parameters:
maxLength The maximum number of characters to read in.
Returns:
The string that was read from the stream.
See also:
writeLongString()
Note:
When working with these particular string reading and writing methods, the stream begins with the length of the string followed by the string itself, and does not include a NULL terminator.
String StreamObject::readString ( )

Read a string up to a maximum of 256 characters.

Returns:
The string that was read from the stream.
See also:
writeString()
Note:
When working with these particular string reading and writing methods, the stream begins with the length of the string followed by the string itself, and does not include a NULL terminator.
String StreamObject::readSTString ( bool caseSensitive = false )

Read in a string and place it on the string table.

Parameters:
caseSensitive If false then case will not be taken into account when attempting to match the read in string with what is already in the string table.
Returns:
The string that was read from the stream.
See also:
writeString()
Note:
When working with these particular string reading and writing methods, the stream begins with the length of the string followed by the string itself, and does not include a NULL terminator.
bool StreamObject::setPosition ( int newPosition )

Gets the position in the stream.

The easiest way to visualize this is to think of a cursor in a text file. If you have moved the cursor by five characters, the current position is 5. If you move ahead 10 more characters, the position is now 15. For StreamObject, when you read in the line the position is increased by the number of characters parsed, the null terminator, and a newline. Using setPosition allows you to skip to specific points of the file.

Example:
// Create a file stream object for reading
%fsObject = new FileStreamObject();

// Open a file for reading
// This file contains the following two lines:
// 11111111111
// Hello World
%fsObject.open("./test.txt", "read");

// Skip ahead by 12, which will bypass the first line entirely
%fsObject.setPosition(12);

// Read in the next line
%line = %fsObject.readLine();

// Print the line just read in, should be "Hello World"
echo(%line);

// Always remember to close a file stream when finished
%fsObject.close();
Returns:
Number of bytes which stream has parsed so far, null terminators and newlines are included
See also:
getPosition()
void StreamObject::writeLine ( string line )

Write a line to the stream, if it was opened for writing.

There is no limit as to what kind of data you can write. Any format and data is allowable, not just text. Be careful of what you write, as whitespace, current values, and literals will be preserved.

Parameters:
line The data we are writing out to file.
Example:
// Create a file stream
%fsObject = new FileStreamObject();

// Open the file for writing
// If it does not exist, it is created. If it does exist, the file is cleared
%fsObject.open("./test.txt", "write");

// Write a line to the file
%fsObject.writeLine("Hello World");

// Write another line to the file
%fsObject.writeLine("Documentation Rocks!");

// Always remember to close a file stream when finished
%fsObject.close();
See also:
readLine()
void StreamObject::writeLongString | ( | int | maxLength,
 |  | string | string
 | ) |  |

Write out a string up to the maximum number of characters.

Parameters:
maxLength | The maximum number of characters that will be written.
string | The string to write out to the stream.
See also:
readLongString()
Note:
When working with these particular string reading and writing methods, the stream begins with the length of the string followed by the string itself, and does not include a NULL terminator.
void StreamObject::writeString | ( | string | string,
 |  | int | maxLength = 256
 | ) |  |

Write out a string with a default maximum length of 256 characters.

Parameters:
string | The string to write out to the stream
maxLength | The maximum string length to write out with a default of 256 characters. This value should not be larger than 256 as it is written to the stream as a single byte.
See also:
readString()
Note:
When working with these particular string reading and writing methods, the stream begins with the length of the string followed by the string itself, and does not include a NULL terminator.


Torque 3D - Script Manual: Sun Class Reference

Sun Class Reference
[Atmosphere]

A global light affecting your entire scene and optionally renders a corona effect. More...

Inheritance diagram for Sun:
[legend]

List of all members.

Public Attributes

void | animate
animate( F32 duration, F32 startAzimuth, F32 endAzimuth, F32 startElevation, F32 endElevation )
void | apply
Lighting

ColorF | ambient
Color shading applied to surfaces not in direct contact with light source, such as in the shadows or interiors.
float | brightness
Adjust the Sun's global contrast/intensity.
bool | castShadows
Enables/disables shadows cast by objects due to Sun light.
ColorF | color
Color shading applied to surfaces in direct contact with light source.
Advanced Lighting

Point3F | attenuationRatio
The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.
filename | cookie
A custom pattern texture which is projected from the light.
float | fadeStartDistance
Start fading shadows out at this distance. 0 = auto calculate this distance.
bool | lastSplitTerrainOnly
This toggles only terrain being rendered to the last split of a PSSM shadow map.
float | logWeight
The logrithmic PSSM split distance factor.
int | numSplits
The logrithmic PSSM split distance factor.
Point4F | overDarkFactor
The ESM shadow darkening factor.
float | shadowDistance
The distance from the camera to extend the PSSM shadow.
float | shadowSoftness
ShadowType shadowType
The type of shadow to use on this light.
int | texSize
The texture size of the shadow map.
Orbit

float | azimuth
The horizontal angle of the sun measured clockwise from the positive Y world axis.
float | elevation
The elevation angle of the sun above or below the horizon.
Corona

bool | coronaEnabled
Enable or disable rendering of the corona sprite.
string | coronaMaterial
Texture for the corona sprite.
float | coronaScale
Controls size the corona sprite renders, specified as a fractional amount of the screen height.
ColorF | coronaTint
Modulates the corona sprite color ( if coronaUseLightColor is false ).
bool | coronaUseLightColor
Modulate the corona sprite color by the color of the light ( overrides coronaTint ).
Misc

float | flareScale
Changes the size and intensity of the flare.
LightFlareData flareType
Datablock for the flare produced by the Sun.
Advanced Lighting Lightmap

bool | includeLightmappedGeometryInShadow
This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).
bool | representedInLightmap
This light is represented in lightmaps (static light, default: false).
ColorF | shadowDarkenColor
The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A global light affecting your entire scene and optionally renders a corona effect.

Sun is both the directional and ambient light for your entire scene.

Member Data Documentation

ColorF Sun::ambient

Color shading applied to surfaces not in direct contact with light source, such as in the shadows or interiors.

void Sun::animate

animate( F32 duration, F32 startAzimuth, F32 endAzimuth, F32 startElevation, F32 endElevation )

void Sun::apply
Point3F Sun::attenuationRatio

The proportions of constant, linear, and quadratic attenuation to use for the falloff for point and spot lights.

float Sun::azimuth

The horizontal angle of the sun measured clockwise from the positive Y world axis.

float Sun::brightness

Adjust the Sun's global contrast/intensity.

bool Sun::castShadows

Enables/disables shadows cast by objects due to Sun light.

ColorF Sun::color

Color shading applied to surfaces in direct contact with light source.

filename Sun::cookie

A custom pattern texture which is projected from the light.

bool Sun::coronaEnabled

Enable or disable rendering of the corona sprite.

string Sun::coronaMaterial

Texture for the corona sprite.

float Sun::coronaScale

Controls size the corona sprite renders, specified as a fractional amount of the screen height.

ColorF Sun::coronaTint

Modulates the corona sprite color ( if coronaUseLightColor is false ).

bool Sun::coronaUseLightColor

Modulate the corona sprite color by the color of the light ( overrides coronaTint ).

float Sun::elevation

The elevation angle of the sun above or below the horizon.

float Sun::fadeStartDistance

Start fading shadows out at this distance. 0 = auto calculate this distance.

float Sun::flareScale

Changes the size and intensity of the flare.

LightFlareData Sun::flareType

Datablock for the flare produced by the Sun.

bool Sun::includeLightmappedGeometryInShadow

This light should render lightmapped geometry during its shadow-map update (ignored if 'representedInLightmap' is false).

bool Sun::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool Sun::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool Sun::lastSplitTerrainOnly

This toggles only terrain being rendered to the last split of a PSSM shadow map.

float Sun::logWeight

The logrithmic PSSM split distance factor.

int Sun::numSplits

The logrithmic PSSM split distance factor.

Point4F Sun::overDarkFactor

The ESM shadow darkening factor.

bool Sun::representedInLightmap

This light is represented in lightmaps (static light, default: false).

ColorF Sun::shadowDarkenColor

The color that should be used to multiply-blend dynamic shadows onto lightmapped geometry (ignored if 'representedInLightmap' is false).

float Sun::shadowDistance

The distance from the camera to extend the PSSM shadow.

float Sun::shadowSoftness
ShadowType Sun::shadowType

The type of shadow to use on this light.

int Sun::texSize

The texture size of the shadow map.


Torque 3D - Script Manual: TCPObject Class Reference

TCPObject Class Reference
[Platform]

Allows communications between the game and a server using TCP/IP protocols. More...

Inheritance diagram for TCPObject:
[legend]

List of all members.

Public Member Functions

void | connect (string address)
Connect to the given address.
void | disconnect ()
Disconnect from whatever this TCPObject is currently connected to, if anything.
void | listen (int port)
Start listening on the specified port for connections.
void | send (string data)
Transmits the data string to the server.
Callbacks

void | onConnected ()
Called whenever a connection is established with a server.
void | onConnectFailed ()
Called whenever a connection has failed to be established with a server.
void | onConnectionRequest (string address, string ID)
Called whenever a connection request is made.
void | onDisconnect ()
Called whenever the TCPObject disconnects from whatever it is currently connected to.
void | onDNSFailed ()
Called whenever the DNS has failed to resolve.
void | onDNSResolved ()
Called whenever the DNS has been resolved.
void | onLine (string line)
Called whenever a line of data is sent from the server connected to this TCPObject to the game client.

Detailed Description

Allows communications between the game and a server using TCP/IP protocols.

Example:
// Create a an TCP object for communications
%newTCPObj = new TCPObject();

// Transmit a send command with a specific server. Parameters are transmitted to the server as strings, one at a time.
%newTCPObj.send(""GET " @ $RSSFeed::serverURL @ " HTTP/1.0
Host: " @ $RSSFeed::serverName @ "\nUser-Agent: " @ $RSSFeed::userAgent @ "\n\r\n\r\n"");

// Callback from the engine. Called when the TCPObject receives a response from the server, along with return data.
function TCPObject.onLine(%this,%returnLine);
{
   echo("Data returned from the server = " @ %returnLine );
};

// DNS Resolved Response
TCPObject::onDNSResolved(%this)
{
   // Do Code When DNS Resolved
}

// DNS Failed Resonse
TCPObject::onDNSFailed(%this)
{
   // Do Code When DNS Failed
}

// Connected to Server Response
TCPObject::onConnected(%this)
{
   // Do Code When Connection Occurs
}

// Connection to Server Failed
TCPObject::onConnectFailed(%this)
{
   // Do Code When Connection Failed
}

// Disconnected from Server
TCPObject::onDisconnect(%this)
{
   // Do Code When Disconnected
}

Member Function Documentation

void TCPObject::onConnected ( )

Called whenever a connection is established with a server.

void TCPObject::onConnectFailed ( )

Called whenever a connection has failed to be established with a server.

void TCPObject::onConnectionRequest | ( | string | address,
 |  | string | ID
 | ) |  |

Called whenever a connection request is made.

Parameters:
address | Server address to connect to.
ID | Connection ID
void TCPObject::onDisconnect ( )

Called whenever the TCPObject disconnects from whatever it is currently connected to.

void TCPObject::onDNSFailed ( )

Called whenever the DNS has failed to resolve.

void TCPObject::onDNSResolved ( )

Called whenever the DNS has been resolved.

void TCPObject::onLine ( string line )

Called whenever a line of data is sent from the server connected to this TCPObject to the game client.

Parameters:
line Data sent from the server.


Torque 3D - Script Manual: TerrainBlock Class Reference

TerrainBlock Class Reference
[Terrain]

Represent a terrain object in a Torque 3D level. More...

Inheritance diagram for TerrainBlock:
[legend]

List of all members.

Public Member Functions

bool | exportHeightMap (string filename,[string format])
export the terrain block's heightmap to a bitmap file (default: png)
bool | exportLayerMaps (string filePrefix,[string format])
export the terrain block's layer maps to bitmap files (default: png)
int | import (String terrainName, String heightMap, F32 metersPerPixel, F32 heightScale, String materials, String opacityLayers)
bool | save (string fileName)
Saves the terrain block's terrain file to the specified file name.

Public Attributes

int | createNew
TerrainBlock.create( String terrainName, U32 resolution, String materialName, bool genNoise ).
Misc

int | baseTexSize
Size of base texture size per meter.
bool | castShadows
Allows the terrain to cast shadows onto itself and other objects.
int | lightMapSize
Light map dimensions in pixels.
int | screenError
Not yet implemented.
float | squareSize
Indicates the spacing between points on the XY plane on the terrain.
Media

filename | terrainFile
The source terrain data file.

Static Public Attributes

static bool | debugRender
Triggers debug rendering of terrain cells.
static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Represent a terrain object in a Torque 3D level.

Example:
new TerrainBlock(theTerrain)
{
   terrainFile = "art/terrains/Deathball Desert_0.ter";
   squareSize = "2";
   tile = "0";
   baseTexSize = "1024";
   screenError = "16";
   position = "-1024 -1024 179.978";
   rotation = "1 0 0 0";
   scale = "1 1 1";
   isRenderEnabled = "true";
   canSaveDynamicFields = "1";
};
See also:
TerrainMaterial

Member Function Documentation

bool TerrainBlock::exportHeightMap ( string filename )

export the terrain block's heightmap to a bitmap file (default: png)

bool TerrainBlock::exportLayerMaps ( string filePrefix )

export the terrain block's layer maps to bitmap files (default: png)

int TerrainBlock::import | ( | String | terrainName,
 |  | String | heightMap,
 |  | F32 | metersPerPixel,
 |  | F32 | heightScale,
 |  | String | materials,
 |  | String | opacityLayers
 | ) |  |
bool TerrainBlock::save ( string fileName )

Saves the terrain block's terrain file to the specified file name.

Parameters:
fileName Name and path of file to save terrain data to.
Returns:
True if file save was successful, false otherwise

Member Data Documentation

int TerrainBlock::baseTexSize

Size of base texture size per meter.

bool TerrainBlock::castShadows

Allows the terrain to cast shadows onto itself and other objects.

int TerrainBlock::createNew

TerrainBlock.create( String terrainName, U32 resolution, String materialName, bool genNoise ).

bool TerrainBlock::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool TerrainBlock::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

int TerrainBlock::lightMapSize

Light map dimensions in pixels.

int TerrainBlock::screenError

Not yet implemented.

float TerrainBlock::squareSize

Indicates the spacing between points on the XY plane on the terrain.

filename TerrainBlock::terrainFile

The source terrain data file.


Torque 3D - Script Manual: TerrainMaterial Class Reference

TerrainMaterial Class Reference
[Miscellaneous]

The TerrainMaterial class orginizes the material settings for a single terrain material layer. More...

Inheritance diagram for TerrainMaterial:
[legend]

List of all members.

Public Attributes

float | detailDistance
Changes how far camera can see the detail map rendering on the material.
filename | detailMap
Detail map for the material.
float | detailSize
Used to scale the detail map to the material square.
float | detailStrength
Exponentially sharpens or lightens the detail map rendering on the material.
filename | diffuseMap
Base texture for the material.
float | diffuseSize
Used to scale the diffuse map to the material square.
filename | normalMap
Bump map for the material.
float | parallaxScale
Used to scale the height from the normal map to give some self occlusion effect (aka parallax) to the terrain material.
bool | useSideProjection
Makes that terrain material project along the sides of steep slopes instead of projected downwards.

Detailed Description

The TerrainMaterial class orginizes the material settings for a single terrain material layer.

Note:
You should not be creating TerrainMaterials by hand in code. All TerrainMaterials should be created in the editors, as intended by the system.
Example:
// Created by the Terrain Painter tool in the World Editor
new TerrainMaterial()
{
   internalName = "grass1";
   diffuseMap = "art/terrains/Test/grass1";
   detailMap = "art/terrains/Test/grass1_d";
   detailSize = "10";
   isManaged = "1";
   detailBrightness = "1";
   Enabled = "1";
   diffuseSize = "200";
};
See also:
Materials

Member Data Documentation

float TerrainMaterial::detailDistance

Changes how far camera can see the detail map rendering on the material.

filename TerrainMaterial::detailMap

Detail map for the material.

float TerrainMaterial::detailSize

Used to scale the detail map to the material square.

float TerrainMaterial::detailStrength

Exponentially sharpens or lightens the detail map rendering on the material.

filename TerrainMaterial::diffuseMap

Base texture for the material.

float TerrainMaterial::diffuseSize

Used to scale the diffuse map to the material square.

filename TerrainMaterial::normalMap

Bump map for the material.

float TerrainMaterial::parallaxScale

Used to scale the height from the normal map to give some self occlusion effect (aka parallax) to the terrain material.

bool TerrainMaterial::useSideProjection

Makes that terrain material project along the sides of steep slopes instead of projected downwards.


Torque 3D - Script Manual: TimeOfDay Class Reference

TimeOfDay Class Reference
[Miscellaneous]

Environmental object that triggers a day/night cycle in level. More...

Inheritance diagram for TimeOfDay:
[legend]

List of all members.

Public Member Functions

void | addTimeOfDayEvent (float elevation, string identifier)
void | animate (float elevation, float degreesPerSecond)
void | setDayLength (float seconds)
void | setPlay (bool enabled)
void | setTimeOfDay (float time)

Public Attributes

TimeOfDay

float | axisTilt
The angle in degrees between global equator and tropic.
float | azimuthOverride
float | dayLength
The length of a virtual day in real world seconds.
float | dayScale
Scalar applied to time that elapses while the sun is up.
float | nightScale
Scalar applied to time that elapses while the sun is down.
bool | play
True when the TimeOfDay object is operating.
float | startTime
float | time
Current time of day.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Environmental object that triggers a day/night cycle in level.

Note:
TimeOfDay only works in Advanced Lighting with a Sub object or ScatterSky
Example:
new TimeOfDay(tod)
{
   axisTilt = "23.44";
   dayLength = "120";
   startTime = "0.15";
   time = "0.15";
   play = "0";
   azimuthOverride = "572.958";
   dayScale = "1";
   nightScale = "1.5";
   position = "598.399 550.652 196.297";
   rotation = "1 0 0 0";
   scale = "1 1 1";
   canSave = "1";
   canSaveDynamicFields = "1";
};

Member Function Documentation

void TimeOfDay::addTimeOfDayEvent | ( | float | elevation,
 |  | string | identifier
 | ) |  |
void TimeOfDay::animate | ( | float | elevation,
 |  | float | degreesPerSecond
 | ) |  |
void TimeOfDay::setDayLength ( float seconds )
void TimeOfDay::setPlay ( bool enabled )
void TimeOfDay::setTimeOfDay ( float time )

Member Data Documentation

float TimeOfDay::axisTilt

The angle in degrees between global equator and tropic.

float TimeOfDay::azimuthOverride
float TimeOfDay::dayLength

The length of a virtual day in real world seconds.

float TimeOfDay::dayScale

Scalar applied to time that elapses while the sun is up.

bool TimeOfDay::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool TimeOfDay::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

float TimeOfDay::nightScale

Scalar applied to time that elapses while the sun is down.

bool TimeOfDay::play

True when the TimeOfDay object is operating.

float TimeOfDay::startTime
float TimeOfDay::time

Current time of day.


Torque 3D - Script Manual: Trigger Class Reference

Trigger Class Reference
[Game Objects]

A Trigger is a volume of space that initiates script callbacks when objects pass through the Trigger. More...

Inheritance diagram for Trigger:
[legend]

List of all members.

Public Member Functions

int | getNumObjects ()
Get the number of objects that are within the Trigger's bounds.
int | getObject (int index)
Retrieve the requested object that is within the Trigger's bounds.
Callbacks

void | onAdd (int objectId)
Called when the Trigger is being created.
void | onRemove (int objectId)
Called just before the Trigger is deleted.

Public Attributes

string | enterCommand
The command to execute when an object enters this trigger. Object id stored in %obj. Maximum 1023 characters.
string | leaveCommand
The command to execute when an object leaves this trigger. Object id stored in %obj. Maximum 1023 characters.
floatList | polyhedron
Defines a non-rectangular area for the trigger.
string | tickCommand
The command to execute while an object is inside this trigger. Maximum 1023 characters.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static bool | renderTriggers
Forces all Trigger's to render.

Detailed Description

A Trigger is a volume of space that initiates script callbacks when objects pass through the Trigger.

TriggerData provides the callbacks for the Trigger when an object enters, stays inside or leaves the Trigger's volume.

See also:
TriggerData

Member Function Documentation

int Trigger::getNumObjects ( )

Get the number of objects that are within the Trigger's bounds.

See also:
getObject()
int Trigger::getObject ( int index )

Retrieve the requested object that is within the Trigger's bounds.

Parameters:
index Index of the object to get (range is 0 to getNumObjects()-1)
Returns:
The SimObjectID of the object, or -1 if the requested index is invalid.
See also:
getNumObjects()
void Trigger::onAdd ( int objectId )

Called when the Trigger is being created.

Parameters:
objectId the object id of the Trigger being created
void Trigger::onRemove ( int objectId )

Called just before the Trigger is deleted.

Parameters:
objectId the object id of the Trigger being deleted

Member Data Documentation

string Trigger::enterCommand

The command to execute when an object enters this trigger. Object id stored in %obj. Maximum 1023 characters.

bool Trigger::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from GameBase.

bool Trigger::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from GameBase.

string Trigger::leaveCommand

The command to execute when an object leaves this trigger. Object id stored in %obj. Maximum 1023 characters.

floatList Trigger::polyhedron

Defines a non-rectangular area for the trigger.

Rather than the standard rectangular bounds, this optional parameter defines a quadrilateral trigger area. The quadrilateral is defined as a corner point followed by three vectors representing the edges extending from the corner.

string Trigger::tickCommand

The command to execute while an object is inside this trigger. Maximum 1023 characters.


Torque 3D - Script Manual: TriggerData Class Reference

TriggerData Class Reference
[Game Objects]

Defines shared properties for Trigger objects. More...

Inheritance diagram for TriggerData:
[legend]

List of all members.

Callbacks

bool | clientSide
Forces Trigger callbacks to only be called on clients.
int | tickPeriodMS
Time in milliseconds between calls to onTickTrigger() while at least one object is within a Trigger's bounds.
void | onEnterTrigger (Trigger trigger, GameBase obj)
Called when an object enters the volume of the Trigger instance using this TriggerData.
void | onLeaveTrigger (Trigger trigger, GameBase obj)
Called when an object leaves the volume of the Trigger instance using this TriggerData.
void | onTickTrigger (Trigger trigger)
Called every tickPeriodMS number of milliseconds (as specified in the TriggerData) whenever one or more objects are inside the volume of the trigger.

Detailed Description

Defines shared properties for Trigger objects.

The primary focus of the TriggerData datablock is the callbacks it provides when an object is within or leaves the Trigger bounds.

See also:
Trigger.

Member Function Documentation

void TriggerData::onEnterTrigger | ( | Trigger | trigger,
 |  | GameBase | obj
 | ) |  |

Called when an object enters the volume of the Trigger instance using this TriggerData.

Parameters:
trigger | the Trigger instance whose volume the object entered
obj | the object that entered the volume of the Trigger instance
void TriggerData::onLeaveTrigger | ( | Trigger | trigger,
 |  | GameBase | obj
 | ) |  |

Called when an object leaves the volume of the Trigger instance using this TriggerData.

Parameters:
trigger | the Trigger instance whose volume the object left
obj | the object that left the volume of the Trigger instance
void TriggerData::onTickTrigger ( Trigger trigger )

Called every tickPeriodMS number of milliseconds (as specified in the TriggerData) whenever one or more objects are inside the volume of the trigger.

The Trigger has methods to retrieve the objects that are within the Trigger's bounds if you want to do something with them in this callback.

Parameters:
trigger the Trigger instance whose volume the object is inside
See also:
tickPeriodMS
Trigger::getNumObjects()
Trigger::getObject()

Member Data Documentation

bool TriggerData::clientSide

Forces Trigger callbacks to only be called on clients.

int TriggerData::tickPeriodMS

Time in milliseconds between calls to onTickTrigger() while at least one object is within a Trigger's bounds.

See also:
onTickTrigger()


Torque 3D - Script Manual: TSForestItemData Class Reference

TSForestItemData Class Reference
[Forest]

Concrete implementation of ForestItemData which loads and renders dts format shapeFiles. More...

Inheritance diagram for TSForestItemData:
[legend]

List of all members.

Detailed Description

Concrete implementation of ForestItemData which loads and renders dts format shapeFiles.


Torque 3D - Script Manual: TSShapeConstructor Class Reference

TSShapeConstructor Class Reference
[Game Objects]

An object used to modify a DTS or COLLADA shape model after it has been loaded by Torque. More...

Inheritance diagram for TSShapeConstructor:
[legend]

List of all members.

Public Member Functions

bool | addCollisionDetail (int size, string type, string target, int depth=4, float merge=30, float concavity=30, int maxVerts=32, float boxMaxError=0, float sphereMaxError=0, float capsuleMaxError=0)
Autofit a mesh primitive or set of convex hulls to the shape geometry. Hulls may optionally be converted to boxes, spheres and/or capsules based on their volume.
int | addImposter (int size, int equatorSteps, int polarSteps, int dl, int dim, bool includePoles, float polarAngle)
Add (or edit) an imposter detail level to the shape.
bool | addMesh (string meshName, string srcShape, string srcMesh)
Add geometry from another DTS or DAE shape file into this shape.
bool | addNode (string name, string parentName, TransformF txfm=TransformF::Identity, bool isWorld=false)
Add a new node.
bool | addPrimitive (string meshName, string type, string params, TransformF txfm, string nodeName)
Add a new mesh primitive to the shape.
bool | addSequence (string source, string name, int start=0, int end=-1)
Add a new sequence to the shape.
bool | addTrigger (string name, int keyframe, int state)
Add a new trigger to the sequence.
void | dumpShape (string filename="")
Dump the shape hierarchy to the console or to a file. Useful for reviewing the result of a series of construction commands.
Box3F | getBounds ()
Get the bounding box for the shape.
int | getDetailLevelCount ()
Get the total number of detail levels in the shape.
int | getDetailLevelIndex (int size)
Get the index of the detail level with a given size.
string | getDetailLevelName (int index)
Get the name of the indexed detail level.
int | getDetailLevelSize (int index)
Get the size of the indexed detail level.
int | getImposterDetailLevel ()
Get the index of the imposter (auto-billboard) detail level (if any).
string | getImposterSettings (int index)
Get the settings used to generate imposters for the indexed detail level.
int | getMeshCount (string name)
Get the number of meshes (detail levels) for the specified object.
string | getMeshMaterial (string name)
Get the name of the material attached to a mesh. Note that only the first material used by the mesh is returned.
string | getMeshName (string name, int index)
Get the name of the indexed mesh (detail level) for the specified object.
int | getMeshSize (string name, int index)
Get the detail level size of the indexed mesh for the specified object.
string | getMeshType (string name)
Get the display type of the mesh.
int | getNodeChildCount (string name)
Get the number of children of this node.
string | getNodeChildName (string name, int index)
Get the name of the indexed child node.
int | getNodeCount ()
Get the total number of nodes in the shape.
int | getNodeIndex (string name)
Get the index of the node.
string | getNodeName (int index)
Get the name of the indexed node.
int | getNodeObjectCount (string name)
Get the number of geometry objects attached to this node.
string | getNodeObjectName (string name, int index)
Get the name of the indexed object.
string | getNodeParentName (string name)
Get the name of the node's parent. If the node has no parent (ie. it is at the root level), return an empty string.
TransformF | getNodeTransform (string name, bool isWorld=false)
Get the base (ie. not animated) transform of a node.
int | getObjectCount ()
Get the total number of objects in the shape.
int | getObjectIndex (string name)
Get the index of the first object with the given name.
string | getObjectName (int index)
Get the name of the indexed object.
string | getObjectNode (string name)
Get the name of the node this object is attached to.
string | getSequenceBlend (string name)
Get information about blended sequences.
int | getSequenceCount ()
Get the total number of sequences in the shape.
bool | getSequenceCyclic (string name)
Check if this sequence is cyclic (looping).
int | getSequenceFrameCount (string name)
Get the number of keyframes in the sequence.
string | getSequenceGroundSpeed (string name)
Get the ground speed of the sequence.
int | getSequenceIndex (string name)
Find the index of the sequence with the given name.
string | getSequenceName (int index)
Get the name of the indexed sequence.
float | getSequencePriority (string name)
Get the priority setting of the sequence.
string | getSequenceSource (string name)
Get information about where the sequence data came from.
int | getTargetCount ()
Get the number of materials in the shape.
string | getTargetName (int index)
Get the name of the indexed shape material.
string | getTrigger (string name, int index)
Get information about the indexed trigger.
int | getTriggerCount (string name)
Get the number of triggers in the specified sequence.
void | notifyShapeChanged ()
Notify game objects that this shape file has changed, allowing them to update internal data if needed.
bool | removeDetailLevel (int index)
Remove the detail level (including all meshes in the detail level).
bool | removeImposter ()
Remove the imposter detail level (if any) from the shape.
bool | removeMesh (string name)
Remove a mesh from the shape.
bool | removeNode (string name)
Remove a node from the shape.
bool | removeObject (string name)
Remove an object (including all meshes for that object) from the shape.
bool | removeSequence (string name)
Remove the sequence from the shape.
bool | removeTrigger (string name, int keyframe, int state)
Remove a trigger from the sequence.
bool | renameDetailLevel (string oldName, string newName)
Rename a detail level.
bool | renameNode (string oldName, string newName)
Rename a node.
bool | renameObject (string oldName, string newName)
Rename an object.
bool | renameSequence (string oldName, string newName)
Rename a sequence.
void | saveShape (string filename)
Save the shape (with all current changes) to a new DTS file.
bool | setBounds (Box3F bbox)
Set the shape bounds to the given bounding box.
int | setDetailLevelSize (int index, int newSize)
Change the size of a detail level.
bool | setMeshMaterial (string meshName, string matName)
Set the name of the material attached to the mesh.
bool | setMeshSize (string name, int size)
Change the detail level size of the named mesh.
bool | setMeshType (string name, string type)
Set the display type for the mesh.
bool | setNodeParent (string name, string parentName)
Set the parent of a node.
bool | setNodeTransform (string name, TransformF txfm, bool isWorld=false)
Set the base transform of a node. That is, the transform of the node when in the root (not-animated) pose.
bool | setObjectNode (string objName, string nodeName)
Set the node an object is attached to.
bool | setSequenceBlend (string name, bool blend, string blendSeq, int blendFrame)
Mark a sequence as a blend or non-blend.
bool | setSequenceCyclic (string name, bool cyclic)
Mark a sequence as cyclic or non-cyclic.
bool | setSequenceGroundSpeed (string name, Point3F transSpeed, Point3F rotSpeed=Point3F::Zero)
Set the translation and rotation ground speed of the sequence.
bool | setSequencePriority (string name, float priority)
Set the sequence priority.
void | writeChangeSet ()
Write the current change set to a TSShapeConstructor script file. The name of the script file is the same as the model, but with .cs extension. eg. myShape.cs for myShape.dts or myShape.dae.
Callbacks

void | onLoad ()
Called immediately after the DTS or DAE file has been loaded; before the shape data is available to any other object (StaticShape, Player etc). This is where you should put any post-load commands to modify the shape in-memory such as addNode, renameSequence etc.
void | onUnload ()
Called when the DTS or DAE resource is flushed from memory. Not normally required, but may be useful to perform cleanup.

Public Attributes

Collada

bool | adjustCenter
Translate COLLADA model on import so the origin is at the center. No effect for DTS files.
bool | adjustFloor
Translate COLLADA model on import so origin is at the (Z axis) bottom of the model. No effect for DTS files.
string | alwaysImport
TAB separated patterns of nodes to import even if in neverImport list. No effect for DTS files.
string | alwaysImportMesh
TAB separated patterns of meshes to import even if in neverImportMesh list. No effect for DTS files.
bool | forceUpdateMaterials
Forces update of the materials.cs file in the same folder as the COLLADA (.dae) file, even if Materials already exist. No effect for DTS files.
bool | ignoreNodeScale
Ignore <scale> elements inside COLLADA <node>s. No effect for DTS files.
TSShapeConstructorLodType | lodType
Control how the COLLADA (.dae) importer interprets LOD in the model. No effect for DTS files.
string | matNamePrefix
Prefix to apply to all material map names in the COLLADA (.dae) file. No effect for DTS files.
string | neverImport
TAB separated patterns of nodes to ignore on loading. No effect for DTS files.
string | neverImportMesh
TAB separated patterns of meshes to ignore on loading. No effect for DTS files.
int | singleDetailSize
Sets the detail size when lodType is set to SingleSize. No effect otherwise, and no effect for DTS files.
float | unit
Override the <unit> element in the COLLADA (.dae) file. No effect for DTS files.
TSShapeConstructorUpAxis | upAxis
Override the <up_axis> element in the COLLADA (.dae) file. No effect for DTS files.
Media

filename | baseShape
Specifies the path to the DTS or DAE file to be operated on by this object.
Sequences

filename | sequence
Legacy method of adding sequences to a DTS or DAE shape after loading.

Detailed Description

An object used to modify a DTS or COLLADA shape model after it has been loaded by Torque.

TSShapeConstructor is a special object used to modify a DTS or COLLADA shape model after it has been loaded by Torque, but before it is used by any other object.

It is often used to share animations from DSQ files between shapes with a common skeleton.

It may also be used to 'Torquify' a model that is missing the nodes and/or sequences required to function as a particular Torque object. A model used for a Player character for example should have an eye and a cam node, but these might not be present in a model not specifically created for Torque. TSShapeConstructor allows the missing nodes to be added and positioned so that the shape does not need to be re-worked or re-exported by an artist.

Note:
In T3D, TSShapeConstructor is no longer a SimDataBlock (like in TGE and TGEA), but a SimObject instead. This means that all declarations of TSShapeConstructor should use the singleton keyword instead of the datablock keyword.

TSShapeConstructor also includes features to aid in loading COLLADA models, such as allowing the <up_axis> and <unit> elements to be overridden, and can also apply a user specified prefix to the names of COLLADA materials as shown below. Prefixing material names is useful to avoid name clashes, particularly for 3D apps like Google SketchUp that export models with generic material names like "material0". These options are most easily accessed using the COLLADA import gui, which will be displayed automatically the first time a COLLADA model is imported into Torque.

Settings from the import gui are automatically saved to a TSShapeConstructor script in the same folder as the model.

To create your own TSShapeConstructor object, simply create a TorqueScript file in the same folder as your DTS or COLLADA model, with the same filename but .cs extension. For example, if your model file was called myShape.dts, you would create a file called myShape.cs. Some example appear below:

singleton TSShapeConstructor( MyShapeDae )
{
   baseShape = "./myShape.dae";
   upAxis = "DEFAULT";          // use <up_axis> defined in myShape.dae
   unit = "1.0";                // override <unit> to be 1.0
   matNamePrefix = "";          // no prefix applied to collada materials
};

singleton TSShapeConstructor( MyShape2Dae )
{
   baseShape = "./myShape2.dae";
   upAxis = "Y_AXIS";           // override <up_axis> to be Y_AXIS
   unit = -1;                   // use <unit> defined in myShape2.dae
   matNamePrefix = "myShape2_"; // prefix all collada material names with "myShape2_"
}

The name of the TSShapeConstructor object (MyShapeDae and MyShape2Dae in the code samples above) is up to you, but you should choose a name that does not conflict with other objects or datablocks. A common convention for TSShapeConstructor objects is the name of the shape file. eg. MyShapeDae for a file called myshape.dae.

When Torque loads a DTS (.dts) or COLLADA (.dae) file, it first looks in the same folder for a TorqueScript file with the same filename (but .cs extension) in order to create the TSShapeConstructor object. Such scripts are executed automatically by Torque 3D, so there is no need to manually call exec("myShape.cs") from another script. Also, you should avoid adding other object and datablock declarations to this script because it will be executed every time the model is loaded, which may cause unexpected results if the datablocks already exist.

After Torque has loaded the model from the DTS or COLLADA file, it executes the TSShapeConstructor onLoad method to apply the desired set of changes to the shape. It should be noted that the changes are applied to the loaded model in memory rather than to the DTS or COLLADA file itself. This means the model can be re-exported to DTS or COLLADA without overwriting the TSShapeConstructor changes. TSShapeConstructor should be thought of as a post-export processing step, and is intended to be used alongside existing object and datablock setups.

Note that DSQ sequences may still be specified within the TSShapeConstructor object as normal:

singleton TSShapeConstructor( PlayerDts )
{
   baseShape = "./player.dts";
   sequence = "~/art/shapes/actors/animations/player_root.dsq root";
   sequence = "~/art/shapes/actors/animations/player_forward.dsq run";
};

function PlayerDts::onLoad( %this )
{
   %this.addCollisionDetail( -1, "box", "bounds" ); // collision mesh
   %this.addSequence( "walk", "walk_short", 1, 5 ); // add subsequence
   %this.addTrigger( "walk_short", 3, 4 );          // add trigger to sequence
   %this.renameSequence( "walk", "walk_long" );     // rename sequence
   %this.renameNode( "Bip Pelvis", "pelvis" );      // rename node
   %this.addNode( "mount5", "Bip L Hand" );         // add a new node
   %this.dumpShape();                               // dump shape to console
}

Note that most of the features in TSShapeConstructor are far more easily accessible in the Shape Editor tool. This tool uses TSShapeConstructor 'under-the-hood' to edit the nodes, sequences and details of a shape, and the changes are saved to a TSShapeConstructor script object.

Shape Terminology

The following definitions should be understood before reading the TSShapeConstructor examples and function reference:

node
A node is a place-holder for transform (position and rotation) information. Nodes are arranged in a parent/child hierarchy allowing complex skeleton structures to be built up.
sequence
A sequence is a set of keyframed node transforms and object states (eg. visibility).
detail level
Level-of-Detail (LOD) is very important to maintain good rendering performance. When a shape is rendered, Torque automatically picks a single detail level based on that shape's on-screen size. Only the sub-meshes belonging to that detail level are rendered.
object
An object is a collection of meshes, each at a different detail level. Each object is attached to a certain node, and is rendered at that node's current transform.
mesh
A mesh is a piece of geometry, and may be a rigid body or a skin (vertex weighted mesh). Each mesh is associated with an object and a certain detail level.

Example 1: Adding a Collision Mesh To an Existing Shape

Imagine you have a model that you want to add to the scene as a StaticShape, but it is missing a collision mesh. TSShapeConstructor makes it simple to modify an existing DTS shape to add a collision (or line-of-sight collision) detail level.

First, define the StaticShapeData datablock as normal. Create a script called myShape.cs in the art/datablocks folder, and define the datablock:

datablock StaticShapeData( MyShapeData )
{
   category = "Misc";
   shapeFile = "art/shapes/myShape/myShape.dts";
};

We need to tell Torque to execute this script so add exec("./myShape.cs"); to art/datablocks/datablockExec.cs.

Now we define the TSShapeConstructor object by creating a new script called myShape.cs in the art/shapes/myShape folder:

singleton TSShapeConstructor( MyShapeDts )
{
   baseShape = "~/art/shapes/myShape/myShape.dts";
};

function MyShapeDts::onLoad( %this )
{
   %this.addCollisionDetail( -1, "box", "bounds" );
}

This script will add a box mesh with the same center and dimensions as the original model using the "Col" detail level at size -1. The negative detail size means that the mesh will not be rendered in-game, and the use of the special "Col" name means that this mesh will be detected as a collision mesh by the Torque engine.

When a Torque mission is started, the following steps occur:

  1. On the server, Torque executes art/datablocks/datablockExec.cs, which in turn executes art/datablocks/myShape.cs
  2. Executing art/datablocks/myShape.cs causes the MyShapeData datablock to attempt to load the DTS file
  3. Before loading the DTS file, Torque executes art/shapes/myShape/myShape.cs, which creates the TSShapeConstructor object
  4. After loading the DTS file, Torque executes MyShapeDts::onLoad, which adds the collision detail level to the shape
  5. The StaticShape object can now be added to the scene (it will appear in the world editor (in the "Misc" category under the Library/Scripted tab)

Example 2: Adding a Mesh From an Existing DTS File

The image below shows a boulder.dts shape in the Torque Show Tool Pro (TSTPro). The circled items indicate the geometry and material that will be copied into a different shape using TSShapeConstructor.

The following shows how to include the boulder1 mesh in another shape:

singleton TSShapeConstructor( TestShapeDts )
{
   baseShape = "~/art/shapes/rocks/rock1.dts";
};

function TestShapeDts::onLoad( %this )
{
   %this.addMesh( "test128", "~/art/shapes/rocks/boulder.dts", "boulder1" );
   %this.dumpShape();
}

The output of the dumpShape command is shown below:

Shape Hierarchy:

   Details:
      detail128, Subtree 0, objectDetail 0, size 128
      detail2, Subtree 0, objectDetail 1, size 2
      collision-1, Subtree 0, objectDetail 2, size -1

   Subtrees:
      Subtree 0
         Rock2 --> Object Rock with following details:  2
               --> Object test with following details:  128
         col-1 --> Object col with following details:  -1

   Sequences:

   %Material list:
   material #0: 'rock2'.
   material #1: 'MossyRock02'.

Note that the new detail ("detail128"), object ("test") and material ("MossyRock02") have been added to the normal rock1.dts shape.

Example 3: Auto-loading animations

Instead of manually specifying all of the animations to load, it's easy to write some TorqueScript that will scan a folder for any matching animations and add them to the shape automatically. Imagine that we have the following shape (DTS) and sequence (DSQ) files:

  • art/shapes/actors/ForgeSoldier/ForgeSoldier.dts
  • art/shapes/actors/animations/player_root.dsq
  • art/shapes/actors/animations/player_run.dsq
  • art/shapes/actors/animations/player_back.dsq
  • art/shapes/actors/animations/player_side.dsq
  • art/shapes/actors/animations/player_death0.dsq

The following script will scan the animations folder and add the sequences to the shape.

singleton TSShapeConstructor( ForgeSoldierDts )
{
   baseShape = "~/art/shapes/actors/ForgeSoldier/ForgeSolder.dts";
};

function ForgeSoldierDts::onLoad( %this )
{
   AddAnimations( %this );
}

function AddAnimations( %shape )
{
   // Scan for all player_*.dsq files and add the animations to the shape.
   // Sequence names are taken from the base name of the dsq file. eg.
   // player_run.dsq would add a sequence called 'run'.

   %filePatterns = "art/shapes/actors/animations/player_*.dsq";
   %fullPath = findFirstFileMultiExpr( %filePatterns );
   while ( %fullPath !$= "" )
   {
      // add this animation to the shape
      %fullPath = makeRelativePath( %fullPath, getMainDotCSDir() );
      %seq_name = strreplace( filebase( %fullPath ), "player_", "" );
      %shape.addSequence( %fullpath, %seq_name );
      %fullPath = findNextFileMultiExpr( %filePatterns );
   }
}

Example 4: Splitting COLLADA animations

Many COLLADA exporters do not support the <animation_clip> element, meaning that animated models imported into Torque appear to have only a single sequence containing all of the animations. TSShapeConstructor can be used to split this combined animation into individual sequences. This is most easily done using the Shape Editor tool, but can also be done manually as follows:

singleton TSShapeConstructor( PlayerModelDts )
{
   baseShape = "~/art/shapes/collada/myPlayer.dae";
};

function PlayerModelDts::onLoad( %this )
{
   // Split animations from combined "ambient" sequence
   %this.addSequence( "ambient", "root", 0, 15 );
   %this.addSequence( "ambient", "run", 16, 40 );
   %this.addSequence( "ambient", "back", 41, 55 );
   %this.addSequence( "ambient", "side", 56, 70 );
   %this.addSequence( "ambient", "death0", 80, 120 );

   // Remove combined "ambient" sequence => we don't need it anymore
   %this.removeSequence( "ambient" );
}

Example 5: LOD using separate files

In the past, using LOD required the artist to export all detail levels into a single DTS file. Using TSShapeConstructor, we can combine separate model files together. In fact, we can even use the folder-scanning approach from Example 3 to automatically construct the shape detail levels using all of the model files in the folder!

Note that the detail level models must contain the same object name, and for skinned models, the skin must be applied to the same skeleton for this script to work.

Imagine that we have the following shape (DAE) files:

  • art/shapes/actors/soldier/soldier.dae (the base model, highest detail level size=1024)
  • art/shapes/actors/soldier/soldier_512.dae
  • art/shapes/actors/soldier/soldier_256.dae
  • art/shapes/actors/soldier/soldier_64.dae
singleton TSShapeConstructor( SoldierDae )
{
   baseShape = "~/art/shapes/actors/soldier.dae";
};

function SoldierDae::onLoad( %this )
{
   %objName = %this.getObjectName( 0 );
   AddDetails( %this, %objName );
}

// Scan for all DAE files in the folder with the same base name, and add the
// skinned mesh from that file to the input shape. The size of the detail level
// is taken from the end of the filename. eg. soldier_30.dae will add detail
// level 30 to the shape.
// Note that this function can be in a different script so it can be shared by
// multiple TSShapeConstructor objects...
function AddDetails( %shape, %objName )
{
   // Determine the base name of the input file. eg. the basename of
   // soldier.dae is 'soldier'.
   %inputBase = fileBase( %shape.baseShape );

   %filePatterns = filePath( %shape.baseShape ) @ "/" @ %inputBase @ "_*.dae";
   %fullPath = findFirstFileMultiExpr( %filePatterns );
   while (%fullPath !$= "")
   {
      %fullPath = makeRelativePath( %fullPath, getMainDotCSDir() );

      // Determine the detail size, then add the new mesh (assumes exported with size = 2)
      %size = strreplace( fileBase( %fullPath ), %inputBase @ "_", "" );
      %shape.addMesh( %objName SPC %size, %fullPath, %objName SPC "2" );

      %fullPath = findNextFileMultiExpr( %filePatterns );
   }
}

Example 6: Add lights to the scene

Although most often used to modify a shape before it is used, TSShapeConstructor can also be used as a general purpose interface to a 3D shape. For example, a 3D modeling package could be used to layout positions for lights in the scene. On import, the shape hierarchy might look like this:

base01
 +-start01
   +-Lights
     +-lightA
     +-lightB
     +-lightC
     ...

The following code demonstrates how to create a TSShapeConstructor object on-demand in order to access the 3D shape data. This example adds lights to the current scene at position of the lightX nodes in the shape:

function AddLights( %obj )
{
   // Get a TSShapeConstructor for this object (use the ShapeEditor
   // utility functions to create one if it does not already exist).
   %shapePath = ShapeEditor.getObjectShapeFile( %obj );
   %shape = ShapeEditor.findConstructor( %shapePath );
   if ( !isObject( %shape ) )
      %shape = ShapeEditor.createConstructor( %shapePath );
   if ( !isObject( %shape ) )
   {
      echo( "Failed to create TSShapeConstructor for " @ %obj.getId() );
      return;
   }

   %objTransform = %obj.getTransform();

   %lightsGroup = "Lights";
   %count = %shape.getNodeChildCount( %lightsGroup );
   for ( %i = 0; %i < %count; %i++ )
   {
      // get node transform in object space, then transform to world space
      %child = %shape.getNodeChildName( %lightsGroup, %i );
      %txfm = %shape.getNodeTransform( %child, true );
      %txfm = MatrixMultiply( %objTransform, %txfm );

      // create a new light at the object node
      %light = new PointLight() {
         position = getWords( %txfm, 0, 2 );
         rotation = getWords( %txfm, 3, 6 );
      };
      MissionGroup.add( %light );
   }
}

The original shape can be placed anywhere in the scene, then AddLights is called to create and place a PointLight at each node.

Example 7: Rigid-body Player Character

Using the addNode and addMesh functions, it is possible to create a rigid-body (ie. non-skinned) player model compatible with the default animations, completely from TorqueScript!

The default player skeleton node transforms were obtained by adding the following code to the TSShapeConstructor onLoad function for a shape that already contained the default skeleton:

%count = %this.getNodeCount();
for ( %i = 0; %i < %count; %i++ )
{
   %name = %this.getNodeName( %i );
   echo( "%shape.addNode(\"" @ %name @ "\", \"" @ %this.getNodeParentName( %name ) @ "\", \"" @
         %this.getNodeTransform( %name ) @ "\");" );
}

The contents of the console can then be copied and pasted into a new script. The script below shows the player model creation process: first pick a dummy dts file (rock1.dts in this case), and delete its existing nodes and meshes. Then create the default player skeleton. Finally, some box meshes are added at certain nodes to build up a rigid-body player character.

// Create the default Torque skeleton (compatible with the default player animations)
function CreateDefaultSkeleton( %shape )
{
   %shape.addNode( "Bip01 Pelvis",      "",                  "-8.10647e-005 8.34974e-006 1.28118 0.00147092 0.999914 0.000312013 1.50833" );
   %shape.addNode( "Bip01 Spine",       "Bip01 Pelvis",      "0.117738 -0.000117005 0.00695224 0.995531 0 0.054662 0.178899" );
   %shape.addNode( "Bip01 Spine1",      "Bip01 Spine",       "0.149188 -0.000154936 5.87594e-006 0.158383 0.207314 0.965104 0.285376" );
   %shape.addNode( "Bip01 Spine2",      "Bip01 Spine1",      "0.202462 -0.000162536 2.93078e-005 0.731516 -0.35723 -0.579706 0.251143" );
   %shape.addNode( "Bip01 Neck",        "Bip01 Spine2",      "0.209867 -4.86846e-005 -2.05922e-005 -0.926274 0.0899337 -0.365008 0.431595" );
   %shape.addNode( "Bip01 Head",        "Bip01 Neck",        "0.067264 -6.98505e-009 -6.66524e-009 -0.139433 0.872649 -0.450268 0.089769" );
   %shape.addNode( "Eye",               "Bip01 Head",        "0.180021 0.33282 -0.00125568 -0.0139777 -0.999387 0.030751 1.57784" );
   %shape.addNode( "Bip01 L Clavicle",  "Bip01 Neck",        "0.0059334 0.0332864 0.0795624 -0.632128 -0.230228 -0.739819 2.58923" );
   %shape.addNode( "Bip01 L UpperArm",  "Bip01 L Clavicle",  "0.358891 -1.27006e-008 1.34618e-007 0.300944 -0.93298 0.197112 1.51847" );
   %shape.addNode( "Bip01 L Forearm",   "Bip01 L UpperArm",  "0.395474 -1.37648e-008 1.96789e-008 0 0 0.999871 0.850149" );
   %shape.addNode( "Bip01 L Hand",      "Bip01 L Forearm",   "0.363508 3.95569e-008 3.80099e-008 -0.975012 -0.0676349 0.211535 3.8945" );
   %shape.addNode( "Bip01 R Clavicle",  "Bip01 Neck",        "-0.00593357 -0.0331793 -0.0795624 0.631473 -0.0957054 -0.769459 3.0916" );
   %shape.addNode( "Bip01 R UpperArm",  "Bip01 R Clavicle",  "0.358891 -1.02138e-008 1.01681e-007 0.594451 0.803854 -0.017401 1.47305" );
   %shape.addNode( "Bip01 R Forearm",   "Bip01 R UpperArm",  "0.395474 6.19864e-008 1.31302e-008 0 0 0.999951 1.88239" );
   %shape.addNode( "Bip01 R Hand",      "Bip01 R Forearm",   "0.363508 1.03579e-008 -1.18848e-008 -0.976003 -0.105148 0.190568 1.71108" );
   %shape.addNode( "mount0",            "Bip01 R Hand",      "0.192386 0.0479768 0.000897807 0.0616579 0.0736096 0.995312 1.76131" );
   %shape.addNode( "mount2",            "Bip01 Spine2",      "0.101603 -0.255502 0.00682753 0.0431623 -0.998124 -0.0431623 1.57267" );
   %shape.addNode( "mount1",            "Bip01 Spine2",      "0.101603 -0.255502 0.00682756 0.0431623 -0.998124 -0.0431623 1.57267" );
   %shape.addNode( "Bip01 L Thigh",     "Bip01 Spine",       "-0.117582 -0.0342993 0.1847 -0.227865 -0.966002 -0.121932 3.27836" );
   %shape.addNode( "Bip01 L Calf",      "Bip01 L Thigh",     "0.567764 2.88694e-008 -2.61884e-009 0 0 0.999795 0.784881" );
   %shape.addNode( "Bip01 L Foot",      "Bip01 L Calf",      "0.659264 6.37417e-009 5.70856e-009 -0.0798252 0.398941 -0.913186 0.331842" );
   %shape.addNode( "Ski0",              "Bip01 L Foot",      "0.587469 -0.0426512 -0.0990439 0.750521 0.554827 0.358877 1.9778" );
   %shape.addNode( "Bip01 R Thigh",     "Bip01 Spine",       "-0.117896 0.0347 -0.198562 -0.134559 -0.982239 0.130533 2.9039" );
   %shape.addNode( "Bip01 R Calf",      "Bip01 R Thigh",     "0.567764 8.48371e-010 1.88575e-009 0 0 0.999915 0.836729" );
   %shape.addNode( "Bip01 R Foot",      "Bip01 R Calf",      "0.659264 -3.34983e-008 -2.20877e-008 0.0784375 -0.241304 -0.967069 0.567876" );
   %shape.addNode( "Ski1",              "Bip01 R Foot",      "0.600815 -0.0369749 0.0998079 -0.352371 -0.698146 -0.62318 3.91937" );
   %shape.addNode( "Unlink",            "",                  "-0.00586435 -0.000234549 0.056661 -0.579417 -0.577691 -0.574872 2.09521" );
   %shape.addNode( "Cam",               "Unlink",            "0.237214 2.06536 -0.00742381 0.999942 -0.00266823 -0.00189359 1.57655" );
}

// Create a new box mesh at the specified node
function CreateBoxObject( %shape, %name, %node, %size, %offset )
{
   if ( %offset $= "" )
      %offset = "0 0 0";

   %shape.addPrimitive( %name @ "2", "box", %size, %offset SPC "0 0 1 0", %node );
}

// Create a simple (rigid) player model using boxes for body parts
function CreateRigidPlayer( %shape )
{
   CreateBoxObject( %shape, "head",             "Eye",               "0.2 0.2 0.3" );

   CreateBoxObject( %shape, "upper_torso",      "Bip01 Spine2",      "0.3 0.2 0.4" );
   CreateBoxObject( %shape, "lower_torso",      "Bip01 Spine",       "0.3 0.2 0.35" );

   CreateBoxObject( %shape, "left_thigh",       "Bip01 L Thigh",     "0.5 0.2 0.2", "0.25 0 0" );
   CreateBoxObject( %shape, "left_leg",         "Bip01 L Calf",      "0.4 0.2 0.2", "0.25 0 0" );
   CreateBoxObject( %shape, "left_foot",        "Bip01 L Foot",      "0.2 0.2 0.2" );

   CreateBoxObject( %shape, "right_thigh",      "Bip01 R Thigh",     "0.5 0.2 0.2", "0.25 0 0" );
   CreateBoxObject( %shape, "right_leg",        "Bip01 R Calf",      "0.4 0.2 0.2", "0.25 0 0" );
   CreateBoxObject( %shape, "right_foot",       "Bip01 R Foot",      "0.2 0.2 0.2" );

   CreateBoxObject( %shape, "left_upper_arm",   "Bip01 L UpperArm",  "0.3 0.15 0.15", "0.15 0 0" );
   CreateBoxObject( %shape, "left_forearm",     "Bip01 L Forearm",   "0.2 0.15 0.15", "0.1 0 0" );
   CreateBoxObject( %shape, "left_hand",        "Bip01 L Hand",      "0.15 0.15 0.15" );

   CreateBoxObject( %shape, "right_upper_arm",  "Bip01 R UpperArm",  "0.3 0.15 0.15", "0.15 0 0" );
   CreateBoxObject( %shape, "right_forearm",    "Bip01 R Forearm",   "0.2 0.15 0.15", "0.1 0 0" );
   CreateBoxObject( %shape, "right_hand",       "Bip01 R Hand",      "0.15 0.15 0.15" );

   // create collision mesh
   %shape.addCollisionDetail( -1, "box", "bounds" );
}

singleton TSShapeConstructor( TestModelDts )
{
   baseShape = "~/art/shapes/rocks/rock1.dts";
};

function TestModelDts::onLoad( %this )
{
   // remove the existing nodes and geometry so we start with a blank shape
   %count = %this.getObjectCount();
   for ( %i = %count-1; %i >= 0; %i-- )
      %this.removeObject( %this.getObjectName( %i ) );
   %count = %this.getNodeCount();
   for ( %i = %count-1; %i >= 0; %i-- )
      %this.removeNode( %this.getNodeName( %i ) );

   // create the player skeleton and rigid body parts
   CreateDefaultSkeleton( %this );
   CreateRigidPlayer( %this );

   // now load the default sequences
   %this.addSequence( "~/art/shapes/actors/animations/player_root.dsq",    "root" );
   %this.addSequence( "~/art/shapes/actors/animations/player_forward.dsq", "run" );

   %this.dumpShape();
}

// The player model definition

singleton PlayerData( TestModelData : DefaultPlayerData )
{
   renderFirstPerson = false;
   emap = true;

   //className = Armor;
   shapeFile = "~/art/shapes/rocks/rock1.dts";
};

PlayerDatasGroup.add( TestModelData );

This produces the following shape:

Shape Hierarchy:

   Details:
      detail2, Subtree 0, objectDetail 0, size 2
      collision-1, Subtree 0, objectDetail 1, size -1

   Subtrees:
      Subtree 0
         Bip01 Pelvis --> Object col with following details:  -1
            Bip01 Spine --> Object lower_torso with following details:  2
               Bip01 Spine1
                  Bip01 Spine2 --> Object upper_torso with following details:  2
                     Bip01 Neck
                        Bip01 Head
                           Eye --> Object head with following details:  2
                        Bip01 L Clavicle
                           Bip01 L UpperArm --> Object left_upper_arm with following details:  2
                              Bip01 L Forearm --> Object left_forearm with following details:  2
                                 Bip01 L Hand --> Object left_Hand with following details:  2
                        Bip01 R Clavicle
                           Bip01 R UpperArm --> Object right_upper_arm with following details:  2
                              Bip01 R Forearm --> Object right_forearm with following details:  2
                                 Bip01 R Hand --> Object right_hand with following details:  2
                                    Mount0
                     Mount2
                     Mount1
               Bip01 L Thigh --> Object left_thigh with following details:  2
                  Bip01 L Calf --> Object left_leg with following details:  2
                     Bip01 L Foot --> Object left_foot with following details:  2
                        Ski0
               Bip01 R Thigh --> Object right_thigh with following details:  2
                  Bip01 R Calf --> Object right_leg with following details:  2
                     Bip01 R Foot --> Object right_foot with following details:  2
                        Ski1
         Unlink
            Cam

   Sequences:
        0: %Root (cyclic)
        1: run (cyclic)

Member Function Documentation

bool TSShapeConstructor::addCollisionDetail | ( | int | size,
 |  | string | type,
 |  | string | target,
 |  | int | depth = 4,
 |  | float | merge = 30,
 |  | float | concavity = 30,
 |  | int | maxVerts = 32,
 |  | float | boxMaxError = 0,
 |  | float | sphereMaxError = 0,
 |  | float | capsuleMaxError = 0
 | ) |  |

Autofit a mesh primitive or set of convex hulls to the shape geometry. Hulls may optionally be converted to boxes, spheres and/or capsules based on their volume.

Parameters:
size | size for this detail level
type | one of: box, sphere, capsule, 10-dop x, 10-dop y, 10-dop z, 18-dop, 26-dop, convex hulls. See the Shape Editor documentation for more details about these types.
target | geometry to fit collision mesh(es) to; either "bounds" (for the whole shape), or the name of an object in the shape
depth | maximum split recursion depth (hulls only)
merge | volume % threshold used to merge hulls together (hulls only)
concavity | volume % threshold used to detect concavity (hulls only)
maxVerts | maximum number of vertices per hull (hulls only)
boxMaxError | max % volume difference for a hull to be converted to a box (hulls only)
sphereMaxError | max % volume difference for a hull to be converted to a sphere (hulls only)
capsuleMaxError | max % volume difference for a hull to be converted to a capsule (hulls only)
Returns:
true if successful, false otherwise
Example:
%this.addCollisionDetail( -1, "box", "bounds" );
%this.addCollisionDetail( -1, "convex hulls", "bounds", 4, 30, 30, 32, 0, 0, 0 );
%this.addCollisionDetail( -1, "convex hulls", "bounds", 4, 30, 30, 32, 50, 50, 50 );

int TSShapeConstructor::addImposter | ( | int | size,
 |  | int | equatorSteps,
 |  | int | polarSteps,
 |  | int | dl,
 |  | int | dim,
 |  | bool | includePoles,
 |  | float | polarAngle
 | ) |  |

Add (or edit) an imposter detail level to the shape.

If the shape already contains an imposter detail level, this command will simply change the imposter settings

Parameters:
size | size of the imposter detail level
equatorSteps | defines the number of snapshots to take around the equator. Imagine the object being rotated around the vertical axis, then a snapshot taken at regularly spaced intervals.
polarSteps | defines the number of snapshots taken between the poles (top and bottom), at each equator step. eg. At each equator snapshot, snapshots are taken at regular intervals between the poles.
dl | the detail level to use when generating the snapshots. Note that this is an array index rather than a detail size. So if an object has detail sizes of: 200, 150, and 40, then setting dl to 1 will generate the snapshots using detail size 150.
dim | defines the size of the imposter images in pixels. The larger the number, the more detailed the billboard will be.
includePoles | flag indicating whether to include the "pole" snapshots. ie. the views from the top and bottom of the object.
polar_angle | if pole snapshots are active (includePoles is true), this parameter defines the camera angle (in degrees) within which to render the pole snapshot. eg. if polar_angle is set to 25 degrees, then the snapshot taken at the pole (looking directly down or up at the object) will be rendered when the camera is within 25 degrees of the pole.
Returns:
true if successful, false otherwise
Example:
%this.addImposter( 2, 4, 0, 0, 64, false, 0 );
%this.addImposter( 2, 4, 2, 0, 64, true, 10 );   // this command would edit the existing imposter detail level

bool TSShapeConstructor::addMesh | ( | string | meshName,
 |  | string | srcShape,
 |  | string | srcMesh
 | ) |  |

Add geometry from another DTS or DAE shape file into this shape.

Any materials required by the source mesh are also copied into this shape.

Parameters:
meshName full name (object name + detail size) of the new mesh. If no detail size is present at the end of the name, a value of 2 is used.
An underscore before the number at the end of the name will be interpreted as a negative sign. eg. "MyMesh_4" will be interpreted as "MyMesh-4".
srcShape | name of a shape file (DTS or DAE) that contains the mesh
srcMesh | the full name (object name + detail size) of the mesh to copy from the DTS/DAE file into this shape
Returns:
true if successful, false otherwise
Example:
%this.addMesh( "ColMesh-1", "./collision.dts", "ColMesh", "Col-1" );
%this.addMesh( "SimpleShape10", "./testShape.dae", "MyMesh2",  );

bool TSShapeConstructor::addNode | ( | string | name,
 |  | string | parentName,
 |  | TransformF | txfm = TransformF::Identity,
 |  | bool | isWorld = false
 | ) |  |

Add a new node.

Parameters:
name | name for the new node (must not already exist)
parentName | name of an existing node to be the parent of the new node. If empty (""), the new node will be at the root level of the node hierarchy.
txfm | (optional) transform string of the form: "pos.x pos.y pos.z rot.x rot.y rot.z rot.angle"
isworld | (optional) flag to set the local-to-parent or the global transform. If false, or not specified, the position and orientation are treated as relative to the node's parent.
Returns:
true if successful, false otherwise
Example:
%this.addNode( "Nose", "Bip01 Head", "0 2 2 0 0 1 0" );
%this.addNode( "myRoot", "", "0 0 4 0 0 1 1.57" );
%this.addNode( "Nodes", "Bip01 Head", "0 2 0 0 0 1 0", true );

bool TSShapeConstructor::addPrimitive | ( | string | meshName,
 |  | string | type,
 |  | string | params,
 |  | TransformF | txfm,
 |  | string | nodeName
 | ) |  |

Add a new mesh primitive to the shape.

Parameters:
meshName full name (object name + detail size) of the new mesh. If no detail size is present at the end of the name, a value of 2 is used.
An underscore before the number at the end of the name will be interpreted as a negative sign. eg. "MyMesh_4" will be interpreted as "MyMesh-4".
type | one of: "box", "sphere", "capsule"
params mesh primitive parameters:

  • for box: "size_x size_y size_z"
  • for sphere: "radius"
  • for capsule: "height radius"
txfm | local transform offset from the node for this mesh
nodeName | name of the node to attach the new mesh to (will change the object's node if adding a new mesh to an existing object)
Returns:
true if successful, false otherwise
Example:
%this.addMesh( "Box4", "box", "2 4 2", "0 2 0 0 0 1 0", "eye" );
%this.addMesh( "Sphere256", "sphere", "2", "0 0 0 0 0 1 0", "root" );
%this.addMesh( "MyCapsule-1", "capsule", "2 5", "0 0 2 0 0 1 0", "base01" );

bool TSShapeConstructor::addSequence | ( | string | source,
 |  | string | name,
 |  | int | start = 0,
 |  | int | end = -1
 | ) |  |

Add a new sequence to the shape.

Parameters:
source | the name of an existing sequence, or the name of a DTS or DAE shape or DSQ sequence file. When the shape file contains more than one sequence, the desired sequence can be specified by appending the name to the end of the shape file. eg. "myShape.dts run" would select the "run" sequence from the "myShape.dts" file.
name | name of the new sequence
start | (optional) first frame to copy. Defaults to 0, the first frame in the sequence.
end | (optional) last frame to copy. Defaults to -1, the last frame in the sequence.
Returns:
true if successful, false otherwise
Example:
%this.addSequence( "./testShape.dts ambient", "ambient" );
%this.addSequence( "./myPlayer.dae run", "run" );
%this.addSequence( "./player_look.dsq", "look", 0, -1 );     // start to end
%this.addSequence( "walk", "walk_shortA", 0, 4 );            // start to frame 4
%this.addSequence( "walk", "walk_shortB", 4, -1 );           // frame 4 to end

bool TSShapeConstructor::addTrigger | ( | string | name,
 |  | int | keyframe,
 |  | int | state
 | ) |  |

Add a new trigger to the sequence.

Parameters:
name | name of the sequence to modify
keyframe | keyframe of the new trigger
state | of the new trigger
Returns:
true if successful, false otherwise
Example:
%this.addTrigger( "walk", 3, 1 );
%this.addTrigger( "walk", 5, -1 );
void TSShapeConstructor::dumpShape ( string filename = "" )

Dump the shape hierarchy to the console or to a file. Useful for reviewing the result of a series of construction commands.

Parameters:
filename Destination filename. If not specified, dump to console.
Example:
%this.dumpShape();               // dump to console
%this.dumpShape( "./dump.txt" ); // dump to file
Box3F TSShapeConstructor::getBounds ( )

Get the bounding box for the shape.

Returns:
Bounding box "minX minY minZ maxX maxY maxZ"
int TSShapeConstructor::getDetailLevelCount ( )

Get the total number of detail levels in the shape.

Returns:
the number of detail levels in the shape
int TSShapeConstructor::getDetailLevelIndex ( int size )

Get the index of the detail level with a given size.

Parameters:
size size of the detail level to lookup
Returns:
index of the detail level with the desired size, or -1 if no such detail exists
Example:
if ( %this.getDetailLevelSize( 32 ) == -1 )
   echo( "Error: This shape does not have a detail level at size 32" );
string TSShapeConstructor::getDetailLevelName ( int index )

Get the name of the indexed detail level.

Parameters:
index detail level index (valid range is 0 - getDetailLevelCount()-1)
Returns:
the detail level name
Example:
// print the names of all detail levels in the shape
%count = %this.getDetailLevelCount();
for ( %i = 0; %i < %count; %i++ )
   echo( %i SPC %this.getDetailLevelName( %i ) );
int TSShapeConstructor::getDetailLevelSize ( int index )

Get the size of the indexed detail level.

Parameters:
index detail level index (valid range is 0 - getDetailLevelCount()-1)
Returns:
the detail level size
Example:
// print the sizes of all detail levels in the shape
%count = %this.getDetailLevelCount();
for ( %i = 0; %i < %count; %i++ )
   echo( "Detail" @ %i @ " has size " @ %this.getDetailLevelSize( %i ) );
int TSShapeConstructor::getImposterDetailLevel ( )

Get the index of the imposter (auto-billboard) detail level (if any).

Returns:
imposter detail level index, or -1 if the shape does not use imposters.
string TSShapeConstructor::getImposterSettings ( int index )

Get the settings used to generate imposters for the indexed detail level.

Parameters:
index index of the detail level to query (does not need to be an imposter detail level
Returns:
string of the form: "valid eqSteps pSteps dl dim poles angle", where:
valid
1 if this detail level generates imposters, 0 otherwise
eqSteps
number of steps around the equator
pSteps
number of steps between the poles
dl
index of the detail level used to generate imposters
dim
size (in pixels) of each imposter image
poles
1 to include pole images, 0 otherwise
angle
angle at which to display pole images
Example:
// print the imposter detail level settings
%index = %this.getImposterDetailLevel();
if ( %index != -1 )
   echo( "Imposter settings: " @ %this.getImposterSettings( %index ) );
int TSShapeConstructor::getMeshCount ( string name )

Get the number of meshes (detail levels) for the specified object.

Parameters:
name name of the object to query
Returns:
the number of meshes for this object.
Example:
%count = %this.getMeshCount( "SimpleShape" );
string TSShapeConstructor::getMeshMaterial ( string name )

Get the name of the material attached to a mesh. Note that only the first material used by the mesh is returned.

Parameters:
name full name (object name + detail size) of the mesh to query
Returns:
name of the material attached to the mesh (suitable for use with the Material mapTo field)
Example:
echo( "Mesh material is " @ %this.sgetMeshMaterial( "SimpleShape128" ) );

string TSShapeConstructor::getMeshName | ( | string | name,
 |  | int | index
 | ) |  |

Get the name of the indexed mesh (detail level) for the specified object.

Parameters:
name | name of the object to query
index | index of the mesh (valid range is 0 - getMeshCount()-1)
Returns:
the mesh name.
Example:
// print the names of all meshes in the shape
%objCount = %this.getObjectCount();
for ( %i = 0; %i < %objCount; %i++ )
{
   %objName = %this.getObjectName( %i );
   %meshCount = %this.getMeshCount( %objName );
   for ( %j = 0; %j < %meshCount; %j++ )
      echo( %this.getMeshName( %objName, %j ) );
}

int TSShapeConstructor::getMeshSize | ( | string | name,
 |  | int | index
 | ) |  |

Get the detail level size of the indexed mesh for the specified object.

Parameters:
name | name of the object to query
index | index of the mesh (valid range is 0 - getMeshCount()-1)
Returns:
the mesh detail level size.
Example:
// print sizes for all detail levels of this object
%objName = "trunk";
%count = %this.getMeshCount( %objName );
for ( %i = 0; %i < %count; %i++ )
   echo( %this.getMeshSize( %objName, %i ) );
string TSShapeConstructor::getMeshType ( string name )

Get the display type of the mesh.

Parameters:
name name of the mesh to query
Returns:
the string returned is one of:
normal
a normal 3D mesh
billboard
a mesh that always faces the camera
billboardzaxis
a mesh that always faces the camera in the Z-axis
Example:
echo( "Mesh type is " @ %this.getMeshType( "SimpleShape128" ) );
int TSShapeConstructor::getNodeChildCount ( string name )

Get the number of children of this node.

Parameters:
name name of the node to query.
Returns:
the number of child nodes.
Example:
%count = %this.getNodeChildCount( "Bip01 Pelvis" );

string TSShapeConstructor::getNodeChildName | ( | string | name,
 |  | int | index
 | ) |  |

Get the name of the indexed child node.

Parameters:
name | name of the parent node to query.
index | index of the child node (valid range is 0 - getNodeChildName()-1).
Returns:
the name of the indexed child node.
Example:
function dumpNode( %shape, %name, %indent )
{
   echo( %indent @ %name );
   %count = %shape.getNodeChildCount( %name );
   for ( %i = 0; %i < %count; %i++ )
      dumpNode( %shape, %shape.getNodeChildName( %name, %i ), %indent @ "   " );
}

function dumpShape( %shape )
{
   // recursively dump node hierarchy
   %count = %shape.getNodeCount();
   for ( %i = 0; %i < %count; %i++ )
   {
      // dump top level nodes
      %name = %shape.getNodeName( %i );
      if ( %shape.getNodeParentName( %name ) $=  )
         dumpNode( %shape, %name, "" );
   }
}
int TSShapeConstructor::getNodeCount ( )

Get the total number of nodes in the shape.

Returns:
the number of nodes in the shape.
Example:
%count = %this.getNodeCount();
int TSShapeConstructor::getNodeIndex ( string name )

Get the index of the node.

Parameters:
name name of the node to lookup.
Returns:
the index of the named node, or -1 if no such node exists.
Example:
// get the index of Bip01 Pelvis node in the shape
%index = %this.getNodeIndex( "Bip01 Pelvis" );
string TSShapeConstructor::getNodeName ( int index )

Get the name of the indexed node.

Parameters:
index index of the node to lookup (valid range is 0 - getNodeCount()-1).
Returns:
the name of the indexed node, or "" if no such node exists.
Example:
// print the names of all the nodes in the shape
%count = %this.getNodeCount();
for (%i = 0; %i < %count; %i++)
   echo(%i SPC %this.getNodeName(%i));
int TSShapeConstructor::getNodeObjectCount ( string name )

Get the number of geometry objects attached to this node.

Parameters:
name name of the node to query.
Returns:
the number of attached objects.
Example:
%count = %this.getNodeObjectCount( "Bip01 Head" );

string TSShapeConstructor::getNodeObjectName | ( | string | name,
 |  | int | index
 | ) |  |

Get the name of the indexed object.

Parameters:
name | name of the node to query.
index | index of the object (valid range is 0 - getNodeObjectCount()-1).
Returns:
the name of the indexed object.
Example:
// print the names of all objects attached to the node
%count = %this.getNodeObjectCount( "Bip01 Head" );
for ( %i = 0; %i < %count; %i++ )
   echo( %this.getNodeObjectName( "Bip01 Head", %i ) );
string TSShapeConstructor::getNodeParentName ( string name )

Get the name of the node's parent. If the node has no parent (ie. it is at the root level), return an empty string.

Parameters:
name name of the node to query.
Returns:
the name of the node's parent, or "" if the node is at the root level
Example:
echo( "Bip01 Pelvis parent = " @ %this.getNodeParentName( "Bip01 Pelvis ") );

TransformF TSShapeConstructor::getNodeTransform | ( | string | name,
 |  | bool | isWorld = false
 | ) |  |

Get the base (ie. not animated) transform of a node.

Parameters:
name | name of the node to query.
isWorld | true to get the global transform, false (or omitted) to get the local-to-parent transform.
Returns:
the node transform in the form "pos.x pos.y pos.z rot.x rot.y rot.z rot.angle".
Example:
%ret = %this.getNodeTransform( "mount0" );
%this.setNodeTransform( "mount4", %ret );
int TSShapeConstructor::getObjectCount ( )

Get the total number of objects in the shape.

Returns:
the number of objects in the shape.
Example:
%count = %this.getObjectCount();
int TSShapeConstructor::getObjectIndex ( string name )

Get the index of the first object with the given name.

Parameters:
name name of the object to get.
Returns:
the index of the named object.
Example:
%index = %this.getObjectIndex( "Head" );
string TSShapeConstructor::getObjectName ( int index )

Get the name of the indexed object.

Parameters:
index index of the object to get (valid range is 0 - getObjectCount()-1).
Returns:
the name of the indexed object.
Example:
// print the names of all objects in the shape
%count = %this.getObjectCount();
for ( %i = 0; %i < %count; %i++ )
   echo( %i SPC %this.getObjectName( %i ) );
string TSShapeConstructor::getObjectNode ( string name )

Get the name of the node this object is attached to.

Parameters:
name name of the object to get.
Returns:
the name of the attached node, or an empty string if this object is not attached to a node (usually the case for skinned meshes).
Example:
echo( "Hand is attached to " @ %this.getObjectNode( "Hand" ) );
string TSShapeConstructor::getSequenceBlend ( string name )

Get information about blended sequences.

Parameters:
name name of the sequence to query
Returns:
TAB delimited string of the form: "isBlend blendSeq blendFrame", where:
blend_flag
a boolean flag indicating whether this sequence is a blend
blend_seq_name
the name of the sequence that contains the reference frame (empty for blend sequences embedded in DTS files)
blend_seq_frame
the blend reference frame (empty for blend sequences embedded in DTS files)
Note:
Note that only sequences set to be blends using the setSequenceBlend command will contain the blendSeq and blendFrame information.
Example:
%blendData = %this.getSequenceBlend( "look" );
if ( getField( %blendData, 0 ) )
   echo( "look is a blend, reference: " @ getField( %blendData, 1 ) );
int TSShapeConstructor::getSequenceCount ( )

Get the total number of sequences in the shape.

Returns:
the number of sequences in the shape
bool TSShapeConstructor::getSequenceCyclic ( string name )

Check if this sequence is cyclic (looping).

Parameters:
name name of the sequence to query
Returns:
true if this sequence is cyclic, false if not
Example:
if ( !%this.getSequenceCyclic( "ambient" ) )
   error( "ambient sequence is not cyclic!" );
int TSShapeConstructor::getSequenceFrameCount ( string name )

Get the number of keyframes in the sequence.

Parameters:
name name of the sequence to query
Returns:
number of keyframes in the sequence
Example:
echo( "Run has " @ %this.getSequenceFrameCount( "run" ) @ " keyframes" );
string TSShapeConstructor::getSequenceGroundSpeed ( string name )

Get the ground speed of the sequence.

Note:
Note that only the first 2 ground frames of the sequence are examined; the speed is assumed to be constant throughout the sequence.
Parameters:
name name of the sequence to query
Returns:
string of the form: "trans.x trans.y trans.z rot.x rot.y rot.z"
Example:
%speed = VectorLen( getWords( %this.getSequenceGroundSpeed( "run" ), 0, 2 ) );
   echo( "Run moves at " @ %speed @ " units per frame" );
int TSShapeConstructor::getSequenceIndex ( string name )

Find the index of the sequence with the given name.

Parameters:
name name of the sequence to lookup
Returns:
index of the sequence with matching name, or -1 if not found
Example:
// Check if a given sequence exists in the shape
if ( %this.getSequenceIndex( "walk" ) == -1 )
   echo( "Could not find 'walk' sequence" );
string TSShapeConstructor::getSequenceName ( int index )

Get the name of the indexed sequence.

Parameters:
index index of the sequence to query (valid range is 0 - getSequenceCount()-1)
Returns:
the name of the sequence
Example:
// print the name of all sequences in the shape
%count = %this.getSequenceCount();
for ( %i = 0; %i < %count; %i++ )
   echo( %i SPC %this.getSequenceName( %i ) );
float TSShapeConstructor::getSequencePriority ( string name )

Get the priority setting of the sequence.

Parameters:
name name of the sequence to query
Returns:
priority value of the sequence
string TSShapeConstructor::getSequenceSource ( string name )

Get information about where the sequence data came from.

For example, whether it was loaded from an external DSQ file.

Parameters:
name name of the sequence to query
Returns:
TAB delimited string of the form: "from reserved start end total", where:
from
the source of the animation data, such as the path to a DSQ file, or the name of an existing sequence in the shape. This field will be empty for sequences already embedded in the DTS or DAE file.
reserved
reserved value
start
the first frame in the source sequence used to create this sequence
end
the last frame in the source sequence used to create this sequence
total
the total number of frames in the source sequence
Example:
// print the source for the walk animation
echo( "walk source:" SPC getField( %this.getSequenceSource( "walk" ), 0 ) );
int TSShapeConstructor::getTargetCount ( )

Get the number of materials in the shape.

Returns:
the number of materials in the shape.
Example:
%count = %this.getTargetCount();
string TSShapeConstructor::getTargetName ( int index )

Get the name of the indexed shape material.

Parameters:
index index of the material to get (valid range is 0 - getTargetCount()-1).
Returns:
the name of the indexed material.
Example:
%count = %this.getTargetCount();
for ( %i = 0; %i < %count; %i++ )
   echo( "Target " @ %i @ ": " @ %this.getTargetName( %i ) );

string TSShapeConstructor::getTrigger | ( | string | name,
 |  | int | index
 | ) |  |

Get information about the indexed trigger.

Parameters:
name | name of the sequence to query
index | index of the trigger (valid range is 0 - getTriggerCount()-1)
Returns:
string of the form "frame state"
Example:
// print all triggers in the sequence
%count = %this.getTriggerCount( "back" );
for ( %i = 0; %i < %count; %i++ )
   echo( %i SPC %this.getTrigger( "back", %i ) );
int TSShapeConstructor::getTriggerCount ( string name )

Get the number of triggers in the specified sequence.

Parameters:
name name of the sequence to query
Returns:
number of triggers in the sequence
void TSShapeConstructor::notifyShapeChanged ( )

Notify game objects that this shape file has changed, allowing them to update internal data if needed.

void TSShapeConstructor::onLoad ( )

Called immediately after the DTS or DAE file has been loaded; before the shape data is available to any other object (StaticShape, Player etc). This is where you should put any post-load commands to modify the shape in-memory such as addNode, renameSequence etc.

void TSShapeConstructor::onUnload ( )

Called when the DTS or DAE resource is flushed from memory. Not normally required, but may be useful to perform cleanup.

bool TSShapeConstructor::removeDetailLevel ( int index )

Remove the detail level (including all meshes in the detail level).

Parameters:
size size of the detail level to remove
Returns:
true if successful, false otherwise
Example:
%this.removeDetailLevel( 2 );
bool TSShapeConstructor::removeImposter ( )

Remove the imposter detail level (if any) from the shape.

Returns:
true if successful, false otherwise
bool TSShapeConstructor::removeMesh ( string name )

Remove a mesh from the shape.

If all geometry is removed from an object, the object is also removed.

Parameters:
name full name (object name + detail size) of the mesh to remove
Returns:
true if successful, false otherwise
Example:
%this.removeMesh( "SimpleShape128" );
bool TSShapeConstructor::removeNode ( string name )

Remove a node from the shape.

The named node is removed from the shape, including from any sequences that use the node. Child nodes and objects attached to the node are re-assigned to the node's parent.

Parameters:
name name of the node to remove.
Returns:
true if successful, false otherwise.
Example:
%this.removeNode( "Nose" );
bool TSShapeConstructor::removeObject ( string name )

Remove an object (including all meshes for that object) from the shape.

Parameters:
name name of the object to remove.
Returns:
true if successful, false otherwise.
Example:
// clear all objects in the shape
%count = %this.getObjectCount();
for ( %i = %count-1; %i >= 0; %i-- )
   %this.removeObject( %this.getObjectName(%i) );
bool TSShapeConstructor::removeSequence ( string name )

Remove the sequence from the shape.

Parameters:
name name of the sequence to remove
Returns:
true if successful, false otherwise
bool TSShapeConstructor::removeTrigger | ( | string | name,
 |  | int | keyframe,
 |  | int | state
 | ) |  |

Remove a trigger from the sequence.

Parameters:
name | name of the sequence to modify
keyframe | keyframe of the trigger to remove
state | of the trigger to remove
Returns:
true if successful, false otherwise
Example:
%this.removeTrigger( "walk", 3, 1 );

bool TSShapeConstructor::renameDetailLevel | ( | string | oldName,
 |  | string | newName
 | ) |  |

Rename a detail level.

Note:
Note that detail level names must be unique, so this command will fail if there is already a detail level with the desired name
Parameters:
oldName | current name of the detail level
newName | new name of the detail level
Returns:
true if successful, false otherwise
Example:
%this.renameDetailLevel( "detail-1", "collision-1" );

bool TSShapeConstructor::renameNode | ( | string | oldName,
 |  | string | newName
 | ) |  |

Rename a node.

Note:
Note that node names must be unique, so this command will fail if there is already a node with the desired name
Parameters:
oldName | current name of the node
newName | new name of the node
Returns:
true if successful, false otherwise
Example:
%this.renameNode( "Bip01 L Hand", "mount5" );

bool TSShapeConstructor::renameObject | ( | string | oldName,
 |  | string | newName
 | ) |  |

Rename an object.

Note:
Note that object names must be unique, so this command will fail if there is already an object with the desired name
Parameters:
oldName | current name of the object
newName | new name of the object
Returns:
true if successful, false otherwise
Example:
%this.renameObject( "MyBox", "Box" );

bool TSShapeConstructor::renameSequence | ( | string | oldName,
 |  | string | newName
 | ) |  |

Rename a sequence.

Note:
Note that sequence names must be unique, so this command will fail if there is already a sequence with the desired name
Parameters:
oldName | current name of the sequence
newName | new name of the sequence
Returns:
true if successful, false otherwise
Example:
%this.renameSequence( "walking", "walk" );
void TSShapeConstructor::saveShape ( string filename )

Save the shape (with all current changes) to a new DTS file.

Parameters:
filename Destination filename.
Example:
%this.saveShape( "./myShape.dts" );
bool TSShapeConstructor::setBounds ( Box3F bbox )

Set the shape bounds to the given bounding box.

Parameters:
Bounding box "minX minY minZ maxX maxY maxZ"
Returns:
true if successful, false otherwise
int TSShapeConstructor::setDetailLevelSize | ( | int | index,
 |  | int | newSize
 | ) |  |

Change the size of a detail level.

Note:
Note that detail levels are always sorted in decreasing size order, so this command may cause detail level indices to change.
Parameters:
index | index of the detail level to modify
newSize | new size for the detail level
Returns:
new index for this detail level
Example:
%this.setDetailLevelSize( 2, 256 );

bool TSShapeConstructor::setMeshMaterial | ( | string | meshName,
 |  | string | matName
 | ) |  |

Set the name of the material attached to the mesh.

Parameters:
meshName | full name (object name + detail size) of the mesh to modify
matName | name of the material to attach. This could be the base name of the diffuse texture (eg. "test_mat" for "test_mat.jpg"), or the name of a Material object already defined in script.
Returns:
true if successful, false otherwise
Example:
// set the mesh material
%this.setMeshMaterial( "SimpleShape128", "test_mat" );

bool TSShapeConstructor::setMeshSize | ( | string | name,
 |  | int | size
 | ) |  |

Change the detail level size of the named mesh.

Parameters:
name | full name (object name + current size ) of the mesh to modify
size | new detail level size
Returns:
true if successful, false otherwise.
Example:
%this.setMeshSize( "SimpleShape128", 64 );

bool TSShapeConstructor::setMeshType | ( | string | name,
 |  | string | type
 | ) |  |

Set the display type for the mesh.

Parameters:
name | full name (object name + detail size) of the mesh to modify
type | the new type for the mesh: "normal", "billboard" or "billboardzaxis"
Returns:
true if successful, false otherwise
Example:
// set the mesh to be a billboard
%this.setMeshType( "SimpleShape64", "billboard" );

bool TSShapeConstructor::setNodeParent | ( | string | name,
 |  | string | parentName
 | ) |  |

Set the parent of a node.

Parameters:
name | name of the node to modify
parentName | name of the parent node to set (use "" to move the node to the root level)
Returns:
true if successful, false if failed
Example:
%this.setNodeParent( "Bip01 Pelvis", "start01" );

bool TSShapeConstructor::setNodeTransform | ( | string | name,
 |  | TransformF | txfm,
 |  | bool | isWorld = false
 | ) |  |

Set the base transform of a node. That is, the transform of the node when in the root (not-animated) pose.

Parameters:
name | name of the node to modify
txfm | transform string of the form: "pos.x pos.y pos.z rot.x rot.y rot.z rot.angle"
isworld | (optional) flag to set the local-to-parent or the global transform. If false, or not specified, the position and orientation are treated as relative to the node's parent.
Returns:
true if successful, false otherwise
Example:
%this.setNodeTransform( "mount0", "0 0 1 0 0 1 0" );
%this.setNodeTransform( "mount0", "0 0 0 0 0 1 1.57" );
%this.setNodeTransform( "mount0", "1 0 0 0 0 1 0", true );

bool TSShapeConstructor::setObjectNode | ( | string | objName,
 |  | string | nodeName
 | ) |  |

Set the node an object is attached to.

When the shape is rendered, the object geometry is rendered at the node's current transform.

Parameters:
objName | name of the object to modify
nodeName | name of the node to attach the object to
Returns:
true if successful, false otherwise
Example:
%this.setObjectNode( "Hand", "Bip01 LeftHand" );

bool TSShapeConstructor::setSequenceBlend | ( | string | name,
 |  | bool | blend,
 |  | string | blendSeq,
 |  | int | blendFrame
 | ) |  |

Mark a sequence as a blend or non-blend.

A blend sequence is one that will be added on top of any other playing sequences. This is done by storing the animated node transforms relative to a reference frame, rather than as absolute transforms.

Parameters:
name | name of the sequence to modify
blend | true to make the sequence a blend, false for a non-blend
blendSeq | the name of the sequence that contains the blend reference frame
blendFrame | the reference frame in the blendSeq sequence
Returns:
true if successful, false otherwise
Example:
%this.setSequenceBlend( "look", true, "root", 0 );

bool TSShapeConstructor::setSequenceCyclic | ( | string | name,
 |  | bool | cyclic
 | ) |  |

Mark a sequence as cyclic or non-cyclic.

Parameters:
name | name of the sequence to modify
cyclic | true to make the sequence cyclic, false for non-cyclic
Returns:
true if successful, false otherwise
Example:
%this.setSequenceCyclic( "ambient", true );
%this.setSequenceCyclic( "shoot", false );

bool TSShapeConstructor::setSequenceGroundSpeed | ( | string | name,
 |  | Point3F | transSpeed,
 |  | Point3F | rotSpeed = Point3F::Zero
 | ) |  |

Set the translation and rotation ground speed of the sequence.

The ground speed of the sequence is set by generating ground transform keyframes. The ground translational and rotational speed is assumed to be constant for the duration of the sequence. Existing ground frames for the sequence (if any) will be replaced.

Parameters:
name | name of the sequence to modify
transSpeed | translational speed (trans.x trans.y trans.z) in Torque units per frame
rotSpeed | (optional) rotational speed (rot.x rot.y rot.z) in radians per frame. Default is "0 0 0"
Returns:
true if successful, false otherwise
Example:
%this.setSequenceGroundSpeed( "run", "5 0 0" );
%this.setSequenceGroundSpeed( "spin", "0 0 0", "4 0 0" );

bool TSShapeConstructor::setSequencePriority | ( | string | name,
 |  | float | priority
 | ) |  |

Set the sequence priority.

Parameters:
name | name of the sequence to modify
priority | new priority value
Returns:
true if successful, false otherwise
void TSShapeConstructor::writeChangeSet ( )

Write the current change set to a TSShapeConstructor script file. The name of the script file is the same as the model, but with .cs extension. eg. myShape.cs for myShape.dts or myShape.dae.

Member Data Documentation

bool TSShapeConstructor::adjustCenter

Translate COLLADA model on import so the origin is at the center. No effect for DTS files.

bool TSShapeConstructor::adjustFloor

Translate COLLADA model on import so origin is at the (Z axis) bottom of the model. No effect for DTS files.

This can be used along with adjustCenter to have the origin at the center of the bottom of the model.

See also:
adjustCenter
string TSShapeConstructor::alwaysImport

TAB separated patterns of nodes to import even if in neverImport list. No effect for DTS files.

Torque allows unwanted nodes in COLLADA (.dae) files to to be ignored during import. This field contains a TAB separated list of patterns to match node names. Any node that matches one of the patterns in the list will always be imported, even if it also matches the neverImport list

See also:
neverImport
Example:
singleton TSShapeConstructor(MyShapeDae)
{
   baseShape = "./myShape.dae";
   alwaysImport = "mount*" TAB "eye";
   neverImport = "*-PIVOT";
}
string TSShapeConstructor::alwaysImportMesh

TAB separated patterns of meshes to import even if in neverImportMesh list. No effect for DTS files.

Torque allows unwanted meshes in COLLADA (.dae) files to to be ignored during import. This field contains a TAB separated list of patterns to match mesh names. Any mesh that matches one of the patterns in the list will always be imported, even if it also matches the neverImportMesh list

See also:
neverImportMesh
Example:
singleton TSShapeConstructor(MyShapeDae)
{
   baseShape = "./myShape.dae";
   alwaysImportMesh = "body*" TAB "armor" TAB "bounds";
   neverImportMesh = "*-dummy";
}
filename TSShapeConstructor::baseShape

Specifies the path to the DTS or DAE file to be operated on by this object.

Since the TSShapeConstructor script must be in the same folder as the DTS or DAE file, it is recommended to use a relative path so that the shape and script files can be copied to another location without having to modify the path.

bool TSShapeConstructor::forceUpdateMaterials

Forces update of the materials.cs file in the same folder as the COLLADA (.dae) file, even if Materials already exist. No effect for DTS files.

Normally only Materials that are not already defined are written to materials.cs.

bool TSShapeConstructor::ignoreNodeScale

Ignore <scale> elements inside COLLADA <node>s. No effect for DTS files.

This field is a workaround for certain exporters that generate bad node scaling, and is not usually required.

TSShapeConstructorLodType TSShapeConstructor::lodType

Control how the COLLADA (.dae) importer interprets LOD in the model. No effect for DTS files.

Set to one of the following values:

DetectDTS
The default value. Instructs the importer to search for a 'baseXXX->startXXX' node hierarchy at the root level. If found, the importer acts as if ''TrailingNumber'' was set. Otherwise, all geometry is imported at a single detail size.
SingleSize
All geometry is imported at a fixed detail size. Numbers at the end of geometry node's are ignored.
TrailingNumber
Numbers at the end of geometry node's name are interpreted as the detail size (similar to DTS exporting). Geometry instances with the same base name but different trailing number are grouped into the same object.
DEFAULT
The default value. Use the value in the .dae file (defaults to Z_AXIS if the <up_axis> element is not present).
string TSShapeConstructor::matNamePrefix

Prefix to apply to all material map names in the COLLADA (.dae) file. No effect for DTS files.

This field is useful to avoid material name clashes for exporters that generate generic material names like "texture0" or "material1".

string TSShapeConstructor::neverImport

TAB separated patterns of nodes to ignore on loading. No effect for DTS files.

Torque allows unwanted nodes in COLLADA (.dae) files to to be ignored during import. This field contains a TAB separated list of patterns to match node names. Any node that matches one of the patterns in the list will not be imported (unless it matches the alwaysImport list.

See also:
alwaysImport
string TSShapeConstructor::neverImportMesh

TAB separated patterns of meshes to ignore on loading. No effect for DTS files.

Torque allows unwanted meshes in COLLADA (.dae) files to to be ignored during import. This field contains a TAB separated list of patterns to match mesh names. Any mesh that matches one of the patterns in the list will not be imported (unless it matches the alwaysImportMesh list.

See also:
alwaysImportMesh
filename TSShapeConstructor::sequence

Legacy method of adding sequences to a DTS or DAE shape after loading.

Example:
singleton TSShapeConstructor(MyShapeDae)
{
   baseShape = "./myShape.dae";
   sequence = "../anims/root.dae root";
   sequence = "../anims/walk.dae walk";
   sequence = "../anims/jump.dsq jump";
}
int TSShapeConstructor::singleDetailSize

Sets the detail size when lodType is set to SingleSize. No effect otherwise, and no effect for DTS files.

See also:
lodType
float TSShapeConstructor::unit

Override the <unit> element in the COLLADA (.dae) file. No effect for DTS files.

COLLADA (.dae) files usually contain a <unit> element that indicates the 'real world' units that the model is described in. It means you can work in sensible and meaningful units in your modeling app.
For example, if you were modeling a small object like a cup, it might make sense to work in inches (1 MAX unit = 1 inch), but if you were modeling a building, it might make more sense to work in feet (1 MAX unit = 1 foot). If you export both models to COLLADA, T3D will automatically scale them appropriately. 1 T3D unit = 1 meter, so the cup would be scaled down by 0.0254, and the building scaled down by 0.3048, given them both the correct scale relative to each other.
Omit the field or set to -1 to use the value in the .dae file (1.0 if the <unit> element is not present)

TSShapeConstructorUpAxis TSShapeConstructor::upAxis

Override the <up_axis> element in the COLLADA (.dae) file. No effect for DTS files.

Set to one of the following values:

X_AXIS
Positive X points up. Model will be rotated into Torque's coordinate system (Z up).
Y_AXIS
Positive Y points up. Model will be rotated into Torque's coordinate system (Z up).
Z_AXIS
Positive Z points up. No rotation will be applied to the model.
DEFAULT
The default value. Use the value in the .dae file (defaults to Z_AXIS if the <up_axis> element is not present).


Torque 3D - Script Manual: TSStatic Class Reference

TSStatic Class Reference
[Game Objects]

A static object derived from a 3D model file and placed within the game world. More...

Inheritance diagram for TSStatic:
[legend]

List of all members.

Public Member Functions

void | changeMaterial (string mapTo="", Material oldMat=NULL, Material newMat=NULL)
Change one of the materials on the shape.
string | getModelFile ()
Get the model filename used by this shape.
int | getTargetCount ()
Get the number of materials in the shape.
string | getTargetName (int index=0)
Get the name of the indexed shape material.

Public Attributes

Collision

bool | allowPlayerStep
Allow a Player to walk up sloping polygons in the TSStatic (based on the collisionType).
TSMeshType collisionType
The type of mesh data to use for collision queries.
TSMeshType decalType
The type of mesh data used to clip decal polygons against.
Debug

int | forceDetail
Forces rendering to a particular detail level.
float | renderNormals
Debug rendering mode shows the normals for each point in the TSStatic's mesh.
Rendering

bool | meshCulling
Enables detailed culling of meshes within the TSStatic. Should only be used with large complex shapes like buildings which contain many submeshes.
bool | originSort
Enables translucent sorting of the TSStatic by its origin instead of the bounds.
bool | playAmbient
Enables automatic playing of the animation sequence named "ambient" (if it exists) when the TSStatic is loaded.
Media

filename | shapeName
Path and filename of the model file (.DTS, .DAE) to use for this TSStatic.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A static object derived from a 3D model file and placed within the game world.

TSStatic is the most basic 3D shape in Torque. Unlike StaticShape it doesn't make use of a datablock. It derrives directly from SceneObject. This makes TSStatic extremely light weight, which is why the Tools use this class when you want to drop in a DTS or DAE object.

While a TSStatic doesn't provide any motion -- it stays were you initally put it -- it does allow for a single ambient animation sequence to play when the object is first added to the scene.

Example:
new TSStatic(Team1Base) {
   shapeName = "art/shapes/desertStructures/station01.dts";
   playAmbient = "1";
   receiveSunLight = "1";
   receiveLMLighting = "1";
   useCustomAmbientLighting = "0";
   customAmbientLighting = "0 0 0 1";
   collisionType = "Visible Mesh";
   decalType = "Collision Mesh";
   allowPlayerStep = "1";
   renderNormals = "0";
   forceDetail = "-1";
   position = "315.18 -180.418 244.313";
   rotation = "0 0 1 195.952";
   scale = "1 1 1";
   isRenderEnabled = "true";
   canSaveDynamicFields = "1";
};

Member Function Documentation

void TSStatic::changeMaterial | ( | string | mapTo = "",
 |  | Material | oldMat = NULL,
 |  | Material | newMat = NULL
 | ) |  |

Change one of the materials on the shape.

This method changes materials per mapTo with others. The material that is being replaced is mapped to unmapped_mat as a part of this transition.

Note:
Warning, right now this only sort of works. It doesn't do a live update like it should.
Parameters:
mapTo | the name of the material target to remap (from getTargetName)
oldMat | the old Material that was mapped
newMat | the new Material to map
Example:
// remap the first material in the shape
%mapTo = %obj.getTargetName( 0 );
%obj.changeMaterial( %mapTo, 0, MyMaterial );
string TSStatic::getModelFile ( )

Get the model filename used by this shape.

Returns:
the shape filename
Example:
// Acquire the model filename used on this shape.
%modelFilename = %obj.getModelFile();
int TSStatic::getTargetCount ( )

Get the number of materials in the shape.

Returns:
the number of materials in the shape.
See also:
getTargetName()
string TSStatic::getTargetName ( int index = 0 )

Get the name of the indexed shape material.

Parameters:
index index of the material to get (valid range is 0 - getTargetCount()-1).
Returns:
the name of the indexed material.
See also:
getTargetCount()

Member Data Documentation

bool TSStatic::allowPlayerStep

Allow a Player to walk up sloping polygons in the TSStatic (based on the collisionType).

When set to false, the slightest bump will stop the player from walking on top of the object.

TSMeshType TSStatic::collisionType

The type of mesh data to use for collision queries.

TSMeshType TSStatic::decalType

The type of mesh data used to clip decal polygons against.

int TSStatic::forceDetail

Forces rendering to a particular detail level.

bool TSStatic::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

bool TSStatic::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

bool TSStatic::meshCulling

Enables detailed culling of meshes within the TSStatic. Should only be used with large complex shapes like buildings which contain many submeshes.

bool TSStatic::originSort

Enables translucent sorting of the TSStatic by its origin instead of the bounds.

bool TSStatic::playAmbient

Enables automatic playing of the animation sequence named "ambient" (if it exists) when the TSStatic is loaded.

float TSStatic::renderNormals

Debug rendering mode shows the normals for each point in the TSStatic's mesh.

filename TSStatic::shapeName

Path and filename of the model file (.DTS, .DAE) to use for this TSStatic.


Torque 3D - Script Manual: Vehicle Class Reference

Vehicle Class Reference
[Vehicles]

Base functionality shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle. More...

Inheritance diagram for Vehicle:
[legend]

List of all members.

Public Attributes

bool | disableMove
When this flag is set, the vehicle will ignore throttle changes.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static float | workingQueryBoxSizeMultiplier
How much larger should the mWorkingQueryBox be made when updating the working collision list.
static int | workingQueryBoxStaleThreshold
The maximum number of ticks that go by before the mWorkingQueryBox is considered stale and needs updating.

Detailed Description

Base functionality shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle.

This object implements functionality shared by all Vehicle types, but should not be instantiated directly. Create a FlyingVehicle, HoverVehicle, or WheeledVehicle instead.

Note:
The model used for any Vehicle must include a collision mesh at detail size -1.

Member Data Documentation

bool Vehicle::disableMove

When this flag is set, the vehicle will ignore throttle changes.

bool Vehicle::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from ShapeBase.

Reimplemented in HoverVehicle, FlyingVehicle, and WheeledVehicle.

bool Vehicle::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from ShapeBase.

Reimplemented in HoverVehicle, FlyingVehicle, and WheeledVehicle.

float Vehicle::workingQueryBoxSizeMultiplier [static]

How much larger should the mWorkingQueryBox be made when updating the working collision list.

The larger this number the less often the working list will be updated due to motion, but any non-static shape that moves into the query box will not be noticed.

int Vehicle::workingQueryBoxStaleThreshold [static]

The maximum number of ticks that go by before the mWorkingQueryBox is considered stale and needs updating.

Other factors can cause the collision working query box to become invalidated, such as the vehicle moving far enough outside of this cached box. The smaller this number, the more times the working list of triangles that are considered for collision is refreshed. This has the greatest impact with colliding with high triangle count meshes.

Note:
Set to -1 to disable any time-based forced check.


Torque 3D - Script Manual: VehicleData Class Reference

VehicleData Class Reference
[Vehicles]

Base properties shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle. More...

Inheritance diagram for VehicleData:
[legend]

List of all members.

Public Member Functions

Callbacks

void | onEnterLiquid (Vehicle obj, float coverage, string type)
Called when the vehicle enters liquid.
void | onLeaveLiquid (Vehicle obj, string type)
Called when the vehicle leaves liquid.

Public Attributes

float | bodyFriction
Collision friction coefficient.
float | bodyRestitution
Collision 'bounciness'.
float | cameraDecay
How quickly the camera moves back towards the vehicle when stopped.
float | cameraLag
How much the camera lags behind the vehicle depending on vehicle speed.
float | cameraOffset
Vertical (Z axis) height of the camera above the vehicle.
bool | cameraRoll
If true, the camera will roll with the vehicle. If false, the camera will always have the positive Z axis as up.
float | collDamageMultiplier
Damage to this vehicle after a collision (multiplied by collision velocity).
float | collDamageThresholdVel
Minimum collision velocity to cause damage to this vehicle.
float | collisionTol
Minimum distance between objects for them to be considered as colliding.
float | contactTol
Maximum relative velocity between objects for collisions to be resolved as contacts.
ParticleEmitterData | damageEmitter [3]
Array of particle emitters used to generate damage (dust, smoke etc) effects.
Point3F | damageEmitterOffset [2]
"x y z" offsets used to emit particles for each of the active damageEmitters.
float | damageLevelTolerance [2]
Damage level (as a percentage of maxDamage) above which to begin emitting particles from the associated damageEmitter.
ParticleEmitterData dustEmitter
Dust particle emitter.
float | dustHeight
Height above ground at which to emit particles from the dustEmitter.
SFXProfile exitingWater
Sound to play when exiting the water.
float | exitSplashSoundVelocity
Minimum velocity when leaving the water for the exitingWater sound to play.
SFXProfile hardImpactSound
Sound to play on a 'hard' impact.
float | hardImpactSpeed
Minimum collision speed for the hardImpactSound to be played.
float | hardSplashSoundVelocity
Minimum velocity when entering the water for the imapactWaterHard sound to play.
SFXProfile impactWaterEasy
Sound to play when entering the water with speed >= softSplashSoundVelocity and < mediumSplashSoundVelocity.
SFXProfile impactWaterHard
Sound to play when entering the water with speed >= hardSplashSoundVelocity.
SFXProfile impactWaterMedium
Sound to play when entering the water with speed >= mediumSplashSoundVelocity and < hardSplashSoundVelocity.
int | integration
Number of integration steps per tick.
float | jetEnergyDrain
Energy amount to drain for each tick the vehicle is jetting.
float | jetForce
Additional force applied to the vehicle when it is jetting.
Point3F | massBox
Define the box used to estimate the vehicle's moment of inertia.
Point3F | massCenter
Defines the vehicle's center of mass (offset from the origin of the model).
float | maxDrag
Maximum drag coefficient.
float | maxSteeringAngle
Maximum yaw (horizontal) and pitch (vertical) steering angle in radians.
float | mediumSplashSoundVelocity
Minimum velocity when entering the water for the imapactWaterMedium sound to play.
float | minDrag
Minimum drag coefficient.
float | minImpactSpeed
Minimum collision speed for the onImpact callback to be invoked.
float | minJetEnergy
Minimum vehicle energy level to begin jetting.
float | minRollSpeed
Unused.
float | numDmgEmitterAreas
Number of damageEmitterOffset values to use for each damageEmitter.
SFXProfile softImpactSound
Sound to play on a 'soft' impact.
float | softImpactSpeed
Minimum collision speed for the softImpactSound to be played.
float | softSplashSoundVelocity
Minimum velocity when entering the water for the imapactWaterEasy sound to play.
ParticleEmitterData | splashEmitter [2]
Array of particle emitters used to generate splash effects.
float | splashFreqMod
Number of splash particles to generate based on vehicle speed.
float | splashVelEpsilon
Minimum speed when moving through water to generate splash particles.
float | triggerDustHeight
Maximum height above surface to emit dust particles.
SFXProfile waterWakeSound
Looping sound to play while moving through the water.

Detailed Description

Base properties shared by all Vehicles (FlyingVehicle, HoverVehicle, WheeledVehicle.

This datablock defines properties shared by all Vehicle types, but should not be instantiated directly. Instead, set the desired properties in the FlyingVehicleData, HoverVehicleData or WheeledVehicleData datablock.

Member Function Documentation

void VehicleData::onEnterLiquid | ( | Vehicle | obj,
 |  | float | coverage,
 |  | string | type
 | ) |  |

Called when the vehicle enters liquid.

Parameters:
obj | the Vehicle object
coverage | percentage of the vehicle's bounding box covered by the liquid
type | type of liquid the vehicle has entered
void VehicleData::onLeaveLiquid | ( | Vehicle | obj,
 |  | string | type
 | ) |  |

Called when the vehicle leaves liquid.

Parameters:
obj | the Vehicle object
type | type of liquid the vehicle has left

Member Data Documentation

float VehicleData::bodyFriction

Collision friction coefficient.

How well this object will slide against objects it collides with.

float VehicleData::bodyRestitution

Collision 'bounciness'.

Normally in the range 0 (not bouncy at all) to 1 (100% bounciness).

float VehicleData::cameraDecay

How quickly the camera moves back towards the vehicle when stopped.

See also:
cameraLag.
float VehicleData::cameraLag

How much the camera lags behind the vehicle depending on vehicle speed.

Increasing this value will make the camera fall further behind the vehicle as it accelerates away.

See also:
cameraDecay.
float VehicleData::cameraOffset

Vertical (Z axis) height of the camera above the vehicle.

bool VehicleData::cameraRoll

If true, the camera will roll with the vehicle. If false, the camera will always have the positive Z axis as up.

float VehicleData::collDamageMultiplier

Damage to this vehicle after a collision (multiplied by collision velocity).

Currently unused.

float VehicleData::collDamageThresholdVel

Minimum collision velocity to cause damage to this vehicle.

Currently unused.

float VehicleData::collisionTol

Minimum distance between objects for them to be considered as colliding.

float VehicleData::contactTol

Maximum relative velocity between objects for collisions to be resolved as contacts.

Velocities greater than this are handled as collisions.

ParticleEmitterData VehicleData::damageEmitter[3]

Array of particle emitters used to generate damage (dust, smoke etc) effects.

See also:
damageEmitterOffset
Point3F VehicleData::damageEmitterOffset[2]

"x y z" offsets used to emit particles for each of the active damageEmitters.

Example:
// damage levels
damageLevelTolerance[0] = 0.5;
damageEmitter[0] = SmokeEmitter;
// emit offsets (used for all active damage level emitters
damageEmitterOffset[0] = "0.5 3 1";
damageEmitterOffset[1] = "-0.5 3 1";
numDmgEmitterAreas = 2;
float VehicleData::damageLevelTolerance[2]

Damage level (as a percentage of maxDamage) above which to begin emitting particles from the associated damageEmitter.

See also:
damageEmitterOffset
ParticleEmitterData VehicleData::dustEmitter

Dust particle emitter.

See also:
triggerDustHeight
dustHeight
float VehicleData::dustHeight

Height above ground at which to emit particles from the dustEmitter.

SFXProfile VehicleData::exitingWater

Sound to play when exiting the water.

float VehicleData::exitSplashSoundVelocity

Minimum velocity when leaving the water for the exitingWater sound to play.

SFXProfile VehicleData::hardImpactSound

Sound to play on a 'hard' impact.

This sound is played if the impact speed >= hardImpactSpeed.

See also:
hardImpactSpeed
float VehicleData::hardImpactSpeed

Minimum collision speed for the hardImpactSound to be played.

float VehicleData::hardSplashSoundVelocity

Minimum velocity when entering the water for the imapactWaterHard sound to play.

See also:
impactWaterHard
SFXProfile VehicleData::impactWaterEasy

Sound to play when entering the water with speed >= softSplashSoundVelocity and < mediumSplashSoundVelocity.

SFXProfile VehicleData::impactWaterHard

Sound to play when entering the water with speed >= hardSplashSoundVelocity.

SFXProfile VehicleData::impactWaterMedium

Sound to play when entering the water with speed >= mediumSplashSoundVelocity and < hardSplashSoundVelocity.

int VehicleData::integration

Number of integration steps per tick.

Increase this to improve simulation stability (also increases simulation processing time).

float VehicleData::jetEnergyDrain

Energy amount to drain for each tick the vehicle is jetting.

Once the vehicle's energy level reaches 0, it will no longer be able to jet.

float VehicleData::jetForce

Additional force applied to the vehicle when it is jetting.

For WheeledVehicles, the force is applied in the forward direction. For FlyingVehicles, the force is applied in the thrust direction.

Point3F VehicleData::massBox

Define the box used to estimate the vehicle's moment of inertia.

Currently only used by WheeledVehicle, other vehicle types use a unit sphere to compute inertia.

Point3F VehicleData::massCenter

Defines the vehicle's center of mass (offset from the origin of the model).

float VehicleData::maxDrag

Maximum drag coefficient.

Currently unused.

float VehicleData::maxSteeringAngle

Maximum yaw (horizontal) and pitch (vertical) steering angle in radians.

float VehicleData::mediumSplashSoundVelocity

Minimum velocity when entering the water for the imapactWaterMedium sound to play.

See also:
impactWaterMedium
float VehicleData::minDrag

Minimum drag coefficient.

Currently only used by FlyingVehicle.

float VehicleData::minImpactSpeed

Minimum collision speed for the onImpact callback to be invoked.

float VehicleData::minJetEnergy

Minimum vehicle energy level to begin jetting.

float VehicleData::minRollSpeed

Unused.

float VehicleData::numDmgEmitterAreas

Number of damageEmitterOffset values to use for each damageEmitter.

See also:
damageEmitterOffset
SFXProfile VehicleData::softImpactSound

Sound to play on a 'soft' impact.

This sound is played if the impact speed is < hardImpactSpeed and >= softImpactSpeed.

See also:
softImpactSpeed
float VehicleData::softImpactSpeed

Minimum collision speed for the softImpactSound to be played.

float VehicleData::softSplashSoundVelocity

Minimum velocity when entering the water for the imapactWaterEasy sound to play.

See also:
impactWaterEasy
ParticleEmitterData VehicleData::splashEmitter[2]

Array of particle emitters used to generate splash effects.

float VehicleData::splashFreqMod

Number of splash particles to generate based on vehicle speed.

This value is multiplied by the current speed to determine how many particles to generate each frame.

float VehicleData::splashVelEpsilon

Minimum speed when moving through water to generate splash particles.

float VehicleData::triggerDustHeight

Maximum height above surface to emit dust particles.

If the vehicle is less than triggerDustHeight above a static surface with a material that has 'showDust' set to true, the vehicle will emit particles from the dustEmitter.

SFXProfile VehicleData::waterWakeSound

Looping sound to play while moving through the water.


Torque 3D - Script Manual: WaterBlock Class Reference

WaterBlock Class Reference
[Water]

A block shaped water volume defined by a 3D scale and orientation. More...

Inheritance diagram for WaterBlock:
[legend]

List of all members.

Public Attributes

WaterBlock

float | gridElementSize
Spacing between vertices in the WaterBlock mesh.
float | gridSize
Duplicate of gridElementSize for backwards compatility.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A block shaped water volume defined by a 3D scale and orientation.

See also:
WaterObject for inherited functionality.

Member Data Documentation

float WaterBlock::gridElementSize

Spacing between vertices in the WaterBlock mesh.

float WaterBlock::gridSize

Duplicate of gridElementSize for backwards compatility.

bool WaterBlock::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from WaterObject.

bool WaterBlock::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from WaterObject.


Torque 3D - Script Manual: WaterObject Class Reference

WaterObject Class Reference
[Water]

Abstract base class for representing a body of water. More...

Inheritance diagram for WaterObject:
[legend]

List of all members.

Public Attributes

WaterObject

ColorI | baseColor
Changes color of water fog.
float | density
Affects buoyancy of an object, thus affecting the Z velocity of a player (jumping, falling, etc.
bool | emissive
When true the water colors don't react to changes to environment lighting.
float | foamAmbientLerp
Point2F | foamDir [2]
float | foamMaxDepth
float | foamOpacity [2]
float | foamRippleInfluence
float | foamSpeed [2]
filename | foamTex
Diffuse texture for foam in shallow water (advanced lighting only).
Point2F | foamTexScale [2]
applied to the surface.
float | fresnelBias
Extent of fresnel affecting reflection fogging.
float | fresnelPower
Measures intensity of affect on reflection based on fogging.
string | liquidType
Liquid type of WaterBlock, such as water, ocean, lava Currently only Water is defined and used.
float | overallFoamOpacity
float | overallRippleMagnitude
Master variable affecting entire surface.
float | overallWaveMagnitude
Master variable affecting entire body of water's undulation.
Point2F | rippleDir [3]
Modifies the direction of ripples on the surface.
float | rippleMagnitude [3]
Intensifies the vertext modification of the surface.
float | rippleSpeed [3]
Modifies speed of surface ripples.
filename | rippleTex
Normal map used to simulate small surface ripples.
Point2F | rippleTexScale [3]
Intensifies the affect of the normal map applied to the surface.
ColorF | specularColor
Color used for specularity on the water surface ( sun only ).
float | specularPower
Power used for specularity on the water surface ( sun only ).
float | viscosity
Affects drag force applied to an object submerged in this container.
Point2F | waveDir [3]
Direction waves flow toward shores.
float | waveMagnitude [3]
Height of water undulation.
float | waveSpeed [3]
Speed of water undulation.
Basic Lighting

float | clarity
Relative opacity or transparency of the water surface.
ColorI | underwaterColor
Changes the color shading of objects beneath the water surface.
Reflect

string | cubemap
Cubemap used instead of reflection texture if fullReflect is off.
bool | fullReflect
Enables dynamic reflection rendering.
float | reflectDetailAdjust
scale up or down the detail level for objects rendered in a reflection
float | reflectivity
Overall scalar to the reflectivity of the water surface.
int | reflectMaxRateMs
Affects the sort time of reflected objects.
bool | reflectNormalUp
always use z up as the reflection normal
float | reflectPriority
Affects the sort order of reflected objects.
int | reflectTexSize
The texture size used for reflections (square).
bool | useOcclusionQuery
turn off reflection rendering when occluded (delayed).
Misc

float | depthGradientMax
Depth in world units, the max range of the color gradient texture.
filename | depthGradientTex
1D texture defining the base water color by depth
Distortion

float | distortEndDist
Max distance that distortion algorithm is performed. The lower, the more distorted the effect.
float | distortFullDepth
Determines the scaling down of distortion in shallow water.
float | distortStartDist
Determines start of distortion effect where water surface intersects the camera near plane.
Sound

SFXAmbience soundAmbience
Ambient sound environment when listener is submerged.
Underwater Fogging

float | waterFogDensity
Intensity of underwater fogging.
float | waterFogDensityOffset
Delta, or limit, applied to waterFogDensity.
float | wetDarkening
The refract color intensity scaled at wetDepth.
float | wetDepth
The depth in world units at which full darkening will be received, giving a wet look to objects underwater.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.
static bool | wireframe
If true, will render the wireframe of the WaterObject.

Detailed Description

Abstract base class for representing a body of water.

WaterObject is abstract and may not be created. It defines functionality shared by its derived classes.

WaterObject exposes many fields for controlling it visual quality.

WaterObject surface rendering has the following general features:

  • Waves represented by vertex undulation and user paramaters.
  • Ripples represented by a normal map and user parameters.
  • Refraction of underwater objects.
  • Dynamic planar reflection or static cubemap reflection.
  • Paramable water fog and color shift.

It will, however, look significantly different depending on the LightingManager that is active. With Basic Lighting, we do not have a prepass texture to lookup per-pixel depth and therefore cannot use our rendering techniques that depend on it.

In particular, the following field groups are not used under Basic Lighting:

  • Underwater Fogging
  • Misc
  • Distortion
  • And foam related fields under the WaterObject group.

WaterObject also defines several fields for gameplay use and objects that support buoyancy.

Member Data Documentation

ColorI WaterObject::baseColor

Changes color of water fog.

float WaterObject::clarity

Relative opacity or transparency of the water surface.

string WaterObject::cubemap

Cubemap used instead of reflection texture if fullReflect is off.

float WaterObject::density

Affects buoyancy of an object, thus affecting the Z velocity of a player (jumping, falling, etc.

float WaterObject::depthGradientMax

Depth in world units, the max range of the color gradient texture.

filename WaterObject::depthGradientTex

1D texture defining the base water color by depth

float WaterObject::distortEndDist

Max distance that distortion algorithm is performed. The lower, the more distorted the effect.

float WaterObject::distortFullDepth

Determines the scaling down of distortion in shallow water.

float WaterObject::distortStartDist

Determines start of distortion effect where water surface intersects the camera near plane.

bool WaterObject::emissive

When true the water colors don't react to changes to environment lighting.

float WaterObject::foamAmbientLerp
Point2F WaterObject::foamDir[2]
float WaterObject::foamMaxDepth
float WaterObject::foamOpacity[2]
float WaterObject::foamRippleInfluence
float WaterObject::foamSpeed[2]
filename WaterObject::foamTex

Diffuse texture for foam in shallow water (advanced lighting only).

Point2F WaterObject::foamTexScale[2]

applied to the surface.

float WaterObject::fresnelBias

Extent of fresnel affecting reflection fogging.

float WaterObject::fresnelPower

Measures intensity of affect on reflection based on fogging.

bool WaterObject::fullReflect

Enables dynamic reflection rendering.

bool WaterObject::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in WaterBlock, WaterPlane, and River.

bool WaterObject::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in WaterBlock, WaterPlane, and River.

string WaterObject::liquidType

Liquid type of WaterBlock, such as water, ocean, lava Currently only Water is defined and used.

float WaterObject::overallFoamOpacity
float WaterObject::overallRippleMagnitude

Master variable affecting entire surface.

float WaterObject::overallWaveMagnitude

Master variable affecting entire body of water's undulation.

float WaterObject::reflectDetailAdjust

scale up or down the detail level for objects rendered in a reflection

float WaterObject::reflectivity

Overall scalar to the reflectivity of the water surface.

int WaterObject::reflectMaxRateMs

Affects the sort time of reflected objects.

bool WaterObject::reflectNormalUp

always use z up as the reflection normal

float WaterObject::reflectPriority

Affects the sort order of reflected objects.

int WaterObject::reflectTexSize

The texture size used for reflections (square).

Point2F WaterObject::rippleDir[3]

Modifies the direction of ripples on the surface.

float WaterObject::rippleMagnitude[3]

Intensifies the vertext modification of the surface.

float WaterObject::rippleSpeed[3]

Modifies speed of surface ripples.

filename WaterObject::rippleTex

Normal map used to simulate small surface ripples.

Point2F WaterObject::rippleTexScale[3]

Intensifies the affect of the normal map applied to the surface.

SFXAmbience WaterObject::soundAmbience

Ambient sound environment when listener is submerged.

ColorF WaterObject::specularColor

Color used for specularity on the water surface ( sun only ).

float WaterObject::specularPower

Power used for specularity on the water surface ( sun only ).

ColorI WaterObject::underwaterColor

Changes the color shading of objects beneath the water surface.

bool WaterObject::useOcclusionQuery

turn off reflection rendering when occluded (delayed).

float WaterObject::viscosity

Affects drag force applied to an object submerged in this container.

float WaterObject::waterFogDensity

Intensity of underwater fogging.

float WaterObject::waterFogDensityOffset

Delta, or limit, applied to waterFogDensity.

Point2F WaterObject::waveDir[3]

Direction waves flow toward shores.

float WaterObject::waveMagnitude[3]

Height of water undulation.

float WaterObject::waveSpeed[3]

Speed of water undulation.

float WaterObject::wetDarkening

The refract color intensity scaled at wetDepth.

float WaterObject::wetDepth

The depth in world units at which full darkening will be received, giving a wet look to objects underwater.


Torque 3D - Script Manual: WaterPlane Class Reference

WaterPlane Class Reference
[Water]

Represents a large body of water stretching to the horizon in all directions. More...

Inheritance diagram for WaterPlane:
[legend]

List of all members.

Public Attributes

WaterPlane

float | gridElementSize
Duplicate of gridElementSize for backwards compatility.
int | gridSize
Spacing between vertices in the WaterBlock mesh.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Represents a large body of water stretching to the horizon in all directions.

WaterPlane's position is defined only height, the z element of position, it is infinite in xy and depth. WaterPlane is designed to represent the ocean on an island scene and viewed from ground level; other uses may not be appropriate and a WaterBlock may be used.

See also:
WaterObject for inherited functionality.

Limitations:

Because WaterPlane cannot be projected exactly to the far-clip distance, other objects nearing this distance can have noticible artifacts as they clip through first the WaterPlane and then the far plane.

To avoid this large objects should be positioned such that they will not line up with the far-clip from vantage points the player is expected to be. In particular, your TerrainBlock should be completely contained by the far-clip distance.

Viewing WaterPlane from a high altitude with a tight far-clip distance will accentuate this limitation. WaterPlane is primarily designed to be viewed from ground level.

Member Data Documentation

float WaterPlane::gridElementSize

Duplicate of gridElementSize for backwards compatility.

int WaterPlane::gridSize

Spacing between vertices in the WaterBlock mesh.

bool WaterPlane::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from WaterObject.

bool WaterPlane::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from WaterObject.


Torque 3D - Script Manual: WayPoint Class Reference

WayPoint Class Reference
[Miscellaneous]

Special type of marker, distinguished by a name and team ID number. More...

Inheritance diagram for WayPoint:
[legend]

List of all members.

Public Attributes

Misc

caseString | markerName
Unique name representing this waypoint.
WayPointTeam | team
Unique numerical ID assigned to this waypoint, or set of waypoints.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

Special type of marker, distinguished by a name and team ID number.

The original Torque engines were built from a multi-player game called Tribes. The Tribes series featured various team based game modes, such as capture the flag. The WayPoint class survived the conversion from game (Tribes) to game engine (Torque).

Essentially, this is a MissionMarker with the addition of two variables: markerName and team. Whenever a WayPoint is created, it is added to a unique global list called WayPointSet. You can iterate through this set, seeking out specific markers determined by their markerName and team ID. This avoids the overhead of constantly calling commandToClient and commandToServer to determine a WayPoint object's name, unique ID, etc.

Note:
The markerName field was previously called name, but was changed because this conflicted with the SimObject name field. Existing scripts that relied on the WayPoint name field will need to be updated.
Example:
new WayPoint()
{
   team = "1";
   dataBlock = "WayPointMarker";
   position = "-0.0224786 1.53471 2.93219";
   rotation = "1 0 0 0";
   scale = "1 1 1";
   canSave = "1";
   canSaveDynamicFields = "1";
};
See also:
MissionMarker
MissionMarkerData

Member Data Documentation

bool WayPoint::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from MissionMarker.

bool WayPoint::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from MissionMarker.

caseString WayPoint::markerName

Unique name representing this waypoint.

WayPointTeam WayPoint::team

Unique numerical ID assigned to this waypoint, or set of waypoints.


Torque 3D - Script Manual: WheeledVehicle Class Reference

WheeledVehicle Class Reference
[Vehicles]

A wheeled vehicle. More...

Inheritance diagram for WheeledVehicle:
[legend]

List of all members.

Public Member Functions

int | getWheelCount ()
Get the number of wheels on this vehicle.
bool | setWheelPowered (int wheel, bool powered)
Set whether the wheel is powered (has torque applied from the engine).
bool | setWheelSpring (int wheel, WheeledVehicleSpring spring)
Set the WheeledVehicleSpring datablock for this wheel.
bool | setWheelSteering (int wheel, float steering)
Set how much the wheel is affected by steering.
bool | setWheelTire (int wheel, WheeledVehicleTire tire)
Set the WheeledVehicleTire datablock for this wheel.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

A wheeled vehicle.

Member Function Documentation

int WheeledVehicle::getWheelCount ( )

Get the number of wheels on this vehicle.

Returns:
the number of wheels (equal to the number of hub nodes defined in the model)
bool WheeledVehicle::setWheelPowered | ( | int | wheel,
 |  | bool | powered
 | ) |  |

Set whether the wheel is powered (has torque applied from the engine).

A rear wheel drive car for example would set the front wheels to false, and the rear wheels to true.

Parameters:
wheel | index of the wheel to set
powered | flag indicating whether to power the wheel or not
Returns:
true if successful, false if failed
bool WheeledVehicle::setWheelSpring | ( | int | wheel,
 |  | WheeledVehicleSpring | spring
 | ) |  |

Set the WheeledVehicleSpring datablock for this wheel.

Parameters:
wheel | index of the wheel to set
spring | WheeledVehicleSpring datablock
Returns:
true if successful, false if failed
Example:
%obj.setWheelSpring( 0, FrontSpring );

bool WheeledVehicle::setWheelSteering | ( | int | wheel,
 |  | float | steering
 | ) |  |

Set how much the wheel is affected by steering.

The steering factor controls how much the wheel is rotated by the vehicle steering. For example, most cars would have their front wheels set to 1.0, and their rear wheels set to 0 since only the front wheels should turn.

Negative values will turn the wheel in the opposite direction to the steering angle.

Parameters:
wheel | index of the wheel to set
steering | steering factor from -1 (full inverse) to 1 (full)
Returns:
true if successful, false if failed
bool WheeledVehicle::setWheelTire | ( | int | wheel,
 |  | WheeledVehicleTire | tire
 | ) |  |

Set the WheeledVehicleTire datablock for this wheel.

Parameters:
wheel | index of the wheel to set
tire | WheeledVehicleTire datablock
Returns:
true if successful, false if failed
Example:
%obj.setWheelTire( 0, FrontTire );

Member Data Documentation

bool WheeledVehicle::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from Vehicle.

bool WheeledVehicle::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from Vehicle.


Torque 3D - Script Manual: WheeledVehicleData Class Reference

WheeledVehicleData Class Reference
[Vehicles]

Defines the properties of a WheeledVehicle. More...

Inheritance diagram for WheeledVehicleData:
[legend]

List of all members.

Public Attributes

float | brakeTorque
Torque applied when braking.
float | engineBrake
Braking torque applied by the engine when the throttle and brake are both 0.
SFXTrack engineSound
Looping engine sound.
float | engineTorque
Torque available from the engine at 100% throttle.
SFXTrack jetSound
Looping sound played when the vehicle is jetting.
float | maxWheelSpeed
Maximum linear velocity of each wheel.
SFXTrack squealSound
Looping sound played while any of the wheels is slipping.
ParticleEmitterData tireEmitter
ParticleEmitterData datablock used to generate particles from each wheel when the vehicle is moving and the wheel is in contact with the ground.
SFXTrack WheelImpactSound
Sound played when the wheels impact the ground.

Detailed Description

Defines the properties of a WheeledVehicle.

The model used for the WheeledVehicle has a number of requirements:

Collision mesh
A convex collision mesh at detail size -1.
Hub nodes
The model must contain a node for each wheel called hubN, where N is a an integer value starting from 0. For example, a four wheeled vehicle would have nodes: hub0, hub1, hub2, and hub3. The wheel model (specified by WheeledVehicleTire) is positioned at the hub node, and automatically rotated to the right orientation (whether on the left or right side of the vehicle).
Spring animations
To visualise the suspension action, the vehicle model should contain an animation sequence for each wheel that animates the appropriate hub node from t=0 (fully compressed to t=1 (fully extended). The sequences must be called springN, where N matches the wheel hub index.
Steering animation
Optional animation called 'steering' that animates from t=0 (full right) to t=0.5 (center) to 1=1 (full left).
Brakelight animation
Optional animation called 'brakeLight' that animates from t=0 (off) to t=1 (braking).

Member Data Documentation

float WheeledVehicleData::brakeTorque

Torque applied when braking.

This controls how fast the vehicle will stop when the brakes are applied.

float WheeledVehicleData::engineBrake

Braking torque applied by the engine when the throttle and brake are both 0.

This controls how quickly the vehicle will coast to a stop.

SFXTrack WheeledVehicleData::engineSound

Looping engine sound.

The pitch is dynamically adjusted based on the current engine RPM

float WheeledVehicleData::engineTorque

Torque available from the engine at 100% throttle.

This controls vehicle acceleration. ie. how fast it will reach maximum speed.

SFXTrack WheeledVehicleData::jetSound

Looping sound played when the vehicle is jetting.

float WheeledVehicleData::maxWheelSpeed

Maximum linear velocity of each wheel.

This caps the maximum speed of the vehicle.

SFXTrack WheeledVehicleData::squealSound

Looping sound played while any of the wheels is slipping.

The volume is dynamically adjusted based on how much the wheels are slipping.

ParticleEmitterData WheeledVehicleData::tireEmitter

ParticleEmitterData datablock used to generate particles from each wheel when the vehicle is moving and the wheel is in contact with the ground.

SFXTrack WheeledVehicleData::WheelImpactSound

Sound played when the wheels impact the ground.

Currently unused.


Torque 3D - Script Manual: WheeledVehicleSpring Class Reference

WheeledVehicleSpring Class Reference
[Vehicles]

Defines the properties of a WheeledVehicle spring. More...

Inheritance diagram for WheeledVehicleSpring:
[legend]

List of all members.

Public Attributes

float | antiSwayForce
Force applied to equalize extension of the spring on the opposite wheel.
float | damping
Force applied to slow changes to the extension of this spring.
float | force
Maximum spring force (when compressed to minimum length, 0).
float | length
Maximum spring length. ie. how far the wheel can extend from the root hub position.

Detailed Description

Defines the properties of a WheeledVehicle spring.

Member Data Documentation

float WheeledVehicleSpring::antiSwayForce

Force applied to equalize extension of the spring on the opposite wheel.

This force helps to keep the suspension balanced when opposite wheels are at different heights.

float WheeledVehicleSpring::damping

Force applied to slow changes to the extension of this spring.

Increasing this makes the suspension stiffer which can help stabilise bouncy vehicles.

float WheeledVehicleSpring::force

Maximum spring force (when compressed to minimum length, 0).

.Increasing this will make the vehicle suspension ride higher (for a given vehicle mass), and also make the vehicle more bouncy when landing jumps.

float WheeledVehicleSpring::length

Maximum spring length. ie. how far the wheel can extend from the root hub position.


Torque 3D - Script Manual: WheeledVehicleTire Class Reference

WheeledVehicleTire Class Reference
[Vehicles]

Defines the properties of a WheeledVehicle tire. More...

Inheritance diagram for WheeledVehicleTire:
[legend]

List of all members.

Public Attributes

float | kineticFriction
Tire friction when the wheel is slipping (no traction).
float | lateralDamping
Damping force applied against lateral forces generated by the tire.
float | lateralForce
Tire force perpendicular to the direction of movement.
float | lateralRelaxation
Relaxing force applied against lateral forces generated by the tire.
float | longitudinalDamping
Damping force applied against longitudinal forces generated by the tire.
float | longitudinalForce
Tire force in the direction of movement.
float | longitudinalRelaxation
Relaxing force applied against longitudinal forces generated by the tire.
float | mass
The mass of the wheel.
float | radius
The radius of the wheel.
float | restitution
Tire restitution.
filename | shapeFile
The path to the shape to use for the wheel.
float | staticFriction
Tire friction when the wheel is not slipping (has traction).

Detailed Description

Defines the properties of a WheeledVehicle tire.

Tires act as springs and generate lateral and longitudinal forces to move the vehicle. These distortion/spring forces are what convert wheel angular velocity into forces that act on the rigid body.

Member Data Documentation

float WheeledVehicleTire::kineticFriction

Tire friction when the wheel is slipping (no traction).

float WheeledVehicleTire::lateralDamping

Damping force applied against lateral forces generated by the tire.

See also:
lateralForce
float WheeledVehicleTire::lateralForce

Tire force perpendicular to the direction of movement.

Lateral force can in simple terms be considered left/right steering force. WheeledVehicles are acted upon by forces generated by their tires and the lateralForce measures the magnitude of the force exerted on the vehicle when the tires are deformed along the x-axis. With real wheeled vehicles, tires are constantly being deformed and it is the interplay of deformation forces which determines how a vehicle moves. In Torque's simulation of vehicle physics, tire deformation obviously can't be handled with absolute realism, but the interplay of a vehicle's velocity, its engine's torque and braking forces, and its wheels' friction, lateral deformation, lateralDamping, lateralRelaxation, longitudinal deformation, longitudinalDamping, and longitudinalRelaxation forces, along with its wheels' angular velocity are combined to create a robust real-time physical simulation.

For this field, the larger the value supplied for the lateralForce, the larger the effect steering maneuvers can have. In Torque tire forces are applied at a vehicle's wheel hubs.

float WheeledVehicleTire::lateralRelaxation

Relaxing force applied against lateral forces generated by the tire.

The lateralRelaxation force measures how strongly the tire effectively un-deforms.

See also:
lateralForce
float WheeledVehicleTire::longitudinalDamping

Damping force applied against longitudinal forces generated by the tire.

See also:
longitudinalForce
float WheeledVehicleTire::longitudinalForce

Tire force in the direction of movement.

Longitudinal force can in simple terms be considered forward/backward movement force. WheeledVehicles are acted upon by forces generated by their tires and the longitudinalForce measures the magnitude of the force exerted on the vehicle when the tires are deformed along the y-axis.

For this field, the larger the value, the larger the effect acceleration/deceleration inputs have.

See also:
lateralForce
float WheeledVehicleTire::longitudinalRelaxation

Relaxing force applied against longitudinal forces generated by the tire.

The longitudinalRelaxation force measures how strongly the tire effectively un-deforms.

See also:
longitudinalForce
float WheeledVehicleTire::mass

The mass of the wheel.

Currently unused.

float WheeledVehicleTire::radius

The radius of the wheel.

The radius is determined from the bounding box of the shape provided in the shapefile field, and does not need to be specified in script. The tire should be built with its hub axis along the object's Y-axis.

float WheeledVehicleTire::restitution

Tire restitution.

Currently unused.

filename WheeledVehicleTire::shapeFile

The path to the shape to use for the wheel.

float WheeledVehicleTire::staticFriction

Tire friction when the wheel is not slipping (has traction).


Torque 3D - Script Manual: ZipObject Class Reference

ZipObject Class Reference
[File I/O]

Provides access to a zip file. More...

Inheritance diagram for ZipObject:
[legend]

List of all members.

Public Member Functions

bool | addFile (string filename, string pathInZip, bool replace=true)
Add a file to the zip archive.
void | closeArchive ()
Close an already opened zip archive.
void | closeFile (SimObject stream)
Close a previously opened file within the zip archive.
bool | deleteFile (string pathInZip)
Deleted the given file from the zip archive.
bool | extractFile (string pathInZip, string filename)
Extact a file from the zip archive and save it to the requested location.
String | getFileEntry (int index)
Get information on the requested file within the zip archive.
int | getFileEntryCount ()
Get the number of files within the zip archive.
bool | openArchive (string filename, string accessMode="read")
Open a zip archive for manipulation.
SimObject | openFileForRead (string filename)
Open a file within the zip archive for reading.
SimObject | openFileForWrite (string filename)
Open a file within the zip archive for writing to.

Detailed Description

Provides access to a zip file.

A ZipObject add, delete and extract files that are within a zip archive. You may also read and write directly to the files within the archive by obtaining a StreamObject for the file.

Example:
// Open a zip archive, creating it if it doesn't exist
%archive = new ZipObject();
%archive.openArchive("testArchive.zip", Write);

// Add a file to the archive with the given name
%archive.addFile("./water.png", "water.png");

// Close the archive to save the changes
%archive.closeArchive();
Note:
Behind the scenes all of the work is being done with the ZipArchive and StreamObject classes.
See also:
StreamObject when using methods such as openFileForRead() and openFileForWrite()

Member Function Documentation

bool ZipObject::addFile | ( | string | filename,
 |  | string | pathInZip,
 |  | bool | replace = true
 | ) |  |

Add a file to the zip archive.

Parameters:
filename | The path and name of the file to add to the zip archive.
pathInZip | The path and name to be given to the file within the zip archive.
replace | If a file already exists within the zip archive at the same location as this new file, this parameter indicates if it should be replaced. By default, it will be replaced.
Returns:
True if the file was successfully added to the zip archive.
void ZipObject::closeArchive ( )

Close an already opened zip archive.

See also:
openArchive()
void ZipObject::closeFile ( SimObject stream )

Close a previously opened file within the zip archive.

Parameters:
stream The StreamObject of a previously opened file within the zip archive.
See also:
openFileForRead()
openFileForWrite()
bool ZipObject::deleteFile ( string pathInZip )

Deleted the given file from the zip archive.

Parameters:
pathInZip The path and name of the file to be deleted from the zip archive.
Returns:
True of the file was successfully deleted.
Note:
Files that have been deleted from the archive will still show up with a getFileEntryCount() until you close the archive. If you need to have the file count up to date with only valid files within the archive, you could close and then open the archive again.
See also:
getFileEntryCount()
closeArchive()
openArchive()
bool ZipObject::extractFile | ( | string | pathInZip,
 |  | string | filename
 | ) |  |

Extact a file from the zip archive and save it to the requested location.

Parameters:
pathInZip | The path and name of the file to be extracted within the zip archive.
filename | The path and name to give the extracted file.
Returns:
True if the file was successfully extracted.
String ZipObject::getFileEntry ( int index )

Get information on the requested file within the zip archive.

This methods provides five different pieces of information for the requested file:

  • filename - The path and name of the file within the zip archive
  • uncompressed size
  • compressed size
  • compression method
  • CRC32

Use getFileEntryCount() to obtain the total number of files within the archive.

Parameters:
index The index of the file within the zip archive. Use getFileEntryCount() to determine the number of files.
Returns:
A tab delimited list of information on the requested file, or an empty string if the file could not be found.
See also:
getFileEntryCount()
int ZipObject::getFileEntryCount ( )

Get the number of files within the zip archive.

Use getFileEntry() to retrive information on each file within the archive.

Returns:
The number of files within the zip archive.
Note:
The returned count will include any files that have been deleted from the archive using deleteFile(). To clear out all deleted files, you could close and then open the archive again.
See also:
getFileEntry()
closeArchive()
openArchive()
bool ZipObject::openArchive | ( | string | filename,
 |  | string | accessMode = "read"
 | ) |  |

Open a zip archive for manipulation.

Once a zip archive is opened use the various ZipObject methods for working with the files within the archive. Be sure to close the archive when you are done with it.

Parameters:
filename | The path and file name of the zip archive to open.
accessMode | One of read, write or readwrite
Returns:
True is the archive was successfully opened.
Note:
If you wish to make any changes to the archive, be sure to open it with a write or readwrite access mode.
See also:
closeArchive()
SimObject ZipObject::openFileForRead ( string filename )

Open a file within the zip archive for reading.

Be sure to close the file when you are done with it.

Parameters:
filename The path and name of the file to open within the zip archive.
Returns:
A standard StreamObject is returned for working with the file.
Note:
You must first open the zip archive before working with files within it.
See also:
closeFile()
openArchive()
SimObject ZipObject::openFileForWrite ( string filename )

Open a file within the zip archive for writing to.

Be sure to close the file when you are done with it.

Parameters:
filename The path and name of the file to open within the zip archive.
Returns:
A standard StreamObject is returned for working with the file.
Note:
You must first open the zip archive before working with files within it.
See also:
closeFile()
openArchive()


Torque 3D - Script Manual: Zone Class Reference

Zone Class Reference
[Miscellaneous]

An object that culls the rendering of everything contained within it. More...

Inheritance diagram for Zone:
[legend]

List of all members.

Public Member Functions

void | dumpZoneState (bool updateFirst=true)
Dump a list of all objects assigned to the zone to the console as well as a list of all connected zone spaces.
int | getZoneId ()
Get the unique numeric ID of the zone in its scene.

Public Attributes

Lighting

ColorF | ambientLightColor
Color of ambient lighting in this zone.
bool | useAmbientLightColor
Whether to use ambientLightColor for ambient lighting in this zone or the global ambient color.
Internal

string | edge
For internal use only.
string | plane
For internal use only.
string | point
For internal use only.
Sound

SFXAmbience soundAmbience
Ambient sound environment for the space.
Zoning

int | zoneGroup
ID of group the zone is part of.

Static Public Attributes

static bool | isRenderable
Disables rendering of all instances of this type.
static bool | isSelectable
Disables selection of all instances of this type.

Detailed Description

An object that culls the rendering of everything contained within it.

This is one of two objects used by the manual culling system Torque 3D provides, the other being Portal. When a Zone is placed in a level, all rendering within the zone is hidden from view when the camera is outside it. When inside, all rendering outside the zone is hidden. This is an excellent way to optimize large levels and complex geometry.

You can attach a Portal a zone. This allows you to view what is rendered in the Zone (or what is rendered outside if you are in the zone), like a window. The larger the Portal, the more you can see through a zone.

Example:
// Example declaration of a Zone
new Zone(TestZone)
{
   soundAmbience = "AudioAmbienceInside";
   position = "3.61793 -1.01945 14.7442";
   rotation = "1 0 0 0";
   scale = "10 10 10";
   canSave = "1";
   canSaveDynamicFields = "1";
};
See also:
Portal

Member Function Documentation

void Zone::dumpZoneState ( bool updateFirst = true )

Dump a list of all objects assigned to the zone to the console as well as a list of all connected zone spaces.

Parameters:
updateFirst Whether to update the contents of the zone before dumping. Since zoning states of objects are updated on demand, the zone contents can be outdated.
int Zone::getZoneId ( )

Get the unique numeric ID of the zone in its scene.

Returns:
The ID of the zone.

Member Data Documentation

ColorF Zone::ambientLightColor

Color of ambient lighting in this zone.

Only used if useAmbientLightColor is true.

string Zone::edge

For internal use only.

bool Zone::isRenderable [static]

Disables rendering of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in Portal.

bool Zone::isSelectable [static]

Disables selection of all instances of this type.

Reimplemented from SceneObject.

Reimplemented in Portal.

string Zone::plane

For internal use only.

string Zone::point

For internal use only.

SFXAmbience Zone::soundAmbience

Ambient sound environment for the space.

bool Zone::useAmbientLightColor

Whether to use ambientLightColor for ambient lighting in this zone or the global ambient color.

int Zone::zoneGroup

ID of group the zone is part of.


Torque 3D - Script Manual: Hierarchical Index

Class Hierarchy

This inheritance list is sorted roughly, but not completely, alphabetically:
  • BanList
  • EditorIconRegistry
  • GFXCardProfiler
  • GFXCardProfilerAPI
  • GFXInit
  • GuiArrayCtrl
    • GuiConsole
    • GuiTextListCtrl
    • GuiTreeViewCtrl
  • LightningStrikeEvent
  • PfxVis
  • RadialImpulseEvent
  • SimObject
    • ActionMap
    • ArrayObject
    • ConsoleLogger
    • CubemapData
    • DebugDrawer
    • EventManager
    • FileDialog
      • OpenFileDialog
        • OpenFolderDialog
      • SaveFileDialog
    • FileObject
    • ForestBrushElement
    • GFXSamplerStateData
    • GFXStateBlockData
    • GuiControlProfile
      • GuiGameListMenuProfile
        • GuiGameListOptionsProfile
    • GuiCursor
    • LangTable
    • Material
      • CustomMaterial
    • Message
    • MessageVector
    • NetObject
      • LevelInfo
      • MissionArea
      • SceneObject
        • BasicClouds
        • CloudLayer
        • ConvexShape
        • DecalManager
        • DecalRoad
        • Forest
        • ForestWindEmitter
        • fxFoliageReplicator
        • fxShapeReplicatedStatic
        • fxShapeReplicator
        • GameBase
          • Debris
          • Explosion
          • Lightning
          • ParticleEmitter
          • ParticleEmitterNode
          • PhysicsDebris
          • PhysicsShape
          • Precipitation
          • Projectile
          • PxCloth
          • PxMultiActor
          • ShapeBase
            • Camera
            • Item
            • MissionMarker
              • SpawnSphere
              • WayPoint
            • PathCamera
            • Player
              • AIPlayer
            • RigidShape
            • StaticShape
            • Vehicle
              • FlyingVehicle
              • HoverVehicle
              • WheeledVehicle
          • Splash
          • Trigger
        • GroundCover
        • GroundPlane
        • InteriorInstance
        • LightBase
          • PointLight
          • SpotLight
        • Marker
        • MeshRoad
        • OcclusionVolume
        • PhysicalZone
        • PhysicsForce
        • Prefab
        • RenderMeshExample
        • RenderObjectExample
        • RenderShapeExample
        • ScatterSky
        • SFXEmitter
        • SFXSpace
        • SkyBox
        • Sun
        • TerrainBlock
        • TimeOfDay
        • TSStatic
        • WaterObject
          • River
          • WaterBlock
          • WaterPlane
        • Zone
          • Portal
      • SimpleNetObject
    • RenderBinManager
      • RenderImposterMgr
      • RenderMeshMgr
      • RenderObjectMgr
      • RenderOcclusionMgr
      • RenderPassStateBin
      • RenderTerrainMgr
      • RenderTexTargetBinManager
        • AdvancedLightBinManager
        • RenderGlowMgr
        • RenderParticleMgr
        • RenderPrePassMgr
      • RenderTranslucentMgr
    • RenderPassManager
    • RenderPassStateToken
      • RenderFormatToken
    • ScriptMsgListener
      • MessageForwarder
    • ScriptObject
    • SFXParameter
    • ShaderData
    • SimDataBlock
      • DecalData
      • ForestItemData
        • TSForestItemData
      • GameBaseData
        • DebrisData
        • ExplosionData
        • LightningData
        • ParticleEmitterData
        • ParticleEmitterNodeData
        • PhysicsDebrisData
        • PhysicsShapeData
        • PrecipitationData
        • ProjectileData
        • PxMultiActorData
        • ShapeBaseData
          • CameraData
          • ItemData
          • MissionMarkerData
          • PathCameraData
          • PlayerData
          • RigidShapeData
          • StaticShapeData
          • VehicleData
            • FlyingVehicleData
            • HoverVehicleData
            • WheeledVehicleData
        • ShapeBaseImageData
        • SplashData
        • TriggerData
      • LightAnimData
      • LightDescription
      • LightFlareData
      • ParticleData
      • PxMaterial
      • ReflectorDesc
      • SFXAmbience
      • SFXDescription
      • SFXEnvironment
      • SFXFMODEventGroup
      • SFXFMODProject
      • SFXState
      • SFXTrack
        • SFXFMODEvent
        • SFXPlayList
        • SFXProfile
      • WheeledVehicleSpring
      • WheeledVehicleTire
    • SimSet
      • SimGroup
        • GuiControl
          • GuiBitmapBorderCtrl
          • GuiBitmapCtrl
            • GuiCrossHairHud
            • GuiFadeinBitmapCtrl
            • GuiSpeedometerHud
          • GuiButtonBaseCtrl
            • GuiBorderButtonCtrl
            • GuiButtonCtrl
              • GuiBitmapButtonCtrl
                • GuiBitmapButtonTextCtrl
              • GuiIconButtonCtrl
              • GuiToggleButtonCtrl
            • GuiCheckBoxCtrl
              • GuiRadioCtrl
            • GuiSwatchButtonCtrl
          • GuiCanvas
          • GuiChunkedBitmapCtrl
          • GuiClockHud
          • GuiContainer
            • GuiFrameSetCtrl
            • GuiPanel
            • GuiScrollCtrl
            • GuiSplitContainer
            • GuiTabBookCtrl
            • GuiTextCtrl
              • GuiBubbleTextCtrl
              • GuiPopUpMenuCtrl
              • GuiPopUpMenuCtrlEx
              • GuiProgressBitmapCtrl
              • GuiProgressCtrl
              • GuiTabPageCtrl
              • GuiTextEditCtrl
                • GuiConsoleEditCtrl
                • GuiTextEditSliderBitmapCtrl
                • GuiTextEditSliderCtrl
            • GuiTSCtrl
              • GameTSCtrl
              • GuiObjectView
            • GuiWindowCtrl
          • GuiControlArrayControl
          • GuiDragAndDropControl
          • GuiDynamicCtrlArrayControl
          • GuiGameListMenuCtrl
            • GuiGameListOptionsCtrl
          • GuiGraphCtrl
          • GuiHealthBarHud
          • GuiListBoxCtrl
            • GuiDirectoryFileListCtrl
          • GuiMessageVectorCtrl
          • GuiMLTextCtrl
            • GuiMLTextEditCtrl
          • GuiMouseEventCtrl
            • GuiInputCtrl
          • GuiPaneControl
          • GuiRolloutCtrl
          • GuiScriptNotifyCtrl
          • GuiSeparatorCtrl
          • GuiShapeNameHud
          • GuiSliderCtrl
          • GuiStackControl
          • GuiTheoraCtrl
          • GuiTickCtrl
            • GuiAutoScrollCtrl
            • GuiMenuBar
        • NetConnection
          • GameConnection
            • AIConnection
              • AIClient
        • Path
        • PostEffect
        • ScriptGroup
        • SFXSource
          • SFXController
          • SFXFMODEventSource
          • SFXSound
    • SimXMLDocument
    • StreamObject
      • FileStreamObject
    • TCPObject
      • HTTPObject
    • TerrainMaterial
    • TSShapeConstructor
    • ZipObject
  • SimpleMessageEvent


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- a -

  • aaLevel : RenderFormatToken
  • acceleration : SplashData
  • accelerator : GuiControl
  • acceptsAsChild() : SimSet
  • accuFire : ShapeBaseImageData
  • activate() : PhysicalZone , SFXState
  • activateGhosting() : GameConnection
  • activateRow() : GuiGameListMenuCtrl
  • active : GuiControl , ParticleEmitterNode
  • add() : GuiPopUpMenuCtrlEx , SimSet , BanList , ArrayObject , GuiPopUpMenuCtrl
  • addAbsolute() : BanList
  • addAutoPlot() : GuiGraphCtrl
  • addCategory() : GuiPopUpMenuCtrlEx
  • addChildSelectionByValue : GuiTreeViewCtrl
  • addCollisionDetail() : TSShapeConstructor
  • addColumn() : GuiFrameSetCtrl
  • addComment() : SimXMLDocument
  • addData() : SimXMLDocument
  • addDatum() : GuiGraphCtrl
  • addFile() : ZipObject
  • addFilteredItem() : GuiListBoxCtrl
  • addGuiControl() : GuiControl
  • addHeader() : SimXMLDocument
  • addImposter() : TSShapeConstructor
  • addLanguage() : LangTable
  • addManager() : RenderPassManager
  • addMarker() : SFXSource
  • addMenu() : GuiMenuBar
  • addMenuItem() : GuiMenuBar
  • addMesh() : TSShapeConstructor
  • addNewElement() : SimXMLDocument
  • addNode() : TSShapeConstructor
  • addPage() : GuiTabBookCtrl
  • addParameter() : SFXSource
  • addPrimitive() : TSShapeConstructor
  • addReference() : Message
  • addressModeU : GFXSamplerStateData
  • addressModeV : GFXSamplerStateData
  • addressModeW : GFXSamplerStateData
  • addRow() : GuiFrameSetCtrl , GuiGameListMenuCtrl , GuiGameListOptionsCtrl , GuiTextListCtrl
  • addScheme() : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • addSelection() : GuiTreeViewCtrl
  • addSequence() : TSShapeConstructor
  • addSubmenuItem() : GuiMenuBar
  • addText() : GuiMLTextCtrl , SimXMLDocument
  • addTimeOfDayEvent() : TimeOfDay
  • addTrigger() : TSShapeConstructor
  • adjustCenter : TSShapeConstructor
  • adjustFloor : TSShapeConstructor
  • advancedLightmapSupport : LevelInfo
  • airAbsorptionHF : SFXEnvironment
  • airControl : PlayerData
  • alignDirection : ParticleEmitterData
  • alignParticles : ParticleEmitterData
  • AlignToTerrain : fxShapeReplicator
  • allowColorChars : GuiMLTextCtrl
  • allowedMatches : GuiMessageVectorCtrl
  • AllowedTerrainSlope : fxFoliageReplicator , fxShapeReplicator
  • allowMultipleSelections : GuiListBoxCtrl
  • AllowOnInteriors : fxFoliageReplicator , fxShapeReplicator
  • AllowOnStatics : fxFoliageReplicator , fxShapeReplicator
  • AllowOnTerrain : fxFoliageReplicator , fxShapeReplicator
  • AllowOnWater : fxFoliageReplicator , fxShapeReplicator
  • allowPlayerStep : fxShapeReplicatedStatic , TSStatic
  • allowReflectPass : PostEffect
  • allowReorder : GuiTabBookCtrl
  • AllowWaterSurface : fxFoliageReplicator , fxShapeReplicator
  • alphaArg1 : GFXSamplerStateData
  • alphaArg2 : GFXSamplerStateData
  • alphaArg3 : GFXSamplerStateData
  • AlphaCutoff : fxFoliageReplicator
  • alphaDefined : GFXStateBlockData
  • alphaOp : GFXSamplerStateData
  • alphaRef : Material
  • alphaTest : Material
  • alphaTestEnable : GFXStateBlockData
  • alphaTestFunc : GFXStateBlockData
  • alphaTestRef : GFXStateBlockData
  • altCommand : GuiControl
  • alwaysHandleMouseButtons : GuiCanvas
  • alwaysImport : TSShapeConstructor
  • alwaysImportMesh : TSShapeConstructor
  • ambient : Sun
  • ambientFactor : ParticleEmitterData
  • ambientLightBlendCurve : LevelInfo
  • ambientLightBlendPhase : LevelInfo
  • ambientLightColor : Zone
  • ambientScale : ScatterSky
  • anchorBottom : GuiContainer
  • anchorLeft : GuiContainer
  • anchorRight : GuiContainer
  • anchorTop : GuiContainer
  • angularDamping : PhysicsShapeData , PhysicsDebrisData
  • angularDrag : Camera , PxMultiActorData
  • angularForce : Camera
  • angularSleepThreshold : PhysicsShapeData , PhysicsDebrisData
  • animate : LightBase , Sun , TimeOfDay
  • animateSplashes : Precipitation
  • animateTexture : ParticleData
  • animationDone() : PlayerData
  • animationPeriod : LightBase , LightDescription
  • animationPhase : LightDescription , LightBase
  • animationType : LightBase , LightDescription
  • animFlags : Material
  • animSequence : GuiObjectView
  • animTexFrames : ParticleData
  • animTexName : ParticleData
  • animTexTiling : ParticleData
  • antiSwayForce : WheeledVehicleSpring
  • append() : ArrayObject
  • appliedForce : PhysicalZone
  • apply() : LightDescription , Sun , LightFlareData
  • applyChanges() : ScatterSky
  • applyDamage() : Lightning , ShapeBase
  • applyImpulse() : GameBase , ShapeBase
  • applyRadialImpulse() : GameBase
  • applyRepair() : ShapeBase
  • area : MissionArea
  • armingDelay : ProjectileData
  • assignFieldsFrom() : SimObject
  • assignPersistentId() : SimObject
  • attach() : PhysicsForce , GuiMessageVectorCtrl , GuiWindowCtrl , ConsoleLogger
  • attachments : PxCloth
  • attachTo() : GuiWindowCtrl
  • attachToObject() : ForestWindEmitter
  • attenuationRatio : LightDescription , Sun , LightBase , ScatterSky
  • attribute() : SimXMLDocument
  • attributeExists() : SimXMLDocument
  • attributeF32() : SimXMLDocument
  • attributeS32() : SimXMLDocument
  • autoAngularForce : FlyingVehicleData
  • autoBalance : GuiFrameSetCtrl
  • autoCellSize : GuiDynamicCtrlArrayControl
  • autoCollapseSiblings : GuiRolloutCtrl
  • autoFitExtents : GuiBitmapButtonCtrl
  • autoFitRadius() : Camera
  • autoInputDamping : FlyingVehicleData
  • autoLinearForce : FlyingVehicleData
  • autoSize : GuiIconButtonCtrl
  • autoSizeHeight : GuiControlProfile
  • autoSizeWidth : GuiControlProfile
  • autoSpawn : SpawnSphere
  • axisTilt : TimeOfDay
  • azimuth : Sun , ScatterSky
  • azimuthOverride : TimeOfDay


Torque 3D - Script Manual: Namespace Index

Namespace List

Here is a list of all namespaces with brief descriptions:
$AL
$BasicLightManager
$BasicLightManagerStats
$Con
$Decals
$Ease
$gfx
$Interior
$Light
$Physics
$platform
$pref
$pref::Camera
$pref::Decals
$pref::GroundCover
$pref::imposter
$pref::Input
$pref::Interior
$pref::Net
$pref::Physics
$pref::PhysicsDebris
$pref::ProjectedShadow
$pref::PSSM
$pref::Reflect
$pref::SFX
$pref::SFX::FMOD
$pref::Shadows
$pref::shadows
$pref::Terrain
$pref::TS
$pref::Video
$pref::Water
$pref::WorldEditor
$Sampler
$SB
$Scene
$SFX
$SFX::Device
$Shadows
$Stats
$TSControl


Torque 3D - Script Manual: $AL Namespace Reference

$AL Namespace Reference

Variables

bool | PSSMDebugRender
Enables debug rendering of the PSSM shadows.
bool | UseSSAOMask
Used by the SSAO PostEffect to toggle the sampling of ssaomask texture by the light shaders.


Torque 3D - Script Manual: $BasicLightManager Namespace Reference

$BasicLightManager Namespace Reference

Variables

float shadowFilterDistance
The maximum distance in meters that projected shadows will get soft filtering.


Torque 3D - Script Manual: $BasicLightManagerStats Namespace Reference

$BasicLightManagerStats Namespace Reference

Variables

int | activePlugins
The number of active Basic Lighting SceneObjectLightingPlugin objects this frame.
int | elapsedUpdateMs
The number of milliseconds spent this frame updating Basic Lighting shadows.
int | shadowsUpdated
The number of Basic Lighting shadows updated this frame.


Torque 3D - Script Manual: $Con Namespace Reference

$Con Namespace Reference

Variables

bool | alwaysUseDebugOutput
Determines whether to send output to the platform's "debug" system.
string | File
The currently executing script file.
bool | logBufferEnabled
If true, the log buffer will be enabled.
int | printLevel
This is deprecated.
string | Root
The mod folder for the currently executing script file.
bool | useTimestamp
If true a timestamp is prepended to every console message.
bool | warnUndefinedVariables
If true, a warning will be displayed in the console whenever a undefined variable is used in script.


Torque 3D - Script Manual: $Decals Namespace Reference

$Decals Namespace Reference

Variables

bool | debugRender
If true, the decal spheres will be visualized when in the editor.
bool | poolBuffers
If true, will merge all PrimitiveBuffers and VertexBuffers into a pair of pools before clearing them at the end of a frame.
float | sphereDistanceTolerance
The distance at which the decal system will start breaking up decal spheres when adding new decals.
float | sphereRadiusTolerance
The radius beyond which the decal system will start breaking up decal spheres when adding new decals.


Torque 3D - Script Manual: $Ease Namespace Reference

$Ease Namespace Reference

Variables

int | Back
Backwards ease for curve movement.
int | Bounce
Bounce ease for curve movement.
int | Circular
Circular ease for curve movement.
int | Cubic
Cubic ease for curve movement.
int | Elastic
Elastic ease for curve movement.
int | Exponential
Exponential ease for curve movement.
int | In
In ease for curve movement.
int | InOut
InOut ease for curve movement.
int | Linear
Linear ease for curve movement.
int | Out
Out ease for curve movement.
int | Quadratic
Quadratic ease for curve movement.
int | Quartic
Quartic ease for curve movement.
int | Quintic
Quintic ease for curve movement.
int | Sinusoidal
Sinusoidal ease for curve movement.


Torque 3D - Script Manual: $gfx Namespace Reference

$gfx Namespace Reference

Variables

bool | disableOcclusionQuery
Debug helper that disables all hardware occlusion queries causing them to return only the visibile state.
bool | disassembleAllShaders
On supported devices this will dump shader disassembly to the procedural shader folder.
bool | wireframe
Used to toggle wireframe rendering at runtime.


Torque 3D - Script Manual: $Interior Namespace Reference

$Interior Namespace Reference

Variables

bool DontRestrictOutside
Render only the outside zone of all InteriorInstances.

Variable Documentation

bool $Interior::DontRestrictOutside

Render only the outside zone of all InteriorInstances.


Torque 3D - Script Manual: $Light Namespace Reference

$Light Namespace Reference

Variables

bool | renderLightFrustums
Toggles rendering of light frustums when the light is selected in the editor.
bool | renderViz
Toggles visualization of light object's radius or cone.


Torque 3D - Script Manual: $Physics Namespace Reference

$Physics Namespace Reference

Variables

bool isSinglePlayer
Used to inform the physics simulation that there is only one player.


Torque 3D - Script Manual: $platform Namespace Reference

$platform Namespace Reference

Variables

int | backgroundSleepTime
Controls processor time usage when the game window is out of focus.
int | timeManagerProcessInterval
Controls processor time usage when the game window is in focus.


Torque 3D - Script Manual: $pref Namespace Reference

$pref Namespace Reference

Namespaces

namespace | Camera
namespace | Decals
namespace | GroundCover
namespace | imposter
namespace | Input
namespace | Interior
namespace | Net
namespace | Physics
namespace | PhysicsDebris
namespace | ProjectedShadow
namespace | PSSM
namespace | Reflect
namespace | SFX
namespace | Shadows
namespace | shadows
namespace | Terrain
namespace | TS
namespace | Video
namespace | Water
namespace | WorldEditor

Variables

bool | enableBadWordFilter
If true, the bad word filter will be enabled.
bool | enablePostEffects
If true, post effects will be eanbled.
float | windEffectRadius
Radius to affect the wind.


Torque 3D - Script Manual: $pref::Camera Namespace Reference

$pref::Camera Namespace Reference

Variables

float distanceScale
A scale to apply to the normal visible distance, typically used for tuning performance.


Torque 3D - Script Manual: $pref::Decals Namespace Reference

$pref::Decals Namespace Reference

Variables

bool | enabled
Whether decals are currently enabled or not.
float | lifeTimeScale
Lifetime that decals will last after being created in the world.


Torque 3D - Script Manual: $pref::GroundCover Namespace Reference

$pref::GroundCover Namespace Reference

Variables

float densityScale
A global LOD scalar which can reduce the overall density of placed GroundCover.


Torque 3D - Script Manual: $pref::imposter Namespace Reference

$pref::imposter Namespace Reference

Variables

bool canShadow
User preference which toggles shadows from imposters. Defaults to true.


Torque 3D - Script Manual: $pref::Input Namespace Reference

$pref::Input Namespace Reference

Variables

bool JoystickEnabled
If true, the joystick is currently enabled.


Torque 3D - Script Manual: $pref::Interior Namespace Reference

$pref::Interior Namespace Reference

Variables

float | detailAdjust
Forces all InteriorInstance rendering to a particular detail level.
bool | VertexLighting
Forces all InteriorInstances to not render their lightmaps.

Variable Documentation

float $pref::Interior::detailAdjust

Forces all InteriorInstance rendering to a particular detail level.

bool $pref::Interior::VertexLighting

Forces all InteriorInstances to not render their lightmaps.


Torque 3D - Script Manual: $pref::Net Namespace Reference

$pref::Net Namespace Reference

Variables

int | LagThreshold
How long between received packets before the client is considered as lagging.
int | PacketRateToClient
Sets how often packets are sent from the server to a client.
int | PacketRateToServer
Sets how often packets are sent from the client to the server.
int | PacketSize
Sets the maximum size in bytes an individual network packet may be.


Torque 3D - Script Manual: $pref::Physics Namespace Reference

$pref::Physics Namespace Reference

Variables

int threadCount
Number of threads to use in a single pass of the physics engine.


Torque 3D - Script Manual: $pref::PhysicsDebris Namespace Reference

$pref::PhysicsDebris Namespace Reference

Variables

float lifetimeScale
Used to scale the lifetime of physics debris. Set it to 0 to disable physics debris completely.


Torque 3D - Script Manual: $pref::ProjectedShadow Namespace Reference

$pref::ProjectedShadow Namespace Reference

Variables

float | fadeEndPixelSize
A size in pixels at which BL shadows are fully faded out. This should be a smaller value than fadeStartPixelSize.
float | fadeStartPixelSize
A size in pixels at which BL shadows begin to fade out. This should be a larger value than fadeEndPixelSize.


Torque 3D - Script Manual: $pref::PSSM Namespace Reference

$pref::PSSM Namespace Reference

Variables

float | detailAdjustScale
Scales the model LOD when rendering into the PSSM shadow. Use this to reduce the draw calls when rendering the shadow by having meshes LOD out nearer to the camera than normal.
float | smallestVisiblePixelSize
The smallest pixel size an object can be and still be rendered into the PSSM shadow. Use this to force culling of small objects which contribute little to the final shadow.


Torque 3D - Script Manual: $pref::Reflect Namespace Reference

$pref::Reflect Namespace Reference

Variables

int | frameLimitMS
ReflectionManager tries not to spend more than this amount of time updating reflections per frame.
float | refractTexScale
RefractTex has dimensions equal to the active render target scaled in both x and y by this float.


Torque 3D - Script Manual: $pref::SFX Namespace Reference

$pref::SFX Namespace Reference

Namespaces

namespace FMOD


Torque 3D - Script Manual: $pref::SFX::FMOD Namespace Reference

$pref::SFX::FMOD Namespace Reference

Variables

bool | disableSoftware
Whether to disable the FMOD software mixer to conserve memory.
string | DSoundHRTF
The type of HRTF to use for hardware-mixed 3D sounds when FMOD is using DirectSound for sound output and hardware-acceleration is not available.
bool | enableProfile
Whether to enable support for FMOD's profiler.
string | pluginPath
Path to additional FMOD plugins.
bool | useSoftwareHRTF
Whether to enable HRTF in FMOD's software mixer.
bool | useSoftwareReverbLowmem
If true, FMOD's SFX reverb is run using 22/24kHz delay buffers, halving the memory required.


Torque 3D - Script Manual: $pref::shadows Namespace Reference

$pref::shadows Namespace Reference

Variables

ShadowFilterMode filterMode
The filter mode to use for shadows.


Torque 3D - Script Manual: $pref::Terrain Namespace Reference

$pref::Terrain Namespace Reference

Variables

float | detailScale
A global detail scale used to tweak the material detail distances.
float | lodScale
A global LOD scale used to tweak the default terrain screen error value.


Torque 3D - Script Manual: $pref::TS Namespace Reference

$pref::TS Namespace Reference

Variables

float | detailAdjust
User perference for scaling the TSShape level of detail. The smaller the value the closer the camera must get to see the highest LOD. This setting can have a huge impact on performance in mesh heavy scenes. The default value is 1.
int | maxInstancingVerts
Enables mesh instancing on non-skin meshes that have less that this count of verts. The default value is 200. Higher values can degrade performance.
int | skipLoadDLs
User perference which causes TSShapes to skip loading higher lods. This potentialy reduces the GPU resources and materials generated as well as limits the LODs rendered. The default value is 0.
int | skipRenderDLs
User perference which causes TSShapes to skip rendering higher lods. This will reduce the number of draw calls and triangles rendered and improve rendering performance when proper LODs have been created for your models. The default value is 0.
float | smallestVisiblePixelSize
User perference which sets the smallest pixel size at which TSShapes will skip rendering. This will force all shapes to stop rendering when they get smaller than this size. The default value is -1 which disables it.


Torque 3D - Script Manual: $pref::Video Namespace Reference

$pref::Video Namespace Reference

Variables

int | defaultAnisotropy
Default anisotropy value.
bool | disableVerticalSync
Disables vertical sync on the active device.
float | forcedPixVersion
Will force the shader model if the value is positive and less than the shader model supported by the active device. Use 0 for fixed function.
int | textureReductionLevel
The number of mipmap levels to drop on loaded textures to reduce video memory usage. It will skip any textures that have been defined as not allowing down scaling.


Torque 3D - Script Manual: $pref::Water Namespace Reference

$pref::Water Namespace Reference

Variables

bool disableTrueReflections
Force all water objects to use static cubemap reflections.


Torque 3D - Script Manual: $pref::WorldEditor Namespace Reference

$pref::WorldEditor Namespace Reference

Variables

float visibleDistanceScale
Scale factor for the visible render distance.

Variable Documentation

float $pref::WorldEditor::visibleDistanceScale

Scale factor for the visible render distance.


Torque 3D - Script Manual: $Sampler Namespace Reference

$Sampler Namespace Reference

Variables

int frequency
Samples taken every nth frame.


Torque 3D - Script Manual: $SB Namespace Reference

$SB Namespace Reference

Variables

float | DFDec
Speed to reduce the damage flash effect per tick.
float | WODec
Speed to reduce the whiteout effect per tick.


Torque 3D - Script Manual: $Scene Namespace Reference

$Scene Namespace Reference

Variables

bool | disableTerrainOcclusion
Used to disable the somewhat expensive terrain occlusion testing.
bool | disableZoneCulling
If true, zone culling will be disabled and the scene contents will only be culled against the root frustum.
bool | lockCull
Debug tool which locks the frustum culling to the current camera location.
int | maxOccludersPerZone
Maximum number of occluders that will be concurrently allowed into the scene culling state of any given zone.
float | occluderMinHeightPercentage
TODO.
float | occluderMinWidthPercentage
TODO.
bool | renderBoundingBoxes
If true, the bounding boxes of objects will be displayed.


Torque 3D - Script Manual: $SFX Namespace Reference

$SFX Namespace Reference

Namespaces

namespace | Device

Variables

int | ambientUpdateTime
Milliseconds spent on the last ambient audio update.
const int | DEVICE_CAPS_DSPEFFECTS
Sound device capability flag indicating that the sound device supports adding DSP effect chains to sounds.
const int | DEVICE_CAPS_FMODDESIGNER
Sound device capability flag indicating that the sound device supports FMOD Designer audio projects.
const int | DEVICE_CAPS_MULTILISTENER
Sound device capability flag indicating that the sound device supports multiple concurrent listeners.
const int | DEVICE_CAPS_OCCLUSION
Sound device capability flag indicating that the sound device implements sound occlusion.
const int | DEVICE_CAPS_REVERB
Sound device capability flag indicating that the sound device supports reverb.
const int | DEVICE_CAPS_VOICEMANAGEMENT
Sound device capability flag indicating that the sound device implements its own voice virtualization.
const int | DEVICE_INFO_CAPS
Index of device capability flags in device info string.
const int | DEVICE_INFO_MAXBUFFERS
Index of buffer limit number in device info string.
const int | DEVICE_INFO_NAME
Index of device name field in device info string.
const int | DEVICE_INFO_PROVIDER
Index of sound provider field in device info string.
const int | DEVICE_INFO_USEHARDWARE
Index of use hardware flag in device info string.
int | numCulled
Number of SFXSounds that are currently in virtualized playback mode.
int | numPlaying
Number of SFXSources that are currently in playing state.
int | numSounds
Number of SFXSound type objects (i.e. actual single-file sounds) that are currently instantiated.
int | numSources
Number of SFXSource type objects that are currently instantiated.
int | numVoices
Number of voices that are currently allocated on the sound device.
int | parameterUpdateTime
Milliseconds spent on the last SFXParameter update loop.
int | sourceUpdateTime
Milliseconds spent on the last SFXSource update loop.


Torque 3D - Script Manual: $SFX::Device Namespace Reference

$SFX::Device Namespace Reference

Variables

int | fmodCoreMem
Current number of bytes allocated by the core FMOD sound system.
int | fmodEventMem
Current number of bytes allocated by the FMOD Designer event system.
int | fmodNumEventSources
The current number of SFXFMODEventSource instances in the system.


Torque 3D - Script Manual: $Shadows Namespace Reference

$Shadows Namespace Reference

Variables

bool disable
Used by the editor to disable all shadow rendering.


Torque 3D - Script Manual: $Stats Namespace Reference

$Stats Namespace Reference

Variables

int | netBitsReceived
The number of bytes received during the last packet process operation.
int | netBitsSent
The number of bytes sent during the last packet send operation.
int | netGhostUpdates
The total number of ghosts added, removed, and/or updated on the client during the last packet process operation.


Torque 3D - Script Manual: $TSControl Namespace Reference

$TSControl Namespace Reference

Variables

int frameCount
The number of frames that have been rendered since this control was created.


Torque 3D - Script Manual: Class Members

  • All
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • i
  • j
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
Here is a list of all namespace members with links to the namespace documentation for each member:

- a -

  • activePlugins : $BasicLightManagerStats
  • alwaysUseDebugOutput : $Con
  • ambientUpdateTime : $SFX

- b -

  • Back : $Ease
  • backgroundSleepTime : $platform
  • Bounce : $Ease

- c -

  • canShadow : $pref::imposter
  • Circular : $Ease
  • Cubic : $Ease

- d -

  • debugRender : $Decals
  • defaultAnisotropy : $pref::Video
  • densityScale : $pref::GroundCover
  • detailAdjust : $pref::TS , $pref::Interior
  • detailAdjustScale : $pref::PSSM
  • detailScale : $pref::Terrain
  • DEVICE_CAPS_DSPEFFECTS : $SFX
  • DEVICE_CAPS_FMODDESIGNER : $SFX
  • DEVICE_CAPS_MULTILISTENER : $SFX
  • DEVICE_CAPS_OCCLUSION : $SFX
  • DEVICE_CAPS_REVERB : $SFX
  • DEVICE_CAPS_VOICEMANAGEMENT : $SFX
  • DEVICE_INFO_CAPS : $SFX
  • DEVICE_INFO_MAXBUFFERS : $SFX
  • DEVICE_INFO_NAME : $SFX
  • DEVICE_INFO_PROVIDER : $SFX
  • DEVICE_INFO_USEHARDWARE : $SFX
  • DFDec : $SB
  • disable : $pref::Shadows , $Shadows
  • disableOcclusionQuery : $gfx
  • disableSoftware : $pref::SFX::FMOD
  • disableTerrainOcclusion : $Scene
  • disableTrueReflections : $pref::Water
  • disableVerticalSync : $pref::Video
  • disableZoneCulling : $Scene
  • disassembleAllShaders : $gfx
  • distanceScale : $pref::Camera
  • DontRestrictOutside : $Interior
  • DSoundHRTF : $pref::SFX::FMOD

- e -

  • elapsedUpdateMs : $BasicLightManagerStats
  • Elastic : $Ease
  • enableBadWordFilter : $pref
  • enabled : $pref::Decals
  • enablePostEffects : $pref
  • enableProfile : $pref::SFX::FMOD
  • Exponential : $Ease

- f -

  • fadeEndPixelSize : $pref::ProjectedShadow
  • fadeStartPixelSize : $pref::ProjectedShadow
  • File : $Con
  • filterMode : $pref::shadows
  • fmodCoreMem : $SFX::Device
  • fmodEventMem : $SFX::Device
  • fmodNumEventSources : $SFX::Device
  • forcedPixVersion : $pref::Video
  • frameCount : $TSControl
  • frameLimitMS : $pref::Reflect
  • frequency : $Sampler

- i -

  • In : $Ease
  • InOut : $Ease
  • isSinglePlayer : $Physics

- j -

  • JoystickEnabled : $pref::Input

- l -

  • LagThreshold : $pref::Net
  • lifeTimeScale : $pref::Decals
  • lifetimeScale : $pref::PhysicsDebris
  • Linear : $Ease
  • lockCull : $Scene
  • lodScale : $pref::Terrain
  • logBufferEnabled : $Con

- m -

  • maxInstancingVerts : $pref::TS
  • maxOccludersPerZone : $Scene

- n -

  • netBitsReceived : $Stats
  • netBitsSent : $Stats
  • netGhostUpdates : $Stats
  • numCulled : $SFX
  • numPlaying : $SFX
  • numSounds : $SFX
  • numSources : $SFX
  • numVoices : $SFX

- o -

  • occluderMinHeightPercentage : $Scene
  • occluderMinWidthPercentage : $Scene
  • Out : $Ease

- p -

  • PacketRateToClient : $pref::Net
  • PacketRateToServer : $pref::Net
  • PacketSize : $pref::Net
  • parameterUpdateTime : $SFX
  • pluginPath : $pref::SFX::FMOD
  • poolBuffers : $Decals
  • printLevel : $Con
  • PSSMDebugRender : $AL

- q -

  • Quadratic : $Ease
  • Quartic : $Ease
  • Quintic : $Ease

- r -

  • refractTexScale : $pref::Reflect
  • renderBoundingBoxes : $Scene
  • renderLightFrustums : $Light
  • renderViz : $Light
  • Root : $Con

- s -

  • shadowFilterDistance : $BasicLightManager
  • shadowsUpdated : $BasicLightManagerStats
  • Sinusoidal : $Ease
  • skipLoadDLs : $pref::TS
  • skipRenderDLs : $pref::TS
  • smallestVisiblePixelSize : $pref::PSSM , $pref::TS
  • sourceUpdateTime : $SFX
  • sphereDistanceTolerance : $Decals
  • sphereRadiusTolerance : $Decals

- t -

  • textureReductionLevel : $pref::Video
  • textureScalar : $pref::Shadows
  • threadCount : $pref::Physics
  • timeManagerProcessInterval : $platform

- u -

  • useSoftwareHRTF : $pref::SFX::FMOD
  • useSoftwareReverbLowmem : $pref::SFX::FMOD
  • UseSSAOMask : $AL
  • useTimestamp : $Con

- v -

  • VertexLighting : $pref::Interior
  • visibleDistanceScale : $pref::WorldEditor

- w -

  • warnUndefinedVariables : $Con
  • windEffectRadius : $pref
  • wireframe : $gfx
  • WODec : $SB


Torque 3D - Script Manual: Member List

ActionMap Member List

This is the complete list of members for ActionMap, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bind(string device, string action, string flag, string deadZone, string scale, string command) | ActionMap
bind(string device, string action, string command) | ActionMap
bindCmd(string device, string action, string makeCmd, string breakCmd="") | ActionMap
bindObj(string device, string action, string flag, string deadZone, string scale, string command, SimObjectID object) | ActionMap
bindObj(string device, string action, string command, SimObjectID object) | ActionMap
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinding(string command) | ActionMap
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCommand(string device, string action) | ActionMap
getDeadZone(string device, string action) | ActionMap
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getScale(string device, string action) | ActionMap
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInverted(string device, string action) | ActionMap
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
pop() | ActionMap
push() | ActionMap
save(string fileName=NULL, bool append=false) | ActionMap
SimObject::save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
unbind(string device, string action) | ActionMap
unbindObj(string device, string action, string obj) | ActionMap


Torque 3D - Script Manual: Member List

AdvancedLightBinManager Member List

This is the complete list of members for AdvancedLightBinManager, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

AIClient Member List

This is the complete list of members for AIClient, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet |
activateGhosting() | GameConnection |
add(SimObject objects...) | SimSet |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
bringToFront(SimObject obj) | SimSet |
call(string method, string args...) | SimObject |
callOnChildren(string method, string args...) | SimSet |
callOnChildrenNoRecurse(string method, string args...) | SimSet |
canSave | SimObject |
canSaveDynamicFields | SimObject |
chaseCam(int size) | GameConnection |
checkMaxRate() | NetConnection |
class | SimObject |
className | SimObject |
clear() | SimSet |
clearCameraObject() | GameConnection |
clearPaths() | NetConnection |
clone() | SimObject |
connect(string remoteAddress) | NetConnection |
connectLocal() | NetConnection |
deepClone() | SimObject |
delete(string reason="") | GameConnection |
NetConnection::delete() | SimObject |
deleteAllObjects() | SimSet |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet |
getAddress | AIConnection |
GameConnection::getAddress() | NetConnection |
getAimLocation | AIClient |
getCameraObject() | GameConnection |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getControlCameraDefaultFov() | GameConnection |
getControlCameraFov() | GameConnection |
getControlObject() | GameConnection |
getCount() | SimSet |
getDamageFlash() | GameConnection |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getFreeLook | AIConnection |
getFullCount() | SimSet |
getGhostID(int realID) | NetConnection |
getGhostsActive() | NetConnection |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getLocation | AIClient |
getMove(string field) | AIConnection |
getMoveDestination | AIClient |
getName() | SimObject |
getObject(int index) | SimSet |
getObjectIndex(SimObject obj) | SimSet |
getPacketLoss() | NetConnection |
getPing() | NetConnection |
getRandom() | SimSet |
getServerConnection() | GameConnection | [static]
getSuperClassNamespace() | SimObject |
getTargetObject | AIClient |
getTrigger(int trigger) | AIConnection |
getWhiteOut() | GameConnection |
hidden | SimObject |
initialControlSet() | GameConnection |
internalName | SimObject |
isAIControlled() | GameConnection |
isChildOfGroup(SimGroup group) | SimObject |
isControlObjectRotDampedCamera() | GameConnection |
isDemoPlaying() | GameConnection |
isDemoRecording() | GameConnection |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isFirstPerson() | GameConnection |
isInNamespaceHierarchy(string name) | SimObject |
isMember(SimObject obj) | SimSet |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
listClassIDs() | GameConnection |
listObjects() | SimSet |
locked | SimObject |
missionCycleCleanup | AIClient |
move | AIClient |
moveForward | AIClient |
name | SimObject |
onConnectionAccepted() | GameConnection |
onConnectionDropped(string reason) | GameConnection |
onConnectionError(string errorString) | GameConnection |
onConnectionTimedOut() | GameConnection |
onConnectRequestRejected(string reason) | GameConnection |
onConnectRequestTimedOut() | GameConnection |
onDataBlocksDone(int sequence) | GameConnection |
onDrop(string disconnectReason) | GameConnection |
onFlash(bool state) | GameConnection |
onObjectAdded(SimObject object) | SimSet |
onObjectRemoved(SimObject object) | SimSet |
parentGroup | SimObject |
persistentId | SimObject |
play2D(SFXProfile profile) | GameConnection |
play3D(SFXProfile profile, TransformF location) | GameConnection |
playDemo(string demoFileName) | GameConnection |
pushToBack(SimObject obj) | SimSet |
remove(SimObject objects...) | SimSet |
reorderChild(SimObject child1, SimObject child2) | SimSet |
resetGhosting() | GameConnection |
resolveGhostID(int ghostID) | NetConnection |
resolveObjectFromGhostIndex(int ghostID) | NetConnection |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
schedule(float time, string method, string args...) | SimObject |
setAimLocation | AIClient |
setBlackOut(bool doFade, int timeMS) | GameConnection |
setCameraObject(GameBase camera) | GameConnection |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setConnectArgs(const char *args) | GameConnection |
setControlCameraFov(float newFOV) | GameConnection |
setControlObject(GameBase ctrlObj) | GameConnection |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setFirstPerson(bool firstPerson) | GameConnection |
setFreeLook(bool isFreeLook) | AIConnection |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setJoinPassword(string password) | GameConnection |
setLagIcon(bool state) | GameConnection |
setLocked(bool value=true) | SimObject |
setMissionCRC(int CRC) | GameConnection |
setMove(string field, float value) | AIConnection |
setMoveDestination | AIClient |
setMoveSpeed | AIClient |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setSimulatedNetParams(float packetLoss, int delay) | NetConnection |
setSuperClassNamespace(string name) | SimObject |
setTargetObject | AIClient |
setTrigger(int trigger, bool set) | AIConnection |
sort(string callbackFunction) | SimSet |
startRecording(string fileName) | GameConnection |
stop | AIClient |
stopRecording() | GameConnection |
superClass | SimObject |
transmitDataBlocks(int sequence) | GameConnection |
transmitPaths() | NetConnection |


Torque 3D - Script Manual: Member List

AIConnection Member List

This is the complete list of members for AIConnection, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet |
activateGhosting() | GameConnection |
add(SimObject objects...) | SimSet |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
bringToFront(SimObject obj) | SimSet |
call(string method, string args...) | SimObject |
callOnChildren(string method, string args...) | SimSet |
callOnChildrenNoRecurse(string method, string args...) | SimSet |
canSave | SimObject |
canSaveDynamicFields | SimObject |
chaseCam(int size) | GameConnection |
checkMaxRate() | NetConnection |
class | SimObject |
className | SimObject |
clear() | SimSet |
clearCameraObject() | GameConnection |
clearPaths() | NetConnection |
clone() | SimObject |
connect(string remoteAddress) | NetConnection |
connectLocal() | NetConnection |
deepClone() | SimObject |
delete(string reason="") | GameConnection |
NetConnection::delete() | SimObject |
deleteAllObjects() | SimSet |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet |
getAddress | AIConnection |
GameConnection::getAddress() | NetConnection |
getCameraObject() | GameConnection |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getControlCameraDefaultFov() | GameConnection |
getControlCameraFov() | GameConnection |
getControlObject() | GameConnection |
getCount() | SimSet |
getDamageFlash() | GameConnection |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getFreeLook | AIConnection |
getFullCount() | SimSet |
getGhostID(int realID) | NetConnection |
getGhostsActive() | NetConnection |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMove(string field) | AIConnection |
getName() | SimObject |
getObject(int index) | SimSet |
getObjectIndex(SimObject obj) | SimSet |
getPacketLoss() | NetConnection |
getPing() | NetConnection |
getRandom() | SimSet |
getServerConnection() | GameConnection | [static]
getSuperClassNamespace() | SimObject |
getTrigger(int trigger) | AIConnection |
getWhiteOut() | GameConnection |
hidden | SimObject |
initialControlSet() | GameConnection |
internalName | SimObject |
isAIControlled() | GameConnection |
isChildOfGroup(SimGroup group) | SimObject |
isControlObjectRotDampedCamera() | GameConnection |
isDemoPlaying() | GameConnection |
isDemoRecording() | GameConnection |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isFirstPerson() | GameConnection |
isInNamespaceHierarchy(string name) | SimObject |
isMember(SimObject obj) | SimSet |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
listClassIDs() | GameConnection |
listObjects() | SimSet |
locked | SimObject |
name | SimObject |
onConnectionAccepted() | GameConnection |
onConnectionDropped(string reason) | GameConnection |
onConnectionError(string errorString) | GameConnection |
onConnectionTimedOut() | GameConnection |
onConnectRequestRejected(string reason) | GameConnection |
onConnectRequestTimedOut() | GameConnection |
onDataBlocksDone(int sequence) | GameConnection |
onDrop(string disconnectReason) | GameConnection |
onFlash(bool state) | GameConnection |
onObjectAdded(SimObject object) | SimSet |
onObjectRemoved(SimObject object) | SimSet |
parentGroup | SimObject |
persistentId | SimObject |
play2D(SFXProfile profile) | GameConnection |
play3D(SFXProfile profile, TransformF location) | GameConnection |
playDemo(string demoFileName) | GameConnection |
pushToBack(SimObject obj) | SimSet |
remove(SimObject objects...) | SimSet |
reorderChild(SimObject child1, SimObject child2) | SimSet |
resetGhosting() | GameConnection |
resolveGhostID(int ghostID) | NetConnection |
resolveObjectFromGhostIndex(int ghostID) | NetConnection |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
schedule(float time, string method, string args...) | SimObject |
setBlackOut(bool doFade, int timeMS) | GameConnection |
setCameraObject(GameBase camera) | GameConnection |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setConnectArgs(const char *args) | GameConnection |
setControlCameraFov(float newFOV) | GameConnection |
setControlObject(GameBase ctrlObj) | GameConnection |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setFirstPerson(bool firstPerson) | GameConnection |
setFreeLook(bool isFreeLook) | AIConnection |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setJoinPassword(string password) | GameConnection |
setLagIcon(bool state) | GameConnection |
setLocked(bool value=true) | SimObject |
setMissionCRC(int CRC) | GameConnection |
setMove(string field, float value) | AIConnection |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setSimulatedNetParams(float packetLoss, int delay) | NetConnection |
setSuperClassNamespace(string name) | SimObject |
setTrigger(int trigger, bool set) | AIConnection |
sort(string callbackFunction) | SimSet |
startRecording(string fileName) | GameConnection |
stopRecording() | GameConnection |
superClass | SimObject |
transmitDataBlocks(int sequence) | GameConnection |
transmitPaths() | NetConnection |


Torque 3D - Script Manual: Member List

AIPlayer Member List

This is the complete list of members for AIPlayer, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
checkDismountPoint(Point3F oldPos, Point3F pos) | Player |
class | SimObject |
className | SimObject |
clearAim() | AIPlayer |
clearControlObject() | Player |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAimLocation() | AIPlayer |
getAimObject() | AIPlayer |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getControlObject() | Player |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamageLocation(Point3F pos) | Player |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMoveDestination() | AIPlayer |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getState() | Player |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | AIPlayer | [static]
isRenderEnabled | SceneObject |
isSelectable | AIPlayer | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
maxPredictionTicks | Player | [static]
maxWarpTicks | Player | [static]
minWarpTicks | Player | [static]
mMoveTolerance | AIPlayer |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
moveStuckTestDelay | AIPlayer |
moveStuckTolerance | AIPlayer |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
renderCollision | Player | [static]
renderMyItems | Player | [static]
renderMyPlayer | Player | [static]
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setActionThread(string name, bool hold=false, bool fsp=true) | Player |
setAimLocation(Point3F target) | AIPlayer |
setAimObject(GameBase targetObject, Point3F offset) | AIPlayer |
setAllMeshesHidden(bool hide) | ShapeBase |
setArmThread(string name) | Player |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setControlObject(ShapeBase obj) | Player |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setMoveDestination(Point3F goal, bool slowDown=true) | AIPlayer |
setMoveSpeed(float speed) | AIPlayer |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stop() | AIPlayer |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

ArrayObject Member List

This is the complete list of members for ArrayObject, including all inherited members.
add(string key, string value="") | ArrayObject
append(ArrayObject target) | ArrayObject
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
caseSensitive | ArrayObject
class | SimObject
className | SimObject
clone() | SimObject
count() | ArrayObject
countKey(string key) | ArrayObject
countValue(string value) | ArrayObject
crop(ArrayObject target) | ArrayObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
duplicate(ArrayObject target) | ArrayObject
echo() | ArrayObject
empty() | ArrayObject
erase(int index) | ArrayObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCurrent() | ArrayObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getIndexFromKey(string key) | ArrayObject
getIndexFromValue(string value) | ArrayObject
getInternalName() | SimObject
getKey(int index) | ArrayObject
getName() | SimObject
getSuperClassNamespace() | SimObject
getValue(int index) | ArrayObject
hidden | SimObject
insert(string key, string value, int index) | ArrayObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
key | ArrayObject
locked | SimObject
moveFirst() | ArrayObject
moveLast() | ArrayObject
moveNext() | ArrayObject
movePrev() | ArrayObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
pop_back() | ArrayObject
pop_front() | ArrayObject
push_back(string key, string value="") | ArrayObject
push_front(string key, string value="") | ArrayObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setCurrent(int index) | ArrayObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setKey(string key, int index) | ArrayObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
setValue(string value, int index) | ArrayObject
sort(bool descending=false) | ArrayObject
sorta() | ArrayObject
sortd() | ArrayObject
sortf(string functionName) | ArrayObject
sortfd(string functionName) | ArrayObject
sortfk(string functionName) | ArrayObject
sortfkd(string functionName) | ArrayObject
sortk(bool descending=false) | ArrayObject
sortka() | ArrayObject
sortkd() | ArrayObject
sortn(bool descending=false) | ArrayObject
sortna() | ArrayObject
sortnd() | ArrayObject
sortnk(bool descending=false) | ArrayObject
sortnka() | ArrayObject
sortnkd() | ArrayObject
superClass | SimObject
uniqueKey() | ArrayObject
uniqueValue() | ArrayObject


Torque 3D - Script Manual: Member List

BanList Member List

This is the complete list of members for BanList, including all inherited members.
add(int uniqueId, string transportAddress, int banLength) | BanList | [static]
addAbsolute(int uniqueId, string transportAddress, int banTime) | BanList | [static]
export(string filename) | BanList | [static]
isBanned(int uniqueId, string transportAddress) | BanList | [static]
removeBan(int uniqueId, string transportAddress) | BanList | [static]


Torque 3D - Script Manual: Member List

BasicClouds Member List

This is the complete list of members for BasicClouds, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
height | BasicClouds |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | BasicClouds | [static]
isRenderEnabled | SceneObject |
isSelectable | BasicClouds | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
layerEnabled | BasicClouds |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
texDirection | BasicClouds |
texOffset | BasicClouds |
texScale | BasicClouds |
texSpeed | BasicClouds |
texture | BasicClouds |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

Camera Member List

This is the complete list of members for Camera, including all inherited members.
angularDrag | Camera |
angularForce | Camera |
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
autoFitRadius(float radius) | Camera |
boundingBox | GameBase | [static]
brakeMultiplier | Camera |
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
controlMode | Camera |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
drag | Camera |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
force | Camera |
getAIRepairPoint() | ShapeBase |
getAngularVelocity() | Camera |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getMode() | Camera |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getOffset() | Camera |
getPendingImage(int slot) | ShapeBase |
getPosition() | Camera |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getRotation() | Camera |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | Camera |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditOrbitMode() | Camera |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Camera | [static]
isRenderEnabled | SceneObject |
isRotationDamped() | Camera |
isSelectable | Camera | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
lookAt(Point3F point) | Camera |
mass | Camera |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
movementSpeed | Camera | [static]
name | SimObject |
newtonMode | Camera |
newtonRotation | Camera |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setAngularDrag(float drag) | Camera |
setAngularForce(float force) | Camera |
setAngularVelocity(VectorF velocity) | Camera |
setBrakeMultiplier(float multiplier) | Camera |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setDrag(float drag) | Camera |
setEditOrbitMode() | Camera |
setEditOrbitPoint(Point3F point) | Camera |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setFlyForce(float force) | Camera |
setFlyMode() | Camera |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMass(float mass) | Camera |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setNewtonFlyMode() | Camera |
setOffset(Point3F offset) | Camera |
setOrbitMode(GameBase orbitObject, TransformF orbitPoint, float minDistance, float maxDistance, float initDistance, bool ownClientObj=false, Point3F offset=Point3F(0.0f, 0.0f, 0.0f), bool locked=false) | Camera |
setOrbitObject(GameBase orbitObject, VectorF rotation, float minDistance, float maxDistance, float initDistance, bool ownClientObject=false, Point3F offset=Point3F(0.0f, 0.0f, 0.0f), bool locked=false) | Camera |
setOrbitPoint(TransformF orbitPoint, float minDistance, float maxDistance, float initDistance, Point3F offset=Point3F(0.0f, 0.0f, 0.0f), bool locked=false) | Camera |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setRotation(Point3F rot) | Camera |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSpeedMultiplier(float multiplier) | Camera |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTrackObject(GameBase trackObject, Point3F offset=Point3F(0.0f, 0.0f, 0.0f)) | Camera |
setTransform(TransformF txfm) | SceneObject |
setValidEditOrbitPoint(bool validPoint) | Camera |
setVelocity(VectorF velocity) | Camera |
ShapeBase::setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
speedMultiplier | Camera |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

CameraData Member List

This is the complete list of members for CameraData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
cameraDefaultFov | ShapeBaseData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
computeCRC | ShapeBaseData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
inheritEnergyFromMount | ShapeBaseData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ShapeBaseData
maxDamage | ShapeBaseData
maxEnergy | ShapeBaseData
name | SimObject
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
superClass | SimObject
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData


Torque 3D - Script Manual: Member List

CloudLayer Member List

This is the complete list of members for CloudLayer, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
baseColor | CloudLayer |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
coverage | CloudLayer |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
exposure | CloudLayer |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
height | CloudLayer |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | CloudLayer | [static]
isRenderEnabled | SceneObject |
isSelectable | CloudLayer | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
texDirection | CloudLayer |
texScale | CloudLayer |
texSpeed | CloudLayer |
texture | CloudLayer |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
windSpeed | CloudLayer |


Torque 3D - Script Manual: Member List

ConsoleLogger Member List

This is the complete list of members for ConsoleLogger, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
attach() | ConsoleLogger
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
detach() | ConsoleLogger
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
level | ConsoleLogger
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

ConvexShape Member List

This is the complete list of members for ConvexShape, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | ConvexShape | [static]
isRenderEnabled | SceneObject |
isSelectable | ConvexShape | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
Material | ConvexShape |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
surface | ConvexShape |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

CubemapData Member List

This is the complete list of members for CubemapData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
cubeFace | CubemapData
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dynamic | CubemapData
dynamicFarDist | CubemapData
dynamicNearDist | CubemapData
dynamicObjectTypeMask | CubemapData
dynamicSize | CubemapData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | CubemapData
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
updateFaces() | CubemapData


Torque 3D - Script Manual: Member List

CustomMaterial Member List

This is the complete list of members for CustomMaterial, including all inherited members.
alphaRef | Material
alphaTest | Material
animFlags | Material
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
baseTex | Material
bumpAtlas | Material
bumpTex | Material
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
castShadows | Material
cellIndex | Material
cellLayout | Material
cellSize | Material
class | SimObject
className | SimObject
clone() | SimObject
colorMultiply | Material
cubemap | Material
customFootstepSound | Material
customImpactSound | Material
deepClone() | SimObject
delete() | SimObject
detailMap | Material
detailNormalMap | Material
detailNormalMapStrength | Material
detailScale | Material
detailTex | Material
diffuseColor | Material
diffuseMap | Material
doubleSided | Material
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpInstances | Material
dumpMethods() | SimObject
dynamicCubemap | Material
effectColor | Material
emissive | Material
envMap | Material
envTex | Material
fallback | CustomMaterial
flush | Material
footstepSoundId | Material
forwardLit | CustomMaterial
getAnimFlags | Material
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename | Material
SimObject::getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
glow | Material
hidden | SimObject
impactSoundId | Material
internalName | SimObject
isAutoGenerated | Material
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lightMap | Material
locked | SimObject
mapTo | Material
minnaertConstant | Material
name | SimObject
normalMap | Material
overlayMap | Material
overlayTex | Material
parallaxScale | Material
parentGroup | SimObject
persistentId | SimObject
pixelSpecular | Material
planarReflection | Material
reload | Material
rotPivotOffset | Material
rotSpeed | Material
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scrollDir | Material
scrollSpeed | Material
sequenceFramePerSec | Material
sequenceSegmentSize | Material
setAutoGenerated | Material
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shader | CustomMaterial
showDust | Material
showFootprints | Material
specular | Material
specularMap | Material
specularPower | Material
stateBlock | CustomMaterial
subSurface | Material
subSurfaceColor | Material
subSurfaceRolloff | Material
superClass | SimObject
target | CustomMaterial
toneMap | Material
translucent | Material
translucentBlendOp | Material
translucentZWrite | Material
useAnisotropic | Material
version | CustomMaterial
vertColor | Material
vertLit | Material
waveAmp | Material
waveFreq | Material
waveType | Material


Torque 3D - Script Manual: Member List

Debris Member List

This is the complete list of members for Debris, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
init(string inputPosition="1.0 1.0 1.0", string inputVelocity="1.0 0.0 0.0") | Debris |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Debris | [static]
isRenderEnabled | SceneObject |
isSelectable | Debris | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
lifetime | Debris |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

DebrisData Member List

This is the complete list of members for DebrisData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
baseRadius | DebrisData
bounceVariance | DebrisData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
elasticity | DebrisData
emitters | DebrisData
explodeOnMaxBounce | DebrisData
Explosion | DebrisData
fade | DebrisData
friction | DebrisData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
gravModifier | DebrisData
hidden | SimObject
ignoreWater | DebrisData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifetime | DebrisData
lifetimeVariance | DebrisData
locked | SimObject
maxSpinSpeed | DebrisData
minSpinSpeed | DebrisData
name | SimObject
numBounces | DebrisData
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shapeFile | DebrisData
snapOnMaxBounce | DebrisData
staticOnMaxBounce | DebrisData
superClass | SimObject
terminalVelocity | DebrisData
texture | DebrisData
useRadiusMass | DebrisData
velocity | DebrisData
velocityVariance | DebrisData


Torque 3D - Script Manual: Member List

DebugDrawer Member List

This is the complete list of members for DebugDrawer, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
drawBox(Point3F a, Point3F b, ColorF color=ColorF::WHITE) | DebugDrawer
drawLine(Point3F a, Point3F b, ColorF color=ColorF::WHITE) | DebugDrawer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLastTTL(int ms) | DebugDrawer
setLastZTest(bool enabled) | DebugDrawer
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
toggleDrawing() | DebugDrawer
toggleFreeze() | DebugDrawer


Torque 3D - Script Manual: Member List

DecalData Member List

This is the complete list of members for DecalData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clippingAngle | DecalData
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fadeEndPixelSize | DecalData
fadeStartPixelSize | DecalData
fadeTime | DecalData
frame | DecalData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifeSpan | DecalData
locked | SimObject
Material | DecalData
name | SimObject
parentGroup | SimObject
persistentId | SimObject
postApply() | DecalData
randomize | DecalData
reloadOnLocalClient() | SimDataBlock
renderPriority | DecalData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
size | DecalData
superClass | SimObject
texCols | DecalData
texRows | DecalData
textureCoordCount | DecalData
textureCoords | DecalData


Torque 3D - Script Manual: Member List

DecalManager Member List

This is the complete list of members for DecalManager, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | DecalManager | [static]
isRenderEnabled | SceneObject |
isSelectable | DecalManager | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

DecalRoad Member List

This is the complete list of members for DecalRoad, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
breakAngle | DecalRoad |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
discardAll | DecalRoad | [static]
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
EditorOpen | DecalRoad | [static]
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | DecalRoad | [static]
isRenderEnabled | SceneObject |
isSelectable | DecalRoad | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
Material | DecalRoad |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
Node | DecalRoad |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
postApply() | DecalRoad |
regenerate() | DecalRoad |
renderPriority | DecalRoad |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
showBatches | DecalRoad | [static]
showRoad | DecalRoad | [static]
showSpline | DecalRoad | [static]
superClass | SimObject |
textureLength | DecalRoad |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
updateDelay | DecalRoad | [static]
wireframe | DecalRoad | [static]


Torque 3D - Script Manual: Alphabetical List

Class Index

A | B | C | D | E | F | G | H | I | L | M | N | O | P | R | S | T | V | W | Z
A
GuiBitmapBorderCtrl GuiTabBookCtrl PfxVis SFXFMODEvent
ActionMap GuiBitmapButtonCtrl GuiTabPageCtrl PhysicalZone SFXFMODEventGroup
AdvancedLightBinManager GuiBitmapButtonTextCtrl GuiTextCtrl PhysicsDebris SFXFMODEventSource
AIClient GuiBitmapCtrl GuiTextEditCtrl PhysicsDebrisData SFXFMODProject
AIConnection GuiBorderButtonCtrl GuiTextEditSliderBitmapCtrl PhysicsForce SFXParameter
AIPlayer GuiBubbleTextCtrl GuiTextEditSliderCtrl PhysicsShape SFXPlayList
ArrayObject GuiButtonBaseCtrl GuiTextListCtrl PhysicsShapeData SFXProfile
B
GuiButtonCtrl GuiTheoraCtrl Player SFXSound
BanList GuiCanvas GuiTickCtrl PlayerData SFXSource
BasicClouds GuiCheckBoxCtrl GuiToggleButtonCtrl PointLight SFXSpace
C
GuiChunkedBitmapCtrl GuiTreeViewCtrl Portal SFXState
Camera GuiClockHud GuiTSCtrl PostEffect SFXTrack
CameraData GuiConsole GuiWindowCtrl Precipitation ShaderData
CloudLayer GuiConsoleEditCtrl
H
PrecipitationData ShapeBase
ConsoleLogger GuiContainer HoverVehicle Prefab ShapeBaseData
ConvexShape GuiControl HoverVehicleData Projectile ShapeBaseImageData
CubemapData GuiControlArrayControl HTTPObject ProjectileData SimDataBlock
CustomMaterial GuiControlProfile
I
PxCloth SimGroup
D
GuiCrossHairHud InteriorInstance PxMaterial SimObject
Debris GuiCursor Item PxMultiActor SimpleMessageEvent
DebrisData GuiDirectoryFileListCtrl ItemData PxMultiActorData SimpleNetObject
DebugDrawer GuiDragAndDropControl
L
R
SimSet
DecalData GuiDynamicCtrlArrayControl LangTable RadialImpulseEvent SimXMLDocument
DecalManager GuiFadeinBitmapCtrl LevelInfo ReflectorDesc SkyBox
DecalRoad GuiFrameSetCtrl LightAnimData RenderBinManager SpawnSphere
E
GuiGameListMenuCtrl LightBase RenderFormatToken Splash
EditorIconRegistry GuiGameListMenuProfile LightDescription RenderGlowMgr SplashData
EventManager GuiGameListOptionsCtrl LightFlareData RenderImposterMgr SpotLight
Explosion GuiGameListOptionsProfile Lightning RenderMeshExample StaticShape
ExplosionData GuiGraphCtrl LightningData RenderMeshMgr StaticShapeData
F
GuiHealthBarHud LightningStrikeEvent RenderObjectExample StreamObject
FileDialog GuiIconButtonCtrl
M
RenderObjectMgr Sun
FileObject GuiInputCtrl Marker RenderOcclusionMgr
T
FileStreamObject GuiListBoxCtrl Material RenderParticleMgr TCPObject
FlyingVehicle GuiMenuBar MeshRoad RenderPassManager TerrainBlock
FlyingVehicleData GuiMessageVectorCtrl Message RenderPassStateBin TerrainMaterial
Forest GuiMLTextCtrl MessageForwarder RenderPassStateToken TimeOfDay
ForestBrushElement GuiMLTextEditCtrl MessageVector RenderPrePassMgr Trigger
ForestItemData GuiMouseEventCtrl MissionArea RenderShapeExample TriggerData
ForestWindEmitter GuiObjectView MissionMarker RenderTerrainMgr TSForestItemData
fxFoliageReplicator GuiPaneControl MissionMarkerData RenderTexTargetBinManager TSShapeConstructor
fxShapeReplicatedStatic GuiPanel
N
RenderTranslucentMgr TSStatic
fxShapeReplicator GuiPopUpMenuCtrl NetConnection RigidShape
V
G
GuiPopUpMenuCtrlEx NetObject RigidShapeData Vehicle
GameBase GuiProgressBitmapCtrl
O
River VehicleData
GameBaseData GuiProgressCtrl OcclusionVolume
S
W
GameConnection GuiRadioCtrl OpenFileDialog SaveFileDialog WaterBlock
GameTSCtrl GuiRolloutCtrl OpenFolderDialog ScatterSky WaterObject
GFXCardProfiler GuiScriptNotifyCtrl
P
SceneObject WaterPlane
GFXCardProfilerAPI GuiScrollCtrl ParticleData ScriptGroup WayPoint
GFXInit GuiSeparatorCtrl ParticleEmitter ScriptMsgListener WheeledVehicle
GFXSamplerStateData GuiShapeNameHud ParticleEmitterData ScriptObject WheeledVehicleData
GFXStateBlockData GuiSliderCtrl ParticleEmitterNode SFXAmbience WheeledVehicleSpring
GroundCover GuiSpeedometerHud ParticleEmitterNodeData SFXController WheeledVehicleTire
GroundPlane GuiSplitContainer Path SFXDescription
Z
GuiArrayCtrl GuiStackControl PathCamera SFXEmitter ZipObject
GuiAutoScrollCtrl GuiSwatchButtonCtrl PathCameraData SFXEnvironment Zone
A | B | C | D | E | F | G | H | I | L | M | N | O | P | R | S | T | V | W | Z


Torque 3D - Script Manual: Member List

EventManager Member List

This is the complete list of members for EventManager, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpEvents() | EventManager
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dumpSubscribers(String event) | EventManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isRegisteredEvent(String event) | EventManager
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
postEvent(String event, String data) | EventManager
queue | EventManager
registerEvent(String event) | EventManager
remove(SimObject listener, String event) | EventManager
removeAll(SimObject listener) | EventManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
subscribe(SimObject listener, String event, String callback) | EventManager
superClass | SimObject
unregisterEvent(String event) | EventManager


Torque 3D - Script Manual: Member List

Explosion Member List

This is the complete list of members for Explosion, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Explosion | [static]
isRenderEnabled | SceneObject |
isSelectable | Explosion | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

ExplosionData Member List

This is the complete list of members for ExplosionData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
camShakeAmp | ExplosionData
camShakeDuration | ExplosionData
camShakeFalloff | ExplosionData
camShakeFreq | ExplosionData
camShakeRadius | ExplosionData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
Debris | ExplosionData
debrisNum | ExplosionData
debrisNumVariance | ExplosionData
debrisPhiMax | ExplosionData
debrisPhiMin | ExplosionData
debrisThetaMax | ExplosionData
debrisThetaMin | ExplosionData
debrisVelocity | ExplosionData
debrisVelocityVariance | ExplosionData
deepClone() | SimObject
delayMS | ExplosionData
delayVariance | ExplosionData
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
emitter | ExplosionData
explosionScale | ExplosionData
explosionShape | ExplosionData
faceViewer | ExplosionData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifetimeMS | ExplosionData
lifetimeVariance | ExplosionData
lightEndBrightness | ExplosionData
lightEndColor | ExplosionData
lightEndRadius | ExplosionData
lightNormalOffset | ExplosionData
lightStartBrightness | ExplosionData
lightStartColor | ExplosionData
lightStartRadius | ExplosionData
locked | SimObject
name | SimObject
offset | ExplosionData
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
particleDensity | ExplosionData
ParticleEmitter | ExplosionData
particleRadius | ExplosionData
persistentId | SimObject
playSpeed | ExplosionData
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shakeCamera | ExplosionData
sizes | ExplosionData
soundProfile | ExplosionData
subExplosion | ExplosionData
superClass | SimObject
times | ExplosionData


Torque 3D - Script Manual: Member List

FileDialog Member List

This is the complete list of members for FileDialog, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
changePath | FileDialog
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
defaultFile | FileDialog
defaultPath | FileDialog
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Execute() | FileDialog
fileName | FileDialog
filters | FileDialog
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
title | FileDialog


Torque 3D - Script Manual: Member List

FileObject Member List

This is the complete list of members for FileObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
close() | FileObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isEOF() | FileObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
openForAppend(string filename) | FileObject
openForRead(string filename) | FileObject
openForWrite(string filename) | FileObject
parentGroup | SimObject
peekLine() | FileObject
persistentId | SimObject
readLine() | FileObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
writeLine(string text) | FileObject
writeObject(SimObject *object, string prepend) | FileObject
writeObject(SimObject *object) | FileObject


Torque 3D - Script Manual: Member List

FileStreamObject Member List

This is the complete list of members for FileStreamObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
close() | FileStreamObject
copyFrom(SimObject other) | StreamObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getPosition() | StreamObject
getStatus() | StreamObject
getStreamSize() | StreamObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isEOF() | StreamObject
isEOS() | StreamObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
open(string filename, string openMode) | FileStreamObject
parentGroup | SimObject
persistentId | SimObject
readLine() | StreamObject
readLongString(int maxLength) | StreamObject
readString() | StreamObject
readSTString(bool caseSensitive=false) | StreamObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int newPosition) | StreamObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
writeLine(string line) | StreamObject
writeLongString(int maxLength, string string) | StreamObject
writeString(string string, int maxLength=256) | StreamObject


Torque 3D - Script Manual: Member List

FlyingVehicle Member List

This is the complete list of members for FlyingVehicle, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
disableMove | Vehicle |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | FlyingVehicle | [static]
isRenderEnabled | SceneObject |
isSelectable | FlyingVehicle | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
useCreateHeight(bool enabled) | FlyingVehicle |
validateCameraFov(float fov) | ShapeBase |
workingQueryBoxSizeMultiplier | Vehicle | [static]
workingQueryBoxStaleThreshold | Vehicle | [static]


Torque 3D - Script Manual: Member List

FlyingVehicleData Member List

This is the complete list of members for FlyingVehicleData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoAngularForce | FlyingVehicleData
autoInputDamping | FlyingVehicleData
autoLinearForce | FlyingVehicleData
backwardJetEmitter | FlyingVehicleData
bodyFriction | VehicleData
bodyRestitution | VehicleData
call(string method, string args...) | SimObject
cameraDecay | VehicleData
cameraDefaultFov | ShapeBaseData
cameraLag | VehicleData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
cameraOffset | VehicleData
cameraRoll | VehicleData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
collDamageMultiplier | VehicleData
collDamageThresholdVel | VehicleData
collisionTol | VehicleData
computeCRC | ShapeBaseData
contactTol | VehicleData
createHoverHeight | FlyingVehicleData
cubeReflectorDesc | ShapeBaseData
damageEmitter | VehicleData
damageEmitterOffset | VehicleData
damageLevelTolerance | VehicleData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
downJetEmitter | FlyingVehicleData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dustEmitter | VehicleData
dustHeight | VehicleData
engineSound | FlyingVehicleData
exitingWater | VehicleData
exitSplashSoundVelocity | VehicleData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
forwardJetEmitter | FlyingVehicleData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hardImpactSound | VehicleData
hardImpactSpeed | VehicleData
hardSplashSoundVelocity | VehicleData
hidden | SimObject
horizontalSurfaceForce | FlyingVehicleData
hoverHeight | FlyingVehicleData
impactWaterEasy | VehicleData
impactWaterHard | VehicleData
impactWaterMedium | VehicleData
inheritEnergyFromMount | ShapeBaseData
integration | VehicleData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
jetEnergyDrain | VehicleData
jetForce | VehicleData
jetSound | FlyingVehicleData
locked | SimObject
maneuveringForce | FlyingVehicleData
mass | ShapeBaseData
massBox | VehicleData
massCenter | VehicleData
maxAutoSpeed | FlyingVehicleData
maxDamage | ShapeBaseData
maxDrag | VehicleData
maxEnergy | ShapeBaseData
maxSteeringAngle | VehicleData
mediumSplashSoundVelocity | VehicleData
minDrag | VehicleData
minImpactSpeed | VehicleData
minJetEnergy | VehicleData
minRollSpeed | VehicleData
minTrailSpeed | FlyingVehicleData
name | SimObject
numDmgEmitterAreas | VehicleData
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onEnterLiquid(Vehicle obj, float coverage, string type) | VehicleData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onLeaveLiquid(Vehicle obj, string type) | VehicleData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
rollForce | FlyingVehicleData
rotationalDrag | FlyingVehicleData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
softImpactSound | VehicleData
softImpactSpeed | VehicleData
softSplashSoundVelocity | VehicleData
splashEmitter | VehicleData
splashFreqMod | VehicleData
splashVelEpsilon | VehicleData
steeringForce | FlyingVehicleData
steeringRollForce | FlyingVehicleData
superClass | SimObject
trailEmitter | FlyingVehicleData
triggerDustHeight | VehicleData
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData
verticalSurfaceForce | FlyingVehicleData
vertThrustMultiple | FlyingVehicleData
waterWakeSound | VehicleData


Torque 3D - Script Manual: Member List

Forest Member List

This is the complete list of members for Forest, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clear() | Forest |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataFile | Forest |
deepClone() | SimObject |
delete() | SimObject |
disableImposters | Forest | [static]
drawBounds | Forest | [static]
drawCells | Forest | [static]
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
forceImposters | Forest | [static]
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isDirty() | Forest |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Forest | [static]
isRenderEnabled | SceneObject |
isSelectable | Forest | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
lodReflectScalar | Forest |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
regenCells() | Forest |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
saveDataFile | Forest |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

ForestBrushElement Member List

This is the complete list of members for ForestBrushElement, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
elevationMax | ForestBrushElement
elevationMin | ForestBrushElement
ForestItemData | ForestBrushElement
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
probability | ForestBrushElement
rotationRange | ForestBrushElement
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
scaleExponent | ForestBrushElement
scaleMax | ForestBrushElement
scaleMin | ForestBrushElement
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
sinkMax | ForestBrushElement
sinkMin | ForestBrushElement
sinkRadius | ForestBrushElement
slopeMax | ForestBrushElement
slopeMin | ForestBrushElement
superClass | SimObject


Torque 3D - Script Manual: Member List

ForestItemData Member List

This is the complete list of members for ForestItemData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
branchAmp | ForestItemData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
collidable | ForestItemData
dampingCoefficient | ForestItemData
deepClone() | SimObject
delete() | SimObject
detailAmp | ForestItemData
detailFreq | ForestItemData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ForestItemData
name | SimObject
parentGroup | SimObject
persistentId | SimObject
radius | ForestItemData
reloadOnLocalClient() | SimDataBlock
rigidity | ForestItemData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shapeFile | ForestItemData
superClass | SimObject
tightnessCoefficient | ForestItemData
trunkBendScale | ForestItemData
windScale | ForestItemData


Torque 3D - Script Manual: Member List

ForestWindEmitter Member List

This is the complete list of members for ForestWindEmitter, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attachToObject(int objectID) | ForestWindEmitter |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
gustFrequency | ForestWindEmitter |
gustStrength | ForestWindEmitter |
gustWobbleStrength | ForestWindEmitter |
gustYawAngle | ForestWindEmitter |
gustYawFrequency | ForestWindEmitter |
hasMount | ForestWindEmitter |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | ForestWindEmitter | [static]
isRenderEnabled | SceneObject |
isSelectable | ForestWindEmitter | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
radialEmitter | ForestWindEmitter |
radius | ForestWindEmitter |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
strength | ForestWindEmitter |
superClass | SimObject |
turbulenceFrequency | ForestWindEmitter |
turbulenceStrength | ForestWindEmitter |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
windEnabled | ForestWindEmitter |


Torque 3D - Script Manual: Member List

fxFoliageReplicator Member List

This is the complete list of members for fxFoliageReplicator, including all inherited members.
AllowedTerrainSlope | fxFoliageReplicator |
AllowOnInteriors | fxFoliageReplicator |
AllowOnStatics | fxFoliageReplicator |
AllowOnTerrain | fxFoliageReplicator |
AllowOnWater | fxFoliageReplicator |
AllowWaterSurface | fxFoliageReplicator |
AlphaCutoff | fxFoliageReplicator |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
CullResolution | fxFoliageReplicator |
DebugBoxHeight | fxFoliageReplicator |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
FadeInRegion | fxFoliageReplicator |
FadeOutRegion | fxFoliageReplicator |
FixAspectRatio | fxFoliageReplicator |
FixSizeToMax | fxFoliageReplicator |
FoliageCount | fxFoliageReplicator |
FoliageFile | fxFoliageReplicator |
FoliageRetries | fxFoliageReplicator |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
GroundAlpha | fxFoliageReplicator |
hidden | SimObject |
HideFoliage | fxFoliageReplicator |
InnerRadiusX | fxFoliageReplicator |
InnerRadiusY | fxFoliageReplicator |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | fxFoliageReplicator | [static]
isRenderEnabled | SceneObject |
isSelectable | fxFoliageReplicator | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
LightOn | fxFoliageReplicator |
LightSync | fxFoliageReplicator |
LightTime | fxFoliageReplicator |
locked | SimObject |
MaxHeight | fxFoliageReplicator |
MaxLuminance | fxFoliageReplicator |
MaxSwayTime | fxFoliageReplicator |
MaxWidth | fxFoliageReplicator |
MinHeight | fxFoliageReplicator |
MinLuminance | fxFoliageReplicator |
MinSwayTime | fxFoliageReplicator |
MinWidth | fxFoliageReplicator |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
OffsetZ | fxFoliageReplicator |
OuterRadiusX | fxFoliageReplicator |
OuterRadiusY | fxFoliageReplicator |
parentGroup | SimObject |
persistentId | SimObject |
PlacementAreaHeight | fxFoliageReplicator |
PlacementColour | fxFoliageReplicator |
position | SceneObject |
RandomFlip | fxFoliageReplicator |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
seed | fxFoliageReplicator |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
ShowPlacementArea | fxFoliageReplicator |
superClass | SimObject |
SwayMagFront | fxFoliageReplicator |
SwayMagSide | fxFoliageReplicator |
SwayOn | fxFoliageReplicator |
SwaySync | fxFoliageReplicator |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
UseCulling | fxFoliageReplicator |
UseDebugInfo | fxFoliageReplicator |
useTrueBillboards | fxFoliageReplicator |
ViewClosest | fxFoliageReplicator |
ViewDistance | fxFoliageReplicator |


Torque 3D - Script Manual: Member List

fxShapeReplicatedStatic Member List

This is the complete list of members for fxShapeReplicatedStatic, including all inherited members.
allowPlayerStep | fxShapeReplicatedStatic |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
collisionType | fxShapeReplicatedStatic |
decalType | fxShapeReplicatedStatic |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
forceDetail | fxShapeReplicatedStatic |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | fxShapeReplicatedStatic | [static]
isRenderEnabled | SceneObject |
isSelectable | fxShapeReplicatedStatic | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
meshCulling | fxShapeReplicatedStatic |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
originSort | fxShapeReplicatedStatic |
parentGroup | SimObject |
persistentId | SimObject |
playAmbient | fxShapeReplicatedStatic |
position | SceneObject |
renderNormals | fxShapeReplicatedStatic |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shapeName | fxShapeReplicatedStatic |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

fxShapeReplicator Member List

This is the complete list of members for fxShapeReplicator, including all inherited members.
AlignToTerrain | fxShapeReplicator |
AllowedTerrainSlope | fxShapeReplicator |
AllowOnInteriors | fxShapeReplicator |
AllowOnStatics | fxShapeReplicator |
AllowOnTerrain | fxShapeReplicator |
AllowOnWater | fxShapeReplicator |
AllowWaterSurface | fxShapeReplicator |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
HideReplications | fxShapeReplicator |
InnerRadiusX | fxShapeReplicator |
InnerRadiusY | fxShapeReplicator |
Interactions | fxShapeReplicator |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | fxShapeReplicator | [static]
isRenderEnabled | SceneObject |
isSelectable | fxShapeReplicator | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
OffsetZ | fxShapeReplicator |
OuterRadiusX | fxShapeReplicator |
OuterRadiusY | fxShapeReplicator |
parentGroup | SimObject |
persistentId | SimObject |
PlacementAreaHeight | fxShapeReplicator |
PlacementColour | fxShapeReplicator |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
seed | fxShapeReplicator |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
ShapeCount | fxShapeReplicator |
shapeFile | fxShapeReplicator |
ShapeRetries | fxShapeReplicator |
ShapeRotateMax | fxShapeReplicator |
ShapeRotateMin | fxShapeReplicator |
ShapeScaleMax | fxShapeReplicator |
ShapeScaleMin | fxShapeReplicator |
ShowPlacementArea | fxShapeReplicator |
superClass | SimObject |
TerrainAlignment | fxShapeReplicator |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

GameBase Member List

This is the complete list of members for GameBase, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | GameBase | [static]
isRenderEnabled | SceneObject |
isSelectable | GameBase | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

GameBaseData Member List

This is the complete list of members for GameBaseData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

GameConnection Member List

This is the complete list of members for GameConnection, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet |
activateGhosting() | GameConnection |
add(SimObject objects...) | SimSet |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
bringToFront(SimObject obj) | SimSet |
call(string method, string args...) | SimObject |
callOnChildren(string method, string args...) | SimSet |
callOnChildrenNoRecurse(string method, string args...) | SimSet |
canSave | SimObject |
canSaveDynamicFields | SimObject |
chaseCam(int size) | GameConnection |
checkMaxRate() | NetConnection |
class | SimObject |
className | SimObject |
clear() | SimSet |
clearCameraObject() | GameConnection |
clearPaths() | NetConnection |
clone() | SimObject |
connect(string remoteAddress) | NetConnection |
connectLocal() | NetConnection |
deepClone() | SimObject |
delete(string reason="") | GameConnection |
NetConnection::delete() | SimObject |
deleteAllObjects() | SimSet |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet |
getAddress() | NetConnection |
getCameraObject() | GameConnection |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getControlCameraDefaultFov() | GameConnection |
getControlCameraFov() | GameConnection |
getControlObject() | GameConnection |
getCount() | SimSet |
getDamageFlash() | GameConnection |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getFullCount() | SimSet |
getGhostID(int realID) | NetConnection |
getGhostsActive() | NetConnection |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getName() | SimObject |
getObject(int index) | SimSet |
getObjectIndex(SimObject obj) | SimSet |
getPacketLoss() | NetConnection |
getPing() | NetConnection |
getRandom() | SimSet |
getServerConnection() | GameConnection | [static]
getSuperClassNamespace() | SimObject |
getWhiteOut() | GameConnection |
hidden | SimObject |
initialControlSet() | GameConnection |
internalName | SimObject |
isAIControlled() | GameConnection |
isChildOfGroup(SimGroup group) | SimObject |
isControlObjectRotDampedCamera() | GameConnection |
isDemoPlaying() | GameConnection |
isDemoRecording() | GameConnection |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isFirstPerson() | GameConnection |
isInNamespaceHierarchy(string name) | SimObject |
isMember(SimObject obj) | SimSet |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
listClassIDs() | GameConnection |
listObjects() | SimSet |
locked | SimObject |
name | SimObject |
onConnectionAccepted() | GameConnection |
onConnectionDropped(string reason) | GameConnection |
onConnectionError(string errorString) | GameConnection |
onConnectionTimedOut() | GameConnection |
onConnectRequestRejected(string reason) | GameConnection |
onConnectRequestTimedOut() | GameConnection |
onDataBlocksDone(int sequence) | GameConnection |
onDrop(string disconnectReason) | GameConnection |
onFlash(bool state) | GameConnection |
onObjectAdded(SimObject object) | SimSet |
onObjectRemoved(SimObject object) | SimSet |
parentGroup | SimObject |
persistentId | SimObject |
play2D(SFXProfile profile) | GameConnection |
play3D(SFXProfile profile, TransformF location) | GameConnection |
playDemo(string demoFileName) | GameConnection |
pushToBack(SimObject obj) | SimSet |
remove(SimObject objects...) | SimSet |
reorderChild(SimObject child1, SimObject child2) | SimSet |
resetGhosting() | GameConnection |
resolveGhostID(int ghostID) | NetConnection |
resolveObjectFromGhostIndex(int ghostID) | NetConnection |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
schedule(float time, string method, string args...) | SimObject |
setBlackOut(bool doFade, int timeMS) | GameConnection |
setCameraObject(GameBase camera) | GameConnection |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setConnectArgs(const char *args) | GameConnection |
setControlCameraFov(float newFOV) | GameConnection |
setControlObject(GameBase ctrlObj) | GameConnection |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setFirstPerson(bool firstPerson) | GameConnection |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setJoinPassword(string password) | GameConnection |
setLagIcon(bool state) | GameConnection |
setLocked(bool value=true) | SimObject |
setMissionCRC(int CRC) | GameConnection |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setSimulatedNetParams(float packetLoss, int delay) | NetConnection |
setSuperClassNamespace(string name) | SimObject |
sort(string callbackFunction) | SimSet |
startRecording(string fileName) | GameConnection |
stopRecording() | GameConnection |
superClass | SimObject |
transmitDataBlocks(int sequence) | GameConnection |
transmitPaths() | NetConnection |


Torque 3D - Script Manual: Member List

GameTSCtrl Member List

This is the complete list of members for GameTSCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
calculateViewDistance(float radius) | GuiTSCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
cameraZRot | GuiTSCtrl
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
forceFOV | GuiTSCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
getWorldToScreenScale() | GuiTSCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
project(Point3F worldPosition) | GuiTSCtrl
pushToBack(SimObject obj) | SimSet
reflectPriority | GuiTSCtrl
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
unproject(Point3F screenPosition) | GuiTSCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GFXCardProfilerAPI Member List

This is the complete list of members for GFXCardProfilerAPI, including all inherited members.
getCard() | GFXCardProfilerAPI | [static]
getRenderer() | GFXCardProfilerAPI | [static]
getVendor() | GFXCardProfilerAPI | [static]
getVersion() | GFXCardProfilerAPI | [static]
getVideoMemoryMB() | GFXCardProfilerAPI | [static]
queryProfile(string name, int defaultValue) | GFXCardProfilerAPI | [static]
setCapability(string name, int value) | GFXCardProfilerAPI | [static]


Torque 3D - Script Manual: Member List

GFXInit Member List

This is the complete list of members for GFXInit, including all inherited members.
createNullDevice() | GFXInit | [static]
getAdapterCount() | GFXInit | [static]
getAdapterMode(int index, int modeIndex) | GFXInit | [static]
getAdapterModeCount(int index) | GFXInit | [static]
getAdapterName(int index) | GFXInit | [static]
getAdapterShaderModel(int index) | GFXInit | [static]
getAdapterType(int index) | GFXInit | [static]
getDefaultAdapterIndex() | GFXInit | [static]


Torque 3D - Script Manual: Member List

GFXSamplerStateData Member List

This is the complete list of members for GFXSamplerStateData, including all inherited members.
addressModeU | GFXSamplerStateData
addressModeV | GFXSamplerStateData
addressModeW | GFXSamplerStateData
alphaArg1 | GFXSamplerStateData
alphaArg2 | GFXSamplerStateData
alphaArg3 | GFXSamplerStateData
alphaOp | GFXSamplerStateData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
colorArg1 | GFXSamplerStateData
colorArg2 | GFXSamplerStateData
colorArg3 | GFXSamplerStateData
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
magFilter | GFXSamplerStateData
maxAnisotropy | GFXSamplerStateData
minFilter | GFXSamplerStateData
mipFilter | GFXSamplerStateData
mipLODBias | GFXSamplerStateData
name | SimObject
parentGroup | SimObject
persistentId | SimObject
resultArg | GFXSamplerStateData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
textureColorOp | GFXSamplerStateData
textureTransform | GFXSamplerStateData


Torque 3D - Script Manual: Member List

GFXStateBlockData Member List

This is the complete list of members for GFXStateBlockData, including all inherited members.
alphaDefined | GFXStateBlockData
alphaTestEnable | GFXStateBlockData
alphaTestFunc | GFXStateBlockData
alphaTestRef | GFXStateBlockData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
blendDefined | GFXStateBlockData
blendDest | GFXStateBlockData
blendEnable | GFXStateBlockData
blendOp | GFXStateBlockData
blendSrc | GFXStateBlockData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
colorWriteAlpha | GFXStateBlockData
colorWriteBlue | GFXStateBlockData
colorWriteDefined | GFXStateBlockData
colorWriteGreen | GFXStateBlockData
colorWriteRed | GFXStateBlockData
cullDefined | GFXStateBlockData
cullMode | GFXStateBlockData
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
ffLighting | GFXStateBlockData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
samplersDefined | GFXStateBlockData
samplerStates | GFXStateBlockData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
separateAlphaBlendDefined | GFXStateBlockData
separateAlphaBlendDest | GFXStateBlockData
separateAlphaBlendEnable | GFXStateBlockData
separateAlphaBlendOp | GFXStateBlockData
separateAlphaBlendSrc | GFXStateBlockData
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
stencilDefined | GFXStateBlockData
stencilEnable | GFXStateBlockData
stencilFailOp | GFXStateBlockData
stencilFunc | GFXStateBlockData
stencilMask | GFXStateBlockData
stencilPassOp | GFXStateBlockData
stencilRef | GFXStateBlockData
stencilWriteMask | GFXStateBlockData
stencilZFailOp | GFXStateBlockData
superClass | SimObject
textureFactor | GFXStateBlockData
vertexColorEnable | GFXStateBlockData
zBias | GFXStateBlockData
zDefined | GFXStateBlockData
zEnable | GFXStateBlockData
zFunc | GFXStateBlockData
zSlopeBias | GFXStateBlockData
zWriteEnable | GFXStateBlockData


Torque 3D - Script Manual: Member List

GroundCover Member List

This is the complete list of members for GroundCover, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
billboardUVs | GroundCover |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
clumpExponent | GroundCover |
clumpRadius | GroundCover |
deepClone() | SimObject |
delete() | SimObject |
dissolveRadius | GroundCover |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
gridSize | GroundCover |
hidden | SimObject |
internalName | SimObject |
invertLayer | GroundCover |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | GroundCover | [static]
isRenderEnabled | SceneObject |
isSelectable | GroundCover | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
layer | GroundCover |
locked | SimObject |
lockFrustum | GroundCover |
Material | GroundCover |
maxBillboardTiltAngle | GroundCover |
maxClumpCount | GroundCover |
maxElements | GroundCover |
maxElevation | GroundCover |
maxSlope | GroundCover |
minClumpCount | GroundCover |
minElevation | GroundCover |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
noBillboards | GroundCover |
noShapes | GroundCover |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
probability | GroundCover |
radius | GroundCover |
reflectScale | GroundCover |
renderCells | GroundCover |
renderedBatches | GroundCover | [static]
renderedBillboards | GroundCover | [static]
renderedCells | GroundCover | [static]
renderedShapes | GroundCover | [static]
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
seed | GroundCover |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shapeCullRadius | GroundCover |
shapeFilename | GroundCover |
shapesCastShadows | GroundCover |
sizeExponent | GroundCover |
sizeMax | GroundCover |
sizeMin | GroundCover |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
windDirection | GroundCover |
windGustFrequency | GroundCover |
windGustLength | GroundCover |
windGustStrength | GroundCover |
windScale | GroundCover |
windTurbulenceFrequency | GroundCover |
windTurbulenceStrength | GroundCover |
zOffset | GroundCover |


Torque 3D - Script Manual: Member List

GroundPlane Member List

This is the complete list of members for GroundPlane, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | GroundPlane | [static]
isRenderEnabled | SceneObject |
isSelectable | GroundPlane | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
Material | GroundPlane |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
postApply() | GroundPlane |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
scaleU | GroundPlane |
scaleV | GroundPlane |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
squareSize | GroundPlane |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

GuiAutoScrollCtrl Member List

This is the complete list of members for GuiAutoScrollCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
childBorder | GuiAutoScrollCtrl
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isLooping | GuiAutoScrollCtrl
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onComplete() | GuiAutoScrollCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onReset() | GuiAutoScrollCtrl
onSleep() | GuiControl
onStart() | GuiAutoScrollCtrl
onTick() | GuiAutoScrollCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
reset() | GuiAutoScrollCtrl
resetDelay | GuiAutoScrollCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scrollDirection | GuiAutoScrollCtrl
scrollOutOfSight | GuiAutoScrollCtrl
scrollSpeed | GuiAutoScrollCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProcessTicks(bool tick) void setProcessTicks([tick | GuiTickCtrl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
startDelay | GuiAutoScrollCtrl
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiBitmapBorderCtrl Member List

This is the complete list of members for GuiBitmapBorderCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiBitmapButtonCtrl Member List

This is the complete list of members for GuiBitmapButtonCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoFitExtents | GuiBitmapButtonCtrl
bitmap | GuiBitmapButtonCtrl
bitmapMode | GuiBitmapButtonCtrl
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onAltClick() | GuiBitmapButtonCtrl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onCtrlClick() | GuiBitmapButtonCtrl
onDefaultClick() | GuiBitmapButtonCtrl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onShiftClick() | GuiBitmapButtonCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(string path) | GuiBitmapButtonCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useModifiers | GuiBitmapButtonCtrl
useMouseEvents | GuiButtonBaseCtrl
useStates | GuiBitmapButtonCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiBitmapButtonTextCtrl Member List

This is the complete list of members for GuiBitmapButtonTextCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoFitExtents | GuiBitmapButtonCtrl
bitmap | GuiBitmapButtonCtrl
bitmapMode | GuiBitmapButtonCtrl
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onAltClick() | GuiBitmapButtonCtrl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onCtrlClick() | GuiBitmapButtonCtrl
onDefaultClick() | GuiBitmapButtonCtrl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onShiftClick() | GuiBitmapButtonCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(string path) | GuiBitmapButtonCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useModifiers | GuiBitmapButtonCtrl
useMouseEvents | GuiButtonBaseCtrl
useStates | GuiBitmapButtonCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiBitmapCtrl Member List

This is the complete list of members for GuiBitmapCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiBitmapCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(String filename) | GuiBitmapCtrl
setBitmap(String filename, bool resize) | GuiBitmapCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(int x, int y) | GuiBitmapCtrl
GuiControl::setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl
wrap | GuiBitmapCtrl


Torque 3D - Script Manual: Member List

GuiBorderButtonCtrl Member List

This is the complete list of members for GuiBorderButtonCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiBubbleTextCtrl Member List

This is the complete list of members for GuiBubbleTextCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiButtonBaseCtrl Member List

This is the complete list of members for GuiButtonBaseCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiButtonCtrl Member List

This is the complete list of members for GuiButtonCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiCanvas Member List

This is the complete list of members for GuiCanvas, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
alwaysHandleMouseButtons | GuiCanvas
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clientToScreen(Point2I coordinate) | GuiCanvas
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
cursorOff() | GuiCanvas
cursorOn() | GuiCanvas
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getContent() | GuiCanvas
getCount() | SimSet
getCursorPos() | GuiCanvas
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiCanvas
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getMode(int modeId) | GuiCanvas
getModeCount() | GuiCanvas
getMouseControl() | GuiCanvas
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
getVideoMode() | GuiCanvas
getWindowPosition() | GuiCanvas
hidden | SimObject
hideCursor() | GuiCanvas
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isCursorOn() | GuiCanvas
isCursorShown() | GuiCanvas
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isFullscreen() | GuiCanvas
isInNamespaceHierarchy(string name) | SimObject
isMaximized() | GuiCanvas
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMinimized() | GuiCanvas
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
maximizeWindow() | GuiCanvas
minExtent | GuiControl
minimizeWindow() | GuiCanvas
modal | GuiControl
name | SimObject
numFences | GuiCanvas
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
popDialog() | GuiCanvas
popDialog(GuiControl ctrl) | GuiCanvas
popLayer(S32 layer) | GuiCanvas
popLayer() | GuiCanvas
position | GuiControl
profile | GuiControl
pushDialog(GuiControl ctrl, int layer=0, bool center=false) | GuiCanvas
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
renderFront(bool enable) | GuiCanvas
reorderChild(SimObject child1, SimObject child2) | SimSet
repaint(int elapsedMS=0) | GuiCanvas
reset() | GuiCanvas
resize(int x, int y, int width, int height) | GuiControl
restoreWindow() | GuiCanvas
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
screenToClient(Point2I coordinate) | GuiCanvas
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setContent(GuiControl ctrl) | GuiCanvas
setCursor(GuiCursor cursor) | GuiCanvas
setCursorPos(F32 posX, F32 posY) | GuiCanvas
setCursorPos(Point2I pos) | GuiCanvas
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setFocus() | GuiCanvas
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVideoMode(int width, int height, bool fullscreen,[int bitDepth],[int refreshRate],[int antialiasLevel]) | GuiCanvas
setVisible(bool state=true) | GuiControl
setWindowPosition(Point2I position) | GuiCanvas
setWindowTitle(string newTitle) | GuiCanvas
showCursor() | GuiCanvas
sort(string callbackFunction) | SimSet
superClass | SimObject
toggleFullscreen() | GuiCanvas
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiCheckBoxCtrl Member List

This is the complete list of members for GuiCheckBoxCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isStateOn() | GuiCheckBoxCtrl
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool newState) | GuiCheckBoxCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiChunkedBitmapCtrl Member List

This is the complete list of members for GuiChunkedBitmapCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiChunkedBitmapCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(string filename) | GuiChunkedBitmapCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tile | GuiChunkedBitmapCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useVariable | GuiChunkedBitmapCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiClockHud Member List

This is the complete list of members for GuiClockHud, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
fillColor | GuiClockHud
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
frameColor | GuiClockHud
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getTime() | GuiClockHud
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setTime(float timeInSeconds=60) | GuiClockHud
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
showFill | GuiClockHud
showFrame | GuiClockHud
sort(string callbackFunction) | SimSet
superClass | SimObject
textColor | GuiClockHud
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiConsole Member List

This is the complete list of members for GuiConsole, including all inherited members.
onMessageSelected(ConsoleLogEntry::Level level, string message) GuiConsole


Torque 3D - Script Manual: Member List

GuiConsoleEditCtrl Member List

This is the complete list of members for GuiConsoleEditCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clearSelectedText() | GuiTextEditCtrl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deniedSound | GuiTextEditCtrl
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
escapeCommand | GuiTextEditCtrl
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
forceValidateText() | GuiTextEditCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getCursorPos() | GuiTextEditCtrl
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiTextEditCtrl
getValue | GuiControl
hidden | SimObject
historySize | GuiTextEditCtrl
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAllTextSelected() | GuiTextEditCtrl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onReturn() | GuiTextEditCtrl
onSleep() | GuiControl
onTabComplete(string val) | GuiTextEditCtrl
onValidate() | GuiTextEditCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
password | GuiTextEditCtrl
passwordMask | GuiTextEditCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
selectAllText() | GuiTextEditCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCursorPos(int position) | GuiTextEditCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextEditCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sinkAllKeyEvents | GuiTextEditCtrl
sort(string callbackFunction) | SimSet
superClass | SimObject
tabComplete | GuiTextEditCtrl
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useSiblingScroller | GuiConsoleEditCtrl
validate | GuiTextEditCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiContainer Member List

This is the complete list of members for GuiContainer, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiControl Member List

This is the complete list of members for GuiControl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiControlArrayControl Member List

This is the complete list of members for GuiControlArrayControl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
colCount | GuiControlArrayControl
colSizes | GuiControlArrayControl
colSpacing | GuiControlArrayControl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
rowSize | GuiControlArrayControl
rowSpacing | GuiControlArrayControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiControlProfile Member List

This is the complete list of members for GuiControlProfile, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoSizeHeight | GuiControlProfile
autoSizeWidth | GuiControlProfile
bevelColorHL | GuiControlProfile
bevelColorLL | GuiControlProfile
bitmap | GuiControlProfile
border | GuiControlProfile
borderColor | GuiControlProfile
borderColorHL | GuiControlProfile
borderColorNA | GuiControlProfile
borderThickness | GuiControlProfile
call(string method, string args...) | SimObject
canKeyFocus | GuiControlProfile
canSave | SimObject
canSaveDynamicFields | SimObject
category | GuiControlProfile
class | SimObject
className | SimObject
clone() | SimObject
cursorColor | GuiControlProfile
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fillColor | GuiControlProfile
fillColorHL | GuiControlProfile
fillColorNA | GuiControlProfile
fillColorSEL | GuiControlProfile
fontCharset | GuiControlProfile
fontColor | GuiControlProfile
fontColorHL | GuiControlProfile
fontColorLink | GuiControlProfile
fontColorLinkHL | GuiControlProfile
fontColorNA | GuiControlProfile
fontColors | GuiControlProfile
fontColorSEL | GuiControlProfile
fontSize | GuiControlProfile
fontType | GuiControlProfile
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getStringWidth(pString) | GuiControlProfile
getSuperClassNamespace() | SimObject
hasBitmapArray | GuiControlProfile
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
justify | GuiControlProfile
locked | SimObject
modal | GuiControlProfile
mouseOverSelected | GuiControlProfile
name | SimObject
numbersOnly | GuiControlProfile
opaque | GuiControlProfile
parentGroup | SimObject
persistentId | SimObject
profileForChildren | GuiControlProfile
returnTab | GuiControlProfile
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
soundButtonDown | GuiControlProfile
soundButtonOver | GuiControlProfile
superClass | SimObject
tab | GuiControlProfile
textOffset | GuiControlProfile


Torque 3D - Script Manual: Member List

GuiCrossHairHud Member List

This is the complete list of members for GuiCrossHairHud, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiBitmapCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
damageFillColor | GuiCrossHairHud
damageFrameColor | GuiCrossHairHud
damageOffset | GuiCrossHairHud
damageRect | GuiCrossHairHud
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(String filename) | GuiBitmapCtrl
setBitmap(String filename, bool resize) | GuiBitmapCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(int x, int y) | GuiBitmapCtrl
GuiControl::setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl
wrap | GuiBitmapCtrl


Torque 3D - Script Manual: Member List

GuiCursor Member List

This is the complete list of members for GuiCursor, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmapName | GuiCursor
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
hotSpot | GuiCursor
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
renderOffset | GuiCursor
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

GuiDirectoryFileListCtrl Member List

This is the complete list of members for GuiDirectoryFileListCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addFilteredItem(string newItem) | GuiListBoxCtrl
addGuiControl(GuiControl control) | GuiControl
allowMultipleSelections | GuiListBoxCtrl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clearItemColor(int index) | GuiListBoxCtrl
clearItems() | GuiListBoxCtrl
clearSelection() | GuiListBoxCtrl
clone() | SimObject
colorBullet | GuiListBoxCtrl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deleteItem(int itemIndex) | GuiListBoxCtrl
doMirror() | GuiListBoxCtrl
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
fileFilter | GuiDirectoryFileListCtrl
filePath | GuiDirectoryFileListCtrl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findItemText(string findText, bool bCaseSensitive=false) | GuiListBoxCtrl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
fitParentWidth | GuiListBoxCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getItemCount() | GuiListBoxCtrl
getItemObject(int index) | GuiListBoxCtrl
getItemText(int index) | GuiListBoxCtrl
getLastClickItem() | GuiListBoxCtrl
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSelCount() | GuiListBoxCtrl
getSelectedFile() | GuiDirectoryFileListCtrl
getSelectedFiles() | GuiDirectoryFileListCtrl
getSelectedItem() | GuiListBoxCtrl
getSelectedItems() | GuiListBoxCtrl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
insertItem(string text, int index) | GuiListBoxCtrl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isObjectMirrored(string indexIdString) | GuiListBoxCtrl
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
makeNameCallback | GuiListBoxCtrl
minExtent | GuiControl
mirrorSet | GuiListBoxCtrl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClearSelection() | GuiListBoxCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDeleteKey() | GuiListBoxCtrl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiListBoxCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDragged() | GuiListBoxCtrl
onMouseUp(string itemHit, string mouseClickCount) | GuiListBoxCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSelect(string index, string itemText) | GuiListBoxCtrl
onSleep() | GuiControl
onUnselect(string index, string itemText) | GuiListBoxCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
reload() | GuiDirectoryFileListCtrl
remove(SimObject objects...) | SimSet
removeFilteredItem(string itemName) | GuiListBoxCtrl
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCurSel(int indexId) | GuiListBoxCtrl
setCurSelRange(int indexStart, int indexStop=999999) | GuiListBoxCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFilter(string filter) | GuiDirectoryFileListCtrl
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setItemColor(int index, ColorF color) | GuiListBoxCtrl
setItemText(int index, string newtext) | GuiListBoxCtrl
setItemTooltip(int index, string text) | GuiListBoxCtrl
setLocked(bool value=true) | SimObject
setMultipleSelection(bool allowMultSelections) | GuiListBoxCtrl
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPath(string path, string filter) | GuiDirectoryFileListCtrl
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSelected(int index, bool setSelected=true) | GuiListBoxCtrl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiDragAndDropControl Member List

This is the complete list of members for GuiDragAndDropControl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deleteOnMouseUp | GuiDragAndDropControl
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
startDragging(int x=0, int y=0) | GuiDragAndDropControl
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiDynamicCtrlArrayControl Member List

This is the complete list of members for GuiDynamicCtrlArrayControl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoCellSize | GuiDynamicCtrlArrayControl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
colCount | GuiDynamicCtrlArrayControl
colSize | GuiDynamicCtrlArrayControl
colSpacing | GuiDynamicCtrlArrayControl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dynamicSize | GuiDynamicCtrlArrayControl
extent | GuiControl
fillRowFirst | GuiDynamicCtrlArrayControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
frozen | GuiDynamicCtrlArrayControl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiDynamicCtrlArrayControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
refresh() | GuiDynamicCtrlArrayControl
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
rowCount | GuiDynamicCtrlArrayControl
rowSize | GuiDynamicCtrlArrayControl
rowSpacing | GuiDynamicCtrlArrayControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiFadeinBitmapCtrl Member List

This is the complete list of members for GuiFadeinBitmapCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiBitmapCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
click() | GuiFadeinBitmapCtrl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
done | GuiFadeinBitmapCtrl
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
fadeColor | GuiFadeinBitmapCtrl
fadeInEase | GuiFadeinBitmapCtrl
fadeInTime | GuiFadeinBitmapCtrl
fadeOutEase | GuiFadeinBitmapCtrl
fadeOutTime | GuiFadeinBitmapCtrl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDone() | GuiFadeinBitmapCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(String filename) | GuiBitmapCtrl
setBitmap(String filename, bool resize) | GuiBitmapCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(int x, int y) | GuiBitmapCtrl
GuiControl::setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl
waitTime | GuiFadeinBitmapCtrl
wrap | GuiBitmapCtrl


Torque 3D - Script Manual: Member List

GuiFrameSetCtrl Member List

This is the complete list of members for GuiFrameSetCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addColumn() | GuiFrameSetCtrl
addGuiControl(GuiControl control) | GuiControl
addRow() | GuiFrameSetCtrl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoBalance | GuiFrameSetCtrl
borderColor | GuiFrameSetCtrl
borderEnable | GuiFrameSetCtrl
borderMovable | GuiFrameSetCtrl
borderWidth | GuiFrameSetCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
columns | GuiFrameSetCtrl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
frameBorder(int index, string state="dynamic") | GuiFrameSetCtrl
frameMinExtent(int index, int width, int height) | GuiFrameSetCtrl
frameMovable(int index, string state="dynamic") | GuiFrameSetCtrl
framePadding(int index, RectSpacingI padding) | GuiFrameSetCtrl
fudgeFactor | GuiFrameSetCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getColumnCount() | GuiFrameSetCtrl
getColumnOffset(int index) | GuiFrameSetCtrl
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFramePadding(int index) | GuiFrameSetCtrl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getRowCount() | GuiFrameSetCtrl
getRowOffset(int index) | GuiFrameSetCtrl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeColumn() | GuiFrameSetCtrl
removeRow() | GuiFrameSetCtrl
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
rows | GuiFrameSetCtrl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setColumnOffset(int index, int offset) | GuiFrameSetCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setRowOffset(int index, int offset) | GuiFrameSetCtrl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
updateSizes() | GuiFrameSetCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiGameListMenuCtrl Member List

This is the complete list of members for GuiGameListMenuCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
activateRow() | GuiGameListMenuCtrl
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
addRow(string label, string callback, int icon=-1, int yPad=0, bool useHighlightIcon=true, bool enabled=true) | GuiGameListMenuCtrl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callbackOnA | GuiGameListMenuCtrl
callbackOnB | GuiGameListMenuCtrl
callbackOnX | GuiGameListMenuCtrl
callbackOnY | GuiGameListMenuCtrl
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
debugRender | GuiGameListMenuCtrl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getRowCount() | GuiGameListMenuCtrl
getRowLabel(int row) | GuiGameListMenuCtrl
getSelectedRow() | GuiGameListMenuCtrl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isRowEnabled(int row) | GuiGameListMenuCtrl
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onChange() | GuiGameListMenuCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setRowEnabled(int row, bool enabled) | GuiGameListMenuCtrl
setRowLabel(int row, string label) | GuiGameListMenuCtrl
setSelected(int row) | GuiGameListMenuCtrl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiGameListMenuProfile Member List

This is the complete list of members for GuiGameListMenuProfile, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoSizeHeight | GuiControlProfile
autoSizeWidth | GuiControlProfile
bevelColorHL | GuiControlProfile
bevelColorLL | GuiControlProfile
bitmap | GuiControlProfile
border | GuiControlProfile
borderColor | GuiControlProfile
borderColorHL | GuiControlProfile
borderColorNA | GuiControlProfile
borderThickness | GuiControlProfile
call(string method, string args...) | SimObject
canKeyFocus | GuiControlProfile
canSave | SimObject
canSaveDynamicFields | SimObject
category | GuiControlProfile
class | SimObject
className | SimObject
clone() | SimObject
cursorColor | GuiControlProfile
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fillColor | GuiControlProfile
fillColorHL | GuiControlProfile
fillColorNA | GuiControlProfile
fillColorSEL | GuiControlProfile
fontCharset | GuiControlProfile
fontColor | GuiControlProfile
fontColorHL | GuiControlProfile
fontColorLink | GuiControlProfile
fontColorLinkHL | GuiControlProfile
fontColorNA | GuiControlProfile
fontColors | GuiControlProfile
fontColorSEL | GuiControlProfile
fontSize | GuiControlProfile
fontType | GuiControlProfile
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getStringWidth(pString) | GuiControlProfile
getSuperClassNamespace() | SimObject
hasBitmapArray | GuiControlProfile
hidden | SimObject
hitAreaLowerRight | GuiGameListMenuProfile
hitAreaUpperLeft | GuiGameListMenuProfile
iconOffset | GuiGameListMenuProfile
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
justify | GuiControlProfile
locked | SimObject
modal | GuiControlProfile
mouseOverSelected | GuiControlProfile
name | SimObject
numbersOnly | GuiControlProfile
opaque | GuiControlProfile
parentGroup | SimObject
persistentId | SimObject
profileForChildren | GuiControlProfile
returnTab | GuiControlProfile
rowSize | GuiGameListMenuProfile
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
soundButtonDown | GuiControlProfile
soundButtonOver | GuiControlProfile
superClass | SimObject
tab | GuiControlProfile
textOffset | GuiControlProfile


Torque 3D - Script Manual: Member List

GuiGameListOptionsCtrl Member List

This is the complete list of members for GuiGameListOptionsCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
activateRow() | GuiGameListMenuCtrl
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
addRow(string label, string options, bool wrapOptions, string callback, int icon=-1, int yPad=0, bool enabled=true) | GuiGameListOptionsCtrl
GuiGameListMenuCtrl::addRow(string label, string callback, int icon=-1, int yPad=0, bool useHighlightIcon=true, bool enabled=true) | GuiGameListMenuCtrl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callbackOnA | GuiGameListMenuCtrl
callbackOnB | GuiGameListMenuCtrl
callbackOnX | GuiGameListMenuCtrl
callbackOnY | GuiGameListMenuCtrl
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
debugRender | GuiGameListMenuCtrl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getCurrentOption(int row) | GuiGameListOptionsCtrl
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getRowCount() | GuiGameListMenuCtrl
getRowLabel(int row) | GuiGameListMenuCtrl
getSelectedRow() | GuiGameListMenuCtrl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isRowEnabled(int row) | GuiGameListMenuCtrl
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onChange() | GuiGameListMenuCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
selectOption(int row, string option) | GuiGameListOptionsCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setOptions(int row, string optionsList) | GuiGameListOptionsCtrl
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setRowEnabled(int row, bool enabled) | GuiGameListMenuCtrl
setRowLabel(int row, string label) | GuiGameListMenuCtrl
setSelected(int row) | GuiGameListMenuCtrl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiGameListOptionsProfile Member List

This is the complete list of members for GuiGameListOptionsProfile, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoSizeHeight | GuiControlProfile
autoSizeWidth | GuiControlProfile
bevelColorHL | GuiControlProfile
bevelColorLL | GuiControlProfile
bitmap | GuiControlProfile
border | GuiControlProfile
borderColor | GuiControlProfile
borderColorHL | GuiControlProfile
borderColorNA | GuiControlProfile
borderThickness | GuiControlProfile
call(string method, string args...) | SimObject
canKeyFocus | GuiControlProfile
canSave | SimObject
canSaveDynamicFields | SimObject
category | GuiControlProfile
class | SimObject
className | SimObject
clone() | SimObject
columnSplit | GuiGameListOptionsProfile
cursorColor | GuiControlProfile
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fillColor | GuiControlProfile
fillColorHL | GuiControlProfile
fillColorNA | GuiControlProfile
fillColorSEL | GuiControlProfile
fontCharset | GuiControlProfile
fontColor | GuiControlProfile
fontColorHL | GuiControlProfile
fontColorLink | GuiControlProfile
fontColorLinkHL | GuiControlProfile
fontColorNA | GuiControlProfile
fontColors | GuiControlProfile
fontColorSEL | GuiControlProfile
fontSize | GuiControlProfile
fontType | GuiControlProfile
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getStringWidth(pString) | GuiControlProfile
getSuperClassNamespace() | SimObject
hasBitmapArray | GuiControlProfile
hidden | SimObject
hitAreaLowerRight | GuiGameListMenuProfile
hitAreaUpperLeft | GuiGameListMenuProfile
iconOffset | GuiGameListMenuProfile
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
justify | GuiControlProfile
locked | SimObject
modal | GuiControlProfile
mouseOverSelected | GuiControlProfile
name | SimObject
numbersOnly | GuiControlProfile
opaque | GuiControlProfile
parentGroup | SimObject
persistentId | SimObject
profileForChildren | GuiControlProfile
returnTab | GuiControlProfile
rightPad | GuiGameListOptionsProfile
rowSize | GuiGameListMenuProfile
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
soundButtonDown | GuiControlProfile
soundButtonOver | GuiControlProfile
superClass | SimObject
tab | GuiControlProfile
textOffset | GuiControlProfile


Torque 3D - Script Manual: Member List

GuiGraphCtrl Member List

This is the complete list of members for GuiGraphCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addAutoPlot(int plotId, string variable, int updateFrequency) | GuiGraphCtrl
addDatum(int plotId, float value) | GuiGraphCtrl
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
centerY | GuiGraphCtrl
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDatum(int plotId, int index) | GuiGraphCtrl
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
matchScale(int plotID1, int plotID2,...) | GuiGraphCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
plotColor | GuiGraphCtrl
plotInterval | GuiGraphCtrl
plotType | GuiGraphCtrl
plotVariable | GuiGraphCtrl
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeAutoPlot(int plotId) | GuiGraphCtrl
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setGraphType(int plotId, GuiGraphType graphType) | GuiGraphCtrl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiHealthBarHud Member List

This is the complete list of members for GuiHealthBarHud, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
damageFillColor | GuiHealthBarHud
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
displayEnergy | GuiHealthBarHud
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
fillColor | GuiHealthBarHud
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
frameColor | GuiHealthBarHud
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pulseRate | GuiHealthBarHud
pulseThreshold | GuiHealthBarHud
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
showFill | GuiHealthBarHud
showFrame | GuiHealthBarHud
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiIconButtonCtrl Member List

This is the complete list of members for GuiIconButtonCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoSize | GuiIconButtonCtrl
bringToFront(SimObject obj) | SimSet
buttonMargin | GuiIconButtonCtrl
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
iconBitmap | GuiIconButtonCtrl
iconLocation | GuiIconButtonCtrl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
makeIconSquare | GuiIconButtonCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(string buttonFilename) | GuiIconButtonCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sizeIconToButton | GuiIconButtonCtrl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
textLocation | GuiIconButtonCtrl
textMargin | GuiIconButtonCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiInputCtrl Member List

This is the complete list of members for GuiInputCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
lockMouse | GuiMouseEventCtrl
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onInputEvent(string device, string action, bool state) | GuiInputCtrl
onLoseFirstResponder() | GuiControl
onMouseDown(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseDragged(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseEnter(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseLeave(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseMove(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseUp(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightMouseDown(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onRightMouseDragged(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onRightMouseUp(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiListBoxCtrl Member List

This is the complete list of members for GuiListBoxCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addFilteredItem(string newItem) | GuiListBoxCtrl
addGuiControl(GuiControl control) | GuiControl
allowMultipleSelections | GuiListBoxCtrl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clearItemColor(int index) | GuiListBoxCtrl
clearItems() | GuiListBoxCtrl
clearSelection() | GuiListBoxCtrl
clone() | SimObject
colorBullet | GuiListBoxCtrl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deleteItem(int itemIndex) | GuiListBoxCtrl
doMirror() | GuiListBoxCtrl
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findItemText(string findText, bool bCaseSensitive=false) | GuiListBoxCtrl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
fitParentWidth | GuiListBoxCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getItemCount() | GuiListBoxCtrl
getItemObject(int index) | GuiListBoxCtrl
getItemText(int index) | GuiListBoxCtrl
getLastClickItem() | GuiListBoxCtrl
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSelCount() | GuiListBoxCtrl
getSelectedItem() | GuiListBoxCtrl
getSelectedItems() | GuiListBoxCtrl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
insertItem(string text, int index) | GuiListBoxCtrl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isObjectMirrored(string indexIdString) | GuiListBoxCtrl
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
makeNameCallback | GuiListBoxCtrl
minExtent | GuiControl
mirrorSet | GuiListBoxCtrl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClearSelection() | GuiListBoxCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDeleteKey() | GuiListBoxCtrl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiListBoxCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDragged() | GuiListBoxCtrl
onMouseUp(string itemHit, string mouseClickCount) | GuiListBoxCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSelect(string index, string itemText) | GuiListBoxCtrl
onSleep() | GuiControl
onUnselect(string index, string itemText) | GuiListBoxCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeFilteredItem(string itemName) | GuiListBoxCtrl
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCurSel(int indexId) | GuiListBoxCtrl
setCurSelRange(int indexStart, int indexStop=999999) | GuiListBoxCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setItemColor(int index, ColorF color) | GuiListBoxCtrl
setItemText(int index, string newtext) | GuiListBoxCtrl
setItemTooltip(int index, string text) | GuiListBoxCtrl
setLocked(bool value=true) | SimObject
setMultipleSelection(bool allowMultSelections) | GuiListBoxCtrl
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSelected(int index, bool setSelected=true) | GuiListBoxCtrl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiMenuBar Member List

This is the complete list of members for GuiMenuBar, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
addMenu(string menuText, int menuId) | GuiMenuBar
addMenuItem(string targetMenu="", string menuItemText="", int menuItemId=0, string accelerator=NULL, int checkGroup=-1) | GuiMenuBar
addSubmenuItem(string menuTarget, string menuItem, string submenuItemText, int submenuItemId, string accelerator, int checkGroup) | GuiMenuBar
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clearMenuItems(string menuTarget) | GuiMenuBar
clearMenus(int param1, int param2) | GuiMenuBar
clearSubmenuItems(string menuTarget, string menuItem) | GuiMenuBar
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMenuItemSelect(string menuId, string menuText, string menuItemId, string menuItemText) | GuiMenuBar
onMenuSelect(string menuId, string menuText) | GuiMenuBar
onMouseInMenu(bool isInMenu) | GuiMenuBar
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onSubmenuSelect(string submenuId, string submenuText) | GuiMenuBar
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiMenuBar
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeMenu(string menuTarget) | GuiMenuBar
removeMenuItem(string menuTarget, string menuItemTarget) | GuiMenuBar
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setCheckmarkBitmapIndex(int bitmapindex) | GuiMenuBar
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setMenuBitmapIndex(string menuTarget, int bitmapindex, bool bitmaponly, bool drawborder) | GuiMenuBar
setMenuItemBitmap(string menuTarget, string menuItemTarget, int bitmapIndex) | GuiMenuBar
setMenuItemChecked(string menuTarget, string menuItemTarget, bool checked) | GuiMenuBar
setMenuItemEnable(string menuTarget, string menuItemTarget, bool enabled) | GuiMenuBar
setMenuItemSubmenuState(string menuTarget, string menuItem, bool isSubmenu) | GuiMenuBar
setMenuItemText(string menuTarget, string menuItemTarget, string newMenuItemText) | GuiMenuBar
setMenuItemVisible(string menuTarget, string menuItemTarget, bool isVisible) | GuiMenuBar
setMenuMargins(int horizontalMargin, int verticalMargin, int bitmapToTextSpacing) | GuiMenuBar
setMenuText(string menuTarget, string newMenuText) | GuiMenuBar
setMenuVisible(string menuTarget, bool visible) | GuiMenuBar
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProcessTicks(bool tick) void setProcessTicks([tick | GuiTickCtrl
setProfile(GuiControlProfile profile) | GuiControl
setSubmenuItemChecked(string menuTarget, string menuItemTarget, string submenuItemText, bool checked) | GuiMenuBar
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiMessageVectorCtrl Member List

This is the complete list of members for GuiMessageVectorCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
allowedMatches | GuiMessageVectorCtrl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
attach(MessageVector item) | GuiMessageVectorCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
detach() | GuiMessageVectorCtrl
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
lineContinuedIndex | GuiMessageVectorCtrl
lineSpacing | GuiMessageVectorCtrl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
matchColor | GuiMessageVectorCtrl
maxColorIndex | GuiMessageVectorCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiMLTextCtrl Member List

This is the complete list of members for GuiMLTextCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
addText(string text, bool reformat) | GuiMLTextCtrl
allowColorChars | GuiMLTextCtrl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deniedSound | GuiMLTextCtrl
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
forceReflow() | GuiMLTextCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiMLTextCtrl
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
lineSpacing | GuiMLTextCtrl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
maxChars | GuiMLTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onResize(string width, string maxY) | GuiMLTextCtrl
onSleep() | GuiControl
onURL(string url) | GuiMLTextCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scrollToBottom() | GuiMLTextCtrl
scrollToTag(int tagID) | GuiMLTextCtrl
scrollToTop(int param1, int param2) | GuiMLTextCtrl
setActive(bool state=true) | GuiControl
setAlpha(float alphaVal) | GuiMLTextCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCursorPosition(int newPos) | GuiMLTextCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiMLTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiMLTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useURLMouseCursor | GuiMLTextCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiMLTextEditCtrl Member List

This is the complete list of members for GuiMLTextEditCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
addText(string text, bool reformat) | GuiMLTextCtrl
allowColorChars | GuiMLTextCtrl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deniedSound | GuiMLTextCtrl
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
escapeCommand | GuiMLTextEditCtrl
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
forceReflow() | GuiMLTextCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiMLTextCtrl
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
lineSpacing | GuiMLTextCtrl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
maxChars | GuiMLTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onResize(string width, string maxY) | GuiMLTextCtrl
onSleep() | GuiControl
onURL(string url) | GuiMLTextCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scrollToBottom() | GuiMLTextCtrl
scrollToTag(int tagID) | GuiMLTextCtrl
scrollToTop(int param1, int param2) | GuiMLTextCtrl
setActive(bool state=true) | GuiControl
setAlpha(float alphaVal) | GuiMLTextCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCursorPosition(int newPos) | GuiMLTextCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiMLTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiMLTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useURLMouseCursor | GuiMLTextCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiMouseEventCtrl Member List

This is the complete list of members for GuiMouseEventCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
lockMouse | GuiMouseEventCtrl
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseDragged(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseEnter(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseLeave(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseMove(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onMouseUp(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightMouseDown(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onRightMouseDragged(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onRightMouseUp(U8 modifier, Point2I mousePoint, U8 mouseClickCount) | GuiMouseEventCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiObjectView Member List

This is the complete list of members for GuiObjectView, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
animSequence | GuiObjectView
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
calculateViewDistance(float radius) | GuiTSCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
cameraSpeed | GuiObjectView
cameraZRot | GuiTSCtrl
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
forceFOV | GuiTSCtrl
getAspect() | GuiControl
getCameraSpeed() | GuiObjectView
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getModel() | GuiObjectView
getMountedModel() | GuiObjectView
getMountSkin(int param1, int param2) | GuiObjectView
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getOrbitDistance() | GuiObjectView
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSkin() | GuiObjectView
getSuperClassNamespace() | SimObject
getValue | GuiControl
getWorldToScreenScale() | GuiTSCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
lightAmbient | GuiObjectView
lightColor | GuiObjectView
lightDirection | GuiObjectView
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxOrbitDiststance | GuiObjectView
minExtent | GuiControl
minOrbitDiststance | GuiObjectView
modal | GuiControl
mountedNode | GuiObjectView
mountedShapeFile | GuiObjectView
mountedSkin | GuiObjectView
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseEnter() | GuiObjectView
onMouseLeave() | GuiObjectView
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
orbitDiststance | GuiObjectView
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
project(Point3F worldPosition) | GuiTSCtrl
pushToBack(SimObject obj) | SimSet
reflectPriority | GuiTSCtrl
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCameraSpeed(float factor) | GuiObjectView
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLightAmbient(ColorF color) | GuiObjectView
setLightColor(ColorF color) | GuiObjectView
setLightDirection(Point3F direction) | GuiObjectView
setLocked(bool value=true) | SimObject
setModel(string shapeName) | GuiObjectView
setMount(string shapeName, string mountNodeIndexOrName) | GuiObjectView
setMountedModel(string shapeName) | GuiObjectView
setMountSkin(string skinName) | GuiObjectView
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setOrbitDistance(float distance) | GuiObjectView
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSeq(string indexOrName) | GuiObjectView
setSkin(string skinName) | GuiObjectView
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
shapeFile | GuiObjectView
skin | GuiObjectView
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
unproject(Point3F screenPosition) | GuiTSCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiPaneControl Member List

This is the complete list of members for GuiPaneControl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
barBehindText | GuiPaneControl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
caption | GuiPaneControl
captionID | GuiPaneControl
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
collapsable | GuiPaneControl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCollapsed(bool collapse) | GuiPaneControl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiPanel Member List

This is the complete list of members for GuiPanel, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiPopUpMenuCtrl Member List

This is the complete list of members for GuiPopUpMenuCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(string name, int idNum, int scheme=0) | GuiPopUpMenuCtrl
GuiTextCtrl::add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
addScheme(int id, ColorI fontColor, ColorI fontColorHL, ColorI fontColorSEL) | GuiPopUpMenuCtrl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiPopUpMenuCtrl
bitmapBounds | GuiPopUpMenuCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
changeTextById(int id, string text) | GuiPopUpMenuCtrl
class | SimObject
className | SimObject
clear | GuiPopUpMenuCtrl
GuiTextCtrl::clear() | SimSet
clearEntry(S32 entry) | GuiPopUpMenuCtrl
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
findText(string text) | GuiPopUpMenuCtrl
forceClose | GuiPopUpMenuCtrl
forceOnAction | GuiPopUpMenuCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSelected | GuiPopUpMenuCtrl
getSuperClassNamespace() | SimObject
getText | GuiPopUpMenuCtrl
getTextById(int id) | GuiPopUpMenuCtrl
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
maxPopupHeight | GuiPopUpMenuCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
replaceText(bool doReplaceText) | GuiPopUpMenuCtrl
resize(int x, int y, int width, int height) | GuiControl
reverseTextList | GuiPopUpMenuCtrl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
sbUsesNAColor | GuiPopUpMenuCtrl
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setEnumContent(string class, string enum) | GuiPopUpMenuCtrl
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setFirstSelected([scriptCallback=true]) | GuiPopUpMenuCtrl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setNoneSelected | GuiPopUpMenuCtrl
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSelected(int id,[scriptCallback=true]) | GuiPopUpMenuCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
size | GuiPopUpMenuCtrl
sort | GuiPopUpMenuCtrl
GuiTextCtrl::sort(string callbackFunction) | SimSet
sortID | GuiPopUpMenuCtrl
superClass | SimObject
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiPopUpMenuCtrlEx Member List

This is the complete list of members for GuiPopUpMenuCtrlEx, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(string name, S32 idNum, S32 scheme=0) | GuiPopUpMenuCtrlEx
add(string name, int idNum, int scheme=0) | GuiPopUpMenuCtrlEx
GuiTextCtrl::add(SimObject objects...) | SimSet
addCategory(string text) | GuiPopUpMenuCtrlEx
addGuiControl(GuiControl control) | GuiControl
addScheme(int id, ColorI fontColor, ColorI fontColorHL, ColorI fontColorSEL) | GuiPopUpMenuCtrlEx
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiPopUpMenuCtrlEx
bitmapBounds | GuiPopUpMenuCtrlEx
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | GuiPopUpMenuCtrlEx
clearEntry(S32 entry) | GuiPopUpMenuCtrlEx
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
findText(string text) | GuiPopUpMenuCtrlEx
forceClose() | GuiPopUpMenuCtrlEx
forceOnAction() | GuiPopUpMenuCtrlEx
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getColorById | GuiPopUpMenuCtrlEx
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSelected() | GuiPopUpMenuCtrlEx
getSuperClassNamespace() | SimObject
getText() | GuiPopUpMenuCtrlEx
getTextById(int id) | GuiPopUpMenuCtrlEx
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hotTrackCallback | GuiPopUpMenuCtrlEx
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
maxPopupHeight | GuiPopUpMenuCtrlEx
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
replaceText | GuiPopUpMenuCtrlEx
resize(int x, int y, int width, int height) | GuiControl
reverseTextList | GuiPopUpMenuCtrlEx
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
sbUsesNAColor | GuiPopUpMenuCtrlEx
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setEnumContent | GuiPopUpMenuCtrlEx
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setNoneSelected(int param) | GuiPopUpMenuCtrlEx
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSelected(bool scriptCallback=true) | GuiPopUpMenuCtrlEx
setSelected(int id, bool scriptCallback=true) | GuiPopUpMenuCtrlEx
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiPopUpMenuCtrlEx
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
size | GuiPopUpMenuCtrlEx
sort() | GuiPopUpMenuCtrlEx
GuiTextCtrl::sort(string callbackFunction) | SimSet
sortID() | GuiPopUpMenuCtrlEx
superClass | SimObject
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiProgressBitmapCtrl Member List

This is the complete list of members for GuiProgressBitmapCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiProgressBitmapCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(string filename) | GuiProgressBitmapCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiProgressCtrl Member List

This is the complete list of members for GuiProgressCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiRadioCtrl Member List

This is the complete list of members for GuiRadioCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isStateOn() | GuiCheckBoxCtrl
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool newState) | GuiCheckBoxCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiRolloutCtrl Member List

This is the complete list of members for GuiRolloutCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
autoCollapseSiblings | GuiRolloutCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
caption | GuiRolloutCtrl
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clickCollapse | GuiRolloutCtrl
clone() | SimObject
collapse() | GuiRolloutCtrl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
defaultHeight | GuiRolloutCtrl
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
expand() | GuiRolloutCtrl
expanded | GuiRolloutCtrl
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
hideHeader | GuiRolloutCtrl
horizSizing | GuiControl
hovertime | GuiControl
instantCollapse() | GuiRolloutCtrl
instantExpand() | GuiRolloutCtrl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | GuiRolloutCtrl
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiRolloutCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onCollapsed() | GuiRolloutCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onExpanded() | GuiRolloutCtrl
onGainFirstResponder() | GuiControl
onHeaderRightClick() | GuiRolloutCtrl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sizeToContents() | GuiRolloutCtrl
sort(string callbackFunction) | SimSet
superClass | SimObject
toggleCollapse() | GuiRolloutCtrl
toggleExpanded(bool instantly=false) | GuiRolloutCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiScriptNotifyCtrl Member List

This is the complete list of members for GuiScriptNotifyCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onChildAdded | GuiScriptNotifyCtrl
onChildAdded(SimObjectId ID, SimObjectId childID) | GuiScriptNotifyCtrl
onChildRemoved | GuiScriptNotifyCtrl
onChildRemoved(SimObjectId ID, SimObjectId childID) | GuiScriptNotifyCtrl
onChildResized | GuiScriptNotifyCtrl
onChildResized(SimObjectId ID, SimObjectId childID) | GuiScriptNotifyCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder | GuiScriptNotifyCtrl
onGainFirstResponder(SimObjectId ID) | GuiScriptNotifyCtrl
GuiControl::onGainFirstResponder() | GuiControl
onLoseFirstResponder | GuiScriptNotifyCtrl
onLoseFirstResponder(SimObjectId ID) | GuiScriptNotifyCtrl
GuiControl::onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onParentResized | GuiScriptNotifyCtrl
onParentResized(SimObjectId ID) | GuiScriptNotifyCtrl
onRemove() | GuiControl
onResize | GuiScriptNotifyCtrl
onResize(SimObjectId ID) | GuiScriptNotifyCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiScrollCtrl Member List

This is the complete list of members for GuiScrollCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
childMargin | GuiScrollCtrl
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
computeSizes() | GuiScrollCtrl
constantThumbHeight | GuiScrollCtrl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getScrollPosition() | GuiScrollCtrl
getScrollPositionX() | GuiScrollCtrl
getScrollPositionY() | GuiScrollCtrl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
hScrollBar | GuiScrollCtrl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
lockHorizScroll | GuiScrollCtrl
lockVertScroll | GuiScrollCtrl
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
modal | GuiControl
mouseWheelScrollSpeed | GuiScrollCtrl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onScroll() | GuiScrollCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scrollToBottom() | GuiScrollCtrl
scrollToObject(GuiControl control) | GuiScrollCtrl
scrollToTop() | GuiScrollCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setScrollPosition(int x, int y) | GuiScrollCtrl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl
vScrollBar | GuiScrollCtrl
willFirstRespond | GuiScrollCtrl


Torque 3D - Script Manual: Member List

GuiSeparatorCtrl Member List

This is the complete list of members for GuiSeparatorCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
borderMargin | GuiSeparatorCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
caption | GuiSeparatorCtrl
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
invisible | GuiSeparatorCtrl
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
leftMargin | GuiSeparatorCtrl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
type | GuiSeparatorCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiShapeNameHud Member List

This is the complete list of members for GuiShapeNameHud, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
distanceFade | GuiShapeNameHud
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
fillColor | GuiShapeNameHud
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
frameColor | GuiShapeNameHud
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
showFill | GuiShapeNameHud
showFrame | GuiShapeNameHud
sort(string callbackFunction) | SimSet
superClass | SimObject
textColor | GuiShapeNameHud
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
verticalOffset | GuiShapeNameHud
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiSliderCtrl Member List

This is the complete list of members for GuiSliderCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue() | GuiSliderCtrl
GuiControl::getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isThumbBeingDragged() | GuiSliderCtrl
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDragged() | GuiSliderCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
range | GuiSliderCtrl
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(float pos, bool doCallback=false) | GuiSliderCtrl
GuiControl::setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
snap | GuiSliderCtrl
sort(string callbackFunction) | SimSet
superClass | SimObject
ticks | GuiSliderCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
value | GuiSliderCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiSpeedometerHud Member List

This is the complete list of members for GuiSpeedometerHud, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiBitmapCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
center | GuiSpeedometerHud
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
color | GuiSpeedometerHud
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
length | GuiSpeedometerHud
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
maxAngle | GuiSpeedometerHud
maxSpeed | GuiSpeedometerHud
minAngle | GuiSpeedometerHud
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setBitmap(String filename) | GuiBitmapCtrl
setBitmap(String filename, bool resize) | GuiBitmapCtrl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(int x, int y) | GuiBitmapCtrl
GuiControl::setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tail | GuiSpeedometerHud
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl
width | GuiSpeedometerHud
wrap | GuiBitmapCtrl


Torque 3D - Script Manual: Member List

GuiSplitContainer Member List

This is the complete list of members for GuiSplitContainer, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
fixedPanel | GuiSplitContainer
fixedSize | GuiSplitContainer
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
orientation | GuiSplitContainer
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
splitPoint | GuiSplitContainer
splitterSize | GuiSplitContainer
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiStackControl Member List

This is the complete list of members for GuiStackControl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
changeChildPosition | GuiStackControl
changeChildSizeToFit | GuiStackControl
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dynamicNonStackExtent | GuiStackControl
dynamicPos | GuiStackControl
dynamicSize | GuiStackControl
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
freeze(bool freeze) | GuiStackControl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
horizStacking | GuiStackControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isFrozen() | GuiStackControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiStackControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
stackingType | GuiStackControl
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
updateStack() | GuiStackControl
variable | GuiControl
vertSizing | GuiControl
vertStacking | GuiStackControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiSwatchButtonCtrl Member List

This is the complete list of members for GuiSwatchButtonCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
color | GuiSwatchButtonCtrl
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setColor(string newColor) | GuiSwatchButtonCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTabBookCtrl Member List

This is the complete list of members for GuiTabBookCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
addPage(string title="") | GuiTabBookCtrl
allowReorder | GuiTabBookCtrl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
defaultPage | GuiTabBookCtrl
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
frontTabPadding | GuiTabBookCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSelectedPage() | GuiTabBookCtrl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
minTabWidth | GuiTabBookCtrl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onTabRightClick(String text, int index) | GuiTabBookCtrl
onTabSelected(String text, int index) | GuiTabBookCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
selectedPage | GuiTabBookCtrl
selectPage(int index) | GuiTabBookCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tabHeight | GuiTabBookCtrl
tabMargin | GuiTabBookCtrl
tabPosition | GuiTabBookCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTabPageCtrl Member List

This is the complete list of members for GuiTabPageCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
fitBook | GuiTabPageCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
select() | GuiTabPageCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTextCtrl Member List

This is the complete list of members for GuiTextCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTextEditCtrl Member List

This is the complete list of members for GuiTextEditCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clearSelectedText() | GuiTextEditCtrl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deniedSound | GuiTextEditCtrl
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
escapeCommand | GuiTextEditCtrl
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
forceValidateText() | GuiTextEditCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getCursorPos() | GuiTextEditCtrl
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiTextEditCtrl
getValue | GuiControl
hidden | SimObject
historySize | GuiTextEditCtrl
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAllTextSelected() | GuiTextEditCtrl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onReturn() | GuiTextEditCtrl
onSleep() | GuiControl
onTabComplete(string val) | GuiTextEditCtrl
onValidate() | GuiTextEditCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
password | GuiTextEditCtrl
passwordMask | GuiTextEditCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
selectAllText() | GuiTextEditCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCursorPos(int position) | GuiTextEditCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextEditCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sinkAllKeyEvents | GuiTextEditCtrl
sort(string callbackFunction) | SimSet
superClass | SimObject
tabComplete | GuiTextEditCtrl
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
validate | GuiTextEditCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTextEditSliderBitmapCtrl Member List

This is the complete list of members for GuiTextEditSliderBitmapCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bitmap | GuiTextEditSliderBitmapCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clearSelectedText() | GuiTextEditCtrl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deniedSound | GuiTextEditCtrl
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
escapeCommand | GuiTextEditCtrl
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
focusOnMouseWheel | GuiTextEditSliderBitmapCtrl
forceValidateText() | GuiTextEditCtrl
format | GuiTextEditSliderBitmapCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getCursorPos() | GuiTextEditCtrl
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiTextEditCtrl
getValue | GuiControl
hidden | SimObject
historySize | GuiTextEditCtrl
horizSizing | GuiControl
hovertime | GuiControl
increment | GuiTextEditSliderBitmapCtrl
internalName | SimObject
isActive | GuiControl
isAllTextSelected() | GuiTextEditCtrl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onReturn() | GuiTextEditCtrl
onSleep() | GuiControl
onTabComplete(string val) | GuiTextEditCtrl
onValidate() | GuiTextEditCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
password | GuiTextEditCtrl
passwordMask | GuiTextEditCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
range | GuiTextEditSliderBitmapCtrl
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
selectAllText() | GuiTextEditCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCursorPos(int position) | GuiTextEditCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextEditCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sinkAllKeyEvents | GuiTextEditCtrl
sort(string callbackFunction) | SimSet
superClass | SimObject
tabComplete | GuiTextEditCtrl
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
validate | GuiTextEditCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTextEditSliderCtrl Member List

This is the complete list of members for GuiTextEditSliderCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clearSelectedText() | GuiTextEditCtrl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
deniedSound | GuiTextEditCtrl
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
escapeCommand | GuiTextEditCtrl
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
focusOnMouseWheel | GuiTextEditSliderCtrl
forceValidateText() | GuiTextEditCtrl
format | GuiTextEditSliderCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getCursorPos() | GuiTextEditCtrl
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiTextEditCtrl
getValue | GuiControl
hidden | SimObject
historySize | GuiTextEditCtrl
horizSizing | GuiControl
hovertime | GuiControl
increment | GuiTextEditSliderCtrl
internalName | SimObject
isActive | GuiControl
isAllTextSelected() | GuiTextEditCtrl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
maxLength | GuiTextCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onReturn() | GuiTextEditCtrl
onSleep() | GuiControl
onTabComplete(string val) | GuiTextEditCtrl
onValidate() | GuiTextEditCtrl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
password | GuiTextEditCtrl
passwordMask | GuiTextEditCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
range | GuiTextEditSliderCtrl
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
selectAllText() | GuiTextEditCtrl
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setCursorPos(int position) | GuiTextEditCtrl
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiTextEditCtrl
setTextID(string textID) | GuiTextCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sinkAllKeyEvents | GuiTextEditCtrl
sort(string callbackFunction) | SimSet
superClass | SimObject
tabComplete | GuiTextEditCtrl
text | GuiTextCtrl
textID | GuiTextCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
validate | GuiTextEditCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTextListCtrl Member List

This is the complete list of members for GuiTextListCtrl, including all inherited members.
addRow(int id=0, string text="", int index=-1) | GuiTextListCtrl
clear() | GuiTextListCtrl
clearSelection() | GuiTextListCtrl
clipColumnText | GuiTextListCtrl
columns | GuiTextListCtrl
findTextIndex(string needle) | GuiTextListCtrl
fitParentWidth | GuiTextListCtrl
getRowId(int index) | GuiTextListCtrl
getRowNumById(int id) | GuiTextListCtrl
getRowText(int index) | GuiTextListCtrl
getRowTextById(int id) | GuiTextListCtrl
getSelectedId() | GuiTextListCtrl
getSelectedRow() | GuiTextListCtrl
isRowActive(int rowNum) | GuiTextListCtrl
onDeleteKey(string id) | GuiTextListCtrl
onSelect(string cellid, string text) | GuiTextListCtrl
removeRow(int index) | GuiTextListCtrl
removeRowById(int id) | GuiTextListCtrl
rowCount() | GuiTextListCtrl
scrollVisible(int rowNum) | GuiTextListCtrl
setRowActive(int rowNum, bool active) | GuiTextListCtrl
setRowById(int id, string text) | GuiTextListCtrl
setSelectedById(int id) | GuiTextListCtrl
setSelectedRow(int rowNum) | GuiTextListCtrl
sort(int columnId, bool increasing=true) | GuiTextListCtrl
sortNumerical(int columnID, bool increasing=true) | GuiTextListCtrl


Torque 3D - Script Manual: Member List

GuiTheoraCtrl Member List

This is the complete list of members for GuiTheoraCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
backgroundColor | GuiTheoraCtrl
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getCurrentTime() | GuiTheoraCtrl
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isPlaybackDone() | GuiTheoraCtrl
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
matchVideoSize | GuiTheoraCtrl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
pause() | GuiTheoraCtrl
persistentId | SimObject
play() | GuiTheoraCtrl
playOnWake | GuiTheoraCtrl
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
renderDebugInfo | GuiTheoraCtrl
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFile(string filename) | GuiTheoraCtrl
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
stop() | GuiTheoraCtrl
stopOnSleep | GuiTheoraCtrl
superClass | SimObject
theoraFile | GuiTheoraCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
transcoder | GuiTheoraCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTickCtrl Member List

This is the complete list of members for GuiTickCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProcessTicks(bool tick) void setProcessTicks([tick | GuiTickCtrl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiToggleButtonCtrl Member List

This is the complete list of members for GuiToggleButtonCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
buttonType | GuiButtonBaseCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getText() | GuiButtonBaseCtrl
getValue | GuiControl
groupNum | GuiButtonBaseCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onClick() | GuiButtonBaseCtrl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onDoubleClick() | GuiButtonBaseCtrl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onMouseDown() | GuiButtonBaseCtrl
onMouseDragged() | GuiButtonBaseCtrl
onMouseEnter() | GuiButtonBaseCtrl
onMouseLeave() | GuiButtonBaseCtrl
onMouseUp() | GuiButtonBaseCtrl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onRightClick() | GuiButtonBaseCtrl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
parentGroup | SimObject
performClick() | GuiButtonBaseCtrl
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resetState() | GuiButtonBaseCtrl
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setStateOn(bool isOn=true) | GuiButtonBaseCtrl
setSuperClassNamespace(string name) | SimObject
setText(string text) | GuiButtonBaseCtrl
setTextID(string id) | GuiButtonBaseCtrl
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
text | GuiButtonBaseCtrl
textID | GuiButtonBaseCtrl
tooltip | GuiControl
tooltipProfile | GuiControl
useMouseEvents | GuiButtonBaseCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiTreeViewCtrl Member List

This is the complete list of members for GuiTreeViewCtrl, including all inherited members.
addChildSelectionByValue | GuiTreeViewCtrl
addSelection(int id, bool isLastSelection=true) | GuiTreeViewCtrl
buildIconTable(builds an icon table) | GuiTreeViewCtrl
buildVisibleTree | GuiTreeViewCtrl
cancelRename | GuiTreeViewCtrl
canRenameObject(SimObject object) | GuiTreeViewCtrl
canRenameObjects | GuiTreeViewCtrl
clear() | GuiTreeViewCtrl
clearAllOnSingleSelection | GuiTreeViewCtrl
clearFilterText() | GuiTreeViewCtrl
clearSelection() | GuiTreeViewCtrl
compareToObjectID | GuiTreeViewCtrl
deleteObjectAllowed | GuiTreeViewCtrl
deleteSelection() | GuiTreeViewCtrl
destroyTreeOnSleep | GuiTreeViewCtrl
dragToItemAllowed | GuiTreeViewCtrl
editItem(TreeItemId item, string newText, string newValue) | GuiTreeViewCtrl
expandItem(TreeItemId item, bool expand=true) | GuiTreeViewCtrl
findChildItemByName(int parentId, string childName) | GuiTreeViewCtrl
findItemByName(string text) | GuiTreeViewCtrl
findItemByObjectId(find item by object id and returns the mId) | GuiTreeViewCtrl
findItemByValue(string value) | GuiTreeViewCtrl
fullRowSelect | GuiTreeViewCtrl
getChild(TreeItemId item) | GuiTreeViewCtrl
getFilterText() | GuiTreeViewCtrl
getFirstRootItem | GuiTreeViewCtrl
getItemCount | GuiTreeViewCtrl
getItemText(TreeItemId item) | GuiTreeViewCtrl
getItemValue(TreeItemId item) | GuiTreeViewCtrl
getNextSibling(TreeItemId item) | GuiTreeViewCtrl
getParent(TreeItemId item) | GuiTreeViewCtrl
getPrevSibling(TreeItemId item) | GuiTreeViewCtrl
getSelectedItem(int index=0) | GuiTreeViewCtrl
getSelectedItemList | GuiTreeViewCtrl
getSelectedItemsCount | GuiTreeViewCtrl
getSelectedObject(int index=0) | GuiTreeViewCtrl
getSelectedObjectList | GuiTreeViewCtrl
getTextToRoot(TreeItemId item, Delimiter=none) | GuiTreeViewCtrl
handleRenameObject(string newName, SimObject object) | GuiTreeViewCtrl
hideSelection(bool state=true) | GuiTreeViewCtrl
insertItem(int parentId, string text, string value="", string icon="", int normalImage=0, int expandedImage=0) | GuiTreeViewCtrl
isItemSelected(int id) | GuiTreeViewCtrl
isParentItem(int id) | GuiTreeViewCtrl
isValidDragTarget(int id, string value) | GuiTreeViewCtrl
itemHeight | GuiTreeViewCtrl
lockSelection(bool lock=true) | GuiTreeViewCtrl
markItem(TreeItemId item, bool mark=true) | GuiTreeViewCtrl
mouseDragging | GuiTreeViewCtrl
moveItemDown(TreeItemId item) | GuiTreeViewCtrl
moveItemUp(TreeItemId item) | GuiTreeViewCtrl
multipleSelections | GuiTreeViewCtrl
onAddGroupSelected(SimGroup group) | GuiTreeViewCtrl
onAddMultipleSelectionBegin() | GuiTreeViewCtrl
onAddMultipleSelectionEnd() | GuiTreeViewCtrl
onAddSelection(int itemOrObjectId, bool isLastSelection) | GuiTreeViewCtrl
onBeginReparenting() | GuiTreeViewCtrl
onClearSelection() | GuiTreeViewCtrl
onDefineIcons() | GuiTreeViewCtrl
onDeleteObject(SimObject object) | GuiTreeViewCtrl
onDeleteSelection() | GuiTreeViewCtrl
onDragDropped() | GuiTreeViewCtrl
onEndReparenting() | GuiTreeViewCtrl
onInspect(int itemOrObjectId) | GuiTreeViewCtrl
onKeyDown(int modifier, int keyCode) | GuiTreeViewCtrl
onMouseDragged() | GuiTreeViewCtrl
onMouseUp(int hitItemId, int mouseClickCount) | GuiTreeViewCtrl
onObjectDeleteCompleted() | GuiTreeViewCtrl
onRemoveSelection(int itemOrObjectId) | GuiTreeViewCtrl
onRenameValidate | GuiTreeViewCtrl
onReparent(int itemOrObjectId, int oldParentItemOrObjectId, int newParentItemOrObjectId) | GuiTreeViewCtrl
onRightMouseDown(int itemId, Point2I mousePos, SimObject object) | GuiTreeViewCtrl
onRightMouseUp(int itemId, Point2I mousePos, SimObject object) | GuiTreeViewCtrl
onSelect(int itemOrObjectId) | GuiTreeViewCtrl
onUnselect(int itemOrObjectId) | GuiTreeViewCtrl
open(SimSet obj, bool okToEdit=true) | GuiTreeViewCtrl
removeAllChildren | GuiTreeViewCtrl
removeChildSelectionByValue | GuiTreeViewCtrl
removeItem(TreeItemId item) | GuiTreeViewCtrl
removeSelection(deselects an item) | GuiTreeViewCtrl
renameInternal | GuiTreeViewCtrl
scrollVisible(TreeItemId item) | GuiTreeViewCtrl
scrollVisibleByObjectId(show item by object id.returns true if sucessful.) | GuiTreeViewCtrl
selectItem(TreeItemId item, bool select=true) | GuiTreeViewCtrl
setDebug(bool value=true) | GuiTreeViewCtrl
setFilterText(string pattern) | GuiTreeViewCtrl
setItemImages(int id, int normalImage, int expandedImage) | GuiTreeViewCtrl
setItemTooltip(int id, string text) | GuiTreeViewCtrl
showClassNameForUnnamedObjects | GuiTreeViewCtrl
showClassNames | GuiTreeViewCtrl
showInternalNames | GuiTreeViewCtrl
showItemRenameCtrl(TreeItemId id) | GuiTreeViewCtrl
showObjectIds | GuiTreeViewCtrl
showObjectNames | GuiTreeViewCtrl
showRoot | GuiTreeViewCtrl
sort(int parent, bool traverseHierarchy=false, bool parentsFirst=false, bool caseSensitive=true) | GuiTreeViewCtrl
tabSize | GuiTreeViewCtrl
textOffset | GuiTreeViewCtrl
toggleHideSelection() | GuiTreeViewCtrl
toggleLockSelection() | GuiTreeViewCtrl
tooltipOnWidthOnly | GuiTreeViewCtrl
useInspectorTooltips | GuiTreeViewCtrl


Torque 3D - Script Manual: Member List

GuiTSCtrl Member List

This is the complete list of members for GuiTSCtrl, including all inherited members.
accelerator | GuiControl
acceptsAsChild(SimObject obj) | SimSet
active | GuiControl
add(SimObject objects...) | SimSet
addGuiControl(GuiControl control) | GuiControl
altCommand | GuiControl
anchorBottom | GuiContainer
anchorLeft | GuiContainer
anchorRight | GuiContainer
anchorTop | GuiContainer
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
calculateViewDistance(float radius) | GuiTSCtrl
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
cameraZRot | GuiTSCtrl
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearFirstResponder(bool ignored=false) | GuiControl
clone() | SimObject
command | GuiControl
controlIsChild(GuiControl control) | GuiControl
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
docking | GuiContainer
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extent | GuiControl
findHitControl(int x, int y) | GuiControl
findHitControls(int x, int y, int width, int height) | GuiControl
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
forceFOV | GuiTSCtrl
getAspect() | GuiControl
getCanSave() | SimObject
getCenter() | GuiControl
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getExtent() | GuiControl
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFirstResponder() | GuiControl
getFullCount() | SimSet
getGlobalCenter() | GuiControl
getGlobalPosition() | GuiControl
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getMinExtent() | GuiControl
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParent() | GuiControl
getPosition() | GuiControl
getRandom() | SimSet
getRoot() | GuiControl
getSuperClassNamespace() | SimObject
getValue | GuiControl
getWorldToScreenScale() | GuiTSCtrl
hidden | SimObject
horizSizing | GuiControl
hovertime | GuiControl
internalName | SimObject
isActive | GuiControl
isAwake() | GuiControl
isChildOfGroup(SimGroup group) | SimObject
isContainer | GuiControl
isEditorOnly() | SimObject
isExpanded() | SimObject
isFirstResponder() | GuiControl
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isMouseLocked() | GuiControl
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isVisible() | GuiControl
langTableMod | GuiControl
listObjects() | SimSet
locked | SimObject
makeFirstResponder(bool isFirst) | GuiControl
margin | GuiContainer
minExtent | GuiControl
modal | GuiControl
name | SimObject
onAction() | GuiControl
onActive(bool state) | GuiControl
onAdd() | GuiControl
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl
onDialogPop() | GuiControl
onDialogPush() | GuiControl
onGainFirstResponder() | GuiControl
onLoseFirstResponder() | GuiControl
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove() | GuiControl
onSleep() | GuiControl
onVisible(bool state) | GuiControl
onWake() | GuiControl
padding | GuiContainer
parentGroup | SimObject
persistentId | SimObject
pointInControl(int x, int y) | GuiControl
position | GuiControl
profile | GuiControl
project(Point3F worldPosition) | GuiTSCtrl
pushToBack(SimObject obj) | SimSet
reflectPriority | GuiTSCtrl
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resize(int x, int y, int width, int height) | GuiControl
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setActive(bool state=true) | GuiControl
setCanSave(bool value=true) | SimObject
setCenter(int x, int y) | GuiControl
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setExtent(Point2I p) | GuiControl
setExtent(S32 width, S32 height) | GuiControl
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setFirstResponder | GuiControl
setFirstResponder() | GuiControl
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int x, int y) | GuiControl
setPositionGlobal(int x, int y) | GuiControl
setProfile(GuiControlProfile profile) | GuiControl
setSuperClassNamespace(string name) | SimObject
setValue(string value) | GuiControl
setVisible(bool state=true) | GuiControl
sort(string callbackFunction) | SimSet
superClass | SimObject
tooltip | GuiControl
tooltipProfile | GuiControl
unproject(Point3F screenPosition) | GuiTSCtrl
variable | GuiControl
vertSizing | GuiControl
visible | GuiControl


Torque 3D - Script Manual: Member List

GuiWindowCtrl Member List

This is the complete list of members for GuiWindowCtrl, including all inherited members.
accelerator | GuiControl |
acceptsAsChild(SimObject obj) | SimSet |
active | GuiControl |
add(SimObject objects...) | SimSet |
addGuiControl(GuiControl control) | GuiControl |
altCommand | GuiControl |
anchorBottom | GuiContainer |
anchorLeft | GuiContainer |
anchorRight | GuiContainer |
anchorTop | GuiContainer |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attach(GuiWindowCtrl bottomWindow, GuiWindowCtrl topWindow) | GuiWindowCtrl | [static]
attachTo(GuiWindowCtrl window) | GuiWindowCtrl |
bringToFront(SimObject obj) | SimSet |
call(string method, string args...) | SimObject |
callOnChildren(string method, string args...) | SimSet |
callOnChildrenNoRecurse(string method, string args...) | SimSet |
canClose | GuiWindowCtrl |
canCollapse | GuiWindowCtrl |
canMaximize | GuiWindowCtrl |
canMinimize | GuiWindowCtrl |
canMove | GuiWindowCtrl |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clear() | SimSet |
clearFirstResponder(bool ignored=false) | GuiControl |
clone() | SimObject |
closeCommand | GuiWindowCtrl |
command | GuiControl |
controlIsChild(GuiControl control) | GuiControl |
deepClone() | SimObject |
delete() | SimObject |
deleteAllObjects() | SimSet |
docking | GuiContainer |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
edgeSnap | GuiWindowCtrl |
extent | GuiControl |
findHitControl(int x, int y) | GuiControl |
findHitControls(int x, int y, int width, int height) | GuiControl |
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet |
getAspect() | GuiControl |
getCanSave() | SimObject |
getCenter() | GuiControl |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getCount() | SimSet |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getExtent() | GuiControl |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getFirstResponder() | GuiControl |
getFullCount() | SimSet |
getGlobalCenter() | GuiControl |
getGlobalPosition() | GuiControl |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMinExtent() | GuiControl |
getName() | SimObject |
getObject(int index) | SimSet |
getObjectIndex(SimObject obj) | SimSet |
getParent() | GuiControl |
getPosition() | GuiControl |
getRandom() | SimSet |
getRoot() | GuiControl |
getSuperClassNamespace() | SimObject |
getValue | GuiControl |
hidden | SimObject |
horizSizing | GuiControl |
hovertime | GuiControl |
internalName | SimObject |
isActive | GuiControl |
isAwake() | GuiControl |
isChildOfGroup(SimGroup group) | SimObject |
isContainer | GuiControl |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isFirstResponder() | GuiControl |
isInNamespaceHierarchy(string name) | SimObject |
isMember(SimObject obj) | SimSet |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMouseLocked() | GuiControl |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
isVisible() | GuiControl |
langTableMod | GuiControl |
listObjects() | SimSet |
locked | SimObject |
makeFirstResponder(bool isFirst) | GuiControl |
margin | GuiContainer |
minExtent | GuiControl |
modal | GuiControl |
name | SimObject |
onAction() | GuiControl |
onActive(bool state) | GuiControl |
onAdd() | GuiControl |
onClose() | GuiWindowCtrl |
onCollapse() | GuiWindowCtrl |
onControlDragEnter(GuiControl control, Point2I dropPoint) | GuiControl |
onControlDragExit(GuiControl control, Point2I dropPoint) | GuiControl |
onControlDragged(GuiControl control, Point2I dropPoint) | GuiControl |
onControlDropped(GuiControl control, Point2I dropPoint) | GuiControl |
onDialogPop() | GuiControl |
onDialogPush() | GuiControl |
onGainFirstResponder() | GuiControl |
onLoseFirstResponder() | GuiControl |
onMaximize() | GuiWindowCtrl |
onMinimize() | GuiWindowCtrl |
onObjectAdded(SimObject object) | SimSet |
onObjectRemoved(SimObject object) | SimSet |
onRemove() | GuiControl |
onRestore() | GuiWindowCtrl |
onSleep() | GuiControl |
onVisible(bool state) | GuiControl |
onWake() | GuiControl |
padding | GuiContainer |
parentGroup | SimObject |
persistentId | SimObject |
pointInControl(int x, int y) | GuiControl |
position | GuiControl |
profile | GuiControl |
pushToBack(SimObject obj) | SimSet |
remove(SimObject objects...) | SimSet |
reorderChild(SimObject child1, SimObject child2) | SimSet |
resize(int x, int y, int width, int height) | GuiControl |
resizeHeight | GuiWindowCtrl |
resizeWidth | GuiWindowCtrl |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
schedule(float time, string method, string args...) | SimObject |
selectWindow() | GuiWindowCtrl |
setActive(bool state=true) | GuiControl |
setCanSave(bool value=true) | SimObject |
setCenter(int x, int y) | GuiControl |
setClassNamespace(string name) | SimObject |
setCollapseGroup(bool state) | GuiWindowCtrl |
setEditorOnly(bool value=true) | SimObject |
setExtent(Point2I p) | GuiControl |
setExtent(S32 width, S32 height) | GuiControl |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setFirstResponder | GuiControl |
setFirstResponder() | GuiControl |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setPosition(int x, int y) | GuiControl |
setPositionGlobal(int x, int y) | GuiControl |
setProfile(GuiControlProfile profile) | GuiControl |
setSuperClassNamespace(string name) | SimObject |
setValue(string value) | GuiControl |
setVisible(bool state=true) | GuiControl |
sort(string callbackFunction) | SimSet |
superClass | SimObject |
text | GuiWindowCtrl |
toggleCollapseGroup() | GuiWindowCtrl |
tooltip | GuiControl |
tooltipProfile | GuiControl |
variable | GuiControl |
vertSizing | GuiControl |
visible | GuiControl |


Torque 3D - Script Manual: Member List

HoverVehicle Member List

This is the complete list of members for HoverVehicle, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
disableMove | Vehicle |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | HoverVehicle | [static]
isRenderEnabled | SceneObject |
isSelectable | HoverVehicle | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |
workingQueryBoxSizeMultiplier | Vehicle | [static]
workingQueryBoxStaleThreshold | Vehicle | [static]


Torque 3D - Script Manual: Member List

HoverVehicleData Member List

This is the complete list of members for HoverVehicleData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bodyFriction | VehicleData
bodyRestitution | VehicleData
brakingActivationSpeed | HoverVehicleData
brakingForce | HoverVehicleData
call(string method, string args...) | SimObject
cameraDecay | VehicleData
cameraDefaultFov | ShapeBaseData
cameraLag | VehicleData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
cameraOffset | VehicleData
cameraRoll | VehicleData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
collDamageMultiplier | VehicleData
collDamageThresholdVel | VehicleData
collisionTol | VehicleData
computeCRC | ShapeBaseData
contactTol | VehicleData
cubeReflectorDesc | ShapeBaseData
damageEmitter | VehicleData
damageEmitterOffset | VehicleData
damageLevelTolerance | VehicleData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dragForce | HoverVehicleData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dustEmitter | VehicleData
dustHeight | VehicleData
dustTrailEmitter | HoverVehicleData
dustTrailFreqMod | HoverVehicleData
dustTrailOffset | HoverVehicleData
engineSound | HoverVehicleData
exitingWater | VehicleData
exitSplashSoundVelocity | VehicleData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
floatingGravMag | HoverVehicleData
floatingThrustFactor | HoverVehicleData
floatSound | HoverVehicleData
forwardJetEmitter | HoverVehicleData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
gyroDrag | HoverVehicleData
hardImpactSound | VehicleData
hardImpactSpeed | VehicleData
hardSplashSoundVelocity | VehicleData
hidden | SimObject
impactWaterEasy | VehicleData
impactWaterHard | VehicleData
impactWaterMedium | VehicleData
inheritEnergyFromMount | ShapeBaseData
integration | VehicleData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
jetEnergyDrain | VehicleData
jetForce | VehicleData
jetSound | HoverVehicleData
locked | SimObject
mainThrustForce | HoverVehicleData
mass | ShapeBaseData
massBox | VehicleData
massCenter | VehicleData
maxDamage | ShapeBaseData
maxDrag | VehicleData
maxEnergy | ShapeBaseData
maxSteeringAngle | VehicleData
mediumSplashSoundVelocity | VehicleData
minDrag | VehicleData
minImpactSpeed | VehicleData
minJetEnergy | VehicleData
minRollSpeed | VehicleData
name | SimObject
normalForce | HoverVehicleData
numDmgEmitterAreas | VehicleData
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onEnterLiquid(Vehicle obj, float coverage, string type) | VehicleData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onLeaveLiquid(Vehicle obj, string type) | VehicleData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
pitchForce | HoverVehicleData
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
restorativeForce | HoverVehicleData
reverseThrustForce | HoverVehicleData
rollForce | HoverVehicleData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
softImpactSound | VehicleData
softImpactSpeed | VehicleData
softSplashSoundVelocity | VehicleData
splashEmitter | VehicleData
splashFreqMod | VehicleData
splashVelEpsilon | VehicleData
stabDampingConstant | HoverVehicleData
stabLenMax | HoverVehicleData
stabLenMin | HoverVehicleData
stabSpringConstant | HoverVehicleData
steeringForce | HoverVehicleData
strafeThrustForce | HoverVehicleData
superClass | SimObject
triggerDustHeight | VehicleData
triggerTrailHeight | HoverVehicleData
turboFactor | HoverVehicleData
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData
vertFactor | HoverVehicleData
waterWakeSound | VehicleData


Torque 3D - Script Manual: Member List

HTTPObject Member List

This is the complete list of members for HTTPObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
connect(string address) | TCPObject
deepClone() | SimObject
delete() | SimObject
disconnect() | TCPObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
get(string Address, string requirstURI, string query="") | HTTPObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listen(int port) | TCPObject
locked | SimObject
name | SimObject
onConnected() | TCPObject
onConnectFailed() | TCPObject
onConnectionRequest(string address, string ID) | TCPObject
onDisconnect() | TCPObject
onDNSFailed() | TCPObject
onDNSResolved() | TCPObject
onLine(string line) | TCPObject
parentGroup | SimObject
persistentId | SimObject
post(string Address, string requirstURI, string query, string post) | HTTPObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
send(string data) | TCPObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

InteriorInstance Member List

This is the complete list of members for InteriorInstance, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | InteriorInstance |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
exportToCollada(bool bakeTransform) | InteriorInstance |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getModelFile() | InteriorInstance |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getNumDetailLevels() | InteriorInstance |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTargetCount(int detailLevel) | InteriorInstance |
getTargetName(int detailLevel, int targetNum) | InteriorInstance |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
interiorFile | InteriorInstance |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | InteriorInstance | [static]
isRenderEnabled | SceneObject |
isSelectable | InteriorInstance | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAlarmMode(string alarmMode) | InteriorInstance |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setDetailLevel(int level) | InteriorInstance |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
zoneGroup | InteriorInstance |


Torque 3D - Script Manual: Member List

Item Member List

This is the complete list of members for Item, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLastStickyNormal() | Item |
getLastStickyPos() | Item |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Item | [static]
isRenderEnabled | SceneObject |
isRotating() | Item |
isSelectable | Item | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
isStatic() | Item |
locked | SimObject |
maxWarpTicks | Item | [static]
minWarpTicks | Item | [static]
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
onEnterLiquid(string objID, string waterCoverage, string liquidType) | Item |
onLeaveLiquid(string objID, string liquidType) | Item |
onStickyCollision(string objID) | Item |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotate | Item |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setCollisionTimeout(int ignoreColObj=NULL) | Item |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
static | Item |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

ItemData Member List

This is the complete list of members for ItemData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
cameraDefaultFov | ShapeBaseData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
computeCRC | ShapeBaseData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
elasticity | ItemData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
friction | ItemData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
gravityMod | ItemData
hidden | SimObject
inheritEnergyFromMount | ShapeBaseData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lightColor | ItemData
lightOnlyStatic | ItemData
lightRadius | ItemData
LightTime | ItemData
lightType | ItemData
locked | SimObject
mass | ShapeBaseData
maxDamage | ShapeBaseData
maxEnergy | ShapeBaseData
maxVelocity | ItemData
name | SimObject
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
sticky | ItemData
superClass | SimObject
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData


Torque 3D - Script Manual: Member List

LangTable Member List

This is the complete list of members for LangTable, including all inherited members.
addLanguage(string filename,[string languageName]) | LangTable
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCurrentLanguage() | LangTable
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getLangName(int language) | LangTable
getName() | SimObject
getNumLang() | LangTable
getString(string filename) | LangTable
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setCurrentLanguage(int language) | LangTable
setDefaultLanguage(int language) | LangTable
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

LevelInfo Member List

This is the complete list of members for LevelInfo, including all inherited members.
advancedLightmapSupport | LevelInfo
ambientLightBlendCurve | LevelInfo
ambientLightBlendPhase | LevelInfo
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
canvasClearColor | LevelInfo
class | SimObject
className | SimObject
clearScopeToClient(NetConnection client) | NetObject
clone() | SimObject
decalBias | LevelInfo
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fogAtmosphereHeight | LevelInfo
fogColor | LevelInfo
fogDensity | LevelInfo
fogDensityOffset | LevelInfo
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getClientObject() | NetObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGhostID() | NetObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getServerObject() | NetObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isClientObject() | NetObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isServerObject() | NetObject
locked | SimObject
name | SimObject
nearClip | LevelInfo
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scopeToClient(NetConnection client) | NetObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setScopeAlways() | NetObject
setSuperClassNamespace(string name) | SimObject
soundAmbience | LevelInfo
soundDistanceModel | LevelInfo
superClass | SimObject
visibleDistance | LevelInfo


Torque 3D - Script Manual: Member List

LightAnimData Member List

This is the complete list of members for LightAnimData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
brightnessA | LightAnimData
brightnessKeys | LightAnimData
brightnessPeriod | LightAnimData
brightnessSmooth | LightAnimData
brightnessZ | LightAnimData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
colorA | LightAnimData
colorKeys | LightAnimData
colorPeriod | LightAnimData
colorSmooth | LightAnimData
colorZ | LightAnimData
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
offsetA | LightAnimData
offsetKeys | LightAnimData
offsetPeriod | LightAnimData
offsetSmooth | LightAnimData
OffsetZ | LightAnimData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
rotA | LightAnimData
rotKeys | LightAnimData
rotPeriod | LightAnimData
rotSmooth | LightAnimData
rotZ | LightAnimData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

LightBase Member List

This is the complete list of members for LightBase, including all inherited members.
animate | LightBase |
animationPeriod | LightBase |
animationPhase | LightBase |
animationType | LightBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attenuationRatio | LightBase |
brightness | LightBase |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
castShadows | LightBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
color | LightBase |
cookie | LightBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fadeStartDistance | LightBase |
flareScale | LightBase |
flareType | LightBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
includeLightmappedGeometryInShadow | LightBase |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isEnabled | LightBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | LightBase | [static]
isRenderEnabled | SceneObject |
isSelectable | LightBase | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
lastSplitTerrainOnly | LightBase |
locked | SimObject |
logWeight | LightBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
numSplits | LightBase |
overDarkFactor | LightBase |
parentGroup | SimObject |
pauseAnimation | LightBase |
persistentId | SimObject |
playAnimation(LightAnimData anim) | LightBase |
playAnimation() | LightBase |
position | SceneObject |
priority | LightBase |
representedInLightmap | LightBase |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLightEnabled(bool state) | LightBase |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shadowDarkenColor | LightBase |
shadowDistance | LightBase |
shadowSoftness | LightBase |
shadowType | LightBase |
superClass | SimObject |
texSize | LightBase |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

LightDescription Member List

This is the complete list of members for LightDescription, including all inherited members.
animationPeriod | LightDescription
animationPhase | LightDescription
animationType | LightDescription
apply() | LightDescription
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
attenuationRatio | LightDescription
brightness | LightDescription
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
castShadows | LightDescription
class | SimObject
className | SimObject
clone() | SimObject
color | LightDescription
cookie | LightDescription
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fadeStartDistance | LightDescription
flareScale | LightDescription
flareType | LightDescription
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
includeLightmappedGeometryInShadow | LightDescription
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lastSplitTerrainOnly | LightDescription
locked | SimObject
logWeight | LightDescription
name | SimObject
numSplits | LightDescription
overDarkFactor | LightDescription
parentGroup | SimObject
persistentId | SimObject
range | LightDescription
reloadOnLocalClient() | SimDataBlock
representedInLightmap | LightDescription
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowDarkenColor | LightDescription
shadowDistance | LightDescription
shadowSoftness | LightDescription
shadowType | LightDescription
superClass | SimObject
texSize | LightDescription


Torque 3D - Script Manual: Member List

LightFlareData Member List

This is the complete list of members for LightFlareData, including all inherited members.
apply() | LightFlareData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
elementDist | LightFlareData
elementRect | LightFlareData
elementRotate | LightFlareData
elementScale | LightFlareData
elementTint | LightFlareData
elementUseLightColor | LightFlareData
flareEnabled | LightFlareData
flareTexture | LightFlareData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
occlusionRadius | LightFlareData
overallScale | LightFlareData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderReflectPass | LightFlareData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

Lightning Member List

This is the complete list of members for Lightning, including all inherited members.
applyDamage(Point3F hitPosition, Point3F hitNormal, SceneObject hitObject) | Lightning |
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boltStartRadius | Lightning |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
chanceToHitTarget | Lightning |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
color | Lightning |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fadeColor | Lightning |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Lightning | [static]
isRenderEnabled | SceneObject |
isSelectable | Lightning | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
strikeObject(int id=NULL) | Lightning |
strikeRadius | Lightning |
strikeRandomPoint() | Lightning |
strikesPerMinute | Lightning |
strikeWidth | Lightning |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useFog | Lightning |
warningFlashes() | Lightning |


Torque 3D - Script Manual: Member List

LightningData Member List

This is the complete list of members for LightningData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
strikeSound | LightningData
strikeTextures | LightningData
superClass | SimObject
thunderSounds | LightningData


Torque 3D - Script Manual: Member List

Marker Member List

This is the complete list of members for Marker, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Marker | [static]
isRenderEnabled | SceneObject |
isSelectable | Marker | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
msToNext | Marker |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
seqNum | Marker |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
smoothingType | Marker |
superClass | SimObject |
type | Marker |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

Material Member List

This is the complete list of members for Material, including all inherited members.
alphaRef | Material
alphaTest | Material
animFlags | Material
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
baseTex | Material
bumpAtlas | Material
bumpTex | Material
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
castShadows | Material
cellIndex | Material
cellLayout | Material
cellSize | Material
class | SimObject
className | SimObject
clone() | SimObject
colorMultiply | Material
cubemap | Material
customFootstepSound | Material
customImpactSound | Material
deepClone() | SimObject
delete() | SimObject
detailMap | Material
detailNormalMap | Material
detailNormalMapStrength | Material
detailScale | Material
detailTex | Material
diffuseColor | Material
diffuseMap | Material
doubleSided | Material
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpInstances | Material
dumpMethods() | SimObject
dynamicCubemap | Material
effectColor | Material
emissive | Material
envMap | Material
envTex | Material
flush | Material
footstepSoundId | Material
getAnimFlags | Material
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename | Material
SimObject::getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
glow | Material
hidden | SimObject
impactSoundId | Material
internalName | SimObject
isAutoGenerated | Material
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lightMap | Material
locked | SimObject
mapTo | Material
minnaertConstant | Material
name | SimObject
normalMap | Material
overlayMap | Material
overlayTex | Material
parallaxScale | Material
parentGroup | SimObject
persistentId | SimObject
pixelSpecular | Material
planarReflection | Material
reload | Material
rotPivotOffset | Material
rotSpeed | Material
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scrollDir | Material
scrollSpeed | Material
sequenceFramePerSec | Material
sequenceSegmentSize | Material
setAutoGenerated | Material
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
showDust | Material
showFootprints | Material
specular | Material
specularMap | Material
specularPower | Material
subSurface | Material
subSurfaceColor | Material
subSurfaceRolloff | Material
superClass | SimObject
toneMap | Material
translucent | Material
translucentBlendOp | Material
translucentZWrite | Material
useAnisotropic | Material
vertColor | Material
vertLit | Material
waveAmp | Material
waveFreq | Material
waveType | Material


Torque 3D - Script Manual: Member List

MeshRoad Member List

This is the complete list of members for MeshRoad, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
bottomMaterial | MeshRoad |
breakAngle | MeshRoad |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
EditorOpen | MeshRoad | [static]
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | MeshRoad | [static]
isRenderEnabled | SceneObject |
isSelectable | MeshRoad | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
Node | MeshRoad |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
postApply() | MeshRoad |
regenerate() | MeshRoad |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setNodeDepth(int idx, float meters) | MeshRoad |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
showBatches | MeshRoad | [static]
showRoad | MeshRoad | [static]
showSpline | MeshRoad | [static]
sideMaterial | MeshRoad |
superClass | SimObject |
textureLength | MeshRoad |
topMaterial | MeshRoad |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
widthSubdivisions | MeshRoad |
wireframe | MeshRoad | [static]


Torque 3D - Script Manual: Member List

Message Member List

This is the complete list of members for Message, including all inherited members.
addReference() | Message
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
freeReference() | Message
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
getType() | Message
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd() | Message
onRemove() | Message
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

MessageForwarder Member List

This is the complete list of members for MessageForwarder, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd() | ScriptMsgListener
onAddToQueue(string queue) | ScriptMsgListener
onMessageObjectReceived(string queue, Message msg) | ScriptMsgListener
onMessageReceived(string queue, string event, string data) | ScriptMsgListener
onRemove() | ScriptMsgListener
onRemoveFromQueue(string queue) | ScriptMsgListener
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
toQueue | MessageForwarder


Torque 3D - Script Manual: Member List

MessageVector Member List

This is the complete list of members for MessageVector, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | MessageVector
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteLine(int deletePos) | MessageVector
dump(string filename, string header) | MessageVector
dump(string filename) | MessageVector
SimObject::dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getLineIndexByTag(int tag) | MessageVector
getLineTag(int pos) | MessageVector
getLineText(int pos) | MessageVector
getLineTextByTag(int tag) | MessageVector
getName() | SimObject
getNumLines() | MessageVector
getSuperClassNamespace() | SimObject
hidden | SimObject
insertLine(int insertPos, string msg, int tag) | MessageVector
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
popBackLine() | MessageVector
popFrontLine() | MessageVector
pushBackLine(string msg, int tag) | MessageVector
pushFrontLine(string msg, int tag) | MessageVector
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

MissionArea Member List

This is the complete list of members for MissionArea, including all inherited members.
area | MissionArea
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clearScopeToClient(NetConnection client) | NetObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
flightCeiling | MissionArea
flightCeilingRange | MissionArea
getArea() | MissionArea
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getClientObject() | NetObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGhostID() | NetObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getServerObject() | NetObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isClientObject() | NetObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isServerObject() | NetObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
postApply() | MissionArea
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scopeToClient(NetConnection client) | NetObject
setArea(int x, int y, int width, int height) | MissionArea
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setScopeAlways() | NetObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

MissionMarker Member List

This is the complete list of members for MissionMarker, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | MissionMarker | [static]
isRenderEnabled | SceneObject |
isSelectable | MissionMarker | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

MissionMarkerData Member List

This is the complete list of members for MissionMarkerData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
cameraDefaultFov | ShapeBaseData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
computeCRC | ShapeBaseData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
inheritEnergyFromMount | ShapeBaseData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ShapeBaseData
maxDamage | ShapeBaseData
maxEnergy | ShapeBaseData
name | SimObject
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
superClass | SimObject
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData


Torque 3D - Script Manual: Member List

NetConnection Member List

This is the complete list of members for NetConnection, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
checkMaxRate() | NetConnection
class | SimObject
className | SimObject
clear() | SimSet
clearPaths() | NetConnection
clone() | SimObject
connect(string remoteAddress) | NetConnection
connectLocal() | NetConnection
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAddress() | NetConnection
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGhostID(int realID) | NetConnection
getGhostsActive() | NetConnection
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getPacketLoss() | NetConnection
getPing() | NetConnection
getRandom() | SimSet
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
parentGroup | SimObject
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
resolveGhostID(int ghostID) | NetConnection
resolveObjectFromGhostIndex(int ghostID) | NetConnection
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSimulatedNetParams(float packetLoss, int delay) | NetConnection
setSuperClassNamespace(string name) | SimObject
sort(string callbackFunction) | SimSet
superClass | SimObject
transmitPaths() | NetConnection


Torque 3D - Script Manual: Member List

NetObject Member List

This is the complete list of members for NetObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clearScopeToClient(NetConnection client) | NetObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getClientObject() | NetObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGhostID() | NetObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getServerObject() | NetObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isClientObject() | NetObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isServerObject() | NetObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scopeToClient(NetConnection client) | NetObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setScopeAlways() | NetObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

OcclusionVolume Member List

This is the complete list of members for OcclusionVolume, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
edge | OcclusionVolume |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | OcclusionVolume | [static]
isRenderEnabled | SceneObject |
isSelectable | OcclusionVolume | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
plane | OcclusionVolume |
point | OcclusionVolume |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

OpenFileDialog Member List

This is the complete list of members for OpenFileDialog, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
changePath | FileDialog
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
defaultFile | FileDialog
defaultPath | FileDialog
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Execute() | FileDialog
fileName | FileDialog
filters | FileDialog
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
MultipleFiles | OpenFileDialog
MustExist | OpenFileDialog
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
title | FileDialog


Torque 3D - Script Manual: Member List

OpenFolderDialog Member List

This is the complete list of members for OpenFolderDialog, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
changePath | FileDialog
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
defaultFile | FileDialog
defaultPath | FileDialog
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Execute() | FileDialog
fileMustExist | OpenFolderDialog
fileName | FileDialog
filters | FileDialog
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
MultipleFiles | OpenFileDialog
MustExist | OpenFileDialog
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
title | FileDialog


Torque 3D - Script Manual: Member List

ParticleData Member List

This is the complete list of members for ParticleData, including all inherited members.
animateTexture | ParticleData
animTexFrames | ParticleData
animTexName | ParticleData
animTexTiling | ParticleData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
colors | ParticleData
constantAcceleration | ParticleData
deepClone() | SimObject
delete() | SimObject
dragCoefficient | ParticleData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
framesPerSec | ParticleData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
gravityCoefficient | ParticleData
hidden | SimObject
inheritedVelFactor | ParticleData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifetimeMS | ParticleData
lifetimeVarianceMS | ParticleData
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
reload() | ParticleData
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
sizes | ParticleData
spinRandomMax | ParticleData
spinRandomMin | ParticleData
spinSpeed | ParticleData
superClass | SimObject
textureCoords | ParticleData
textureName | ParticleData
times | ParticleData
useInvAlpha | ParticleData
windCoefficient | ParticleData


Torque 3D - Script Manual: Member List

ParticleEmitter Member List

This is the complete list of members for ParticleEmitter, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | ParticleEmitter | [static]
isRenderEnabled | SceneObject |
isSelectable | ParticleEmitter | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

ParticleEmitterData Member List

This is the complete list of members for ParticleEmitterData, including all inherited members.
alignDirection | ParticleEmitterData
alignParticles | ParticleEmitterData
ambientFactor | ParticleEmitterData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
blendStyle | ParticleEmitterData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
ejectionOffset | ParticleEmitterData
ejectionPeriodMS | ParticleEmitterData
ejectionVelocity | ParticleEmitterData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
highResOnly | ParticleEmitterData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifetimeMS | ParticleEmitterData
lifetimeVarianceMS | ParticleEmitterData
locked | SimObject
name | SimObject
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
orientOnVelocity | ParticleEmitterData
orientParticles | ParticleEmitterData
overrideAdvance | ParticleEmitterData
parentGroup | SimObject
particles | ParticleEmitterData
periodVarianceMS | ParticleEmitterData
persistentId | SimObject
phiReferenceVel | ParticleEmitterData
phiVariance | ParticleEmitterData
reload() | ParticleEmitterData
reloadOnLocalClient() | SimDataBlock
renderReflection | ParticleEmitterData
reverseOrder | ParticleEmitterData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
softnessDistance | ParticleEmitterData
sortParticles | ParticleEmitterData
superClass | SimObject
textureName | ParticleEmitterData
thetaMax | ParticleEmitterData
thetaMin | ParticleEmitterData
useEmitterColors | ParticleEmitterData
useEmitterSizes | ParticleEmitterData
velocityVariance | ParticleEmitterData


Torque 3D - Script Manual: Member List

ParticleEmitterNode Member List

This is the complete list of members for ParticleEmitterNode, including all inherited members.
active | ParticleEmitterNode |
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
emitter | ParticleEmitterNode |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | ParticleEmitterNode | [static]
isRenderEnabled | SceneObject |
isSelectable | ParticleEmitterNode | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setActive(bool active) | ParticleEmitterNode |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEmitterDataBlock(ParticleEmitterData emitterDatablock=0) | ParticleEmitterNode |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
velocity | ParticleEmitterNode |


Torque 3D - Script Manual: Member List

ParticleEmitterNodeData Member List

This is the complete list of members for ParticleEmitterNodeData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
timeMultiple | ParticleEmitterNodeData


Torque 3D - Script Manual: Member List

Path Member List

This is the complete list of members for Path, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getPathId() | Path
getRandom() | SimSet
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isLooping | Path
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
parentGroup | SimObject
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
sort(string callbackFunction) | SimSet
superClass | SimObject


Torque 3D - Script Manual: Member List

PathCamera Member List

This is the complete list of members for PathCamera, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PathCamera | [static]
isRenderEnabled | SceneObject |
isSelectable | PathCamera | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
onNode(string node) | PathCamera |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
popFront() | PathCamera |
position | SceneObject |
pushBack(TransformF transform, float speed=1.0, string type="Normal", string path="Linear") | PathCamera |
pushFront(TransformF transform, float speed=1.0, string type="Normal", string path="Linear") | PathCamera |
reset(float speed=1.0f) | PathCamera |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setPosition(float position=0.0f) | PathCamera |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setState(string newState="forward") | PathCamera |
setSuperClassNamespace(string name) | SimObject |
setTarget(float position=1.0f) | PathCamera |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

PathCameraData Member List

This is the complete list of members for PathCameraData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
cameraDefaultFov | ShapeBaseData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
computeCRC | ShapeBaseData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
inheritEnergyFromMount | ShapeBaseData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ShapeBaseData
maxDamage | ShapeBaseData
maxEnergy | ShapeBaseData
name | SimObject
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
superClass | SimObject
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData


Torque 3D - Script Manual: Member List

PfxVis Member List

This is the complete list of members for PfxVis, including all inherited members.
clear() | PfxVis
hide() | PfxVis
onWindowClosed(GuiWindowCtrl *ctrl) | PfxVis
open(PostEffect effect, bool clear) | PfxVis
show() | PfxVis


Torque 3D - Script Manual: Member List

PhysicalZone Member List

This is the complete list of members for PhysicalZone, including all inherited members.
activate() | PhysicalZone |
appliedForce | PhysicalZone |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deactivate() | PhysicalZone |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
gravityMod | PhysicalZone |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PhysicalZone | [static]
isRenderEnabled | SceneObject |
isSelectable | PhysicalZone | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
polyhedron | PhysicalZone |
position | SceneObject |
renderZones | PhysicalZone | [static]
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
velocityMod | PhysicalZone |


Torque 3D - Script Manual: Member List

PhysicsDebris Member List

This is the complete list of members for PhysicsDebris, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PhysicsDebris | [static]
isRenderEnabled | SceneObject |
isSelectable | PhysicsDebris | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

PhysicsDebrisData Member List

This is the complete list of members for PhysicsDebrisData, including all inherited members.
angularDamping | PhysicsDebrisData
angularSleepThreshold | PhysicsDebrisData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
buoyancyDensity | PhysicsDebrisData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
castShadows | PhysicsDebrisData
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
friction | PhysicsDebrisData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifetime | PhysicsDebrisData
lifetimeVariance | PhysicsDebrisData
linearDamping | PhysicsDebrisData
linearSleepThreshold | PhysicsDebrisData
locked | SimObject
mass | PhysicsDebrisData
name | SimObject
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
preload | PhysicsDebrisData
reloadOnLocalClient() | SimDataBlock
restitution | PhysicsDebrisData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shapeFile | PhysicsDebrisData
staticFriction | PhysicsDebrisData
superClass | SimObject
waterDampingScale | PhysicsDebrisData


Torque 3D - Script Manual: Member List

PhysicsForce Member List

This is the complete list of members for PhysicsForce, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attach(Point3F start, Point3F direction, float maxDist) | PhysicsForce |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
detach(Point3F force=Point3F::Zero) | PhysicsForce |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isAttached() | PhysicsForce |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PhysicsForce | [static]
isRenderEnabled | SceneObject |
isSelectable | PhysicsForce | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

PhysicsShape Member List

This is the complete list of members for PhysicsShape, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroy() | PhysicsShape |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isDestroyed() | PhysicsShape |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PhysicsShape | [static]
isRenderEnabled | SceneObject |
isSelectable | PhysicsShape | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
noCorrections | PhysicsShape | [static]
noSmoothing | PhysicsShape | [static]
parentGroup | SimObject |
persistentId | SimObject |
playAmbient | PhysicsShape |
position | SceneObject |
restore() | PhysicsShape |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

PhysicsShapeData Member List

This is the complete list of members for PhysicsShapeData, including all inherited members.
angularDamping | PhysicsShapeData
angularSleepThreshold | PhysicsShapeData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
buoyancyDensity | PhysicsShapeData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
Debris | PhysicsShapeData
deepClone() | SimObject
delete() | SimObject
destroyedShape | PhysicsShapeData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Explosion | PhysicsShapeData
friction | PhysicsShapeData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
linearDamping | PhysicsShapeData
linearSleepThreshold | PhysicsShapeData
locked | SimObject
mass | PhysicsShapeData
name | SimObject
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
restitution | PhysicsShapeData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shapeName | PhysicsShapeData
simType | PhysicsShapeData
staticFriction | PhysicsShapeData
superClass | SimObject
waterDampingScale | PhysicsShapeData


Torque 3D - Script Manual: Member List

Player Member List

This is the complete list of members for Player, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
checkDismountPoint(Point3F oldPos, Point3F pos) | Player |
class | SimObject |
className | SimObject |
clearControlObject() | Player |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getControlObject() | Player |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamageLocation(Point3F pos) | Player |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getState() | Player |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Player | [static]
isRenderEnabled | SceneObject |
isSelectable | Player | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
maxPredictionTicks | Player | [static]
maxWarpTicks | Player | [static]
minWarpTicks | Player | [static]
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
renderCollision | Player | [static]
renderMyItems | Player | [static]
renderMyPlayer | Player | [static]
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setActionThread(string name, bool hold=false, bool fsp=true) | Player |
setAllMeshesHidden(bool hide) | ShapeBase |
setArmThread(string name) | Player |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setControlObject(ShapeBase obj) | Player |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

PlayerData Member List

This is the complete list of members for PlayerData, including all inherited members.
airControl | PlayerData
animationDone(Player obj) | PlayerData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
boundingBox | PlayerData
boxHeadBackPercentage | PlayerData
boxHeadFrontPercentage | PlayerData
boxHeadLeftPercentage | PlayerData
boxHeadPercentage | PlayerData
boxHeadRightPercentage | PlayerData
boxTorsoPercentage | PlayerData
bubbleEmitTime | PlayerData
call(string method, string args...) | SimObject
cameraDefaultFov | ShapeBaseData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
computeCRC | ShapeBaseData
crouchBoundingBox | PlayerData
crouchForce | PlayerData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
DecalData | PlayerData
decalOffset | PlayerData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
doDismount(Player obj) | PlayerData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dustEmitter | PlayerData
exitingWater | PlayerData
exitSplashSoundVelocity | PlayerData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
FootBubblesSound | PlayerData
FootHardSound | PlayerData
FootMetalSound | PlayerData
footPuffEmitter | PlayerData
footPuffNumParts | PlayerData
footPuffRadius | PlayerData
FootShallowSound | PlayerData
FootSnowSound | PlayerData
FootSoftSound | PlayerData
footstepSplashHeight | PlayerData
FootUnderwaterSound | PlayerData
FootWadingSound | PlayerData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
groundImpactMinSpeed | PlayerData
groundImpactShakeAmp | PlayerData
groundImpactShakeDuration | PlayerData
groundImpactShakeFalloff | PlayerData
groundImpactShakeFreq | PlayerData
hardSplashSoundVelocity | PlayerData
hidden | SimObject
horizMaxSpeed | PlayerData
horizResistFactor | PlayerData
horizResistSpeed | PlayerData
impactHardSound | PlayerData
impactMetalSound | PlayerData
impactSnowSound | PlayerData
impactSoftSound | PlayerData
impactWaterEasy | PlayerData
impactWaterHard | PlayerData
impactWaterMedium | PlayerData
inheritEnergyFromMount | ShapeBaseData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
jetJumpEnergyDrain | PlayerData
jetJumpForce | PlayerData
jetJumpSurfaceAngle | PlayerData
jetMaxJumpSpeed | PlayerData
jetMinJumpEnergy | PlayerData
jetMinJumpSpeed | PlayerData
jumpDelay | PlayerData
jumpEnergyDrain | PlayerData
jumpForce | PlayerData
jumpSurfaceAngle | PlayerData
jumpTowardsNormal | PlayerData
locked | SimObject
mass | ShapeBaseData
maxBackwardSpeed | PlayerData
maxCrouchBackwardSpeed | PlayerData
maxCrouchForwardSpeed | PlayerData
maxCrouchSideSpeed | PlayerData
maxDamage | ShapeBaseData
maxEnergy | ShapeBaseData
maxForwardSpeed | PlayerData
maxFreelookAngle | PlayerData
maxJumpSpeed | PlayerData
maxLookAngle | PlayerData
maxProneBackwardSpeed | PlayerData
maxProneForwardSpeed | PlayerData
maxProneSideSpeed | PlayerData
maxSideSpeed | PlayerData
maxStepHeight | PlayerData
maxTimeScale | PlayerData
maxUnderwaterBackwardSpeed | PlayerData
maxUnderwaterForwardSpeed | PlayerData
maxUnderwaterSideSpeed | PlayerData
mediumSplashSoundVelocity | PlayerData
minImpactSpeed | PlayerData
minJumpEnergy | PlayerData
minJumpSpeed | PlayerData
minLookAngle | PlayerData
minRunEnergy | PlayerData
movingBubblesSound | PlayerData
name | SimObject
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onEnterLiquid(Player obj, float coverage, string type) | PlayerData
onEnterMissionArea(Player obj) | PlayerData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onLeaveLiquid(Player obj, string type) | PlayerData
onLeaveMissionArea(Player obj) | PlayerData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onStartSwim(Player obj) | PlayerData
onStopSwim(Player obj) | PlayerData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
physicsPlayerType | PlayerData
pickupRadius | PlayerData
proneBoundingBox | PlayerData
proneForce | PlayerData
recoverDelay | PlayerData
recoverRunForceScale | PlayerData
reloadOnLocalClient() | SimDataBlock
renderFirstPerson | PlayerData
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
runEnergyDrain | PlayerData
runForce | PlayerData
runSurfaceAngle | PlayerData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
Splash | PlayerData
splashAngle | PlayerData
splashEmitter | PlayerData
splashFreqMod | PlayerData
splashVelEpsilon | PlayerData
splashVelocity | PlayerData
superClass | SimObject
swimBoundingBox | PlayerData
swimForce | PlayerData
underwaterExplosion | ShapeBaseData
upMaxSpeed | PlayerData
upResistFactor | PlayerData
upResistSpeed | PlayerData
useEyePoint | ShapeBaseData
waterBreathSound | PlayerData


Torque 3D - Script Manual: Member List

PointLight Member List

This is the complete list of members for PointLight, including all inherited members.
animate | LightBase |
animationPeriod | LightBase |
animationPhase | LightBase |
animationType | LightBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attenuationRatio | LightBase |
brightness | LightBase |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
castShadows | LightBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
color | LightBase |
cookie | LightBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fadeStartDistance | LightBase |
flareScale | LightBase |
flareType | LightBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
includeLightmappedGeometryInShadow | LightBase |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isEnabled | LightBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PointLight | [static]
isRenderEnabled | SceneObject |
isSelectable | PointLight | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
lastSplitTerrainOnly | LightBase |
locked | SimObject |
logWeight | LightBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
numSplits | LightBase |
overDarkFactor | LightBase |
parentGroup | SimObject |
pauseAnimation | LightBase |
persistentId | SimObject |
playAnimation(LightAnimData anim) | LightBase |
playAnimation() | LightBase |
position | SceneObject |
priority | LightBase |
radius | PointLight |
representedInLightmap | LightBase |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLightEnabled(bool state) | LightBase |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shadowDarkenColor | LightBase |
shadowDistance | LightBase |
shadowSoftness | LightBase |
shadowType | LightBase |
superClass | SimObject |
texSize | LightBase |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

Portal Member List

This is the complete list of members for Portal, including all inherited members.
ambientLightColor | Zone |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
backSidePassable | Portal |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
dumpZoneState(bool updateFirst=true) | Zone |
edge | Zone |
frontSidePassable | Portal |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
getZoneId() | Zone |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isExteriorPortal() | Portal |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isInteriorPortal() | Portal |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Portal | [static]
isRenderEnabled | SceneObject |
isSelectable | Portal | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
plane | Zone |
point | Zone |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
soundAmbience | Zone |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useAmbientLightColor | Zone |
zoneGroup | Zone |


Torque 3D - Script Manual: Member List

PostEffect Member List

This is the complete list of members for PostEffect, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
allowReflectPass | PostEffect
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clearShaderMacros() | PostEffect
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
disable() | PostEffect
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dumpShaderDisassembly() | PostEffect
enable() | PostEffect
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAspectRatio() | PostEffect
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getRandom() | SimSet
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isEnabled | PostEffect
isEnabled() | PostEffect
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listObjects() | SimSet
locked | SimObject
name | SimObject
onAdd() | PostEffect
onDisabled() | PostEffect
oneFrameOnly | PostEffect
onEnabled() | PostEffect
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onThisFrame | PostEffect
parentGroup | SimObject
persistentId | SimObject
preProcess() | PostEffect
pushToBack(SimObject obj) | SimSet
reload() | PostEffect
remove(SimObject objects...) | SimSet
removeShaderMacro(string key) | PostEffect
renderBin | PostEffect
renderPriority | PostEffect
renderTime | PostEffect
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setShaderConst(string name, string value) | PostEffect
setShaderConsts() | PostEffect
setShaderMacro(string key, string value="") | PostEffect
setSuperClassNamespace(string name) | SimObject
shader | PostEffect
skip | PostEffect
sort(string callbackFunction) | SimSet
stateBlock | PostEffect
superClass | SimObject
target | PostEffect
targetClear | PostEffect
targetClearColor | PostEffect
targetDepthStencil | PostEffect
targetFormat | PostEffect
targetScale | PostEffect
targetSize | PostEffect
texture | PostEffect
toggle() | PostEffect


Torque 3D - Script Manual: Member List

Precipitation Member List

This is the complete list of members for Precipitation, including all inherited members.
animateSplashes | Precipitation |
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
boxHeight | Precipitation |
boxWidth | Precipitation |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
doCollision | Precipitation |
dropAnimateMS | Precipitation |
dropSize | Precipitation |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fadeDist | Precipitation |
fadeDistEnd | Precipitation |
followCam | Precipitation |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
glowIntensity | Precipitation |
hidden | SimObject |
hitPlayers | Precipitation |
hitVehicles | Precipitation |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Precipitation | [static]
isRenderEnabled | SceneObject |
isSelectable | Precipitation | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
maxMass | Precipitation |
maxSpeed | Precipitation |
maxTurbulence | Precipitation |
minMass | Precipitation |
minSpeed | Precipitation |
modifyStorm(float percentage=1.0f, float length=5.0f) | Precipitation |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
numDrops | Precipitation |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
reflect | Precipitation |
rotateWithCamVel | Precipitation |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setPercentage(float percentage=1.0f) | Precipitation |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
setTurbulence(float max=1.0f, float speed=5.0f, float seconds=5.0) | Precipitation |
splashMS | Precipitation |
splashSize | Precipitation |
superClass | SimObject |
turbulenceSpeed | Precipitation |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useLighting | Precipitation |
useTrueBillboards | Precipitation |
useTurbulence | Precipitation |
useWind | Precipitation |


Torque 3D - Script Manual: Member List

PrecipitationData Member List

This is the complete list of members for PrecipitationData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dropShader | PrecipitationData
dropsPerSide | PrecipitationData
dropTexture | PrecipitationData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
soundProfile | PrecipitationData
splashesPerSide | PrecipitationData
splashShader | PrecipitationData
splashTexture | PrecipitationData
superClass | SimObject


Torque 3D - Script Manual: Member List

Prefab Member List

This is the complete list of members for Prefab, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fileName | Prefab |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Prefab | [static]
isRenderEnabled | SceneObject |
isSelectable | Prefab | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
onLoad(SimGroup children) | Prefab |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

Projectile Member List

This is the complete list of members for Projectile, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
initialPosition | Projectile |
initialVelocity | Projectile |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Projectile | [static]
isRenderEnabled | SceneObject |
isSelectable | Projectile | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
presimulate(float seconds=1.0f) | Projectile |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
sourceObject | Projectile |
sourceSlot | Projectile |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

ProjectileData Member List

This is the complete list of members for ProjectileData, including all inherited members.
armingDelay | ProjectileData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bounceElasticity | ProjectileData
bounceFriction | ProjectileData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
decal | ProjectileData
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Explosion | ProjectileData
fadeDelay | ProjectileData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
gravityMod | ProjectileData
hidden | SimObject
impactForce | ProjectileData
internalName | SimObject
isBallistic | ProjectileData
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifetime | ProjectileData
lightDesc | ProjectileData
locked | SimObject
muzzleVelocity | ProjectileData
name | SimObject
onAdd(GameBase obj) | GameBaseData
onCollision(Projectile proj, SceneObject col, float fade, Point3F pos, Point3F normal) | ProjectileData
onExplode(Projectile proj, Point3F pos, float fade) | ProjectileData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
ParticleEmitter | ProjectileData
particleWaterEmitter | ProjectileData
persistentId | SimObject
projectileShapeName | ProjectileData
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
scale | ProjectileData
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
sound | ProjectileData
Splash | ProjectileData
superClass | SimObject
velInheritFactor | ProjectileData
waterExplosion | ProjectileData


Torque 3D - Script Manual: Member List

PxCloth Member List

This is the complete list of members for PxCloth, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attachments | PxCloth |
bending | PxCloth |
bendingStiffness | PxCloth |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
damping | PxCloth |
dampingCoefficient | PxCloth |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
density | PxCloth |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
friction | PxCloth |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PxCloth | [static]
isRenderEnabled | SceneObject |
isSelectable | PxCloth | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
Material | PxCloth |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
samples | PxCloth |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
selfCollision | PxCloth |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
size | PxCloth |
superClass | SimObject |
thickness | PxCloth |
triangleCollision | PxCloth |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

PxMaterial Member List

This is the complete list of members for PxMaterial, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dynamicFriction | PxMaterial
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
restitution | PxMaterial
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
staticFriction | PxMaterial
superClass | SimObject


Torque 3D - Script Manual: Member List

PxMultiActor Member List

This is the complete list of members for PxMultiActor, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
broken | PxMultiActor |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
debugRender | PxMultiActor |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | PxMultiActor | [static]
isRenderEnabled | SceneObject |
isSelectable | PxMultiActor | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
listMeshes(enum Hidden/Shown/All) | PxMultiActor |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllHidden(bool) | PxMultiActor |
setBroken(bool) | PxMultiActor |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string meshName, bool isHidden) | PxMultiActor |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

PxMultiActorData Member List

This is the complete list of members for PxMultiActorData, including all inherited members.
angularDrag | PxMultiActorData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
breakForce | PxMultiActorData
buoyancyDensity | PxMultiActorData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clientOnly | PxMultiActorData
clone() | SimObject
correctionNode0 | PxMultiActorData
correctionNode1 | PxMultiActorData
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dumpModel | PxMultiActorData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
linearDrag | PxMultiActorData
locked | SimObject
Material | PxMultiActorData
mountNode0 | PxMultiActorData
mountNode1 | PxMultiActorData
mountNode10 | PxMultiActorData
mountNode11 | PxMultiActorData
mountNode12 | PxMultiActorData
mountNode13 | PxMultiActorData
mountNode14 | PxMultiActorData
mountNode15 | PxMultiActorData
mountNode16 | PxMultiActorData
mountNode17 | PxMultiActorData
mountNode18 | PxMultiActorData
mountNode19 | PxMultiActorData
mountNode2 | PxMultiActorData
mountNode20 | PxMultiActorData
mountNode21 | PxMultiActorData
mountNode22 | PxMultiActorData
mountNode23 | PxMultiActorData
mountNode24 | PxMultiActorData
mountNode25 | PxMultiActorData
mountNode26 | PxMultiActorData
mountNode27 | PxMultiActorData
mountNode28 | PxMultiActorData
mountNode29 | PxMultiActorData
mountNode3 | PxMultiActorData
mountNode30 | PxMultiActorData
mountNode31 | PxMultiActorData
mountNode4 | PxMultiActorData
mountNode5 | PxMultiActorData
mountNode6 | PxMultiActorData
mountNode7 | PxMultiActorData
mountNode8 | PxMultiActorData
mountNode9 | PxMultiActorData
name | SimObject
noCorrection | PxMultiActorData
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
physXStream | PxMultiActorData
reload | PxMultiActorData
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shapeName | PxMultiActorData
singlePlayerOnly | PxMultiActorData
superClass | SimObject
waterDragScale | PxMultiActorData


Torque 3D - Script Manual: Member List

RadialImpulseEvent Member List

This is the complete list of members for RadialImpulseEvent, including all inherited members.
send(string inPosition="1.0 1.0 1.0", float radius=10.0f, float magnitude=20.0f) RadialImpulseEvent [static]


Torque 3D - Script Manual: Member List

ReflectorDesc Member List

This is the complete list of members for ReflectorDesc, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
detailAdjust | ReflectorDesc
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
farDist | ReflectorDesc
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
maxRateMs | ReflectorDesc
name | SimObject
nearDist | ReflectorDesc
objectTypeMask | ReflectorDesc
parentGroup | SimObject
persistentId | SimObject
priority | ReflectorDesc
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
texSize | ReflectorDesc
useOcclusionQuery | ReflectorDesc


Torque 3D - Script Manual: Member List

RenderBinManager Member List

This is the complete list of members for RenderBinManager, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderFormatToken Member List

This is the complete list of members for RenderFormatToken, including all inherited members.
aaLevel | RenderFormatToken
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
copyEffect | RenderFormatToken
deepClone() | SimObject
delete() | SimObject
depthFormat | RenderFormatToken
disable() | RenderPassStateToken
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
enable() | RenderPassStateToken
enabled | RenderPassStateToken
format | RenderFormatToken
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
resolveEffect | RenderFormatToken
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
toggle() | RenderPassStateToken


Torque 3D - Script Manual: Member List

RenderGlowMgr Member List

This is the complete list of members for RenderGlowMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderImposterMgr Member List

This is the complete list of members for RenderImposterMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderMeshExample Member List

This is the complete list of members for RenderMeshExample, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | RenderMeshExample | [static]
isRenderEnabled | SceneObject |
isSelectable | RenderMeshExample | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
Material | RenderMeshExample |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
postApply() | RenderMeshExample |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

RenderMeshMgr Member List

This is the complete list of members for RenderMeshMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderObjectExample Member List

This is the complete list of members for RenderObjectExample, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | RenderObjectExample | [static]
isRenderEnabled | SceneObject |
isSelectable | RenderObjectExample | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

RenderObjectMgr Member List

This is the complete list of members for RenderObjectMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderOcclusionMgr Member List

This is the complete list of members for RenderOcclusionMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
binType | RenderBinManager |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clone() | SimObject |
debugRender | RenderOcclusionMgr | [static]
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getBinType() | RenderBinManager |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getName() | SimObject |
getSuperClassNamespace() | SimObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
locked | SimObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
processAddOrder | RenderBinManager |
renderOrder | RenderBinManager |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
schedule(float time, string method, string args...) | SimObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setSuperClassNamespace(string name) | SimObject |
superClass | SimObject |


Torque 3D - Script Manual: Member List

RenderParticleMgr Member List

This is the complete list of members for RenderParticleMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderPassManager Member List

This is the complete list of members for RenderPassManager, including all inherited members.
addManager(RenderBinManager renderBin) | RenderPassManager
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getManager(int index) | RenderPassManager
getManagerCount() | RenderPassManager
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
removeManager(RenderBinManager renderBin) | RenderPassManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderPassStateBin Member List

This is the complete list of members for RenderPassStateBin, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
stateToken | RenderPassStateBin
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderPassStateToken Member List

This is the complete list of members for RenderPassStateToken, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
disable() | RenderPassStateToken
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
enable() | RenderPassStateToken
enabled | RenderPassStateToken
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
toggle() | RenderPassStateToken


Torque 3D - Script Manual: Member List

RenderPrePassMgr Member List

This is the complete list of members for RenderPrePassMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderShapeExample Member List

This is the complete list of members for RenderShapeExample, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | RenderShapeExample | [static]
isRenderEnabled | SceneObject |
isSelectable | RenderShapeExample | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shapeFile | RenderShapeExample |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

RenderTerrainMgr Member List

This is the complete list of members for RenderTerrainMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
binType | RenderBinManager |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getBinType() | RenderBinManager |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getName() | SimObject |
getSuperClassNamespace() | SimObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
locked | SimObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
processAddOrder | RenderBinManager |
renderOrder | RenderBinManager |
renderWireframe | RenderTerrainMgr | [static]
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
schedule(float time, string method, string args...) | SimObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setSuperClassNamespace(string name) | SimObject |
superClass | SimObject |


Torque 3D - Script Manual: Member List

RenderTexTargetBinManager Member List

This is the complete list of members for RenderTexTargetBinManager, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RenderTranslucentMgr Member List

This is the complete list of members for RenderTranslucentMgr, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
binType | RenderBinManager
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getBinType() | RenderBinManager
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
processAddOrder | RenderBinManager
renderOrder | RenderBinManager
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

RigidShape Member List

This is the complete list of members for RigidShape, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
freezeSim(bool isFrozen) | RigidShape |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | RigidShape | [static]
isRenderEnabled | SceneObject |
isSelectable | RigidShape | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
onEnterLiquid(string objId, string waterCoverage, string liquidType) | RigidShape |
onLeaveLiquid(string objId, string liquidType) | RigidShape |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
reset() | RigidShape |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

RigidShapeData Member List

This is the complete list of members for RigidShapeData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bodyFriction | RigidShapeData
bodyRestitution | RigidShapeData
call(string method, string args...) | SimObject
cameraDecay | RigidShapeData
cameraDefaultFov | ShapeBaseData
cameraLag | RigidShapeData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
cameraOffset | RigidShapeData
cameraRoll | RigidShapeData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
collisionTol | RigidShapeData
computeCRC | ShapeBaseData
contactTol | RigidShapeData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dragForce | RigidShapeData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dustEmitter | RigidShapeData
dustHeight | RigidShapeData
dustTrailEmitter | RigidShapeData
exitingWater | RigidShapeData
exitSplashSoundVelocity | RigidShapeData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hardImpactSound | RigidShapeData
hardImpactSpeed | RigidShapeData
hardSplashSoundVelocity | RigidShapeData
hidden | SimObject
impactWaterEasy | RigidShapeData
impactWaterHard | RigidShapeData
impactWaterMedium | RigidShapeData
inheritEnergyFromMount | ShapeBaseData
integration | RigidShapeData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ShapeBaseData
massBox | RigidShapeData
massCenter | RigidShapeData
maxDamage | ShapeBaseData
maxDrag | RigidShapeData
maxEnergy | ShapeBaseData
mediumSplashSoundVelocity | RigidShapeData
minDrag | RigidShapeData
minImpactSpeed | RigidShapeData
minRollSpeed | RigidShapeData
name | SimObject
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
softImpactSound | RigidShapeData
softImpactSpeed | RigidShapeData
softSplashSoundVelocity | RigidShapeData
splashEmitter | RigidShapeData
splashFreqMod | RigidShapeData
splashVelEpsilon | RigidShapeData
superClass | SimObject
triggerDustHeight | RigidShapeData
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData
vertFactor | RigidShapeData
waterWakeSound | RigidShapeData


Torque 3D - Script Manual: Member List

River Member List

This is the complete list of members for River, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
baseColor | WaterObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
clarity | WaterObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
cubemap | WaterObject |
deepClone() | SimObject |
delete() | SimObject |
density | WaterObject |
depthGradientMax | WaterObject |
depthGradientTex | WaterObject |
distortEndDist | WaterObject |
distortFullDepth | WaterObject |
distortStartDist | WaterObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
EditorOpen | River | [static]
emissive | WaterObject |
FlowMagnitude | River |
foamAmbientLerp | WaterObject |
foamDir | WaterObject |
foamMaxDepth | WaterObject |
foamOpacity | WaterObject |
foamRippleInfluence | WaterObject |
foamSpeed | WaterObject |
foamTex | WaterObject |
foamTexScale | WaterObject |
fresnelBias | WaterObject |
fresnelPower | WaterObject |
fullReflect | WaterObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | River | [static]
isRenderEnabled | SceneObject |
isSelectable | River | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
liquidType | WaterObject |
locked | SimObject |
LowLODDistance | River |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
Node | River |
overallFoamOpacity | WaterObject |
overallRippleMagnitude | WaterObject |
overallWaveMagnitude | WaterObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
reflectDetailAdjust | WaterObject |
reflectivity | WaterObject |
reflectMaxRateMs | WaterObject |
reflectNormalUp | WaterObject |
reflectPriority | WaterObject |
reflectTexSize | WaterObject |
regenerate() | River |
rippleDir | WaterObject |
rippleMagnitude | WaterObject |
rippleSpeed | WaterObject |
rippleTex | WaterObject |
rippleTexScale | WaterObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
SegmentLength | River |
setBatchSize(float meters) | River |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMaxDivisionSize(float meters) | River |
setMetersPerSegment(float meters) | River |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setNodeDepth(int idx, float meters) | River |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
showNodes | River | [static]
showRiver | River | [static]
showSpline | River | [static]
showWalls | River | [static]
showWireframe | River | [static]
soundAmbience | WaterObject |
specularColor | WaterObject |
specularPower | WaterObject |
SubdivideLength | River |
superClass | SimObject |
underwaterColor | WaterObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useOcclusionQuery | WaterObject |
viscosity | WaterObject |
waterFogDensity | WaterObject |
waterFogDensityOffset | WaterObject |
waveDir | WaterObject |
waveMagnitude | WaterObject |
waveSpeed | WaterObject |
wetDarkening | WaterObject |
wetDepth | WaterObject |
wireframe | WaterObject | [static]


Torque 3D - Script Manual: Member List

SaveFileDialog Member List

This is the complete list of members for SaveFileDialog, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
changePath | FileDialog
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
defaultFile | FileDialog
defaultPath | FileDialog
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Execute() | FileDialog
fileName | FileDialog
filters | FileDialog
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
OverwritePrompt | SaveFileDialog
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
title | FileDialog


Torque 3D - Script Manual: Member List

ScatterSky Member List

This is the complete list of members for ScatterSky, including all inherited members.
ambientScale | ScatterSky |
applyChanges() | ScatterSky |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attenuationRatio | ScatterSky |
azimuth | ScatterSky |
brightness | ScatterSky |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
castShadows | ScatterSky |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
cookie | ScatterSky |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
elevation | ScatterSky |
exposure | ScatterSky |
fadeStartDistance | ScatterSky |
flareScale | ScatterSky |
flareType | ScatterSky |
fogScale | ScatterSky |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
includeLightmappedGeometryInShadow | ScatterSky |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | ScatterSky | [static]
isRenderEnabled | SceneObject |
isSelectable | ScatterSky | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
lastSplitTerrainOnly | ScatterSky |
locked | SimObject |
logWeight | ScatterSky |
mieScattering | ScatterSky |
moonAzimuth | ScatterSky |
moonElevation | ScatterSky |
moonEnabled | ScatterSky |
moonLightColor | ScatterSky |
moonMat | ScatterSky |
moonScale | ScatterSky |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
nightColor | ScatterSky |
nightCubemap | ScatterSky |
nightFogColor | ScatterSky |
numSplits | ScatterSky |
overDarkFactor | ScatterSky |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rayleighScattering | ScatterSky |
representedInLightmap | ScatterSky |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shadowDarkenColor | ScatterSky |
shadowDistance | ScatterSky |
shadowSoftness | ScatterSky |
shadowType | ScatterSky |
skyBrightness | ScatterSky |
sunScale | ScatterSky |
superClass | SimObject |
texSize | ScatterSky |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useNightCubemap | ScatterSky |


Torque 3D - Script Manual: Member List

SceneObject Member List

This is the complete list of members for SceneObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | SceneObject | [static]
isRenderEnabled | SceneObject |
isSelectable | SceneObject | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

ScriptGroup Member List

This is the complete list of members for ScriptGroup, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getRandom() | SimSet
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listObjects() | SimSet
locked | SimObject
name | SimObject
onAdd(SimObjectId ID) | ScriptGroup
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onRemove(SimObjectId ID) | ScriptGroup
parentGroup | SimObject
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
sort(string callbackFunction) | SimSet
superClass | SimObject


Torque 3D - Script Manual: Member List

ScriptMsgListener Member List

This is the complete list of members for ScriptMsgListener, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd() | ScriptMsgListener
onAddToQueue(string queue) | ScriptMsgListener
onMessageObjectReceived(string queue, Message msg) | ScriptMsgListener
onMessageReceived(string queue, string event, string data) | ScriptMsgListener
onRemove() | ScriptMsgListener
onRemoveFromQueue(string queue) | ScriptMsgListener
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

ScriptObject Member List

This is the complete list of members for ScriptObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd(SimObjectId ID) | ScriptObject
onRemove(SimObjectId ID) | ScriptObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXAmbience Member List

This is the complete list of members for SFXAmbience, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dopplerFactor | SFXAmbience
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
environment | SFXAmbience
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
rolloffFactor | SFXAmbience
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
soundTrack | SFXAmbience
states | SFXAmbience
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXController Member List

This is the complete list of members for SFXController, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
addMarker(String name, float pos) | SFXSource
addParameter(SFXParameter parameter) | SFXSource
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
description | SFXSource
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAttenuatedVolume() | SFXSource
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getCurrentSlot() | SFXController
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getFadeInTime() | SFXSource
getFadeOutTime() | SFXSource
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParameter(int index) | SFXSource
getParameterCount() | SFXSource
getPitch() | SFXSource
getRandom() | SimSet
getStatus() | SFXSource
getSuperClassNamespace() | SimObject
getVolume() | SFXSource
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isPaused() | SFXSource
isPlaying() | SFXSource
isSelected() | SimObject
isStopped() | SFXSource
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onParameterValueChange(SFXParameter parameter) | SFXSource
onStatusChange(SFXStatus newStatus) | SFXSource
parentGroup | SimObject
pause(float fadeOutTime=-1.f) | SFXSource
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeParameter(SFXParameter parameter) | SFXSource
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setCone(float innerAngle, float outerAngle, float outsideVolume) | SFXSource
setCurrentSlot(int index) | SFXController
setEditorOnly(bool value=true) | SimObject
setFadeTimes(float fadeInTime, float fadeOutTime) | SFXSource
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPitch(float pitch) | SFXSource
setSuperClassNamespace(string name) | SimObject
setTransform(Point3F position, Point3F direction) void setTransform(Point3F position) void play(float fadeInTime | SFXSource
setVolume(float volume) | SFXSource
sort(string callbackFunction) | SimSet
statusCallback | SFXSource
stop(float fadeOutTime=-1.f) | SFXSource
superClass | SimObject
trace | SFXController


Torque 3D - Script Manual: Member List

SFXDescription Member List

This is the complete list of members for SFXDescription, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clone() | SimObject |
coneInsideAngle | SFXDescription |
coneOutsideAngle | SFXDescription |
coneOutsideVolume | SFXDescription |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fadeInEase | SFXDescription |
fadeInTime | SFXDescription |
fadeLoops | SFXDescription |
fadeOutEase | SFXDescription |
fadeOutTime | SFXDescription |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getName() | SimObject |
getSuperClassNamespace() | SimObject |
hidden | SimObject |
internalName | SimObject |
is3D | SFXDescription |
isChildOfGroup(SimGroup group) | SimObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isInNamespaceHierarchy(string name) | SimObject |
isLooping | SFXDescription |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
isStreaming | SFXDescription |
locked | SimObject |
maxDistance | SFXDescription |
name | SimObject |
parameters | SFXDescription |
parentGroup | SimObject |
persistentId | SimObject |
pitch | SFXDescription |
priority | SFXDescription |
referenceDistance | SFXDescription |
reloadOnLocalClient() | SimDataBlock |
REVERB_DIRECTHFAUTO | SFXDescription | [static]
REVERB_INSTANCE0 | SFXDescription | [static]
REVERB_INSTANCE1 | SFXDescription | [static]
REVERB_INSTANCE2 | SFXDescription | [static]
REVERB_INSTANCE3 | SFXDescription | [static]
REVERB_ROOMAUTO | SFXDescription | [static]
REVERB_ROOMHFAUTO | SFXDescription | [static]
reverbAirAbsorptionFactor | SFXDescription |
reverbDirect | SFXDescription |
reverbDirectHF | SFXDescription |
reverbDopplerFactor | SFXDescription |
reverbExclusion | SFXDescription |
reverbExclusionLFRatio | SFXDescription |
reverbFlags | SFXDescription |
reverbObstruction | SFXDescription |
reverbObstructionLFRatio | SFXDescription |
reverbOcclusion | SFXDescription |
reverbOcclusionDirectRatio | SFXDescription |
reverbOcclusionLFRatio | SFXDescription |
reverbOcclusionRoomRatio | SFXDescription |
reverbOutsideVolumeHF | SFXDescription |
reverbReverbRolloffFactor | SFXDescription |
reverbRoom | SFXDescription |
reverbRoomHF | SFXDescription |
reverbRoomRolloffFactor | SFXDescription |
rolloffFactor | SFXDescription |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scatterDistance | SFXDescription |
schedule(float time, string method, string args...) | SimObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setSuperClassNamespace(string name) | SimObject |
sourceGroup | SFXDescription |
streamPacketSize | SFXDescription |
streamReadAhead | SFXDescription |
superClass | SimObject |
useCustomReverb | SFXDescription |
useHardware | SFXDescription |
volume | SFXDescription |


Torque 3D - Script Manual: Member List

SFXEmitter Member List

This is the complete list of members for SFXEmitter, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
coneInsideAngle | SFXEmitter |
coneOutsideAngle | SFXEmitter |
coneOutsideVolume | SFXEmitter |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fadeInTime | SFXEmitter |
fadeOutTime | SFXEmitter |
fileName | SFXEmitter |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSource() | SFXEmitter |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
is3D | SFXEmitter |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isLooping | SFXEmitter |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | SFXEmitter | [static]
isRenderEnabled | SceneObject |
isSelectable | SFXEmitter | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
isStreaming | SFXEmitter |
locked | SimObject |
maxDistance | SFXEmitter |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
pitch | SFXEmitter |
play() | SFXEmitter |
playOnAdd | SFXEmitter |
position | SceneObject |
referenceDistance | SFXEmitter |
renderColorInnerCone | SFXEmitter | [static]
renderColorOuterCone | SFXEmitter | [static]
renderColorOutsideVolume | SFXEmitter | [static]
renderColorPlayingInRange | SFXEmitter | [static]
renderColorPlayingOutOfRange | SFXEmitter | [static]
renderColorRangeSphere | SFXEmitter | [static]
renderColorStoppedInRange | SFXEmitter | [static]
renderColorStoppedOutOfRange | SFXEmitter | [static]
renderEmitters | SFXEmitter | [static]
renderPointDistance | SFXEmitter | [static]
renderRadialIncrements | SFXEmitter | [static]
renderSweepIncrements | SFXEmitter | [static]
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
scatterDistance | SFXEmitter |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
sourceGroup | SFXEmitter |
stop() | SFXEmitter |
superClass | SimObject |
track | SFXEmitter |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useTrackDescriptionOnly | SFXEmitter |
volume | SFXEmitter |


Torque 3D - Script Manual: Member List

SFXEnvironment Member List

This is the complete list of members for SFXEnvironment, including all inherited members.
airAbsorptionHF | SFXEnvironment |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clone() | SimObject |
decayHFRatio | SFXEnvironment |
decayLFRatio | SFXEnvironment |
decayTime | SFXEnvironment |
deepClone() | SimObject |
delete() | SimObject |
density | SFXEnvironment |
diffusion | SFXEnvironment |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
echoDepth | SFXEnvironment |
echoTime | SFXEnvironment |
envDiffusion | SFXEnvironment |
envSize | SFXEnvironment |
flags | SFXEnvironment |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getName() | SimObject |
getSuperClassNamespace() | SimObject |
HFReference | SFXEnvironment |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isNameChangeAllowed() | SimObject |
isSelected() | SimObject |
LFReference | SFXEnvironment |
locked | SimObject |
modulationDepth | SFXEnvironment |
modulationTime | SFXEnvironment |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
reflections | SFXEnvironment |
reflectionsDelay | SFXEnvironment |
reflectionsPan | SFXEnvironment |
reloadOnLocalClient() | SimDataBlock |
reverb | SFXEnvironment |
REVERB_CORE0 | SFXEnvironment | [static]
REVERB_CORE1 | SFXEnvironment | [static]
REVERB_DECAYHFLIMIT | SFXEnvironment | [static]
REVERB_DECAYTIMESCALE | SFXEnvironment | [static]
REVERB_ECHOTIMESCALE | SFXEnvironment | [static]
REVERB_HIGHQUALITYDPL2REVERB | SFXEnvironment | [static]
REVERB_HIGHQUALITYREVERB | SFXEnvironment | [static]
REVERB_MODULATIONTIMESCALE | SFXEnvironment | [static]
REVERB_REFLECTIONSDELAYSCALE | SFXEnvironment | [static]
REVERB_REFLECTIONSSCALE | SFXEnvironment | [static]
REVERB_REVERBDELAYSCALE | SFXEnvironment | [static]
REVERB_REVERBSCALE | SFXEnvironment | [static]
reverbDelay | SFXEnvironment |
reverbPan | SFXEnvironment |
room | SFXEnvironment |
roomHF | SFXEnvironment |
roomLF | SFXEnvironment |
roomRolloffFactor | SFXEnvironment |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
schedule(float time, string method, string args...) | SimObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setSuperClassNamespace(string name) | SimObject |
superClass | SimObject |


Torque 3D - Script Manual: Member List

SFXFMODEvent Member List

This is the complete list of members for SFXFMODEvent, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
description | SFXTrack
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fmodGroup | SFXFMODEvent
fmodName | SFXFMODEvent
fmodParameterRanges | SFXFMODEvent
fmodParameterValues | SFXFMODEvent
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parameters | SFXTrack
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXFMODEventGroup Member List

This is the complete list of members for SFXFMODEventGroup, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fmodGroup | SFXFMODEventGroup
fmodName | SFXFMODEventGroup
fmodProject | SFXFMODEventGroup
freeData() | SFXFMODEventGroup
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isDataLoaded() | SFXFMODEventGroup
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
loadData(bool loadStreams=true, bool loadSamples=true) | SFXFMODEventGroup
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXFMODEventSource Member List

This is the complete list of members for SFXFMODEventSource, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
addMarker(String name, float pos) | SFXSource
addParameter(SFXParameter parameter) | SFXSource
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
description | SFXSource
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAttenuatedVolume() | SFXSource
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getFadeInTime() | SFXSource
getFadeOutTime() | SFXSource
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParameter(int index) | SFXSource
getParameterCount() | SFXSource
getPitch() | SFXSource
getRandom() | SimSet
getStatus() | SFXSource
getSuperClassNamespace() | SimObject
getVolume() | SFXSource
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isPaused() | SFXSource
isPlaying() | SFXSource
isSelected() | SimObject
isStopped() | SFXSource
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onParameterValueChange(SFXParameter parameter) | SFXSource
onStatusChange(SFXStatus newStatus) | SFXSource
parentGroup | SimObject
pause(float fadeOutTime=-1.f) | SFXSource
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeParameter(SFXParameter parameter) | SFXSource
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setCone(float innerAngle, float outerAngle, float outsideVolume) | SFXSource
setEditorOnly(bool value=true) | SimObject
setFadeTimes(float fadeInTime, float fadeOutTime) | SFXSource
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPitch(float pitch) | SFXSource
setSuperClassNamespace(string name) | SimObject
setTransform(Point3F position, Point3F direction) void setTransform(Point3F position) void play(float fadeInTime | SFXSource
setVolume(float volume) | SFXSource
sort(string callbackFunction) | SimSet
statusCallback | SFXSource
stop(float fadeOutTime=-1.f) | SFXSource
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXFMODProject Member List

This is the complete list of members for SFXFMODProject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fileName | SFXFMODProject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mediaPath | SFXFMODProject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXParameter Member List

This is the complete list of members for SFXParameter, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
channel | SFXParameter
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
defaultValue | SFXParameter
delete() | SimObject
description | SFXParameter
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getParameterName() | SFXParameter
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onUpdate() | SFXParameter
parentGroup | SimObject
persistentId | SimObject
range | SFXParameter
reset() | SFXParameter
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
value | SFXParameter


Torque 3D - Script Manual: Member List

SFXPlayList Member List

This is the complete list of members for SFXPlayList, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delayTimeIn | SFXPlayList
delayTimeInVariance | SFXPlayList
delayTimeOut | SFXPlayList
delayTimeOutVariance | SFXPlayList
delete() | SimObject
description | SFXTrack
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fadeTimeIn | SFXPlayList
fadeTimeInVariance | SFXPlayList
fadeTimeOut | SFXPlayList
fadeTimeOutVariance | SFXPlayList
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
loopMode | SFXPlayList
maxDistance | SFXPlayList
maxDistanceVariance | SFXPlayList
name | SimObject
numSlotsToPlay | SFXPlayList
parameters | SFXTrack
parentGroup | SimObject
persistentId | SimObject
pitchScale | SFXPlayList
pitchScaleVariance | SFXPlayList
random | SFXPlayList
referenceDistance | SFXPlayList
referenceDistanceVariance | SFXPlayList
reloadOnLocalClient() | SimDataBlock
repeatCount | SFXPlayList
replay | SFXPlayList
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
state | SFXPlayList
stateMode | SFXPlayList
superClass | SimObject
trace | SFXPlayList
track | SFXPlayList
transitionIn | SFXPlayList
transitionOut | SFXPlayList
volumeScale | SFXPlayList
volumeScaleVariance | SFXPlayList


Torque 3D - Script Manual: Member List

SFXProfile Member List

This is the complete list of members for SFXProfile, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
description | SFXTrack
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
fileName | SFXProfile
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSoundDuration() | SFXProfile
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parameters | SFXTrack
parentGroup | SimObject
persistentId | SimObject
preload | SFXProfile
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXSound Member List

This is the complete list of members for SFXSound, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
addMarker(String name, float pos) | SFXSource
addParameter(SFXParameter parameter) | SFXSource
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
description | SFXSource
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAttenuatedVolume() | SFXSource
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDuration() | SFXSound
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getFadeInTime() | SFXSource
getFadeOutTime() | SFXSource
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParameter(int index) | SFXSource
getParameterCount() | SFXSource
getPitch() | SFXSource
getPosition() | SFXSound
getRandom() | SimSet
getStatus() | SFXSource
getSuperClassNamespace() | SimObject
getVolume() | SFXSource
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isPaused() | SFXSource
isPlaying() | SFXSource
isReady() | SFXSound
isSelected() | SimObject
isStopped() | SFXSource
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onParameterValueChange(SFXParameter parameter) | SFXSource
onStatusChange(SFXStatus newStatus) | SFXSource
parentGroup | SimObject
pause(float fadeOutTime=-1.f) | SFXSource
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeParameter(SFXParameter parameter) | SFXSource
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setCone(float innerAngle, float outerAngle, float outsideVolume) | SFXSource
setEditorOnly(bool value=true) | SimObject
setFadeTimes(float fadeInTime, float fadeOutTime) | SFXSource
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPitch(float pitch) | SFXSource
setPosition(float position) | SFXSound
setSuperClassNamespace(string name) | SimObject
setTransform(Point3F position, Point3F direction) void setTransform(Point3F position) void play(float fadeInTime | SFXSource
setVolume(float volume) | SFXSource
sort(string callbackFunction) | SimSet
statusCallback | SFXSource
stop(float fadeOutTime=-1.f) | SFXSource
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXSource Member List

This is the complete list of members for SFXSource, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
addMarker(String name, float pos) | SFXSource
addParameter(SFXParameter parameter) | SFXSource
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
description | SFXSource
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getAttenuatedVolume() | SFXSource
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getFadeInTime() | SFXSource
getFadeOutTime() | SFXSource
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getParameter(int index) | SFXSource
getParameterCount() | SFXSource
getPitch() | SFXSource
getRandom() | SimSet
getStatus() | SFXSource
getSuperClassNamespace() | SimObject
getVolume() | SFXSource
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isPaused() | SFXSource
isPlaying() | SFXSource
isSelected() | SimObject
isStopped() | SFXSource
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
onParameterValueChange(SFXParameter parameter) | SFXSource
onStatusChange(SFXStatus newStatus) | SFXSource
parentGroup | SimObject
pause(float fadeOutTime=-1.f) | SFXSource
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
removeParameter(SFXParameter parameter) | SFXSource
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setCone(float innerAngle, float outerAngle, float outsideVolume) | SFXSource
setEditorOnly(bool value=true) | SimObject
setFadeTimes(float fadeInTime, float fadeOutTime) | SFXSource
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPitch(float pitch) | SFXSource
setSuperClassNamespace(string name) | SimObject
setTransform(Point3F position, Point3F direction) void setTransform(Point3F position) void play(float fadeInTime | SFXSource
setVolume(float volume) | SFXSource
sort(string callbackFunction) | SimSet
statusCallback | SFXSource
stop(float fadeOutTime=-1.f) | SFXSource
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXSpace Member List

This is the complete list of members for SFXSpace, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
edge | SFXSpace |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | SFXSpace | [static]
isRenderEnabled | SceneObject |
isSelectable | SFXSpace | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
plane | SFXSpace |
point | SFXSpace |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
soundAmbience | SFXSpace |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

SFXState Member List

This is the complete list of members for SFXState, including all inherited members.
activate() | SFXState
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deactivate() | SFXState
deepClone() | SimObject
delete() | SimObject
disable() | SFXState
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
enable() | SFXState
excludedStates | SFXState
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
includedStates | SFXState
internalName | SimObject
isActive() | SFXState
isChildOfGroup(SimGroup group) | SimObject
isDisabled() | SFXState
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onActivate() | SFXState
onDeactivate() | SFXState
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SFXTrack Member List

This is the complete list of members for SFXTrack, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
description | SFXTrack
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parameters | SFXTrack
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

ShaderData Member List

This is the complete list of members for ShaderData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
defines | ShaderData
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
DXPixelShaderFile | ShaderData
DXVertexShaderFile | ShaderData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
OGLPixelShaderFile | ShaderData
OGLVertexShaderFile | ShaderData
parentGroup | SimObject
persistentId | SimObject
pixVersion | ShaderData
reload() | ShaderData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
useDevicePixVersion | ShaderData


Torque 3D - Script Manual: Member List

ShapeBase Member List

This is the complete list of members for ShapeBase, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | ShapeBase | [static]
isRenderEnabled | SceneObject |
isSelectable | ShapeBase | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

ShapeBaseData Member List

This is the complete list of members for ShapeBaseData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
cameraDefaultFov | ShapeBaseData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
computeCRC | ShapeBaseData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
inheritEnergyFromMount | ShapeBaseData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ShapeBaseData
maxDamage | ShapeBaseData
maxEnergy | ShapeBaseData
name | SimObject
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
superClass | SimObject
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData


Torque 3D - Script Manual: Member List

ShapeBaseImageData Member List

This is the complete list of members for ShapeBaseImageData, including all inherited members.
accuFire | ShapeBaseImageData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
camShakeAmp | ShapeBaseImageData
camShakeFreq | ShapeBaseImageData
canSave | SimObject
canSaveDynamicFields | SimObject
casing | ShapeBaseImageData
category | GameBaseData
class | SimObject
className | SimObject
cloakable | ShapeBaseImageData
clone() | SimObject
computeCRC | ShapeBaseImageData
correctMuzzleVector | ShapeBaseImageData
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
emap | ShapeBaseImageData
eyeOffset | ShapeBaseImageData
eyeRotation | ShapeBaseImageData
firstPerson | ShapeBaseImageData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lightBrightness | ShapeBaseImageData
lightColor | ShapeBaseImageData
lightDuration | ShapeBaseImageData
lightRadius | ShapeBaseImageData
lightType | ShapeBaseImageData
locked | SimObject
mass | ShapeBaseImageData
maxConcurrentSounds | ShapeBaseImageData
minEnergy | ShapeBaseImageData
mountPoint | ShapeBaseImageData
name | SimObject
offset | ShapeBaseImageData
onAdd(GameBase obj) | GameBaseData
onMount(ShapeBase obj, int slot, float dt) | ShapeBaseImageData
GameBaseData::onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(ShapeBase obj, int slot, float dt) | ShapeBaseImageData
GameBaseData::onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
Projectile | ShapeBaseImageData
reloadOnLocalClient() | SimDataBlock
rotation | ShapeBaseImageData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shakeCamera | ShapeBaseImageData
shapeFile | ShapeBaseImageData
shellExitDir | ShapeBaseImageData
shellExitVariance | ShapeBaseImageData
shellVelocity | ShapeBaseImageData
stateAllowImageChange | ShapeBaseImageData
stateDirection | ShapeBaseImageData
stateEjectShell | ShapeBaseImageData
stateEmitter | ShapeBaseImageData
stateEmitterNode | ShapeBaseImageData
stateEmitterTime | ShapeBaseImageData
stateEnergyDrain | ShapeBaseImageData
stateFire | ShapeBaseImageData
stateIgnoreLoadedForReady | ShapeBaseImageData
stateLoadedFlag | ShapeBaseImageData
stateName | ShapeBaseImageData
stateRecoil | ShapeBaseImageData
stateScaleAnimation | ShapeBaseImageData
stateScript | ShapeBaseImageData
stateSequence | ShapeBaseImageData
stateSequenceRandomFlash | ShapeBaseImageData
stateSound | ShapeBaseImageData
stateSpinThread | ShapeBaseImageData
stateTimeoutValue | ShapeBaseImageData
stateTransitionOnAltTriggerDown | ShapeBaseImageData
stateTransitionOnAltTriggerUp | ShapeBaseImageData
stateTransitionOnAmmo | ShapeBaseImageData
stateTransitionOnLoaded | ShapeBaseImageData
stateTransitionOnNoAmmo | ShapeBaseImageData
stateTransitionOnNoTarget | ShapeBaseImageData
stateTransitionOnNotLoaded | ShapeBaseImageData
stateTransitionOnNotWet | ShapeBaseImageData
stateTransitionOnTarget | ShapeBaseImageData
stateTransitionOnTimeout | ShapeBaseImageData
stateTransitionOnTriggerDown | ShapeBaseImageData
stateTransitionOnTriggerUp | ShapeBaseImageData
stateTransitionOnWet | ShapeBaseImageData
stateWaitForTimeout | ShapeBaseImageData
superClass | SimObject
useRemainderDT | ShapeBaseImageData
usesEnergy | ShapeBaseImageData


Torque 3D - Script Manual: Member List

SimDataBlock Member List

This is the complete list of members for SimDataBlock, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SimGroup Member List

This is the complete list of members for SimGroup, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getRandom() | SimSet
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
parentGroup | SimObject
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
sort(string callbackFunction) | SimSet
superClass | SimObject


Torque 3D - Script Manual: Member List

SimObject Member List

This is the complete list of members for SimObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SimpleNetObject Member List

This is the complete list of members for SimpleNetObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clearScopeToClient(NetConnection client) | NetObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getClientObject() | NetObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGhostID() | NetObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getServerObject() | NetObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isClientObject() | NetObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
isServerObject() | NetObject
locked | SimObject
msg(NetConnection con, string message) | SimpleNetObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
scopeToClient(NetConnection client) | NetObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setMessage(string msg) | SimpleNetObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setScopeAlways() | NetObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SimSet Member List

This is the complete list of members for SimSet, including all inherited members.
acceptsAsChild(SimObject obj) | SimSet
add(SimObject objects...) | SimSet
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bringToFront(SimObject obj) | SimSet
call(string method, string args...) | SimObject
callOnChildren(string method, string args...) | SimSet
callOnChildrenNoRecurse(string method, string args...) | SimSet
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimSet
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
deleteAllObjects() | SimSet
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
findObjectByInternalName(string internalName, bool searchChildren=false) | SimSet
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getCount() | SimSet
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getFullCount() | SimSet
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getObject(int index) | SimSet
getObjectIndex(SimObject obj) | SimSet
getRandom() | SimSet
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMember(SimObject obj) | SimSet
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listObjects() | SimSet
locked | SimObject
name | SimObject
onObjectAdded(SimObject object) | SimSet
onObjectRemoved(SimObject object) | SimSet
parentGroup | SimObject
persistentId | SimObject
pushToBack(SimObject obj) | SimSet
remove(SimObject objects...) | SimSet
reorderChild(SimObject child1, SimObject child2) | SimSet
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
sort(string callbackFunction) | SimSet
superClass | SimObject


Torque 3D - Script Manual: Member List

SimXMLDocument Member List

This is the complete list of members for SimXMLDocument, including all inherited members.
addComment(string comment) | SimXMLDocument
addData(string text) | SimXMLDocument
addHeader() | SimXMLDocument
addNewElement(string name) | SimXMLDocument
addText(string text) | SimXMLDocument
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
attribute(string attributeName) | SimXMLDocument
attributeExists(string attributeName) | SimXMLDocument
attributeF32(string attributeName) | SimXMLDocument
attributeS32(string attributeName) | SimXMLDocument
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clear() | SimXMLDocument
clearError() | SimXMLDocument
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
elementValue() | SimXMLDocument
firstAttribute() | SimXMLDocument
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getData() | SimXMLDocument
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getErrorDesc() | SimXMLDocument
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
getText() | SimXMLDocument
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lastAttribute() | SimXMLDocument
loadFile(string fileName) | SimXMLDocument
locked | SimObject
name | SimObject
nextAttribute() | SimXMLDocument
nextSiblingElement(string name) | SimXMLDocument
parentGroup | SimObject
parse(string xmlString) | SimXMLDocument
persistentId | SimObject
popElement() | SimXMLDocument
prevAttribute() | SimXMLDocument
pushChildElement(int index) | SimXMLDocument
pushFirstChildElement(string name) | SimXMLDocument
pushNewElement(string name) | SimXMLDocument
readComment(int index) | SimXMLDocument
removeText() | SimXMLDocument
reset() | SimXMLDocument
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
saveFile(string fileName) | SimXMLDocument
schedule(float time, string method, string args...) | SimObject
setAttribute(string attributeName, string value) | SimXMLDocument
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setObjectAttributes(string objectID) | SimXMLDocument
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

SkyBox Member List

This is the complete list of members for SkyBox, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
drawBottom | SkyBox |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fogBandHeight | SkyBox |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | SkyBox | [static]
isRenderEnabled | SceneObject |
isSelectable | SkyBox | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
Material | SkyBox |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
postApply | SkyBox |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

SpawnSphere Member List

This is the complete list of members for SpawnSphere, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
autoSpawn | SpawnSphere |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
indoorWeight | SpawnSphere |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | SpawnSphere | [static]
isRenderEnabled | SceneObject |
isSelectable | SpawnSphere | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
onAdd(int objectId) | SpawnSphere |
outdoorWeight | SpawnSphere |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
radius | SpawnSphere |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
spawnClass | SpawnSphere |
spawnDatablock | SpawnSphere |
spawnObject(string additionalProps) | SpawnSphere |
spawnProperties | SpawnSphere |
spawnScript | SpawnSphere |
sphereWeight | SpawnSphere |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

Splash Member List

This is the complete list of members for Splash, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Splash | [static]
isRenderEnabled | SceneObject |
isSelectable | Splash | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

SplashData Member List

This is the complete list of members for SplashData, including all inherited members.
acceleration | SplashData
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clone() | SimObject
colors | SplashData
deepClone() | SimObject
delayMS | SplashData
delayVariance | SplashData
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
ejectionAngle | SplashData
ejectionFreq | SplashData
emitter | SplashData
Explosion | SplashData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
height | SplashData
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
lifetimeMS | SplashData
lifetimeVariance | SplashData
locked | SimObject
name | SimObject
numSegments | SplashData
onAdd(GameBase obj) | GameBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
ringLifetime | SplashData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
scale | SplashData
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
soundProfile | SplashData
startRadius | SplashData
superClass | SimObject
texFactor | SplashData
texture | SplashData
texWrap | SplashData
times | SplashData
velocity | SplashData
width | SplashData


Torque 3D - Script Manual: Member List

SpotLight Member List

This is the complete list of members for SpotLight, including all inherited members.
animate | LightBase |
animationPeriod | LightBase |
animationPhase | LightBase |
animationType | LightBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attenuationRatio | LightBase |
brightness | LightBase |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
castShadows | LightBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
color | LightBase |
cookie | LightBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
fadeStartDistance | LightBase |
flareScale | LightBase |
flareType | LightBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
includeLightmappedGeometryInShadow | LightBase |
innerAngle | SpotLight |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isEnabled | LightBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | SpotLight | [static]
isRenderEnabled | SceneObject |
isSelectable | SpotLight | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
lastSplitTerrainOnly | LightBase |
locked | SimObject |
logWeight | LightBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
numSplits | LightBase |
outerAngle | SpotLight |
overDarkFactor | LightBase |
parentGroup | SimObject |
pauseAnimation | LightBase |
persistentId | SimObject |
playAnimation(LightAnimData anim) | LightBase |
playAnimation() | LightBase |
position | SceneObject |
priority | LightBase |
range | SpotLight |
representedInLightmap | LightBase |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLightEnabled(bool state) | LightBase |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shadowDarkenColor | LightBase |
shadowDistance | LightBase |
shadowSoftness | LightBase |
shadowType | LightBase |
superClass | SimObject |
texSize | LightBase |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

StaticShape Member List

This is the complete list of members for StaticShape, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | StaticShape | [static]
isRenderEnabled | SceneObject |
isSelectable | StaticShape | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

StaticShapeData Member List

This is the complete list of members for StaticShapeData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
cameraDefaultFov | ShapeBaseData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
computeCRC | ShapeBaseData
cubeReflectorDesc | ShapeBaseData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dynamicType | StaticShapeData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
inheritEnergyFromMount | ShapeBaseData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ShapeBaseData
maxDamage | ShapeBaseData
maxEnergy | ShapeBaseData
name | SimObject
noIndividualDamage | StaticShapeData
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
superClass | SimObject
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData


Torque 3D - Script Manual: Member List

StreamObject Member List

This is the complete list of members for StreamObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
copyFrom(SimObject other) | StreamObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getPosition() | StreamObject
getStatus() | StreamObject
getStreamSize() | StreamObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isEOF() | StreamObject
isEOS() | StreamObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
readLine() | StreamObject
readLongString(int maxLength) | StreamObject
readString() | StreamObject
readSTString(bool caseSensitive=false) | StreamObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setPosition(int newPosition) | StreamObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
writeLine(string line) | StreamObject
writeLongString(int maxLength, string string) | StreamObject
writeString(string string, int maxLength=256) | StreamObject


Torque 3D - Script Manual: Member List

Sun Member List

This is the complete list of members for Sun, including all inherited members.
ambient | Sun |
animate | Sun |
apply | Sun |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
attenuationRatio | Sun |
azimuth | Sun |
brightness | Sun |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
castShadows | Sun |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
color | Sun |
cookie | Sun |
coronaEnabled | Sun |
coronaMaterial | Sun |
coronaScale | Sun |
coronaTint | Sun |
coronaUseLightColor | Sun |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
elevation | Sun |
fadeStartDistance | Sun |
flareScale | Sun |
flareType | Sun |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
includeLightmappedGeometryInShadow | Sun |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Sun | [static]
isRenderEnabled | SceneObject |
isSelectable | Sun | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
lastSplitTerrainOnly | Sun |
locked | SimObject |
logWeight | Sun |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
numSplits | Sun |
overDarkFactor | Sun |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
representedInLightmap | Sun |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shadowDarkenColor | Sun |
shadowDistance | Sun |
shadowSoftness | Sun |
shadowType | Sun |
superClass | SimObject |
texSize | Sun |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

TCPObject Member List

This is the complete list of members for TCPObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
connect(string address) | TCPObject
deepClone() | SimObject
delete() | SimObject
disconnect() | TCPObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
listen(int port) | TCPObject
locked | SimObject
name | SimObject
onConnected() | TCPObject
onConnectFailed() | TCPObject
onConnectionRequest(string address, string ID) | TCPObject
onDisconnect() | TCPObject
onDNSFailed() | TCPObject
onDNSResolved() | TCPObject
onLine(string line) | TCPObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
send(string data) | TCPObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

TerrainBlock Member List

This is the complete list of members for TerrainBlock, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
baseTexSize | TerrainBlock |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
castShadows | TerrainBlock |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
createNew | TerrainBlock |
debugRender | TerrainBlock | [static]
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
exportHeightMap(string filename,[string format]) | TerrainBlock |
exportLayerMaps(string filePrefix,[string format]) | TerrainBlock |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
import(String terrainName, String heightMap, F32 metersPerPixel, F32 heightScale, String materials, String opacityLayers) | TerrainBlock |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | TerrainBlock | [static]
isRenderEnabled | SceneObject |
isSelectable | TerrainBlock | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
lightMapSize | TerrainBlock |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
rotation | SceneObject |
save(string fileName) | TerrainBlock |
SceneObject::save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
screenError | TerrainBlock |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
squareSize | TerrainBlock |
superClass | SimObject |
terrainFile | TerrainBlock |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

TerrainMaterial Member List

This is the complete list of members for TerrainMaterial, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
detailDistance | TerrainMaterial
detailMap | TerrainMaterial
detailSize | TerrainMaterial
detailStrength | TerrainMaterial
diffuseMap | TerrainMaterial
diffuseSize | TerrainMaterial
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
normalMap | TerrainMaterial
parallaxScale | TerrainMaterial
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
useSideProjection | TerrainMaterial


Torque 3D - Script Manual: Member List

TimeOfDay Member List

This is the complete list of members for TimeOfDay, including all inherited members.
addTimeOfDayEvent(float elevation, string identifier) | TimeOfDay |
animate(float elevation, float degreesPerSecond) | TimeOfDay |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
axisTilt | TimeOfDay |
azimuthOverride | TimeOfDay |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dayLength | TimeOfDay |
dayScale | TimeOfDay |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | TimeOfDay | [static]
isRenderEnabled | SceneObject |
isSelectable | TimeOfDay | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
nightScale | TimeOfDay |
parentGroup | SimObject |
persistentId | SimObject |
play | TimeOfDay |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setDayLength(float seconds) | TimeOfDay |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setPlay(bool enabled) | TimeOfDay |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTimeOfDay(float time) | TimeOfDay |
setTransform(TransformF txfm) | SceneObject |
startTime | TimeOfDay |
superClass | SimObject |
time | TimeOfDay |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

Trigger Member List

This is the complete list of members for Trigger, including all inherited members.
applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
enterCommand | Trigger |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getNumObjects() | Trigger |
getObject(int index) | Trigger |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Trigger | [static]
isRenderEnabled | SceneObject |
isSelectable | Trigger | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
leaveCommand | Trigger |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
onAdd(int objectId) | Trigger |
onRemove(int objectId) | Trigger |
parentGroup | SimObject |
persistentId | SimObject |
polyhedron | Trigger |
position | SceneObject |
renderTriggers | Trigger | [static]
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setControl(bool controlled) | GameBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
superClass | SimObject |
tickCommand | Trigger |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

TriggerData Member List

This is the complete list of members for TriggerData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
class | SimObject
className | SimObject
clientSide | TriggerData
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
onAdd(GameBase obj) | GameBaseData
onEnterTrigger(Trigger trigger, GameBase obj) | TriggerData
onLeaveTrigger(Trigger trigger, GameBase obj) | TriggerData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTickTrigger(Trigger trigger) | TriggerData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject
tickPeriodMS | TriggerData


Torque 3D - Script Manual: Member List

TSForestItemData Member List

This is the complete list of members for TSForestItemData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
branchAmp | ForestItemData
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
collidable | ForestItemData
dampingCoefficient | ForestItemData
deepClone() | SimObject
delete() | SimObject
detailAmp | ForestItemData
detailFreq | ForestItemData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
mass | ForestItemData
name | SimObject
parentGroup | SimObject
persistentId | SimObject
radius | ForestItemData
reloadOnLocalClient() | SimDataBlock
rigidity | ForestItemData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shapeFile | ForestItemData
superClass | SimObject
tightnessCoefficient | ForestItemData
trunkBendScale | ForestItemData
windScale | ForestItemData


Torque 3D - Script Manual: Member List

TSShapeConstructor Member List

This is the complete list of members for TSShapeConstructor, including all inherited members.
addCollisionDetail(int size, string type, string target, int depth=4, float merge=30, float concavity=30, int maxVerts=32, float boxMaxError=0, float sphereMaxError=0, float capsuleMaxError=0) | TSShapeConstructor
addImposter(int size, int equatorSteps, int polarSteps, int dl, int dim, bool includePoles, float polarAngle) | TSShapeConstructor
addMesh(string meshName, string srcShape, string srcMesh) | TSShapeConstructor
addNode(string name, string parentName, TransformF txfm=TransformF::Identity, bool isWorld=false) | TSShapeConstructor
addPrimitive(string meshName, string type, string params, TransformF txfm, string nodeName) | TSShapeConstructor
addSequence(string source, string name, int start=0, int end=-1) | TSShapeConstructor
addTrigger(string name, int keyframe, int state) | TSShapeConstructor
adjustCenter | TSShapeConstructor
adjustFloor | TSShapeConstructor
alwaysImport | TSShapeConstructor
alwaysImportMesh | TSShapeConstructor
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
baseShape | TSShapeConstructor
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dumpShape(string filename="") | TSShapeConstructor
forceUpdateMaterials | TSShapeConstructor
getBounds() | TSShapeConstructor
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDetailLevelCount() | TSShapeConstructor
getDetailLevelIndex(int size) | TSShapeConstructor
getDetailLevelName(int index) | TSShapeConstructor
getDetailLevelSize(int index) | TSShapeConstructor
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getImposterDetailLevel() | TSShapeConstructor
getImposterSettings(int index) | TSShapeConstructor
getInternalName() | SimObject
getMeshCount(string name) | TSShapeConstructor
getMeshMaterial(string name) | TSShapeConstructor
getMeshName(string name, int index) | TSShapeConstructor
getMeshSize(string name, int index) | TSShapeConstructor
getMeshType(string name) | TSShapeConstructor
getName() | SimObject
getNodeChildCount(string name) | TSShapeConstructor
getNodeChildName(string name, int index) | TSShapeConstructor
getNodeCount() | TSShapeConstructor
getNodeIndex(string name) | TSShapeConstructor
getNodeName(int index) | TSShapeConstructor
getNodeObjectCount(string name) | TSShapeConstructor
getNodeObjectName(string name, int index) | TSShapeConstructor
getNodeParentName(string name) | TSShapeConstructor
getNodeTransform(string name, bool isWorld=false) | TSShapeConstructor
getObjectCount() | TSShapeConstructor
getObjectIndex(string name) | TSShapeConstructor
getObjectName(int index) | TSShapeConstructor
getObjectNode(string name) | TSShapeConstructor
getSequenceBlend(string name) | TSShapeConstructor
getSequenceCount() | TSShapeConstructor
getSequenceCyclic(string name) | TSShapeConstructor
getSequenceFrameCount(string name) | TSShapeConstructor
getSequenceGroundSpeed(string name) | TSShapeConstructor
getSequenceIndex(string name) | TSShapeConstructor
getSequenceName(int index) | TSShapeConstructor
getSequencePriority(string name) | TSShapeConstructor
getSequenceSource(string name) | TSShapeConstructor
getSuperClassNamespace() | SimObject
getTargetCount() | TSShapeConstructor
getTargetName(int index) | TSShapeConstructor
getTrigger(string name, int index) | TSShapeConstructor
getTriggerCount(string name) | TSShapeConstructor
hidden | SimObject
ignoreNodeScale | TSShapeConstructor
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
lodType | TSShapeConstructor
matNamePrefix | TSShapeConstructor
name | SimObject
neverImport | TSShapeConstructor
neverImportMesh | TSShapeConstructor
notifyShapeChanged() | TSShapeConstructor
onLoad() | TSShapeConstructor
onUnload() | TSShapeConstructor
parentGroup | SimObject
persistentId | SimObject
removeDetailLevel(int index) | TSShapeConstructor
removeImposter() | TSShapeConstructor
removeMesh(string name) | TSShapeConstructor
removeNode(string name) | TSShapeConstructor
removeObject(string name) | TSShapeConstructor
removeSequence(string name) | TSShapeConstructor
removeTrigger(string name, int keyframe, int state) | TSShapeConstructor
renameDetailLevel(string oldName, string newName) | TSShapeConstructor
renameNode(string oldName, string newName) | TSShapeConstructor
renameObject(string oldName, string newName) | TSShapeConstructor
renameSequence(string oldName, string newName) | TSShapeConstructor
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
saveShape(string filename) | TSShapeConstructor
schedule(float time, string method, string args...) | SimObject
sequence | TSShapeConstructor
setBounds(Box3F bbox) | TSShapeConstructor
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setDetailLevelSize(int index, int newSize) | TSShapeConstructor
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setMeshMaterial(string meshName, string matName) | TSShapeConstructor
setMeshSize(string name, int size) | TSShapeConstructor
setMeshType(string name, string type) | TSShapeConstructor
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setNodeParent(string name, string parentName) | TSShapeConstructor
setNodeTransform(string name, TransformF txfm, bool isWorld=false) | TSShapeConstructor
setObjectNode(string objName, string nodeName) | TSShapeConstructor
setSequenceBlend(string name, bool blend, string blendSeq, int blendFrame) | TSShapeConstructor
setSequenceCyclic(string name, bool cyclic) | TSShapeConstructor
setSequenceGroundSpeed(string name, Point3F transSpeed, Point3F rotSpeed=Point3F::Zero) | TSShapeConstructor
setSequencePriority(string name, float priority) | TSShapeConstructor
setSuperClassNamespace(string name) | SimObject
singleDetailSize | TSShapeConstructor
superClass | SimObject
unit | TSShapeConstructor
upAxis | TSShapeConstructor
writeChangeSet() | TSShapeConstructor


Torque 3D - Script Manual: Member List

TSStatic Member List

This is the complete list of members for TSStatic, including all inherited members.
allowPlayerStep | TSStatic |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo="", Material oldMat=NULL, Material newMat=NULL) | TSStatic |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
collisionType | TSStatic |
decalType | TSStatic |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
forceDetail | TSStatic |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getModelFile() | TSStatic |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTargetCount() | TSStatic |
getTargetName(int index=0) | TSStatic |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | TSStatic | [static]
isRenderEnabled | SceneObject |
isSelectable | TSStatic | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
meshCulling | TSStatic |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
originSort | TSStatic |
parentGroup | SimObject |
persistentId | SimObject |
playAmbient | TSStatic |
position | SceneObject |
renderNormals | TSStatic |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
shapeName | TSStatic |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |


Torque 3D - Script Manual: Member List

Vehicle Member List

This is the complete list of members for Vehicle, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
disableMove | Vehicle |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Vehicle | [static]
isRenderEnabled | SceneObject |
isSelectable | Vehicle | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |
workingQueryBoxSizeMultiplier | Vehicle | [static]
workingQueryBoxStaleThreshold | Vehicle | [static]


Torque 3D - Script Manual: Member List

VehicleData Member List

This is the complete list of members for VehicleData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bodyFriction | VehicleData
bodyRestitution | VehicleData
call(string method, string args...) | SimObject
cameraDecay | VehicleData
cameraDefaultFov | ShapeBaseData
cameraLag | VehicleData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
cameraOffset | VehicleData
cameraRoll | VehicleData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
collDamageMultiplier | VehicleData
collDamageThresholdVel | VehicleData
collisionTol | VehicleData
computeCRC | ShapeBaseData
contactTol | VehicleData
cubeReflectorDesc | ShapeBaseData
damageEmitter | VehicleData
damageEmitterOffset | VehicleData
damageLevelTolerance | VehicleData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dustEmitter | VehicleData
dustHeight | VehicleData
exitingWater | VehicleData
exitSplashSoundVelocity | VehicleData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hardImpactSound | VehicleData
hardImpactSpeed | VehicleData
hardSplashSoundVelocity | VehicleData
hidden | SimObject
impactWaterEasy | VehicleData
impactWaterHard | VehicleData
impactWaterMedium | VehicleData
inheritEnergyFromMount | ShapeBaseData
integration | VehicleData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
jetEnergyDrain | VehicleData
jetForce | VehicleData
locked | SimObject
mass | ShapeBaseData
massBox | VehicleData
massCenter | VehicleData
maxDamage | ShapeBaseData
maxDrag | VehicleData
maxEnergy | ShapeBaseData
maxSteeringAngle | VehicleData
mediumSplashSoundVelocity | VehicleData
minDrag | VehicleData
minImpactSpeed | VehicleData
minJetEnergy | VehicleData
minRollSpeed | VehicleData
name | SimObject
numDmgEmitterAreas | VehicleData
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onEnterLiquid(Vehicle obj, float coverage, string type) | VehicleData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onLeaveLiquid(Vehicle obj, string type) | VehicleData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
softImpactSound | VehicleData
softImpactSpeed | VehicleData
softSplashSoundVelocity | VehicleData
splashEmitter | VehicleData
splashFreqMod | VehicleData
splashVelEpsilon | VehicleData
superClass | SimObject
triggerDustHeight | VehicleData
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData
waterWakeSound | VehicleData


Torque 3D - Script Manual: Member List

WaterBlock Member List

This is the complete list of members for WaterBlock, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
baseColor | WaterObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
clarity | WaterObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
cubemap | WaterObject |
deepClone() | SimObject |
delete() | SimObject |
density | WaterObject |
depthGradientMax | WaterObject |
depthGradientTex | WaterObject |
distortEndDist | WaterObject |
distortFullDepth | WaterObject |
distortStartDist | WaterObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
emissive | WaterObject |
foamAmbientLerp | WaterObject |
foamDir | WaterObject |
foamMaxDepth | WaterObject |
foamOpacity | WaterObject |
foamRippleInfluence | WaterObject |
foamSpeed | WaterObject |
foamTex | WaterObject |
foamTexScale | WaterObject |
fresnelBias | WaterObject |
fresnelPower | WaterObject |
fullReflect | WaterObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
gridElementSize | WaterBlock |
gridSize | WaterBlock |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | WaterBlock | [static]
isRenderEnabled | SceneObject |
isSelectable | WaterBlock | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
liquidType | WaterObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
overallFoamOpacity | WaterObject |
overallRippleMagnitude | WaterObject |
overallWaveMagnitude | WaterObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
reflectDetailAdjust | WaterObject |
reflectivity | WaterObject |
reflectMaxRateMs | WaterObject |
reflectNormalUp | WaterObject |
reflectPriority | WaterObject |
reflectTexSize | WaterObject |
rippleDir | WaterObject |
rippleMagnitude | WaterObject |
rippleSpeed | WaterObject |
rippleTex | WaterObject |
rippleTexScale | WaterObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
soundAmbience | WaterObject |
specularColor | WaterObject |
specularPower | WaterObject |
superClass | SimObject |
underwaterColor | WaterObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useOcclusionQuery | WaterObject |
viscosity | WaterObject |
waterFogDensity | WaterObject |
waterFogDensityOffset | WaterObject |
waveDir | WaterObject |
waveMagnitude | WaterObject |
waveSpeed | WaterObject |
wetDarkening | WaterObject |
wetDepth | WaterObject |
wireframe | WaterObject | [static]


Torque 3D - Script Manual: Member List

WaterObject Member List

This is the complete list of members for WaterObject, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
baseColor | WaterObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
clarity | WaterObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
cubemap | WaterObject |
deepClone() | SimObject |
delete() | SimObject |
density | WaterObject |
depthGradientMax | WaterObject |
depthGradientTex | WaterObject |
distortEndDist | WaterObject |
distortFullDepth | WaterObject |
distortStartDist | WaterObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
emissive | WaterObject |
foamAmbientLerp | WaterObject |
foamDir | WaterObject |
foamMaxDepth | WaterObject |
foamOpacity | WaterObject |
foamRippleInfluence | WaterObject |
foamSpeed | WaterObject |
foamTex | WaterObject |
foamTexScale | WaterObject |
fresnelBias | WaterObject |
fresnelPower | WaterObject |
fullReflect | WaterObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | WaterObject | [static]
isRenderEnabled | SceneObject |
isSelectable | WaterObject | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
liquidType | WaterObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
overallFoamOpacity | WaterObject |
overallRippleMagnitude | WaterObject |
overallWaveMagnitude | WaterObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
reflectDetailAdjust | WaterObject |
reflectivity | WaterObject |
reflectMaxRateMs | WaterObject |
reflectNormalUp | WaterObject |
reflectPriority | WaterObject |
reflectTexSize | WaterObject |
rippleDir | WaterObject |
rippleMagnitude | WaterObject |
rippleSpeed | WaterObject |
rippleTex | WaterObject |
rippleTexScale | WaterObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
soundAmbience | WaterObject |
specularColor | WaterObject |
specularPower | WaterObject |
superClass | SimObject |
underwaterColor | WaterObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useOcclusionQuery | WaterObject |
viscosity | WaterObject |
waterFogDensity | WaterObject |
waterFogDensityOffset | WaterObject |
waveDir | WaterObject |
waveMagnitude | WaterObject |
waveSpeed | WaterObject |
wetDarkening | WaterObject |
wetDepth | WaterObject |
wireframe | WaterObject | [static]


Torque 3D - Script Manual: Member List

WaterPlane Member List

This is the complete list of members for WaterPlane, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
baseColor | WaterObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
clarity | WaterObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
cubemap | WaterObject |
deepClone() | SimObject |
delete() | SimObject |
density | WaterObject |
depthGradientMax | WaterObject |
depthGradientTex | WaterObject |
distortEndDist | WaterObject |
distortFullDepth | WaterObject |
distortStartDist | WaterObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
emissive | WaterObject |
foamAmbientLerp | WaterObject |
foamDir | WaterObject |
foamMaxDepth | WaterObject |
foamOpacity | WaterObject |
foamRippleInfluence | WaterObject |
foamSpeed | WaterObject |
foamTex | WaterObject |
foamTexScale | WaterObject |
fresnelBias | WaterObject |
fresnelPower | WaterObject |
fullReflect | WaterObject |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
gridElementSize | WaterPlane |
gridSize | WaterPlane |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | WaterPlane | [static]
isRenderEnabled | SceneObject |
isSelectable | WaterPlane | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
liquidType | WaterObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
overallFoamOpacity | WaterObject |
overallRippleMagnitude | WaterObject |
overallWaveMagnitude | WaterObject |
parentGroup | SimObject |
persistentId | SimObject |
position | SceneObject |
reflectDetailAdjust | WaterObject |
reflectivity | WaterObject |
reflectMaxRateMs | WaterObject |
reflectNormalUp | WaterObject |
reflectPriority | WaterObject |
reflectTexSize | WaterObject |
rippleDir | WaterObject |
rippleMagnitude | WaterObject |
rippleSpeed | WaterObject |
rippleTex | WaterObject |
rippleTexScale | WaterObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
soundAmbience | WaterObject |
specularColor | WaterObject |
specularPower | WaterObject |
superClass | SimObject |
underwaterColor | WaterObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useOcclusionQuery | WaterObject |
viscosity | WaterObject |
waterFogDensity | WaterObject |
waterFogDensityOffset | WaterObject |
waveDir | WaterObject |
waveMagnitude | WaterObject |
waveSpeed | WaterObject |
wetDarkening | WaterObject |
wetDepth | WaterObject |
wireframe | WaterObject | [static]


Torque 3D - Script Manual: Member List

WayPoint Member List

This is the complete list of members for WayPoint, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | WayPoint | [static]
isRenderEnabled | SceneObject |
isSelectable | WayPoint | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
markerName | WayPoint |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
team | WayPoint |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |


Torque 3D - Script Manual: Member List

WheeledVehicle Member List

This is the complete list of members for WheeledVehicle, including all inherited members.
applyDamage(float amount) | ShapeBase |
applyImpulse(Point3F pos, Point3F vec) | ShapeBase |
GameBase::applyImpulse(Point3F pos, VectorF vel) | GameBase |
applyRadialImpulse(Point3F origin, float radius, float magnitude) | GameBase |
applyRepair(float amount) | ShapeBase |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
boundingBox | GameBase | [static]
call(string method, string args...) | SimObject |
canCloak() | ShapeBase |
canSave | SimObject |
canSaveDynamicFields | SimObject |
changeMaterial(string mapTo, Material oldMat, Material newMat) | ShapeBase |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
dataBlock | GameBase |
deepClone() | SimObject |
delete() | SimObject |
destroyThread(int slot) | ShapeBase |
disableMove | Vehicle |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMeshVisibility() | ShapeBase |
dumpMethods() | SimObject |
getAIRepairPoint() | ShapeBase |
getCameraFov() | ShapeBase |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getControllingClient() | ShapeBase |
getControllingObject() | ShapeBase |
getDamageFlash() | ShapeBase |
getDamageLevel() | ShapeBase |
getDamagePercent() | ShapeBase |
getDamageState() | ShapeBase |
getDataBlock() | GameBase |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDefaultCameraFov() | ShapeBase |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEnergyLevel() | ShapeBase |
getEnergyPercent() | ShapeBase |
getEulerRotation() | SceneObject |
getEyePoint() | ShapeBase |
getEyeTransform() | ShapeBase |
getEyeVector() | ShapeBase |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getImageAltTrigger(int slot) | ShapeBase |
getImageAmmo(int slot) | ShapeBase |
getImageLoaded(int slot) | ShapeBase |
getImageSkinTag(int slot) | ShapeBase |
getImageState(int slot) | ShapeBase |
getImageTrigger(int slot) | ShapeBase |
getInternalName() | SimObject |
getLookAtPoint(float distance=2000, int typeMask=0xFFFFFFFF) | ShapeBase |
getModelFile() | ShapeBase |
getMountedImage(int slot) | ShapeBase |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getMountSlot(ShapeBaseImageData image) | ShapeBase |
getMuzzlePoint(int slot) | ShapeBase |
getMuzzleVector(int slot) | ShapeBase |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPendingImage(int slot) | ShapeBase |
getPosition() | SceneObject |
getRechargeRate() | ShapeBase |
getRepairRate() | ShapeBase |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getShapeName() | ShapeBase |
getSkinName() | ShapeBase |
getSlotTransform(int slot) | ShapeBase |
getSuperClassNamespace() | SimObject |
getTargetCount() | ShapeBase |
getTargetName(int index) | ShapeBase |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getVelocity() | ShapeBase |
getWheelCount() | WheeledVehicle |
getWhiteOut() | ShapeBase |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isCloaked() | ShapeBase |
isDestroyed() | ShapeBase |
isDisabled() | ShapeBase |
isEditorOnly() | SimObject |
isEnabled() | ShapeBase |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isHidden() | ShapeBase |
isImageFiring(int slot) | ShapeBase |
isImageMounted(ShapeBaseImageData image) | ShapeBase |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | WheeledVehicle | [static]
isRenderEnabled | SceneObject |
isSelectable | WheeledVehicle | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountImage(ShapeBaseImageData image, int slot, bool loaded=true, string skinTag="") | ShapeBase |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
pauseThread(int slot) | ShapeBase |
persistentId | SimObject |
playAudio(int slot, SFXTrack track) | ShapeBase |
playThread(int slot, string name="") | ShapeBase |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setAllMeshesHidden(bool hide) | ShapeBase |
setCameraFov(float fov) | ShapeBase |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setCloaked(bool cloak) | ShapeBase |
setControl(bool controlled) | GameBase |
setDamageFlash(float level) | ShapeBase |
setDamageLevel(float level) | ShapeBase |
setDamageState(string state) | ShapeBase |
setDamageVector(Point3F vec) | ShapeBase |
setDataBlock(GameBaseData data) | GameBase |
setEditorOnly(bool value=true) | SimObject |
setEnergyLevel(float level) | ShapeBase |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool show) | ShapeBase |
setImageAltTrigger(int slot, bool state) | ShapeBase |
setImageAmmo(int slot, bool state) | ShapeBase |
setImageLoaded(int slot, bool state) | ShapeBase |
setImageTrigger(int slot, bool state) | ShapeBase |
setInternalName(string newInternalName) | SimObject |
setInvincibleMode(float time, float speed) | ShapeBase |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setMeshHidden(string name, bool hide) | ShapeBase |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setRechargeRate(float rate) | ShapeBase |
setRepairRate(float rate) | ShapeBase |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setShapeName(string name) | ShapeBase |
setSkinName(string name) | ShapeBase |
setSuperClassNamespace(string name) | SimObject |
setThreadDir(int slot, bool fwd) | ShapeBase |
setThreadTimeScale(int slot, float scale) | ShapeBase |
setTransform(TransformF txfm) | SceneObject |
setVelocity(Point3F vel) | ShapeBase |
setWheelPowered(int wheel, bool powered) | WheeledVehicle |
setWheelSpring(int wheel, WheeledVehicleSpring spring) | WheeledVehicle |
setWheelSteering(int wheel, float steering) | WheeledVehicle |
setWheelTire(int wheel, WheeledVehicleTire tire) | WheeledVehicle |
setWhiteOut(float level) | ShapeBase |
startFade(int time, int delay, bool fadeOut) | ShapeBase |
stopAudio(int slot) | ShapeBase |
stopThread(int slot) | ShapeBase |
superClass | SimObject |
unmount() | SceneObject |
unmountImage(int slot) | ShapeBase |
unmountObject(SceneObject target) | SceneObject |
validateCameraFov(float fov) | ShapeBase |
workingQueryBoxSizeMultiplier | Vehicle | [static]
workingQueryBoxStaleThreshold | Vehicle | [static]


Torque 3D - Script Manual: Member List

WheeledVehicleData Member List

This is the complete list of members for WheeledVehicleData, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
bodyFriction | VehicleData
bodyRestitution | VehicleData
brakeTorque | WheeledVehicleData
call(string method, string args...) | SimObject
cameraDecay | VehicleData
cameraDefaultFov | ShapeBaseData
cameraLag | VehicleData
cameraMaxDist | ShapeBaseData
cameraMaxFov | ShapeBaseData
cameraMinDist | ShapeBaseData
cameraMinFov | ShapeBaseData
cameraOffset | VehicleData
cameraRoll | VehicleData
canSave | SimObject
canSaveDynamicFields | SimObject
category | GameBaseData
checkDeployPos(TransformF txfm) | ShapeBaseData
class | SimObject
className | SimObject
clone() | SimObject
collDamageMultiplier | VehicleData
collDamageThresholdVel | VehicleData
collisionTol | VehicleData
computeCRC | ShapeBaseData
contactTol | VehicleData
cubeReflectorDesc | ShapeBaseData
damageEmitter | VehicleData
damageEmitterOffset | VehicleData
damageLevelTolerance | VehicleData
Debris | ShapeBaseData
debrisShapeName | ShapeBaseData
deepClone() | SimObject
delete() | SimObject
density | ShapeBaseData
destroyedLevel | ShapeBaseData
disabledLevel | ShapeBaseData
drag | ShapeBaseData
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
dustEmitter | VehicleData
dustHeight | VehicleData
engineBrake | WheeledVehicleData
engineSound | WheeledVehicleData
engineTorque | WheeledVehicleData
exitingWater | VehicleData
exitSplashSoundVelocity | VehicleData
Explosion | ShapeBaseData
firstPersonOnly | ShapeBaseData
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDeployTransform(Point3F pos, Point3F normal) | ShapeBaseData
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hardImpactSound | VehicleData
hardImpactSpeed | VehicleData
hardSplashSoundVelocity | VehicleData
hidden | SimObject
impactWaterEasy | VehicleData
impactWaterHard | VehicleData
impactWaterMedium | VehicleData
inheritEnergyFromMount | ShapeBaseData
integration | VehicleData
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isInvincible | ShapeBaseData
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
jetEnergyDrain | VehicleData
jetForce | VehicleData
jetSound | WheeledVehicleData
locked | SimObject
mass | ShapeBaseData
massBox | VehicleData
massCenter | VehicleData
maxDamage | ShapeBaseData
maxDrag | VehicleData
maxEnergy | ShapeBaseData
maxSteeringAngle | VehicleData
maxWheelSpeed | WheeledVehicleData
mediumSplashSoundVelocity | VehicleData
minDrag | VehicleData
minImpactSpeed | VehicleData
minJetEnergy | VehicleData
minRollSpeed | VehicleData
name | SimObject
numDmgEmitterAreas | VehicleData
observeThroughObject | ShapeBaseData
onAdd(GameBase obj) | GameBaseData
onCollision(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onDamage(ShapeBase obj, float delta) | ShapeBaseData
onDestroyed(ShapeBase obj, string lastState) | ShapeBaseData
onDisabled(ShapeBase obj, string lastState) | ShapeBaseData
onEnabled(ShapeBase obj, string lastState) | ShapeBaseData
onEndSequence(ShapeBase obj, int slot) | ShapeBaseData
onEnterLiquid(Vehicle obj, float coverage, string type) | VehicleData
onForceUncloak(ShapeBase obj, string reason) | ShapeBaseData
onImpact(ShapeBase obj, SceneObject collObj, VectorF vec, float len) | ShapeBaseData
onLeaveLiquid(Vehicle obj, string type) | VehicleData
onMount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
onNewDataBlock(GameBase obj) | GameBaseData
onRemove(GameBase obj) | GameBaseData
onTrigger(ShapeBase obj, int index, bool state) | ShapeBaseData
onUnmount(GameBase obj, SceneObject mountObj, int node) | GameBaseData
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
renderWhenDestroyed | ShapeBaseData
repairRate | ShapeBaseData
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shadowEnable | ShapeBaseData
shadowMaxVisibleDistance | ShapeBaseData
shadowProjectionDistance | ShapeBaseData
shadowSize | ShapeBaseData
shadowSphereAdjust | ShapeBaseData
shapeFile | ShapeBaseData
softImpactSound | VehicleData
softImpactSpeed | VehicleData
softSplashSoundVelocity | VehicleData
splashEmitter | VehicleData
splashFreqMod | VehicleData
splashVelEpsilon | VehicleData
squealSound | WheeledVehicleData
superClass | SimObject
tireEmitter | WheeledVehicleData
triggerDustHeight | VehicleData
underwaterExplosion | ShapeBaseData
useEyePoint | ShapeBaseData
waterWakeSound | VehicleData
WheelImpactSound | WheeledVehicleData


Torque 3D - Script Manual: Member List

WheeledVehicleSpring Member List

This is the complete list of members for WheeledVehicleSpring, including all inherited members.
antiSwayForce | WheeledVehicleSpring
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
damping | WheeledVehicleSpring
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
force | WheeledVehicleSpring
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
length | WheeledVehicleSpring
locked | SimObject
name | SimObject
parentGroup | SimObject
persistentId | SimObject
reloadOnLocalClient() | SimDataBlock
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

WheeledVehicleTire Member List

This is the complete list of members for WheeledVehicleTire, including all inherited members.
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
deepClone() | SimObject
delete() | SimObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
kineticFriction | WheeledVehicleTire
lateralDamping | WheeledVehicleTire
lateralForce | WheeledVehicleTire
lateralRelaxation | WheeledVehicleTire
locked | SimObject
longitudinalDamping | WheeledVehicleTire
longitudinalForce | WheeledVehicleTire
longitudinalRelaxation | WheeledVehicleTire
mass | WheeledVehicleTire
name | SimObject
parentGroup | SimObject
persistentId | SimObject
radius | WheeledVehicleTire
reloadOnLocalClient() | SimDataBlock
restitution | WheeledVehicleTire
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
shapeFile | WheeledVehicleTire
staticFriction | WheeledVehicleTire
superClass | SimObject


Torque 3D - Script Manual: Member List

ZipObject Member List

This is the complete list of members for ZipObject, including all inherited members.
addFile(string filename, string pathInZip, bool replace=true) | ZipObject
assignFieldsFrom(SimObject fromObject) | SimObject
assignPersistentId() | SimObject
call(string method, string args...) | SimObject
canSave | SimObject
canSaveDynamicFields | SimObject
class | SimObject
className | SimObject
clone() | SimObject
closeArchive() | ZipObject
closeFile(SimObject stream) | ZipObject
deepClone() | SimObject
delete() | SimObject
deleteFile(string pathInZip) | ZipObject
dump(bool detailed=false) | SimObject
dumpClassHierarchy() | SimObject
dumpGroupHierarchy() | SimObject
dumpMethods() | SimObject
extractFile(string pathInZip, string filename) | ZipObject
getCanSave() | SimObject
getClassName() | SimObject
getClassNamespace() | SimObject
getDebugInfo() | SimObject
getDeclarationLine() | SimObject
getDynamicField(int index) | SimObject
getDynamicFieldCount() | SimObject
getField(int index) | SimObject
getFieldCount() | SimObject
getFieldType(string fieldName) | SimObject
getFieldValue(string fieldName, int index=-1) | SimObject
getFileEntry(int index) | ZipObject
getFileEntryCount() | ZipObject
getFilename() | SimObject
getGroup() | SimObject
getId() | SimObject
getInternalName() | SimObject
getName() | SimObject
getSuperClassNamespace() | SimObject
hidden | SimObject
internalName | SimObject
isChildOfGroup(SimGroup group) | SimObject
isEditorOnly() | SimObject
isExpanded() | SimObject
isInNamespaceHierarchy(string name) | SimObject
isMemberOfClass(string className) | SimObject
isMethod(string methodName) | SimObject
isNameChangeAllowed() | SimObject
isSelected() | SimObject
locked | SimObject
name | SimObject
openArchive(string filename, string accessMode="read") | ZipObject
openFileForRead(string filename) | ZipObject
openFileForWrite(string filename) | ZipObject
parentGroup | SimObject
persistentId | SimObject
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject
schedule(float time, string method, string args...) | SimObject
setCanSave(bool value=true) | SimObject
setClassNamespace(string name) | SimObject
setEditorOnly(bool value=true) | SimObject
setFieldType(string fieldName, string type) | SimObject
setFieldValue(string fieldName, string value, int index=-1) | SimObject
setFilename(string fileName) | SimObject
setHidden(bool value=true) | SimObject
setInternalName(string newInternalName) | SimObject
setIsExpanded(bool state=true) | SimObject
setIsSelected(bool state=true) | SimObject
setLocked(bool value=true) | SimObject
setName(string newName) | SimObject
setNameChangeAllowed(bool value=true) | SimObject
setSuperClassNamespace(string name) | SimObject
superClass | SimObject


Torque 3D - Script Manual: Member List

Zone Member List

This is the complete list of members for Zone, including all inherited members.
ambientLightColor | Zone |
assignFieldsFrom(SimObject fromObject) | SimObject |
assignPersistentId() | SimObject |
call(string method, string args...) | SimObject |
canSave | SimObject |
canSaveDynamicFields | SimObject |
class | SimObject |
className | SimObject |
clearScopeToClient(NetConnection client) | NetObject |
clone() | SimObject |
deepClone() | SimObject |
delete() | SimObject |
dump(bool detailed=false) | SimObject |
dumpClassHierarchy() | SimObject |
dumpGroupHierarchy() | SimObject |
dumpMethods() | SimObject |
dumpZoneState(bool updateFirst=true) | Zone |
edge | Zone |
getCanSave() | SimObject |
getClassName() | SimObject |
getClassNamespace() | SimObject |
getClientObject() | NetObject |
getDebugInfo() | SimObject |
getDeclarationLine() | SimObject |
getDynamicField(int index) | SimObject |
getDynamicFieldCount() | SimObject |
getEulerRotation() | SceneObject |
getField(int index) | SimObject |
getFieldCount() | SimObject |
getFieldType(string fieldName) | SimObject |
getFieldValue(string fieldName, int index=-1) | SimObject |
getFilename() | SimObject |
getForwardVector() | SceneObject |
getGhostID() | NetObject |
getGroup() | SimObject |
getId() | SimObject |
getInternalName() | SimObject |
getMountedObject(int slot) | SceneObject |
getMountedObjectCount() | SceneObject |
getMountedObjectNode(int slot) | SceneObject |
getMountNodeObject(int node) | SceneObject |
getName() | SimObject |
getObjectBox() | SceneObject |
getObjectMount() | SceneObject |
getPosition() | SceneObject |
getRightVector() | SceneObject |
getScale() | SceneObject |
getServerObject() | NetObject |
getSuperClassNamespace() | SimObject |
getTransform() | SceneObject |
getType() | SceneObject |
getUpVector() | SceneObject |
getWorldBox() | SceneObject |
getWorldBoxCenter() | SceneObject |
getZoneId() | Zone |
hidden | SimObject |
internalName | SimObject |
isChildOfGroup(SimGroup group) | SimObject |
isClientObject() | NetObject |
isEditorOnly() | SimObject |
isExpanded() | SimObject |
isGlobalBounds() | SceneObject |
isInNamespaceHierarchy(string name) | SimObject |
isMemberOfClass(string className) | SimObject |
isMethod(string methodName) | SimObject |
isMounted() | SceneObject |
isNameChangeAllowed() | SimObject |
isRenderable | Zone | [static]
isRenderEnabled | SceneObject |
isSelectable | Zone | [static]
isSelected() | SimObject |
isSelectionEnabled | SceneObject |
isServerObject() | NetObject |
locked | SimObject |
mountNode | SceneObject |
mountObject(SceneObject objB, int slot, TransformF txfm=MatrixF::Identity) | SceneObject |
mountPID | SceneObject |
mountPos | SceneObject |
mountRot | SceneObject |
name | SimObject |
parentGroup | SimObject |
persistentId | SimObject |
plane | Zone |
point | Zone |
position | SceneObject |
rotation | SceneObject |
save(string fileName, bool selectedOnly=false, string preAppendString="") | SimObject |
scale | SceneObject |
schedule(float time, string method, string args...) | SimObject |
scopeToClient(NetConnection client) | NetObject |
setCanSave(bool value=true) | SimObject |
setClassNamespace(string name) | SimObject |
setEditorOnly(bool value=true) | SimObject |
setFieldType(string fieldName, string type) | SimObject |
setFieldValue(string fieldName, string value, int index=-1) | SimObject |
setFilename(string fileName) | SimObject |
setHidden(bool value=true) | SimObject |
setInternalName(string newInternalName) | SimObject |
setIsExpanded(bool state=true) | SimObject |
setIsSelected(bool state=true) | SimObject |
setLocked(bool value=true) | SimObject |
setName(string newName) | SimObject |
setNameChangeAllowed(bool value=true) | SimObject |
setScale(Point3F scale) | SceneObject |
setScopeAlways() | NetObject |
setSuperClassNamespace(string name) | SimObject |
setTransform(TransformF txfm) | SceneObject |
soundAmbience | Zone |
superClass | SimObject |
unmount() | SceneObject |
unmountObject(SceneObject target) | SceneObject |
useAmbientLightColor | Zone |
zoneGroup | Zone |


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- j -

  • jetEnergyDrain : VehicleData
  • jetForce : VehicleData
  • jetJumpEnergyDrain : PlayerData
  • jetJumpForce : PlayerData
  • jetJumpSurfaceAngle : PlayerData
  • jetMaxJumpSpeed : PlayerData
  • jetMinJumpEnergy : PlayerData
  • jetMinJumpSpeed : PlayerData
  • jetSound : WheeledVehicleData , FlyingVehicleData , HoverVehicleData
  • jumpDelay : PlayerData
  • jumpEnergyDrain : PlayerData
  • jumpForce : PlayerData
  • jumpSurfaceAngle : PlayerData
  • jumpTowardsNormal : PlayerData
  • justify : GuiControlProfile


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- k -

  • key : ArrayObject
  • kineticFriction : WheeledVehicleTire


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- l -

  • langTableMod : GuiControl
  • lastAttribute() : SimXMLDocument
  • lastSplitTerrainOnly : LightDescription , ScatterSky , LightBase , Sun
  • lateralDamping : WheeledVehicleTire
  • lateralForce : WheeledVehicleTire
  • lateralRelaxation : WheeledVehicleTire
  • layer : GroundCover
  • layerEnabled : BasicClouds
  • leaveCommand : Trigger
  • leftMargin : GuiSeparatorCtrl
  • length : GuiSpeedometerHud , WheeledVehicleSpring
  • level : ConsoleLogger
  • LFReference : SFXEnvironment
  • lifeSpan : DecalData
  • lifetime : DebrisData , Debris , ProjectileData , PhysicsDebrisData
  • lifetimeMS : ExplosionData , SplashData , ParticleData , ParticleEmitterData
  • lifetimeVariance : DebrisData , ExplosionData , SplashData , PhysicsDebrisData
  • lifetimeVarianceMS : ParticleEmitterData , ParticleData
  • lightAmbient : GuiObjectView
  • lightBrightness : ShapeBaseImageData
  • lightColor : ItemData , GuiObjectView , ShapeBaseImageData
  • lightDesc : ProjectileData
  • lightDirection : GuiObjectView
  • lightDuration : ShapeBaseImageData
  • lightEndBrightness : ExplosionData
  • lightEndColor : ExplosionData
  • lightEndRadius : ExplosionData
  • lightMap : Material
  • lightMapSize : TerrainBlock
  • lightNormalOffset : ExplosionData
  • LightOn : fxFoliageReplicator
  • lightOnlyStatic : ItemData
  • lightRadius : ItemData , ShapeBaseImageData
  • lightStartBrightness : ExplosionData
  • lightStartColor : ExplosionData
  • lightStartRadius : ExplosionData
  • LightSync : fxFoliageReplicator
  • LightTime : ItemData , fxFoliageReplicator
  • lightType : ItemData , ShapeBaseImageData
  • linearDamping : PhysicsShapeData , PhysicsDebrisData
  • linearDrag : PxMultiActorData
  • linearSleepThreshold : PhysicsDebrisData , PhysicsShapeData
  • lineContinuedIndex : GuiMessageVectorCtrl
  • lineSpacing : GuiMLTextCtrl , GuiMessageVectorCtrl
  • liquidType : WaterObject
  • listClassIDs() : GameConnection
  • listen() : TCPObject
  • listMeshes() : PxMultiActor
  • listObjects() : SimSet
  • loadData() : SFXFMODEventGroup
  • loadFile() : SimXMLDocument
  • locked : SimObject
  • lockFrustum : GroundCover
  • lockHorizScroll : GuiScrollCtrl
  • lockMouse : GuiMouseEventCtrl
  • lockSelection() : GuiTreeViewCtrl
  • lockVertScroll : GuiScrollCtrl
  • lodReflectScalar : Forest
  • lodType : TSShapeConstructor
  • logWeight : LightBase , ScatterSky , LightDescription , Sun
  • longitudinalDamping : WheeledVehicleTire
  • longitudinalForce : WheeledVehicleTire
  • longitudinalRelaxation : WheeledVehicleTire
  • lookAt() : Camera
  • loopMode : SFXPlayList
  • LowLODDistance : River


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- m -

  • magFilter : GFXSamplerStateData
  • mainThrustForce : HoverVehicleData
  • makeFirstResponder() : GuiControl
  • makeIconSquare : GuiIconButtonCtrl
  • makeNameCallback : GuiListBoxCtrl
  • maneuveringForce : FlyingVehicleData
  • mapTo : Material
  • margin : GuiContainer , GuiRolloutCtrl
  • markerName : WayPoint
  • markItem() : GuiTreeViewCtrl
  • mass : Camera , ShapeBaseImageData , PhysicsDebrisData , ShapeBaseData , PhysicsShapeData , WheeledVehicleTire , ForestItemData
  • massBox : RigidShapeData , VehicleData
  • massCenter : RigidShapeData , VehicleData
  • matchColor : GuiMessageVectorCtrl
  • matchScale() : GuiGraphCtrl
  • matchVideoSize : GuiTheoraCtrl
  • Material : PxMultiActorData , DecalRoad , SkyBox , ConvexShape , GroundCover , PxCloth , GroundPlane , DecalData , RenderMeshExample
  • matNamePrefix : TSShapeConstructor
  • maxAngle : GuiSpeedometerHud
  • maxAnisotropy : GFXSamplerStateData
  • maxAutoSpeed : FlyingVehicleData
  • maxBackwardSpeed : PlayerData
  • maxBillboardTiltAngle : GroundCover
  • maxChars : GuiMLTextCtrl
  • maxClumpCount : GroundCover
  • maxColorIndex : GuiMessageVectorCtrl
  • maxConcurrentSounds : ShapeBaseImageData
  • maxCrouchBackwardSpeed : PlayerData
  • maxCrouchForwardSpeed : PlayerData
  • maxCrouchSideSpeed : PlayerData
  • maxDamage : ShapeBaseData
  • maxDistance : SFXDescription , SFXPlayList , SFXEmitter
  • maxDistanceVariance : SFXPlayList
  • maxDrag : RigidShapeData , VehicleData
  • maxElements : GroundCover
  • maxElevation : GroundCover
  • maxEnergy : ShapeBaseData
  • maxForwardSpeed : PlayerData
  • maxFreelookAngle : PlayerData
  • MaxHeight : fxFoliageReplicator
  • maximizeWindow() : GuiCanvas
  • maxJumpSpeed : PlayerData
  • maxLength : GuiTextCtrl
  • maxLookAngle : PlayerData
  • MaxLuminance : fxFoliageReplicator
  • maxMass : Precipitation
  • maxOrbitDiststance : GuiObjectView
  • maxPopupHeight : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • maxPredictionTicks : Player
  • maxProneBackwardSpeed : PlayerData
  • maxProneForwardSpeed : PlayerData
  • maxProneSideSpeed : PlayerData
  • maxRateMs : ReflectorDesc
  • maxSideSpeed : PlayerData
  • maxSlope : GroundCover
  • maxSpeed : GuiSpeedometerHud , Precipitation
  • maxSpinSpeed : DebrisData
  • maxSteeringAngle : VehicleData
  • maxStepHeight : PlayerData
  • MaxSwayTime : fxFoliageReplicator
  • maxTimeScale : PlayerData
  • maxTurbulence : Precipitation
  • maxUnderwaterBackwardSpeed : PlayerData
  • maxUnderwaterForwardSpeed : PlayerData
  • maxUnderwaterSideSpeed : PlayerData
  • maxVelocity : ItemData
  • maxWarpTicks : Player , Item
  • maxWheelSpeed : WheeledVehicleData
  • MaxWidth : fxFoliageReplicator
  • mediaPath : SFXFMODProject
  • mediumSplashSoundVelocity : RigidShapeData , VehicleData , PlayerData
  • meshCulling : fxShapeReplicatedStatic , TSStatic
  • mieScattering : ScatterSky
  • minAngle : GuiSpeedometerHud
  • minClumpCount : GroundCover
  • minDrag : RigidShapeData , VehicleData
  • minElevation : GroundCover
  • minEnergy : ShapeBaseImageData
  • minExtent : GuiControl
  • minFilter : GFXSamplerStateData
  • MinHeight : fxFoliageReplicator
  • minimizeWindow() : GuiCanvas
  • minImpactSpeed : VehicleData , RigidShapeData , PlayerData
  • minJetEnergy : VehicleData
  • minJumpEnergy : PlayerData
  • minJumpSpeed : PlayerData
  • minLookAngle : PlayerData
  • MinLuminance : fxFoliageReplicator
  • minMass : Precipitation
  • minnaertConstant : Material
  • minOrbitDiststance : GuiObjectView
  • minRollSpeed : RigidShapeData , VehicleData
  • minRunEnergy : PlayerData
  • minSpeed : Precipitation
  • minSpinSpeed : DebrisData
  • MinSwayTime : fxFoliageReplicator
  • minTabWidth : GuiTabBookCtrl
  • minTrailSpeed : FlyingVehicleData
  • minWarpTicks : Player , Item
  • MinWidth : fxFoliageReplicator
  • mipFilter : GFXSamplerStateData
  • mipLODBias : GFXSamplerStateData
  • mirrorSet : GuiListBoxCtrl
  • missionCycleCleanup : AIClient
  • mMoveTolerance : AIPlayer
  • modal : GuiControl , GuiControlProfile
  • modifyStorm() : Precipitation
  • modulationDepth : SFXEnvironment
  • modulationTime : SFXEnvironment
  • moonAzimuth : ScatterSky
  • moonElevation : ScatterSky
  • moonEnabled : ScatterSky
  • moonLightColor : ScatterSky
  • moonMat : ScatterSky
  • moonScale : ScatterSky
  • mountedNode : GuiObjectView
  • mountedShapeFile : GuiObjectView
  • mountedSkin : GuiObjectView
  • mountImage() : ShapeBase
  • mountNode : SceneObject
  • mountNode0 : PxMultiActorData
  • mountNode1 : PxMultiActorData
  • mountNode10 : PxMultiActorData
  • mountNode11 : PxMultiActorData
  • mountNode12 : PxMultiActorData
  • mountNode13 : PxMultiActorData
  • mountNode14 : PxMultiActorData
  • mountNode15 : PxMultiActorData
  • mountNode16 : PxMultiActorData
  • mountNode17 : PxMultiActorData
  • mountNode18 : PxMultiActorData
  • mountNode19 : PxMultiActorData
  • mountNode2 : PxMultiActorData
  • mountNode20 : PxMultiActorData
  • mountNode21 : PxMultiActorData
  • mountNode22 : PxMultiActorData
  • mountNode23 : PxMultiActorData
  • mountNode24 : PxMultiActorData
  • mountNode25 : PxMultiActorData
  • mountNode26 : PxMultiActorData
  • mountNode27 : PxMultiActorData
  • mountNode28 : PxMultiActorData
  • mountNode29 : PxMultiActorData
  • mountNode3 : PxMultiActorData
  • mountNode30 : PxMultiActorData
  • mountNode31 : PxMultiActorData
  • mountNode4 : PxMultiActorData
  • mountNode5 : PxMultiActorData
  • mountNode6 : PxMultiActorData
  • mountNode7 : PxMultiActorData
  • mountNode8 : PxMultiActorData
  • mountNode9 : PxMultiActorData
  • mountObject() : SceneObject
  • mountPID : SceneObject
  • mountPoint : ShapeBaseImageData
  • mountPos : SceneObject
  • mountRot : SceneObject
  • mouseDragging : GuiTreeViewCtrl
  • mouseOverSelected : GuiControlProfile
  • mouseWheelScrollSpeed : GuiScrollCtrl
  • move : AIClient
  • moveFirst() : ArrayObject
  • moveForward : AIClient
  • moveItemDown() : GuiTreeViewCtrl
  • moveItemUp() : GuiTreeViewCtrl
  • moveLast() : ArrayObject
  • movementSpeed : Camera
  • moveNext() : ArrayObject
  • movePrev() : ArrayObject
  • moveStuckTestDelay : AIPlayer
  • moveStuckTolerance : AIPlayer
  • movingBubblesSound : PlayerData
  • msg() : SimpleNetObject
  • msToNext : Marker
  • MultipleFiles : OpenFileDialog
  • multipleSelections : GuiTreeViewCtrl
  • MustExist : OpenFileDialog
  • muzzleVelocity : ProjectileData


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- n -

  • name : SimObject
  • nearClip : LevelInfo
  • nearDist : ReflectorDesc
  • neverImport : TSShapeConstructor
  • neverImportMesh : TSShapeConstructor
  • newtonMode : Camera
  • newtonRotation : Camera
  • nextAttribute() : SimXMLDocument
  • nextSiblingElement() : SimXMLDocument
  • nightColor : ScatterSky
  • nightCubemap : ScatterSky
  • nightFogColor : ScatterSky
  • nightScale : TimeOfDay
  • noBillboards : GroundCover
  • noCorrection : PxMultiActorData
  • noCorrections : PhysicsShape
  • Node : DecalRoad , MeshRoad , River
  • noIndividualDamage : StaticShapeData
  • normalForce : HoverVehicleData
  • normalMap : TerrainMaterial , Material
  • noShapes : GroundCover
  • noSmoothing : PhysicsShape
  • notifyShapeChanged() : TSShapeConstructor
  • numbersOnly : GuiControlProfile
  • numBounces : DebrisData
  • numDmgEmitterAreas : VehicleData
  • numDrops : Precipitation
  • numFences : GuiCanvas
  • numSegments : SplashData
  • numSlotsToPlay : SFXPlayList
  • numSplits : LightDescription , LightBase , ScatterSky , Sun


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- o -

  • objectTypeMask : ReflectorDesc
  • observeThroughObject : ShapeBaseData
  • occlusionRadius : LightFlareData
  • offset : ExplosionData , ShapeBaseImageData
  • offsetA : LightAnimData
  • offsetKeys : LightAnimData
  • offsetPeriod : LightAnimData
  • offsetSmooth : LightAnimData
  • OffsetZ : LightAnimData , fxFoliageReplicator , fxShapeReplicator
  • OGLPixelShaderFile : ShaderData
  • OGLVertexShaderFile : ShaderData
  • onAction() : GuiControl
  • onActivate() : SFXState
  • onActive() : GuiControl
  • onAdd() : GameBaseData , GuiControl , ScriptMsgListener , SpawnSphere , Trigger , ScriptObject , ScriptGroup , PostEffect , Message
  • onAddGroupSelected() : GuiTreeViewCtrl
  • onAddMultipleSelectionBegin() : GuiTreeViewCtrl
  • onAddMultipleSelectionEnd() : GuiTreeViewCtrl
  • onAddSelection() : GuiTreeViewCtrl
  • onAddToQueue() : ScriptMsgListener
  • onAltClick() : GuiBitmapButtonCtrl
  • onBeginReparenting() : GuiTreeViewCtrl
  • onChange() : GuiGameListMenuCtrl
  • onChildAdded : GuiScriptNotifyCtrl
  • onChildRemoved : GuiScriptNotifyCtrl
  • onChildResized : GuiScriptNotifyCtrl
  • onClearSelection() : GuiListBoxCtrl , GuiTreeViewCtrl
  • onClick() : GuiButtonBaseCtrl
  • onClose() : GuiWindowCtrl
  • onCollapse() : GuiWindowCtrl
  • onCollapsed() : GuiRolloutCtrl
  • onCollision() : ShapeBaseData , ProjectileData
  • onComplete() : GuiAutoScrollCtrl
  • onConnected() : TCPObject
  • onConnectFailed() : TCPObject
  • onConnectionAccepted() : GameConnection
  • onConnectionDropped() : GameConnection
  • onConnectionError() : GameConnection
  • onConnectionRequest() : TCPObject
  • onConnectionTimedOut() : GameConnection
  • onConnectRequestRejected() : GameConnection
  • onConnectRequestTimedOut() : GameConnection
  • onControlDragEnter() : GuiControl
  • onControlDragExit() : GuiControl
  • onControlDragged() : GuiControl
  • onControlDropped() : GuiControl
  • onCtrlClick() : GuiBitmapButtonCtrl
  • onDamage() : ShapeBaseData
  • onDataBlocksDone() : GameConnection
  • onDeactivate() : SFXState
  • onDefaultClick() : GuiBitmapButtonCtrl
  • onDefineIcons() : GuiTreeViewCtrl
  • onDeleteKey() : GuiListBoxCtrl , GuiTextListCtrl
  • onDeleteObject() : GuiTreeViewCtrl
  • onDeleteSelection() : GuiTreeViewCtrl
  • onDestroyed() : ShapeBaseData
  • onDialogPop() : GuiControl
  • onDialogPush() : GuiControl
  • onDisabled() : ShapeBaseData , PostEffect
  • onDisconnect() : TCPObject
  • onDNSFailed() : TCPObject
  • onDNSResolved() : TCPObject
  • onDone() : GuiFadeinBitmapCtrl
  • onDoubleClick() : GuiButtonBaseCtrl , GuiListBoxCtrl
  • onDragDropped() : GuiTreeViewCtrl
  • onDrop() : GameConnection
  • oneFrameOnly : PostEffect
  • onEnabled() : ShapeBaseData , PostEffect
  • onEndReparenting() : GuiTreeViewCtrl
  • onEndSequence() : ShapeBaseData
  • onEnterLiquid() : VehicleData , Item , PlayerData , RigidShape
  • onEnterMissionArea() : PlayerData
  • onEnterTrigger() : TriggerData
  • onExpanded() : GuiRolloutCtrl
  • onExplode() : ProjectileData
  • onFlash() : GameConnection
  • onForceUncloak() : ShapeBaseData
  • onGainFirstResponder : GuiScriptNotifyCtrl , GuiControl , GuiScriptNotifyCtrl
  • onHeaderRightClick() : GuiRolloutCtrl
  • onImpact() : ShapeBaseData
  • onInputEvent() : GuiInputCtrl
  • onInspect() : GuiTreeViewCtrl
  • onKeyDown() : GuiTreeViewCtrl
  • onLeaveLiquid() : VehicleData , Item , PlayerData , RigidShape
  • onLeaveMissionArea() : PlayerData
  • onLeaveTrigger() : TriggerData
  • onLine() : TCPObject
  • onLoad() : Prefab , TSShapeConstructor
  • onLoseFirstResponder : GuiScriptNotifyCtrl , GuiControl , GuiScriptNotifyCtrl
  • onMaximize() : GuiWindowCtrl
  • onMenuItemSelect() : GuiMenuBar
  • onMenuSelect() : GuiMenuBar
  • onMessageObjectReceived() : ScriptMsgListener
  • onMessageReceived() : ScriptMsgListener
  • onMessageSelected() : GuiConsole
  • onMinimize() : GuiWindowCtrl
  • onMount() : GameBaseData , ShapeBaseImageData
  • onMouseDown() : GuiButtonBaseCtrl , GuiMouseEventCtrl
  • onMouseDragged() : GuiButtonBaseCtrl , GuiListBoxCtrl , GuiTreeViewCtrl , GuiMouseEventCtrl , GuiSliderCtrl
  • onMouseEnter() : GuiButtonBaseCtrl , GuiObjectView , GuiMouseEventCtrl
  • onMouseInMenu() : GuiMenuBar
  • onMouseLeave() : GuiButtonBaseCtrl , GuiObjectView , GuiMouseEventCtrl
  • onMouseMove() : GuiMouseEventCtrl
  • onMouseUp() : GuiButtonBaseCtrl , GuiListBoxCtrl , GuiTreeViewCtrl , GuiMouseEventCtrl
  • onNewDataBlock() : GameBaseData
  • onNode() : PathCamera
  • onObjectAdded() : SimSet
  • onObjectDeleteCompleted() : GuiTreeViewCtrl
  • onObjectRemoved() : SimSet
  • onParameterValueChange() : SFXSource
  • onParentResized() : GuiScriptNotifyCtrl
  • onRemove() : GameBaseData , GuiControl , Trigger , ScriptObject , ScriptGroup , Message , ScriptMsgListener
  • onRemoveFromQueue() : ScriptMsgListener
  • onRemoveSelection() : GuiTreeViewCtrl
  • onRenameValidate : GuiTreeViewCtrl
  • onReparent() : GuiTreeViewCtrl
  • onReset() : GuiAutoScrollCtrl
  • onResize : GuiScriptNotifyCtrl , GuiMLTextCtrl , GuiScriptNotifyCtrl
  • onRestore() : GuiWindowCtrl
  • onReturn() : GuiTextEditCtrl
  • onRightClick() : GuiButtonBaseCtrl
  • onRightMouseDown() : GuiTreeViewCtrl , GuiMouseEventCtrl
  • onRightMouseDragged() : GuiMouseEventCtrl
  • onRightMouseUp() : GuiTreeViewCtrl , GuiMouseEventCtrl
  • onScroll() : GuiScrollCtrl
  • onSelect() : GuiListBoxCtrl , GuiTreeViewCtrl , GuiTextListCtrl
  • onShiftClick() : GuiBitmapButtonCtrl
  • onSleep() : GuiControl
  • onStart() : GuiAutoScrollCtrl
  • onStartSwim() : PlayerData
  • onStatusChange() : SFXSource
  • onStickyCollision() : Item
  • onStopSwim() : PlayerData
  • onSubmenuSelect() : GuiMenuBar
  • onTabComplete() : GuiTextEditCtrl
  • onTabRightClick() : GuiTabBookCtrl
  • onTabSelected() : GuiTabBookCtrl
  • onThisFrame : PostEffect
  • onTick() : GuiAutoScrollCtrl
  • onTickTrigger() : TriggerData
  • onTrigger() : ShapeBaseData
  • onUnload() : TSShapeConstructor
  • onUnmount() : GameBaseData , ShapeBaseImageData
  • onUnselect() : GuiTreeViewCtrl , GuiListBoxCtrl
  • onUpdate() : SFXParameter
  • onURL() : GuiMLTextCtrl
  • onValidate() : GuiTextEditCtrl
  • onVisible() : GuiControl
  • onWake() : GuiControl
  • onWindowClosed() : PfxVis
  • opaque : GuiControlProfile
  • open() : GuiTreeViewCtrl , FileStreamObject , PfxVis
  • openArchive() : ZipObject
  • openFileForRead() : ZipObject
  • openFileForWrite() : ZipObject
  • openForAppend() : FileObject
  • openForRead() : FileObject
  • openForWrite() : FileObject
  • orbitDiststance : GuiObjectView
  • orientation : GuiSplitContainer
  • orientOnVelocity : ParticleEmitterData
  • orientParticles : ParticleEmitterData
  • originSort : fxShapeReplicatedStatic , TSStatic
  • outdoorWeight : SpawnSphere
  • outerAngle : SpotLight
  • OuterRadiusX : fxShapeReplicator , fxFoliageReplicator
  • OuterRadiusY : fxFoliageReplicator , fxShapeReplicator
  • overallFoamOpacity : WaterObject
  • overallRippleMagnitude : WaterObject
  • overallScale : LightFlareData
  • overallWaveMagnitude : WaterObject
  • overDarkFactor : LightBase , LightDescription , Sun , ScatterSky
  • overlayMap : Material
  • overlayTex : Material
  • overrideAdvance : ParticleEmitterData
  • OverwritePrompt : SaveFileDialog


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- z -

  • zBias : GFXStateBlockData
  • zDefined : GFXStateBlockData
  • zEnable : GFXStateBlockData
  • zFunc : GFXStateBlockData
  • zOffset : GroundCover
  • zoneGroup : InteriorInstance , Zone
  • zSlopeBias : GFXStateBlockData
  • zWriteEnable : GFXStateBlockData


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- b -

  • backgroundColor : GuiTheoraCtrl
  • backSidePassable : Portal
  • backwardJetEmitter : FlyingVehicleData
  • barBehindText : GuiPaneControl
  • baseColor : CloudLayer , WaterObject
  • baseRadius : DebrisData
  • baseShape : TSShapeConstructor
  • baseTex : Material
  • baseTexSize : TerrainBlock
  • bending : PxCloth
  • bendingStiffness : PxCloth
  • bevelColorHL : GuiControlProfile
  • bevelColorLL : GuiControlProfile
  • billboardUVs : GroundCover
  • bind() : ActionMap
  • bindCmd() : ActionMap
  • bindObj() : ActionMap
  • binType : RenderBinManager
  • bitmap : GuiBitmapCtrl , GuiBitmapButtonCtrl , GuiControlProfile , GuiTextEditSliderBitmapCtrl , GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx , GuiChunkedBitmapCtrl , GuiProgressBitmapCtrl
  • bitmapBounds : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • bitmapMode : GuiBitmapButtonCtrl
  • bitmapName : GuiCursor
  • blendDefined : GFXStateBlockData
  • blendDest : GFXStateBlockData
  • blendEnable : GFXStateBlockData
  • blendOp : GFXStateBlockData
  • blendSrc : GFXStateBlockData
  • blendStyle : ParticleEmitterData
  • bodyFriction : RigidShapeData , VehicleData
  • bodyRestitution : RigidShapeData , VehicleData
  • boltStartRadius : Lightning
  • border : GuiControlProfile
  • borderColor : GuiControlProfile , GuiFrameSetCtrl
  • borderColorHL : GuiControlProfile
  • borderColorNA : GuiControlProfile
  • borderEnable : GuiFrameSetCtrl
  • borderMargin : GuiSeparatorCtrl
  • borderMovable : GuiFrameSetCtrl
  • borderThickness : GuiControlProfile
  • borderWidth : GuiFrameSetCtrl
  • bottomMaterial : MeshRoad
  • bounceElasticity : ProjectileData
  • bounceFriction : ProjectileData
  • bounceVariance : DebrisData
  • boundingBox : GameBase , PlayerData
  • boxHeadBackPercentage : PlayerData
  • boxHeadFrontPercentage : PlayerData
  • boxHeadLeftPercentage : PlayerData
  • boxHeadPercentage : PlayerData
  • boxHeadRightPercentage : PlayerData
  • boxHeight : Precipitation
  • boxTorsoPercentage : PlayerData
  • boxWidth : Precipitation
  • brakeMultiplier : Camera
  • brakeTorque : WheeledVehicleData
  • brakingActivationSpeed : HoverVehicleData
  • brakingForce : HoverVehicleData
  • branchAmp : ForestItemData
  • breakAngle : MeshRoad , DecalRoad
  • breakForce : PxMultiActorData
  • brightness : ScatterSky , LightBase , Sun , LightDescription
  • brightnessA : LightAnimData
  • brightnessKeys : LightAnimData
  • brightnessPeriod : LightAnimData
  • brightnessSmooth : LightAnimData
  • brightnessZ : LightAnimData
  • bringToFront() : SimSet
  • broken : PxMultiActor
  • bubbleEmitTime : PlayerData
  • buildIconTable() : GuiTreeViewCtrl
  • buildVisibleTree : GuiTreeViewCtrl
  • bumpAtlas : Material
  • bumpTex : Material
  • buoyancyDensity : PxMultiActorData , PhysicsDebrisData , PhysicsShapeData
  • buttonMargin : GuiIconButtonCtrl
  • buttonType : GuiButtonBaseCtrl


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- c -

  • calculateViewDistance() : GuiTSCtrl
  • call() : SimObject
  • callbackOnA : GuiGameListMenuCtrl
  • callbackOnB : GuiGameListMenuCtrl
  • callbackOnX : GuiGameListMenuCtrl
  • callbackOnY : GuiGameListMenuCtrl
  • callOnChildren() : SimSet
  • callOnChildrenNoRecurse() : SimSet
  • cameraDecay : RigidShapeData , VehicleData
  • cameraDefaultFov : ShapeBaseData
  • cameraLag : RigidShapeData , VehicleData
  • cameraMaxDist : ShapeBaseData
  • cameraMaxFov : ShapeBaseData
  • cameraMinDist : ShapeBaseData
  • cameraMinFov : ShapeBaseData
  • cameraOffset : RigidShapeData , VehicleData
  • cameraRoll : RigidShapeData , VehicleData
  • cameraSpeed : GuiObjectView
  • cameraZRot : GuiTSCtrl
  • camShakeAmp : ExplosionData , ShapeBaseImageData
  • camShakeDuration : ExplosionData
  • camShakeFalloff : ExplosionData
  • camShakeFreq : ExplosionData , ShapeBaseImageData
  • camShakeRadius : ExplosionData
  • cancelRename : GuiTreeViewCtrl
  • canCloak() : ShapeBase
  • canClose : GuiWindowCtrl
  • canCollapse : GuiWindowCtrl
  • canKeyFocus : GuiControlProfile
  • canMaximize : GuiWindowCtrl
  • canMinimize : GuiWindowCtrl
  • canMove : GuiWindowCtrl
  • canRenameObject() : GuiTreeViewCtrl
  • canRenameObjects : GuiTreeViewCtrl
  • canSave : SimObject
  • canSaveDynamicFields : SimObject
  • canvasClearColor : LevelInfo
  • caption : GuiSeparatorCtrl , GuiRolloutCtrl , GuiPaneControl
  • captionID : GuiPaneControl
  • caseSensitive : ArrayObject
  • casing : ShapeBaseImageData
  • castShadows : LightBase , Material , LightDescription , PhysicsDebrisData , ScatterSky , Sun , TerrainBlock
  • category : GameBaseData , GuiControlProfile
  • cellIndex : Material
  • cellLayout : Material
  • cellSize : Material
  • center : GuiSpeedometerHud
  • centerY : GuiGraphCtrl
  • chanceToHitTarget : Lightning
  • changeChildPosition : GuiStackControl
  • changeChildSizeToFit : GuiStackControl
  • changeMaterial() : ShapeBase , TSStatic , InteriorInstance
  • changePath : FileDialog
  • changeTextById() : GuiPopUpMenuCtrl
  • channel : SFXParameter
  • chaseCam() : GameConnection
  • checkDeployPos() : ShapeBaseData
  • checkDismountPoint() : Player
  • checkMaxRate() : NetConnection
  • childBorder : GuiAutoScrollCtrl
  • childMargin : GuiScrollCtrl
  • clarity : WaterObject
  • class : SimObject
  • className : SimObject
  • clear : GuiPopUpMenuCtrl , SimSet , SimXMLDocument , Forest , GuiTreeViewCtrl , GuiPopUpMenuCtrlEx , GuiTextListCtrl , MessageVector , PfxVis
  • clearAim() : AIPlayer
  • clearAllOnSingleSelection : GuiTreeViewCtrl
  • clearCameraObject() : GameConnection
  • clearControlObject() : Player
  • clearEntry() : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • clearError() : SimXMLDocument
  • clearFilterText() : GuiTreeViewCtrl
  • clearFirstResponder() : GuiControl
  • clearItemColor() : GuiListBoxCtrl
  • clearItems() : GuiListBoxCtrl
  • clearMenuItems() : GuiMenuBar
  • clearMenus() : GuiMenuBar
  • clearPaths() : NetConnection
  • clearScopeToClient() : NetObject
  • clearSelectedText() : GuiTextEditCtrl
  • clearSelection() : GuiListBoxCtrl , GuiTreeViewCtrl , GuiTextListCtrl
  • clearShaderMacros() : PostEffect
  • clearSubmenuItems() : GuiMenuBar
  • click() : GuiFadeinBitmapCtrl
  • clickCollapse : GuiRolloutCtrl
  • clientOnly : PxMultiActorData
  • clientSide : TriggerData
  • clientToScreen() : GuiCanvas
  • clipColumnText : GuiTextListCtrl
  • clippingAngle : DecalData
  • cloakable : ShapeBaseImageData
  • clone() : SimObject
  • close() : FileObject , FileStreamObject
  • closeArchive() : ZipObject
  • closeCommand : GuiWindowCtrl
  • closeFile() : ZipObject
  • clumpExponent : GroundCover
  • clumpRadius : GroundCover
  • colCount : GuiControlArrayControl , GuiDynamicCtrlArrayControl
  • collapsable : GuiPaneControl
  • collapse() : GuiRolloutCtrl
  • collDamageMultiplier : VehicleData
  • collDamageThresholdVel : VehicleData
  • collidable : ForestItemData
  • collisionTol : VehicleData , RigidShapeData
  • collisionType : fxShapeReplicatedStatic , TSStatic
  • color : GuiSpeedometerHud , LightDescription , Lightning , GuiSwatchButtonCtrl , Sun , LightBase
  • colorA : LightAnimData
  • colorArg1 : GFXSamplerStateData
  • colorArg2 : GFXSamplerStateData
  • colorArg3 : GFXSamplerStateData
  • colorBullet : GuiListBoxCtrl
  • colorKeys : LightAnimData
  • colorMultiply : Material
  • colorPeriod : LightAnimData
  • colors : ParticleData , SplashData
  • colorSmooth : LightAnimData
  • colorWriteAlpha : GFXStateBlockData
  • colorWriteBlue : GFXStateBlockData
  • colorWriteDefined : GFXStateBlockData
  • colorWriteGreen : GFXStateBlockData
  • colorWriteRed : GFXStateBlockData
  • colorZ : LightAnimData
  • colSize : GuiDynamicCtrlArrayControl
  • colSizes : GuiControlArrayControl
  • colSpacing : GuiControlArrayControl , GuiDynamicCtrlArrayControl
  • columns : GuiFrameSetCtrl , GuiTextListCtrl
  • columnSplit : GuiGameListOptionsProfile
  • command : GuiControl
  • compareToObjectID : GuiTreeViewCtrl
  • computeCRC : ShapeBaseImageData , ShapeBaseData
  • computeSizes() : GuiScrollCtrl
  • coneInsideAngle : SFXDescription , SFXEmitter
  • coneOutsideAngle : SFXDescription , SFXEmitter
  • coneOutsideVolume : SFXDescription , SFXEmitter
  • connect() : NetConnection , TCPObject
  • connectLocal() : NetConnection
  • constantAcceleration : ParticleData
  • constantThumbHeight : GuiScrollCtrl
  • contactTol : RigidShapeData , VehicleData
  • controlIsChild() : GuiControl
  • controlMode : Camera
  • cookie : LightDescription , ScatterSky , LightBase , Sun
  • copyEffect : RenderFormatToken
  • copyFrom() : StreamObject
  • coronaEnabled : Sun
  • coronaMaterial : Sun
  • coronaScale : Sun
  • coronaTint : Sun
  • coronaUseLightColor : Sun
  • correctionNode0 : PxMultiActorData
  • correctionNode1 : PxMultiActorData
  • correctMuzzleVector : ShapeBaseImageData
  • count() : ArrayObject
  • countKey() : ArrayObject
  • countValue() : ArrayObject
  • coverage : CloudLayer
  • createHoverHeight : FlyingVehicleData
  • createNew : TerrainBlock
  • createNullDevice() : GFXInit
  • crop() : ArrayObject
  • crouchBoundingBox : PlayerData
  • crouchForce : PlayerData
  • cubeFace : CubemapData
  • cubemap : Material , WaterObject
  • cubeReflectorDesc : ShapeBaseData
  • cullDefined : GFXStateBlockData
  • cullMode : GFXStateBlockData
  • CullResolution : fxFoliageReplicator
  • cursorColor : GuiControlProfile
  • cursorOff() : GuiCanvas
  • cursorOn() : GuiCanvas
  • customFootstepSound : Material
  • customImpactSound : Material


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- d -

  • damageEmitter : VehicleData
  • damageEmitterOffset : VehicleData
  • damageFillColor : GuiHealthBarHud , GuiCrossHairHud
  • damageFrameColor : GuiCrossHairHud
  • damageLevelTolerance : VehicleData
  • damageOffset : GuiCrossHairHud
  • damageRect : GuiCrossHairHud
  • damping : PxCloth , WheeledVehicleSpring
  • dampingCoefficient : PxCloth , ForestItemData
  • dataBlock : GameBase
  • dataFile : Forest
  • dayLength : TimeOfDay
  • dayScale : TimeOfDay
  • deactivate() : PhysicalZone , SFXState
  • Debris : ShapeBaseData , ExplosionData , PhysicsShapeData
  • debrisNum : ExplosionData
  • debrisNumVariance : ExplosionData
  • debrisPhiMax : ExplosionData
  • debrisPhiMin : ExplosionData
  • debrisShapeName : ShapeBaseData
  • debrisThetaMax : ExplosionData
  • debrisThetaMin : ExplosionData
  • debrisVelocity : ExplosionData
  • debrisVelocityVariance : ExplosionData
  • DebugBoxHeight : fxFoliageReplicator
  • debugRender : RenderOcclusionMgr , PxMultiActor , GuiGameListMenuCtrl , TerrainBlock
  • decal : ProjectileData
  • decalBias : LevelInfo
  • DecalData : PlayerData
  • decalOffset : PlayerData
  • decalType : fxShapeReplicatedStatic , TSStatic
  • decayHFRatio : SFXEnvironment
  • decayLFRatio : SFXEnvironment
  • decayTime : SFXEnvironment
  • deepClone() : SimObject
  • defaultFile : FileDialog
  • defaultHeight : GuiRolloutCtrl
  • defaultPage : GuiTabBookCtrl
  • defaultPath : FileDialog
  • defaultValue : SFXParameter
  • defines : ShaderData
  • delayMS : ExplosionData , SplashData
  • delayTimeIn : SFXPlayList
  • delayTimeInVariance : SFXPlayList
  • delayTimeOut : SFXPlayList
  • delayTimeOutVariance : SFXPlayList
  • delayVariance : ExplosionData , SplashData
  • delete() : SimObject , GameConnection
  • deleteAllObjects() : SimSet
  • deleteFile() : ZipObject
  • deleteItem() : GuiListBoxCtrl
  • deleteLine() : MessageVector
  • deleteObjectAllowed : GuiTreeViewCtrl
  • deleteOnMouseUp : GuiDragAndDropControl
  • deleteSelection() : GuiTreeViewCtrl
  • deniedSound : GuiTextEditCtrl , GuiMLTextCtrl
  • density : ShapeBaseData , PxCloth , WaterObject , SFXEnvironment
  • depthFormat : RenderFormatToken
  • depthGradientMax : WaterObject
  • depthGradientTex : WaterObject
  • description : SFXTrack , SFXSource , SFXParameter
  • destroy() : PhysicsShape
  • destroyedLevel : ShapeBaseData
  • destroyedShape : PhysicsShapeData
  • destroyThread() : ShapeBase
  • destroyTreeOnSleep : GuiTreeViewCtrl
  • detach() : PhysicsForce , ConsoleLogger , GuiMessageVectorCtrl
  • detailAdjust : ReflectorDesc
  • detailAmp : ForestItemData
  • detailDistance : TerrainMaterial
  • detailFreq : ForestItemData
  • detailMap : Material , TerrainMaterial
  • detailNormalMap : Material
  • detailNormalMapStrength : Material
  • detailScale : Material
  • detailSize : TerrainMaterial
  • detailStrength : TerrainMaterial
  • detailTex : Material
  • diffuseColor : Material
  • diffuseMap : TerrainMaterial , Material
  • diffuseSize : TerrainMaterial
  • diffusion : SFXEnvironment
  • disable() : PostEffect , RenderPassStateToken , SFXState
  • disabledLevel : ShapeBaseData
  • disableImposters : Forest
  • disableMove : Vehicle
  • discardAll : DecalRoad
  • disconnect() : TCPObject
  • displayEnergy : GuiHealthBarHud
  • dissolveRadius : GroundCover
  • distanceFade : GuiShapeNameHud
  • distortEndDist : WaterObject
  • distortFullDepth : WaterObject
  • distortStartDist : WaterObject
  • docking : GuiContainer
  • doCollision : Precipitation
  • doDismount() : PlayerData
  • doMirror() : GuiListBoxCtrl
  • done : GuiFadeinBitmapCtrl
  • dopplerFactor : SFXAmbience
  • doubleSided : Material
  • downJetEmitter : FlyingVehicleData
  • drag : ShapeBaseData , Camera
  • dragCoefficient : ParticleData
  • dragForce : HoverVehicleData , RigidShapeData
  • dragToItemAllowed : GuiTreeViewCtrl
  • drawBottom : SkyBox
  • drawBounds : Forest
  • drawBox() : DebugDrawer
  • drawCells : Forest
  • drawLine() : DebugDrawer
  • dropAnimateMS : Precipitation
  • dropShader : PrecipitationData
  • dropSize : Precipitation
  • dropsPerSide : PrecipitationData
  • dropTexture : PrecipitationData
  • dump() : SimObject , MessageVector
  • dumpClassHierarchy() : SimObject
  • dumpEvents() : EventManager
  • dumpGroupHierarchy() : SimObject
  • dumpInstances : Material
  • dumpMeshVisibility() : ShapeBase
  • dumpMethods() : SimObject
  • dumpModel : PxMultiActorData
  • dumpShaderDisassembly() : PostEffect
  • dumpShape() : TSShapeConstructor
  • dumpSubscribers() : EventManager
  • dumpZoneState() : Zone
  • duplicate() : ArrayObject
  • dustEmitter : RigidShapeData , VehicleData , PlayerData
  • dustHeight : VehicleData , RigidShapeData
  • dustTrailEmitter : RigidShapeData , HoverVehicleData
  • dustTrailFreqMod : HoverVehicleData
  • dustTrailOffset : HoverVehicleData
  • DXPixelShaderFile : ShaderData
  • DXVertexShaderFile : ShaderData
  • dynamic : CubemapData
  • dynamicCubemap : Material
  • dynamicFarDist : CubemapData
  • dynamicFriction : PxMaterial
  • dynamicNearDist : CubemapData
  • dynamicNonStackExtent : GuiStackControl
  • dynamicObjectTypeMask : CubemapData
  • dynamicPos : GuiStackControl
  • dynamicSize : GuiStackControl , GuiDynamicCtrlArrayControl , CubemapData
  • dynamicType : StaticShapeData


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- e -

  • echo() : ArrayObject
  • echoDepth : SFXEnvironment
  • echoTime : SFXEnvironment
  • edge : OcclusionVolume , SFXSpace , Zone
  • edgeSnap : GuiWindowCtrl
  • editItem() : GuiTreeViewCtrl
  • EditorOpen : DecalRoad , MeshRoad , River
  • effectColor : Material
  • ejectionAngle : SplashData
  • ejectionFreq : SplashData
  • ejectionOffset : ParticleEmitterData
  • ejectionPeriodMS : ParticleEmitterData
  • ejectionVelocity : ParticleEmitterData
  • elasticity : DebrisData , ItemData
  • elementDist : LightFlareData
  • elementRect : LightFlareData
  • elementRotate : LightFlareData
  • elementScale : LightFlareData
  • elementTint : LightFlareData
  • elementUseLightColor : LightFlareData
  • elementValue() : SimXMLDocument
  • elevation : ScatterSky , Sun
  • elevationMax : ForestBrushElement
  • elevationMin : ForestBrushElement
  • emap : ShapeBaseImageData
  • emissive : WaterObject , Material
  • emitter : ExplosionData , SplashData , ParticleEmitterNode
  • emitters : DebrisData
  • empty() : ArrayObject
  • enable() : RenderPassStateToken , PostEffect , SFXState
  • enabled : RenderPassStateToken
  • engineBrake : WheeledVehicleData
  • engineSound : FlyingVehicleData , HoverVehicleData , WheeledVehicleData
  • engineTorque : WheeledVehicleData
  • enterCommand : Trigger
  • envDiffusion : SFXEnvironment
  • environment : SFXAmbience
  • envMap : Material
  • envSize : SFXEnvironment
  • envTex : Material
  • erase() : ArrayObject
  • escapeCommand : GuiTextEditCtrl , GuiMLTextEditCtrl
  • excludedStates : SFXState
  • Execute() : FileDialog
  • exitingWater : PlayerData , RigidShapeData , VehicleData
  • exitSplashSoundVelocity : PlayerData , VehicleData , RigidShapeData
  • expand() : GuiRolloutCtrl
  • expanded : GuiRolloutCtrl
  • expandItem() : GuiTreeViewCtrl
  • explodeOnMaxBounce : DebrisData
  • Explosion : PhysicsShapeData , SplashData , ShapeBaseData , ProjectileData , DebrisData
  • explosionScale : ExplosionData
  • explosionShape : ExplosionData
  • export() : BanList
  • exportHeightMap() : TerrainBlock
  • exportLayerMaps() : TerrainBlock
  • exportToCollada() : InteriorInstance
  • exposure : ScatterSky , CloudLayer
  • extent : GuiControl
  • extractFile() : ZipObject
  • eyeOffset : ShapeBaseImageData
  • eyeRotation : ShapeBaseImageData


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- f -

  • faceViewer : ExplosionData
  • fade : DebrisData
  • fadeColor : GuiFadeinBitmapCtrl , Lightning
  • fadeDelay : ProjectileData
  • fadeDist : Precipitation
  • fadeDistEnd : Precipitation
  • fadeEndPixelSize : DecalData
  • fadeInEase : SFXDescription , GuiFadeinBitmapCtrl
  • FadeInRegion : fxFoliageReplicator
  • fadeInTime : SFXDescription , SFXEmitter , GuiFadeinBitmapCtrl
  • fadeLoops : SFXDescription
  • fadeOutEase : SFXDescription , GuiFadeinBitmapCtrl
  • FadeOutRegion : fxFoliageReplicator
  • fadeOutTime : SFXDescription , SFXEmitter , GuiFadeinBitmapCtrl
  • fadeStartDistance : LightBase , LightDescription , ScatterSky , Sun
  • fadeStartPixelSize : DecalData
  • fadeTime : DecalData
  • fadeTimeIn : SFXPlayList
  • fadeTimeInVariance : SFXPlayList
  • fadeTimeOut : SFXPlayList
  • fadeTimeOutVariance : SFXPlayList
  • fallback : CustomMaterial
  • farDist : ReflectorDesc
  • ffLighting : GFXStateBlockData
  • fileFilter : GuiDirectoryFileListCtrl
  • fileMustExist : OpenFolderDialog
  • fileName : FileDialog , SFXFMODProject , Prefab , SFXEmitter , SFXProfile
  • filePath : GuiDirectoryFileListCtrl
  • fillColor : GuiHealthBarHud , GuiShapeNameHud , GuiControlProfile , GuiClockHud
  • fillColorHL : GuiControlProfile
  • fillColorNA : GuiControlProfile
  • fillColorSEL : GuiControlProfile
  • fillRowFirst : GuiDynamicCtrlArrayControl
  • filters : FileDialog
  • findChildItemByName() : GuiTreeViewCtrl
  • findHitControl() : GuiControl
  • findHitControls() : GuiControl
  • findItemByName() : GuiTreeViewCtrl
  • findItemByObjectId() : GuiTreeViewCtrl
  • findItemByValue() : GuiTreeViewCtrl
  • findItemText() : GuiListBoxCtrl
  • findObjectByInternalName() : SimSet
  • findText() : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • findTextIndex() : GuiTextListCtrl
  • firstAttribute() : SimXMLDocument
  • firstPerson : ShapeBaseImageData
  • firstPersonOnly : ShapeBaseData
  • fitBook : GuiTabPageCtrl
  • fitParentWidth : GuiListBoxCtrl , GuiTextListCtrl
  • FixAspectRatio : fxFoliageReplicator
  • fixedPanel : GuiSplitContainer
  • fixedSize : GuiSplitContainer
  • FixSizeToMax : fxFoliageReplicator
  • flags : SFXEnvironment
  • flareEnabled : LightFlareData
  • flareScale : LightBase , LightDescription , ScatterSky , Sun
  • flareTexture : LightFlareData
  • flareType : LightBase , LightDescription , ScatterSky , Sun
  • flightCeiling : MissionArea
  • flightCeilingRange : MissionArea
  • floatingGravMag : HoverVehicleData
  • floatingThrustFactor : HoverVehicleData
  • floatSound : HoverVehicleData
  • FlowMagnitude : River
  • flush : Material
  • fmodGroup : SFXFMODEvent , SFXFMODEventGroup
  • fmodName : SFXFMODEvent , SFXFMODEventGroup
  • fmodParameterRanges : SFXFMODEvent
  • fmodParameterValues : SFXFMODEvent
  • fmodProject : SFXFMODEventGroup
  • foamAmbientLerp : WaterObject
  • foamDir : WaterObject
  • foamMaxDepth : WaterObject
  • foamOpacity : WaterObject
  • foamRippleInfluence : WaterObject
  • foamSpeed : WaterObject
  • foamTex : WaterObject
  • foamTexScale : WaterObject
  • focusOnMouseWheel : GuiTextEditSliderCtrl , GuiTextEditSliderBitmapCtrl
  • fogAtmosphereHeight : LevelInfo
  • fogBandHeight : SkyBox
  • fogColor : LevelInfo
  • fogDensity : LevelInfo
  • fogDensityOffset : LevelInfo
  • fogScale : ScatterSky
  • FoliageCount : fxFoliageReplicator
  • FoliageFile : fxFoliageReplicator
  • FoliageRetries : fxFoliageReplicator
  • followCam : Precipitation
  • fontCharset : GuiControlProfile
  • fontColor : GuiControlProfile
  • fontColorHL : GuiControlProfile
  • fontColorLink : GuiControlProfile
  • fontColorLinkHL : GuiControlProfile
  • fontColorNA : GuiControlProfile
  • fontColors : GuiControlProfile
  • fontColorSEL : GuiControlProfile
  • fontSize : GuiControlProfile
  • fontType : GuiControlProfile
  • FootBubblesSound : PlayerData
  • FootHardSound : PlayerData
  • FootMetalSound : PlayerData
  • footPuffEmitter : PlayerData
  • footPuffNumParts : PlayerData
  • footPuffRadius : PlayerData
  • FootShallowSound : PlayerData
  • FootSnowSound : PlayerData
  • FootSoftSound : PlayerData
  • footstepSoundId : Material
  • footstepSplashHeight : PlayerData
  • FootUnderwaterSound : PlayerData
  • FootWadingSound : PlayerData
  • force : WheeledVehicleSpring , Camera
  • forceClose() : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • forceDetail : fxShapeReplicatedStatic , TSStatic
  • forceFOV : GuiTSCtrl
  • forceImposters : Forest
  • forceOnAction : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • forceReflow() : GuiMLTextCtrl
  • forceUpdateMaterials : TSShapeConstructor
  • forceValidateText() : GuiTextEditCtrl
  • ForestItemData : ForestBrushElement
  • format : GuiTextEditSliderBitmapCtrl , RenderFormatToken , GuiTextEditSliderCtrl
  • forwardJetEmitter : FlyingVehicleData , HoverVehicleData
  • forwardLit : CustomMaterial
  • frame : DecalData
  • frameBorder() : GuiFrameSetCtrl
  • frameColor : GuiClockHud , GuiHealthBarHud , GuiShapeNameHud
  • frameMinExtent() : GuiFrameSetCtrl
  • frameMovable() : GuiFrameSetCtrl
  • framePadding() : GuiFrameSetCtrl
  • framesPerSec : ParticleData
  • freeData() : SFXFMODEventGroup
  • freeReference() : Message
  • freeze() : GuiStackControl
  • freezeSim() : RigidShape
  • fresnelBias : WaterObject
  • fresnelPower : WaterObject
  • friction : DebrisData , ItemData , PhysicsShapeData , PhysicsDebrisData , PxCloth
  • frontSidePassable : Portal
  • frontTabPadding : GuiTabBookCtrl
  • frozen : GuiDynamicCtrlArrayControl
  • fudgeFactor : GuiFrameSetCtrl
  • fullReflect : WaterObject
  • fullRowSelect : GuiTreeViewCtrl


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- g -

  • get() : HTTPObject
  • getAdapterCount() : GFXInit
  • getAdapterMode() : GFXInit
  • getAdapterModeCount() : GFXInit
  • getAdapterName() : GFXInit
  • getAdapterShaderModel() : GFXInit
  • getAdapterType() : GFXInit
  • getAddress : AIConnection , NetConnection
  • getAimLocation : AIClient , AIPlayer
  • getAimObject() : AIPlayer
  • getAIRepairPoint() : ShapeBase
  • getAngularVelocity() : Camera
  • getAnimFlags : Material
  • getArea() : MissionArea
  • getAspect() : GuiControl
  • getAspectRatio() : PostEffect
  • getAttenuatedVolume() : SFXSource
  • getBinding() : ActionMap
  • getBinType() : RenderBinManager
  • getBounds() : TSShapeConstructor
  • getCameraFov() : ShapeBase
  • getCameraObject() : GameConnection
  • getCameraSpeed() : GuiObjectView
  • getCanSave() : SimObject
  • getCard() : GFXCardProfilerAPI
  • getCenter() : GuiControl
  • getChild() : GuiTreeViewCtrl
  • getClassName() : SimObject
  • getClassNamespace() : SimObject
  • getClientObject() : NetObject
  • getColorById : GuiPopUpMenuCtrlEx
  • getColumnCount() : GuiFrameSetCtrl
  • getColumnOffset() : GuiFrameSetCtrl
  • getCommand() : ActionMap
  • getContent() : GuiCanvas
  • getControlCameraDefaultFov() : GameConnection
  • getControlCameraFov() : GameConnection
  • getControllingClient() : ShapeBase
  • getControllingObject() : ShapeBase
  • getControlObject() : GameConnection , Player
  • getCount() : SimSet
  • getCurrent() : ArrayObject
  • getCurrentLanguage() : LangTable
  • getCurrentOption() : GuiGameListOptionsCtrl
  • getCurrentSlot() : SFXController
  • getCurrentTime() : GuiTheoraCtrl
  • getCursorPos() : GuiTextEditCtrl , GuiCanvas
  • getDamageFlash() : ShapeBase , GameConnection
  • getDamageLevel() : ShapeBase
  • getDamageLocation() : Player
  • getDamagePercent() : ShapeBase
  • getDamageState() : ShapeBase
  • getData() : SimXMLDocument
  • getDataBlock() : GameBase
  • getDatum() : GuiGraphCtrl
  • getDeadZone() : ActionMap
  • getDebugInfo() : SimObject
  • getDeclarationLine() : SimObject
  • getDefaultAdapterIndex() : GFXInit
  • getDefaultCameraFov() : ShapeBase
  • getDeployTransform() : ShapeBaseData
  • getDetailLevelCount() : TSShapeConstructor
  • getDetailLevelIndex() : TSShapeConstructor
  • getDetailLevelName() : TSShapeConstructor
  • getDetailLevelSize() : TSShapeConstructor
  • getDuration() : SFXSound
  • getDynamicField() : SimObject
  • getDynamicFieldCount() : SimObject
  • getEnergyLevel() : ShapeBase
  • getEnergyPercent() : ShapeBase
  • getErrorDesc() : SimXMLDocument
  • getEulerRotation() : SceneObject
  • getExtent() : GuiControl , GuiCanvas
  • getEyePoint() : ShapeBase
  • getEyeTransform() : ShapeBase
  • getEyeVector() : ShapeBase
  • getFadeInTime() : SFXSource
  • getFadeOutTime() : SFXSource
  • getField() : SimObject
  • getFieldCount() : SimObject
  • getFieldType() : SimObject
  • getFieldValue() : SimObject
  • getFileEntry() : ZipObject
  • getFileEntryCount() : ZipObject
  • getFilename : Material , SimObject , CubemapData
  • getFilterText() : GuiTreeViewCtrl
  • getFirstResponder() : GuiControl
  • getFirstRootItem : GuiTreeViewCtrl
  • getForwardVector() : SceneObject
  • getFramePadding() : GuiFrameSetCtrl
  • getFreeLook : AIConnection
  • getFullCount() : SimSet
  • getGhostID() : NetObject , NetConnection
  • getGhostsActive() : NetConnection
  • getGlobalCenter() : GuiControl
  • getGlobalPosition() : GuiControl
  • getGroup() : SimObject
  • getId() : SimObject
  • getImageAltTrigger() : ShapeBase
  • getImageAmmo() : ShapeBase
  • getImageLoaded() : ShapeBase
  • getImageSkinTag() : ShapeBase
  • getImageState() : ShapeBase
  • getImageTrigger() : ShapeBase
  • getImposterDetailLevel() : TSShapeConstructor
  • getImposterSettings() : TSShapeConstructor
  • getIndexFromKey() : ArrayObject
  • getIndexFromValue() : ArrayObject
  • getInternalName() : SimObject
  • getItemCount : GuiTreeViewCtrl , GuiListBoxCtrl
  • getItemObject() : GuiListBoxCtrl
  • getItemText() : GuiListBoxCtrl , GuiTreeViewCtrl
  • getItemValue() : GuiTreeViewCtrl
  • getKey() : ArrayObject
  • getLangName() : LangTable
  • getLastClickItem() : GuiListBoxCtrl
  • getLastStickyNormal() : Item
  • getLastStickyPos() : Item
  • getLineIndexByTag() : MessageVector
  • getLineTag() : MessageVector
  • getLineText() : MessageVector
  • getLineTextByTag() : MessageVector
  • getLocation : AIClient
  • getLookAtPoint() : ShapeBase
  • getManager() : RenderPassManager
  • getManagerCount() : RenderPassManager
  • getMeshCount() : TSShapeConstructor
  • getMeshMaterial() : TSShapeConstructor
  • getMeshName() : TSShapeConstructor
  • getMeshSize() : TSShapeConstructor
  • getMeshType() : TSShapeConstructor
  • getMinExtent() : GuiControl
  • getMode() : Camera , GuiCanvas
  • getModeCount() : GuiCanvas
  • getModel() : GuiObjectView
  • getModelFile() : ShapeBase , TSStatic , InteriorInstance
  • getMountedImage() : ShapeBase
  • getMountedModel() : GuiObjectView
  • getMountedObject() : SceneObject
  • getMountedObjectCount() : SceneObject
  • getMountedObjectNode() : SceneObject
  • getMountNodeObject() : SceneObject
  • getMountSkin() : GuiObjectView
  • getMountSlot() : ShapeBase
  • getMouseControl() : GuiCanvas
  • getMove() : AIConnection
  • getMoveDestination : AIClient , AIPlayer
  • getMuzzlePoint() : ShapeBase
  • getMuzzleVector() : ShapeBase
  • getName() : SimObject
  • getNextSibling() : GuiTreeViewCtrl
  • getNodeChildCount() : TSShapeConstructor
  • getNodeChildName() : TSShapeConstructor
  • getNodeCount() : TSShapeConstructor
  • getNodeIndex() : TSShapeConstructor
  • getNodeName() : TSShapeConstructor
  • getNodeObjectCount() : TSShapeConstructor
  • getNodeObjectName() : TSShapeConstructor
  • getNodeParentName() : TSShapeConstructor
  • getNodeTransform() : TSShapeConstructor
  • getNumDetailLevels() : InteriorInstance
  • getNumLang() : LangTable
  • getNumLines() : MessageVector
  • getNumObjects() : Trigger
  • getObject() : SimSet , Trigger
  • getObjectBox() : SceneObject
  • getObjectCount() : TSShapeConstructor
  • getObjectIndex() : SimSet , TSShapeConstructor
  • getObjectMount() : SceneObject
  • getObjectName() : TSShapeConstructor
  • getObjectNode() : TSShapeConstructor
  • getOffset() : Camera
  • getOrbitDistance() : GuiObjectView
  • getPacketLoss() : NetConnection
  • getParameter() : SFXSource
  • getParameterCount() : SFXSource
  • getParameterName() : SFXParameter
  • getParent() : GuiControl , GuiTreeViewCtrl
  • getPathId() : Path
  • getPendingImage() : ShapeBase
  • getPing() : NetConnection
  • getPitch() : SFXSource
  • getPosition() : Camera , SceneObject , GuiControl , StreamObject , SFXSound
  • getPrevSibling() : GuiTreeViewCtrl
  • getRandom() : SimSet
  • getRechargeRate() : ShapeBase
  • getRenderer() : GFXCardProfilerAPI
  • getRepairRate() : ShapeBase
  • getRightVector() : SceneObject
  • getRoot() : GuiControl
  • getRotation() : Camera
  • getRowCount() : GuiFrameSetCtrl , GuiGameListMenuCtrl
  • getRowId() : GuiTextListCtrl
  • getRowLabel() : GuiGameListMenuCtrl
  • getRowNumById() : GuiTextListCtrl
  • getRowOffset() : GuiFrameSetCtrl
  • getRowText() : GuiTextListCtrl
  • getRowTextById() : GuiTextListCtrl
  • getScale() : ActionMap , SceneObject
  • getScrollPosition() : GuiScrollCtrl
  • getScrollPositionX() : GuiScrollCtrl
  • getScrollPositionY() : GuiScrollCtrl
  • getSelCount() : GuiListBoxCtrl
  • getSelected() : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • getSelectedFile() : GuiDirectoryFileListCtrl
  • getSelectedFiles() : GuiDirectoryFileListCtrl
  • getSelectedId() : GuiTextListCtrl
  • getSelectedItem() : GuiListBoxCtrl , GuiTreeViewCtrl
  • getSelectedItemList : GuiTreeViewCtrl
  • getSelectedItems() : GuiListBoxCtrl
  • getSelectedItemsCount : GuiTreeViewCtrl
  • getSelectedObject() : GuiTreeViewCtrl
  • getSelectedObjectList : GuiTreeViewCtrl
  • getSelectedPage() : GuiTabBookCtrl
  • getSelectedRow() : GuiTextListCtrl , GuiGameListMenuCtrl
  • getSequenceBlend() : TSShapeConstructor
  • getSequenceCount() : TSShapeConstructor
  • getSequenceCyclic() : TSShapeConstructor
  • getSequenceFrameCount() : TSShapeConstructor
  • getSequenceGroundSpeed() : TSShapeConstructor
  • getSequenceIndex() : TSShapeConstructor
  • getSequenceName() : TSShapeConstructor
  • getSequencePriority() : TSShapeConstructor
  • getSequenceSource() : TSShapeConstructor
  • getServerConnection() : GameConnection
  • getServerObject() : NetObject
  • getShapeName() : ShapeBase
  • getSkin() : GuiObjectView
  • getSkinName() : ShapeBase
  • getSlotTransform() : ShapeBase
  • getSoundDuration() : SFXProfile
  • getSource() : SFXEmitter
  • getState() : Player
  • getStatus() : SFXSource , StreamObject
  • getStreamSize() : StreamObject
  • getString() : LangTable
  • getStringWidth() : GuiControlProfile
  • getSuperClassNamespace() : SimObject
  • getTargetCount() : TSStatic , InteriorInstance , TSShapeConstructor , ShapeBase
  • getTargetName() : ShapeBase , TSStatic , TSShapeConstructor , InteriorInstance
  • getTargetObject : AIClient
  • getText : GuiPopUpMenuCtrl , GuiButtonBaseCtrl , GuiTextEditCtrl , SimXMLDocument , GuiPopUpMenuCtrlEx , GuiMLTextCtrl
  • getTextById() : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • getTextToRoot() : GuiTreeViewCtrl
  • getTime() : GuiClockHud
  • getTransform() : SceneObject
  • getTrigger() : TSShapeConstructor , AIConnection
  • getTriggerCount() : TSShapeConstructor
  • getType() : Message , SceneObject
  • getUpVector() : SceneObject
  • getValue() : ArrayObject , GuiControl , GuiSliderCtrl
  • getVelocity() : ShapeBase , Camera
  • getVendor() : GFXCardProfilerAPI
  • getVersion() : GFXCardProfilerAPI
  • getVideoMemoryMB() : GFXCardProfilerAPI
  • getVideoMode() : GuiCanvas
  • getVolume() : SFXSource
  • getWheelCount() : WheeledVehicle
  • getWhiteOut() : ShapeBase , GameConnection
  • getWindowPosition() : GuiCanvas
  • getWorldBox() : SceneObject
  • getWorldBoxCenter() : SceneObject
  • getWorldToScreenScale() : GuiTSCtrl
  • getZoneId() : Zone
  • glow : Material
  • glowIntensity : Precipitation
  • gravityCoefficient : ParticleData
  • gravityMod : ProjectileData , ItemData , PhysicalZone
  • gravModifier : DebrisData
  • gridElementSize : WaterPlane , WaterBlock
  • gridSize : GroundCover , WaterBlock , WaterPlane
  • GroundAlpha : fxFoliageReplicator
  • groundImpactMinSpeed : PlayerData
  • groundImpactShakeAmp : PlayerData
  • groundImpactShakeDuration : PlayerData
  • groundImpactShakeFalloff : PlayerData
  • groundImpactShakeFreq : PlayerData
  • groupNum : GuiButtonBaseCtrl
  • gustFrequency : ForestWindEmitter
  • gustStrength : ForestWindEmitter
  • gustWobbleStrength : ForestWindEmitter
  • gustYawAngle : ForestWindEmitter
  • gustYawFrequency : ForestWindEmitter
  • gyroDrag : HoverVehicleData


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- h -

  • handleRenameObject() : GuiTreeViewCtrl
  • hardImpactSound : RigidShapeData , VehicleData
  • hardImpactSpeed : RigidShapeData , VehicleData
  • hardSplashSoundVelocity : PlayerData , RigidShapeData , VehicleData
  • hasBitmapArray : GuiControlProfile
  • hasMount : ForestWindEmitter
  • height : SplashData , BasicClouds , CloudLayer
  • HFReference : SFXEnvironment
  • hidden : SimObject
  • hide() : PfxVis
  • hideCursor() : GuiCanvas
  • HideFoliage : fxFoliageReplicator
  • hideHeader : GuiRolloutCtrl
  • HideReplications : fxShapeReplicator
  • hideSelection() : GuiTreeViewCtrl
  • highResOnly : ParticleEmitterData
  • historySize : GuiTextEditCtrl
  • hitAreaLowerRight : GuiGameListMenuProfile
  • hitAreaUpperLeft : GuiGameListMenuProfile
  • hitPlayers : Precipitation
  • hitVehicles : Precipitation
  • horizMaxSpeed : PlayerData
  • horizontalSurfaceForce : FlyingVehicleData
  • horizResistFactor : PlayerData
  • horizResistSpeed : PlayerData
  • horizSizing : GuiControl
  • horizStacking : GuiStackControl
  • hotSpot : GuiCursor
  • hotTrackCallback : GuiPopUpMenuCtrlEx
  • hoverHeight : FlyingVehicleData
  • hovertime : GuiControl
  • hScrollBar : GuiScrollCtrl


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- i -

  • iconBitmap : GuiIconButtonCtrl
  • iconLocation : GuiIconButtonCtrl
  • iconOffset : GuiGameListMenuProfile
  • ignoreNodeScale : TSShapeConstructor
  • ignoreWater : DebrisData
  • impactForce : ProjectileData
  • impactHardSound : PlayerData
  • impactMetalSound : PlayerData
  • impactSnowSound : PlayerData
  • impactSoftSound : PlayerData
  • impactSoundId : Material
  • impactWaterEasy : RigidShapeData , VehicleData , PlayerData
  • impactWaterHard : VehicleData , PlayerData , RigidShapeData
  • impactWaterMedium : RigidShapeData , VehicleData , PlayerData
  • import() : TerrainBlock
  • includedStates : SFXState
  • includeLightmappedGeometryInShadow : LightBase , LightDescription , ScatterSky , Sun
  • increment : GuiTextEditSliderBitmapCtrl , GuiTextEditSliderCtrl
  • indoorWeight : SpawnSphere
  • inheritedVelFactor : ParticleData
  • inheritEnergyFromMount : ShapeBaseData
  • init() : Debris
  • initialControlSet() : GameConnection
  • initialPosition : Projectile
  • initialVelocity : Projectile
  • innerAngle : SpotLight
  • InnerRadiusX : fxFoliageReplicator , fxShapeReplicator
  • InnerRadiusY : fxFoliageReplicator , fxShapeReplicator
  • insert() : ArrayObject
  • insertItem() : GuiListBoxCtrl , GuiTreeViewCtrl
  • insertLine() : MessageVector
  • instantCollapse() : GuiRolloutCtrl
  • instantExpand() : GuiRolloutCtrl
  • integration : RigidShapeData , VehicleData
  • Interactions : fxShapeReplicator
  • interiorFile : InteriorInstance
  • internalName : SimObject
  • invertLayer : GroundCover
  • invisible : GuiSeparatorCtrl
  • is3D : SFXDescription , SFXEmitter
  • isActive : GuiControl , SFXState
  • isAIControlled() : GameConnection
  • isAllTextSelected() : GuiTextEditCtrl
  • isAttached() : PhysicsForce
  • isAutoGenerated : Material
  • isAwake() : GuiControl
  • isBallistic : ProjectileData
  • isBanned() : BanList
  • isChildOfGroup() : SimObject
  • isClientObject() : NetObject
  • isCloaked() : ShapeBase
  • isContainer : GuiControl
  • isControlObjectRotDampedCamera() : GameConnection
  • isCursorOn() : GuiCanvas
  • isCursorShown() : GuiCanvas
  • isDataLoaded() : SFXFMODEventGroup
  • isDemoPlaying() : GameConnection
  • isDemoRecording() : GameConnection
  • isDestroyed() : ShapeBase , PhysicsShape
  • isDirty() : Forest
  • isDisabled() : ShapeBase , SFXState
  • isEditOrbitMode() : Camera
  • isEditorOnly() : SimObject
  • isEnabled : LightBase , PostEffect , ShapeBase , PostEffect
  • isEOF() : FileObject , StreamObject
  • isEOS() : StreamObject
  • isExpanded() : SimObject , GuiRolloutCtrl
  • isExteriorPortal() : Portal
  • isFirstPerson() : GameConnection
  • isFirstResponder() : GuiControl
  • isFrozen() : GuiStackControl
  • isFullscreen() : GuiCanvas
  • isGlobalBounds() : SceneObject
  • isHidden() : ShapeBase
  • isImageFiring() : ShapeBase
  • isImageMounted() : ShapeBase
  • isInNamespaceHierarchy() : SimObject
  • isInteriorPortal() : Portal
  • isInverted() : ActionMap
  • isInvincible : ShapeBaseData
  • isItemSelected() : GuiTreeViewCtrl
  • isLooping : SFXDescription , SFXEmitter , GuiAutoScrollCtrl , Path
  • isMaximized() : GuiCanvas
  • isMember() : SimSet
  • isMemberOfClass() : SimObject
  • isMethod() : SimObject
  • isMinimized() : GuiCanvas
  • isMounted() : SceneObject
  • isMouseLocked() : GuiControl
  • isNameChangeAllowed() : SimObject
  • isObjectMirrored() : GuiListBoxCtrl
  • isParentItem() : GuiTreeViewCtrl
  • isPaused() : SFXSource
  • isPlaybackDone() : GuiTheoraCtrl
  • isPlaying() : SFXSource
  • isReady() : SFXSound
  • isRegisteredEvent() : EventManager
  • isRenderable : MissionMarker , Marker , WayPoint , OcclusionVolume , LightBase , CloudLayer , PointLight , StaticShape , SpotLight , DecalManager , RenderObjectExample , RenderShapeExample , Explosion , fxFoliageReplicator , fxShapeReplicator , fxShapeReplicatedStatic , GroundCover , ParticleEmitter , Splash , PhysicsDebris , PxCloth , SFXSpace , Vehicle , HoverVehicle , BasicClouds , WaterObject , WaterBlock , WaterPlane , Player , ShapeBase , AIPlayer , Camera , GroundPlane , Item , SpawnSphere , PathCamera , PhysicalZone , Zone , Portal , Projectile , RigidShape , Trigger , RenderMeshExample , Lightning , ParticleEmitterNode , Sun , PhysicsForce , PhysicsShape , PxMultiActor , FlyingVehicle , WheeledVehicle , DecalRoad , InteriorInstance , River , ScatterSky , SkyBox , Forest , TimeOfDay , ForestWindEmitter , SFXEmitter , TerrainBlock , MeshRoad , TSStatic , Precipitation , Prefab , Debris , SceneObject , ConvexShape , GameBase
  • isRenderEnabled : SceneObject
  • isRotating() : Item
  • isRotationDamped() : Camera
  • isRowActive() : GuiTextListCtrl
  • isRowEnabled() : GuiGameListMenuCtrl
  • isSelectable : River , PxCloth , SFXSpace , RenderShapeExample , ForestWindEmitter , Projectile , OcclusionVolume , fxFoliageReplicator , RenderObjectExample , PathCamera , DecalRoad , fxShapeReplicator , MeshRoad , ParticleEmitterNode , fxShapeReplicatedStatic , MissionMarker , InteriorInstance , TSStatic , StaticShape , PhysicalZone , WayPoint , PhysicsShape , Portal , ShapeBase , Sun , ConvexShape , BasicClouds , ParticleEmitter , Explosion , WheeledVehicle , SpotLight , AIPlayer , ScatterSky , RenderMeshExample , Trigger , Precipitation , Player , WaterPlane , Item , TerrainBlock , GroundPlane , PxMultiActor , Zone , TimeOfDay , DecalManager , RigidShape , Lightning , Debris , WaterObject , SFXEmitter , Vehicle , Marker , PhysicsDebris , SpawnSphere , HoverVehicle , Prefab , WaterBlock , LightBase , Splash , GameBase , GroundCover , Camera , Forest , CloudLayer , SkyBox , FlyingVehicle , PhysicsForce , PointLight , SceneObject
  • isSelected() : SimObject
  • isSelectionEnabled : SceneObject
  • isServerObject() : NetObject
  • isStateOn() : GuiCheckBoxCtrl
  • isStatic() : Item
  • isStopped() : SFXSource
  • isStreaming : SFXDescription , SFXEmitter
  • isThumbBeingDragged() : GuiSliderCtrl
  • isValidDragTarget() : GuiTreeViewCtrl
  • isVisible() : GuiControl
  • itemHeight : GuiTreeViewCtrl


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- p -

  • padding : GuiContainer , GuiDynamicCtrlArrayControl , GuiMenuBar , GuiStackControl
  • parallaxScale : Material , TerrainMaterial
  • parameters : SFXTrack , SFXDescription
  • parentGroup : SimObject
  • parse() : SimXMLDocument
  • particleDensity : ExplosionData
  • ParticleEmitter : ExplosionData , ProjectileData
  • particleRadius : ExplosionData
  • particles : ParticleEmitterData
  • particleWaterEmitter : ProjectileData
  • password : GuiTextEditCtrl
  • passwordMask : GuiTextEditCtrl
  • pause() : SFXSource , GuiTheoraCtrl
  • pauseAnimation : LightBase
  • pauseThread() : ShapeBase
  • peekLine() : FileObject
  • performClick() : GuiButtonBaseCtrl
  • periodVarianceMS : ParticleEmitterData
  • persistentId : SimObject
  • phiReferenceVel : ParticleEmitterData
  • phiVariance : ParticleEmitterData
  • physicsPlayerType : PlayerData
  • physXStream : PxMultiActorData
  • pickupRadius : PlayerData
  • pitch : SFXDescription , SFXEmitter
  • pitchForce : HoverVehicleData
  • pitchScale : SFXPlayList
  • pitchScaleVariance : SFXPlayList
  • pixelSpecular : Material
  • pixVersion : ShaderData
  • PlacementAreaHeight : fxFoliageReplicator , fxShapeReplicator
  • PlacementColour : fxFoliageReplicator , fxShapeReplicator
  • planarReflection : Material
  • plane : OcclusionVolume , SFXSpace , Zone
  • play : TimeOfDay , SFXEmitter , GuiTheoraCtrl
  • play2D() : GameConnection
  • play3D() : GameConnection
  • playAmbient : fxShapeReplicatedStatic , TSStatic , PhysicsShape
  • playAnimation() : LightBase
  • playAudio() : ShapeBase
  • playDemo() : GameConnection
  • playOnAdd : SFXEmitter
  • playOnWake : GuiTheoraCtrl
  • playSpeed : ExplosionData
  • playThread() : ShapeBase
  • plotColor : GuiGraphCtrl
  • plotInterval : GuiGraphCtrl
  • plotType : GuiGraphCtrl
  • plotVariable : GuiGraphCtrl
  • point : OcclusionVolume , SFXSpace , Zone
  • pointInControl() : GuiControl
  • polyhedron : Trigger , PhysicalZone
  • pop() : ActionMap
  • pop_back() : ArrayObject
  • pop_front() : ArrayObject
  • popBackLine() : MessageVector
  • popDialog() : GuiCanvas
  • popElement() : SimXMLDocument
  • popFront() : PathCamera
  • popFrontLine() : MessageVector
  • popLayer() : GuiCanvas
  • position : SceneObject , GuiControl
  • post() : HTTPObject
  • postApply() : RenderMeshExample , SkyBox , DecalData , MissionArea , GroundPlane , DecalRoad , MeshRoad
  • postEvent() : EventManager
  • preload : PhysicsDebrisData , SFXProfile
  • preProcess() : PostEffect
  • presimulate() : Projectile
  • prevAttribute() : SimXMLDocument
  • priority : SFXDescription , LightBase , ReflectorDesc
  • probability : GroundCover , ForestBrushElement
  • processAddOrder : RenderBinManager
  • profile : GuiControl
  • profileForChildren : GuiControlProfile
  • project() : GuiTSCtrl
  • Projectile : ShapeBaseImageData
  • projectileShapeName : ProjectileData
  • proneBoundingBox : PlayerData
  • proneForce : PlayerData
  • pulseRate : GuiHealthBarHud
  • pulseThreshold : GuiHealthBarHud
  • push() : ActionMap
  • push_back() : ArrayObject
  • push_front() : ArrayObject
  • pushBack() : PathCamera
  • pushBackLine() : MessageVector
  • pushChildElement() : SimXMLDocument
  • pushDialog() : GuiCanvas
  • pushFirstChildElement() : SimXMLDocument
  • pushFront() : PathCamera
  • pushFrontLine() : MessageVector
  • pushNewElement() : SimXMLDocument
  • pushToBack() : SimSet


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- q -

  • queryProfile() : GFXCardProfilerAPI
  • queue : EventManager


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- r -

  • radialEmitter : ForestWindEmitter
  • radius : PointLight , WheeledVehicleTire , ForestItemData , GroundCover , SpawnSphere , ForestWindEmitter
  • random : SFXPlayList
  • RandomFlip : fxFoliageReplicator
  • randomize : DecalData
  • range : SFXParameter , SpotLight , GuiTextEditSliderBitmapCtrl , GuiTextEditSliderCtrl , LightDescription , GuiSliderCtrl
  • rayleighScattering : ScatterSky
  • readComment() : SimXMLDocument
  • readLine() : FileObject , StreamObject
  • readLongString() : StreamObject
  • readString() : StreamObject
  • readSTString() : StreamObject
  • recoverDelay : PlayerData
  • recoverRunForceScale : PlayerData
  • referenceDistance : SFXDescription , SFXPlayList , SFXEmitter
  • referenceDistanceVariance : SFXPlayList
  • reflect : Precipitation
  • reflectDetailAdjust : WaterObject
  • reflections : SFXEnvironment
  • reflectionsDelay : SFXEnvironment
  • reflectionsPan : SFXEnvironment
  • reflectivity : WaterObject
  • reflectMaxRateMs : WaterObject
  • reflectNormalUp : WaterObject
  • reflectPriority : GuiTSCtrl , WaterObject
  • reflectScale : GroundCover
  • reflectTexSize : WaterObject
  • refresh() : GuiDynamicCtrlArrayControl
  • regenCells() : Forest
  • regenerate() : DecalRoad , MeshRoad , River
  • registerEvent() : EventManager
  • reload : Material , PxMultiActorData , ParticleData , ParticleEmitterData , GuiDirectoryFileListCtrl , ShaderData , PostEffect
  • reloadOnLocalClient() : SimDataBlock
  • remove() : SimSet , EventManager
  • removeAll() : EventManager
  • removeAllChildren : GuiTreeViewCtrl
  • removeAutoPlot() : GuiGraphCtrl
  • removeBan() : BanList
  • removeChildSelectionByValue : GuiTreeViewCtrl
  • removeColumn() : GuiFrameSetCtrl
  • removeDetailLevel() : TSShapeConstructor
  • removeFilteredItem() : GuiListBoxCtrl
  • removeImposter() : TSShapeConstructor
  • removeItem() : GuiTreeViewCtrl
  • removeManager() : RenderPassManager
  • removeMenu() : GuiMenuBar
  • removeMenuItem() : GuiMenuBar
  • removeMesh() : TSShapeConstructor
  • removeNode() : TSShapeConstructor
  • removeObject() : TSShapeConstructor
  • removeParameter() : SFXSource
  • removeRow() : GuiFrameSetCtrl , GuiTextListCtrl
  • removeRowById() : GuiTextListCtrl
  • removeSelection() : GuiTreeViewCtrl
  • removeSequence() : TSShapeConstructor
  • removeShaderMacro() : PostEffect
  • removeText() : SimXMLDocument
  • removeTrigger() : TSShapeConstructor
  • renameDetailLevel() : TSShapeConstructor
  • renameInternal : GuiTreeViewCtrl
  • renameNode() : TSShapeConstructor
  • renameObject() : TSShapeConstructor
  • renameSequence() : TSShapeConstructor
  • renderBin : PostEffect
  • renderCells : GroundCover
  • renderCollision : Player
  • renderColorInnerCone : SFXEmitter
  • renderColorOuterCone : SFXEmitter
  • renderColorOutsideVolume : SFXEmitter
  • renderColorPlayingInRange : SFXEmitter
  • renderColorPlayingOutOfRange : SFXEmitter
  • renderColorRangeSphere : SFXEmitter
  • renderColorStoppedInRange : SFXEmitter
  • renderColorStoppedOutOfRange : SFXEmitter
  • renderDebugInfo : GuiTheoraCtrl
  • renderedBatches : GroundCover
  • renderedBillboards : GroundCover
  • renderedCells : GroundCover
  • renderedShapes : GroundCover
  • renderEmitters : SFXEmitter
  • renderFirstPerson : PlayerData
  • renderFront() : GuiCanvas
  • renderMyItems : Player
  • renderMyPlayer : Player
  • renderNormals : fxShapeReplicatedStatic , TSStatic
  • renderOffset : GuiCursor
  • renderOrder : RenderBinManager
  • renderPointDistance : SFXEmitter
  • renderPriority : DecalData , DecalRoad , PostEffect
  • renderRadialIncrements : SFXEmitter
  • renderReflection : ParticleEmitterData
  • renderReflectPass : LightFlareData
  • renderSweepIncrements : SFXEmitter
  • renderTime : PostEffect
  • renderTriggers : Trigger
  • renderWhenDestroyed : ShapeBaseData
  • renderWireframe : RenderTerrainMgr
  • renderZones : PhysicalZone
  • reorderChild() : SimSet
  • repaint() : GuiCanvas
  • repairRate : ShapeBaseData
  • repeatCount : SFXPlayList
  • replaceText : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • replay : SFXPlayList
  • representedInLightmap : LightBase , LightDescription , Sun , ScatterSky
  • reset() : PathCamera , RigidShape , GuiAutoScrollCtrl , GuiCanvas , SFXParameter , SimXMLDocument
  • resetDelay : GuiAutoScrollCtrl
  • resetGhosting() : GameConnection
  • resetState() : GuiButtonBaseCtrl
  • resize() : GuiControl
  • resizeHeight : GuiWindowCtrl
  • resizeWidth : GuiWindowCtrl
  • resolveEffect : RenderFormatToken
  • resolveGhostID() : NetConnection
  • resolveObjectFromGhostIndex() : NetConnection
  • restitution : PhysicsShapeData , PxMaterial , WheeledVehicleTire , PhysicsDebrisData
  • restorativeForce : HoverVehicleData
  • restore() : PhysicsShape
  • restoreWindow() : GuiCanvas
  • resultArg : GFXSamplerStateData
  • returnTab : GuiControlProfile
  • reverb : SFXEnvironment
  • REVERB_CORE0 : SFXEnvironment
  • REVERB_CORE1 : SFXEnvironment
  • REVERB_DECAYHFLIMIT : SFXEnvironment
  • REVERB_DECAYTIMESCALE : SFXEnvironment
  • REVERB_DIRECTHFAUTO : SFXDescription
  • REVERB_ECHOTIMESCALE : SFXEnvironment
  • REVERB_HIGHQUALITYDPL2REVERB : SFXEnvironment
  • REVERB_HIGHQUALITYREVERB : SFXEnvironment
  • REVERB_INSTANCE0 : SFXDescription
  • REVERB_INSTANCE1 : SFXDescription
  • REVERB_INSTANCE2 : SFXDescription
  • REVERB_INSTANCE3 : SFXDescription
  • REVERB_MODULATIONTIMESCALE : SFXEnvironment
  • REVERB_REFLECTIONSDELAYSCALE : SFXEnvironment
  • REVERB_REFLECTIONSSCALE : SFXEnvironment
  • REVERB_REVERBDELAYSCALE : SFXEnvironment
  • REVERB_REVERBSCALE : SFXEnvironment
  • REVERB_ROOMAUTO : SFXDescription
  • REVERB_ROOMHFAUTO : SFXDescription
  • reverbAirAbsorptionFactor : SFXDescription
  • reverbDelay : SFXEnvironment
  • reverbDirect : SFXDescription
  • reverbDirectHF : SFXDescription
  • reverbDopplerFactor : SFXDescription
  • reverbExclusion : SFXDescription
  • reverbExclusionLFRatio : SFXDescription
  • reverbFlags : SFXDescription
  • reverbObstruction : SFXDescription
  • reverbObstructionLFRatio : SFXDescription
  • reverbOcclusion : SFXDescription
  • reverbOcclusionDirectRatio : SFXDescription
  • reverbOcclusionLFRatio : SFXDescription
  • reverbOcclusionRoomRatio : SFXDescription
  • reverbOutsideVolumeHF : SFXDescription
  • reverbPan : SFXEnvironment
  • reverbReverbRolloffFactor : SFXDescription
  • reverbRoom : SFXDescription
  • reverbRoomHF : SFXDescription
  • reverbRoomRolloffFactor : SFXDescription
  • reverseOrder : ParticleEmitterData
  • reverseTextList : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • reverseThrustForce : HoverVehicleData
  • rightPad : GuiGameListOptionsProfile
  • rigidity : ForestItemData
  • ringLifetime : SplashData
  • rippleDir : WaterObject
  • rippleMagnitude : WaterObject
  • rippleSpeed : WaterObject
  • rippleTex : WaterObject
  • rippleTexScale : WaterObject
  • rollForce : HoverVehicleData , FlyingVehicleData
  • rolloffFactor : SFXDescription , SFXAmbience
  • room : SFXEnvironment
  • roomHF : SFXEnvironment
  • roomLF : SFXEnvironment
  • roomRolloffFactor : SFXEnvironment
  • rotA : LightAnimData
  • rotate : Item
  • rotateWithCamVel : Precipitation
  • rotation : ShapeBaseImageData , SceneObject
  • rotationalDrag : FlyingVehicleData
  • rotationRange : ForestBrushElement
  • rotKeys : LightAnimData
  • rotPeriod : LightAnimData
  • rotPivotOffset : Material
  • rotSmooth : LightAnimData
  • rotSpeed : Material
  • rotZ : LightAnimData
  • rowCount() : GuiTextListCtrl , GuiDynamicCtrlArrayControl
  • rows : GuiFrameSetCtrl
  • rowSize : GuiDynamicCtrlArrayControl , GuiControlArrayControl , GuiGameListMenuProfile
  • rowSpacing : GuiDynamicCtrlArrayControl , GuiControlArrayControl
  • runEnergyDrain : PlayerData
  • runForce : PlayerData
  • runSurfaceAngle : PlayerData


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- s -

  • samplersDefined : GFXStateBlockData
  • samplerStates : GFXStateBlockData
  • samples : PxCloth
  • save() : SimObject , ActionMap , TerrainBlock
  • saveDataFile : Forest
  • saveFile() : SimXMLDocument
  • saveShape() : TSShapeConstructor
  • sbUsesNAColor : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • scale : SceneObject , SplashData , ProjectileData
  • scaleExponent : ForestBrushElement
  • scaleMax : ForestBrushElement
  • scaleMin : ForestBrushElement
  • scaleU : GroundPlane
  • scaleV : GroundPlane
  • scatterDistance : SFXDescription , SFXEmitter
  • schedule() : SimObject
  • scopeToClient() : NetObject
  • screenError : TerrainBlock
  • screenToClient() : GuiCanvas
  • scrollDir : Material
  • scrollDirection : GuiAutoScrollCtrl
  • scrollOutOfSight : GuiAutoScrollCtrl
  • scrollSpeed : Material , GuiAutoScrollCtrl
  • scrollToBottom() : GuiScrollCtrl , GuiMLTextCtrl
  • scrollToObject() : GuiScrollCtrl
  • scrollToTag() : GuiMLTextCtrl
  • scrollToTop() : GuiMLTextCtrl , GuiScrollCtrl
  • scrollVisible() : GuiTreeViewCtrl , GuiTextListCtrl
  • scrollVisibleByObjectId() : GuiTreeViewCtrl
  • seed : fxFoliageReplicator , fxShapeReplicator , GroundCover
  • SegmentLength : River
  • select() : GuiTabPageCtrl
  • selectAllText() : GuiTextEditCtrl
  • selectedPage : GuiTabBookCtrl
  • selectItem() : GuiTreeViewCtrl
  • selectOption() : GuiGameListOptionsCtrl
  • selectPage() : GuiTabBookCtrl
  • selectWindow() : GuiWindowCtrl
  • selfCollision : PxCloth
  • send() : RadialImpulseEvent , TCPObject
  • separateAlphaBlendDefined : GFXStateBlockData
  • separateAlphaBlendDest : GFXStateBlockData
  • separateAlphaBlendEnable : GFXStateBlockData
  • separateAlphaBlendOp : GFXStateBlockData
  • separateAlphaBlendSrc : GFXStateBlockData
  • seqNum : Marker
  • sequence : TSShapeConstructor
  • sequenceFramePerSec : Material
  • sequenceSegmentSize : Material
  • setActionThread() : Player
  • setActive() : GuiControl , ParticleEmitterNode
  • setAimLocation : AIClient , AIPlayer
  • setAimObject() : AIPlayer
  • setAlarmMode() : InteriorInstance
  • setAllHidden() : PxMultiActor
  • setAllMeshesHidden() : ShapeBase
  • setAlpha() : GuiMLTextCtrl
  • setAngularDrag() : Camera
  • setAngularForce() : Camera
  • setAngularVelocity() : Camera
  • setArea() : MissionArea
  • setArmThread() : Player
  • setAttribute() : SimXMLDocument
  • setAutoGenerated : Material
  • setBatchSize() : River
  • setBitmap() : GuiBitmapCtrl , GuiBitmapButtonCtrl , GuiIconButtonCtrl , GuiChunkedBitmapCtrl , GuiProgressBitmapCtrl
  • setBlackOut() : GameConnection
  • setBounds() : TSShapeConstructor
  • setBrakeMultiplier() : Camera
  • setBroken() : PxMultiActor
  • setCameraFov() : ShapeBase
  • setCameraObject() : GameConnection
  • setCameraSpeed() : GuiObjectView
  • setCanSave() : SimObject
  • setCapability() : GFXCardProfilerAPI
  • setCenter() : GuiControl
  • setCheckmarkBitmapIndex() : GuiMenuBar
  • setClassNamespace() : SimObject
  • setCloaked() : ShapeBase
  • setCollapsed() : GuiPaneControl
  • setCollapseGroup() : GuiWindowCtrl
  • setCollisionTimeout() : Item
  • setColor() : GuiSwatchButtonCtrl
  • setColumnOffset() : GuiFrameSetCtrl
  • setCone() : SFXSource
  • setConnectArgs() : GameConnection
  • setContent() : GuiCanvas
  • setControl() : GameBase
  • setControlCameraFov() : GameConnection
  • setControlObject() : GameConnection , Player
  • setCurrent() : ArrayObject
  • setCurrentLanguage() : LangTable
  • setCurrentSlot() : SFXController
  • setCurSel() : GuiListBoxCtrl
  • setCurSelRange() : GuiListBoxCtrl
  • setCursor() : GuiCanvas
  • setCursorPos() : GuiTextEditCtrl , GuiCanvas
  • setCursorPosition() : GuiMLTextCtrl
  • setDamageFlash() : ShapeBase
  • setDamageLevel() : ShapeBase
  • setDamageState() : ShapeBase
  • setDamageVector() : ShapeBase
  • setDataBlock() : GameBase
  • setDayLength() : TimeOfDay
  • setDebug() : GuiTreeViewCtrl
  • setDefaultLanguage() : LangTable
  • setDetailLevel() : InteriorInstance
  • setDetailLevelSize() : TSShapeConstructor
  • setDrag() : Camera
  • setEditOrbitMode() : Camera
  • setEditOrbitPoint() : Camera
  • setEditorOnly() : SimObject
  • setEmitterDataBlock() : ParticleEmitterNode
  • setEnergyLevel() : ShapeBase
  • setEnumContent : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • setExtent() : GuiControl
  • setFadeTimes() : SFXSource
  • setFieldType() : SimObject
  • setFieldValue() : SimObject
  • setFile() : GuiTheoraCtrl
  • setFilename() : SimObject
  • setFilter() : GuiDirectoryFileListCtrl
  • setFilterText() : GuiTreeViewCtrl
  • setFirstPerson() : GameConnection
  • setFirstResponder : GuiControl
  • setFirstSelected() : GuiPopUpMenuCtrl
  • setFlyForce() : Camera
  • setFlyMode() : Camera
  • setFocus() : GuiCanvas
  • setFreeLook() : AIConnection
  • setGraphType() : GuiGraphCtrl
  • setHidden() : SimObject , ShapeBase
  • setImageAltTrigger() : ShapeBase
  • setImageAmmo() : ShapeBase
  • setImageLoaded() : ShapeBase
  • setImageTrigger() : ShapeBase
  • setInternalName() : SimObject
  • setInvincibleMode() : ShapeBase
  • setIsExpanded() : SimObject
  • setIsSelected() : SimObject
  • setItemColor() : GuiListBoxCtrl
  • setItemImages() : GuiTreeViewCtrl
  • setItemText() : GuiListBoxCtrl
  • setItemTooltip() : GuiListBoxCtrl , GuiTreeViewCtrl
  • setJoinPassword() : GameConnection
  • setKey() : ArrayObject
  • setLagIcon() : GameConnection
  • setLastTTL() : DebugDrawer
  • setLastZTest() : DebugDrawer
  • setLightAmbient() : GuiObjectView
  • setLightColor() : GuiObjectView
  • setLightDirection() : GuiObjectView
  • setLightEnabled() : LightBase
  • setLocked() : SimObject
  • setMass() : Camera
  • setMaxDivisionSize() : River
  • setMenuBitmapIndex() : GuiMenuBar
  • setMenuItemBitmap() : GuiMenuBar
  • setMenuItemChecked() : GuiMenuBar
  • setMenuItemEnable() : GuiMenuBar
  • setMenuItemSubmenuState() : GuiMenuBar
  • setMenuItemText() : GuiMenuBar
  • setMenuItemVisible() : GuiMenuBar
  • setMenuMargins() : GuiMenuBar
  • setMenuText() : GuiMenuBar
  • setMenuVisible() : GuiMenuBar
  • setMeshHidden() : ShapeBase , PxMultiActor
  • setMeshMaterial() : TSShapeConstructor
  • setMeshSize() : TSShapeConstructor
  • setMeshType() : TSShapeConstructor
  • setMessage() : SimpleNetObject
  • setMetersPerSegment() : River
  • setMissionCRC() : GameConnection
  • setModel() : GuiObjectView
  • setMount() : GuiObjectView
  • setMountedModel() : GuiObjectView
  • setMountSkin() : GuiObjectView
  • setMove() : AIConnection
  • setMoveDestination : AIClient , AIPlayer
  • setMoveSpeed : AIClient , AIPlayer
  • setMultipleSelection() : GuiListBoxCtrl
  • setName() : SimObject
  • setNameChangeAllowed() : SimObject
  • setNewtonFlyMode() : Camera
  • setNodeDepth() : MeshRoad , River
  • setNodeParent() : TSShapeConstructor
  • setNodeTransform() : TSShapeConstructor
  • setNoneSelected : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • setObjectAttributes() : SimXMLDocument
  • setObjectNode() : TSShapeConstructor
  • setOffset() : Camera
  • setOptions() : GuiGameListOptionsCtrl
  • setOrbitDistance() : GuiObjectView
  • setOrbitMode() : Camera
  • setOrbitObject() : Camera
  • setOrbitPoint() : Camera
  • setPath() : GuiDirectoryFileListCtrl
  • setPercentage() : Precipitation
  • setPitch() : SFXSource
  • setPlay() : TimeOfDay
  • setPosition() : GuiControl , PathCamera , StreamObject , SFXSound
  • setPositionGlobal() : GuiControl
  • setProcessTicks() : GuiTickCtrl
  • setProfile() : GuiControl
  • setRechargeRate() : ShapeBase
  • setRepairRate() : ShapeBase
  • setRotation() : Camera
  • setRowActive() : GuiTextListCtrl
  • setRowById() : GuiTextListCtrl
  • setRowEnabled() : GuiGameListMenuCtrl
  • setRowLabel() : GuiGameListMenuCtrl
  • setRowOffset() : GuiFrameSetCtrl
  • setScale() : SceneObject
  • setScopeAlways() : NetObject
  • setScrollPosition() : GuiScrollCtrl
  • setSelected() : GuiPopUpMenuCtrlEx , GuiListBoxCtrl , GuiGameListMenuCtrl , GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • setSelectedById() : GuiTextListCtrl
  • setSelectedRow() : GuiTextListCtrl
  • setSeq() : GuiObjectView
  • setSequenceBlend() : TSShapeConstructor
  • setSequenceCyclic() : TSShapeConstructor
  • setSequenceGroundSpeed() : TSShapeConstructor
  • setSequencePriority() : TSShapeConstructor
  • setShaderConst() : PostEffect
  • setShaderConsts() : PostEffect
  • setShaderMacro() : PostEffect
  • setShapeName() : ShapeBase
  • setSimulatedNetParams() : NetConnection
  • setSkin() : GuiObjectView
  • setSkinName() : ShapeBase
  • setSpeedMultiplier() : Camera
  • setState() : PathCamera
  • setStateOn() : GuiButtonBaseCtrl , GuiCheckBoxCtrl
  • setSubmenuItemChecked() : GuiMenuBar
  • setSuperClassNamespace() : SimObject
  • setTarget() : PathCamera
  • setTargetObject : AIClient
  • setText() : GuiButtonBaseCtrl , GuiTextCtrl , GuiTextEditCtrl , GuiMLTextCtrl , GuiPopUpMenuCtrlEx
  • setTextID() : GuiButtonBaseCtrl , GuiTextCtrl
  • setThreadDir() : ShapeBase
  • setThreadTimeScale() : ShapeBase
  • setTime() : GuiClockHud
  • setTimeOfDay() : TimeOfDay
  • setTrackObject() : Camera
  • setTransform() : SceneObject , SFXSource
  • setTrigger() : AIConnection
  • setTurbulence() : Precipitation
  • setValidEditOrbitPoint() : Camera
  • setValue() : GuiControl , GuiBitmapCtrl , ArrayObject , GuiSliderCtrl
  • setVelocity() : ShapeBase , Camera
  • setVideoMode() : GuiCanvas
  • setVisible() : GuiControl
  • setVolume() : SFXSource
  • setWheelPowered() : WheeledVehicle
  • setWheelSpring() : WheeledVehicle
  • setWheelSteering() : WheeledVehicle
  • setWheelTire() : WheeledVehicle
  • setWhiteOut() : ShapeBase
  • setWindowPosition() : GuiCanvas
  • setWindowTitle() : GuiCanvas
  • shader : CustomMaterial , PostEffect
  • shadowDarkenColor : LightDescription , LightBase , ScatterSky , Sun
  • shadowDistance : LightDescription , LightBase , ScatterSky , Sun
  • shadowEnable : ShapeBaseData
  • shadowMaxVisibleDistance : ShapeBaseData
  • shadowProjectionDistance : ShapeBaseData
  • shadowSize : ShapeBaseData
  • shadowSoftness : LightDescription , LightBase , ScatterSky , Sun
  • shadowSphereAdjust : ShapeBaseData
  • shadowType : LightBase , LightDescription , ScatterSky , Sun
  • shakeCamera : ExplosionData , ShapeBaseImageData
  • ShapeCount : fxShapeReplicator
  • shapeCullRadius : GroundCover
  • shapeFile : WheeledVehicleTire , PhysicsDebrisData , ShapeBaseData , DebrisData , RenderShapeExample , fxShapeReplicator , ForestItemData , GuiObjectView , ShapeBaseImageData
  • shapeFilename : GroundCover
  • shapeName : TSStatic , fxShapeReplicatedStatic , PhysicsShapeData , PxMultiActorData
  • ShapeRetries : fxShapeReplicator
  • ShapeRotateMax : fxShapeReplicator
  • ShapeRotateMin : fxShapeReplicator
  • ShapeScaleMax : fxShapeReplicator
  • ShapeScaleMin : fxShapeReplicator
  • shapesCastShadows : GroundCover
  • shellExitDir : ShapeBaseImageData
  • shellExitVariance : ShapeBaseImageData
  • shellVelocity : ShapeBaseImageData
  • show() : PfxVis
  • showBatches : MeshRoad , DecalRoad
  • showClassNameForUnnamedObjects : GuiTreeViewCtrl
  • showClassNames : GuiTreeViewCtrl
  • showCursor() : GuiCanvas
  • showDust : Material
  • showFill : GuiHealthBarHud , GuiShapeNameHud , GuiClockHud
  • showFootprints : Material
  • showFrame : GuiHealthBarHud , GuiShapeNameHud , GuiClockHud
  • showInternalNames : GuiTreeViewCtrl
  • showItemRenameCtrl() : GuiTreeViewCtrl
  • showNodes : River
  • showObjectIds : GuiTreeViewCtrl
  • showObjectNames : GuiTreeViewCtrl
  • ShowPlacementArea : fxFoliageReplicator , fxShapeReplicator
  • showRiver : River
  • showRoad : DecalRoad , MeshRoad
  • showRoot : GuiTreeViewCtrl
  • showSpline : DecalRoad , MeshRoad , River
  • showWalls : River
  • showWireframe : River
  • sideMaterial : MeshRoad
  • simType : PhysicsShapeData
  • singleDetailSize : TSShapeConstructor
  • singlePlayerOnly : PxMultiActorData
  • sinkAllKeyEvents : GuiTextEditCtrl
  • sinkMax : ForestBrushElement
  • sinkMin : ForestBrushElement
  • sinkRadius : ForestBrushElement
  • size : PxCloth , DecalData , GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • sizeExponent : GroundCover
  • sizeIconToButton : GuiIconButtonCtrl
  • sizeMax : GroundCover
  • sizeMin : GroundCover
  • sizes : ExplosionData , ParticleData
  • sizeToContents() : GuiRolloutCtrl
  • skin : GuiObjectView
  • skip : PostEffect
  • skyBrightness : ScatterSky
  • slopeMax : ForestBrushElement
  • slopeMin : ForestBrushElement
  • smoothingType : Marker
  • snap : GuiSliderCtrl
  • snapOnMaxBounce : DebrisData
  • softImpactSound : RigidShapeData , VehicleData
  • softImpactSpeed : RigidShapeData , VehicleData
  • softnessDistance : ParticleEmitterData
  • softSplashSoundVelocity : RigidShapeData , VehicleData
  • sort() : GuiTextListCtrl , SimSet , GuiPopUpMenuCtrl , ArrayObject , GuiPopUpMenuCtrlEx , GuiTreeViewCtrl
  • sorta() : ArrayObject
  • sortd() : ArrayObject
  • sortf() : ArrayObject
  • sortfd() : ArrayObject
  • sortfk() : ArrayObject
  • sortfkd() : ArrayObject
  • sortID() : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • sortk() : ArrayObject
  • sortka() : ArrayObject
  • sortkd() : ArrayObject
  • sortn() : ArrayObject
  • sortna() : ArrayObject
  • sortnd() : ArrayObject
  • sortnk() : ArrayObject
  • sortnka() : ArrayObject
  • sortnkd() : ArrayObject
  • sortNumerical() : GuiTextListCtrl
  • sortParticles : ParticleEmitterData
  • sound : ProjectileData
  • soundAmbience : Zone , SFXSpace , WaterObject , LevelInfo
  • soundButtonDown : GuiControlProfile
  • soundButtonOver : GuiControlProfile
  • soundDistanceModel : LevelInfo
  • soundProfile : SplashData , ExplosionData , PrecipitationData
  • soundTrack : SFXAmbience
  • sourceGroup : SFXDescription , SFXEmitter
  • sourceObject : Projectile
  • sourceSlot : Projectile
  • spawnClass : SpawnSphere
  • spawnDatablock : SpawnSphere
  • spawnObject() : SpawnSphere
  • spawnProperties : SpawnSphere
  • spawnScript : SpawnSphere
  • specular : Material
  • specularColor : WaterObject
  • specularMap : Material
  • specularPower : WaterObject , Material
  • speedMultiplier : Camera
  • sphereWeight : SpawnSphere
  • spinRandomMax : ParticleData
  • spinRandomMin : ParticleData
  • spinSpeed : ParticleData
  • Splash : ProjectileData , PlayerData
  • splashAngle : PlayerData
  • splashEmitter : RigidShapeData , VehicleData , PlayerData
  • splashesPerSide : PrecipitationData
  • splashFreqMod : PlayerData , VehicleData , RigidShapeData
  • splashMS : Precipitation
  • splashShader : PrecipitationData
  • splashSize : Precipitation
  • splashTexture : PrecipitationData
  • splashVelEpsilon : VehicleData , PlayerData , RigidShapeData
  • splashVelocity : PlayerData
  • splitPoint : GuiSplitContainer
  • splitterSize : GuiSplitContainer
  • squareSize : TerrainBlock , GroundPlane
  • squealSound : WheeledVehicleData
  • stabDampingConstant : HoverVehicleData
  • stabLenMax : HoverVehicleData
  • stabLenMin : HoverVehicleData
  • stabSpringConstant : HoverVehicleData
  • stackingType : GuiStackControl
  • startDelay : GuiAutoScrollCtrl
  • startDragging() : GuiDragAndDropControl
  • startFade() : ShapeBase
  • startRadius : SplashData
  • startRecording() : GameConnection
  • startTime : TimeOfDay
  • state : SFXPlayList
  • stateAllowImageChange : ShapeBaseImageData
  • stateBlock : PostEffect , CustomMaterial
  • stateDirection : ShapeBaseImageData
  • stateEjectShell : ShapeBaseImageData
  • stateEmitter : ShapeBaseImageData
  • stateEmitterNode : ShapeBaseImageData
  • stateEmitterTime : ShapeBaseImageData
  • stateEnergyDrain : ShapeBaseImageData
  • stateFire : ShapeBaseImageData
  • stateIgnoreLoadedForReady : ShapeBaseImageData
  • stateLoadedFlag : ShapeBaseImageData
  • stateMode : SFXPlayList
  • stateName : ShapeBaseImageData
  • stateRecoil : ShapeBaseImageData
  • states : SFXAmbience
  • stateScaleAnimation : ShapeBaseImageData
  • stateScript : ShapeBaseImageData
  • stateSequence : ShapeBaseImageData
  • stateSequenceRandomFlash : ShapeBaseImageData
  • stateSound : ShapeBaseImageData
  • stateSpinThread : ShapeBaseImageData
  • stateTimeoutValue : ShapeBaseImageData
  • stateToken : RenderPassStateBin
  • stateTransitionOnAltTriggerDown : ShapeBaseImageData
  • stateTransitionOnAltTriggerUp : ShapeBaseImageData
  • stateTransitionOnAmmo : ShapeBaseImageData
  • stateTransitionOnLoaded : ShapeBaseImageData
  • stateTransitionOnNoAmmo : ShapeBaseImageData
  • stateTransitionOnNoTarget : ShapeBaseImageData
  • stateTransitionOnNotLoaded : ShapeBaseImageData
  • stateTransitionOnNotWet : ShapeBaseImageData
  • stateTransitionOnTarget : ShapeBaseImageData
  • stateTransitionOnTimeout : ShapeBaseImageData
  • stateTransitionOnTriggerDown : ShapeBaseImageData
  • stateTransitionOnTriggerUp : ShapeBaseImageData
  • stateTransitionOnWet : ShapeBaseImageData
  • stateWaitForTimeout : ShapeBaseImageData
  • static : Item
  • staticFriction : PhysicsDebrisData , PhysicsShapeData , PxMaterial , WheeledVehicleTire
  • staticOnMaxBounce : DebrisData
  • statusCallback : SFXSource
  • steeringForce : HoverVehicleData , FlyingVehicleData
  • steeringRollForce : FlyingVehicleData
  • stencilDefined : GFXStateBlockData
  • stencilEnable : GFXStateBlockData
  • stencilFailOp : GFXStateBlockData
  • stencilFunc : GFXStateBlockData
  • stencilMask : GFXStateBlockData
  • stencilPassOp : GFXStateBlockData
  • stencilRef : GFXStateBlockData
  • stencilWriteMask : GFXStateBlockData
  • stencilZFailOp : GFXStateBlockData
  • sticky : ItemData
  • stop() : AIPlayer , SFXSource , SFXEmitter , GuiTheoraCtrl , AIClient
  • stopAudio() : ShapeBase
  • stopOnSleep : GuiTheoraCtrl
  • stopRecording() : GameConnection
  • stopThread() : ShapeBase
  • strafeThrustForce : HoverVehicleData
  • streamPacketSize : SFXDescription
  • streamReadAhead : SFXDescription
  • strength : ForestWindEmitter
  • strikeObject() : Lightning
  • strikeRadius : Lightning
  • strikeRandomPoint() : Lightning
  • strikeSound : LightningData
  • strikesPerMinute : Lightning
  • strikeTextures : LightningData
  • strikeWidth : Lightning
  • SubdivideLength : River
  • subExplosion : ExplosionData
  • subscribe() : EventManager
  • subSurface : Material
  • subSurfaceColor : Material
  • subSurfaceRolloff : Material
  • sunScale : ScatterSky
  • superClass : SimObject
  • surface : ConvexShape
  • SwayMagFront : fxFoliageReplicator
  • SwayMagSide : fxFoliageReplicator
  • SwayOn : fxFoliageReplicator
  • SwaySync : fxFoliageReplicator
  • swimBoundingBox : PlayerData
  • swimForce : PlayerData


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- t -

  • tab : GuiControlProfile
  • tabComplete : GuiTextEditCtrl
  • tabHeight : GuiTabBookCtrl
  • tabMargin : GuiTabBookCtrl
  • tabPosition : GuiTabBookCtrl
  • tabSize : GuiTreeViewCtrl
  • tail : GuiSpeedometerHud
  • target : CustomMaterial , PostEffect
  • targetClear : PostEffect
  • targetClearColor : PostEffect
  • targetDepthStencil : PostEffect
  • targetFormat : PostEffect
  • targetScale : PostEffect
  • targetSize : PostEffect
  • team : WayPoint
  • terminalVelocity : DebrisData
  • TerrainAlignment : fxShapeReplicator
  • terrainFile : TerrainBlock
  • texCols : DecalData
  • texDirection : BasicClouds , CloudLayer
  • texFactor : SplashData
  • texOffset : BasicClouds
  • texRows : DecalData
  • texScale : BasicClouds , CloudLayer
  • texSize : Sun , LightBase , ReflectorDesc , LightDescription , ScatterSky
  • texSpeed : BasicClouds , CloudLayer
  • text : GuiButtonBaseCtrl , GuiWindowCtrl , GuiTextCtrl , GuiMLTextCtrl
  • textColor : GuiShapeNameHud , GuiClockHud
  • textID : GuiButtonBaseCtrl , GuiTextCtrl
  • textLocation : GuiIconButtonCtrl
  • textMargin : GuiIconButtonCtrl
  • textOffset : GuiControlProfile , GuiTreeViewCtrl
  • texture : DebrisData , SplashData , BasicClouds , CloudLayer , PostEffect
  • textureColorOp : GFXSamplerStateData
  • textureCoordCount : DecalData
  • textureCoords : DecalData , ParticleData
  • textureFactor : GFXStateBlockData
  • textureLength : DecalRoad , MeshRoad
  • textureName : ParticleData , ParticleEmitterData
  • textureTransform : GFXSamplerStateData
  • texWrap : SplashData
  • theoraFile : GuiTheoraCtrl
  • thetaMax : ParticleEmitterData
  • thetaMin : ParticleEmitterData
  • thickness : PxCloth
  • thunderSounds : LightningData
  • tickCommand : Trigger
  • tickPeriodMS : TriggerData
  • ticks : GuiSliderCtrl
  • tightnessCoefficient : ForestItemData
  • tile : GuiChunkedBitmapCtrl
  • time : TimeOfDay
  • timeMultiple : ParticleEmitterNodeData
  • times : SplashData , ParticleData , ExplosionData
  • tireEmitter : WheeledVehicleData
  • title : FileDialog
  • toggle() : RenderPassStateToken , PostEffect
  • toggleCollapse() : GuiRolloutCtrl
  • toggleCollapseGroup() : GuiWindowCtrl
  • toggleDrawing() : DebugDrawer
  • toggleExpanded() : GuiRolloutCtrl
  • toggleFreeze() : DebugDrawer
  • toggleFullscreen() : GuiCanvas
  • toggleHideSelection() : GuiTreeViewCtrl
  • toggleLockSelection() : GuiTreeViewCtrl
  • toneMap : Material
  • tooltip : GuiControl
  • tooltipOnWidthOnly : GuiTreeViewCtrl
  • tooltipProfile : GuiControl
  • topMaterial : MeshRoad
  • toQueue : MessageForwarder
  • trace : SFXPlayList , SFXController
  • track : SFXEmitter , SFXPlayList
  • trailEmitter : FlyingVehicleData
  • transcoder : GuiTheoraCtrl
  • transitionIn : SFXPlayList
  • transitionOut : SFXPlayList
  • translucent : Material
  • translucentBlendOp : Material
  • translucentZWrite : Material
  • transmitDataBlocks() : GameConnection
  • transmitPaths() : NetConnection
  • triangleCollision : PxCloth
  • triggerDustHeight : RigidShapeData , VehicleData
  • triggerTrailHeight : HoverVehicleData
  • trunkBendScale : ForestItemData
  • turboFactor : HoverVehicleData
  • turbulenceFrequency : ForestWindEmitter
  • turbulenceSpeed : Precipitation
  • turbulenceStrength : ForestWindEmitter
  • type : Marker , GuiSeparatorCtrl


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- u -

  • unbind() : ActionMap
  • unbindObj() : ActionMap
  • underwaterColor : WaterObject
  • underwaterExplosion : ShapeBaseData
  • uniqueKey() : ArrayObject
  • uniqueValue() : ArrayObject
  • unit : TSShapeConstructor
  • unmount() : SceneObject
  • unmountImage() : ShapeBase
  • unmountObject() : SceneObject
  • unproject() : GuiTSCtrl
  • unregisterEvent() : EventManager
  • upAxis : TSShapeConstructor
  • updateDelay : DecalRoad
  • updateFaces() : CubemapData
  • updateSizes() : GuiFrameSetCtrl
  • updateStack() : GuiStackControl
  • upMaxSpeed : PlayerData
  • upResistFactor : PlayerData
  • upResistSpeed : PlayerData
  • useAmbientLightColor : Zone
  • useAnisotropic : Material
  • useCreateHeight() : FlyingVehicle
  • UseCulling : fxFoliageReplicator
  • useCustomReverb : SFXDescription
  • UseDebugInfo : fxFoliageReplicator
  • useDevicePixVersion : ShaderData
  • useEmitterColors : ParticleEmitterData
  • useEmitterSizes : ParticleEmitterData
  • useEyePoint : ShapeBaseData
  • useFog : Lightning
  • useHardware : SFXDescription
  • useInspectorTooltips : GuiTreeViewCtrl
  • useInvAlpha : ParticleData
  • useLighting : Precipitation
  • useModifiers : GuiBitmapButtonCtrl
  • useMouseEvents : GuiButtonBaseCtrl
  • useNightCubemap : ScatterSky
  • useOcclusionQuery : WaterObject , ReflectorDesc
  • useRadiusMass : DebrisData
  • useRemainderDT : ShapeBaseImageData
  • usesEnergy : ShapeBaseImageData
  • useSiblingScroller : GuiConsoleEditCtrl
  • useSideProjection : TerrainMaterial
  • useStates : GuiBitmapButtonCtrl
  • useTrackDescriptionOnly : SFXEmitter
  • useTrueBillboards : fxFoliageReplicator , Precipitation
  • useTurbulence : Precipitation
  • useURLMouseCursor : GuiMLTextCtrl
  • useVariable : GuiChunkedBitmapCtrl
  • useWind : Precipitation


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- v -

  • validate : GuiTextEditCtrl
  • validateCameraFov() : ShapeBase
  • value : SFXParameter , GuiSliderCtrl
  • variable : GuiControl
  • velInheritFactor : ProjectileData
  • velocity : SplashData , ParticleEmitterNode , DebrisData
  • velocityMod : PhysicalZone
  • velocityVariance : DebrisData , ParticleEmitterData
  • version : CustomMaterial
  • vertColor : Material
  • vertexColorEnable : GFXStateBlockData
  • vertFactor : RigidShapeData , HoverVehicleData
  • verticalOffset : GuiShapeNameHud
  • verticalSurfaceForce : FlyingVehicleData
  • vertLit : Material
  • vertSizing : GuiControl
  • vertStacking : GuiStackControl
  • vertThrustMultiple : FlyingVehicleData
  • ViewClosest : fxFoliageReplicator
  • ViewDistance : fxFoliageReplicator
  • viscosity : WaterObject
  • visible : GuiControl
  • visibleDistance : LevelInfo
  • volume : SFXDescription , SFXEmitter
  • volumeScale : SFXPlayList
  • volumeScaleVariance : SFXPlayList
  • vScrollBar : GuiScrollCtrl


Torque 3D - Script Manual: Class Members

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z
Here is a list of all class members with links to the classes they belong to:

- w -

  • waitTime : GuiFadeinBitmapCtrl
  • warningFlashes() : Lightning
  • waterBreathSound : PlayerData
  • waterDampingScale : PhysicsShapeData , PhysicsDebrisData
  • waterDragScale : PxMultiActorData
  • waterExplosion : ProjectileData
  • waterFogDensity : WaterObject
  • waterFogDensityOffset : WaterObject
  • waterWakeSound : RigidShapeData , VehicleData
  • waveAmp : Material
  • waveDir : WaterObject
  • waveFreq : Material
  • waveMagnitude : WaterObject
  • waveSpeed : WaterObject
  • waveType : Material
  • wetDarkening : WaterObject
  • wetDepth : WaterObject
  • WheelImpactSound : WheeledVehicleData
  • width : SplashData , GuiSpeedometerHud
  • widthSubdivisions : MeshRoad
  • willFirstRespond : GuiScrollCtrl
  • windCoefficient : ParticleData
  • windDirection : GroundCover
  • windEnabled : ForestWindEmitter
  • windGustFrequency : GroundCover
  • windGustLength : GroundCover
  • windGustStrength : GroundCover
  • windScale : ForestItemData , GroundCover
  • windSpeed : CloudLayer
  • windTurbulenceFrequency : GroundCover
  • windTurbulenceStrength : GroundCover
  • wireframe : WaterObject , DecalRoad , MeshRoad
  • workingQueryBoxSizeMultiplier : Vehicle
  • workingQueryBoxStaleThreshold : Vehicle
  • wrap : GuiBitmapCtrl
  • writeChangeSet() : TSShapeConstructor
  • writeLine() : FileObject , StreamObject
  • writeLongString() : StreamObject
  • writeObject() : FileObject
  • writeString() : StreamObject


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- a -

  • acceptsAsChild() : SimSet
  • activate() : PhysicalZone , SFXState
  • activateGhosting() : GameConnection
  • activateRow() : GuiGameListMenuCtrl
  • add() : ArrayObject , GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx , SimSet , BanList
  • addAbsolute() : BanList
  • addAutoPlot() : GuiGraphCtrl
  • addCategory() : GuiPopUpMenuCtrlEx
  • addCollisionDetail() : TSShapeConstructor
  • addColumn() : GuiFrameSetCtrl
  • addComment() : SimXMLDocument
  • addData() : SimXMLDocument
  • addDatum() : GuiGraphCtrl
  • addFile() : ZipObject
  • addFilteredItem() : GuiListBoxCtrl
  • addGuiControl() : GuiControl
  • addHeader() : SimXMLDocument
  • addImposter() : TSShapeConstructor
  • addLanguage() : LangTable
  • addManager() : RenderPassManager
  • addMarker() : SFXSource
  • addMenu() : GuiMenuBar
  • addMenuItem() : GuiMenuBar
  • addMesh() : TSShapeConstructor
  • addNewElement() : SimXMLDocument
  • addNode() : TSShapeConstructor
  • addPage() : GuiTabBookCtrl
  • addParameter() : SFXSource
  • addPrimitive() : TSShapeConstructor
  • addReference() : Message
  • addRow() : GuiFrameSetCtrl , GuiGameListMenuCtrl , GuiGameListOptionsCtrl , GuiTextListCtrl
  • addScheme() : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • addSelection() : GuiTreeViewCtrl
  • addSequence() : TSShapeConstructor
  • addSubmenuItem() : GuiMenuBar
  • addText() : GuiMLTextCtrl , SimXMLDocument
  • addTimeOfDayEvent() : TimeOfDay
  • addTrigger() : TSShapeConstructor
  • animate() : TimeOfDay
  • animationDone() : PlayerData
  • append() : ArrayObject
  • apply() : LightDescription , LightFlareData
  • applyChanges() : ScatterSky
  • applyDamage() : Lightning , ShapeBase
  • applyImpulse() : ShapeBase , GameBase
  • applyRadialImpulse() : GameBase
  • applyRepair() : ShapeBase
  • assignFieldsFrom() : SimObject
  • assignPersistentId() : SimObject
  • attach() : GuiWindowCtrl , ConsoleLogger , GuiMessageVectorCtrl , PhysicsForce
  • attachTo() : GuiWindowCtrl
  • attachToObject() : ForestWindEmitter
  • attribute() : SimXMLDocument
  • attributeExists() : SimXMLDocument
  • attributeF32() : SimXMLDocument
  • attributeS32() : SimXMLDocument
  • autoFitRadius() : Camera


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- l -

  • lastAttribute() : SimXMLDocument
  • listClassIDs() : GameConnection
  • listen() : TCPObject
  • listMeshes() : PxMultiActor
  • listObjects() : SimSet
  • loadData() : SFXFMODEventGroup
  • loadFile() : SimXMLDocument
  • lockSelection() : GuiTreeViewCtrl
  • lookAt() : Camera


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- m -

  • makeFirstResponder() : GuiControl
  • markItem() : GuiTreeViewCtrl
  • matchScale() : GuiGraphCtrl
  • maximizeWindow() : GuiCanvas
  • minimizeWindow() : GuiCanvas
  • modifyStorm() : Precipitation
  • mountImage() : ShapeBase
  • mountObject() : SceneObject
  • moveFirst() : ArrayObject
  • moveItemDown() : GuiTreeViewCtrl
  • moveItemUp() : GuiTreeViewCtrl
  • moveLast() : ArrayObject
  • moveNext() : ArrayObject
  • movePrev() : ArrayObject
  • msg() : SimpleNetObject


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- n -

  • nextAttribute() : SimXMLDocument
  • nextSiblingElement() : SimXMLDocument
  • notifyShapeChanged() : TSShapeConstructor


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- o -

  • onAction() : GuiControl
  • onActivate() : SFXState
  • onActive() : GuiControl
  • onAdd() : GameBaseData , Trigger , ScriptObject , GuiControl , ScriptGroup , PostEffect , ScriptMsgListener , Message , SpawnSphere
  • onAddGroupSelected() : GuiTreeViewCtrl
  • onAddMultipleSelectionBegin() : GuiTreeViewCtrl
  • onAddMultipleSelectionEnd() : GuiTreeViewCtrl
  • onAddSelection() : GuiTreeViewCtrl
  • onAddToQueue() : ScriptMsgListener
  • onAltClick() : GuiBitmapButtonCtrl
  • onBeginReparenting() : GuiTreeViewCtrl
  • onChange() : GuiGameListMenuCtrl
  • onChildAdded() : GuiScriptNotifyCtrl
  • onChildRemoved() : GuiScriptNotifyCtrl
  • onChildResized() : GuiScriptNotifyCtrl
  • onClearSelection() : GuiListBoxCtrl , GuiTreeViewCtrl
  • onClick() : GuiButtonBaseCtrl
  • onClose() : GuiWindowCtrl
  • onCollapse() : GuiWindowCtrl
  • onCollapsed() : GuiRolloutCtrl
  • onCollision() : ShapeBaseData , ProjectileData
  • onComplete() : GuiAutoScrollCtrl
  • onConnected() : TCPObject
  • onConnectFailed() : TCPObject
  • onConnectionAccepted() : GameConnection
  • onConnectionDropped() : GameConnection
  • onConnectionError() : GameConnection
  • onConnectionRequest() : TCPObject
  • onConnectionTimedOut() : GameConnection
  • onConnectRequestRejected() : GameConnection
  • onConnectRequestTimedOut() : GameConnection
  • onControlDragEnter() : GuiControl
  • onControlDragExit() : GuiControl
  • onControlDragged() : GuiControl
  • onControlDropped() : GuiControl
  • onCtrlClick() : GuiBitmapButtonCtrl
  • onDamage() : ShapeBaseData
  • onDataBlocksDone() : GameConnection
  • onDeactivate() : SFXState
  • onDefaultClick() : GuiBitmapButtonCtrl
  • onDefineIcons() : GuiTreeViewCtrl
  • onDeleteKey() : GuiListBoxCtrl , GuiTextListCtrl
  • onDeleteObject() : GuiTreeViewCtrl
  • onDeleteSelection() : GuiTreeViewCtrl
  • onDestroyed() : ShapeBaseData
  • onDialogPop() : GuiControl
  • onDialogPush() : GuiControl
  • onDisabled() : ShapeBaseData , PostEffect
  • onDisconnect() : TCPObject
  • onDNSFailed() : TCPObject
  • onDNSResolved() : TCPObject
  • onDone() : GuiFadeinBitmapCtrl
  • onDoubleClick() : GuiButtonBaseCtrl , GuiListBoxCtrl
  • onDragDropped() : GuiTreeViewCtrl
  • onDrop() : GameConnection
  • onEnabled() : ShapeBaseData , PostEffect
  • onEndReparenting() : GuiTreeViewCtrl
  • onEndSequence() : ShapeBaseData
  • onEnterLiquid() : VehicleData , Item , PlayerData , RigidShape
  • onEnterMissionArea() : PlayerData
  • onEnterTrigger() : TriggerData
  • onExpanded() : GuiRolloutCtrl
  • onExplode() : ProjectileData
  • onFlash() : GameConnection
  • onForceUncloak() : ShapeBaseData
  • onGainFirstResponder() : GuiControl , GuiScriptNotifyCtrl
  • onHeaderRightClick() : GuiRolloutCtrl
  • onImpact() : ShapeBaseData
  • onInputEvent() : GuiInputCtrl
  • onInspect() : GuiTreeViewCtrl
  • onKeyDown() : GuiTreeViewCtrl
  • onLeaveLiquid() : VehicleData , Item , PlayerData , RigidShape
  • onLeaveMissionArea() : PlayerData
  • onLeaveTrigger() : TriggerData
  • onLine() : TCPObject
  • onLoad() : Prefab , TSShapeConstructor
  • onLoseFirstResponder() : GuiControl , GuiScriptNotifyCtrl
  • onMaximize() : GuiWindowCtrl
  • onMenuItemSelect() : GuiMenuBar
  • onMenuSelect() : GuiMenuBar
  • onMessageObjectReceived() : ScriptMsgListener
  • onMessageReceived() : ScriptMsgListener
  • onMessageSelected() : GuiConsole
  • onMinimize() : GuiWindowCtrl
  • onMount() : GameBaseData , ShapeBaseImageData
  • onMouseDown() : GuiMouseEventCtrl , GuiButtonBaseCtrl
  • onMouseDragged() : GuiButtonBaseCtrl , GuiListBoxCtrl , GuiTreeViewCtrl , GuiSliderCtrl , GuiMouseEventCtrl
  • onMouseEnter() : GuiMouseEventCtrl , GuiButtonBaseCtrl , GuiObjectView
  • onMouseInMenu() : GuiMenuBar
  • onMouseLeave() : GuiMouseEventCtrl , GuiButtonBaseCtrl , GuiObjectView
  • onMouseMove() : GuiMouseEventCtrl
  • onMouseUp() : GuiTreeViewCtrl , GuiMouseEventCtrl , GuiButtonBaseCtrl , GuiListBoxCtrl
  • onNewDataBlock() : GameBaseData
  • onNode() : PathCamera
  • onObjectAdded() : SimSet
  • onObjectDeleteCompleted() : GuiTreeViewCtrl
  • onObjectRemoved() : SimSet
  • onParameterValueChange() : SFXSource
  • onParentResized() : GuiScriptNotifyCtrl
  • onRemove() : GameBaseData , ScriptMsgListener , ScriptObject , GuiControl , ScriptGroup , Message , Trigger
  • onRemoveFromQueue() : ScriptMsgListener
  • onRemoveSelection() : GuiTreeViewCtrl
  • onReparent() : GuiTreeViewCtrl
  • onReset() : GuiAutoScrollCtrl
  • onResize() : GuiScriptNotifyCtrl , GuiMLTextCtrl
  • onRestore() : GuiWindowCtrl
  • onReturn() : GuiTextEditCtrl
  • onRightClick() : GuiButtonBaseCtrl
  • onRightMouseDown() : GuiTreeViewCtrl , GuiMouseEventCtrl
  • onRightMouseDragged() : GuiMouseEventCtrl
  • onRightMouseUp() : GuiMouseEventCtrl , GuiTreeViewCtrl
  • onScroll() : GuiScrollCtrl
  • onSelect() : GuiTextListCtrl , GuiListBoxCtrl , GuiTreeViewCtrl
  • onShiftClick() : GuiBitmapButtonCtrl
  • onSleep() : GuiControl
  • onStart() : GuiAutoScrollCtrl
  • onStartSwim() : PlayerData
  • onStatusChange() : SFXSource
  • onStickyCollision() : Item
  • onStopSwim() : PlayerData
  • onSubmenuSelect() : GuiMenuBar
  • onTabComplete() : GuiTextEditCtrl
  • onTabRightClick() : GuiTabBookCtrl
  • onTabSelected() : GuiTabBookCtrl
  • onTick() : GuiAutoScrollCtrl
  • onTickTrigger() : TriggerData
  • onTrigger() : ShapeBaseData
  • onUnload() : TSShapeConstructor
  • onUnmount() : ShapeBaseImageData , GameBaseData
  • onUnselect() : GuiListBoxCtrl , GuiTreeViewCtrl
  • onUpdate() : SFXParameter
  • onURL() : GuiMLTextCtrl
  • onValidate() : GuiTextEditCtrl
  • onVisible() : GuiControl
  • onWake() : GuiControl
  • onWindowClosed() : PfxVis
  • open() : GuiTreeViewCtrl , FileStreamObject , PfxVis
  • openArchive() : ZipObject
  • openFileForRead() : ZipObject
  • openFileForWrite() : ZipObject
  • openForAppend() : FileObject
  • openForRead() : FileObject
  • openForWrite() : FileObject


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- b -

  • bind() : ActionMap
  • bindCmd() : ActionMap
  • bindObj() : ActionMap
  • bringToFront() : SimSet
  • buildIconTable() : GuiTreeViewCtrl


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- c -

  • calculateViewDistance() : GuiTSCtrl
  • call() : SimObject
  • callOnChildren() : SimSet
  • callOnChildrenNoRecurse() : SimSet
  • canCloak() : ShapeBase
  • canRenameObject() : GuiTreeViewCtrl
  • changeMaterial() : TSStatic , InteriorInstance , ShapeBase
  • changeTextById() : GuiPopUpMenuCtrl
  • chaseCam() : GameConnection
  • checkDeployPos() : ShapeBaseData
  • checkDismountPoint() : Player
  • checkMaxRate() : NetConnection
  • clear() : SimXMLDocument , Forest , GuiTreeViewCtrl , GuiPopUpMenuCtrlEx , GuiTextListCtrl , MessageVector , PfxVis , SimSet
  • clearAim() : AIPlayer
  • clearCameraObject() : GameConnection
  • clearControlObject() : Player
  • clearEntry() : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • clearError() : SimXMLDocument
  • clearFilterText() : GuiTreeViewCtrl
  • clearFirstResponder() : GuiControl
  • clearItemColor() : GuiListBoxCtrl
  • clearItems() : GuiListBoxCtrl
  • clearMenuItems() : GuiMenuBar
  • clearMenus() : GuiMenuBar
  • clearPaths() : NetConnection
  • clearScopeToClient() : NetObject
  • clearSelectedText() : GuiTextEditCtrl
  • clearSelection() : GuiListBoxCtrl , GuiTextListCtrl , GuiTreeViewCtrl
  • clearShaderMacros() : PostEffect
  • clearSubmenuItems() : GuiMenuBar
  • click() : GuiFadeinBitmapCtrl
  • clientToScreen() : GuiCanvas
  • clone() : SimObject
  • close() : FileStreamObject , FileObject
  • closeArchive() : ZipObject
  • closeFile() : ZipObject
  • collapse() : GuiRolloutCtrl
  • computeSizes() : GuiScrollCtrl
  • connect() : TCPObject , NetConnection
  • connectLocal() : NetConnection
  • controlIsChild() : GuiControl
  • copyFrom() : StreamObject
  • count() : ArrayObject
  • countKey() : ArrayObject
  • countValue() : ArrayObject
  • createNullDevice() : GFXInit
  • crop() : ArrayObject
  • cursorOff() : GuiCanvas
  • cursorOn() : GuiCanvas


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- d -

  • deactivate() : PhysicalZone , SFXState
  • deepClone() : SimObject
  • delete() : SimObject , GameConnection
  • deleteAllObjects() : SimSet
  • deleteFile() : ZipObject
  • deleteItem() : GuiListBoxCtrl
  • deleteLine() : MessageVector
  • deleteSelection() : GuiTreeViewCtrl
  • destroy() : PhysicsShape
  • destroyThread() : ShapeBase
  • detach() : PhysicsForce , ConsoleLogger , GuiMessageVectorCtrl
  • disable() : RenderPassStateToken , PostEffect , SFXState
  • disconnect() : TCPObject
  • doDismount() : PlayerData
  • doMirror() : GuiListBoxCtrl
  • drawBox() : DebugDrawer
  • drawLine() : DebugDrawer
  • dump() : SimObject , MessageVector
  • dumpClassHierarchy() : SimObject
  • dumpEvents() : EventManager
  • dumpGroupHierarchy() : SimObject
  • dumpMeshVisibility() : ShapeBase
  • dumpMethods() : SimObject
  • dumpShaderDisassembly() : PostEffect
  • dumpShape() : TSShapeConstructor
  • dumpSubscribers() : EventManager
  • dumpZoneState() : Zone
  • duplicate() : ArrayObject


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- e -

  • echo() : ArrayObject
  • editItem() : GuiTreeViewCtrl
  • elementValue() : SimXMLDocument
  • empty() : ArrayObject
  • enable() : RenderPassStateToken , PostEffect , SFXState
  • erase() : ArrayObject
  • Execute() : FileDialog
  • expand() : GuiRolloutCtrl
  • expandItem() : GuiTreeViewCtrl
  • export() : BanList
  • exportHeightMap() : TerrainBlock
  • exportLayerMaps() : TerrainBlock
  • exportToCollada() : InteriorInstance
  • extractFile() : ZipObject


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- f -

  • findChildItemByName() : GuiTreeViewCtrl
  • findHitControl() : GuiControl
  • findHitControls() : GuiControl
  • findItemByName() : GuiTreeViewCtrl
  • findItemByObjectId() : GuiTreeViewCtrl
  • findItemByValue() : GuiTreeViewCtrl
  • findItemText() : GuiListBoxCtrl
  • findObjectByInternalName() : SimSet
  • findText() : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • findTextIndex() : GuiTextListCtrl
  • firstAttribute() : SimXMLDocument
  • forceClose() : GuiPopUpMenuCtrlEx
  • forceOnAction() : GuiPopUpMenuCtrlEx
  • forceReflow() : GuiMLTextCtrl
  • forceValidateText() : GuiTextEditCtrl
  • frameBorder() : GuiFrameSetCtrl
  • frameMinExtent() : GuiFrameSetCtrl
  • frameMovable() : GuiFrameSetCtrl
  • framePadding() : GuiFrameSetCtrl
  • freeData() : SFXFMODEventGroup
  • freeReference() : Message
  • freeze() : GuiStackControl
  • freezeSim() : RigidShape


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- g -

  • get() : HTTPObject
  • getAdapterCount() : GFXInit
  • getAdapterMode() : GFXInit
  • getAdapterModeCount() : GFXInit
  • getAdapterName() : GFXInit
  • getAdapterShaderModel() : GFXInit
  • getAdapterType() : GFXInit
  • getAddress() : NetConnection
  • getAimLocation() : AIPlayer
  • getAimObject() : AIPlayer
  • getAIRepairPoint() : ShapeBase
  • getAngularVelocity() : Camera
  • getArea() : MissionArea
  • getAspect() : GuiControl
  • getAspectRatio() : PostEffect
  • getAttenuatedVolume() : SFXSource
  • getBinding() : ActionMap
  • getBinType() : RenderBinManager
  • getBounds() : TSShapeConstructor
  • getCameraFov() : ShapeBase
  • getCameraObject() : GameConnection
  • getCameraSpeed() : GuiObjectView
  • getCanSave() : SimObject
  • getCard() : GFXCardProfilerAPI
  • getCenter() : GuiControl
  • getChild() : GuiTreeViewCtrl
  • getClassName() : SimObject
  • getClassNamespace() : SimObject
  • getClientObject() : NetObject
  • getColumnCount() : GuiFrameSetCtrl
  • getColumnOffset() : GuiFrameSetCtrl
  • getCommand() : ActionMap
  • getContent() : GuiCanvas
  • getControlCameraDefaultFov() : GameConnection
  • getControlCameraFov() : GameConnection
  • getControllingClient() : ShapeBase
  • getControllingObject() : ShapeBase
  • getControlObject() : GameConnection , Player
  • getCount() : SimSet
  • getCurrent() : ArrayObject
  • getCurrentLanguage() : LangTable
  • getCurrentOption() : GuiGameListOptionsCtrl
  • getCurrentSlot() : SFXController
  • getCurrentTime() : GuiTheoraCtrl
  • getCursorPos() : GuiTextEditCtrl , GuiCanvas
  • getDamageFlash() : ShapeBase , GameConnection
  • getDamageLevel() : ShapeBase
  • getDamageLocation() : Player
  • getDamagePercent() : ShapeBase
  • getDamageState() : ShapeBase
  • getData() : SimXMLDocument
  • getDataBlock() : GameBase
  • getDatum() : GuiGraphCtrl
  • getDeadZone() : ActionMap
  • getDebugInfo() : SimObject
  • getDeclarationLine() : SimObject
  • getDefaultAdapterIndex() : GFXInit
  • getDefaultCameraFov() : ShapeBase
  • getDeployTransform() : ShapeBaseData
  • getDetailLevelCount() : TSShapeConstructor
  • getDetailLevelIndex() : TSShapeConstructor
  • getDetailLevelName() : TSShapeConstructor
  • getDetailLevelSize() : TSShapeConstructor
  • getDuration() : SFXSound
  • getDynamicField() : SimObject
  • getDynamicFieldCount() : SimObject
  • getEnergyLevel() : ShapeBase
  • getEnergyPercent() : ShapeBase
  • getErrorDesc() : SimXMLDocument
  • getEulerRotation() : SceneObject
  • getExtent() : GuiControl , GuiCanvas
  • getEyePoint() : ShapeBase
  • getEyeTransform() : ShapeBase
  • getEyeVector() : ShapeBase
  • getFadeInTime() : SFXSource
  • getFadeOutTime() : SFXSource
  • getField() : SimObject
  • getFieldCount() : SimObject
  • getFieldType() : SimObject
  • getFieldValue() : SimObject
  • getFileEntry() : ZipObject
  • getFileEntryCount() : ZipObject
  • getFilename() : SimObject , CubemapData
  • getFilterText() : GuiTreeViewCtrl
  • getFirstResponder() : GuiControl
  • getForwardVector() : SceneObject
  • getFramePadding() : GuiFrameSetCtrl
  • getFullCount() : SimSet
  • getGhostID() : NetObject , NetConnection
  • getGhostsActive() : NetConnection
  • getGlobalCenter() : GuiControl
  • getGlobalPosition() : GuiControl
  • getGroup() : SimObject
  • getId() : SimObject
  • getImageAltTrigger() : ShapeBase
  • getImageAmmo() : ShapeBase
  • getImageLoaded() : ShapeBase
  • getImageSkinTag() : ShapeBase
  • getImageState() : ShapeBase
  • getImageTrigger() : ShapeBase
  • getImposterDetailLevel() : TSShapeConstructor
  • getImposterSettings() : TSShapeConstructor
  • getIndexFromKey() : ArrayObject
  • getIndexFromValue() : ArrayObject
  • getInternalName() : SimObject
  • getItemCount() : GuiListBoxCtrl
  • getItemObject() : GuiListBoxCtrl
  • getItemText() : GuiListBoxCtrl , GuiTreeViewCtrl
  • getItemValue() : GuiTreeViewCtrl
  • getKey() : ArrayObject
  • getLangName() : LangTable
  • getLastClickItem() : GuiListBoxCtrl
  • getLastStickyNormal() : Item
  • getLastStickyPos() : Item
  • getLineIndexByTag() : MessageVector
  • getLineTag() : MessageVector
  • getLineText() : MessageVector
  • getLineTextByTag() : MessageVector
  • getLookAtPoint() : ShapeBase
  • getManager() : RenderPassManager
  • getManagerCount() : RenderPassManager
  • getMeshCount() : TSShapeConstructor
  • getMeshMaterial() : TSShapeConstructor
  • getMeshName() : TSShapeConstructor
  • getMeshSize() : TSShapeConstructor
  • getMeshType() : TSShapeConstructor
  • getMinExtent() : GuiControl
  • getMode() : Camera , GuiCanvas
  • getModeCount() : GuiCanvas
  • getModel() : GuiObjectView
  • getModelFile() : ShapeBase , TSStatic , InteriorInstance
  • getMountedImage() : ShapeBase
  • getMountedModel() : GuiObjectView
  • getMountedObject() : SceneObject
  • getMountedObjectCount() : SceneObject
  • getMountedObjectNode() : SceneObject
  • getMountNodeObject() : SceneObject
  • getMountSkin() : GuiObjectView
  • getMountSlot() : ShapeBase
  • getMouseControl() : GuiCanvas
  • getMove() : AIConnection
  • getMoveDestination() : AIPlayer
  • getMuzzlePoint() : ShapeBase
  • getMuzzleVector() : ShapeBase
  • getName() : SimObject
  • getNextSibling() : GuiTreeViewCtrl
  • getNodeChildCount() : TSShapeConstructor
  • getNodeChildName() : TSShapeConstructor
  • getNodeCount() : TSShapeConstructor
  • getNodeIndex() : TSShapeConstructor
  • getNodeName() : TSShapeConstructor
  • getNodeObjectCount() : TSShapeConstructor
  • getNodeObjectName() : TSShapeConstructor
  • getNodeParentName() : TSShapeConstructor
  • getNodeTransform() : TSShapeConstructor
  • getNumDetailLevels() : InteriorInstance
  • getNumLang() : LangTable
  • getNumLines() : MessageVector
  • getNumObjects() : Trigger
  • getObject() : SimSet , Trigger
  • getObjectBox() : SceneObject
  • getObjectCount() : TSShapeConstructor
  • getObjectIndex() : SimSet , TSShapeConstructor
  • getObjectMount() : SceneObject
  • getObjectName() : TSShapeConstructor
  • getObjectNode() : TSShapeConstructor
  • getOffset() : Camera
  • getOrbitDistance() : GuiObjectView
  • getPacketLoss() : NetConnection
  • getParameter() : SFXSource
  • getParameterCount() : SFXSource
  • getParameterName() : SFXParameter
  • getParent() : GuiControl , GuiTreeViewCtrl
  • getPathId() : Path
  • getPendingImage() : ShapeBase
  • getPing() : NetConnection
  • getPitch() : SFXSource
  • getPosition() : GuiControl , Camera , StreamObject , SFXSound , SceneObject
  • getPrevSibling() : GuiTreeViewCtrl
  • getRandom() : SimSet
  • getRechargeRate() : ShapeBase
  • getRenderer() : GFXCardProfilerAPI
  • getRepairRate() : ShapeBase
  • getRightVector() : SceneObject
  • getRoot() : GuiControl
  • getRotation() : Camera
  • getRowCount() : GuiFrameSetCtrl , GuiGameListMenuCtrl
  • getRowId() : GuiTextListCtrl
  • getRowLabel() : GuiGameListMenuCtrl
  • getRowNumById() : GuiTextListCtrl
  • getRowOffset() : GuiFrameSetCtrl
  • getRowText() : GuiTextListCtrl
  • getRowTextById() : GuiTextListCtrl
  • getScale() : ActionMap , SceneObject
  • getScrollPosition() : GuiScrollCtrl
  • getScrollPositionX() : GuiScrollCtrl
  • getScrollPositionY() : GuiScrollCtrl
  • getSelCount() : GuiListBoxCtrl
  • getSelected() : GuiPopUpMenuCtrlEx
  • getSelectedFile() : GuiDirectoryFileListCtrl
  • getSelectedFiles() : GuiDirectoryFileListCtrl
  • getSelectedId() : GuiTextListCtrl
  • getSelectedItem() : GuiTreeViewCtrl , GuiListBoxCtrl
  • getSelectedItems() : GuiListBoxCtrl
  • getSelectedObject() : GuiTreeViewCtrl
  • getSelectedPage() : GuiTabBookCtrl
  • getSelectedRow() : GuiGameListMenuCtrl , GuiTextListCtrl
  • getSequenceBlend() : TSShapeConstructor
  • getSequenceCount() : TSShapeConstructor
  • getSequenceCyclic() : TSShapeConstructor
  • getSequenceFrameCount() : TSShapeConstructor
  • getSequenceGroundSpeed() : TSShapeConstructor
  • getSequenceIndex() : TSShapeConstructor
  • getSequenceName() : TSShapeConstructor
  • getSequencePriority() : TSShapeConstructor
  • getSequenceSource() : TSShapeConstructor
  • getServerConnection() : GameConnection
  • getServerObject() : NetObject
  • getShapeName() : ShapeBase
  • getSkin() : GuiObjectView
  • getSkinName() : ShapeBase
  • getSlotTransform() : ShapeBase
  • getSoundDuration() : SFXProfile
  • getSource() : SFXEmitter
  • getState() : Player
  • getStatus() : SFXSource , StreamObject
  • getStreamSize() : StreamObject
  • getString() : LangTable
  • getStringWidth() : GuiControlProfile
  • getSuperClassNamespace() : SimObject
  • getTargetCount() : TSShapeConstructor , TSStatic , InteriorInstance , ShapeBase
  • getTargetName() : TSShapeConstructor , InteriorInstance , TSStatic , ShapeBase
  • getText() : GuiMLTextCtrl , GuiTextEditCtrl , GuiButtonBaseCtrl , GuiPopUpMenuCtrlEx , SimXMLDocument
  • getTextById() : GuiPopUpMenuCtrlEx , GuiPopUpMenuCtrl
  • getTextToRoot() : GuiTreeViewCtrl
  • getTime() : GuiClockHud
  • getTransform() : SceneObject
  • getTrigger() : TSShapeConstructor , AIConnection
  • getTriggerCount() : TSShapeConstructor
  • getType() : Message , SceneObject
  • getUpVector() : SceneObject
  • getValue() : GuiSliderCtrl , ArrayObject
  • getVelocity() : ShapeBase , Camera
  • getVendor() : GFXCardProfilerAPI
  • getVersion() : GFXCardProfilerAPI
  • getVideoMemoryMB() : GFXCardProfilerAPI
  • getVideoMode() : GuiCanvas
  • getVolume() : SFXSource
  • getWheelCount() : WheeledVehicle
  • getWhiteOut() : GameConnection , ShapeBase
  • getWindowPosition() : GuiCanvas
  • getWorldBox() : SceneObject
  • getWorldBoxCenter() : SceneObject
  • getWorldToScreenScale() : GuiTSCtrl
  • getZoneId() : Zone


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- h -

  • handleRenameObject() : GuiTreeViewCtrl
  • hide() : PfxVis
  • hideCursor() : GuiCanvas
  • hideSelection() : GuiTreeViewCtrl


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- i -

  • import() : TerrainBlock
  • init() : Debris
  • initialControlSet() : GameConnection
  • insert() : ArrayObject
  • insertItem() : GuiListBoxCtrl , GuiTreeViewCtrl
  • insertLine() : MessageVector
  • instantCollapse() : GuiRolloutCtrl
  • instantExpand() : GuiRolloutCtrl
  • isActive() : SFXState
  • isAIControlled() : GameConnection
  • isAllTextSelected() : GuiTextEditCtrl
  • isAttached() : PhysicsForce
  • isAwake() : GuiControl
  • isBanned() : BanList
  • isChildOfGroup() : SimObject
  • isClientObject() : NetObject
  • isCloaked() : ShapeBase
  • isControlObjectRotDampedCamera() : GameConnection
  • isCursorOn() : GuiCanvas
  • isCursorShown() : GuiCanvas
  • isDataLoaded() : SFXFMODEventGroup
  • isDemoPlaying() : GameConnection
  • isDemoRecording() : GameConnection
  • isDestroyed() : ShapeBase , PhysicsShape
  • isDirty() : Forest
  • isDisabled() : ShapeBase , SFXState
  • isEditOrbitMode() : Camera
  • isEditorOnly() : SimObject
  • isEnabled() : ShapeBase , PostEffect
  • isEOF() : FileObject , StreamObject
  • isEOS() : StreamObject
  • isExpanded() : SimObject , GuiRolloutCtrl
  • isExteriorPortal() : Portal
  • isFirstPerson() : GameConnection
  • isFirstResponder() : GuiControl
  • isFrozen() : GuiStackControl
  • isFullscreen() : GuiCanvas
  • isGlobalBounds() : SceneObject
  • isHidden() : ShapeBase
  • isImageFiring() : ShapeBase
  • isImageMounted() : ShapeBase
  • isInNamespaceHierarchy() : SimObject
  • isInteriorPortal() : Portal
  • isInverted() : ActionMap
  • isItemSelected() : GuiTreeViewCtrl
  • isMaximized() : GuiCanvas
  • isMember() : SimSet
  • isMemberOfClass() : SimObject
  • isMethod() : SimObject
  • isMinimized() : GuiCanvas
  • isMounted() : SceneObject
  • isMouseLocked() : GuiControl
  • isNameChangeAllowed() : SimObject
  • isObjectMirrored() : GuiListBoxCtrl
  • isParentItem() : GuiTreeViewCtrl
  • isPaused() : SFXSource
  • isPlaybackDone() : GuiTheoraCtrl
  • isPlaying() : SFXSource
  • isReady() : SFXSound
  • isRegisteredEvent() : EventManager
  • isRotating() : Item
  • isRotationDamped() : Camera
  • isRowActive() : GuiTextListCtrl
  • isRowEnabled() : GuiGameListMenuCtrl
  • isSelected() : SimObject
  • isServerObject() : NetObject
  • isStateOn() : GuiCheckBoxCtrl
  • isStatic() : Item
  • isStopped() : SFXSource
  • isThumbBeingDragged() : GuiSliderCtrl
  • isValidDragTarget() : GuiTreeViewCtrl
  • isVisible() : GuiControl


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- p -

  • parse() : SimXMLDocument
  • pause() : SFXSource , GuiTheoraCtrl
  • pauseThread() : ShapeBase
  • peekLine() : FileObject
  • performClick() : GuiButtonBaseCtrl
  • play() : GuiTheoraCtrl , SFXEmitter
  • play2D() : GameConnection
  • play3D() : GameConnection
  • playAnimation() : LightBase
  • playAudio() : ShapeBase
  • playDemo() : GameConnection
  • playThread() : ShapeBase
  • pointInControl() : GuiControl
  • pop() : ActionMap
  • pop_back() : ArrayObject
  • pop_front() : ArrayObject
  • popBackLine() : MessageVector
  • popDialog() : GuiCanvas
  • popElement() : SimXMLDocument
  • popFront() : PathCamera
  • popFrontLine() : MessageVector
  • popLayer() : GuiCanvas
  • post() : HTTPObject
  • postApply() : RenderMeshExample , DecalRoad , MeshRoad , DecalData , GroundPlane , MissionArea
  • postEvent() : EventManager
  • preProcess() : PostEffect
  • presimulate() : Projectile
  • prevAttribute() : SimXMLDocument
  • project() : GuiTSCtrl
  • push() : ActionMap
  • push_back() : ArrayObject
  • push_front() : ArrayObject
  • pushBack() : PathCamera
  • pushBackLine() : MessageVector
  • pushChildElement() : SimXMLDocument
  • pushDialog() : GuiCanvas
  • pushFirstChildElement() : SimXMLDocument
  • pushFront() : PathCamera
  • pushFrontLine() : MessageVector
  • pushNewElement() : SimXMLDocument
  • pushToBack() : SimSet


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- q -

  • queryProfile() : GFXCardProfilerAPI


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- r -

  • readComment() : SimXMLDocument
  • readLine() : FileObject , StreamObject
  • readLongString() : StreamObject
  • readString() : StreamObject
  • readSTString() : StreamObject
  • refresh() : GuiDynamicCtrlArrayControl
  • regenCells() : Forest
  • regenerate() : DecalRoad , MeshRoad , River
  • registerEvent() : EventManager
  • reload() : ShaderData , PostEffect , ParticleData , ParticleEmitterData , GuiDirectoryFileListCtrl
  • reloadOnLocalClient() : SimDataBlock
  • remove() : SimSet , EventManager
  • removeAll() : EventManager
  • removeAutoPlot() : GuiGraphCtrl
  • removeBan() : BanList
  • removeColumn() : GuiFrameSetCtrl
  • removeDetailLevel() : TSShapeConstructor
  • removeFilteredItem() : GuiListBoxCtrl
  • removeImposter() : TSShapeConstructor
  • removeItem() : GuiTreeViewCtrl
  • removeManager() : RenderPassManager
  • removeMenu() : GuiMenuBar
  • removeMenuItem() : GuiMenuBar
  • removeMesh() : TSShapeConstructor
  • removeNode() : TSShapeConstructor
  • removeObject() : TSShapeConstructor
  • removeParameter() : SFXSource
  • removeRow() : GuiFrameSetCtrl , GuiTextListCtrl
  • removeRowById() : GuiTextListCtrl
  • removeSelection() : GuiTreeViewCtrl
  • removeSequence() : TSShapeConstructor
  • removeShaderMacro() : PostEffect
  • removeText() : SimXMLDocument
  • removeTrigger() : TSShapeConstructor
  • renameDetailLevel() : TSShapeConstructor
  • renameNode() : TSShapeConstructor
  • renameObject() : TSShapeConstructor
  • renameSequence() : TSShapeConstructor
  • renderFront() : GuiCanvas
  • reorderChild() : SimSet
  • repaint() : GuiCanvas
  • replaceText() : GuiPopUpMenuCtrl
  • reset() : RigidShape , GuiAutoScrollCtrl , SimXMLDocument , SFXParameter , PathCamera , GuiCanvas
  • resetGhosting() : GameConnection
  • resetState() : GuiButtonBaseCtrl
  • resize() : GuiControl
  • resolveGhostID() : NetConnection
  • resolveObjectFromGhostIndex() : NetConnection
  • restore() : PhysicsShape
  • restoreWindow() : GuiCanvas
  • rowCount() : GuiTextListCtrl


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- s -

  • save() : SimObject , ActionMap , TerrainBlock
  • saveFile() : SimXMLDocument
  • saveShape() : TSShapeConstructor
  • schedule() : SimObject
  • scopeToClient() : NetObject
  • screenToClient() : GuiCanvas
  • scrollToBottom() : GuiMLTextCtrl , GuiScrollCtrl
  • scrollToObject() : GuiScrollCtrl
  • scrollToTag() : GuiMLTextCtrl
  • scrollToTop() : GuiMLTextCtrl , GuiScrollCtrl
  • scrollVisible() : GuiTextListCtrl , GuiTreeViewCtrl
  • scrollVisibleByObjectId() : GuiTreeViewCtrl
  • select() : GuiTabPageCtrl
  • selectAllText() : GuiTextEditCtrl
  • selectItem() : GuiTreeViewCtrl
  • selectOption() : GuiGameListOptionsCtrl
  • selectPage() : GuiTabBookCtrl
  • selectWindow() : GuiWindowCtrl
  • send() : RadialImpulseEvent , TCPObject
  • setActionThread() : Player
  • setActive() : GuiControl , ParticleEmitterNode
  • setAimLocation() : AIPlayer
  • setAimObject() : AIPlayer
  • setAlarmMode() : InteriorInstance
  • setAllHidden() : PxMultiActor
  • setAllMeshesHidden() : ShapeBase
  • setAlpha() : GuiMLTextCtrl
  • setAngularDrag() : Camera
  • setAngularForce() : Camera
  • setAngularVelocity() : Camera
  • setArea() : MissionArea
  • setArmThread() : Player
  • setAttribute() : SimXMLDocument
  • setBatchSize() : River
  • setBitmap() : GuiBitmapCtrl , GuiBitmapButtonCtrl , GuiIconButtonCtrl , GuiChunkedBitmapCtrl , GuiProgressBitmapCtrl
  • setBlackOut() : GameConnection
  • setBounds() : TSShapeConstructor
  • setBrakeMultiplier() : Camera
  • setBroken() : PxMultiActor
  • setCameraFov() : ShapeBase
  • setCameraObject() : GameConnection
  • setCameraSpeed() : GuiObjectView
  • setCanSave() : SimObject
  • setCapability() : GFXCardProfilerAPI
  • setCenter() : GuiControl
  • setCheckmarkBitmapIndex() : GuiMenuBar
  • setClassNamespace() : SimObject
  • setCloaked() : ShapeBase
  • setCollapsed() : GuiPaneControl
  • setCollapseGroup() : GuiWindowCtrl
  • setCollisionTimeout() : Item
  • setColor() : GuiSwatchButtonCtrl
  • setColumnOffset() : GuiFrameSetCtrl
  • setCone() : SFXSource
  • setConnectArgs() : GameConnection
  • setContent() : GuiCanvas
  • setControl() : GameBase
  • setControlCameraFov() : GameConnection
  • setControlObject() : GameConnection , Player
  • setCurrent() : ArrayObject
  • setCurrentLanguage() : LangTable
  • setCurrentSlot() : SFXController
  • setCurSel() : GuiListBoxCtrl
  • setCurSelRange() : GuiListBoxCtrl
  • setCursor() : GuiCanvas
  • setCursorPos() : GuiTextEditCtrl , GuiCanvas
  • setCursorPosition() : GuiMLTextCtrl
  • setDamageFlash() : ShapeBase
  • setDamageLevel() : ShapeBase
  • setDamageState() : ShapeBase
  • setDamageVector() : ShapeBase
  • setDataBlock() : GameBase
  • setDayLength() : TimeOfDay
  • setDebug() : GuiTreeViewCtrl
  • setDefaultLanguage() : LangTable
  • setDetailLevel() : InteriorInstance
  • setDetailLevelSize() : TSShapeConstructor
  • setDrag() : Camera
  • setEditOrbitMode() : Camera
  • setEditOrbitPoint() : Camera
  • setEditorOnly() : SimObject
  • setEmitterDataBlock() : ParticleEmitterNode
  • setEnergyLevel() : ShapeBase
  • setEnumContent() : GuiPopUpMenuCtrl
  • setExtent() : GuiControl
  • setFadeTimes() : SFXSource
  • setFieldType() : SimObject
  • setFieldValue() : SimObject
  • setFile() : GuiTheoraCtrl
  • setFilename() : SimObject
  • setFilter() : GuiDirectoryFileListCtrl
  • setFilterText() : GuiTreeViewCtrl
  • setFirstPerson() : GameConnection
  • setFirstResponder() : GuiControl
  • setFirstSelected() : GuiPopUpMenuCtrl
  • setFlyForce() : Camera
  • setFlyMode() : Camera
  • setFocus() : GuiCanvas
  • setFreeLook() : AIConnection
  • setGraphType() : GuiGraphCtrl
  • setHidden() : SimObject , ShapeBase
  • setImageAltTrigger() : ShapeBase
  • setImageAmmo() : ShapeBase
  • setImageLoaded() : ShapeBase
  • setImageTrigger() : ShapeBase
  • setInternalName() : SimObject
  • setInvincibleMode() : ShapeBase
  • setIsExpanded() : SimObject
  • setIsSelected() : SimObject
  • setItemColor() : GuiListBoxCtrl
  • setItemImages() : GuiTreeViewCtrl
  • setItemText() : GuiListBoxCtrl
  • setItemTooltip() : GuiListBoxCtrl , GuiTreeViewCtrl
  • setJoinPassword() : GameConnection
  • setKey() : ArrayObject
  • setLagIcon() : GameConnection
  • setLastTTL() : DebugDrawer
  • setLastZTest() : DebugDrawer
  • setLightAmbient() : GuiObjectView
  • setLightColor() : GuiObjectView
  • setLightDirection() : GuiObjectView
  • setLightEnabled() : LightBase
  • setLocked() : SimObject
  • setMass() : Camera
  • setMaxDivisionSize() : River
  • setMenuBitmapIndex() : GuiMenuBar
  • setMenuItemBitmap() : GuiMenuBar
  • setMenuItemChecked() : GuiMenuBar
  • setMenuItemEnable() : GuiMenuBar
  • setMenuItemSubmenuState() : GuiMenuBar
  • setMenuItemText() : GuiMenuBar
  • setMenuItemVisible() : GuiMenuBar
  • setMenuMargins() : GuiMenuBar
  • setMenuText() : GuiMenuBar
  • setMenuVisible() : GuiMenuBar
  • setMeshHidden() : ShapeBase , PxMultiActor
  • setMeshMaterial() : TSShapeConstructor
  • setMeshSize() : TSShapeConstructor
  • setMeshType() : TSShapeConstructor
  • setMessage() : SimpleNetObject
  • setMetersPerSegment() : River
  • setMissionCRC() : GameConnection
  • setModel() : GuiObjectView
  • setMount() : GuiObjectView
  • setMountedModel() : GuiObjectView
  • setMountSkin() : GuiObjectView
  • setMove() : AIConnection
  • setMoveDestination() : AIPlayer
  • setMoveSpeed() : AIPlayer
  • setMultipleSelection() : GuiListBoxCtrl
  • setName() : SimObject
  • setNameChangeAllowed() : SimObject
  • setNewtonFlyMode() : Camera
  • setNodeDepth() : MeshRoad , River
  • setNodeParent() : TSShapeConstructor
  • setNodeTransform() : TSShapeConstructor
  • setNoneSelected() : GuiPopUpMenuCtrlEx
  • setObjectAttributes() : SimXMLDocument
  • setObjectNode() : TSShapeConstructor
  • setOffset() : Camera
  • setOptions() : GuiGameListOptionsCtrl
  • setOrbitDistance() : GuiObjectView
  • setOrbitMode() : Camera
  • setOrbitObject() : Camera
  • setOrbitPoint() : Camera
  • setPath() : GuiDirectoryFileListCtrl
  • setPercentage() : Precipitation
  • setPitch() : SFXSource
  • setPlay() : TimeOfDay
  • setPosition() : GuiControl , StreamObject , SFXSound , PathCamera
  • setPositionGlobal() : GuiControl
  • setProcessTicks() : GuiTickCtrl
  • setProfile() : GuiControl
  • setRechargeRate() : ShapeBase
  • setRepairRate() : ShapeBase
  • setRotation() : Camera
  • setRowActive() : GuiTextListCtrl
  • setRowById() : GuiTextListCtrl
  • setRowEnabled() : GuiGameListMenuCtrl
  • setRowLabel() : GuiGameListMenuCtrl
  • setRowOffset() : GuiFrameSetCtrl
  • setScale() : SceneObject
  • setScopeAlways() : NetObject
  • setScrollPosition() : GuiScrollCtrl
  • setSelected() : GuiPopUpMenuCtrlEx , GuiListBoxCtrl , GuiGameListMenuCtrl , GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • setSelectedById() : GuiTextListCtrl
  • setSelectedRow() : GuiTextListCtrl
  • setSeq() : GuiObjectView
  • setSequenceBlend() : TSShapeConstructor
  • setSequenceCyclic() : TSShapeConstructor
  • setSequenceGroundSpeed() : TSShapeConstructor
  • setSequencePriority() : TSShapeConstructor
  • setShaderConst() : PostEffect
  • setShaderConsts() : PostEffect
  • setShaderMacro() : PostEffect
  • setShapeName() : ShapeBase
  • setSimulatedNetParams() : NetConnection
  • setSkin() : GuiObjectView
  • setSkinName() : ShapeBase
  • setSpeedMultiplier() : Camera
  • setState() : PathCamera
  • setStateOn() : GuiButtonBaseCtrl , GuiCheckBoxCtrl
  • setSubmenuItemChecked() : GuiMenuBar
  • setSuperClassNamespace() : SimObject
  • setTarget() : PathCamera
  • setText() : GuiMLTextCtrl , GuiPopUpMenuCtrlEx , GuiTextCtrl , GuiButtonBaseCtrl , GuiTextEditCtrl
  • setTextID() : GuiButtonBaseCtrl , GuiTextCtrl
  • setThreadDir() : ShapeBase
  • setThreadTimeScale() : ShapeBase
  • setTime() : GuiClockHud
  • setTimeOfDay() : TimeOfDay
  • setTrackObject() : Camera
  • setTransform() : SceneObject , SFXSource
  • setTrigger() : AIConnection
  • setTurbulence() : Precipitation
  • setValidEditOrbitPoint() : Camera
  • setValue() : GuiControl , ArrayObject , GuiBitmapCtrl , GuiSliderCtrl
  • setVelocity() : Camera , ShapeBase
  • setVideoMode() : GuiCanvas
  • setVisible() : GuiControl
  • setVolume() : SFXSource
  • setWheelPowered() : WheeledVehicle
  • setWheelSpring() : WheeledVehicle
  • setWheelSteering() : WheeledVehicle
  • setWheelTire() : WheeledVehicle
  • setWhiteOut() : ShapeBase
  • setWindowPosition() : GuiCanvas
  • setWindowTitle() : GuiCanvas
  • show() : PfxVis
  • showCursor() : GuiCanvas
  • showItemRenameCtrl() : GuiTreeViewCtrl
  • sizeToContents() : GuiRolloutCtrl
  • sort() : GuiPopUpMenuCtrlEx , SimSet , ArrayObject , GuiTextListCtrl , GuiTreeViewCtrl
  • sorta() : ArrayObject
  • sortd() : ArrayObject
  • sortf() : ArrayObject
  • sortfd() : ArrayObject
  • sortfk() : ArrayObject
  • sortfkd() : ArrayObject
  • sortID() : GuiPopUpMenuCtrlEx
  • sortk() : ArrayObject
  • sortka() : ArrayObject
  • sortkd() : ArrayObject
  • sortn() : ArrayObject
  • sortna() : ArrayObject
  • sortnd() : ArrayObject
  • sortnk() : ArrayObject
  • sortnka() : ArrayObject
  • sortnkd() : ArrayObject
  • sortNumerical() : GuiTextListCtrl
  • spawnObject() : SpawnSphere
  • startDragging() : GuiDragAndDropControl
  • startFade() : ShapeBase
  • startRecording() : GameConnection
  • stop() : SFXEmitter , AIPlayer , GuiTheoraCtrl , SFXSource
  • stopAudio() : ShapeBase
  • stopRecording() : GameConnection
  • stopThread() : ShapeBase
  • strikeObject() : Lightning
  • strikeRandomPoint() : Lightning
  • subscribe() : EventManager


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- t -

  • toggle() : RenderPassStateToken , PostEffect
  • toggleCollapse() : GuiRolloutCtrl
  • toggleCollapseGroup() : GuiWindowCtrl
  • toggleDrawing() : DebugDrawer
  • toggleExpanded() : GuiRolloutCtrl
  • toggleFreeze() : DebugDrawer
  • toggleFullscreen() : GuiCanvas
  • toggleHideSelection() : GuiTreeViewCtrl
  • toggleLockSelection() : GuiTreeViewCtrl
  • transmitDataBlocks() : GameConnection
  • transmitPaths() : NetConnection


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- u -

  • unbind() : ActionMap
  • unbindObj() : ActionMap
  • uniqueKey() : ArrayObject
  • uniqueValue() : ArrayObject
  • unmount() : SceneObject
  • unmountImage() : ShapeBase
  • unmountObject() : SceneObject
  • unproject() : GuiTSCtrl
  • unregisterEvent() : EventManager
  • updateFaces() : CubemapData
  • updateSizes() : GuiFrameSetCtrl
  • updateStack() : GuiStackControl
  • useCreateHeight() : FlyingVehicle


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- v -

  • validateCameraFov() : ShapeBase


Torque 3D - Script Manual: Class Members - Functions

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- w -

  • warningFlashes() : Lightning
  • writeChangeSet() : TSShapeConstructor
  • writeLine() : StreamObject , FileObject
  • writeLongString() : StreamObject
  • writeObject() : FileObject
  • writeString() : StreamObject


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- a -

  • aaLevel : RenderFormatToken
  • acceleration : SplashData
  • accelerator : GuiControl
  • accuFire : ShapeBaseImageData
  • active : GuiControl , ParticleEmitterNode
  • addChildSelectionByValue : GuiTreeViewCtrl
  • addressModeU : GFXSamplerStateData
  • addressModeV : GFXSamplerStateData
  • addressModeW : GFXSamplerStateData
  • adjustCenter : TSShapeConstructor
  • adjustFloor : TSShapeConstructor
  • advancedLightmapSupport : LevelInfo
  • airAbsorptionHF : SFXEnvironment
  • airControl : PlayerData
  • alignDirection : ParticleEmitterData
  • alignParticles : ParticleEmitterData
  • AlignToTerrain : fxShapeReplicator
  • allowColorChars : GuiMLTextCtrl
  • allowedMatches : GuiMessageVectorCtrl
  • AllowedTerrainSlope : fxFoliageReplicator , fxShapeReplicator
  • allowMultipleSelections : GuiListBoxCtrl
  • AllowOnInteriors : fxFoliageReplicator , fxShapeReplicator
  • AllowOnStatics : fxFoliageReplicator , fxShapeReplicator
  • AllowOnTerrain : fxFoliageReplicator , fxShapeReplicator
  • AllowOnWater : fxFoliageReplicator , fxShapeReplicator
  • allowPlayerStep : fxShapeReplicatedStatic , TSStatic
  • allowReflectPass : PostEffect
  • allowReorder : GuiTabBookCtrl
  • AllowWaterSurface : fxFoliageReplicator , fxShapeReplicator
  • alphaArg1 : GFXSamplerStateData
  • alphaArg2 : GFXSamplerStateData
  • alphaArg3 : GFXSamplerStateData
  • AlphaCutoff : fxFoliageReplicator
  • alphaDefined : GFXStateBlockData
  • alphaOp : GFXSamplerStateData
  • alphaRef : Material
  • alphaTest : Material
  • alphaTestEnable : GFXStateBlockData
  • alphaTestFunc : GFXStateBlockData
  • alphaTestRef : GFXStateBlockData
  • altCommand : GuiControl
  • alwaysHandleMouseButtons : GuiCanvas
  • alwaysImport : TSShapeConstructor
  • alwaysImportMesh : TSShapeConstructor
  • ambient : Sun
  • ambientFactor : ParticleEmitterData
  • ambientLightBlendCurve : LevelInfo
  • ambientLightBlendPhase : LevelInfo
  • ambientLightColor : Zone
  • ambientScale : ScatterSky
  • anchorBottom : GuiContainer
  • anchorLeft : GuiContainer
  • anchorRight : GuiContainer
  • anchorTop : GuiContainer
  • angularDamping : PhysicsDebrisData , PhysicsShapeData
  • angularDrag : Camera , PxMultiActorData
  • angularForce : Camera
  • angularSleepThreshold : PhysicsShapeData , PhysicsDebrisData
  • animate : LightBase , Sun
  • animateSplashes : Precipitation
  • animateTexture : ParticleData
  • animationPeriod : LightBase , LightDescription
  • animationPhase : LightDescription , LightBase
  • animationType : LightBase , LightDescription
  • animFlags : Material
  • animSequence : GuiObjectView
  • animTexFrames : ParticleData
  • animTexName : ParticleData
  • animTexTiling : ParticleData
  • antiSwayForce : WheeledVehicleSpring
  • appliedForce : PhysicalZone
  • apply : Sun
  • area : MissionArea
  • armingDelay : ProjectileData
  • attachments : PxCloth
  • attenuationRatio : LightBase , ScatterSky , Sun , LightDescription
  • autoAngularForce : FlyingVehicleData
  • autoBalance : GuiFrameSetCtrl
  • autoCellSize : GuiDynamicCtrlArrayControl
  • autoCollapseSiblings : GuiRolloutCtrl
  • autoFitExtents : GuiBitmapButtonCtrl
  • autoInputDamping : FlyingVehicleData
  • autoLinearForce : FlyingVehicleData
  • autoSize : GuiIconButtonCtrl
  • autoSizeHeight : GuiControlProfile
  • autoSizeWidth : GuiControlProfile
  • autoSpawn : SpawnSphere
  • axisTilt : TimeOfDay
  • azimuth : ScatterSky , Sun
  • azimuthOverride : TimeOfDay


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- j -

  • jetEnergyDrain : VehicleData
  • jetForce : VehicleData
  • jetJumpEnergyDrain : PlayerData
  • jetJumpForce : PlayerData
  • jetJumpSurfaceAngle : PlayerData
  • jetMaxJumpSpeed : PlayerData
  • jetMinJumpEnergy : PlayerData
  • jetMinJumpSpeed : PlayerData
  • jetSound : WheeledVehicleData , FlyingVehicleData , HoverVehicleData
  • jumpDelay : PlayerData
  • jumpEnergyDrain : PlayerData
  • jumpForce : PlayerData
  • jumpSurfaceAngle : PlayerData
  • jumpTowardsNormal : PlayerData
  • justify : GuiControlProfile


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- k -

  • key : ArrayObject
  • kineticFriction : WheeledVehicleTire


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- l -

  • langTableMod : GuiControl
  • lastSplitTerrainOnly : LightBase , ScatterSky , Sun , LightDescription
  • lateralDamping : WheeledVehicleTire
  • lateralForce : WheeledVehicleTire
  • lateralRelaxation : WheeledVehicleTire
  • layer : GroundCover
  • layerEnabled : BasicClouds
  • leaveCommand : Trigger
  • leftMargin : GuiSeparatorCtrl
  • length : GuiSpeedometerHud , WheeledVehicleSpring
  • level : ConsoleLogger
  • LFReference : SFXEnvironment
  • lifeSpan : DecalData
  • lifetime : DebrisData , Debris , ProjectileData , PhysicsDebrisData
  • lifetimeMS : ExplosionData , SplashData , ParticleData , ParticleEmitterData
  • lifetimeVariance : DebrisData , ExplosionData , SplashData , PhysicsDebrisData
  • lifetimeVarianceMS : ParticleData , ParticleEmitterData
  • lightAmbient : GuiObjectView
  • lightBrightness : ShapeBaseImageData
  • lightColor : ItemData , GuiObjectView , ShapeBaseImageData
  • lightDesc : ProjectileData
  • lightDirection : GuiObjectView
  • lightDuration : ShapeBaseImageData
  • lightEndBrightness : ExplosionData
  • lightEndColor : ExplosionData
  • lightEndRadius : ExplosionData
  • lightMap : Material
  • lightMapSize : TerrainBlock
  • lightNormalOffset : ExplosionData
  • LightOn : fxFoliageReplicator
  • lightOnlyStatic : ItemData
  • lightRadius : ItemData , ShapeBaseImageData
  • lightStartBrightness : ExplosionData
  • lightStartColor : ExplosionData
  • lightStartRadius : ExplosionData
  • LightSync : fxFoliageReplicator
  • LightTime : ItemData , fxFoliageReplicator
  • lightType : ShapeBaseImageData , ItemData
  • linearDamping : PhysicsDebrisData , PhysicsShapeData
  • linearDrag : PxMultiActorData
  • linearSleepThreshold : PhysicsShapeData , PhysicsDebrisData
  • lineContinuedIndex : GuiMessageVectorCtrl
  • lineSpacing : GuiMLTextCtrl , GuiMessageVectorCtrl
  • liquidType : WaterObject
  • locked : SimObject
  • lockFrustum : GroundCover
  • lockHorizScroll : GuiScrollCtrl
  • lockMouse : GuiMouseEventCtrl
  • lockVertScroll : GuiScrollCtrl
  • lodReflectScalar : Forest
  • lodType : TSShapeConstructor
  • logWeight : LightBase , LightDescription , Sun , ScatterSky
  • longitudinalDamping : WheeledVehicleTire
  • longitudinalForce : WheeledVehicleTire
  • longitudinalRelaxation : WheeledVehicleTire
  • loopMode : SFXPlayList
  • LowLODDistance : River


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- m -

  • magFilter : GFXSamplerStateData
  • mainThrustForce : HoverVehicleData
  • makeIconSquare : GuiIconButtonCtrl
  • makeNameCallback : GuiListBoxCtrl
  • maneuveringForce : FlyingVehicleData
  • mapTo : Material
  • margin : GuiRolloutCtrl , GuiContainer
  • markerName : WayPoint
  • mass : PhysicsDebrisData , ShapeBaseData , PhysicsShapeData , WheeledVehicleTire , ForestItemData , Camera , ShapeBaseImageData
  • massBox : RigidShapeData , VehicleData
  • massCenter : RigidShapeData , VehicleData
  • matchColor : GuiMessageVectorCtrl
  • matchVideoSize : GuiTheoraCtrl
  • Material : ConvexShape , GroundCover , PxCloth , GroundPlane , DecalData , RenderMeshExample , PxMultiActorData , DecalRoad , SkyBox
  • matNamePrefix : TSShapeConstructor
  • maxAngle : GuiSpeedometerHud
  • maxAnisotropy : GFXSamplerStateData
  • maxAutoSpeed : FlyingVehicleData
  • maxBackwardSpeed : PlayerData
  • maxBillboardTiltAngle : GroundCover
  • maxChars : GuiMLTextCtrl
  • maxClumpCount : GroundCover
  • maxColorIndex : GuiMessageVectorCtrl
  • maxConcurrentSounds : ShapeBaseImageData
  • maxCrouchBackwardSpeed : PlayerData
  • maxCrouchForwardSpeed : PlayerData
  • maxCrouchSideSpeed : PlayerData
  • maxDamage : ShapeBaseData
  • maxDistance : SFXDescription , SFXPlayList , SFXEmitter
  • maxDistanceVariance : SFXPlayList
  • maxDrag : RigidShapeData , VehicleData
  • maxElements : GroundCover
  • maxElevation : GroundCover
  • maxEnergy : ShapeBaseData
  • maxForwardSpeed : PlayerData
  • maxFreelookAngle : PlayerData
  • MaxHeight : fxFoliageReplicator
  • maxJumpSpeed : PlayerData
  • maxLength : GuiTextCtrl
  • maxLookAngle : PlayerData
  • MaxLuminance : fxFoliageReplicator
  • maxMass : Precipitation
  • maxOrbitDiststance : GuiObjectView
  • maxPopupHeight : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • maxPredictionTicks : Player
  • maxProneBackwardSpeed : PlayerData
  • maxProneForwardSpeed : PlayerData
  • maxProneSideSpeed : PlayerData
  • maxRateMs : ReflectorDesc
  • maxSideSpeed : PlayerData
  • maxSlope : GroundCover
  • maxSpeed : GuiSpeedometerHud , Precipitation
  • maxSpinSpeed : DebrisData
  • maxSteeringAngle : VehicleData
  • maxStepHeight : PlayerData
  • MaxSwayTime : fxFoliageReplicator
  • maxTimeScale : PlayerData
  • maxTurbulence : Precipitation
  • maxUnderwaterBackwardSpeed : PlayerData
  • maxUnderwaterForwardSpeed : PlayerData
  • maxUnderwaterSideSpeed : PlayerData
  • maxVelocity : ItemData
  • maxWarpTicks : Player , Item
  • maxWheelSpeed : WheeledVehicleData
  • MaxWidth : fxFoliageReplicator
  • mediaPath : SFXFMODProject
  • mediumSplashSoundVelocity : RigidShapeData , VehicleData , PlayerData
  • meshCulling : fxShapeReplicatedStatic , TSStatic
  • mieScattering : ScatterSky
  • minAngle : GuiSpeedometerHud
  • minClumpCount : GroundCover
  • minDrag : RigidShapeData , VehicleData
  • minElevation : GroundCover
  • minEnergy : ShapeBaseImageData
  • minExtent : GuiControl
  • minFilter : GFXSamplerStateData
  • MinHeight : fxFoliageReplicator
  • minImpactSpeed : PlayerData , RigidShapeData , VehicleData
  • minJetEnergy : VehicleData
  • minJumpEnergy : PlayerData
  • minJumpSpeed : PlayerData
  • minLookAngle : PlayerData
  • MinLuminance : fxFoliageReplicator
  • minMass : Precipitation
  • minnaertConstant : Material
  • minOrbitDiststance : GuiObjectView
  • minRollSpeed : RigidShapeData , VehicleData
  • minRunEnergy : PlayerData
  • minSpeed : Precipitation
  • minSpinSpeed : DebrisData
  • MinSwayTime : fxFoliageReplicator
  • minTabWidth : GuiTabBookCtrl
  • minTrailSpeed : FlyingVehicleData
  • minWarpTicks : Player , Item
  • MinWidth : fxFoliageReplicator
  • mipFilter : GFXSamplerStateData
  • mipLODBias : GFXSamplerStateData
  • mirrorSet : GuiListBoxCtrl
  • missionCycleCleanup : AIClient
  • mMoveTolerance : AIPlayer
  • modal : GuiControl , GuiControlProfile
  • modulationDepth : SFXEnvironment
  • modulationTime : SFXEnvironment
  • moonAzimuth : ScatterSky
  • moonElevation : ScatterSky
  • moonEnabled : ScatterSky
  • moonLightColor : ScatterSky
  • moonMat : ScatterSky
  • moonScale : ScatterSky
  • mountedNode : GuiObjectView
  • mountedShapeFile : GuiObjectView
  • mountedSkin : GuiObjectView
  • mountNode : SceneObject
  • mountNode0 : PxMultiActorData
  • mountNode1 : PxMultiActorData
  • mountNode10 : PxMultiActorData
  • mountNode11 : PxMultiActorData
  • mountNode12 : PxMultiActorData
  • mountNode13 : PxMultiActorData
  • mountNode14 : PxMultiActorData
  • mountNode15 : PxMultiActorData
  • mountNode16 : PxMultiActorData
  • mountNode17 : PxMultiActorData
  • mountNode18 : PxMultiActorData
  • mountNode19 : PxMultiActorData
  • mountNode2 : PxMultiActorData
  • mountNode20 : PxMultiActorData
  • mountNode21 : PxMultiActorData
  • mountNode22 : PxMultiActorData
  • mountNode23 : PxMultiActorData
  • mountNode24 : PxMultiActorData
  • mountNode25 : PxMultiActorData
  • mountNode26 : PxMultiActorData
  • mountNode27 : PxMultiActorData
  • mountNode28 : PxMultiActorData
  • mountNode29 : PxMultiActorData
  • mountNode3 : PxMultiActorData
  • mountNode30 : PxMultiActorData
  • mountNode31 : PxMultiActorData
  • mountNode4 : PxMultiActorData
  • mountNode5 : PxMultiActorData
  • mountNode6 : PxMultiActorData
  • mountNode7 : PxMultiActorData
  • mountNode8 : PxMultiActorData
  • mountNode9 : PxMultiActorData
  • mountPID : SceneObject
  • mountPoint : ShapeBaseImageData
  • mountPos : SceneObject
  • mountRot : SceneObject
  • mouseDragging : GuiTreeViewCtrl
  • mouseOverSelected : GuiControlProfile
  • mouseWheelScrollSpeed : GuiScrollCtrl
  • move : AIClient
  • moveForward : AIClient
  • movementSpeed : Camera
  • moveStuckTestDelay : AIPlayer
  • moveStuckTolerance : AIPlayer
  • movingBubblesSound : PlayerData
  • msToNext : Marker
  • MultipleFiles : OpenFileDialog
  • multipleSelections : GuiTreeViewCtrl
  • MustExist : OpenFileDialog
  • muzzleVelocity : ProjectileData


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- n -

  • name : SimObject
  • nearClip : LevelInfo
  • nearDist : ReflectorDesc
  • neverImport : TSShapeConstructor
  • neverImportMesh : TSShapeConstructor
  • newtonMode : Camera
  • newtonRotation : Camera
  • nightColor : ScatterSky
  • nightCubemap : ScatterSky
  • nightFogColor : ScatterSky
  • nightScale : TimeOfDay
  • noBillboards : GroundCover
  • noCorrection : PxMultiActorData
  • noCorrections : PhysicsShape
  • Node : MeshRoad , River , DecalRoad
  • noIndividualDamage : StaticShapeData
  • normalForce : HoverVehicleData
  • normalMap : Material , TerrainMaterial
  • noShapes : GroundCover
  • noSmoothing : PhysicsShape
  • numbersOnly : GuiControlProfile
  • numBounces : DebrisData
  • numDmgEmitterAreas : VehicleData
  • numDrops : Precipitation
  • numFences : GuiCanvas
  • numSegments : SplashData
  • numSlotsToPlay : SFXPlayList
  • numSplits : LightDescription , LightBase , Sun , ScatterSky


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- o -

  • objectTypeMask : ReflectorDesc
  • observeThroughObject : ShapeBaseData
  • occlusionRadius : LightFlareData
  • offset : ExplosionData , ShapeBaseImageData
  • offsetA : LightAnimData
  • offsetKeys : LightAnimData
  • offsetPeriod : LightAnimData
  • offsetSmooth : LightAnimData
  • OffsetZ : LightAnimData , fxFoliageReplicator , fxShapeReplicator
  • OGLPixelShaderFile : ShaderData
  • OGLVertexShaderFile : ShaderData
  • onChildAdded : GuiScriptNotifyCtrl
  • onChildRemoved : GuiScriptNotifyCtrl
  • onChildResized : GuiScriptNotifyCtrl
  • oneFrameOnly : PostEffect
  • onGainFirstResponder : GuiScriptNotifyCtrl
  • onLoseFirstResponder : GuiScriptNotifyCtrl
  • onParentResized : GuiScriptNotifyCtrl
  • onRenameValidate : GuiTreeViewCtrl
  • onResize : GuiScriptNotifyCtrl
  • onThisFrame : PostEffect
  • opaque : GuiControlProfile
  • orbitDiststance : GuiObjectView
  • orientation : GuiSplitContainer
  • orientOnVelocity : ParticleEmitterData
  • orientParticles : ParticleEmitterData
  • originSort : TSStatic , fxShapeReplicatedStatic
  • outdoorWeight : SpawnSphere
  • outerAngle : SpotLight
  • OuterRadiusX : fxFoliageReplicator , fxShapeReplicator
  • OuterRadiusY : fxFoliageReplicator , fxShapeReplicator
  • overallFoamOpacity : WaterObject
  • overallRippleMagnitude : WaterObject
  • overallScale : LightFlareData
  • overallWaveMagnitude : WaterObject
  • overDarkFactor : LightDescription , Sun , LightBase , ScatterSky
  • overlayMap : Material
  • overlayTex : Material
  • overrideAdvance : ParticleEmitterData
  • OverwritePrompt : SaveFileDialog


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- z -

  • zBias : GFXStateBlockData
  • zDefined : GFXStateBlockData
  • zEnable : GFXStateBlockData
  • zFunc : GFXStateBlockData
  • zOffset : GroundCover
  • zoneGroup : InteriorInstance , Zone
  • zSlopeBias : GFXStateBlockData
  • zWriteEnable : GFXStateBlockData


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- b -

  • backgroundColor : GuiTheoraCtrl
  • backSidePassable : Portal
  • backwardJetEmitter : FlyingVehicleData
  • barBehindText : GuiPaneControl
  • baseColor : CloudLayer , WaterObject
  • baseRadius : DebrisData
  • baseShape : TSShapeConstructor
  • baseTex : Material
  • baseTexSize : TerrainBlock
  • bending : PxCloth
  • bendingStiffness : PxCloth
  • bevelColorHL : GuiControlProfile
  • bevelColorLL : GuiControlProfile
  • billboardUVs : GroundCover
  • binType : RenderBinManager
  • bitmap : GuiBitmapCtrl , GuiBitmapButtonCtrl , GuiControlProfile , GuiTextEditSliderBitmapCtrl , GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx , GuiChunkedBitmapCtrl , GuiProgressBitmapCtrl
  • bitmapBounds : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • bitmapMode : GuiBitmapButtonCtrl
  • bitmapName : GuiCursor
  • blendDefined : GFXStateBlockData
  • blendDest : GFXStateBlockData
  • blendEnable : GFXStateBlockData
  • blendOp : GFXStateBlockData
  • blendSrc : GFXStateBlockData
  • blendStyle : ParticleEmitterData
  • bodyFriction : RigidShapeData , VehicleData
  • bodyRestitution : RigidShapeData , VehicleData
  • boltStartRadius : Lightning
  • border : GuiControlProfile
  • borderColor : GuiControlProfile , GuiFrameSetCtrl
  • borderColorHL : GuiControlProfile
  • borderColorNA : GuiControlProfile
  • borderEnable : GuiFrameSetCtrl
  • borderMargin : GuiSeparatorCtrl
  • borderMovable : GuiFrameSetCtrl
  • borderThickness : GuiControlProfile
  • borderWidth : GuiFrameSetCtrl
  • bottomMaterial : MeshRoad
  • bounceElasticity : ProjectileData
  • bounceFriction : ProjectileData
  • bounceVariance : DebrisData
  • boundingBox : PlayerData , GameBase
  • boxHeadBackPercentage : PlayerData
  • boxHeadFrontPercentage : PlayerData
  • boxHeadLeftPercentage : PlayerData
  • boxHeadPercentage : PlayerData
  • boxHeadRightPercentage : PlayerData
  • boxHeight : Precipitation
  • boxTorsoPercentage : PlayerData
  • boxWidth : Precipitation
  • brakeMultiplier : Camera
  • brakeTorque : WheeledVehicleData
  • brakingActivationSpeed : HoverVehicleData
  • brakingForce : HoverVehicleData
  • branchAmp : ForestItemData
  • breakAngle : MeshRoad , DecalRoad
  • breakForce : PxMultiActorData
  • brightness : LightBase , Sun , LightDescription , ScatterSky
  • brightnessA : LightAnimData
  • brightnessKeys : LightAnimData
  • brightnessPeriod : LightAnimData
  • brightnessSmooth : LightAnimData
  • brightnessZ : LightAnimData
  • broken : PxMultiActor
  • bubbleEmitTime : PlayerData
  • buildVisibleTree : GuiTreeViewCtrl
  • bumpAtlas : Material
  • bumpTex : Material
  • buoyancyDensity : PhysicsDebrisData , PhysicsShapeData , PxMultiActorData
  • buttonMargin : GuiIconButtonCtrl
  • buttonType : GuiButtonBaseCtrl


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- c -

  • callbackOnA : GuiGameListMenuCtrl
  • callbackOnB : GuiGameListMenuCtrl
  • callbackOnX : GuiGameListMenuCtrl
  • callbackOnY : GuiGameListMenuCtrl
  • cameraDecay : RigidShapeData , VehicleData
  • cameraDefaultFov : ShapeBaseData
  • cameraLag : RigidShapeData , VehicleData
  • cameraMaxDist : ShapeBaseData
  • cameraMaxFov : ShapeBaseData
  • cameraMinDist : ShapeBaseData
  • cameraMinFov : ShapeBaseData
  • cameraOffset : RigidShapeData , VehicleData
  • cameraRoll : RigidShapeData , VehicleData
  • cameraSpeed : GuiObjectView
  • cameraZRot : GuiTSCtrl
  • camShakeAmp : ExplosionData , ShapeBaseImageData
  • camShakeDuration : ExplosionData
  • camShakeFalloff : ExplosionData
  • camShakeFreq : ExplosionData , ShapeBaseImageData
  • camShakeRadius : ExplosionData
  • cancelRename : GuiTreeViewCtrl
  • canClose : GuiWindowCtrl
  • canCollapse : GuiWindowCtrl
  • canKeyFocus : GuiControlProfile
  • canMaximize : GuiWindowCtrl
  • canMinimize : GuiWindowCtrl
  • canMove : GuiWindowCtrl
  • canRenameObjects : GuiTreeViewCtrl
  • canSave : SimObject
  • canSaveDynamicFields : SimObject
  • canvasClearColor : LevelInfo
  • caption : GuiSeparatorCtrl , GuiRolloutCtrl , GuiPaneControl
  • captionID : GuiPaneControl
  • caseSensitive : ArrayObject
  • casing : ShapeBaseImageData
  • castShadows : LightBase , Material , LightDescription , PhysicsDebrisData , ScatterSky , Sun , TerrainBlock
  • category : GameBaseData , GuiControlProfile
  • cellIndex : Material
  • cellLayout : Material
  • cellSize : Material
  • center : GuiSpeedometerHud
  • centerY : GuiGraphCtrl
  • chanceToHitTarget : Lightning
  • changeChildPosition : GuiStackControl
  • changeChildSizeToFit : GuiStackControl
  • changePath : FileDialog
  • channel : SFXParameter
  • childBorder : GuiAutoScrollCtrl
  • childMargin : GuiScrollCtrl
  • clarity : WaterObject
  • class : SimObject
  • className : SimObject
  • clear : GuiPopUpMenuCtrl
  • clearAllOnSingleSelection : GuiTreeViewCtrl
  • clickCollapse : GuiRolloutCtrl
  • clientOnly : PxMultiActorData
  • clientSide : TriggerData
  • clipColumnText : GuiTextListCtrl
  • clippingAngle : DecalData
  • cloakable : ShapeBaseImageData
  • closeCommand : GuiWindowCtrl
  • clumpExponent : GroundCover
  • clumpRadius : GroundCover
  • colCount : GuiControlArrayControl , GuiDynamicCtrlArrayControl
  • collapsable : GuiPaneControl
  • collDamageMultiplier : VehicleData
  • collDamageThresholdVel : VehicleData
  • collidable : ForestItemData
  • collisionTol : RigidShapeData , VehicleData
  • collisionType : fxShapeReplicatedStatic , TSStatic
  • color : LightDescription , LightBase , GuiSpeedometerHud , Lightning , Sun , GuiSwatchButtonCtrl
  • colorA : LightAnimData
  • colorArg1 : GFXSamplerStateData
  • colorArg2 : GFXSamplerStateData
  • colorArg3 : GFXSamplerStateData
  • colorBullet : GuiListBoxCtrl
  • colorKeys : LightAnimData
  • colorMultiply : Material
  • colorPeriod : LightAnimData
  • colors : ParticleData , SplashData
  • colorSmooth : LightAnimData
  • colorWriteAlpha : GFXStateBlockData
  • colorWriteBlue : GFXStateBlockData
  • colorWriteDefined : GFXStateBlockData
  • colorWriteGreen : GFXStateBlockData
  • colorWriteRed : GFXStateBlockData
  • colorZ : LightAnimData
  • colSize : GuiDynamicCtrlArrayControl
  • colSizes : GuiControlArrayControl
  • colSpacing : GuiControlArrayControl , GuiDynamicCtrlArrayControl
  • columns : GuiTextListCtrl , GuiFrameSetCtrl
  • columnSplit : GuiGameListOptionsProfile
  • command : GuiControl
  • compareToObjectID : GuiTreeViewCtrl
  • computeCRC : ShapeBaseData , ShapeBaseImageData
  • coneInsideAngle : SFXDescription , SFXEmitter
  • coneOutsideAngle : SFXDescription , SFXEmitter
  • coneOutsideVolume : SFXEmitter , SFXDescription
  • constantAcceleration : ParticleData
  • constantThumbHeight : GuiScrollCtrl
  • contactTol : VehicleData , RigidShapeData
  • controlMode : Camera
  • cookie : ScatterSky , LightDescription , LightBase , Sun
  • copyEffect : RenderFormatToken
  • coronaEnabled : Sun
  • coronaMaterial : Sun
  • coronaScale : Sun
  • coronaTint : Sun
  • coronaUseLightColor : Sun
  • correctionNode0 : PxMultiActorData
  • correctionNode1 : PxMultiActorData
  • correctMuzzleVector : ShapeBaseImageData
  • coverage : CloudLayer
  • createHoverHeight : FlyingVehicleData
  • createNew : TerrainBlock
  • crouchBoundingBox : PlayerData
  • crouchForce : PlayerData
  • cubeFace : CubemapData
  • cubemap : WaterObject , Material
  • cubeReflectorDesc : ShapeBaseData
  • cullDefined : GFXStateBlockData
  • cullMode : GFXStateBlockData
  • CullResolution : fxFoliageReplicator
  • cursorColor : GuiControlProfile
  • customFootstepSound : Material
  • customImpactSound : Material


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- d -

  • damageEmitter : VehicleData
  • damageEmitterOffset : VehicleData
  • damageFillColor : GuiHealthBarHud , GuiCrossHairHud
  • damageFrameColor : GuiCrossHairHud
  • damageLevelTolerance : VehicleData
  • damageOffset : GuiCrossHairHud
  • damageRect : GuiCrossHairHud
  • damping : PxCloth , WheeledVehicleSpring
  • dampingCoefficient : PxCloth , ForestItemData
  • dataBlock : GameBase
  • dataFile : Forest
  • dayLength : TimeOfDay
  • dayScale : TimeOfDay
  • Debris : ShapeBaseData , ExplosionData , PhysicsShapeData
  • debrisNum : ExplosionData
  • debrisNumVariance : ExplosionData
  • debrisPhiMax : ExplosionData
  • debrisPhiMin : ExplosionData
  • debrisShapeName : ShapeBaseData
  • debrisThetaMax : ExplosionData
  • debrisThetaMin : ExplosionData
  • debrisVelocity : ExplosionData
  • debrisVelocityVariance : ExplosionData
  • DebugBoxHeight : fxFoliageReplicator
  • debugRender : GuiGameListMenuCtrl , TerrainBlock , RenderOcclusionMgr , PxMultiActor
  • decal : ProjectileData
  • decalBias : LevelInfo
  • DecalData : PlayerData
  • decalOffset : PlayerData
  • decalType : fxShapeReplicatedStatic , TSStatic
  • decayHFRatio : SFXEnvironment
  • decayLFRatio : SFXEnvironment
  • decayTime : SFXEnvironment
  • defaultFile : FileDialog
  • defaultHeight : GuiRolloutCtrl
  • defaultPage : GuiTabBookCtrl
  • defaultPath : FileDialog
  • defaultValue : SFXParameter
  • defines : ShaderData
  • delayMS : ExplosionData , SplashData
  • delayTimeIn : SFXPlayList
  • delayTimeInVariance : SFXPlayList
  • delayTimeOut : SFXPlayList
  • delayTimeOutVariance : SFXPlayList
  • delayVariance : ExplosionData , SplashData
  • deleteObjectAllowed : GuiTreeViewCtrl
  • deleteOnMouseUp : GuiDragAndDropControl
  • deniedSound : GuiTextEditCtrl , GuiMLTextCtrl
  • density : SFXEnvironment , ShapeBaseData , PxCloth , WaterObject
  • depthFormat : RenderFormatToken
  • depthGradientMax : WaterObject
  • depthGradientTex : WaterObject
  • description : SFXTrack , SFXSource , SFXParameter
  • destroyedLevel : ShapeBaseData
  • destroyedShape : PhysicsShapeData
  • destroyTreeOnSleep : GuiTreeViewCtrl
  • detailAdjust : ReflectorDesc
  • detailAmp : ForestItemData
  • detailDistance : TerrainMaterial
  • detailFreq : ForestItemData
  • detailMap : TerrainMaterial , Material
  • detailNormalMap : Material
  • detailNormalMapStrength : Material
  • detailScale : Material
  • detailSize : TerrainMaterial
  • detailStrength : TerrainMaterial
  • detailTex : Material
  • diffuseColor : Material
  • diffuseMap : TerrainMaterial , Material
  • diffuseSize : TerrainMaterial
  • diffusion : SFXEnvironment
  • disabledLevel : ShapeBaseData
  • disableImposters : Forest
  • disableMove : Vehicle
  • discardAll : DecalRoad
  • displayEnergy : GuiHealthBarHud
  • dissolveRadius : GroundCover
  • distanceFade : GuiShapeNameHud
  • distortEndDist : WaterObject
  • distortFullDepth : WaterObject
  • distortStartDist : WaterObject
  • docking : GuiContainer
  • doCollision : Precipitation
  • done : GuiFadeinBitmapCtrl
  • dopplerFactor : SFXAmbience
  • doubleSided : Material
  • downJetEmitter : FlyingVehicleData
  • drag : Camera , ShapeBaseData
  • dragCoefficient : ParticleData
  • dragForce : RigidShapeData , HoverVehicleData
  • dragToItemAllowed : GuiTreeViewCtrl
  • drawBottom : SkyBox
  • drawBounds : Forest
  • drawCells : Forest
  • dropAnimateMS : Precipitation
  • dropShader : PrecipitationData
  • dropSize : Precipitation
  • dropsPerSide : PrecipitationData
  • dropTexture : PrecipitationData
  • dumpInstances : Material
  • dumpModel : PxMultiActorData
  • dustEmitter : RigidShapeData , PlayerData , VehicleData
  • dustHeight : VehicleData , RigidShapeData
  • dustTrailEmitter : RigidShapeData , HoverVehicleData
  • dustTrailFreqMod : HoverVehicleData
  • dustTrailOffset : HoverVehicleData
  • DXPixelShaderFile : ShaderData
  • DXVertexShaderFile : ShaderData
  • dynamic : CubemapData
  • dynamicCubemap : Material
  • dynamicFarDist : CubemapData
  • dynamicFriction : PxMaterial
  • dynamicNearDist : CubemapData
  • dynamicNonStackExtent : GuiStackControl
  • dynamicObjectTypeMask : CubemapData
  • dynamicPos : GuiStackControl
  • dynamicSize : GuiStackControl , GuiDynamicCtrlArrayControl , CubemapData
  • dynamicType : StaticShapeData


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- e -

  • echoDepth : SFXEnvironment
  • echoTime : SFXEnvironment
  • edge : SFXSpace , Zone , OcclusionVolume
  • edgeSnap : GuiWindowCtrl
  • EditorOpen : MeshRoad , River , DecalRoad
  • effectColor : Material
  • ejectionAngle : SplashData
  • ejectionFreq : SplashData
  • ejectionOffset : ParticleEmitterData
  • ejectionPeriodMS : ParticleEmitterData
  • ejectionVelocity : ParticleEmitterData
  • elasticity : DebrisData , ItemData
  • elementDist : LightFlareData
  • elementRect : LightFlareData
  • elementRotate : LightFlareData
  • elementScale : LightFlareData
  • elementTint : LightFlareData
  • elementUseLightColor : LightFlareData
  • elevation : ScatterSky , Sun
  • elevationMax : ForestBrushElement
  • elevationMin : ForestBrushElement
  • emap : ShapeBaseImageData
  • emissive : WaterObject , Material
  • emitter : SplashData , ParticleEmitterNode , ExplosionData
  • emitters : DebrisData
  • enabled : RenderPassStateToken
  • engineBrake : WheeledVehicleData
  • engineSound : WheeledVehicleData , FlyingVehicleData , HoverVehicleData
  • engineTorque : WheeledVehicleData
  • enterCommand : Trigger
  • envDiffusion : SFXEnvironment
  • environment : SFXAmbience
  • envMap : Material
  • envSize : SFXEnvironment
  • envTex : Material
  • escapeCommand : GuiMLTextEditCtrl , GuiTextEditCtrl
  • excludedStates : SFXState
  • exitingWater : RigidShapeData , VehicleData , PlayerData
  • exitSplashSoundVelocity : RigidShapeData , VehicleData , PlayerData
  • expanded : GuiRolloutCtrl
  • explodeOnMaxBounce : DebrisData
  • Explosion : SplashData , ProjectileData , PhysicsShapeData , DebrisData , ShapeBaseData
  • explosionScale : ExplosionData
  • explosionShape : ExplosionData
  • exposure : CloudLayer , ScatterSky
  • extent : GuiControl
  • eyeOffset : ShapeBaseImageData
  • eyeRotation : ShapeBaseImageData


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- f -

  • faceViewer : ExplosionData
  • fade : DebrisData
  • fadeColor : GuiFadeinBitmapCtrl , Lightning
  • fadeDelay : ProjectileData
  • fadeDist : Precipitation
  • fadeDistEnd : Precipitation
  • fadeEndPixelSize : DecalData
  • fadeInEase : SFXDescription , GuiFadeinBitmapCtrl
  • FadeInRegion : fxFoliageReplicator
  • fadeInTime : SFXDescription , SFXEmitter , GuiFadeinBitmapCtrl
  • fadeLoops : SFXDescription
  • fadeOutEase : SFXDescription , GuiFadeinBitmapCtrl
  • FadeOutRegion : fxFoliageReplicator
  • fadeOutTime : SFXDescription , SFXEmitter , GuiFadeinBitmapCtrl
  • fadeStartDistance : LightBase , LightDescription , ScatterSky , Sun
  • fadeStartPixelSize : DecalData
  • fadeTime : DecalData
  • fadeTimeIn : SFXPlayList
  • fadeTimeInVariance : SFXPlayList
  • fadeTimeOut : SFXPlayList
  • fadeTimeOutVariance : SFXPlayList
  • fallback : CustomMaterial
  • farDist : ReflectorDesc
  • ffLighting : GFXStateBlockData
  • fileFilter : GuiDirectoryFileListCtrl
  • fileMustExist : OpenFolderDialog
  • fileName : FileDialog , SFXFMODProject , Prefab , SFXEmitter , SFXProfile
  • filePath : GuiDirectoryFileListCtrl
  • fillColor : GuiHealthBarHud , GuiShapeNameHud , GuiControlProfile , GuiClockHud
  • fillColorHL : GuiControlProfile
  • fillColorNA : GuiControlProfile
  • fillColorSEL : GuiControlProfile
  • fillRowFirst : GuiDynamicCtrlArrayControl
  • filters : FileDialog
  • firstPerson : ShapeBaseImageData
  • firstPersonOnly : ShapeBaseData
  • fitBook : GuiTabPageCtrl
  • fitParentWidth : GuiListBoxCtrl , GuiTextListCtrl
  • FixAspectRatio : fxFoliageReplicator
  • fixedPanel : GuiSplitContainer
  • fixedSize : GuiSplitContainer
  • FixSizeToMax : fxFoliageReplicator
  • flags : SFXEnvironment
  • flareEnabled : LightFlareData
  • flareScale : LightDescription , ScatterSky , Sun , LightBase
  • flareTexture : LightFlareData
  • flareType : LightBase , LightDescription , ScatterSky , Sun
  • flightCeiling : MissionArea
  • flightCeilingRange : MissionArea
  • floatingGravMag : HoverVehicleData
  • floatingThrustFactor : HoverVehicleData
  • floatSound : HoverVehicleData
  • FlowMagnitude : River
  • flush : Material
  • fmodGroup : SFXFMODEvent , SFXFMODEventGroup
  • fmodName : SFXFMODEvent , SFXFMODEventGroup
  • fmodParameterRanges : SFXFMODEvent
  • fmodParameterValues : SFXFMODEvent
  • fmodProject : SFXFMODEventGroup
  • foamAmbientLerp : WaterObject
  • foamDir : WaterObject
  • foamMaxDepth : WaterObject
  • foamOpacity : WaterObject
  • foamRippleInfluence : WaterObject
  • foamSpeed : WaterObject
  • foamTex : WaterObject
  • foamTexScale : WaterObject
  • focusOnMouseWheel : GuiTextEditSliderCtrl , GuiTextEditSliderBitmapCtrl
  • fogAtmosphereHeight : LevelInfo
  • fogBandHeight : SkyBox
  • fogColor : LevelInfo
  • fogDensity : LevelInfo
  • fogDensityOffset : LevelInfo
  • fogScale : ScatterSky
  • FoliageCount : fxFoliageReplicator
  • FoliageFile : fxFoliageReplicator
  • FoliageRetries : fxFoliageReplicator
  • followCam : Precipitation
  • fontCharset : GuiControlProfile
  • fontColor : GuiControlProfile
  • fontColorHL : GuiControlProfile
  • fontColorLink : GuiControlProfile
  • fontColorLinkHL : GuiControlProfile
  • fontColorNA : GuiControlProfile
  • fontColors : GuiControlProfile
  • fontColorSEL : GuiControlProfile
  • fontSize : GuiControlProfile
  • fontType : GuiControlProfile
  • FootBubblesSound : PlayerData
  • FootHardSound : PlayerData
  • FootMetalSound : PlayerData
  • footPuffEmitter : PlayerData
  • footPuffNumParts : PlayerData
  • footPuffRadius : PlayerData
  • FootShallowSound : PlayerData
  • FootSnowSound : PlayerData
  • FootSoftSound : PlayerData
  • footstepSoundId : Material
  • footstepSplashHeight : PlayerData
  • FootUnderwaterSound : PlayerData
  • FootWadingSound : PlayerData
  • force : WheeledVehicleSpring , Camera
  • forceClose : GuiPopUpMenuCtrl
  • forceDetail : fxShapeReplicatedStatic , TSStatic
  • forceFOV : GuiTSCtrl
  • forceImposters : Forest
  • forceOnAction : GuiPopUpMenuCtrl
  • forceUpdateMaterials : TSShapeConstructor
  • ForestItemData : ForestBrushElement
  • format : RenderFormatToken , GuiTextEditSliderBitmapCtrl , GuiTextEditSliderCtrl
  • forwardJetEmitter : FlyingVehicleData , HoverVehicleData
  • forwardLit : CustomMaterial
  • frame : DecalData
  • frameColor : GuiShapeNameHud , GuiClockHud , GuiHealthBarHud
  • framesPerSec : ParticleData
  • fresnelBias : WaterObject
  • fresnelPower : WaterObject
  • friction : ItemData , PxCloth , PhysicsShapeData , DebrisData , PhysicsDebrisData
  • frontSidePassable : Portal
  • frontTabPadding : GuiTabBookCtrl
  • frozen : GuiDynamicCtrlArrayControl
  • fudgeFactor : GuiFrameSetCtrl
  • fullReflect : WaterObject
  • fullRowSelect : GuiTreeViewCtrl


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- g -

  • getAddress : AIConnection
  • getAimLocation : AIClient
  • getAnimFlags : Material
  • getColorById : GuiPopUpMenuCtrlEx
  • getFilename : Material
  • getFirstRootItem : GuiTreeViewCtrl
  • getFreeLook : AIConnection
  • getItemCount : GuiTreeViewCtrl
  • getLocation : AIClient
  • getMoveDestination : AIClient
  • getSelected : GuiPopUpMenuCtrl
  • getSelectedItemList : GuiTreeViewCtrl
  • getSelectedItemsCount : GuiTreeViewCtrl
  • getSelectedObjectList : GuiTreeViewCtrl
  • getTargetObject : AIClient
  • getText : GuiPopUpMenuCtrl
  • getValue : GuiControl
  • glow : Material
  • glowIntensity : Precipitation
  • gravityCoefficient : ParticleData
  • gravityMod : ItemData , PhysicalZone , ProjectileData
  • gravModifier : DebrisData
  • gridElementSize : WaterBlock , WaterPlane
  • gridSize : GroundCover , WaterBlock , WaterPlane
  • GroundAlpha : fxFoliageReplicator
  • groundImpactMinSpeed : PlayerData
  • groundImpactShakeAmp : PlayerData
  • groundImpactShakeDuration : PlayerData
  • groundImpactShakeFalloff : PlayerData
  • groundImpactShakeFreq : PlayerData
  • groupNum : GuiButtonBaseCtrl
  • gustFrequency : ForestWindEmitter
  • gustStrength : ForestWindEmitter
  • gustWobbleStrength : ForestWindEmitter
  • gustYawAngle : ForestWindEmitter
  • gustYawFrequency : ForestWindEmitter
  • gyroDrag : HoverVehicleData


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- h -

  • hardImpactSound : RigidShapeData , VehicleData
  • hardImpactSpeed : VehicleData , RigidShapeData
  • hardSplashSoundVelocity : RigidShapeData , VehicleData , PlayerData
  • hasBitmapArray : GuiControlProfile
  • hasMount : ForestWindEmitter
  • height : SplashData , BasicClouds , CloudLayer
  • HFReference : SFXEnvironment
  • hidden : SimObject
  • HideFoliage : fxFoliageReplicator
  • hideHeader : GuiRolloutCtrl
  • HideReplications : fxShapeReplicator
  • highResOnly : ParticleEmitterData
  • historySize : GuiTextEditCtrl
  • hitAreaLowerRight : GuiGameListMenuProfile
  • hitAreaUpperLeft : GuiGameListMenuProfile
  • hitPlayers : Precipitation
  • hitVehicles : Precipitation
  • horizMaxSpeed : PlayerData
  • horizontalSurfaceForce : FlyingVehicleData
  • horizResistFactor : PlayerData
  • horizResistSpeed : PlayerData
  • horizSizing : GuiControl
  • horizStacking : GuiStackControl
  • hotSpot : GuiCursor
  • hotTrackCallback : GuiPopUpMenuCtrlEx
  • hoverHeight : FlyingVehicleData
  • hovertime : GuiControl
  • hScrollBar : GuiScrollCtrl


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- i -

  • iconBitmap : GuiIconButtonCtrl
  • iconLocation : GuiIconButtonCtrl
  • iconOffset : GuiGameListMenuProfile
  • ignoreNodeScale : TSShapeConstructor
  • ignoreWater : DebrisData
  • impactForce : ProjectileData
  • impactHardSound : PlayerData
  • impactMetalSound : PlayerData
  • impactSnowSound : PlayerData
  • impactSoftSound : PlayerData
  • impactSoundId : Material
  • impactWaterEasy : RigidShapeData , VehicleData , PlayerData
  • impactWaterHard : VehicleData , PlayerData , RigidShapeData
  • impactWaterMedium : RigidShapeData , VehicleData , PlayerData
  • includedStates : SFXState
  • includeLightmappedGeometryInShadow : LightBase , LightDescription , ScatterSky , Sun
  • increment : GuiTextEditSliderBitmapCtrl , GuiTextEditSliderCtrl
  • indoorWeight : SpawnSphere
  • inheritedVelFactor : ParticleData
  • inheritEnergyFromMount : ShapeBaseData
  • initialPosition : Projectile
  • initialVelocity : Projectile
  • innerAngle : SpotLight
  • InnerRadiusX : fxFoliageReplicator , fxShapeReplicator
  • InnerRadiusY : fxFoliageReplicator , fxShapeReplicator
  • integration : RigidShapeData , VehicleData
  • Interactions : fxShapeReplicator
  • interiorFile : InteriorInstance
  • internalName : SimObject
  • invertLayer : GroundCover
  • invisible : GuiSeparatorCtrl
  • is3D : SFXDescription , SFXEmitter
  • isActive : GuiControl
  • isAutoGenerated : Material
  • isBallistic : ProjectileData
  • isContainer : GuiControl
  • isEnabled : LightBase , PostEffect
  • isInvincible : ShapeBaseData
  • isLooping : SFXDescription , SFXEmitter , GuiAutoScrollCtrl , Path
  • isRenderable : OcclusionVolume , LightBase , PointLight , StaticShape , SpotLight , DecalManager , RenderObjectExample , RenderShapeExample , Explosion , fxFoliageReplicator , fxShapeReplicator , fxShapeReplicatedStatic , GroundCover , ParticleEmitter , Splash , PhysicsDebris , PxCloth , SFXSpace , TerrainBlock , InteriorInstance , Vehicle , Forest , TimeOfDay , HoverVehicle , BasicClouds , ScatterSky , River , MeshRoad , CloudLayer , WaterObject , WaterBlock , WaterPlane , Marker , PhysicsShape , Player , AIPlayer , Camera , Lightning , Debris , GroundPlane , Item , RigidShape , SpawnSphere , PathCamera , PhysicalZone , Zone , Portal , Prefab , Projectile , Trigger , TSStatic , RenderMeshExample , ParticleEmitterNode , Precipitation , PhysicsForce , PxMultiActor , SFXEmitter , FlyingVehicle , WheeledVehicle , SceneObject , DecalRoad , ConvexShape , GameBase , SkyBox , Sun , ShapeBase , MissionMarker , ForestWindEmitter , WayPoint
  • isRenderEnabled : SceneObject
  • isSelectable : DecalRoad , GroundCover , fxShapeReplicator , Explosion , Precipitation , Portal , ForestWindEmitter , GroundPlane , Sun , FlyingVehicle , ConvexShape , SpotLight , PhysicsForce , WaterObject , GameBase , Trigger , Forest , PhysicsShape , DecalManager , Marker , SFXSpace , RenderMeshExample , PhysicsDebris , SkyBox , BasicClouds , fxShapeReplicatedStatic , Zone , PxCloth , TerrainBlock , TSStatic , WaterBlock , RigidShape , ScatterSky , SFXEmitter , Player , WayPoint , LightBase , StaticShape , Item , RenderShapeExample , SceneObject , CloudLayer , RenderObjectExample , OcclusionVolume , PhysicalZone , Debris , ParticleEmitter , WaterPlane , TimeOfDay , Splash , HoverVehicle , ParticleEmitterNode , Projectile , River , AIPlayer , MissionMarker , fxFoliageReplicator , ShapeBase , PointLight , PathCamera , Camera , PxMultiActor , Prefab , Lightning , InteriorInstance , Vehicle , MeshRoad , SpawnSphere , WheeledVehicle
  • isSelectionEnabled : SceneObject
  • isStreaming : SFXEmitter , SFXDescription
  • itemHeight : GuiTreeViewCtrl


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- p -

  • padding : GuiContainer , GuiDynamicCtrlArrayControl , GuiMenuBar , GuiStackControl
  • parallaxScale : Material , TerrainMaterial
  • parameters : SFXTrack , SFXDescription
  • parentGroup : SimObject
  • particleDensity : ExplosionData
  • ParticleEmitter : ExplosionData , ProjectileData
  • particleRadius : ExplosionData
  • particles : ParticleEmitterData
  • particleWaterEmitter : ProjectileData
  • password : GuiTextEditCtrl
  • passwordMask : GuiTextEditCtrl
  • pauseAnimation : LightBase
  • periodVarianceMS : ParticleEmitterData
  • persistentId : SimObject
  • phiReferenceVel : ParticleEmitterData
  • phiVariance : ParticleEmitterData
  • physicsPlayerType : PlayerData
  • physXStream : PxMultiActorData
  • pickupRadius : PlayerData
  • pitch : SFXDescription , SFXEmitter
  • pitchForce : HoverVehicleData
  • pitchScale : SFXPlayList
  • pitchScaleVariance : SFXPlayList
  • pixelSpecular : Material
  • pixVersion : ShaderData
  • PlacementAreaHeight : fxFoliageReplicator , fxShapeReplicator
  • PlacementColour : fxFoliageReplicator , fxShapeReplicator
  • planarReflection : Material
  • plane : OcclusionVolume , SFXSpace , Zone
  • play : TimeOfDay
  • playAmbient : TSStatic , fxShapeReplicatedStatic , PhysicsShape
  • playOnAdd : SFXEmitter
  • playOnWake : GuiTheoraCtrl
  • playSpeed : ExplosionData
  • plotColor : GuiGraphCtrl
  • plotInterval : GuiGraphCtrl
  • plotType : GuiGraphCtrl
  • plotVariable : GuiGraphCtrl
  • point : Zone , SFXSpace , OcclusionVolume
  • polyhedron : PhysicalZone , Trigger
  • position : GuiControl , SceneObject
  • postApply : SkyBox
  • preload : SFXProfile , PhysicsDebrisData
  • priority : LightBase , SFXDescription , ReflectorDesc
  • probability : ForestBrushElement , GroundCover
  • processAddOrder : RenderBinManager
  • profile : GuiControl
  • profileForChildren : GuiControlProfile
  • Projectile : ShapeBaseImageData
  • projectileShapeName : ProjectileData
  • proneBoundingBox : PlayerData
  • proneForce : PlayerData
  • pulseRate : GuiHealthBarHud
  • pulseThreshold : GuiHealthBarHud


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- q -

  • queue : EventManager


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- r -

  • radialEmitter : ForestWindEmitter
  • radius : PointLight , WheeledVehicleTire , ForestItemData , GroundCover , SpawnSphere , ForestWindEmitter
  • random : SFXPlayList
  • RandomFlip : fxFoliageReplicator
  • randomize : DecalData
  • range : SFXParameter , SpotLight , GuiTextEditSliderBitmapCtrl , GuiTextEditSliderCtrl , LightDescription , GuiSliderCtrl
  • rayleighScattering : ScatterSky
  • recoverDelay : PlayerData
  • recoverRunForceScale : PlayerData
  • referenceDistance : SFXDescription , SFXPlayList , SFXEmitter
  • referenceDistanceVariance : SFXPlayList
  • reflect : Precipitation
  • reflectDetailAdjust : WaterObject
  • reflections : SFXEnvironment
  • reflectionsDelay : SFXEnvironment
  • reflectionsPan : SFXEnvironment
  • reflectivity : WaterObject
  • reflectMaxRateMs : WaterObject
  • reflectNormalUp : WaterObject
  • reflectPriority : GuiTSCtrl , WaterObject
  • reflectScale : GroundCover
  • reflectTexSize : WaterObject
  • reload : Material , PxMultiActorData
  • removeAllChildren : GuiTreeViewCtrl
  • removeChildSelectionByValue : GuiTreeViewCtrl
  • renameInternal : GuiTreeViewCtrl
  • renderBin : PostEffect
  • renderCells : GroundCover
  • renderCollision : Player
  • renderColorInnerCone : SFXEmitter
  • renderColorOuterCone : SFXEmitter
  • renderColorOutsideVolume : SFXEmitter
  • renderColorPlayingInRange : SFXEmitter
  • renderColorPlayingOutOfRange : SFXEmitter
  • renderColorRangeSphere : SFXEmitter
  • renderColorStoppedInRange : SFXEmitter
  • renderColorStoppedOutOfRange : SFXEmitter
  • renderDebugInfo : GuiTheoraCtrl
  • renderedBatches : GroundCover
  • renderedBillboards : GroundCover
  • renderedCells : GroundCover
  • renderedShapes : GroundCover
  • renderEmitters : SFXEmitter
  • renderFirstPerson : PlayerData
  • renderMyItems : Player
  • renderMyPlayer : Player
  • renderNormals : fxShapeReplicatedStatic , TSStatic
  • renderOffset : GuiCursor
  • renderOrder : RenderBinManager
  • renderPointDistance : SFXEmitter
  • renderPriority : DecalData , DecalRoad , PostEffect
  • renderRadialIncrements : SFXEmitter
  • renderReflection : ParticleEmitterData
  • renderReflectPass : LightFlareData
  • renderSweepIncrements : SFXEmitter
  • renderTime : PostEffect
  • renderTriggers : Trigger
  • renderWhenDestroyed : ShapeBaseData
  • renderWireframe : RenderTerrainMgr
  • renderZones : PhysicalZone
  • repairRate : ShapeBaseData
  • repeatCount : SFXPlayList
  • replaceText : GuiPopUpMenuCtrlEx
  • replay : SFXPlayList
  • representedInLightmap : LightBase , LightDescription , ScatterSky , Sun
  • resetDelay : GuiAutoScrollCtrl
  • resizeHeight : GuiWindowCtrl
  • resizeWidth : GuiWindowCtrl
  • resolveEffect : RenderFormatToken
  • restitution : PhysicsShapeData , PxMaterial , WheeledVehicleTire , PhysicsDebrisData
  • restorativeForce : HoverVehicleData
  • resultArg : GFXSamplerStateData
  • returnTab : GuiControlProfile
  • reverb : SFXEnvironment
  • REVERB_CORE0 : SFXEnvironment
  • REVERB_CORE1 : SFXEnvironment
  • REVERB_DECAYHFLIMIT : SFXEnvironment
  • REVERB_DECAYTIMESCALE : SFXEnvironment
  • REVERB_DIRECTHFAUTO : SFXDescription
  • REVERB_ECHOTIMESCALE : SFXEnvironment
  • REVERB_HIGHQUALITYDPL2REVERB : SFXEnvironment
  • REVERB_HIGHQUALITYREVERB : SFXEnvironment
  • REVERB_INSTANCE0 : SFXDescription
  • REVERB_INSTANCE1 : SFXDescription
  • REVERB_INSTANCE2 : SFXDescription
  • REVERB_INSTANCE3 : SFXDescription
  • REVERB_MODULATIONTIMESCALE : SFXEnvironment
  • REVERB_REFLECTIONSDELAYSCALE : SFXEnvironment
  • REVERB_REFLECTIONSSCALE : SFXEnvironment
  • REVERB_REVERBDELAYSCALE : SFXEnvironment
  • REVERB_REVERBSCALE : SFXEnvironment
  • REVERB_ROOMAUTO : SFXDescription
  • REVERB_ROOMHFAUTO : SFXDescription
  • reverbAirAbsorptionFactor : SFXDescription
  • reverbDelay : SFXEnvironment
  • reverbDirect : SFXDescription
  • reverbDirectHF : SFXDescription
  • reverbDopplerFactor : SFXDescription
  • reverbExclusion : SFXDescription
  • reverbExclusionLFRatio : SFXDescription
  • reverbFlags : SFXDescription
  • reverbObstruction : SFXDescription
  • reverbObstructionLFRatio : SFXDescription
  • reverbOcclusion : SFXDescription
  • reverbOcclusionDirectRatio : SFXDescription
  • reverbOcclusionLFRatio : SFXDescription
  • reverbOcclusionRoomRatio : SFXDescription
  • reverbOutsideVolumeHF : SFXDescription
  • reverbPan : SFXEnvironment
  • reverbReverbRolloffFactor : SFXDescription
  • reverbRoom : SFXDescription
  • reverbRoomHF : SFXDescription
  • reverbRoomRolloffFactor : SFXDescription
  • reverseOrder : ParticleEmitterData
  • reverseTextList : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • reverseThrustForce : HoverVehicleData
  • rightPad : GuiGameListOptionsProfile
  • rigidity : ForestItemData
  • ringLifetime : SplashData
  • rippleDir : WaterObject
  • rippleMagnitude : WaterObject
  • rippleSpeed : WaterObject
  • rippleTex : WaterObject
  • rippleTexScale : WaterObject
  • rollForce : HoverVehicleData , FlyingVehicleData
  • rolloffFactor : SFXDescription , SFXAmbience
  • room : SFXEnvironment
  • roomHF : SFXEnvironment
  • roomLF : SFXEnvironment
  • roomRolloffFactor : SFXEnvironment
  • rotA : LightAnimData
  • rotate : Item
  • rotateWithCamVel : Precipitation
  • rotation : ShapeBaseImageData , SceneObject
  • rotationalDrag : FlyingVehicleData
  • rotationRange : ForestBrushElement
  • rotKeys : LightAnimData
  • rotPeriod : LightAnimData
  • rotPivotOffset : Material
  • rotSmooth : LightAnimData
  • rotSpeed : Material
  • rotZ : LightAnimData
  • rowCount : GuiDynamicCtrlArrayControl
  • rows : GuiFrameSetCtrl
  • rowSize : GuiGameListMenuProfile , GuiControlArrayControl , GuiDynamicCtrlArrayControl
  • rowSpacing : GuiControlArrayControl , GuiDynamicCtrlArrayControl
  • runEnergyDrain : PlayerData
  • runForce : PlayerData
  • runSurfaceAngle : PlayerData


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- s -

  • samplersDefined : GFXStateBlockData
  • samplerStates : GFXStateBlockData
  • samples : PxCloth
  • saveDataFile : Forest
  • sbUsesNAColor : GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • scale : SplashData , ProjectileData , SceneObject
  • scaleExponent : ForestBrushElement
  • scaleMax : ForestBrushElement
  • scaleMin : ForestBrushElement
  • scaleU : GroundPlane
  • scaleV : GroundPlane
  • scatterDistance : SFXEmitter , SFXDescription
  • screenError : TerrainBlock
  • scrollDir : Material
  • scrollDirection : GuiAutoScrollCtrl
  • scrollOutOfSight : GuiAutoScrollCtrl
  • scrollSpeed : Material , GuiAutoScrollCtrl
  • seed : fxFoliageReplicator , fxShapeReplicator , GroundCover
  • SegmentLength : River
  • selectedPage : GuiTabBookCtrl
  • selfCollision : PxCloth
  • separateAlphaBlendDefined : GFXStateBlockData
  • separateAlphaBlendDest : GFXStateBlockData
  • separateAlphaBlendEnable : GFXStateBlockData
  • separateAlphaBlendOp : GFXStateBlockData
  • separateAlphaBlendSrc : GFXStateBlockData
  • seqNum : Marker
  • sequence : TSShapeConstructor
  • sequenceFramePerSec : Material
  • sequenceSegmentSize : Material
  • setAimLocation : AIClient
  • setAutoGenerated : Material
  • setEnumContent : GuiPopUpMenuCtrlEx
  • setFirstResponder : GuiControl
  • setMoveDestination : AIClient
  • setMoveSpeed : AIClient
  • setNoneSelected : GuiPopUpMenuCtrl
  • setTargetObject : AIClient
  • shader : CustomMaterial , PostEffect
  • shadowDarkenColor : LightBase , LightDescription , ScatterSky , Sun
  • shadowDistance : LightBase , LightDescription , ScatterSky , Sun
  • shadowEnable : ShapeBaseData
  • shadowMaxVisibleDistance : ShapeBaseData
  • shadowProjectionDistance : ShapeBaseData
  • shadowSize : ShapeBaseData
  • shadowSoftness : LightBase , LightDescription , ScatterSky , Sun
  • shadowSphereAdjust : ShapeBaseData
  • shadowType : LightBase , LightDescription , ScatterSky , Sun
  • shakeCamera : ExplosionData , ShapeBaseImageData
  • ShapeCount : fxShapeReplicator
  • shapeCullRadius : GroundCover
  • shapeFile : ShapeBaseData , DebrisData , RenderShapeExample , fxShapeReplicator , WheeledVehicleTire , ForestItemData , GuiObjectView , ShapeBaseImageData , PhysicsDebrisData
  • shapeFilename : GroundCover
  • shapeName : fxShapeReplicatedStatic , PhysicsShapeData , TSStatic , PxMultiActorData
  • ShapeRetries : fxShapeReplicator
  • ShapeRotateMax : fxShapeReplicator
  • ShapeRotateMin : fxShapeReplicator
  • ShapeScaleMax : fxShapeReplicator
  • ShapeScaleMin : fxShapeReplicator
  • shapesCastShadows : GroundCover
  • shellExitDir : ShapeBaseImageData
  • shellExitVariance : ShapeBaseImageData
  • shellVelocity : ShapeBaseImageData
  • showBatches : DecalRoad , MeshRoad
  • showClassNameForUnnamedObjects : GuiTreeViewCtrl
  • showClassNames : GuiTreeViewCtrl
  • showDust : Material
  • showFill : GuiHealthBarHud , GuiShapeNameHud , GuiClockHud
  • showFootprints : Material
  • showFrame : GuiHealthBarHud , GuiShapeNameHud , GuiClockHud
  • showInternalNames : GuiTreeViewCtrl
  • showNodes : River
  • showObjectIds : GuiTreeViewCtrl
  • showObjectNames : GuiTreeViewCtrl
  • ShowPlacementArea : fxFoliageReplicator , fxShapeReplicator
  • showRiver : River
  • showRoad : DecalRoad , MeshRoad
  • showRoot : GuiTreeViewCtrl
  • showSpline : DecalRoad , MeshRoad , River
  • showWalls : River
  • showWireframe : River
  • sideMaterial : MeshRoad
  • simType : PhysicsShapeData
  • singleDetailSize : TSShapeConstructor
  • singlePlayerOnly : PxMultiActorData
  • sinkAllKeyEvents : GuiTextEditCtrl
  • sinkMax : ForestBrushElement
  • sinkMin : ForestBrushElement
  • sinkRadius : ForestBrushElement
  • size : PxCloth , DecalData , GuiPopUpMenuCtrl , GuiPopUpMenuCtrlEx
  • sizeExponent : GroundCover
  • sizeIconToButton : GuiIconButtonCtrl
  • sizeMax : GroundCover
  • sizeMin : GroundCover
  • sizes : ExplosionData , ParticleData
  • skin : GuiObjectView
  • skip : PostEffect
  • skyBrightness : ScatterSky
  • slopeMax : ForestBrushElement
  • slopeMin : ForestBrushElement
  • smoothingType : Marker
  • snap : GuiSliderCtrl
  • snapOnMaxBounce : DebrisData
  • softImpactSound : RigidShapeData , VehicleData
  • softImpactSpeed : RigidShapeData , VehicleData
  • softnessDistance : ParticleEmitterData
  • softSplashSoundVelocity : RigidShapeData , VehicleData
  • sort : GuiPopUpMenuCtrl
  • sortID : GuiPopUpMenuCtrl
  • sortParticles : ParticleEmitterData
  • sound : ProjectileData
  • soundAmbience : LevelInfo , SFXSpace , WaterObject , Zone
  • soundButtonDown : GuiControlProfile
  • soundButtonOver : GuiControlProfile
  • soundDistanceModel : LevelInfo
  • soundProfile : ExplosionData , PrecipitationData , SplashData
  • soundTrack : SFXAmbience
  • sourceGroup : SFXDescription , SFXEmitter
  • sourceObject : Projectile
  • sourceSlot : Projectile
  • spawnClass : SpawnSphere
  • spawnDatablock : SpawnSphere
  • spawnProperties : SpawnSphere
  • spawnScript : SpawnSphere
  • specular : Material
  • specularColor : WaterObject
  • specularMap : Material
  • specularPower : WaterObject , Material
  • speedMultiplier : Camera
  • sphereWeight : SpawnSphere
  • spinRandomMax : ParticleData
  • spinRandomMin : ParticleData
  • spinSpeed : ParticleData
  • Splash : PlayerData , ProjectileData
  • splashAngle : PlayerData
  • splashEmitter : RigidShapeData , VehicleData , PlayerData
  • splashesPerSide : PrecipitationData
  • splashFreqMod : RigidShapeData , VehicleData , PlayerData
  • splashMS : Precipitation
  • splashShader : PrecipitationData
  • splashSize : Precipitation
  • splashTexture : PrecipitationData
  • splashVelEpsilon : VehicleData , PlayerData , RigidShapeData
  • splashVelocity : PlayerData
  • splitPoint : GuiSplitContainer
  • splitterSize : GuiSplitContainer
  • squareSize : TerrainBlock , GroundPlane
  • squealSound : WheeledVehicleData
  • stabDampingConstant : HoverVehicleData
  • stabLenMax : HoverVehicleData
  • stabLenMin : HoverVehicleData
  • stabSpringConstant : HoverVehicleData
  • stackingType : GuiStackControl
  • startDelay : GuiAutoScrollCtrl
  • startRadius : SplashData
  • startTime : TimeOfDay
  • state : SFXPlayList
  • stateAllowImageChange : ShapeBaseImageData
  • stateBlock : CustomMaterial , PostEffect
  • stateDirection : ShapeBaseImageData
  • stateEjectShell : ShapeBaseImageData
  • stateEmitter : ShapeBaseImageData
  • stateEmitterNode : ShapeBaseImageData
  • stateEmitterTime : ShapeBaseImageData
  • stateEnergyDrain : ShapeBaseImageData
  • stateFire : ShapeBaseImageData
  • stateIgnoreLoadedForReady : ShapeBaseImageData
  • stateLoadedFlag : ShapeBaseImageData
  • stateMode : SFXPlayList
  • stateName : ShapeBaseImageData
  • stateRecoil : ShapeBaseImageData
  • states : SFXAmbience
  • stateScaleAnimation : ShapeBaseImageData
  • stateScript : ShapeBaseImageData
  • stateSequence : ShapeBaseImageData
  • stateSequenceRandomFlash : ShapeBaseImageData
  • stateSound : ShapeBaseImageData
  • stateSpinThread : ShapeBaseImageData
  • stateTimeoutValue : ShapeBaseImageData
  • stateToken : RenderPassStateBin
  • stateTransitionOnAltTriggerDown : ShapeBaseImageData
  • stateTransitionOnAltTriggerUp : ShapeBaseImageData
  • stateTransitionOnAmmo : ShapeBaseImageData
  • stateTransitionOnLoaded : ShapeBaseImageData
  • stateTransitionOnNoAmmo : ShapeBaseImageData
  • stateTransitionOnNoTarget : ShapeBaseImageData
  • stateTransitionOnNotLoaded : ShapeBaseImageData
  • stateTransitionOnNotWet : ShapeBaseImageData
  • stateTransitionOnTarget : ShapeBaseImageData
  • stateTransitionOnTimeout : ShapeBaseImageData
  • stateTransitionOnTriggerDown : ShapeBaseImageData
  • stateTransitionOnTriggerUp : ShapeBaseImageData
  • stateTransitionOnWet : ShapeBaseImageData
  • stateWaitForTimeout : ShapeBaseImageData
  • static : Item
  • staticFriction : PxMaterial , PhysicsDebrisData , PhysicsShapeData , WheeledVehicleTire
  • staticOnMaxBounce : DebrisData
  • statusCallback : SFXSource
  • steeringForce : FlyingVehicleData , HoverVehicleData
  • steeringRollForce : FlyingVehicleData
  • stencilDefined : GFXStateBlockData
  • stencilEnable : GFXStateBlockData
  • stencilFailOp : GFXStateBlockData
  • stencilFunc : GFXStateBlockData
  • stencilMask : GFXStateBlockData
  • stencilPassOp : GFXStateBlockData
  • stencilRef : GFXStateBlockData
  • stencilWriteMask : GFXStateBlockData
  • stencilZFailOp : GFXStateBlockData
  • sticky : ItemData
  • stop : AIClient
  • stopOnSleep : GuiTheoraCtrl
  • strafeThrustForce : HoverVehicleData
  • streamPacketSize : SFXDescription
  • streamReadAhead : SFXDescription
  • strength : ForestWindEmitter
  • strikeRadius : Lightning
  • strikeSound : LightningData
  • strikesPerMinute : Lightning
  • strikeTextures : LightningData
  • strikeWidth : Lightning
  • SubdivideLength : River
  • subExplosion : ExplosionData
  • subSurface : Material
  • subSurfaceColor : Material
  • subSurfaceRolloff : Material
  • sunScale : ScatterSky
  • superClass : SimObject
  • surface : ConvexShape
  • SwayMagFront : fxFoliageReplicator
  • SwayMagSide : fxFoliageReplicator
  • SwayOn : fxFoliageReplicator
  • SwaySync : fxFoliageReplicator
  • swimBoundingBox : PlayerData
  • swimForce : PlayerData


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- t -

  • tab : GuiControlProfile
  • tabComplete : GuiTextEditCtrl
  • tabHeight : GuiTabBookCtrl
  • tabMargin : GuiTabBookCtrl
  • tabPosition : GuiTabBookCtrl
  • tabSize : GuiTreeViewCtrl
  • tail : GuiSpeedometerHud
  • target : CustomMaterial , PostEffect
  • targetClear : PostEffect
  • targetClearColor : PostEffect
  • targetDepthStencil : PostEffect
  • targetFormat : PostEffect
  • targetScale : PostEffect
  • targetSize : PostEffect
  • team : WayPoint
  • terminalVelocity : DebrisData
  • TerrainAlignment : fxShapeReplicator
  • terrainFile : TerrainBlock
  • texCols : DecalData
  • texDirection : BasicClouds , CloudLayer
  • texFactor : SplashData
  • texOffset : BasicClouds
  • texRows : DecalData
  • texScale : BasicClouds , CloudLayer
  • texSize : Sun , LightBase , ReflectorDesc , LightDescription , ScatterSky
  • texSpeed : BasicClouds , CloudLayer
  • text : GuiButtonBaseCtrl , GuiWindowCtrl , GuiTextCtrl , GuiMLTextCtrl
  • textColor : GuiShapeNameHud , GuiClockHud
  • textID : GuiButtonBaseCtrl , GuiTextCtrl
  • textLocation : GuiIconButtonCtrl
  • textMargin : GuiIconButtonCtrl
  • textOffset : GuiControlProfile , GuiTreeViewCtrl
  • texture : DebrisData , SplashData , BasicClouds , CloudLayer , PostEffect
  • textureColorOp : GFXSamplerStateData
  • textureCoordCount : DecalData
  • textureCoords : DecalData , ParticleData
  • textureFactor : GFXStateBlockData
  • textureLength : DecalRoad , MeshRoad
  • textureName : ParticleData , ParticleEmitterData
  • textureTransform : GFXSamplerStateData
  • texWrap : SplashData
  • theoraFile : GuiTheoraCtrl
  • thetaMax : ParticleEmitterData
  • thetaMin : ParticleEmitterData
  • thickness : PxCloth
  • thunderSounds : LightningData
  • tickCommand : Trigger
  • tickPeriodMS : TriggerData
  • ticks : GuiSliderCtrl
  • tightnessCoefficient : ForestItemData
  • tile : GuiChunkedBitmapCtrl
  • time : TimeOfDay
  • timeMultiple : ParticleEmitterNodeData
  • times : SplashData , ExplosionData , ParticleData
  • tireEmitter : WheeledVehicleData
  • title : FileDialog
  • toneMap : Material
  • tooltip : GuiControl
  • tooltipOnWidthOnly : GuiTreeViewCtrl
  • tooltipProfile : GuiControl
  • topMaterial : MeshRoad
  • toQueue : MessageForwarder
  • trace : SFXController , SFXPlayList
  • track : SFXPlayList , SFXEmitter
  • trailEmitter : FlyingVehicleData
  • transcoder : GuiTheoraCtrl
  • transitionIn : SFXPlayList
  • transitionOut : SFXPlayList
  • translucent : Material
  • translucentBlendOp : Material
  • translucentZWrite : Material
  • triangleCollision : PxCloth
  • triggerDustHeight : VehicleData , RigidShapeData
  • triggerTrailHeight : HoverVehicleData
  • trunkBendScale : ForestItemData
  • turboFactor : HoverVehicleData
  • turbulenceFrequency : ForestWindEmitter
  • turbulenceSpeed : Precipitation
  • turbulenceStrength : ForestWindEmitter
  • type : Marker , GuiSeparatorCtrl


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- u -

  • underwaterColor : WaterObject
  • underwaterExplosion : ShapeBaseData
  • unit : TSShapeConstructor
  • upAxis : TSShapeConstructor
  • updateDelay : DecalRoad
  • upMaxSpeed : PlayerData
  • upResistFactor : PlayerData
  • upResistSpeed : PlayerData
  • useAmbientLightColor : Zone
  • useAnisotropic : Material
  • UseCulling : fxFoliageReplicator
  • useCustomReverb : SFXDescription
  • UseDebugInfo : fxFoliageReplicator
  • useDevicePixVersion : ShaderData
  • useEmitterColors : ParticleEmitterData
  • useEmitterSizes : ParticleEmitterData
  • useEyePoint : ShapeBaseData
  • useFog : Lightning
  • useHardware : SFXDescription
  • useInspectorTooltips : GuiTreeViewCtrl
  • useInvAlpha : ParticleData
  • useLighting : Precipitation
  • useModifiers : GuiBitmapButtonCtrl
  • useMouseEvents : GuiButtonBaseCtrl
  • useNightCubemap : ScatterSky
  • useOcclusionQuery : ReflectorDesc , WaterObject
  • useRadiusMass : DebrisData
  • useRemainderDT : ShapeBaseImageData
  • usesEnergy : ShapeBaseImageData
  • useSiblingScroller : GuiConsoleEditCtrl
  • useSideProjection : TerrainMaterial
  • useStates : GuiBitmapButtonCtrl
  • useTrackDescriptionOnly : SFXEmitter
  • useTrueBillboards : Precipitation , fxFoliageReplicator
  • useTurbulence : Precipitation
  • useURLMouseCursor : GuiMLTextCtrl
  • useVariable : GuiChunkedBitmapCtrl
  • useWind : Precipitation


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- v -

  • validate : GuiTextEditCtrl
  • value : GuiSliderCtrl , SFXParameter
  • variable : GuiControl
  • velInheritFactor : ProjectileData
  • velocity : ParticleEmitterNode , DebrisData , SplashData
  • velocityMod : PhysicalZone
  • velocityVariance : DebrisData , ParticleEmitterData
  • version : CustomMaterial
  • vertColor : Material
  • vertexColorEnable : GFXStateBlockData
  • vertFactor : HoverVehicleData , RigidShapeData
  • verticalOffset : GuiShapeNameHud
  • verticalSurfaceForce : FlyingVehicleData
  • vertLit : Material
  • vertSizing : GuiControl
  • vertStacking : GuiStackControl
  • vertThrustMultiple : FlyingVehicleData
  • ViewClosest : fxFoliageReplicator
  • ViewDistance : fxFoliageReplicator
  • viscosity : WaterObject
  • visible : GuiControl
  • visibleDistance : LevelInfo
  • volume : SFXEmitter , SFXDescription
  • volumeScale : SFXPlayList
  • volumeScaleVariance : SFXPlayList
  • vScrollBar : GuiScrollCtrl


Torque 3D - Script Manual: Class Members - Variables

  • All
  • Functions
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • j
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • z

- w -

  • waitTime : GuiFadeinBitmapCtrl
  • waterBreathSound : PlayerData
  • waterDampingScale : PhysicsDebrisData , PhysicsShapeData
  • waterDragScale : PxMultiActorData
  • waterExplosion : ProjectileData
  • waterFogDensity : WaterObject
  • waterFogDensityOffset : WaterObject
  • waterWakeSound : RigidShapeData , VehicleData
  • waveAmp : Material
  • waveDir : WaterObject
  • waveFreq : Material
  • waveMagnitude : WaterObject
  • waveSpeed : WaterObject
  • waveType : Material
  • wetDarkening : WaterObject
  • wetDepth : WaterObject
  • WheelImpactSound : WheeledVehicleData
  • width : SplashData , GuiSpeedometerHud
  • widthSubdivisions : MeshRoad
  • willFirstRespond : GuiScrollCtrl
  • windCoefficient : ParticleData
  • windDirection : GroundCover
  • windEnabled : ForestWindEmitter
  • windGustFrequency : GroundCover
  • windGustLength : GroundCover
  • windGustStrength : GroundCover
  • windScale : ForestItemData , GroundCover
  • windSpeed : CloudLayer
  • windTurbulenceFrequency : GroundCover
  • windTurbulenceStrength : GroundCover
  • wireframe : DecalRoad , WaterObject , MeshRoad
  • workingQueryBoxSizeMultiplier : Vehicle
  • workingQueryBoxStaleThreshold : Vehicle
  • wrap : GuiBitmapCtrl


Torque 3D - Script Manual: Graph Legend

Graph Legend

This page explains how to interpret the graphs that are generated by doxygen.

Consider the following example:

/*! Invisible class because of truncation */
class Invisible { };

/*! Truncated class, inheritance relation is hidden */
class Truncated : public Invisible { };

/* Class not documented with doxygen comments */
class Undocumented { };

/*! Class that is inherited using public inheritance */
class PublicBase : public Truncated { };

/*! A template class */
template<class T> class Templ { };

/*! Class that is inherited using protected inheritance */
class ProtectedBase { };

/*! Class that is inherited using private inheritance */
class PrivateBase { };

/*! Class that is used by the Inherited class */
class Used { };

/*! Super class that inherits a number of other classes */
class Inherited : public PublicBase,
                  protected ProtectedBase,
                  private PrivateBase,
                  public Undocumented,
                  public Templ<int>
{
  private:
    Used *m_usedClass;
};

This will result in the following graph:

The boxes in the above graph have the following meaning:

  • A filled gray box represents the struct or class for which the graph is generated.
  • A box with a black border denotes a documented struct or class.
  • A box with a grey border denotes an undocumented struct or class.
  • A box with a red border denotes a documented struct or class forwhich not all inheritance/containment relations are shown. A graph is truncated if it does not fit within the specified boundaries.

The arrows have the following meaning:

  • A dark blue arrow is used to visualize a public inheritance relation between two classes.
  • A dark green arrow is used for protected inheritance.
  • A dark red arrow is used for private inheritance.
  • A purple dashed arrow is used if a class is contained or used by another class. The arrow is labeled with the variable(s) through which the pointed class or struct is accessible.
  • A yellow dashed arrow denotes a relation between a template instance and the template class it was instantiated from. The arrow is labeled with the template parameters of the instance.


Torque 3D - Script Manual: Class Members

  • All
  • Variables
  • a
  • b
  • c
  • d
  • e
  • f
  • i
  • j
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w

- a -

  • activePlugins : $BasicLightManagerStats
  • alwaysUseDebugOutput : $Con
  • ambientUpdateTime : $SFX

- b -

  • Back : $Ease
  • backgroundSleepTime : $platform
  • Bounce : $Ease

- c -

  • canShadow : $pref::imposter
  • Circular : $Ease
  • Cubic : $Ease

- d -

  • debugRender : $Decals
  • defaultAnisotropy : $pref::Video
  • densityScale : $pref::GroundCover
  • detailAdjust : $pref::TS , $pref::Interior
  • detailAdjustScale : $pref::PSSM
  • detailScale : $pref::Terrain
  • DEVICE_CAPS_DSPEFFECTS : $SFX
  • DEVICE_CAPS_FMODDESIGNER : $SFX
  • DEVICE_CAPS_MULTILISTENER : $SFX
  • DEVICE_CAPS_OCCLUSION : $SFX
  • DEVICE_CAPS_REVERB : $SFX
  • DEVICE_CAPS_VOICEMANAGEMENT : $SFX
  • DEVICE_INFO_CAPS : $SFX
  • DEVICE_INFO_MAXBUFFERS : $SFX
  • DEVICE_INFO_NAME : $SFX
  • DEVICE_INFO_PROVIDER : $SFX
  • DEVICE_INFO_USEHARDWARE : $SFX
  • DFDec : $SB
  • disable : $pref::Shadows , $Shadows
  • disableOcclusionQuery : $gfx
  • disableSoftware : $pref::SFX::FMOD
  • disableTerrainOcclusion : $Scene
  • disableTrueReflections : $pref::Water
  • disableVerticalSync : $pref::Video
  • disableZoneCulling : $Scene
  • disassembleAllShaders : $gfx
  • distanceScale : $pref::Camera
  • DontRestrictOutside : $Interior
  • DSoundHRTF : $pref::SFX::FMOD

- e -

  • elapsedUpdateMs : $BasicLightManagerStats
  • Elastic : $Ease
  • enableBadWordFilter : $pref
  • enabled : $pref::Decals
  • enablePostEffects : $pref
  • enableProfile : $pref::SFX::FMOD
  • Exponential : $Ease

- f -

  • fadeEndPixelSize : $pref::ProjectedShadow
  • fadeStartPixelSize : $pref::ProjectedShadow
  • File : $Con
  • filterMode : $pref::shadows
  • fmodCoreMem : $SFX::Device
  • fmodEventMem : $SFX::Device
  • fmodNumEventSources : $SFX::Device
  • forcedPixVersion : $pref::Video
  • frameCount : $TSControl
  • frameLimitMS : $pref::Reflect
  • frequency : $Sampler

- i -

  • In : $Ease
  • InOut : $Ease
  • isSinglePlayer : $Physics

- j -

  • JoystickEnabled : $pref::Input

- l -

  • LagThreshold : $pref::Net
  • lifeTimeScale : $pref::Decals
  • lifetimeScale : $pref::PhysicsDebris
  • Linear : $Ease
  • lockCull : $Scene
  • lodScale : $pref::Terrain
  • logBufferEnabled : $Con

- m -

  • maxInstancingVerts : $pref::TS
  • maxOccludersPerZone : $Scene

- n -

  • netBitsReceived : $Stats
  • netBitsSent : $Stats
  • netGhostUpdates : $Stats
  • numCulled : $SFX
  • numPlaying : $SFX
  • numSounds : $SFX
  • numSources : $SFX
  • numVoices : $SFX

- o -

  • occluderMinHeightPercentage : $Scene
  • occluderMinWidthPercentage : $Scene
  • Out : $Ease

- p -

  • PacketRateToClient : $pref::Net
  • PacketRateToServer : $pref::Net
  • PacketSize : $pref::Net
  • parameterUpdateTime : $SFX
  • pluginPath : $pref::SFX::FMOD
  • poolBuffers : $Decals
  • printLevel : $Con
  • PSSMDebugRender : $AL

- q -

  • Quadratic : $Ease
  • Quartic : $Ease
  • Quintic : $Ease

- r -

  • refractTexScale : $pref::Reflect
  • renderBoundingBoxes : $Scene
  • renderLightFrustums : $Light
  • renderViz : $Light
  • Root : $Con

- s -

  • shadowFilterDistance : $BasicLightManager
  • shadowsUpdated : $BasicLightManagerStats
  • Sinusoidal : $Ease
  • skipLoadDLs : $pref::TS
  • skipRenderDLs : $pref::TS
  • smallestVisiblePixelSize : $pref::PSSM , $pref::TS
  • sourceUpdateTime : $SFX
  • sphereDistanceTolerance : $Decals
  • sphereRadiusTolerance : $Decals

- t -

  • textureReductionLevel : $pref::Video
  • textureScalar : $pref::Shadows
  • threadCount : $pref::Physics
  • timeManagerProcessInterval : $platform

- u -

  • useSoftwareHRTF : $pref::SFX::FMOD
  • useSoftwareReverbLowmem : $pref::SFX::FMOD
  • UseSSAOMask : $AL
  • useTimestamp : $Con

- v -

  • VertexLighting : $pref::Interior
  • visibleDistanceScale : $pref::WorldEditor

- w -

  • warnUndefinedVariables : $Con
  • windEffectRadius : $pref
  • wireframe : $gfx
  • WODec : $SB


Torque 3D - Script Manual: Page Index

Related Pages

Here is a list of all related documentation pages:
  • Syntax Guide
  • Quick Reference